function crm00002001_OportunidadeNegocio_Controller(
  ScreenService,
  templateManager,
  Utilities,
  ZHPromise,
  restEngine,
  Operador_Repository,
  CRM_Utilities,
  General,
  Messages,
  ABEvolucaoController,
  evolutionTabController,
  localStorageEngine,
  PartnerInfosModalController,
  ZhFilterPreferences
) {
  var self = this;
  var widgetAtiva;
  var paramCRM;

  this.shootsOpportunityEventsAfterMoveRow = function (widget) {
    this.checkOport(widget); //Define a visibilidade da action 'Editar'
    this.goBackActions();
    this.initItemsWidget();
    this.initTaskSchedule();
    this.checkLoggedOperatorPermissionToChangeOpport(widget);
    this.checkParamSM(widget);
  };

  self.iniciaFiltrosWidoportunidadegrid = function (widget) {
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
    
    Utilities.insertFilterWithoutReload(
      widget,
      "P_NRORG",
      "=",
      loggedOperatorInfos.NRORG,
      0
    );
    Utilities.insertFilterWithoutReload(
      widget,
      "P_NRPARCNEGOCIO",
      "=",
      loggedOperatorInfos.NRPARCNEGOCIO,
      1
    );
    Utilities.insertFilterWithoutReload(
      widget, 
      "NRPARCRESP", 
      "IN",
      [loggedOperatorInfos.NRPARCNEGOCIO],
      1
    );
    
    var field = widget.getField( "NRPARCRESP");
    field.value([loggedOperatorInfos.NRPARCNEGOCIO]);
    field.setValue([loggedOperatorInfos.NRPARCNEGOCIO]);
    field.reload();

    //Utilities.insertFilterWithoutReload(widget, "NRPARCRESP", "IN", [loggedOperatorInfos.NRPARCNEGOCIO], 1);

    //this.setResponsibleOperatorFilterDefaultValueInFilterPopup(widget);
  };

  self.iniciaFiltrosWidevoloport = function (widget) {
    Operador_Repository.retornaOperadorLogado().then(
      function (operator) {
        if (operator[0] === undefined || operator[0] === null) {
          ScreenService.showMessage("Erro ao realizar a operação.");
          return;
        }

        var field;

        field = widget.getField("NMPARCINTERLOCUTOR");
        Utilities.insertFilter(
          field,
          "NRPARCNEGOCIO",
          "=",
          operator[0].NRPARCNEGOCIO,
          0
        );
      },
      function (error) {
        ScreenService.showMessage("Erro ao realizar a operação.");
      }
    );
  };

  self.iniciaFiltrosWidoportfilter = function (widget) {    
    Operador_Repository.retornaOperadorLogado().then(
      function (operator) {
        if (operator[0] === undefined || operator[0] === null) {
          ScreenService.showMessage("Erro ao realizar a operação.");
          return;
        }

        field = widget.getField("NMPARCRESP");
        Utilities.insertFilterWithoutReload(
          field,
          "P_NRORG",
          "=",
          operator[0].NRORG,
          0
        );
        Utilities.insertFilter(
          field,
          "P_NRPARCNEGOCIO",
          "=",
          operator[0].NRPARCNEGOCIO,
          1
        );
      },
      function (error) {
        ScreenService.showMessage("Erro ao realizar a operação.");
      }
    );
  };

  self.iniciaFiltrosWidevolucao = function (widget) {
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    var field = widget.getField("NMMOTIEVOCON");
    Utilities.insertFilterWithoutReload(
      field,
      "P_NRORG",
      "=",
      loggedOperatorInfos.NRORG,
      0
    );
    Utilities.insertFilter(
      field,
      "P_CDOPERADOR",
      "=",
      loggedOperatorInfos.CDOPERADOR,
      1
    );

    field = widget.getField("NMSEQRESULEVOL");
    Utilities.insertFilterWithoutReload(
      field,
      "P_NRORG",
      "=",
      loggedOperatorInfos.NRORG,
      0
    );
    Utilities.insertFilter(
      field,
      "P_CDOPERADOR",
      "=",
      loggedOperatorInfos.CDOPERADOR,
      1
    );

    field = widget.getField("DESCRESULEVOL");
    Utilities.insertFilterWithoutReload(
      field,
      "P_NRORG",
      "=",
      loggedOperatorInfos.NRORG,
      0
    );
    Utilities.insertFilter(
      field,
      "P_CDOPERADOR",
      "=",
      loggedOperatorInfos.CDOPERADOR,
      1
    );
  };

  self.iniciaFiltrosWidfinishoport = function (widget) {
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    var field = widget.getField("DESCRESULEVOL");
    Utilities.insertFilterWithoutReload(
      field,
      "P_NRORG",
      "=",
      loggedOperatorInfos.NRORG,
      0
    );
    Utilities.insertFilter(
      field,
      "P_CDOPERADOR",
      "=",
      loggedOperatorInfos.CDOPERADOR,
      1
    );
  };

  self.calcOportValue = function () {
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    var items = templateManager.container.getWidget("itensgrid");
    items.reload();

    var oport =
      items.name == "itensgrid"
        ? items.parent.parent
        : templateManager.containers["wizard/oportunidade/wzoportstageoport"]
          .widgets[0];

    oport.currentRow.VRPREVOPORT = 0;

    items.dataSource.data.forEach(function (item) {
      oport.currentRow.VRPREVOPORT += parseInt(item.VRTOTITEMOPORT);
    });

    if (oport.isValid() && oport.currentRow.IDTPOPORT) {
      oport.currentRow.changed = true;

      oport.currentRow.NRORGULTATU = loggedOperatorInfos.NRORG;
      oport.currentRow.CDOPERULTATU = loggedOperatorInfos.CDOPERADOR;

      return oport.saveRow().then(function (response) {
        oport.currentRow.changed = false;

        if (response.dataset.DADOS && response.dataset.DADOS.DTULTATU)
          oport.currentRow.DTULTATU = response.dataset.DADOS.DTULTATU;
        ScreenService.showMessage(Messages.VAL_PREV_CAL_SUCESSO);
      });
    }
  };

  self.calcTotalItemValue = function () {
    var widget = templateManager.container.getWidget("itensgrid");

    Utilities.unMask("VRUNITITEMOPORT");
    Utilities.unMask("VRDESCITEMOPORT");

    widget.currentRow.QTITEMOPORT = widget.currentRow.QTITEMOPORT
      ? widget.currentRow.QTITEMOPORT
      : 1;
    widget.currentRow.VRUNITITEMOPORT = widget.currentRow.VRUNITITEMOPORT
      ? widget.currentRow.VRUNITITEMOPORT < 0
        ? widget.currentRow.VRUNITITEMOPORT * -1
        : widget.currentRow.VRUNITITEMOPORT
      : 1;
    widget.currentRow.QTMEDITEMOPORT = widget.currentRow.QTMEDITEMOPORT
      ? widget.currentRow.QTMEDITEMOPORT
      : 1;
    widget.currentRow.VRDESCITEMOPORT = widget.currentRow.VRDESCITEMOPORT
      ? widget.currentRow.VRDESCITEMOPORT
      : 0;

    var qtd = widget.currentRow.QTITEMOPORT;
    var valor_unitario = widget.currentRow.VRUNITITEMOPORT;
    var qtd_medida = widget.currentRow.QTMEDITEMOPORT;
    var tipo_desconto = widget.currentRow.IDTPDESCITEMOPORT;
    var desconto = widget.currentRow.VRDESCITEMOPORT;

    desconto =
      typeof desconto === "string"
        ? parseFloat(desconto.replace(",", "."))
        : desconto;

    switch (tipo_desconto) {
      case "S":
        widget.getField("VRDESCITEMOPORT").readOnly = true;
        widget.currentRow.VRDESCITEMOPORT = 0;
        widget.currentRow.VRTOTITEMOPORT = qtd * valor_unitario * qtd_medida;
        break;
      case "V":
        widget.getField("VRDESCITEMOPORT").readOnly = false;

        if (desconto < 0) {
          widget.currentRow.VRTOTITEMOPORT = "";
          ScreenService.notificationMessage(
            "O valor de desconto deve ser positivo",
            "alert"
          );
        } else if (desconto > qtd * valor_unitario * qtd_medida) {
          widget.currentRow.VRTOTITEMOPORT = "";
          ScreenService.notificationMessage(
            "O valor de desconto não pode ser maior que o valor total",
            "alert"
          );
        } else
          widget.currentRow.VRTOTITEMOPORT =
            qtd * valor_unitario * qtd_medida - desconto;

        widget.currentRow.VRDESCITEMOPORT = $.currency.string(desconto, {
          showSymbol: true,
          symbol: "R$",
          precision: 2,
          decimal: ",",
          thousands: ".",
        });

        break;
      case "P":
        widget.getField("VRDESCITEMOPORT").readOnly = false;

        if (desconto >= 0 && desconto <= 100)
          widget.currentRow.VRTOTITEMOPORT =
            qtd * valor_unitario * qtd_medida * (1 - desconto / 100);
        else {
          widget.currentRow.VRTOTITEMOPORT = "";
          ScreenService.notificationMessage(
            "O valor de desconto percentual deve estar entre 0 e 100",
            "alert"
          );
        }

        widget.currentRow.VRDESCITEMOPORT = desconto + "%";
    }
  };

  self.checkOport = function (widget) {
    if (
      widget.currentRow.SITUACAO == "A" ||
      widget.currentRow.SITUACAO == "Em aberto"
    ) {
      widget.getAction("EDIT").isVisible = true;
    } else {
      widget.getAction("EDIT").isVisible = false;
    }
  };

  self.checkRequirements = function (args, widgetName) {
    var widget = templateManager.container.getWidget(widgetName);

    if (
      (widget.name == "itens" || widget.name == "itensgrid") &&
      !widget.isValid() &&
      widget.currentRow.VRTOTITEMOPORT === 0 &&
      widget.currentRow.NRSERVICOPRODUTO &&
      widget.currentRow.CDTPMEDIDASERV &&
      widget.currentRow.IDTPDESCITEMOPORT
    ) {
      return true;
    } else if (
      !widget.isValid() ||
      ((widget.name == "oportunidade" || widget.name == "oportunidadegrid") &&
        !widget.currentRow.IDTPOPORT)
    ) {
      if (args) {
        args.e.preventDefault();
        ScreenService.showMessage(
          "Preencha todos os campos marcados com asterisco!"
        );
      }
      return false;
    }
    return true;
  };

  this.openModal = function () {
    ScreenService.openPopup(
      templateManager.container.getWidget("WDGT_OCCURRENCE")
    ).then(function () { }.bind(this));
  };

  self.checkRequirementsEvolutionGrid = function (args, widgetName) {
    var widget = templateManager.container.getWidget(widgetName);
    PartnerInfosModalController.setModalWidgetOnActiveWidget(
      widget,
      widget.parent.parent.currentRow.NRPARCNEGOCIO
    );
    if (
      widget.name == "evolucao" &&
      widget.isValid() &&
      widget.currentRow.NMMOTIEVOCON !== "" &&
      widget.currentRow.NMTIPOCONT !== "" &&
      widget.currentRow.NMSEQRESULEVOL !== "" &&
      widget.currentRow.TXEVOLCONT !== ""
    ) {
      if (widget.currentRow.NMSEQFASENEGO === "Solicitar Encerramento") {
        this.openModal();
      } else if (widget.parent.parent.currentRow.DSCORTERMOMETRO === '#ff030b' && (widget.currentRow.DSCORTERMOMETRO === '#19beff' || widget.currentRow.DSCORTERMOMETRO === '#ff8636')) {
        this.openModal();
      } else {
        var gridEvolucao = templateManager.container.getWidget("evolucao");
        gridEvolucao.currentRow.DSHIERARQUIAOPERPAI = "";
        gridEvolucao.currentRow.IDTPOCORRENCIA = "";
        gridEvolucao.currentRow.DSJUSTIFICATIVA = "";
        this.confirmClosingOpportunityBeforeSaveEvolution(gridEvolucao);
      }
    } else if (!widget.isValid() || widget.name == "evolucao") {
      if (args) {
        args.e.preventDefault();
        ScreenService.showMessage(
          "Preencha todos os campos marcados com asterisco!"
        );

      }
      return false;
    }

    return true;
  };

  this.saveOcorrence = function (args) {
    var widget = args.owner.widget;
    var gridEvolucao = templateManager.container.getWidget("evolucao");
    var fieldHierarquia = widget.getField("DSHIERARQUIAOPERPAI");
    var fieldTipoOcorrencia = widget.getField("IDTPOCORRENCIA");
    var fieldDescicaoOcorrencia = widget.getField("DSJUSTIFICATIVA");
    if (
      widget.name == "WDGT_OCCURRENCE" &&
      widget.isValid() &&
      widget.currentRow.DSHIERARQUIAOPER !== "" &&
      widget.currentRow.IDTPOCORRENCIA !== "" &&
      widget.currentRow.DSJUSTIFICATIVA !== ""
    ) {
      gridEvolucao.currentRow.DSHIERARQUIAOPERPAI = widget.currentRow.DSHIERARQUIAOPERPAI;
      gridEvolucao.currentRow.IDTPOCORRENCIA = widget.currentRow.IDTPOCORRENCIA;
      gridEvolucao.currentRow.DSJUSTIFICATIVA = widget.currentRow.DSJUSTIFICATIVA;
      gridEvolucao.currentRow.CDOPERADORGEST = widget.currentRow.CDOPERADORGEST;
      gridEvolucao.currentRow.NRHIERARQUIARESP = widget.currentRow.NRHIERARQUIAPAI;

      this.confirmClosingOpportunityBeforeSaveEvolution(gridEvolucao);

      ScreenService.closePopup(true);
      fieldHierarquia.value("");
      fieldTipoOcorrencia.value("");
      fieldDescicaoOcorrencia.value("");

    } else {

      ScreenService.showMessage(
        "Preencha todos os campos marcados com asterisco!"
      );
      return false;
    }
    widget.reload();
  };

  this.changeStatusJustifyField = function () {
    var gridEvolucao = templateManager.container.getWidget("evolucao");
    var fieldGroups = gridEvolucao.fieldGroups;

    var indexGroupJustify = CRM_Utilities.getFieldGroupPosition(fieldGroups, "FG_JUSTIFICATIVA");

    var groupFixedJustify = fieldGroups[indexGroupJustify];

    if (gridEvolucao.currentRow.DSJUSTIFICATIVA == "" || gridEvolucao.currentRow.DSJUSTIFICATIVA == null) {
      groupFixedJustify.isVisible = false;
    } else {
      groupFixedJustify.isVisible = true;
    }
  };

  self.cleanWizard = function () {
    if (templateManager.containers["wizard/oportunidade/wzoportstageoport"])
      templateManager.containers[
        "wizard/oportunidade/wzoportstageoport"
      ].widgets[0].currentRow = {};
    if (templateManager.containers["wizard/oportunidade/wzoportstageitens"])
      templateManager.containers[
        "wizard/oportunidade/wzoportstageitens"
      ].widgets[0].currentRow = {};
    if (templateManager.containers["wizard/oportunidade/wzoportstageposvenda"])
      templateManager.containers[
        "wizard/oportunidade/wzoportstageposvenda"
      ].widgets[0].currentRow = {};
  };

  function closeOccurrence(widget) {
    var oportWidgetFromOccurrence = widget.currentRow;
    oportWidgetFromOccurrence.CDOPERULTATU = CRM_Utilities.getLoggedOperatorInfos().CDOPERADOR;
    oportWidgetFromOccurrence.NRSEQFASENEGO = '7';
    oportWidgetFromOccurrence.IDATIVO = 'N';
    oportWidgetFromOccurrence.DTREALFECHA = moment(new Date()).format("DD/MM/YYYY HH:mm");

    var params = {
      requestType: "Row",
      row: oportWidgetFromOccurrence,
    };

    return restEngine.post("/closeOportByOccurrence", params)
      .then(function (response) {
        return response;
      })
      .catch(function (error) {
        ScreenService.showMessage(error.data.error, "error");
        console.log(error);
      });
  }

  self.closeOport = function (widget) {
    widget.currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    var params = {
      requestType: "Row",
      row: widget.currentRow,
    };

    return restEngine
      .post("/fecharOportunidade", params)
      .then(function () {
        widget.parent.parent.currentRow.DTREALFECHA =
          widget.currentRow.DTREALFECHA;
        widget.parent.parent.currentRow.NMRAZSOCCONC =
          widget.currentRow.NMRAZSOCCONC;
        widget.parent.parent.currentRow.SITUACAO = "F";

        //BEGIN RD Station
        var filter = [
          {
            name: "NRPARCNEGOCIO",
            operator: "=",
            value: widget.parent.parent.currentRow.NRPARCOPORT,
          },
          {
            name: "P_NRORGPADRAO",
            operator: "=",
            value: getLocalVar("CRM_NRORGPADRAO"),
          },
        ];
        localStorageEngine
          .download("product#/crud/crm_interlocutor", filter)
          .then(function (contacts) {
            if (!Util.isEmptyOrBlank(contacts)) {
              contacts.forEach(function (contact) {
                var row = {
                  email: contact["EMAILINTERLOC"],
                };
                if (widget.currentRow.IDGANHAPERDE === "GANHA") {
                  row["status"] = "won";
                  row["value"] = widget.currentRow.VROPORT;
                } else if (widget.currentRow.IDGANHAPERDE === "PERDE") {
                  row["status"] = "lost";
                  row["lost_reason"] = widget.currentRow.DESCRESULEVOL;
                }
                restEngine
                  .post("/IntegracaoRDStation/feedBackConversion", {
                    requestType: "Row",
                    row: {
                      EVENT_NAME: "Venda gerada pelo CRM",
                      EMAIL: contact["EMAILINTERLOC"],
                    },
                  })
                  .then(function () {
                    restEngine.post("/IntegracaoRDStation/markSale", {
                      requestType: "Row",
                      row: row,
                    });
                  });
              });
            }
          });
        //END RD Station
      })
      .catch(function (error) {
        ScreenService.showMessage(error.data.error, "error");
        console.log(error);
      });
  };

  self.evolve = function () {
    var widget = templateManager.container.getWidget("oportunidadegrid");

    self.start(
      widget.currentRow.NRPARCOPORT,
      widget.currentRow.NRCONTATO,
      widget.currentRow.NRSEQCONTATO,
      widget.currentRow.IDTPEVOLCONT
    );
  };

  self.start = function (parceiro, nrcontato, nrseqcontato, idtpevolcont) {
    setLocalVar("PARCEIRO", parceiro);

    var promises = [openWindow("evolucao_de_caso")];

    ZHPromise.all(promises).then(function () {
      var widget = templateManager.container.getActiveWidget();

      widget.currentRow.NRCONTATO = nrcontato;
      widget.currentRow.NRSEQCONTATO = nrseqcontato;

      widget.currentRow.IDTPEVOLCONT = idtpevolcont;
      widget.currentRow.NRPARCNEGOCIO = parceiro;

      widget.currentRow.__is_new = true;
    });
  };

  self.filterOport = function () {
    var widget = templateManager.container.getWidget("oportfilter");

    var NRSEQCLASSOPORT = widget.currentRow.NRSEQCLASSOPORT
      ? widget.currentRow.NRSEQCLASSOPORT
      : null;
    var NRSEQFASENEGO = widget.currentRow.NRSEQFASENEGO
      ? widget.currentRow.NRSEQFASENEGO
      : null;
    var NRPARCOPORT = widget.currentRow.NRPARCOPORT
      ? widget.currentRow.NRPARCOPORT
      : null;
    var NRPARCRESP = widget.currentRow.NRPARCRESP
      ? widget.currentRow.NRPARCRESP
      : null;
    var IDPARTPEPELINE = widget.currentRow.IDPARTPEPELINE
      ? widget.currentRow.IDPARTPEPELINE
      : null;

    var filter = [];
    var i = 0;

    filter[i] = widget.parent.parent.dataSourceFilter[0];
    i++;
    filter[i] = widget.parent.parent.dataSourceFilter[1];
    i++;

    if (NRSEQCLASSOPORT) {
      filter[i] = {
        name: "NRSEQCLASSOPORT",
        operator: "=",
        value: NRSEQCLASSOPORT,
      };
      i++;
    }
    if (NRSEQFASENEGO) {
      filter[i] = {
        name: "NRSEQFASENEGO",
        operator: "=",
        value: NRSEQFASENEGO,
      };
      i++;
    }
    if (NRPARCOPORT) {
      filter[i] = {
        name: "NRPARCOPORT",
        operator: "=",
        value: NRPARCOPORT,
      };
      i++;
    }
    if (NRPARCRESP) {
      filter[i] = {
        name: "NRPARCRESP",
        operator: "=",
        value: NRPARCRESP,
      };
      i++;
    }
    if (IDPARTPEPELINE) {
      filter[i] = {
        name: "IDPARTPEPELINE",
        operator: "=",
        value: IDPARTPEPELINE,
      };
      i++;
    }

    widget.parent.parent.dataSourceFilter = filter;
    Utilities.masterDetailClosePopup();
    widget.parent.parent.reload();
  };

  self.finishEvolution = function () {
    var popup = templateManager.container.getWidget("evoloport");

    Operador_Repository.retornaOperadorLogado().then(
      function (operator) {
        if (popup.isValid()) {
          if (operator[0] === undefined || operator[0] === null) {
            ScreenService.showMessage("Erro ao realizar a operação.");
            return;
          }

          popup.currentRow.NRORGULTATU = operator[0].NRORG;
          popup.currentRow.CDOPERULTATU = operator[0].CDOPERADOR;

          return popup.saveRow().then(function (response) {
            popup.currentRow.changed = false;
            popup.currentRow.__is_new = false;

            if (response.dataset.DADOS && response.dataset.DADOS.DTULTATU)
              popup.currentRow.DTULTATU = response.dataset.DADOS.DTULTATU;

            Utilities.masterDetailClosePopup();

            var widget = templateManager.container.getActiveWidget();

            widget.reload();
          });
        }
      },
      function (error) {
        ScreenService.showMessage("Erro ao realizar a operação.");
      }
    );
  };

  self.initAftersale = function () {
    var widget = templateManager.container.getWidget("posvenda");

    Operador_Repository.retornaOperadorLogado().then(
      function (operator) {
        if (operator[0] === undefined || operator[0] === null) {
          ScreenService.showMessage("Erro ao realizar a operação.");
          return;
        }

        widget.currentRow.NRORG = operator[0].NRORG;
        widget.currentRow.NMPARCRESP = operator[0].NMOPERADOR;
        widget.currentRow.NRPARCRESP = operator[0].CDOPERADOR;
        widget.currentRow.CDOPERREAL = operator[0].CDOPERADOR;

        widget.currentRow.NMPRINCIPALPARC = "";
        widget.currentRow.DSEMAILTAREFA = "";
        widget.currentRow.DSTELEFONETAREFA = "";

        widget.currentRow.__is_new = true;
        widget.currentRow.DTPLANFILACONTA = widget.currentRow.DTPLANFILACONTA
          ? widget.currentRow.DTPLANFILACONTA
          : moment(new Date()).format("DD/MM/YYYY HH:mm");

        widget.currentRow.NRPARCNEGOCIO =
          templateManager.containers[
            "wizard/oportunidade/wzoportstageoport"
          ].widgets[0].currentRow.NRPARCOPORT;
        widget.currentRow.NRCONTATO =
          templateManager.containers[
            "wizard/oportunidade/wzoportstageoport"
          ].widgets[0].currentRow.NRCONTATO;
        widget.currentRow.NRSEQCONTATO =
          templateManager.containers[
            "wizard/oportunidade/wzoportstageoport"
          ].widgets[0].currentRow.NRSEQCONTATO;

        widget.getField("NMPRINCIPALPARC").dataSourceFilter[0].value =
          templateManager.containers[
            "wizard/oportunidade/wzoportstageoport"
          ].widgets[0].currentRow.NRPARCOPORT;
        widget.getField("NMPRINCIPALPARC").reload();
      },
      function (error) {
        ScreenService.showMessage("Erro ao realizar a operação.");
      }
    );
  };

  self.initItemsWidget = function () {
    var widget = templateManager.container.getWidget("itensgrid");

    if (widget.parent.parent.currentRow.NRSEQOPORT) {
      widget.dataSourceFilter.find(function (x) {
        return x.name == "NRSEQOPORT";
      }).value = widget.parent.parent.currentRow.NRSEQOPORT;
    } else {
      widget.dataSourceFilter.find(function (x) {
        return x.name == "NRSEQOPORT";
      }).value = null;
    }
    widget.dataSourceFilter.find(function (x) {
      return x.name == "CRM_NRORGTRAB";
    }).value = getLocalVar("CRM_NRORGTRABALHO");

    self.reloadTab(widget, "NRSEQOPORT");
  };

  self.initItemsWizard = function () {
    var widget =
      templateManager.containers["wizard/oportunidade/wzoportstageitens"]
        .widgets[0];

    Operador_Repository.retornaOperadorLogado().then(
      function (operator) {
        if (operator[0] === undefined || operator[0] === null) {
          ScreenService.showMessage("Erro ao realizar a operação.");
          return;
        }

        widget.dataSourceFilter[1].value =
          templateManager.containers[
            "wizard/oportunidade/wzoportstageoport"
          ].widgets[0].currentRow.NRSEQOPORT;
        widget.reload();

        widget.currentRow.NRORG = operator[0].NRORG;
        widget.currentRow.NRSEQOPORT =
          templateManager.containers[
            "wizard/oportunidade/wzoportstageoport"
          ].widgets[0].currentRow.NRSEQOPORT;
      },
      function (error) {
        ScreenService.showMessage("Erro ao realizar a operação.");
      }
    );
  };

  self.initOportWidget = function () {
    if (
      templateManager.historyItems.length >= 2 &&
      templateManager.historyItems[templateManager.historyItems.length - 2] ==
      "evolucao_de_caso"
    ) {
      templateManager.historyItems[templateManager.historyItems.length - 2] =
        templateManager.historyItems[templateManager.historyItems.length - 1];

      self.openEvolutionPopup();
    }
  };

  self.initOportWizard = function () {
    var widget = templateManager.container.getWidget("oportunidade");
    Operador_Repository.retornaOperadorLogado().then(
      function (operator) {
        if (operator[0] === undefined || operator[0] === null) {
          ScreenService.showMessage("Erro ao realizar a operação.");
          return;
        }

        widget.currentRow.NRORG = operator[0].NRORG;
        widget.currentRow.CDFILIAL = "";
        widget.currentRow.NMPARCRESP = operator[0].NMOPERADOR;
        widget.currentRow.CDOPERCONT = operator[0].CDOPERADOR;
        widget.currentRow.NRPARCRESP = operator[0].NRPARCNEGOCIO;
        if (
          widget.currentRow.__is_new !== false &&
          widget.currentRow.__is_new !== true
        ) {
          widget.currentRow.__is_new = true;
        }
      },
      function (error) {
        ScreenService.showMessage("Erro ao realizar a operação.");
      }
    );
  };

  self.initTaskSchedule = function () {
    var widget = templateManager.container.getWidget("posvendagrid");

    //if(widget.parent.parent.currentRow.NRCONTATO) widget.dataSourceFilter[0].value = widget.parent.parent.currentRow.NRCONTATO;
    if (widget.parent.parent.currentRow.NRSEQCONTATO)
      widget.dataSourceFilter[0].value =
        widget.parent.parent.currentRow.NRSEQCONTATO;

    this.reloadTab(widget, "NRSEQCONTATO");
  };

  self.initTab = function (widget) {
    if (widget.parent.parent.currentRow.NRSEQOPORT) {
      var nrSeqoPortFilter = findFilterByName(widget.dataSourceFilter, "NRSEQOPORT");
      if (nrSeqoPortFilter) {
        nrSeqoPortFilter.value = widget.parent.parent.currentRow.NRSEQOPORT;
      } else {
        logError("Filtro 'NRSEQOPORT' não encontrado em dataSourceFilter.");
      }
    }

    var nrOrgTrabFilter = findFilterByName(widget.dataSourceFilter, "CRM_NRORGTRAB");
    if (nrOrgTrabFilter) {
      nrOrgTrabFilter.value = getLocalVar("CRM_NRORGTRABALHO");
    } else {
      logError("Filtro 'CRM_NRORGTRAB' não encontrado em dataSourceFilter.");
    }

    return self.reloadTab(widget, "NRSEQOPORT");
  };

  function findFilterByName(dataSourceFilter, filterName) {
    if (dataSourceFilter && dataSourceFilter.length > 0) {
      for (var i = 0; i < dataSourceFilter.length; i++) {
        if (dataSourceFilter[i].name === filterName) {
          return dataSourceFilter[i];
        }
      }
    }
    return null;
  };

  function logError(message) {
    console.error(message);
  };

  this.reloadTab = function (widget, filter) {
    var promise = ZHPromise.defer();
    if (
      widget.currentFilter &&
      widget.currentFilter !== widget.parent.parent.currentRow[filter]
    ) {
      widget.reload().then(function () {
        promise.resolve(widget.dataSource.data);
      });
    } else if (!widget.currentFilter) {
      widget.reload().then(function () {
        promise.resolve(widget.dataSource.data);
      });
    }
    this.setCurrentFilter(widget, filter);
    widget.reload();
    return promise.promise;
  };

  this.setCurrentFilter = function (widget, filter) {
    widget.currentFilter = widget.parent.parent.currentRow[filter];
  };

  /**
   * Questiona o usuário se ele deseja calcular o valor
   * (previsto) da oportunidade depois da exclusão do item.
   *
   * @param {object} widget widget de oportunidade ('oportunidadegrid').
   */
  this.calcOportValueAfeterItemDelete = function (widget) {
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              ScreenService.confirmMessage(
                Messages.CALC_VAL_PREV_OPORT_DELETE,
                "CONFIRMATION",
                function (success) {
                  this.itemsDelete(widget);
                  widget.CALCULATEOPPORTVALUE = true;
                }.bind(this),
                function () {
                  if (Boolean(widget.CALCULATEOPPORTVALUE)) {
                    delete widget.CALCULATEOPPORTVALUE;
                  }
                  this.itemsDelete(widget);
                }.bind(this)
              );
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    }.bind(this));
  };

  self.itemsDelete = function (widget) {
    General.deleteCrud(widget).then(function () {
      if (Boolean(widget.CALCULATEOPPORTVALUE)) {
        delete widget.CALCULATEOPPORTVALUE;
        self.calcOportValue();
      }
    });
  };

  self.itemsSave = function (widget) {
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              if (response.dataset) {
                Utilities.unMask("VRDESCITEMOPORT");

                widget.currentRow.CDPRODUTO = widget.currentRow.CDPRODUTO || "";
                widget.currentRow.CDSERVORCA = widget.currentRow.CDSERVORCA || "";
                if (widget.currentRow.__is_new) {
                  widget.currentRow.NRSEQOPORT = widget.parent.parent.currentRow.NRSEQOPORT;
                }

                return General.widgetSave(widget).then(function (response) {
                  if (Boolean(response.dataset.columnsToReturn[0])) {
                    widget.currentRow.NRSEQITENSOPORTUNI = response.dataset.columnsToReturn[0].NRSEQITENSOPORTUNI;
                  }
                  ScreenService.confirmMessage(
                    "Deseja calcular o valor da oportunidade à partir dos itens?",
                    "CONFIRMATION",
                    self.calcOportValue
                  );
                });
              }
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    }.bind(this));
  };

  self.itemsEdit = function (widget) {
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    if (widget.isValid()) {
      this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                General.widgetEdit(widget);
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                  response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                  " - " +
                  response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                  "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }.bind(this));
    }
  };

  /**
   * Habilita o ambiente de inserção de um item
   * para a oportunidade selecionada.
   *
   * @param {object} widget widget de items
   * ('itensgrid');
   */
  this.addOpportunityItem = function (widget) {
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              General.widgetNewRow(widget);

              this.setOpportItemsDefaultValues(widget);
              this.setWidgetItemsPermissions(widget);
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    }.bind(this));
  };

  /**
   * Define a permissão dos campos da widget de
   * itens.
   *
   * @param {object} widget widget de itens da oportunidade
   * ('itensgrid').
   */
  this.setWidgetItemsPermissions = function (widget) {
    var discountField = widget.getField("VRDESCITEMOPORT");
    discountField.readOnly = true;
  };

  /**
   * Define os valores iniciais do item
   * da oportunidade.
   *
   * @param {object} widget widget de items
   * ('itensgrid');
   */
  this.setOpportItemsDefaultValues = function (widget) {
    var currentRow = widget.currentRow;

    currentRow.CDTPMEDIDASERV = "";
  };

  self.itemsWizardCancelForm = function () {
    Utilities.wizardChangeFooter();
    Utilities.masterDetailCancelForm();
  };

  self.itemsWizardEdit = function () {
    Utilities.wizardChangeFooter();
    Utilities.masterDetailEdit();
  };

  self.itemsWizardNewRow = function () {
    self.calcTotalItemValue();
    Utilities.wizardChangeFooter();
  };

  self.openEvolutionPopup = function () {
    var widget = templateManager.container.getWidget("evoloport");

    ScreenService.openSwipe(widget);
    Utilities.masterDetailClosePopup();

    /* var widget = templateManager.container.getWidget('oportunidadegrid');

       Utilities.masterDetailOpenPopup('evoloport');

       var popup = templateManager.container.getActiveWidget();
       popup.currentRow = widget.currentRow;*/
  };

  self.oportNewRow = function (widget) {
    /*Evitando Bug depois de aplicar layout(Insere um field bugado no array d fields da widget)
          modificado no dia 05/10/17 por Arthur Herbert*/
    widget.fields.forEach(function (field, index, fields) {
      if (!field.value) {
        fields.splice(index, 1);
      }
    });
    /*Fim*/

    General.widgetNewRow(widget);

    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    widget.currentRow.CDFILIAL = "";
    widget.currentRow.NRSEQFASENEGO = "";
    widget.currentRow.NRORG = loggedOperatorInfos.NRORG;
    widget.currentRow.NMPARCRESP = loggedOperatorInfos.NMOPERADOR;
    widget.currentRow.CDOPERCONT = loggedOperatorInfos.CDOPERADOR;
    widget.currentRow.NRPARCRESP = loggedOperatorInfos.NRPARCNEGOCIO;
    widget.currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;

    this.setClosingDataGroupLockByNegotiationPhase(widget);
    this.setOpportunityValueObligatorinessByNegotiationPhase(widget);
    this.habilitaFechamento(widget);
  };

  self.removeOportFilters = function () {
    var popup = templateManager.container.getWidget("oportfilter");

    popup.currentRow = {};
    popup.reload();
  };

  self.saveOport = function (widgetName) {
    var widget = templateManager.container.getWidget(widgetName);
    var nrParcNegocio = widget.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              if (widget.isValid() && widget.currentRow.IDTPOPORT) {
                widgetAtiva = widget;
                widget.currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
                widget.currentRow.changed = true;

                Utilities.unMask("VROPORT");
                Utilities.unMask("VRPREVOPORT");
                this.goBackActions(widget);

                return General.widgetSave(widget)
                  .then(
                    function (response) {
                      if (response.dataset.DADOS && response.dataset.DADOS.NRSEQOPORT) {
                        widget.currentRow.NRSEQOPORT = response.dataset.DADOS.NRSEQOPORT;
                        widget.currentRow.NRCONTATO = response.dataset.DADOS.NRCONTATO;
                        widget.currentRow.NRSEQCONTATO = response.dataset.DADOS.NRSEQCONTATO;
                        widget.currentRow.DTINCLUSAO = response.dataset.DADOS.DTINCLUSAO;

                        widget.reload();
                        
                        var enviarEmail = function () {
                          if (response.dataset.DADOS.ENVIAEMAIL != false) {
                            ScreenService.confirmMessage(
                              "Deseja enviar um e-mail para o operador responsável da Oportunidade?",
                              "QUESTION",
                              function (yes) {
                                widget.currentRow.OPERADOREMAIL = response.dataset.DADOS.ENVIAEMAIL;      
                                var params = {
                                  requestType: "Row",
                                  row: widget.currentRow,
                                };

                                restEngine
                                  .post("/enviaEmailOportunidade", params)
                                  .then(
                                    function () {
                                      ScreenService.notificationMessage(
                                        "E-mail enviado com sucesso!! Número da Oportunidade: " +
                                        parseInt(response.dataset.DADOS.NRSEQOPORT),
                                        "success"
                                      );
                                    }
                                  )
                                  .catch(
                                    function (error) {
                                      if (error.data.error) {
                                        ScreenService.notificationMessage(
                                          "O e-mail não pode ser enviado pois as configurações de SMTP estão desconfiguradas ou erradas!",
                                          "error"
                                        );
                                      } else {
                                        ScreenService.notificationMessage(
                                          error.data.error,
                                          "error"
                                        );
                                      }
                                    }
                                  );
                              }.bind(this)
                            ).then(
                              function () {
                                this.continueIntegration(widget);
                              }.bind(this)
                            );
                          } else {
                            ScreenService.showMessage(
                              "Número da Oportunidade: " + parseInt(response.dataset.DADOS.NRSEQOPORT)
                            );
                            this.continueIntegration(widget);
                          }
                        }.bind(this);
                        
                        if (response.dataset.DADOS.IDATIVOPARCEIRO == 'N') {
                          ScreenService.confirmMessage(
                            "Parceiro inativo. Deseja reativar?",
                            "QUESTION",
                            function (yes) {
                              restEngine
                                .post("/reativaParceiro", {
                                  "PARCEIRO":nrParcNegocio 
                                })
                                .then(
                                  function () {
                                    ScreenService.notificationMessage(
                                      "Parceiro reativado com sucesso!",
                                      "success"
                                    );
                                  }
                                )
                                .catch(
                                  function (error) {
                                    if (error.data.error) {
                                      ScreenService.notificationMessage(
                                        "Parceiro não pode ser reativado. Consulte o administrador para mais informações!",
                                        "error"
                                      );
                                    } else {
                                      ScreenService.notificationMessage(
                                        error.data.error,
                                        "error"
                                      );
                                    }
                                  }
                                );
                                enviarEmail();
                            }.bind(this),
                            function (no) {
                              enviarEmail();
                            }.bind(this)
                          );
                        } else {
                          debugger;
                          enviarEmail();
                        }

                      } else if (response.dataset.DADOS && response.dataset.DADOS.DTULTATU) {
                        widget.currentRow.DTULTATU = response.dataset.DADOS.DTULTATU;
                      }
                    }.bind(this)
                  )
                  .catch(
                    function (error) {
                      ScreenService.showMessage(
                        Messages.CATCH_EXCEPTION_ERROR(error)
                      );
                    }
                  );
              }
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    }.bind(this));
  };

  self.saveTask = function (widgetName) {
    var widget = templateManager.container.getWidget(widgetName);
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              Operador_Repository.retornaOperadorLogado().then(
                function (operator) {
                  if (operator[0] === undefined || operator[0] === null) {
                    ScreenService.showMessage("Erro ao realizar a operação.");
                    return;
                  } else if (widget.isValid()) {
                    widget.currentRow.changed = true;
                    if (widget.currentRow.__is_new) {
                      widget.currentRow.NRORGINCLUSAO = operator[0].NRORG;
                      widget.currentRow.CDOPERINCLUSAO = operator[0].CDOPERADOR;
                      widget.currentRow.NRORGULTATU = null;
                      widget.currentRow.CDOPERULTATU = null;
                    } else {
                      widget.currentRow.NRORGULTATU = operator[0].NRORG;
                      widget.currentRow.CDOPERULTATU = operator[0].CDOPERADOR;
                    }

                    widget.currentRow.CDFILIAL = "";
                    widget.currentRow.NRSEQCLASSIFICATAREFA = widget.currentRow.NRSEQCLASSIFICATAREFA
                      ? widget.currentRow.NRSEQCLASSIFICATAREFA
                      : null;
                    widget.currentRow.TIPO = "OPORTUNIDADE";
                    widget.currentRow.NMPARCNEGOCIO = widget.getParent().currentRow.NMOPORT;
                    widget.currentRow.DESCRICAO =
                      "Referente a oportunidade " +
                      widget.currentRow.NMPARCNEGOCIO;
                    widget.currentRow.NMOPERREAL = widget.currentRow.NMOPERADOR;
                    widget.currentRow.OPERADORDOLOGADO = widget.getParent().currentRow.NMOPERINCLUSAO;
                    widget.currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
                    return widget.saveRow().then(function (response) {
                      widget.currentRow.changed = false;
                      widget.currentRow.__is_new = false;

                      if (Boolean(response.dataset.columnsToReturn.length)) {
                        widget.currentRow.NRSEQFILACONTA = response.dataset.DADOS[0].NRSEQFILACONTA;
                      }

                      if (widget.name == "posvenda") {
                        self.cleanWizard();
                        ScreenService.openWindow("oportunidade_de_negocio");
                      } else {
                        ScreenService.closeSwipe();
                        widget.reload();
                        widget.list();
                      }
                    });
                  }
                },
                function (error) {
                  ScreenService.showMessage("Erro ao realizar a operação.");
                }
              );
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    }.bind(this));
  };

  self.editTask = function (widget) {
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [
          currentRow,
        ]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              General.widgetEdit(widget);
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    }.bind(this));
  };

  self.deleteTask = function (widget) {
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [
          currentRow,
        ]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              General.deleteCrud(widget);
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    }.bind(this));
  };

  /**
   * Confirma o fechamento da oportunidade
   * antes de salvar a evolução em caso.
   *
   * @param {object} widget widget de evolução
   * ("evolucao").
   */
  this.confirmClosingOpportunityBeforeSaveEvolution = function (widget) {
    var currentRow = widget.currentRow;
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCOPORT;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [
          currentRow,
        ]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              if (widget.isValid()) {
                if (Boolean(currentRow.NRSEQRESULEVOLOPORT)) {
                  ScreenService.confirmMessage(
                    Messages.PERGUNTA_FECHAR_OPORTUNIDADE,
                    "CONFIRMATION",
                    function (success) {
                      widgetAtiva = widget;
                      this.saveEvolucao(widget);
                    }.bind(this)
                  );
                } else {
                  widgetAtiva = widget;
                  this.saveEvolucao(widget);
                }
              }
            } else {
              if (Boolean(currentRow.NRSEQRESULEVOLOPORT)) {
                ScreenService.confirmMessage(
                  Messages.PERGUNTA_FECHAR_OPORTUNIDADE,
                  "CONFIRMATION",
                  function (success) {
                    widgetAtiva = widget;
                    this.saveEvolucao(widget);
                  }.bind(this)
                );
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                  response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                  " - " +
                  response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                  "!"
                );
              }
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    }.bind(this));
  };

  /**
   * Organiza os campos para salvar a evolução
   * e verifica tarefa já aberta.
   *
   * @param {object} widget widget de evolução
   */
  self.saveEvolucao = function (widget) {
    var self = this; // Preserve the context

    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");

    if (Util.isEmptyOrBlank(currentRow.NRPARCNEGOCIO)) {
      currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCOPORT;
    }

    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    if (widget.getField("NMSEQRESULEVOL") && widget.name !== "WDGT_EVOLUCAO") {
      widget.getField("NMSEQRESULEVOL").readOnly = true;
    }

    if (widget.getField("DTPLANFILACONTA") && widget.name !== "WDGT_EVOLUCAO") {
      widget.getField("DTPLANFILACONTA").validations = {};
    }

    this.verificaTarefasAbertas(currentRow).then(
      function (response) {
        if (response.dataset.DADOS.TAREFAS) {
          var tarefas = response.dataset.DADOS.TAREFAS;
          var operadores = "";
          tarefas.forEach(function (tarefa) {
            operadores += "<br>" + tarefa;
          });

          ScreenService.confirmMessage(
            'Este parceiro possui tarefas "Em Aberto" para o(s) seguinte(s) operador(es) <br>' +
            operadores +
            "<br><br> Deseja continuar? ",
            "CONFIRMATION",
            function (success) {
              self.saveEvolutionAndInsertTask(
                widget,
                currentRow,
                loggedOperatorInfos
              ).then(function () {
                self.closeEvolSwipeAndReloadMainWid(widget);
              });
            }
          );
        } else {
          self.saveEvolutionAndInsertTask(
            widget,
            currentRow,
            loggedOperatorInfos
          ).then(function () {
            self.closeEvolSwipeAndReloadMainWid(widget);
          });
        }
      }.bind(self)
    );
  };

  this.closeEvolSwipeAndReloadMainWid = function (widget) {
    var mainWid = widget.parent.parent;

    ScreenService.closeSwipe().then(function () {
      ScreenService.closeSwipe();
      mainWid.activate();
      mainWid.reload();
    });
  };

  /**
   * Salva evolução e gera Tarefa
   *
   * @param {object} widget widget de evolução
   */
  this.saveEvolutionAndInsertTask = function (widget, currentRow, loggedOperatorInfos) {
    return this.insertEvolutionNewTask(widget).then(function (response) {
      if (response) {
        currentRow.NRSEQFILACONTA = response.dataset.DADOS.NRSEQFILACONTA;
      } else if (!currentRow.NRSEQFILACONTA) {
        currentRow.NRSEQFILACONTA = "";
      }
  
      currentRow.changed = true;
      if (currentRow.__is_new) {
        currentRow.NRORGINCLUSAO = loggedOperatorInfos.NRORG;
        currentRow.CDOPERINCLUSAO = loggedOperatorInfos.CDOPERADOR;
        currentRow.NRORGULTATU = null;
        currentRow.CDOPERULTATU = null;
      } else {
        currentRow.NRORGULTATU = loggedOperatorInfos.NRORG;
        currentRow.CDOPERULTATU = loggedOperatorInfos.CDOPERADOR;
      }
  
      currentRow.IDGERAFATURA = "NAO";
      currentRow.IDTPEVOLCONT = "P";
      currentRow.IDANEXOEVOLCONT = "N";
      currentRow.CDFILIAL = "";
  
      if (!currentRow.NRRELACIONAPARC) {
        currentRow.NRRELACIONAPARC = null;
      }
  
      var mainWid = templateManager.container.getWidget("oportunidadegrid");
      var estaFechada = false;
      if (
        Util.isEmptyOrBlank(mainWid) &&
        (widget.parent.parent.name == "CALENDARIO" ||
          widget.parent.parent.name == "LIST_COMPROMISSO")
      ) {
        return restEngine.post("product#/evolcont_crm_oportuni/buscarOportunidade", {
          requestType: "Row",
          row: widget.currentRow
        }).then(function (resp) {
          estaFechada = resp.dataset.DADOS.OPORTUNIDADE.SITUACAO === "F";
  
          // Reabre a evolução se ela estiver fechada e continua a salvar a evolução
          if (estaFechada) {
            return this.reabrirOportunidade(widget).then(
              function () {
                // Para garantir que não encerrará a oportunidade novamente.
                currentRow.NRSEQRESULEVOLOPORT = null;
              },
              function (err) {
                ScreenService.showMessage(err.error);
              }
            );
          } else {
            var finalizouOport = Boolean(currentRow.NRSEQRESULEVOLOPORT);
  
            // Se o operador escolheu finalizar a oportunidade
            if (finalizouOport) {
              var resposta = null;
              if (resp && resp.dataset.DADOS) {
                resposta = resp.dataset.DADOS.OPORTUNIDADE;
              }
              this.prepareToCloseOport(mainWid, widget, currentRow, resposta);
              return this.closeOport(widget).then(function () {
                if (!Util.isEmptyOrBlank(mainWid)) {
                  mainWid.currentRow.DTREALFECHA = currentRow.DTREALFECHA;
                  mainWid.currentRow.SITUACAO = "F";
                } else {
                  templateManager.container.getWidget("WDGT_NEW_COMMITMENT").currentRow.DTREALFECHA =
                    currentRow.DTREALFECHA;
                }
  
                // Guarda flag de oportunidade concluída para evitar sobreposição da mensagem de conclusão
                // e da mensagem de verificação de compromisso
                widget.OPORTCONCLUIDA = true;
              });
            }
          }
        }.bind(this));
      }
  
      return Promise.resolve();
    }.bind(this)).then(function () {
      return this.saveEvolutionAndReload(widget, currentRow, loggedOperatorInfos);
    }.bind(this));
  };

  this.prepareToCloseOport = function (mainWid, widget, currentRow, dados) {
    dados = dados || null;

    if (!Util.isEmptyOrBlank(mainWid)) {
      currentRow.NRSEQOPORT = mainWid.currentRow.NRSEQOPORT;
      currentRow.NRCONCORRENTE = currentRow.NRCONCORRENTE ? currentRow.NRCONCORRENTE : "";
      currentRow.DTREALFECHA = moment().format("DD/MM/YYYY HH:mm");
    } else if (!Util.isEmptyOrBlank(dados)) {
      currentRow.NRSEQOPORT = dados.NRSEQOPORT;
      currentRow.NRCONCORRENTE = currentRow.NRCONCORRENTE ? currentRow.NRCONCORRENTE : "";
      currentRow.DTREALFECHA = moment().format("DD/MM/YYYY HH:mm");
    }
  };

  this.saveEvolutionAndReload = function (widget, currentRow, loggedOperatorInfos) {
    var mainWid = widget.parent.parent;
  
    this.finishSavingEvolution(widget, currentRow, loggedOperatorInfos).then(function () {
      this.checkLoggedOperatorPermissionToChangeOpport(mainWid);
      mainWid.reload();
      widget.reload();
    }.bind(this));
  };

  this.finishSavingEvolution = function (widget, currentRow, loggedOperatorInfos) {
    var mainWid = widget.parent.parent;
    var is_new = widget.currentRow.__is_new;

    return General.widgetSave(widget).then(function (response) {
      if (response.dataset.DADOS) {
        widget.currentRow.NRSEQEVOLCONT =
          response.dataset.DADOS[0].NRSEQEVOLCONT;
      }

      return this.checkMail(widget).then(function () {
        this.cleanNextTaskFieldValues(widget);

        var fazerUpdate = false;
        var params = {
          requestType: "Row",
          row: {
            NRSEQOPORT: mainWid.currentRow.NRSEQOPORT,
          },
        };

        Utilities.unMask("VROPORT");
        Utilities.unMask("VRPREVOPORT");

        var nrtermoportuni = currentRow.NRTERMOPORTUNI;
        var nrseqfasenego = currentRow.NRSEQFASENEGO;
        var nrparcresp = currentRow.NRPARCRESP;
        var vroport = currentRow.VROPORT;
        var vrprevoport = currentRow.VRPREVOPORT;

        if (nrtermoportuni) {
          params.row.NRTERMOPORTUNI = nrtermoportuni;
          fazerUpdate = true;
        }
        if (nrseqfasenego) {
          params.row.NRSEQFASENEGO = nrseqfasenego;
          fazerUpdate = true;
        }
        if (nrparcresp) {
          params.row.NRPARCRESP = nrparcresp;
          fazerUpdate = true;
        }
        if (vroport) {
          params.row.VROPORT = vroport;
          fazerUpdate = true;
        }
        if (vrprevoport) {
          params.row.VRPREVOPORT = vrprevoport;
          fazerUpdate = true;
        }

        if (fazerUpdate) {
          var currRow = mainWid.currentRow;

          try {
            //atualiza oportunidade
            return restEngine.post(
              "product#/evolcont_crm_oportuni/atualizarOportunidade",
              params
            ).then(function () {
              if (nrseqfasenego) {
                currRow.NRSEQFASENEGO = nrseqfasenego;
                currRow.NMSEQFASENEGO = widget.currentRow.NMSEQFASENEGO;
              }

              if (nrparcresp) {
                currRow.NRPARCRESP = nrparcresp;
                currRow.NMPARCRESP = widget.currentRow.NMPARCRESP;
              }

              if (vroport) {
                currRow.VROPORT = vroport;
              }

              mainWid.reload();
            }).catch(function (error) {
              console.log(error);
              ScreenService.showMessage(error.data.error);
            });
          } catch (error) {
            console.log(error);
            ScreenService.showMessage(error.data.error);
          }
        }

        this.setTaskEndDate(widget);
        var widgetCompromisso = templateManager.container.getWidget(
          "compromissoOportunidade"
        );
        var widgetOportunidade = templateManager.container.getWidget(
          "oportunidadegrid"
        );
        //pula se for tab dinamica
        if (widget.name !== "WDGT_EVOLUCAO") {
          if (is_new == true) {
            if (widget.OPORTCONCLUIDA) {
              ScreenService.showMessage(Messages.OPORTUNIDADE_CONCLUIDA);
              this.verificaNovoCompromisso(widgetCompromisso, widgetOportunidade);
              delete widget.OPORTCONCLUIDA;
            } else {
              this.verificaNovoCompromisso(widgetCompromisso, widgetOportunidade);
            }
          }
        }
        if (widget.afterSave) {
          widget.afterSave.forEach(function (method) {
            eval(method);
          });
        }
      }.bind(this));
    }.bind(this)).catch(function (error) {
      if (error.indexOf("REQUIRE_INTERLOCUTOR") !== -1) {
        ScreenService.showMessage('Operação bloqueada! <br><br> Favor informar o interlocutor.');
        if (widget.OPORTCONCLUIDA === true) this.goBackActions(widget);
      } else {
        ScreenService.showMessage(error);
      }
    }.bind(this));
  };

  this.checkMail = function (widget) {
    var promise = ZHPromise.defer();
    if (
      !Util.isEmptyOrBlank(widget.currentRow.NRSEQINTERLOCUTOR) &&
      widget.currentRow.IDENVIAEMAIL === "S"
    ) {
      ScreenService.confirmMessage(
        "Deseja enviar um email para " + widget.currentRow.NMINTERLOCUTOR + "?",
        "QUESTION",
        function (yes) {
          evolutionTabController.openWidgetSendMail(widget).then(function () {
            promise.resolve();
          });
        },
        function (no) {
          promise.resolve();
        }
      );
    } else {
      promise.resolve();
    }
    return promise.promise;
  };

  /**
   * Verifica se já existem tarefas relacionadas
   * aquele parceiro
   *
   * @param {object} widget widget de evolução
   */
  this.verificaTarefasAbertas = function (currentRow) {
    var paramsRestEngine = {
      requestType: "Row",
      row: currentRow,
    };
    return restEngine.post("/verificaTarefas", paramsRestEngine);
  };

  self.insertEvolutionNewTask = function (widget) {
    var currentRow = widget.currentRow;
    currentRow.CDOPERINCLUSAO = templateManager.LOGGEDOPERATOR.CDOPERADOR;
    currentRow.NRSEQFILACONTA = null;
    currentRow.NRSEQCAMPANHA = null;
    currentRow.NRSEQINTERLOCUTOR = Util.isEmptyOrBlank(
      currentRow.NRSEQINTERLOCUTOR
    )
      ? null
      : currentRow.NRSEQINTERLOCUTOR;
    currentRow.DSEMAILTAREFA = null;
    currentRow.DSTELEFONETAREFA = null;
    currentRow.NRSEQCLASSIFICATAREFA = null;

    var deferred = ZHPromise.defer();

    if (currentRow.DTPLANFILACONTA && !currentRow.NEXTTASKBLOCKED) {
      if (Util.isEmptyOrBlank(currentRow.NRPARCNEGOCIO)) {
        currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCOPORT;
      }

      var params = {
        requestType: "Row",
        row: currentRow,
      };

      //insere tarefa
      return restEngine
        .post("/insertNextTaskCliente", params)
        .then()
        .catch(function (error) {
          ScreenService.showMessage(error.data.error);
        });
    } else {
      deferred.resolve();
    }
    return deferred;
  };

  self.evolucaoNewRow = function (encerramentoVisivel) {
    var widget = templateManager.container.getWidget("evolucao");
    var groupEncerramento = widget.fieldGroups.find(function (group) {
      return group.name === "FG_DADOS_FECHAMENTO";
    });

    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    var self = this; // Preserve the context

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              General.widgetNewRow(widget);

              widget.getField("NMSEQRESULEVOL").readOnly = false;
              widget.getField("NMSEQFASENEGO").readOnly = false;
              widget.getField("DTPLANFILACONTA").validations = {
                required: true,
              };
              widget.getField("NMSEQFASENEGO").validations = {
                required: true,
              };

              var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
              var currentRow = widget.currentRow;

              if (
                (widget.parent.parent.currentRow.SITUACAO === "P" ||
                  widget.parent.parent.currentRow.SITUACAO == "F") &&
                loggedOperatorInfos.CDOPERADOR ==
                widget.parent.parent.currentRow.CDOPERADORGEST
              ) {
                var gridEvolution = templateManager.container.getWidget(
                  "evolucao"
                );
                var newCurrentRow = Object.values(gridEvolution.dataSource.data);
                console.log(newCurrentRow);

                currentRow.DTHREVOLCONT = currentRow.DTHREVOLCONT
                  ? currentRow.DTHREVOLCONT
                  : moment(new Date()).format("DD/MM/YYYY HH:mm");
                currentRow.DTREALFECHA = CRM_Utilities.getDataHoraAtual();
                currentRow.NMOPERADOR =
                  widget.parent.parent.currentRow.NMPARCRESP;
                NMOPERADORREAL;
                currentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
                currentRow.CDOPERREAL =
                  widget.parent.parent.currentRow.CDOPERADOR;
                currentRow.NMOPERADORREAL =
                  widget.parent.parent.currentRow.NMPARCRESP;
                currentRow.NRCONTATO =
                  widget.parent.parent.currentRow.NRCONTATO;
                currentRow.NRSEQCONTATO =
                  widget.parent.parent.currentRow.NRSEQCONTATO;
                currentRow.NRORG = loggedOperatorInfos.NRORG;
                currentRow.NRSEQFASENEGO = newCurrentRow[1].NRSEQFASENEGO;
                currentRow.NMSEQFASENEGO = newCurrentRow[1].NMSEQFASENEGO;
                currentRow.NRSEQINTERLOCUTOR =
                  newCurrentRow[1].NRSEQINTERLOCUTOR;
                currentRow.NMINTERLOCUTOR =
                  newCurrentRow[1].NMINTERLOCUTOR;
                currentRow.NMTIPOCONT = newCurrentRow[1].NMTIPOCONT;
                currentRow.CDTIPOCONT = newCurrentRow[1].CDTIPOCONT;
                currentRow.CDMOTIEVOCON =
                  newCurrentRow[1].CDMOTIEVOCON;
                currentRow.NMMOTIEVOCON =
                  newCurrentRow[1].NMMOTIEVOCON;
                currentRow.DESCRESULEVOL =
                  newCurrentRow[1].DESCRESULEVOL;
                currentRow.NMSEQRESULEVOL =
                  newCurrentRow[1].NMSEQRESULEVOL;
                currentRow.NRSEQRESULEVOL =
                  newCurrentRow[1].NRSEQRESULEVOL;
                currentRow.NRTERMOPORTUNI =
                  widget.parent.parent.currentRow.NRTERMOPORTUNI;
                currentRow.NMTERMOPORTUNI =
                  widget.parent.parent.currentRow.NMTERMOPORTUNI;
              } else {
                currentRow.DTHREVOLCONT = currentRow.DTHREVOLCONT
                  ? currentRow.DTHREVOLCONT
                  : moment(new Date()).format("DD/MM/YYYY HH:mm");
                currentRow.DTREALFECHA = CRM_Utilities.getDataHoraAtual();
                currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
                currentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
                currentRow.CDOPERREAL =
                  widget.parent.parent.currentRow.CDOPERADOR;
                currentRow.NMOPERADORREAL =
                  widget.parent.parent.currentRow.NMPARCRESP;
                currentRow.NRCONTATO =
                  widget.parent.parent.currentRow.NRCONTATO;
                currentRow.NRSEQCONTATO =
                  widget.parent.parent.currentRow.NRSEQCONTATO;
                currentRow.NRORG = loggedOperatorInfos.NRORG;
                currentRow.NRSEQFASENEGO =
                  widget.parent.parent.currentRow.NRSEQFASENEGO;
                currentRow.NMSEQFASENEGO =
                  widget.parent.parent.currentRow.NMSEQFASENEGO;
                currentRow.NRTERMOPORTUNI =
                  widget.parent.parent.currentRow.NRTERMOPORTUNI;
                currentRow.NMTERMOPORTUNI =
                  widget.parent.parent.currentRow.NMTERMOPORTUNI;
              }

              ABEvolucaoController.setEvolDateChangePermission(widget);
              self.unlockNextTask(widget); // Use 'self' to reference 'this'
              self.setNewTaskPermission(widget, true);
              self.setClosingDataGroupLockByNegotiationPhase(widget);
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }
        );
      } else {
        self.showMessageCantEditParc();
      }
    });
  };

  /**
   * Confirma se o usuário deseja criar um novo
   * compromisso relacionado aquela oportunidade.
   *
   */
  this.verificaNovoCompromisso = function (
    widgetCompromisso,
    widgetOportunidade
  ) {
    ScreenService.confirmMessage(
      "Deseja criar um novo compromisso para esta oportunidade? ",
      "CONFIRMATION",
      function (success) {
        this.abrirWidgetCompromisso(widgetCompromisso, widgetOportunidade);
      }.bind(this)
    );
  };

  this.abrirWidgetCompromisso = function (
    widgetCompromisso,
    widgetOportunidade
  ) {
    ScreenService.openSwipe(widgetCompromisso).then(function () {
      widgetCompromisso.newRow();
      widgetCompromisso.edit();
      widgetCompromisso.activate();

      widgetCompromisso.actions.forEach(function (comprimissoAction) {
        comprimissoAction.isVisible = true;
      });

      var compromissoRow = widgetCompromisso.currentRow;

      compromissoRow.NMPRINCIPALPARC =
        widgetOportunidade.currentRow.NMPRINCIPALPARC;
      compromissoRow.NRPARCNEGOCIO = widgetOportunidade.currentRow.NRPARCOPORT;
      compromissoRow.DSPLANOCUPA =
        "Número da Oportunidade: " +
        parseInt(widgetOportunidade.currentRow.NRSEQOPORT);
      widgetCompromisso.descriptionOrder =
        "Compromisso relacionado à Oportunidade: " +
        parseInt(widgetOportunidade.currentRow.NRSEQOPORT);
      compromissoRow.TIPO = "OPORTUNIDADE";
      compromissoRow.NRSEQCONTATO = widgetOportunidade.currentRow.NRSEQCONTATO;
      compromissoRow.NMOPORT = widgetOportunidade.currentRow.NMOPORT;
      compromissoRow.FIELDOPORTUNI = widgetOportunidade.currentRow.NMOPORT;
      compromissoRow.CDOPERADOR = widgetOportunidade.currentRow.CDOPERADOR;
      compromissoRow.NMOPERADORESPONS =
        widgetOportunidade.currentRow.NMPARCRESP;
      compromissoRow.NMOPERADOR = widgetOportunidade.currentRow.NMPARCRESP;
      compromissoRow.CDOPERADORESPONS =
        widgetOportunidade.currentRow.CDOPERADOR;

      widgetCompromisso.redraw();
    });
  };

  this.cancelarCompromisso = function (widget) {
    var widgetOportunidade = templateManager.container.getWidget(
      "oportunidadegrid"
    );
    ScreenService.closeSwipe().then(function () {
      widgetOportunidade.activate();
    });
  };

  /**
   * Salva o novo compromisso
   */
  this.salvarCompromisso = function (widget) {
    var compromissoController = CRM_Utilities.getController(
      "crm30000000_Compromisso_Controller"
    );

    var parentWidget = widget.getParent();

    if (widget.isValid()) {
      this.setCommitmentDateInCurrentRow(widget);
      var currentRow = widget.currentRow;
      var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
      var widgetOportunidade = templateManager.container.getWidget(
        "oportunidadegrid"
      );

      currentRow.NRORG = loggedOperatorInfos.NRORG;
      currentRow.DTINIPLANOCUPA = currentRow.DTINI;
      currentRow.DTFINPLANOCUPA = currentRow.DTFIM;
      currentRow.NRRELACIONAPARC = "";
      currentRow.CDFILIAL = "";
      currentRow.NRCONTATO = currentRow.NRCONTATO
        ? currentRow.NRCONTATO
        : currentRow.NRSEQCONTATO;
      currentRow.CDINTEPLANOCUPA = "";

      currentRow.DEFINEEVENTOGOOGLE = currentRow.__is_new ? true : false;

      CRM_Utilities.setColumnToReturnInCurrentRow(
        widget.currentRow,
        "NRSEQPLANOCUPA"
      );

      var saveParams = {
        requestType: "DataSet",
        dataset: [currentRow],
      };

      restEngine
        .post(widget.dataSource.name + "/save", saveParams)
        .then(function (response) {
          ScreenService.closeSwipe().then(function () {
            templateManager.container.getWidget("oportunidadegrid").activate();
          });

          currentRow.NRSEQPLANOCUPA =
            response.dataset.columnsToReturn.NRSEQPLANOCUPA;

          ScreenService.confirmMessage(
            Messages.SINC_GOOGLE_CALENDAR,
            "question",
            function (success) {
              if (currentRow.DEFINEEVENTOGOOGLE) {
                compromissoController.addEventToLoggedUserGoogleCalendarWithoutQuest(
                  currentRow
                );
              } else {
                compromissoController.editGoogleEvent(currentRow);
              }
            },
            function (error) {
              ScreenService.showMessage("Compromisso criado com sucesso!");
            }
          );
        });
    }
  };

  self.wizardFirstStep = function () {
    var promises = [self.saveOport("oportunidade_de_negocio_wizard")];

    ZHPromise.all(promises).then(function () {
      var widget =
        templateManager.containers["wizard/oportunidade/wzoportstageoport"]
          .widgets[0];

      if (widget.isValid() && widget.currentRow.IDTPOPORT)
        self.initItemsWizard();
    });
  };

  this.abrirWidgetTarefa = function () {
    var self = this; // Preserve the context

    var widget = templateManager.container.getActiveWidget();
    var nrParcNegocio = widget.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              self.fecharPopupDeActions().then(
                function () {
                  var widget = templateManager.container.getWidget("posvendagrid");
                  widget.activate();
                  setTimeout(function () {
                    self.taskScheduleNewRow(widget);
                  }, 100);
                }.bind(self)
              );
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(self)
        );
      } else {
        self.showMessageCantEditParc();
      }
    });
  };

  this.abrirWidgetEvolucao = function (encerramentoVisivel) {
    var widget = templateManager.container.getWidget("evolucao");
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCOPORT;
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
    var self = this; // Save a reference to 'this' for use inside the inner functions

    if (
      (widget.parent.parent.currentRow.SITUACAO == "P" ||
        widget.parent.parent.currentRow.SITUACAO == "F") &&
      loggedOperatorInfos.NRHIERARQUIAOPER != widget.parent.parent.currentRow.NRHIERARQUIARESP
    ) {
      ScreenService.showMessage(
        "Essa Oportunidade encontra-se Pendente, gentileza procurar o gestor responsável!"
      );
    } else {
      this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
        if (canEdit) {
          self.fecharPopupDeActions().then(
            function () {
              widget.activate();
              setTimeout(function () {
                self.evolucaoNewRow(encerramentoVisivel);
              }, 100);
            }.bind(self) // Use .bind(self) to set the correct value of 'this'
          ).catch(function (error) {
            console.error("Error closing popup:", error);
          });
        } else {
          self.showMessageCantEditParc();
        }
      }.bind(self)); // Use .bind(self) to set the correct value of 'this'
    }
  };

  this.fecharPopupDeActions = function () {
    var deferred = ZHPromise.defer();
    ScreenService.closePopup();
    deferred.resolve();
    return deferred;
  };

  this.setResultFieldFilter = function (field) {
    var fieldFilter = field.dataSourceFilter;
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    var nrorgFilterIndex = CRM_Utilities.getFilterPosition(
      fieldFilter,
      "P_NRORG"
    );
    var operatorCodeFilterIndex = CRM_Utilities.getFilterPosition(
      fieldFilter,
      "P_CDOPERADOR"
    );

    fieldFilter[nrorgFilterIndex].value = loggedOperatorInfos.NRORG;
    fieldFilter[operatorCodeFilterIndex].value = loggedOperatorInfos.CDOPERADOR;
  };

  /**
   * Função para possibilitar o cadastro de
   * uma evolução referente a tarefa em caso,
   * indicando a conclusão da tarefa.
   *
   * @param {object} widget widget ativa, no modo
   * view, referente a tarefa em caso.
   */
  this.completeTask = function (widget) {
    var self = this; // Preserve the context
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCOPORT;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        var currentRow = widget.currentRow;

        if (!currentRow.DTREALFILACONTA) {
          var evolutionWidget = templateManager.container.getWidget("evolucao");

          evolutionWidget.COMPLETETASK = true;
          evolutionWidget.NRORG = currentRow.NRORG;
          evolutionWidget.NRSEQFILACONTA = currentRow.NRSEQFILACONTA;
          ScreenService.closeSwipe().then(
            function () {
              self.activateWidget(evolutionWidget).then(
                function () {
                  setTimeout(
                    function () {
                      self.evolucaoNewRow();
                    },
                    500
                  );
                }
              );
            }
          );
        } else {
          ScreenService.showMessage(Messages.TAREFA_JA_CONCLUIDA);
        }
      } else {
        self.showMessageCantEditParc();
      }
    });
  };

  /**
   * Função para ativar uma widget
   *
   * @param {object} widget widget que será
   * ativada.
   *
   * @return {object} deferred 'promise' indicando
   * a conclusão da tarefa da função.
   */
  this.activateWidget = function (widget) {
    var deferred = ZHPromise.defer();

    widget.activate();
    deferred.resolve();

    return deferred;
  };

  /**
   * Função para pegar as informações da tarefa
   * na widget de evolução e setar a data de
   * conclusão da tarefa no registro da própria
   * tarefa.
   *
   * @param {object} widget widget ativa que contém
   * as informações da tarefa que será concluida.
   */
  this.setTaskEndDate = function (widget) {
    var currentRow = widget.currentRow;

    if (widget.COMPLETETASK) {
      var paramsRestEngine = {
        requestType: "Row",
        row: currentRow,
      };

      currentRow.NRSEQFILACONTA = widget.NRSEQFILACONTA;
      currentRow.NRORG = widget.NRORG;

      return restEngine.post(
        "/setTaskEndDate/oportunidadeDeNegocio",
        paramsRestEngine,
        function (success) {
          ScreenService.showMessage(Messages.TAREFA_CONCLUIDA);
          this.deleteTaskInfosInEvolutionWidget(widget);
          this.activateTaskWidget();
        }.bind(this),
        undefined,
        function (error) { },
        undefined,
        undefined
      );
    }
  };

  /**
   * Função para ativar a widget de agenda
   * de tarefas.
   */
  this.activateTaskWidget = function () {
    var taskWidget = templateManager.container.getWidget("posvendagrid");

    taskWidget.activate();
  };

  /**
   * Função para deletar as informações da
   * tarefa a ser concluída da widget de evolução.
   *
   * @param {object} widget widget de evolução.
   */
  this.deleteTaskInfosInEvolutionWidget = function (widget) {
    delete widget.COMPLETETASK;
    delete widget.NRSEQFILACONTA;
    delete widget.NRORG;
  };

  /**
   * Função para definir os valores iniciais
   * de uma tarefa.
   *
   * @param {object} widget widget ativa, que terá
   * sua currentRow modificada com os valores da nova
   * tarefa.
   */
  self.taskScheduleNewRow = function (widget) {
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;
  
    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [
          currentRow,
        ]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              General.widgetNewRow(widget);
  
              currentRow = widget.currentRow;
              var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
  
              currentRow.DTPLANFILACONTA = widget.currentRow.DTPLANFILACONTA
                ? widget.currentRow.DTPLANFILACONTA
                : moment(new Date()).format("DD/MM/YYYY HH:mm");
              currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
              currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
              currentRow.NRPARCNEGOCIO =
                widget.parent.parent.currentRow.NRPARCOPORT;
              currentRow.NRCONTATO = widget.parent.parent.currentRow.NRCONTATO;
              currentRow.NRSEQCONTATO =
                widget.parent.parent.currentRow.NRSEQCONTATO;
              currentRow.NMPRINCIPALPARC = "";
              currentRow.DSEMAILTAREFA = "";
              currentRow.DSTELEFONETAREFA = "";
              currentRow.NRORG = loggedOperatorInfos.NRORG;
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    });
  };

  /**
   * Função para checar a permissão para gerar
   * uma nova tarefa a partir de uma nova evolução.
   *
   * @param {object} widget widget ativa, no modo
   * edit, onde está sendo cadastrado a evolução.
   */
  this.checkNewTaskPermissionByEvolutionResult = function (widget) {
    var currentRow = widget.currentRow;
    var dataProximaTarefa = widget.getField("DTPLANFILACONTA");
    var operadorField = widget.getField("NMOPERADORREAL");
    var assuntoTarefaField = widget.getField("DSFILACONTATO");
    var prioridadeField = widget.getField("NRPRIORFILACONT");

    if (
      !Boolean(currentRow.DESCRESULEVOL) &&
      currentRow.IDGERPROXATIV &&
      currentRow.IDGERPROXATIV === "S" &&
      !currentRow.NEXTTASKBLOCKED
    ) {
      this.setNewTaskPermission(widget, true);
      dataProximaTarefa.validations = {
        required: true,
      };
      operadorField.validations = {
        required: true,
      };
      assuntoTarefaField.validations = {
        required: true,
      };
      prioridadeField.validations = {
        required: true,
      };
    } else {
      this.setNewTaskPermission(widget, false);
      dataProximaTarefa.validations = {};
      operadorField.validations = {};
      assuntoTarefaField.validations = {};
      prioridadeField.validations = {};
    }
  };

  /**
   * Função para setar a permissão de criar uma nova
   * tarefa a partir do resultado da evolução.
   *
   * @param {object} widget widget ativa, no modo edit,
   * onde está sendo cadastrado a evolução.
   *
   * @param {boolean} isAllowed permissão booleana do
   * cadastro da tarefa.
   */
  this.setNewTaskPermission = function (widget, isAllowed) {
    if (isAllowed) {
      this.setTaskFieldLock(widget, false);

      widget.currentRow.DTPLANFILACONTA = "";
    } else {
      this.setTaskFieldLock(widget, true);
    }
  };

  /**
   * Função para definir o bloqueio dos campos
   * de agenda de tarefa na widget de evolução.
   *
   * @param {object} widget widget de evolução,
   * onde estão os campos para criar um nova
   * tarefa.
   *
   * @param {boolean} isLocked estado dos campos.
   */
  this.setTaskFieldLock = function (widget, isLocked) {
    var nextTaskDate = widget.getField("DTPLANFILACONTA");
    var taskOperator = widget.getField("NMOPERADORREAL");
    var taskDescription = widget.getField("DSFILACONTATO");
    var taskClassification = widget.getField("DSCLASSIFICATAREFA");
    var taskPriority = widget.getField("NRPRIORFILACONT");

    nextTaskDate.readOnly = isLocked;
    taskOperator.readOnly = isLocked;
    taskDescription.readOnly = isLocked;
    taskClassification.readOnly = isLocked;
    taskPriority.readOnly = isLocked;
  };

  /**
   * Função para resetar as informações
   * de criação de uma nova tarefa(a partir de uma
   * evolução).
   *
   * @param {object} widget widget de evolução, que terá
   * as informações resetadas.
   */
  this.resetNewTaskInfos = function (widget) {
    var currentRow = widget.currentRow;
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    currentRow.DTPLANFILACONTA = moment().format("DD/MM/YYYY");
    currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
    currentRow.NMOPERADORREAL = loggedOperatorInfos.NMOPERADOR;
    currentRow.NRPRIORFILACONT = 2;
  };

  /**
   * Função para abrir a widget de seleção
   * de arquivos.
   */
  this.openAnnexSwipe = function () {
    var fileUploadWidget = templateManager.container.getWidget(
      "WDGT_SELECAO_ARQUIVOS"
    );

    fileUploadWidget.isVisible = true;
    ScreenService.openSwipe(fileUploadWidget);
  };

  /**
   * Função para salvar os anexos selecionados
   * ao caso em questão.
   *
   * @param {object} widget widget onde é
   * feito a seleção dos anexos.
   */
  this.uploadEvolutionFiles = function (widget) {
    var attachedStatus = templateManager.container.getWidget("evolucao");
    var files = widget.currentRow.DSCAMINHO;

    var rows = [];

    files.forEach(
      function (file, fileIndex) {
        rows.push(this.setValuesForFileUpload(widget, fileIndex));
      }.bind(this)
    );

    General.callRestEngine(
      "product#/crm_anexocontato/save",
      "DataSet",
      rows
    ).then(
      function () {
        this.closeAnnexSwipe(widget);
        widget.parent.parent.reload();
        attachedStatus.reload();
      }.bind(this)
    );
  };

  /**
   * Função para retornar uma row configurada
   * com as informações do anexo referente
   * ao ID, recebido como parâmetro, no array
   * de anexos na currentRow.
   *
   * @param {object} widget widget onde foi selecionado
   * os anexos.Array
   *
   * @param {int} fileIndex index do anexo no array de
   * anexos presente na currentRow.
   *
   * @return {object} currentRow row configurada com as informações
   * do anexo referente ao ID recebido.
   */
  this.setValuesForFileUpload = function (widget, fileIndex) {
    var currentRow = angular.copy(widget.currentRow);
    var evolutionWidget = widget.parent.parent;
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    currentRow.NRSEQCONTATO = evolutionWidget.getParent().currentRow.NRSEQCONTATO;
    currentRow.NMARQUIVO = this.getFileNameWithoutExtension(
      currentRow.DSCAMINHO[fileIndex].name
    );
    currentRow.DSTIPO = this.getFileExtension(
      currentRow.DSCAMINHO[fileIndex].name
    );
    currentRow.VRTAMANHO = currentRow.DSCAMINHO[fileIndex].size;
    currentRow.IDATIVO = "S";
    currentRow.NRORG = loggedOperatorInfos.NRORG;
    currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
    currentRow.IDORIGEM = "EVOLUCAO";
    currentRow.NRORIGEM = evolutionWidget.getParent().currentRow.NRSEQEVOLCONT;

    return currentRow;
  };

  /**
   * Função para retornar a extenção de um arquivo
   * extraida do seu nome.
   *
   * @param {string} fileName nome completo do arquivo.
   */
  this.getFileExtension = function (fileName) {
    return fileName.replace(/^(.*)\.(.*)$/, "$2");
  };

  /**
   * Função para retornar o nome do arquivo sem
   * sua extenção.
   *
   * @param {string} fileName nome completo do arquivo.
   */
  this.getFileNameWithoutExtension = function (fileName) {
    return fileName.replace(/^(.*)\.(.*)$/, "$1");
  };

  /**
   * Função para fechar o swipe de upload de imagens.
   *
   * @param {object} widget widget de upload de imagens.
   */
  this.closeAnnexSwipe = function (widget) {
    ScreenService.closeSwipe().then(function () {
      widget.isVisible = false;
      widget.parent.parent.list();
      widget.parent.parent.activate();
    });
  };

  /**
   * Função para fazer o download de uma arquivo
   * salvo no servidor.
   *
   * @param {object} widget widget que contém
   * as informações do arquivo a ser baixado
   * em sua currentRow.
   */
  this.downloadFile = function (widget) {
    window.open(window.fileServerBaseUrl + widget.currentRow.DSCAMINHO);
  };

  /**
   * Função para deletar uma tarefa,
   *
   * @param {object} widget widget ativa, no modo
   * de visualização, mostrando a tarefa a ser deletada.
   */
  this.deleteTask = function (widget) {
    General.deleteCrud(widget)
      .then(function () { })
      .catch(
        function () {
          ScreenService.confirmMessage(
            ScreenService.i18n(Messages.EXCLUSAO_TAREFA_VINC_EVOLUCAO),
            "question",

            function (success) {
              this.deactivateTask(widget).then(function () {
                ScreenService.showMessage(Messages.TAREFA_INATIVADA);

                ScreenService.closeSwipe().then(function () {
                  widget.reload();
                });
              });
            }.bind(this),
            function (error) { }
          );
        }.bind(this)
      );
  };

  /**
   * Função para desativar a tarefa em caso.
   *
   * @param {object} widget widget ativa, no modo
   * de visualização, com as informações da tarefa
   * a ser desativada.
   */
  this.deactivateTask = function (widget) {
    var currentRow = widget.currentRow;

    var paramsRestEngine = {
      requestType: "Row",
      row: currentRow,
    };

    return restEngine.post(
      "/deactivateLeadTask",
      paramsRestEngine,
      function (success) { },
      undefined,
      function (error) { },
      undefined,
      undefined
    );
  };

  this.concludeOportTask = function (widget) {

    var paramsRestEngine = {
      requestType: "Row",
      row: widget,
    };

    return restEngine.post("/concludeOportTask", paramsRestEngine);

  };

  this.setEvolution = function (widget) {
    var currentRow = widget;
  
    var params = {
      requestType: "Row",
      row: currentRow,
    };
  
    return restEngine.post("/setEvolution", params).then(function (response) {
      return response;
    }).catch(function (error) {
      ScreenService.showMessage(error.data.error, "error");
      console.log(error);
    });
  };

  /**
   * Função para editar uma evolução.
   *
   * @param {object} widget widget ativa, no
   * modo de visualização, com as informações
   * da evolução a ser editada.
   */
  this.editEvolution = function (widget) {
    var self = this; // Preserve the context
    var currentRow = widget.parent.parent.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = currentRow.NRPARCOPORT;

    this.checkIfCanEditOrEvolParc(currentRow.NRPARCNEGOCIO).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [
          currentRow,
        ]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              General.widgetEdit(widget);

              widget.getField("NMSEQRESULEVOL").readOnly = true;
              widget.getField("NMSEQFASENEGO").readOnly = true;
              widget.getField("DTPLANFILACONTA").validations = {};
              widget.getField("NMSEQFASENEGO").validations = {};

              ABEvolucaoController.setEvolDateChangePermission(widget);
              self.checkPermissionToCreateNewTaskInEvolutionEdition(widget); // Use the preserved context
              self.setClosingDataGroupLockByNegotiationPhase(widget);
              self.setOpportunityValueObligatorinessByNegotiationPhase(widget);
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(self)
        );
      } else {
        self.showMessageCantEditParc();
      }
    });
  };

  /**
   * Função para verificar a permissão para inserir
   * uma nova tarefa na edição da evolução em caso.
   *
   * @param {object} widget widget ativa, no modo de
   * edição, com as informações da evolução em edição.
   */
  this.checkPermissionToCreateNewTaskInEvolutionEdition = function (widget) {
    var currentRow = widget.currentRow;

    if (currentRow.DTPLANFILACONTA) {
      this.setTaskFieldLock(widget, true);

      currentRow.NEXTTASKBLOCKED = true;
    } else {
      this.unlockNextTask(widget);
      this.checkNewTaskPermissionByEvolutionResult(widget);
      this.resetNewTaskInfos(widget);
    }
  };

  /**
   * Função para liberar o cadastro de uma
   * nova tarefa a partir de um evolução,
   * excluindo o parâmetro de bloqueio.
   *
   * @param {object} widget widget de evolução.
   */
  this.unlockNextTask = function (widget) {
    if (widget.currentRow.NEXTTASKBLOCKED) {
      delete widget.currentRow.NEXTTASKBLOCKED;
    }
  };

  /**
   * Função para limpar os valores dos campos
   * para gerar uma nova tarefa através de uma
   * evolução.onmessage.
   *
   * @param {object} widget widget de evolução.
   */
  this.cleanNextTaskFieldValues = function (widget) {
    var currentRow = widget.currentRow;

    if (!currentRow.DTPLANFILACONTA) {
      currentRow.DTPLANFILACONTA = "";
      currentRow.DSFILACONTATO = "";
      currentRow.NMOPERADORREAL = "";
      currentRow.CDOPERREAL = "";
      currentRow.NRPRIORFILACONT = "";
    }
  };

  /**
   * Funão para editar uma oportunidade de negocio
   * e bloquear a edição do campo 'Fase de negocioação'.
   *
   * @param {object} widget widget de oportunidade, no modo
   * de edição.
   */
  this.editOppotunity = function (widget) {
    var self = this; // Preserve the context

    var nrParcNegocio = widget.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              if (widget.isValid()) {
                General.widgetEdit(widget);
                self.blockFieldsNotAllowedForOpportunityEditing(widget);
                self.setOpportunityValueObligatorinessByNegotiationPhase(widget);
                self.habilitaFechamento(widget);
              }
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(self)
        );
      } else {
        self.showMessageCantEditParc();
      }
    });
  };

  /**
   * Função para bloquear os campos que não podem ser editados
   * no ambiente de edição de uma oportundade.
   *
   * @param {object} widget widget de oportunidade que contém
   * os campos a serem bloqueados.
   */
  this.blockFieldsNotAllowedForOpportunityEditing = function (widget) {
    var fieldFase = widget.getField("NMSEQFASENEGO");
    if (!Util.isEmptyOrBlank(fieldFase.value())) fieldFase.readOnly = true;

    var fieldResp = widget.getField("NMPARCRESP");
    if (!Util.isEmptyOrBlank(fieldResp.value())) fieldResp.readOnly = true;

    var fieldParcNeg = widget.getField("NMPRINCIPALPARC");
    if (!Util.isEmptyOrBlank(fieldParcNeg.value()))
      fieldParcNeg.readOnly = true;
  };

  /**
   * Função para desbloquear os campos que não podem ser editados
   * no ambiente de edição de uma oportundade.
   *
   * @param {object} widget widget de oportunidade que contém
   * os campos a serem desbloqueados.
   */
  this.unlockFieldsNotAllowedForOpportunityEditing = function (widget) {
    widget.getField("NMSEQFASENEGO").readOnly = false;
    widget.getField("NMPARCRESP").readOnly = false;
    widget.getField("NMPRINCIPALPARC").readOnly = false;
  };

  this.setClosingDataGroupLockByNegotiationPhase = function (widget) {
    var resultField = widget.getField("DESCRESULEVOL");
    var competitorWinnerField = widget.getField("NMRAZSOCCONC");
    var dataFechamentoField = widget.getField("DTREALFECHA");
    var valueField = widget.getField("VROPORT");

    var currentRow = widget.currentRow;

    if (currentRow.IDPERMITEFECHA && currentRow.IDPERMITEFECHA === "S") {
      dataFechamentoField.value(CRM_Utilities.getDataHoraAtual());
      this.setRequiredValidationField(resultField, true);
      this.setRequiredValidationField(valueField, true);
    } else {
      this.setRequiredValidationField(resultField, false);
      this.setRequiredValidationField(valueField, false);
    }
  };

  this.blockField = function (field) {
    field.clearValue();
    field.readOnly = true;
  };

  this.unlockField = function (field) {
    field.readOnly = false;
  };

  this.setRequiredValidationField = function (field, required) {
    if (!field.validations) {
      field.validations = {};
    }

    if (required) {
      field.validations.required = true;
    } else {
      field.validations = {};
    }
  };

  /**
   * Verifica a permissão do operador logado para
   * trabalhar a oportunidade selecionada.
   *
   * @param {object} widget widget de oportunidade
   * ('oportunidadegrid');
   */
  this.checkLoggedOperatorPermissionToChangeOpport = function (widget) {
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    if (
      !Boolean(loggedOperatorInfos.IDOPERMASTERHIERARQCRM) ||
      loggedOperatorInfos.IDOPERMASTERHIERARQCRM === "N" ||
      !this.isChildOpport(widget)
    ) {
      if (Boolean(widget.currentRow.DTREALFECHA)) {
        this.hideCompletedOpportunitiesActions(widget);
      } else {
        this.checkOpportResponsibleOperator(widget);
      }
    }

    if (widget.name !== "CALENDARIO") {
      this.checkMostrarActionReabrir(widget);
    } else {
      var calendarWidget = templateManager.container.getWidget(
        "WDGT_NEW_COMMITMENT"
      );
      if (calendarWidget.currentRow.IDSTATPLANOCUPA == "P") {
        calendarWidget.getAction("UPDATE_STATUSPLAN_ACCEPT").isVisible = true;
        calendarWidget.getAction("UPDATE_STATUS_RECUSE").isVisible = true;
      } else if (calendarWidget.currentRow.IDSTATPLANOCUPA == "A") {
        calendarWidget.getAction("UPDATE_STATUSPLAN_ACCEPT").isVisible = false;
        calendarWidget.getAction("UPDATE_STATUS_RECUSE").isVisible = true;
      } else if (calendarWidget.currentRow.IDSTATPLANOCUPA == "R") {
        calendarWidget.getAction("UPDATE_STATUSPLAN_ACCEPT").isVisible = true;
        calendarWidget.getAction("UPDATE_STATUS_RECUSE").isVisible = false;
      }

      var actionEvolucao = calendarWidget.getAction("EVOLUIR");
      if (Util.isEmptyOrBlank(calendarWidget.currentRow.TIPO)) {
        actionEvolucao.isVisible = false;
      } else if (!Util.isEmptyOrBlank(calendarWidget.currentRow.NRSEQOPORT)) {
        actionEvolucao.label = "Evoluir Oportunidade";
        actionEvolucao.isVisible = true;
      } else {
        actionEvolucao.label = "Evoluir Parceiro";
        actionEvolucao.isVisible = true;
      }

      calendarWidget.getAction("BACK_FORMCOMMITMENT").isVisible = true;
      calendarWidget.getAction("SAVE_COMMITMENT").isVisible = true;
      calendarWidget.getAction("EDIT_COMMITMENT").isVisible = true;
      calendarWidget.getAction("DELETE_COMMITMENT").isVisible = true;

      widget.getAction("ADD_COMMITMENT").isVisible = true;
      var compromissoController = CRM_Utilities.getController(
        "crm30000000_Compromisso_Controller"
      );
      compromissoController.widgetAfterLoadDataSource(widget);
    }
  };

  /**
   * Procura o responsável da oportunidade na hierarquia
   * do operador logado.
   *
   * Serve para impedir que operadores master na hierarquia
   * consigam manipular oportunidades de qualquer um, e não
   * somente de quem está abaixo dele
   *
   * @param {object} widget widget de oportunidade
   * ('oportunidadegrid');
   */
  this.isChildOpport = function (widget) {
    var childs = templateManager.LOGGEDOPERATOR.NRPARCOPERSHIERARQINF;
    var resp = widget.currentRow.NRPARCRESP;

    if (childs.indexOf(resp) !== -1) return true;

    return false;
  };

  /**
   * Esconde as ações em uma oportunidade fechada.
   *
   * @param {object} widget widget de oportunidade
   * ('oportunidadegrid').
   */
  this.hideCompletedOpportunitiesActions = function (widget) {
    var activeWidget = templateManager.container.getActiveWidget();
    var containerActions = templateManager.container.actions;

    if (activeWidget.name !== "WDGT_EVOLUCAO") {
      containerActions.forEach(function (action) {
        if (
          action.label !== "Voltar" &&
          action.name !== "ACTION_MODAL_INFOS_PARCEIRO" &&
          action.name !== "BACK_EDIT" &&
          action.name !== "SAVE"
        ) {
          action.isVisible = false;
        }
      });
    }
  };

  /**
   * Verifica se o operador logado é um dos responsáveis
   * pela oportunidade selecionada.
   *
   * @param {object} widget widget de oportunidade
   * ('oportunidadegrid').
   */
  this.checkOpportResponsibleOperator = function (widget) {
    var containerActions = templateManager.container.actions;
    var operadorInclusao = widget.currentRow.CDOPERINCLUSAO;
    var operadorResponsavel = widget.currentRow.CDOPERADOR;
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
    var operadorLogado = loggedOperatorInfos.CDOPERADOR;
    var isOperadorMaster = loggedOperatorInfos.IDOPERMASTER == "S";

    // As actions de Adicionar, Editar e Evoluir são visíveis se o operador
    //logado *for o mesmo que incluiu* a oportunidade ou se ele for *master*
    var setActionsVisible =
      operadorLogado == operadorInclusao ||
      operadorLogado == operadorResponsavel ||
      isOperadorMaster;

    containerActions.forEach(function (action) {
      if (
        action.label === "Adicionar" ||
        action.label === "Editar" ||
        action.label == "Evoluir / Alterar Fase" ||
        action.label == "Criar Tarefa"
      ) {
        action.isVisible = setActionsVisible;
      }
    });
  };

  this.goBackActions = function (widget) {
    var containerActions = templateManager.container.actions;
    var attachedScreen = templateManager.container.getWidget(
      "WDGT_ANEXOS_EVOLUCAO"
    );
    if (attachedScreen) {
      var attachedStatus = templateManager.container.getWidget("evolucao");
      attachedStatus.reload();
    }
    containerActions.forEach(function (action) {
      if (!action.chartAction) action.isVisible = true;
    });
  };

  this.returnContainerDefaultAction = function (widget) {
    var containerActions = templateManager.container.actions;

    if (widget.currentRow.DTREALFECHA && widget.mode === "list") {
      containerActions.forEach(function (action) {
        if (!action.chartAction) action.isVisible = true;
      });
    }
  };

  this.setCurrentFilterValueInFilterPopUp = function (
    filterWidget,
    field,
    value
  ) {
    var filterCurrentRow = filterWidget.currentRow;

    filterCurrentRow[field] = value;
  };

  this.setItemFieldVisibilityBySelectedItem = function (widget) {
    this.setRequiredProdServ(widget);
  };

  this.setRequiredProdServ = function (widget) {
    var fieldProd = widget.getField("NMPRODUTO");
    var fieldServ = widget.getField("NMSERVORCA");
    if (
      Util.isEmptyOrBlank(
        fieldProd.value() || Util.isEmptyOrBlank(widget.currentRow.NRTPARVPROD)
      ) &&
      Util.isEmptyOrBlank(fieldServ.value())
    ) {
      this.setRequiredValidationField(fieldServ, true);
      this.setRequiredValidationField(fieldProd, true);
    } else if (Util.isEmptyOrBlank(fieldServ.value())) {
      this.setRequiredValidationField(fieldServ, false);
      this.setRequiredValidationField(fieldProd, true);
    } else {
      this.setRequiredValidationField(fieldServ, true);
      this.setRequiredValidationField(fieldProd, false);
    }
  };

  this.setFieldVisibilityOnForm = function (field, isVisible) {
    field.showOnForm = isVisible;
  };

  this.setFieldVisibilityOnView = function (field, isVisible) {
    field.showOnView = isVisible;
  };

  /**
   * Função para definir a obrigatoriedade do campo
   * 'valor da oportunidade' de acordo com a fase de
   * negociação em caso.
   *
   * @param {object} widget widget de oportunidade.
   */
  this.setOpportunityValueObligatorinessByNegotiationPhase = function (widget) {
    var currentRow = widget.currentRow;
    var valueOportField = widget.getField("VRPREVOPORT");
    var resultadoField = widget.getField("DESCRESULEVOL");
    var fechamentoField = widget.getField("DTREALFECHA");
    var concorrenteField = widget.getField("NMRAZSOCCONC");
    if (!concorrenteField) {
      concorrenteField = widget.getField("NMPARCCONC");
    }

    if (currentRow.IDEXIGEVROPORT === "S") {
      this.setRequiredValidationField(valueOportField, true);
    } else {
      this.setRequiredValidationField(valueOportField, false);
    }

    if (currentRow.IDPERMITEFECHA === "S") {
      this.setRequiredValidationField(resultadoField, true);
      this.setRequiredValidationField(fechamentoField, true);
    } else {
      this.setRequiredValidationField(resultadoField, false);
      this.setRequiredValidationField(fechamentoField, false);
    }
  };

  /**
   * Função para setar o filtro de intervalo de dias
   * desde a ultima evolução
   */
  this.setQuantityOfDaysLastEvolutionFilter = function (args) {
    var widgetGrid = args.owner;
    var currentRow = args.e.preference.FILTER_ROW;
    /*Variável para fazer o controle do dataSourceFilter*/
    var filters = [];
    widgetGrid.dataSourceFilter.forEach(function (filter, index) {
      if (
        !(
          filter.name === "DIAS_DESDE_EVOLUCAO" ||
          filter.name === "ULTEVOLDE" ||
          filter.name === "ULTEVOLATE"
        )
      ) {
        filters.push(filter);
      }
    });
    /*Monta filtro*/
    var filter = this.getOperatorForFilterBeginEnd(
      currentRow.ULTEVOLDE,
      currentRow.ULTEVOLATE,
      "DIAS_DESDE_EVOLUCAO"
    );
    widgetGrid.dataSourceFilter = filters;
    if (filter !== false) widgetGrid.dataSourceFilter.push(filter);
  };

  /**
   * Função para setar o filtro de intervalo de
   * quantidade de evoluções por oportunidade
   */
  this.setQuantityOfEvolutionsFilter = function (args) {
    var widgetGrid = args.owner;
    var currentRow = args.e.preference.FILTER_ROW;
    /*Variável para fazer o controle do dataSourceFilter*/
    var filters = [];
    widgetGrid.dataSourceFilter.forEach(function (filter, index) {
      if (
        !(
          filter.name === "QUANTIDADE_EVOLUCOES" ||
          filter.name === "QTEVOLDE" ||
          filter.name === "QTEVOLATE"
        )
      ) {
        filters.push(filter);
      }
    });
    /*Monta filtro*/
    var filter = this.getOperatorForFilterBeginEnd(
      currentRow.QTEVOLDE,
      currentRow.QTEVOLATE,
      "QUANTIDADE_EVOLUCOES"
    );
    widgetGrid.dataSourceFilter = filters;
    if (filter !== false) widgetGrid.dataSourceFilter.push(filter);
  };

  /**
   * Função para validar os campos de filtros de
   * intervalo
   *
   * @param {String} valor do campo 'De' dos fields
   * com filtro de intervalo
   *
   * @param {String} valor do campo 'Ate' dos fields
   * com filtro de intervalo
   */
  // this.validateQTEvolutions = function(args, fieldDe, fieldAte) {
  //     var quantDe = fieldDe.value();
  //     var quantAte = fieldAte.value();
  //     var fieldDeName = fieldDe.name;
  //     var fieldAteName = fieldAte.name;
  //     var widgetGrid = templateManager.container.getWidget('oportunidadegrid').__filterPopup;
  //     if ((quantDe !== "" && quantAte !== "") && parseInt(quantDe) > parseInt(quantAte)) {
  //         ScreenService.showMessage("Quantidade inicial deve ser menor que a final. (Preencha só um dos campos para setar maior/menor que)");
  //         widgetGrid.currentRow[fieldDeName] = "";
  //         widgetGrid.currentRow[fieldAteName] = "";
  //     }

  // };

  /**
   * Função para montar o filtro baseado no field
   * e em seus valores 'De' e 'Até'. O filtro pode
   * ser criado como BETWEEN, >= ou <=
   *
   * param{String} valor do field 'De'
   * param{String} valor do field 'Ate'
   *
   * return{Boolean} Boolean se os valores não forem
   * válidos ou se forem vazios
   * return{Object} Object contendo o filtro montado
   * (name/operator/value) se os valores forem válidos
   */
  this.getOperatorForFilterBeginEnd = function (minValue, maxValue, fieldName) {
    if (minValue !== "" || maxValue !== "") {
      var quantDe = minValue;
      var quantAte = maxValue;
      var filter = {};

      if (quantAte > quantDe && quantDe !== "") {
        filter.name = fieldName;
        filter.operator = "BETWEEN";
        filter.value = [quantDe, quantAte];
        return filter;
      } else if (quantAte > quantDe && quantDe === "") {
        filter.name = fieldName;
        filter.operator = "<=";
        filter.value = quantAte;
        return filter;
      } else if (quantDe > quantAte && quantAte === "") {
        filter.name = fieldName;
        filter.operator = ">=";
        filter.value = quantDe;
        return filter;
      }
      return false;
    }
    return false;
  };

  /**
   * Define o valor default do filtro do campo de operador
   * responsável.
   *
   * @param {object} widget widget principal da tela de oportunidade
   * ("oportunidadegrid").
   */
  this.setResponsibleOperatorFilterDefaultValueInFilterPopup = function (
    widget
  ) {
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
    var filterPopupCurrentRow = widget.__filterPopup.currentRow;

    filterPopupCurrentRow.NRPARCRESP = [loggedOperatorInfos.NRPARCNEGOCIO];
    filterPopupCurrentRow.NMPARCRESP = [loggedOperatorInfos.NMOPERADOR];
  };

  /**
   * Define as regras da tela de oportunidade
   * de acordo com a revenda do operador logado.
   *
   * @param {object} widget widget principal da tela
   * de oportunidade de negócio ('oportunidadegrid').
   */
  this.setResaleRules = function (widget) {
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    if (
      loggedOperatorInfos.IDTPOPERADOR === "R" &&
      Boolean(loggedOperatorInfos.NRREVENDA)
    ) {
      var restrictObjectsByResale = [];

      restrictObjectsByResale.push(widget);
      restrictObjectsByResale.push(widget.getField("NMPARCRESP"));

      restrictObjectsByResale.push(widget.getField("NMPRINCIPALPARC"));

      var evolutionWidget = templateManager.container.getWidget("evolucao");
      restrictObjectsByResale.push(evolutionWidget.getField("NMPARCRESP"));
      restrictObjectsByResale.push(evolutionWidget.getField("NMOPERADORREAL"));

      var tasksWidget = templateManager.container.getWidget("evolucao");
      restrictObjectsByResale.push(tasksWidget.getField("NMOPERADOR"));

      CRM_Utilities.setResaleRulesInRestrictObjectsByLoggedOperatorResale(
        restrictObjectsByResale
      );
    }
  };

  //Limpa o filtro no inicio(necessário pra funcionalidade do filtro padrão de operador)
  this.cleanFilter = function (args) {
    var filterRow = args.e.preference.FILTER_ROW;
    filterRow.NRPARCRESP = "";
  };

  //Filtra pelo operador logado quando não há outros filtros
  this.changeOperatorFilter = function (args) {
    var widget = args.owner;
    var filtros = widget.dataSourceFilter;

    if (filtros.length !== 3) {
      filtros.forEach(function (filter) {
        if (filter.name === "NRPARCRESP") {
          if (filter.default) {
            filter.operator = "IS_NOT_NULL";
            delete filter.value;
          }
        }
      });
    } else {
      filtros.forEach(function (filter) {
        if (filter.name === "NRPARCRESP") {
          if (filter.default) {
            filter.operator = "IN";
            filter.value = [templateManager.LOGGEDOPERATOR.NRPARCNEGOCIO];
          }
        }
      });
    }
  };

  this.termometroOnChange = function (widget) {
    var NRTERMOPORTUNI = widget.currentRow.NRTERMOPORTUNI;
    var fieldColor = widget.getField("DSCORTERMOMETRO");

    //Tira a cor do field color se não houver termômetro selecionado
    if (Util.isEmptyOrBlank(NRTERMOPORTUNI)) {
      fieldColor.clearValue();
      $(".inner-color").removeAttr("style");
      $(".color-field-view .zh-select-multiple").addClass("zh-field-value");
    }
  };

  /**
   * metodo chamado para cada td do GRID, percorre o HTML e colore
   * o field de termômetro.
   *
   * @param {object} row row do grid a ser percorrida.
   *        {array} elemento jquery representando cada td da row.
   */
  this.setColorOfRowBasedOnTermometro = function (row, element) {
    var color = row.DSCORTERMOMETRO;
    var fieldsHTML = $(element[0]);
    if (fieldsHTML.attr("data-zh-field-name") === "NMTERMOPORTUNI") {
      //style padrão de fields zeedhi
      var style = "width: 96px; margin-left: 0px; opacity: 1;";
      fieldsHTML.attr(
        "style",
        "color:" + color + "; font-weight:bold; " + style
      );
    }
  };

  this.preventLazyUser = function (widget) {
    var fieldFechamento = widget.getField("DTREALFECHA");
    if (!Util.isEmptyOrBlank(fieldFechamento.value())) {
      widget.currentRow.SITUACAO = "F";
    } else {
      widget.currentRow.SITUACAO = "A";
      widget.currentRow.DESCRESULEVOL = "";
      widget.currentRow.NMRAZSOCCONC = "";
    }
  };

  this.fixDateFilter = function (widget) {
    widget.dataSourceFilter.forEach(function (filter) {
      if (
        filter.name === "DINCLUSAO" ||
        filter.name === "DTREALFECHA" ||
        filter.name === "ULTIMA_EVOLUCAO"
      ) {
        if (Array.isArray(filter.value)) filter.value[1] += " 23:59";
      }
    });
  };

  this.habilitaFechamento = function (widget) {
    if (widget.currentRow.SITUACAO == "F") {
      widget.getField("DTREALFECHA").readOnly = false;
      widget.getField("DESCRESULEVOL").readOnly = false;
      widget.getField("NMRAZSOCCONC").readOnly = false;
    } else {
      widget.getField("DTREALFECHA").readOnly = true;
      widget.getField("DESCRESULEVOL").readOnly = true;
      widget.getField("NMRAZSOCCONC").readOnly = true;
    }
  };

  this.criarNovoConcorrente = function (widget) {
    var popupNovoConcorrente = templateManager.container.getWidget(
      "popupNovoConcorrente"
    );
    popupNovoConcorrente.newRow();

    popupNovoConcorrente.template = "widget/form.html";
    popupNovoConcorrente.activate();
    ScreenService.openPopup(popupNovoConcorrente);
  };

  this.prepararNovoConcorrente = function (widget) {
    CRM_Utilities.setColumnToReturnInCurrentRow(
      widget.currentRow,
      "NRCONCORRENTE"
    );
    widget.currentRow.DTULTATUBAIR = CRM_Utilities.getCurrentDate();

    widget.currentRow.NRORG = templateManager.LOGGEDOPERATOR.NRORG;
    widget.currentRow.FIELDONADD = true;
    this.salvarConcorrente(widget.currentRow).then(function (response) {
      var widgetConvert = templateManager.container.getWidget("evolucao");
      widgetConvert.currentRow.NRCONCORRENTE =
        response.dataset.columnsToReturn[0].NRCONCORRENTE;
      widgetConvert.currentRow.NMRAZSOCCONC = widget.currentRow.NMRAZSOCCONC;
      ScreenService.closePopup();
      ScreenService.closePopup();
      ScreenService.showMessage("Concorrente salvo com sucesso!");
    });
  };

  this.salvarConcorrente = function (currentRow) {
    var paramsRestEngine = {
      requestType: "Row",
      row: currentRow,
    };

    return restEngine.post("/crm_concorrente/save", paramsRestEngine);
  };

  this.checkParamSM = function (widget) {
    var idIntegracaoSM = CRM_Utilities.getCrmParametrization();

    if (idIntegracaoSM) idIntegracaoSM = idIntegracaoSM["IDINTEGRACAOSM"];

    var integracaoAction = widget.getAction("GERA_PROPOSTA");
    if (idIntegracaoSM === "S") {
      integracaoAction.isVisible = true;
    } else {
      integracaoAction.isVisible = false;
    }
  };

  this.abrirPopupProposta = function () {
    this.checkItems().then(function () {
      var wdgtProposta = templateManager.container.getWidget(
        "popupGeraProposta"
      );
      wdgtProposta.newRow();

      wdgtProposta.template = "widget/form.html";
      wdgtProposta.activate();
      ScreenService.openPopup(wdgtProposta);
    });
  };

  this.checkItems = function () {
    var promise = ZHPromise.defer();
    var wdgtOportunidade = templateManager.container.getWidget(
      "oportunidadegrid"
    );
    var wdgtItens = templateManager.container.getWidget("itensgrid");
    wdgtItens.dataSourceFilter = [
      {
        name: "NRSEQOPORT",
        operator: "=",
        value: wdgtOportunidade.currentRow.NRSEQOPORT,
      },
      {
        name: "NRORG",
        operator: "=",
        value: templateManager.LOGGEDOPERATOR.NRORG,
      },
    ];
    wdgtItens.reload().then(function () {
      var itens = wdgtItens.dataSource.data;
      itens = itens.map(function (item) {
        return {
          servico: item.CDSERVORCA,
          produto: item.CDPRODUTO,
          quantidade: item.QTITEMOPORT,
          medida: item.CDTPMEDIDASERV,
          quantidade_medida: item.QTITEMOPORT,
          valor_unitario: item.VRUNITITEMOPORT,
          tipo_ajuste:
            item.IDTPDESCITEMOPORT === "S" ? "N" : item.IDTPDESCITEMOPORT,
          ajuste: item.VRDESCITEMOPORT,
          valor_total: item.VRTOTITEMOPORT,
        };
      });
      wdgtItens.ITENSPROPOSTA = itens;
      if (!Util.isEmptyOrBlank(itens)) {
        promise.resolve();
      } else {
        ScreenService.confirmMessage(
          "Esta oportunidade não possui itens, deseja continuar com a criação da proposta?",
          "CONFIRMATION",
          function () {
            promise.resolve();
          },
          function () {
            promise.reject();
          }
        );
      }
    });

    return promise.promise;
  };

  this.prepararProposta = function (widget) {
    var wdgtOportunidade = templateManager.container.getWidget(
      "oportunidadegrid"
    );
    var wdgtItens = templateManager.container.getWidget("itensgrid");
    var wdgtEvolucao = templateManager.container.getWidget("evolucao");
    var interlocutor = null;
    this.initTab(wdgtEvolucao).then(function () {
      wdgtEvolucao.dataSource.data.forEach(function (evol) {
        if (
          !Util.isEmptyOrBlank(evol.NRSEQINTERLOCUTOR) &&
          interlocutor === null
        )
          interlocutor = evol.NRSEQINTERLOCUTOR;
      });
      var rowProposta = {
        requisitante: {
          operador: templateManager.LOGGEDOPERATOR.CDOPERADOR,
          nrorg: templateManager.LOGGEDOPERATOR.NRORG,
        },
        proposta: {
          modelo: widget.currentRow.NRORCAMENTOMODELO,
          escopos: widget.currentRow.NRTIPOORCAMENTO,
          parceiro_negocio: wdgtOportunidade.currentRow.NRPARCOPORT,
          operador_responsavel: wdgtOportunidade.currentRow.CDOPERADOR,
          interlocutor: interlocutor,
          nrseqcontato: wdgtOportunidade.currentRow.NRSEQCONTATO,
          nrseqoport: wdgtOportunidade.currentRow.NRSEQOPORT,
          itens: wdgtItens.ITENSPROPOSTA,
        },
      };
      var params = {
        requestType: "DataSet",
        dataset: [rowProposta],
      };

      restEngine
        .post("product#/IntegracaoSm/geraProposta", params)
        .then(function (response) {
          if (response.dataset.INTEGRACAO) {
            ScreenService.showMessage("Proposta Criada");
          } else {
            ScreenService.showMessage("Erro ao Criar Proposta");
          }
          ScreenService.closePopup();
        });
    });
  };

  this.mainWidgetOnEnter = function (widget, fieldsToApply) {
    
    this.setResaleRules(widget);
    //PartnerInfosModalController.setModalWidgetOnActiveWidget(widget, 'NRPARCOPORT');
    
    var filterRow = {};
    filterRow.NRPARCNEGOCIO = [templateManager.LOGGEDOPERATOR.NRPARCNEGOCIO];
    filterRow.NRPARCRESP = [templateManager.LOGGEDOPERATOR.NRPARCNEGOCIO];
    filterRow.NMPARCRESP = [templateManager.LOGGEDOPERATOR.NMOPERADOR];
    filterRow.IDOPERATIVO = 'A';

    fieldsToApply.push("NRPARCRESP");
    fieldsToApply.push("NMPARCRESP");
    fieldsToApply.push("NMOPORT");
    fieldsToApply.push("IDOPERATIVO");
    
    if (widget.fromDashboard !== true) {
      CRM_Utilities.openFilterOnEnter(widget, filterRow, fieldsToApply);
    } else {
      widget.fromDashboard = false;
      ZhFilterPreferences.setOriginalFilter(widget.id, filterRow);
    }
  };

  this.checkMostrarActionReabrir = function (widget) {
    var row = widget.currentRow;
    var actionReabrir = widget.getAction("REABRIR_OPORTUNI");

    //Se a oportunidade estiver fechada e o operador
    // for master, a action será visível.
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
    var isOperadorMaster =
      loggedOperatorInfos.IDOPERMASTER === "S" ||
      loggedOperatorInfos.NRPARCNEGOCIO == widget.currentRow.NRPARCRESP;
    var isFechada = row.SITUACAO === "F";

    if (!Util.isEmptyOrBlank(actionReabrir)) {
      actionReabrir.isVisible = isFechada && isOperadorMaster;
    }
  };

  this.evolucaoReabertura = function (widget) {
    this.abrirWidgetEvolucao(false);
  };

  this.reabrirOportunidade = function (widget) {
    var mainWid = widget.parent.parent;

    var params = {
      requestType: "Row",
      row: {
        nrorg: getLocalVar("CRM_NRORG"),
        nrseqoport: mainWid.currentRow.NRSEQOPORT,
        crm_nrorgtrab: getLocalVar("CRM_NRORGTRABALHO"),
      },
    };

    //Promise
    return restEngine
      .post("/crm_oportuni_oportunidadenegocio/reopen", params)
      .then(function () {
        var row = mainWid.currentRow;

        row.SITUACAO = "A";
        row.DTREALFECHA = null;
        row.NMRAZSOCCONC = null;
        widget.OPORTCONCLUIDA = false;
      });
  };

  this.visibilidadeTransferirResponsavel = function () {
    restEngine
      .post("product#/crud/crm_parametrizacao", {
        requestType: "FilterData",
        filter: [
          {
            operator: "=",
            name: "IDATIVO",
            value: "S",
          },
          {
            operator: "=",
            name: "NRORG",
            value: templateManager.LOGGEDOPERATOR.NRORG,
          },
        ],
      })
      .then(function (response) {
        paramCRM = response.dataset.crm_parametrizacao[0];
        var widget = templateManager.container.getWidget("oportunidadegrid");

        if (
          paramCRM["IDEVOLTRANSOPORT"] == "N" ||
          widget.getField("SITUACAO").value() == "F"
        ) {
          widget.getAction("transferir_responsavel_tarefa").isVisible = false;
        } else if (paramCRM["IDEVOLTRANSOPORT"] == "S") {
          widget.getAction("transferir_responsavel_tarefa").isVisible = true;
        }
      });
  };

  this.abrirPopupTransferirOportunidade = function (widget) {
    var nrParcNegocio = widget.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [
          currentRow,
        ]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              var popTransfOportuni = templateManager.container.getWidget(
                "TRANSFERIROPORTUNIDADE"
              );
              popTransfOportuni.getField("NMOPERREAL").clearValue();
              ScreenService.openPopup(popTransfOportuni);
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    });
  };

  this.fecharPopupTransferirOportunidade = function (widget) {
    widget.isVisible = false;
    ScreenService.closePopup();
  };

  this.transferirOportunidade = function (widget) {
    var row = templateManager.container.getWidget("oportunidadegrid")
      .currentRow;
    restEngine.post(
      "/transferirOportunidade",
      {
        requestType: "Row",
        row: {
          ROW: row,
          OPERADOR: widget.currentRow.NRPARCNEGOCIO,
          NOVORESPONSAVEL: widget.currentRow.NMOPERREAL,
        },
      },
      function (response) {
        var wid = templateManager.container.getWidget("oportunidadegrid");
        ScreenService.showMessage("Oportunidade transferida com sucesso.");
        ScreenService.closePopup(true);
        ScreenService.closeSwipe();
        // wid.dataSource.filter();
        wid.reload();
        // widget.getParent().reload();
      },
      undefined,
      function (response) {
        ScreenService.showMessage(response);
      }
    );
  };

  this.criarNovoInterlocutor = function (widget) {
    var popupNovoInterlocutor = templateManager.container.getWidget(
      "popupNovoInterlocutor"
    );
    popupNovoInterlocutor.newRow();
    var filterPopup = popupNovoInterlocutor.currentRow;
    if (widget.name === "convertLeadInProspect") {
      filterPopup = templateManager.container.getWidget(
        "convertLeadInProspect"
      );
      popupNovoInterlocutor.currentRow.filtro = false;
      popupNovoInterlocutor.parentName = widget.name;
    } else if (widget.name === "filterPopup") {
      filterPopup = templateManager.container.getWidget("oportunidadegrid")
        .__filterPopup;
      popupNovoInterlocutor.currentRow.filtro = true;
    } else if (widget.name === "oportunidadegrid") {
      filterPopup = templateManager.container.getWidget("oportunidadegrid");
      popupNovoInterlocutor.currentRow.filtro = false;
      popupNovoInterlocutor.parentName = widget.name;
    } else if (widget.name === "posvendagrid") {
      filterPopup = templateManager.container.getWidget("posvendagrid");
      popupNovoInterlocutor.currentRow.filtro = false;
      popupNovoInterlocutor.parentName = widget.name;
    } else if (widget.name === "evolucao") {
      filterPopup = templateManager.container.getWidget("evolucao");
      popupNovoInterlocutor.currentRow.filtro = false;
      popupNovoInterlocutor.parentName = widget.name;
    }

    ScreenService.openPopup(popupNovoInterlocutor).then(function () {
      popupNovoInterlocutor.currentRow.NMINTERLOCUTOR =
        filterPopup.NMINTERLOCUTOR;
      popupNovoInterlocutor.currentRow.DTNASCIMENTO = filterPopup.DTNASCIMENTO;
      popupNovoInterlocutor.currentRow.IDRECEBEPRESENTE =
        filterPopup.IDRECEBEPRESENTE;
      popupNovoInterlocutor.currentRow.NMCARGOINTERLOC =
        filterPopup.NMCARGOINTERLOC;
      popupNovoInterlocutor.currentRow.EMAILINTERLOC =
        filterPopup.EMAILINTERLOC;
      popupNovoInterlocutor.currentRow.NRTELEFONE1 = filterPopup.NRTELEFONE1;
      popupNovoInterlocutor.currentRow.NRORG = getLocalVar("CRM_NRORG");
      popupNovoInterlocutor.reload();
    });
  };

  this.setInterlocutorWidgetDefaultValues = function (widget) {
    var wid = templateManager.container.getWidget("oportunidadegrid");

    wid.currentRow.NRPARCNEGOCIO;

    widget.currentRow.NRPARCNEGOCIO = wid.currentRow.NRPARCOPORT;
  };

  this.removeInterlocutorPhoneMask = function (widget) {
    var currentRow = widget.currentRow;
    var phoneFields = ["NRTELEFONE1"];

    phoneFields.forEach(function (phone) {
      if (currentRow[phone]) {
        currentRow[phone] = currentRow[phone].replace(/[^0-9]/g, "");
      }
    });
  };

  this.salvarInterlocutor = function (currentRow) {
    var paramsRestEngine = {
      requestType: "Row",
      row: currentRow,
    };
    return restEngine.post("/crm_interlocutor/save", paramsRestEngine);
  };

  this.prepararInterlocutor = function (widget) {
    var parent = templateManager.container.getWidget(widget.parentName);

    CRM_Utilities.setColumnToReturnInCurrentRow(
      widget.currentRow,
      "NRSEQINTERLOCUTOR"
    );
    this.removeInterlocutorPhoneMask(widget);
    widget.currentRow.NRCPFINTERLOC = widget.currentRow.NRCPFINTERLOC.replace(
      /[^0-9]/g,
      ""
    );
    this.salvarInterlocutor(widget.currentRow).then(function (
      response,
      widget
    ) {
      var currentRow = templateManager.container.getWidget(
        "popupNovoInterlocutor"
      );
      if (currentRow.filtro === true) {
        var widgetfilter = templateManager.container.getWidget(
          "popupNovoInterlocutor"
        ).__filterPopup;
        var widgetprospect = templateManager.container.getWidget(
          "oportunidadegrid"
        );
        var widgetConvertfilter = templateManager.container.getWidget(
          "evolucao"
        );
        widgetConvertfilter.currentRow.NMINTERLOCUTOR =
          widget.currentRow.NMINTERLOCUTOR;

        widgetfilter.template = "widget/form.html";
        widgetfilter.activate();
        widgetprospect.widgets[0].fields[7].defaultValue =
          widget.currentRow.NMINTERLOCUTOR;
        ScreenService.closePopup(true);
        ScreenService.showMessage("Interlocutor criado com sucesso!");
      } else {
        var widgetcurrent = templateManager.container.getWidget(
          "popupNovoInterlocutor"
        );
        var wid = templateManager.container.getWidget("oportunidadegrid");

        parent.currentRow.NRSEQINTERLOCUTOR =
          response.dataset.columnsToReturn[0].NRSEQINTERLOCUTOR;
        parent.currentRow.NMINTERLOCUTOR =
          widgetcurrent.currentRow.NMINTERLOCUTOR;
        parent.currentRow.EMAILINTERLOC =
          widgetcurrent.currentRow.EMAILINTERLOC;

        ScreenService.closePopup(true);

        ScreenService.showMessage("Interlocutor criado com sucesso!").then(
          function () {
            parent.activate();
            parent.reload();
          }
        );
      }
    });
  };

  this.evolucaoRowOnEnter = function (widget) {
    var prospectController = CRM_Utilities.getController(
      "ger45000_Prospect_Controller"
    );

    prospectController.setEditEvolButtonAction(
      widget,
      this.editEvolButtonDefaultCode,
      "EDITAR_EVOLUCAO"
    );
  };

  this.setCanEvolve = function () {
    var widget = templateManager.container.getWidget("oportunidadegrid");
    var evolWidget = templateManager.container.getActiveWidget();
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
  
    if (
      (widget.currentRow.SITUACAO == "P" || widget.currentRow.SITUACAO == "F") &&
      loggedOperatorInfos.CDOPERADOR != widget.currentRow.CDOPERADORGEST
    ) {
      evolWidget.actions.find(function (x) {
        return x.label == "Adicionar";
      }).isVisible = false;
      evolWidget.actions.find(function (x) {
        return x.label == "Editar";
      }).isVisible = false;
    } else if (
      (widget.currentRow.SITUACAO === "P" || widget.currentRow.SITUACAO == "F") &&
      loggedOperatorInfos.CDOPERADOR == widget.currentRow.CDOPERADORGEST
    ) {
      evolWidget.actions.find(function (x) {
        return x.label == "Adicionar";
      }).isVisible = false;
      evolWidget.actions.find(function (x) {
        return x.label == "Editar";
      }).isVisible = false;
    } else {
      evolWidget.actions.find(function (x) {
        return x.label == "Adicionar";
      }).isVisible = true;
      evolWidget.actions.find(function (x) {
        return x.label == "Editar";
      }).isVisible = true;
    }
  };

  this.changeValueFilterOportunity = function (widget) {

    var grid = widget;
    var filterAgenda = templateManager.container.getWidget("oportunidadegrid");
    var getFieldParcResp = filterAgenda.getField('NRPARCRESP');
    if (grid.currentRow.IDOPERATIVO == "I") {
      getFieldParcResp.dataSourceFilter[1].value = "I";
      grid.getField('NRPARCRESP').clearValue();
      getFieldParcResp.reload();
    } else {
      getFieldParcResp.dataSourceFilter[1].value = "A";
      getFieldParcResp.reload();
    }
  };

  this.setCanEdit = function () {
    var widget = templateManager.container.getWidget("oportunidadegrid");
    var taskWidget = templateManager.container.getWidget("posvendagrid");
    var itensWidget = templateManager.container.getWidget("itensgrid");
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
  
    if ((widget.currentRow.SITUACAO == "P" || widget.currentRow.SITUACAO == "F") && loggedOperatorInfos.CDOPERADOR != widget.currentRow.CDOPERADORGEST) {
      taskWidget.actions.find(function (x) { return x.label == "Adicionar"; }).isVisible = false;
      itensWidget.actions.find(function (x) { return x.label == "Adicionar"; }).isVisible = false;
      widget.actions.find(function (x) { return x.label == "Editar"; }).isVisible = false;
      widget.actions.find(function (x) { return x.label == "Aprovar"; }).isVisible = false;
      widget.actions.find(function (x) { return x.label == "Reprovar"; }).isVisible = false;
      widget.actions[7].isVisible = false;
      widget.actions[8].isVisible = false;
      widget.actions[9].isVisible = false;
    } else if ((widget.currentRow.SITUACAO === "P" || widget.currentRow.SITUACAO == "F") && loggedOperatorInfos.CDOPERADOR == widget.currentRow.CDOPERADORGEST) {
      widget.action.find(function (x) { return x.label == "Criar Tarefa"; }).isVisible = false;
      widget.actions.find(function (x) { return x.label == "Aprovar"; }).isVisible = true;
      widget.actions.find(function (x) { return x.label == "Reprovar"; }).isVisible = true;
      taskWidget.actions.find(function (x) { return x.label == "Adicionar"; }).isVisible = false;
    } else {
      widget.actions.find(function (x) { return x.label == "Editar"; }).isVisible = true;
      widget.actions.find(function (x) { return x.label == "Aprovar"; }).isVisible = false;
      widget.actions.find(function (x) { return x.label == "Reprovar"; }).isVisible = false;
    }
  };

  this.editEvolButtonDefaultCode = 'crm00002001_OportunidadeNegocio_Controller.editEvolution(args.owner.widget);';

  this.checkValidDate = function () {
    var widget = templateManager.container.getActiveWidget();
    var dataAbertura = widget.getField("DTHREVOLCONT");
    var data = dataAbertura.value().substring(0, 10);
    var dataAtual = new moment().format("DD/MM/YYYY");
    var variacao = moment(dataAtual, "DD/MM/YYYY").diff(
      moment(data, "DD/MM/YYYY"),
      "day"
    );
    if (variacao > paramCRM.NRDIASLANCEVOL) {
      ScreenService.showMessage(
        "Operação bloqueada!<br>Há um limite de " +
        paramCRM.NRDIASLANCEVOL +
        " dias para o lançamento retroativo de evoluções!"
      );
      widget.currentRow.DTHREVOLCONT = null;
    }
  };

  self.verifyNewEvolution = function () {
    var gridEvolucao = templateManager.container.getWidget("evolucao");
    var fieldGroups = gridEvolucao.fieldGroups;
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
    var fieldValueOpportunity = gridEvolucao.getField("VRPREVOPORT");
    var fieldResponsibleOperator = gridEvolucao.getField("NMPARCRESP");
    var fieldClosingDate = gridEvolucao.getField("DTREALFECHA");
  
    var indexGroupClosingData = CRM_Utilities.getFieldGroupPosition(fieldGroups, "FG_DADOS_FECHAMENTO");
    var indexGroupOpportunityData = CRM_Utilities.getFieldGroupPosition(fieldGroups, "FG_DADOS_OPORTUNIDADE");
  
    var groupFixedClosingData = fieldGroups[indexGroupClosingData];
    var groupFixedOpportunityData = fieldGroups[indexGroupOpportunityData];
  
    if (canEditClosingData(loggedOperatorInfos, gridEvolucao)) {
      configureClosingDataEditMode(fieldValueOpportunity, fieldResponsibleOperator, fieldClosingDate, groupFixedClosingData, groupFixedOpportunityData);
    } else {
      configureOpportunityDataMode(fieldValueOpportunity, fieldResponsibleOperator, fieldClosingDate, groupFixedClosingData);
    }
  };

  function canEditClosingData(loggedOperatorInfos, gridEvolucao) {
    return loggedOperatorInfos.IDOPERMASTERHIERARQCRM === "S" || loggedOperatorInfos.CDOPERADOR === gridEvolucao.parent.parent.currentRow.CDOPERADOR;
  }
  
  function configureClosingDataEditMode(fieldValueOpportunity, fieldResponsibleOperator, fieldClosingDate, groupFixedClosingData, groupFixedOpportunityData) {
    fieldClosingDate.class = "4";
    fieldValueOpportunity.isVisible = true;
    fieldResponsibleOperator.isVisible = true;
    groupFixedClosingData.isVisible = true;
    groupFixedOpportunityData.isVisible = true;
    fieldClosingDate.fieldGroup = "FG_DADOS_FECHAMENTO";
  }
  
  function configureOpportunityDataMode(fieldValueOpportunity, fieldResponsibleOperator, fieldClosingDate, groupFixedClosingData) {
    fieldClosingDate.class = "12";
    fieldValueOpportunity.isVisible = false;
    groupFixedClosingData.isVisible = false;
    fieldResponsibleOperator.isVisible = false;
    fieldClosingDate.fieldGroup = "FG_DADOS_OPORTUNIDADE";
  }

  this.setCommitmentDateInCurrentRow = function (widget) {
    var currentRow = widget.currentRow;

    currentRow.DTINIPLANOCUPA = currentRow.DTINI.replace(/\sàs\s/, " ");
    currentRow.DTFINPLANOCUPA = currentRow.DTFIM.replace(/\sàs\s/, " ");
  };

  this.changeOutData = function () {
    var widget = templateManager.container.getActiveWidget();
    var field = widget.getField("NMPARCRESP");
    var keys = field.value();
    var rows = field.selectWidget.getCheckedRows();

    if (Array.isArray(keys) && !Util.isEmptyOrBlank(rows)) {
      field.widget.currentRow.NMPARCRESP = [];
      field.widget.currentRow.CDOPERADOR = [];
      rows.forEach(function (row) {
        keys.forEach(function (key) {
          if (row.NRPARCRESP == key) {
            field.widget.currentRow.NMPARCRESP.push(row.NMPARCRESP);
            field.widget.currentRow.DSEVENTO.push(row.CDOPERADOR);
          }
        });
      });
    }
  };

  this.returnToMainGrid = function () {
    var mainWid = templateManager.container.getWidget("oportunidadegrid");

    ScreenService.closeSwipe();
    mainWid.list();
    mainWid.activate();
  };

  this.returnToEvolutionGrid = function () {
    var evoWid = templateManager.container.getWidget("evolucao");

    ScreenService.closeSwipe();
    evoWid.list();
    evoWid.activate();

    var mainWid = templateManager.container.getWidget("oportunidadegrid");
    mainWid.view();
  };

  this.continueIntegration = function (widget) {
    var widgetCompromisso = templateManager.container.getWidget(
      "compromissoOportunidade"
    );
    var widgetOportunidade = templateManager.container.getWidget(
      "oportunidadegrid"
    );
    //BEGIN RD Station
    var filter = [
      {
        name: "NRPARCNEGOCIO",
        operator: "=",
        value: widget.currentRow.NRPARCOPORT,
      },
      {
        name: "P_NRORGPADRAO",
        operator: "=",
        value: getLocalVar("CRM_NRORGPADRAO"),
      },
    ];
    localStorageEngine
      .download("product#/crud/crm_interlocutor", filter)
      .then(function (contacts) {
        if (!Util.isEmptyOrBlank(contacts)) {
          contacts.forEach(function (contact) {
            var row = {
              EMAIL: contact["EMAILINTERLOC"],
            };
            restEngine
              .post("/IntegracaoRDStation/feedBackConversion", {
                requestType: "Row",
                row: {
                  EVENT_NAME: "Oportunidade gerada pelo CRM",
                  EMAIL: contact["EMAILINTERLOC"],
                },
              })
              .then(function () {
                restEngine.post("/IntegracaoRDStation/markOpport", {
                  requestType: "Row",
                  row: row,
                });
              });
          });
        }
      });
    //END RD Station
    //pula se for tab dinamica
    if (widget.name !== "WDGT_EVOLUCAO")
      this.verificaNovoCompromisso(widgetCompromisso, widgetOportunidade);
  };

  this.checkIfCanEditOrEvolParc = function (nrParcNegocio) {
    var restRow = {
      NRPARCNEGOCIO: nrParcNegocio,
      CRM_NRORGTRAB: getLocalVar("CRM_NRORGTRABALHO"),
    };

    var params = {
      requestType: "Row",
      row: restRow,
    };

    return restEngine
      .post("/checkIfCanEditOrEvolParc", params)
      .then(function (response) {
        return response.dataset.DADOS.CAN_EDIT;
      })
      .catch(function () {
        return false;
      });
  };

  this.showMessageCantEditParc = function () {
    var message = "Ação bloqueada!<br>" +
      "Somente o operador responsável pelo prospect e seus assistentes podem " +
      "editá-lo/evoluí-lo.";

    ScreenService.showMessage(message);
  };
}

Configuration(function (ContextRegister) {
  ContextRegister.register(
    "crm00002001_OportunidadeNegocio_Controller",
    crm00002001_OportunidadeNegocio_Controller
  );
});
