function crm00040_Lead_Controller(ScreenService, ValidationEngine, templateManager, Utilities, wizardEngine, ZHPromise, restEngine, Operador_Repository, Crm_00040_Lead_Service, General, CRM_Utilities, Endereco, Messages, ABEvolucaoController, evolutionTabController, CRM_ParceiroNegocio_Controller) {
    
    var self = this;
    /*
    *   Seta valores Iniciais do novo Lead.
    */
    this.newLead = function(widget) {
        
        General.widgetNewRow(widget);
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        var currentRow = widget.currentRow;

        currentRow.CDPAIS = "";
        currentRow.CDSEGMER = "";
        currentRow.CDBAIRRO = "";
        currentRow.CDFILIAL = "";
        currentRow.SGESTADO = "";
        currentRow.IDATIVO = "S";
        currentRow.IDTPIJURCAN = "I";
        currentRow.CDMUNICIPIO = "";
        currentRow.CDMODODIVULG = "";
        currentRow.TIPOINSC = "CODIGO";
        currentRow.IDPARCFUNDIDO = "N";
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        currentRow.NRORGINCLUSAO = loggedOperatorInfos.NRORG;
        currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
        currentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
        currentRow.NRPARCPROPRI = loggedOperatorInfos.NRPARCNEGOCIO;
        currentRow.NMPARCPROPRI = loggedOperatorInfos.NMOPERADOR;
        currentRow.NRSEQPERFILRESPONSAVEL = loggedOperatorInfos.NRSEQPERFATIV[0];
        currentRow.DESCPEFATIV = loggedOperatorInfos.DESCPEFATIV[0];
        currentRow.IDTPOPERADOR = loggedOperatorInfos.IDTPOPERADOR;
        currentRow.ISCPF = currentRow.IDTPIJURCAN === "F" ? "S" : "N";
        currentRow.DSTELEFONECAN = null;
        currentRow.NRSEQPERFILRESPONSAVEL = null;
        currentRow.DTINCLUSAO = "";
        widget.getField('NRINSJURCAN').readOnly = false;
        widget.getField('NMCANDIDATO').readOnly = false;

    };
    
    this.changeValueFilterLead = function (field) {

        var grid = field;
        var getFieldParcResp = grid.getField('NRPARCPROPRI');

        if (grid.currentRow.IDOPERATIVO == "A") {
            getFieldParcResp.dataSourceFilter[1].value = "A";
            getFieldParcResp.reload();
        } else {
            getFieldParcResp.dataSourceFilter[1].value = "I";
            grid.getField('NRPARCPROPRI').clearValue();
            getFieldParcResp.reload();
        }
    }

    self.saveTask = function(widgetName) {
        var widget = templateManager.container.getWidget(widgetName);
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        var currentRow = widget.currentRow;
    
        currentRow.NRPARCNEGOCIO = widget.getParent().currentRow.NRPARCNEGOCIO;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
    
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response) {
            if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
                if (widget.isValid()) {
                    widget.currentRow.changed = true;
                    if (!Util.isEmptyOrBlank) {
                        widget.currentRow['DSTELEFONETAREFA'] = widget.currentRow['DSTELEFONETAREFA'].replace(/[^0-9]/g, '');
                    }
                    if (widget.currentRow.__is_new) {
                        widget.currentRow.NRORGINCLUSAO = loggedOperatorInfos.NRORG;
                        widget.currentRow.CDOPERINCLUSAO = loggedOperatorInfos.CDOPERADOR;
                        widget.currentRow.NRORGULTATU = null;
                        widget.currentRow.CDOPERULTATU = null;
                    } else {
                        widget.currentRow.NRORGULTATU = loggedOperatorInfos.NRORG;
                        widget.currentRow.CDOPERULTATU = loggedOperatorInfos.CDOPERADOR;
                    }
    
                    widget.currentRow.CDFILIAL = "";
                    widget.currentRow.NRPARCNEGOCIO = widget.getParent().currentRow.NRPARCNEGOCIO;
                    widget.currentRow.NRSEQCLASSIFICATAREFA = (widget.currentRow.NRSEQCLASSIFICATAREFA) ? widget.currentRow.NRSEQCLASSIFICATAREFA : null;
                    widget.currentRow.TIPO = "PARCEIRO";
                    widget.currentRow.NMPARCNEGOCIO = widget.getParent().currentRow.NMCANDIDATO;
                    widget.currentRow.DESCRICAO = "Referente ao Lead " + widget.currentRow.NMPARCNEGOCIO;
                    widget.currentRow.NMOPERREAL = widget.currentRow.NMOPERADOR;
                    widget.currentRow.OPERADORDOLOGADO = widget.currentRow.NMPARCRESP;
    
                    return General.widgetSave(widget).then(function(response) {
                        widget.currentRow.changed = false;
                        widget.currentRow.__is_new = false;
    
                        ScreenService.closeSwipe();
    
                        if (widget.currentRow.CDOPERINCLUSAO != widget.currentRow.CDOPERREAL && !Util.isEmptyOrBlank(widget.currentRow.DSEMAILOPER)) {
                            ScreenService.confirmMessage('Deseja enviar um e-mail para o operador responsável da tarefa?', 'QUESTION', function(yes) {
                                var params = {
                                    "requestType": "Row",
                                    "row": widget.currentRow
                                };
    
                                restEngine.post('/enviaEmailTarefa', params).then(function() {
                                    ScreenService.showMessage('E-mail enviado com sucesso!');
                                }).catch(function(error) {
                                    if (error.data.error) {
                                        ScreenService.showMessage('O e-mail não pode ser enviado pois as configurações de SMTP estão desconfiguradas ou erradas!', 'ERROR');
                                    } else {
                                        ScreenService.showMessage(error.data.error);
                                    }
                                });
                            });
                        }
                        widget.reload();
                        widget.list();
                    });
                }
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        });
    };

    /**
     * Prepara e valida LEAD para ser salvo
    */
    this.prepareLead = function(widget) {
        if(!Util.isEmptyOrBlank(widget.currentRow.NRTELEFONE1) || !Util.isEmptyOrBlank(widget.currentRow.EMAILINTERLOC)) {
            widget.getField('NMINTERLOCUTOR').validations = {"required": true};
        }else{
            widget.getField('NMINTERLOCUTOR').validations = {};
        }

        if (Util.isEmptyOrBlank(widget.currentRow.IDSTATUSCAN)){
            ScreenService.confirmMessage("Operação Bloqueada Pois o Lead Não Possui Status <br><br> Deseja Atualiza-lo? ", 'CONFIRMATION',
                    function(success) {
                        this.updateStatusCan(widget, '2');
                    }.bind(this));
        }
        
        if(widget.isValid()) {
            widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
            var currentRow = widget.currentRow;
            const telefone = widget.currentRow['DSTELEFONECAN'];
            const cep = widget.currentRow['NRCEPENDERECO'];
            const inscricao = widget.currentRow['NRINSJURCAN'];
            if(currentRow.CDBAIRRO === undefined) currentRow.CDBAIRRO = null;
            if (!Util.isEmptyOrBlank(telefone)) {
                widget.currentRow['DSTELEFONECAN'] = telefone.replace(/\D/g, '');
            }
            if (!Util.isEmptyOrBlank(cep)) {
                widget.currentRow['NRCEPENDERECO'] = cep.replace(/\D/g, '');
            }
            if (!Util.isEmptyOrBlank(inscricao)) {
                widget.currentRow['NRINSJURCAN'] = inscricao.replace(/\D/g, '');
            }
            if (widget.currentRow.NMMODODIVULG !== 'Revenda') {
                widget.currentRow.NRREVENDA = null;                
            }

            this.prepareCurrentRowForSave(currentRow);
            widget.CRM_PARAMETRIZACAO = CRM_Utilities.getCrmParametrization();
            
            if(currentRow.__is_new) {
                
                var limiteRevenda = false;
                
                this.verificaParametrizacaoRevenda(currentRow).then(function(verificaRevenda) {
                    
                    limiteRevenda = verificaRevenda.dataset.DADOS.EXCEDEULIMITE;
                    
                    if(!limiteRevenda) {
                        
                        this.validacaoLeadExistente(widget, currentRow);
                        
                    }else{
                        
                        var quantidadeLeads = verificaRevenda.dataset.DADOS.QUANTIDADE;
                        var limiteLeads = verificaRevenda.dataset.DADOS.LIMITE;
                        ScreenService.showMessage('Operação bloqueada! <br><br> Máximo de Leads excedido. <br> Você possui: '+quantidadeLeads+' Leads<br> O limite de Leads por revenda é: '+limiteLeads);
                    
                    }
                }.bind(this));
            }else{
                this.saveValidLead(widget, currentRow);    
            }
        }
    };
    
    this.validacaoLeadExistente = function (widget, currentRow) {
        this.verificaLeadExistente(currentRow).then(function (verificaLead) {
            if (verificaLead.dataset.DADOS.LEADS === true) {
                if (widget.CRM_PARAMETRIZACAO.IDBLOQNOMESEMELHA === 'S') {
                    ScreenService.showMessage("Operação bloqueada! <br><br> A 'Razão Social' informada já está vinculada a outro lead. Consulte o mapa de prospecção.");
                } else {
                    ScreenService.confirmMessage("Operação bloqueada! <br><br> A 'Razão Social' informada já está vinculada a outro lead. Consulte o mapa de prospecção. <br><br> Deseja continuar? ", 'CONFIRMATION',
                        function (success) {
                            this.saveValidLead(widget, currentRow);
                        }.bind(this));
                }
    
            } else if (Array.isArray(verificaLead.dataset.DADOS.LEADS) && !Util.isEmptyOrBlank(verificaLead.dataset.DADOS.LEADS) && verificaLead.dataset.DADOS.PARCEXISTS) {
                var leads = verificaLead.dataset.DADOS.LEADS;
                var mensagemInscricaoVinculada = this.criarMensagemInscricaoJaVinculada(leads);
                ScreenService.showMessage(mensagemInscricaoVinculada);
                widget.fields.find(function (x) { return x.label == 'Inscrição'; }).clearValue();
                widget.fields.find(function (x) { return x.label == 'Tipo de Inscrição'; }).value('I');
                widget.currentRow.INSCRICAO = "";
                widget.currentRow.NOME = "";
                widget.currentRow.CNPJRAIZ = "";
            } else {
                this.saveValidLead(widget, currentRow);
            }
        }.bind(this));
    };
    
    /**
     * Faz verificações na currentRow e a retorna
    */
    this.prepareCurrentRowForSave = function(currentRow) {
        
        if(currentRow.IDTPIJURCAN === "J") {
            if(!currentRow.CNPJRAIZ) {
                currentRow.CNPJRAIZ = currentRow.NRINSJURCAN.toString().split('/')[0].replace(/[^0-9]/g,'');
            }
            currentRow.INSCRICAO = currentRow.NRINSJURCAN.toString();
        }else{
            currentRow.INSCRICAO = currentRow.NRINSJURCAN ? currentRow.NRINSJURCAN.toString().replace(/[^0-9]/g,'') : '';
        }
        currentRow.NOME = currentRow.NMCANDIDATO.toString().replace(' ', "%").toUpperCase();
        
        currentRow.NMFANTCAN   = currentRow.NMFANTCAN ? currentRow.NMFANTCAN : currentRow.NMCANDIDATO;
        currentRow.NRINSJURCAN = currentRow.NRINSJURCAN ? currentRow.NRINSJURCAN.toString(): '';
        
        //Propriedade para fazer validação de lead
        currentRow.LEAD     = true;
        currentRow.PROSPECT = false;
    };
    
    /**
     * Salva Lead validado
    */
    this.saveValidLead = function (widget, currentRow) {
        widget.currentRow.CDOPERINCLUSAO = templateManager.LOGGEDOPERATOR.CDOPERADOR;
        widget.currentRow.IDSTATUS = widget.currentRow.IDSTATUSCAN;
        widget.currentRow.IDVALIDACNPJ = templateManager.CRM_PARAMETRIZACAO.IDCNPJRAIZ;
        widget.currentRow.IDBLOQNOMESEMELHA = templateManager.CRM_PARAMETRIZACAO.IDBLOQNOMESEMELHA;
    
        if (widget.currentRow.__is_new) {
            widget.currentRow.DTINCLUSAO = moment().format('DD/MM/YYYY HH:mm:ss');
        } else {
            widget.currentRow.DTULTATU = moment().format('DD/MM/YYYY HH:mm:ss');
        }
        return CRM_Utilities.saveWidget(widget, false).then(function (response) {
            if (response.dataset) {
                // Atribui à current row os campos gerados no backend
                currentRow.NRCANDIDATO = response.dataset.DADOS.NRCANDIDATO;
                currentRow.NRPARCNEGOCIO = response.dataset.DADOS.NRPARCNEGOCIO;
                currentRow.NRSEQCONTATO = response.dataset.DADOS.NRSEQCONTATO;
                currentRow.NRCONTATO = response.dataset.DADOS.NRCONTATO;
                // Recarrega a widget
                widget.reload().then(function () {
                    widget.currentRow.__is_new = false;
                    widget.view();
                    widget.reload();
                });
            }
        });
    };
    
    /**
     * Defini o filtro da tela de lead pelo
     * lead ativo.
     * 
     * @param {object} widget widget principal da tela
     * de lead.
    */
    this.setLeadWidgetFilterByActiveLead = function(widget) {
        
        var currentRow = widget.currentRow;
        //Resetando filtros
        var filters = angular.copy(widget.dataSourceFilter); 
        widget.dataSourceFilter.forEach(function(filter, index) {
            if(filter.name !== "P_NRPARCNEGOCIO" && filter.name !== "P_NRORG" && filter.name !== "IDTPOPERADOR") {
                filters.splice(index);
            }
        });
        widget.dataSourceFilter = filters;
        //filtros resetados
        
        var filter = {};
            
        filter.name     = "NRCANDIDATO";
        filter.operator = "=";
        filter.value    = currentRow.NRCANDIDATO;
        
        widget.dataSourceFilter.push(filter);
        widget.reload();
        widget.dataSourceFilter.pop();    
        
    };
    
    /**
     * Verifica se já existem parceiros vinculados
     * aquele CNPJ ou nome
    */
    this.verificaLeadExistente = function(currentRow) {
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        return restEngine.post('/validaLead', paramsRestEngine);
    };
    
    /**
     * Verifica se aquele operador responsável já excedeu 
     * o máximo de leads (de acordo com a parametrização);
    */
    this.verificaParametrizacaoRevenda = function(currentRow) {
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        return restEngine.post('/validaOperadorRevenda', paramsRestEngine);
    };
    
    this.deleteLead = function (widget) {
        var currentRow = widget.currentRow;
        if (currentRow.NRPARCPROPRI === CRM_Utilities.getLoggedOperatorInfos().NRPARCNEGOCIO) {

            currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
            ScreenService.confirmMessage(ScreenService.i18n(Messages.DESATIVAR_LEAD(widget.currentRow.NMCANDIDATO)), 'question', function (success) {

                var paramsRestEngine = {
                    "requestType": "Row",
                    "row": currentRow
                };

                return restEngine.post('/deactivateParc', paramsRestEngine).then(function () {
                    currentRow.IDATIVO = 'N';
                    ScreenService.showMessage('Lead inativado com sucesso!');
                    widget.reload();
                }.bind(this)).catch(function (error) {
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
                });

            });
        } else {
            ScreenService.showMessage('Operação Bloqueada! <br/> Somente o Parceiro Responsável <br/> Pode Inativar o Lead!');
        }
    };

    this.activateLead = function (widget) {
        var currentRow = widget.currentRow;
        if (currentRow.NRPARCPROPRI === CRM_Utilities.getLoggedOperatorInfos().NRPARCNEGOCIO) {

            currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
            ScreenService.confirmMessage(ScreenService.i18n(Messages.ATIVAR_LEAD(widget.currentRow.NMCANDIDATO)), 'question', function (success) {

                var paramsRestEngine = {
                    "requestType": "Row",
                    "row": currentRow
                };

                return restEngine.post('/activateParc', paramsRestEngine).then(function () {
                    currentRow.IDATIVO = 'S';
                    ScreenService.showMessage('Lead Ativado com Sucesso!');
                    widget.reload();
                }.bind(this)).catch(function (error) {
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
                });

            });
        } else {
            ScreenService.showMessage('Operação Bloqueada! <br/> Somente o Parceiro Responsável <br/> Pode Inativar o Lead!');
        }
    };
    
    /**
     * Bloqueia as ações quando um lead inativo
     * é selecionado.
     * 
     * @param {object} widget widget principal da
     * tela de lead.
    */
    this.checkInactiveLead = function(widget) {
        
        var currentRow = widget.currentRow;
        
        if(Boolean(currentRow.IDATIVO)) {
              
            if(currentRow.IDATIVO === 'N') {
                CRM_Utilities.hideFunctionalActions();
                this.defineActivateLeadActionVisibility(widget, true);
            }else{
                CRM_Utilities.returnContainerDefaultActions();
                this.defineActivateLeadActionVisibility(widget, false);
            }
        
        }
        
    };
    
    /**
     * Exibe o botão para ativar o lead selecionado
     * se ele estivar desativado.
     * 
     * @param {object} widget widget principal da
     * tela de lead.
    */
    this.defineActivateLeadActionVisibility = function(widget, isVisible) {
        
        var actionIndexInActions = CRM_Utilities.getObjectPositionInArrayByName(widget.actions, "ATIVAR_LEAD");
        widget.actions[actionIndexInActions].isVisible = isVisible;
        
    };
    
    /**
     * Ativa o lead, desativado, selecionado.
     * 
     * @param {object} widget widget principal 
     * da tela de lead (gridLead).
    */
    this.activateLead = function(widget) {
        
        ScreenService.confirmMessage(ScreenService.i18n(Messages.ATIVAR_LEAD(widget.currentRow.NMCANDIDATO)), 'question', function (success) {
            
            var currentRow = widget.currentRow;
            currentRow.IDATIVO = 'S';
            currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
            
            var paramsRestEngine = {
                "requestType": "Row",
                "row": currentRow
            };
            
            return restEngine.post('/setLeadIdAtivo', paramsRestEngine).then(function() {
                
                this.checkInactiveLead(widget);
                this.setLeadWidgetFilterByActiveLead(widget);
                
            }.bind(this)).catch(function(error) {
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
            });
            	
		}.bind(this));
        
    };
    
    this.editLead = function(widget) {
        var currentRow = widget.currentRow;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                General.widgetEdit(widget);
                
                if(widget.currentRow.NMMODORECEBINFO == undefined) {
                    widget.currentRow.NRMODORECEBINFO = "";
                }
                    
                widget.currentRow.PARCORIGINAL = widget.currentRow.NRPARCNEGOCIO;
                widget.getField('NRINSJURCAN').readOnly = false;
                widget.getField('NMCANDIDATO').readOnly = false;
                /*Controle de Readonly fields de Endereço*/
                widget.getField('NMPAIS').readOnly = false;
                widget.getField('NMESTADO').readOnly = false;
                widget.getField('NMMUNICIPIO').readOnly = false;
                if(typeof widget.getField('NMBAIRROCAN') !== "undefined") {
                    widget.getField('NMBAIRROCAN').readOnly = false;
                }
                if(typeof widget.getField('NMBAIRRO') !== "undefined") {
                    widget.getField('NMBAIRRO').readOnly = false;
                }
                
                this.getLocalFound(currentRow);
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    };
    
    this.cleanWidgetFields = function(widget) {
        widget.fields.forEach(function(field) {
            field.value("");    
        });   
    };
    
    /**
     * Função que usa o CRM_Utilities para 
     * validar a inscrição e atualizar 
     * a currentRow.
    */
    this.validaInscricao = function(widget, lead, prospect, fromProspect) {
        
        widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        widget.currentRow.IDVALIDACNPJ = templateManager.CRM_PARAMETRIZACAO.IDCNPJRAIZ;
        widget.currentRow.IDBLOQNOMESEMELHA = templateManager.CRM_PARAMETRIZACAO.IDBLOQNOMESEMELHA;
        
        var inscricao     = widget.getField("NRINSJURCAN");
        var tipoInscricao = widget.getField("IDTPIJURCAN");
        
        if(fromProspect) {
            inscricao = widget.getField("NRINSJURPROS");
            tipoInscricao = widget.getField("IDTPIJURPROS");
            widget.currentRow.IDTPIJURCAN = widget.currentRow.IDTPIJURPROS;
        } else if(widget.name === 'gridCliente') {
            inscricao = widget.getField("NRINSJURCLIE");
            tipoInscricao = widget.getField("IDTPIJURCLIE");
        }
        
        if (CRM_Utilities.isWidgetFilter(widget)) {
            if(fromProspect) {
                widget.currentRow.NRINSJURPROS = inscricao.value().replace(/[^0-9]/g,'');
            } else if(inscricao.name == "NRINSJURCLIE") {
                widget.currentRow.NRINSJURCLIE = inscricao.value().replace(/[^0-9]/g,'');
            } else {
                widget.currentRow.NRINSJURCAN  = inscricao.value().replace(/[^0-9]/g,'')
            }
            return;
        } else if (Util.isEmptyOrBlank(inscricao.value())) {
            tipoInscricao.value('');
            return;
        }
        
        //Variavel para validacao de cpnj raiz
        var valueInscricao = inscricao.value();
        
        CRM_Utilities.validaInscricao(widget, inscricao.name, tipoInscricao.name);
        
        if(templateManager.CRM_PARAMETRIZACAO.IDCNPJRAIZ === 'S' && valueInscricao.length === 14) {
           if(templateManager.container.name == 'crm00040_000_leads') {
                widget.currentRow.CNPJRAIZ = widget.currentRow.NRINSJURCAN.toString().split('/')[0].replace(/[^0-9]/g,'');
                widget.currentRow.INSCRICAO = widget.currentRow.CNPJRAIZ;
                widget.currentRow.NOME      = widget.currentRow.NMCANDIDATO.toString().replace(' ', "%").toUpperCase();
            } else if(templateManager.container.name == 'ger45000_prospect') {
                widget.currentRow.CNPJRAIZ = widget.currentRow.NRINSJURPROS.toString().split('/')[0].replace(/[^0-9]/g,'');
                widget.currentRow.INSCRICAO = widget.currentRow.CNPJRAIZ;
                widget.currentRow.NOME      = widget.currentRow.NMRAZSOCPROS.toString().replace(' ', "%").toUpperCase();
            } else if(templateManager.container.name == 'crm_cliente') {
                widget.currentRow.CNPJRAIZ = widget.currentRow.NMRAZSOCCLIE.toString().split('/')[0].replace(/[^0-9]/g,'');
                widget.currentRow.INSCRICAO = widget.currentRow.CNPJRAIZ;
                widget.currentRow.NOME      = widget.currentRow.NMFANTCLIE.toString().replace(' ', "%").toUpperCase();
            }
            this.verificaLeadExistente(widget.currentRow).then(function(verificaLead) {
                if(Array.isArray(verificaLead.dataset.DADOS.LEADS) && verificaLead.dataset.DADOS.LEADS.LEADS && verificaLead.dataset.DADOS.PARCEXISTS) { 
                    var leads = verificaLead.dataset.DADOS.LEADS;
                
                    var mensagemCNPJ = this.criarMensagemInscricaoJaVinculada(leads);
                    mensagemCNPJ = "Operação bloqueada! Este CNPJ Raiz já está vinculado" + mensagemCNPJ.substr(81);
                    
                    ScreenService.showMessage(mensagemCNPJ);
                    widget.fields.find(function (x) {x.label == 'Inscrição'}).clearValue();
                    widget.fields.find(function (x) {x.label == 'Tipo de Inscrição'}).value('I');
                    widget.currentRow.INSCRICAO = "";
                    widget.currentRow.NOME = "";
                    widget.currentRow.CNPJRAIZ = "";
                }else if(!Util.isEmptyOrBlank(valueInscricao)) {
                    this.completeValidation(widget, inscricao, tipoInscricao, lead, prospect, fromProspect);
                }
            }.bind(this));
        }else if(!Util.isEmptyOrBlank(valueInscricao)) {
            this.completeValidation(widget, inscricao, tipoInscricao, lead, prospect, fromProspect);    
        }
        if(!fromProspect && widget.name !== 'gridCliente') {
            this.changeLabelDTNASCIFUNDPARC(widget);
        }
    };
    
    this.completeValidation = function(widget, inscricao, tipoInscricao, lead, prospect, fromProspect) {
        if(fromProspect) {
            widget.currentRow.INSCRICAO = widget.currentRow.NRINSJURPROS.toString().replace(/[^0-9]/g,'');
            widget.currentRow.NOME      = widget.currentRow.NMRAZSOCPROS.toString().replace(' ', "%").toUpperCase();
            widget.currentRow.IDTPIJURCAN = widget.currentRow.IDTPIJURPROS;
        }else if(widget.name === 'gridCliente') {
            widget.currentRow.INSCRICAO = widget.currentRow.NRINSJURCLIE.toString().replace(/[^0-9]/g,'');
            widget.currentRow.NOME      = widget.currentRow.NMRAZSOCCLIE.toString().replace(' ', "%").toUpperCase();
            widget.currentRow.IDTPIJURCAN = widget.currentRow.IDTPIJURCLIE;
        } else {
            widget.currentRow.INSCRICAO = widget.currentRow.NRINSJURCAN.toString();
            widget.currentRow.NOME      = widget.currentRow.NMCANDIDATO.toString().replace(' ', "%").toUpperCase();
        }
        widget.currentRow.LEAD      = lead || false;
        widget.currentRow.PROSPECT  = prospect || false;
        this.verificaLeadExistente(widget.currentRow).then(function(response) {
            if(Array.isArray(response.dataset.DADOS.LEADS) && !Util.isEmptyOrBlank(response.dataset.DADOS.LEADS) && response.dataset.DADOS.PARCEXISTS) {
                var leads = response.dataset.DADOS.LEADS;
                
                var mensagemInscricaoVinculada = this.criarMensagemInscricaoJaVinculada(leads);
                ScreenService.showMessage(mensagemInscricaoVinculada);
                widget.fields.find(function (x) {x.label == 'Inscrição'}).clearValue();
                widget.fields.find(function (x) {x.label == 'Tipo de Inscrição'}).value('I');
                widget.currentRow.INSCRICAO = "";
                widget.currentRow.NOME = "";
                widget.currentRow.CNPJRAIZ = "";
            } else if(!Util.isEmptyOrBlank(response.dataset.DADOS.LEADS) && response.dataset.DADOS.PARCEXISTS) {
                self.buildReturnedParcRow(widget, response.dataset.DADOS.LEADS);
            } else {
                this.autofillData(widget, fromProspect); 
            }
        }.bind(this));
        
    };
    
    /**
     * A label do campo de data de nascimento/fundação
     *  muda de acordo com o tipo de inscrição
    */
    this.changeLabelDTNASCIFUNDPARC = function(widget) {
        var readOnly = true;
        
        if(widget.currentRow.IDTPIJURCAN === "J") {
            widget.getField('DTNASCIFUNDPARC').label = 'Data de Fundação';
            readOnly = false;
        }else if(widget.currentRow.IDTPIJURCAN === "F") {
            widget.getField('DTNASCIFUNDPARC').label = 'Data de Nascimento';
            readOnly = false;
        }else{
            widget.getField('DTNASCIFUNDPARC').label = 'Nascimento/Fundação';
            readOnly = true;
            widget.currentRow.DTNASCIFUNDPARC = null;
        }
        
        widget.getField('DTNASCIFUNDPARC').readOnly = readOnly;
    };
    
    this.validaCNPJRaiz = function(CNPJ) {
        
        var cnpj = CNPJ.substr(8,4);
        
        if(cnpj === "0001")
            return true;
        else
            return false;
        
    };
    
    this.startWidgetFilterGridlead = function(widget)
    {
        var widgetFilter = widget.dataSourceFilter;
        var nrparcnegocioFilterIndex = CRM_Utilities.getFilterPosition(widgetFilter, "P_NRPARCNEGOCIO");
        var nrorgFilterIndex = CRM_Utilities.getFilterPosition(widgetFilter, "P_NRORG");
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        if(nrorgFilterIndex) {
            if(loggedOperatorInfos) widgetFilter[nrparcnegocioFilterIndex].value = loggedOperatorInfos.NRPARCNEGOCIO;
            widgetFilter[nrorgFilterIndex].value = getLocalVar("CRM_NRORG");
            var restrictObjects = [];
            
            restrictObjects.push(widget);
            restrictObjects.push(widget.getField("NMPARCPROPRI"));
            
            CRM_Utilities.setResaleRulesInRestrictObjectsByLoggedOperatorResale(restrictObjects);
        }
        
    
        //seta parametrizacoes na widget
        widget.CRM_PARAMETRIZACAO = CRM_Utilities.getCrmParametrization();
    };
    
    this.setTasksWidgetOperatorField = function() {
        
        var tasksWidget = templateManager.container.getWidget('posvendagrid');
        var operatorField = tasksWidget.getField('NMOPERADOR');
        
        CRM_Utilities.setObjectFilterWhenResaleLoggedOperator(operatorField);
        
    };
    
    /**
     * Função para definir o filtro dos campos
     * de motivo de contato e resultado, na widget
     * de evolução.
     * 
     * @param {object} widget widget de evolução.
    */
    this.setEvolutionResultFilterAndContactReasonFilter = function(widget) {
        
        var ContactReasonField = widget.getField("NMMOTIEVOCON");
        var ResultField = widget.getField("DESCRESULEVOL");
        this.setOperatorCodeFilterValueAndOrganizationNumberFilterValue(ContactReasonField);
        this.setOperatorCodeFilterValueAndOrganizationNumberFilterValue(ResultField);
        widget.getField('NRPARCNEGOCIO').defaultValue = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        
    };
    
    /**
     * Função para setar valor dos filtros de
     * número de organização e código de operador
     * da field recebida como parâmetro, e logo
     * em seguida, recarrega a field.
     * 
     * @param {object} field field que receberá
     * o valor dos filtros
    */
    this.setOperatorCodeFilterValueAndOrganizationNumberFilterValue = function(field) {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        var fieldFilter = field.dataSourceFilter;
        var nrorgFilterIndex = CRM_Utilities.getFilterPosition(fieldFilter, "P_NRORG");
        var cdoperadorFilterIndex = CRM_Utilities.getFilterPosition(fieldFilter, "P_CDOPERADOR");
        
        fieldFilter[nrorgFilterIndex].value = loggedOperatorInfos.NRORG;
        fieldFilter[cdoperadorFilterIndex].value = loggedOperatorInfos.CDOPERADOR;
        
        field.reload();
            
    };
    
    this.typechecking = function(widget) {
      var currentRow = widget.currentRow;
      if(typeof currentRow.NRINSJURCAN !== "undefined" && currentRow.NRINSJURCAN.toString() !== "")
      {
        var nrinsjuca = widget.currentRow.NRINSJURCAN.toString().replace(/[^0-9]/g,'');
        var FieldIDTPIJURCAN = widget.getField('IDTPIJURCAN');

        switch (nrinsjuca.length) {
            case 5:
                FieldIDTPIJURCAN.value("O");
                currentRow.TIPOINSC = "CODIGO";
              break;

            case 11:
                FieldIDTPIJURCAN.value("F");
                currentRow.TIPOINSC = "CPF";
              break;

            case 14:
                FieldIDTPIJURCAN.value("J");
                currentRow.TIPOINSC = "CNPJ";
              break;

            case 20:
                FieldIDTPIJURCAN.value("I");
                currentRow.TIPOINSC = "LIVRE";
              break;

            default:
                FieldIDTPIJURCAN.value("O");
                currentRow.TIPOINSC = "CODIGO";
              break;

        }
      }else{
          currentRow.IDTPIJURCAN = "";
      }
    };

    this.convertsToSubscriptionType = function(currentRow) {
      if(typeof currentRow.NRINSJURCAN !== "undefined" && currentRow.NRINSJURCAN.toString() !== "")
      {
        var nrinsjucan = currentRow.NRINSJURCAN.toString().replace(/[^0-9]/g,'');

        switch (nrinsjucan.length) {
            case 11:
                nrinsjucan = nrinsjucan.replace(/^(\d{3})(\d{3})(\d{3})(\d{2})/, "$1.$2.$3-$4");
              break;

            case 14:
                nrinsjucan = nrinsjucan.replace(/^(\d{2})(\d{3})(\d{3})(\d{4})(\d{2})/, "$1.$2.$3/$4-$5");
              break;
        }

        currentRow.NRINSJURCAN = nrinsjucan;
      }
    };

    this.checkInvalidInscription = function(widget) {
      var currentRow = widget.currentRow;
      var fieldInscription = widget.getField('NRINSJURCAN');

      if(fieldInscription && this.isValidInscription(currentRow.NRINSJURCAN)) {
          fieldInscription.value("");
          ScreenService.showMessage("Inscrição Inválida.");
      }
    };


    this.isValidInscription = function(inscription) {

        if(inscription[0] === "0") {
            inscription = this.validateRegistrationWithZerosLeft(inscription);
        }

        var inscriptionInNumber = parseInt(inscription).toString();
        if(inscriptionInNumber.length === inscription.length || inscriptionInNumber === "0") {
            return false;
        }
        return true;
    };

    this.validateRegistrationWithZerosLeft = function(value) {
        var index = 0;

       while(value[index] === "0") {
            value = value + "1";
            index++;
        }

        return parseInt(value).toString();
    };

    this.validationEmail = function(field) {
		var receivedTestEmail = ValidationEngine.mail(field.value(),"E-mail Válido");
		if(receivedTestEmail.valid === false) {
		    field.value("");
		    ScreenService.showMessage("E-mail inválido");
		}
	};

    this.validationPhone = function(field) {
	    var numberSizeReceived = field.value().replace(/[^0-9]/g,'').length;
	    if(numberSizeReceived !== 10 && numberSizeReceived !== 11 && numberSizeReceived !== 12) {
	        field.value("");
		    ScreenService.showMessage("Telefone Inválido");
	    }
	};
    
    this.localFilter = function(widget,field) {
        var localname = field.name;
        var currentRow = widget.currentRow;
        var filters = [];
        var filterCode;

        switch(localname) {
            case "NMESTADO":
                filterCode = "CDPAIS";
                filters.push(this.createEqualFilter(filterCode,currentRow.CDPAIS));
            break;
            
            case "NMMUNICIPIO":
                filterCode = "SGESTADO";
                filters.push(this.createEqualFilter(filterCode,currentRow.SGESTADO));
                filterCode = "CDPAIS";
                filters.push(this.createEqualFilter(filterCode,currentRow.CDPAIS));
            break;
            
            case "NMBAIRRO":
                filterCode = "CDMUNICIPIO";
                filters.push(this.createEqualFilter(filterCode,currentRow.CDMUNICIPIO));
                filterCode = "SGESTADO";
                filters.push(this.createEqualFilter(filterCode,currentRow.SGESTADO));
                filterCode = "CDPAIS";
                filters.push(this.createEqualFilter(filterCode,currentRow.CDPAIS));
            break;
            
            default:
                if(localname === "NMBAIRROCAN") {
                    filterCode = "CDMUNICIPIO";
                    filters.push(this.createEqualFilter(filterCode,currentRow.CDMUNICIPIO));
                    filterCode = "SGESTADO";
                    filters.push(this.createEqualFilter(filterCode,currentRow.SGESTADO));
                    filterCode = "CDPAIS";
                    filters.push(this.createEqualFilter(filterCode,currentRow.CDPAIS));
                }
            break;
        }
        
        filters.forEach(function(filter) {
            var filterCode = filter.name;    
            var localNameIndexFilter = CRM_Utilities.getFilterPosition(field.dataSourceFilter, filterCode);
            
            if(field.dataSourceFilter[localNameIndexFilter]) {
                field.dataSourceFilter = CRM_Utilities.deleteFilterObject(field.dataSourceFilter, localNameIndexFilter);
            }
            field.dataSourceFilter.push(filter);
        });
        
        
    };

    var selectedcountry;
    this.exchangeCountry = function(currentRow) {
      var currentCountrys = currentRow.NMPAIS.toString();

      if(typeof selectedcountry === "undefined") {
          selectedcountry = currentCountrys;
      }else if(selectedcountry !== currentCountrys) {
          currentRow.NMESTADO = "";
          currentRow.SGESTADO = "";
          currentRow.NMMUNICIPIO = "";
          currentRow.CDMUNICIPIO = "";
          currentRow.NMBAIRRO = "";
          currentRow.NMBAIRROCAN = "";
          currentRow.CDBAIRRO = "";
          selectedcountry = currentCountrys;
      }
    };

    var selectedstate;
    this.exchangeState = function(currentRow) {
      var currentState = currentRow.NMESTADO.toString();

      if(typeof selectedstate === "undefined") {
          selectedstate = currentState;
      }else if(selectedstate !== currentState) {
          currentRow.NMMUNICIPIO = "";
          currentRow.CDMUNICIPIO = "";
          currentRow.NMBAIRRO = "";
          currentRow.NMBAIRROCAN = "";
          currentRow.CDBAIRRO = "";
          selectedstate = currentState;
      }
    };

    var selectedmunicipality;
    this.exchangeMunicipality = function(currentRow) {
      var currentMunicipality = currentRow.NMMUNICIPIO.toString();

      if(typeof selectedmunicipality === "undefined") {
          selectedmunicipality = currentMunicipality;
      }else if(selectedmunicipality !== currentMunicipality) {
          currentRow.NMBAIRROCAN = "";
          currentRow.NMBAIRRO = "";
          currentRow.CDBAIRRO = "";
          selectedmunicipality = currentMunicipality;
      }
    };

    this.momentNow = function() {
        return moment(new Date()).format('DD/MM/YYYY HH:mm:ss');
    };

    this.createEqualFilter = function(name,value) {
        var filter = {
            "name": name,
            "operator": "=",
            "value": value
        };
            
        return filter;
    };

    this.setQualifyLead = function (widget, newValue) {
        var currentRow = widget.currentRow;
        var atualizarAcoes = this.atualizarAcoes;
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');

        if (currentRow.NRPARCPROPRI === CRM_Utilities.getLoggedOperatorInfos().NRPARCNEGOCIO) {
            General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function (response) {
                if (response.dataset && response.dataset.error) {
                    ScreenService.showMessage(response.dataset.error, 'ERROR');
                }
                if (response.dataset && response.dataset.GROUPREL[0] == false) {
                    if ((currentRow.IDSTATUSCAN !== "3" && newValue === "3") || (currentRow.IDSTATUSCAN !== "4" && newValue === "4")) {
                        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

                        currentRow.IDSTATUSCAN = newValue;
                        currentRow.CDOPERULTATU = loggedOperatorInfos.CDOPERADOR;
                        currentRow.DTULTATU = self.momentNow();

                        restEngine.post('/setQualification', { 'requestType': 'Row', 'row': currentRow },
                            undefined, undefined, undefined).then(function (response) {
                                //BEGIN RD Station
                                var contactWidgets = templateManager.container.getWidget('WDGT_INTERLOCUTOR');
                                contactWidgets.dataSourceFilter.forEach(function (filter) {
                                    if (filter.name === 'NRPARCNEGOCIO')
                                        filter.value = widget.currentRow.NRPARCNEGOCIO;
                                });
                                contactWidgets.reload().then(function () {
                                    if (!Util.isEmptyOrBlank(contactWidgets.dataSource.data)) {
                                        contactWidgets.dataSource.data.forEach(function (contact) {
                                            restEngine.post('/IntegracaoRDStation/changeFunnel', { 'requestType': 'Row', 'row': { FUNNEL: (currentRow.IDSTATUSCAN === "3") ? 'Qualified Lead' : 'Lead', EMAIL: contact['EMAILINTERLOC'], OPPORTUNITY: false } },
                                                undefined, undefined, undefined);
                                        });
                                    }
                                });
                                //END RD Station
                                this.showLeadQualificationMessage(newValue);
                                widget.reload().then(function () {
                                    atualizarAcoes(widget);
                                });
                            }.bind(this));
                    } else {
                        this.showQualificationErrorMessage(currentRow.IDSTATUSCAN);
                    }
                } else {
                    ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
                }
            }.bind(this));
        } else {
            ScreenService.showMessage('Operação Bloqueada! <br> Somente o Parceiro Responsável <br> Pode Qualificar/Desqualificar o Lead');
        }
    };
    
    this.updateStatusCan = function (widget, newValue){
        var currentRow = widget.currentRow;
        var atualizarAcoes = this.atualizarAcoes;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                if(Util.isEmptyOrBlank(currentRow.IDSTATUSCAN)) {
                    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
                    
                    currentRow.IDSTATUSCAN = newValue;
                    currentRow.CDOPERULTATU = loggedOperatorInfos.CDOPERADOR;
                    currentRow.DTULTATU = self.momentNow();
                    
                    restEngine.post('/setNewStatus', {'requestType':'Row', 'row': currentRow},
                    undefined, undefined, undefined).then(function(response) {
                        this.showLeadQualificationMessage(newValue);
                        widget.reload().then(function() {
                        atualizarAcoes(widget);
                        });
                    }.bind(this));
                }else{
                    this.showQualificationErrorMessage(currentRow.IDSTATUSCAN);
                }
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    }


    this.showLeadQualificationMessage = function(leadQualification) {
    
        if(leadQualification === "3") {
            ScreenService.showMessage('Lead qualificado com sucesso.');
        }else if (leadQualification === "4"){
            ScreenService.showMessage('Lead desqualificado com sucesso.');
        } else {
            ScreenService.showMessage('Status do Lead Atualizado Com Sucesso.');
        }
        
    };
    
    this.showQualificationErrorMessage = function(leadQualification) {
        
        if(leadQualification === "3") {
            ScreenService.showMessage(Messages.LEAD_JA_QUALIFICADO);
        }else{
            ScreenService.showMessage(Messages.LEAD_JA_DESQUALIFICADO);
        }
        
    };
    
    this.initTab = function(widget) {
        if(widget.parent.parent.currentRow.NRCANDIDATO) {
            widget.dataSourceFilter.find(function (x) {x.name = 'NRCANDIDATO'}).value = widget.parent.parent.currentRow.NRCANDIDATO;
        }

        widget.reload();
    };

    this.initTabEvol = function(widget) {
        setLocalVar('PARCEIRO', widget.parent.parent.currentRow.NRPARCNEGOCIO);
        
        widget.reload();
    };

    this.evolucaoNewRow = function() {
        var widget = templateManager.container.getWidget('evolucao');
        var currentRow = widget.currentRow;
        var gridWidget = templateManager.container.getWidget("gridLead");
        var gridCurrentRow = gridWidget.currentRow;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        gridCurrentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        gridCurrentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [gridCurrentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                widget.getField("DESCRESULEVOL").readOnly = false;
                widget.getField("NMINTERLOCUTOR").defaultValue = "";
                General.widgetNewRow(widget);
                currentRow = widget.currentRow;
                
                currentRow.DTHREVOLCONT = (currentRow.DTHREVOLCONT)? currentRow.DTHREVOLCONT : moment(new Date()).format('DD/MM/YYYY HH:mm');
                currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
                currentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
                currentRow.NRORG = loggedOperatorInfos.NRORG;
                
                ABEvolucaoController.setEvolDateChangePermission(widget);
                
                currentRow.NRCONTATO = (!Util.isEmptyOrBlank(widget.parent.parent.currentRow.NRCONTATO)) ? widget.parent.parent.currentRow.NRCONTATO : widget.parent.parent.currentRow.NRSEQCONTATO;  
                currentRow.NRSEQCONTATO = widget.parent.parent.currentRow.NRSEQCONTATO;
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    };
    

    this.cancelEvolForm = function(widget) {
        this.cleanConversionIndicator(widget);
        widget.getField("DESCRESULEVOL").readOnly = true;
        General.widgetCancelForm(widget);
    };
    
    this.setOperatorNextTask = function(currentRow, loggedOperatorInfos) {
        currentRow.NMOPERADORREAL = loggedOperatorInfos.NMOPERADOR;
        currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
    };
    
    this.insertRowNextTask = function(widget) {
        
        var currentRow = widget.currentRow;
        var deferred = ZHPromise.defer();
        
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        
        if(currentRow.DTPLANFILACONTA && !currentRow.NEXTTASKBLOCKED) {
        
            return Crm_00040_Lead_Service.callForInsertClient(widget.currentRow);
            
        }else{
            
            deferred.resolve();
            
        }
        
        return deferred;
        
    };
    
    
    /**
     * Procedimento para verificar se uma evolução
     * está sendo salva por uma rotina de conversão
     * ou por uma rotina comum de insert.
     * 
     * @param {object} widget widget de evolução.
    */
    this.checkEvolutionConversion = function(widget) {
        //prepara widget para a verificação
        if(!widget.currentRow.NRPARCNEGOCIO) {
            widget.currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        }
        
        var currentRow = widget.currentRow;
        
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                if(widget.isValid()) {
                    this.verificaTarefasAbertas(widget.currentRow).then(function() {
                        if(Boolean(widget.REALIZARCONVERCAO)) {
                            templateManager.evolutionWidget = widget;
                            this.verifyHasRelationship(widget);
                        }else{
                            this.saveEvolucao(widget);
                        }   
                    }.bind(this)).catch(function() {
                        General.widgetCancelForm(widget);
                    }.bind(this));
                }
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    };
    
    /**
     * Procedimento para remover a widget de evolução
     * salva no template Manager.
    */
    this.cleanEvolutionWidgetInTemplateManager = function() {
        
        if(Boolean(templateManager.evolutionWidget)) {
            delete templateManager.evolutionWidget;
        }
        
    };
    
    /**
     * Organiza os campos para salvar a evolução
     * e verifica tarefa já aberta.
     * 
     * @param {object} widget widget de evolução
    */
    this.saveEvolucao = function(widget) {
        
        var currentRow = widget.currentRow;
        var zhPromise = ZHPromise.defer();
        
        if(widget.isValid()) {
        
            currentRow.IDGERAFATURA = 'NAO';
            currentRow.IDTPEVOLCONT = 'P';
            currentRow.IDANEXOEVOLCONT = currentRow.IDANEXOEVOLCONT === 'S' ? currentRow.IDANEXOEVOLCONT : 'N';
            currentRow.CDFILIAL = "";
            currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
    
            if(!currentRow.NRRELACIONAPARC) {
                currentRow.NRRELACIONAPARC = null;
            }
            
            var widgetevol = templateManager.container.getWidget('evolucao');
            this.getParentField(widget);
            this.saveEvolutionAndInsertTask(widget, currentRow).then(function() {
                zhPromise.resolve();
            });
            
        }
        return zhPromise.promise;
    };
    
    
    /**
     * Salva evolução e gera Tarefa
     * 
     * @param {object} widget widget de evolução
    */
    this.saveEvolutionAndInsertTask = function(widget, currentRow) {
        var zhPromise = ZHPromise.defer();
        this.insertRowNextTask(widget).then(function(response) {
            
            if(response) {
                
                currentRow.NRSEQFILACONTA = response.dataset.DADOS.NRSEQFILACONTA;
                
            }else if(!currentRow.NRSEQFILACONTA) {
                
                currentRow.NRSEQFILACONTA = "";
                
            }
            
            General.widgetSave(widget).then(function(response) {
    
                if(response.dataset.DADOS[0] && response.dataset.DADOS[0].NRSEQEVOLCONT) {
                    currentRow.NRSEQEVOLCONT = response.dataset.DADOS[0].NRSEQEVOLCONT;
                }
                if(!Util.isEmptyOrBlank(widget.currentRow.NRSEQINTERLOCUTOR) && widget.currentRow.IDENVIAEMAIL === 'S') {
                    ScreenService.confirmMessage('Deseja enviar um email para '+widget.currentRow.NMINTERLOCUTOR+'?', 'QUESTION',
                    function(yes) {
                        evolutionTabController.openWidgetSendMail(widget, 'gridLead').then(function() {
                            templateManager.promise = zhPromise;
                        });
                    }, function(no) {
                        zhPromise.resolve();
                    });
                }else{
                    zhPromise.resolve();
                }
                widget.reload();
                
                this.setTaskEndDate(widget);    
                
            }.bind(this)).catch(function(error) {
                if(error.indexOf('REQUIRE_INTERLOCUTOR')  !== -1)
                    ScreenService.showMessage("Operação bloqueada! <br><br> Favor informar o interlocutor.");
                else
                    ScreenService.showMessage(error);
            });
        }.bind(this));
        return zhPromise.promise; 
    };
    
    /**
     * Verifica se já existem tarefas relacionadas
     * aquele parceiro
     * 
     * @param {object} widget widget de evolução
    */
    this.verificaTarefasAbertas = function(currentRow) {
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        
        var zhPromise = ZHPromise.defer();
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        
        restEngine.post('/verificaTarefas', paramsRestEngine).
            then(function(response) {
                if(response.dataset.DADOS.TAREFAS) {
                    var tarefas = response.dataset.DADOS.TAREFAS;
                    var operadores = '';
                    tarefas.forEach(function(tarefa) {
                        operadores +='<br>'+tarefa;
                    });
                    ScreenService.confirmMessage('Este parceiro possui tarefas "Em Aberto" para o(s) seguinte(s) operador(es) <br>'+operadores+'<br><br> Deseja continuar? ', 'CONFIRMATION',
                    function(success) {
                        zhPromise.resolve();
                    }.bind(this),
                    function(fail) {
                        zhPromise.reject();
                    });
                }else{
                    zhPromise.resolve();
                }
            }.bind(this));
        return zhPromise.promise;
    };
    
    
    this.getParentField = function(widget) {
        
        widget.currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        if(widget.currentRow.__is_new) {
            widget.currentRow.NRCONTATO = widget.parent.parent.currentRow.NRCONTATO;
            widget.currentRow.NRSEQCONTATO = widget.parent.parent.currentRow.NRSEQCONTATO;
        }
        
    };

    this.openWidgetFundir = function() {
      var widget = templateManager.container.getWidget('FUNDIRLEAD');

      ScreenService.closePopup();

      widget.currentRow.NRCANDIDATOLEAD = widget.parent.parent.currentRow.NMCANDIDATO;
    };

    this.closeWidgetFundir = function() {
        var widgetLeads = templateManager.container.getWidget('crm00040_000_leads');
        var widgetMerge = templateManager.container.getWidget('FUNDIR');

        widgetLeads.list();
        widgetMerge.currentRow.NOME = "";

    };

    this.mergeCandidate = function(widget) {
        var currentRow = widget.currentRow;
        var sourcePartners = currentRow.NOME;

        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.NRORG = widget.parent.parent.currentRow.NRORG;
        currentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
        currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCNEGOCIO;

        if(currentRow.NRPARCNEGOCIO) {

            var parcSeparatedByUnderline = "_";

            sourcePartners.forEach(function(value) {
            parcSeparatedByUnderline = parcSeparatedByUnderline + value + "_";
            });
            currentRow.PARCTOSTRING = parcSeparatedByUnderline;

            restEngine.post('/mergeCandidate', {'requestType':'Row', 'row': currentRow},
             function(success) {
                 
                ScreenService.showMessage(Messages.PARCEIROS_FUNDIDOS_SUCESSO);
                currentRow.NOME = "";
                ScreenService.closeSwipe();
                widget.parent.parent.view();
                widget.parent.parent.activate();
                
             },undefined, undefined);
        }else{

            ScreenService.showMessage("O Lead selecionado não possui parceiro de negócio.");
            currentRow.NOME = "";
        }
    };
    
    
    /*
    * Prepara campos para conversão do lead
    * e valida se já existe prospect com aquela inscrição
    */
    this.ConvertLeadInProspect = function(widget) {
        var loggedOperatorInfos   = CRM_Utilities.getLoggedOperatorInfos();
        var currentRow = widget.currentRow;
        widget.CRM_PARAMETRIZACAO = CRM_Utilities.getCrmParametrization();

        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                if(widget.isValid()) {
                    widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                    var currentRow = widget.currentRow;
                    currentRow['DSTELEFONECAN'] = currentRow['DSTELEFONECAN'].replace(/[^0-9]/g, '');
                    
                    if(widget.currentRow.NMMODORECEBINFO == undefined || widget.currentRow.NMMODORECEBINFO == "") {
                        widget.currentRow.NRMODORECEBINFO = "";
                    }
                    
                    currentRow.INSCRICAO = currentRow.NRINSJURCAN.toString().replace(/[^0-9]/g,'');
                    currentRow.NOME = currentRow.NMCANDIDATO.toString().replace(' ', "%").toUpperCase();
                    
                    //Propriedade para fazer validação de lead
                    currentRow.LEAD     = false;
                    currentRow.PROSPECT = true;
                    
                    currentRow.CDOPERINCLUSAO = loggedOperatorInfos.CDOPERADOR;
                    currentRow.NRORG = loggedOperatorInfos.NRORG;
                    currentRow.CURRENTDATE = self.momentNow();
                    currentRow.NRFUNCCAN = widget.parent.parent.currentRow.NRFUNCCAN;
                    currentRow.CDMODODIVULG = widget.parent.parent.currentRow.CDMODODIVULG;
                    currentRow.NRCONTATO = (!Util.isEmptyOrBlank(widget.parent.parent.currentRow.NRCONTATO)) ? widget.parent.parent.currentRow.NRCONTATO : widget.parent.parent.currentRow.NRSEQCONTATO;
                    currentRow.NRCANDIDATO = widget.parent.parent.currentRow.NRCANDIDATO;
                    currentRow.NRINSJURCAN = currentRow.NRINSJURCAN.toString().replace(/[^0-9]/g,'') ;
                    currentRow.NMFANTCAN = currentRow.NMFANTCAN ? currentRow.NMFANTCAN : currentRow.NMCANDIDATO;
                    currentRow.NRPARCRESPROSP  = loggedOperatorInfos.NRPARCNEGOCIO;
                    currentRow.CDOPERRESPONSAVEL = loggedOperatorInfos.CDOPERADOR;
                    currentRow.DTINITRESERVAPROSP = CRM_Utilities.getDataHoraAtual();
                    
                    this.getNewResponsibleOperatorForTheLead(widget);
                    this.requireInterlocutorFields(widget);
                    
                    if(currentRow.__is_new) {
                        this.verificaLeadExistente(currentRow).then(function(response) {
                                if(response.dataset.DADOS.LEADS === true){
                                    //Verifica parametrização bloqueia nome semelhante
                                    if(widget.CRM_PARAMETRIZACAO.IDBLOQNOMESEMELHA === 'S') {
                                        ScreenService.showMessage("Operação bloqueada! <br><br> A 'Razão Social' informada, já está vinculada a outro prospect.");
                                    }else{
                                        ScreenService.confirmMessage("A 'Razão Social' informada, já está vinculada a outro prospect. <br><br> Deseja continuar? ", 'CONFIRMATION',
                                            function(success) {
                                                this.convertValidLead(widget, currentRow, loggedOperatorInfos);
                                            }.bind(this));
                                    }
                                }else if(Array.isArray(response.dataset.DADOS.LEADS) && !Util.isEmptyOrBlank(response.dataset.DADOS.LEADS) && response.dataset.DADOS.PARCEXISTS) {
                                    var leads = response.dataset.DADOS.LEADS;
                                    var mensagemInscricaoVinculada = this.criarMensagemInscricaoJaVinculada(leads);
                                    ScreenService.showMessage(mensagemInscricaoVinculada);
                                    
                                    widget.fields.find(function (x) {x.label == 'Inscrição'}).clearValue();
                                    widget.fields.find(function (x) {x.label == 'Tipo de Inscrição'}).value('I');  
                                    widget.currentRow.INSCRICAO = "";
                                    widget.currentRow.NOME = "";
                                    widget.currentRow.CNPJRAIZ = "";
                                }else {
                                    this.convertValidLead(widget, currentRow, loggedOperatorInfos);
                                }
                            }
                        .bind(this));
                    }else{
                        this.convertValidLead(widget, currentRow, loggedOperatorInfos);    
                    }
                }
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
        
    };
    
    this.criarMensagemInscricaoJaVinculada = function(parceiros) {
        var mensagem = "Operação bloqueada! <br><br> Esta Inscrição já está vinculada ao(s) seguinte(s):";
    
        var tiposDeParceiroEValores = this.agruparParceirosPorTipo(parceiros);
    
        tiposDeParceiroEValores.forEach(function(grupoDeParceiros) {
            mensagem += "<br><br>--> " + grupoDeParceiros.tipo + ":";
    
            grupoDeParceiros.parceiros.forEach(function(parceiro) {
                mensagem += "<br>- " + parceiro;
            });
        });
    
        return mensagem;
    };
    
    this.agruparParceirosPorTipo = function (parceiros) {
        var parceirosAgrupadosPorTipo = CRM_Utilities.groupBy(parceiros, ['TIPOPARC']);
    
        // Adaptar para iterar sobre as propriedades
        var tiposDeParceiroEValores = [];
        var self = this; // Armazenar referência ao contexto externo
    
        Object.keys(parceirosAgrupadosPorTipo).forEach(function (tipo) {
            var grupo = parceirosAgrupadosPorTipo[tipo];
    
            // Verificar se grupo é um array antes de prosseguir
            if (Array.isArray(grupo)) {
                var grupoDeParceiros = {
                    tipo: self.cdTipoParcToString(tipo),
                    parceiros: grupo.map(function (parceiro) {
                        return parceiro.NMPRINCIPALPARC;
                    })
                };
    
                tiposDeParceiroEValores.push(grupoDeParceiros);
            }
        });
    
        return tiposDeParceiroEValores;
    };
    
    this.cdTipoParcToString = function(cdTipoParc) {
        var tipoDoParceiro;
        var crmu = CRM_Utilities;
        
        switch(cdTipoParc) {
            case 'CLIENTE':
                tipoDoParceiro = 'Cliente(s)';
                break;
                
            case 'PROSPECT':
                tipoDoParceiro = 'Prospect(s)';
                break;
                
            case 'CANDIDATO':
                tipoDoParceiro = 'Lead(s)';
                break;
                
            default:
                tipoDoParceiro = cdTipoParc;
                break;
        }
        
        return tipoDoParceiro;
    }
    
    /**
     * Verifica se o operador que está convertendo o lead em
     * caso, está sendo trabalhado por um operador diferente
     * do responsável.
     * 
     * @param {object} widget widget de conversão ("convertLeadInProspect").
    */
    this.getNewResponsibleOperatorForTheLead = function(widget){
        
        var leadWidgetCurrentRow = widget.parent.parent.currentRow;
        var conversionWidgetCurrentRow = widget.currentRow;
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        if(leadWidgetCurrentRow.NRPARCPROPRI !== loggedOperatorInfos.NRPARCNEGOCIO){
            conversionWidgetCurrentRow.NEWNRPARCPROPRI = loggedOperatorInfos.NRPARCNEGOCIO;
        }
        
    };
    
    this.atualizarAcoes = function(widget) {
        var status = widget.currentRow.IDSTATUSCAN;
        
        if(status == '3') { //QUALIFICADO
            widget.getAction('QUALIFY').isVisible = false;
            widget.getAction('DISQUALIFY').isVisible = true;
        } else if(status == '4') { //DESQUALIFICADO
            widget.getAction('QUALIFY').isVisible = true;
            widget.getAction('DISQUALIFY').isVisible = false;
        } else { //ABERTO
            widget.getAction('QUALIFY').isVisible = true;
            widget.getAction('DISQUALIFY').isVisible = true;
        }
    };
    
    /*
    *   Converte lead já preparado e verificado
    */
    this.convertValidLead = function(widget, currentRow, loggedOperatorInfos) {
        ScreenService.closePopup();
    
        currentRow.CEP = currentRow.NRCEPENDERECO;
        currentRow.NUMERO = currentRow.NRIMOVELENDERECO;
        currentRow.ENDERECO = currentRow.DSENDERECO;
        currentRow.COMPLEMENTO = currentRow.DSCOMPLEENDERECO;
    
        var parametroRestEngine = {
            'requestType': 'Row',
            'row': currentRow
        };
    
        var griWidget = templateManager.container.getWidget('gridLead');
        var evolWidget = templateManager.container.getWidget('evolucao');
        var nrparcnegocio = currentRow.NRPARCNEGOCIO;
        var parcResp = widget.parent.parent.currentRow.NRPARCPROPRI;
    
        restEngine.post('/insertProspect', parametroRestEngine,
            function(success) {
                if (success.dataset && success.dataset.error) {
                    ScreenService.closeSwipe(0);
                    widget.parent.parent.activate();
                    ScreenService.showMessage(success.dataset.error[0], "ERROR");
                } else {
                    //BEGIN RD Station
                    var contactWidgets = templateManager.container.getWidget('WDGT_INTERLOCUTOR');
                    contactWidgets.dataSourceFilter.forEach(function(filter) {
                        if (filter.name === 'NRPARCNEGOCIO')
                            filter.value = widget.currentRow.NRPARCNEGOCIO;
                    });
                    contactWidgets.reload().then(function() {
                        if (!Util.isEmptyOrBlank(contactWidgets.dataSource.data)) {
                            contactWidgets.dataSource.data.forEach(function(contact) {
                                restEngine.post('/IntegracaoRDStation/feedBackConversion', {
                                    'requestType': 'Row',
                                    'row': {
                                        EVENT_NAME: 'Cadastro convertido em prospect no CRM',
                                        EMAIL: contact['EMAILINTERLOC']
                                    }
                                }).then(function() {
                                    restEngine.post('/IntegracaoRDStation/changeFunnel', {
                                        'requestType': 'Row',
                                        'row': {
                                            FUNNEL: (currentRow.IDSTATUSCAN === "3") ? 'Qualified Lead' : 'Lead',
                                            EMAIL: contact['EMAILINTERLOC']
                                        }
                                    });
                                });
    
                            });
                        }
                    });
    
                    if (!Util.isEmptyOrBlank(griWidget.PARCUPDATE)) {
                        var rows = [];
    
                        griWidget.PARCUPDATE.forEach(function(parcnegocio, index) {
                            var row = {
                                NRPARCNEGOCIO: null,
                                NRORG: getLocalVar('CRM_NRORGTRAB'),
                                CRM_NRORGTRAB: getLocalVar('CRM_NRORGTRABALHO'),
                                DTINCLUSAO: moment().format('DD/MM/YYYY HH:mm:ss'),
                                CDOPERADOR: getLocalVar('CRM_CDOPERADOR'),
                                CDOPEREVOL: evolWidget.currentRow.CDOPEREVOL
                            };
    
                            row.NRPARCNEGOCIO = parcnegocio.NRPARCNEGOCIO;
                            rows.push(row);
                        });
    
                        restEngine.post('/setRelationshipPartnerStatus', {
                            'requestType': 'Row',
                            'row': rows
                        }).then(function(relation) {
                            if (relation.dataset && relation.dataset.error) {
                                ScreenService.showMessage(relation.dataset.error[0], "ERROR");
                            }
                        });
                    }
    
                    //END RD Station
                    ScreenService.successNotification('Lead convertido com sucesso!');
                    this.saveEvolucao(templateManager.evolutionWidget).then(function() {
                        ScreenService.closeSwipe(0).then(function() {
    
                            widget.parent.parent.activate();
                            CRM_Utilities.reloadGridInViewMode(widget.getParent());
                        }.bind(this));
                    }.bind(this));
                    if (templateManager.evolutionWidget.currentRow.IDENVIAEMAIL !== 'S' || Util.isEmptyOrBlank(templateManager.evolutionWidget.currentRow.NRSEQINTERLOCUTOR)) {
                        this.callRedirectForProspect(widget, parcResp, nrparcnegocio);
                    }
                }
            }.bind(this), undefined,
            function(error) {
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
            }
        );
    };
    /**
     * Procedimento para obrigar o usuário a
     * realizar uma evolução antes de converter
     * um lead em prospect.
     * 
     * @param {object} widget principal da tela de
     * lead.
    */
    this.openEvolutionSwipe = function(widget){
        var currentRow = widget.currentRow;
        var evolutionWidget = templateManager.container.getWidget('evolucao');

        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                if(widget.currentRow.IDSTATUSCAN === "3"){
                    this.verificaParametrizacaoProspect(widget.currentRow).then(function(response){
                            var excedeuLimite = response.dataset.DADOS.EXCEDEULIMITE;
                            if(!excedeuLimite) {
                                widget.openTab('evolucao');
                                ScreenService.closePopup();
                                
                                evolutionWidget.REALIZARCONVERCAO = true;
                                
                                setTimeout(function() {    
                                    this.evolucaoNewRow();
                                }.bind(this), 500);
                            }else{
                                var quantidadeProspects = response.dataset.DADOS.QUANTIDADE;
                                var limiteProspects = response.dataset.DADOS.LIMITE;
                                ScreenService.showMessage('Operação bloqueada! <br><br> Número máximo de prospects excedido. <br> Você possui: '+quantidadeProspects+' Prospects.<br> O limite de prospects por operador é: '+limiteProspects);
                            }
                        }.bind(this)
                    );
                }else{
                    ScreenService.showMessage("Lead não qualificado.");
                }
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    };
    
     /**
     * Verifica se o número de prospects daquele operador
     * excede o limite predefino na parametrização
     * 
     * @param {object} widget widget de evolução
    */
    this.verificaParametrizacaoProspect = function(currentRow) {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.NRPARCNEGOCIOOPER = loggedOperatorInfos.NRPARCNEGOCIO;
        
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        return restEngine.post('/verificaParametrizacaoProspect', paramsRestEngine);
    };
    
    /**
     * Procedimento para limpar o indicador
     * de conversão.
     * 
     * @param {object} widget widget de evolução.
    */
    this.cleanConversionIndicator = function(widget) {
        
        if(Boolean(widget.REALIZARCONVERCAO)) {
            delete widget.REALIZARCONVERCAO;
        }
        
    };
    
    /**
     * Procedimento para direcionar o sistema
     * para o ambiente de conversão após a realização de uma evolução.
     * 
     * @param {object} widget widget de evolução.
    */
    this.convertLeadAfterEvolution = function(widget) {
        
        if(widget.REALIZARCONVERCAO) {
            this.cleanConversionIndicator(widget);
            this.openSwipeConvertLeadInProspect(widget.parent.parent);
        }  
        
    };
    
    /**
     * Procedimento para abrir a tela de prospect
     * no sistema.
     * 
     * @param {object} widget widget de conversão.
    */
    this.openProspectWindowWithFilterByConvertedLead = function(widget) {
        
        ScreenService.openWindow('product#ger45000_prospect').then(function() {
            
            var prospectWidget = templateManager.container.getWidget('gridProspect');
            this.setProspectWidgetFilterByConvertedLead(widget, prospectWidget);
            prospectWidget.reload().then(function() {
                ScreenService.closePopup(true);
            });
            
        }.bind(this));
        
    };
    
    /**
     * Procedimento para setar a widget de prospect
     * pelo lead que está sendo convertido em caso.
     * 
     * @param {object} conversionWidget widget de conversão.
     * 
     * @param {object} prospectWidget widget principal da tela
     * de prospect.
    */
    this.setProspectWidgetFilterByConvertedLead = function(conversionWidget, prospectWidget) {
        
        var conversionWidgetCurrentRow = conversionWidget.currentRow;
        var tipoOperador = templateManager.LOGGEDOPERATOR.IDTPOPERADOR || 'E';
        var mainWid = conversionWidget.parent.parent;
        
        var filter = [
            {
                name: "NRPARCNEGOCIO",
                operator: "=",
                static: true,
                value: mainWid.currentRow.NRPARCNEGOCIO
            },
            {
                name: "NRORG",
                operator: "=",
                static: true,
                value: getLocalVar('CRM_NRORG')
            },
            {
                name: "IDTPOPERADOR",
                operator: "=",
                static: true,
                value: tipoOperador
            }
        ];
        
        prospectWidget.dataSourceFilter = filter;
    };
    
    this.openSwipeConvertLeadInProspect = function(widget) {
        var convertWidget = templateManager.container.getWidget('convertLeadInProspect');
        
        ScreenService.closeSwipe().then(function() {
            widget.view();
            ScreenService.openSwipe(convertWidget).then(function() {
                convertWidget.activate();
                convertWidget.newRow();
                convertWidget.redraw();
                var currentRow = convertWidget.currentRow;
            
                currentRow.NMCANDIDATO = convertWidget.parent.parent.currentRow.NMCANDIDATO;
                currentRow.NMFANTCAN = convertWidget.parent.parent.currentRow.NMFANTCAN;
                
                currentRow.DATAFUNDACAO = "";
                
                currentRow.DSENDERECO = convertWidget.parent.parent.currentRow.DSENDERECO;
                currentRow.NRIMOVELENDERECO = parseInt(convertWidget.parent.parent.currentRow.NRIMOVELENDERECO);
                currentRow.NRCEPENDERECO = convertWidget.parent.parent.currentRow.NRCEPENDERECO;
                currentRow.DSCOMPLEENDERECO = convertWidget.parent.parent.currentRow.DSCOMPLEENDERECO;
                currentRow.LATITUDE = "";
                currentRow.LONGITUDE = "";
                currentRow.CDCARGOINTERLOC = "";
                currentRow.DSCARGINPROS = "";
                currentRow.DTNASCIFUNDPARC = convertWidget.parent.parent.currentRow.DTNASCIFUNDPARC;
                currentRow.NRORG = templateManager.LOGGEDOPERATOR.NRORG;
                currentRow.NRPARCNEGOCIO = widget.currentRow.NRPARCNEGOCIO;
                currentRow.IDATIVO = 'S';
                currentRow.CDOPERULTATU = widget.currentRow.CDOPERULTATU;
                currentRow.PARCORIGINAL = widget.currentRow.NRPARCNEGOCIO;
                currentRow.__is_new = false;
                
                this.getLocalFound(convertWidget.parent.parent.currentRow);
                this.getLeadInforForConversionToProspect(widget);
                this.requireInterlocutorFields(convertWidget);
                this.validaInscricao(convertWidget, false, true, false);
                    
            }.bind(this));
        }.bind(this));
    };
    
    /**
     * Verifica se o prospect é pessoa jurídica ou física, ou se já possui interlocutor
     * obriga o usuário a inserir um interlocutor em caso de pesoa jurídica sem interlocutor
     * 
     * @param {object} widget widget de conversão de lead.
    */
    this.requireInterlocutorFields = function(widget) {
        
        var interlocutorField = widget.getField('NMINTERLOCUTOR');
        var interlocutorPhoneField = widget.getField('DSTELEFONEINTERLOCUTOR');
        var inscription = widget.currentRow.NRINSJURCAN.replace(/[^0-9]/g, '');
        var interlocutorEmailField = widget.getField('DSEMAILINTERLOCUTOR');
        
        if((inscription.length === 11) || widget.currentRow.IDTPIJURCAN === 'F' || this.getInterlocutorLead(widget)) {
            delete interlocutorField.validations.required; 
            delete interlocutorPhoneField.validations.required; 
            delete interlocutorEmailField.validations.required;
        }else{
            interlocutorField.validations["required"] = true; 
            interlocutorPhoneField.validations["required"] = true;
            interlocutorEmailField.validations["required"] = true;
        }
        
    };
    
    this.getInterlocutorLead = function(widget) {
        var widgetInterlocutor = templateManager.container.getWidget('WDGT_INTERLOCUTOR');
        var interlocutores = widgetInterlocutor.dataSource.data;
        
        if(Util.isEmptyOrBlank(interlocutores)) {
            widgetInterlocutor.reload().then(function() {
                interlocutores = widgetInterlocutor.dataSource.data;
                if(Util.isEmptyOrBlank(interlocutores))
                    return false;
                else
                    return true;
            });
        }else{
            return true;
        }
    }
    
    this.openSwipeFundirParceiro = function() {

        var widget = templateManager.container.getWidget('FUNDIR');
        
        widget.activate();
        widget.newRow();
        
        ScreenService.openSwipe(widget);
        
    };
    
    this.autofillData = function(widget, fromProspect) {

        var currentRow = widget.currentRow;
        if(fromProspect) {
            currentRow.NUMBERINSC = currentRow.NRINSJURPROS ? currentRow.NRINSJURPROS.replace(/[^0-9]/g,'') : "";    
        }else if(widget.name === 'gridCliente') {
            currentRow.NUMBERINSC = currentRow.NRINSJURCLIE ? currentRow.NRINSJURCLIE.replace(/[^0-9]/g,'') : "";
        } else {
            if(currentRow.NRINSJURCAN.match(/^[A-Za-z]([0-9]){8}$/gm)){
                currentRow.NUMBERINSC = currentRow.NRINSJURCAN;
            }else{
                currentRow.NUMBERINSC = currentRow.NRINSJURCAN ? currentRow.NRINSJURCAN.replace(/[^0-9]/g,'') : "";
            }
        }
        
        if(currentRow.NUMBERINSC.length === 14) {
        
            ScreenService.confirmMessage("Deseja buscar as informações pelo CNPJ?", "question", function() {
        
                var parametroRestEngine = {
                    'requestType':'Row',
                    'row': {'NUMBERINSC': currentRow.NUMBERINSC}
                };
                
                restEngine.post('/consultaRF', parametroRestEngine,
                    function(success) {
                        var dadosReceitaFederal = success.dataset.CONSULTA;
                        if(Boolean(dadosReceitaFederal.Mensagem) && dadosReceitaFederal.Mensagem === 'Saldo Insuficiente ou Contrato com Pendencias') {
                            ScreenService.showMessage(dadosReceitaFederal.Mensagem);
                        }
                        else if(dadosReceitaFederal.SituacaoRFB !== "ATIVA") {
                            ScreenService.showMessage("Lead Inativo na receita.");
                        }else{
                            self.fillWithCurrentRowReturnedValues(widget, dadosReceitaFederal);
                            ScreenService.showMessage("Consulta realizada com sucesso.");
                        }
                    }, undefined, 
                    function(error) {
                        console.log(error);
                    }, null, 3000000
                );
                ScreenService.closePopup();
            });
        }
        
    };
    
    this.fillWithCurrentRowReturnedValues = function(widget, returnedValues) {
        
        
        var currentRow = widget.currentRow;
        
        if (widget.getField('NMCANDIDATO')) {
            currentRow.NMCANDIDATO = returnedValues.RazaoSocial;
            currentRow.NMFANTCAN = returnedValues.NomeFantasia;
        } else if(widget.name === 'gridCliente') {
            currentRow.NMRAZSOCCLIE = returnedValues.RazaoSocial;
            currentRow.NMFANTCLIE = returnedValues.NomeFantasia;
        } else {
            currentRow.NMRAZSOCPROS = returnedValues.RazaoSocial;
            currentRow.NMFANTPROS = returnedValues.NomeFantasia;
        }
        
        currentRow.NMPAIS = "Brasil";
        currentRow.CDPAIS = "0055";
        
        currentRow.NRIMOVELENDERECO = parseInt(returnedValues.Enderecos.Numero);
        currentRow.DSCOMPLEENDERECO = returnedValues.Enderecos.Complemento;
        currentRow.DSENDERECO = returnedValues.Enderecos.Logradouro;
        currentRow.NRCEPENDERECO = returnedValues.Enderecos.CEP;

        currentRow.DSTELEFONECAN = (currentRow.DSTELEFONECAN === "") ? returnedValues.Telefone : currentRow.DSTELEFONECAN;
        if((currentRow.DSEMAILCAN === "") && typeof returnedValues.Email !== "undefined") {
            currentRow.DSEMAILCAN = returnedValues.Email;
        }
        currentRow.DATAFUNDACAO = returnedValues.DataFundacao;
        currentRow.LATITUDE = returnedValues.Enderecos.GeoLocalizacao.Latitude;
        currentRow.LONGITUDE = returnedValues.Enderecos.GeoLocalizacao.Longitude;
        
        this.localizationFill(currentRow, returnedValues);
        this.getLocalFound(currentRow);        
        
        widget.getField('NMESTADO').readOnly    = false;
        widget.getField('NMMUNICIPIO').readOnly = false;
        
        if(widget.getField('NMBAIRRO')) {
            widget.getField('NMBAIRRO').readOnly = false;
        } else {
            widget.getField('NMBAIRROCAN').readOnly = false;
        }
    };
    
    this.localizationFill = function(currentRow ,values) {
        
        var parametroRestEngine = {
            'requestType':'Row',
            'row': {'RESULTCONSUL': values}
        };

        restEngine.post('/ConfirmationLocation', parametroRestEngine,
            function(success) {
                var localization = success.dataset.LOCALIZACAO;
                currentRow.NMESTADO = localization[0].NMESTADO;
                currentRow.SGESTADO = localization[0].SGESTADO;
                currentRow.NMMUNICIPIO = localization[1].NMMUNICIPIO;
                currentRow.CDMUNICIPIO = localization[1].CDMUNICIPIO;
                currentRow.NMBAIRRO = (!Util.isUndefined(localization[2].NMBAIRRO)) ? localization[2].NMBAIRRO : values.Enderecos.BAIRRO;
                currentRow.NMBAIRROCAN = (!Util.isUndefined(localization[2].NMBAIRRO)) ? localization[2].NMBAIRRO : values.Enderecos.BAIRRO;
                currentRow.CDBAIRRO = (!Util.isUndefined(localization[2].CDBAIRRO)) ? localization[2].CDBAIRRO : null;
                
            }, undefined, 
            function(error) {
                ScreenService.showMessage("Operação não concluida, Tente Novamente");
            }
        ); 
        
    };
    
    this.CancelForm = function() {
        var widget = templateManager.container.getActiveWidget();
        
        this.cleanEvolutionWidgetInTemplateManager();
        
        ScreenService.closeSwipe().then(function() {
            self.cleanWidgetFields(widget);
            widget.parent.parent.view();
            widget.parent.parent.activate();
        });
    };
    
    this.inserNewTask = function(widget) {
        var currentRow = widget.currentRow;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.NRPARCNEGOCIO = loggedOperatorInfos.NRPARCNEGOCIO;
        currentRow.NMPARCRESP = loggedOperatorInfos.NMOPERADOR;
        currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
    };
    
    this.convertValidLead = function(widget, currentRow, loggedOperatorInfos) {
        ScreenService.closePopup();
    
        currentRow.CEP = currentRow.NRCEPENDERECO;
        currentRow.NUMERO = currentRow.NRIMOVELENDERECO;
        currentRow.ENDERECO = currentRow.DSENDERECO;
        currentRow.COMPLEMENTO = currentRow.DSCOMPLEENDERECO;
    
        var parametroRestEngine = {
            'requestType': 'Row',
            'row': currentRow
        };
    
        var griWidget = templateManager.container.getWidget('gridLead');
        var evolWidget = templateManager.container.getWidget('evolucao');
        var nrparcnegocio = currentRow.NRPARCNEGOCIO;
        var parcResp = widget.parent.parent.currentRow.NRPARCPROPRI;
    
        restEngine.post('/insertProspect', parametroRestEngine,
            function(success) {
                if (success.dataset && success.dataset.error) {
                    ScreenService.closeSwipe(0);
                    widget.parent.parent.activate();
                    ScreenService.showMessage(success.dataset.error[0], "ERROR");
                } else {
                    //BEGIN RD Station
                    var contactWidgets = templateManager.container.getWidget('WDGT_INTERLOCUTOR');
                    contactWidgets.dataSourceFilter.forEach(function(filter) {
                        if (filter.name === 'NRPARCNEGOCIO')
                            filter.value = widget.currentRow.NRPARCNEGOCIO;
                    });
                    contactWidgets.reload().then(function() {
                        if (!Util.isEmptyOrBlank(contactWidgets.dataSource.data)) {
                            contactWidgets.dataSource.data.forEach(function(contact) {
                                restEngine.post('/IntegracaoRDStation/feedBackConversion', {
                                    'requestType': 'Row',
                                    'row': {
                                        EVENT_NAME: 'Cadastro convertido em prospect no CRM',
                                        EMAIL: contact['EMAILINTERLOC']
                                    }
                                }).then(function() {
                                    restEngine.post('/IntegracaoRDStation/changeFunnel', {
                                        'requestType': 'Row',
                                        'row': {
                                            FUNNEL: (currentRow.IDSTATUSCAN === "3") ? 'Qualified Lead' : 'Lead',
                                            EMAIL: contact['EMAILINTERLOC']
                                        }
                                    });
                                });
    
                            });
                        }
                    });
    
                    if (!Util.isEmptyOrBlank(griWidget.PARCUPDATE)) {
                        var rows = [];
    
                        griWidget.PARCUPDATE.forEach(function(parcnegocio, index) {
                            var row = {
                                NRPARCNEGOCIO: null,
                                NRORG: getLocalVar('CRM_NRORGTRAB'),
                                CRM_NRORGTRAB: getLocalVar('CRM_NRORGTRABALHO'),
                                DTINCLUSAO: moment().format('DD/MM/YYYY HH:mm:ss'),
                                CDOPERADOR: getLocalVar('CRM_CDOPERADOR'),
                                CDOPEREVOL: evolWidget.currentRow.CDOPEREVOL
                            };
    
                            row.NRPARCNEGOCIO = parcnegocio.NRPARCNEGOCIO;
                            rows.push(row);
                        });
    
                        restEngine.post('/setRelationshipPartnerStatus', {
                            'requestType': 'Row',
                            'row': rows
                        }).then(function(relation) {
                            if (relation.dataset && relation.dataset.error) {
                                ScreenService.showMessage(relation.dataset.error[0], "ERROR");
                            }
                        });
                    }
    
                    //END RD Station
                    ScreenService.successNotification('Lead convertido com sucesso!');
                    this.saveEvolucao(templateManager.evolutionWidget).then(function() {
                        ScreenService.closeSwipe(0).then(function() {
    
                            widget.parent.parent.activate();
                            CRM_Utilities.reloadGridInViewMode(widget.getParent());
                        }.bind(this));
                    }.bind(this));
                    if (templateManager.evolutionWidget.currentRow.IDENVIAEMAIL !== 'S' || Util.isEmptyOrBlank(templateManager.evolutionWidget.currentRow.NRSEQINTERLOCUTOR)) {
                        this.callRedirectForProspect(widget, parcResp, nrparcnegocio);
                    }
                }
            }.bind(this), undefined,
            function(error) {
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
            }
        );
    };
    
    self.editTask = function() {
        var widget = templateManager.container.getActiveWidget();
        var currentRow = widget.currentRow;
        
        currentRow.NRPARCNEGOCIO = widget.getParent().currentRow.NRPARCNEGOCIO;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                General.widgetEdit(widget);
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    };

    function formatCEP(cepSemMascara, formato) {
        const regex = new RegExp(formato.regex, 'g');
        return cepSemMascara.replace(regex, formato.formato);
    }

    this.validateMask = function(field) {
        var nrCepEndereco = field.currentRow.NRCEPENDERECO;
    
        if (!Util.isEmptyOrBlank(nrCepEndereco)) {
            var cepSemMascara = nrCepEndereco.replace(/\D/g, '');
            var formatos = [
                { length: 4, regex: /^(\d{2})(\d{2})$/, formato: '$1$2' },
                { length: 5, regex: /^(\d{2})(\d{3})$/, formato: '$1$2' },
                { length: 6, regex: /^(\d{3})(\d{3})$/, formato: '$1-$2' },
                { length: 7, regex: /^(\d{3})(\d{4})$/, formato: '$1-$2' },
                { length: 8, regex: /^(\d{2})(\d{3})(\d{3})$/, formato: '$1.$2-$3' }
            ];
    
            var formatoEncontrado = null;
    
            for (var i = 0; i < formatos.length; i++) {
                var formato = formatos[i];
                if (nrCepEndereco.length === formato.length) {
                    formatoEncontrado = formato;
                    break;
                }
            }
    
            if (formatoEncontrado) {
                field.currentRow.NRCEPENDERECO = formatCEP(cepSemMascara, formatoEncontrado);
                field.reload();
            }
        }
    };

    function detectCountryCode(phoneWithoutMask) {
        const countryCodes = [
            { key: '1', value: 'US' },   // United States --Tem Validação
            { key: '1', value: 'CA' },   // Canada --Tem Validação
            { key: '1', value: 'DO' },   // Dominican Republic --Tem Validação
            { key: '1', value: 'JM' },   // Jamaica --Tem Validação
            { key: '1', value: 'PR' },   // Puerto Rico --Tem Validação
            { key: '51', value: 'PE' },  // Peru
            { key: '504', value: 'HN' }, // Honduras
            { key: '597', value: 'SR' }, // Suriname
            { key: '592', value: 'GY' }, // Guyana
            { key: '501', value: 'BZ' }, // Belize
            { key: '34', value: 'ES' },  // Spain --Tem Validação
            { key: '351', value: 'PT' }, // Portugal
            { key: '39', value: 'IT' },  // Italy --Tem Validação
            { key: '595', value: 'PY' }, // Paraguay
            { key: '58', value: 'VE' },  // Venezuela
            { key: '54', value: 'AR' },  // Argentina --Tem Validação
            { key: '55', value: 'BR' },  // Brazil --Tem Validação
            { key: '56', value: 'CL' },  // Chile
            { key: '33', value: 'FR' },  // France --Tem Validação
            { key: '46', value: 'SE' },  // Sweden
            { key: '44', value: 'UK' },  // United Kingdom --Tem Validação
            { key: '57', value: 'CO' },  // Colombia --Tem Validação
            { key: '52', value: 'MX' },  // Mexico --Tem Validação
            { key: '591', value: 'BO' }, // Bolivia
            { key: '598', value: 'UY' }, // Uruguay
            { key: '218', value: 'LY' }, // Libya
            { key: '244', value: 'AO' }, // Angola 
            { key: '213', value: 'DZ' }, // Algeria
            { key: '507', value: 'PA' }, // Panama
            { key: '234', value: 'NG' }, // Nigeria --Tem Validação
            { key: '27', value: 'ZA' },  // South Africa --Tem Validação
            { key: '971', value: 'AE' }, // United Arab Emirates --Tem Validação
            { key: '297', value: 'AW' }, // Aruba
            { key: '506', value: 'CR' }, // Costa Rica
            { key: '62', value: 'ID' },  // Indonesia
            { key: '966', value: 'SA' }, // Saudi Arabia --Tem Validação
            { key: '61', value: 'AU' },  // Australia --Tem Validação
            { key: '356', value: 'MT' }, // Malta
            { key: '248', value: 'SC' }, // Seychelles
            { key: '353', value: 'IE' }, // Ireland
            { key: '91', value: 'IN' },  // India --Tem Validação
            { key: '679', value: 'FJ' }, // Fiji
            { key: '254', value: 'KE' }, // Kenya --Tem Validação
            { key: '66', value: 'TH' },  // Thailand
            { key: '84', value: 'VN' },  // Vietnam
            { key: '86', value: 'CN' },  // China --Tem Validação
            { key: '49', value: 'DE' },  // Germany --Tem Validação
            { key: '43', value: 'AT' },  // Austria
            { key: '20', value: 'EG' },  // Egypt --Tem Validação
            { key: '81', value: 'JP' },  // Japan --Tem Validação
            { key: '41', value: 'CH' },  // Switzerland
            { key: '94', value: 'LK' },  // Sri Lanka
            { key: '65', value: 'SG' },  // Singapore --Tem Validação
            { key: '31', value: 'NL' },  // Netherlands
            { key: '40', value: 'RO' },  // Romania
            { key: '852', value: 'HK' }, // Hong Kong --Tem Validação
            { key: '593', value: 'EC' }, // Ecuador
            { key: '961', value: 'LB' }, // Lebanon
            { key: '503', value: 'SV' }, // El Salvador 
            { key: '502', value: 'GT' }, // Guatemala
            { key: '972', value: 'IL' }, // Israel --Tem Validação
            { key: '82', value: 'KR' },  // Coreia do Sul --Tem Validação
            { key: '886', value: 'TW' }, // Taiwan --Tem Validação
        ];
    
        var countryCodeInfo = null;

        for (var i = 0; i < countryCodes.length; i++) {
            var entry = countryCodes[i];
            if (phoneWithoutMask.startsWith(entry.key)) {
                countryCodeInfo = entry;
                break;
            }
        }
    
        return countryCodeInfo;

    }

    function formatPhoneNumber(phoneWithoutMask, countryCode, country) {
        var format = {};

        if (phoneWithoutMask && phoneWithoutMask.length) {
            switch (true) {
                case country === '0055' && countryCode === 'BR':
                    switch (Util.isEmptyOrBlank(phoneWithoutMask)) {
                        case phoneWithoutMask.length === 10:
                            format = { regex: /^(\d{2})(\d{4})(\d{4})$/, format: '($1) $2-$3' };
                            break;
                        case phoneWithoutMask.length === 11:
                            format = { regex: /^(\d{2})(\d{5})(\d{4})$/, format: '($1) $2-$3' };
                            break;
                        case phoneWithoutMask.length === 12:
                            format = { regex: /^(\d{2})(\d{2})(\d{4})(\d{4})$/, format: '+$1 ($2) $3-$4' };
                            break;
                        case phoneWithoutMask.length === 13:
                            format = { regex: /^(\d{2})(\d{2})(\d{5})(\d{4})$/, format: '+$1 ($2) $3-$4' };
                            break;
                        default:
                            return phoneWithoutMask;
                    }
                    break;
                case phoneWithoutMask.length === 11 && (countryCode.value === 'US' || countryCode.value === 'CA' || countryCode.value === 'DO' || countryCode.value === 'JM' || countryCode.value === 'PR'):
                    format = { regex: /^(\d{1})(\d{3})(\d{3})(\d{4})$/, format: '+$1 ($2) $3-$4' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'UK':
                    format = { regex: /^(\d{2})(\d{2})(\d{4})(\d{4})$/, format: '+($1) $2 $3-$4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'AU':
                    format = { regex: /^(\d{2})(\d{4})(\d{4})$/, format: '+$1 $2 $3' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'IN':
                    format = { regex: /^(\d{2})(\d{2})(\d{4})(\d{4})$/, format: '+$1 $2 $3 $4' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'CN':
                    format = { regex: /^(\d{3})(\d{3})(\d{4})(\d{2})$/, format: '+$1 $2 $3 $4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'JP':
                    format = { regex: /^(\d{2})(\d{3})(\d{4})$/, format: '+$1 $2 $3' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'DE':
                    format = { regex: /^(\d{2})(\d{2})(\d{4})(\d{4})$/, format: '+$1 $2 $3 $4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'FR':
                    format = { regex: /^(\d{2})(\d{1})(\d{2})(\d{2})(\d{2})$/, format: '+$1 $2 $3 $4 $5' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'MX':
                    format = { regex: /^(\d{2})(\d{2})(\d{4})(\d{4})$/, format: '+$1 $2 $3 $4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'RU':
                    format = { regex: /^(\d{1})(\d{3})(\d{3})(\d{2})(\d{2})$/, format: '+$1 ($2) $3-$4-$5' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'IT':
                    format = { regex: /^(\d{2})(\d{2})(\d{4})(\d{4})$/, format: '+$1 $2 $3 $4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'ES':
                    format = { regex: /^(\d{2})(\d{3})(\d{2})(\d{2})(\d{2})$/, format: '+$1 $2 $3 $4 $5' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'IL':
                    format = { regex: /^(\d{3})(\d{2})(\d{3})(\d{4})$/, format: '+$1 ($2) $3-$4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'AE':
                    format = { regex: /^(\d{3})(\d{2})(\d{3})(\d{4})$/, format: '+$1 ($2) $3 $4' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'SA':
                    format = { regex: /^(\d{3})(\d{2})(\d{3})(\d{4})$/, format: '+$1 ($2) $3 $4' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'KR':
                    format = { regex: /^(\d{2})(\d{2})(\d{4})(\d{4})$/, format: '+$1 ($2) $3-$4' };
                    break;
                case phoneWithoutMask.length === 10 && countryCode.value === 'SG':
                    format = { regex: /^(\d{2})(\d{4})(\d{4})$/, format: '+$1 $2-$3' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'HK':
                    format = { regex: /^(\d{3})(\d{4})(\d{4})$/, format: '+$1 $2 $3' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'TW':
                    format = { regex: /^(\d{3})(\d{4})(\d{4})$/, format: '+$1 $2 $3' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'AR':
                    format = { regex: /^(\d{2})(\d{3})(\d{3})(\d{4})$/, format: '+$1 ($2) $3-$4' };
                    break;
                case phoneWithoutMask.length === 10 && countryCode.value === 'CO':
                    format = { regex: /^(\d{1})(\d{3})(\d{4})$/, format: '+$1 $2 $3' };
                    break;
                case phoneWithoutMask.length === 10 && countryCode.value === 'NZ':
                    format = { regex: /^(\d{1})(\d{3})(\d{4})$/, format: '+$1 $2 $3' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'ZA':
                    format = { regex: /^(\d{2})(\d{3})(\d{4})$/, format: '+$1 $2 $3 $4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'NG':
                    format = { regex: /^(\d{3})(\d{1})(\d{4})(\d{4})$/, format: '+$1 $2 $3 $4' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'EG':
                    format = { regex: /^(\d{2})(\d{2})(\d{4})(\d{4})$/, format: '+$1 $2 $3 $4' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'KE':
                    format = { regex: /^(\d{3})(\d{2})(\d{4})(\d{4})$/, format: '+$1 $2 $3 $4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'PE':
                    format = { regex: /^(\d{2})(\d{3})(\d{3})(\d{3})$/, format: '+$1 $2 $3-$4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'HN':
                    format = { regex: /^(\d{3})(\d{4})(\d{4})$/, format: '+$1 $2-$3' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'GY' || countryCode.value === 'BZ':
                    format = { regex: /^(\d{3})(\d{3})(\d{4})$/, format: '+$1 $2-$3' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'PT' || countryCode.value === 'PY' || countryCode.value === 'AO':
                    format = { regex: /^(\d{3})(\d{3})(\d{3})(\d{3})$/, format: '+$1 ($2) $3 $4' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'VE':
                    format = { regex: /^(\d{2})(\d{3})(\d{3})(\d{4})$/, format: '+$1 ($2) $3 $4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'CL':
                    format = { regex: /^(\d{2})(\d{1})(\d{4})(\d{4})$/, format: '+$1 ($2) $3 $4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'SE':
                    format = { regex: /^(\d{2})(\d{2})(\d{3})(\d{2})(\d{2})$/, format: '+$1 ($2) $3 $4 $5' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'BO' || countryCode.value === 'GT':
                    format = { regex: /^(\d{3})(\d{4})(\d{4})$/, format: '+$1 $2 $3' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'UY':
                    format = { regex: /^(\d{3})(\d{2})(\d{3})(\d{3})$/, format: '+$1 ($2) $3 $4' };
                    break;
                case phoneWithoutMask.length === 9 && countryCode.value === 'SR':
                    format = { regex: /^(\d{3})(\d{3})(\d{3})$/, format: '+$1 $2-$3' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'LY':
                    format = { regex: /^(\d{3})(\d{2})(\d{3})(\d{4})$/, format: '+$1 ($2) $3 $4' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'DZ':
                    format = { regex: /^(\d{3})(\d{4})(\d{3})(\d{2})$/, format: '+$1 ($2) $3 $4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'PA' || countryCode.value === 'CR' || countryCode.value === 'MT' || countryCode.value === 'SV':
                    format = { regex: /^(\d{3})(\d{4})(\d{4})$/, format: '+$1 $2-$3' };
                    break;
                case phoneWithoutMask.length === 13 && countryCode.value === 'ID':
                    format = { regex: /^(\d{2})(\d{3})(\d{4})(\d{4})$/, format: '+$1 $2-$3-$4' };
                    break;
                case phoneWithoutMask.length === 10 && countryCode.value === 'SC':
                    format = { regex: /^(\d{3})(\d{1})(\d{3})(\d{3})$/, format: '+$1 $2 $3 $4' };
                    break;
                case phoneWithoutMask.length === 10 && countryCode.value === 'FJ':
                    format = { regex: /^(\d{3})(\d{3})(\d{4})$/, format: '+$1 $2-$3' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'IE':
                    format = { regex: /^(\d{3})(\d{2})(\d{3})(\d{4})$/, format: '+$1 $2 $3 $4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'TH':
                    format = { regex: /^(\d{2})(\d{2})(\d{3})(\d{4})$/, format: '+$1 $2-$3-$4' };
                    break;
                case phoneWithoutMask.length === 10 && countryCode.value === 'AW':
                    format = { regex: /^(\d{3})(\d{3})(\d{4})$/, format: '+$1 $2-$3' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'VN' || countryCode.value === 'LK':
                    format = { regex: /^(\d{2})(\d{2})(\d{3})(\d{4})$/, format: '+$1 ($2) $3-$4' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'AT':
                    format = { regex: /^(\d{2})(\d{3})(\d{7})$/, format: '+$1 ($2) $3' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'CH':
                    format = { regex: /^(\d{2})(\d{2})(\d{3})(\d{2})(\d{2})$/, format: '+$1 ($2) $3-$4-$5' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'NL':
                    format = { regex: /^(\d{2})(\d{1})(\d{8})$/, format: '+$1 ($2) $3' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'RO':
                    format = { regex: /^(\d{2})(\d{3})(\d{3})(\d{3})$/, format: '+$1 $2-$3-$4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'RO':
                    format = { regex: /^(\d{3})(\d{2})(\d{3})(\d{3})$/, format: '+$1 $2-$3-$4' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'EC' || countryCode.value === 'LB':
                    format = { regex: /^(\d{3})(\d{2})(\d{3})(\d{3})$/, format: '+$1 $2-$3-$4' };
                    break;
                default:
            }

            const formattedNumber = phoneWithoutMask.replace(format.regex, format.format);
            return formattedNumber;
        } else {
            return formattedNumber = "";
        }
    }

    function validateMaskPhone(field) {
        var country;
        var numberPhones = [];
    
        switch (true) {
            case field.name === "gridLead":
                country = Util.isEmptyOrBlank(field.currentRow.CDPAIS) ? '0055' : field.currentRow.CDPAIS;
                numberPhones.push(field.currentRow.DSTELEFONECAN);
                break;
            case field.name === "WDGT_INTERLOCUTOR":
                country = field.currentRow.CDPAIS === null ? '0055' : field.currentRow.CDPAIS;
                numberPhones.push(field.currentRow.NRTELEFONE1);
                numberPhones.push(field.currentRow.NRTELEFONE2);
                numberPhones.push(field.currentRow.NRTELEFONE3);
                numberPhones.push(field.currentRow.NRTELEFONE4);
                break;
        }
    
        for (var i = 0; i < numberPhones.length; i++) {
            var numberPhone = numberPhones[i];
            if (Util.isEmptyOrBlank(numberPhone)) {
                continue;
            }
    
            var phoneWithoutMask = numberPhone ? numberPhone.replace(/\D/g, '') : '';
            var countryCode = country === '0055' ? 'BR' : detectCountryCode(phoneWithoutMask);
            var formattedNumber = formatPhoneNumber(phoneWithoutMask, countryCode, country);
    
            if (formattedNumber) {
                switch (field.name) {
                    case "gridLead":
                        field.currentRow.DSTELEFONECAN = formattedNumber;
                        break;
                    case "WDGT_INTERLOCUTOR":
                        for (var j = 1; j <= 4; j++) {
                            var fieldName = "NRTELEFONE" + j;
                            field.currentRow[fieldName] = formatPhoneNumber(
                                field.currentRow[fieldName],
                                countryCode,
                                country
                            );
                        }
                        break;
                }
                field.reload();
            }
        }
    }
    
    var MESSAGES = {
        INVALID_PHONE: "O número de Telefone informado não Corresponde ao País Selecionado."
    };

    // this.validatePhoneType = function (field){

    //     const currentPhone = field.value();
    //     const currentCountry = field.widget.currentRow.CDPAIS === null ? '0055' : field.widget.currentRow.CDPAIS;
    //     const countryWithoutZeros = parseInt(currentCountry, 10).toString();
    //     const currentPhoneWhitoutMask = currentPhone.replace(/\D/g, '');
        
    //     if (!Util.isEmptyOrBlank(currentCountry) && !Util.isEmptyOrBlank(currentPhoneWhitoutMask) && currentCountry !== '0055') {
    //         const {key: codeCountry} = detectCountryCode(currentPhoneWhitoutMask);
    //         if (countryWithoutZeros !== codeCountry){
    //             ScreenService.showMessage(MESSAGES.INVALID_PHONE)
    //         }
    //     }
    // }

    /**
     * Função para buscar e setar 
     * na currentRow do endereço em cadastro,
     * o endereço retornado da pesquisa pelo CEP.
     * 
     * @param {object(widget)} widget que receberá
     * em sua currentRow, o endereço retornado.
    */
    this.searchAddress = function(widget) {
        
        var currentRow = widget.currentRow;
        const nrCepEndereco = widget.currentRow.NRCEPENDERECO;
        const cepSemMascara = nrCepEndereco.replace(/\D/g, '');
        
        if((currentRow.CEP || currentRow.NRCEPENDERECO) && cepSemMascara.length === 8) {
        
            ScreenService.confirmMessage("Deseja buscar o endereço pelo CEP informado?", "question", function() {
                
                var CEP = currentRow.CEP || currentRow.NRCEPENDERECO;
                
                Endereco.buscarCep(CEP).then(function(response) {
                    
                    var addressFound = response.dataset.ENDERECO;
                    
                    if(addressFound) {
                            
                            currentRow.NMPAIS = "Brasil";
                            currentRow.CDPAIS = "0055";
                            currentRow.NMESTADO = addressFound.NMESTADO;
                            currentRow.SGESTADO = addressFound.SGESTADO;
                            currentRow.NMMUNICIPIO = addressFound.NMMUNICIPIO;
                            currentRow.CDMUNICIPIO = addressFound.CDMUNICIPIO;
                            currentRow.NMBAIRRO = addressFound.NMBAIRRO;
                            currentRow.NMBAIRROCAN = addressFound.NMBAIRRO;
                            currentRow.CDBAIRRO = addressFound.CDBAIRRO;
                            
                            /*Controle de Readonly fields de Endereço*/
                            widget.getField('NMPAIS').readOnly = false;
                            widget.getField('NMESTADO').readOnly = false;
                            widget.getField('NMMUNICIPIO').readOnly = false;
                            if(typeof widget.getField('NMBAIRROCAN') !== "undefined") 
                                widget.getField('NMBAIRROCAN').readOnly = false;
                            if(typeof widget.getField('NMBAIRRO') !== "undefined") 
                                widget.getField('NMBAIRRO').readOnly = false;
                            
                            this.setAddressDescriptionFoundInCurrentRow(currentRow, addressFound);
                            this.getLocalFound(currentRow);
                            
                            /*TODO Encontrar um jeito melhor de fazer o autocomplete atualizar os fields para os dados da currentRow*/
                            angular.element('#footer').click();
                        
                    }else{
                        currentRow.CEP = '';
                        currentRow.NRCEPENDERECO = '';
                    }
                    
                    if(response.dataset.ERRO) {
                        ScreenService.showMessage(response.dataset.ERRO.MESSAGE, "warning");
                    }
                    
                }.bind(this)).catch(function(error) {
                    ScreenService.showMessage(error.error);
                });
                
            }.bind(this), null);
        
        }
    };
    
    this.setAddressDescriptionFoundInCurrentRow = function(currentRow, addressResult) {
        
        currentRow.DSENDERECO = (addressResult.DSENDERECO)? addressResult.DSENDERECO : '';
        currentRow.ENDERECO = (addressResult.DSENDERECO)? addressResult.DSENDERECO : '';
        
    };

    this.getLocalFound = function(currentRow) {
        
        selectedcountry = currentRow.NMPAIS;
        selectedstate = currentRow.NMESTADO;
        selectedmunicipality = currentRow.NMMUNICIPIO;
        
    };
    
    this.getLeadInforForConversionToProspect = function() {
        
        var widget = templateManager.container.getWidget("convertLeadInProspect");
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        var parentWidgetCurrentRow = widget.parent.parent.currentRow;
        var widgetCurrentRow = widget.currentRow;
        
        widgetCurrentRow.NRINSJURCAN = (parentWidgetCurrentRow.NRINSJURCAN) ? parentWidgetCurrentRow.NRINSJURCAN : "";
        widgetCurrentRow.IDTPIJURCAN = (parentWidgetCurrentRow.IDTPIJURCAN) ? parentWidgetCurrentRow.IDTPIJURCAN : "";
        widgetCurrentRow.DSSEGMER = (parentWidgetCurrentRow.DSSEGMER) ? parentWidgetCurrentRow.DSSEGMER : "";
        widgetCurrentRow.CDSEGMER= (parentWidgetCurrentRow.CDSEGMER) ? parentWidgetCurrentRow.CDSEGMER : "";
        widgetCurrentRow.NMPAIS = (parentWidgetCurrentRow.NMPAIS) ? parentWidgetCurrentRow.NMPAIS : "";
        widgetCurrentRow.CDPAIS = (parentWidgetCurrentRow.CDPAIS) ? parentWidgetCurrentRow.CDPAIS : "";
        widgetCurrentRow.NMESTADO = (parentWidgetCurrentRow.NMESTADO) ? parentWidgetCurrentRow.NMESTADO : "";
        widgetCurrentRow.SGESTADO = (parentWidgetCurrentRow.SGESTADO) ? parentWidgetCurrentRow.SGESTADO : "";
        widgetCurrentRow.NMMUNICIPIO = (parentWidgetCurrentRow.NMMUNICIPIO) ? parentWidgetCurrentRow.NMMUNICIPIO : "";
        widgetCurrentRow.CDMUNICIPIO = (parentWidgetCurrentRow.CDMUNICIPIO) ? parentWidgetCurrentRow.CDMUNICIPIO : "";
        widgetCurrentRow.NMBAIRRO = (parentWidgetCurrentRow.NMBAIRROCAN) ? parentWidgetCurrentRow.NMBAIRROCAN : "";
        widgetCurrentRow.CDBAIRRO = (parentWidgetCurrentRow.CDBAIRRO) ? parentWidgetCurrentRow.CDBAIRRO : "";
        widgetCurrentRow.DSTELEFONECAN = (parentWidgetCurrentRow.DSTELEFONECAN) ? parentWidgetCurrentRow.DSTELEFONECAN : "";
        widgetCurrentRow.DSEMAILCAN = (parentWidgetCurrentRow.DSEMAILCAN) ? parentWidgetCurrentRow.DSEMAILCAN : "";
        widgetCurrentRow.DSEMAILINTERLOCUTOR = "";
        widgetCurrentRow.DSTELEFONEINTERLOCUTOR = "";
        
        if(Boolean(loggedOperatorInfos.NRREVENDA) && loggedOperatorInfos.IDTPOPERADOR === 'R') {
            widgetCurrentRow.NRREVENDA = loggedOperatorInfos.NRREVENDA;
        }
        
        var fieldsEndereco = [widget.getField("NMPAIS"), widget.getField("NMESTADO"), widget.getField("NMMUNICIPIO"), widget.getField("NMBAIRRO")]; 
        this.cascadeReadOnly(widget, fieldsEndereco);
            
    };
    
    /**
     * Função para possibilitar o cadastro de
     * uma evolução referente a tarefa em caso,
     * indicando a conclusão da tarefa.
     * 
     * @param {object} widget widget ativa, no modo
     * view, referente a tarefa em caso.
    */
    this.completeTask = function(widget) {
        var currentRow = widget.currentRow;
        var evolutionWidget = templateManager.container.getWidget("evolucao");
        
        currentRow.NRPARCNEGOCIO = widget.getParent().currentRow.NRPARCNEGOCIO;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                evolutionWidget.COMPLETETASK = true;
                evolutionWidget.NRSEQFILACONTA = widget.currentRow.NRSEQFILACONTA;
                
                ScreenService.closeSwipe().then(function() {
                    this.activateWidget(evolutionWidget).then(function() {
                        setTimeout(function() {    
                            this.evolucaoNewRow();
                        }.bind(this), 500);
                    }.bind(this));
                }.bind(this));
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    };
    
    /**
     * Função para ativar uma widget
     * 
     * @param {object} widget widget que será
     * ativada.
     * 
     * @return {object} deferred 'promise' indicando
     * a conclusão da tarefa da função.
    */
    this.activateWidget = function(widget) {
        
        var deferred = ZHPromise.defer();
        
        widget.activate();
        deferred.resolve();
        
        return deferred;
    };
    
    /**
     * Função para pegar as informações da tarefa
     * na widget de evolução e setar a data de
     * conclusão da tarefa no registro da própria
     * tarefa.
     * 
     * @param {object} widget widget ativa que contém
     * as informações da tarefa que será concluida.
    */
    this.setTaskEndDate = function(widget) {

        if(widget.COMPLETETASK) {
            
            Crm_00040_Lead_Service.callForSetTaskEndDate(widget).then(function() {
                
                ScreenService.showMessage(Messages.TAREFA_CONCLUIDA);
                this.deleteTaskInfosInEvolutionWidget(widget);
                this.activateTaskWidget();
                    
            }.bind(this));
        }
            
    };
    
    /**
     * Função para ativar a widget de agenda
     * de tarefas.
    */
    this.activateTaskWidget = function() {
        
        var taskWidget = templateManager.container.getWidget("posvendagrid");
        
        taskWidget.activate();    
    };
    
    /**
     * Função para deletar as informações da
     * tarefa a ser concluída da widget de evolução.
     * 
     * @param {object} widget widget de evolução.
    */
    this.deleteTaskInfosInEvolutionWidget = function(widget) {
        
        delete widget.COMPLETETASK;
        delete widget.NRSEQFILACONTA;
        
    };
    
    /**
     * Função para definir os valores iniciais
     * de uma tarefa.
     * 
     * @param {object} widget widget ativa, que terá
     * sua currentRow modificada com os valores da nova
     * tarefa.
    */
    self.taskScheduleNewRow = function(widget) {
        var currentRow = widget.currentRow;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.NRPARCNEGOCIO = widget.getParent().currentRow.NRPARCNEGOCIO;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                General.widgetNewRow(widget);
                
                currentRow.DTPLANFILACONTA = (widget.currentRow.DTPLANFILACONTA)? widget.currentRow.DTPLANFILACONTA : moment(new Date()).format('DD/MM/YYYY HH:mm');
        
                currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
                currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
                currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCOPORT;
        
                currentRow.NRCONTATO = widget.parent.parent.currentRow.NRCONTATO;
                currentRow.NRSEQCONTATO = widget.parent.parent.currentRow.NRSEQCONTATO;
                
                currentRow.DTREALFILACONTA = null;
                
                // currentRow.NRSEQCLASSIFICATAREFA = 2;
                currentRow.NMPRINCIPALPARC = '';
                currentRow.DSEMAILTAREFA = '';
                currentRow.DSTELEFONETAREFA = null;
        
                currentRow.NRORG = loggedOperatorInfos.NRORG;
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
        

    };
    
    /**
     * Função para checar a permissão para gerar
     * uma nova tarefa a partir de uma nova evolução.
     * 
     * @param {object} widget widget ativa, no modo
     * edit, onde está sendo cadastrado a evolução.
    */
    this.checkNewTaskPermissionByEvolutionResult = function(widget) {
        
        var currentRow        = widget.currentRow;
        var dataProximaTarefa = widget.getField("DTPLANFILACONTA");
        var dataMinima  = moment().subtract(dataProximaTarefa.maxDiasRetro,'d').format('DD/MM/YYYY');
        if(currentRow.IDGERPROXATIV && currentRow.IDGERPROXATIV === "S" && !currentRow.NEXTTASKBLOCKED) {
            this.setTaskFieldLock(widget, false);
            dataProximaTarefa.validations = {"required": true, "dateGreaterThan": {"minimumDate": dataMinima, "dateFormat" : "DD/MM/YYYY HH:mm"}};
        }else{
            this.setTaskFieldLock(widget, true);
        }
    };
    
    /**
     * Função para setar a permissão de criar uma nova
     * tarefa a partir do resultado da evolução.
     * 
     * @param {object} widget widget ativa, no modo edit,
     * onde está sendo cadastrado a evolução.
     * 
     * @param {boolean} isAllowed permissão booleana do
     * cadastro da tarefa.
    */
    this.setNewTaskPermission = function(widget, isAllowed) {
        
        if(isAllowed) {
            
            this.setTaskFieldLock(widget, false);
            
            widget.currentRow.DTPLANFILACONTA = "";
            
        }else{
            
            this.setTaskFieldLock(widget, true);
            
        }
            
    };
    
    /**
     * Função para definir o bloqueio dos campos
     * de agenda de tarefa na widget de evolução.
     * 
     * @param {object} widget widget de evolução,
     * onde estão os campos para criar um nova
     * tarefa.
     * 
     * @param {boolean} isLocked estado dos campos.
    */
    this.setTaskFieldLock = function(widget, isLocked) {
        
        var taskFields = ["DTPLANFILACONTA", "NMOPERADORREAL", "DSFILACONTATO",
                "DSCLASSIFICATAREFA", "NRPRIORFILACONT"];
        
        taskFields.forEach(function(fieldName) {
            var field = widget.getField(fieldName);
            
            // Se o campo for bloqueado, ele será read-only, não obrigatório e
            //terá seu valor apagado.
            field.readOnly = isLocked;
            if(fieldName != "DSCLASSIFICATAREFA") {
                field.validations = {required: !isLocked};
            }
            widget.currentRow[fieldName] = isLocked ? "" :
                widget.currentRow[fieldName];
        });
    };
        
    /**
     * Função para resetar as informações
     * de criação de uma nova tarefa(a partir de uma
     * evolução). 
     * 
     * @param {object} widget widget de evolução, que terá
     * as informações resetadas.
    */
    this.resetNewTaskInfos = function(widget) {
        
        var currentRow = widget.currentRow;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.DTPLANFILACONTA = "";
        currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
        currentRow.NMOPERADORREAL = loggedOperatorInfos.NMOPERADOR;
        currentRow.DSFILACONTATO = "Retornar contato";
        currentRow.NRPRIORFILACONT = 2;
    };
    
    /**
     * Função para abrir a widget de seleção
     * de arquivos.
    */
    this.openAnnexSwipe = function() {
        var fileUploadWidget = templateManager.container.getWidget('WDGT_SELECAO_ARQUIVOS');
        var currentRow = templateManager.container.getWidget('gridLead').currentRow;
        
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                fileUploadWidget.isVisible = true;
                ScreenService.openSwipe(fileUploadWidget);
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    };
    
    this.deleteAnnex = function() {
        var widget = templateManager.container.getActiveWidget();
        var currentRow = templateManager.container.getWidget('gridLead').currentRow;
        
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                General.deleteCrud(widget);
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    };
    
    /**
     * Função para salvar os anexos selecionados
     * ao caso em questão.
     * 
     * @param {object} widget widget onde é
     * feito a seleção dos anexos.
    */
    this.uploadEvolutionFiles = function(widget) {
        
        var files = widget.currentRow.DSCAMINHO;
        var rows = [];
        
        files.forEach(function(file, fileIndex) {
            
            rows.push(this.setValuesForFileUpload(widget, fileIndex));
            
        }.bind(this));
        
        General.callRestEngine("product#/crm_anexocontato/save", "DataSet", rows).then(function() {
            
                this.closeAnnexSwipe(widget);
                widget.parent.parent.reload();
                
        }.bind(this)).catch(function(err) {
            var errorMessage = Messages.CATCH_EXCEPTION_ERROR(err.data.error);
            ScreenService.showMessage(errorMessage);
        });
    };
    
    /**
     * Função para retornar uma row configurada
     * com as informações do anexo referente
     * ao ID, recebido como parâmetro, no array
     * de anexos na currentRow.
     * 
     * @param {object} widget widget onde foi selecionado
     * os anexos.Array
     * 
     * @param {int} fileIndex index do anexo no array de 
     * anexos presente na currentRow.
     * 
     * @return {object} currentRow row configurada com as informações
     * do anexo referente ao ID recebido.
    */
    this.setValuesForFileUpload = function(widget, fileIndex) {
        
        var currentRow = angular.copy(widget.currentRow);
        // WDGT_SELECAO_ARQUIVOS -> WDGT_ANEXOS_EVOLUCAO -> evolucao
        var evolutionWidget = widget.getParent().getParent();
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.NRSEQCONTATO = evolutionWidget.currentRow.NRSEQCONTATO;
        currentRow.NMARQUIVO = this.getFileNameWithoutExtension(currentRow.DSCAMINHO[fileIndex].name);
        currentRow.DSTIPO = this.getFileExtension(currentRow.DSCAMINHO[fileIndex].name);
        currentRow.VRTAMANHO = currentRow.DSCAMINHO[fileIndex].size;
        currentRow.IDATIVO = "S";
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
        currentRow.IDORIGEM = "EVOLUCAO";
        currentRow.NRORIGEM = evolutionWidget.currentRow.NRSEQEVOLCONT;
        
        return currentRow;
        
    };
    
    /**
     * Função para retornar a extenção de um arquivo
     * extraida do seu nome.
     * 
     * @param {string} fileName nome completo do arquivo.
    */
    this.getFileExtension = function(fileName) {
        
        return fileName.replace(/^(.*)\.(.*)$/, "$2");
        
    };
    
    /**
     * Função para retornar o nome do arquivo sem
     * sua extenção.
     * 
     * @param {string} fileName nome completo do arquivo.
    */
    this.getFileNameWithoutExtension = function(fileName) {
        
        return fileName.replace(/^(.*)\.(.*)$/, "$1");
            
    };
    
    /**
     * Função para fechar o swipe de upload de imagens.
     * 
     * @param {object} widget widget de upload de imagens.
    */
    this.closeAnnexSwipe = function(widget) {
        ScreenService.closeSwipe().then(function() {
            
            widget.isVisible = false;
            widget.parent.parent.list();
            widget.parent.parent.activate();
           
        });
    };
    
    /**
     * Função para fazer o download de uma arquivo
     * salvo no servidor.
     * 
     * @param {object} widget widget que contém
     * as informações do arquivo a ser baixado 
     * em sua currentRow.
    */    
    this.downloadFile = function(widget) {
        
        window.open(window.fileServerBaseUrl + widget.currentRow.DSCAMINHO);
            
    };
    
    /**
     * Função para deletar uma tarefa,
     * 
     * @param {object} widget widget ativa, no modo
     * de visualização, mostrando a tarefa a ser deletada.
    */
    this.deleteTask = function(widget) {
        var currentRow = widget.currentRow;
        
        currentRow.NRPARCNEGOCIO = widget.getParent().currentRow.NRPARCNEGOCIO;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                General.deleteCrud(widget).then(function() {
                }).catch(function() {
                    ScreenService.confirmMessage(ScreenService.i18n(Messages.EXCLUSAO_TAREFA_VINC_EVOLUCAO), 'question', function (success) {
                        this.deactivateTask(widget).then(function() {
                            ScreenService.showMessage(Messages.TAREFA_INATIVADA);
                            ScreenService.closeSwipe().then(function() {
                                widget.reload();
                            });
                        });
                    }.bind(this));
                }.bind(this));
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    };
    
    /**
     * Função para desativar a tarefa em caso.
     * 
     * @param {object} widget widget ativa, no modo
     * de visualização, com as informações da tarefa
     * a ser desativada.
    */
    this.deactivateTask = function(widget) {
        
        return Crm_00040_Lead_Service.callForDeactivateTask(widget);
            
    };
    
    /**
     * Função para editar uma evolução.
     * 
     * @param {object} widget widget ativa, no
     * modo de visualização, com as informações
     * da evolução a ser editada.
    */
    this.editEvolution = function(widget) {
        var currentRow = widget.currentRow;
        
        currentRow.NRPARCNEGOCIO = widget.getParent().currentRow.NRPARCNEGOCIO;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                General.widgetEdit(widget);
                var dataProximaTarefa = widget.getField("DTPLANFILACONTA");
                dataProximaTarefa.validations = {};
                ABEvolucaoController.setEvolDateChangePermission(widget);
                this.checkPermissionToCreateNewTaskInEvolutionEdition(widget);
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
            
    };
    
    /**
     * Função para verificar a permissão para inserir
     * uma nova tarefa na edição da evolução em caso.
     * 
     * @param {object} widget widget ativa, no modo de
     * edição, com as informações da evolução em edição.
    */
    this.checkPermissionToCreateNewTaskInEvolutionEdition = function(widget) {
        var currentRow = widget.currentRow;
        
        if(currentRow.DTPLANFILACONTA || currentRow.DESCRESULEVOL) {
            this.setTaskFieldLock(widget, true);
            currentRow.NEXTTASKBLOCKED = true;
        }else{
            this.unlockNextTask(widget);
            this.checkNewTaskPermissionByEvolutionResult(widget);
            this.resetNewTaskInfos(widget);
        }
    };
    
    /**
     * Função para liberar o cadastro de uma
     * nova tarefa a partir de um evolução,
     * excluindo o parâmetro de bloqueio.
     * 
     * @param {object} widget widget de evolução.
    */
    this.unlockNextTask = function(widget) {
        if(widget.currentRow.NEXTTASKBLOCKED) {
            delete widget.currentRow.NEXTTASKBLOCKED;
        }
    };
    
    /**
     * Função para limpar os valores dos campos
     * para gerar uma nova tarefa através de uma
     * evolução.
     * 
     * @param {object} widget widget de evolução.
    */
    this.cleanNextTaskFieldValues = function(widget) {
        
        var currentRow = widget.currentRow;
        
        if(!currentRow.DTPLANFILACONTA) {
            
            currentRow.DTPLANFILACONTA = "";
            currentRow.DSFILACONTATO = "";
            currentRow.NMOPERADORREAL = "";
            currentRow.DSCLASSIFICATAREFA = "";
            currentRow.NRPRIORFILACONT = "";
        }
        
    };
    
    this.setAddressFieldFilterValue = function(field) {
        
        var fieldFilter = field.dataSourceFilter;
        var nrorgFilterIndex = CRM_Utilities.getFilterPosition(fieldFilter, "NRORG");
        
        fieldFilter[nrorgFilterIndex].value = [this.getOperatorJobOrganizationNumber(), getLocalVar('CRM_NRORGPADRAO')];
        
    };
    
    this.getOperatorJobOrganizationNumber = function() {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        return loggedOperatorInfos.NRORGTRAB;
            
    };
    
    this.alteraEstadoReadonly = function(widget) {
        var paisField = widget.getField("NMPAIS");
        var estadoField = widget.getField("NMESTADO");
        var currentRow = widget.currentRow;
        if (!paisField.value()) {
            estadoField.readOnly = true;
            currentRow.SGESTADO = null;
            currentRow.NMESTADO = null;
        }
        else {
            estadoField.readOnly = false;
            currentRow.SGESTADO = null;
            currentRow.NMESTADO = null;
        }
        this.alteraMunicipioReadonly(widget);
    };

    this.alteraMunicipioReadonly = function(widget) {
        var estadoField = widget.getField("NMESTADO");
        var municipioField = widget.getField("NMMUNICIPIO");
        var currentRow = widget.currentRow;
        if (!estadoField.value()) {
            municipioField.readOnly = true;
            currentRow.NMMUNICIPIO = null;
            currentRow.CDMUNICIPIO = null;
            currentRow.NMMUNICIPIO = null;
        }
        else {
            municipioField.readOnly = false;
            currentRow.NMMUNICIPIO = null;
            currentRow.CDMUNICIPIO = null;
            currentRow.NMMUNICIPIO = null;
        }
        this.alteraBairroReadonly(widget);
    };

    this.alteraBairroReadonly = function(widget) {
        var municipioField = widget.getField("NMMUNICIPIO");
        var bairroField = widget.getField('NMBAIRRO');
        var currentRow = widget.currentRow;
        if (!municipioField.value()) {
            bairroField.readOnly = true;
            currentRow.NMBAIRROTRAN = null;
            currentRow.CDBAIRRO = null;
            currentRow.NMBAIRRO = null;
            currentRow.NMBAIRROCAN = null;
        }
        else {
            bairroField.readOnly = false;
            currentRow.NMBAIRROTRAN = null;
            currentRow.CDBAIRRO = null;
            currentRow.NMBAIRRO = null;
            currentRow.NMBAIRROCAN = null;
        }
    };
    
    this.criarNovoEstado = function(widget) {
        var popUpNovoEstado = templateManager.container.getWidget('popUpNovoEstado');
        popUpNovoEstado.newRow();
        var filterPopup;
        if(widget.name === "convertLeadInProspect") {
            filterPopup = templateManager.container.getWidget("convertLeadInProspect");
            popUpNovoEstado.currentRow.filtro = false;
        } else if(widget.name === "filterPopup") {
            filterPopup = templateManager.container.getWidget("gridLead").__filterPopup;
            popUpNovoEstado.currentRow.filtro = true;
        } else if(widget.name === "gridLead") {
            filterPopup = templateManager.container.getWidget("gridLead");
            popUpNovoEstado.currentRow.filtro = false;
        } else if(widget.name === "gridProspect") {
            filterPopup = templateManager.container.getWidget("gridProspect");
            popUpNovoEstado.currentRow.filtro = false;
        } else if(widget.name === "gridCliente") {
            filterPopup = templateManager.container.getWidget("gridCliente");
            popUpNovoEstado.currentRow.filtro = false;
        } else if(widget.name === "parceiroNegocio") {
            filterPopup = templateManager.container.getWidget("parceiroNegocio");
            popUpNovoEstado.currentRow.filtro = false;
        }
        
        ScreenService.openPopup(popUpNovoEstado).then(function() {
            if (filterPopup && filterPopup.currentRow && filterPopup.currentRow.CDPAIS !== null) {
                popUpNovoEstado.currentRow.CDPAIS = filterPopup.currentRow.CDPAIS;
            } else if (widget && widget.currentRow && widget.currentRow.CDPAIS !== null && filterPopup === undefined) {
                popUpNovoEstado.currentRow.CDPAIS = widget.currentRow.CDPAIS;
            }
            popUpNovoEstado.currentRow.NRORG  = getLocalVar('CRM_NRORG');
            popUpNovoEstado.reload();
        });
    };

    this.prepararNovoEstado = function (widget) {

        CRM_Utilities.setColumnToReturnInCurrentRow(widget.currentRow, "SGESTADO");

        this.salvarNovoEstado(widget.currentRow).then(function (response) {
            var closeAndReload = function (widget, filter) {
                ScreenService.closePopup();
                ScreenService.closePopup();
                ScreenService.showMessage('Estado Criado Com Sucesso!').then(function () {
                    if (filter) {
                        filter.reload();
                    } else {
                        widget.reload();
                    }
                });
            };

            if (widget.currentRow.filtro === true) {
                var filter = templateManager.container.getWidget("gridLead").__filterPopup;
                filter.currentRow.SGESTADO = response.dataset.estado[0].SGESTADO;
                filter.currentRow.NMESTADO = widget.currentRow.NMESTADO;
                closeAndReload(null, filter);
            } else if (widget.id === "17223197581811413729286") {
                var widgetConvert = templateManager.container.getWidget("gridProspect");
                widgetConvert.currentRow.SGESTADO = response.dataset.estado[0].SGESTADO;
                widgetConvert.currentRow.NMESTADO = widget.currentRow.NMESTADO;
                closeAndReload(widgetConvert);
            } else if (widget.id === "2946427491885752492902") {
                var widgetConvert = templateManager.container.getWidget("gridCliente");
                widgetConvert.currentRow.SGESTADO = response.dataset.estado[0].SGESTADO;
                widgetConvert.currentRow.NMESTADO = widget.currentRow.NMESTADO;
                closeAndReload(widgetConvert);
            } else if (widget.id === "14418982342932124704610") {
                var widgetConvert = templateManager.container.getWidget("parceiroNegocio");
                widgetConvert.currentRow.SGESTADO = response.dataset.estado[0].SGESTADO;
                widgetConvert.currentRow.NMESTADO = widget.currentRow.NMESTADO;
                closeAndReload(widgetConvert);
            } else {
                var widgetConvert = templateManager.container.getWidget("convertLeadInProspect");
                var widgetGrid = templateManager.container.getWidget("gridLead");
                widgetConvert.currentRow.SGESTADO = response.dataset.estado[0].SGESTADO;
                widgetConvert.currentRow.NMESTADO = widget.currentRow.NMESTADO;
                widgetGrid.currentRow.SGESTADO = response.dataset.estado[0].SGESTADO;
                widgetGrid.currentRow.NMESTADO = widget.currentRow.NMESTADO;

                closeAndReload(widgetConvert);
            }
        });
    };
    
    this.salvarNovoEstado = function(currentRow) {
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        return restEngine.post('/saveEstado', paramsRestEngine);
    };

    this.criarNovoMunicipio = function(widget) {
        var popUpNovoMunicipio = templateManager.container.getWidget('popupNovoMunicipio');
        popUpNovoMunicipio.newRow();
        var filterPopup;
        if(widget.name === "convertLeadInProspect") {
            filterPopup = templateManager.container.getWidget("convertLeadInProspect");
            popUpNovoMunicipio.currentRow.filtro = false;
        }else if(widget.name === "filterPopup") {
            filterPopup = templateManager.container.getWidget("gridLead").__filterPopup;
            popUpNovoMunicipio.currentRow.filtro = true;
        }else if(widget.name === "gridLead") {
            filterPopup = templateManager.container.getWidget("gridLead");
            popUpNovoMunicipio.currentRow.filtro = false;
        }else if(widget.name === "gridProspect") {
            filterPopup = templateManager.container.getWidget("gridProspect");
            popUpNovoMunicipio.currentRow.filtro = false;
        }else if(widget.name === "gridCliente") {
            filterPopup = templateManager.container.getWidget("gridCliente");
            popUpNovoMunicipio.currentRow.filtro = false;
        }else if(widget.name === "parceiroNegocio") {
            filterPopup = templateManager.container.getWidget("parceiroNegocio");
            popUpNovoMunicipio.currentRow.filtro = false;
        }
        
        ScreenService.openPopup(popUpNovoMunicipio).then(function() {
            if (filterPopup && filterPopup.currentRow && filterPopup.currentRow.CDPAIS !== null) {
                popUpNovoMunicipio.currentRow.CDPAIS = filterPopup.currentRow.CDPAIS;
            } else if (widget && widget.currentRow && widget.currentRow.CDPAIS !== null && filterPopup === undefined) {
                popUpNovoMunicipio.currentRow.CDPAIS = widget.currentRow.CDPAIS;
            }
            if (filterPopup && filterPopup.currentRow && filterPopup.currentRow.SGESTADO !== null) {
                popUpNovoMunicipio.currentRow.SGESTADO = filterPopup.currentRow.SGESTADO;
            } else if (widget && widget.currentRow && widget.currentRow.SGESTADO !== null && filterPopup === undefined) {
                popUpNovoMunicipio.currentRow.SGESTADO = widget.currentRow.SGESTADO;
            }
            popUpNovoMunicipio.currentRow.NRORG       = getLocalVar('CRM_NRORG');
            popUpNovoMunicipio.reload();
        });
    };
       
    this.prepararNovoMunicipio = function(widget) {
        
        CRM_Utilities.setColumnToReturnInCurrentRow(widget.currentRow, "CDMUNICIPIO");
        
        this.salvarMunicipio(widget.currentRow).then(function (response) {

            var closeAndReload = function (widget, filter) {
                ScreenService.closePopup();
                ScreenService.closePopup();
                ScreenService.showMessage('Município Criado Com Sucesso!!').then(function () {
                    if (filter) {
                        filter.reload();
                    } else {
                        widget.reload();
                    }
                });
            };

            if (widget.currentRow.filtro === true) {
                var filter = templateManager.container.getWidget("gridLead").__filterPopup;
                filter.currentRow.CDMUNICIPIO = response.dataset.columnsToReturn[0].CDMUNICIPIO;
                filter.currentRow.NMMUNICIPIO = widget.currentRow.NMMUNICIPIO;
                closeAndReload(null, filter);

            } else if (widget.id === "17223197581675540933293") {
                var widgetConvert = templateManager.container.getWidget("gridProspect");
                widgetConvert.currentRow.CDMUNICIPIO = response.dataset.columnsToReturn[0].CDMUNICIPIO;
                widgetConvert.currentRow.NMMUNICIPIO = widget.currentRow.NMMUNICIPIO;
                closeAndReload(widgetConvert);
                
            } else if (widget.id === "294642749332775850987") {
                var widgetConvert = templateManager.container.getWidget("gridCliente");
                widgetConvert.currentRow.CDMUNICIPIO = response.dataset.columnsToReturn[0].CDMUNICIPIO;
                widgetConvert.currentRow.NMMUNICIPIO = widget.currentRow.NMMUNICIPIO;
                closeAndReload(widgetConvert);

            } else if (widget.id === "1441898234649502068617") {
                var widgetConvert = templateManager.container.getWidget("parceiroNegocio");
                widgetConvert.currentRow.CDMUNICIPIO = response.dataset.columnsToReturn[0].CDMUNICIPIO;
                widgetConvert.currentRow.NMMUNICIPIO = widget.currentRow.NMMUNICIPIO;
                closeAndReload(widgetConvert);
                
            } else {
                var widgetGrid = templateManager.container.getWidget("gridLead");
                var widgetConvert = templateManager.container.getWidget("convertLeadInProspect");
                widgetConvert.currentRow.CDBAIRRO = response.dataset.columnsToReturn[0].CDMUNICIPIO;
                widgetConvert.currentRow.NMMUNICIPIO = widget.currentRow.NMMUNICIPIO;
                widgetGrid.currentRow.CDBAIRRO = response.dataset.columnsToReturn[0].CDMUNICIPIO;
                widgetGrid.currentRow.NMMUNICIPIO = widget.currentRow.NMMUNICIPIO;
                closeAndReload(widgetConvert);
            }
        });
    };
    

    this.salvarMunicipio = function(currentRow) {
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        return restEngine.post('/municipio/save', paramsRestEngine);
    };

    this.criarNovoBairro = function(widget) {
        var popUpNovoBairro = templateManager.container.getWidget('popupNovoBairro');
        popUpNovoBairro.newRow();
        var filterPopup;
        if(widget.name === "convertLeadInProspect") {
            filterPopup = templateManager.container.getWidget("convertLeadInProspect");
            popUpNovoBairro.currentRow.filtro = false;
        }else if(widget.name === "filterPopup") {
            filterPopup = templateManager.container.getWidget("gridLead").__filterPopup;
            popUpNovoBairro.currentRow.filtro = true;
        }else if(widget.name === "gridLead") {
            filterPopup = templateManager.container.getWidget("gridLead");
            popUpNovoBairro.currentRow.filtro = false;
        }else if(widget.name === "gridProspect") {
            filterPopup = templateManager.container.getWidget("gridProspect");
            popUpNovoBairro.currentRow.filtro = false;
        }else if(widget.name === "gridCliente") {
            filterPopup = templateManager.container.getWidget("gridCliente");
            popUpNovoBairro.currentRow.filtro = false;
        }else if(widget.name === "parceiroNegocio") {
            filterPopup = templateManager.container.getWidget("parceiroNegocio");
            popUpNovoBairro.currentRow.filtro = false;
        }
        
        ScreenService.openPopup(popUpNovoBairro).then(function() {
            if (filterPopup && filterPopup.currentRow && filterPopup.currentRow.CDPAIS !== null) {
                popUpNovoBairro.currentRow.CDPAIS = filterPopup.currentRow.CDPAIS;
            } else if (widget && widget.currentRow && widget.currentRow.CDPAIS !== null && filterPopup === undefined) {
                popUpNovoBairro.currentRow.CDPAIS = widget.currentRow.CDPAIS;
            }
            if (filterPopup && filterPopup.currentRow && filterPopup.currentRow.SGESTADO !== null) {
                popUpNovoBairro.currentRow.SGESTADO = filterPopup.currentRow.SGESTADO;
            } else if (widget && widget.currentRow && widget.currentRow.SGESTADO !== null && filterPopup === undefined) {
                popUpNovoBairro.currentRow.SGESTADO = widget.currentRow.SGESTADO;
            }
            if (filterPopup && filterPopup.currentRow && filterPopup.currentRow.CDMUNICIPIO !== null) {
                popUpNovoBairro.currentRow.CDMUNICIPIO = filterPopup.currentRow.CDMUNICIPIO;
            } else if (widget && widget.currentRow && widget.currentRow.CDMUNICIPIO !== null && filterPopup === undefined) {
                popUpNovoBairro.currentRow.CDMUNICIPIO = widget.currentRow.CDMUNICIPIO;
            }
            popUpNovoBairro.currentRow.NRORG = getLocalVar('CRM_NRORG');
            popUpNovoBairro.reload();
        });
    };
    
    
    this.prepararNovoBairro = function(widget) {
        
        CRM_Utilities.setColumnToReturnInCurrentRow(widget.currentRow, "CDBAIRRO");
        widget.currentRow.DTULTATUBAIR = CRM_Utilities.getCurrentDate();
        
        if(!Util.isEmptyOrBlank(widget.currentRow.CDMUNICIPIO)) {
                this.salvarBairro(widget.currentRow).then(function(response) {
                if(widget.currentRow.filtro === true) {
                    var filter = templateManager.container.getWidget("gridLead").__filterPopup;
                    filter.currentRow.CDBAIRRO    = response.dataset.columnsToReturn[0].CDBAIRRO;  
                    filter.currentRow.NMBAIRRO    = widget.currentRow.NMBAIRRO;
                    filter.currentRow.NMBAIRROCAN = widget.currentRow.NMBAIRRO;
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                    ScreenService.showMessage('Bairro criado com sucesso!').then(function() {
                    filter.reload(); 
                    });
                }else if(widget.id === "17223197581926249916678") {
                    var widgetGridProspect = templateManager.container.getWidget("gridProspect");
                    widgetGridProspect.currentRow.CDBAIRRO    = response.dataset.columnsToReturn[0].CDBAIRRO;  
                    widgetGridProspect.currentRow.NMBAIRRO    = widget.currentRow.NMBAIRRO;
                    widgetGridProspect.currentRow.NMBAIRROCAN = widget.currentRow.NMBAIRRO;
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                    ScreenService.showMessage('Bairro criado com sucesso!').then(function() {
                        widgetGridProspect.reload();
                    });    
                }else if(widget.id === "294642749498830618988") {
                    var widgetGridProspect = templateManager.container.getWidget("gridCliente");
                    widgetGridProspect.currentRow.CDBAIRRO    = response.dataset.columnsToReturn[0].CDBAIRRO;  
                    widgetGridProspect.currentRow.NMBAIRRO    = widget.currentRow.NMBAIRRO;
                    widgetGridProspect.currentRow.NMBAIRROCAN = widget.currentRow.NMBAIRRO;
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                    ScreenService.showMessage('Bairro criado com sucesso!').then(function() {
                        widgetGridProspect.reload();
                    });    
                }else if(widget.id === "14418982342382710746623") {
                    var widgetGridProspect = templateManager.container.getWidget("parceiroNegocio");
                    widgetGridProspect.currentRow.CDBAIRRO    = response.dataset.columnsToReturn[0].CDBAIRRO;  
                    widgetGridProspect.currentRow.NMBAIRRO    = widget.currentRow.NMBAIRRO;
                    widgetGridProspect.currentRow.NMBAIRROCAN = widget.currentRow.NMBAIRRO;
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                    ScreenService.showMessage('Bairro criado com sucesso!').then(function() {
                        widgetGridProspect.reload();
                    });    
                }else{
                    var widgetConvert = templateManager.container.getWidget("convertLeadInProspect");
                    widgetConvert.currentRow.CDBAIRRO    = response.dataset.columnsToReturn[0].CDBAIRRO;  
                    widgetConvert.currentRow.NMBAIRRO    = widget.currentRow.NMBAIRRO;
                    widgetConvert.currentRow.NMBAIRROCAN = widget.currentRow.NMBAIRRO;
                    var widgetGrid = templateManager.container.getWidget("gridLead");
                    widgetGrid.currentRow.CDBAIRRO    = response.dataset.columnsToReturn[0].CDBAIRRO;  
                    widgetGrid.currentRow.NMBAIRRO    = widget.currentRow.NMBAIRRO;
                    widgetGrid.currentRow.NMBAIRROCAN = widget.currentRow.NMBAIRRO;
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                    ScreenService.showMessage('Bairro criado com sucesso!').then(function() {
                        widgetConvert.reload();
                    });
                }
            });
        } else {
            ScreenService.showMessage('Gentileza Informar o Municipio!');
        }
    };
    
    this.salvarBairro = function(currentRow) {
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        return restEngine.post('/bairro/save', paramsRestEngine);
    }; 
    
    this.criarNovoInterlocutor = function(widget) {
        var popupNovoInterlocutor = templateManager.container.getWidget('popupNovoInterlocutor');
        popupNovoInterlocutor.newRow();
        var filterPopup = popupNovoInterlocutor.currentRow;
        if(widget.name === "convertLeadInProspect") {
            filterPopup = templateManager.container.getWidget("convertLeadInProspect");
            popupNovoInterlocutor.currentRow.filtro = false;
            popupNovoInterlocutor.parentName = widget.name;
        }else if(widget.name === "filterPopup") {
            filterPopup = templateManager.container.getWidget("gridLead").__filterPopup;
            popupNovoInterlocutor.currentRow.filtro = true;
        }else if(widget.name === "gridLead") {
            filterPopup = templateManager.container.getWidget("gridLead");
            popupNovoInterlocutor.currentRow.filtro = false;
            popupNovoInterlocutor.parentName = widget.name;
         }else if(widget.name === "posvendagrid") {
            filterPopup = templateManager.container.getWidget("posvendagrid");
            popupNovoInterlocutor.currentRow.filtro = false;
            popupNovoInterlocutor.parentName = widget.name;
        }else if(widget.name === "evolucao") {
            filterPopup = templateManager.container.getWidget("evolucao");
            popupNovoInterlocutor.currentRow.filtro = false;
            popupNovoInterlocutor.parentName = widget.name;
        }
        
        ScreenService.openPopup(popupNovoInterlocutor).then(function() {
            popupNovoInterlocutor.currentRow.NMINTERLOCUTOR      = filterPopup.NMINTERLOCUTOR;
            popupNovoInterlocutor.currentRow.DTNASCIMENTO    = filterPopup.DTNASCIMENTO;
            popupNovoInterlocutor.currentRow.IDRECEBEPRESENTE = filterPopup.IDRECEBEPRESENTE;
            popupNovoInterlocutor.currentRow.NMCARGOINTERLOC = filterPopup.NMCARGOINTERLOC;
            popupNovoInterlocutor.currentRow.EMAILINTERLOC = filterPopup.EMAILINTERLOC;
            popupNovoInterlocutor.currentRow.NRTELEFONE1 = filterPopup.NRTELEFONE1;
            popupNovoInterlocutor.currentRow.NRORG       = getLocalVar('CRM_NRORG');
        });
    }; 
    
    
    this.setInterlocutorWidgetDefaultValues = function(widget) {
        var wid = templateManager.container.getWidget('gridLead');
        
        wid.currentRow.NRPARCNEGOCIO;
        
        widget.currentRow.NRPARCNEGOCIO = wid.currentRow.NRPARCNEGOCIO;
        
    };
    
    this.prepararInterlocutor = function(widget) {
        
        var parent = templateManager.container.getWidget(widget.parentName);
        
        CRM_Utilities.setColumnToReturnInCurrentRow(widget.currentRow, "NRSEQINTERLOCUTOR");
        this.removeInterlocutorPhoneMask(widget);
        widget.currentRow.NRCPFINTERLOC = widget.currentRow.NRCPFINTERLOC.replace(/[^0-9]/g, '');
        this.salvarInterlocutor(widget.currentRow).then(function(response, widget) {
            var currentRow = templateManager.container.getWidget('popupNovoInterlocutor');
              if(currentRow.filtro === true) {
                var widgetfilter = templateManager.container.getWidget('popupNovoInterlocutor').__filterPopup;
                var widgetlead = templateManager.container.getWidget('gridLead');
                var widgetConvertfilter = templateManager.container.getWidget('evolucao');
                widgetConvertfilter.currentRow.NMINTERLOCUTOR = widget.currentRow.NMINTERLOCUTOR; 
                
                widgetfilter.template = "widget/form.html";
                widgetfilter.activate();
                widgetlead.widgets[0].fields[7].defaultValue = widget.currentRow.NMINTERLOCUTOR;
                ScreenService.closePopup(true);
                ScreenService.showMessage('Interlocutor criado com sucesso!');
              }else{
                var widgetcurrent = templateManager.container.getWidget('popupNovoInterlocutor');
                var wid = templateManager.container.getWidget('gridLead');

                parent.currentRow.NRSEQINTERLOCUTOR = response.dataset.columnsToReturn[0].NRSEQINTERLOCUTOR;  
                parent.currentRow.NMINTERLOCUTOR = widgetcurrent.currentRow.NMINTERLOCUTOR; 
                parent.currentRow.EMAILINTERLOC = widgetcurrent.currentRow.EMAILINTERLOC; 
                
                ScreenService.closePopup(true);
                
                ScreenService.showMessage('Interlocutor criado com sucesso!').then(function() {
                    parent.activate();
                    parent.reload();
                });
              }
        });
    };
    
    this.salvarInterlocutor = function(currentRow) {
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        return restEngine.post('/crm_interlocutor/save', paramsRestEngine);
    };

     this.removeInterlocutorPhoneMask = function(widget) {
        
        var currentRow = widget.currentRow;
        var phoneFields = ["NRTELEFONE1"];
        
        phoneFields.forEach(function(phone) {
            
            if(currentRow[phone]) {
                currentRow[phone] = currentRow[phone].replace(/[^0-9]/g, '');    
            }
            
        });
        
    };
    this.cancelarNovoRegistro = function() {
        ScreenService.closePopup();
    };
    
    this.changeOperatorFilter = function(widget) {
        var filtros = widget.dataSourceFilter;
        var allOperators = true;
        var defaultOperator = true;
        
        if(filtros.length !== 5 && filtros.length !== 4) {
            filtros.forEach(function(filtro, index) {
                //Se filtrou operador
                if(filtro.name === "NRPARCPROPRI") {
                    defaultOperator = false;
                    
                    if(filtro.value !== templateManager.LOGGEDOPERATOR.NRPARCNEGOCIO) {
                        allOperators = false;
                    }
                }
            });
            
            if(allOperators) {
                filtros.forEach(function(filtro, index) {
                    //Se filtrou operador
                    if(filtro.name === "NRPARCPROPRI" ) {
                        filtros.splice(index, 1);
                    }
                });    
            }
            
            /*if(defaultOperator) {
                var filter = {
                    name: "NRPARCPROPRI",
                    operator: "IN",
                    static: true,
                    value: [templateManager.LOGGEDOPERATOR.NRPARCNEGOCIO]
                };
                filtros.push(filter);
            }*/
        }    
        
    };
    
    
    /**
     * Função para estender a data final do filtro between de data de inclusao.
     * Sem isso a data final era passada com 00:00, não filtrando os leads 
     * daquele dia;
     * 
     * @param {object} widget widget de lead.
    */
    this.fixDataInclusaoFilter = function(widget) {
        widget.dataSourceFilter.forEach(function(filter, index, dataSourceFilter) {
            if(filter.name === "INCLUSAO")
                dataSourceFilter[index].value[1] += ' 23:59';
        });    
    };
    
    /**
     * Função para propagar readonly num array de fields
    */
    this.cascadeReadOnly = function(widget, fieldsNames) {

        var fields = [];
        
        fieldsNames.forEach(function(name) {
            var field = widget.getField(name);
            if(field) {
                fields.push(field);
            }
        });
        
        if(fields.length > 1) {
            fields.forEach(function(field, index) {
                if(index > 0) {
                    if (!field.value()) {
                        field.readOnly = true;
                    } else {
                        field.readOnly = false;
                    }
                }
            });
        }
    };
    
    this.styleNewLead = function(element) {
        var tr = $(element[0]);  
        if(tr.hasClass('tr')) {
            tr.wrap('<a class="newLeadTooltip" title="Lead recém criado"></a>');
        }
    };
    
    this.styleLead = function(element) {
        while($(element[0]).parent().is('a')) {
            $(element[0]).unwrap('a');  
        }
    };
    
    this.choosePerfOrOper = function(widget, perfOrOper) {
        var fieldOper = widget.getField('NRPARCPROPRI');
        var fieldPerf = widget.getField('NRSEQPERFILRESPONSAVEL');
        if(perfOrOper === 'OPER') {
            if(Util.isEmptyOrBlank(fieldOper.value())) {
                fieldPerf.readOnly = false;
            }else{
                fieldPerf.readOnly = true;
                fieldPerf.clearValue();
                fieldOper.readOnly = false;
            }
        }else if(perfOrOper === 'PERF') {
            if(Util.isEmptyOrBlank(fieldPerf.value())) {
                fieldOper.readOnly = false;
            }else{
                fieldPerf.readOnly = false;
                fieldOper.readOnly = true;
                fieldOper.clearValue();
            }
        }
    };
    
    this.exibeInterlocutor = function(widget) {
        setTimeout(function() {   
             widget;
             if(widget.mode === "edit" && widget.currentRow.__is_new) {
                widget.fieldGroups.forEach(function(group) {
                    if(group.name == "INTER") {
                    	group.isVisible = true;
                    }
                    widget.getField('NRTELEFONE1').validations = { "phone": {"message": "Telefone Inválido"}};
                    widget.getField('EMAILINTERLOC').validations = { "mail": true};
                });
             }else{
                 widget.fieldGroups.forEach(function(group) {
                    if(group.name == "INTER") {
                    	group.isVisible = false;
                    }
                    widget.getField('NRTELEFONE1').validations = {};
                    widget.getField('EMAILINTERLOC').validations = {};
                });
             }
            
        },4);
    };
    
    this.widgetOnEnter = function (widget, fieldsToApply) {
        CRM_Utilities.cascadeReadOnly(widget, ['NMPAIS', 'NMESTADO', 'NMMUNICIPIO', 'NMBAIRROCAN']);

        if (typeof templateManager !== 'undefined' && CRM_Utilities.getLoggedOperatorInfos()) {
            var filterRow = {
                IDOPERATIVO: 'A',
                NRPARCPROPRI: [CRM_Utilities.getLoggedOperatorInfos().NRPARCNEGOCIO]
            };

            if (widget.name === 'gridLead') {
                CRM_Utilities.openFilterOnEnter(widget, filterRow, fieldsToApply);
            } else {
                widget.dataSource.data = templateManager.container.getWidget('gridLead').dataSource.data;
                widget.appliedFilter = templateManager.container.getWidget('gridLead').appliedFilter;
            }
        }
        this.setTasksWidgetOperatorField();
        this.startWidgetFilterGridlead(widget);
    };
    
    function setDiasRetroativosTarefaEvol(widget) {
        var diasMaxRetro = 0;
        var dataProxTarefaField = widget.getField('DTPLANFILACONTA');
        
        var postParams = {
            requestType: 'FilterData',
            filter: [
                {
                    name:  'NRORG',
                    operator: '=',
                    value: getLocalVar('CRM_NRORG')
                },
                {
                    name:  'IDATIVO',
                    operator: '=',
                    value: 'S'
                }
            ]
        };
        
        try {
            diasMaxRetro = restEngine.post('/crm_parametrizacao', postParams)
                .dataset.crm_parametrizacao[0].NRDIASLANCEVOL || 0;
        } catch (err) {
            diasMaxRetro = 0;
        }
        
        dataProxTarefaField.maxDiasRetro = diasMaxRetro;
    };
    
    this.tratarCamposDeData = function(widget) {
        var rows = widget.dataSource.data;
        
        rows.forEach(function(row) {
            row.DTINCLUSAO = this.removerSegundosDeData(row.DTINCLUSAO);
            row.DTULTATU = this.removerSegundosDeData(row.DTULTATU);
            row.INCLUSAO = this.removerSegundosDeData(row.INCLUSAO);
        }.bind(this));
    };
    
    this.removerSegundosDeData = function(datetime) {
         return moment(datetime, 'DD/MM/YYYY HH:mm').
            format('DD/MM/YYYY');
    };
    
    this.removeTabCustomFilter = function(widget) {
        CRM_Utilities.removeCustomFiltersFromWidget(widget);
        widget.reload();
    };
    
    this.openPopupFundirLead = function() {
        var gridWidget = templateManager.container.getActiveWidget();
        var currentRow = gridWidget.currentRow;
        var widget = templateManager.container.getWidget('FUNDIRLEAD');
        var fieldOrigem = widget.getField('NRPARCORIGEM');
        
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                ScreenService.closePopup();
                ScreenService.openPopup(widget);
                  
                widget.activate();
                widget.newRow();
            
                widget.currentRow.NRPARCDESTINO = widget.getParent().currentRow.NRPARCNEGOCIO;
                widget.currentRow.NMDESTINO = widget.getParent().currentRow.NMCANDIDATO;
                
                var sameParcFilter = CRM_Utilities.getComponentDataSourceFilter(fieldOrigem, 'NRPARCORIGEM');
                
                sameParcFilter.value = widget.currentRow.NRPARCDESTINO;
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    };
    
    this.openPopupUnmergeLead = function(mainWid) {
        var gridWidget = templateManager.container.getActiveWidget();
        var currentRow = gridWidget.currentRow;
        var widgetUnmerge = templateManager.container.getWidget('DESFUNDIRLEAD');

        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                ScreenService.closePopup();
                ScreenService.openPopup(widgetUnmerge);
                
                widgetUnmerge.activate();
                widgetUnmerge.newRow();
                
                widgetUnmerge.currentRow.NMCANDPROSPECT = mainWid.currentRow.NMCANDIDATO;
                widgetUnmerge.currentRow.NRPARCATUAL = mainWid.currentRow.NRPARCNEGOCIO;
                
                var filterParcDestino = widgetUnmerge.getField('PARCSDESFUNDIR').dataSourceFilter.find(function(filter) {
                    return filter.name == "P_NRPARCDEST";
                });
                
                filterParcDestino.value = mainWid.currentRow.NRPARCNEGOCIO;
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
        
        
    };
    
    this.setUnmergeActionVisibility = function(widget) {
        var unmergeAction = widget.getAction('UNMERGEPARC');
        unmergeAction.isVisible = false;
        
        var nrparcneg = widget.currentRow.NRPARCNEGOCIO;
        var nrorg = widget.currentRow.NRORG;
        
        CRM_ParceiroNegocio_Controller.checkParcHasMerge(nrparcneg, nrorg).then(function(hasMerge) {
            // Action de desfundir será visível se o prospect tiver algum
            //parceiro fundido a ele.
            unmergeAction.isVisible = hasMerge;
            
            widget.redraw();
        }.bind(this));
    };
    
    this.evolucaoRowOnEnter = function(widget) {
        var prospectController = CRM_Utilities.getController('ger45000_Prospect_Controller');
        
        prospectController.setEditEvolButtonAction(widget, this.editEvolButtonDefaultCode, 'EDITAR_EVOLUCAO');
    };
    
    this.editEvolButtonDefaultCode =
        "ger45000_Prospect_Controller.cleanTaskGroupIfInvisible(args.owner.widget, 'AGENDAR_TAREFA');" +
        "crm00040_Lead_Controller.editEvolution(args.owner.widget);";
        
    this.editLeadActionOnClick = function (widget) {
        var currentRow = widget.currentRow;
        if (currentRow.NRPARCPROPRI === CRM_Utilities.getLoggedOperatorInfos().NRPARCNEGOCIO) {
            this.editLead(widget);
            CRM_Utilities.cascadeReadOnly(widget, ['NMPAIS', 'NMESTADO', 'NMMUNICIPIO', 'NMBAIRROCAN']);
        } else {
            ScreenService.showMessage('Operação Bloqueada! Somente o Parceiro Responsável Pode Editar as Informações do Lead');
        }
    };
    
    this.addEvolActionOnCLick = function(widget) {
        var prospectController = CRM_Utilities.getController('ger45000_Prospect_Controller');
        
        this.evolucaoNewRow();
        prospectController.setNextTaskVisibility(widget, 'AGENDAR_TAREFA');
    };
    
    this.showCantEditMessage = function() {
        var message = "Ação bloqueada!<br>" +
                      "Somente o operador responsável pelo lead e seus assistentes podem " +
                      "editá-lo/evoluí-lo.";
                      
        ScreenService.showMessage(message);
    };

    this.idativeBasedStatusChange = function (widget) {

        if (widget.currentRow.IDATIVO == 'S') {
            widget.getAction('ACTIVATE').isVisible = false
            widget.getAction('DELETE').isVisible = true
        } else {
            widget.getAction('ACTIVATE').isVisible = true
            widget.getAction('DELETE').isVisible = false
        }
    }

    this.leadGridAfterMoveRow = function (widget) {
        var prospectController = CRM_Utilities.getController('ger45000_Prospect_Controller');
        var rdController = CRM_Utilities.getController('IntegracaoRDStationController');

        this.idativeBasedStatusChange(widget);
        this.changeLabelDTNASCIFUNDPARC(widget);
        rdController.insertSendActionRD(widget, 'Lead');
        this.exibeInterlocutor(widget);
        this.atualizarAcoes(widget);
        prospectController.setUnmergeActionVisibility(widget);
        this.showsResale(widget);
    };
    
    this.callRedirectForProspect = function(widget, parcResp, nrparcnegocio) {
        ScreenService.confirmMessage("Deseja ser redirecionado para a tela de prospect?", "CORFIRMATION", 
        function(success) {
            templateManager.container.getWidget('gridLead').mode = 'list';
            templateManager.container.getWidget('gridLead').reload();
            ScreenService.openWindow('ger45000_prospect').then(function() {
                var prospWidgt = templateManager.container.getWidget('gridProspect');
                prospWidgt.dataSourceFilter = [
                    {
                        name: "NRPARCRESPROSP",
                        operator: "=",
                        value: parcResp
                    },
                    {
                        name: "IDATIVO",
                        operator: "=",
                        value: 'S'
                    },
                    {
                        name: "IDTPOPERADOR",
                        operator: "=",
                        value: templateManager.LOGGEDOPERATOR.IDTPOPERADOR
                    },
                    {
                        name: "NRORG",
                        operator: "=",
                        value: templateManager.LOGGEDOPERATOR.NRORGTRAB
                    },
                    {
                        name: "P_CRM_NRORGTRAB",
                        operator: "=",
                        value: getLocalVar('CRM_NRORGTRABALHO')
                    },
                    {
                        name: "NRPARCNEGOCIO",
                        operator: "=",
                        value: nrparcnegocio
                    }
                ];
                prospWidgt.fromLead = true;
                prospWidgt.reload().then(function() {
                    ScreenService.closePopup(true);
                });
            });
        }, function(error) {
            templateManager.container.getWidget('gridLead').activate();
        });
    };
    
    this.buildReturnedParcRow = function(widget, row) {
        var razSoc; var nomFant; var insc; var tpinsc;
        if(row.NMRAZSOCCLIE) {
            razSoc = row.NMRAZSOCCLIE;
            nomFant = row.NMFANTCLIE;
            insc = row.NRINSJURCLIE;
            tpinsc = row.IDTPIJURCLIE;
        } else if(row.NMRAZSOCPROS) {
            razSoc = row.NMRAZSOCPROS;
            nomFant = row.NMFANTPROS;
            insc = row.NRINSJURPROS;
            tpinsc = row.IDTPIJURPROS;
        } else {
            razSoc = row.NMCANDIDATO;
            nomFant = row.NMFANTCAN;
            insc = row.NRINSJURCAN;
            tpinsc = row.IDTPIJURCAN;
        }
        
        if(templateManager.container.name == 'crm00040_000_leads') {
            widget.currentRow.NMCANDIDATO = razSoc;
            widget.currentRow.NMFANTCAN = nomFant;
            widget.currentRow.DSTELEFONECAN = row.DSTELEFONECAN ? row.DSTELEFONECAN : null;
            widget.currentRow.NRINSJURCAN = insc;
            widget.currentRow.IDTPIJURCAN = tpinsc;
            widget.currentRow.DESCTITULOCAN = row.DESCTITULOCAN ? row.DESCTITULOCAN : widget.currentRow.DESCTITULOCAN;
            widget.currentRow.DSEMAILCAN = row.DSEMAILCAN ? row.DSEMAILCAN : widget.currentRow.DSEMAILCAN;
            widget.currentRow.IDSTATUSCAN = row.IDSTATUSCAN ? row.IDSTATUSCAN : 2;
            widget.currentRow.NRFUNCCAN = row.NRFUNCCAN ? row.NRFUNCCAN : widget.currentRow.NRFUNCCAN;
            widget.currentRow.NRSEQPERFILRESPONSAVEL = row.NRSEQPERFILRESPONSAVEL ? row.NRSEQPERFILRESPONSAVEL : widget.currentRow.NRSEQPERFILRESPONSAVEL;
            widget.currentRow.NMBAIRROCAN = row.NMBAIRRO ? row.NMBAIRRO : widget.currentRow.NMBAIRROCAN;
        } else if(templateManager.container.name == 'ger45000_prospect') {
            widget.currentRow.NMRAZSOCPROS = razSoc;
            widget.currentRow.NMFANTPROS = nomFant;
            widget.currentRow.NRINSJURPROS = insc;
            widget.currentRow.IDTPIJURPROS = tpinsc;
            widget.currentRow.NRFUNCPROS = row.NRFUNCPROS ? row.NRFUNCPROS : widget.currentRow.NRFUNCPROS;
            widget.currentRow.IDQUALIFICADO = row.IDQUALIFICADO ? row.IDQUALIFICADO : widget.currentRow.IDQUALIFICADO;
            widget.currentRow.NMBAIRRO = row.NMBAIRRO ? row.NMBAIRRO : widget.currentRow.NMBAIRRO;
        } else if(templateManager.container.name == 'crm_cliente') {
            widget.currentRow.NMRAZSOCCLIE = razSoc;
            widget.currentRow.NMFANTCLIE = nomFant;
            widget.currentRow.NRINSJURCLIE = insc;
            widget.currentRow.IDTPIJURCLIE = tpinsc;
            widget.currentRow.NMBAIRRO = row.NMBAIRRO ? row.NMBAIRRO : widget.currentRow.NMBAIRRO;
        }
        
        widget.currentRow.NRPARCNEGOCIO = row.NRPARCNEGOCIO ? row.NRPARCNEGOCIO : null;
        widget.currentRow.NMPAIS = row.NMPAIS ? row.NMPAIS : widget.currentRow.NMPAIS;
        widget.currentRow.NMESTADO = row.NMESTADO ? row.NMESTADO : widget.currentRow.NMESTADO;
        widget.currentRow.NMMUNICIPIO = row.NMMUNICIPIO ? row.NMMUNICIPIO : widget.currentRow.NMMUNICIPIO;
        widget.currentRow.CDPAIS = row.CDPAIS ? row.CDPAIS : widget.currentRow.CDPAIS;
        widget.currentRow.SGESTADO = row.SGESTADO ? row.SGESTADO : widget.currentRow.SGESTADO;
        widget.currentRow.CDMUNICIPIO = row.CDMUNICIPIO ? row.CDMUNICIPIO : widget.currentRow.CDMUNICIPIO;
        widget.currentRow.CDBAIRRO = row.CDBAIRRO ? row.CDBAIRRO : widget.currentRow.CDBAIRRO;
        widget.currentRow.CDFILIAL = row.CDFILIAL ? row.CDFILIAL : widget.currentRow.CDFILIAL;
        widget.currentRow.CDMODODIVULG = row.CDMODODIVULG ? row.CDMODODIVULG : null;
        widget.currentRow.CDSEGMER = row.CDSEGMER ? row.CDSEGMER : null;
        widget.currentRow.DSCOMPLEENDERECO = row.DSCOMPLEENDERECO ? row.DSCOMPLEENDERECO : null;
        widget.currentRow.DSENDERECO = row.DSENDERECO ? row.DSENDERECO : widget.currentRow.DSENDERECO;
        widget.currentRow.DSOBSERVACAOLEAD = row.DSOBSERVACAOLEAD ? row.DSOBSERVACAOLEAD : null;
        widget.currentRow.CDSEGMER = row.CDSEGMER ? row.CDSEGMER : widget.currentRow.CDSEGMER;
        widget.currentRow.DSSEGMER = row.DSSEGMER ? row.DSSEGMER : widget.currentRow.DSSEGMER;
        widget.currentRow.DTINCLUSAO = row.DTINCLUSAO ? row.DTINCLUSAO : null;
        widget.currentRow.DTNASCIFUNDPARC = row.DTNASCIFUNDPARC ? row.DTNASCIFUNDPARC : null;
        widget.currentRow.DTULTATU = row.DTULTATU ? row.DTULTATU : null;
        widget.currentRow.IDPARCFUNDIDO = row.IDPARCFUNDIDO ? row.IDPARCFUNDIDO : 'N';
        widget.currentRow.NRCANDIDATO = row.NRCANDIDATO ? row.NRCANDIDATO : null;
        widget.currentRow.NRCEPENDERECO = row.NRCEPENDERECO ? row.NRCEPENDERECO : widget.currentRow.NRCEPENDERECO;
        widget.currentRow.NRIMOVELENDERECO = row.NRIMOVELENDERECO ? row.NRIMOVELENDERECO : null;
        widget.currentRow.NRMODORECEBINFO = row.NRMODORECEBINFO ? row.NRMODORECEBINFO : null;
        widget.currentRow.NRORG = row.NRORG ? row.NRORG : null;
        widget.currentRow.NRORGINCLUSAO = row.NRORGINCLUSAO ? row.NRORGINCLUSAO : null;
        widget.currentRow.NRCONTATO = row.NRCONTATO ? row.NRCONTATO : null;
        widget.currentRow.NRSEQCONTATO = row.NRSEQCONTATO ? row.NRSEQCONTATO : null;
        widget.currentRow.CDOPERINCLUSAO = row.CDOPERINCLUSAO ? row.CDOPERINCLUSAO : null;
        if(templateManager.container.name == 'crm00040_000_leads') {
            if(Util.isEmptyOrBlank(widget.currentRow.NRCANDIDATO)) {
                widget.currentRow.__is_new = true;
            }
            if(!Util.isEmptyOrBlank(row.NRPARCNEGOCIO)) {
                if(!Util.isEmptyOrBlank(widget.currentRow.NRINSJURCAN)) {
                    widget.getField('NRINSJURCAN').readOnly = true;
                } else {
                    widget.getField('NRINSJURCAN').readOnly = false;
                }
                widget.getField('NMCANDIDATO').readOnly = true;
            }
        } else if(templateManager.container.name == 'ger45000_prospect') {
            if(!Util.isEmptyOrBlank(row.NRPARCNEGOCIO)) {
                if(!Util.isEmptyOrBlank(widget.currentRow.NRINSJURPROS)) {
                    widget.getField('NRINSJURPROS').readOnly = true;
                } else {
                    widget.getField('NRINSJURPROS').readOnly = false;
                }
                widget.getField('NMRAZSOCPROS').readOnly = true;
            }
        } else if(templateManager.container.name == 'crm_cliente') {
            if(!Util.isEmptyOrBlank(row.NRPARCNEGOCIO)) {
                if(!Util.isEmptyOrBlank(widget.currentRow.NRINSJURCLIE)) {
                    widget.getField('NRINSJURCLIE').readOnly = true;
                } else {
                    widget.getField('NRINSJURCLIE').readOnly = false;
                }
                widget.getField('NMRAZSOCCLIE').readOnly = true;
            }
        }
    }; 
    
    this.searchParcForName = function() {
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow.NRORG = getLocalVar('CRM_NRORG');
        widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        
        var CRM_Par = CRM_Utilities.getCrmParametrization();
        
        var razSoc;
        var insc;
        
        if (templateManager.container.name == 'crm00040_000_leads') {
            razSoc = widget.fields.find(function(x) { return x.name == "NMCANDIDATO"; });
            insc = widget.fields.find(function(x) { return x.name == "NRINSJURCAN"; });
            widget.currentRow.NOME = widget.currentRow.NMCANDIDATO.toString().replace(' ', "%").toUpperCase();
        } else if (templateManager.container.name == 'ger45000_prospect') {
            razSoc = widget.fields.find(function(x) { return x.name == "NMRAZSOCPROS"; });
            insc = widget.fields.find(function(x) { return x.name == "NRINSJURPROS"; });
            widget.currentRow.NOME = widget.currentRow.NMRAZSOCPROS.toString().replace(' ', "%").toUpperCase();
        } else if (templateManager.container.name == 'crm_cliente') {
            razSoc = widget.fields.find(function(x) { return x.name == "NMRAZSOCCLIE"; });
            insc = widget.fields.find(function(x) { return x.name == "NRINSJURCLIE"; });
            widget.currentRow.NOME = widget.currentRow.NMFANTCLIE.toString().replace(' ', "%").toUpperCase();
        }
        
        if (!Util.isEmptyOrBlank(razSoc.value()) && Util.isEmptyOrBlank(insc.value())) {
            this.verificaLeadExistente(widget.currentRow).then(function(response) {
                if (response.dataset.DADOS.LEADS === true) {
                    // Verifica parametrização bloqueia nome semelhante
                    if (CRM_Par.IDBLOQNOMESEMELHA === 'S') {
                        ScreenService.showMessage("Operação bloqueada! <br><br> A 'Razão Social' informada já está vinculada a outro lead. Consulte o mapa de prospecção.");
                        razSoc.value('');
                    } else {
                        ScreenService.confirmMessage("A 'Razão Social' informada, já está vinculada a outro prospect. <br><br> Deseja continuar? ", 'CONFIRMATION',
                            function(success) {}.bind(this),
                            function(fail) {
                                razSoc.value('');
                            }
                        );
                    }
                } else if (!Util.isEmptyOrBlank(response.dataset.DADOS.LEADS) && response.dataset.DADOS.PARCEXISTS) {
                    self.buildReturnedParcRow(widget, response.dataset.DADOS.LEADS);
                } else if (Array.isArray(response.dataset.DADOS.LEADS) && !Util.isEmptyOrBlank(response.dataset.DADOS.LEADS) && response.dataset.DADOS.PARCEXISTS) {
                    var leads = response.dataset.DADOS.LEADS;
                    var mensagemInscricaoVinculada = this.criarMensagemInscricaoJaVinculada(leads);
                    ScreenService.showMessage(mensagemInscricaoVinculada);
                    
                    widget.fields.find(function(x) { return x.label == 'Inscrição'; }).clearValue();
                    widget.fields.find(function(x) { return x.label == 'Tipo de Inscrição'; }).value('I');
                    widget.currentRow.INSCRICAO = "";
                    widget.currentRow.NOME = "";
                    widget.currentRow.CNPJRAIZ = "";
                }
            }.bind(this));
        }
    };
    
    this.verifyFilter = function() {
        var widget = templateManager.container.getWidget('gridLead');
    
        if (!widget) {
            console.error('Widget not found.');
            return;
        }
    
        var modified = false;
    
        if (widget.dataSourceFilter) {
            widget.dataSourceFilter.forEach(function(filtro, index) {
                if(filtro.name == 'NRPARCNEGOCIO' && !widget.fromMap) {
                    widget.dataSourceFilter.splice(index, 1);
                    modified = true;
                }
                if(filtro.name == 'NRPARCNEGOCIO' && widget.fromMap) {
                    widget.dataSourceFilter.splice(index, 1);
                    widget.fromMap = false;
                }
            });
        }
    
        if(modified && !widget.fromMap) {
            widget.reload();
        }
    };
    
    this.verifyHasRelationship = function() {
        var widget = templateManager.container.getWidget('gridLead');
        var evolWidget = templateManager.container.getWidget('evolucao');
        var currentRow = widget.currentRow;
    
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                General.callRestEngine("product#/verifyParcGroupRel", "DataSet", [currentRow]).then(function(response) {
                    if(response.dataset && response.dataset.error) {
                        ScreenService.showMessage(response.dataset.error, 'ERROR');
                    }
                    if(response.dataset && !Util.isEmptyOrBlank(response.dataset.RELATIONSHIP)) {
                        ScreenService.confirmMessage(response.dataset.RELATIONSHIP.PAI.NRINSCRICAOPARC + ' – ' + response.dataset.RELATIONSHIP.PAI.NMPRINCIPALPARC + ' possui parceiros relacionados. ' +
                            'Deseja criar uma evolução para os parceiros relacionados alterando o status destes parceiros para a organização ' + templateManager.LOGGEDOPERATOR.CRM_NRORGTRAB + ' - ' + templateManager.LOGGEDOPERATOR.NMORGTRAB, 'CONFIRMATION', function () {
                                widget.PARCUPDATE = response.dataset.RELATIONSHIP.FILHOS;
                                this.convertLeadAfterEvolution(evolWidget);
                            }.bind(this));
                    } else {
                        this.convertLeadAfterEvolution(evolWidget);
                    }
                }.bind(this));
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    };


    /*
    Codigos para adição e ediçao de interlocutor na evolução
    */
   
    this.prepararInterlocutor = function (widget) {
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var currentRow = widget.currentRow;
        currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
        currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

        var parceiroController = CRM_Utilities.getController('CRM_ParceiroNegocio_Controller');
    
        parceiroController.checkIfCanEditOrEvolParc(nrParcNegocio).then(
          function (canEdit) {
            if (canEdit) {
              General.callRestEngine("product#/verifyGroupRel", "DataSet", [
                currentRow,
              ]).then(
                function (response) {
                  if (response.dataset && response.dataset.error) {
                    ScreenService.showMessage(response.dataset.error, "ERROR");
                  }
                  if (response.dataset && response.dataset.GROUPREL[0] == false) {
                    var parent = templateManager.container.getWidget(
                      widget.parentName
                    );
    
                    CRM_Utilities.setColumnToReturnInCurrentRow(
                      widget.currentRow,
                      "NRSEQINTERLOCUTOR"
                    );
                    this.removeInterlocutorPhoneMask(widget);
    
                    if(widget.currentRow.NRCPFINTERLOC){
                        widget.currentRow.NRCPFINTERLOC = widget.currentRow.NRCPFINTERLOC.replace(
                          /[^0-9]/g,
                          ""
                        );
                    } else {
                        widget.currentRow.NRCPFINTERLOC = null;
                    };
                    
                    this.salvarInterlocutor(widget.currentRow).then(function (
                      response,
                      widget
                    ) {
                      var currentRow = templateManager.container.getWidget(
                        "popupNovoInterlocutor"
                      );
                      if (currentRow.filtro === true) {
                        var widgetfilter = templateManager.container.getWidget(
                          "popupNovoInterlocutor"
                        ).__filterPopup;
                        var widgetprospect = templateManager.container.getWidget(
                          "gridLead"
                        );
                        var widgetConvertfilter = templateManager.container.getWidget(
                          "evolucao"
                        );
                        widgetConvertfilter.currentRow.NMINTERLOCUTOR =
                          widget.currentRow.NMINTERLOCUTOR;
    
                        widgetfilter.template = "widget/form.html";
                        widgetfilter.activate();
                        widgetprospect.widgets[0].fields[7].defaultValue =
                          widget.currentRow.NMINTERLOCUTOR;
                        ScreenService.closePopup(true);
                        ScreenService.showMessage(
                          "Interlocutor criado com sucesso!"
                        );
                      } else {
                        var widgetcurrent = templateManager.container.getWidget(
                          "popupNovoInterlocutor"
                        );
    
                        parent.currentRow.NRSEQINTERLOCUTOR =
                          response.dataset.columnsToReturn[0].NRSEQINTERLOCUTOR;
                        parent.currentRow.NMINTERLOCUTOR =
                          widgetcurrent.currentRow.NMINTERLOCUTOR;
                        parent.currentRow.EMAILINTERLOC =
                          widgetcurrent.currentRow.EMAILINTERLOC;
    
                        ScreenService.closePopup(true);
    
                        ScreenService.showMessage(
                          "Interlocutor criado com sucesso!"
                        ).then(function () {
                          parent.activate();
                          parent.reload();
                        });
                      }
                    });
                  } else {
                    ScreenService.showMessage(
                      "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                      response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                      " - " +
                      response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                      "!"
                    );
                  }
                }.bind(this)
              );
            } else {
              this.showMessageCantEditParc();
            }
          }.bind(this)
        );
    };

    this.removeInterlocutorPhoneMask = function (widget) {
        var currentRow = widget.currentRow;
        var phoneFields = ["NRTELEFONE1"];

        phoneFields.forEach(function (phone) {
            if (currentRow[phone]) {
            currentRow[phone] = currentRow[phone].replace(/[^0-9]/g, "");
            }
        });
    };

    this.salvarInterlocutor = function (currentRow) {
        var paramsRestEngine = {
          requestType: "Row",
          row: currentRow,
        };
        return restEngine.post("/crm_interlocutor/save", paramsRestEngine);
    };

    this.selectInterlocutor = function (widget){
        var parent = templateManager.container.getWidget("evolucao");

        parent.currentRow.NRSEQINTERLOCUTOR = widget.currentRow.NRSEQINTERLOCUTOR;
        parent.currentRow.NMINTERLOCUTOR = widget.currentRow.NMINTERLOCUTOR;
        parent.currentRow.EMAILINTERLOC = widget.currentRow.EMAILINTERLOC;
    
        ScreenService.closePopup(true);
    };

    this.showsResale = function (widget) {
        var source = widget.getField("NMMODODIVULG").value();
        var fieldResale = [widget.getField("LEADNRREVENDA"), widget.getField("NMRAZSOCREVENDA")]
        
        if (source == "Revenda") {
            fieldResale.forEach(function(field) {
                field.isVisible  = true;
                field.reload();                
            });
        } else {
            fieldResale.forEach(function(field) {
                field.isVisible  = false;
                field.clearValue();
                field.reload();
            });            
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm00040_Lead_Controller', crm00040_Lead_Controller);
});