// FILE: ./assets/js/general/evolutionTabController.js
function evolutionTabController(ScreenService, templateManager, metaDataFactory, ZHPromise, General){
    
    /**
     * Tranforma o JSON da tab em uma widget de fato.
     * 
     * @param {object} widget widget que irá receber a tab.
     * 
     * @param {string} nrparcnegocio nome do campo com o número
     * do parceiro de negócio.
     * 
     * @return widget evolucao construida.
     * 
    */
    function _factoryEvolutionTab(activeWidget) {
        
        
        var evolutionTabWidgetJson = {
            "id": "1722319758311315390513",
            "container":activeWidget.container,
            "parent":activeWidget,
            "name": "WDGT_EVOLUCAO",
            "label": "Evoluções",
            "isVisible": true,
            "showDescriptionOrder": false,
            "template": "widget/master_detail/grid.html",
            "dataSource": {
                "name": "/evolcont_contato",
                "rest": true,
                "lazyLoad": true
            },
            "fieldGroups": [
                {
                    "name": "FG_AGENDAR_TAREFA",
                    "label": "Próxima Tarefa",
                    "collapsible": true,
                    "opened": true
                }
            ],
            "dataSourceFilter": [
                {
                    "name": "NRSEQCONTATO",
                    "operator": "=",
                    "value": ""
                },
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": "@templateManager.LOGGEDOPERATOR.NRORG@"
                },
                {
                    "name": "CRM_NRORGTRAB",
                    "operator": "=",
                    "value": "@getLocalVar('CRM_NRORGTRABALHO')@"
                }
            ],
            "fields": [
                {
                    "id": "02",
                    "name": "NRSEQCONTATO",
                    "label": "Contato",
                    "template": "field/datetime.html",
                    "showOnForm": false,
                    "showOnList": false,
                    "isVisible": false,
                    "readOnly": false,
                    "class": "6",
                    "defaultValue":"@General.getFieldValue('NRSEQCONTATO', '"+activeWidget.name+"')@",
                    "events": []
                },
                {
                    "id": "03",
                    "name": "NRORG",
                    "label": "Org",
                    "template": "field/datetime.html",
                    "showOnForm": false,
                    "showOnList": false,
                    "isVisible": false,
                    "readOnly": false,
                    "class": "6",
                    "defaultValue":"@getLocalVar('CRM_NRORGTRAB')@",
                    "events": []
                },
                {
                    "id": "04",
                    "name": "DTHREVOLCONT",
                    "label": "Data da Evolução",
                    "template": "field/datetime.html",
                    "showOnForm": true,
                    "showOnList": true,
                    "isVisible": true,
                    "readOnly": false,
                    "defaultValue":"@CRM_Utilities.getDataHoraAtual()@",
                    "class": "6",
                    "events": []
                },
                {
                    "id": "05",
                    "name": "IDSENEVOCONT",
                    "label": "Sentido",
                    "template": "field/select-native.html",
                    "showOnForm": true,
                    "showOnList": true,
                    "class": "6",
                    "valueField": "IDSENEVOCONT",
                    "descriptionField": "NMSENEVOLCONT",
                    "defaultValue": "S",
                    "isVisible": true,
                    "events": [],
                    "validations":{
                        "required":true
                    },
                    "filterProperties":{
                        "validations":{}
                    },
                    "hideEmptyValue":true,
                    "dataSource": {
                        "data": [
                            {
                                "NMSENEVOLCONT": "Entrada",
                                "IDSENEVOCONT":"E"
                            },
                            {
                                "NMSENEVOLCONT": "Saída",
                                "IDSENEVOCONT":"S"
                            }
                        ]
                    }
                },
                {
                    "id": "06",
                    "name": "NMOPERADOR",
                    "label": "Operador Responsável",
                    "template": "field/select.html",
                    "class": "12",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnView": true,
                    "showOnForm": true,
                    "readOnly": false,
                    "dataSource": {
                        "name": "product#/operador",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "defaultValue": "@getLocalVar('CRM_NMOPERADOR')@",
                    "itemsPerPage": 50,
                    "dataSourceFilter": [
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": "@getLocalVar('CRM_NRORGTRAB')@"
                        },
                        {
                            "name": "IDATIVO",
                            "operator": "=",
                            "value": "S"
                        }
                    ],
                    "descriptionField": "NMOPERADOR",
                    "valueField": "CDOPEREVOL",
                    "outData":{
                        "CDOPERADOR" : "CDOPEREVOL",
                        "NMOPERADOR" : "NMOPERADOR",
                        "DSEMAILOPER": "DSEMAILOPER"
                    },
                    "showSelectAs": "grid",
                    "fields": [
                        {
                            
                            "name": "NMOPERADOR",
                            "label": "Operador",
                            "showOnList": true
                        }
                    ],
                    "validations": {},
                    "events": []
                },
                {
                    "id": "07",
                    "name": "CDOPEREVOL",
                    "label": "Código Operador",
                    "template": "field/datetime.html",
                    "showOnForm": false,
                    "showOnList": false,
                    "isVisible": false,
                    "readOnly": false,
                    "class": "6",
                    "defaultValue":"@templateManager.LOGGEDOPERATOR.CDOPERADOR@",
                    "events": []
                },
                {
                    "id": "08",
                    "name": "NMTIPOCONT",
                    "label": "Tipo de Contato",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "isVisible": true,
                    "showOnForm": true,
                    "showOnList": true,
                    "class": "6",
                    "readOnly": false,
                    "dataSource": {
                        "name": "product#/crud/tipocont",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "itemsPerPage": 50,
                    "dataSourceFilter": [
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": "@getLocalVar('CRM_NRORGTRAB')@"
                        },
                        {
                            "name": "IDATIVO",
                            "operator": "=",
                            "value": "S"
                        }
                    ],
                    "descriptionField": "NMTIPOCONT",
                    "valueField": "CDTIPOCONT",
                    "fields": [
                        {
                            
                            "name": "NMTIPOCONT",
                            "label": "Tipo de Contato",
                            "showOnList": true
                        }
                    ],
                    "validations":{  
                        "required":true
                    },
                    "events": []
                },
                {
                    "id": "09",
                    "name": "NMMOTIEVOCON",
                    "label": "Motivo da Evolução",
                    "template": "field/select.html",
                    "class": "6",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnView": true,
                    "showOnForm": true,
                    "readOnly": false,
                    "dataSource": {
                        "name": "product#/motievolcont_crm_perfiresult_crm_perfioper",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "itemsPerPage": 50,
                    "dataSourceFilter": [
                        {
                            "name": "P_NRORG",
                            "operator": "=",
                            "value": "@getLocalVar('CRM_NRORGTRAB')@"
                        },
                        {
                            "name": "P_CDOPERADOR",
                            "operator": "=",
                            "value": "@getLocalVar('CRM_CDOPERADOR')@"
                        }
                    ],
                    "outData": {
                        "NMMOTIEVOCON": "NMMOTIEVOCON",
                        "CDMOTIEVOCON": "CDMOTIEVOCON",
                        "IDENVIAEMAIL": "IDENVIAEMAIL",
                        "NMANEXOPADRAO": "NMANEXOPADRAO",
                        "DSCAMINHOANEXOPADRAO": "DSCAMINHOANEXOPADRAO"
                    },
                    "descriptionField": "NMMOTIEVOCON",
                    "valueField": "CDMOTIEVOCON",
                    "showSelectAs": "grid",
                    "fields": [
                        {
                            
                            "name": "NMMOTIEVOCON",
                            "label": "Motivo da Evolução",
                            "showOnList": true
                        }
                    ],
                    "validations":{  
                        "required":true
                    },
                    "events":[
                        {
                            "name":"FieldOnChange",
                            "code":"evolutionTabController.checkMotievolcont(args.owner.field.widget)"
                        }
                    ]
                },
                {
                    "id": "010",
                    "name": "NMINTERLOCUTOR",
                    "label": "Interlocutor",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "isVisible": true,
                    "showOnForm": true,
                    "showOnList": true,
                    "readOnly": false,
                    "class": "6",
                    "valueField": "NRSEQINTERLOCUTOR",
                    "descriptionField": "NMINTERLOCUTOR",
                    "dataSource": {
                        "name": "product#/crm_interlocutor",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "itemsPerPage": 50,
                    "dataSourceFilter": [
                   
                        {
                            "name": "NRPARCNEGOCIO",
                            "operator": "=",
                            "value": "@General.getFieldValue('NRPARCNEGOCIO', '"+activeWidget.name+"')@"
                        },
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": "@getLocalVar('CRM_NRORGTRAB')@"
                        }
                    ],
                    "outData": {
                        "NRSEQINTERLOCUTOR": "NRSEQINTERLOCUTOR",
                        "EMAILINTERLOC": "EMAILINTERLOC",
                        "NRTELEFONE1": "NRTELEFONE1",
                        "NMINTERLOCUTOR": "NMINTERLOCUTOR"
                    },
                    "fields": [
                        {
                            
                            "name": "NMINTERLOCUTOR",
                            "label": "Nome Interlocutor",
                            "isVisible": true,
                            "showOnList": true
                        }
                    ],
                    "events": [
                        {
                            
                            "name": "FieldAfterSelectOpen",
                            "code": "args.owner.field.reload()"
                        }
                    ],
                    "filterProperties": {
                        "isVisible": false,
                        "showOnForm": false
                    }
                },
                {
                    "id": "12932085129618812781121755128",
                    "name": "ESTADOINTERLOCUTOR",
                    "label": "Estado (Interlocutor)",
                    "template": "field/text-edit.html",
                    "showOnForm": false,
                    "showOnView": false,
                    "showOnList": true,
                    "isVisible": true,
                    "events": []
                },
                {
                    "id": "12932085112296181287811127559",
                    "name": "CIDADEINTERLOCUTOR",
                    "label": "Cidade (Interlocutor)",
                    "template": "field/text-edit.html",
                    "showOnForm": false,
                    "showOnView": false,
                    "showOnList": true,
                    "isVisible": true,
                    "events": []
                },
                {
                    "id": "011",
                    "name": "NMSEQRESULEVOL",
                    "label": "Resultado",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "isVisible": true,
                    "showOnForm": true,
                    "showOnList": true,
                    "class": "6",
                    "dataSource": {
                        "name": "product#/crm_resultevol_crm_perfiresult_crm_perfioper",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "itemsPerPage": 50,
                    "dataSourceFilter": [
                        {  
                            "name":"P_NRORG",
                            "operator":"=",
                            "value":"@getLocalVar('CRM_NRORGTRAB')@"
                        },
                        {  
                            "name":"P_CDOPERADOR",
                            "operator":"=",
                            "value":"@getLocalVar('CRM_CDOPERADOR')@"
                        },
                        {  
                            "name":"IDRESULTEVOLUCAO",
                            "operator":"=",
                            "value":"SIM"
                        }
                    ],
                    "descriptionField": "DESCRESULEVOL",
                    "valueField": "NRSEQRESULEVOL",
                    "fields": [
                        {
                            
                            "name": "DESCRESULEVOL",
                            "label": "Resultado da Evolução",
                            "showOnList": true
                        }
                    ],
                    "outData": {
                        "IDGERPROXATIV": "NEWTASK",
                        "DESCRESULEVOL": "NMSEQRESULEVOL",
                        "NRSEQRESULEVOL":"NRSEQRESULEVOL"
                    },
                    "validations":{  
                        "required":true
                    },
                    "events": [
                        {
                            
                            "name": "FieldOnChange",
                            "code": "EvolucaoController.checkNewTask(args.owner.field.widget)"
                        }
                    ]
                },
                {
                    "id": "012",
                    "name": "TXEVOLCONT",
                    "label": "Descrição",
                    "template": "field/textarea.html",
                    "isVisible": true,
                    "showOnForm": true,
                    "class": "12",
                    "validations":{  
                        "required":true
                    },
                    "textRows": 5
                },
                {
                    "id": "013",
                    "name": "DTPLANFILACONTA",
                    "label": "Data da Próxima Tarefa",
                    "template": "field/datetime.html",
                    "showOnForm": true,
                    "showOnList": false,
                    "isVisible": true,
                    "readOnly": true,
                    "class": "4",
                    "fieldGroup": "FG_AGENDAR_TAREFA",
                    "events": []
                },
                {
                    "id": "014",
                    "name": "NMOPERADORREAL",
                    "label": "Operador",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "isVisible": true,
                    "showOnForm": true,
                    "showOnView": true,
                    "showOnList": false,
                    "readOnly": true,
                    "fieldGroup": "FG_AGENDAR_TAREFA",
                    "class": "4",
                    "dataSource": {
                        "name": "product#/operador",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "defaultValue": "@getLocalVar('CRM_NMOPERADOR')@",
                    "itemsPerPage": 50,
                    "dataSourceFilter": [
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": "@getLocalVar('CRM_NRORGTRAB')@"
                        },
                        {
                            "name": "IDATIVO",
                            "operator": "=",
                            "value": "S"
                        }
                    ],
                    "descriptionField": "NMOPERADORREAL",
                    "valueField": "CDOPERREAL",
                    "fields": [
                        {
                            
                            "name": "NMOPERADOR",
                            "label": "Operador",
                            "showOnList": true
                        }
                    ],
                    "outData": {
                        "NMOPERADOR": "NMOPERADORREAL",
                        "CDOPERADOR": "CDOPERREAL",
                        "DSEMAILOPER": "DSEMAILOPER"
                    },
                    "validations": {},
                    "events": []
                },
                {
                    "id": "",
                    "name": "DSCLASSIFICATAREFA",
                    "label": "Classificação da Tarefa",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "fields": [
                        {
                            "id": "1616168282555678644284",
                            "name": "DSCLASSIFICATAREFA",
                            "label": "Classificação da Tarefa",
                            "showOnList": true,
                            "isVisible": true,
                            "template": "field/text-edit.html"
                        }
                    ],
                    "isVisible": true,
                    "readOnly": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "fieldGroup": "FG_AGENDAR_TAREFA",
                    "class": "4",
                    "valueField": "NRSEQCLASSIFICATAREFA",
                    "descriptionField": "DSCLASSIFICATAREFA",
                    "dataSource": {
                        "name": "product#/crm_classificatarefa",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "itemsPerPage": 50,
                    "dataSourceFilter": [],
                    "outData": {
                        "NRSEQCLASSIFICATAREFA": "NRSEQCLASSIFICATAREFA",
                        "DSCLASSIFICATAREFA": "DSCLASSIFICATAREFA"
                    },
                    "events": [],
                    "searchableFields": [
                        "DSCLASSIFICATAREFA"
                    ],
                    "displayedFields": [
                        "DSCLASSIFICATAREFA"
                    ]
                },
                {
                    "id": "015",
                    "name": "CDOPERREAL",
                    "label": "Código Operador",
                    "template": "field/datetime.html",
                    "showOnForm": false,
                    "showOnList": false,
                    "isVisible": false,
                    "readOnly": false,
                    "class": "6",
                    "defaultValue":"@templateManager.LOGGEDOPERATOR.CDOPERADOR@",
                    "events": []
                },
                {
                    "id": "016",
                    "name": "DSFILACONTATO",
                    "label": "Assunto da Tarefa",
                    "template": "field/text-edit.html",
                    "showOnForm": true,
                    "fieldGroup": "FG_AGENDAR_TAREFA",
                    "readOnly": true,
                    "showOnList": true,
                    "isVisible": true,
                    "defaultValue": "Retornar contato",
                    "class": "12",
                    "events": []
                }
            ],
            "actions": [
                {
                    "id": "017",
                    "name": "BACK_VIEW",
                    "label": "Voltar",
                    "isVisible": true,
                    "preventHide":true,
                    "showAsAction": "back_view",
                    "events": [
                        {
                            
                            "name": "ActionEvent",
                            "code": "General.widgetGoBackToList(args.owner.widget);"
                        }
                    ]
                },
                {
                    "id": "018",
                    "name": "BACK_LIST",
                    "label": "Voltar",
                    "isVisible": true,
                    "preventHide":true,
                    "showAsAction": "back_list",
                    "events": [
                        {
                            
                            "name": "ActionEvent",
                            "code": "General.widgetGoBackToParent(args.owner.widget);"
                        }
                    ]
                },
                {
                    "id": "019",
                    "name": "BACK_EDIT",
                    "label": "Cancelar",
                    "isVisible": true,
                    "showAsAction": "back_edit",
                    "events": [
                        {
                            
                            "name": "ActionEvent",
                            "code": "General.widgetCancelForm(args.owner.widget)"
                        }
                    ]
                },
                {
                    "id": "020",
                    "name": "EDIT",
                    "label": "Editar",
                    "icon": "pencil",
                    "isVisible": true,
                    "showAsAction": "view",
                    "events": [
                        {
                            
                            "name": "ActionEvent",
                            "code": "General.widgetEdit(args.owner.widget)"
                        }
                    ]
                },
                {
                    "id": "021",
                    "name": "ADD",
                    "label": "Adicionar",
                    "icon": "plus",
                    "showAsAction": "always|list",
                    "events": [
                        {
                            
                            "name": "ActionEvent",
                            "code": "General.widgetNewRow(args.owner.widget)"
                        }
                    ]
                },
                {
                    "id": "022",
                    "name": "SAVE",
                    "label": "Salvar",
                    "showAsAction": "never_edit",
                    "events": [
                        {
                            
                            "name": "ActionEvent",
                            "code": "EvolucaoController.checkEvolution(args.owner.widget)"
                        }
                    ]
                },
                {
                    "id": "023",
                    "name": "DELETE",
                    "label": "Excluir",
                    "icon": "trash",
                    "isVisible": false,
                    "preventHide": true,
                    "showAsAction": "view",
                    "events": [
                        {
                            "id": "024",
                            "name": "ActionEvent",
                            "code": "General.deleteCrud(args.owner.widget);"
                        }
                    ]
                }
            ],
            "events": [
                {
                    "id": "025",
                    "name": "WidgetOnEnterOnce",
                    "code": "CRM_Utilities.factoryWidgetActions(args.owner)"
                },
                {
                    "id": "026",
                    "name": "WidgetOnEnter",
                    "code": "CRM_Utilities.setDataSourceFilterOnDynamicTabs(args.owner, templateManager.container.getWidget('" + activeWidget.name + "'))"
                }
            ],
            "widgets": [
                {
                    "id": "1722319758311315390514",
                    "container":activeWidget.container,
                    "name": "WDGT_ANEXOS_EVOLUCAO",
                    "label": "Anexos",
                    "isVisible": true,
                    "showDescriptionOrder": false,
                    "template": "widget/master_detail/grid.html",
                    "dataSource": {
                        "name": "/crm_anexocontato",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "dataSourceFilter": [
                        {
                            "name": "NRSEQCONTATO",
                            "operator": "=",
                            "value": "@General.getFieldValue('NRSEQCONTATO', 'WDGT_EVOLUCAO')@"
                        },
                        {
                            "name": "NRORIGEM",
                            "operator": "=",
                            "value": "@General.getFieldValue('NRSEQEVOLCONT', 'WDGT_EVOLUCAO')@"
                        }
                    ],
                    "events": [
                        {
                            "id": "17223197583113153905171",
                            "name": "WidgetOnEnter",
                            "code": "args.owner.reload()"
                        }
                    ],
                    "actions": [
                        {
                            "id": "1722319758311315390516",
                            "name": "DOWNLOAD",
                            "label": "Download",
                            "isVisible": true,
                            "showAsAction": "never_view",
                            "events": [
                                {
                                    "id": "030",
                                    "name": "ActionEvent",
                                    "code": "EvolucaoController.downloadFile(args.owner.widget);"
                                }
                            ]
                        },
                        {
                            "id": "1722319758311315390517",
                            "name": "ADD",
                            "label": "Adicionar",
                            "icon": "plus",
                            "showAsAction": "always|list",
                            "events": [
                                {
                                    "id": "032",
                                    "name": "ActionEvent",
                                    "code": "EvolucaoController.openAttachSwipe();"
                                }
                            ]
                        },
                        {
                            "id": "1722319758311315390518",
                            "name": "BACK_LIST",
                            "label": "Voltar",
                            "isVisible": true,
                            "preventHide":true,
                            "showAsAction": "back_list",
                            "events": [
                                {
                                    "id": "035",
                                    "name": "ActionEvent",
                                    "code": "General.widgetGoBackToParent(args.owner.widget);"
                                }
                            ]
                        },
                        {
                            "id": "172231975831131539051911",
                            "name": "BACK_VIEW",
                            "label": "Voltar",
                            "isVisible": true,
                            "preventHide":true,
                            "showAsAction": "back_view",
                            "events": [
                                {
                                    "id": "037",
                                    "name": "ActionEvent",
                                    "code": "General.widgetGoBackToList(args.owner.widget);"
                                }
                            ]
                        },
                        {
                            "id": "1722319758311315390591",
                            "name": "DELETE",
                            "label": "Excluir",
                            "icon": "trash",
                            "showAsAction": "view",
                            "events": [
                                {
                                    "id": "039",
                                    "name": "ActionEvent",
                                    "code": "General.deleteCrud(args.owner.widget);"
                                }
                            ]
                        }
                    ],
                    "fields": [
                        {
                            "id": "1722319758311315390592",
                            "name": "NRORIGEM",
                            "label": "Código",
                            "template": "field/text-edit.html",
                            "class": "6",
                            "showOnList": false,
                            "isVisible": false,
                            "readOnly": false
                        },
                        {
                            "id": "1722319758311315390593",
                            "name": "NMARQUIVO",
                            "label": "Nome do arquivo",
                            "class": "12",
                            "isVisible": true,
                            "showOnList": true,
                            "showOnView": true,
                            "readOnly": false,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id": "1722319758311315390594",   
                            "name": "DSTIPO",
                            "label": "Extensão",
                            "class": "6",
                            "isVisible": true,
                            "showOnList": true,
                            "showOnView": true,
                            "readOnly": false,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id": "1722319758311315390595",
                            "name": "VRTAMANHO",
                            "label": "Tamanho do arquivo(bytes)",
                            "class": "6",
                            "isVisible": true,
                            "showOnList": true,
                            "showOnView": true,
                            "readOnly": false,
                            "template": "field/text-edit.html"
                        }
                    ],
                    "widgets": [
                        {
                            "id": "1722319758311315390515",
                            "container":activeWidget.container,
                            "name": "WDGT_SELECAO_ARQUIVOS",
                            "label": "Anexar",
                            "isVisible": false,
                            "template": "widget/form.html",
                            "dataSource": {},
                            "actions": [
                                {
                                    "id": "1722319758311315390519112",
                                    "name": "uploadFile",
                                    "isVisible": true,
                                    "label": "Anexar",
                                    "showAsAction": "never",
                                    "events": [
                                        {
                                            "id": "046",
                                            "name": "ActionEvent",
                                            "code": "EvolucaoController.uploadEvolutionFiles(args.owner.widget);"
                                        }
                                    ]
                                },
                                {
                                    "id": "1722319758311315390519113",
                                    "name": "BACK",
                                    "label": "Cancelar",
                                    "isVisible": true,
                                    "showAsAction": "back",
                                    "events": [
                                        {
                                            "id": "1722319758311315390519114",
                                            "name": "ActionEvent",
                                            "code": "EvolucaoController.closeAttachSwipe(args.owner.widget);"
                                        }
                                    ]
                                }
                            ],
                            "events": [
                                {
                                    "id": "1722319758311315390597",
                                    "name": "WidgetOnEnter",
                                    "code": "args.owner.newRow();"
                                }
                            ],
                            "fields": [
                                {
                                    "id": "1722319758311315390598",
                                    "name": "DSCAMINHO",
                                    "placeholder": "Anexar arquivo",
                                    "class": "10 col-xs-offset-1",
                                    "isVisible": true,
                                    "readOnly": false,
                                    "descriptionOrder": 1,
                                    "validations": {
                                        "required": true
                                    },
                                    "template": "field/file-upload.html",
                                    "isMultiple": true
                                }
                            ]
                        }
                    ]
                }
            ]
        };
        
        var evolutionTabWidget = metaDataFactory.widgetFactory(evolutionTabWidgetJson);
        
        return evolutionTabWidget;
        
    }
    
    
    
    /**
     * Insere a widget de evoluções na widget recebida como 
     * parâmetro.
     * 
     * @param {object} widget widget que receberá a tab.
     * 
     * @param {string} nrparcnegocio nome referente ao
     * campo de parceiro de negócio.
    */
    this.setEvolutionTabOnActiveWidget = function(widget){
        
        widget.widgets.push(_factoryEvolutionTab(widget));
        
    };
    
    /**
     * Sobreescreve qualquer action da tab.
     * 
     * @param {string} actionName nome da action que será sobrescrita.
     *   BACK_VIEW -> Voltar para o grid da tab.
     *   BACK_LIST -> Voltar para o grid principal.
     *   BACK_EDIT -> Cancelar Edição.
     *   EDIT      -> Editar.
     *   ADD       -> Nova Evolução.
     *   SAVE      -> Salvar.
     *   DELETE    -> Excluir.
     * 
     * @param {string} code nome do controller + nome do metodo a ser executado.
     * Ex.:XYController.xyMethod()
    */
    this.overwriteAction = function(actionName, code){
        var evolutionWidget = templateManager.container.getWidget('WDGT_EVOLUCAO');
        if(!evolutionWidget.getAction(actionName).events[0].defaultCode)
            evolutionWidget.getAction(actionName).events[0].defaultCode = evolutionWidget.getAction(actionName).events[0].code;
        templateManager.container.getWidget('WDGT_EVOLUCAO').getAction(actionName).events[0].code = code;    
    };
    
    /**
     * Volta para o evento defalut de qualquer action.
     * 
     * @param {string} actionName nome da action que será sobrescrita.
     *   BACK_VIEW -> Voltar para o grid da tab.
     *   BACK_LIST -> Voltar para o grid principal.
     *   BACK_EDIT -> Cancelar Edição.
     *   EDIT      -> Editar.
     *   ADD       -> Nova Evolução.
     *   SAVE      -> Salvar.
     *   DELETE    -> Excluir.
     * 
    */
    this.defaultAction = function(actionName){
        var evolutionWidget = templateManager.container.getWidget('WDGT_EVOLUCAO');
        if(evolutionWidget.getAction(actionName).events[0].defaultCode)
            evolutionWidget.getAction(actionName).events[0].code = evolutionWidget.getAction(actionName).events[0].defaultCode;
    };
    
    /**
     * Executa comandos após toda a rotina save da evolução.
     * 
     * @param {array} arrayOfMethods array de strings, cada posição 
     * um comando a ser executado.
     * Ex.:[
     *      "ScreenService.closeSwipe(true)",
     *      "XYController.xyMethod()"
     *    ]
    */
    this.setMethodsAfterSave = function(arrayOfMethods) {
        var evolutionWidget = templateManager.container.getWidget('WDGT_EVOLUCAO');
    
        // Verifique se a propriedade 'afterSave' existe no widget 'WDGT_EVOLUCAO'
        if (evolutionWidget.afterSave) {
            // Se existir, adicione os métodos de 'arrayOfMethods' ao array 'afterSave'
            Array.prototype.push.apply(evolutionWidget.afterSave, arrayOfMethods);
        } else {
            // Se 'afterSave' não existir, crie-a e atribua o valor de 'arrayOfMethods'
            evolutionWidget.afterSave = arrayOfMethods;
        }
    };
    
    
    /**
     * Builda novos fieldGroups na tab e chama o metodo de inserção de fields.
     * 
     * @param {array}  arrayOfFields array de fields(json).
     * @param {string} fieldGroupName nome do fieldGroup a ser inserido.
     * 
    */
    this.buildDynamicFieldGroup = function(arrayOfFields, fieldGroupName, fieldGroupLabel){
        var evolutionWidget = templateManager.container.getWidget('WDGT_EVOLUCAO');
        
        var fieldGroup = {
            "name":fieldGroupName,
            "label":fieldGroupLabel,
            "colapsible":true,
            "opened":true,
            "isVisible":true,
            "dynamic":true
        };
        if(this.checkFieldGroup(fieldGroup, evolutionWidget.fieldGroups) === -1){
            if(evolutionWidget.fieldGroups)
                evolutionWidget.fieldGroups.push(fieldGroup);
            else
                evolutionWidget.fieldGroups = [fieldGroup];
            
            evolutionWidget.fieldGroups = evolutionWidget.fieldGroups.map(function(item) {
    			item.widget = evolutionWidget;
    			return Util.extend(new FieldGroup(), item);
    		});
    		//Chama o metodo de inserção
            _insertFields(arrayOfFields, evolutionWidget);
        }
    };
    
    this.checkFieldGroup = function(fieldGroup, fieldGroups){
        var indexField = -1;
        fieldGroups.forEach(function(item, index){
            if(item.name === fieldGroup.name)
                indexField = index;
        });    
        return indexField;
    }
    
    /**
     * Builda os novos Fields na widget
     * 
     * @param {array}  arrayOfFields array de fields(json).
     * @param {string} fieldGroupName nome do fieldGroup a ser inserido.
     * 
    */
    function _insertFields(arrayOfFields, widget){
        arrayOfFields.forEach(function(field){
            field.dynamic = true;
            metaDataFactory.fieldFactory(field, widget, true);  
        });
    }
    
    /**
     * Esconde determinados fieldGroups
     * 
     * @param {string/true} fieldGroupName nome do field
     * group a ser escondido, se = true, esconde todos.
     * 
    */
    this.hideFieldGroup = function(fieldGroupName){
        var evolutionWidget = templateManager.container.getWidget('WDGT_EVOLUCAO');
        
        if(typeof fieldGroupName === "string"){
            evolutionWidget.fieldGroups.forEach(function(fg){
                if(fg.name === fieldGroupName && fg.dynamic){
                    fg.isVisible = false;
                }
            });    
        }else if(fieldGroupName && typeof fieldGroupName === "boolean"){
            evolutionWidget.fieldGroups.forEach(function(fg){
                if(fg.dynamic)
                    fg.isVisible = false;
            });   
        }
        
        evolutionWidget.fields.forEach(function(field){
            if(field.fieldGroup && (field.fieldGroup === fieldGroupName || fieldGroupName === true)){
                if(field.dynamic)
                    field.isVisible = false;
            }
        });
    };
    
    /**
     * Mostra determinados fieldGroups
     * 
     * @param {string/true} fieldGroupName nome do field
     * group a ser mostrado, se = true, mostra todos.
     * 
    */
    this.showFieldGroup = function(fieldGroupName){
        var evolutionWidget = templateManager.container.getWidget('WDGT_EVOLUCAO');
        
        if(typeof fieldGroupName === "string"){
            evolutionWidget.fieldGroups.forEach(function(fg){
                if(fg.name === fieldGroupName && fg.dynamic)
                    fg.isVisible = true;
            });    
        }else if(fieldGroupName && typeof fieldGroupName === "boolean"){
            evolutionWidget.fieldGroups.forEach(function(fg){
                if(fg.dynamic)
                    fg.isVisible = true;
            });   
        }
        
        evolutionWidget.fields.forEach(function(field){
            if(field.fieldGroup && (field.fieldGroup === fieldGroupName || fieldGroupName === true)){
                if(field.dynamic)
                    field.isVisible = true;
            }
        });
    };
    
    /**
     * Verifica se o motivo selecionado permite enviar email
     * para o interlocutor
     * 
     * @param {object} evolWidget  Widget de Evolução
     * 
    */
    this.checkMotievolcont = function(evolWidget){
        widgetMail.fields.forEach(function(field, index){
            if(field.name === 'DSCAMINHO')
                widgetMail.fields.splice(index,1);
        });
        if(evolWidget.currentRow.IDENVIAEMAIL === 'S'){
            //Salva o Anexo default no popup de email
            var file = {
                name: evolWidget.currentRow.NMANEXOPADRAO || '',
                path: evolWidget.currentRow.DSCAMINHOANEXOPADRAO || ''
            };
            this.insertAttachField(file);    
        }
    };
    
    this.insertAttachField = function(file){
        var field = {
            "name": "DSCAMINHO",
            "placeholder": "Anexar arquivo",
            "class": "12",
            "isVisible": true,
            "readOnly": false,
            "validations": {},
            "template": "field/file-upload.html",
            "isMultiple": true,
            "file":file
        };
        widgetMail.fields.push(field);     
    };
    
    var widgetMail = 
        {
            "name": "mensagens",
            "label": "Notificação de Interlocutor",
            "isVisible": false,
            "showAsTab": false,
            "template": "widget/form.html",
            "events": [
                {
                    "id": "6182828512039293853658",
                    "name": "WidgetOnEnter",
                    "code": "args.owner.reload();"
                }
            ],
            "actions": [
                {
                    "id": "618282851568652067654",
                    "name": "enviar",
                    "isVisible": true,
                    "label": "Enviar",
                    "showAsAction": "never",
                    "events": [
                        {
                            "id": "6182828514145614549655",
                            "name": "ActionEvent",
                            "code": "evolutionTabController.notificarInterlocutor(args.owner.widget, args.owner.widget.backuprow)"
                        }
                    ]
                },
                {
                    "id": "6182828511372890396656",
                    "name": "cancel",
                    "label": "Voltar",
                    "showAsAction": "back",
                    "events": [
                        {
                            "id": "6182828512205401251657",
                            "name": "ActionEvent",
                            "code": "ScreenService.closePopup(args.owner.widget);evolutionTabController.removeMessagesWidget(args.owner.widget.parent);"
                        }
                    ]
                }
            ],
            "fields": [
                {
                    "id": "6182828513466738669652",
                    "name": "DSTITULOMENSAGEM",
                    "label": "Assunto da Mensagem",
                    "isVisible": true,
                    "class": 12,
                    "descriptionOrder": 1,
                    "events": [],
                    "showOnList": true,
                    "showOnForm": true,
                    "showOnView": true,
                    "template": "field/text-edit.html",
                    "validations": {
                        "required": {},
                        "maxLength": {
                            "length": 100
                        }
                    }
                },
                {
                    "id": "6182828511660973795653",
                    "name": "DSMENSAGEM",
                    "label": "Mensagem",
                    "class": 12,
                    "placeholder": null,
                    "isVisible": true,
                    "showOnList": false,
                    "showOnForm": true,
                    "showOnView": true,
                    "template": "zh-rich-text#field/rich-text.html",
                    "height": 150,
                    "toolbar": {
                        "fontname": true
                    },
                    "validations": {
                        "required": {}
                    },
                    "events": [],
                    "filterProperty": {
                        "isVisible": false,
                        "showOnForm": false
                    }
                }
            ]
        };

    this.removeMessagesWidget = function(widget){
        widget.widgets.forEach(function(wid, index){
            if(wid.name === "mensagens")
                widget.widgets.splice(index, 1);
        });      
        widget.activate();
    };
    
    this.openWidgetSendMail = function(widget, widgetForActivate) {
        var promise = ZHPromise.defer();
        if (!widgetForActivate) {
            widgetForActivate = null;
        }
    
        if (widget.currentRow.EMAILINTERLOC) {
            widgetMail.container = widget.container;
            widgetMail = metaDataFactory.widgetFactory(widgetMail);
            widgetMail.parent = widget;
            widget.widgets.push(widgetMail);
            widgetMail.widgetForActivate = widgetForActivate;
    
            widgetMail.currentRow.DSMENSAGEM = '<table border="0" width="100%" cellpadding="0" cellspacing="0" bgcolor="eeeeee" style="background-color: #eeeeee;"> <tbody> <tr> <td> <table border="0" align="center" width="590" cellpadding="0" cellspacing="0" bgcolor="0274BA" class="container590" style="background-color: #0274ba; text-align: center;"> <tbody> <tr> <td> <table border="0" align="center" width="540" cellpadding="0" cellspacing="0" class="container580"> <tbody> <tr> <td align="center" valign="middle"> <table border="0" align="middle" cellpadding="0" cellspacing="0" style="border-collapse:collapse; mso-table-lspace:0pt; mso-table-rspace:0pt;" class=""> <tbody> <tr> <td align="center" valign="middle"> <p style="color: #ffffff; font-size: 25px; padding:20px; font-family: " Questrial ", Helvetica, sans-serif; line-height: 25px; padding-top:45px;">Notificação de Evolução</p> <p style="color: #ffffff; font-size: 16px; font-family: "Questrial", Helvetica, sans-serif; line-height: 15px; padding-top:15px;"> [DATAEVOLUCAO] </p> <p style="color: #ffffff; font-size: 16px; font-family: "Questrial", Helvetica, sans-serif; line-height: 15px; padding-top:15px;">&nbsp;</p> <p style="color: #ffffff; font-size: 16px; font-family: " Questrial ", Helvetica, sans-serif; line-height: 15px; padding-top:15px;"> <br> </p> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> <table border="0" width="100%" cellpadding="0" cellspacing="0" bgcolor="eeeeee"> <tbody> <tr> <td align="center"> <table border="0" align="center" width="590" cellpadding="0" cellspacing="0" bgcolor="ffffff" class="container590 bg_color"> <tbody> <tr> <td> <table border="0" align="center" width="540" cellpadding="0" cellspacing="0" class="container580"> <tbody> <tr> <td align="left" style="color: #39434b; font-size: 20px; font-family: " Montserrat ", Helvetica, sans-serif; font-weight: 400; padding-bottom:15px; padding-top:20px; line-height: 35px;" class="title_color"> <div style="padding:20px; line-height: 22px"> Prezado(a) [INTERLOCUTOR]</div> </td> </tr> <tr> <td align="left" class="title_color" style="color: #848999; font-size: 14px; font-family: " Questrial ", sans-serif; mso-line-height-rule: exactly; line-height: 24px; padding-bottom:15px;"> <div style="line-height: 24px;"> <br> </div> </td> </tr> <tr> <td height="10" style="font-size: 10px; line-height: 10px;">&nbsp;</td> </tr> </tbody> </table> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table>';
            
            // Seta o anexo default no field de upload
            widgetMail.currentRow.DATAEVOLUCAO = widget.currentRow.DTHREVOLCONT;
            widgetMail.backuprow = angular.copy(widget.currentRow);
            
            ScreenService.openPopup(widgetMail).then(function() {
                promise.resolve();
                widgetMail.activate();
            });
        } else {
            ScreenService.showMessage('Interlocutor não possui email cadastrado!').then(function() {
                promise.resolve();
            });
        }
        return promise.promise;
    };
    
    this.notificarInterlocutor = function(widget, row){
        var evolWidget = templateManager.container.getWidget('evolucao');
        if(!evolWidget){
            evolWidget = templateManager.container.getWidget('WDGT_EVOLUCAO');
            evolWidget.currentRow = row;    
        }
        
        var messagesWidget = templateManager.container.getWidget('mensagens');
        messagesWidget.fields.forEach(function(field, index){
            if(field.name === 'DSCAMINHO')
                messagesWidget.fields.splice(index,1);
        }); 
        
        var files = messagesWidget.currentRow.DSCAMINHO;
        var rows = [];
        
        if(!Util.isEmptyOrBlank(files)) {
            files.forEach(function(file, fileIndex){
                rows.push(this.setValuesForFileUpload({DSCAMINHO:widget.currentRow.DSCAMINHO}, fileIndex, evolWidget.currentRow));
                //Se for o anexo default
                if(!Util.isEmptyOrBlank(file.path)){
                    rows[0].DEFAULTATTACH = true;
                }
            }.bind(this));
        }else {
            rows.push(this.setValuesForFileUpload({DSCAMINHO:widget.currentRow.DSCAMINHO}, 0, evolWidget.currentRow));
            rows[0].DEFAULTATTACH = true;
        }
        
        General.callRestEngine("product#/saveAttachEvol", "DataSet", rows).then(function() {
            
                ScreenService.closePopup(true);
                widget.currentRow.NMINTERLOCUTOR  = evolWidget.currentRow.NMINTERLOCUTOR;
                widget.currentRow.DSEMAILINTERLOC = evolWidget.currentRow.EMAILINTERLOC;
                widget.currentRow.NRORG           = templateManager.LOGGEDOPERATOR.NRORG;
                widget.currentRow.NMOPERADORRESP  = evolWidget.currentRow.NMOPERADOR;
                widget.currentRow.NRSEQEVOLCONT   = evolWidget.currentRow.NRSEQEVOLCONT;
                General.callRestEngine("product#/notificaInterlocutorEvolucao", "Row", widget.currentRow);
                this.removeMessagesWidget(evolWidget);
                evolWidget.activate();
                ScreenService.successNotification("Interlocutor notificado com sucesso!");
                if(!Util.isEmptyOrBlank(widget.widgetForActivate)) {
                    var widForActivate = templateManager.container.getWidget(widget.widgetForActivate);
                    widForActivate.activate();
                    widForActivate.list();
                }
        }.bind(this));
        if(templateManager.promise)
            templateManager.promise.resolve();
    };
    
    /**
     * Função para retornar uma row configurada
     * com as informações do anexo referente
     * ao ID, recebido como parâmetro, no array
     * de anexos na currentRow.
     * 
     * @param {object} widget widget onde foi selecionado
     * os anexos.Array
     * 
     * @param {int} fileIndex index do anexo no array de 
     * anexos presente na currentRow.
     * 
     * @return {object} currentRow row configurada com as informações
     * do anexo referente ao ID recebido.
    */
    this.setValuesForFileUpload = function(row, fileIndex){
        
        var currentRow = angular.copy(row);
        var evolutionWidget = templateManager.container.getWidget('evolucao');
        if(!evolutionWidget){
            evolutionWidget = templateManager.container.getWidget('WDGT_EVOLUCAO');
        }
        var loggedOperatorInfos = templateManager.LOGGEDOPERATOR;
        
        currentRow.NRSEQCONTATO = evolutionWidget.currentRow.NRSEQCONTATO;
        currentRow.NMCOMPLETO = currentRow.DSCAMINHO ? currentRow.DSCAMINHO[fileIndex].name : "";
        currentRow.NMARQUIVO = currentRow.DSCAMINHO ? this.getFileNameWithoutExtension(currentRow.DSCAMINHO[fileIndex].name) : "";
        currentRow.DSTIPO = currentRow.DSCAMINHO ? this.getFileExtension(currentRow.DSCAMINHO[fileIndex].name) : "";
        currentRow.VRTAMANHO = currentRow.DSCAMINHO ? currentRow.DSCAMINHO[fileIndex].size : "";
        currentRow.IDATIVO = "S";
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
        currentRow.IDORIGEM = "EVOLUCAO";
        currentRow.NRORIGEM = evolutionWidget.currentRow.NRSEQEVOLCONT;
        
        return currentRow;
        
    };
    
    /**
     * Função para retornar a extenção de um arquivo
     * extraida do seu nome.
     * 
     * @param {string} fileName nome completo do arquivo.
    */
    this.getFileExtension = function(fileName){
        
        return fileName.replace(/^(.*)\.(.*)$/, "$2");
        
    };
    
    /**
     * Função para retornar o nome do arquivo sem
     * sua extenção.
     * 
     * @param {string} fileName nome completo do arquivo.
    */
    this.getFileNameWithoutExtension = function(fileName){
        
        return fileName.replace(/^(.*)\.(.*)$/, "$1");
            
    };
	
}
Configuration(function(ContextRegister){
    ContextRegister.register('evolutionTabController', evolutionTabController);
});

// FILE: ./assets/js/general/Messages.js
function Messages(){
    
    /* MENSAGENS DE ERRO (GERAL) */
    this.CATCH_EXCEPTION_ERROR = function(error) {
        return 'Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>';
    };

//--------------------------------------------------------------------------------------------------------------------

    /* GERAL */
    this.INSCRICAO_INVALIDA = "Inscrição Inválida!";
    this.ENDERECO_NAO_ENCONTRADO = "Endereço não encontrado.";
    this.CEP_INVALIDO = "CEP Inválido";
    this.ERRO_REQUSICAO_INFOS_OPERADOR_LOGADO = "Erro ao buscar as informações do operador logado.<br/>Contate um administrador.";
    this.ERRO_REQUSICAO_PARAMETRIZACOES = "Erro ao buscar as informações de parametrização do operador logado.<br/>Contate um administrador.";
    this.CONFIRMAR_DELETE = "Deseja realmente excluir este registro?";
    this.REMOVE_ROW_SUCCESS = 'Registro excluído com sucesso';
    this.REMOVE_ROW_ERROR = 'Erro ao excluir o registro';


//--------------------------------------------------------------------------------------------------------------------
    
    /* LEAD */
    this.LEAD_JA_QUALIFICADO = "Lead já qualificado.";
    this.LEAD_JA_DESQUALIFICADO = "Lead já desqualificado.";
    this.PARCEIROS_FUNDIDOS_SUCESSO = "Parceiros fundidos com sucesso.";
    this.LEAD_CONVERTIDO = "Lead convertido com sucesso.<br><br>Deseja ir para a tela de prospect exibindo o lead convertido?";
    this.DESATIVAR_LEAD = function(leadName){
        return "Deseja desativar o Lead \"" + leadName + "\"?";
    };
    this.ATIVAR_LEAD = function(leadName){
        return "Deseja ativar o Lead \"" + leadName + "\"?";
    };
    this.IMPOSSIVEL_DESATIVAR_POSSUI_EVOL = "Operação bloqueada<br/><br/>Este lead possui registros de evoluções.";
    
//--------------------------------------------------------------------------------------------------------------------    
    
    /* PROSPECT */
    this.TIPO_ENDERECO_JA_REGISTRADO = "Tipo de endereço já registrado.";
    this.PROSPECT_BLOQUEADO = "Operação bloqueada.<br/><br/>Este prospect já sendo trabalhado por outro operador.";

//--------------------------------------------------------------------------------------------------------------------    
    
    /* AGENDA DE TAREFAS */
    this.EXCLUSAO_TAREFA_VINC_EVOLUCAO = "Exclusão não permitida.<br/>Tarefa vinculada à uma evolução.<br/><br/><u>Deseja inativar a tarefa?<u/>";
    this.TAREFA_INATIVADA = "Tarefa inativada com sucesso.";
    this.TAREFA_CONCLUIDA = "Tarefa concluída com sucesso.";
    this.TAREFA_JA_CONCLUIDA = "Tarefa já concluída.";
    this.ERROR_EVOLUCAO_SEM_CONTATO = "Evolução não permitida.<br/>Tarefa não vinculada à um caso ou à uma oportunidade.";
    this.SELECIONAR_TAREFA_TRANSFERENCIA = "Selecione uma tarefa para ser transferida.";
    this.SELECIONAR_TAREFA_EXCLUSAO = "Selecione uma tarefa para ser excluída.";
    this.ERRO_TRASNFERIR_TAREFA_CONCLUIDA = "Não é possivel trasnferir tarefas concluídas.";
    
//--------------------------------------------------------------------------------------------------------------------    
    
    /* ASSISTENTE DE AGENDAMENTO */
    this.NAO_HA_PARCEIROS_FILTRADOR = "Registros não encontrados.<br/><br/>Deseja realizar uma busca por parceiros para gerenciar o assistente?";
    this.INTERVALO_INVALIDO = "Intervalo inválido.";
    this.TAREFAS_GERADAS_SUCESSO = "Tarefas geradas com sucesso.";
    this.CONFIRMACAO_GERADOR_DE_TAREFAS = function(numberofPartners) {
        return 'Deseja gerar tarefas em massa para os [' + numberofPartners + '] parceiros filtrados?';
    };
    this.ANO_MAIOR_ANO_ATUAL = "Operação Bloqueada<br/><br/>Não é possivel gerar tarefas referente a anos passados.";
    this.PERGUNTA_GERAR_TAREFAS_ANIVERSARIO = "Deseja gerar tarefas para os operadores, de acordo com a data de fundação/aniversário, de seus respectivos parceiros?";
    this.PERGUNTA_GERAR_TAREFAS_INTERVALO = "Deseja gerar tarefas para os operadores relacionadas a seus respectivos parceiros de acordo com o intervalo selecionado?";    
//--------------------------------------------------------------------------------------------------------------------    
    
    /* CASO */
    this.CODIGO_PERSONALIZADO_EXISTENTE = "Código já existente.";

//--------------------------------------------------------------------------------------------------------------------    
    
    /* OPORTUNIDADE DE NEGÓCIO */
    this.OPORTUNIDADE_CONCLUIDA = "Oportunidade concluída com sucesso.";
    this.PERGUNTA_FECHAR_OPORTUNIDADE = "Esta oportunidade será fechada e bloqueada para qualquer tipo de ação. <br/><br/>Deseja realmente fechar esta oportunidade?";
    this.CALC_VAL_PREV_OPORT_DELETE = "Deseja calcular o valor da oportunidade à partir dos itens após a exclusão?";
    this.VAL_PREV_CAL_SUCESSO = "Valor previsto calculado com sucesso.";

//--------------------------------------------------------------------------------------------------------------------
    
    /* ENDERECO */
    this.ENDERECO_NAO_ENCONTRADO = "Endereço não encontrado.";
    
//--------------------------------------------------------------------------------------------------------------------
    
    /* COMPROMISSO */
    this.IMPOSSIVEL_MANUSEAR_EVENTO = function(explicacao){
        return "Operação bloqueada!<br><br>" + explicacao;
    };
    
    this.QUESTAO_INSERIR_COMPROMISSO_GOOGLE = "Deseja inserir este compromisso ao Google Calendar?";
    this.SINC_GOOGLE_CALENDAR = "Deseja sincronizar seus compromissos com o Google Calendar?";
    this.DESINC_GOOGLE_CALENDAR = "Deseja dessincronizar seus compromissos com o Google Calendar?";
    this.COMPROMISSO_INSERIDO_GOOGLE = "Compromisso inserido em sua agenda do Google.";
    this.COMPROMISSO_NAO_INSERIDO_GOOGLE = "Compromisso não inserido ao Google Calendar.";
    this.IMPOSSIVEL_MANUSEAR_EVENTO_GOOGLE = "Não é possível alterar um compromisso referente ao Google Calendar.";
    this.GOOGLE_SINC_SUCESSO = "Google Calendar sincronizado com sucesso.";
    this.GOOGLE_DESINC_SUCESSO = "Google Calendar dessincronizado com sucesso.";
    this.GOOGLE_EVENTO_EDITADO_SUCESSO = "Evento editado com sucesso no Google Calendar.";
    this.NOEDIT_PARTICIPANTE_COMPROMISSO = "Participantes não podem modificar compromissos em que foram relacionados.";
    this.EDICAO_APENAS_RESPONSAVEL = "Apenas o operador responsável e o de inclusão tem permissão para alterar o compromisso.";
    this.FALHA_SINC_GOOGLE_CALENDAR = "Falha ao sincronizar com o Google Calendar";
    this.OPORTUNIDADE_FECHADA = "A oportunidade de negócio está fechada.";
    
//--------------------------------------------------------------------------------------------------------------------

    /* API GOOGLE CALENDAR */
    this.POPUP_BLOQUEADA = "Popup do navegador bloqueado!<br/>Libere o popup para realizar a sincronização com o Google Calendar.";
    
    
//--------------------------------------------------------------------------------------------------------------------    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Messages', Messages);
});

// FILE: ./assets/js/general/OperadorGeral.js
var Operador_Repository = function(localStorageEngine, restEngine) {
    this.retornaOperadorLogado = function(user) {
        var cdoperador = 'OPERADOR_LOGADO';
        
        if(!Util.isEmptyOrBlank(user)) {
            cdoperador = user.cdoperador;
        }
        
        var filtro = {
            'requestType': 'FilterData',
            filter: [{
                name: "CDOPERADOR",
                operator: "=",
                value: cdoperador
            },
            {
                name: "NRORG",
                operator: "=",
                value: getLocalVar('CRM_NRORG')
            }]
        };
        
        return restEngine.post('product#/crud/operador_geral', filtro).then(function(response) {
            return response.dataset.operador_geral;
        });
    };
    this.retornaPerfilOperadorLogado = function(){
        var filter  = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        return localStorageEngine.download("product#/crud/crm_perfioper_operador", filter);
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Operador_Repository', Operador_Repository);
});

// FILE: ./assets/js/general/taskTabController.js
function taskTabController(ScreenService, templateManager, metaDataFactory){
    
    /**
     * Tranforma o JSON da tab em uma widget de fato.
     * 
     * @param {object} widget widget que irá receber a tab.
     * 
     * @param {string} nrparcnegocio nome do campo com o número
     * do parceiro de negócio.
     * 
     * @return widget evolucao construida.
     * 
    */
    function _factoryTaskTab(activeWidget) {
        
        
        var taskTabWidgetJson = {
            "id": "165190053618173611545287",
            "name": "WDGT_TAREFAS",
            "container":activeWidget.container,
            "parent":activeWidget,
            "label": "Agenda de Tarefas",
            "isVisible": true,
            "showDescriptionOrder": false,
            "template": "widget/master_detail/grid.html",
            "dataSource": {
                "name": "product#/filacontato_agendatarefas",
                "rest": true,
                "lazyLoad": false
            },
            "dataSourceFilter": [
                {
                    "name": "NRSEQCONTATO",
                    "operator": "=",
                    "value": ""
                },
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": "@templateManager.LOGGEDOPERATOR.NRORG@"
                }
            ],
            "events": [
                {
                    "id": "12145938358850258985322",
                    "name": "WidgetOnEnterOnce",
                    "code": "CRM_Utilities.factoryWidgetActions(args.owner)"
                },
                {
                    "id": "12145938359454958305323",
                    "name": "WidgetOnEnter",
                    "code": "CRM_Utilities.setDataSourceFilterOnDynamicTabs(args.owner, templateManager.container.getWidget('" + activeWidget.name + "'))"
                }
            ],
            "actions": [
                {
                    "id": "12145938358778860855308",
                    "name": "ADD",
                    "isVisible": true,
                    "label": "Adicionar",
                    "icon": "plus",
                    "showAsAction": "always|list",
                    "events": [
                        {
                            "id": "1214593835687091805309",
                            "name": "ActionEvent",
                            "code": "General.widgetNewRow(args.owner.widget)"
                        }
                    ]
                },
                {
                    "id": "121459383529023736205310",
                    "name": "BACK_EDIT",
                    "label": "Cancelar",
                    "isVisible": true,
                    "showAsAction": "back_edit",
                    "events": [
                        {
                            "id": "12145938352536628455311",
                            "name": "ActionEvent",
                            "code": "General.widgetCancelForm(args.owner.widget);"
                        }
                    ]
                },
                {
                    "id": "121459383515432103205312",
                    "name": "BACK_LIST",
                    "label": "Voltar",
                    "isVisible": true,
                    "preventHide": true,
                    "showAsAction": "back_list",
                    "events": [
                        {
                            "id": "121459383539130013215313",
                            "name": "ActionEvent",
                            "code": "General.widgetGoBackToParent(args.owner.widget);"
                        }
                    ]
                },
                {
                    "id": "12145938354105660785314",
                    "name": "BACK_VIEW",
                    "label": "Voltar",
                    "isVisible": true,
                    "preventHide": true,
                    "showAsAction": "back_view",
                    "events": [
                        {
                            "id": "12145938355192145735315",
                            "name": "ActionEvent",
                            "code": "General.widgetGoBackToList(args.owner.widget);"
                        }
                    ]
                },
                {
                    "id": "121459383523551511425316",
                    "name": "SAVE",
                    "label": "Salvar",
                    "isVisible": true,
                    "showAsAction": "never_edit",
                    "events": [
                        {
                            "id": "121459383521319591925317",
                            "name": "ActionEvent",
                            "code": "General.widgetSave(args.owner.widget)"
                        }
                    ]
                },
                {
                    "id": "121459383512178699915318",
                    "name": "EDIT",
                    "label": "Editar",
                    "isVisible": true,
                    "icon": "pencil",
                    "showAsAction": "view",
                    "events": [
                        {
                            "id": "121459383538831883375319",
                            "name": "ActionEvent",
                            "code": "General.widgetEdit(args.owner.widget);"
                        }
                    ]
                },
                {
                    "id": "121459383527596916025320",
                    "name": "DELETE",
                    "label": "Excluir",
                    "isVisible": true,
                    "icon": "trash",
                    "showAsAction": "view",
                    "events": [
                        {
                            "id": "121459383522857367935321",
                            "name": "ActionEvent",
                            "code": "General.deleteCrud(args.owner.widget);"
                        }
                    ]
                }
            ],
            "fields": [
                {
                    "id": "121459383521799955325288",
                    "name": "DSFILACONTATO",
                    "label": "Assunto",
                    "template": "field/text-edit.html",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnView": true,
                    "showOnForm": true,
                    "maxlength": 2000,
                    "class": "12",
                    "validations": {
                        "required": {}
                    },
                    "events": [],
                    "descriptionOrder": 1
                },
                {
                    "id": "121459383524658483795289",
                    "name": "DSCLASSIFICATAREFA",
                    "label": "Classificação da Tarefa",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "fields": [
                        {
                            "id": "121459383535174967265290",
                            "name": "DSCLASSIFICATAREFA",
                            "label": "Classificação da Tarefa",
                            "showOnList": true,
                            "isVisible": true,
                            "template": "field/text-edit.html"
                        }
                    ],
                    "isVisible": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "class": "6",
                    "valueField": "NRSEQCLASSIFICATAREFA",
                    "descriptionField": "DSCLASSIFICATAREFA",
                    "dataSource": {
                        "name": "product#/crm_classificatarefa",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "validations": {
                        "required": {}
                    },
                    "itemsPerPage": 50,
                    "dataSourceFilter": [],
                    "outData": {
                        "NRSEQCLASSIFICATAREFA": "NRSEQCLASSIFICATAREFA",
                        "DSCLASSIFICATAREFA": "DSCLASSIFICATAREFA"
                    },
                    "events": []
                },
                {
                    "id": "121459383524336115205291",
                    "name": "DTPLANFILACONTA",
                    "label": "Data/Hora de Contato",
                    "template": "field/datetime.html",
                    "datetime-preset": "datetime",
                    "datetime-dateFormat": "dd/mm/yy",
                    "datetime-timeFormat": "HH:ii",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnView": true,
                    "showOnForm": true,
                    "class": "6",
                    "defaultValue": "@CRM_Utilities.getDataHoraAtual()@",
                    "validations": {
                        "required": {}
                    },
                    "events": []
                },
                {
                    "id": "12145938357360006555292",
                    "name": "NMOPERADOR",
                    "label": "Operador Responsável",
                    "template": "field/select.html",
                    "class": "12",
                    "showSelectAs": "grid",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnView": true,
                    "showOnForm": true,
                    "valueField": "CDOPERREAL",
                    "descriptionField": "NMOPERADOR",
                    "validations": {
                        "required": {}
                    },
                    "defaultValue": "@getLocalVar('CRM_NMOPERADOR')@",
                    "dataSource": {
                        "name": "product#/crud/operador_crm_operrevenda",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "itemsPerPage": 50,
                    "dataSourceFilter": [],
                    "fields": [
                        {
                            "id": "12145938352562112795293",
                            "name": "NMOPERADOR",
                            "label": "Nome",
                            "isVisible": true,
                            "showOnList": true
                        }
                    ],
                    "outData": {
                        "NMOPERADOR": "NMOPERADOR",
                        "CDOPERADOR": "CDOPERREAL"
                    },
                    "events": []
                },
                {
                    "id": "121459383521168607645294",
                    "name": "CDOPERREAL",
                    "label": "Código Operador",
                    "template": "field/datetime.html",
                    "showOnForm": false,
                    "showOnList": false,
                    "isVisible": false,
                    "readOnly": false,
                    "class": "6",
                    "defaultValue": "@templateManager.LOGGEDOPERATOR.CDOPERADOR@",
                    "events": []
                },
                {
                    "id": "121459383537971805055295",
                    "name": "NMPRIORFILACONT",
                    "label": "Prioridade",
                    "template": "field/text-edit.html",
                    "isVisible": false,
                    "showOnList": false,
                    "showOnView": false,
                    "showOnForm": false,
                    "class": "6",
                    "events": []
                },
                {
                    "id": "1214593835389562785296",
                    "name": "DTREALFILACONTA",
                    "label": "Data de Conclusão",
                    "template": "field/calendar.html",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnView": true,
                    "showOnForm": true,
                    "readOnly": true,
                    "dateFormat": "DD/MM/YYYY",
                    "class": "6",
                    "events": []
                },
                {
                    "id": "12145938359203751095297",
                    "name": "NRPRIORFILACONT",
                    "label": "Prioridade",
                    "template": "field/select-native.html",
                    "hideEmptyValue": true,
                    "isVisible": true,
                    "showOnList": false,
                    "showOnForm": true,
                    "showOnView": true,
                    "class": "6",
                    "dataSource": {
                        "data": [
                            {
                                "NRPRIORFILACONT": 2,
                                "NMPRIORFILACONT": "Normal"
                            },
                            {
                                "NRPRIORFILACONT": 1,
                                "NMPRIORFILACONT": "Prioridade"
                            }
                        ]
                    },
                    "descriptionField": "NMPRIORFILACONT",
                    "valueField": "NRPRIORFILACONT",
                    "defaultValue": 2,
                    "validations": {
                        "required": true
                    }
                },
                {
                    "id": "121459383525106681375298",
                    "name": "NMINTERLOCUTOR",
                    "label": "Interlocutor",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "isVisible": true,
                    "showOnForm": true,
                    "showOnList": false,
                    "readOnly": false,
                    "class": "6",
                    "valueField": "NRSEQINTERLOCUTOR",
                    "descriptionField": "NMINTERLOCUTOR",
                    "dataSource": {
                        "name": "product#/crm_interlocutor",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "itemsPerPage": 50,
                    "dataSourceFilter": [
                        {
                            "name": "NRPARCNEGOCIO",
                            "operator": "=",
                            "value": "@General.getFieldValue('NRPARCNEGOCIO', '"+activeWidget.name+"')@"
                        },
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": "@getLocalVar('CRM_NRORGTRAB')@"
                        }
                    ],
                    "outData": {
                        "NRSEQINTERLOCUTOR": "NRSEQINTERLOCUTOR",
                        "EMAILINTERLOC": "EMAILINTERLOC",
                        "NRTELEFONE1": "NRTELEFONE1",
                        "NMINTERLOCUTOR": "NMINTERLOCUTOR"
                    },
                    "fields": [
                        {
                            "id": "12145938353104527715299",
                            "name": "NMINTERLOCUTOR",
                            "label": "Nome Interlocutor",
                            "isVisible": true,
                            "showOnList": true
                        }
                    ],
                    "events": [
                        {
                            "id": "121459383538789140965300",
                            "name": "FieldAfterSelectOpen",
                            "code": "args.owner.field.reload()"
                        }
                    ],
                    "filterProperties": {
                        "isVisible": false,
                        "showOnForm": false
                    }
                },
                {
                    "id": "121459383512624111745301",
                    "name": "DSTELEFONETAREFA",
                    "label": "Telefone",
                    "template": "field/text-edit.html",
                    "isVisible": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "class": "6",
                    "maxlength": 15,
                    "events": []
                },
                {
                    "id": "121459383542832204335302",
                    "name": "DSEMAILTAREFA",
                    "label": "E-mail",
                    "template": "field/text-edit.html",
                    "isVisible": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "class": "6",
                    "validations": {
                        "mail": true
                    },
                    "events": []
                },
                {
                    "id": "12145938354756362625303",
                    "name": "DSDETEFILACONTA",
                    "label": "Descrição",
                    "template": "field/textarea.html",
                    "textRows": 5,
                    "isVisible": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "maxlength": 4000,
                    "class": "12",
                    "events": []
                },
                {
                    "id": "12145938359935862175304",
                    "name": "NRORG",
                    "label": "Org",
                    "template": "field/text-edit.html",
                    "isVisible": false,
                    "showOnList": false,
                    "showOnView": false,
                    "showOnForm": false,
                    "defaultValue": "@templateManager.LOGGEDOPERATOR.NRORG@"
                },
                {
                    "id": "121459383530261645445305",
                    "name": "CDOPEREVOL",
                    "label": "Operador",
                    "template": "field/text-edit.html",
                    "isVisible": false,
                    "showOnList": false,
                    "showOnView": false,
                    "showOnForm": false,
                    "defaultValue": "@templateManager.LOGGEDOPERATOR.CDOPERADOR@"
                },
                {
                    "id": "121459383516284260395306",
                    "name": "NRPARCNEGOCIO",
                    "label": "Parceiro",
                    "template": "field/text-edit.html",
                    "isVisible": false,
                    "showOnList": false,
                    "showOnView": false,
                    "showOnForm": false,
                    "defaultValue":"@templateManager.container.getWidget('" + activeWidget.name + "').currentRow.NRPARCNEGOCIO@"
                },
                {
                    "id": "12145938352448535765307",
                    "name": "NRSEQCONTATO",
                    "label": "Contato",
                    "template": "field/text-edit.html",
                    "isVisible": false,
                    "showOnList": false,
                    "showOnView": false,
                    "showOnForm": false,
                    "defaultValue":"@templateManager.container.getWidget('" + activeWidget.name + "').currentRow.NRSEQCONTATO@"
                }
            ],
            "widgets": []
        };
        
        var taskTabWidget = metaDataFactory.widgetFactory(taskTabWidgetJson);
        taskTabWidget.widgets = [];
        
        return taskTabWidget;
        
    };
    
    /**
     * Insere a widget de tarefas na widget recebida como 
     * parâmetro.
     * 
     * @param {object} widget widget que receberá a tab.
     * 
     * @param {string} nrparcnegocio nome referente ao
     * campo de parceiro de negócio.
    */
    this.setTaskTabOnActiveWidget = function(widget, nrparcnegocio){
        
        widget.widgets.push(_factoryTaskTab(widget, nrparcnegocio));
        
    };

    
	
}
Configuration(function(ContextRegister){
    ContextRegister.register('taskTabController', taskTabController);
});

// FILE: ./assets/js/utilities/API_GoogleCalendar.js
function API_GoogleCalendar(ZHPromise, ScreenService, Messages) {
    
    // Array of API discovery doc URLs for APIs used by the quickstart
    var DISCOVERY_DOCS = ["https://www.googleapis.com/discovery/v1/apis/calendar/v3/rest"];
    
    // Authorization scopes required by the API; multiple scopes can be
    // included, separated by spaces.
    var SCOPES = "https://www.googleapis.com/auth/calendar";
    
    //
    var defaultEventId = "pebbiancrm";
    
    /**
     *  On load, called to load the auth2 library and API client library.
    */
    this.loadAuth2AndApiClientLibrary = function() {
        
        gapi.load('client:auth2', this.initClient);
        
    };
    
    /**
     *  Initializes the API client library and API key;
    */
    this.initClient = function(){
        
        gapi.client.init({
            discoveryDocs: DISCOVERY_DOCS,
            clientId: window.googleClientId,
            scope: SCOPES,
            apiKey: window.googleApiKey
        }).then(function(){
            gapi.client.setApiKey(window.googleApiKey);
        }.bind(this));
        
    };
    
    /**
     *  Sign in Google if there is not logged user.
    */
    this.signInGoogle = function() {
        
        var zhPromiseSignIn = ZHPromise.defer();
            
        if(!this.isLoggedSomeGoogleUser()){
            
            gapi.auth2.getAuthInstance().signIn().then(function(response){
                
                gapi.auth2.getAuthInstance().isSignedIn.listen(updateSigninStatus);
                zhPromiseSignIn.resolve();
                
            },function(response){
                
                var errorMessage;
                if(response.error === "popup_blocked_by_browser"){
                    errorMessage = Messages.POPUP_BLOQUEADA;
                } else {
                    errorMessage = Messages.FALHA_SINC_GOOGLE_CALENDAR;
                }
                
                zhPromiseSignIn.reject(errorMessage);
            });    
            
        }else{
            zhPromiseSignIn.resolve();
        }
        
        return zhPromiseSignIn.promise;
        
    };
    
    /**
     *  Called when the signed in status changes, to update the UI
     *  appropriately. After a sign-in, the API is called.
     * 
     * @param {Boolean} isSignedIn description
    */
    function updateSigninStatus(isSignedIn){
        
        if(!isSignedIn){
            
            var activeWidget = getActiveWidget();
            activeWidget.reload();
            
        }    
        
    }
    
    /**
     * Retorna a widget ativa.
    */
    function getActiveWidget() {
        
        return angular.element('#footer').scope().templateManager.container.getActiveWidget();
       
    }
    
    /**
     *  Sign out Google.
    */
    this.signOutGoogle = function () {
        gapi.auth2.getAuthInstance().signOut();
    };
    
    /**
     * Create an event(for logged user) according object received 
     * as parameter.
     * 
     * @param {object} commitmentModel object with the
     * commitment informations.
     * 
     * @objectModel = {TITLE: XXXX, INITDATE: XX/XX/XXXX, INITTIME: XX:XX, ENDDATE: XX/XX/XXXX, ENDTIME: XX:XX, DESCRIPTION: XXXX}
     * 
     * "ATTENTION WITH THE VARIABLES FORMAT".
    */
    this.addGoogleEvent = function(objectWithCommitmentInfos){
        var deferred = ZHPromise.defer();
        
        var event = this.createDefaultGoogleEventObject(objectWithCommitmentInfos);
        
        var request = gapi.client.calendar.events.insert({
            'calendarId': 'primary',
            'resource': event
        });
        
        if(this.isLoggedSomeGoogleUser()){
            request.execute(function(response){
                
                if(Boolean(response.error)){
                    deferred.reject();
                }else{
                    deferred.resolve();    
                }
                
            });
        }
        
        return deferred.promise;
    };
    
    /**
     * Returns a default google event.
    */
    this.createDefaultGoogleEventObject = function(event){
        
        var defaultEvent = {
            'id': defaultEventId + event.ID,
            'description': event.DESCRIPTION,
            'start': {
                'dateTime': this.createGoogleEventDateTimeFormat(event.INITDATE, event.INITTIME)
            },
            'end': {
                'dateTime': this.createGoogleEventDateTimeFormat(event.ENDDATE, event.ENDTIME)
            },
            'summary': event.TITLE
        };
        
        return defaultEvent;
    };
    
    /**
     * Returns a formatted string of the type "dateTime".
     * 
     * @param {string} date date required.
     * 
     * @param {string} time time required.
     * 
     * @return {string} formatted string of the type "dateTime".
    */
    this.createGoogleEventDateTimeFormat = function(date, time){
        var formattedDate = moment(date, 'DD/MM/YYYY').format('YYYY-MM-DD');
        var formattedTime = moment(time, 'HH:mm:ss').format('HH:mm:00');
        var formattedDateTime = formattedDate + 'T' + formattedTime + '-03:00';
        
        return formattedDateTime;
    };
    
    /**
     * Returns the logged Google user events.
     * 
     * @param {string} timeMax período máximo
     * para buscar os eventos.
     * 
     * @param {string} timeMin período mínimo
     * para buscar os eventos.
     * 
     * ATENÇÂO: Os parâmetros devem ser passados
     * do formato usado pelo google.
     * Ex.: 1997-05-22T09:00:00-03:00
    */
    this.getLoggedGoogleUserEvents = function(timeMax, timeMin) {
        
        var params = {
            'calendarId': 'primary'
        };
        
        if(timeMax){
            params.timeMax = timeMax;
        }
        if(timeMin){
            params.timeMin = timeMin;
        }
        
        return gapi.client.calendar.events.list(params)
        .then(function(response) {
            var events = response.result.items;
            return events;
        });
        
    };
    
    /**
     * Returns if exist some looged google user.
    */
    this.isLoggedSomeGoogleUser = function(){
        
        return gapi.auth2.getAuthInstance().isSignedIn.get();
        
    };
    
    /**
     * Delete a google event by received id.
    */
    this.deleteGoogleEvent = function(id){

        var params = {'calendarId': 'primary', 'eventId': defaultEventId + id};
        var request = gapi.client.calendar.events.delete(params);
        
        if(this.isLoggedSomeGoogleUser()){
            request.execute();
        }
        
    };
    
    /**
     * Edit a google event by received id in event object.
    */
    this.editGoogleEvent = function(event){
        
        var zhPromise = ZHPromise.defer();
        var defaultGoogleEvent = this.createDefaultGoogleEventObject(event);
        
        var params = {'calendarId': 'primary', 'eventId': defaultEventId + event.ID, 'resource': defaultGoogleEvent};
        var request = gapi.client.calendar.events.update(params);
        
        if(this.isLoggedSomeGoogleUser()){
            request.execute(function(){
                zhPromise.resolve();
            },function(fail){
                zhPromise.reject();
            });
        }
        
        return zhPromise.promise;
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('API_GoogleCalendar', API_GoogleCalendar);
});

// FILE: ./assets/js/utilities/CRM_Utilities.js
function CRM_Utilities(ScreenService, templateManager, Operador_Repository, ZHPromise, restEngine, General, ValidationEngine, ZhUtil, ZhFilterPreferences, metaDataFactory, Messages) {

    this.controllers = {};

    this.addController = function (controller, controllerName) {
        this.controllers[controllerName] = controller;
    };

    this.getController = function (controllerName) {
        var controller = this.controllers[controllerName];

        return controller;
    };

    this.propagate = function (widgetEvents, field) {
		var parentEventsOnChild = this.filterWidgetEventsOnField(field.events);
		return widgetEvents.concat(parentEventsOnChild);
	};

	this.filterWidgetEventsOnField = function (fieldEvents) {
		return fieldEvents.filter(function (event) {
			return ~event.name.indexOf("Widget");
		});
	};

    /**
     * Função para limpar todos os valores de uma widget recebida
     * como parâmetro.
     * 
     * @param {obejct} widget widget na qual será removido os valores
     * de todas as fields.
     * 
    */
    this.cleanWidgetFields = function (widget) {
        widget.fields.forEach(function (field) {
            field.value("");
        });
    };

    /**
     * Função para retornar as informações do
     * operador logado.
     * 
     * @return {object} loggedOperatorInfos objeto
     * que contém todas as informações do operador
     * logado.
    */
    this.getLoggedOperatorInfos = function () {

        var loggedOperatorInfos = templateManager.LOGGEDOPERATOR;

        return loggedOperatorInfos;

    };

    /**
     * Função para setar as informações do operador 
     * logado em um array na widget recebida.
     * 
     * @param {object} destinationObject objeto destino 
     * das informações do operador logado.
     * 
    */
    this.setOperatorLoggedInfosInCurrentRow = function (destinationObject) {

        return Operador_Repository.retornaOperadorLogado().then(function (operator) {

            if (!operator[0]) {

                ScreenService.showMessage("Não foi possível carregar os dados do operador logado. Entre em contato com um administrador sobre o erro.");
                return;
            }

            destinationObject.OPERATORLOGGED = operator[0];

        },
            function (error) {
                ScreenService.showMessage("Não foi possível carregar os dados do operador logado. Entre em contato com um administrador sobre o erro.");
            }
        );
    };

    /**
     * Retorna o index da widget localizada, pelo nome
     * recebido como parâmetro da função, no array de widgets,
     * também recebido como parâmetro.
     * 
     * @param {object} widgets array de widgets onde é feito
     * a busca.
     * 
     * @ param {string} widgetName nome da widget a ser
     * localizada.
     * 
     * @param {int} indexWidgetObject index da widget localizada
     * dentro do array de wigets.
    */
    this.getWidgetPosition = function (widgets, widgetName) {

        var indexWidgetObject;

        widgets.forEach(function (widget, indexWidget) {

            if (widget.name === widgetName) {
                indexWidgetObject = indexWidget;
                return;
            }

        });

        return indexWidgetObject;

    };

    /**
     * Função para identificar o index de um objeto
     * dentro de um dataSourceFilter, de acordo com 
     * seu nome.
     * 
     * @param {object} dataSourceFilter objeto da busca.
     * 
     * @param {String} name propriedade no objeto pelo qual
     * é feito a busca.
     * 
     * @return {int} indexFilterObject index Do objeto 
     * encontrado.
     * 
    */
    this.getFilterPosition = function (dataSourceFilter, name) {
        var indexFilterObject;

        dataSourceFilter.forEach(function (value, i) {
            if (value.name === name) {
                indexFilterObject = i;
                return;
            }
        });
        return indexFilterObject;
    };

    /**
     * Função para identificar o index de um objeto
     * dentro de um FieldGroups, de acordo com 
     * seu nome.
     * 
     * @param {object} fieldGroup objeto da busca.
     * 
     * @param {String} name propriedade no objeto 
     * pelo qual é feito a busca.
     * 
     * @return {int} indexFieldGroupObject index Do objeto 
     * encontrado.
    */
    this.getFieldGroupPosition = function (fieldGroups, name) {

        var indexFieldGroupObject;

        fieldGroups.forEach(function (value, i) {
            if (value.name === name) {
                indexFieldGroupObject = i;
            }
        });

        return indexFieldGroupObject;

    };

    /**
     * Procedimento para recuperar a posição
     * de um objeto dentro de um array.
     * 
     * @param {object} array array onde será feito
     * a varredura.
     * 
     * @param {object} objectName nome do objeto a ser
     * buscado.
    */
    this.getObjectPositionInArrayByName = function (array, objectName) {

        var indexFieldObject;

        array.forEach(function (value, i) {
            if (value.name === objectName) {
                indexFieldObject = i;
            }
        });

        return indexFieldObject;

    };

    /**
     * Limpa um field de acordo com seu template.
     * 
     * @param {object} field terá seu valor limpo
    */
    this.clearFieldValue = function (field) {

        var templateField = field.template;

        if (templateField === "field/select.html") {

            if (field.value() && field.value() !== "") {

                field.clearByOutData();
            }

        } else {

            field.clearValue();

        }

    };

    /**
    * Função que habilita a criação de um novo código
    * para o registro que será salvo.
    * 
    * @param {object(widget)} widget widget ativa que
    * terá seu parâmetro alterados
    * 
    * @param {String} tableName tabela referência para
    * gerar o novo código
    * 
    * @param {String} tablePk nome da Primary Key da tabela
    * que recebera o código gerado.
   */
    this.enableNewNumericalCode = function (widget, tableName, tablePk) {

        if (widget.currentRow.__is_new) {

            var paramsNewCode = widget.paramsNewCode;

            paramsNewCode.__is_new_code = true;
            paramsNewCode.__new_code_pk = tableName;
            paramsNewCode.__table_pk = tablePk;

        }

    };

    /**
    * Define os parâmetros para gerar um novo código
    * para o registro a ser salvo.
    * 
    * @param {object} row objeto que será persistido.
    * 
    * @param {String} tableName tabela referência para
    * gerar o novo código
    * 
    * @param {String} tablePk nome da Primary Key da tabela
    * que recebera o código gerado.
    * 
    * @param {string} columnToReturn coluna a ser retornada.
   */
    this.setColumnToReturnParamsOnRow = function (row, tableName, tablePk, columnToReturn) {

        row.__is_new_code = true;
        row.__new_code_pk = tableName;
        row.__table_pk = tablePk;
        row.__new_code_length = 20;
        row.__columns_to_return = [columnToReturn];

    };

    /**
     * Função que desabilita a criação de um novo código.
     * 
     * @param {object(widget)} widget widget ativa
     * que terá seus parâmetros desabilitados.
    */
    this.desableNewNumericalCode = function (widget) {

        var paramsNewCode = widget.paramsNewCode;

        paramsNewCode.__is_new_code = false;
        paramsNewCode.__new_code_pk = "";
        paramsNewCode.__table_pk = "";

    };

    /**
     * Função para setar a coluna a ser retornada
     * na resposta do 'save'.
     * 
     * @param {object} currentRow currentRow que receberá
     * a propriedade com o nome da coluna a ser retornada.
     * 
     * @param {string} columnName nome da coluna a ser
     * retornada.
    */
    this.setColumnToReturnInCurrentRow = function (currentRow, columnName) {

        currentRow.__columns_to_return = [columnName];

    };

    /**
     * Função para remover todos os caracteres
     * não numéricos de um determinado valor,
     * caso o valor recebido seja vazio, uma
     * String vazia é retornada.
     * 
     * @param {String} valueWithCurrencyMask valor que será retornado
     * sem caracteres não numéricos.
     * 
     * @return {String} valueWithoutSymbols valor
     * recebido como parâmetro sem caracteres não
     * numéricos.
     * 
    */
    this.removeValueMask = function (valueWithMask) {

        if (valueWithMask) {

            var valueWithoutSymbols = valueWithMask.replace(/[^0-9]/g, "");

            return valueWithoutSymbols;

        } else {

            return "";

        }
    };

    /**
     * Função para removar mascarás de moedas do valor
     * recebido como parâmetro.
     * 
     * @param {String} valueWithCurrencyMask valor que 
     * será retornado sem máscara de moeda.
     * 
     * @return {String} valueWithoutSymbols valor
     * recebido como parâmetro sem máscara de moeda.
     * 
    */
    this.removeValueCurrencyMask = function (valueWithCurrencyMask) {

        if (valueWithCurrencyMask) {
            if (typeof valueWithCurrencyMask === "string") {
                var valuesWithoutCurrencyMask = $.currency.unmaskString(valueWithCurrencyMask, { "thousands": "." });
                return valuesWithoutCurrencyMask;
            } else {
                //Retorna o pŕoprio valor se não vier uma string
                return valueWithCurrencyMask;
            }
        } else {

            return "";

        }


    };

    /**
     * Função para localizar uma widget dentro
     * de um array de widgets pelo seu nome;
     * 
     * @param {object} widgets arrays de widgets, que
     * será percorrido pela busca.
     * 
     * @param {string} widgetName nome da widget a ser
     * procurada.
     * 
     * @return {object} foundWidget widget encontrada
     * no array de widgets recebido como parâmetro.
    */
    this.getWidgetByName = function (widgets, widgetName) {

        var foundWidget;

        widgets.map(function (widget) {

            if (widget.name === widgetName) {
                foundWidget = widget;
            }
            else if (widget.widgets && widget.widgets.length > 0 && !foundWidget) {

                foundWidget = this.getWidgetByName(widget.widgets, widgetName);

            }

        }.bind(this));

        return foundWidget;

    };

    /**
     * Função para setar o filtro do número da organização
     * padrão e do número da organização do operador logado
     * na field recebida como parâmetro, e logo em seguida,
     * recarregar a field.
     * 
     * @param {object} field field que receberá o filtro.
    */
    this.setDefaultOrgFilterAndOperatorOrgFilter = function (field) {

        var fieldFilter = field.dataSourceFilter;
        var loggedOperatorInfos = this.getLoggedOperatorInfos();
        var valueWithDefaultOrgAndJobOrg = [getLocalVar("CRM_NRORGPADRAO"), loggedOperatorInfos.NRORG];

        if (!fieldFilter) {

            field.dataSourceFilter = [];
            fieldFilter = field.dataSourceFilter;

        }

        var nrorgFilterIndex = this.getFilterPosition(fieldFilter, "NRORG");

        if (nrorgFilterIndex >= 0) {
            fieldFilter[nrorgFilterIndex].value = valueWithDefaultOrgAndJobOrg;
        } else {
            fieldFilter.push(
                {
                    "name": "NRORG",
                    "operator": "IN",
                    "value": valueWithDefaultOrgAndJobOrg
                }
            );
        }

    };

    /**
     * Função para setar o filtro de organização padrão
     * para atribuir o valor do parâmetro 'P_NRORGPADRAO'
     * nas querys do dataSource em caso.
     * 
     * @param {object} filterDestination destino onde o filtro
     * será definido.
    */
    this.setDefaultOrgNumberFilterValue = function (filterDestination) {

        var filterDestinationFilter = filterDestination.dataSourceFilter;

        if (!filterDestinationFilter) {

            filterDestination.dataSourceFilter = [];
            filterDestinationFilter = filterDestination.dataSourceFilter;

        }

        filterDestinationFilter.push(
            {
                "name": "P_NRORGPADRAO",
                "operator": "IN",
                "value": [getLocalVar("CRM_NRORGPADRAO")]
            }
        );

    };

    /**
     * Função para remover um objeto do array(filtro)
     * recebido como parâmetro.
     * 
     * @param {object} filter array com os objetos(filtros).
     * 
     * @param {int} objectIndex índice do objecto a ser removido
     * do array(filtro).
    */
    this.deleteFilterObject = function (filter, objectIndex) {

        if (objectIndex === 0) {
            filter.shift();
        } else if (objectIndex === filter.length - 1) {
            filter.pop();
        } else {
            filter = filter.slice(0, objectIndex).concat(filter.slice(objectIndex + 1));
        }

        return filter;
    };

    /**
     * Função para retornar a data e hora atual.
     * 
     * @return {string} data e hora atual.
    */
    this.getDataHoraAtual = function () {
        return moment().format('DD/MM/YYYY HH:mm');
    };

    /**
     * Função para retornar a data atual.
     * 
     * @return {string} data atual.
    */
    this.getCurrentDate = function () {
        return moment().format('DD/MM/YYYY');
    };

    /**
     * Função para retornar a hora atual.
     * 
     * @return {string} hora atual.
    */
    this.getCurrentTime = function () {
        return moment().format('HH:ss');
    };

    /**
     * Função para retornar a data atual com
     * o horário máximo.
     * 
     * @return {string} data atual.
    */
    this.getCurrentDateWithMaxTime = function () {
        return moment().format('DD/MM/YYYY 23:59');
    };

    /**
     * Função para retornar a data atual com
     * o horário mínimo.
     * 
     * @return {string} data atual.
    */
    this.getCurrentDateWithMinTime = function () {
        return moment().format('DD/MM/YYYY 00:00');
    };

    /**
     * Procedimento para retornar uma data
     * subtraida pela quantidade de dias recebida
     * como parâmetro.
     * 
     * @param {string} date data s ser subtraida.
     * 
     * @param {number} numberOfDays dias como subtraendo.
     * 
     * @return {string} data subtraida.
    */
    this.subtractDateByDays = function (date, numberOfDays) {
        return moment(date, 'DD/MM/YYYY').subtract(numberOfDays, 'day').format('DD/MM/YYYY');
    };

    /**
     * Procedimento para retornar uma data
     * somada pela quantidade de dias recebida
     * como parâmetro.
     * 
     * @param {string} date data s ser somada.
     * 
     * @param {number} numberOfDays dias como parcela.
     * 
     * @return {string} data somada.
    */
    this.sumDateByDays = function (date, numberOfDays) {
        return moment(date, 'DD/MM/YYYY').add(numberOfDays, 'day').format('DD/MM/YYYY');
    };

    /**
     * Procedimento para retornar uma data
     * subtraida pela quantidade de mêses recebido
     * como parâmetro.
     * 
     * @param {string} date data s ser subtraida.
     * 
     * @param {number} numberOfMonth mêses como subtraendo.
     * 
     * @return {string} data subtraida.
    */
    this.subtractDateByMonth = function (date, numberOfMonth) {
        return moment(date, 'DD/MM/YYYY').subtract(numberOfMonth, 'month').format('DD/MM/YYYY');
    };

    /**
     * Procedimento para retornar uma data
     * subtraida pela quantidade de mêses recebido
     * como parâmetro.
     * 
     * @param {string} date data s ser adicionada.
     * 
     * @param {number} numberOfMonth mêses como parcela.
     * 
     * @return {string} data adicionada.
    */
    this.sumDateByMonth = function (date, numberOfMonth) {
        return moment(date, 'DD/MM/YYYY').add(numberOfMonth, 'month').format('DD/MM/YYYY');
    };

    /**
     * Adiciona um número de dias a uma data.
     * 
     * @param {string} date data se ser modificada.
     * 
     * @param {number} numberOfDays número de dias a ser
     * adicionado.
     * 
     * @param {string} format formato da data recebida.
     * 
     * @return  {string} data com os dias adicionado.
    */
    this.addDaysToDate = function (date, numberOfDays, format) {
        return moment(date, format).add(numberOfDays, 'day').format(format);
    };

    /**
     * Retornar a data de uma string no formato
     * 'dateTime'.
     * 
     * @param {string} dateTime string no formato
     * 'dateTime'.
    */
    this.getDateInDateTime = function (dateTime) {
        return moment(dateTime, 'DD/MM/YYYY HH:ss').format('DD/MM/YYYY');
    };

    /**
     * Retornar o horário de uma string no formato
     * 'dateTime'.
     * 
     * @param {string} dateTime string no formato
     * 'dateTime'.
    */
    this.getTimeInDateTime = function (dateTime) {
        return moment(dateTime, 'DD/MM/YYYY HH:ss').format('HH:ss');
    };

    /**
     * Altera o formato da data de acordo com o
     * formato recebido como parâmetro.
     * 
     * @param {string} date data que será modificada.
     * 
     * @param {string} currentFormat formato atual da
     * data recebida.
     * 
     * @param {string} newFormat formato que será aplicado
     * na data recebida.
     * 
     * @return {string} data recebida formatada de acordo com
     * o novo padrão também recebido.
    */
    this.changeDateFormat = function (date, currentFormat, newFormat) {
        return moment(date, currentFormat).format('YYYY-MM-DD');
    };

    /**
     * Função para filtrar os valores de um
     * campo de localização pelo seu local de origem
     * (Ex.:Minas Gerais (estado selecionado)
     * Cidades disponíveis: Contagem, Belo Horizonte, Betin).
     * 
     * @param {object} widget widget onde se localiza o campo
     * de localidade.
     * 
     * @param {object} field campo de localidade que receberá
     * o filtro pelo seu local de origem.
    */
    this.setPlaceFilterByPlaceOrigin = function (widget, field) {

        var simplifiedFieldName = this.getPartOfTheExpressionFromLeftToRight(field.name, 4);
        var currentRow = widget.currentRow;
        var filters = [];
        var filterReference;

        switch (simplifiedFieldName) {

            case "NMES":
                filterReference = "CDPAIS";
                filters.push(this.createFilterWithEqualityOperator(filterReference, currentRow.CDPAIS));
                break;

            case "NMMU":
                filterReference = "SGESTADO";
                filters.push(this.createFilterWithEqualityOperator(filterReference, currentRow.SGESTADO));
                filterReference = "CDPAIS";
                filters.push(this.createFilterWithEqualityOperator(filterReference, currentRow.CDPAIS));
                break;

            case "NMBA":
                filterReference = "CDMUNICIPIO";
                filters.push(this.createFilterWithEqualityOperator(filterReference, currentRow.CDMUNICIPIO));
                filterReference = "SGESTADO";
                filters.push(this.createFilterWithEqualityOperator(filterReference, currentRow.SGESTADO));
                filterReference = "CDPAIS";
                filters.push(this.createFilterWithEqualityOperator(filterReference, currentRow.CDPAIS));
                break;

        }

        if (filters) {
            filters.forEach(function (filter) {
                var placeNameFilterIndex = this.getFilterPosition(field.dataSourceFilter, filter.name);

                if (placeNameFilterIndex >= 0) {
                    field.dataSourceFilter[placeNameFilterIndex].value = currentRow[filter.name];
                } else {
                    field.dataSourceFilter.push(filter);
                }
            }.bind(this));
        }
    };

    /**
     * Função que recebe uma expressão e retorna
     * a mesma expressão simplicada(o número de 
     * caracteres recebido como parâmetro, começando
     * da esquerda para a direita.)
     * 
     * @param {string} string expressão a ser simplificada.
     * 
     * @para {number} numbersOfChars número de caracteres
     * que será retornado da expressão recebida com parâmetro.
    */
    this.getPartOfTheExpressionFromLeftToRight = function (expression, numbersOfChars) {

        eval('var regEx = /(\\w{' + numbersOfChars + '})(\\w*)/');

        var newExpression = expression.replace(regEx, "$1");
        return newExpression;
    };

    /**
     * Função que retorna um 'objeto filtro'
     * com o operador de igualdade.
     * 
     * @param {string} name nome de referência para
     * o filtro.
     * 
     * @param {string/number} value valor buscado pelo
     * filtro.
    */
    this.createFilterWithEqualityOperator = function (name, value) {

        var filter = {
            "name": name,
            "operator": "=",
            "value": value
        };

        return filter;
    };

    /**
     * Valida a inscrição informada pelo usuário
     * e seta na currentRow da widget o código do
     * tipo da inscrição e a máscara da inscrição,
     * caso a inscrição seja inválida
     * ele limpa os campos e manda uma mensagem.
     * 
     * @param {object} widget        : widget que possui a currentRow
     *                                  a ser modificada
     * 
     * @param {string} inscricao     : string com o nome do field 
     *                                  que possui a Inscrição
     * 
     * @param {string} tipoInscricao : string com o nome do field 
     *                                  do tipo de inscrição
    */
    this.validaInscricao = function (widget, inscricao, tipoInscricao) {

        var currentRow = widget.currentRow;
        var resultValidate;

        if (currentRow[inscricao].match(/^[0-9]{1,2}\.[0-9]{3}\.[0-9]{3}\-[0-9K]$/)) {
            resultValidate = this.inscricaoFormatRUT(currentRow[inscricao]);
        } else if (currentRow[inscricao].match(/^[A-Za-z]*[0-9]{8}[A-Za-z]*$/)) {
            resultValidate = this.inscricaoFormatCIF(currentRow[inscricao]);
        } else {
            resultValidate = General.inscricaoFormat(currentRow[inscricao]);
        }

        if (resultValidate.valid && resultValidate.value) {

            currentRow[tipoInscricao] = resultValidate.tipo.cod;

            currentRow[inscricao] = resultValidate.value;

        } else {

            ScreenService.showMessage('Número de inscrição inválido');

            currentRow[inscricao] = "";
            currentRow[tipoInscricao] = "";
        }

    };

    /*
     * Função responsável por formatar inscrições no formato CIF/NIF
     */

    this.inscricaoFormatCIF = function (inscricao) {
        var obj = {};
        obj.tipo = {};

        if (inscricao.match(/^[A-Za-z]([0-9]){8}$/gm)) {
            obj.tipo.cod = 'J';
            obj.tipo.desc = 'Pessoa Jurídica';
            obj.valid = true;
            obj.value = inscricao.replace(/\D/g, '');
        }

        obj.parameter = inscricao;
        return obj;
    }

    this.inscricaoFormatRUT = function (inscricao) {
        var obj = {};
        obj.tipo = {};

        if (inscricao.match(/^[0-9]{1,2}\.[0-9]{3}\.[0-9]{3}\-[0-9K]$/)) {
            obj.tipo.cod = 'J';
            obj.tipo.desc = 'Pessoa Jurídica';
            obj.valid = true;
            obj.value = inscricao.replace(/\D/g, '');
        }

        obj.parameter = inscricao;
        return obj;
    }

    this.validaCPF = function (widget, inscricao) {

        var currentRow = widget.currentRow;

        var resultValidate = General.validateCPF(currentRow[inscricao]);

        if (resultValidate) {
            resultValidate = General.inscricaoFormat(currentRow[inscricao]);
            currentRow[inscricao] = resultValidate.value;

        } else {

            ScreenService.showMessage('CPF inválido');

            currentRow[inscricao] = "";
        }

    };

    /**
     * Busca as parametrizações do sistema
     * de acordo com o número da organização
     * do operador logado no template Manager.
     * 
     * @return {object} array com as parametrizações
     * da organização do operador logado.
    */
    this.getCrmParametrization = function () {

        return templateManager.CRM_PARAMETRIZACAO;

    };

    /**
     * Esconde as ações funcionais do container
     * ativo.
    */
    this.hideFunctionalActions = function () {

        var containerActions = templateManager.container.actions;

        containerActions.forEach(function (action) {

            if (action.label !== "Voltar") {
                action.isVisible = false;
                action.disable = true;
            }

        });

    };

    /**
     * Retorna as configurações padrão das ações
     * do container ativo.
     * 
     * @param {object} widget em caso.
    */
    this.returnContainerDefaultActions = function (widget) {

        var containerActions = templateManager.container.actions;

        containerActions.forEach(function (action) {

            if (Boolean(action.disable)) {
                action.isVisible = true;
                delete action.disable;
            }

        });

    };

    /**
     * Define o filtro(regra) nos fields definidos de acordo
     * com a revenda do operador logado.
     * 
     * @param {object} objects array com os objetos a receberem
     * a regra.
    */
    this.setResaleRulesInRestrictObjectsByLoggedOperatorResale = function (objects) {

        objects.forEach(function (field) {
            this.setObjectFilterWhenResaleLoggedOperator(field);
        }.bind(this));

    };

    /**
     * Defini os filtros de revenda do obejto recebido
     * como parâmetro (field || widget).
     * 
     * @param {object} objeto object a ser modificado.
    */
    this.setObjectFilterWhenResaleLoggedOperator = function (object) {

        if (this.isResaleLoggedOperator()) {

            this.changeObjectOperTypeFilterToResaleOper(object);
            this.setObjectResaleFilter(object);
        }

    };

    /**
     * Retorna um valor lógico apontando se o operador
     * logado pertence a uma revenda.
     * 
    */
    this.isResaleLoggedOperator = function () {

        var loggedOperatorInfos = this.getLoggedOperatorInfos();

        return (Boolean(loggedOperatorInfos.NRREVENDA) && loggedOperatorInfos.IDTPOPERADOR === 'R');

    };

    /**
     * Altera o filtro de tipo de operador do objeto
     * recebido como parâmetro.
     * 
     * @param {object} object objeto a ser modificado.
    */
    this.changeObjectOperTypeFilterToResaleOper = function (object) {

        var objectFilter = object.dataSourceFilter;
        var idtooperadorFilterIndex = this.getObjectPositionInArrayByName(objectFilter, 'IDTPOPERADOR');
        var resaleTypeOperator = 'R';

        if (idtooperadorFilterIndex === 0 || Boolean(idtooperadorFilterIndex)) {
            objectFilter[idtooperadorFilterIndex].value = resaleTypeOperator;
        }

    };

    /**
     * Define um filtro no objeto recebido como parâmetro
     * atribuindo o número da revenda o qual o operador
     * logado pertence.
     * 
     * @param {object} object objeto a ser modificado.
    */
    this.setObjectResaleFilter = function (object) {

        var loggedOperatorInfos = this.getLoggedOperatorInfos();

        var resaleFilter = {
            name: "NRREVENDA",
            operator: "=",
            value: loggedOperatorInfos.NRREVENDA
        };

        object.dataSourceFilter.push(resaleFilter);

    };

    /* Função para confirmar e setar na currentRow 
     * do endereço em cadastro, o endereço retornado
     * da pesquisa pelo CEP no banco.
     * 
     * @param {string} CEP cep que será utilizado 
     *  para encontrar o endereço
     * 
    */
    this.buscarCep = function (CEP) {
        CEP = CEP.replace(/[\D]+/g, '');

        if (CEP.length == 8) {
            return restEngine.post('/findAddress', {
                'requestType': 'Row',
                'row': { 'CEP': CEP }
            });
        } else {
            ScreenService.showMessage('CEP Inválido.');
        }
    };

    /*
     * Deixa primeira letra das palavras de uma frase maíusculas
    */
    this.capitalizeFirstLetter = function (string) {
        string = string.split(' ');
        string.forEach(function (partOfString, index, string) {
            partOfString = partOfString.charAt(0).toUpperCase() + partOfString.toLowerCase().slice(1);
            string[index] = partOfString;
        });
        return string.join(' ');
    };

    /*
     * registra a validação do tipo 'phone'
    */
    this.registerPhoneValidation = function () {

        var phoneValidation = function (value, validationAttrs) {
            var retorno;
            if (value === null || value === undefined) {
                retorno = { "valid": true };
            } else {
                var numberSizeReceived = value.replace(/[^0-9]/g, '').length;
                retorno = {
                    "valid": (numberSizeReceived === 10 || numberSizeReceived === 11 || numberSizeReceived === 12 || numberSizeReceived === 0),
                    "message": ScreenService.i18n(validationAttrs.message) || ScreenService.i18n("Invalid phone.")
                };
            }
            return retorno;
        };

        ValidationEngine.registerValidation('phone', phoneValidation);
    };

    this.registerMinCurrencyValidation = function () {

        var minCurrency = function (value, validationAttrs) {
            var limit = parseFloat(validationAttrs.limit);
            if (value) {
                value = parseFloat(value.replace(/[^0-9]/g, '').slice(0, -2));
            } else {
                value = 0;
            }

            return {
                "valid": limit <= value || (isNaN(limit) && isNaN(value)),
                "message": ScreenService.i18n(validationAttrs.message) || ScreenService.i18n("Minimum value: ") + validationAttrs.limit
            };
        };

        ValidationEngine.registerValidation('minCurrency', minCurrency);
    };

    /**
     * Inicializa as actions da widget e suas 
     * filhas recursivamente.
     * 
     * @param {object} widget widget de evolução.
     * 
    */
    this.factoryWidgetActions = function (widget) {
        if (!Util.isEmptyOrBlank(widget.widgets)) {
            widget.widgets.forEach(function (inWidget) {
                this.factoryWidgetActions(inWidget);
            }.bind(this));
        }
        widget.actions.forEach(function (action) {
            metaDataFactory.actionFactory(action, widget);
        });
        widget.activate();
    };

    /**
     * Seta o datasource filter das tabs dinamicas 
     * baseado num campo da widget principal.
     * 
     * @param {object} widget widget dinamica
     * @param {object} widget widget principal
    */
    this.setDataSourceFilterOnDynamicTabs = function (tabWidget, activeWidget) {

        var NRSEQCONTATO = activeWidget.currentRow.NRSEQCONTATO;
        tabWidget.dataSourceFilter[0].value = NRSEQCONTATO;
        if (Util.isEmptyOrBlank(tabWidget.currentRow.NRSEQCONTATO))
            tabWidget.currentRow.NRSEQCONTATO = NRSEQCONTATO;
        tabWidget.reload();

    };

    /**
     * Seta um elemento em uma posição definida dentro de um
     * array.
     * 
     * @param {all} element elemento a ser inserido no array.
     * 
     * @param {object} array array a ser modificado.
     * 
     * @param {int} position posição que o elemento entrará no
     * array.
     * 
     * @return {object} array modificado.
    */
    this.setElementOnArrayDefinedPosition = function (element, array, position) {

        if (!Boolean(position)) {
            array.push(element);
        } else {
            array.splice(position - 1, 0, element);
        }

        return array;

    };

    /**
     * Verifica se a primeira data recebida como parâmtro
     * é maior que a segunda data, também recebida como
     * parâmetro.
     * Valida um intervalo de datas.
     * 
     * @param {string} initDate data inicial do intervalo.
     * 
     * @param {string} endDate data final do intervalo.
     * 
     * @param {string} format formato das datas recebidas.
     * 
     * @retur {boolean} valor lógico indicando se a primeira
     * data é maior ou não que a segunda.
    */
    this.validateIntervalDates = function (initDate, endDate, format) {

        if (moment(initDate, format).format(format) > moment(endDate, format).format(format)) {
            return false;
        }

        return true;
    };

    /**
     * Define a propriedade 'readOnly' do campo recebido como
     * parâmetro.
     * 
     * @param {object} field campo a ser modificado.
     * 
     * @param {boolean} isReadOnly valor lógico definindo a 
     * propriedade do campo.
    */
    this.setFieldReadOnlyProperty = function (field, isReadOnly) {
        field.readOnly = isReadOnly;
    };

    /**
     * Aplica o método de inserção na widget recebida como parâmetro e
     * seta na currentRow a coluna retornada.
     * 
     * @param {object} widgtet widget que sofrerá a rotina de inserção.
     * 
     * @param {string} columnToReturn coluna a ser retornada na currentRow.
    */
    this.saveAndSetColumnToBeRetunrOnCurrentRow = function (widget, columnToReturn) {

        var currentRow = widget.currentRow;
        var newRow = currentRow.__is_new;

        this.setColumnToReturnInCurrentRow(currentRow, columnToReturn);

        return General.widgetSave(widget).then(function (response) {
            if (newRow) {
                this.reloadGridInViewMode(widget);
            }

            currentRow[columnToReturn] = response.dataset.columnsToReturn[0][columnToReturn];
        }.bind(this));

    };

    /**
     * Sobreescreve a função relacionada a uma ação
     * da widget recebida como parâmetro.
     * 
     * @param {object} widget widget que terá sua ação
     * modificadas.
     * 
     * @param {string} actionName nome da ação a ser 
     * modificada.
     * 
     * @param {string} functionCall chamada da função a ser colocada
     * na action.
     * EX.: ExemploController.exmploFuncao();
     * Vale lembrar que a chamada da função é atribuida no JSON da
     * widget, sendo assim, os parâmetros devem seguir as regras de
     * chamdas em JSON.
    */
    this.overwriteAction = function (widget, actionName, functionCall) {

        if (!Boolean(widget.getAction(actionName).events[0].defaultCode)) {
            widget.getAction(actionName).events[0].defaultCode = widget.getAction(actionName).events[0].code;
        }

        widget.getAction(actionName).events[0].code = functionCall;

    };

    /**
     * Retorna a função padrão de uma ação (quando a mesma
     * foi sobrescrita).
     * 
     * @param {object} widget widget que terá sua ação 
     * modificada.
     * 
     * @param {string} actionName nome da ação a ser 
     * modificada.
    */
    this.setActionDefaultCode = function (widget, actionName) {

        widget.getAction(actionName).events[0].code = widget.getAction(actionName).events[0].defaultCode;

    };
    /* Função que verifica se o caractere digitado é do tipo NUMBER ou STRING,
    caso seja STRING, substitui o valor para vazio, caso seja numero, passa o valor digitado*/
    this.onlyNumbers = function (field) {
        const fieldValue = field.value();
        if (fieldValue) {
            var fieldElements = fieldValue.split("");

            fieldElements.forEach(function (value, index) {
                if (isNaN(parseInt(value))) {
                    fieldElements.splice(index, 1);
                    field.value(fieldElements.join(''));
                }
            });
        }
    };

    this.changeVisibilityOrgTrab = function (nrOrgRegistro, widget, actions, fields) {

        var visible = true;
        var nrOrgTrab = getLocalVar("CRM_NRORGTRAB");

        if (nrOrgRegistro == nrOrgTrab || widget.currentRow.__is_new) {
            visible = true;
        }
        else {
            visible = false;
        }

        if (!Util.isUndefinedOrNull(actions)) {
            actions.forEach(function (action) {
                if (widget.getAction(action)) {
                    widget.getAction(action).isVisible = visible;
                }
            });
        }

        if (!Util.isUndefinedOrNull(fields)) {
            fields.forEach(function (field) {
                if (widget.getField(field)) {
                    widget.getField(field).readOnly = !visible;
                }
            });
        }
    };

    /**
     * Faz com que o select-native respeite o outData, setando 
     * os capos na currentRow
    */
    this.outDataNativeFields = function (args) {
        var field = args.owner.field;
        field.dataSource.data.forEach(function (option) {
            if (option[field.valueField] === args.row[field.name]) {
                //Limpa a antiga row
                Object.keys(field.outData).forEach(function (key) {
                    if (args.row[field.outData[key]] !== undefined) delete args.row[field.outData[key]];
                });
                Object.keys(option).forEach(function (key) {
                    if (field.outData[key] !== undefined) {
                        args.row[field.outData[key]] = option[key];
                    }
                });
            }
        });
    };

    this.applyFieldDefaultValueOnFilterPopup = function (filterWidget, field) {

        var fieldDefaultValue;

        if (!Util.isEmptyOrBlank(field.filterProperties) && field.filterProperties.hasOwnProperty("defaultValue")) {
            fieldDefaultValue = field.filterProperties.defaultValue;
        } else {
            fieldDefaultValue = field.defaultValue;
        }

        if (filterWidget.currentRow) {
            filterWidget.currentRow[field.name] = typeof fieldDefaultValue === "undefined" ? "" : ZhUtil.evaluate(fieldDefaultValue);
        }
    };

    this.openFilterOnEnter = function (widgetToFilter, row, fieldsToApplyDefaultValue) {
        var filterRow = row || {};
        var fieldsToApplyDefaultValue = [];

        fieldsToApplyDefaultValue.forEach(function (fieldName) {
            var field = widgetToFilter.getField(fieldName);
            if (field) {
                this.applyFieldDefaultValueOnFilterPopup(widgetToFilter, field);
                filterRow[fieldName] = field.value();
                field.reload();
            }
        }.bind(this));
        ZhFilterPreferences.setOriginalFilter(widgetToFilter.id, filterRow);
        return ZhFilterPreferences.openFilterWidget(widgetToFilter, filterRow).then(function () {
            return templateManager.container.getActiveWidget();
        });
    };

    /**
     * Converts a date variable from YYYY-MM-DD to DD/MM/YYYY format.
     * 
     * @param {string} date - The date(YYYY-MM-DD) to be converted.
     * @returns {string} Converted date (null if the given date is invalid).
     * 
     * @author Reynaldo Pinto <reynaldo.pinto@teknisa.com>
     */
    this.convertDateFromFilter = function (date) {
        if (typeof date == 'string') {
            var dateSplit = date.split('-');
            if (dateSplit.length == 3) {
                var year = dateSplit[0];
                var month = dateSplit[1];
                var day = dateSplit[2];

                var newDate = day + '/' + month + '/' + year;

                return newDate;
            }

        }

        return null;
    }

    /**

     * Applies the readOnly property to the fields in a cascade-like way.
     * That is, a field is only writable when its "parent" field has a valid value.
     * 
     * @param {Widget} widget - Widget in which the fields are.
     * @param {string[]} fieldsNames - Fields to have the cascade property applied.
     * 
     * @author Reynaldo Pinto <reynaldo.pinto@teknisa.com>
     */
    this.cascadeReadOnly = function (widget, fieldsNames) {
        var fields = [];

        // Get the respective fields from the widget using their names
        fieldsNames.forEach(function (name) {
            var field = widget.getField(name);
            fields.push(field);
        });

        // It doesn't make any sense to apply it if there's only one field
        if (fields.length > 1) {
            fields.forEach(function (field, index, fields) {

                //Isn't the last field (has a child field)
                if (index < fields.length - 1) {
                    // Makes the next field its child
                    field.childFieldName = fieldsNames[index + 1];
                }
            });
        }
    };

    /**
     * Function to be executed when a parent field's value changes.
     * It will will always clean its descendants' values, but it will only make them
     * read-only if the parent's new value is empty.
     * 
     * @param {Field} parentField - Field which owns a child field.
     * 
     * @author Reynaldo Pinto <reynaldo.pinto@teknisa.com>
     */
    this.parentFieldOnChange = function (parentField) {
        var childField = this.getFieldChild(parentField);

        // If a field's new value is empty, its descendants will be read-only.
        if (Util.isEmptyOrBlank(parentField.value())) {
            this.cascadeCleanValue(parentField, true);
        } else {
            this.cascadeCleanValue(parentField, false);
            childField.readOnly = false;
        }
    };

    /**
     * Cleans (makes empty) the value of all field's "descendants" (cascade).
     * 
     * @param {Field} parentField - Field which will have all descendants' values
     *  cleaned.
     * @param {boolean} readOnly - Defines if the descendants will be read only.
     * 
     * @author Reynaldo Pinto <reynaldo.pinto@teknisa.com>
     */
    this.cascadeCleanValue = function (parentField, readOnly) {
        var childField = this.getFieldChild(parentField);
        var widget = parentField.widget;

        // Loops while the current field has a child
        while (!Util.isEmptyOrBlank(childField)) {

            var childName = childField.valueField || childField.name;

            // Cleans child's value
            widget.currentRow[childName] = undefined;
            childField.value(null);

            if (readOnly) {
                childField.readOnly = true;
            }

            // Gets the next child (child's child)
            childField = this.getFieldChild(childField);
        }
    };

    /**
     * Gets the child of the given field through its widget.
     * 
     * @param {Field} parentField - Field that owns the child to be returned.
     * @returns {Field} - Parent filter's child.
     * 
     * @author Reynaldo Pinto <reynaldo.pinto@teknisa.com>
     */
    this.getFieldChild = function (parentField) {
        var widget = parentField.widget;
        var childName = parentField.childFieldName;
        var childField = widget.getField(childName);

        return childField;
    };

    /**
     * Defines a property of a field in both general and filter properties.
     * 
     * @param {Field} field - Field which will have the property applied.
     * @param {string} propertyName - Property's name to be applied.
     * @param value - Property's new value.
     * 
     * @author Reynaldo Pinto <reynaldo.pinto@teknisa.com>
     */
    this.applyProperty = function (field, propertyName, value) {
        field[propertyName] = value;
        var filter = field.filterProperties;

        if (!filter) {
            field.filterProperties = filter = {};
        }

        filter[propertyName] = value;
    };

    /**
     * Returns the component's (Widget or Field) data source filter with the corresponding given name.
     * 
     * @param {object} component - Component in which the data source filter (hopefully) is.
     * @param {string} dsfName - Data source filter's name.
     * @returns {DataSourceFilter} - Data source filter with the corresponding name.
     * 
     * @author Reynaldo Pinto <reynaldo.pinto@teknisa.com>
     */
    this.getComponentDataSourceFilter = function (component, dsfName) {

        //Returns the first data source filter with the given name
        var filter = component.dataSourceFilter.find(function (dsFilter) {
            return dsFilter.name == dsfName;
        });

        return filter || undefined;
    };

    /**
     * Search and returns all fields with the given names in the widget.
     * 
     * @param {Widget} widget - Widget to look for the fields.
     * @param {string[]} names - The names of the fields to be returned.
     * 
     * @returns {Field[]} - Array of fields with the respective given names
     *  (undefined item if the field is not found).
     * 
     * @author Reynaldo Pinto <reynaldo.pinto@teknisa.com>
     */
    this.getWidgetFieldsByName = function (widget, names) {
        var fields = [];

        names.forEach(function (name) {
            var field = widget.getField(name);
            fields.push(field);
        });

        return fields;
    };

    /**
     * Agrupa um array de objetos de forma semelhante ao GROUP BY do SQL.
     * 
     * @param {Array} rows - Array de objetos(rows) a serem agrupados.
     * @param {string[]} columnsToGroup - Nome das colunas que serão utilizadas
     *como base para o agrupamento.
     */
    this.groupBy = function (rows, columnsToGroup) {
        // rows = [];
        // columnsToGroup = [];

        // Caso não seja passado nenhum valor nas rows, será retornado uma
        //estrutura padrão vazia
        if (rows.length == 0) {
            var _default = {
                value: {},
                rows: []
            };

            return _default;
        }

        // Cria os grupos para cada row.
        var groups = rows.reduce(function (groupedRows, row) {
            // Verifica se já existe algum grupo com os mesmos valores da row
            //em questão.
            var group = groupedRows.find(function (gpdRow) {
                // Faz a verificação abaixo com todas as columas a serem
                //agrupadas.
                return columnsToGroup.reduce(function (sameGroup, column) {
                    // Se o valor da coluna em questão da row é igual ao do
                    //grupo sendo verificado.
                    sameGroup &= (row[column] === gpdRow.value[column]);

                    return sameGroup;
                }, true);
            });

            // Caso não ache um grupo com esses valores, criará um novo.
            if (group === undefined) {
                group = this.createNewGroup(row, columnsToGroup);
                groupedRows.push(group);
            }

            group.rows.push(row);

            return groupedRows;
        }.bind(this), []);

        return groups;
    };

    this.createNewGroup = function (row, groupColumns) {
        var group = {
            value: {},
            rows: []
        };

        group.value = groupColumns.reduce(function (groupValue, column) {
            groupValue[column] = row[column];

            return groupValue;
        }, {});

        return group;
    };

    this.saveWidget = function (widget, closeSwipe) {
        closeSwipe = true;
        // Assumindo que a rota para salvar é a mesma que para pegar os
        //dados + /save
        var route = widget.dataSource.name + '/save';

        var params = {
            requestType: 'DataSet',
            dataset: [widget.currentRow]
        };

        // Envia uma requisição ao servidor para salvar a nova row
        var request = restEngine.post(route, params).promise;

        request.then(function (response) {
            // Sai do swipe de adicionar e vai para a grid
            if (closeSwipe) {
                ScreenService.closeSwipe();
            }

            // Ativa as tabs da widget
            widget.widgets.forEach(function (tab) {
                tab.setEnabled(true);
            });

        }).catch(this.showErrorMessage); // Mostra uma mensagem na tela caso haja algum erro

        // Retorna a promise, permitindo que ela seja tratada posteriormente em
        //outra função
        return request;
    };

    this.showErrorMessage = function (error) {
        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
    };

    this.reloadWithTempFilter = function (widget, columnName, columnValue) {
        // Criação do filtro que servirá para mostrar apenas a row desejada
        var filterNewRow = {
            name: columnName,
            operator: '=',
            value: columnValue,
            // Indicação para saber qual filtro remover após o reload
            temp: true
        };

        // Adiciona o novo filtro criado ao data source filter
        widget.dataSourceFilter.push(filterNewRow);

        // Recarrega os dados e remove o filtro temporário
        return widget.reload().then(function () {
            widget.dataSourceFilter = widget.dataSourceFilter.filter(function (x) {
                return x.temp !== true;
            });
        });
    };

    /**
     * Recarrega a widget passada apenas se seu filtro já tiver sido aplicado.
     * 
     * @param widget - Widget a ser verificado e recarregada.
     * @author Reynaldo Pinto <reynaldo.pinto@teknisa.com>
     */
    this.reloadWidgetIfFiltered = function (widget) {
        if (widget.filtered) {
            widget.reload();
        }
    };

    this.setWidgetAsFiltered = function (widget) {
        widget.filtered = true;
    };

    this.isWidgetFilter = function (widget) {
        var isFilter = widget.name == "zhFilterPreferencesSelectConditions";

        return isFilter;
    };

    this.post = function (uri, params, callback) {
        if (!uri || !params) {
            return undefined;
        }

        var self = this; // Armazena o valor de 'this' em uma variável local

        return restEngine.post(uri, params).then(function (response) {
            if (!response.dataset) {
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(response));
                throw response;
            } else {
                if (callback) {
                    callback(response);
                }
            }

            return response;
        }).catch(function (err) {
            self.showErrorMessage(err); // Usa a variável 'self' em vez de 'this'
            throw err;
        });
    };

    this.getDataSourceFilter = function (widget, filterName) {
        var filter = widget.dataSourceFilter.find(function (dsFilter) {
            return dsFilter.name === filterName;
        });

        return filter;
    };

    this.reloadGridInViewMode = function (widget) {
        widget.mode = 'list';
        var promise = widget.reload();
        widget.mode = 'view';

        return promise;
    }

    this.construirWidgetSelect = function(field, newActions) {
        if (!field.selectWidget) {
            var actions = [{
    			"label": ScreenService.i18n("Cancel"),
    			"showAsAction": "back",
    			"isVisible": true,
    			"showOnForm": true,
    			"showOnList": true,
    			"hideIcon": true,
    			"events": [{
    				"name": "ActionEvent",
    				"code": "ScreenService.closePopup(); args.owner.widget.afterClosePopup(args.owner.widget.selectField);",
    				"id": 9998
    			}]
    		}];
    
    		if (field.showAddButtonAs == 'action') {
    			actions.push({
    				"icon": "plus",
    				"label": field.addButtonText,
    				"showAsAction": "always|edit|checked_rows|view",
    				"isVisible": true,
    				"showOnForm": true,
    				"showOnList": true,
    				"events": [{
    					"name": "ActionEvent",
    					"code": "args.owner.widget.onAdd()",
    					"id": 9999
    				}]
    			});
    		}
    		
    		actions = actions.concat(newActions);

    		var template;
    		if (!field.showSelectAs) {
    			template = "widget/list.html";
    		} else if (field.showSelectAs === "tree") {
    			template = "widget/tree/grid.html";
    		} else {
    			template = "widget/" + field.showSelectAs + ".html";
    		}
    
    		var fields;
    		if (field.fields && field.fields.length) {
    			fields = field.fields;
    		} else {
    			fields = [{
    				"label": field.sourceLabel,
    				"name": field.descriptionField,
    				"showOnList": true,
    				"mask": field.mask
    			}];
    		}
            
			var widgetEvents = [{
				"name": "WidgetAfterMoveRow",
				"code": "args.owner.setSelected(args);",
				"id": 9999
			}];
			field.selectWidget = metaDataFactory.widgetFactory({
				"id": 9009,
				"name": "Widget",
				"label": field.label,
				"template": template,
				"container": field.widget.container,
				"isVisible": true,
				"popupNoBlock": false,
				"showDescriptionOrder": false,
				"floatingControl": {
					"openSearch": !Util.isMobile(),
					"defaultSearchField": field.defaultSearchField || field.descriptionField,
					"pdfAction": false,
					"xlsAction": false,
					"csvAction": false,
					"searchAction": true,
					"customizationAction": {
						"filter": false,
						"layout": false,
						"view": false
					}
				},

				"parentProperty": field.parentProperty,
				"primaryProperty": field.primaryProperty,
				"expandingProperty": field.expandingProperty,
				"breadcrumbProperty": field.breadcrumbProperty,

				"order": field.order,
				"reverse": field.reverse,
				"bringGroupsCollapsed": field.bringGroupsCollapsed,
				"orderFromGroups": field.orderFromGroups,
				"selectField": field,
				"showCheckbox": false,
				"onAdd": field.onAdd,
				"showAddButtonAs": field.showAddButtonAs,
				"addButtonText": field.addButtonText,
				"noMatchText": field.noMatchText,
				"searchNoMatchText": field.searchNoMatchText,
				"fields": fields,
				"dataSource": field.dataSource,
				"dataSourceFilter": field.dataSourceFilter,
				"itemsPerPage": field.itemsPerPage,
				"searchWithPagination": Util.isUndefinedOrNull(field.searchWithPagination) ? true : field.searchWithPagination,
				"hasPagination": Util.isUndefinedOrNull(field.hasPagination) ? true : field.hasPagination,
				"onDemand": field.onDemand,
				"allowSelectOnlyLastChild": field.allowSelectOnlyLastChild,
				"searchCriteria": field.searchCriteria,

				"actions": actions,
				"events": this.propagate(widgetEvents, field),

				"styles": field.selectWidgetStyles
			});
			
			field.selectWidget.setSelected = this.setSelected;
			field.selectWidget.afterClosePopup = this.afterClosePopup;
		}
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('CRM_Utilities', CRM_Utilities);
});

// FILE: ./assets/js/utilities/IntegracaoRDStationController.js
function IntegracaoRDStationController(templateManager, ScreenService, restEngine, General, Messages, metaDataFactory,CRM_Utilities){
    var LINK_CRM = 'https://crm.teknisa.com/backend/index.php';
    var LINK_CRM_CLOUD = 'https://crm.teknisa.cloud/backend/index.php';
    
     CRM_Utilities.addController(this, 'IntegracaoRDStationController');
    
    /**
     *      PARAMETRIZACAO
    */
    
    /**
     * Inicia a integração com o RDStation, 
     * chamando a rota de autenticação e salvando
     * o refresh token no templateManager.CRM_PARAMETRIZACAO.
    */
    this.authRDStation = function(widget){
        var self = this;
        if(Util.isEmptyOrBlank(templateManager.CRM_PARAMETRIZACAO.DSREFRESHTOKENRD) && templateManager.LOGGEDOPERATOR.CDOPERADOR === templateManager.CRM_PARAMETRIZACAO.CDOPERRESPONSAVELRD){
            var x = screen.width/2 - 900/2 - 50;
            var y = screen.height/2 - 600/2 - 50;
            var redirect_url = (window.location.href.indexOf('cloud') !== -1) ? LINK_CRM_CLOUD : LINK_CRM;
            redirect_url += '/IntegracaoRDStation/auth';
            var popupSendContact = window.open('https://api.rd.services/auth/dialog?client_id=2de5e1c4-b917-4d0b-9356-7a67c6a89362&redirect_url='+redirect_url, 'popup','height=600,width=900,top='+y+',left='+x);
            
            if(popupSendContact !== null){
                ScreenService.changeLoadingMessage('Aguardando autorização...');
                ScreenService.showLoader();
                
                function removeListener(event) {
                    window.removeEventListener("message", removeListener);
                    if(event.data.success === false && !window.authRDFinished){
                        window.authRDFinished = true;
                        ScreenService.showMessage('Não foi possível conectar com o RD Station, tente novamente! <br> Se o erro persistir contate um administrador.');    
                        ScreenService.hideLoader();
                        ScreenService.restoreDefaultLoadingMessage();
                    }else if(event.data.closedByUser === true && !window.authRDFinished){
                        window.authRDFinished = true;
                        ScreenService.showMessage('Não foi possível conectar com o RD Station, a janela de autorização foi fechada.');    
                        ScreenService.hideLoader();
                        ScreenService.restoreDefaultLoadingMessage();
                    }else if(!window.authRDFinished){
                        window.authRDFinished = true;
                        ScreenService.showMessage('RD Station conectado!');  
                        ScreenService.hideLoader();
                        ScreenService.restoreDefaultLoadingMessage();
                        templateManager.CRM_PARAMETRIZACAO.DSREFRESHTOKENRD = event.data.refreshToken;
                        self.showCustomFieldAction();
                    }
                }
                var timer = setInterval(function() { 
                    if(popupSendContact.closed) {
                        clearInterval(timer);
                        removeListener({data:{closedByUser:true}});
                        window.authRDFinished = false;
                    }
                }, 1000);
                
                window.addEventListener("message", removeListener);
            }else{
                ScreenService.showMessage("Popup do navegador bloqueado!<br/>Libere o popup para realizar a sincronização com o RD Station.");
            }
        }
    };
    
    /**
     * Abre o swipe com os passos para configurar a integração
     * no RD Station.
    */
    this.helpRD = function(widget){
        var widHelp = templateManager.container.getWidget('MODAL_HELP');
        var url = (window.location.href.indexOf('cloud') !== -1) ? LINK_CRM_CLOUD : LINK_CRM;
        url += '/IntegracaoRDStation/importLead?organization='+templateManager.LOGGEDOPERATOR.NRORG;
        widHelp.currentRow.URL = url;
        ScreenService.openSwipe(widHelp);
    };
    
    /**
     *      CAMPOS PERSONALIZADOS
    */
    
    /**
     * Copia a url de integração do field para a área de transferência.
    */
    this.copyURLRDStation = function(widget){
        if(!widget.urlCopied){
            var url = widget.currentRow.URL;
            $('body').append('<input id="temp" value='+url+'></input>');
            $('body > #temp').select();
            document.execCommand('copy');
            $('body > #temp').remove();
            ScreenService.successNotification('Url copiada para a área de transferência', 1000);
            //Evita vários clicks no botão;
            widget.urlCopied = true;
            setTimeout(function(){
                widget.urlCopied = false;
            },1200);
        }
    };
    
    /**
     * Abre o popup de campos personalizados.
    */
    this.openModalCustomField = function(widget){
        var widCustomField = templateManager.container.getWidget('MODAL_CUSTOM_FIELD');
        ScreenService.openPopup(widCustomField);
        widCustomField.reload();
    };
    
    /**
     * New row na widget de campos personalizados.
    */
    this.addField = function(widget){
        widget.template = 'widget/form.html';
        widget.edit();
        widget.currentRow = {};
        ScreenService.openPopup(widget);
    };
    
    /**
     * Cancel na widget de campos personalizados
    */
    this.cancelNewField = function(widget){
        widget.template = 'widget/grid.html';
        widget.list();
    };
    
    /**
     * Save e Edit na widget de campos personalizados.
    */
    this.saveCustomField = function(widget){
        if(widget.isValid()){
            var paramsRestEngine = {
                "requestType": "Row",
                "row": widget.currentRow
            };
            restEngine.post('/IntegracaoRDStation/saveCustomField', paramsRestEngine).then(function(response){
                if(response && response.dataset){
                    if(Util.isEmptyOrBlank(widget.currentRow.IDUUID)){
                        ScreenService.showMessage('Campo personalizado criado! \n Você pode usá-lo dentro do RDStation.');
                        widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
                		widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
                		widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
                		widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
                		widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
                        widget.currentRow.__columns_to_return = widget.paramsNewCode.__columns_to_return;
                        widget.currentRow.__is_new = true;
                        widget.currentRow.IDUUID = response.dataset.CUSTOM_FIELD['uuid'];
                    }
                    widget.currentRow.DSOPCOESCAMPOSELECT = (widget.currentRow.DSOPCOESCAMPOSELECT) ? widget.currentRow.DSOPCOESCAMPOSELECT.join(',') : '';
                    widget.currentRow.NMCAMPORELACIONADO  = (Array.isArray(widget.currentRow.NMCAMPORELACIONADO))  ? widget.currentRow.NMCAMPORELACIONADO.join(',')  :  widget.currentRow.NMCAMPORELACIONADO || '';
                    widget.currentRow.NMTABELARELACIONADA = (Array.isArray(widget.currentRow.NMTABELARELACIONADA)) ? widget.currentRow.NMTABELARELACIONADA.join(',') :  widget.currentRow.NMTABELARELACIONADA || '';
                    widget.saveRow().then(function (){
                        widget.reload().then(function(){
                            this.cancelNewField(widget);
                        }.bind(this));
                    }.bind(this));
                }    
            }.bind(this)).catch(function(error){
                if(error.data.errorCode === 2)
                    ScreenService.showMessage(error.data.error);
                else
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
                
            });
        }
    };
    
    /**
     * Delete na widget de campos personalizados.
    */
    this.deleteFields = function(widget){
        var paramsRestEngine = {
            "requestType": "DataSet",
            "dataset": widget.dataSource.getCheckedRows()
        };
        restEngine.post('/IntegracaoRDStation/deleteCustomFields', paramsRestEngine).then(function(response){
            if(response && response.dataset){
                widget.removeCheckedRows().then(function () {
                    widget.reload();
                });
            }
        }.bind(this)).catch(function(error){
            if(error.data.errorCode === 2)
                ScreenService.showMessage(error.data.error);
            else
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
            
        });
    };
    
    /**
     * Controla a visibilidade da action de campos
     * personalizados baseado no templateManager.CRM_PARAMETRIZACAO.DSREFRESHTOKENRD
     * e no operador logado.
    */
    this.showCustomFieldAction = function(){
        var widRD = templateManager.container.getWidget('WDGT_PARAM_INTEGRATION_RDSTATION');
        var customFieldAction = widRD.getAction('CREATE_CUSTOM_FIELD');
        if(templateManager.LOGGEDOPERATOR.CDOPERADOR === templateManager.CRM_PARAMETRIZACAO.CDOPERRESPONSAVELRD){
            if(Util.isEmptyOrBlank(templateManager.CRM_PARAMETRIZACAO.DSREFRESHTOKENRD)){
                customFieldAction.isVisible = false;
            }else{
                customFieldAction.isVisible = true;
            }
        }else{
            customFieldAction.isVisible = false;
        }
        widRD.activate();
    };
    
    /**
     * Controla a visibilidade e obrigatoriedade do campo
     * de opções baseado no tipo de campo personalizado.
    */
    this.showOptions = function(widget){
        var tipo = widget.currentRow.IDTIPOCAMPORDSTATION;
        if(!Util.isEmptyOrBlank(tipo) && (tipo === 'CHECK_BOX' || tipo === 'MULTIPLE_CHOICE' || tipo === 'COMBO_BOX' || tipo === 'RADIO_BUTTON')){
            widget.getField('DSOPCOESCAMPOSELECT').isVisible = true;
            widget.getField('DSOPCOESCAMPOSELECT').validations = {required:true};
        }else{
            widget.getField('DSOPCOESCAMPOSELECT').isVisible = false;
            widget.getField('DSOPCOESCAMPOSELECT').validations = {};
        }
    };
    
    /**
     * Muda a widget de campos personalizdos para o modo de edit
    */
    this.changeWidgetToEditMode = function(args){
        args.e.preventDefault();
        args.owner.currentRow = args.row;
        args.owner.template = 'widget/form.html';
        args.owner.edit();
    };
    
    /*  FIM CAMPOS PERSONALIZADOS  */
    
    /*  FIM PARAMETRIZACAO  */
    
    /**
     * GERAL
    */
    
    /**
     * Cria a action de enviar para o RD baseado no operador logado
     * e na parametrização DSREFRESHTOKENRD
    */
    this.insertSendActionRD = function(widget, funnel){
        funnel = CRM_Utilities.capitalizeFirstLetter(funnel);
        funnel = (funnel === 'Cliente') ? 'Client' : (funnel === 'Prospect') ? 'Qualified Lead' : 'Lead';
        var hasSendAction = false;
        widget.actions.forEach(function(action){
            if(action.name === 'SEND_RD'){
                hasSendAction = true;
            }
        });
        var needAction = Boolean(!Util.isEmptyOrBlank(templateManager.CRM_PARAMETRIZACAO.DSTOKENPUBLICORD) && templateManager.LOGGEDOPERATOR.CDOPERADOR === templateManager.CRM_PARAMETRIZACAO.CDOPERRESPONSAVELRD);
        if(needAction && !hasSendAction){
            var sendAction = {
                "id":"172231975831131665551239",
                "name": "SEND_RD",
                "label": "Enviar para o RD Station",
                "isVisible": true,
                "preventHide":true,
                "showAsAction": "never_view",
                "events": [
                    {
                        "name": "ActionEvent",
                        "code": "IntegracaoRDStationController.openPopupSendContactToRD(args.owner.widget);"
                    }
                ]
            };
            metaDataFactory.actionFactory(sendAction, widget, true);
            widget.FUNNEL = funnel;
        }else if(needAction && hasSendAction){
            widget.getAction('SEND_RD').isVisible = true;
            widget.FUNNEL = funnel;
        }else if(!needAction && hasSendAction){
            widget.getAction('SEND_RD').isVisible = false;
        }
        widget.activate();
    };
	
	
	this.openPopupSendContactToRD = function(widget){
	    var popupSendContact = {
            "name": "SEND_RD_POPUP",
            "label": "Enviar para o RD Station",
            "isVisible": false,
            "showAsTab": false,
            "template": "widget/form.html",
            "parent":widget,
            "container":widget.container,
            "events": [],
            "actions": [
                {
                    "id": "6182828515686520676545",
                    "name": "enviar",
                    "isVisible": true,
                    "label": "Enviar",
                    "showAsAction": "never",
                    "events": [
                        {
                            "id": "6182828514145614549655",
                            "name": "ActionEvent",
                            "code": "IntegracaoRDStationController.sendContactToRD(args.owner.widget, args.owner.widget.parent.parent)"
                        }
                    ]
                },
                {
                    "id": "6182828511372890396656",
                    "name": "cancel",
                    "label": "Voltar",
                    "showAsAction": "back",
                    "events": [
                        {
                            "id": "6182828512205401251657",
                            "name": "ActionEvent",
                            "code": "ScreenService.closePopup(args.owner.widget);"
                        }
                    ]
                }
            ],
            "fields": [
                {
                    "id": "61828285113728903966578",
                    "name": "CONVERSION_EVENT",
                    "label": "Evento de Conversão",
                    "template": "field/text-edit.html",
                    "class": "12",
                    "isVisible": true,
                    "showOnView": true,
                    "showOnForm": true,
                    "defaultValue":"CRM",
                    "minValue": 0,
                    "validations": {
                        "required":true
                    },
                    "events": []
                },
                {
                    "id": "61828285113728903966577",
                    "name": "NAME",
                    "label": "Interlocutor",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "isVisible": true,
                    "showOnForm": true,
                    "showOnList": true,
                    "readOnly": false,
                    "class": "12",
                    "valueField": "NRSEQINTERLOCUTOR",
                    "descriptionField": "NMINTERLOCUTOR",
                    "dataSource": {
                        "name": "product#/crm_interlocutor",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "validations": {
                        "required":true
                    },
                    "itemsPerPage": 50,
                    "dataSourceFilter": [
                   
                        {
                            "name": "NRPARCNEGOCIO",
                            "operator": "=",
                            "value": "@General.getFieldValue('NRPARCNEGOCIO', '"+widget.name+"')@"
                        },
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": "@getLocalVar('CRM_NRORGTRAB')@"
                        }
                    ],
                    "outData": {
                        "EMAILINTERLOC": "EMAIL",
                        "NRTELEFONE1": "PHONE",
                        "NRTELEFONE2": "PHONE_2",
                        "NMINTERLOCUTOR": "NAME",
                        "NMCARGOINTERLOC":"JOB"
                    },
                    "fields": [
                        {
                            
                            "name": "NMINTERLOCUTOR",
                            "label": "Nome Interlocutor",
                            "isVisible": true,
                            "showOnList": true
                        }
                    ],
                    "events": [
                        {
                            
                            "name": "FieldAfterSelectOpen",
                            "code": "args.owner.field.reload()"
                        }
                    ],
                    "filterProperties": {
                        "isVisible": false,
                        "showOnForm": false
                    }
                },
                {
                    "id": "155128146334412170291613258",
                    "name": "TAGS",
                    "label": "Tags",
                    "template": "field-tag#field/tag.html",
                    "class": "12",
                    "help":"Separe os tags utilizando ' , ', ' tab ' ou ' enter '.",
                    "isVisible": true,
                    "dataSource":{
                        "data":[]
                    },
                    "showOnView": true,
                    "showOnForm": true,
                    "readOnly": false
                }
            ]
        };  
        
        if(templateManager.container.getWidget('SEND_RD_POPUP') === undefined){
            popupSendContact = metaDataFactory.widgetFactory(popupSendContact);
            widget.widgets.push(popupSendContact);
        }else{
            popupSendContact = templateManager.container.getWidget('SEND_RD_POPUP');
        }
        ScreenService.openPopup(metaDataFactory.widgetFactory(popupSendContact));
	};
	
	/**
	 * Manda o contato para o RD Station,
	 * leads vão como Leads, prospects como Leads Qualificados
	 * e Clientes como Clientes
	*/
	this.sendContactToRD = function(popup, parcWidget){
	    popup.currentRow.FUNNEL = parcWidget.FUNNEL;
	    popup.currentRow.COMPANY = parcWidget.currentRow.NMCANDIDATO || parcWidget.currentRow.NMRAZSOCPROS || parcWidget.currentRow.NOME;
	    popup.currentRow.NR_EMP = parcWidget.currentRow.NRFUNCCAN || parcWidget.currentRow.NRFUNCPROS || '';
	    popup.currentRow.COMPANY_ADDRESS = (parcWidget.currentRow.NMESTADO || '') + ' ' + (parcWidget.currentRow.NMMUNICIPIO || '') + ' ' + (parcWidget.currentRow.NMBAIRROCAN || parcWidget.currentRow.NMBAIRRO || '');
	    popup.currentRow.TAGS = Array.isArray(popup.currentRow.TAGS) ? popup.currentRow.TAGS.join(',') : ''; 
	    popup.currentRow.NRPARCNEGOCIO = parcWidget.currentRow.NRPARCNEGOCIO; 
	    
	    var paramsRestEngine = {
            "requestType": "Row",
            "row": popup.currentRow
        };
        restEngine.post('/IntegracaoRDStation/sendContactToRD', paramsRestEngine).then(function(response){
            if(response && response.dataset){
                ScreenService.showMessage('Parceiro enviado! <br> Você pode manipulá-lo no RD Station');
                ScreenService.closePopup();
            }
        }.bind(this)).catch(function(error){
            if(error.data.errorCode === 2)
                ScreenService.showMessage(error.data.error);
            else
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
            
        });
	};
	
	this.downloadDoc = function(){
        var filename = 'Documentacao_Integracao_RD_CRM.pdf';
        window.open("files/" + filename, "_blank");
	};
}
Configuration(function(ContextRegister){
    ContextRegister.register('IntegracaoRDStationController', IntegracaoRDStationController);
});

// FILE: ./assets/js/utilities/PartnerInfosModalController.js
function PartnerInfosModalController(CRM_Utilities, ScreenService, templateManager, metaDataFactory){
    
    CRM_Utilities.addController(this, 'PartnerInfosModalController');
    
    /**
     * Builda o modal.
     * 
     * @param {object} widget widget que irá receber o modal.
     * 
     * @param {string} nrparcnegocio nome do campo com o número
     * do parceiro de negócio.
     * 
     * @return widget modal construida.
     * 
    */
    this.factoryModalWidget = function(activeWidget, nrparcnegocio) {
        
        /*Modificado em 22/09 por Arthur
            Adicionada propriedade 'preventHide',
            que garante que a widget Dados do Parceiro 
            não tenha suas actions setadas como invisíveis em chamados já 
            concluidos
        */
        var modalWidgetJson = {
            "id":"17223197583113",
            "name": "WDGT_MODAL_PARTNER_INFOS",
            "label": "Informações do Parceiro",
            "container": activeWidget.container,
            "parent": activeWidget,
            "template": "widget/tabbedWidget.html",
            "defaultTab": "WDGT_PARTNER_DATA",
            "showAsModal": true,
            "preventHide":true,
            "showAsTab":false,
            "isVisible": true,
            "events":[
                {
                    "id":"17223197583113124",
                    "name":"WidgetOnEnterOnce",
                    "code":"AbaInterlocutorController.setInterlocutorWidgetOnActiveWidget(args.owner);ABALogotipoParceiroController.setLogoWidgetOnActiveWidget(args.owner, 5);PartnerInfosModalController.changeTemplateTabInterlocutor(args.owner);"
                }
            ],
            "widgets":[
                {
                    "id":"17223197583113123",
                    "name": "WDGT_PARTNER_DATA",
                    "label": "Dados",
                    "container": activeWidget.container,
                    "template": "widget/form-view.html",
                    "isVisible": true,
                    "dataSource": {
                        "name": "product#/crm_candidato_prospect_parcnegocio",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "dataSourceFilter": [
                        {
                            "name": "NRPARCNEGOCIO",
                            "operator": "=",
                            "value": ""
                        },
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": "@getLocalVar('CRM_NRORGTRAB')@"
                        },
                        {
                            "name": "CRM_NRORGTRAB",
                            "operator": "=",
                            "value": "@getLocalVar('CRM_NRORGTRABALHO')@"
                        }
                    ],
                    "actions": [],
                    "events": [
                        {
                            "id":"17223197583113125",
                            "name": "WidgetOnEnter",
                            "code": "PartnerInfosModalController.setModalFilterByActivePartner(args.owner.parent, templateManager.container.getWidget('" + activeWidget.name + "'), '" + nrparcnegocio + "');"
                        },
                        {
                            "id":"17223197583113126",
                            "name": "WidgetAfterLoadDataSource",
                            "code": "args.owner.moveToFirst();"
                        }
                    ],
                    "fields": [
                        {
                            "id":"17223197583113127",
                            "name": "NOMEPRINCIPAL",
                            "label": "Nome",
                            "template": "field/text-edit.html",
                            "class": "12",
                            "isVisible": true,
                            "showOnView": true
                        },
                        {
                            "id":"17223197583113128",
                            "name": "NOMEFANTASIA",
                            "label": "Nome Fantasia",
                            "template": "field/text-edit.html",
                            "class": "12",
                            "isVisible": true,
                            "showOnView": true
                        },
                        {
                            "id":"17223197583113129",
                            "name": "INSCRICAO",
                            "label": "Inscrição",
                            "template": "field/text-edit.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnView": true
                        },
                        {
                            "id":"17223197583113130",
                            "name": "TIPOINSCRICAO",
                            "label": "Tipo Inscrição",
                            "template": "field/select-native.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnView": true,
                            "valueField": "value",
                            "descriptionField": "name",
                            "validations": {},
                            "events": [],
                            "dataSource": {
                                "data": [
                                    {
                                        "name": "Física",
                                        "value": "CPF"
                                    },
                                    {
                                        "name": "Jurídica",
                                        "value": "CNPJ"
                                    },
                                    {
                                        "name": "Outros",
                                        "value": "CODIGO"
                                    },
                                    {
                                        "name": "Inscrição",
                                        "value": "LIVRE"
                                    }
                                ]
                            }
                        },
                        {
                            "id":"17223197583113131",
                            "name": "NMOPERRESPONSAVEL",
                            "label": "Operador Responsável",
                            "template": "field/text-edit.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnView": true
                        },
                        {
                            "id":"17223197583113132",
                            "name": "TIPOPARCEIRO",
                            "label": "Tipo Parceiro",
                            "template": "field/select-native.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnView": true,
                            "valueField": "value",
                            "descriptionField": "name",
                            "dataSource": {
                                "data": [
                                    {
                                        "name": "Lead",
                                        "value": "CANDIDATO"
                                    },
                                    {
                                        "name": "Prospect",
                                        "value": "PROSPECT"
                                    },
                                    {
                                        "name": "Cliente",
                                        "value": "CLIENTE"
                                    }
                                ]
                            }
                        },
                        {
                            "id":"17223197583113133",
                            "name": "DSSEGMER",
                            "label": "Segmento de Mercado",
                            "template": "field/text-edit.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnView": true
                        },
                        {
                            "id":"17223197583113134",
                            "name": "DSATIVCLI",
                            "label": "Ramo de Atividade",
                            "template": "field/text-edit.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnView": true
                        },
                        {
                            "id":"17223197583113135",
                            "name": "DSTPATIVCLIENTE",
                            "label": "Tipo de Atividade",
                            "template": "field/text-edit.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnView": true
                        },
                        {
                            "id":"17223197583113136",
                            "name": "NMMODODIVULG",
                            "label": "Como Chegou Até Nós",
                            "template": "field/text-edit.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnView": true
                        },
                        {
                            "id":"17223197583113137",
                            "name": "IDATIVO",
                            "label": "Ativo",
                            "template": "field/select-native.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnView": true,
                            "valueField": "value",
                            "descriptionField": "name",
                            "validations": {},
                            "dataSource": {
                                "data": [
                                    {
                                        "name": "Sim",
                                        "value": "S"
                                    },
                                    {
                                        "name": "Não",
                                        "value": "N"
                                    }
                                ]
                            }
                        },
                        {
                            "id":"17223197583113138",
                            "name": "NRFUNCIONARIOS",
                            "label": "Nr. Funcionários",
                            "template": "field/text-edit.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnView": true
                        }
                    ],
                    "widgets":[]
                },
                {
                    "id": "14418982341257778598851",
                    "name": "WDGT_DADOS_ADICIONAIS",
                    "container": activeWidget.container,
                    "label": "Dados Adicionais",
                    "showCheckbox": false,
                    "isVisible": true,
                    "itemsPerPage": 30,
                    "template": "widget/form-view.html",
                    "templateToForm":"widget/form.html",
                    "showDescriptionOrder": false,
                    "dataSource": {
                        "rest": true,
                        "lazyLoad": true,
                        "name": "product#/crud/ger_parcnegocioinfo",
                        "itemsPerPage": 100
                    },
                    "dataSourceFilter": [
                        {
                            "name": "P_NRPARCNEGOCIO",
                            "operator": "=",
                            "value": ""
                        },
                        {
                            "name": "P_NRORG",
                            "operator": "=",
                            "value": "@templateManager.LOGGEDOPERATOR.NRORG@"
                        }
                    ],
                    "actions": [],
                    "events": [
                        {
                            "id": "14418982343495474723876",
                            "name": "WidgetOnEnter",
                            "code": "PartnerInfosModalController.setCurrentRowDadosAdicionais(args.owner)"
                        }
                    ],
                    "fields": [   
                        {
                            "id":"17223197583113139",
                            "name": "NMRESPGERAL",
                            "label": "Responsável Geral",
                            "class":"12",
                            "isVisible": true,
                            "showOnForm": true,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id":"17223197583113140",
                            "name": "NMPONTOATENDIMENTO",
                            "label": "Ponto de Atendimento",
                            "class":"12",
                            "isVisible": true,
                            "showOnForm": true,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id":"17223197583113141",
                            "name": "NRPONTUACAO",
                            "label": "Pontuação",
                            "class":"6",
                            "isVisible": true,
                            "showOnForm": true,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id":"17223197583113142",
                            "name": "CDINTEGRACAO",
                            "label": "Núm. Integração",
                            "class":"6",
                            "isVisible": true,
                            "showOnForm": true,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id":"17223197583113143",
                            "name": "DTINIRELACIONA",
                            "label": "Data de Início do Relacionamento",
                            "class":"6",
                            "isVisible": true,
                            "showOnForm": true,
                            "dateFormat": "DD/MM/YYYY",
                            "template": "field/calendar.html"
                        },
                        {
                            "id":"17223197583113143",
                            "name": "NMMODORECEBINFO",
                            "label": "Como Deseja Receber Informações",
                            "class":"6",
                            "isVisible": true,
                            "showOnForm": true,
                            "template": "field/text-edit.html"
                        }
                    ],
                    "widgets": []
                },
                {
                    "id":"17223197583113144",
                    "name": "WDGT_PARTNER_ADDRESS",
                    "label": "Endereços",
                    "container": activeWidget.container,
                    "template": "widget/grid.html",
                    "isVisible": true,
                    "dataSource": {
                        "name": "product#/crud/enderecoparc_localizacao_tipoendereco",
                        "rest": true,
                        "itemsPerPage": 50,
                        "lazyLoad": true
                    },
                    "dataSourceFilter": [
                        {
                            "name": "NRPARCNEGOCIO",
                            "operator": "=",
                            "value": ""
                        }
                    ],
                    "actions": [],
                    "events": [
                        {
                            "id":"17223197583113144",
                            "name": "WidgetOnEnter",
                            "code": "args.owner.reload();PartnerInfosModalController.resizeWindow()"
                        }
                    ],
                    "fields": [
                        {
                            "id":"17223197583113145",
                            "label": "Tipo de Endereço",
                            "name": "NMTIPOENDERECO",
                            "template": "field/text-edit.html",
                            "isVisible": true,
                            "showOnForm": true,
                            "showOnList": true,
                            "valueField": "CDTIPOENDERECO",
                            "descriptionField": "NMTIPOENDERECO",
                            "dataSource": {},
                            "events": []
                        },
                        {
                            "id":"17223197583113146",
                            "name": "NRCEPENDERECO",
                            "label": "CEP",
                            "template": "field/text-edit.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnList": true,
                            "showOnForm": true,
                            "events": [],
                            "mask": {
                                "type": "fix",
                                "params": {
                                    "cleanMaskOnModel": true,
                                    "mask": "99999-999"
                                }
                            }
                        },
                        {
                            "id":"17223197583113147",
                            "name": "DSENDERECO",
                            "label": "Endereço",
                            "validations": {
                                "required": true
                            },
                            "maxlength": 250,
                            "class": "10",
                            "showOnList": true,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id":"17223197583113147",
                            "name": "NRIMOVELENDERECO",
                            "label": "Número",
                            "class": "2",
                            "maxlength": 10,
                            "isVisible": true,
                            "showOnList": true,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id":"17223197583113148",
                            "name": "DSCOMPLEENDERECO",
                            "label": "Complemento",
                            "class": "12",
                            "maxlength": 100,
                            "isVisible": true,
                            "showOnList": true,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id":"17223197583113149",
                            "name": "NMPAIS",
                            "label": "País",
                            "template": "field/select.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnList": true,
                            "dataSource": {
                                "name": "product#/pais",
                                "lazyLoad": true
                            },
                            "dataSourceFilter": [],
                            "outData": {
                                "CDPAIS": "CDPAIS",
                                "NMPAIS": "NMPAIS"
                            },
                            "fields": [
                                {
                                    "id":"17223197583113150",
                                    "label": "Código",
                                    "name": "CDPAIS",
                                    "class": "4",
                                    "showOnList": true,
                                    "template": "field/text-edit.html"
                                },
                                {
                                    "id":"17223197583113151",
                                    "label": "País",
                                    "name": "NMPAIS",
                                    "class": "8",
                                    "showOnList": true,
                                    "template": "field/text-edit.html"
                                }
                            ],
                            "events": []
                        },
                        {
                            "id":"17223197583113152",
                            "name": "NMESTADO",
                            "label": "Estado",
                            "template": "field/select.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnList": true,
                            "dataSource": {
                                "name": "product#/estado",
                                "lazyLoad": true
                            },
                            "dataSourceFilter": [],
                            "outData": {
                                "SGESTADO": "SGESTADO",
                                "NMESTADO": "NMESTADO"
                            },
                            "fields": [
                                {
                                    "id":"17223197583113153",
                                    "label": "Sigla",
                                    "name": "SGESTADO",
                                    "class": "4",
                                    "showOnList": true,
                                    "template": "field/text-edit.html"
                                },
                                {
                                    "id":"17223197583113153",
                                    "label": "Estado",
                                    "name": "NMESTADO",
                                    "class": "8",
                                    "showOnList": true,
                                    "template": "field/text-edit.html"
                                }
                            ],
                            "events": []
                        },
                        {
                            "id":"17223197583113154",
                            "name": "NMMUNICIPIO",
                            "label": "Município",
                            "template": "field/select.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnList": true,
                            "dataSource": {
                                "name": "product#/municipio",
                                "lazyLoad": true
                            },
                            "dataSourceFilter": [],
                            "outData": {
                                "CDMUNICIPIO": "CDMUNICIPIO",
                                "NMMUNICIPIO": "NMMUNICIPIO"
                            },
                            "fields": [
                                {
                                    "id":"17223197583113155",
                                    "label": "Código",
                                    "name": "CDMUNICIPIO",
                                    "class": "4",
                                    "showOnList": true,
                                    "template": "field/text-edit.html"
                                },
                                {
                                    "id":"17223197583113156",
                                    "label": "Município",
                                    "name": "NMMUNICIPIO",
                                    "class": "8",
                                    "showOnList": true,
                                    "template": "field/text-edit.html"
                                }
                            ],
                            "events": []
                        },
                        {
                            "id":"17223197583113157",
                            "name": "NMBAIRRO",
                            "label": "Bairro",
                            "template": "field/select.html",
                            "class": "6",
                            "isVisible": true,
                            "showOnList": true,
                            "dataSource": {
                                "name": "product#/bairro",
                                "lazyLoad": true
                            },
                            "dataSourceFilter": [],
                            "outData": {
                                "CDBAIRRO": "CDBAIRRO",
                                "NMBAIRRO": "NMBAIRRO"
                            },
                            "events": []
                        }
                    ],
                    "widgets": []
                },
                {
                    "id":"17223197583113158",
                    "name": "WDGT_PARTNER_CONTACTS",
                    "label": "Contatos",
                    "container": activeWidget.container,
                    "template": "widget/grid.html",
                    "isVisible": false,
                    "dataSource": {
                        "rest": true,
                        "name": "product#/crm_relacionaparc",
                        "lazyLoad": true
                    },
                    "dataSourceFilter": [
                        {
                            "name": "NRPARCNEGOCIO",
                            "operator": "=",
                            "value": ""
                        },
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": "@getLocalVar('CRM_NRORG')@"
                        },
                        {
                            "name": "P_NRORG",
                            "operator": "=",
                            "value": "@getLocalVar('CRM_NRORG')@"
                        }
                    ],
                    "actions": [],
                    "events": [
                        {
                            "id":"17223197583113159",
                            "name": "WidgetOnEnter",
                            "code": "args.owner.reload();PartnerInfosModalController.resizeWindow()"
                        }
                    ],
                    "fields": [
                        {
                            "id":"17223197583113160",
                            "name": "NOMECONT",
                            "label": "Nome",
                            "isVisible": true,
                            "showOnList": true,
                            "showOnForm": true,
                            "validations": {
                                "required": true
                            },
                            "class": 10,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id":"17223197583113161",
                            "name": "EMAIL",
                            "label": "Email",
                            "isVisible": true,
                            "showOnList": true,
                            "showOnView": true,
                            "showOnForm": true,
                            "class": 6,
                            "template": "field/text-edit.html",
                            "events": []
                        },
                        {
                            "id":"17223197583113162",
                            "name": "TELEFONE",
                            "label": "Telefone",
                            "isVisible": true,
                            "showOnList": true,
                            "showOnView": true,
                            "showOnForm": true,
                            "class": 6,
                            "template": "field/text-edit.html",
                            "events": []
                        },
                        {
                            "id":"17223197583113163",
                            "name": "NMTIPOPARCEIRO",
                            "label": "Tipo de Parceiro",
                            "template": "field/select.html",
                            "isVisible": true,
                            "showOnList": true,
                            "class": "12",
                            "valueField": "TIPODEPARCEIRO",
                            "descriptionField": "NMTIPODEPARCEIRO",
                            "dataSource": {
                                "rest": true,
                                "name": "product#/crm_tipoParceiro",
                                "lazyLoad": true
                            },
                            "outData": {
                                "NMTIPODEPARCEIRO": "NMTIPODEPARCEIRO",
                                "TIPODEPARCEIRO": "TIPODEPARCEIRO"
                            },
                            "dataSourceFilter": [],
                            "events": []
                        }
                    ],
                    "widgets": []
                },
                {
                    "id": "14418982341257778598852",
                    "name": "WDGT_PARTNER_COMU",
                    "container": activeWidget.container,
                    "label": "Comunicação",
                    "showCheckbox": false,
                    "isVisible": true,
                    "itemsPerPage": 30,
                    "template": "widget/master_detail/grid.html",
                    "showDescriptionOrder": false,
                    "dataSource": {
                        "rest": true,
                        "lazyLoad": true,
                        "name": "product#/crm_comunicaparc",
                        "itemsPerPage": 100
                    },
                    "dataSourceFilter": [
                        {
                            "name": "P_NRPARCNEGOCIO",
                            "operator": "=",
                            "value": ""
                        },
                        {
                            "name": "P_NRORG",
                            "operator": "=",
                            "value": "@templateManager.LOGGEDOPERATOR.NRORG@"
                        },
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": "@templateManager.LOGGEDOPERATOR.NRORG@"
                        }
                    ],
                    "actions": [],
                    "events": [
                        {
                            "id": "14418982343495474723875",
                            "name": "WidgetOnEnter",
                            "code": "args.owner.reload();PartnerInfosModalController.resizeWindow()"
                        }
                    ],
                    "fields": [
                        {
                            "id": "14418982341628670838852",
                            "name": "IDATIVO",
                            "label": "Ativo",
                            "isVisible": false,
                            "showOnList": false,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id": "14418982342800647217853",
                            "name": "NRCOMUNICAPARC",
                            "label": "NRCOMUNICAPARC",
                            "isVisible": false,
                            "showOnList": false,
                            "showOnForm": false,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id": "14418982341061414688854",
                            "name": "NRPARCNEGOCIO",
                            "label": "NRPARCNEGOCIO",
                            "isVisible": false,
                            "showOnList": false,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id": "14418982344140770823855",
                            "name": "NRENDERECOPARC",
                            "label": "NRENDERECOPARC",
                            "isVisible": false,
                            "showOnList": false,
                            "showOnForm": false,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id": "1441898234664443810856",
                            "name": "CDCOMPLECOMUPARC",
                            "label": "CDCOMPLECOMUPARC",
                            "isVisible": false,
                            "showOnList": false,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id": "14418982341567386213857",
                            "name": "CDFORMACOMU",
                            "label": "Forma de Comunicação",
                            "isVisible": false,
                            "showOnList": false,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id": "1441898234614649406858",
                            "name": "NMFORMACOMU",
                            "label": "Forma de Comunicação",
                            "class": "12",
                            "order": "CDFORMACOMU",
                            "maxlength": 4,
                            "isVisible": true,
                            "showOnList": true,
                            "showOnForm": true,
                            "readOnly": false,
                            "defaultValue": null,
                            "template": "field/select.html",
                            "showSelectAs": "grid",
                            "validations": {
                                "required": true
                            },
                            "newLine": true,
                            "placeholder": null,
                            "dataSource": {
                                "rest": true,
                                "localStorage": true,
                                "name": "product#/formacomu",
                                "itemsPerPage": 50,
                                "lazyLoad": true
                            },
                            "dataSourceFilter": [
                                {
                                    "name": "NRORG",
                                    "operator": "IN",
                                    "value": "@[getLocalVar('CRM_NRORGTRAB'),getLocalVar('CRM_NRORGPADRAO') ]@"
                                }
                            ],
                            "outData": {
                                "CDFORMACOMU": "CDFORMACOMU",
                                "NMFORMACOMU": "NMFORMACOMU"
                            },
                            "fields": [
                                {
                                    "id": "14418982344259089695859",
                                    "label": "Código",
                                    "name": "CDFORMACOMU",
                                    "class": "4",
                                    "showOnList": true,
                                    "template": "field/text-edit.html"
                                },
                                {
                                    "id": "14418982341859185194860",
                                    "label": "Forma de Comunicação",
                                    "name": "NMFORMACOMU",
                                    "class": "8",
                                    "showOnList": true,
                                    "template": "field/text-edit.html"
                                }
                            ],
                            "events": []
                        },
                        {
                            "id": "14418982341691438344861",
                            "name": "CDPREFIXCOMUPARC",
                            "label": "Prefixo",
                            "class": "2",
                            "isVisible": true,
                            "showOnList": true,
                            "maxlength": 10,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id": "14418982342324818248862",
                            "name": "CDCOMUNICAPARC",
                            "label": "Descrição",
                            "class": "10",
                            "isVisible": true,
                            "showOnList": true,
                            "validations": {
                                "required": true
                            },
                            "maxlength": 250,
                            "template": "field/text-edit.html"
                        }
                    ],
                    "widgets": []
                }
			],
			"actions": [
			    {
			        "id":"17223197583113164",
                    "name": "BACK_MODAL",
                    "label": "Voltar",
                    "icon": "back",
                    "isVisible": true,
                    "showAsAction": "back",
                    "events": [
                        {
                            "id":"17223197583113165",
                           	"name": "ActionEvent",
                            "code": "ScreenService.closePopup(true)"
                        }
                    ]
                }
            ]
        };
        
        var modalWidget = metaDataFactory.widgetFactory(modalWidgetJson);
        
        return modalWidget;
        
    };
    
    /**
     * Abri o modal com as informações do parceiro.
    */
    this.openModal = function(){
        
        ScreenService.openPopup(templateManager.container.getWidget('WDGT_MODAL_PARTNER_INFOS')).then(function(){
            var widget = templateManager.container.getWidget('WDGT_PARTNER_DATA');
            //this.setDataWidgetCurrentRow(widget);
        }.bind(this));
        
    };
    
    /**
     * Define o filtro das widgets do modal informativo
     * de acordo com o parceiro selectionado na widget
     * ativa.
     * 
     * @param {object} modalWidget widget do modal informativo.
     * 
     * @param {object} activeWidget widget ativa onde o parceiro
     * foi selecionado.
     * 
     * @param {string} partnerFieldName nome do campo referente ao
     * parceiro de negócio.
    */
    this.setModalFilterByActivePartner = function(modalWidget, activeWidget, partnerFieldName){
        
        var selectedPartner = activeWidget.currentRow[partnerFieldName];
        
        var modalWidgets = modalWidget.widgets;
        var dataWidgetIndex = CRM_Utilities.getObjectPositionInArrayByName(modalWidgets, "WDGT_PARTNER_DATA");
        var addressWidgetIndex = CRM_Utilities.getObjectPositionInArrayByName(modalWidgets, "WDGT_PARTNER_ADDRESS");     
        var contactsWidgetIndex = CRM_Utilities.getObjectPositionInArrayByName(modalWidgets, "WDGT_PARTNER_CONTACTS");
        var comunicationWidgetIndex = CRM_Utilities.getObjectPositionInArrayByName(modalWidgets, "WDGT_PARTNER_COMU");
        var additionalWidgetIndex = CRM_Utilities.getObjectPositionInArrayByName(modalWidgets, "WDGT_DADOS_ADICIONAIS");
        var dataWidget = modalWidgets[dataWidgetIndex]; 
        var addressWidget = modalWidgets[addressWidgetIndex];     
        var contactsWidget = modalWidgets[contactsWidgetIndex];
        var comunicationWidget = modalWidgets[comunicationWidgetIndex];
        var additionalWidget = modalWidgets[additionalWidgetIndex];
        
        var dataWidgetNrparcnegocioFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(dataWidget.dataSourceFilter, "NRPARCNEGOCIO");
        var addressWidgetNrparcnegocioFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(addressWidget.dataSourceFilter, "NRPARCNEGOCIO");
        var contactsWidgetNrparcnegocioFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(contactsWidget.dataSourceFilter, "NRPARCNEGOCIO");
        var comunicationWidgetNrparcnegocioFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(comunicationWidget.dataSourceFilter, "P_NRPARCNEGOCIO");
        var additionalWidgetNrparcnegocioFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(additionalWidget.dataSourceFilter, "P_NRPARCNEGOCIO");
        
        dataWidget.dataSourceFilter[dataWidgetNrparcnegocioFilterIndex].value = selectedPartner;
        addressWidget.dataSourceFilter[addressWidgetNrparcnegocioFilterIndex].value = selectedPartner;
        contactsWidget.dataSourceFilter[contactsWidgetNrparcnegocioFilterIndex].value = selectedPartner;
        comunicationWidget.dataSourceFilter[comunicationWidgetNrparcnegocioFilterIndex].value = selectedPartner;
        additionalWidget.dataSourceFilter[additionalWidgetNrparcnegocioFilterIndex].value = selectedPartner;
        
        dataWidget.reload();
        
    };
    
    /**
     * Atribui o parceiro retornado no data source do modal
     * na currentRow da widget de informações do parceiro
     * ('WDGT_PARTNER_DATA').
     * 
     * @param {object} widget widget de dados do parceiro.
     * ('WDGT_PARTNER_DATA').
    */
    this.setDataWidgetCurrentRow = function(widget){

        widget.moveToFirst();
        
    };
    
    /**
     * Insere a widget modal na widget recebida como 
     * parâmetro.
     * 
     * @param {object} widget widget que receberá o modal.
     * 
     * @param {string} nrparcnegocio nome referente ao
     * campo de parceiro de negócio.
    */
    this.setModalWidgetOnActiveWidget = function(widget, nrparcnegocio){
        
        this.createModalAction(widget);
        widget.widgets.push(this.factoryModalWidget(widget, nrparcnegocio));
        
    };
    
    /**
     * Cria a action para abrir o modal com os dados
     *  do parceiro na widget.
     * 
     * @param {object} widget widget que receberá o modal.
     * 
    */
    this.createModalAction = function(widget){
        /*Modificado em 22/09 por Arthur
            Adicionada propriedade 'preventHide',
            que garante que a action de Dados do Parceiro 
            não seja setada como invisível em chamados já 
            concluidos
        */
        var modalAction = {
            "id":"17223197583113166",
            "name": "ACTION_MODAL_INFOS_PARCEIRO",
            "label": "Consultar Dados do Parceiro",
            "isVisible": true,
            "preventHide":true,
            "showAsAction": "never_view",
            "events": [
                {
                    "name": "ActionEvent",
                    "code": "PartnerInfosModalController.openModal();"
                }
            ]
        };
        
        if((widget.template.search("master_detail") === -1) && widget.template.search("kanban") === -1){
            modalAction.showAsAction = "never_list";
        }
        
        //metaDataFactory.actionFactory(modalAction, widget, true);
        
        if(!widget.getAction('ACTION_MODAL_INFOS_PARCEIRO')) {
            widget.actions.push(modalAction);
        }
        
    };
    
    
    /**
     * Muda o template da tab de interlocutor, necessário
     * para evitar o click na row, que abria o swipe.
     * 
     * @param {object} widget widget modal.
     * 
    */
    this.changeTemplateTabInterlocutor = function(widget){
        var interlocutorTab = templateManager.container.getWidget('WDGT_INTERLOCUTOR');
        interlocutorTab.template = 'widget/grid.html';
        templateManager.updateTemplate();
        interlocutorTab.activate();
    };
    
    this.setCurrentRowDadosAdicionais = function(widget){
        widget.reload().then(function(){
            if(!Util.isEmptyOrBlank(widget.dataSource.data))
                widget.currentRow = widget.dataSource.data[0];
        });
    }
    
    /**
     * Evita Bug de tamanho de colunas inferior ao tamanho do registro
    */
    this.resizeWindow = function(){
        $(window).resize();
    };
	
}
Configuration(function(ContextRegister){
    ContextRegister.register('PartnerInfosModalController', PartnerInfosModalController);
});

// FILE: ./assets/js/utilities/Utilities.js
function Utilities(ScreenService, templateManager, wizardEngine) { //ZhGrifFilter removido

    var self = this;

    self.changeWidgetVisibility = function(widgets, isVisible) {
        widgets.forEach(function(widget){
            widget.isVisible = isVisible;
        });
    };

    self.formChangeTemplate = function() {
        var widget = templateManager.container.getActiveWidget();

        if((widget.template != "widget/form.html")&&(widget.template != "widget/form-view.html")) return false;

        if(!widget.templateToForm) widget.templateToForm = "widget/form.html";
        if(!widget.templateToView) widget.templateToForm = "widget/form-view.html";

        if(widget.template == widget.templateToForm) widget.template = widget.templateToView;
        else if(widget.template == widget.templateToView) widget.template = widget.templateToForm;

        templateManager.updateTemplate();

        return true;
    };

    self.insertFilter = function(requirer, name, operator, value, position)
    {
        var object = {"name": name, "operator": operator, "value": value};

        if(position == -1)
        {
            if(requirer.dataSourceFilter && requirer.dataSourceFilter.length > 0)
            {
                requirer.dataSourceFilter[dataSourceFilter.length] = object;
            }
            else if(requirer.dataSourceFilter)
            {
                requirer.dataSourceFilter[0] = object;
            }
            else
            {
                requirer.dataSourceFilter = [object];
            }
        }
        else
        {
            requirer.dataSourceFilter[position] = object;
        }

        requirer.reload();

    };
    
    /**
     * Insere um objeto no dataSourceFilter
     * 
     * @param {Object} requirer Objeto que possui o dataSourceFilter a ser modificado.
     * @param {string} name Valor da propriedade "name" do dataSourceFilter.
     * @param {string} operator Valor da propriedade "operator" do dataSourceFilter.
     * @param {string} value Valor da propriedade "value" do dataSourceFilter.
     * @param {number} position Posição em que o objeto será inserido no dataSourceFilter.
     */
    this.insertFilterWithoutReload = function(requirer, name, operator, value, position)
    {
        var object = {"name": name, "operator": operator, "value": value};

        if (position < 0) {
            if (requirer.dataSourceFilter) {
                requirer.dataSourceFilter[requirer.dataSourceFilter.length] = object;
            }
            else {
                requirer.dataSourceFilter = [object];
            }
        }
        else {
            requirer.dataSourceFilter[position] = object;
        }
    };

    self.goBackToDashboard = function() {
        ScreenService.openWindow('dashboard');
    };

    self.masterDetailCancelForm = function() {
        var widget = templateManager.container.getActiveWidget();

        self.changeWidgetVisibility(widget.widgets, true);

        if(widget.currentRow.__is_new) {
            var indexOfCurrentRow = widget.dataSource.data.indexOf(widget.currentRow);
            if(indexOfCurrentRow !== -1) {
                widget.dataSource.data.pop();
            }
            if(!self.formChangeTemplate()) widget.list();
            else widget.list();

            ScreenService.closeSwipe();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            self.formChangeTemplate();
            widget.view();
        }
    };

    self.masterDetailClosePopup = function() {
        var popup = templateManager.container.getActiveWidget();

        ScreenService.closePopup();
        popup.deactivate();
        popup.parentWidget.currentWidget = popup.parentWidget;
        popup.parentWidget.activate();
    };

    self.masterDetailDelete = function() {
        try {
            var widget = templateManager.container.getActiveWidget();
            ScreenService.confirmMessage("Deseja deletar o registro?", "CONFIRMATION", function() {
                widget.remove();
                self.masterDetailGoBackToList();
                ScreenService.showMessage("Registro excluído com sucesso");
            }.bind(this));
        } catch (e) {
            ScreenService.showMessage(e, 'ERROR');
        }
    };

    self.masterDetailEdit = function() {
        var widget = templateManager.container.getActiveWidget();

        self.changeWidgetVisibility(widget.widgets, false);
        self.formChangeTemplate();

        widget.backupRow = Util.clone(widget.currentRow);
        widget.edit();
    };

    self.masterDetailGoBackToList = function() {
        var widget = templateManager.container.getActiveWidget();

        ScreenService.closeSwipe();
        widget.list();
    };

    self.masterDetailGoBackToParent = function() {
        var widget = templateManager.container.getActiveWidget();

        ScreenService.closeSwipe().then(function(){
            widget.parent.list();
            widget.parent.activate();
        });
    };

    self.masterDetailNewRow = function() {
        var widget = templateManager.container.getActiveWidget();

        self.changeWidgetVisibility(widget.widgets, false);

        widget.newRow();
    };

    self.masterDetailOpenPopup = function(name) {
        var widget = templateManager.container.getActiveWidget();

        var popup = widget.container.getWidget(name);
        popup.parentWidget = widget;
        ScreenService.openPopup(popup);
        //ZhGridFilter.startFiltering();
        /*var x = templateManager.container.getActiveWidget().name;
        ZhGridFilter.startSavingFilter(x, true);*/
    };

    self.masterDetailSave = function() {
        var widget = templateManager.container.getActiveWidget();

        self.changeWidgetVisibility(widget.widgets, true);
        self.formChangeTemplate();

        if(widget.isValid()) {
            widget.currentRow.changed = true;

            return widget.saveRow().then(function(response){
                widget.currentRow.changed = false;
                widget.currentRow.__is_new = false;
                ScreenService.showMessage("Registro salvo com sucesso");
                ScreenService.closeSwipe();
                widget.list();
                widget.reload();
            });
        }
    };

    self.unMask = function(columnName) {
        var widget = templateManager.container.getActiveWidget();

        if(widget.currentRow[columnName] && typeof widget.currentRow[columnName] === 'string' && widget.currentRow[columnName].indexOf('R$') != -1)
            widget.currentRow[columnName] = $.currency.unmaskString(widget.currentRow[columnName], {"thousands": "."});
        if(widget.currentRow[columnName] && typeof widget.currentRow[columnName] === 'string' && widget.currentRow[columnName].indexOf('%') != -1)
            widget.currentRow[columnName] = parseFloat(widget.currentRow[columnName].replace(',', '.'));
    };

    self.wizardChangeFooter = function() {
        var widget = templateManager.container.getActiveWidget();

        widget.container.footer = (widget.container.footer == "component/footer.html")?
            "component/footer-wizard.html" : "component/footer.html";
    };

    self.wizardGoBack = function(){
    	wizardEngine.previous();
    };

    self.wizardGoNext = function(){
        wizardEngine.next();
    };

    self.getValorEmReais = function(value)
    {
        var pad = "00";
        var valorFatura = value.split('.');

        if(valorFatura[1] === undefined)
        {
            valorFatura[1] = "";
        }
        valorFatura[1] = String(valorFatura[1]) + pad.substring(0, pad.length - String(valorFatura[1]).length);

        if(valorFatura[0] === '')
        {
            valorFatura[0] = "0";
        }
        var aux = "";
        for(var i = valorFatura[0].length - 1; i >= 0; i--)
        {
            if(((valorFatura[0].length -1 - i)%3 === 0) && (valorFatura[0].length -1 != i))
            {
                aux += ".";
            }
            aux += valorFatura[0][i];
        }

        aux = aux.split("").reverse().join("");
        var valorEmReais = "R$ "+aux+","+valorFatura[1];
        return valorEmReais;
    };

    self.validateFilterPopup = function(args)
    {
        var filterPopup = templateManager.currentWidget;
        if(!filterPopup.isValid())
            args.e.preventDefault();
    };

    self.showErrorMessage = function(error) {
        if(typeof error === 'object') {
            if(error.message) {
                ScreenService.showMessage(error.message, 'error', 'error');
            } else {
                ScreenService.showMessage(error.data.error, 'error', 'error');
            }
        } else {
            ScreenService.showMessage(error, 'error', 'error');
        }
    };
    
    self.masterDetailVoltarList = function(widget) {
        widget.list();
        ScreenService.closeSwipe();
        widget.activate();
    };

    self.masterDetailEdit = function() {
        var widget = templateManager.container.getActiveWidget();
        self.changeWidgetVisibility(widget.widgets, false);
        widget.backupRow = Util.clone(widget.currentRow);
        widget.edit();
    };
    
    this.changeTemplateToEdit = function(args) {
        var widget = args.owner.widget;
        widget.template = 'widget/form.html';
        widget.edit();
        widget.backupRow = widget.currentRow;
    };

    this.changeTemplateToView = function(args) {
        var widget = args.owner.widget;
        widget.template = 'widget/form-view.html';
        widget.list();
    };
    
    this.changeTemplateToViewOnCancel = function(args) {
        var widget = args.owner.widget;
        widget.template = 'widget/form-view.html';
        widget.list();
        if(widget.backupRow) {
            widget.currentRow = widget.backupRow;
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Utilities', Utilities);
});

// FILE: ./assets/js/repositories/Crm_00040_Lead_Repository.js
function Crm_00040_Lead_Repository(restEngine){
    
    this.createClientAndReturnNrClient = function(paramsRestEngine, currentRow){
        if(Util.isEmptyOrBlank(paramsRestEngine.row.NRSEQCLASSIFICATAREFA)){
            paramsRestEngine.row.NRSEQCLASSIFICATAREFA = "";
        }
        return restEngine.post('/insertNextTaskCliente', paramsRestEngine,
            function(success){
                
                //return success.dataset.DADOS.NRSEQFILACONTA;
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
    };
    
    this.requestForSetTaskEndDate = function(paramsRestEngine){
      
        return restEngine.post('/setTaskEndDate/Lead', paramsRestEngine,
            function(success){
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
         
    };
    
    this.requestForDeactivateTask = function(paramsRestEngine){
      
        return restEngine.post('/deactivateLeadTask', paramsRestEngine,
            function(success){
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
         
    };
    
}

Configuration(function (ContextRegister) {
    ContextRegister.register("Crm_00040_Lead_Repository", Crm_00040_Lead_Repository);
});


// FILE: ./assets/js/repositories/CRM_Operador_Repository.js
var CRM_Operador_Repository = function(localStorageEngine, General) {
    this.retornaOperadorLogado = function() {
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        return localStorageEngine.download("product#/crud/operador", filter);
    };
    
    
    this.getNrOrgTrabalhoAtual = function(user) {
        var filter = [
            {
                "name": "P_NRORG",
                "operator": "=",
                "value": user.nrorg
            },
            {
                "name": "P_CDOPERADOR",
                "operator": "=",
                "value": user.cdoperador
            }
        ];
        
        return General.callRestEngine('product#/getNrOrgTrabalhoAtual', "FilterData", filter);
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('CRM_Operador_Repository', CRM_Operador_Repository);
});

// FILE: ./assets/js/repositories/CRM_ParceiroNegocio_Repository.js
var CRM_ParceiroNegocio_Repository = function (restEngine) {

    this.salvarComunicacao = function(row) {
        return restEngine.post('/crm_comunicaparc/save', {
            "requestType": "Row",
            "row": row
        }, null, null, null, null, 60000);
    };
    
    this.salvarContato = function(row) {
        return restEngine.post('/crm_relacionaparc/saveContato', {
            "requestType": "Row",
            "row": row
        }, null, null, null, null, 60000);
    };

    this.salvarEndereco = function(row) {
        return restEngine.post('/crm_enderecoparc/save', {
            "requestType": "Row",
            "row": row
        }, null, null, null, null, 60000);
    };

    this.salvarParceiro = function(row) {
        return restEngine.post('/crm_parcnegocio/save', {
            "requestType": "Row",
            "row": row
        }, null, null, null, null, 60000);
    };

};

Configuration(function(ContextRegister){
    ContextRegister.register('CRM_ParceiroNegocio_Repository', CRM_ParceiroNegocio_Repository);
});

// FILE: ./assets/js/repositories/crm00050000_Comunicacao_Revenda_Repository.js
function crm00050000_Comunicacao_Revenda_Repository(CRM_Utilities, restEngine){
    
    this.requestForInsertNewPartnerCommunication = function(paramsRestEngine){
        
        return restEngine.post('/insertNewPartnerCommunication', paramsRestEngine,
            function(success){
                return success;
            },undefined,
            function(error){
                return error;
            }
        );
        
    };
    
}

Configuration(function(ContextRegister){
   ContextRegister.register("crm00050000_Comunicacao_Revenda_Repository", crm00050000_Comunicacao_Revenda_Repository); 
});


// FILE: ./assets/js/repositories/crm00050000_Interlocutor_Revenda_Repository.js
function crm00050000_Interlocutor_Revenda_Repository(restEngine) {
    
    this.requestForInsertPartnerCommunication = function(paramsRestEngine){
        
        return restEngine.post('/insertPartnerCommunication', paramsRestEngine,
            function(success){
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
        
    };
    
    this.requestForInsertPartnerParceria = function(paramsRestEngine){
        
        restEngine.post('/insertPartnerParceria', paramsRestEngine,
            function(success){
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
            
    };
    
    this.requestForInsertPartnerRelation = function(paramsRestEngine){
        
        restEngine.post('/insertPartnerRelation', paramsRestEngine,
            function(success){
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
            
    };
    
    this.requestForDeletePartnerCommunication = function(paramsRestEngine){
        
        return restEngine.post('/deletePartnerCommunication', paramsRestEngine,
            function(success){
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
            
    };
    
    this.requestForUpdateRelationState = function(paramsRestEngine){
        
        return restEngine.post('/updateRelationState', paramsRestEngine,
            function(success){
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
            
    };
    
    this.requestForInactivatePartner = function(paramsRestEngine){
        
        return restEngine.post('/inactivatePartner', paramsRestEngine,
            function(success){
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
        
    };
    
    this.requestForDeleteResaleRelation = function(paramsRestEngine){
        
        return restEngine.post('/deleteResaleRelation', paramsRestEngine,
            function(success){
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
        
    };

}

Configuration(function (ContextRegister) {
    ContextRegister.register("crm00050000_Interlocutor_Revenda_Repository", crm00050000_Interlocutor_Revenda_Repository);
});


// FILE: ./assets/js/repositories/crm00050000_Revenda_Repository.js
function crm00050000_Revenda_Repository(restEngine){
    
    this.createParcNegocioAndReturnNrParcNegocio = function(currentRow){
        
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        
        return restEngine.post('/insertParcNegocioForResale', paramsRestEngine,
            function(success){
                
                currentRow.NRPARCNEGOCIO  = success.dataset.DADOS.NRPARCNEGOCIO;
                currentRow.NRENDERECOPARC = success.dataset.DADOS.NRENDERECOPARC;
                currentRow.NRCOMUNICAPARC = success.dataset.DADOS.NRCOMUNICAPARC;
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
        
    };
    
     this.createInterlocRevenda = function(currentRow){
        
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        
        return restEngine.post('/insertInterlocForResale', paramsRestEngine,
            function(success){
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
        
    };
    
    this.requestForReplicaRevenda = function(currentRow){
        
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        
        return restEngine.post('/replicaRevenda', paramsRestEngine,
            function(success){
            },undefined,
            function(error){
                
            },undefined,undefined
        );
        
    };
    
}

Configuration(function (ContextRegister) {
    ContextRegister.register("crm00050000_Revenda_Repository", crm00050000_Revenda_Repository);
});


// FILE: ./assets/js/repositories/crm00050002_Reserva_de_Prospect_Repository.js
function crm00050002_Reserva_de_Prospect_Repository(restEngine) {
    
    /**
     * Função para fazer a requisição no backEnd
     * para realizar o insert do prospect.
     * 
     * @param {object} paramsRestEngine parâmetros para
     * a função restEngine.
    */    
    this.requestForInsertResaleProspect = function(paramsRestEngine){
        
        return restEngine.post('/insertResaleProspect', paramsRestEngine,
            function(success){
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
        
    };
    
    /**
     * Função para fazer a requisição no backEnd
     * para realizar o select do número da revenda
     * do operado.
     * 
     * @param {object} paramsRestEngine parâmetros para
     * a função restEngine.
    */
    this.requestForcallForSelectOperatorResaleNumber = function(paramsRestEngine){
        
        return restEngine.post('/selectOperatorResaleNumber', paramsRestEngine,
            function(success){
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
        
    };
    
    /**
     * Função para fazer a requisição no backEnd,
     * solicitando o envio de email.
     * 
     * @param {object} paramsRestEngine parâmetros para
     * a função restEngine. 
    */
    this.requestForSendEmail = function(paramsRestEngine){
        
        restEngine.post('/sendEmail', paramsRestEngine,
            function(success){
                
            },undefined,
            function(error){
                
            },undefined, undefined
        );
        
    };

}

Configuration(function (ContextRegister) {
    ContextRegister.register("crm00050002_Reserva_de_Prospect_Repository", crm00050002_Reserva_de_Prospect_Repository);
});

// FILE: ./assets/js/repositories/ger00004500_Prospect_Repository.js
function ger00004500_Prospect_Repository(restEngine, CRM_Utilities){
    
    this.callInsertTaskProspect = function(paramsRestEngine, currentRow){
        
        return restEngine.post('/insertNextTaskProspect', paramsRestEngine,
            function(success){
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
    };
    
    this.selectContactProspect = function(paramsRestEngine, currentRow){
        
        return restEngine.post('/selectProspectNrContato', paramsRestEngine,
            function(success){
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
    };
    
    this.requestForForInsertNrseqcontatoForNewOpportunity = function(paramsRestEngine){
        
        return restEngine.post('/insertNrseqcontatoForNewOpportunity', paramsRestEngine,
            function(success){
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
        
    };
    
    this.requestForUpdatePartnerType = function(paramsRestEngine){
        
        return restEngine.post('/updatePartnerType', paramsRestEngine,
            function(success){
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
        
    };
    
    this.requestForInsertPartnershipOfTypeClient = function(paramsRestEngine){
    
        return restEngine.post('/insertPartnershipOfTypeClient', paramsRestEngine,
            function(success){
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
        
    };
    
    this.requestForInsertClient = function(paramsRestEngine){
        
        return CRM_Utilities.post('/insertClient', paramsRestEngine);
        
    };
    
    this.requestForDeactivateProspect = function(paramsRestEngine){
        
        return restEngine.post('/deactivateProspect', paramsRestEngine,
            function(success){
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
          
    };
    
    this.requestForInsertClientAddress = function(paramsRestEngine){
    
        return restEngine.post('/insertClientAddress', paramsRestEngine,
            function(success){
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
        
    };
    
    this.requestForSelectProspectAddress = function(paramsRestEngine){
      
        return restEngine.post('/selectProspectAddress', paramsRestEngine,
            function(success){
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
         
    };
    
    this.requestForSetTaskEndDate = function(paramsRestEngine){
      
        return restEngine.post('/setTaskEndDate/Prospect', paramsRestEngine,
            function(success){
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
         
    };
    
    this.requestForDeleteEvolutionFilesByOriginNumber = function(paramsRestEngine){
        
        return restEngine.post('/deleteFilesByOriginNumber', paramsRestEngine,
            function(success){
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
        
    };
    
    this.requestForDeactivateTask = function(paramsRestEngine){
      
        return restEngine.post('/deactivateProspectTask', paramsRestEngine,
            function(success){
                
            },undefined,
            function(error){
                
            },undefined,undefined
        );
         
    };
    
}

Configuration(function (ContextRegister) {
    ContextRegister.register("ger00004500_Prospect_Repository", ger00004500_Prospect_Repository);
});


// FILE: ./assets/js/repositories/Ger01200_Estado_Repository.js
function Ger01200_Estado_Repository(restEngine) {

	this.save = function(row) {
        return restEngine.post('cadFis#/saveEstado', {
            "requestType": "Row",
            "row": row
        });
	};

}
Configuration(function (ContextRegister) {
	ContextRegister.register('Ger01200_Estado_Repository', Ger01200_Estado_Repository);
});

// FILE: ./assets/js/repositories/Ger01300_Pais_Repository.js
function Ger01300_Pais_Repository(restEngine) {

	this.save = function(row) {
        return restEngine.post('cadFis#/savePais', {
            "requestType": "Row",
            "row": row
        });
	};
	
}
Configuration(function (ContextRegister) {
	ContextRegister.register('Ger01300_Pais_Repository', Ger01300_Pais_Repository);
});

// FILE: ./assets/js/repositories/Ger01500_Municipio_Repository.js
function Ger01500_Municipio_Repository(restEngine) {

	this.save = function(row) {
        return restEngine.post('product#/saveMunicipio', {
            "requestType": "Row",
            "row": row
        });
	};
	
	this.novoCodigoBairro = function(row) {
        return restEngine.post('product#/novoCodigoBairro', {
            "requestType": "Row",
            "row": row
        });
	};
	
	this.novoCodigoRegiao = function(row) {
        return restEngine.post('product#/novoCodigoRegiao', {
            "requestType": "Row",
            "row": row
        });
	};
	
}
Configuration(function (ContextRegister) {
	ContextRegister.register('Ger01500_Municipio_Repository', Ger01500_Municipio_Repository);
});

// FILE: ./assets/js/repositories/Ger05400_Logradouro_Repository.js
function Ger05400_Logradouro_Repository(restEngine) {

	this.save = function(row) {
        return restEngine.post('cadFis#/saveLogradouro', {
            "requestType": "Row",
            "row": row
        });
	};
	
}
Configuration(function (ContextRegister) {
	ContextRegister.register('Ger05400_Logradouro_Repository', Ger05400_Logradouro_Repository);
});

// FILE: ./assets/js/services/Crm_00040_Lead_Service.js
function Crm_00040_Lead_Service(Crm_00040_Lead_Repository){
    
    this.callForInsertClient = function(currentRow){
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        
        var requestPromisse = Crm_00040_Lead_Repository.createClientAndReturnNrClient(paramsRestEngine, currentRow);
        
        return requestPromisse;
    };
    
    this.callForSetTaskEndDate = function(widget){
        
        var currentRow = widget.currentRow;
        
        currentRow.NRSEQFILACONTA = widget.NRSEQFILACONTA;
        
        var paramsRestEngine = {
            
            "requestType": "Row",
            "row": currentRow
            
        };
        
        return Crm_00040_Lead_Repository.requestForSetTaskEndDate(paramsRestEngine);
          
    };
    
    this.callForDeactivateTask = function(widget){
        
        var currentRow = widget.currentRow;
        
        var paramsRestEngine = {
            
            "requestType": "Row",
            "row": currentRow
            
        };
        
        return Crm_00040_Lead_Repository.requestForDeactivateTask(paramsRestEngine);
          
    };
}
Configuration(function (ContextRegister) {
    ContextRegister.register("Crm_00040_Lead_Service", Crm_00040_Lead_Service);
});


// FILE: ./assets/js/services/CRM_ParceiroNegocio_Service.js
var CRM_ParceiroNegocio_Service = function (CRM_ParceiroNegocio_Repository) {

    var defaultTiposParceiro = [
        "CLIENTE",
        "PROSPECT",
        "CANDIDATO",
        "PESSOA",
        "OPERADOR",
        "FUNCIONARIO",
        "FORNECEDOR",
        "TRANSPORTADORA",
        "VENDEDOR",
        "INTERLOCUTOR",
        "REVENDA"
    ];

    var tipoInscricao = {
        "F": "CPF",
        "I": "LIVRE",
        "J": "CNPJ",
        "O": "CODIGO"
    };

    this.getTipoInscricao = function(tipoDefault) {
        return tipoInscricao[tipoDefault];
    };

    this.salvarComunicacao = function(row) {
        return CRM_ParceiroNegocio_Repository.salvarComunicacao(row);
    };
    
    this.salvarContato = function(row) {
        return CRM_ParceiroNegocio_Repository.salvarContato(row);
    };

    this.salvarEndereco = function(row) {
        return CRM_ParceiroNegocio_Repository.salvarEndereco(row);
    };

    this.salvarParceiro = function(row) {
        return CRM_ParceiroNegocio_Repository.salvarParceiro(row);
    };

    this.setTipoPrincipal = function(row) {
        var tipos = row.TIPODEPARCEIRO;
        
        if (Array.isArray(tipos) && tipos.length > 0) {
            var i = 0;
            var tipoPrincipal = null;
            while (tipoPrincipal === null && i < defaultTiposParceiro.length) {
                if (tipos.indexOf(defaultTiposParceiro[i]) !== -1) {
                    tipoPrincipal = defaultTiposParceiro[i];
                }
                i++;
            }
            row.CDTIPOPARCPRINCIPAL = tipoPrincipal;
        }
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('CRM_ParceiroNegocio_Service', CRM_ParceiroNegocio_Service);
});

// FILE: ./assets/js/services/crm00050000_Comunicacao_Revenda_Service.js
function crm00050000_Comunicacao_Revenda_Service(CRM_Utilities, crm00050000_Comunicacao_Revenda_Repository){
    
    this.callForInsertNewPartnerCommunication = function(currentRow){
    
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        
        var promisseInsert = crm00050000_Comunicacao_Revenda_Repository.requestForInsertNewPartnerCommunication(paramsRestEngine);
        
        return promisseInsert;
        
    };
    
}

Configuration(function(ContextRegister){
   ContextRegister.register("crm00050000_Comunicacao_Revenda_Service", crm00050000_Comunicacao_Revenda_Service); 
});


// FILE: ./assets/js/services/crm00050000_Interlocutor_Revenda_Service.js
function crm00050000_Interlocutor_Revenda_Service(crm00050000_Interlocutor_Revenda_Repository) {
    
    this.callForInsertPartnerCommunication = function(widget){
        
        var currentRow;
        
        if(widget.currentRow){
            currentRow = widget.currentRow;
        }else{
            currentRow = widget;
        }
        
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        
        return crm00050000_Interlocutor_Revenda_Repository.requestForInsertPartnerCommunication(paramsRestEngine);
        
    };
    this.callForInsertPartnerParceria = function(widget){
        
        var currentRow = widget.currentRow;
        
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        
        crm00050000_Interlocutor_Revenda_Repository.requestForInsertPartnerParceria(paramsRestEngine);
        
    };
    
    this.callForInsertPartnerRelation = function(widget){
        
        var currentRow = widget.currentRow;
        
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        
        crm00050000_Interlocutor_Revenda_Repository.requestForInsertPartnerRelation(paramsRestEngine);
        
    };
    
    this.callForDeletePartnerCommunication = function(widget){
        
        var currentRow = widget.currentRow;
        
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        
        return crm00050000_Interlocutor_Revenda_Repository.requestForDeletePartnerCommunication(paramsRestEngine);
        
    };
    
    this.callForUpdateRelationState = function(widget){
        
        var currentRow = widget.currentRow;
        
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        
        crm00050000_Interlocutor_Revenda_Repository.requestForUpdateRelationState(paramsRestEngine);
            
    };
    
    this.callForInactivatePartner = function(widget){
        
        var currentRow = widget.currentRow;
        
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        
        crm00050000_Interlocutor_Revenda_Repository.requestForInactivatePartner(paramsRestEngine);
        
    };
    
    this.callForDeleteResaleRelation = function(widget){
        
        var currentRow = widget.currentRow;
        
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        
        return crm00050000_Interlocutor_Revenda_Repository.requestForDeleteResaleRelation(paramsRestEngine);
        
    };

}

Configuration(function (ContextRegister) {
    ContextRegister.register("crm00050000_Interlocutor_Revenda_Service", crm00050000_Interlocutor_Revenda_Service);
});


// FILE: ./assets/js/services/crm00050000_Revenda_Service.js
function crm00050000_Revenda_Service(crm00050000_Revenda_Repository, crm00050000_Interlocutor_Revenda_Repository){
    
    this.callInsertParcNegocioRoute = function(currentRow){
        
        var nrParcNegocio = crm00050000_Revenda_Repository.createParcNegocioAndReturnNrParcNegocio(currentRow);
        
        return nrParcNegocio;
        
    };
    
    this.callInsertNewResaleInterlocutor = function(currentRow){
        
        var nrParcNegocio = crm00050000_Revenda_Repository.createInterlocRevenda(currentRow);
        
        return nrParcNegocio;
        
    };
    
    this.callInsertRelationInterloc = function(currentRow){
        
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        
        crm00050000_Interlocutor_Revenda_Repository.requestForInsertPartnerRelation(paramsRestEngine);
    };
    
    this.callReplicaRevenda = function(currentRow){
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        
        crm00050000_Revenda_Repository.requestForReplicaRevenda(paramsRestEngine);
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register("crm00050000_Revenda_Service", crm00050000_Revenda_Service);
});


// FILE: ./assets/js/services/crm00050002_Reserva_de_Prospect_Service.js
function crm00050002_Reserva_de_Prospect_Service(crm00050002_Reserva_de_Prospect_Repository) {
    
    /**
     * Função para fazer a chamada da requisição
     * do insert do prospect.
     * 
     * @param {object} currentRow currentRow para
     * onde se localiza as informações do prospect.
    */    
    this.callForInsertResaleProspect = function(currentRow){
        
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        
        return crm00050002_Reserva_de_Prospect_Repository.requestForInsertResaleProspect(paramsRestEngine);
        
    };
    
    /**
     * Função para fazer a chamada da requisição
     * do select do número da revenda ligado ao
     * operador logado.
     * 
     * @param {currentRow} currentRow currentRow onde 
     * se localiza as informações do operador.
    */
    this.callForSelectOperatorResaleNumber = function(currentRow){
        
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        
        return crm00050002_Reserva_de_Prospect_Repository.requestForcallForSelectOperatorResaleNumber(paramsRestEngine);
        
    };
    
    /**
     * Função para fazer a chamada da requisição
     * de envio de email.
     * 
     * @param {object} currentRow currentRow onde
     * se localiza as informações do email.
    */
    this.callForSendEmail = function(currentRow){
      
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        
        crm00050002_Reserva_de_Prospect_Repository.requestForSendEmail(paramsRestEngine);
        
    };

}

Configuration(function (ContextRegister) {
    ContextRegister.register("crm00050002_Reserva_de_Prospect_Service", crm00050002_Reserva_de_Prospect_Service);
});


// FILE: ./assets/js/services/fileRepository.js
Configuration(function(RepositoryFactory, ContextRegister)
{
	var fileRepository = RepositoryFactory.factory("crm#/uploadFile", "LOCAL");

	ContextRegister.register('fileRepository', fileRepository);
});

// FILE: ./assets/js/services/ger00004500_Prospect_Service.js
function ger00004500_Prospect_Service(ger00004500_Prospect_Repository, CRM_Utilities){
    
    this.callForInsertProspect = function(currentRow){
        
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        
        return ger00004500_Prospect_Repository.callInsertTaskProspect(paramsRestEngine, currentRow);
        
    };
    
    this.callForSelectProspect = function(currentRow){
        
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        
        return ger00004500_Prospect_Repository.selectContactProspect(paramsRestEngine, currentRow);
        
    };
    
    this.callForInsertNrseqcontatoForNewOpportunity = function(currentRow){
        
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        
        ger00004500_Prospect_Repository.requestForForInsertNrseqcontatoForNewOpportunity(paramsRestEngine);
        
    };
    
    this.callForUpdatePartnerType = function(currentRow){
    
        var paramsRestEngine = {
            
            "requestType": "Row",
            "row": currentRow
            
        };
        
        return ger00004500_Prospect_Repository.requestForUpdatePartnerType(paramsRestEngine);
        
    };
    
    this.callForInsertPartnershipOfTypeClient = function(currentRow){
    
        var paramsRestEngine = {
            
            "requestType": "Row",
            "row": currentRow
            
        };
        
        return ger00004500_Prospect_Repository.requestForInsertPartnershipOfTypeClient(paramsRestEngine);
        
    };
    
    this.callForInsertClient = function(currentRow){
        
        currentRow.NRINSJURPROS = CRM_Utilities.removeValueMask(currentRow.NRINSJURPROS);
        currentRow.CDCLIENTE = this.concatInscriptionTypeWithInscription(currentRow.IDTPIJURPROS, currentRow.NRINSJURPROS);
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        
        var paramsRestEngine = {
            
            "requestType": "Row",
            "row": currentRow
            
        };
        
        return ger00004500_Prospect_Repository.requestForInsertClient(paramsRestEngine);
        
    };
    
    this.concatInscriptionTypeWithInscription = function(inscriptionType, inscription){
        
        return inscriptionType + inscription;
            
    };
    
    this.callForDeactivateProspect = function(currentRow){
    
        var paramsRestEngine = {
            
            "requestType": "Row",
            "row": currentRow
            
        };
        
        return ger00004500_Prospect_Repository.requestForDeactivateProspect(paramsRestEngine);
    };
    
    this.callForInsertClientAddress = function(currentRow){
        
        var paramsRestEngine = {
            
            "requestType": "Row",
            "row": currentRow
            
        };
        
        return ger00004500_Prospect_Repository.requestForInsertClientAddress(paramsRestEngine);
        
    };
    
    this.callForSelectProspectAddress = function(currentRow){
        
        var paramsRestEngine = {
            
            "requestType": "Row",
            "row": currentRow
            
        };
        
        return ger00004500_Prospect_Repository.requestForSelectProspectAddress(paramsRestEngine);
        
    };
    
    this.callForSetTaskEndDate = function(widget){
        
        var currentRow = widget.currentRow;
        
        currentRow.NRSEQFILACONTA = widget.NRSEQFILACONTA;
        
        var paramsRestEngine = {
            
            "requestType": "Row",
            "row": currentRow
            
        };
        
        return ger00004500_Prospect_Repository.requestForSetTaskEndDate(paramsRestEngine);
          
    };
    
    this.callForDeleteEvolutionFilesByOriginNumber = function(widget){
        
        var currentRow = widget.currentRow;
        
        var paramsRestEngine = {
            
            "requestType": "Row",
            "row": currentRow
            
        };
        
        return ger00004500_Prospect_Repository.requestForDeleteEvolutionFilesByOriginNumber(paramsRestEngine);
        
    };
    
    this.callForDeactivateTask = function(widget){
        
        var currentRow = widget.currentRow;
        
        var paramsRestEngine = {
            
            "requestType": "Row",
            "row": currentRow
            
        };
        
        return ger00004500_Prospect_Repository.requestForDeactivateTask(paramsRestEngine);
          
    };
    
}
Configuration(function (ContextRegister) {
    ContextRegister.register("ger00004500_Prospect_Service", ger00004500_Prospect_Service);
});


// FILE: ./assets/js/services/Ger01200_Estado_Service.js
function Ger01200_Estado_Service(Ger01200_Estado_Repository) {

	this.salvarEstado = function(row){
        return Ger01200_Estado_Repository.save(row);
    };

}
Configuration(function (ContextRegister) {
	ContextRegister.register('Ger01200_Estado_Service', Ger01200_Estado_Service);
});

// FILE: ./assets/js/services/Ger01300_Pais_Service.js
function Ger01300_Pais_Service(Ger01300_Pais_Repository) {

	this.salvarPais = function(row){
        return Ger01300_Pais_Repository.save(row);
    };
    
}
Configuration(function (ContextRegister) {
	ContextRegister.register('Ger01300_Pais_Service', Ger01300_Pais_Service);
});

// FILE: ./assets/js/services/Ger01500_Municipio_Service.js
function Ger01500_Municipio_Service(Ger01500_Municipio_Repository) {

	this.salvarMunicipio = function(row){
        return Ger01500_Municipio_Repository.save(row);
    };
    
    this.novoCodigoBairro = function(row){
        return Ger01500_Municipio_Repository.novoCodigoBairro(row);
    };
    
    this.novoCodigoRegiao = function(row){
        return Ger01500_Municipio_Repository.novoCodigoRegiao(row);
    };
    
}
Configuration(function (ContextRegister) {
	ContextRegister.register('Ger01500_Municipio_Service', Ger01500_Municipio_Service);
});

// FILE: ./assets/js/services/Ger05400_Logradouro_Service.js
function Ger05400_Logradouro_Service(Ger05400_Logradouro_Repository) {

	this.salvarPais = function(row){
        return Ger05400_Logradouro_Repository.save(row);
    };
    
}
Configuration(function (ContextRegister) {
	ContextRegister.register('Ger05400_Logradouro_Service', Ger05400_Logradouro_Service);
});

// FILE: ./assets/js/services/InitService.js
function InitService(restEngine, templateManager,ZHPromise, ScreenService) {

    //var IDENTITY_URI = "http://crm.pebbian.com/teknisa/";
    var self =this;
    var buildRequestObj = function (baseUrl, service, params) {
        return {
            "service": service,
            "params": params,
            "typeRequest": "post",
            "baseUrl": baseUrl
        };
    };

    this.getCookie = function (cname) {
        var name = cname + "=";
        var ca = document.cookie.split(';');
        for (var i = 0; i < ca.length; i++) {
            var c = ca[i];
            while (c.charAt(0) == ' ') c = c.substring(1);
            if (c.indexOf(name) === 0) return c.substring(name.length, c.length);
        }
        return "";
    };

    this.startSession = function (token) {
        var cookie = window.document.location.href.split('&');
        if(cookie[2])
        {
            cookie = cookie.split('=');
            if(cookie[1])
            {
                cookie = cookie[1];
                cookie = cookie.substr(0, (cookie.length-7));
                /*var cookie = this.getCookie('varwwwv_250CRM');
                var cookie = this.getCookie('Cworkfoldercrm');*/

                var requestObj = buildRequestObj(window.serviceUrl, "/startSession", {
                    "row": {"TOKEN": cookie},
                    "requestType": "Row"
                });

                var location = window.document.location.href.split('&');
                if(location[1])
                {
                    location = location[1].split('=');
                    if(location[1])
                    {
                        location = location[1];
                        var widget = templateManager.container.getActiveWidget();
                        return restEngine.post(requestObj).then(function (data) {
                            widget.currentRow.CDOPERADOR = data.dataset.operador.email;
                            widget.currentRow.CDSENHAOPER = data.dataset.operador.senha;
                             var promises = [self.autenticar(widget)];
                             ZHPromise.all(promises).then(function() {
                             ScreenService.openWindow(location).then(function(){
                             templateManager.container.showMenu = false;
                             });
                             if (data.method[0].parameters[1] !== false) {
                                setLocalVar("CDOPERADOR", data.method[0].parameters[1]);
                                setLocalVar("NRORG", data.method[1].parameters[1]);
                             }
                             });
                        }, function(callback) {
                         if (callback.data) {
                             ScreenService.showMessage(ScreenService.i18n(callback.data.error));
                             } else {
                             ScreenService.showMessage(ScreenService.i18n('Timeout! Verifique sua conexão e tente novamente!'), 'error');
                             }
                         });
                    }
                }
            }
        }

    };

    this.getRules = function(groupIds) {
        return restEngine.post('/zhu_acl_element_login',
            {
                "requestType": "FilterData",
                "filter": [
                    {
                        "name": "GROUP_ID",
                        "operator": "=",
                        "value": groupIds
                    }
                ]
            }
        );
    };

    this.autenticar = function(widget){

        var user = widget.currentRow.CDOPERADOR;
        var password = widget.currentRow.CDSENHAOPER;

        var filters = [{
            "name": "user",
            "value": user,
            "operator": "="
        }, {
            "name": "password",
            "value": password,
            "operator": "="
        }];

        localStorageEngine.download('/login/login', filters).then(function(data){
            var userId = data.login;
            templateManager.userId = userId;
            var accessProfiles = getLocalVar('NRGROUPCTLACESS');
            localStorageEngine.setLocalVar('login', user);
            localStorageEngine.setLocalVar('PROJECT_ID', 13);
            self.getRules(accessProfiles).then( //remove the hash when query is ready
                function(response) {
                    var data = response.dataset.zhu_access_control_rule_login;
                    var rules = {};
                    data.forEach(
                        function(rule) {
                            var profileObject = {
                                'rule': rule.RULE
                            };
                            var profileObjects = {};
                            profileObjects[userId] = profileObject;
                            rules[rule.NAME] = {
                                'itemName': rule.NAME,
                                'userGroups': profileObjects
                            };
                        }
                    );
                    templateManager.aclRules = rules;
                }
            );


            ScreenService.buildUserData(data.userData.nmoperador, [data.userData.nmEstrutLegalOper,""],function(){
                ScreenService.successNotification("Logado com sucesso!");
            });
        });
    };
}
Configuration(function(ContextRegister){
    ContextRegister.register('InitService', InitService);
});

// FILE: ./assets/js/services/ProdutoService.js
var ProdutoService = function(restEngine) {

	this.saveProdArvProd = function(row){

		return restEngine.post("product#/arvoreprodtree/save", {
			"requestType":"Row",
			"row": row
		});

	};
	

};

Configuration(function(ContextRegister, eventEngine) {
    ContextRegister.register('ProdutoService', ProdutoService);
});

// FILE: ./assets/js/controllers/ABAEnderecoParceiroController.js
function ABAEnderecoParceiroController(CRM_Utilities, templateManager,ScreenService, Messages, General, metaDataFactory, restEngine) {
    
    /**
     * Insere a widget de endereço na widget recebida como 
     * parâmetro.
     * 
     * @param {object} widget widget que receberá a a widget
     * de endereço("WDGT_ENDERECOS").
     * 
     * @param {string} nrparcnegocio nome referente ao
     * campo de parceiro de negócio.
    */

    this.setAddressWidgetOnActiveWidget = function(widget, position){
        
        widget.widgets = CRM_Utilities.setElementOnArrayDefinedPosition(this.factoryAddressWidget(widget), widget.widgets, position);
        widget.activate();
        
    };
    
    /**
     * Cria a widget dinâmica de endereços
     * na widget ativa recebida como parâmetro.
     * 
     * @param {object} activeWidget widget ativa.
    */

    this.factoryAddressWidget = function(activeWidget){
        
        var addressWidget = {
            "id":"1722319758311315390516",
            "name": "WDGT_ENDERECOS",
            "label": "Endereços",
            "template": "widget/master_detail/grid.html",
            "isVisible": true,
            "parent": activeWidget,
            "container": activeWidget.container,
            "dataSource": {
                "name": "product#/crud/enderecoparc_localizacao_tipoendereco",
                "rest": true
            },
            "paramsNewCode": {
                "__is_new_code": true,
                "__new_code_pk": "ENDERECOPARC",
                "__table_pk": "NRENDERECOPARC",
                "__cast_number": true
            },
            "dataSourceFilter":[
                {
                    "name": "NRPARCNEGOCIO",
                    "operator": "=",
                    "value": ""
                }
            ],
            "fieldGroups": [
                {
                    "name": "geolocalizacao",
                    "label": "Geolocalização",
                    "collapsible": true,
                    "opened": true
                }
            ],
            "events": [
                {
                    "name": "WidgetOnEnter",
                    "code": "ABAEnderecoParceiroController.setAddressWidgetFilters(args.owner);"
                },
                {
                    "name": "WidgetAfterMoveRow",
                    "code": "crm00040_Lead_Controller.validateMask(args.owner);"
                },
                {
                    "name": "WidgetOnSave",
                    "code": "args.owner.reload();"
                }
            ],
            "actions": [
                {
                    "name": "VOLTAR_LISTA",
                    "label": "Voltar",
                    "isVisible": true,
                    "showAsAction": "back_view",
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "General.widgetGoBackToList(args.owner.widget);"
                        }
                    ]
                },
                {
                    "name": "VOLTAR_LISTA_PAI",
                    "label": "Voltar",
                    "isVisible": true,
                    "showAsAction": "back_list",
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "General.widgetGoBackToParent(args.owner.widget);"
                        }
                    ]
                },
                {
                    "name": "ADICIONAR_ENDERECO",
                    "label": "Adicionar",
                    "icon": "plus",
                    "isVisible": true,
                    "showAsAction": "always|list",
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "ABAEnderecoParceiroController.addAddress(args.owner.widget);"
                        }
                    ]
                },
                {
                    "name": "EDITAR_ENDERECO",
                    "label": "Editar",
                    "icon": "pencil",
                    "isVisible": true,
                    "showAsAction": "view",
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "ABAEnderecoParceiroController.editAddress(args.owner.widget);"
                        }
                    ]
                },
                {
                    "name": "CANCELAR_FORMULARIO",
                    "label": "Cancelar",
                    "isVisible": true,
                    "showAsAction": "back_edit",
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "General.widgetCancelForm(args.owner.widget);"
                        }
                    ]
                },
                {
                    "name": "SALVAR_ENDERECO",
                    "label": "Salvar",
                    "isVisible": true,
                    "showAsAction": "never_edit",
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "CRM_Utilities.saveAndSetColumnToBeRetunrOnCurrentRow(args.owner.widget, args.owner.widget.paramsNewCode.__table_pk);"
                        }
                    ]
                },
                {
                    "name": "EXCLUIR_ENDERECO",
                    "label": "Excluir",
                    "isVisible": true,
                    "icon": "trash",
                    "showAsAction": "view",
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "ABAEnderecoParceiroController.deleteAddress(args.owner.widget);"
                        }
                    ]
                },
                {
                    "name": "GEOCODEADRESS",
                    "label": "Buscar Latitude/Longitude",
                    "isVisible": true,
                    "showAsAction": "never_view",
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "ABAEnderecoParceiroController.searchLocation();"
                        }
                    ]
                }
            ],
            "fields": [
                {
                    "name": "NMTIPOENDERECO",
                    "label": "Tipo de Endereço",
                    "class": "12",
                    "template": "field/select.html",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnView": true,
                    "showOnForm": true,
                    "showSelectAs": "grid",
                    "descriptionOrder": 1,
                    "validations": {
                        "required": true
                    },
                    "dataSource": {
                        "name": "product#/crud/tipoendereco_unico_por_parceiro",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "dataSourceFilter": [
                        {
                            "name": "P_NRPARCNEGOCIO",
                            "operator": "=",
                            "value": ""
                        },
                        {
                            "name": "P_CDTIPOENDERECO",
                            "operator": "=",
                            "value": ""
                        },
                        {
                            "name": "P_NRORG",
                            "operator": "=",
                            "value": ""
                        }
                    ],
                    "valueField": "CDTIPOENDERECO",
                    "descriptionField": "NMTIPOENDERECO",
                    "outData": {
                        "NMTIPOENDERECO": "NMTIPOENDERECO",
                        "CDTIPOENDERECO": "CDTIPOENDERECO"
                    },
                    "fields": [
                        {
                            "name": "NMTIPOENDERECO",
                            "label": "Tipo de Endereço",
                            "isVisible": true,
                            "showOnList": true,
                            "template": "field/text-edit.html"
                        }
                    ],
                    "events": [
                        {
                            "name": "FieldOnClick",
                            "code": "ABAEnderecoParceiroController.setAddressTypeFieldFilter(args.owner.field.widget);"
                        }
                    ],
                    "filterProperties": {
                        "events": [],
                        "validations": {}
                    }
                },
                {
                    "name": "IDATIVO",
                    "label": "Ativo",
                    "template": "field/select-native.html",
                    "class": "6",
                    "isVisible": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "defaultValue": "S",
                    "valueField": "value",
                    "descriptionField": "name",
                    "validations": {},
                    "hideEmptyValue": true,
                    "dataSource": {
                        "data": [
                            {
                                "name": "Sim",
                                "value": "S"
                            },
                            {
                                "name": "Não",
                                "value": "N"
                            }
                        ]
                    },
                    "filterProperties": {
                        "hideEmptyValue": false
                    }
                },
                {
                    "name": "NRCEPENDERECO",
                    "label": "CEP",
                    "template": "field/text-edit.html",
                    "class": "6",
                    "isVisible": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "validations": {
                        "required": true
                    },
                    "maxlength": 9,
                    "events": [
                        {
                            "name": "FieldOnChange",
                            "code": "ABAEnderecoParceiroController.fillAddressByCep(args.owner.field.widget);"
                        }
                    ],
                    "filterProperties": {
                        "events": [],
                        "validations": {},
                        "mask": {
                            "type": "fix",
                            "params": {}
                        }
                    }
                },
                {
                    "name": "DSENDERECO",
                    "label": "Endereço",
                    "template": "field/text-edit.html",
                    "class": "12",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnView": true,
                    "showOnForm": true,
                    "validations": {},
                    "events": []
                },
                {
                    "name": "NRIMOVELENDERECO",
                    "label": "Número",
                    "template": "field/number-edit.html",
                    "class": "6",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnView": true,
                    "showOnForm": true,
                    "minValue": 0,
                    "validations": {},
                    "events": []
                },
                {
                    "name": "DSCOMPLEENDERECO",
                    "label": "Complemento",
                    "template": "field/text-edit.html",
                    "class": "6",
                    "isVisible": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "validations": {},
                    "events": []
                },
                {
                    "name": "NMPAIS",
                    "label": "País",
                    "template": "field/select.html",
                    "class": "6",
                    "isVisible": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "defaultValue": "",
                    "validations": {
                        "required": true
                    },
                    "dataSource": {
                        "name": "product#/pais",
                        "lazyLoad": true,
                        "rest": true
                    },
                    "outData": {
                        "CDPAIS": "CDPAIS",
                        "NMPAIS": "NMPAIS"
                    },
                    "valueField": "CDPAIS",
                    "descriptionField": "NMPAIS",
                    "showSelectAs": "grid",
                    "fields": [
                        {
                            "name": "NMPAIS",
                            "label": "País",
                            "isVisible": true,
                            "showOnList": true,
                            "template": "field/text-edit.html"
                        }
                    ],
                    "events": [
                        {
                            "name": "FieldOnChange",
                            "code": "ABAEnderecoParceiroController.checkPlaceChange(args.owner.field);"
                        },
                        {
                            "name": "FieldOnClick",
                            "code": "CRM_Utilities.setDefaultOrgFilterAndOperatorOrgFilter(args.owner.field);"
                        }
                    ],
                    "filterProperties": {
                        "events": [],
                        "validations": {}
                    }
                },
                {
                    "name": "NMESTADO",
                    "label": "Estado",
                    "template": "field/select.html",
                    "class": "6",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnView": true,
                    "showOnForm": true,
                    "showAddButtonAs": "button",
                    "addButtonText": "Adicionar Novo Estado",
                    "readOnly": true,
                    "validations": {
                        "required": true
                    },
                    "valueField": "SGESTADO",
                    "descriptionField": "NMESTADO",
                    "dataSource": {
                        "name": "product#/estado",
                        "rest": true
                    },
                    "dataSourceFilter": [],
                    "outData": {
                        "SGESTADO": "SGESTADO",
                        "NMESTADO": "NMESTADO"
                    },
                    "showSelectAs": "grid",
                    "fields": [
                        {
                            "name": "NMESTADO",
                            "label": "Estado",
                            "isVisible": true,
                            "showOnList": true,
                            "template": "field/text-edit.html"
                        }
                    ],
                    "events": [
                        {
                            "name": "FieldOnChange",
                            "code": "ABAEnderecoParceiroController.checkPlaceChange(args.owner.field);"
                        },
                        {
                            "id": "17223197582476052126733",
                            "name": "FieldOnAdd",
                            "code": "crm00040_Lead_Controller.criarNovoEstado(args.owner.field.widget)"
                        },
                        {
                            "name": "FieldOnClick",
                            "code": "ABAEnderecoParceiroController.addressFieldOnClick(args.owner.field);"
                        }
                    ],
                    "filterProperties": {
                        "events": [],
                        "validations": {},
                        "readOnly": false
                    }
                },
                {
                    "name": "NMMUNICIPIO",
                    "label": "Município",
                    "template": "field/select.html",
                    "class": "6",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnView": true,
                    "showOnForm": true,
                    "readOnly": true,
                    "defaultValue": "",
                    "showAddButtonAs": "button",
                    "addButtonText": "Adicionar Novo Município",
                    "validations": {
                        "required": true
                    },
                    "valueField": "CDMUNICIPIO",
                    "descriptionField": "NMMUNICIPIO",
                    "dataSource": {
                        "name": "product#/municipio",
                        "rest": true
                    },
                    "outData": {
                        "NMMUNICIPIO": "NMMUNICIPIO",
                        "CDMUNICIPIO": "CDMUNICIPIO"
                    },
                    "dataSourceFilter": [],
                    "showSelectAs": "grid",
                    "fields": [
                        {
                            "name": "NMMUNICIPIO",
                            "label": "Município",
                            "isVisible": true,
                            "showOnList": true,
                            "template": "field/text-edit.html"
                        }
                    ],
                    "events": [
                        {
                            "name": "FieldOnChange",
                            "code": "ABAEnderecoParceiroController.checkPlaceChange(args.owner.field);"
                        },
                        {
                            "id": "12932085961632664968982",
                            "name": "FieldOnAdd",
                            "code": "crm00040_Lead_Controller.criarNovoMunicipio(args.owner.field.widget)"
                        },
                        {
                            "name": "FieldOnClick",
                            "code": "ABAEnderecoParceiroController.addressFieldOnClick(args.owner.field);"
                        }
                    ],
                    "filterProperties": {
                        "events": [],
                        "validations": {},
                        "readOnly": false
                    }
                },
                {
                    "name": "NMBAIRRO",
                    "label": "Bairro",
                    "template": "field/select.html",
                    "class": "6",
                    "isVisible": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "readOnly": true,
                    "defaultValue": "",
                    "validations": {
                        "required": true
                    },
                    "showAddButtonAs": "button",
                    "addButtonText": "Adicionar Novo Município",
                    "valueField": "CDBAIRRO",
                    "descriptionField": "NMBAIRRO",
                    "dataSource": {
                        "name": "product#/bairro",
                        "rest": true
                    },
                    "outData": {
                        "CDBAIRRO": "CDBAIRRO",
                        "NMBAIRRO": "NMBAIRRO"
                    },
                    "dataSourceFilter": [],
                    "showSelectAs": "grid",
                    "fields": [
                        {
                            "name": "NMBAIRRO",
                            "label": "Bairro",
                            "isVisible": true,
                            "showOnList": true,
                            "template": "field/text-edit.html"
                        }
                    ],
                    "events": [
                        {
                            "name": "FieldOnClick",
                            "code": "ABAEnderecoParceiroController.addressFieldOnClick(args.owner.field);"
                        },
                        {
                            "id": "1722319758387363832512",
                            "name": "FieldOnAdd",
                            "code": "crm00040_Lead_Controller.criarNovoBairro(args.owner.field.widget)"
                        }
                    ],
                    "filterProperties": {
                        "events": [],
                        "validations": {},
                        "readOnly": false
                    }
                },
                {
                    "name": "DSREFERENCIAENDE",
                    "label": "Referência",
                    "template": "field/textarea.html",
                    "class": "12",
                    "isVisible": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "textRows": 5,
                    "validations": {},
                    "events": []
                },
                {
                    "name": "DSLATITUDE",
                    "label": "Latitude",
                    "template": "field/text-edit.html",
                    "fieldGroup": "geolocalizacao",
                    "help": "Estes campos são necessários para que o registro apareça na tela 'Geolocalizacao'",
                    "class": "6",
                    "isVisible": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "textRows": 5,
                    "validations": {},
                    "events": []
                },
                {
                    "name": "DSLONGITUDE",
                    "label": "Longitude",
                    "template": "field/text-edit.html",
                    "fieldGroup": "geolocalizacao",
                    "help": "Estes campos são necessários para que o registro apareça na tela 'Geolocalizacao'",
                    "class": "6",
                    "isVisible": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "textRows": 5,
                    "validations": {},
                    "events": []
                }
            ],
            "widgets": [
                {
                    "id":"1722319758311315390518",
                    "name": "",
                    "label": "",
                    "template": "widget/form.html",
                    "container": activeWidget.container,
                    "isVisible": false,
                    "showAsTab": false,
                    "dataSource": {},
                    "events": [],
                    "actions": [],
                    "fields": [],
                    "widgets": []
                }
            ]
        };    
        
        addressWidget = metaDataFactory.widgetFactory(addressWidget);
        CRM_Utilities.factoryWidgetActions(addressWidget);
        
        return addressWidget;
        
    };
    
    /**
     * Executa as funções relacionadas a filtro da
     * widget de endereço.
     * 
     * @param {object} widgte widget de endereço
     * ("WDGT_ENDERECO").
    */
    this.setAddressWidgetFilters = function(widget){
        
        this.setAddressWidgetFilterBySelectedPartner(widget);
        
        widget.reload();
        
    };
    
    /**
     * Define o filtro da widget de enderço pelo parceiro selecionado.
     *
     * @param {object} widget widget de endereço.
    */
    this.setAddressWidgetFilterBySelectedPartner = function(widget){
        
        var parentWidgetCurrentRow = widget.getParent().currentRow;
        
        var widgetFilter = widget.dataSourceFilter;
        var nrparcnegocioFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(widgetFilter, "NRPARCNEGOCIO");
        
        if(widgetFilter[nrparcnegocioFilterIndex].value !== parentWidgetCurrentRow.NRPARCNEGOCIO){
            widgetFilter[nrparcnegocioFilterIndex].value = parentWidgetCurrentRow.NRPARCNEGOCIO;
        }    
        
    };
    
    /**
     * Define o filtro do campo 'Tipo do Endereço' pelo
     * parceiro selecionado.
     * Definindo o filtro, o usuário consegue cadastrar
     * apenas um endereço por tipo, lembrando que se o usuário
     * for editar um endereço, o tipo previamente cadastra
     * é exibido, este é o motivo do filtro do campo CDTIPOENDERECO.
     * 
     * @param {object} widget widget de endereços
     * ("WDGT_ENDERECOS").
    */
    this.setAddressTypeFieldFilter = function(widget){
        
        var parentWidgetCurrentRow = widget.getParent().currentRow;
        var currentRow = widget.currentRow;
        
        var relatedPartnerCode = parentWidgetCurrentRow.NRPARCNEGOCIO;
        var relatedOrgCode = parentWidgetCurrentRow.NRORG;
        var currentAddressType = currentRow.CDTIPOENDERECO;
        
        var addressTypeField = widget.getField("NMTIPOENDERECO");
        var addressTypeFieldFilter = addressTypeField.dataSourceFilter;
        
        var nrparcnegocioFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(addressTypeFieldFilter, "P_NRPARCNEGOCIO");
        var nrorgFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(addressTypeFieldFilter, "P_NRORG");
        var cdtipoenderecoFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(addressTypeFieldFilter, "P_CDTIPOENDERECO");
        
        
        addressTypeFieldFilter[nrparcnegocioFilterIndex].value = relatedPartnerCode;
        addressTypeFieldFilter[nrorgFilterIndex].value = relatedOrgCode;
        addressTypeFieldFilter[cdtipoenderecoFilterIndex].value = currentAddressType ? currentAddressType : "-1";
        
        addressTypeField.reload();    
        
        
    };
    
    /**
     * Verifica se o usuário modificou a localidade, em caso,
     * selecionada.
     * 
     * @param {object} field campo a ser verificado.
    */
    this.SELECTEDPLACES = {COUNTRY: "", STATE: "", CITY: ""};
    this.checkPlaceChange = function(field){
        
        var widget = field.widget;
        var currentRow = widget.currentRow;
        
        switch(field.name){
            
            case "NMPAIS":
                
                if(currentRow.NMPAIS !== this.SELECTEDPLACES.COUNTRY){
                    
                    this.cleanSelectedPlacesByPlaceHierarchy(widget, "STATE");
                    this.SELECTEDPLACES.COUNTRY = currentRow.NMPAIS;
                    
                }
                
                break;
                
            case "NMESTADO":
                
                if(currentRow.NMESTADO !== this.SELECTEDPLACES.STATE){
                    
                    this.cleanSelectedPlacesByPlaceHierarchy(widget, "CITY");
                    this.SELECTEDPLACES.STATE = currentRow.NMESTADO;
                    
                }
                
                break;
                
            case "NMMUNICIPIO":
                
                if(currentRow.NMMUNICIPIO !== this.SELECTEDPLACES.COUNTRY){
                    
                    this.cleanSelectedPlacesByPlaceHierarchy(widget, "NEIGHBORHOOD");
                    this.SELECTEDPLACES.CITY = currentRow.NMMUNICIPIO;
                    
                }
                
                break;
            
        }
        
        this.unlockPlaceFieldsByFilledPlaces(widget);
        
    };
    
    /**
     * Atualiza os locais preenchidos na variável
     * relacionada a locais selecionados
     * (SELECTEDPLACES).
     * 
     * @param {object} widget widget de endereços
     * ("WDGT_ENDERECOS").
    */
    this.checkPlacesFilled = function(widget){
        
        var currentRow = widget.currentRow;
        
        this.SELECTEDPLACES.COUNTRY = currentRow.NMPAIS;
        this.SELECTEDPLACES.STATE = currentRow.NMESTADO;
        this.SELECTEDPLACES.CITY = currentRow.NMMUNICIPIO;
        
    };
    
    /**
     * Limpa os campo de endereço a partir do local selecionado
     * (olhando a hierarquia de localidade).
     * EX.:: Se o parâmetro 'referencePlace' for 'STATE', o procedimento
     * irá limpar todos os campo a partir de estado (incluindo o estado)
     * na currentRow.
     * 
     * @param {object} widget widget de endereço ('WDGT_ENDERECO').
     * 
     * @param {string} referencePlace localidade referência para a função executar
     * a limpeza.
    */
    this.PLACEHIERARCHY = {
        COUNTRY: ["NMPAIS", "CDPAIS"], 
        STATE: ["NMESTADO", "SGESTADO"], 
        CITY: ["NMMUNICIPIO", "CDMUNICIPIO"], 
        NEIGHBORHOOD: ["NMBAIRRO", "CDBAIRRO"]
    };
    this.cleanSelectedPlacesByPlaceHierarchy = function(widget, referencePlace){
        
        var currentRow = widget.currentRow;
        var toClean = false;
        
        for(var place in this.PLACEHIERARCHY){
            
            if(place === referencePlace){
                toClean = true;
            }
            
            if(toClean){
                
                this.PLACEHIERARCHY[place].forEach(function(placeField){
                    currentRow[placeField] = "";
                });
                
            }
            
        }
        
    };
    
    /**
     * Libera os campos de endereço de acordo com o preenchimento
     * dos mesmos, pois através da regra de negócio do sistema, o
     * usuário deve preencher um endereço de acordo com a hierarquia
     * de localidade.
     * 
     * @param {object} widget widget de endereços("WDGT_ENDEREÇOS").
    */
    this.unlockPlaceFieldsByFilledPlaces = function(widget){
        
        var arrayOfPlaces = [
            widget.getField("NMPAIS"),
            widget.getField("NMESTADO"),
            widget.getField("NMMUNICIPIO"),
            widget.getField("NMBAIRRO")
        ];
        var currentRow = widget.currentRow;
        
        arrayOfPlaces.forEach(function(place, index){
            
            if(place.name !== "NMBAIRRO"){
                
                if(Boolean(currentRow[place.name])){
                    CRM_Utilities.setFieldReadOnlyProperty(arrayOfPlaces[index + 1], false);
                } else {
                    CRM_Utilities.setFieldReadOnlyProperty(arrayOfPlaces[index + 1], true);
                }
                
            } 
            
        });
        
    };
    
    /**
     * Dispara os eventos necessários ao clicar
     * em um campo de endereço.
     * 
     * @param {object} field campo selecionado.
    */
    this.addressFieldOnClick = function(field){
        
        CRM_Utilities.setPlaceFilterByPlaceOrigin(field.widget, field);
        CRM_Utilities.setDefaultOrgFilterAndOperatorOrgFilter(field);
        
        field.reload();
        
    };
    
    /**
     * Preenche os campos de endereço pelo CEP
     * digitado.
     * 
     * @param {object} widget widget de endereços
     * ("WDGT_ENDEREÇOS").
    */
    this.fillAddressByCep = function (widget) {

        var currentRow = widget.currentRow;
        var cep = currentRow.NRCEPENDERECO;
        const nrCepEndereco = widget.currentRow.NRCEPENDERECO;
        const cepSemMascara = nrCepEndereco.replace(/\D/g, '');

        if (cep && cepSemMascara.length === 8) {

            CRM_Utilities.buscarCep(cep).then(function (response) {

                var foundAddress = response.dataset.ENDERECO;

                currentRow.NMPAIS = "Brasil";
                currentRow.CDPAIS = "0055";
                currentRow.NMESTADO = foundAddress.NMESTADO;
                currentRow.SGESTADO = foundAddress.SGESTADO;
                currentRow.NMMUNICIPIO = foundAddress.NMMUNICIPIO;
                currentRow.CDMUNICIPIO = foundAddress.CDMUNICIPIO;
                currentRow.NMBAIRRO = foundAddress.NMBAIRRO;
                currentRow.CDBAIRRO = foundAddress.CDBAIRRO;
                currentRow.DSENDERECO = foundAddress.DSENDERECO;

                this.unlockPlaceFieldsByFilledPlaces(widget);

            }.bind(this))
                .catch(function (error) {
                    ScreenService.showMessage(error.error);
                });

        }

    };
    
    /**
     * Habilita o ambiente de inserção
     * de um endereço.
     * 
     * @param {object} widget widget de 
     * endereços ("WDGT_ENDERECOS").
    */
    this.addAddress = function(widget){
        var nrParcNegocio = widget.parent.currentRow.NRPARCNEGOCIO;
        
        this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function(canEdit) {
            if (canEdit) {
                General.widgetNewRow(widget);
                
                this.unlockPlaceFieldsByFilledPlaces(widget);
                this.setAddressDefaultValues(widget);
            } else {
                this.showMessageCantEditParc();
            }
        }.bind(this));
    };
    
    /**
     * Habilita o ambiente de edição de 
     * um endereço.
     * 
     * @param {object} widget widget de 
     * endereços ("WDGT_ENDERECOS").
    */
    this.editAddress = function(widget){
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        
        this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function(canEdit) {
            if (canEdit) {
                General.widgetEdit(widget);
                
                this.unlockPlaceFieldsByFilledPlaces(widget);
                this.checkPlacesFilled(widget);
            } else {
                this.showMessageCantEditParc();
            }
        }.bind(this));
    };
    
    /**
     * Define os valores padrões de um endereço.
     * 
     * @param {object} widget widget de endereço.
    */
    this.setAddressDefaultValues = function(widget){
        
        var parentWidgetCurrentRow = widget.getParent().currentRow;
        var currentRow = widget.currentRow;
        
        currentRow.NRPARCNEGOCIO = parentWidgetCurrentRow.NRPARCNEGOCIO;
        
    };
    
    this.searchLocation = function() {
        var nrParcNegocio = templateManager.container.getActiveWidget().currentRow.NRPARCNEGOCIO;
    
        this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function(canEdit) {
            if (canEdit) {
                ScreenService.confirmMessage('Os campos de Latitude e Longitude serão atualizados de acordo com os dados dos campos "Endereço", "Número" e "Estado", deseja continuar? ', 'CONFIRMATION', function(success) {
                    var widget = templateManager.container.getActiveWidget();
                    var currentRow = widget.currentRow;
                    var geocoder = new google.maps.Geocoder();
                    var endereco = currentRow.DSENDERECO + ', ' + currentRow.NRIMOVELENDERECO + ', ' + currentRow.SGESTADO;
    
                    geocoder.geocode({ 'address': endereco }, function(results, status) {
                        if (status == google.maps.GeocoderStatus.OK) {
                            var latitude = results[0].geometry.location.lat();
                            var longitude = results[0].geometry.location.lng();
                            currentRow.DSLATITUDE = latitude;
                            currentRow.DSLONGITUDE = longitude;
                            restEngine.post('/atualizaLatLong', {requestType: "DataSet", dataset: [currentRow]}).then(function() {
                                widget.reload();
                            });
                        } else if (status == 'OVER_QUERY_LIMIT') {
                            ScreenService.showMessage("Limite de pesquisa por latitude e longitude por tempo ou diário excedido! Espere alguns minutos e tente novamente ou tente novamente em outro dia.", "ERROR");
                        }
                    });
                }.bind(this));
            } else {
                this.showMessageCantEditParc();
            }
        }.bind(this));
    };
    
    this.deleteAddress = function(widget) {
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
    
        this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function(canEdit) {
            if (canEdit) {
                General.deleteCrud(widget);
            } else {
                this.showMessageCantEditParc();
            }
        }.bind(this));
    };
    
    this.showMessageCantEditParc = function() {
        var message = "Ação bloqueada!<br>" +
            "Somente o operador responsável pelo prospect e seus assistentes podem " +
            "editá-lo/evoluí-lo.";
    
        ScreenService.showMessage(message);
    };
    
    this.checkIfCanEditOrEvolParc = function(nrParcNegocio) {
        var restRow = {
            NRPARCNEGOCIO: nrParcNegocio,
            CRM_NRORGTRAB: getLocalVar('CRM_NRORGTRABALHO')
        };
        
        var params = {
            requestType: 'Row',
            row: restRow
        };
        
        return restEngine.post('/checkIfCanEditOrEvolParc', params)
            .then(function(response) {
                return response.dataset.DADOS.CAN_EDIT;
            })
            .catch(function(error) {
                return false;
            });
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ABAEnderecoParceiroController', ABAEnderecoParceiroController);
});

// FILE: ./assets/js/controllers/ABAgendaDeTarefasController.js
function ABAgendaDeTarefasController(CRM_Utilities, templateManager) {
    
    /**
     * Define o filtro da widget de tarefas
     * de acordo com a campanha selecionada
     * (Tela 'Campanha Tarefas').
     * 
     * @param {object} campaignWidget widget de campanhas.
    */
    this.setTasksWidgetFilterByCampaignNumber = function(campaignWidget){
        
        var currentCampaign = campaignWidget.currentRow;
        var tasksWidget = templateManager.container.getWidget('Agenda');
        
        var nrseqcampanhaFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(tasksWidget.dataSourceFilter, "NRSEQCAMPANHA");
        
        tasksWidget.dataSourceFilter[nrseqcampanhaFilterIndex].value = currentCampaign.NRSEQCAMPANHA;
        
        tasksWidget.reload();
        
    };
    
    /**
     * Define o filtro de uma widget
     * de evolução.
     * 
     * @param {object} widget widget de evolução.
    */
    this.setEvolutionWidgetfilter = function(){
        
        var evolutionWidget = templateManager.container.getWidget("evolucao");
        var widgetFilter = evolutionWidget.dataSourceFilter;
        
        widgetFilter[0].value = evolutionwidget.getParent().currentRow.NRPARCNEGOCIO;
        
        evolutionWidget.reload();
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ABAgendaDeTarefasController', ABAgendaDeTarefasController);
});

// FILE: ./assets/js/controllers/AbaInterlocutorController.js
function AbaInterlocutorController(CRM_Utilities, templateManager, ScreenService, Messages, General, metaDataFactory, restEngine) {
    
    /**
     * Insere a widget de interlocutor na widget recebida como 
     * parâmetro.
     * 
     * @param {object} widget widget que receberá a widget de interlocutor
     * ("WDGT_INTERLOCUTOR").
     * 
     * @param {string} nrparcnegocio nome referente ao
     * campo de parceiro de negócio.
    */
    this.setInterlocutorWidgetOnActiveWidget = function(widget, position){
        
        widget.widgets = CRM_Utilities.setElementOnArrayDefinedPosition(this.factoryInterlocutorWidget(widget), widget.widgets, position);
        widget.activate();
        
    };
    
    
    /**
     * builda a widget de interlocutor.
     * 
     * @param {object} widget widget ativa.
     * 
     * @return {object} widget de interlocutor construída.
    */
    this.factoryInterlocutorWidget = function(activeWidget){
        
        var interlocutorWidget = {
    "id": "1722319758311315390519",
    "name": "WDGT_INTERLOCUTOR",
    "label": "Interlocutor",
    "template": "widget/master_detail/grid.html",
    "container": activeWidget.container, 
    "parent": activeWidget,
    "isVisible": true,
    "dataSource": {
        "name": "product#/crud/crm_interlocutor",
        "rest": true,
        "lazyLoad": true
    },
    "dataSourceFilter": [
        {
            "name": "NRPARCNEGOCIO",
            "operator": "=",
            "value": ""
        }
    ],
    "paramsNewCode": {
        "__is_new_code": true,
        "__new_code_pk": "CRM_INTERLOCUTOR",
        "__table_pk": "NRSEQINTERLOCUTOR",
        "__columns_to_return": [
            "NRSEQINTERLOCUTOR"
        ],
        "__new_code_length": 1
    },
    "events": [
        {
            "id": "4704026363171137102435",
            "name": "WidgetOnEnterOnce",
            "code": "AbaInterlocutorController.setAddressFieldsFilterByDefaultOrgAndOperatorOrg(args.owner);"
        },
        {
            "id": "4704026361772684518436",
            "name": "WidgetOnEnter",
            "code": "AbaInterlocutorController.setInterlocutorWidgetFilter(args.owner);PartnerInfosModalController.resizeWindow(); args.owner.reload();"
        },
        {
            "id": "4704026362516730175437",
            "name": "WidgetNewRow",
            "code": "AbaInterlocutorController.setInterlocutorWidgetDefaultValues(args.owner);"
        },
        {
            "id": "12932085961377142479320",
            "name": "WidgetAfterMoveRow",
            "code": "crm00040_Lead_Controller.validateMask(args.owner); crm00040_Lead_Controller.validateMaskPhone(args.owner);"
        }
    ],
    "actions": [
        {
            "id": "12932085961763543151750",
            "name": "ACT_ADICIONAR",
            "isVisible": true,
            "icon": "plus",
            "label": "Adicionar",
            "showAsAction": "always|list",
            "events": [
                {
                    "id": "12932085963772391836751",
                    "name": "ActionEvent",
                    "code": "AbaInterlocutorController.novoInterlocutor(args.owner.widget);"
                }
            ]
        },
        {
            "id": "12932085961137644085752",
            "name": "ACT_EDITAR",
            "isVisible": true,
            "icon": "pencil",
            "label": "Editar",
            "showAsAction": "view",
            "events": [
                {
                    "id": "12932085961785161109753",
                    "name": "ActionEvent",
                    "code": "AbaInterlocutorController.editInterlocutor(args.owner.widget);"
                }
            ]
        },
        {
            "id": "12932085962912644809754",
            "name": "ACT_SALVAR",
            "isVisible": true,
            "label": "Salvar",
            "showAsAction": "never_edit",
            "events": [
                {
                    "id": "12932085961363353803755",
                    "name": "ActionEvent",
                    "code": "AbaInterlocutorController.saveInterlocutor(args.owner.widget);"
                }
            ]
        },
        {
            "id": "12932085962868422568756",
            "name": "ACT_VOLTAR_LISTA",
            "isVisible": true,
            "label": "Voltar",
            "showAsAction": "back_view",
            "events": [
                {
                    "id": "12932085964000722743757",
                    "name": "ActionEvent",
                    "code": "General.widgetGoBackToList(args.owner.widget);"
                }
            ]
        },
        {
            "id": "4704026363618852287433",
            "name": "ACT_VOLTAR_LISTA_PAI",
            "isVisible": true,
            "label": "Voltar",
            "showAsAction": "back_list",
            "events": [
                {
                    "id": "4704026363974312354434",
                    "name": "ActionEvent",
                    "code": "General.widgetGoBackToParent(args.owner.widget);"
                }
            ]
        },
        {
            "id": "129320859675487224758",
            "name": "ACT_CANCELAR_FORMULARIO",
            "isVisible": true,
            "label": "Cancelar",
            "showAsAction": "back_edit",
            "events": [
                {
                    "id": "12932085964021042762759",
                    "name": "ActionEvent",
                    "code": "General.widgetCancelForm(args.owner.widget);"
                }
            ]
        },
        {
            "id": "12932085962468638339760",
            "name": "ACT_DELETAR",
            "isVisible": true,
            "label": "Excluir",
            "icon": "trash",
            "showAsAction": "view",
            "events": [
                {
                    "id": "12932085962865850781761",
                    "name": "ActionEvent",
                    "code": "AbaInterlocutorController.deleteInterlocutor(args.owner.widget);"
                }
            ]
        }
    ],
    "fieldGroups": [
        {
            "id": "4704026362707790522438",
            "name": "CONTATO_INTERLOCUTOR",
            "label": "Contatos",
            "collapsible": true,
            "opened": true
        },
        {
            "id": "470402636407032826439",
            "name": "ENDERECO_INTERLOCUTOR",
            "label": "Endereço",
            "collapsible": true,
            "opened": true
        }
    ],
    "fields": [
        {
            "id": "4704026363644901721399",
            "name": "NRSEQINTERLOCUTOR",
            "label": "",
            "template": "field/text-edit.html",
            "class": "12",
            "isVisible": false,
            "showOnList": false,
            "showOnView": false,
            "showOnForm": false,
            "validations": {}
        },
        {
            "id": "4704026361560207406400",
            "name": "NMINTERLOCUTOR",
            "label": "Nome",
            "template": "field/text-edit.html",
            "class": "12",
            "isVisible": true,
            "showOnList": true,
            "showOnView": true,
            "showOnForm": true,
            "validations": {
                "required": true
            },
            "filterProperties": {
                "validations": {}
            }
        },                                       
        {
            "id": "12932085961498481550889",
            "name": "IDATIVO",
            "label": "Status",
            "template": "field/select-native.html",
            "class": "6",
            "isVisible": true,
            "showOnList": true,
            "showOnView": true,
            "showOnForm": true,
            "defaultValue": "IDATIVO",
            "valueField": "value",
            "descriptionField": "name",
            "validations": {},
            "hideEmptyValue": true,
            "dataSource": {
                "data": [
                    {
                        "name": "Ativo",
                        "value": "S"
                    },
                    {
                        "name": "Inativo",
                        "value": "N"
                    }
                ]
            },
            "filterProperties": {
                "hideEmptyValue": false
            }
        },
        {
            "id": "4704026361402559843401",
            "name": "NRCPFINTERLOC",
            "label": "CPF",
            "template": "field/text-edit.html",
            "isVisible": true,
            "showOnForm": true,
            "showOnList": true,
            "showOnView": true,
            "maxlength": 14,
            "class": "12",
            "validations": {},
            "events": [
                {
                    "id": "12932085961135018746701",
                    "name": "FieldOnChange",
                    "code": "CRM_Utilities.validaCPF(args.owner.field.widget, 'NRCPFINTERLOC')"
                }
            ]
        },
        {
            "id": "470402636901915548402",
            "name": "DTNASCIMENTO",
            "label": "Data de Nascimento",
            "template": "field/datetime.html",
            "class": "6",
            "isVisible": true,
            "showOnList": false,
            "showOnView": true,
            "showOnForm": true,
            "validations": {},
            "descriptionOrder": 1,
            "datetime-preset": "date",
            "datetime-dateFormat": "dd/mm/yy"
        },
        {
            "id": "4704026363311671195403",
            "name": "IDRECEBEPRESENTE",
            "label": "Recebe Presente",
            "template": "field/select-native.html",
            "class": "6",
            "isVisible": true,
            "showOnList": false,
            "showOnView": true,
            "showOnForm": true,
            "validations": {},
            "valueField": "value",
            "descriptionField": "name",
            "hideEmptyValue": true,
            "skipSearch": true,
            "defaultValue": "S",
            "dataSource": {
                "data": [
                    {
                        "name": "Sim",
                        "value": "S"
                    },
                    {
                        "name": "Não",
                        "value": "N"
                    }
                ]
            },
            "events": []
        },
        {
            "id": "470402636424517917404",
            "name": "NMSETOR",
            "label": "Setor",
            "template": "field/select.html",
            "class": "6",
            "isVisible": true,
            "showOnList": true,
            "showOnView": true,
            "showOnForm": true,
            "validations": {},
            "showSelectAs": "grid",
            "valueField": "CDSETOR",
            "descriptionField": "NMSETOR",
            "dataSource": {
                "name": "product#/crud/setor",
                "rest": true,
                "lazyLoad": true
            },
            "outData": {
                "CDSETOR": "CDSETOR",
                "NMSETOR": "NMSETOR"
            },
            "fields": [
                {
                    "id": "4704026363146147265405",
                    "name": "NMSETOR",
                    "label": "Setor",
                    "isVisible": true,
                    "showOnList": true,
                    "template": "field/text-edit.html"
                }
            ]
        },
        {
            "id": "4704026364283424767406",
            "name": "CDSETOR",
            "label": "",
            "template": "field/text-edit.html",
            "isVisible": false,
            "showOnList": false,
            "showOnForm": false,
            "showOnView": false
        },
        {
            "id": "4704026361324098498407",
            "name": "NMCARGOINTERLOC",
            "label": "Cargo",
            "template": "field/select.html",
            "class": "6",
            "isVisible": true,
            "showOnList": true,
            "showOnView": true,
            "showOnForm": true,
            "validations": {},
            "showSelectAs": "grid",
            "valueField": "CDCARGOINTERLOC",
            "descriptionField": "NMCARGOINTERLOC",
            "dataSource": {
                "name": "product#/crud/cargointerloc",
                "rest": true,
                "lazyLoad": true
            },
            "outData": {
                "CDCARGOINTERLOC": "CDCARGOINTERLOC",
                "NMCARGOINTERLOC": "NMCARGOINTERLOC"
            },
            "fields": [
                {
                    "id": "4704026362335482132408",
                    "name": "NMCARGOINTERLOC",
                    "label": "Cargo",
                    "isVisible": true,
                    "showOnList": true,
                    "template": "field/text-edit.html"
                }
            ],
            "events": []
        },
        {
            "id": "12932085961768620586743",
            "name": "EMAILINTERLOC",
            "label": "Email",
            "template": "field/text-edit.html",
            "class": "12",
            "fieldGroup": "CONTATO_INTERLOCUTOR",
            "isVisible": true,
            "showOnList": true,
            "showOnView": true,
            "showOnForm": true,
            "validations": {
                "mail": true
            }
        },
        {
            "id": "12932085962868349647744",
            "name": "NRTELEFONE1",
            "label": "Telefone 1",
            "template": "field/text.html",
            "maxlength": 18,
            "class": "4",
            "fieldGroup": "CONTATO_INTERLOCUTOR",
            "isVisible": true,
            "showOnList": true,
            "showOnView": true,
            "showOnForm": true,
            "validations": {}
        },
        {
            "id": "4704026362367364219409",
            "name": "NRRAMALTEL1",
            "label": "Ramal 1",
            "template": "field/text-edit.html",
            "class": "2",
            "fieldGroup": "CONTATO_INTERLOCUTOR",
            "isVisible": true,
            "showOnList": true,
            "showOnView": true,
            "showOnForm": true,
            "maxlength": 10,
            "validations": {}
        },
        {
            "id": "12932085962868349647744",
            "name": "NRTELEFONE2",
            "label": "Telefone 2",
            "template": "field/text.html",
            "class": "4",
            "fieldGroup": "CONTATO_INTERLOCUTOR",
            "isVisible": true,
            "showOnList": false,
            "showOnView": true,
            "showOnForm": true,
            "validations": {}
        },
        {
            "id": "4704026362950630855410",
            "name": "NRRAMALTEL2",
            "label": "Ramal 2",
            "template": "field/text-edit.html",
            "class": "2",
            "fieldGroup": "CONTATO_INTERLOCUTOR",
            "isVisible": true,
            "showOnList": false,
            "showOnView": true,
            "showOnForm": true,
            "maxlength": 10,
            "validations": {}
        },
        {
            "id": "12932085962868349647744",
            "name": "NRTELEFONE3",
            "label": "Telefone 3",
            "template": "field/text.html",
            "class": "4",
            "fieldGroup": "CONTATO_INTERLOCUTOR",
            "isVisible": true,
            "showOnList": false,
            "showOnView": true,
            "showOnForm": true,
            "validations": {}
        },
        {
            "id": "4704026363408825727411",
            "name": "NRRAMALTEL3",
            "label": "Ramal 3",
            "template": "field/text-edit.html",
            "class": "2",
            "fieldGroup": "CONTATO_INTERLOCUTOR",
            "isVisible": true,
            "showOnList": false,
            "showOnView": true,
            "showOnForm": true,
            "maxlength": 10,
            "validations": {}
        },
        {
            "id": "12932085962868349647744",
            "name": "NRTELEFONE4",
            "label": "Telefone 4",
            "template": "field/text.html",
            "class": "4",
            "fieldGroup": "CONTATO_INTERLOCUTOR",
            "isVisible": true,
            "showOnList": false,
            "showOnView": true,
            "showOnForm": true,
            "validations": {}
        },
        {
            "id": "4704026363781538409412",
            "name": "NRRAMALTEL4",
            "label": "Ramal 4",
            "template": "field/text-edit.html",
            "class": "2",
            "fieldGroup": "CONTATO_INTERLOCUTOR",
            "isVisible": true,
            "showOnList": false,
            "showOnView": true,
            "showOnForm": true,
            "maxlength": 10,
            "validations": {}
        },
        {
            "id": "4704026361059330171413",
            "name": "NRCEPINTERLOCUTOR",
            "label": "CEP",
            "class": "6",
            "template": "field/text-edit.html",
            "isVisible": true,
            "showOnList": false,
            "showOnForm": true,
            "showOnView": true,
            "fieldGroup": "ENDERECO_INTERLOCUTOR",
            "validations": {},
            "events": [
                {
                    "id": "4704026363737460426414",
                    "name": "FieldOnChange",
                    "code": "AbaInterlocutorController.fillAddressByCep(args.owner.field.widget);"
                }
            ],
            "maxlength": 15,
            "mask": {
                "type": "fix",
                "params": {
                    "cleanMaskOnModel": true,
                    "mask": "99.999-999"
                }
            },
            "filterProperties": {
                "showOnList": false,
                "showOnForm": false,
                "showOnView": false
            }
        },
        {
            "id": "470402636594185349430",
            "name": "DSENDEINTERLOCUTOR",
            "label": "Endereço",
            "template": "field/text-edit.html",
            "fieldGroup": "ENDERECO_INTERLOCUTOR",
            "isVisible": true,
            "showOnList": false,
            "showOnForm": true,
            "showOnView": true,
            "class": "6",
            "validations": {
                "maxLength": {
                    "length": 50
                }
            },
            "events": [],
            "filterProperties": {
                "isVisible": false,
                "showOnList": false,
                "showOnForm": false,
                "showOnView": false
            }
        },
        {
            "id": "4704026363663145192431",
            "name": "NRENDEINTERLOCUTOR",
            "label": "N°",
            "fieldGroup": "ENDERECO_INTERLOCUTOR",
            "template": "field/number.html",
            "isVisible": true,
            "showOnList": false,
            "showOnForm": true,
            "showOnView": true,
            "class": "6",
            "validations": {},
            "events": [],
            "filterProperties": {
                "showOnList": false,
                "showOnForm": false,
                "showOnView": false
            }
        },
        {
            "id": "4704026362739314762432",
            "name": "DSCOMPINTERLOCUTOR",
            "label": "Complemento",
            "fieldGroup": "ENDERECO_INTERLOCUTOR",
            "template": "field/text-edit.html",
            "isVisible": true,
            "showOnList": false,
            "showOnForm": true,
            "showOnView": true,
            "class": "6",
            "validations": {},
            "events": [],
            "filterProperties": {
                "showOnList": false,
                "showOnForm": false,
                "showOnView": false
            }
        },
        {
            "id": "4704026361724224837415",
            "name": "NMPAIS",
            "label": "País",
            "template": "field/select.html",
            "class": "6",
            "showSelectAs": "grid",
            "fieldGroup": "ENDERECO_INTERLOCUTOR",
            "isVisible": true,
            "showOnList": false,
            "showOnView": true,
            "showOnForm": true,
            "breakline": true,
            "validations": {},
            "dataSource": {
                "name": "product#/crud/pais",
                "rest": true,
                "lazyLoad": true
            },
            "dataSourceFilter": [
                {
                    "name": "NRORG",
                    "operator": "IN",
                    "value": ""
                }
            ],
            "valueField": "CDPAIS",
            "descriptionField": "NMPAIS",
            "outData": {
                "CDPAIS": "CDPAIS",
                "NMPAIS": "NMPAIS"
            },
            "fields": [
                {
                    "id": "4704026363588634898416",
                    "name": "NMPAIS",
                    "label": "País",
                    "isVisible": true,
                    "showOnList": true,
                    "template": "field/text-edit.html"
                }
            ],
            "events": [
                {
                    "id": "4704026361517789957417",
                    "name": "FieldOnChange",
                    "code": "AbaInterlocutorController.checkCountryChange(args.owner.field.widget.currentRow); AbaInterlocutorController.alteraEstadoReadonly(args.owner.field.widget);"
                },
                {
                    "id": "4704026361390236077418",
                    "name": "FieldOnClick",
                    "code": "args.owner.field.reload();"
                }
            ]
        },
        {
            "id": "4704026361644634769419",
            "name": "NMESTADO",
            "label": "Estado",
            "template": "field/select.html",
            "class": "6",
            "isVisible": true,
            "showOnList": false,
            "showOnView": true,
            "showOnForm": true,
            "readOnly": true,
            "fieldGroup": "ENDERECO_INTERLOCUTOR",
            "validations": {},
            "showSelectAs": "grid",
            "showAddButtonAs": "button",
            "addButtonText": "Adicionar Estado",
            "dataSource": {
                "name": "product#/crud/estado",
                "rest": true,
                "lazyLoad": true
            },
            "dataSourceFilter": [
                {
                    "name": "NRORG",
                    "operator": "IN",
                    "value": ""
                },
                {
                    "name": "CDPAIS",
                    "operator": "=",
                    "value": ""
                }
            ],
            "valueField": "SGESTADO",
            "descriptionField": "NMESTADO",
            "outData": {
                "SGESTADO": "SGESTADO",
                "NMESTADO": "NMESTADO"
            },
            "fields": [
                {
                    "id": "4704026361211516554420",
                    "name": "NMESTADO",
                    "label": "Estado",
                    "isVisible": true,
                    "showOnList": true,
                    "template": "field/text-edit.html"
                }
            ],
            "events": [
                {
                    "id": "4704026362138943311421",
                    "name": "FieldOnChange",
                    "code": "AbaInterlocutorController.checkStateChange(args.owner.field.widget.currentRow);AbaInterlocutorController.alteraMunicipioReadonly(args.owner.field.widget);"
                },
                {
                    "id": "1293208596679033120340",
                    "name": "FieldOnAdd",
                    "code": "crm00040_Lead_Controller.criarNovoEstado(args.owner.field.widget)"
                },
                {
                    "id": "4704026362239848735422",
                    "name": "FieldOnClick",
                    "code": "AbaInterlocutorController.placeFilter(args.owner.field.widget, args.owner.field);"
                }
            ]
        },
        {
            "id": "470402636757526035423",
            "name": "NMMUNICIPIO",
            "label": "Município",
            "template": "field/select.html",
            "class": "6",
            "isVisible": true,
            "showOnList": false,
            "showOnView": true,
            "showOnForm": true,
            "readOnly": true,
            "fieldGroup": "ENDERECO_INTERLOCUTOR",
            "showAddButtonAs": "button",
            "addButtonText": "Adicionar Município",
            "validations": {},
            "dataSource": {
                "name": "product#/crud/municipio",
                "rest": true,
                "lazyLoad": true
            },
            "dataSourceFilter": [
                {
                    "name": "NRORG",
                    "operator": "IN",
                    "value": ""
                },
                {
                    "name": "SGESTADO",
                    "operator": "=",
                    "value": ""
                }
            ],
            "showSelectAs": "grid",
            "valueField": "CDMUNICIPIO",
            "descriptionField": "NMMUNICIPIO",
            "outData": {
                "NMMUNICIPIO": "NMMUNICIPIO",
                "CDMUNICIPIO": "CDMUNICIPIO"
            },
            "fields": [
                {
                    "id": "470402636485243290424",
                    "name": "NMMUNICIPIO",
                    "label": "Município",
                    "isVisible": true,
                    "showOnList": true,
                    "template": "field/text-edit.html"
                }
            ],
            "events": [
                {
                    "id": "470402636581058328425",
                    "name": "FieldOnChange",
                    "code": "AbaInterlocutorController.checkCityChange(args.owner.field.widget.currentRow);AbaInterlocutorController.alteraBairroReadonly(args.owner.field.widget);"
                },
                {
                    "id": "12932085962049539827220",
                    "name": "FieldOnAdd",
                    "code": "crm00040_Lead_Controller.criarNovoMunicipio(args.owner.field.widget)"
                },
                {
                    "id": "4704026363008653175426",
                    "name": "FieldOnClick",
                    "code": "AbaInterlocutorController.placeFilter(args.owner.field.widget, args.owner.field);"
                }
            ]
        },
        {
            "id": "4704026361521773731427",
            "name": "NMBAIRRO",
            "label": "Bairro",
            "template": "field/select.html",
            "class": "6",
            "isVisible": true,
            "showOnList": false,
            "showOnView": true,
            "showOnForm": true,
            "readOnly": true,
            "maxlength": 100,
            "showAddButtonAs": "button",
            "addButtonText": "Adicionar Bairro",
            "showSelectAs": "grid",
            "fieldGroup": "ENDERECO_INTERLOCUTOR",
            "validations": {},
            "dataSource": {
                "name": "product#/crud/bairro",
                "rest": true,
                "lazyLoad": true
            },
            "dataSourceFilter": [
                {
                    "name": "NRORG",
                    "operator": "IN",
                    "value": ""
                },
                {
                    "name": "CDMUNICIPIO",
                    "operator": "=",
                    "value": ""
                }
            ],
            "valueField": "CDBAIRRO",
            "descriptionField": "NMBAIRRO",
            "outData": {
                "CDBAIRRO": "CDBAIRRO",
                "NMBAIRRO": "NMBAIRRO"
            },
            "fields": [
                {
                    "id": "4704026363686845137428",
                    "name": "NMBAIRRO",
                    "label": "Bairro",
                    "isVisible": true,
                    "showOnList": true,
                    "template": "field/text-edit.html"
                }
            ],
            "events": [
                {
                    "id": "12932085962726970312221",
                    "name": "FieldOnAdd",
                    "code": "crm00040_Lead_Controller.criarNovoBairro(args.owner.field.widget);"
                },
                {
                    "id": "4704026361487655038429",
                    "name": "FieldOnClick",
                    "code": "AbaInterlocutorController.placeFilter(args.owner.field.widget, args.owner.field);"
                }
            ]
        }
    ],
    "widgets": [
        {
            "id": "12932085962659776778",
            "name": "popUpNovoSetor",
            "label": "Novo Setor",
            "container": activeWidget.container,
            "isVisible": true,
            "showAsTab": false,
            "template": "widget/form.html",
            "events": [],
            "dataSource": {
                "name": "product#/crud/setor",
                "rest": true,
                "lazyLoad": true
            },
            "paramsNewCode": {
                "__is_new_code": true,
                "__new_code_pk": "SETOR",
                "__table_pk": "CDSETOR",
                "__new_code_column_size": 4,
                "__columns_to_return": [
                    "CDSETOR"
                ]
            },
            "actions": [
                {
                    "id": "129320859630533787387",
                    "name": "BACK_EDIT",
                    "label": "Cancelar",
                    "isVisible": true,
                    "showAsAction": "back",
                    "events": [
                        {
                            "id": "12932085962959932781",
                            "name": "ActionEvent",
                            "code": "crm00040_Lead_Controller.cancelarNovoRegistro()"
                        }
                    ]
                },
                {
                    "id": "12932085962627022",
                    "name": "SAVE",
                    "label": "Salvar",
                    "isVisible": true,
                    "showAsAction": "never",
                    "events": [
                        {
                            "id": "129321863783",
                            "name": "ActionEvent",
                            "code": "AbaInterlocutorController.saveSetor(args.owner.widget)"
                        }
                    ]
                }
            ],
            "fields": [
                {
                    "id": "12932085962763145692779",
                    "name": "SGSETOR",
                    "label": "Sigla do Setor",
                    "class": "4",
                    "maxlength": 10,
                    "isVisible": true,
                    "showOnList": true,
                    "showOnView": true,
                    "readOnly": false,
                    "validations": {
                        "required": true
                    },
                    "template": "field/text-edit.html"
                },
                {
                    "id": "12932085962763145692779",
                    "name": "NMSETOR",
                    "label": "Setor",
                    "class": "8",
                    "maxlength": 30,
                    "isVisible": true,
                    "showOnList": true,
                    "showOnView": true,
                    "readOnly": false,
                    "validations": {
                        "required": true
                    },
                    "template": "field/text-edit.html"
                }
            ]
        }
    ]
};
        
        interlocutorWidget = metaDataFactory.widgetFactory(interlocutorWidget);
        CRM_Utilities.factoryWidgetActions(interlocutorWidget);
        
        return interlocutorWidget;
        
    };
    
    this.openPopupNovoSetor = function(widget){
        var widSetor = templateManager.container.getWidget('popUpNovoSetor');
        ScreenService.openPopup(widSetor).then(function(){
            widSetor.edit();
            widSetor.template = "widget/form.html";
            widSetor.activate();
            widSetor.currentRow = {};  
            widSetor.actions = widSetor.actions.splice(0,2);
        });
    };
    
    this.saveCargo = function(widget){
        //var widInter = templateManager.container.getWidget('WDGT_INTERLOCUTOR');
        CRM_Utilities.setColumnToReturnInCurrentRow(widget.currentRow, 'CDCARGOINTERLOC');
        
        widget.currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
        widget.currentRow.__new_code_column_size = 4;
        General.widgetSave(widget).then(function(response){
            widget.reload();
        });
        
    };
    
    this.saveSetor = function(widget){
        //var widInter = templateManager.container.getWidget('WDGT_INTERLOCUTOR');
        CRM_Utilities.setColumnToReturnInCurrentRow(widget.currentRow, 'CDSETOR');
        
        widget.currentRow.__new_code_column_size = 4;
        widget.currentRow.CDDEPTO = '';
        General.widgetSave(widget).then(function(response){
            widget.reload();
            //widInter.currentRow.CDSETOR = response.dataset.columnsToReturn[0].CDSETOR;
            //widInter.currentRow.NMSETOR = widget.currentRow.NMSETOR;
            //ScreenService.showMessage('Setor adicionado com sucesso!');
        });
        
    };
    
    /**
     * Define o filtro de acordo com o local referente selecionado,
     * por exemplo, filtra apenas os municípios do estado selecionado.
     * 
     * @param {object} widget widget pai da widget de interlocutor
    */
    this.placeFilter = function(widget,field){
        var placeName = field.name;
        var currentRow = widget.currentRow;
        var filter;
        var filterCode;
        
        switch(placeName){
            case "NMESTADO":
                filterCode = "CDPAIS";
                filter = this.createEqualFilter(filterCode,currentRow.CDPAIS);
            break;
            
            case "NMMUNICIPIO":
                filterCode = "SGESTADO";
                filter = this.createEqualFilter(filterCode,currentRow.SGESTADO);
            break;
            
            case "NMBAIRRO":
                filterCode = "CDMUNICIPIO";
                filter = this.createEqualFilter(filterCode,currentRow.CDMUNICIPIO);
            break;
        }
        
        var localNameIndexFilter = CRM_Utilities.getFilterPosition(field.dataSourceFilter, filterCode);
        
        if(field.dataSourceFilter[localNameIndexFilter]){
            field.dataSourceFilter = CRM_Utilities.deleteFilterObject(field.dataSourceFilter, localNameIndexFilter);
        }
        
        field.dataSourceFilter.push(filter);
        field.reload();
    };
    
    /**
     * Retorna um objeto "filtro" com o operador
     * de igualdade.
     * 
     * @param {string} name campo referente para filtrar
     * 
     * @param {string || number} value valor a ser filtrado
     * 
     * @return {object} objeto como filtro.s
    */
    this.createEqualFilter = function(name,value){
        var filter = {
            "name": name,
            "operator": "=",
            "value": value
        };
            
        return filter;
    };
    
    /**
     * Verifica se o usuário modificou o país selecionado,
     * caso ele tenha alterado, a função limpa os campos
     * abaixo da hierarquia de localidade.
     * 
     * @param {object} currentRow row do interlocutor a ser
     * cadastrado.
    */
    var selectedCountry;
    this.checkCountryChange = function(currentRow){
        var currentCountrys = currentRow.NMPAIS.toString();
        
        if(typeof selectedCountry === "undefined"){
            selectedCountry = currentCountrys;
        }else if(selectedCountry !== currentCountrys){
            currentRow.NMESTADO = "";
            currentRow.SGESTADO = "";
            currentRow.NMMUNICIPIO = "";
            currentRow.CDMUNICIPIO = "";
            currentRow.NMBAIRRO = "";
            currentRow.CDBAIRRO = "";
            selectedCountry = currentCountrys;
        }
    };
    
    /**
     * Verifica se o usuário modificou o estado selecionado,
     * caso ele tenha alterado, a função limpa os campos
     * abaixo da hierarquia de localidade.
     * 
     * @param {object} currentRow row do interlocutor a ser
     * cadastrado.
    */
    var selectedState;
    this.checkStateChange = function(currentRow){
        var currentState = currentRow.NMESTADO.toString();
        
        if(typeof selectedState === "undefined"){
            selectedState = currentState;
        }else if(selectedState !== currentState){
            currentRow.NMMUNICIPIO = "";
            currentRow.CDMUNICIPIO = "";
            currentRow.NMBAIRRO = "";
            currentRow.CDBAIRRO = "";
            selectedState = currentState;
        }
    };
    
    /**
     * Verifica se o usuário modificou o cidade selecionado,
     * caso ele tenha alterado, a função limpa os campos
     * abaixo da hierarquia de localidade.
     * 
     * @param {object} currentRow row do interlocutor a ser
     * cadastrado.
    */
    var selectedCity;
    this.checkCityChange = function(currentRow){
        var currentMunicipality = currentRow.NMMUNICIPIO.toString();
        
        if(typeof selectedCity === "undefined"){
            selectedCity = currentMunicipality;
        }else if(selectedCity !== currentMunicipality){
            currentRow.NMBAIRRO = "";
            currentRow.CDBAIRRO = "";
            selectedCity = currentMunicipality;
        }
    };
    
    /**
     * Define o bloqueio do campo de estado de acordo 
     * com a hierarquia de localidade.
     * 
     * @param {object} wodget widget de interlocutor
     * ('WDGT_INTERLOCUTOR').
    */
    this.alteraEstadoReadonly = function(widget) {
        //Tratando se é filtro ou edit
        if(widget.mode === "edit" || widget.mode === "list") {
            var paisField = widget.getField("NMPAIS");
            var estadoField = widget.getField("NMESTADO");
            var currentRow = widget.currentRow;
            if (!paisField.value()) {
                estadoField.readOnly = true;
                currentRow.SGESTADO = "";
                currentRow.NMESTADO = "";
            }
            else {
                estadoField.readOnly = false;
            }
            this.alteraMunicipioReadonly(widget);
            
        }
    };
    
    /**
     * Define o bloqueio do campo de município de acordo 
     * com a hierarquia de localidade.
     * 
     * @param {object} wodget widget de interlocutor
     * ('WDGT_INTERLOCUTOR').
    */
    this.alteraMunicipioReadonly = function(widget) {
        //Tratando se é filtro ou edit
        if(widget.mode === "edit" || widget.mode === "list") {
            var estadoField = widget.getField("NMESTADO");
            var municipioField = widget.getField("NMMUNICIPIO");
            var currentRow = widget.currentRow;
            if (!estadoField.value()) {
                municipioField.readOnly = true;
                currentRow.NMMUNICIPIO = "";
                currentRow.CDMUNICIPIO = "";
                currentRow.NMMUNICIPIO = "";
            }
            else {
                municipioField.readOnly = false;
            }
        }
        this.alteraBairroReadonly(widget);
    };
    
    /**
     * Define o bloqueio do campo de bairro de acordo 
     * com a hierarquia de localidade.
     * 
     * @param {object} wodget widget de interlocutor
     * ('WDGT_INTERLOCUTOR').
    */
    this.alteraBairroReadonly = function(widget) {
        //Tratando se é filtro ou edit
        if(widget.mode === "edit" || widget.mode === "list"){
            var municipioField = widget.getField("NMMUNICIPIO");
            var bairroField = widget.getField("NMBAIRRO");
            var currentRow = widget.currentRow;
            if (!municipioField.value()) {
                bairroField.readOnly = true;
                currentRow.NMBAIRRO = "";
                currentRow.CDBAIRRO = "";
                currentRow.NMBAIRRO = "";
            }
            else {
                bairroField.readOnly = false;
            }
        }
    };
    
    /**
     * Define o filtro dos campos de endereço
     * pela organização padrão do sistema e
     * pela organização do operador logado.
     * 
     * @param {object} widget widget de interlocutor
     * ('WDGT_INTERLOCUTOR').
    */
    this.setAddressFieldsFilterByDefaultOrgAndOperatorOrg = function(widget){
        
        var addressFields = [widget.getField('NMPAIS'), widget.getField('NMESTADO'), widget.getField('NMMUNICIPIO'), widget.getField('NMBAIRRO')];
        
        addressFields.forEach(function(field){
            this.setAddressFieldFilterValue(field);
        }.bind(this));
        
    };
    
    /**
     * Define o filtro do campo recebido como parâmtro
     * para buscar registros da organização padrão e
     * da organização do operador logado.
     * 
     * @param {object} field campo de endereço a ser
     * filtrado.
    */
    this.setAddressFieldFilterValue = function(field){
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        var fieldFilter = field.dataSourceFilter;
        var nrorgFilterIndex = CRM_Utilities.getFilterPosition(fieldFilter, "NRORG");
        
        if(Util.isUndefined(nrorgFilterIndex)){
            nrorgFilterIndex = field.dataSourceFilter.push({name: "NRORG", operator: "IN", value: ""}) - 1;
        }    
        
        fieldFilter[nrorgFilterIndex].value = [loggedOperatorInfos.NRORG, getLocalVar('CRM_NRORGPADRAO')];
        
    };
    
    /**
     * Define os valores iniciais do cadastro de interlocutor.
     * 
     * @param {object} widget widget de interlocutor ('WDGT_INTERLOCUTOR').
    */
    this.setInterlocutorWidgetDefaultValues = function(widget){
        
        var currentRow = widget.currentRow;
        var parentWidget = widget.getParent();
        
        currentRow.NRPARCNEGOCIO = parentWidget.currentRow.NRPARCNEGOCIO;
        
    };
    
    /**
     * Salve um registro de interlocutor.
     * 
     * @param {object} widget widget de interlocutor('WDGT_INTERLOCUTOR').
    */
    this.saveInterlocutor = function(widget) {
        var nrParcNegocio = widget.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.currentRow.CDTIPOPARCPRINCIPAL;
        
        if (!nrParcNegocio) {
            nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        }
        
        if (!tipoParc) {
            if (templateManager.container.name == 'ger45000_prospect') {
                tipoParc = "PROSPECT";
            }
            if (templateManager.container.name == 'crm_cliente') {
                tipoParc = "CLIENTE";
            }
        }
        
        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function(canEdit) {
                if (canEdit) {
                    var currentRow = widget.currentRow;
                    var newRow = widget.currentRow.__is_new;
                    
                    this.removeInterlocutorPhoneMask(widget);
                    
                    if (Util.isEmptyOrBlank(currentRow.NRCPFINTERLOC)) {
                        currentRow.NRCPFINTERLOC = '';
                    }
                    
                    currentRow.NRCPFINTERLOC = currentRow.NRCPFINTERLOC.replace(/[^0-9]/g, '');
                    CRM_Utilities.setColumnToReturnInCurrentRow(currentRow, "NRSEQINTERLOCUTOR");
                    
                    General.widgetSave(widget).then(function(response) {
                        currentRow.NRSEQINTERLOCUTOR = response.dataset.columnsToReturn[0].NRSEQINTERLOCUTOR;
                        if (newRow) { // A função de salvar não recarrega caso o registro seja novo
                            widget.reload();
                        }
                    });
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this));
        } else {
            var currentRow = widget.currentRow;
            var newRow = widget.currentRow.__is_new;
            
            this.removeInterlocutorPhoneMask(widget);
            
            if (Util.isEmptyOrBlank(currentRow.NRCPFINTERLOC)) {
                currentRow.NRCPFINTERLOC = '';
            }
            
            currentRow.NRCPFINTERLOC = currentRow.NRCPFINTERLOC.replace(/[^0-9]/g, '');
            CRM_Utilities.setColumnToReturnInCurrentRow(currentRow, "NRSEQINTERLOCUTOR");
            
            General.widgetSave(widget).then(function(response) {
                currentRow.NRSEQINTERLOCUTOR = response.dataset.columnsToReturn[0].NRSEQINTERLOCUTOR;
                if (newRow) { // A função de salvar não recarrega caso o registro seja novo
                    widget.reload();
                }
            });
        }
    };
    
    /**
     * Retira a máscara dos telefones digitados
     * na currentRow.
     * 
     * @param {object} widget widget de interlocutor
     * ('WDGT_INTERLOCUTOR').
    */
    this.removeInterlocutorPhoneMask = function(widget){
        
        var currentRow = widget.currentRow;
        var phoneFields = ["NRTELEFONE1", "NRTELEFONE2", "NRTELEFONE3", "NRTELEFONE4"];
        
        phoneFields.forEach(function(phone){
            
            if(currentRow[phone]){
                currentRow[phone] = currentRow[phone].replace(/[^0-9]/g, '');    
            }
            
        });
        
    };
    
    /**
     * Abre um ambiente para edição de um
     * interlocutor.
     * 
     * @param {object} widget widget de interlocutor
     * ('CRM_INTERLOCUTOR').
    */
    this.editInterlocutor = function (widget) {
        var nrParcNegocio = widget.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.currentRow.CDTIPOPARCPRINCIPAL;

        if (widget.parent.currentRow.NRPARCPROPRI === CRM_Utilities.getLoggedOperatorInfos().NRPARCNEGOCIO || widget.parent.currentRow.NRPARCRESPROSP === CRM_Utilities.getLoggedOperatorInfos().NRPARCNEGOCIO) {

            if (!nrParcNegocio) {
                nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
            }

            if (!tipoParc) {
                if (templateManager.container.name == 'ger45000_prospect') {
                    tipoParc = "PROSPECT";
                }
                if (templateManager.container.name == 'crm_cliente') {
                    tipoParc = "CLIENTE";
                }
            }

            if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
                this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                    if (canEdit) {
                        General.widgetEdit(widget);

                        this.checkAddressFieldsPermission(widget);
                    } else {
                        this.showMessageCantEditParc();
                    }
                }.bind(this));
            } else {
                General.widgetEdit(widget);

                this.checkAddressFieldsPermission(widget);
            }
        } else {
            var tipoParc = widget.parent.currentRow.CDTIPOPARCPRINCIPAL;
            tipoParc == "PROSPECT" || tipoParc == 'CLIENTE' || widget.parent.name === "gridProspect" || widget.parent.name === "gridCliente" ? this.showMessageCantEditParc() : this.showMessageCantEditLead();
        }
    };
    
    /**
     * Define as permissões dos campos de endereço,
     * se eles estarão bloqueados ou não.
     * 
     * @param {object} widget widget de interlocutor
     * ('CRM_INTERLOCUTOR').
    */
    this.checkAddressFieldsPermission = function(widget){
        
        this.alteraEstadoReadonly(widget);
        this.alteraMunicipioReadonly(widget);
        this.alteraBairroReadonly(widget);    
        
    };
    
    /**
     * Preenche os campos de endereço pelo CEP
     * digitado.
     * 
     * @param {object} widget widget de interlocutor
     * ('WDGT_INTERLOCUTOR').
    */
    this.fillAddressByCep = function(widget) {
        
        var currentRow = widget.currentRow;
        var cep = currentRow.NRCEPINTERLOCUTOR;
        
        if(Util.isEmptyOrBlank(cep)) {
            ScreenService.showMessage("CEP não informado!");
        } else if(cep.length === 8) {
            CRM_Utilities.buscarCep(cep).then(function(response) {
                var foundAddress = response.dataset.ENDERECO;
                
                currentRow.NMPAIS = "Brasil";
                currentRow.CDPAIS = "0055";
                currentRow.NMESTADO = foundAddress.NMESTADO;
                currentRow.SGESTADO = foundAddress.SGESTADO;
                currentRow.NMMUNICIPIO = foundAddress.NMMUNICIPIO;
                currentRow.CDMUNICIPIO = foundAddress.CDMUNICIPIO;
                currentRow.NMBAIRRO = foundAddress.NMBAIRRO;
                currentRow.CDBAIRRO = foundAddress.CDBAIRRO;
                currentRow.DSENDEINTERLOCUTOR = foundAddress.DSENDERECO;
                
                this.checkAddressFieldsPermission(widget);
                
                /*TODO Encontrar um jeito melhor de fazer o autocomplete atualizar os fields para os dados da currentRow*/
                angular.element('#footer').click();
            }.bind(this)).catch(function(error) {
                ScreenService.showMessage(Messages.ENDERECO_NAO_ENCONTRADO);
            });    
        } else {
            ScreenService.showMessage(Messages.CEP_INVALIDO);
        }
    };
    
    /**
     * Define o filtro da aba de interlocutor pelo
     * parceiro de negócio em caso.
     * 
     * @param {object} widget widget de interlocutor.
    */
    this.setInterlocutorWidgetFilter = function(widget){
        
        var parentWidgetCurrentRow = widget.getParent().currentRow;
        /*Adaptação para widget modal 'dados do parceiro'*/
        if(Util.isEmptyOrBlank(Object.keys(parentWidgetCurrentRow))){
            parentWidgetCurrentRow = widget.getParent().widgets[0].currentRow;
        }
        var nrparcnegocioFilterIndex = CRM_Utilities.getFilterPosition(widget.dataSourceFilter, "NRPARCNEGOCIO");
        if(!Boolean(widget.NRPARCEIROFILTRADO) || widget.NRPARCEIROFILTRADO !== parentWidgetCurrentRow.NRPARCNEGOCIO){
            
             widget.dataSourceFilter[nrparcnegocioFilterIndex].value = parentWidgetCurrentRow.NRPARCNEGOCIO;
             widget.NRPARCEIROFILTRADO = parentWidgetCurrentRow.NRPARCNEGOCIO;
        
             widget.reload();
            
        }
        
    };
    
    this.novoInterlocutor = function(widget) {
        var nrParcNegocio = widget.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.currentRow.CDTIPOPARCPRINCIPAL;
    
        if (!nrParcNegocio) {
            nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        }
    
        if (!tipoParc) {
            if (templateManager.container.name == 'ger45000_prospect') {
                tipoParc = "PROSPECT";
            }
            if (templateManager.container.name == 'crm_cliente') {
                tipoParc = "CLIENTE";
            }
        }
    
        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function(canEdit) {
                if (canEdit) {
                    General.widgetNewRow(widget);
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this));
        } else {
            General.widgetNewRow(widget);
        }
    };
    
    this.deleteInterlocutor = function (widget) {
        var nrParcNegocio = widget.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.currentRow.CDTIPOPARCPRINCIPAL;
        if (widget.parent.currentRow.NRPARCPROPRI === CRM_Utilities.getLoggedOperatorInfos().NRPARCNEGOCIO || widget.parent.currentRow.NRPARCRESPROSP === CRM_Utilities.getLoggedOperatorInfos().NRPARCNEGOCIO) {
            if (!nrParcNegocio) {
                nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
            }

            if (!tipoParc) {
                if (templateManager.container.name == 'ger45000_prospect') {
                    tipoParc = "PROSPECT";
                }
                if (templateManager.container.name == 'crm_cliente') {
                    tipoParc = "CLIENTE";
                }
            }

            if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
                this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                    if (canEdit) {
                        General.deleteCrud(widget);
                    } else {
                        this.showMessageCantEditParc();
                    }
                }.bind(this));
            } else {
                General.deleteCrud(widget);
            }
        } else {
            var tipoParc = widget.parent.currentRow.CDTIPOPARCPRINCIPAL;
            tipoParc == "PROSPECT" || tipoParc == 'CLIENTE' || widget.parent.name === "gridProspect" || widget.parent.name === "gridCliente" ? this.showMessageCantEditParc() : this.showMessageCantEditLead();
        }
    };
    
    this.showMessageCantEditLead = function() {
        var message = "Ação bloqueada!<br>" +
            "Somente o operador responsável pelo lead e seus assistentes podem" +
            "editá-lo/evoluí-lo.";
    
        ScreenService.showMessage(message);
    };

    this.showMessageCantEditParc = function() {
        var message = "Ação bloqueada!<br>" +
            "Somente o operador responsável pelo prospect e seus assistentes podem<br>" +
            "editá-lo/evoluí-lo.";
    
        ScreenService.showMessage(message);
    };
    
    this.checkIfCanEditOrEvolParc = function(nrParcNegocio) {
        var restRow = {
            NRPARCNEGOCIO: nrParcNegocio,
            CRM_NRORGTRAB: getLocalVar('CRM_NRORGTRABALHO')
        };
        
        var params = {
            requestType: 'Row',
            row: restRow
        };
        
        return restEngine.post('/checkIfCanEditOrEvolParc', params)
            .then(function(response) {
                return response.dataset.DADOS.CAN_EDIT;
            })
            .catch(function() {
                return false;
            });
    };
    
    this.checkTelephoneMask = function() {
        var widget = templateManager.container.getActiveWidget();
        var nmTipoComu = widget.getField('NMFORMACOMU');
        
        if(nmTipoComu == 'Telefone Internacional') {
            
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('AbaInterlocutorController', AbaInterlocutorController);
});

// FILE: ./assets/js/controllers/ABALogotipoParceiroController.js
function ABALogotipoParceiroController(CRM_Utilities, templateManager, ScreenService, Messages, General, metaDataFactory, restEngine) {
    
    /**
     * Insere a widget de logo na widget recebida como 
     * parâmetro.
     * 
     * @param {object} widget widget que receberá a widget de logotipo
     * ("WDGT_LOGO_PARCEIRO").
     * 
     * @param {string} nrparcnegocio nome referente ao
     * campo de parceiro de negócio.
    */
    this.setLogoWidgetOnActiveWidget = function(widget, position){
        
        widget.widgets = CRM_Utilities.setElementOnArrayDefinedPosition(this.factoryLogoWidget(widget), widget.widgets, position);
        widget.activate();
        
    };
    
    
    /**
     * builda a widget de logotipo.
     * 
     * @param {object} widget widget ativa.
     * 
     * @return {object} widget de logotipo construída.
    */
    this.factoryLogoWidget = function(activeWidget){
        
        var logoWdgtJson = {
            "id": "17223197583113153905177",
            "name": "WDGT_LOGO_PARCEIRO",
            "label": "Logotipo",
            "template": "widget/form-view.html",
            "container": activeWidget.container,
            "parent": activeWidget,
            "showCheckbox": false,
            "isVisible": true,
            "dataSource": {
                "name": "product#/parcnegocio_logotipo",
                "rest": true,
                "lazyLoad": true
            },
            "dataSourceFilter": [
                {
                    "name": "NRPARCNEGOCIO",
                    "operator": "=",
                    "value": ""
                },
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": "@getLocalVar('CRM_NRORG')@"
                }
            ],
            "events": [
                {
                    "id": "17223197583113153905182",
                    "name": "WidgetAfterLoadDataSource",
                    "code": "ABALogotipoParceiroController.wdgLogotipoAfterLoadDataSource(args.owner);"
                },
                {
                    "id": "17223197583113153905183",
                    "name": "WidgetOnEnterTab",
                    "code": "ABALogotipoParceiroController.setLogotipoWidgetFilter(args.owner);ABALogotipoParceiroController.wdgLogotipoOnEnter(args.owner);"
                }
            ],
            "actions": [
                {
                    "id": "17223197583113153905178",
                    "name": "back",
                    "label": "Voltar",
                    "showAsAction": "back_list|back_view",
                    "isVisible": true,
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "ScreenService.closeSwipe();"
                        }
                    ]
                },
                {
                    "id": "17223197583113153905179",
                    "name": "edit",
                    "label": "Editar",
                    "icon": "pencil",
                    "showAsAction": "view",
                    "isVisible": true,
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "ABALogotipoParceiroController.editarLogo(args.owner.widget);"
                        }
                    ]
                },
                {
                    "id": "17223197583113153905180",
                    "name": "delete",
                    "label": "Excluir",
                    "icon": "trash",
                    "showAsAction": "view",
                    "isVisible": true,
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "ABALogotipoParceiroController.excluirLogo(args.owner.widget);"
                        }
                    ]
                },
                {
                    "id": "17223197583113153905181",
                    "name": "cancel",
                    "label": "Cancelar",
                    "hideIcon": true,
                    "showAsAction": "back_edit",
                    "isVisible": true,
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "ABALogotipoParceiroController.cancelarLogo(args.owner.widget);"
                        }
                    ]
                },
                {
                    "id": "17223197583113153905182",
                    "name": "save",
                    "label": "Salvar",
                    "showAsAction": "never_edit",
                    "isVisible": true,
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "ABALogotipoParceiroController.salvarLogo(args.owner.widget);"
                        }
                    ]
                }
            ],
            "fields": [
                {
                    "id": "17223197583113153905184",
                    "name": "NRPARCNEGOCIO",
                    "isVisible": false
                },
                {
                    "id": "17223197583113153905185",
                    "name": "NRORG",
                    "isVisible": false
                },
                {
                    "id": "17223197583113153905186",
                    "name": "DSDIRLOGOMARCA_OLD",
                    "isVisible": false
                },
                {
                    "id": "17223197583113153905187",
                    "name": "DSDIRLOGOMARCA",
                    "label": "Logotipo",
                    "template": "zh-image-uploader#field/image-uploader.html",
                    "class": "12",
                    "preview": "DSDIRLOGOMARCA",
                    "isVisible": true,
                    "validations": {
                        "extensions": {
                            "value": [
                                ".jpg", ".JPG",
                                ".jpeg", ".JPEG",
                                ".png", ".PNG",
                                ".bmp", ".BMP"
                            ]
                        }
                    }
                }
            ],
            "widgets": []
        };
        
        var logoWdgt = metaDataFactory.widgetFactory(logoWdgtJson);
        CRM_Utilities.factoryWidgetActions(logoWdgt);
        
        return logoWdgt;
        
    };
    
    /**
     * Define o filtro da aba de logotipo pelo
     * parceiro de negócio em caso.
     * 
     * @param {object} widget widget de logotipo.
    */
    this.setLogotipoWidgetFilter = function(widget){
        
        var parentWidgetCurrentRow = widget.getParent().currentRow;
        /*Adaptação para widget modal 'dados do parceiro'*/
        if(Util.isEmptyOrBlank(Object.keys(parentWidgetCurrentRow))){
            parentWidgetCurrentRow = widget.getParent().widgets[0].currentRow;
        }
        var nrparcnegocioFilterIndex = CRM_Utilities.getFilterPosition(widget.dataSourceFilter, "NRPARCNEGOCIO");
        if(!Boolean(widget.NRPARCEIROFILTRADO) || widget.NRPARCEIROFILTRADO !== parentWidgetCurrentRow.NRPARCNEGOCIO){
            
             widget.dataSourceFilter[nrparcnegocioFilterIndex].value = parentWidgetCurrentRow.NRPARCNEGOCIO;
             widget.NRPARCEIROFILTRADO = parentWidgetCurrentRow.NRPARCNEGOCIO;
        
             widget.reload();
            
        }
        
    };
    
    this.wdgLogotipoAfterLoadDataSource = function(wdgLogotipo) {
        wdgLogotipo.currentRow = wdgLogotipo.dataSource.data[0];
        this.controlarAcaoExcluirLogo(wdgLogotipo);
        this.buildImageInViewMode(wdgLogotipo);
    };
    
    this.controlarAcaoExcluirLogo = function(wdgLogotipo) {
        var actExcluir = wdgLogotipo.getAction("delete");
        actExcluir.isVisible = (!wdgLogotipo.currentRow.DSDIRLOGOMARCA) ? false : true;
    };
    
    this.wdgLogotipoOnEnter = function(wdgLogotipo) {
        wdgLogotipo.list();
        wdgLogotipo.reload();
        wdgLogotipo.view();
    };
    
    this.editarLogo = function(wdgLogotipo) {
        var nrParcNegocio = wdgLogotipo.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = wdgLogotipo.parent.currentRow.CDTIPOPARCPRINCIPAL;
    
        if (!nrParcNegocio) {
            nrParcNegocio = wdgLogotipo.parent.parent.currentRow.NRPARCNEGOCIO;
        }
    
        if (!tipoParc) {
            if (templateManager.container.name == 'ger45000_prospect') {
                tipoParc = "PROSPECT";
            }
            if (templateManager.container.name == 'crm_cliente') {
                tipoParc = "CLIENTE";
            }
        }
    
        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function(canEdit) {
                if (canEdit) {
                    wdgLogotipo.backupRow = Util.clone(wdgLogotipo.currentRow);
                    wdgLogotipo.edit();
                    wdgLogotipo.template = "widget/form.html";
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this));
        } else {
            wdgLogotipo.backupRow = Util.clone(wdgLogotipo.currentRow);
            wdgLogotipo.edit();
            wdgLogotipo.template = "widget/form.html";
        }
    
        var widgets = this.getWidgetsMenosLogo();
        General.changeWidgetAcessibility(widgets, false);
    };
    
    this.cancelarLogo = function(wdgLogotipo) {
        Object.keys(wdgLogotipo.backupRow).forEach(function (key) {
			wdgLogotipo.currentRow[key] = wdgLogotipo.backupRow[key];
		}); 
		wdgLogotipo.view();
		wdgLogotipo.template = "widget/form-view.html";
		
		var widgets = this.getWidgetsMenosLogo();
		General.changeWidgetAcessibility(widgets, true);
		this.buildImageInViewMode(wdgLogotipo);
    };
    
    this.buildImageInViewMode = function(wdgLogotipo){
        setTimeout(function(){
            if(!Util.isEmptyOrBlank(wdgLogotipo.dataSource.data[0]['DSDIRLOGOMARCA'])){
                var row = wdgLogotipo.dataSource.data[0]['DSDIRLOGOMARCA'];
                var fieldLogo = $('#span-field-DSDIRLOGOMARCA');
                var b64Image = typeof row === "object" ? row[0]['b64File'] : row;
                var urlLogo = window.fileServerBaseUrl+b64Image;
                var image = '<img src='+urlLogo+' class="img-responsive center-block">';
                if($('.img-responsive.center-block').length <= 0){
                    fieldLogo.find('img').remove();
                    fieldLogo.append(image);
                    fieldLogo.find('p').css({display:'none'});
                }
            }else{
                this.setDefaultImage();
            }
        }.bind(this), 50);
    };
    
    this.setDefaultImage = function(){
        var fieldLogo = $('#span-field-DSDIRLOGOMARCA');
        fieldLogo.find('p').css({display:'none'});
        fieldLogo.find('img').remove();
        fieldLogo.append('<img></img>');
        fieldLogo.find('img').addClass('defaultImage');
    }
    
    this.salvarLogo = function(wdgLogotipo) {
        var nrParcNegocio = wdgLogotipo.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = wdgLogotipo.parent.currentRow.CDTIPOPARCPRINCIPAL;
        var currentRow = wdgLogotipo.currentRow;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
    
        if (!nrParcNegocio) {
            nrParcNegocio = wdgLogotipo.parent.parent.currentRow.NRPARCNEGOCIO;
        }
    
        if (!tipoParc) {
            if (templateManager.container.name == 'ger45000_prospect') {
                tipoParc = "PROSPECT";
            }
            if (templateManager.container.name == 'crm_cliente') {
                tipoParc = "CLIENTE";
            }
        }
    
        var verifyGroupRelCallback = function(response) {
            if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
    
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
                var logo = wdgLogotipo.currentRow.DSDIRLOGOMARCA;
    
                if (logo instanceof Array && logo.length > 0) {
                    General.widgetSave(wdgLogotipo).then(
                        function () {
                            this.controlarAcaoExcluirLogo(wdgLogotipo);
    
                            var widgets = this.getWidgetsMenosLogo();
                            General.changeWidgetAcessibility(widgets, true);
    
                            wdgLogotipo.reload().then(
                                function () {
                                    this.wdgLogotipoAfterLoadDataSource(wdgLogotipo);
                                }.bind(this)
                            );
                        }.bind(this),
                        function (error) {
                            console.error(error);
                            if (error.data) ScreenService.showMessage(error.data.error);
                            else ScreenService.showMessage(error);
                        }
                    );
                } else {
                    ScreenService.showMessage("Escolha um arquivo para salvar.");
                }
            } else {
                ScreenService.showMessage(
                    'Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' +
                        response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] +
                        ' - ' +
                        response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] +
                        '!'
                );
            }
        }.bind(this);
    
        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(
                function (canEdit) {
                    if (canEdit) {
                        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
                            verifyGroupRelCallback
                        );
                    } else {
                        this.showMessageCantEditParc();
                    }
                }.bind(this)
            );
        } else {
            General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
                verifyGroupRelCallback
            );
        }
    };
    
    this.excluirLogo = function(wdgLogotipo) {
        var nrParcNegocio = wdgLogotipo.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = wdgLogotipo.parent.currentRow.CDTIPOPARCPRINCIPAL;
        var currentRow = wdgLogotipo.currentRow;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
    
        if (!nrParcNegocio) {
            nrParcNegocio = wdgLogotipo.parent.parent.currentRow.NRPARCNEGOCIO;
        }
    
        if (!tipoParc) {
            if (templateManager.container.name == 'ger45000_prospect') {
                tipoParc = "PROSPECT";
            }
            if (templateManager.container.name == 'crm_cliente') {
                tipoParc = "CLIENTE";
            }
        }
    
        var verifyGroupRelCallback = function(response) {
            if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
    
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
                if (wdgLogotipo.dataSource.data[0].DSDIRLOGOMARCA) {
                    ScreenService.confirmMessage(Messages.CONFIRMAR_DELETE, 'QUESTION',
                        function() {
                            General.callRestEngine("product#/parcnegocio_logotipo/excluirLogo", "Row", wdgLogotipo.currentRow).then(
                                function() {
                                    wdgLogotipo.currentRow.DSDIRLOGOMARCA = null;
                                    wdgLogotipo.currentRow.DSDIRLOGOMARCA_OLD = null;
                                    ScreenService.showMessage("Logotipo excluído com sucesso!");
                                    this.controlarAcaoExcluirLogo(wdgLogotipo);
                                    this.setDefaultImage(wdgLogotipo);
                                }.bind(this)
                            ).catch(
                                function(error) {
                                    console.error(error);
                                    ScreenService.showMessage(error.data.error);
                                }
                            );
                        }.bind(this)
                    );
                } else {
                    ScreenService.showMessage('Nenhuma logo encontrada para este parceiro!');
                }
            } else {
                ScreenService.showMessage(
                    'Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' +
                    response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] +
                    ' - ' +
                    response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] +
                    '!'
                );
            }
        }.bind(this);
    
        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(
                function(canEdit) {
                    if (canEdit) {
                        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
                            verifyGroupRelCallback
                        );
                    } else {
                        this.showMessageCantEditParc();
                    }
                }.bind(this)
            );
        } else {
            General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
                verifyGroupRelCallback
            );
        }
    };
    
    this.getWidgetsMenosLogo = function() {
        var wdgLogotipo = templateManager.container.getWidget("WDGT_LOGO_PARCEIRO");
        
        var widgets = wdgLogotipo.getParent().widgets;
		widgets = widgets.filter(function(wid) {
		    return wid.name !== wdgLogotipo.name;
		});
		
		return widgets.concat(wdgLogotipo.getParent());
    };
    
    this.showMessageCantEditParc = function() {
        var message = 'Ação bloqueada!<br>' +
            'Somente o operador responsável pelo prospect e seus assistentes podem ' +
            'editá-lo/evoluí-lo.';
    
        ScreenService.showMessage(message);
    };
    
    this.checkIfCanEditOrEvolParc = function(nrParcNegocio) {
        var restRow = {
            NRPARCNEGOCIO: nrParcNegocio,
            CRM_NRORGTRAB: getLocalVar('CRM_NRORGTRABALHO')
        };
    
        var params = {
            requestType: 'Row',
            row: restRow
        };
    
        return restEngine.post('/checkIfCanEditOrEvolParc', params).then(function(response) {
            return response.dataset.DADOS.CAN_EDIT;
        }).catch(function() {
            return false;
        });
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ABALogotipoParceiroController', ABALogotipoParceiroController);
});

// FILE: ./assets/js/controllers/ABEvolucaoController.js
function ABEvolucaoController(CRM_Utilities, templateManager, restEngine, ScreenService, Messages, ZHPromise) {
    
    /**
     * Procedimento para definir a permissão para editar
     * o campo 'Data da Evolução' no ambiente de criação
     * de uma evolução.
     * 
     * @para {widget} widget widget referente a tela de
     * evolução.
    */
    this.setEvolDateChangePermission = function(widget){
        var currentRow = widget.currentRow;
        
        this.getNrDiasLanceEvol(widget).then(function(response){
            var nrDiasLanceEvol = templateManager.NRDIASLANCEVOL;
            
            if(nrDiasLanceEvol > 0 && currentRow.__is_new){
                widget.getField('DTHREVOLCONT').readOnly = false;
                this.configureEvolDateChangePermission(widget, nrDiasLanceEvol);
            }else{
                widget.getField('DTHREVOLCONT').readOnly = true;
            }
        }.bind(this));
    };
    
    /**
     * Procedimento para buscar, e setar no templateManager
     * (se não já existir no templateManager),
     * o número de dias permitido para uma 
     * evolução ser lançada posteriomento ao dia real.
     * 
     * @param {object} widget widget referente a
     * tela de evoluções.
     * 
     * @return {number} retorna o número de dias pemitido
     * para lançar uma evolução posterior a data real.
    */
    this.getNrDiasLanceEvol = function(widget){
        var nrDiasLanceEvol = templateManager.NRDIASLANCEVOL;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        var deferred = ZHPromise.defer();
        
        if(nrDiasLanceEvol){
            deferred.resolve();
            
            return deferred;
        }else{
            
            var paramsRestEngine = {
            "requestType": "Row",
            "row": {NRORG: loggedOperatorInfos.NRORG}
            };
        
            return restEngine.post('/getNrDiasLanceEvol', paramsRestEngine,
            function(success){
                templateManager.NRDIASLANCEVOL = success.dataset.DADOS.NRDIASLANCEVOL[0].NRDIASLANCEVOL;
            },undefined,
            function(error){
                Messages.CATCH_EXCEPTION_ERROR(error.data.error);
            },undefined,undefined
        );
            
        }
    };
    
    /**
     * Procedimento para configurar as permissões
     * de data máxima e data mínima para lançar
     * uma evolução.
     * 
     * @param {object} widget widget referente a
     * tela de evoluções.
     * 
     * @param {number} numberOfDays número máximo de dias
     * para se lançar uma evolução posteriormente.
    */
    this.configureEvolDateChangePermission = function(widget, numberOfDays){
        var evolDateField = widget.getField('DTHREVOLCONT');
        
        evolDateField.minDate = CRM_Utilities.subtractDateByDays(CRM_Utilities.getCurrentDateWithMinTime(),numberOfDays);
        evolDateField.maxDate = CRM_Utilities.getCurrentDateWithMaxTime();
    };
    
    /**
     * //TODO
    */
    this.configureEvolTimeShowPermission = function(widget){
        var currentRow = widget.currentRow;
        var selectedDateWithoutTime = moment(currentRow.DTHREVOLCONT, 'DD/MM/YYYY HH:mm').format('DD/MM/YYYY');    
        
        if(selectedDateWithoutTime === CRM_Utilities.getCurrentDate()){
            currentRow.DTHREVOLCONT = selectedDateWithoutTime + ' ' + CRM_Utilities.getCurrentTime();
        }else{
            currentRow.DTHREVOLCONT = selectedDateWithoutTime + ' 00:00';
        }
    };
    
    /**
     * Define o filtro da widget de evolução
     * pelo número do parceiro de negócio selecionado
     * anteriormente.
     * 
     * @param {object} widgetName nome da widget de evolução
     * em caso.
    */
    this.setEvolutionWidgetFilterByNrParcNegocio = function(widgetName){
        
        var evolutionWidget = templateManager.container.getWidget(widgetName);
        
        var widgetFilter = evolutionWidget.dataSourceFilter;
        var parentWidgetCurrentRow = evolutionWidget.getParent().currentRow;
        var nrParcNegocioFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(widgetFilter, "P_NRPARCNEGOCIO");
        
        widgetFilter[nrParcNegocioFilterIndex].value = parentWidgetCurrentRow.NRPARCNEGOCIO;
        
        evolutionWidget.reload();
        
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ABEvolucaoController', ABEvolucaoController);
});

// FILE: ./assets/js/controllers/agrupamentoParceiroController.js
function agrupamentoParceiroController(ScreenService, ValidationEngine, templateManager, Utilities, wizardEngine, ZHPromise, restEngine, Operador_Repository, General, CRM_Utilities, Messages) {
    
    var self = this;
    
    
    this.widgetOnEnter = function(widget, fieldsToApply) {
        var filterRow = {};
        filterRow.CDOPERRESPONSAVEL = [templateManager.LOGGEDOPERATOR.CDOPERADOR];
        filterRow.IDATIVO = 'S';
        
        CRM_Utilities.openFilterOnEnter(widget, filterRow, fieldsToApply);
    };
    

    this.showCantEditMessage = function() {
        var message = 'Ação bloqueada!<br>' +
            'Somente o operador responsável pelo lead e seus assistentes podem ' +
            'editá-lo/evoluí-lo.';
    
        ScreenService.showMessage(message);
    };
    
    this.save = function() {
        var widget = templateManager.container.getWidget('agrupamentoGrid');
        var currentRow = widget.currentRow;
        var evolWidget = templateManager.container.getWidget('evolucao');
        var evolCurrentRow = evolWidget.currentRow;
    
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
    
        if (evolWidget.isValid()) {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                if (canEdit) {
                    if (widget.isValid()) {
    
                        ScreenService.confirmMessage("A evolução será criada para todos os parceiros relacionados. Deseja continuar?", "question", function () {
                            currentRow.NRORG = getLocalVar('CRM_NRORG');
                            currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                            currentRow.CDOPERINCLUSAO = templateManager.LOGGEDOPERATOR.CDOPERADOR;
                            currentRow.NRORGINCLUSAO = getLocalVar('CRM_NRORG');
                            currentRow.CDOPERULTATU = templateManager.LOGGEDOPERATOR.CDOPERADOR;
                            currentRow.NRORGULTATU = getLocalVar('CRM_NRORG');
    
                            var parcnegocioRows = currentRow.NRPARCNEGOCIO_REL;
                            var rows = [];
    
                            parcnegocioRows.forEach(function (parcnegocio, parcnegociotIndex) {
                                rows.push(this.setParcnegocioValues(widget, parcnegociotIndex));
                            }.bind(this));
    
                            General.callRestEngine("product#/agrupamentoParceiros/save", "DataSet", rows).then(function (response) {
                                if (response.dataset && response.dataset.error) {
                                    ScreenService.showMessage(response.dataset.error, 'ERROR');
                                }
                                if (response.dataset && (response.dataset.PPR || response.dataset.PFR)) {
                                    var dataset = response.dataset;
    
                                    ScreenService.notificationMessage("Ocorreram erros na adição dos registros, verifique o popup de mensagens!", "alert");
                                    openPopupMensagens(dataset.msg);
                                }
    
                                if (!Util.isEmptyOrBlank(response.dataset.PARCS)) {
                                    response.dataset.PARCS.forEach(function (parcnegocio, index) {
                                        evolCurrentRow.NRPARCNEGOCIO = parcnegocio;
                                        General.callRestEngine("product#/agrupamentoEvolSave", "Row", evolCurrentRow).then(function (resp) {
                                            if (resp.dataset && resp.dataset.error) {
                                                ScreenService.showMessage(resp.dataset.error, 'ERROR');
                                            } else if (resp.error) {
                                                ScreenService.showMessage(resp.error, 'ERROR');
                                            }
                                        });
                                    }.bind(this));
                                }
    
                                ScreenService.closeSwipe();
                                widget.list();
                                widget.reload();
                            }.bind(this));
                        }.bind(this));
                    }
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this));
        }
    };
    
    this.newRow = function() {
        var widget = templateManager.container.getActiveWidget();
        
        General.widgetNewRow(widget);
    };
    
    this.deleteRow = function() {
        var widget = templateManager.container.getWidget('agrupamentoGrid');
        var evolWidget = templateManager.container.getWidget('evolucao');
    
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
    
        this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
            if (canEdit) {
                if (evolWidget.isValid()) {
                    General.deleteCrud(widget).then(function () {
                        General.callRestEngine("product#/agrupamentoEvolSave", "Row", evolWidget.currentRow).then(function (resp) {
                            if (resp.dataset && resp.dataset.error) {
                                ScreenService.showMessage(resp.dataset.error, 'ERROR');
                            } else if (resp.error) {
                                ScreenService.showMessage(resp.error, 'ERROR');
                            } else {
                                ScreenService.closeSwipe();
                            }
                        });
                    });
                }
            } else {
                this.showMessageCantEditParc();
            }
        }.bind(this));
    };
    
    this.cancelForm = function() {
        var widget = templateManager.container.getWidget('agrupamentoGrid');
        var widgetEvol = templateManager.container.getWidget('evolucao');
        
        General.widgetCancelForm(widget);
        General.widgetCancelForm(widgetEvol);
    };
    
    this.setParcnegocioValues = function(widget, parcnegocioIndex){
        var currentRow = angular.copy(widget.currentRow);
        var agrupamentoWidgetCurrentRow = this.getAgrupamentoWidgetCurrentRow();
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.NRPARCNEGOCIO = currentRow.NRPARCNEGOCIO;  
        currentRow.NRPARCNEGOCIO_REL = currentRow.NRPARCNEGOCIO_REL[parcnegocioIndex];
        currentRow.NMPRINCIPALPARCREL = currentRow.NMPRINCIPALPARCREL[parcnegocioIndex];
        currentRow.NRORG = currentRow.NRORG;
        currentRow.CRM_NRORGTRAB = currentRow.CRM_NRORGTRAB;
        currentRow.IDATIVO = agrupamentoWidgetCurrentRow.IDATIVO;
        currentRow.CDOPERINCLUSAO = agrupamentoWidgetCurrentRow.CDOPERINCLUSAO;
        currentRow.NRORGINCLUSAO = agrupamentoWidgetCurrentRow.NRORGINCLUSAO;
        currentRow.CDOPERULTATU = agrupamentoWidgetCurrentRow.CDOPERULTATU;
        currentRow.NRORGULTATU = agrupamentoWidgetCurrentRow.NRORGULTATU;
        currentRow.DTINCLUSAO = loggedOperatorInfos.DTINCLUSAO;
        currentRow.DTULTATU = agrupamentoWidgetCurrentRow.DTULTATU;
        
        return currentRow;
    };
    
    this.getAgrupamentoWidgetCurrentRow = function(){
        var agrupamentotWidget = templateManager.container.getWidget("agrupamentoGrid");
        
        return agrupamentotWidget.currentRow;
        
    };
    
    var openPopupMensagens = function(msg) {
        var widgetMensagens = templateManager.container.getWidget('messagesImportacaoAgrupamento');
        widgetMensagens.dataSource.data = msg;
        ScreenService.openPopup(widgetMensagens);
    };
    

    this.showMessageCantEditParc = function() {
        var message = 'Ação bloqueada!<br>' +
            'Somente o operador responsável pelo prospect e seus assistentes podem' +
            'editá-lo/evoluí-lo.';
        
        ScreenService.showMessage(message);
    };
    
    this.checkIfCanEditOrEvolParc = function(nrParcNegocio) {
        var restRow = {
            NRPARCNEGOCIO: nrParcNegocio,
            CRM_NRORGTRAB: getLocalVar('CRM_NRORGTRABALHO')
        };
    
        var params = {
            requestType: 'Row',
            row: restRow
        };
    
        return restEngine.post('/checkIfCanEditOrEvolParc', params).then(function(response) {
            return response.dataset.DADOS.CAN_EDIT;
        }).catch(function() {
            return false;
        });
    };
    
    this.openEvolTab = function() {
        var widget = templateManager.container.getActiveWidget();
        var currentRow = widget.currentRow;
        var evolWidget = templateManager.container.getWidget('evolucao');
        
        var loggedOperatorInfos = templateManager.LOGGEDOPERATOR;
        
        if(widget.isValid()) {
            ScreenService.closeSwipe().then(function() {
                widget.list();
                evolWidget.actions.find(function(x) {
                    return x.name == 'SAVE';
                }).isVisible = true;
                evolWidget.actions.find(function(x) {
                    return x.name == 'confirmDeleteParc';
                }).isVisible = false;
                evolWidget.activate();
                evolWidget.newRow();
                
                var evolCurrentRow = evolWidget.currentRow;
                evolCurrentRow.NRPARCNEGOCIO = currentRow.NRPARCNEGOCIO_REL;
                evolCurrentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
                evolCurrentRow.NMOPERADOREVOL = loggedOperatorInfos.NMOPERADOR;
                evolCurrentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
                evolCurrentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
                evolCurrentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
                evolCurrentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                evolCurrentRow.DTHREVOLCONT = (currentRow.DTHREVOLCONT)? currentRow.DTHREVOLCONT : moment(new Date()).format('DD/MM/YYYY HH:mm');
                evolCurrentRow.TXEVOLCONT = "Realizado o agrupamento de parceiro com o parceiro " + currentRow.NMPRINCIPALPARC;
                
                evolWidget.redraw();
                
                ScreenService.openSwipe(evolWidget);
            });
        }
    };
    
    this.openEvolRemoveTab = function() {
        var widget = templateManager.container.getActiveWidget();
        var currentRow = widget.currentRow;
        var evolWidget = templateManager.container.getWidget('evolucao');
        
        var loggedOperatorInfos = templateManager.LOGGEDOPERATOR;
        
        if(widget.isValid()) {
            ScreenService.closeSwipe().then(function() {
                widget.list();
                evolWidget.actions.find(function(x) {
                    return x.name == 'SAVE';
                }).isVisible = false;
                evolWidget.actions.find(function(x) {
                    return x.name == 'confirmDeleteParc';
                }).isVisible = true;
                evolWidget.activate();
                evolWidget.newRow();
                
                var evolCurrentRow = evolWidget.currentRow;
                evolCurrentRow.NRPARCNEGOCIO = currentRow.NRPARCNEGOCIO_REL;
                evolCurrentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
                evolCurrentRow.NMOPERADOREVOL = loggedOperatorInfos.NMOPERADOR;
                evolCurrentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
                evolCurrentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
                evolCurrentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
                evolCurrentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                evolCurrentRow.DTHREVOLCONT = (currentRow.DTHREVOLCONT)? currentRow.DTHREVOLCONT : moment(new Date()).format('DD/MM/YYYY HH:mm');
                evolCurrentRow.TXEVOLCONT = "Retirado o agrupamento de parceiro com o parceiro " + currentRow.NMPRINCIPALPARC;
                
                evolWidget.redraw();
                
                ScreenService.openSwipe(evolWidget);
            });
        }
    };
    
    
    this.popupMensagensVoltar = function() {
        var widget = templateManager.container.getWidget('agrupamentoGrid');
        
        ScreenService.closePopup();
        General.cancelForm(widget);
        widget.activate();
        widget.list();
        
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('agrupamentoParceiroController', agrupamentoParceiroController);
});

// FILE: ./assets/js/controllers/AlterarSenhaController.js
/**
 * Created by gustavolima on 25/11/2015.
 */
function AlterarSenhaController(templateManager,ScreenService,restEngine,Operador_Repository) {

    this.mostrarSenha = function()
    {
        var widget = templateManager.container.getActiveWidget();
        if(widget.currentRow.viewPass == 'SIM')
        {
            widget.fields[0].template = 'field\/text-edit.html';
            widget.fields[1].template = 'field\/text-edit.html';
            widget.fields[2].template = 'field\/text-edit.html';

        }else{
            widget.fields[0].template = 'field\/password-edit.html';
            widget.fields[1].template = 'field\/password-edit.html';
            widget.fields[2].template = 'field\/password-edit.html';
        }
        widget.fields[0].reload();
        widget.fields[1].reload();
        widget.fields[2].reload();
    };

    this.alteraSenha = function()
    {
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }

            var newPass = templateManager.container.getActiveWidget().currentRow;

            newPass.CDOPERADOR = operator[0].CDOPERADOR;
            newPass.NRORG = operator[0].NRORG;
            newPass.DSEMAILOPER = operator[0].DSEMAILOPER;

            if(templateManager.container.getActiveWidget().isValid() === false)
                ScreenService.showMessage("Campos obrigatórios não foram preenchidos",'ERROR');
            else{
                if(newPass.confirm_new_password == newPass.new_password)
                {
                    restEngine.post('crm#/login\/alteraSenha', {
                            "requestType": "Row",
                            "row": {"newpass":newPass}
                        }
                    ).then(function (data){
                            if(data.messages[1].message == "0")
                            {
                                ScreenService.openWindow('dashboard');
                            }
                            ScreenService.showMessage(data.messages[0].message);
                        }
                    );
                }
                else
                {
                    if(newPass.new_password == newPass.old_password)
                        ScreenService.showMessage("A nova senha deve ser diferente da antiga.");
                    else
                        ScreenService.showMessage("As senhas não conferem.");
                }
            }
        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
    };

}


Configuration(function(ContextRegister) {
    ContextRegister.register('AlterarSenhaController', AlterarSenhaController);
});

// FILE: ./assets/js/controllers/CargoInterlocutor.js
function CargoInterlocutorController(templateManager, ScreenService, Utilities, restEngine, General){
    this.setCargo = function(args) {
        var widget = args;
        if (widget.isValid()) {
            widget.currentRow.NRORG = getLocalVar('CRM_NRORG') ? getLocalVar('CRM_NRORG') : " ";
            
            return General.saveCrud(widget).then(function(response){
                widget.reload();
            });
           
        }
    };
	
}
Configuration(function(ContextRegister){
    ContextRegister.register('CargoInterlocutorController', CargoInterlocutorController);
});

// FILE: ./assets/js/controllers/ChamadoController.js
function ChamadoController(templateManager, ScreenService, Utilities, restEngine, General, CRM_Utilities, localStorageEngine, ZHPromise, Messages){
    
    /**
     * Inicializa campos da row.
     * 
     * @param {object} widget widget de chamado
    */
    this.widgetNewRow = function(widget){
        General.widgetNewRow(widget);
        
        widget.currentRow.IDTPCONTATO  = 'P';
        widget.currentRow.IDSTATUSCONT = 'A';
        widget.currentRow.NRPARCNEGOCIORELAC = '';
        widget.currentRow.IDGERAFATURA = 'NAO';
        widget.currentRow.NRLOTEESTQ = '';
        widget.currentRow.CDMOTICONT = '';
        widget.currentRow.NRSEQSITUACAO = '';
        widget.currentRow.NRCLASSIFICACAOCASO = '';
        widget.currentRow.NRPARCINTERLOCUTOR = '';
        widget.currentRow.NMOPERCONT = templateManager.LOGGEDOPERATOR.NMOPERADOR;
        widget.currentRow.CDOPERCONT = templateManager.LOGGEDOPERATOR.CDOPERADOR;
        
        this.setReadOnlyCDLOTEandMOTICONT(widget);
    };
    
    /**
     * Abre a tab de conclusão de chamado, e 
     * coloca ela no modo correto de edição
     * 
     * @param {object} widget widget de chamado
    */
    this.concluirChamado = function(widget){
    
        var conclusaoWidget = templateManager.container.getWidget('WDGT_CONCLUSAO_CHAMADO');
        conclusaoWidget.isVisible = true;
        this.editConclusao(conclusaoWidget);
        widget.openTab('WDGT_CONCLUSAO_CHAMADO');
        conclusaoWidget.newRow();
        //Seta parâmetro para determinar ações no método de cancelar form
        conclusaoWidget.currentRow.CONCLUSAOCHAMADO = true;
        ScreenService.closePopup(true);
    };
    
    /**
     * Abre o swipe de Evolução, procedimento executado
     * pré conclusão do chamado
     * 
     * @param {object} widget widget de chamado
    */
    this.evolucaoPreConclusao = function(widget){
        widget.openTab('WDGT_EVOLUCAO');
        ScreenService.closePopup();
        var evolucaoWidget = templateManager.container.getWidget('WDGT_EVOLUCAO');
        
        setTimeout(function(){    
            General.widgetNewRow(evolucaoWidget); 
            evolucaoWidget.currentRow.EVOLUCAOPRECONCLUSAO = true;
        }.bind(this), 1000);
        
    };
    
    /**
     * Muda o readonly doS campos MOTICONT e CDLOTE baseado
     * no campo 'Produto'.
     * 
     * @param {object} widget widget de chamado
    */
    this.setReadOnlyCDLOTEandMOTICONT = function(widget, keepValue){
      var currentRow = widget.currentRow;
      var fieldLote = widget.getField('NRLOTEESTQ');
      var fieldMoti = widget.getField('NMMOTICONT');
      var fieldProd = widget.getField('NMPRODUTO');
      
      if(widget.name === "filterPopup"){
        fieldMoti = widget.getField('CDMOTICONT');
      }
      
      if(!Util.isEmptyOrBlank(fieldProd.value()) || !Util.isEmptyOrBlank(currentRow.NRTPARVPROD)){
            if(fieldLote){
                fieldLote.readOnly = false;   
                if(!keepValue)            
                    fieldLote.clearValue();
            }
            if(fieldMoti){
                fieldMoti.readOnly = false;   
                if(!keepValue)            
                    fieldMoti.clearValue();
            }
      }else{
            if(fieldLote){
                fieldLote.readOnly = true;    
                fieldLote.clearValue();
            }
            if(fieldMoti){
                fieldMoti.readOnly = true;   
                fieldMoti.clearValue();
            }
      }
      
      this.setFilterCDLOTEandMOTICONT(widget);
    };
    
    this.setFilterCDLOTEandMOTICONT = function(widget){
        var currentRow = widget.currentRow;  
        var fieldLote = widget.getField('NRLOTEESTQ');
        
        if(fieldLote){
            var filterLote = fieldLote.dataSourceFilter;
            //filtro pelo produto
            if(!Util.isEmptyOrBlank(filterLote[3].value)){
                if(widget.name === "filterPopup")
                    filterLote[3].value = currentRow.CDPRODUTO;
            }
        
        }
        
        var fieldMoti = widget.getField('NMMOTICONT');
        if(widget.name === "filterPopup")
            fieldMoti = widget.getField('CDMOTICONT')
        
        if(fieldMoti){
            var filterMoti = fieldMoti.dataSourceFilter;
            filterMoti[1].value = currentRow.CDPRODUTO;
        }
        
        
        
    };
    
    /**
     * Procedimento para garantir o comportamento correto
     * da widget de conclusao(form) em modo de edição.
     * 
     * @param {object} widget widget de conclusão
    */
    this.editConclusao = function(widget){
        General.widgetEdit(widget);
        if(!widget.backupRow) widget.backupRow = Util.clone(widget.currentRow);
        widget.template = "widget/form.html";
        widget.activate();
    };
    
    /**
     * Procedimento para salvar a conclusão e, 
     * consequentemente a evolução que é feita antes disso.
     * 
     * @param {object} widget widget de conclusão
    */
    this.saveConclusao = function(widget){
        General.widgetSave(widget).
            then(function(response){
                //se tudo der certo no save
                if(!Util.isUndefined(response.dataset.DADOS.NRSEQCONCLUSAO)){
                    //Muda pra modo "view/list"
                    widget.parent.parent.currentRow.DTHRCONCCONT  = CRM_Utilities.getDataHoraAtual();
                    widget.mode = "list";
                    widget.activate();
                    //salvando a evolução 
                    if(!widget.currentRow.KANBAN === true){
                        General.widgetSave(templateManager.container.WIDGETEVOLUCAO);
                        delete templateManager.container.WIDGETEVOLUCAO;
                    }
                    ScreenService.showMessage('Chamado Concluido!');
                    widget.parent.parent.reload();
                    var row = {};
                    
                    row.NRPARCINTERLOCUTOR = widget.parent.parent.currentRow.NRPARCINTERLOCUTOR;
                    row.INTERLOCUTOR       = widget.parent.parent.currentRow.NMPARCINTERLOCUTOR;
                    row.NRSEQCONTATO       = widget.parent.parent.currentRow.NRSEQCONTATO;
                    row.PRODUTO            = widget.parent.parent.currentRow.NMPRODUTO;
                    row.CLIENTE            = widget.parent.parent.currentRow.NMPARCNEGOCIO;
                    row.REFERENCIA         = widget.parent.parent.currentRow.DSREFECONT;
                    row.DATACONCLUSAO      = widget.parent.parent.currentRow.DTHRCONCCONT;
                    row.EMAIL              = widget.parent.parent.currentRow.EMAIL;
                    row.NRORG              = widget.currentRow.NRORG;
                    row.RESPONSAVEL        = widget.currentRow.NMOPERCONCLUSAO;
                    row.DESCCONCLUSAO      = widget.currentRow.DESCCONCLUSAO;
                    
                    
                    var paramsRestEngine = {
                        "requestType": "Row",
                        "row": row
                    };
                    restEngine.post('/notificaInterlocutorChamado', paramsRestEngine).then(function(){}).
                        catch(function(fail){
                            ScreenService.showMessage('Falha ao Notificar o Solicitante.');
                        }.bind(this));
                }else{
                    //se algo der errado
                    General.widgetCancelForm(templateManager.container.WIDGETEVOLUCAO);
                    delete templateManager.container.WIDGETEVOLUCAO;    
                }
            }.bind(this));
    };
    
    /**
     * Procedimento para cancelar a edição da conclusão 
     * garantindo o comportamento correto da widget conclusão(form).
     * 
     * @param {object} widget widget de conclusão
    */
    this.cancelConclusao = function(widget){
        //Se não for o primeiro save de conclusão, cancela e bota em modo "view/list"
        if(!widget.currentRow.CONCLUSAOCHAMADO){
            General.widgetCancelForm(widget);
            widget.mode = "list";
            widget.activate();
        }else{
            //Se for a primeira ediçãod a conclusão, cancela e volta para a tab principal
            var widgets = widget.parent.parent.widgets;
    		General.changeWidgetAcessibility(widgets.concat(widget.parent.parent), true);
    		widget.mode = "list";
    		widget.template = "widget/form-view.html";
    		widget.editing = false;
    		widget.activate();
    		widget.parent.parent.openTab('WDGT_CHAMADO');
    		delete widget.currentRow.CONCLUSAOCHAMADO;
        }
    };
    
    /**
     * Seta os dados vindos da requisição na currentRow
     * do form.
     * 
     * @param {object} widget widget de conclusão
    */
    this.setConcInCurrentRow = function(widget){
        if(widget.dataSource.data.length > 0 ){
            widget.currentRow = widget.dataSource.data[0];
        } 
    };
    
    /**
     * Procedimento para garantir o fucnionamento correto,
     * do field colorido no grid.
     * 
     * @param {object} widget widget de chamado
    */
    this.classificacaoOnChange = function(widget){
        var NRCLASSIFICACAOCASO = widget.currentRow.NRCLASSIFICACAOCASO;
        var fieldColor     = widget.getField("DSCLASSIFICACAOCASO");
        
        //Tira a cor do field color se não houver termômetro selecionado
        if(Util.isEmptyOrBlank(NRCLASSIFICACAOCASO)){
            fieldColor.clearValue();
            $('.inner-color').removeAttr('style');
            $('.color-field-view .zh-select-multiple').addClass('zh-field-value');
        }
    };
    
   /**
     * metodo chamado para cada td do GRID, percorre o HTML e colore
     * o field de termômetro.
     * 
     * @param {object} row row do grid a ser percorrida.
     *        {array} elemento jquery representando cada td da row.
    */
    this.setColorOfRowBasedOnPrioridade = function(row, element){
        var color   = row.DSCORPRIORIDADE;
        var fieldsHTML = $(element[0]);
        if(fieldsHTML.attr('data-zh-field-name') === "DSPRIORIDADECLI"){
            //style padrão de fields zeedhi
            fieldsHTML.css({color:color});
        }
    };
    
    /**
     * Abre o popup de transferência e inicia a widget de evolução.
     * 
     * @param {object} widget widget de chamado
    */
    this.transferirChamado = function(widget){
        
        
        var evolWidget = templateManager.container.getWidget('WDGT_EVOLUCAO');
        var transferWidget = templateManager.container.getWidget('WDGT_TRANSFERIR_CHAMADO');
        
        evolWidget.newRow();
        transferWidget.newRow();
        
        if(widget.name === "WDGT_CHAMADO_KANBAN")
            transferWidget.kanban = true;
        
        var parcFilter = transferWidget.getField('NMINTERLOCUTOR').dataSourceFilter;
        var parcFilterValue;
        if(Array.isArray(widget.currentRow)){
            parcFilterValue = [];
            widget.currentRow.forEach(function(ticket){
                parcFilterValue.push(ticket.NRPARCNEGOCIO);
            });
            transferWidget.getField('NMINTERLOCUTOR').dataSourceFilter[CRM_Utilities.getFilterPosition(parcFilter, 'NRPARCNEGOCIO')].value =  parcFilterValue;
            transferWidget.getField('NMINTERLOCUTOR').dataSourceFilter[CRM_Utilities.getFilterPosition(parcFilter, 'NRPARCNEGOCIO')].operator = "IN";
        }else{
            parcFilterValue = widget.currentRow.NRPARCNEGOCIO;
            transferWidget.getField('NMINTERLOCUTOR').dataSourceFilter[CRM_Utilities.getFilterPosition(parcFilter, 'NRPARCNEGOCIO')].value =  parcFilterValue;
            transferWidget.getField('NMINTERLOCUTOR').dataSourceFilter[CRM_Utilities.getFilterPosition(parcFilter, 'NRPARCNEGOCIO')].operator = "=";
        }
        
        ScreenService.openPopup(transferWidget);
        
    };
    
    /**
     * Inicializa os campos necessários para a criação da evolução
     * de transferência, evolui e inicia o procedimento de transferência de
     * operador
     * 
     * @param {object} widget widget de chamado
    */
    this.completeTransferecia = function(widget, kanban){
        
        var ticketWdgt = templateManager.container.getWidget('WDGT_CHAMADO');
        var chamadoCurrentRows = ticketWdgt.currentRow; 
        if(Util.isEmptyOrBlank(Object.keys(chamadoCurrentRows)) || kanban){
            ticketWdgt = templateManager.container.getWidget('WDGT_CHAMADO_KANBAN');
            chamadoCurrentRows = ticketWdgt.currentRow; 
        }
        var evolWidget = templateManager.container.getWidget('WDGT_EVOLUCAO'); 
        
        if(!Array.isArray(chamadoCurrentRows)){
            chamadoCurrentRows = [chamadoCurrentRows];
        }
        
        if(!Array.isArray(evolWidget.currentRow)){
            evolWidget.currentRow = [evolWidget.currentRow];
            chamadoCurrentRows.forEach(function(chamadoCurrentRow, index){
                evolWidget.currentRow[index] = angular.copy(evolWidget.currentRow[0]);
            });
        }
    
        chamadoCurrentRows.forEach(function(chamadoCurrentRow, index, chamadoCurrentRows){
            evolWidget.currentRow[index].CDOPEREVOL = templateManager.LOGGEDOPERATOR.CDOPERADOR;
            evolWidget.currentRow[index].DTHREVOLCONT = CRM_Utilities.getDataHoraAtual();
            evolWidget.currentRow[index].NRCONTATO = evolWidget.currentRow[index].NRSEQCONTATO = chamadoCurrentRow.NRSEQCONTATO;
            evolWidget.currentRow[index].NRORG = templateManager.LOGGEDOPERATOR.NRORG;
            evolWidget.currentRow[index].IDSENEVOCONT = 'E';
            evolWidget.currentRow[index].NRSEQINTERLOCUTOR = widget.currentRow.NRSEQINTERLOCUTOR;
            
            //required fields in evolWidget
            evolWidget.getField('NMTIPOCONT').setValue(widget.currentRow.NMTIPOCONT);
            evolWidget.getField('NMMOTIEVOCON').setValue(widget.currentRow.NMMOTIEVOCON);
            evolWidget.getField('NMSEQRESULEVOL').setValue(widget.currentRow.DESCRESULEVOL);
            
            evolWidget.currentRow[index].CDTIPOCONT = widget.currentRow.CDTIPOCONT;
            evolWidget.currentRow[index].NRSEQRESULEVOL = widget.currentRow.NRSEQRESULEVOL;
            evolWidget.currentRow[index].CDMOTIEVOCON = widget.currentRow.CDMOTIEVOCON;
            evolWidget.currentRow[index].IDTPEVOLCONT = 'P';
            evolWidget.currentRow[index].NRRELACIONAPARC = '';
            evolWidget.currentRow[index].IDANEXOEVOLCONT = 'N';
            evolWidget.currentRow[index].IDGERAFATURA = 'NAO';
            evolWidget.currentRow[index].NRSEQFILACONTA = '';
            
            if(!Util.isEmptyOrBlank(chamadoCurrentRow.CDOPERCONT))
                evolWidget.currentRow[index].TXEVOLCONT = 'Transferência do chamado: '+ chamadoCurrentRow.CDCASO +' do operador: '+ chamadoCurrentRow.NMOPERCONT +' para o operador: '+ widget.currentRow.NMOPERADOR;
            else
                evolWidget.currentRow[index].TXEVOLCONT = 'Transferência do chamado: '+ chamadoCurrentRow.CDCASO +' para o operador: '+ widget.currentRow.NMOPERADOR;
        });
        
        var paramsRestEngine = {
            "requestType": "DataSet",
            "dataset": evolWidget.currentRow
        };
        
        restEngine.post('/evolcont_contato/save', paramsRestEngine).  
            then(function(response){
                if(!Array.isArray(widget.currentRow)){
                    widget.currentRow = [widget.currentRow];
                    chamadoCurrentRows.forEach(function(chamadoCurrentRow, index){
                        widget.currentRow[index] = angular.copy(widget.currentRow[0]);
                    });
                }
                evolWidget.currentRow.forEach(function(row, index){
                    widget.currentRow[index].NRSEQCONTATO = evolWidget.currentRow[index].NRSEQCONTATO;
                    widget.currentRow[index].NRORG = evolWidget.currentRow[index].NRORG;
                    widget.currentRow[index].CDOPEREVOL = evolWidget.currentRow[index].CDOPEREVOL;
                    widget.currentRow[index].DTHREVOLCONT = evolWidget.currentRow[index].DTHREVOLCONT
                });
                this.transfereOperador(widget.currentRow, ticketWdgt.name);
            }.bind(this));    
    };
    
    /**
     * fecha os popups
     * 
     * @param {object} widget widget de chamado
    */
    this.cancelTransferencia = function(widget){
        if(widget.name === "WDGT_MOVE_TICKET"){
            var ticketWdgt = templateManager.container.getWidget('WDGT_CHAMADO_KANBAN');
            this.updateColumns(ticketWdgt);
        }
        ScreenService.closePopup(true);    
    };
    
    /**
     * Transfere o chamado
     * 
     * @param {object} widget widget de chamado
    */
    this.transfereOperador = function(currentRow, widgetName){
        
        var paramsRestEngine = {
            "requestType": "DataSet",
            "dataset": currentRow
        };
        
        restEngine.post('/transfereOperador', paramsRestEngine).  
            then(function(response){
                if(response.dataset){
                    ScreenService.showMessage('Ticket Transferido!');
                    ScreenService.closePopup(true);
                    ScreenService.closeSwipe(true); 
                    templateManager.container.getWidget(widgetName).reload();
                    templateManager.container.getWidget(widgetName).dataSource.clearCheckedRows();
                }
            }.bind(this)).
            catch(function(fail){
                ScreenService.showMessage('Falha ao transferir o Chamado.');
            }.bind(this));
    };
    
    /**
     * Decide se as actions de editar e excluir estarão
     * visíveis(verifica se o chamado está fechado).
     * 
     * @param {object} widget widget de chamado
    */
    this.controlActionsVisibilityByConclusao = function(widget){
        if(!Util.isEmptyOrBlank(widget.currentRow.DTHRCONCCONT)){
            this.setActionsVisibilityByConclusao(widget, false);    
        }else{
            this.setActionsVisibilityByConclusao(widget, true);    
        }
    };
    
    /**
     * Seta a visibilidade das actions recursivamente para 
     * todas as widgets exceto a de conclusão
     * 
     * @param {object} widget widget de chamado
    */
    this.setActionsVisibilityByConclusao = function(widget, visibility){
        if(!Util.isEmptyOrBlank(widget.widgets)){
            widget.widgets.forEach(function(inWidget){
                this.setActionsVisibilityByConclusao(inWidget, visibility);
            }.bind(this));
        }
        if(!widget.preventHide){
            if(widget.actions){
                widget.actions.forEach(function(action){
                    if(!action.preventHide)
                        action.isVisible = visibility;
                });
            }
        }
    };
    
    /**
     * Garantindo o reload da widget após os ave
     * 
     * @param {object} widget widget de chamado
    */
    this.widgetSave = function(widget){
        if(Util.isEmptyOrBlank(widget.currentRow.CDOPERCONT))
            widget.currentRow.CDOPERCONT = templateManager.LOGGEDOPERATOR.CDOPERADOR;
        if(widget.currentRow.IDPERMITECONCLUSAO === 'S'){
            widget.currentRow.DTHRCONCCONT = CRM_Utilities.getDataHoraAtual();
        }
        if(widget.name === "WDGT_CHAMADO_KANBAN"){
            delete widget.currentRow.resources;
            delete widget.currentRow.FROMCOLUMN;
            delete widget.currentRow.TOCOLUMN;
            General.widgetSave(widget).then(function(response){
                widget.childTemplate = "widget/form-view.html";
                widget.reload().then(function(response){
                    this.defaultFilters(widget);
                    this.controlActionsVisibilityByConclusao(widget);
                    this.setSituacaoOnKanbanColumns(widget);
                    this.setPeopleOnCurrentRow(widget);
                }.bind(this));
            }.bind(this));
            
        }else{
            CRM_Utilities.setColumnToReturnInCurrentRow(widget.currentRow, "DTULTATU");
            General.widgetSave(widget).then(function(response){
                widget.reload().then(function(){
                    widget.currentRow.DTULTATU = response.dataset.columnsToReturn.DTULTATU;
                    this.setPeopleOnCurrentRow(widget);
                }.bind(this));
            }.bind(this));    
        }
    };
    
    
    
    /**
     * Seta os filtros padrões
     * 
     * @param {object} widget widget de chamado
    */
    this.defaultFilters = function(widget){
        var filter = widget.__filterPopup;
        if(filter){
            filter.currentRow.CDOPERCONT = [templateManager.LOGGEDOPERATOR.CDOPERADOR];
            filter.currentRow.NMOPERCONT = [templateManager.LOGGEDOPERATOR.NMOPERADOR];
            filter.getField('CDOPERCONT').show();
        }
    };
    
    this.setVisibilityFieldsComunica = function(widget){
        if(!widget.currentRow.__is_new){
            widget.getField('DSCAMINHO').isVisible = false;
            //widget.getField('TELEFONE').isVisible = false;
            //widget.getField('EMAIL').isVisible = false;
        }else if(widget.currentRow.__is_new){
            widget.getField('DSCAMINHO').isVisible = true;
            //widget.getField('TELEFONE').isVisible = true;
            //widget.getField('EMAIL').isVisible = true;
        }
    };
    
    
    /**
     * Função para abrir a widget de seleção
     * de arquivos.
    */
    this.openAttachSwipe = function(){
        
        var fileUploadWidget = templateManager.container.getWidget('WDGT_SELECAO_ARQUIVOS_CHAMADO');
        
        fileUploadWidget.isVisible = true;
        ScreenService.openSwipe(fileUploadWidget);
            
    };
    
    this.nullFilter  = function(widget, nullFieldName, fieldName, widName){
        var fieldNull = widget.getField(nullFieldName);
        var field = widget.getField(fieldName);
        
        if(fieldNull.value() === "IS_NULL"){
            field.clearValue();
            field.readOnly = true;
        }else{
            field.clearValue();
            field.readOnly = false;
            if(fieldName === 'CDOPERCONT')
                this.defaultFilters(templateManager.container.getWidget(widName));
        }
    };
    
    this.buildFilter = function(widget){
        var dataSourceFilter = widget.dataSourceFilter;
        var indexResp, newFilter;
        var filters;
        
        dataSourceFilter.forEach(function(filter, index, dataSourceFilter){
            if(filter.name === "RESPNULL"){
                newFilter = {
                    "name":"CDOPERCONT",
                    "static":true,
                    "operator":filter.value
                };
                if(filter.value === "IS_NULL")
                    filters = dataSourceFilter.filter(function(f){return f.name !== "CDOPERCONT" && f.name !== "RESPNULL"});
                else
                    filters = dataSourceFilter.filter(function(f){return f.name !== "RESPNULL"});    
                    
                filters.push(newFilter);
            }
            if(filter.name === "IDNOMETAG"){
                if(Array.isArray(filter.value)){
                    filter.value = filter.value.join(',');
                    filter.value = ','+filter.value+',';
                }
            }
            if(filter.name === "NRPARCNEGOCIORELAC"){
                if(Array.isArray(filter.value)){
                    filter.value = filter.value.join(',');
                    filter.value = ','+filter.value+',';
                }
            }
        });
        if(filters)
            widget.dataSourceFilter = filters;
        this.filterClieNull(widget);
    };
    
    this.filterClieNull = function(widget){
        var dataSourceFilter = widget.dataSourceFilter;
        var newFilter;
        var filters;
        
        dataSourceFilter.forEach(function(filter, index, dataSourceFilter){
            if(filter.name === "CLIENULL"){
                newFilter = {
                    "name":"NRPARCNEGOCIO",
                    "static":true,
                    "operator":filter.value
                };
                if(filter.value === "IS_NULL")
                    filters = dataSourceFilter.filter(function(f){return f.name !== "NRPARCNEGOCIO" && f.name !== "CLIENULL"});
                else
                    filters = dataSourceFilter.filter(function(f){return f.name !== "CLIENULL"});    
                    
                filters.push(newFilter);
            }
        });
        if(filters)
            widget.dataSourceFilter = filters;
    };
            
    
    /**
     * Muda o readonly do campo Sistema baseado
     * no campo 'Classificação'.
     * 
     * @param {object} widget widget de chamado
     * Desativado 17/01/18 - Mudanças na rotina de produto
    */
    /**
    this.setReadOnlySistema = function(widget, keepValue){
        var currentRow = widget.currentRow;
        var fieldSistema = widget.getField('NMSISTEMA');
        
        if(widget.name === "filterPopup")
        fieldSistema = widget.getField('CDSISTEMA')
        
        if(!Util.isEmptyOrBlank(currentRow.NRCLASSIFICACAOCASO)){
            if(fieldSistema){
                fieldSistema.readOnly = false;    
                if(!keepValue)
                    fieldSistema.clearValue();
            }
        }else{
            if(fieldSistema){
                fieldSistema.readOnly = true;    
                fieldSistema.clearValue();
            }    
        }
      
      this.setFilterSistema(widget);
    };
    this.setFilterSistema = function(widget){
        var currentRow = widget.currentRow;  
        var fieldSistema = widget.getField('NMSISTEMA');

        if(widget.name === "filterPopup")
            fieldSistema = widget.getField('CDSISTEMA')
        
        if(fieldSistema){
            var filterSistema = fieldSistema.dataSourceFilter;
            filterSistema[2].value = currentRow.NRCLASSIFICACAOCASO;
        }
        
        this.setReadOnlyCDLOTEandMOTICONT(widget, true);
        
    };
    */
    
    /**
     *  Desabilita o clique em níveis menores que o máximo
     *  do select tree/grid e muda a label do field,
     *  adicionando a hierarquia da árvore selecionada.
    */
    this.getBreadcrumbForProdField = function(args, widgetName){
        
        var parentWidget       = templateManager.container.getWidget(widgetName);
        var parentWidgetFilter = parentWidget.__filterPopup ? parentWidget.__filterPopup : false;
            
        var currentRow   = parentWidget.currentRow;
        if(parentWidgetFilter)
            var currentRowFilter   = parentWidgetFilter.currentRow;
        
        if(args.row.TIPO !== "P"){
            ScreenService.openPopup(args.owner);
        }else{
            
            this.setProdInCurrentRow(currentRow, args);
            
            if(parentWidgetFilter)
                this.setProdInCurrentRow(currentRowFilter, args);
            
            if(widgetName === 'WDGT_CHAMADO' || widgetName === 'WDGT_ABERTURA_CHAMADO' || widgetName === 'WDGT_CHAMADO_KANBAN'){
                this.setFilterCDLOTEandMOTICONT(parentWidget);
                
                var fieldMoti = parentWidget.getField('NMMOTICONT');
                if(fieldMoti)
                    fieldMoti.readOnly = false;
                    
                var fieldLote = parentWidget.getField('NRLOTEESTQ');     
                if(fieldLote)    
                    parentWidget.getField('NRLOTEESTQ').readOnly = false;
                
                if(parentWidgetFilter){
                    var fieldMoti = parentWidgetFilter.getField('CDMOTICONT');
                    if(fieldMoti)
                        fieldMoti.readOnly = false;
                        
                    var fieldLote = parentWidgetFilter.getField('NRLOTEESTQ');     
                    if(fieldLote)    
                        fieldLote.readOnly = false;
                    
                }
            }
            
        }
    };
    
    //Seta os dados do produto na currentRow, com breadcrumb
    this.setProdInCurrentRow = function(currentRow, args){
        currentRow.NMPRODUTO    = args.row._breadcrumb.replace(new RegExp(' > ', 'g'), ' -- ') + ' -- ' + args.row.NAME;
        currentRow.CDPRODUTO    = args.row.ID;
        currentRow.NRTPARVPROD  = args.row.NRTPARVPROD;
        currentRow.NRARVOREPROD = this.findNrArvoreProd(args.dataSource, args.dataSource.indexOf(args.row));
    };
    
    /**
     * Métodos para encontrar a estrutura da árvore
     * em que o produto escolhido se encontra
     * 
     * 17/01/18 - Arthur Melo
    *
    *   Encontra e retorna o index do produto passado no array de produtos e níveis de árvore
    */
    this.findParentOnArray = function(rows, element){
        var index = rows.find(function(e, i, a){
            if(e.ID === element.PARENT && e.NRTPARVPROD === element.NRTPARVPROD) 
                return e;
        }.bind(this));
        return rows.indexOf(index);
    }
    /*
    *   Encontra o NRARVOREPROD do menor nível na estrutura da árvore do produto
    */
    this.findNrArvoreProd = function(rows, chosenIndex){
        if(parseInt(rows[chosenIndex].PARENT) === parseInt(rows[chosenIndex].NRTPARVPROD))    
            return rows[chosenIndex].ID.replace(rows[chosenIndex].NRTPARVPROD.toString(), '');
        else
            return this.findNrArvoreProd(rows, this.findParentOnArray(rows, rows[chosenIndex]));
    };
    
    /**
     * Métodos para encontrar abrir a árvore
     * do produto que está selecionado
     * 
     * 18/01/18 - Arthur Melo
    *
    *   Encontra o produto na árvore e abre sua árvore
    */
    this.findProdcutAndOpenTree = function(args, row){
        var rows = args.dataSource;
        
        if(!Util.isEmptyOrBlank(row.CDPRODUTO) && !Util.isEmptyOrBlank(rows)){
            
            var parent = row.NRTPARVPROD;
            var id = row.CDPRODUTO;
            
            var product = rows.find(function(e, i, a){
                if(e.ID == id && e.NRTPARVPROD == parent)
                    return e;
            });
            
            this.openTree(rows, product, id);
            
            templateManager.container.getActiveWidget().dataSource.data = rows;
        }
        /*Gambs pra conseguir filtrar o tree grid*/
        args.owner.dataSource.data = Util.isEmptyOrBlank(args.owner.plainTreeData) ? args.owner.dataSource.data : args.owner.plainTreeData;
    };
    /*
    *   Abre todos os parents d produto
    */
    this.openTree = function(rows, product, cdproduto){
        if(product.ID != cdproduto)
            product._opened = true;
            
        if(product.PARENT !== null){
            this.openTree(rows, rows[this.findParentOnArray(rows, product)]);
        }
        
        return;
    };
    
    /*
    *   Cria o filtro de tipo de árvore, quando
    *   o produto é selecionado
    */
    this.filterByTree = function(widget){
        var dataSourceFilter = widget.dataSourceFilter;
        var newFilter, productFiltered = false;
        
        dataSourceFilter.forEach(function(filter, index, dataSourceFilter){
            if(filter.name === "CDPRODUTO"){
                newFilter = {
                    "name":"NRTPARVPROD",
                    "static":true,
                    "operator":'=',
                    "value":widget.__filterPopup.currentRow.NRTPARVPROD
                };
                
                dataSourceFilter.push(newFilter);
                
                productFiltered = true;
            } 
        });
        
        if(!productFiltered){
            dataSourceFilter.find(function(e, i, a){
                if(e.name === "NRTPARVPROD")
                    a.splice(i, 1);
            });   
        }
    };
    /**
     * Fim
    */
    
    this.testImap = function(widget){
        restEngine.post('product#/insertTicketsInMail', {});
    };
    
    this.changeAnalistaReadOnly = function(widget){
        var analistaField = widget.getField('NMOPERCONT');
        if(Util.isEmptyOrBlank(widget.currentRow.CDOPERCONT)){
            analistaField.readOnly = false;
        }else{
            analistaField.readOnly = true;
        }
    }
    
    /**
     * KANBAN 
    */
    
    this.setSituacaoOnKanbanColumns = function(widget, reload){
        var paramsRestEngine = {
            "requestType": "FilterData",
            filter:[
                {
                    name:"NRORG",
                    operator:"IN",
                    value:[getLocalVar('CRM_NRORG'), getLocalVar('CRM_NRORGPADRAO')]
                }
            ]
        };
        if(Util.isEmptyOrBlank(widget.columns)){
            restEngine.post('product#/crud/crm_situacao', paramsRestEngine).
                then(function(response){
                    widget.columns = [];
                    response.dataset.crm_situacao.forEach(function(situacao){
                        if(situacao.IDEXIBEKANBAN === 'S' && situacao.IDATIVO === 'S'){
                            widget.columns.push({
                                id:situacao.NRSEQSITUACAO,
                                order:situacao.NRORDEM,
                                idpermiteconclusao:situacao.IDPERMITECONCLUSAO,
                                movable:situacao.IDPERMITECONCLUSAO === 'N' ? true : false, 
                                label:situacao.DSSITUACAOCLI
                            });
                        }
                    });
                    this.updateColumns(widget);
                }.bind(this));
        }else{
            this.updateColumns(widget);
        }
    };
    
    this.updateColumns = function(widget){
        widget.dataSource.data.forEach(function(ticket){
            ticket.column = ticket.NRSEQSITUACAO;   
            ticket.resources = [{
                photo: ticket.OPERCONTFOTO,
                name:  ticket.NMOPERCONT ? ticket.NMOPERCONT : 'Sem Analista.'
            }];
            var column = widget.columns.find(function(column) {if(column.id === ticket.column) return column});
            ticket.movable =  column.movable;
        });
        this.rebuildKanban(widget);
    };
    
    this.setColorRibbon = function(row, element){
        var color    = row['DSCORPRIORIDADE'];
        var cssClass = row['DSPRIORIDADE']; 
        element.addClass(cssClass);
        $('.'+cssClass+' .kanban-ticket-ribbon').css({
          'background-color': color
        })
        $('.'+cssClass+' .kanban-ticket-ribbon .before').css({
          'border-color': color+' transparent transparent'
        })
        $('.'+cssClass+' .kanban-ticket-ribbon .after').css({
          'border-color': 'transparent ' +color+ ' transparent transparent'
        })
    };
    
    this.fixContainerSize = function(){
        var widget = templateManager.container.getWidget('WDGT_CHAMADO_KANBAN');
        //Conserta tamanho do container de acordo com a quantidade de colunas (O tamanho da task do kanban foi alterado)
        $('.zh-kanban-column-container').width(332*widget.columns.length);
    };
    
    this.findColumnById = function(columns, id){
        return columns.find(function(column, index, columns){
            if(parseInt(column.id) === parseInt(id))
                return column;
        });
    };
    
    /**
     * Abre o popup de mudança de status e inicia a widget de evolução.
     * 
     * @param {object} widget widget de chamado
    */
    this.ticketStatusChange = function(widget, e){
        
        var evolWidget = templateManager.container.getWidget('WDGT_EVOLUCAO');
        var moveWidget = templateManager.container.getWidget('WDGT_MOVE_TICKET');
        
        evolWidget.newRow();
        moveWidget.newRow();
        
        moveWidget.currentRow = e.item;
        moveWidget.currentRow.FROMCOLUMN = this.findColumnById(widget.columns, e.columns.from);
        moveWidget.currentRow.TOCOLUMN = this.findColumnById(widget.columns, e.columns.to);
        moveWidget.label = 'Mudança de Status - De: '+moveWidget.currentRow.FROMCOLUMN.label+' Para: '+moveWidget.currentRow.TOCOLUMN.label;
        moveWidget.currentRow.TXEVOLCONT = 'Mudança de Status do Ticket: '+ moveWidget.currentRow.CDCASO +'\nDe: '+ moveWidget.currentRow.FROMCOLUMN.label +' \nPara : '+ moveWidget.currentRow.TOCOLUMN.label;
        var parcFilter = moveWidget.getField('NMINTERLOCUTOR').dataSourceFilter;
        moveWidget.getField('NMINTERLOCUTOR').dataSourceFilter[CRM_Utilities.getFilterPosition(parcFilter, 'NRPARCNEGOCIO')].value =  e.item.NRPARCNEGOCIO;
        ScreenService.openPopup(moveWidget);
        
    };
    
    this.ticketBeforeMove = function(widget, args){
        if(args.e.columns.to !== "1" && args.e.columns.from !== args.e.columns.to){
            widget.currentRow = args.e.item;
            if(!widget.isValid()){
                ScreenService.showMessage(Messages.IMPOSSIVEL_MANUSEAR_EVENTO('Favor Completar o Ticket com as Informações Básicas'));
                return false;
            }
            this.ticketStatusChange(widget, args.e);    
        }else{
            if(args.e.columns.from !== "1" && args.e.columns.from !== args.e.columns.to)
                ScreenService.showMessage(Messages.IMPOSSIVEL_MANUSEAR_EVENTO("Não é possível voltar um ticket para a situação 'Aberto'"));
            return false;
        }
    };
    
    /**
     * Inicializa os campos necessários para a criação da evolução
     * de mudança de status e evolui.
     * 
     * @param {object} widget widget de ticket
    */
    this.completeStatusChange = function(widget){
        
        var ticketCurrentRow = templateManager.container.getWidget('WDGT_MOVE_TICKET').currentRow; 
        var evolWidget = templateManager.container.getWidget('WDGT_EVOLUCAO'); 
        
        evolWidget.currentRow.CDOPEREVOL = templateManager.LOGGEDOPERATOR.CDOPERADOR;
        evolWidget.currentRow.DTHREVOLCONT = CRM_Utilities.getDataHoraAtual();
        evolWidget.currentRow.NRCONTATO = evolWidget.currentRow.NRSEQCONTATO = ticketCurrentRow.NRSEQCONTATO;
        evolWidget.currentRow.NRORG = templateManager.LOGGEDOPERATOR.NRORG;
        evolWidget.currentRow.IDSENEVOCONT = 'E';
        
        //required fields in evolWidget
        evolWidget.getField('NMTIPOCONT').setValue(widget.currentRow.NMTIPOCONT);
        evolWidget.getField('NMMOTIEVOCON').setValue(widget.currentRow.NMMOTIEVOCON);
        evolWidget.getField('NMSEQRESULEVOL').setValue(widget.currentRow.DESCRESULEVOL);
        
        evolWidget.currentRow.CDTIPOCONT = widget.currentRow.CDTIPOCONT;
        evolWidget.currentRow.NRSEQRESULEVOL = widget.currentRow.NRSEQRESULEVOL;
        evolWidget.currentRow.CDMOTIEVOCON = widget.currentRow.CDMOTIEVOCON;
        evolWidget.currentRow.IDTPEVOLCONT = 'P';
        evolWidget.currentRow.NRRELACIONAPARC = '';
        evolWidget.currentRow.IDANEXOEVOLCONT = 'N';
        evolWidget.currentRow.IDGERAFATURA = 'NAO';
        evolWidget.currentRow.NRSEQFILACONTA = '';
        evolWidget.currentRow.TXEVOLCONT = ticketCurrentRow.TXEVOLCONT;
        evolWidget.currentRow.NRSEQINTERLOCUTOR = ticketCurrentRow.NRSEQINTERLOCUTOR;
        
        General.widgetSave(evolWidget).
            then(function(response){
                widget.currentRow.NRSEQCONTATO = evolWidget.currentRow.NRSEQCONTATO;
                widget.currentRow.NRORG = evolWidget.currentRow.NRORG;
                widget.currentRow.CDOPEREVOL = evolWidget.currentRow.CDOPEREVOL;
                widget.currentRow.DTHREVOLCONT = evolWidget.currentRow.DTHREVOLCONT;
                
                var ticketWdgt = templateManager.container.getWidget('WDGT_CHAMADO_KANBAN');
                ticketWdgt.currentRow = ticketCurrentRow;
                ticketWdgt.currentRow.NRSEQSITUACAO = ticketWdgt.currentRow.TOCOLUMN.id;
                if(Util.isEmptyOrBlank(ticketWdgt.currentRow.CDOPERCONT))
                    ticketWdgt.currentRow.CDOPERCONT = templateManager.LOGGEDOPERATOR.CDOPERADOR;
                if(ticketWdgt.currentRow.TOCOLUMN.idpermiteconclusao === 'S'){
                    ticketWdgt.currentRow.DTHRCONCCONT = CRM_Utilities.getDataHoraAtual();
                    this.beforeConcStatus(evolWidget.currentRow.NRSEQRESULEVOL, evolWidget.currentRow.TXEVOLCONT);
                }
                delete ticketWdgt.currentRow.resources;
                delete ticketWdgt.currentRow.FROMCOLUMN;
                delete ticketWdgt.currentRow.TOCOLUMN;
                General.widgetSave(ticketWdgt).then(function(){
                    ScreenService.closePopup(true);
                    ticketWdgt.mode = "list";
                    ticketWdgt.activate();
                    this.setSituacaoOnKanbanColumns(ticketWdgt);
                }.bind(this));
            }.bind(this)).catch(function(){
                var ticketWdgt = templateManager.container.getWidget('WDGT_CHAMADO_KANBAN');
                this.setSituacaoOnKanbanColumns(ticketWdgt);
            }.bind(this));    
    };
    
    this.beforeConcStatus = function(result, desc){
        var widConc = templateManager.container.getWidget('WDGT_CONCLUSAO_CHAMADO');
        widConc.currentRow = {
            CDOPERCONCLUSAO: templateManager.LOGGEDOPERATOR.CDOPERADOR,
            NMOPERCONCLUSAO: templateManager.LOGGEDOPERATOR.NMOPERADOR,
            CONCLUSAOCHAMADO: true,
            DTCONCLUSAO: CRM_Utilities.getDataHoraAtual(),
            NRORG: templateManager.LOGGEDOPERATOR.NRORG,
            NRSEQCONTATO: widConc.parent.parent.currentRow.NRSEQCONTATO,
            DESCCONCLUSAO: 'Chamado Concluido!\n'+ desc,
            IDATIVO:'S',
            NRSEQRESULTEVOL:result,
            __is_new: true,
            KANBAN: true
        };
        this.saveConclusao(widConc);
    };
    
    this.setTagsOnCurrentRow = function(widget, parcOrTicket){
        var currentRow = widget.currentRow;
        var code;
        if(parcOrTicket === 'PARCNEGOCIO'){
            code = currentRow.NRPARCNEGOCIO;
        }else if(parcOrTicket === 'CONTATO'){
            code = currentRow.NRSEQCONTATO
        }
        this.getTags(code, parcOrTicket).then(function(response){
            if(!Util.isEmptyOrBlank(response)){
                widget.currentRow.IDNOMETAG = [];
                widget.currentRow.DSNOMETAG = [];
                response.forEach(function(tag){
                    widget.currentRow.IDNOMETAG.push(tag.IDNOMETAG);
                    widget.currentRow.DSNOMETAG.push(tag.DSNOMETAG);
                });
                widget.getField('IDNOMETAG').show();
            }
        }.bind(this));
    };
    
    this.getTags = function(code, parcOrTicket){
        var column
        if(parcOrTicket === 'PARCNEGOCIO'){
            column = "NRPARCNEGOCIO";
        }else if(parcOrTicket === 'CONTATO'){
            column = "NRSEQCONTATO"
        }
        var filter = [
            {
                "name": column,
                "operator": "=",
                "value": code
            }
        ];
        return localStorageEngine.download("product#/crud/crm_tag_"+parcOrTicket.toLowerCase(), filter);
    };
    
    this.setPeopleOnCurrentRow = function(widget){
        var currentRow = widget.currentRow;
        this.getPeople(currentRow.NRSEQCONTATO).then(function(response){
            if(!Util.isEmptyOrBlank(response)){
                widget.currentRow.NRPARCNEGOCIORELAC = [];
                widget.currentRow.NMPARCNEGOCIORELAC = [];
                response.forEach(function(person){
                    widget.currentRow.NRPARCNEGOCIORELAC.push(person.NRPARCNEGOCIO);
                    widget.currentRow.NMPARCNEGOCIORELAC.push(person.NMPRINCIPALPARC);
                });
                widget.getField('NRPARCNEGOCIORELAC').show();
            }
        }.bind(this));
    };
    
    this.getPeople = function(code){
        var filter = [
            {
                "name": 'NRSEQCONTATO',
                "operator": "=",
                "value": code
            }
        ];
        return localStorageEngine.download("product#/crud/crm_parcrelaccontato", filter);
    };
    
    this.ticketOnClick= function(args, e){
        var currentRow = e.item;
        var widget = templateManager.container.getWidget('WDGT_CHAMADO_KANBAN');
        widget.currentRow = currentRow;
        ScreenService.openSwipe(widget).then(function(){
            this.setTagsOnCurrentRow(widget, 'CONTATO');
            this.setPeopleOnCurrentRow(widget);
            widget.templateToForm = "widget/master_detail/tabbedWidget.html";
            widget.templateToView = "widget/master_detail/tabbedWidget.html";
            widget.childTemplate = "widget/form-view.html";
            widget.computeDescriptionOrder();
            $('.swipe-parent-description').empty().append(widget.descriptionOrder);
            widget.view();
            widget.activate();
            this.controlActionsVisibilityByConclusao(widget);
            this.changeAnalistaReadOnly(widget);
        }.bind(this));
    };
    
    this.widgetCancelForm = function(widget){
        widget.childTemplate = "widget/form-view.html";
        General.widgetCancelForm(widget);
    };
    
    this.widgetEdit = function(widget){
        widget.childTemplate = "widget/form.html";
        General.widgetEdit(widget);
    };
    
    this.kanbanNewRow = function(widget){
        ScreenService.openSwipe(widget).then(function(){
            widget.templateToForm = "widget/master_detail/tabbedWidget.html";
            widget.templateToView = "widget/master_detail/tabbedWidget.html";
            widget.childTemplate = "widget/form.html";
            this.widgetNewRow(widget);
            this.controlActionsVisibilityByConclusao(widget);
        }.bind(this));    
    };
    
    this.buildRowsTransferir = function(widget){
        var tickets = widget.getCheckedRows();
        widget.currentRow = tickets;
        this.transferirChamado(widget);
    }
    
    this.rebuildKanban = function (widget) {
		if (widget.dataSource.data) {
			widget.columns.forEach(function(column) {
				column.items = widget.dataSource.data.filter(function(row) {
					return row.column == column.id;
				});
			});
		}
		//Espera o resize acabar e muda o tamanho do container
		var resizeTimer;
        $(window).on('resize', function(e) {
            clearTimeout(resizeTimer);
            resizeTimer = setTimeout(function() {
                this.fixContainerSize(widget);
            }.bind(this), 500);
        }.bind(this));
        
        $(window).resize();
	}
    
    this.openPopupNovaTag = function(widget){
        var wdgtTag = templateManager.container.getWidget('WDGT_NOVA_TAG');
        wdgtTag.newRow();
        wdgtTag.NAMEWDGT = widget
        ScreenService.openPopup(wdgtTag);
    }
    
    this.saveNovaTag = function(widget, widgetName){
        if(!widgetName)
            widgetName = widget.NAMEWDGT;
        var widPrincipal = templateManager.container.getWidget(widgetName);
        widget.currentRow.__using_unit =  false;
		widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
		widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
		widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
		widget.currentRow.__cast_number = false;
		widget.currentRow.__columns_to_return = widget.paramsNewCode.__columns_to_return;
		widget.saveRow().then(function(response){
		    ScreenService.closePopup();
		    if(!widPrincipal.currentRow.IDNOMETAG){
		        widPrincipal.currentRow.IDNOMETAG = [];
		        widPrincipal.currentRow.DSNOMETAG = [];
		    }
		    widPrincipal.currentRow.IDNOMETAG.push(response.dataset.columnsToReturn[0].IDNOMETAG);
		    widPrincipal.currentRow.DSNOMETAG.push(response.dataset.columnsToReturn[0].DSNOMETAG);
		    widPrincipal.getField('IDNOMETAG').show();
		    var selectWdgt = templateManager.container.getActiveWidget();
		    selectWdgt.clearSearchCriteria();
		    selectWdgt.reload().then(function(){
		       var novaTag = selectWdgt.dataSource.data.filter(function(tag){if(tag.IDNOMETAG === parseInt(response.dataset.columnsToReturn[0].IDNOMETAG)) return tag}); 
		       novaTag[0].__isSelected = true;
		       selectWdgt.updateCheckedRows();
		    });
		}).catch(function(err) {
		    ScreenService.showMessage(err.data.error);
		});
    };
    
    this.addInterlocutor = function(widget){
        if(Util.isEmptyOrBlank(widget.currentRow.NRPARCNEGOCIO)){
            ScreenService.showMessage(Messages.IMPOSSIVEL_MANUSEAR_EVENTO('Favor selecionar um cliente para cadastrar um novo interlocutor.')).then(function(){
                widget.currentRow.NRPARCINTERLOCUTOR = '';
                widget.currentRow.NMPARCINTERLOCUTOR = '';
                widget.currentRow.EMAIL = '';
                ScreenService.closePopup();
                setTimeout(function(){
                    $('.zh-field-NMPARCNEGOCIO').click();
                    widget.CREATINGINTERLOC = true;
                },4);
            });
        }else{
            var wdgtInter = templateManager.container.getWidget('WDGT_NOVO_INTERLOC');
            wdgtInter.newRow();
            wdgtInter.currentRow.NRPARCNEGOCIO = widget.currentRow.NRPARCNEGOCIO;
            ScreenService.openPopup(wdgtInter);
        }
    };
    
    this.afterSelectClient = function(widget){
        var tckWdgt = templateManager.container.getWidget('WDGT_CHAMADO');
        var kanWdgt = templateManager.container.getWidget('WDGT_CHAMADO_KANBAN');
        var mainWdgt = Util.isEmptyOrBlank(tckWdgt.currentRow.NRPARCNEGOCIO) ? kanWdgt : tckWdgt; 
        if(mainWdgt.CREATINGINTERLOC){
            setTimeout(function(){
                var wdgtInter = templateManager.container.getWidget('WDGT_NOVO_INTERLOC');
                wdgtInter.newRow();
                wdgtInter.currentRow.NRPARCNEGOCIO = mainWdgt.currentRow.NRPARCNEGOCIO;
                ScreenService.openPopup(wdgtInter);
                mainWdgt.CREATINGINTERLOC = false;
            },4);    
        }
    };
    
    this.saveInterlocutor = function(widget){
        var tckWdgt = templateManager.container.getWidget('WDGT_CHAMADO');
        var kanWdgt = templateManager.container.getWidget('WDGT_CHAMADO_KANBAN');
        var mainWdgt = Util.isEmptyOrBlank(tckWdgt.currentRow.NRPARCNEGOCIO) ? kanWdgt : tckWdgt; 
        
        var paramsRestEngine = {
            "requestType": "Row",
            "row": widget.currentRow
        };
        widget.currentRow.NRCPFINTERLOC = widget.currentRow.NRCPFINTERLOC.replace(/[^0-9]/g, '');
        restEngine.post('/createInterloc', paramsRestEngine).then(function(response){
            if(response.dataset.INTERLOCUTOR){
                
                ScreenService.showMessage('Interlocutor criado com sucesso.');
                ScreenService.closePopup();
                
                mainWdgt.currentRow.NRPARCINTERLOCUTOR = response.dataset.INTERLOCUTOR.NRPARCNEGOCIO;
                mainWdgt.currentRow.NMPARCINTERLOCUTOR = response.dataset.INTERLOCUTOR.NMINTERLOCUTOR;
                mainWdgt.currentRow.EMAIL              = response.dataset.INTERLOCUTOR.EMAILINTERLOC;
                
            }else{
                ScreenService.showMessage('Falha ao Criar o Interlocutor.');    
            }
        }).
        catch(function(fail){
            ScreenService.showMessage('Falha ao Criar o Interlocutor.');
        }.bind(this));    
    };
    
    /**
     * Cancela o chamado
     * 
     * @param {object} widget widget de chamado
    */
    this.cancelarTicket = function(widget){
        var paramsRestEngine = {
            "requestType": "DataSet",
            "dataset": [widget.currentRow]
        };
        
        restEngine.post('/cancelTicket', paramsRestEngine).  
            then(function(response){
                if(response.dataset){
                    ScreenService.showMessage('Ticket Cancelado!');
                    ScreenService.closePopup(true);
                    ScreenService.closeSwipe().then(function(responsea){
                        widget.reload();
                        if(widget.name === "WDGT_CHAMADO_KANBAN")
                            this.setSituacaoOnKanbanColumns(widget);
                    }.bind(this));
                }
            }.bind(this)).
            catch(function(fail){
                ScreenService.showMessage('Falha ao Cancelar o Ticket.');
            }.bind(this));
    };
    
    /**
     * Corrige erro de paginação nos fiedls tipo select
    */
    this.setPaginationTreeGrid = function(field){
        field.hasPagination = false;    
    };
    
    this.loadwidgettree = function(args){
        console.log(args);
    }
}
Configuration(function(ContextRegister){
    ContextRegister.register('ChamadoController', ChamadoController);
});

// FILE: ./assets/js/controllers/ClassificacaoParceiroController.js
function ClassificacaoParceiroController(templateManager, ScreenService, Utilities, restEngine, General){
    this.setClassParc = function(args) {
        var widget = args;
        if (widget.isValid()) {
            widget.currentRow.NRORG = getLocalVar('CRM_NRORG') ? getLocalVar('CRM_NRORG') : " ";
            
            return General.saveCrud(widget).then(function(response){
                widget.reload();
            });
           
        }
    };
}
Configuration(function(ContextRegister){
    ContextRegister.register('ClassificacaoParceiroController', ClassificacaoParceiroController);
});

// FILE: ./assets/js/controllers/ClassificacaoTicketController.js
function ClassificacaoTicketController(ScreenService, restEngine, General, CRM_Utilities){
    
    this.saveProduto = function(widget){
        
        var currentRow = widget.currentRow;
        
        var produtos = currentRow.PRODUTOS;
        var rows = [];
        
        produtos.forEach(function(result, index){
            
            rows.push(this.setProdutoValuesInCurrentRow(widget, index));
                
        }.bind(this)); 
        
        General.callRestEngine("product#/sistema_classificacao/save", "DataSet", rows).then(function(response){
            widget.reload().then(function(){
                ScreenService.closeSwipe(true);
            });
        }.bind(this));
    };
    
    this.setProdutoValuesInCurrentRow = function(widget, index){
        
        var currentRow = angular.copy(widget.currentRow);
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.__is_new = true;
        currentRow.NRCLASSIFICACAOCASO = widget.parent.parent.currentRow.NRCLASSIFICACAOCASO;
        currentRow.CDSISTEMA = currentRow.PRODUTOS[index];
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        
        return currentRow;
        
    };
    
    
	
}
Configuration(function(ContextRegister){    ContextRegister.register('ClassificacaoTicketController', ClassificacaoTicketController);
});

// FILE: ./assets/js/controllers/Crm_31000_Agenda_de_Tarefas_Controller.js
function Crm_31000_Agenda_de_Tarefas_Controller(ScreenService, templateManager, Utilities, restEngine, fileRepository, localStorageEngine, CRM_Utilities, General, Messages, ZHPromise, ABEvolucaoController, evolutionTabController) { // zhFilterPreferences removido
    var self = this;
    var backupTipo = '';
    
    self.setFiltrosIniciais = function(widget) {

        var filter = {};
        filter.name = "STATUS_PRINCIPAL";
        filter.operator = "IN";
        filter.value = ['ATRASADA', 'HOJE'];
        widget.dataSourceFilter.push(filter);
        widget.reload();

    };

    self.clearInitialFilters = function(widget) {
        widget.dataSourceFilter.forEach(function(filter, index, dataSourceFilter) {
            if (filter.name === "STATUS_PRINCIPAL") {
                dataSourceFilter.splice(index, 1);
            }
        });
    };

    self.setFilterOperator = function(fieldOperator) {
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        fieldOperator.dataSourceFilter.forEach(function(filter) {
            if (filter.name === "P_NRORG") {
                filter.value = loggedOperatorInfos.NRORG;
            }
            if (filter.name === "P_NRPARCNEGOCIO") {
                filter.value = loggedOperatorInfos.NRPARCNEGOCIO;
            }
        });

    };

    self.taskSchedule = function(widget) {
        General.widgetNewRow(widget);
        self.activateField(widget, "DESCRICAO", "TIPO", "NMINTERLOCUTOR");

        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        widget.currentRow.IDATIVO = 'S';

        widget.currentRow.NMOPERREAL = loggedOperatorInfos.NMOPERADOR;
        widget.currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
        // widget.currentRow.NRPRIORFILACONT = 2;
        widget.currentRow.DTPLANFILACONTA = (widget.currentRow.DTPLANFILACONTA) ? widget.currentRow.DTPLANFILACONTA : moment(new Date()).format('DD/MM/YYYY HH:mm');

        widget.currentRow.NRCONTATO = null;
        widget.currentRow.NRSEQCONTATO = null;
        widget.currentRow.DSEMAILTAREFA = '';
        widget.currentRow.DSFILACONTATO = null;
        widget.currentRow.NRCOMUNICAPARC = null;
        widget.currentRow.DSDETEFILACONTA = '';
        widget.currentRow.DTVENCFILACONTA = null;
        widget.currentRow.NRRELACIONAPARC = null;
        widget.currentRow.DTREALFILACONTA = null;
        widget.currentRow.DSTELEFONETAREFA = '';
        widget.currentRow.NRSEQCLASSIFICATAREFA = null;
        widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        widget.currentRow.NMORGTRAB = getLocalVar('NMORGTRAB');


        this.configureBlockedFieldsToEdit(widget, false);
        this.setDescricaoDataSourceFilter(widget);
        this.setDescricaoReadOnly(widget);

    };

    this.changeValueFilterAgenda = function(widget){
    
        var grid = widget;
        var filterAgenda = templateManager.container.getWidget("Parceiros");
        var getFieldParcResp = filterAgenda.getField('CDOPERREAL');
     
        if(grid.currentRow.IDOPERATIVO == "I"){
          getFieldParcResp.dataSourceFilter[1].value = "I";
          grid.getField('CDOPERREAL').clearValue();
          getFieldParcResp.reload();
        } else {
          getFieldParcResp.dataSourceFilter[1].value = "A";
          getFieldParcResp.reload();
        }
    }

    /**
     * Habilita o ambiente de edição para a tarefa
     * selecionada.
     * 
     * @param {object} widget widget da agenda de 
     * tarefas.
     */
    this.editTask = function(widget) {
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.currentRow.TIPOPARCPRINC;
    
        if (tipoParc.toUpperCase() == 'PROSPECT' || tipoParc.toUpperCase() == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function(canEdit) {
                if (canEdit) {
                    General.widgetEdit(widget);
                    widget.getField('NMOPERREAL').readOnly = true;
                    this.setDescricaoDataSourceFilter(widget);
                    this.setDescricaoReadOnly(widget, true);
                    this.configureBlockedFieldsToEdit(widget, true);
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this));
        } else {
            General.widgetEdit(widget);
            widget.getField('NMOPERREAL').readOnly = true;
            this.setDescricaoDataSourceFilter(widget);
            this.setDescricaoReadOnly(widget, true);
            this.configureBlockedFieldsToEdit(widget, true);
        }
    };
    
     this.cancelEditTask = function(widget) {
        widget.getField('NMOPERREAL').readOnly = false;
        General.widgetCancelForm(widget);
    };
    
    /**
     * Configura o estado das fields bloqueadas para
     * edição.
     * 
     * @param {object} widget widget de agenda de tarefas.
     * 
     * @param {boolean} isBlocked define se a field será
     * bloqueada ou não.
     */
    this.configureBlockedFieldsToEdit = function(widget, isBlocked) {

        var blockedFieldsToEdit = [
            widget.getField('NMPARCNEGOCIO')
        ];

        blockedFieldsToEdit.forEach(function(field) {
            field.readOnly = isBlocked;
        });

    };

    self.evolucaoNewRow = function(widget) {
        var mainWid = widget.parent.parent;
        var nrParcNegocio = mainWid.currentRow.NRPARCNEGOCIO;
        var tipoParc = mainWid.currentRow.TIPOPARCPRINC;
    
        if (tipoParc.toUpperCase() == 'PROSPECT' || tipoParc.toUpperCase() == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function(canEdit) {
                if (canEdit) {
                    if (mainWid.currentRow.NRSEQCONTATO || mainWid.currentRow.NRCONTATO) {
                        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
    
                        widget.getField('NMRESULTEVOL').readOnly = false;
    
                        General.widgetNewRow(widget);
    
                        self.defaultEditAuditRow(widget);
                        setLocalVar('PARCEIRO', mainWid.currentRow.NRPARCNEGOCIO);
    
                        widget.currentRow.DTHREVOLCONT = (widget.currentRow.DTHREVOLCONT) ? widget.currentRow.DTHREVOLCONT : moment(new Date()).format('DD/MM/YYYY HH:mm');
                        widget.currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
                        widget.currentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
                        widget.currentRow.NMOPERADORREAL = loggedOperatorInfos.NMOPERADOR;
                        widget.currentRow.NRCONTATO = mainWid.currentRow.NRCONTATO;
                        widget.currentRow.NRSEQCONTATO = mainWid.currentRow.NRSEQCONTATO;
                        widget.currentRow.IDTPEVOLCONT = 'P';
                        widget.currentRow.IDSENEVOCONT = 'S';
                        widget.currentRow.IDANEXOEVOLCONT = 'N';
                        widget.currentRow.CDFILIAL = "";
                        widget.currentRow.IDGERAFATURA = 'NAO';
                        widget.currentRow.NRCONCORRENTE = "";
                        widget.currentRow.NMSEQFASENEGO = mainWid.currentRow.NMSEQFASENEGO;
    
                        ABEvolucaoController.setEvolDateChangePermission(widget);
    
                        this.setOpportunityGroupVisibilityBySelectedTask(widget);
                        this.getOpportNegotiationPhase(widget);
                        this.getOpportTermometro(widget);
                        this.setOportClosingDataGroupVisibility(widget);
                    } else {
                        ScreenService.showMessage(Messages.ERROR_EVOLUCAO_SEM_CONTATO);
                    }
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this));
        } else {
            if (mainWid.currentRow.NRSEQCONTATO || mainWid.currentRow.NRCONTATO) {
                var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
    
                widget.getField('NMRESULTEVOL').readOnly = false;
    
                General.widgetNewRow(widget);
    
                self.defaultEditAuditRow(widget);
                setLocalVar('PARCEIRO', mainWid.currentRow.NRPARCNEGOCIO);
    
                widget.currentRow.DTHREVOLCONT = (widget.currentRow.DTHREVOLCONT) ? widget.currentRow.DTHREVOLCONT : moment(new Date()).format('DD/MM/YYYY HH:mm');
                widget.currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
                widget.currentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
                widget.currentRow.NMOPERADORREAL = loggedOperatorInfos.NMOPERADOR;
                widget.currentRow.NRCONTATO = mainWid.currentRow.NRCONTATO;
                widget.currentRow.NRSEQCONTATO = mainWid.currentRow.NRSEQCONTATO;
                widget.currentRow.IDTPEVOLCONT = 'P';
                widget.currentRow.IDSENEVOCONT = 'S';
                widget.currentRow.IDANEXOEVOLCONT = 'N';
                widget.currentRow.CDFILIAL = "";
                widget.currentRow.IDGERAFATURA = 'NAO';
                widget.currentRow.NRCONCORRENTE = "";
                widget.currentRow.NMSEQFASENEGO = mainWid.currentRow.NMSEQFASENEGO;
    
                ABEvolucaoController.setEvolDateChangePermission(widget);
    
                this.setOpportunityGroupVisibilityBySelectedTask(widget);
                this.getOpportNegotiationPhase(widget);
                this.getOpportTermometro(widget);
                this.setOportClosingDataGroupVisibility(widget);
            } else {
                ScreenService.showMessage(Messages.ERROR_EVOLUCAO_SEM_CONTATO);
            }
        }
    };

    self.defaultEditAuditRow = function(widget) {

        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        if (widget.currentRow.__is_new) {
            widget.currentRow.NRORG = loggedOperatorInfos.NRORG;
            widget.currentRow.NRORGINCLUSAO = loggedOperatorInfos.NRORG;
            widget.currentRow.CDOPERINCLUSAO = loggedOperatorInfos.CDOPERADOR;
            widget.currentRow.DTINCLUSAO = moment(new Date()).format('DD/MM/YYYY HH:mm');
        }
        else {
            widget.currentRow.NRORGULTATU = loggedOperatorInfos.NRORG;
            widget.currentRow.CDOPERULTATU = loggedOperatorInfos.CDOPERADOR;
            widget.currentRow.DTULTATU = moment(new Date()).format('DD/MM/YYYY HH:mm');
        }
    };

    self.checkRequirements = function(widget) {
        if (!widget.isValid()) {
            ScreenService.showMessage('Preencha todos os campos marcados com asterisco!');
            return false;
        }

        return true;
    };

    self.abrirPopupDeTransferencia = function(widget) {
        var rows = widget.getCheckedRows();
        var tasksIsValid = this.validateTasksByStatus(rows);
        if(tasksIsValid) {
            tasksIsValid = this.validateTasksByAssistant(rows);
        }
        
        
        if (rows && rows.length !== 0) {
            if (tasksIsValid) {
                widget.widgets[1].isVisible = true;
                ScreenService.openPopup(widget.widgets[1]);
            } else {
                ScreenService.showMessage("As tarefas selecionadas estão em algum dos status abaixo e a ação foi bloqueada.<br><br><li>As tarefas estão concluídas.<br><li>Os Parceiros relacionados das tarefas não pertencem à sua equipe de operadores.");
            }
        } else {
            ScreenService.showMessage(Messages.SELECIONAR_TAREFA_TRANSFERENCIA);
        }
    };

    this.validateTasksByStatus = function(tasks) {
        var isValid = true;
        
        tasks.forEach(function(task, count) {
            if (task.STATUS === "Concluída") {
                isValid = false;
            }
        });
        return isValid;
    };
    
    self.fecharPopupDeTransferencia = function(widget) {
        widget.isVisible = false;
        ScreenService.closePopup();
    };
    
    this.validateTasksByAssistant = function(tasks) {
        // Map tasks to an array of promises
        var promises = tasks.map(function(task) {
            var self = this;  // Store reference to the current context
            return self.checkIfCanEditOrEvolParc(task.NRPARCNEGOCIO).then(function(canEdit) {
                if (!canEdit) {
                    self.showMessageCantEditParc();
                }
                return canEdit;
            });
        }.bind(this));
    
        // Wait for all promises to resolve
        return Promise.all(promises).then(function(results) {
            // Check if all tasks are valid
            return results.every(function(canEdit) {
                return canEdit;
            });
        });
    };

    self.fecharPopupDeTransferencia = function(widget) {
        widget.isVisible = false;
        ScreenService.closePopup();
    };

    self.transferirTarefa = function(widget) {
        var mainWid = widget.parent.parent;
        if(!widget.isValid()) return;
        
        var rows = mainWid.getCheckedRows();
        restEngine.post('/transferirTarefa', {
                'requestType': 'Row',
                'row': {
                    "ROW": rows,
                    "OPERADOR": widget.currentRow.CDOPERREAL,
                }
            },
            function(response) {
                widget.getField('NMOPERREAL').value("");
                ScreenService.showMessage('Tarefa(s) transferida(s) com sucesso.');
                ScreenService.closePopup();
                mainWid.unSelectAll();
                mainWid.reload();
            }, undefined,
            function(response) {
                ScreenService.showMessage(response);
            });
    };

    self.concluirTarefa = function(widget) {
        widget.currentRow.DTREALFILACONTA = moment(new Date()).format('YYYY/MM/DD HH:mm');
        restEngine.post('\/concluirTarefa', {
                'requestType': 'Row',
                'row': widget.currentRow
            },
            undefined, undefined, undefined).then(function(response) {
            ScreenService.showMessage('Tarefa concluída com sucesso.');
            ScreenService.closeSwipe();
            widget.list();
            widget.reload();
        });
    }; 

    self.podeModificarAgenda = function(widget) {
        widget.getAction('EDIT').isVisible = (widget.currentRow.DTREALFILACONTA === null);
        widget.widgets[0].getAction('ADD').isVisible = (widget.currentRow.DTREALFILACONTA === null);
        widget.getAction('CONCLUIR').isVisible = (widget.currentRow.DTREALFILACONTA === null);
    };

    self.saveTask = function (widget) {
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.currentRow.TIPOPARCPRINC;
        var currentRow = widget.currentRow;
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');

        if (tipoParc && typeof tipoParc === 'string') {
            if (tipoParc.toUpperCase() == 'PROSPECT' || tipoParc.toUpperCase() == 'CLIENTE') {
                this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                    if (canEdit) {
                        if (currentRow.__is_new) {
                            General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function (response) {
                                if (response.dataset && response.dataset.error) {
                                    ScreenService.showMessage(response.dataset.error, 'ERROR');
                                }
                                if (response.dataset && response.dataset.GROUPREL[0] == false) {
                                    if (self.checkRequirements(widget)) {
                                        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
                                        self.defaultEditAuditRow(widget);
                                        widget.currentRow.CDFILIAL = "";
                                        widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                                        widget.currentRow.OPERADORDOLOGADO = loggedOperatorInfos.NMOPERADOR;
                                        widget.currentRow.NRSEQCLASSIFICATAREFA = (widget.currentRow.NRSEQCLASSIFICATAREFA) ? widget.currentRow.NRSEQCLASSIFICATAREFA : null;

                                        return General.widgetSave(widget).then(function (response) {
                                            if (response.dataset.DADOS) {
                                                widget.currentRow.NRSEQFILACONTA = response.dataset.DADOS.NRSEQFILACONTA;
                                            }
                                            if (widget.currentRow.CDOPERINCLUSAO != widget.currentRow.CDOPERREAL && !Util.isEmptyOrBlank(widget.currentRow.DSEMAILOPER)) {
                                                ScreenService.confirmMessage('Deseja enviar um e-mail para o operador responsável da tarefa?', 'QUESTION', function (yes) {
                                                    var params = {
                                                        "requestType": "Row",
                                                        "row": widget.currentRow
                                                    };

                                                    restEngine.post('/enviaEmailTarefa', params).then(function () {
                                                        ScreenService.showMessage('E-mail enviado com sucesso!');
                                                    }).catch(function (error) {
                                                        if (error.data.error) {
                                                            ScreenService.showMessage('O e-mail não pode ser enviado pois as configurações de SMTP estão desconfiguradas ou erradas!', 'ERROR');
                                                        } else {
                                                            ScreenService.showMessage(error.data.error);
                                                        }
                                                    });
                                                }.bind(this));
                                            }
                                            self.setEvolutionWidgetfilter(widget);
                                            widget.getField('NMOPERREAL').readOnly = false;
                                            widget.reload();
                                        }.bind(this)).then(function () {
                                            self.setDescricaoDataSourceFilter(widget);
                                            self.setDescricaoReadOnly(widget, true);
                                        });
                                    }
                                } else {
                                    ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
                                }
                            });
                        } else {
                            if (self.checkRequirements(widget)) {
                                var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
                                self.defaultEditAuditRow(widget);
                                widget.currentRow.CDFILIAL = "";
                                widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                                widget.currentRow.OPERADORDOLOGADO = loggedOperatorInfos.NMOPERADOR;
                                widget.currentRow.NRSEQCLASSIFICATAREFA = (widget.currentRow.NRSEQCLASSIFICATAREFA) ? widget.currentRow.NRSEQCLASSIFICATAREFA : null;

                                return General.widgetSave(widget).then(function (response) {
                                    if (response.dataset.DADOS) {
                                        widget.currentRow.NRSEQFILACONTA = response.dataset.DADOS.NRSEQFILACONTA;
                                    }
                                    if (widget.currentRow.CDOPERINCLUSAO != widget.currentRow.CDOPERREAL && !Util.isEmptyOrBlank(widget.currentRow.DSEMAILOPER)) {
                                        ScreenService.confirmMessage('Deseja enviar um e-mail para o operador responsável da tarefa?', 'QUESTION', function (yes) {
                                            var params = {
                                                "requestType": "Row",
                                                "row": widget.currentRow
                                            };

                                            restEngine.post('/enviaEmailTarefa', params).then(function () {
                                                ScreenService.showMessage('E-mail enviado com sucesso!');
                                            }).catch(function (error) {
                                                if (error.data.error) {
                                                    ScreenService.showMessage('O e-mail não pode ser enviado pois as configurações de SMTP estão desconfiguradas ou erradas!', 'ERROR');
                                                } else {
                                                    ScreenService.showMessage(error.data.error);
                                                }
                                            });
                                        }.bind(this));
                                    }
                                    self.setEvolutionWidgetfilter(widget);
                                    widget.getField('NMOPERREAL').readOnly = false;
                                    widget.reload();
                                }.bind(this)).then(function () {
                                    self.setDescricaoDataSourceFilter(widget);
                                    self.setDescricaoReadOnly(widget, true);
                                });
                            }
                        }
                    } else {
                        self.showMessageCantEditParc();
                    }
                });
            } else {
                if (currentRow.__is_new) {
                    General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function (response) {
                        if (response.dataset && response.dataset.error) {
                            ScreenService.showMessage(response.dataset.error, 'ERROR');
                        }
                        if (response.dataset && response.dataset.GROUPREL[0] == false) {
                            if (self.checkRequirements(widget)) {
                                var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
                                self.defaultEditAuditRow(widget);
                                widget.currentRow.CDFILIAL = "";
                                widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                                widget.currentRow.OPERADORDOLOGADO = loggedOperatorInfos.NMOPERADOR;
                                widget.currentRow.NRSEQCLASSIFICATAREFA = (widget.currentRow.NRSEQCLASSIFICATAREFA) ? widget.currentRow.NRSEQCLASSIFICATAREFA : null;

                                return General.widgetSave(widget).then(function (response) {
                                    if (response.dataset.DADOS) {
                                        widget.currentRow.NRSEQFILACONTA = response.dataset.DADOS.NRSEQFILACONTA;
                                    }
                                    if (widget.currentRow.CDOPERINCLUSAO != widget.currentRow.CDOPERREAL && !Util.isEmptyOrBlank(widget.currentRow.DSEMAILOPER)) {
                                        ScreenService.confirmMessage('Deseja enviar um e-mail para o operador responsável da tarefa?', 'QUESTION', function (yes) {
                                            var params = {
                                                "requestType": "Row",
                                                "row": widget.currentRow
                                            };

                                            restEngine.post('/enviaEmailTarefa', params).then(function () {
                                                ScreenService.showMessage('E-mail enviado com sucesso!');
                                            }).catch(function (error) {
                                                if (error.data.error) {
                                                    ScreenService.showMessage('O e-mail não pode ser enviado pois as configurações de SMTP estão desconfiguradas ou erradas!', 'ERROR');
                                                } else {
                                                    ScreenService.showMessage(error.data.error);
                                                }
                                            });
                                        }.bind(this));
                                    }
                                    self.setEvolutionWidgetfilter(widget);
                                    widget.getField('NMOPERREAL').readOnly = false;
                                    widget.reload();
                                }.bind(this)).then(function () {
                                    self.setDescricaoDataSourceFilter(widget);
                                    self.setDescricaoReadOnly(widget, true);
                                });
                            }
                        } else {
                            ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
                        }
                    });
                } else {
                    if (self.checkRequirements(widget)) {
                        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
                        self.defaultEditAuditRow(widget);
                        widget.currentRow.CDFILIAL = "";
                        widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                        widget.currentRow.OPERADORDOLOGADO = loggedOperatorInfos.NMOPERADOR;
                        widget.currentRow.NRSEQCLASSIFICATAREFA = (widget.currentRow.NRSEQCLASSIFICATAREFA) ? widget.currentRow.NRSEQCLASSIFICATAREFA : null;

                        return General.widgetSave(widget).then(function (response) {
                            if (response.dataset.DADOS) {
                                widget.currentRow.NRSEQFILACONTA = response.dataset.DADOS.NRSEQFILACONTA;
                            }
                            if (widget.currentRow.CDOPERINCLUSAO != widget.currentRow.CDOPERREAL && !Util.isEmptyOrBlank(widget.currentRow.DSEMAILOPER)) {
                                ScreenService.confirmMessage('Deseja enviar um e-mail para o operador responsável da tarefa?', 'QUESTION', function (yes) {
                                    var params = {
                                        "requestType": "Row",
                                        "row": widget.currentRow
                                    };

                                    restEngine.post('/enviaEmailTarefa', params).then(function () {
                                        ScreenService.showMessage('E-mail enviado com sucesso!');
                                    }).catch(function (error) {
                                        if (error.data.error) {
                                            ScreenService.showMessage('O e-mail não pode ser enviado pois as configurações de SMTP estão desconfiguradas ou erradas!', 'ERROR');
                                        } else {
                                            ScreenService.showMessage(error.data.error);
                                        }
                                    });
                                }.bind(this));
                            }
                            self.setEvolutionWidgetfilter(widget);
                            widget.getField('NMOPERREAL').readOnly = false;
                            widget.reload();
                        }.bind(this)).then(function () {
                            self.setDescricaoDataSourceFilter(widget);
                            self.setDescricaoReadOnly(widget, true);
                        });
                    }
                }
            }
        }
    };

    self.saveEvolucao = function (widget) {
        var mainWid = widget.parent.parent;
        var nrParcNegocio = mainWid.currentRow.NRPARCNEGOCIO;
        var tipoParc = mainWid.currentRow.TIPOPARCPRINC;
    
        function handleSaveResponse(response) {
            if (response.dataset.DADOS) {
                widget.currentRow.NRSEQEVOLCONT = response.dataset.DADOS.NRSEQEVOLCONT;
            }
    
            self.checkMail(widget).then(function () {
                self.setOpportunityNegotiationPhase(widget);
                self.setTaskEndDate(widget);
    
                if (widget.currentRow.IDGERPROXATIV == 'S' && isNew) {
                    widget.currentRow.NRPARCNEGOCIO = parcnegocio;
                    widget.currentRow.NRSEQCAMPANHA = campanha;
                    widget.currentRow.CDOPERREAL = templateManager.LOGGEDOPERATOR.CDOPERADOR;
                    widget.currentRow.DSEMAILOPER = widget.currentRow.DSEMAILOPER || "";
    
                    var params = {
                        "requestType": "Row",
                        "row": widget.currentRow
                    };
    
                    restEngine.post('/filacontato_agendatarefasprincipal/inserirTarefa', params)
                        .then(function (response) {
                            widget.reload();
                        })
                        .catch(function (error) {
                            ScreenService.showMessage(error.data.error);
                        });
                }
    
                if (response.dataset.DADOS && response.dataset.DADOS.NRSEQEVOLCONT) {
                    widget.currentRow.NRSEQEVOLCONT = response.dataset.DADOS.NRSEQEVOLCONT;
                    widget.currentRow.DTINCLUSAO = response.dataset.DADOS.DTINCLUSAO;
                } else if (response.dataset.DADOS && response.dataset.DADOS.DTULTATU) {
                    widget.currentRow.DTULTATU = response.dataset.DADOS.DTULTATU;
                }
    
                if (Boolean(widget.currentRow.DESCRESULEVOL)) {
                    self.closeOport(widget).then(function () {
                        ScreenService.showMessage(Messages.OPORTUNIDADE_CONCLUIDA);
                    });
                }
    
                widget.reload();
            });
        }
    
        function handleError(error) {
            if (error && error.indexOf && error.indexOf('REQUIRE_INTERLOCUTOR') !== -1) {
                ScreenService.showMessage("Operação bloqueada! <br><br> Favor informar o interlocutor.");
            } else {
                ScreenService.showMessage(error);
            }
        }
    
        function handleCanEdit(canEdit) {
            if (canEdit) {
                if (self.checkRequirements(widget)) {
                    self.defaultEditAuditRow(widget);
                    if (!widget.currentRow.NRRELACIONAPARC) {
                        widget.currentRow.NRRELACIONAPARC = null;
                    }
    
                    widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                    widget.currentRow.NRSEQFILACONTA = angular.copy(mainWid.currentRow.NRSEQFILACONTA);
                    var parcnegocio = angular.copy(mainWid.currentRow.NRPARCNEGOCIO);
                    var campanha = angular.copy(mainWid.currentRow.NRSEQCAMPANHA);
                    var isNew = widget.currentRow.__is_new;
    
                    General.widgetSave(widget)
                        .then(function (response) {
                            handleSaveResponse(response);
                        })
                        .catch(function (error) {
                            handleError(error);
                        });
                }
                self.setDescricaoDataSourceFilter(widget);
                self.setDescricaoReadOnly(widget, true);
            } else {
                self.showMessageCantEditParc();
            }
        }
    
        if (tipoParc.toUpperCase() == 'PROSPECT' || tipoParc.toUpperCase() == 'CLIENTE') {
            self.checkIfCanEditOrEvolParc(nrParcNegocio)
                .then(function (canEdit) {
                    handleCanEdit(canEdit);
                });
        } else {
            if (self.checkRequirements(widget)) {
                self.defaultEditAuditRow(widget);
                if (!widget.currentRow.NRRELACIONAPARC) {
                    widget.currentRow.NRRELACIONAPARC = null;
                }
    
                widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                widget.currentRow.NRSEQFILACONTA = angular.copy(widget.parent.parent.currentRow.NRSEQFILACONTA);
                var parcnegocio = angular.copy(widget.parent.parent.currentRow.NRPARCNEGOCIO);
                var campanha = angular.copy(widget.parent.parent.currentRow.NRSEQCAMPANHA);
                var isNew = widget.currentRow.__is_new;
    
                General.widgetSave(widget)
                    .then(function (response) {
                        handleSaveResponse(response);
                    })
                    .catch(function (error) {
                        handleError(error);
                    });
            }
            self.setDescricaoDataSourceFilter(widget);
            self.setDescricaoReadOnly(widget, true);
        }
    };
    
    this.checkMail = function(widget){
        var promise = ZHPromise.defer();
        if(!Util.isEmptyOrBlank(widget.currentRow.NRSEQINTERLOCUTOR) && widget.currentRow.IDENVIAEMAIL === 'S'){
                    ScreenService.confirmMessage('Deseja enviar um email para '+widget.currentRow.NMINTERLOCUTOR+'?', 'QUESTION',
            function(yes){
                evolutionTabController.openWidgetSendMail(widget).then(function(){
                    promise.resolve();
                });
            }, function(no) {
                promise.resolve();
            });
        }else{
            promise.resolve();
        }
        return promise.promise;
    };

    /**
     * Define se o fieldgroup para fechar uma oportunidade
     * será exibido na widget.
     * 
     * @param {object} widget widget de evolução da tela
     * de agenda de tarefas.
     */
    this.setOportClosingDataGroupVisibility = function(widget) {

        var mainWidgetCurrentRow = widget.parent.parent.currentRow;
        var fgClosingData = CRM_Utilities.getObjectPositionInArrayByName(widget.fieldGroups, "FG_DADOS_FECHAMENTO");
        var currentRow = widget.currentRow;

        if (mainWidgetCurrentRow.TIPO === "OPORTUNIDADE" && Boolean(widget.COMPLETETASK)) {

            widget.fieldGroups[fgClosingData].isVisible = true;
            currentRow.DTREALFECHA = CRM_Utilities.getDataHoraAtual();

            this.setEvolutionRelatedValidadtionsByNegotiationPhase(widget);

        }
        else {
            widget.fieldGroups[fgClosingData].isVisible = false;
            this.returnOpportRelatedFieldsDefaulValidations(widget);
        }


    };

    /**
     * Fecha uma oportunidade ligada a uma tarefa.
     * 
     * @param {object} widget widget de evolução da tela
     * de agenda de tarefas.
     */
    this.closeOport = function(widget) {

        var currentRow = widget.currentRow;
        currentRow.NRSEQOPORT = widget.NRSEQOPORT;

        var params = {
            "requestType": "Row",
            "row": currentRow
        };

        this.setOpportunityNegotiationPhase(widget);

        return restEngine.post('/fecharOportunidade', params).then(function() {
            ScreenService.showMessage(Messages.OPORTUNIDADE_CONCLUIDA);
        }).catch(function(error) {
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
        });

    };

    /**
     * Defini a fase de negociação da oportunidade concluída
     * de acordo com a fase selecionada pelo usuário.
     * 
     * @param {object} widget widget de evolução.
     */
    this.setOpportunityNegotiationPhase = function(widget) {

        var currentRow = widget.currentRow;

        if ((Boolean(currentRow.NRSEQFASENEGO) || Boolean(currentRow.NRTERMOPORTUNI)) && Boolean(widget.COMPLETETASK)) {

            var params = {
                "requestType": "Row",
                "row": this.setValuesToChangeOpport(widget)
            };

            return restEngine.post("product#/evolcont_crm_oportuni/atualizarOportunidade", params).then(function() {
                this.refreshEvolWidgetAndTaskWidgetToGetNewRelatedPhase(widget);
            }.bind(this)).catch(function(error) {
                console.log(error);
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
            });

        }

    };

    /**
     * Define os valores a ser atualizados da oportunidade
     * em caso.
     * 
     * @param {object} widget widget de evoluções('evolucao').
     * 
     * @return {object} parâmetros para atualziar a oportunidade.
     */
    this.setValuesToChangeOpport = function(widget) {

        var currentRow = widget.currentRow;
        var params = {};

        params.NRSEQOPORT = widget.NRSEQOPORT;

        if (currentRow.NRSEQFASENEGO) {
            params.NRSEQFASENEGO = currentRow.NRSEQFASENEGO;
        }

        if (currentRow.VRPREVOPORT) {
            params.VRPREVOPORT = CRM_Utilities.removeValueCurrencyMask(currentRow.VRPREVOPORT);
        }

        if (currentRow.VROPORT) {
            params.VROPORT = CRM_Utilities.removeValueCurrencyMask(currentRow.VROPORT);
        }

        if (currentRow.NRPARCRESP) {
            params.NRPARCRESP = currentRow.NRPARCRESP;
        }

        if (currentRow.NRTERMOPORTUNI) {
            params.NRTERMOPORTUNI = currentRow.NRTERMOPORTUNI;
        }

        return params;

    };

    /**
     * Atualiza a widget de evolução e a widget de tarefas
     * para obter a nova fase de negociação relacionada.
     * 
     * @param {object} widget widget de evolução
     * ("evolucao").
     */
    this.refreshEvolWidgetAndTaskWidgetToGetNewRelatedPhase = function(widget) {

        widget.parent.parent.reload();
        widget.reload();

    };
    
    self.setDescricaoReadOnly = function(widget, keepValue) {
        var parcnegocio = widget.currentRow.NRPARCNEGOCIO;
        var tipo = widget.getField('TIPO');
        var descricao = widget.getField('DESCRICAO');
        var interlocutor = widget.getField('NMINTERLOCUTOR');
        var telefone = widget.getField('DSTELEFONETAREFA');
        var email = widget.getField('DSEMAILTAREFA');
    
        if (!Util.isEmptyOrBlank(parcnegocio)) {
            setFieldReadOnly(tipo, false);
            setFieldReadOnly(descricao, false);
            setFieldReadOnly(interlocutor, false);
    
            if (!keepValue) {
                clearFieldValues(tipo, descricao, interlocutor, telefone, email);
            }
        } else {
            setFieldReadOnly(tipo, true);
            setFieldReadOnly(descricao, true);
            setFieldReadOnly(interlocutor, true);
            clearFieldValues(tipo, descricao, interlocutor, telefone, email);
        }
    };
    
    function setFieldReadOnly(field, readOnly) {
        if (field) {
            field.readOnly = readOnly;
        }
    }
    
    function clearFieldValues() {
        for (var i = 0; i < arguments.length; i++) {
            var field = arguments[i];
            if (field) {
                field.clearValue();
            }
        }
    }

    self.setDescricaoDataSourceFilter = function (widget) {
        try {
            var descricao = widget.getField('DESCRICAO');
    
            // Check if dataSourceFilter is available
            if (descricao && descricao.dataSourceFilter && Array.isArray(descricao.dataSourceFilter)) {
                descricao.dataSourceFilter[0].value = widget.currentRow.NRPARCNEGOCIO;
                descricao.dataSourceFilter[1].value = widget.currentRow.TIPO;
    
                if (widget.getField('TIPO').value() === 'OPORTUNIDADE') {
                    setDescriptionFilterValue(descricao.dataSourceFilter, 'CRM_NRORGTRAB', getLocalVar('CRM_NRORGTRABALHO'));
                } else {
                    setDescriptionFilterValue(descricao.dataSourceFilter, 'CRM_NRORGTRAB', "");
                }
            } else {
                console.error('Error: dataSourceFilter is not available or is not an array.');
            }
        } catch (error) {
            console.error('Error in setDescricaoDataSourceFilter:', error);
        }
    };
    
    // Helper function to find and set value in dataSourceFilter
    function setDescriptionFilterValue(dataSourceFilter, name, value) {
        var filter = dataSourceFilter.find(function (x) {
            return x.name === name;
        });
    
        if (filter) {
            filter.value = value;
        } else {
            console.error('Error: Filter with name', name, 'not found in dataSourceFilter.');
        }
    }

    self.setComunicaDataSourceFilter = function(widget) {
        var comunica = widget.getField('CDCOMUNICAPARC');
        comunica.dataSourceFilter[1].value = widget.currentRow.NRPARCNEGOCIO;
    };

    self.initTabGeneric = function(widget, field) {
        if (widget.parent.currentRow[field]) {
            widget.dataSourceFilter[0].value = widget.parent.currentRow[field];
        }

        widget.reload();
    };

    self.activateField = function(widget, field, decisiveField) {
        field = widget.getField(field);
        decisiveField = widget.currentRow[decisiveField];

        if ((decisiveField === null) || (decisiveField === '') || (decisiveField === undefined)) {
            field.clearValue();
            field.readOnly = true;
            field.validations = {};
        }
        else {
            field.readOnly = false;
            field.validations.required = {};
        }
    };

    self.activateFieldDescricao = function(widget, field, decisiveField, onChange) {
        onChange = onChange || false;
    
        if (widget) {
            var descricao = widget.getField('DESCRICAO');
    
            if (!Util.isEmptyOrBlank(descricao)) {
                descricao.readOnly = false;
                var value = widget.getField('TIPO').value();
    
                if (onChange && value !== backupTipo) {
                    descricao.value(null);
                }
    
                switch (value) {
                    case 'PARCEIRO':
                        backupTipo = value;
                        descricao.label = 'Parceiro';
                        break;
                    case 'CHAMADO':
                        backupTipo = value;
                        descricao.label = 'Ticket';
                        break;
                    case 'OPORTUNIDADE':
                        backupTipo = value;
                        descricao.label = 'Oportunidade';
                        break;
                    default:
                        backupTipo = value;
                        descricao.label = 'Código';
                        break;
                }
            } else {
                descricao.readOnly = true;
                descricao.label = 'Código';
                widget.currentRow.NRSEQCONTATO = null;
                widget.currentRow.NRCONTATO = null;
                widget.currentRow.DESCRICAO = "";
            }
    
            self.activateField(widget, field, decisiveField);
        }
    };

    /**
     * Função para definir o filtro dos campos
     * de motivo de contato e resultado, na widget
     * de evolução.
     * 
     * @param {object} widget widget de evolução.
     */
    this.setEvolutionResultFilterAndContactReasonFilter = function(widget) {

        var ContactReasonField = widget.getField("NMMOTIEVOCON");
        var ResultField = widget.getField("NMRESULTEVOL");
        
        this.setOperatorCodeFilterValueAndOrganizationNumberFilterValue(ContactReasonField);
        this.setOperatorCodeFilterValueAndOrganizationNumberFilterValue(ResultField);
    };
    
    this.updateSeqfilaFilter = function (widget) {
        widget.dataSourceFilter[2].value = widget.parent.parent.currentRow.NRSEQFILACONTA;
        //widget.reload();
    }

    /**
     * Função para setar valor dos filtros de
     * número de organização e código de operador
     * da field recebida como parâmetro, e logo
     * em seguida, recarrega a field.
     * 
     * @param {object} field field que receberá
     * o valor dos filtros
     */
    this.setOperatorCodeFilterValueAndOrganizationNumberFilterValue = function(field) {

        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        var fieldFilter = field.dataSourceFilter;
        var nrorgFilterIndex = CRM_Utilities.getFilterPosition(fieldFilter, "P_NRORG");
        var cdoperadorFilterIndex = CRM_Utilities.getFilterPosition(fieldFilter, "P_CDOPERADOR");

        fieldFilter[nrorgFilterIndex].value = loggedOperatorInfos.NRORG;
        fieldFilter[cdoperadorFilterIndex].value = loggedOperatorInfos.CDOPERADOR;

        field.reload();

    };

    /**
     * Função para abrir a widget de seleção
     * de arquivos.
     */
    this.openAnnexSwipe = function() {

        var fileUploadWidget = templateManager.container.getWidget('WDGT_SELECAO_ARQUIVOS');

        fileUploadWidget.isVisible = true;
        ScreenService.openSwipe(fileUploadWidget);

    };

    /**
     * Função para salvar os anexos selecionados
     * ao caso em questão.
     * 
     * @param {object} widget widget onde é
     * feito a seleção dos anexos.
     */
    this.uploadEvolutionFiles = function(widget) {

        var files = widget.currentRow.DSCAMINHO;

        var rows = [];

        files.forEach(function(file, fileIndex) {

            rows.push(this.setValuesForFileUpload(widget, fileIndex));

        }.bind(this));

        General.callRestEngine("product#/crm_anexocontato/save", "DataSet", rows).then(function() {

            this.closeAnnexSwipe(widget);
            widget.parent.parent.reload();

        }.bind(this));
    };

    /**
     * Função para retornar uma row configurada
     * com as informações do anexo referente
     * ao ID, recebido como parâmetro, no array
     * de anexos na currentRow.
     * 
     * @param {object} widget widget onde foi selecionado
     * os anexos.Array
     * 
     * @param {int} fileIndex index do anexo no array de 
     * anexos presente na currentRow.
     * 
     * @return {object} currentRow row configurada com as informações
     * do anexo referente ao ID recebido.
     */
    this.setValuesForFileUpload = function(widget, fileIndex) {

        var currentRow = angular.copy(widget.currentRow);
        var evolutionWidget = widget.parent.parent;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        currentRow.NRSEQCONTATO = evolutionWidget.getParent().currentRow.NRSEQCONTATO;
        currentRow.NMARQUIVO = this.getFileNameWithoutExtension(currentRow.DSCAMINHO[fileIndex].name);
        currentRow.DSTIPO = this.getFileExtension(currentRow.DSCAMINHO[fileIndex].name);
        currentRow.VRTAMANHO = currentRow.DSCAMINHO[fileIndex].size;
        currentRow.IDATIVO = "S";
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
        currentRow.IDORIGEM = "EVOLUCAO";
        currentRow.NRORIGEM = evolutionWidget.getParent().currentRow.NRSEQEVOLCONT;

        return currentRow;

    };

    /**
     * Função para retornar a extenção de um arquivo
     * extraida do seu nome.
     * 
     * @param {string} fileName nome completo do arquivo.
     */
    this.getFileExtension = function(fileName) {

        return fileName.replace(/^(.*)\.(.*)$/, "$2");

    };

    /**
     * Função para retornar o nome do arquivo sem
     * sua extenção.
     * 
     * @param {string} fileName nome completo do arquivo.
     */
    this.getFileNameWithoutExtension = function(fileName) {

        return fileName.replace(/^(.*)\.(.*)$/, "$1");

    };

    /**
     * Função para fechar o swipe de upload de imagens.
     * 
     * @param {object} widget widget de upload de imagens.
     */
    this.closeAnnexSwipe = function(widget) {
        var mainWid = widget.parent.parent;
        ScreenService.closeSwipe().then(function() {

            widget.isVisible = false;
            mainWid.list();
            mainWid.activate();

        });
    };

    /**
     * Função para fazer o download de uma arquivo
     * salvo no servidor.
     * 
     * @param {object} widget widget que contém
     * as informações do arquivo a ser baixado 
     * em sua currentRow.
     */
    this.downloadFile = function(widget) {

        window.open(window.fileServerBaseUrl + widget.currentRow.DSCAMINHO);

    };

    /**
     * Função para setar o filtro da widget
     * de evolução.
     * 
     * @param {object} widget widget de evolução.
     */
    this.setEvolutionWidgetfilter = function(gridWidget) {

        var widget = templateManager.container.getWidget("evolucao");
        var mainWid = widget.parent.parent;
        var widgetFilter = widget.dataSourceFilter;
        var hasFilterContato = false;

        widgetFilter[0].value = mainWid.currentRow.NRPARCNEGOCIO;

        widgetFilter.forEach(function(filter) {
            if (filter.name === "NRSEQCONTATO")
                hasFilterContato = true;
        });

        if (gridWidget.currentRow.TIPO === 'CHAMADO') {
            if (hasFilterContato) {
                widgetFilter[2].value = mainWid.currentRow.NRSEQCONTATO;
            }
            else {
                var filterContato = {
                    name: "NRSEQCONTATO",
                    operator: "=",
                    value: mainWid.currentRow.NRSEQCONTATO
                };
                widgetFilter.push(filterContato);
                hasFilterContato = true;
            }
        }
        else {
            if (hasFilterContato) {
                for(var i=0; i<widgetFilter.length; i++) {
                    if(widgetFilter[i].name == "NRSEQCONTATO") {
                        widgetFilter.splice(i,1);
                        hasFilterContato = false;
                        break;
                    }
                }
            }
        }

    };

    /**
     * Função para possibilitar o cadastro de
     * uma evolução referente a tarefa em caso,
     * indicando a conclusão da tarefa.
     * 
     * @param {object} widget widget ativa, no modo
     * view, referente a tarefa em caso.
     */
    this.completeTask = function(widget) {
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.currentRow.TIPOPARCPRINC;
    
        if (tipoParc.toUpperCase() === 'PROSPECT' || tipoParc.toUpperCase() === 'CLIENTE') {
            // Capture the 'this' reference
            var self = this;
    
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function(canEdit) {
                if (canEdit) {
                    var evolutionWidget = templateManager.container.getWidget("evolucao");
    
                    evolutionWidget.COMPLETETASK = true;
                    evolutionWidget.NRSEQFILACONTA = widget.currentRow.NRSEQFILACONTA;
                    evolutionWidget.NRORG = widget.currentRow.NRORG;
    
                    if (Boolean(widget.currentRow.NRSEQOPORT)) {
                        evolutionWidget.NRSEQOPORT = widget.currentRow.NRSEQOPORT;
                    }
    
                    ScreenService.closePopup();
    
                    self.setOpportunityGroupVisibilityBySelectedTask(evolutionWidget);
                    self.setOportClosingDataGroupVisibility(evolutionWidget);
    
                    self.activateWidget(evolutionWidget).then(function() {
                        setTimeout(function() {
                            self.evolucaoNewRow(evolutionWidget);
                        }, 500);
                    });
                } else {
                    self.showMessageCantEditParc();
                }
            });
        } else {
            var evolutionWidget = templateManager.container.getWidget("evolucao");
    
            evolutionWidget.COMPLETETASK = true;
            evolutionWidget.NRSEQFILACONTA = widget.currentRow.NRSEQFILACONTA;
            evolutionWidget.NRORG = widget.currentRow.NRORG;
    
            if (Boolean(widget.currentRow.NRSEQOPORT)) {
                evolutionWidget.NRSEQOPORT = widget.currentRow.NRSEQOPORT;
            }
    
            ScreenService.closePopup();
    
            this.setOpportunityGroupVisibilityBySelectedTask(evolutionWidget);
            this.setOportClosingDataGroupVisibility(evolutionWidget);
    
            this.activateWidget(evolutionWidget).then(function() {
                setTimeout(function() {
                    this.evolucaoNewRow(evolutionWidget);
                }.bind(this), 500);
            }.bind(this));
        }
    };

    /**
     * Função para ativar uma widget
     * 
     * @param {object} widget widget que será
     * ativada.
     * 
     * @return {object} deferred 'promise' indicando
     * a conclusão da tarefa da função.
     */
    this.activateWidget = function(widget) {

        var deferred = ZHPromise.defer();

        widget.activate();
        deferred.resolve();

        return deferred;
    };

    /**
     * Função para pegar as informações da tarefa
     * na widget de evolução e setar a data de
     * conclusão da tarefa no registro da própria
     * tarefa.
     * 
     * @param {object} widget widget ativa que contém
     * as informações da tarefa que será concluida.
     */
    this.setTaskEndDate = function(widget) {

        if (widget.COMPLETETASK) {

            var taskWidget = templateManager.container.getWidget("Parceiros");

            taskWidget.currentRow = {};

            taskWidget.currentRow.NRSEQFILACONTA = widget.NRSEQFILACONTA;
            taskWidget.currentRow.NRORG = widget.NRORG;

            this.concluirTarefa(taskWidget);
            this.deleteTaskInfosInEvolutionWidget(widget);

        }

    };

    /**
     * Função para deletar as informações da
     * tarefa a ser concluída da widget de evolução.
     * 
     * @param {object} widget widget de evolução.
     */
    this.deleteTaskInfosInEvolutionWidget = function(widget) {

        delete widget.COMPLETETASK;
        delete widget.NRSEQFILACONTA;
        delete widget.NRORG;

    };

    /**
     * Função para deletar uma tarefa, mas caso
     * ela tenha registros ligado a ela, a função permite
     * desativá-la.
     * 
     * @param {object} widget widget ativa, no modo
     * de visualização, com a tarefa em caso.
     */
    this.deleteTask = function(widget) {
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.currentRow.TIPOPARCPRINC;
        
        if (tipoParc.toUpperCase() == 'PROSPECT' || tipoParc.toUpperCase() == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function(canEdit) {
                if (canEdit) {
                    General.deleteCrud(widget).then(function() {
                    }).catch(function() {
                        ScreenService.confirmMessage(
                            ScreenService.i18n(Messages.EXCLUSAO_TAREFA_VINC_EVOLUCAO),
                            'question',
                            function(success) {
                                this.deactivateTask(widget).then(function() {
                                    ScreenService.showMessage(Messages.TAREFA_INATIVADA);
                                    ScreenService.closeSwipe().then(function() {
                                        widget.reload();
                                    });
                                });
                            }.bind(this),
                            function(error) {
                            }
                        );
                    }.bind(this));
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this));
        } else {
            General.deleteCrud(widget).then(function() {
            }).catch(function() {
                ScreenService.confirmMessage(
                    ScreenService.i18n(Messages.EXCLUSAO_TAREFA_VINC_EVOLUCAO),
                    'question',
                    function(success) {
                        this.deactivateTask(widget).then(function() {
                            ScreenService.showMessage(Messages.TAREFA_INATIVADA);
                            ScreenService.closeSwipe().then(function() {
                                widget.reload();
                            });
                        });
                    }.bind(this),
                    function(error) {
                    }
                );
            }.bind(this));
        }
    };
    
    /**
     * Função para deletar uma ou
     * mais tarefas.
     * 
     * @param {object} widget ativa, no modo
     * de visualização das tarefas filtradas
     * por operador
     */
    this.deleteMultipleTasks = function(widget) {
        var rows = widget.getCheckedRows();
        
        if(rows && rows.length !== 0) {
            var allParcsCantEditOrEvol = this.getAllParcsCantEditOrEvol(widget);
            
            if(allParcsCantEditOrEvol.length == 0){
                General.deleteCrudCheckedRows(widget).then(function() {
                    ScreenService.showMessage('Tarefa(s) excluída(s) com sucesso.');
                    ScreenService.closePopup();
                }).catch(function() {
                    ScreenService.confirmMessage(ScreenService.i18n(Messages.EXCLUSAO_TAREFA_VINC_EVOLUCAO), 'question',
                        function(success) {
                            ScreenService.closeSwipe().then(function() {
                                widget.reload();
                            });
                        }.bind(this),
                        function(error) {
                        });
                })
            }
            else {
                this.showMessageAllParcsCantEdit(allParcsCantEditOrEvol);
            }
        }
        else {
            ScreenService.showMessage(Messages.SELECIONAR_TAREFA_EXCLUSAO);
        }
        
    }
    
    /**
     * Função para recuperar todos os parceiros
     * que não possam ser editados ou evoluídos
     * pelo operador
     */
    this.getAllParcsCantEditOrEvol = function (widget) {
        var rows = widget.getCheckedRows();
        var parcsCantEditOrEvol = [];
    
        rows.forEach(function(row) {
            var nrParcNegocio = row.NRPARCNEGOCIO;
            var tipoParc = row.TIPOPARCPRINC;
    
            if (tipoParc.toUpperCase() == 'PROSPECT' || tipoParc.toUpperCase() == 'CLIENTE') {
                this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function(canEdit) {
                    if (!canEdit) {
                        parcsCantEditOrEvol.push(row.NMPARCNEGOCIO);
                    }
                }.bind(this));
            }
        }.bind(this));
    
        return parcsCantEditOrEvol;
    };
    
    this.showMessageAllParcsCantEdit = function(allParcsCantEdit) {
        var message = "Ação bloqueada!<br>" +
            "Somente o operador responsável pelo(s) seguinte(s) prospect(s) e seus assistentes podem " +
            "editá-lo(s)/evoluí-lo(s): ";
    
        for (var i = 0; i < allParcsCantEdit.length; i++) {
            message += allParcsCantEdit[i];
            if (i < allParcsCantEdit.length - 1) {
                message += ", ";
            }
        }
    
        ScreenService.showMessage(message);
    };

    /**
     * Função para desativar uma tarefa.
     * 
     * @param {object} widget widget com as 
     * informações da tarefa a ser desativada em sua
     * currentRow.
     */
    this.deactivateTask = function(widget) {

        var paramsRestEngine = {
            "requestType": "Row",
            "row": widget.currentRow
        };

        return restEngine.post('/deactivateTask', paramsRestEngine,
            function(success) {

            }, undefined,
            function(error) {

            }, undefined, undefined
        );

    };

    this.prepareFieldsNextTask = function(widget) {

        var nextTaskDate = widget.getField("DTPLANFILACONTA");
        var taskOperator = widget.getField("NMOPERADORREAL");
        var taskDescription = widget.getField("DSFILACONTATO");
        var taskClassification = widget.getField("DSCLASSIFICATAREFA");
        var taskPriority = widget.getField("NRPRIORFILACONT");

        nextTaskDate.readOnly = true;
        taskOperator.readOnly = true;
        taskDescription.readOnly = true;
        taskClassification.readOnly = true;
        taskPriority.readOnly = true;
        
        nextTaskDate.validations.required = false;
        taskOperator.validations.required = false;
        taskDescription.validations.required = false;
        taskPriority.validations.required = false;
    };


    this.changeOperatorFilter = function(args) {

        var widget = args.owner;
        var filterPopup = args.e.preference.FILTER_ROW;
        var cdoperador = filterPopup.CDOPERREAL;
        var filtros = widget.dataSourceFilter;
        var allOperators = true;

        //2 = Quantidade padrão de filtros, ou seja, se algo foi filtrado
        if (filtros.length !== 2) {
            filtros.forEach(function(filtro) {
                //Se filtrou operador
                if (filtro.name === "CDOPERREAL") {
                    allOperators = false;
                }
            });
        }
        else {
            //Se nada foi filtrado operador logado é o padrão
            var defaultOperator = {};
            defaultOperator.name = "CDOPERREAL";
            defaultOperator.operator = "IN";
            defaultOperator.value = [getLocalVar('CRM_CDOPERADOR')];
            defaultOperator.static = true;
            filtros.push(defaultOperator);
            allOperators = false;
        }
        //Se algo foi filtrado e operador não foi setado, todos é o padrão
        if (allOperators) {
            allOperators = {};
            allOperators.name = "CDOPERREAL";
            allOperators.operator = "IS_NOT_NULL";
            allOperators.static = true;
            filtros.push(allOperators);
        }

    };

    /**
     * Função para editar uma evolução.
     * 
     * @param {object} widget widget ativa, no
     * modo de visualização, com as informações
     * da evolução a ser editada.
     */
    this.editEvolution = function(widget) {
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.parent.currentRow.TIPOPARCPRINC;
    
        var blockfieldsAndEdit = function() {
            this.blockfieldsNextTask(widget, 'fdgAgendarTarefa', true);
            if (widget.name === 'evolucao') {
                widget.getField('NMRESULTEVOL').readOnly = true;
            }
            General.widgetEdit(widget);
    
            ABEvolucaoController.setEvolDateChangePermission(widget);
        }.bind(this);
    
        if (tipoParc.toUpperCase() == 'PROSPECT' || tipoParc.toUpperCase() == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function(canEdit) {
                if (canEdit) {
                    blockfieldsAndEdit();
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this));
        } else {
            blockfieldsAndEdit();
        }
    };

    this.widgetCancelForm = function(widget) {
        this.blockfieldsNextTask(widget, 'fdgAgendarTarefa', false);
        if (widget.name === 'evolucao')
            widget.getField('NMRESULTEVOL').readOnly = false;
        General.widgetCancelForm(widget);
        this.deleteTaskInfosInEvolutionWidget(widget);
    };

    this.blockfieldsNextTask = function(widget, name, block) {
        widget.fields.forEach(function(field) {
            if (field.fieldGroup === name) {
                field.readOnly = block;
            }
        });
    };

    /**
     * Define as regras da tela de agenda de tarefas
     * de acordo com a revenda do operador logado.
     * 
     * @param {object} widget widget principal da tela 
     * de agenda de tarefas ('Agenda').
     */
    this.setResaleRules = function(widget) {

        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        if (loggedOperatorInfos.IDTPOPERADOR === 'R' && Boolean(loggedOperatorInfos.NRREVENDA)) {

            var restrictObjects = [];

            restrictObjects.push(widget.getField("NMOPERREAL"));
            restrictObjects.push(widget.getField("CDOPERREAL"));
            restrictObjects.push(widget.getField("NMPARCNEGOCIO"));
            restrictObjects.push(widget.getField("NRPARCNEGOCIO"));

            var taskTransferWidget = templateManager.container.getWidget("TRANSFERIR");
            restrictObjects.push(taskTransferWidget.getField("NMOPERREAL"));

            var evolutionWidget = templateManager.container.getWidget("evolucao");
            restrictObjects.push(evolutionWidget.getField("NMOPERADORREAL"));

            CRM_Utilities.setResaleRulesInRestrictObjectsByLoggedOperatorResale(restrictObjects);

        }
        
        //widget.reload();
    };

    /**
     * Define a visibilidade do fieldgroup("FG_OPORTUNIDADE")
     * de acordo com a tarefa selecionada.
     * 
     * @param {object} widget widget de evolucao ("evolucao");
     */
    this.setOpportunityGroupVisibilityBySelectedTask = function(widget) {

        var parentWidgetCurrentRow = widget.parent.parent.currentRow;
        var phaseField = widget.getField('NMSEQFASENEGO');

        if (parentWidgetCurrentRow.TIPO === "OPORTUNIDADE" && Boolean(widget.COMPLETETASK)) {

            this.setOpportunityGroupVisibility(widget, true);
            this.setOpportFieldGroupDefaultValues(widget);

            phaseField.validations = {
                required: true
            };

        }
        else {

            this.setOpportunityGroupVisibility(widget, false);

            phaseField.validations = {};
            widget.currentRow[phaseField.name] = "";

        }

    };

    /**
     * Define os valores iniciais do grupo de campos relacionados
     * a oportunidade da tarefa, quando a mesmo for carregada.
     * 
     * @param {object} widget widget de evolução ("evolucao").
     */
    this.setOpportFieldGroupDefaultValues = function(widget) {

        var parentWidgetCurrentRow = widget.parent.parent.currentRow;
        var currentRow = widget.currentRow;

        currentRow.VRPREVOPORT = parentWidgetCurrentRow.VRPREVOPORT;

    };

    /**
     * Define a visibilidade do grupo de oportunidade.
     * 
     * @param {object} widget widget de evolucao ("evolucao").
     * 
     * @param {boolean} isVisible valor lógico definindo se o grupo
     * será visivel ou não.
     */
    this.setOpportunityGroupVisibility = function(widget, isVisible) {

        var opportFieldGroupIndex = CRM_Utilities.getObjectPositionInArrayByName(widget.fieldGroups, "FG_OPORTUNIDADE");
        var opportFieldGroup = widget.fieldGroups[opportFieldGroupIndex];

        opportFieldGroup.isVisible = isVisible;

    };

    /**
     * Busca a fase de negociação da oportunidade
     * relacionada a tarefa selecionada e seta na
     * currentRow da evolução.
     * 
     * @param {object} widget widget de evolução
     * ("evolucao").
     */
    this.getOpportNegotiationPhase = function(widget) {

        var parentWidgetCurrentRow = widget.parent.parent.currentRow;
        var currentRow = widget.currentRow;

        if (parentWidgetCurrentRow.TIPO === "OPORTUNIDADE") {

            widget.NRSEQOPORT = parentWidgetCurrentRow.NRSEQOPORT;
            currentRow.NRSEQFASENEGO = parentWidgetCurrentRow.NRSEQFASENEGO;
            currentRow.NMSEQFASENEGO = parentWidgetCurrentRow.NMSEQFASENEGO;
            currentRow.IDPERMITEFECHA = parentWidgetCurrentRow.IDPERMITEFECHA;

        }

    };

    /**
     * Busca o termometro da oportunidade
     * relacionada a tarefa selecionada e seta na
     * currentRow da evolução.
     * 
     * @param {object} widget widget de evolução
     * ("evolucao").
     */
    this.getOpportTermometro = function(widget) {

        var parentWidgetCurrentRow = widget.parent.parent.currentRow;
        var currentRow = widget.currentRow;

        if (parentWidgetCurrentRow.TIPO === "OPORTUNIDADE") {

            widget.NRSEQOPORT = parentWidgetCurrentRow.NRSEQOPORT;
            currentRow.NRTERMOPORTUNI = parentWidgetCurrentRow.NRTERMOPORTUNI;
            currentRow.NMTERMOPORTUNI = parentWidgetCurrentRow.NMTERMOPORTUNI;
            currentRow.IDPERMITEFECHA = parentWidgetCurrentRow.IDPERMITEFECHA;

        }

    };

    this.alteraMunicipioReadonly = function(widget) {
        widget = templateManager.container.getWidget('Agenda').__filterPopup;
        var estadoField = widget.getField("NMESTADO");
        var municipioField = widget.getField("NMMUNICIPIO");
        var currentRow = widget.currentRow;
        if (!estadoField.value()) {
            municipioField.readOnly = true;
            currentRow.CDMUNICIPIO = null;
            currentRow.NMMUNICIPIO = null;
            municipioField.dataSourceFilter[1].value = "";
        }
        else {
            municipioField.readOnly = false;
            municipioField.dataSourceFilter[1].value = widget.currentRow.SGESTADO;
        }
    };

    this.setFilterRelacionadoA = function(widget) {
        var descricaoField = widget.getField('DESCRICAO');
        var tipoField = widget.getField('TIPO');
        var interlocutorField = widget.getField('NMINTERLOCUTOR');

        if (!Util.isEmptyOrBlank(tipoField.value())) {
            descricaoField.dataSourceFilter.forEach(function(filter) {
                if (filter.name === "SEPARADOR")
                    filter.value = tipoField.value();
            });
            descricaoField.readOnly = false;
        }
        else {
            descricaoField.readOnly = true;
        }
    };

    /**
     * Configura as validações da widget de evolução referentes a 
     * fase de negociação.
     * 
     * @param {object} widget widget de evoluções('evolucao').
     */
    this.setEvolutionRelatedValidadtionsByNegotiationPhase = function(widget) {

        this.setOpportClosingValidationsByNegotiationPhase(widget);
        this.setOpportValueFieldValidationsByNegotiationPhase(widget);

    };

    /**
     * Define a validação padrão dos campos relacionados a oportunidade,
     * na widget de evolução('evolucao').
     * 
     * @param {object} widget widget de evolução('evolucao').
     */
    this.returnOpportRelatedFieldsDefaulValidations = function(widget) {

        var fields = [
            widget.getField('NMSEQFASENEGO'),
            widget.getField('VRPREVOPORT'),
            widget.getField('VROPORT'),
            widget.getField('DESCRESULEVOL'),
            widget.getField('NMPARCRESP')
        ];

        fields.forEach(function(field) {
            field.validations = {};
        });

    };

    /**
     * Define se a fase de negociação da oportunidade relacionada a tarefa
     * selecionada obriga o usuário a fechar a oportunidade.
     * 
     * @param {object} widget widget de evolução('evolucao').
     */
    this.setOpportClosingValidationsByNegotiationPhase = function(widget) {

        var opportValueField = widget.getField('VROPORT');
        var resultField = widget.getField('DESCRESULEVOL');

        var currentRow = widget.currentRow;

        if (currentRow.IDPERMITEFECHA === 'S') {
            opportValueField.validations = {
                required: true
            };
            resultField.validations = {
                required: true
            };
        }else {
            opportValueField.validations = {};
            resultField.validations = {};
        }

    };

    /**
     * Define a obrigatoriedade do campo
     * 'valor previsto da oportunidade' de acordo com a fase de
     * negociação em caso.
     * 
     * @param {object} widget widget de oportunidade.
     */
    this.setOpportValueFieldValidationsByNegotiationPhase = function(widget) {

        var currentRow = widget.currentRow;
        var valueOportField = widget.getField('VRPREVOPORT');

        if (currentRow.IDEXIGEVROPORT === 'S') {
            valueOportField.validations = {
                required: true
            };
        }
        else {
            valueOportField.validations = {};
        }

    };
    
    
    /**
     * Muda o campo de data no filtro, para filtrar pela data real,
     * e não pelo campo DATATAREFA, que é um char. Muda também o segundo
     * valor do between para o último minuto do dia selecionado.
    */
    this.buildDataFilter = function(widget){
        widget.dataSourceFilter.forEach(function(filter, CDOPERREAL){
            if(filter.name === 'DATATAREFA'){
                filter.name = 'DTPLANFILACONTA';
                filter.value[0] += ' 00:00';
                filter.value[1] += ' 23:59';
            }    
        });   
    };
    
    this.setMunicipioFilters = function(widget) {
        var municipioField = widget.getField('NMMUNICIPIO');
        
        var dsFilterPais = municipioField.dataSourceFilter.find(function(filter) {
            return filter.name == "CDPAIS";
        });
        
        if(dsFilterPais) {
            dsFilterPais.value = "0055";
        }
    };
    
    this.openFilter = function(widget) {
        var taskWidget = templateManager.container.getWidget("Parceiros");
    
        if (taskWidget.fromDashboard !== true) {
            var filterRow = {};
            var loggedOper = templateManager.LOGGEDOPERATOR;
            var orgField = widget.getField('CRM_NRORGTRAB');
            var nmOrgField = widget.getField('NMORGTRAB');
    
            filterRow.CDOPERREAL = [loggedOper.CDOPERADOR];
            filterRow.NMOPERADOR = [loggedOper.NMOPERADOR];
            filterRow.NMORGTRAB = [getLocalVar('NMORGTRAB')];
            filterRow.IDOPERATIVO = 'A';
            filterRow.CRM_NRORGTRAB = [getLocalVar('CRM_NRORGTRABALHO')];
    
            var filtro = [
                {
                    "name": "P_NRORG",
                    "operator": "=",
                    "value": getLocalVar('CRM_NRORGTRAB')
                },
                {
                    "name": "P_CDOPERADOR",
                    "operator": "=",
                    "value": loggedOper.CDOPERADOR
                }
            ];
    
            General.callRestEngine("product#/getRelatedOrganizations", "FilterData", filtro)
                .then(function(response) {
                    if (response.dataset && response.dataset.getRelatedOrganizations) {
                        if (response.dataset.getRelatedOrganizations.length > 1) {
                            nmOrgField.isVisible = true;
                            orgField.isVisible = true;
                            nmOrgField.filterProperties.isVisible = true;
                        } else {
                            nmOrgField.isVisible = false;
                            orgField.isVisible = false;
                            nmOrgField.filterProperties.isVisible = false;
                        }
                    } else {
                        templateManager.project.userDataActions = [];
                    }
                })
                .catch(function(error) {
                    console.error("Error in promise:", error);
                })
                .then(function() {
                    CRM_Utilities.openFilterOnEnter(widget, filterRow, ['STATUS_PRINCIPAL', 'CDOPERREAL', 'NMOPERREAL', 'CRM_NRORGTRABALHO']);
                });
        }
    };

    this.setStatusTitle = function(row, element, status) {
        element.attr('title', status);
    };
    
    this.evolucaoRowOnEnter = function(widget) {
        var prospectController = CRM_Utilities.getController('ger45000_Prospect_Controller');
        
        prospectController.setEditEvolButtonAction(widget, this.editEvolButtonDefaultCode, 'EDITAR_EVOLUCAO');
    };
    
    this.setNextTaskVisibility = function(taskGroupName) {
        var widget = templateManager.container.getWidget('evolucao');
        
        // Pega o grupo de campos relacionado à próxima tarefa
        var taskGroup = widget.fieldGroups.find(function(x) {
            return x.name == taskGroupName;
        });
        
        // Se o resultado selecionado estiver parametrizado para gerar tarefa,
        //o grupo ficará visível. Caso contrário, ficará invisível
        var geraProxTarefa = widget.currentRow.IDGERPROXATIV === 'S';
        
        var taskFields = widget.fields.filter(function(x) {
            return x.fieldGroup == taskGroupName;
        });
        
        taskFields.forEach(function(field) {
            field.isVisible = geraProxTarefa;
        });
        
        taskGroup.isVisible = geraProxTarefa;
    };
    
    this.editEvolButtonDefaultCode = 
    'Crm_31000_Agenda_de_Tarefas_Controller.editEvolution(args.owner.widget);\n' +
    'ger45000_Prospect_Controller.setNextTaskVisibility(args.owner.widget, \'fdgAgendarTarefa\');';
         
    this.setInterlocutorWidgetDefaultValues = function(widget){
        var wid = templateManager.container.getWidget('Agenda');
        
        wid.currentRow.NRPARCNEGOCIO;
        
        widget.currentRow.NRPARCNEGOCIO = wid.currentRow.NRPARCNEGOCIO;
    };
    
    this.removeCustomFilters = function() {
        var widget = templateManager.container.getActiveWidget();
        if(widget.customFilter) {
            widget.dataSourceFilter.forEach(function(filter, index, dataSourceFilter) {
                if (filter.name === "NRPARCNEGOCIO") {
                    dataSourceFilter[index].name = 'CDOPERREAL';
                    dataSourceFilter[index].value = [templateManager.LOGGEDOPERATOR.CDOPERADOR];
                }
            });
            var status = {
                name: "STATUS_PRINCIPAL",
                operator: "IN",
                value: ["ATRASADA", "HOJE", "FUTURA"]
            };
            widget.dataSourceFilter.push(status);
            delete widget.customFilter;
        }
    };
    
    this.returnToMainGrid = function() {
        var mainWid = templateManager.container.getWidget('Agenda');
        
        ScreenService.closeSwipe();
        mainWid.activate();
        mainWid.list();
    };
    
    this.verificaExistenciaContato = function() {
        var widget = templateManager.container.getWidget('Agenda');
        
        if(Util.isEmptyOrBlank(widget.currentRow.NRSEQCONTATO) && !widget.currentRow.__is_new) {
            var params = {
                'requestType':'Row',
                'row': {"NRPARCNEGOCIO": widget.currentRow.NRPARCNEGOCIO, "NRORG": widget.currentRow.NRORG}
            };
            restEngine.post('/selectProspectNrContato', params,
                function(success) {
                    widget.currentRow.NRSEQCONTATO = success.dataset.DADOS.NRSEQCONTATO;
                    widget.currentRow.NRCONTATO = success.dataset.DADOS.NRSEQCONTATO;
                });
        }
    };

    this.verificaExistenciaContatoParceiro = function() {
        var widget = templateManager.container.getWidget('Parceiros');
        
        if(Util.isEmptyOrBlank(widget.currentRow.NRSEQCONTATO) && !widget.currentRow.__is_new) {
            var params = {
                'requestType':'Row',
                'row': {"NRPARCNEGOCIO": widget.currentRow.NRPARCNEGOCIO, "NRORG": widget.currentRow.NRORG}
            };
            restEngine.post('/selectProspectNrContato', params,
                function(success) {
                    widget.currentRow.NRSEQCONTATO = success.dataset.DADOS.NRSEQCONTATO;
                    widget.currentRow.NRCONTATO = success.dataset.DADOS.NRSEQCONTATO;
                });
        }
    };
    
    this.checkIfCanEditOrEvolParc = function(nrParcNegocio) {
        var restRow = {
            NRPARCNEGOCIO: nrParcNegocio,
            CRM_NRORGTRAB: getLocalVar('CRM_NRORGTRABALHO')
        };
    
        var params = {
            requestType: 'Row',
            row: restRow
        };
    
        return restEngine.post('/checkIfCanEditOrEvolParc', params).then(function(response) {
            return response.dataset.DADOS.CAN_EDIT;
        }).catch(function() {
            return false;
        });
    };    
    
    this.showMessageCantEditParc = function() {
        var message = 'Ação bloqueada!<br>' +
            'Somente o operador responsável pelo prospect e seus assistentes podem ' +
            'editá-lo/evoluí-lo.';
        
        ScreenService.showMessage(message);
    };

    this.getTasks = function (field){
        debugger;
        
        var widget = templateManager.container.getWidget("Parceiros");
        var parceiro = widget.currentRow.NRPARCNEGOCIO;
        
        field.dataSourceFilter = widget.dataSourceFilter;
        
        var posicao = field.dataSourceFilter.findIndex(function(elemento) {
            return elemento.name == "NRPARCNEGOCIO";
        });
        
        if (posicao >= 0){
            field.dataSourceFilter[posicao].value = parceiro;
        } else {
            var filter = {};
            filter.name = "NRPARCNEGOCIO";
            filter.operator = "=";
            filter.value = parceiro;

            field.dataSourceFilter.push(filter);
        }
        
        
        posicao = field.dataSourceFilter.findIndex(function(elemento) {
            return elemento.name == "STATUS_PRINCIPAL";
        });      
        if (posicao < 0){
            filter = {};
            filter.name = "STATUS_PRINCIPAL";
            filter.operator = "IN";
            filter.value = ['ATRASADA', 'HOJE'];

            field.dataSourceFilter.push(filter);
        }

        field.reload();
    }
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Crm_31000_Agenda_de_Tarefas_Controller', Crm_31000_Agenda_de_Tarefas_Controller);
});


// FILE: ./assets/js/controllers/crm_cadastro_slaController.js
function crm_cadastro_slaController(CRM_Utilities, General, templateManager, ScreenService, restEngine, localStorageEngine, metaDataFactory) {

    var self = this;

    this.campos = function(DSPRIORIDADE, PK) {
        var campos = [
            {
                "id": "",
                "name": "DSPRIORIDADE" + DSPRIORIDADE,
                "label": "Prioridade",
                "template": "field/text-edit.html",
                "fieldGroup": "PRIORIDADE",
                "class": "2",
                "descriptionField": PK,
                "defaultValue": DSPRIORIDADE,
                "isVisible": true,
                "showOnList": false,
                "showOnView": true,
                "showOnForm": true,
                "readOnly": true,
                "events": [],
                "filterProperties": {
                        "showOnList": false,
                        "showOnForm": false,
                        "showOnView": false,
                        "isVisible": false,
                        "class": "3"
                    }
            },
            {
                "id": "",
                "name": "RESPONDER" + DSPRIORIDADE,
                "label": "Responder em",
                "template": "field/number-edit.html",
                "fieldGroup": "PRIORIDADE",
                "isVisible": true,
                "showOnList": false,
                "showOnView": true,
                "showOnForm": true,
                "readOnly": false,
                "class": "textSelect",
                "validations": {
                    "required": true
                },
                "events": [
                        {
                        "id": "",
                        "name": "FieldOnChange",
                        "code": "crm_cadastro_slaController.verificaMaiorMenor(args); crm_cadastro_slaController.setAviso(args);"
                        }
                ],
                "filterProperties": {
                        "showOnList": false,
                        "showOnForm": false,
                        "showOnView": false,
                        "isVisible": false,
                        "class": "3"
                    }
         
            },
            {
                "id": "",
                "name": "RESPONDER" + DSPRIORIDADE+"_OPTION",
                "template": "field/select-native.html",
                "fieldGroup": "PRIORIDADE",
                "valueField": "TPHORATRAB",
                "hideEmptyValue": true,
                "descriptionField": "DESCRICAO",
                "defaultValue": 1,
                "isVisible": true,
                "showOnList": false,
                "showOnView": false,
                "class": "selectText",
                "dataSource": {
                    "data": [
                        {
                            "TPHORATRAB": 1,
                            "DESCRICAO": "Min."
                        },
                        {
                            "TPHORATRAB": 2,
                            "DESCRICAO": "Hora (s)"
                        },
                        {
                            "TPHORATRAB": 3,
                            "DESCRICAO": "Dias Úteis"
                        },
                        {
                            "TPHORATRAB": 4,
                            "DESCRICAO": "Dias Corridos"
                        },
                        {
                            "TPHORATRAB": 5,
                            "DESCRICAO": "Meses"
                        }
                    ]
                },
                "events": [
                        {
                        "id": "",
                        "name": "FieldOnChange",
                        "code": "crm_cadastro_slaController.verificaMaiorMenor(args); crm_cadastro_slaController.setAviso(args);"
                        }
                ],      
                "filterProperties": {
                        "showOnList": false,
                        "showOnForm": false,
                        "showOnView": false,
                        "isVisible": false,
                        "class": "3"
                    }
                
            },
            {
                "id": "",
                "name": "RESOLVER" + DSPRIORIDADE,
                "label": "Resolver em",
                "template": "field/number-edit.html",
                "fieldGroup": "PRIORIDADE",
                "isVisible": true,
                "showOnList": false,
                "showOnView": true,
                "showOnForm": true,
                "readOnly": false,
                "class": "textSelect",
                "validations": {
                    "required": true
                },
                "events": [
                        {
                        "id": "",
                        "name": "FieldOnChange",
                        "code": "crm_cadastro_slaController.verificaMaiorMenor(args); crm_cadastro_slaController.setAviso(args);"
                        }
                ],
                "filterProperties": {
                        "showOnList": false,
                        "showOnForm": false,
                        "showOnView": false,
                        "isVisible": false,
                        "class": "3"
                    }
         
            },
            {
                "id": "",
                "name": "RESOLVER" + DSPRIORIDADE+"_OPTION",
                "template": "field/select-native.html",
                "fieldGroup": "PRIORIDADE",
                "valueField": "TPHORATRAB",
                "hideEmptyValue": true,
                "defaultValue": 1,
                "descriptionField": "DESCRICAO",
                "isVisible": true,
                "showOnList": false,
                "showOnView": false,
                "class": "selectText",
                "dataSource": {
                    "data": [{
                            "TPHORATRAB": 1,
                            "DESCRICAO": "Min."
                        },
                        {
                            "TPHORATRAB": 2,
                            "DESCRICAO": "Hora (s)"
                        },
                        {
                            "TPHORATRAB": 3,
                            "DESCRICAO": "Dias Úteis"
                        },
                        {
                            "TPHORATRAB": 4,
                            "DESCRICAO": "Dias Corridos"
                        },
                        {
                            "TPHORATRAB": 5,
                            "DESCRICAO": "Meses"
                        }
                    ]
                },
                "events": [
                        {
                        "id": "",
                        "name": "FieldOnChange",
                        "code": "crm_cadastro_slaController.verificaMaiorMenor(args); crm_cadastro_slaController.setAviso(args);"
                        }
                ],
                "filterProperties": {
                        "showOnList": false,
                        "showOnForm": false,
                        "showOnView": false,
                        "isVisible": false,
                        "class": "3"
                    }
            },
            {
                "id": "",
                "name": "NRHORATRAB" + DSPRIORIDADE,
                "label": "Horário Operação",
                "template": "field/select-native.html",
                "fieldGroup": "PRIORIDADE",
                "valueField": "NRHORATRAB",
                "hideEmptyValue": true,
                "descriptionField": "NMHORARIO",
                "dataSource": {
                    "name": "product#/crud/crm_horatrab",
                    "rest": true,
                    "lazyLoad": false
                },
                "defaultValue": null,
                "validations": {
                    "required": true
                },
                "isVisible": true,
                "showOnList": false,
                "class": "2",
                "events": [{
                    "id": "",
                    "name": "FieldOnChange",
                    "code": "crm_cadastro_slaController.verificaMaiorMenor(args); crm_cadastro_slaController.setAviso(args);"
                }],
                "filterProperties": {
                        "showOnList": false,
                        "showOnForm": false,
                        "showOnView": false,
                        "isVisible": false,
                        "class": "3"
                    }
            },
            {
                "id": "",
                "name": "MANDAEMAIL" + DSPRIORIDADE,
                "label": "E-mail",
                "template": "field/select-native.html",
                "fieldGroup": "PRIORIDADE",
                "valueField": "MANDAEMAIL",
                "hideEmptyValue": true,
                "descriptionField": "DESCRICAO",
                "dataSource": {
                    "data": [
                        {
                            "MANDAEMAIL": "1",
                            "DESCRICAO": "Envia Lembrete"
                        },
                        {
                            "MANDAEMAIL": "2",
                            "DESCRICAO": "Envia Notificação"
                        },
                        {
                            "MANDAEMAIL": "3",
                            "DESCRICAO": "Envia Ambos"
                        },
                        {
                            "MANDAEMAIL": "4",
                            "DESCRICAO": "Não Envia"
                        }
                    ]
                },
                "defaultValue": "2",
                "isVisible": true,
                "showOnList": false,
                "class": "2",
                "filterProperties": {
                        "showOnList": false,
                        "showOnForm": false,
                        "showOnView": false,
                        "isVisible": false,
                        "class": "3"
                    }
            },
            {
                "name": "DSPRIORIDADECLI",
                "label": "Prioridade",
                "template": "field/select.html",
                "class": "3",
                "isVisible": false,
                "showOnList": false,
                "showOnView": false,
                "showOnForm": false,
                "readOnly": false,
                "dataSource": {
                    "name": "product#/crud/crm_prioridade",
                    "rest": true,
                    "lazyLoad": false
                },
                "itemsPerPage": 50,
                "dataSourceFilter": [{
                        "name": "NRORG",
                        "operator": "IN",
                        "value": "@[getLocalVar('CRM_NRORGTRAB'), getLocalVar('CRM_NRORGPADRAO')]@"
                    },
                    {
                        "name": "IDATIVO",
                        "operator": "=",
                        "value": "S"
                    }
                ],
                "descriptionField": "DSPRIORIDADECLI",
                "valueField": "NRPRIORIDADE",
                "outData": {
                    "NRPRIORIDADE": "NRPRIORIDADE",
                    "DSPRIORIDADECLI": "DSPRIORIDADECLI"
                },
                "fields": [{
                    "name": "DSPRIORIDADECLI",
                    "label": "Prioridade",
                    "showOnList": true
                }],
                "events": [],
                "filterProperties": {
                        "showOnList": false,
                        "showOnForm": false,
                        "showOnView": false,
                        "isVisible": false,
                        "class": "3"
                    }
            },
            {
                "id": "",
                "name": "AVISO" + DSPRIORIDADE,
                "defaultValue": "",
                "template": "field/span-field.html",
                "class": "12 avisoTempoResposta",
                "isVisible": true,
                "fieldGroup": "PRIORIDADE",
                "showOnList": false,
                "showOnView": true,
                "showOnForm": true,
                "events": [],
                "filterProperties": {
                        "showOnList": false,
                        "showOnForm": false,
                        "showOnView": false,
                        "isVisible": false,
                        "class": "3"
                    }
            },
            {
                "id": "",
                "name": "NRORG" + DSPRIORIDADE,
                "defaultValue": "@templateManager.LOGGEDOPERATOR.NRORG@",
                "template": "field/text-edit.html",
                "class": "1",
                "isVisible": false,
                "fieldGroup": "PRIORIDADE",
                "showOnList": false,
                "showOnView": false,
                "showOnForm": false,
                "events": [],
                "filterProperties": {
                        "showOnList": false,
                        "showOnForm": false,
                        "showOnView": false,
                        "isVisible": false,
                        "class": "3"
                    }
            }

        ];
        return campos;
    };

    this.nomePrioridades = function() { /*Pega as prioridades criadas*/
        var widget = templateManager.container.getWidget('WDGT_CADASTRO_SLA');
        var prioridades = widget.getField('DSPRIORIDADECLI').dataSource.data;
        var rows = [];
        rows = prioridades.map(function(row) { /*Pega nome das priorirades*/
            return row['DSPRIORIDADECLI'];
        });
        return rows;
    };

    this.PkPrioridades = function() { /*Pega as prioridades criadas*/
        var widget = templateManager.container.getWidget('WDGT_CADASTRO_SLA');
        var prioridades = widget.getField('DSPRIORIDADECLI').dataSource.data;
        var rows = [];
        rows = prioridades.map(function(row) { /*Pega nome das priorirades*/
            return row['NRPRIORIDADE'];
        });
        return rows;
    };

    this.listaPrioridade = function() {

        var widget = templateManager.container.getWidget('WDGT_CADASTRO_SLA');
        var prioridades = widget.getField('DSPRIORIDADECLI').dataSource.data;

        var cammposfield = [];

        var rowsPk = self.PkPrioridades();
        var rows = self.nomePrioridades();
        var num = 0;

        cammposfield = prioridades.map(function(row) {
            var fields = self.campos(rows[num], rowsPk[num]);
            num++;
            return fields;
        });

        return cammposfield;
    };

    this.insertFields = function(arrayOfFields, widget) {
        arrayOfFields.forEach(function(field, index) {
            if (index > 6) { //tira label dos campos 
                field.label = undefined;
            }
            field.dynamic = true;
            metaDataFactory.fieldFactory(field, widget, true);
        });
    };

    this.ativaFieldPrioridade = function() {
        var widget = templateManager.container.getWidget('WDGT_CADASTRO_SLA');

        var arrayFields = self.listaPrioridade();

        if (arrayFields == "") {
            //  ScreenService.showMessage('Prioridade não cadastrada');
        } else {
            var fieldsFixo = 5; /*Quantidade de Fields que esta no Json */
            var qntObjArray = arrayFields.length; /*Quantidade de Objetos dentro do array principal de campos*/
            var qntObjSubArray = arrayFields[0].length; /*Quantidade de Objetos dentro do sub array do principal de campos*/
            var totalField = qntObjArray * qntObjSubArray + fieldsFixo; /*Total de field que deve ter*/

            if (widget.fields.length < totalField) { /*Verifica se os campos foram criados*/
                var Fields = arrayFields[0];
                for (var i = 1; i < arrayFields.length; i++) {
                    Fields = Fields.concat(arrayFields[i]);
                }
                self.insertFields(Fields, widget);
            }
        }


    };

    this.salvaSLA = function(widget) {
        if (widget.currentRow.__is_new == true) {

              
                var prioridades = self.nomePrioridades();
                var fieldPrioridades = [];

                fieldPrioridades = prioridades.map(function(prioridade) {
                    var wid = templateManager.container.getWidget('WDGT_CADASTRO_SLA');

                    var tempoResp       = wid.currentRow['RESPONDER' + prioridade];
                    var tempoTextResp   = wid.currentRow['RESPONDER' + prioridade];
                    var tipoResp        = wid.currentRow['RESPONDER' + prioridade + '_OPTION'];
 
                    var tempoResv       = wid.currentRow['RESOLVER' + prioridade];
                    var tempoTextResv   = wid.currentRow['RESOLVER' + prioridade];
                    var tipoResv        = wid.currentRow['RESOLVER' + prioridade + '_OPTION'];
        

                    if (tipoResp == 1) { /*Se o tempo estiver em mintos*/
                        tempoTextResp = tempoResp;

                    } else if (tipoResp == 2) { /*Se o tempo estiver em horas*/
                        tempoTextResp = tempoResp * 60;
                        tempoResp = tempoTextResp;
                    } else if (tipoResp == 3) { /*Se o tempo estiver em dias*/
                        tempoTextResp = tempoResp * 60 * 24;
                        tempoResp = tempoTextResp;

                    } else if (tipoResp == 4) { /*Se o tempo estiver em meses*/
                        tempoTextResp = tempoResp * 60 * 24;
                        tempoResp = tempoTextResp;
                        
                    } else if (tipoResp == 5) { /*Se o tempo estiver em meses*/
                        tempoTextResp = tempoResp * 60 * 24 * 30;
                        tempoResp = tempoTextResp;
                    }



                    if (tipoResv == 1) { /*Se o tempo estiver em mintos*/
                        tempoTextResv = tempoResv;

                    } else if (tipoResv == 2) { /*Se o tempo estiver em horas*/
                        tempoTextResv = tempoResv * 60;
                        tempoResv = tempoTextResv;
                    } else if (tipoResv == 3) { /*Se o tempo estiver em dias*/
                        tempoTextResv = tempoResv * 60 * 24;
                        tempoResv = tempoTextResv;
                    } else if (tipoResv == 4) { 
                        tempoTextResv = tempoResv * 60 * 24;
                        tempoResv = tempoTextResv;
                    }else if (tipoResv == 5) { /*Se o tempo estiver em meses*/
                        tempoTextResv = tempoResv * 60 * 24 * 30;
                        tempoResv = tempoTextResv;
                    }

                    wid.currentRow['RESPONDER' + prioridade] = tempoResp;
                    wid.currentRow['RESOLVER' + prioridade] = tempoResv;
                    wid.currentRow['RESOLVER' + prioridade + '_TEXT'] = tempoTextResv;

                    var fieldsPrioridade = new Object();
                    fieldsPrioridade.NRORG              = wid.currentRow['NRORG' + prioridade];
                    fieldsPrioridade.DSPRIORIDADE       = wid.getField('DSPRIORIDADE' + prioridade).descriptionField;
                    fieldsPrioridade.NRHORATRAB         = wid.currentRow['NRHORATRAB' + prioridade];
                    fieldsPrioridade.RESPONDER          = wid.currentRow['RESPONDER' + prioridade];
                    fieldsPrioridade.RESPONDEREAL       = wid.currentRow['RESPONDER'+'REAL'+prioridade];
                    fieldsPrioridade.RESPONDER_OPTION   = wid.currentRow['RESPONDER' + prioridade + '_OPTION'];
                    fieldsPrioridade.RESOLVER           = wid.currentRow['RESOLVER' + prioridade];
                    fieldsPrioridade.RESOLVER_OPTION    = wid.currentRow['RESOLVER' + prioridade + '_OPTION'];
                    fieldsPrioridade.RESOLVEREAL        = wid.currentRow['RESOLVER' +'REAL'+ prioridade];
                    fieldsPrioridade.MANDAEMAIL         = wid.currentRow['MANDAEMAIL' + prioridade];
                    fieldsPrioridade.AVISO              = wid.currentRow['AVISO' + prioridade];

                    return fieldsPrioridade;


                });

                var dataset     = {};
                dataset.SLA     = widget.currentRow;
                dataset.rows    = fieldPrioridades;

                General.callRestEngine("product#/crm_sla_vincula/sla_prioridade_SLA", "DataSet", [dataset]).then(function(response) {
                    ScreenService.closeSwipe().then(function() {
                        widget.reload();
                    });

                }.bind(this));

            
        } else {
            var prioridades = self.nomePrioridades();
            var row = widget.currentRow;
            var dataset = {};
            var fieldsSLA = new Object();
            fieldsSLA.DSSLA = row.DSSLA;
            fieldsSLA.NMSLA = row.NMSLA;
            fieldsSLA.NRSEQSLA = row.NRSEQSLA;
            fieldsSLA.NRORG = row.NRORG;

            dataset.sla = fieldsSLA;
            dataset.prioridade = prioridades.map(function(prioridade) {
                var row = templateManager.container.getActiveWidget().currentRow;

                var tipoResp =  row['RESPONDER' + prioridade+'_OPTION'];
                var tempoTextResp = row['RESPONDER' + prioridade];
                var tempoResp = row['RESPONDER' + prioridade];
                if (tipoResp == 1) { /*Se o tempo estiver em mintos*/
                    tempoTextResp = tempoResp;

                } else if (tipoResp == 2) { /*Se o tempo estiver em horas*/
                    tempoTextResp = tempoResp * 60;
                    tempoResp = tempoTextResp;
                } else if (tipoResp == 3) { /*Se o tempo estiver em dias*/
                    tempoTextResp = tempoResp * 60 * 24;
                    tempoResp = tempoTextResp;
                } else if (tipoResp == 4) { /*Se o tempo estiver em meses*/
                     tempoTextResp = tempoResp * 60 * 24;
                    tempoResp = tempoTextResp;
                }else if (tipoResp == 5) { /*Se o tempo estiver em meses*/
                    tempoTextResp = tempoResp * 60 * 24 * 30;
                    tempoResp = tempoTextResp;
                }




                var tipoResv = row['RESOLVER' + prioridade+'_OPTION'];
                var tempoTextResv = row['RESOLVER' + prioridade];
                var tempoResv = row['RESOLVER' + prioridade];
                if (tipoResv == 1) { /*Se o tempo estiver em mintos*/
                    tempoTextResv = tempoResv;

                } else if (tipoResv == 2) { /*Se o tempo estiver em horas*/
                    tempoTextResv = tempoResv * 60;
                    tempoResv = tempoTextResv;
                } else if (tipoResv == 3) { /*Se o tempo estiver em dias*/
                    tempoTextResv = tempoResv * 60 * 24;
                    tempoResv = tempoTextResv;
                } else if (tipoResv == 4) { /*Se o tempo estiver em meses*/
                    tempoTextResv = tempoResv * 60 * 24;
                    tempoResv = tempoTextResv;
                } else if (tipoResv == 5) { /*Se o tempo estiver em meses*/
                    tempoTextResv = tempoResv * 60 * 24 * 30;
                    tempoResv = tempoTextResv;
                }

                var fieldsPrioridade = new Object();
                fieldsPrioridade.NRSLAPRIORIDADE    = row['NRSLAPRIORIDADE' + prioridade];
                fieldsPrioridade.RESOLVER           = tempoTextResv;
                fieldsPrioridade.RESPONDER          = tempoTextResp;
                fieldsPrioridade.MANDAEMAIL         = row['MANDAEMAIL' + prioridade];
                fieldsPrioridade.NRHORATRAB         = row['NRHORATRAB' + prioridade];
                fieldsPrioridade.TPRESOLVER         = tipoResv;
                fieldsPrioridade.TPRESPONDER        = tipoResp;
                fieldsPrioridade.NRORG              = row.NRORG;
                fieldsPrioridade.NRSEQSLA           = row.NRSEQSLA;
                fieldsPrioridade.AVISO              = row['AVISO' + prioridade];
                fieldsPrioridade.RESPONDEREAL       = row['RESPONDER'+'REAL'+prioridade];
                fieldsPrioridade.RESOLVEREAL        = row['RESOLVER' +'REAL'+ prioridade];
                return fieldsPrioridade;

            });

            General.callRestEngine("product#/crm_sla_vincula/sla_update", "DataSet", [dataset]).then(function(response) {
                ScreenService.closeSwipe().then(function() {

                    widget.reload();
                });

            }.bind(this));
        }

    };

    this.inativarSLA = function(widget) {
                                        
        ScreenService.confirmMessage('Deseja realmente Inativar a SLA?', 'QUESTION',
            function(success) {
                var paramsRestEngine = {
                    requestType: 'Row',
                    row: widget.currentRow
                };

                restEngine.post('product#/crm_sla_vincula/sla_inativar', paramsRestEngine).
                then(function(response) {

                    ScreenService.showMessage('SLA Inativada');
                    ScreenService.closeSwipe().then(function() {
                        ScreenService.closePopup(true);
                        widget.reload();
                    });

                }).catch(function(error) {
                    ScreenService.showMessage(error.data.error);
                });
            },
            function(cancel) {

            });
    };

    this.setPrioridade = function() {
        var widget = templateManager.container.getActiveWidget();
      
        setTimeout(function() {
            if (widget.mode === "view") {
                var wid = templateManager.container.getWidget('WDGT_VINCULO_SLA_CLIENTE');
                var NRSEQSLA = widget.currentRow.NRSEQSLA;
                restEngine.post("product#/crud/crm_slaprioridade", {
                    'requestType': 'FilterData',
                    filter: [{
                        operator: "=",
                        name: "NRSEQSLA",
                        value: NRSEQSLA
                    }]
                }).
                then(function(response) {

                    var slaprioridades = response.dataset.crm_slaprioridade;
                    slaprioridades.forEach(function(slaprioridade) {

                        var nmPrioridade = slaprioridade.DSPRIORIDADECLI;

                        var responderTipo   = parseInt(slaprioridade.IDTPRESPONDER);
                        var resolverTipo    = parseInt(slaprioridade.IDTPRESOLVER);
                        var responderQntmin = parseInt(slaprioridade.NRTEMPORESPSLA);
                        var resolverQntmin  = parseInt(slaprioridade.NRTEMPOSOLUSLA);
                        var responderTratado;
                        var resolverTratado;

                        if (responderTipo == 1) { /*Se o tempo estiver em mintos*/
                            responderTratado = responderQntmin + ' Minuto(s)';

                        } else if (responderTipo == 2) { /*Se o tempo estiver em horas*/
                            responderTratado = (responderQntmin / 60) + ' Hora(s)';

                        } else if (responderTipo == 3) { /*Se o tempo estiver em dias*/
                            responderTratado = (responderQntmin / 60 / 24) + ' Dias Uteis';

                        } else if (responderTipo == 4) { /*Se o tempo estiver em dias*/
                            responderTratado = (responderQntmin / 60 / 24) + ' Dias Corridos';

                        } else if (responderTipo == 5) { /*Se o tempo estiver em dias*/
                            responderTratado =(responderQntmin / 60 / 24 / 30) + ' Mes(es)';

                        }

                        if (resolverTipo == 1) { /*Se o tempo estiver em mintos*/
                            resolverTratado = resolverQntmin + ' Minuto(s)';

                        } else if (resolverTipo == 2) { /*Se o tempo estiver em horas*/
                            resolverTratado = (resolverQntmin / 60) + ' Hora(s)';

                        } else if (resolverTipo == 3) { /*Se o tempo estiver em dias*/
                            resolverTratado = (resolverQntmin / 60 / 24) + ' Dia Uteis';

                        } else if (resolverTipo == 4) { /*Se o tempo estiver em meses*/
                            resolverTratado = (resolverQntmin / 60 / 24) + ' Dias Corridos';

                        } else if (resolverTipo == 5) { /*Se o tempo estiver em dias*/
                            resolverTratado = (resolverQntmin  / 60 / 24 / 30) + ' Mes(es)';

                        }

                        widget.currentRow['DSPRIORIDADE' + nmPrioridade]        = slaprioridade.DSPRIORIDADECLI;
                        widget.currentRow['RESPONDER' + nmPrioridade]           = responderTratado;
                        widget.currentRow['RESPONDER' + nmPrioridade+'_OPTION'] = responderTipo
                        widget.currentRow['RESOLVER' + nmPrioridade]            = resolverTratado;
                        widget.currentRow['RESOLVER' + nmPrioridade+'_OPTION']  = resolverTipo
                        widget.currentRow['NRHORATRAB' + nmPrioridade]          = slaprioridade.NRHORATRAB;
                        widget.currentRow['MANDAEMAIL' + nmPrioridade]          = slaprioridade.IDENVIAREMAIL;
                        widget.currentRow['AVISO' + nmPrioridade]               = slaprioridade.DSTPREAL;

                    }.bind(this));
                }.bind(this));
                wid.enabled = true;
                
                if(widget.currentRow.IDATIVO == "N"){
                    widget.getAction('DELETE').label = "Ativar";
                    widget.getAction('EDIT').isVisible = true;
                    wid.template = "widget/grid.html" ;
                    wid.actions.forEach(function(action){
                        action.isVisible = false;
                    });
                }else{
                    widget.getAction('DELETE').label = "Inativar";
                    widget.getAction('EDIT').isVisible = true;
                    wid.template = "widget/master_detail/grid.html";
                    wid.actions.forEach(function(action){
                        action.isVisible = true;
                    });
                }
                setTimeout(function() {
                    widget.reload();
                }, 4);
            } else if (widget.mode === "edit") {

                var NRSEQSLA = widget.currentRow.NRSEQSLA;
                restEngine.post("product#/crud/crm_slaprioridade", {
                    'requestType': 'FilterData',
                    filter: [{
                        operator: "=",
                        name: "NRSEQSLA",
                        value: NRSEQSLA
                    }]
                }).
                then(function(response) {

                    var slaprioridades = response.dataset.crm_slaprioridade;
                    slaprioridades.forEach(function(slaprioridade) {

                        var nmPrioridade = slaprioridade.DSPRIORIDADECLI;

                        var responderTipo   = parseInt(slaprioridade.IDTPRESPONDER);
                        var resolverTipo    = parseInt(slaprioridade.IDTPRESOLVER);
                        var responderQntmin = parseInt(slaprioridade.NRTEMPORESPSLA);
                        var resolverQntmin  = parseInt(slaprioridade.NRTEMPOSOLUSLA);
                        var responderTratado;
                        var resolverTratado;

                        if (responderTipo == 1) { /*Se o tempo estiver em mintos*/
                            responderTratado = parseInt(responderQntmin);

                        } else if (responderTipo == 2) { /*Se o tempo estiver em horas*/
                            responderTratado = (responderQntmin / 60);

                        } else if (responderTipo == 3) { /*Se o tempo estiver em dias*/
                            responderTratado = (responderQntmin / 60 / 24);

                        } else if (responderTipo == 4) { /*Se o tempo estiver em dias*/
                            responderTratado = (responderQntmin / 60 / 24);
                            
                        } else if (responderTipo == 5) { /*Se o tempo estiver em dias*/
                            responderTratado = (responderQntmin / 24 / 30);
                        }

                        if (resolverTipo == 1) { /*Se o tempo estiver em mintos*/
                            resolverTratado = parseInt(resolverQntmin);

                        } else if (resolverTipo == 2) { /*Se o tempo estiver em horas*/
                            resolverTratado = (resolverQntmin / 60);

                        } else if (resolverTipo == 3) { /*Se o tempo estiver em dias*/
                            resolverTratado = (resolverQntmin / 60 / 24);

                        } else if (resolverTipo == 4) { /*Se o tempo estiver em dias*/
                            resolverTratado = (resolverQntmin / 60  / 24);
                            
                        } else if (resolverTipo == 5) { /*Se o tempo estiver em meses*/
                            resolverTratado = (resolverQntmin / 60 / 24 / 30);
                        }

                        widget.currentRow['DSPRIORIDADECLI' + nmPrioridade] = slaprioridade.DSPRIORIDADECLI;
                        widget.currentRow['RESPONDER' + nmPrioridade]       = parseInt(responderTratado);
                        widget.currentRow['TPRESPONDER' + nmPrioridade]     = parseInt(slaprioridade.IDTPRESPONDER);
                        widget.currentRow['RESOLVER' + nmPrioridade]        = parseInt(resolverTratado);
                        widget.currentRow['TPRESOLVER' + nmPrioridade]      = parseInt(slaprioridade.IDTPRESOLVER);
                        widget.currentRow['NRHORATRAB' + nmPrioridade]      = slaprioridade.NRHORATRAB;
                        widget.currentRow['NRHORATRAB' + nmPrioridade]      = slaprioridade.NRHORATRAB;
                        widget.currentRow['MANDAEMAIL' + nmPrioridade]      = slaprioridade.IDENVIAREMAIL;
                        widget.currentRow['NRSLAPRIORIDADE' + nmPrioridade] = slaprioridade.NRSLAPRIORIDADE;


                    }.bind(this));
                }.bind(this));
            }
        }, 4)

    };

    this.openSwipeCliente = function() {
        var widget = templateManager.container.getWidget('WDGT_CLIENTES');
        ScreenService.openSwipe(widget);
    };
    
    this.openSwipeProduto = function() {
        var widget = templateManager.container.getWidget('WDGT_PRODUTOS');
        ScreenService.openSwipe(widget);
    };

    this.vincularCliente = function(widget) {

        var dataset = {};
        dataset.rows = widget.getCheckedRows();
        dataset.nrseqsla = templateManager.container.getWidget('WDGT_CADASTRO_SLA').currentRow.NRSEQSLA;


        if (dataset.rows && dataset.rows.length !== 0) {

            var wid = templateManager.container.getWidget('WDGT_VINCULO_SLA_CLIENTE');
             
            var clientes = widget.getCheckedRows();
            
            var NRPARCNEGOCIO = clientes.map(function(cliente) {
                    return cliente.NRPARCNEGOCIO;
            });
            var NRSEQSLA = wid.currentRow.NRSEQSLA;
            restEngine.post("product#/crud/crm_vinculoSlaCliente", {
                'requestType': 'FilterData',
                filter: [
                    {
                    operator: "IN",
                    name: "NRPARCNEGOCIO",
                    value: NRPARCNEGOCIO
                    },
                    {
                    operator: "=",
                    name: "NRSEQSLA",
                    value: ""
                    }
                ]
            }).
            then(function(response) {
                var clienteJaVinculados = response.dataset.crm_vinculoSlaCliente;
                
                if(clienteJaVinculados.length == 0){
                    
                    General.callRestEngine("product#/crm_sla_vincula/sla_vinculo", "DataSet", [dataset]).then(function(response) {
                ScreenService.closeSwipe().then(function() {

                    widget.reload();
                    wid.reload();
                });

            }.bind(this));
                }else{
                    ScreenService.showMessage('Cliente ja em SLA');
                }
            }.bind(this));


        } else {
            ScreenService.showMessage('Selecione um cliente');

        }
    };

    this.deleteCliente = function(widget) {
        ScreenService.confirmMessage('Deseja realmente desvincular o Cliente à SLA?', 'QUESTION',
            function(success) {
                var paramsRestEngine = {
                    requestType: 'Row',
                    row: widget.currentRow
                };

                restEngine.post('product#/crm_sla_vincula/sla_vinculo_delete', paramsRestEngine).
                then(function(response) {

                    ScreenService.showMessage('Cliente desvinculado');
                    ScreenService.closeSwipe().then(function() {
                        ScreenService.closePopup(true);
                        widget.reload();
                    });

                }).catch(function(error) {
                    ScreenService.showMessage(error.data.error);
                });
            },
            function(cancel) {

            });



    };

    this.mensagemAvisoMinuto = function(dia, hora, minuto) {
        var msg;
        if (dia == 0) {
            if (hora == 0) {
                if (minuto == 1) {
                    msg = minuto + " Minuto ";
                } else {
                    msg = minuto + " Minutos ";
                }
            } else {
                if (hora == 1) {
                    if (minuto == 0) {
                        msg = hora + " Hora ";
                    } else if (minuto == 1) {
                        msg = hora + " Hora e " + minuto + " Minuto";
                    } else {
                        msg = hora + " Hora e " + minuto + " Minutos";
                    }
                } else {
                        if (minuto == 0) {
                        msg = hora + " Horas ";
                    } else if (minuto == 1) {
                        msg = hora + " Horas e " + minuto + " Minuto";
                    } else {
                        msg = hora + " Horas e " + minuto + " Minutos";
                    }
                }
            }

        } else if (dia == 1) {
            if (hora == 0) {
                if (minuto == 1) {
                    msg = dia + " Dia e " + minuto + " Minuto ";
                } else if (minuto == 0) {
                    msg = dia + " Dia";
                } else {
                    msg = dia + " Dia e " + minuto + " Minutos ";
                }
            } else {
                if (hora == 1) {
                    if (minuto == 0) {
                        msg = dia + " Dia e " + hora + " Hora ";
                    } else if (minuto == 1) {
                        msg = dia + " Dia, " + hora + " Hora e " + minuto + " Minuto";
                    } else {
                        msg = dia + " Dia,  " + hora + " Hora e " + minuto + " Minutos";
                    }
                } else {
                    if (minuto == 0) {
                        msg = dia + " Dia e " + hora + " Horas ";
                    } else if (minuto == 1) {
                        msg = dia + " Dia, " + hora + " Horas e " + minuto + " Minuto";
                    } else {
                        msg = dia + " Dia,  " + hora + " Horas e " + minuto + " Minutos";
                    }
                }
            }

        } else {
            if (hora == 0) {
                if (minuto == 1) {
                    msg = dia + " Dias e " + minuto + " Minuto ";
                } else if (minuto == 0) {
                    msg = dia + " Dias";
                } else {
                    msg = dia + " Dias e " + minuto + " Minutos ";
                }
            } else {
                if (hora == 1) {
                    if (minuto == 0) {
                        msg = dia + " Dias e " + hora + " Hora ";
                    } else if (minuto == 1) {
                        msg = dia + " Dias, " + hora + " Hora e " + minuto + " Minuto";
                    } else {
                        msg = dia + " Dias,  " + hora + " Hora e " + minuto + " Minutos";
                    }
                } else {
                    if (minuto == 0) {
                        msg = dia + " Dias e " + hora + " Horas ";
                    } else if (minuto == 1) {
                        msg = dia + " Dias, " + hora + " Horas e " + minuto + " Minuto";
                    } else {
                        msg = dia + " Dias,  " + hora + " Horas e " + minuto + " Minutos";
                    }
                }
            }

        }

        return msg;
    };

    this.mensagemAvisoMes = function(mes, dia) {
        var msg;

        if (dia == 0) {
            if (mes == 1) {
                msg = mes + " Mes ";
            } else {
                msg = mes + " Meses ";
            }
        } else {
            if (mes == 1) {
                if (dia == 1) {
                    msg = mes + " Mes e " + dia + " Dia ";
                } else {
                    msg = mes + " Mes e " + dia + " Dias ";
                }
            } else if (mes == 0) {
                if (dia == 1) {
                    msg = dia + " Dia ";
                } else {
                    msg = dia + " Dias ";
                }
            } else {
                if (dia == 1) {
                    msg = mes + " Meses e " + dia + " Dia ";
                } else {
                    msg = mes + " Meses e " + dia + " Dias ";
                }
            }
        }
        return msg;
    };

    this.calculaMinuto = function(widget, preFixCampo, prioridadeNomeResp, qntHRStrab) {
        var tempoMsg;
        var qntMinSet = widget.currentRow[preFixCampo + prioridadeNomeResp];
        for (var i = 0; i < qntHRStrab.length; i++) {
            var minTrab = qntHRStrab[i] * 60 / 100;

            if (qntMinSet > 0 && i + 1 < qntHRStrab.length) {
                qntMinSet = qntMinSet - minTrab;
                var d = i;

            } else {
                if (qntMinSet == 0) {
                    var dias = d + 1;
                    tempoMsg = self.mensagemAvisoMinuto(dias, 0, 0);
                    var minDReal = dias*24*60;
                    widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minDReal;

                } else {
                    var dias = d;
                    var minutosHora = qntMinSet + qntHRStrab[i-1] * 60 / 100;
                    if (minutosHora >= 60) {
                        var horaMinutos = parseInt(minutosHora / 60);
                        minutosHora = minutosHora - (horaMinutos * 60);
                        if (minutosHora == 0) {
                            tempoMsg = self.mensagemAvisoMinuto(dias, horaMinutos, 0);
                            var minHReal = horaMinutos *  60;
                            var minDReal = (dias*24*60) + minHReal;
                            widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minDReal;
                             break;
                        } else {
                            tempoMsg = self.mensagemAvisoMinuto(dias, horaMinutos, minutosHora);
                            var minHReal = horaMinutos *  60;
                            var minDReal = (dias*24*60) + minHReal + parseInt(minutosHora);
                            widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minDReal;
                            break;
                        }
                    } else {
                        tempoMsg = self.mensagemAvisoMinuto(dias, 0, minutosHora);
                        var minDReal = (dias*24*60) + parseInt(minutosHora);
                        widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minDReal;
                        break;
                    }
                }

               
            }
        }
        return tempoMsg;
    };

    this.calculaHora = function(widget, preFixCampo, prioridadeNomeResp, qntHRStrab) {
        var tempoMsg;
        var qntHoraSet = widget.currentRow[preFixCampo + prioridadeNomeResp] * 100;
        for (var i = 0; i < qntHRStrab.length; i++) {
            if (qntHoraSet > 0 && i + 1 < qntHRStrab.length) {
                qntHoraSet = qntHoraSet - qntHRStrab[i];
                var h = i;
            } else {
                if (qntHoraSet == 0) {
                    var dias = h + 1;
                    tempoMsg = self.mensagemAvisoMinuto(dias, 0, 0);
                    var minDReal = dias*24*60;
                    widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minDReal;
                     
                } else {
                    qntHoraSet = (qntHoraSet + qntHRStrab[h]) / 100;
                    var dias = h;
                    var horaMinutos = Math.round(qntHoraSet);
                    var minutosHora = Math.round(qntHoraSet) * 100 - (qntHoraSet * 100);
                    if (minutosHora == 0) {
                        tempoMsg = self.mensagemAvisoMinuto(dias, horaMinutos, 0);
                        var minHReal = horaMinutos *  60;
                        var minDReal = (dias*24*60) + minHReal;
                        widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minDReal;
                    } else {
                        tempoMsg = self.mensagemAvisoMinuto(dias, horaMinutos, parseInt(minutosHora));
                        var minHReal = horaMinutos *  60;
                        var minDReal = (dias*24*60) + minHReal + parseInt(minutosHora);
                        widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minDReal;
                    }

                }
                break;
            }
        }
        return tempoMsg;
    };

    this.calculaDiaUtil = function(widget, preFixCampo, prioridadeNomeResp, diasAbertos) {
        var tempoMsg;
        var qntDiaSet = widget.currentRow[preFixCampo + prioridadeNomeResp];
        var qntDiaAberto = diasAbertos.length;
        var qntSemana = parseInt(qntDiaSet / qntDiaAberto);
        if (qntSemana == qntDiaSet / qntDiaAberto) {
            qntSemana = qntSemana - 1
        };
        var qntDiaSemana = (qntSemana * 7) - qntDiaSet;
        var diferencaDias = (qntSemana * 7) - (qntSemana * qntDiaAberto);
        qntDiaSet = qntDiaSet + diferencaDias;

        if (qntDiaSet >= 30) {
            var qntMesSet = parseInt(qntDiaSet / 30);
            qntDiaSet = qntDiaSet - (qntMesSet * 30);
            if (qntDiaSet == 0) {
                tempoMsg = self.mensagemAvisoMes(qntMesSet, 0);
                var minMReal = qntMesSet * 30 * 24 * 60;
                widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minMReal;
            } else {
                tempoMsg = self.mensagemAvisoMes(qntMesSet, qntDiaSet);
                
                var minMReal = qntMesSet * 30 * 24 * 60;
                var minDReal = (qntDiaSet*24*60) + minMReal;
                widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minDReal;
            }

        } else {
            tempoMsg = self.mensagemAvisoMes(0, qntDiaSet);
   
            var minDReal = (qntDiaSet*24*60);
            widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minDReal;
        }
        return tempoMsg;

    };

    this.calculaDiaCorrido = function(widget, preFixCampo, prioridadeNomeResp) {
        var tempoMsg;
        var qntDiaSet = widget.currentRow[preFixCampo + prioridadeNomeResp];
        if (qntDiaSet >= 30) {
            var qntMesSet = parseInt(qntDiaSet / 30);
            qntDiaSet = qntDiaSet - (qntMesSet * 30);
            if (qntDiaSet == 0) {
                tempoMsg = self.mensagemAvisoMes(qntMesSet, 0);
                 var minMReal = qntMesSet * 30 * 24 * 60;
                widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minMReal;
            } else {
                tempoMsg = self.mensagemAvisoMes(qntMesSet, qntDiaSet);
                 var minMReal = qntMesSet * 30 * 24 * 60;
                var minDReal = (qntDiaSet*24*60) + minMReal;
                widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minDReal;
            }
        } else {
            tempoMsg = self.mensagemAvisoMes(0, qntDiaSet);
            
            var minDReal = (qntDiaSet*24*60);
            widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minDReal;
        }
        return tempoMsg;
    };
    
    this.verificaMaiorMenor = function(args) {
        var widget = templateManager.container.getActiveWidget();
        var prioridade = args.owner.field.name.replace('_OPTION','');
        var nome = prioridade.split("RESPONDER");
        var prioridadeNomeResp;
        var prioridadeNomeRelv;
        var tempoResposta;
        var tempoResolucao;
        if (nome.length === 2) {
            prioridadeNomeResp = nome[1];
            prioridadeNomeRelv = nome[1];
        } else {
            nome = prioridade.split("RESOLVER");
            if (nome.length === 2) {
                prioridadeNomeRelv = nome[1];
                prioridadeNomeResp = nome[1];
            } else {
                nome = prioridade.split("NRHORATRAB");
                prioridadeNomeRelv = nome[1];
                prioridadeNomeResp = nome[1];
            }
        }
        
        if (!Util.isEmptyOrBlank(widget.currentRow['RESPONDER' + prioridadeNomeResp]) && !Util.isEmptyOrBlank(widget.currentRow['RESOLVER' + prioridadeNomeRelv]) && widget.currentRow['NRHORATRAB' + prioridadeNomeRelv] != null) {
     
                var tipoResposta = widget.currentRow['RESPONDER' + prioridadeNomeResp + '_OPTION'] ;
                var tipoResolver = widget.currentRow['RESOLVER' + prioridadeNomeResp + '_OPTION'] 
                var tempoTextResp;
                var tempoResp = widget.currentRow['RESPONDER' + prioridadeNomeResp];
                var tempoTextResv;
                var tempoResv = widget.currentRow['RESOLVER' + prioridadeNomeResp];
                
                if(tipoResposta == tipoResolver){
                    if(tempoResp > tempoResv){
                        ScreenService.showMessage('Tempo de Resolução menor que o tempo de Resposta');
                        widget.currentRow['RESOLVER' + prioridadeNomeResp] = "";
                    }
                }else{
                    /*RESPONDER*/
                     if (tipoResposta == 1) { /*Se o tempo estiver em mintos*/
                        tempoTextResp = tempoResp;
                    } else if (tipoResposta == 2) { /*Se o tempo estiver em horas*/
                        tempoTextResp = tempoResp * 60;
                        tempoResp = tempoTextResp;
                    } else if (tipoResposta == 3) { /*Se o tempo estiver em dias*/
                        tempoTextResp = tempoResp * 60 * 24;
                        tempoResp = tempoTextResp;

                    } else if (tipoResposta == 4) { /*Se o tempo estiver em dias*/
                        tempoTextResp = tempoResp * 60 * 24;
                        tempoResp = tempoTextResp;
                        
                    } else if (tipoResposta == 5) { /*Se o tempo estiver em meses*/
                        tempoTextResp = tempoResp * 60 * 24 * 30;
                        tempoResp = tempoTextResp;
                    }
                    
                    /*RESOLVER*/
                    if (tipoResolver == 1) { /*Se o tempo estiver em mintos*/
                        tempoTextResv = tempoResv;
                    } else if (tipoResolver == 2) { /*Se o tempo estiver em horas*/
                        tempoTextResv = tempoResv * 60;
                        tempoResv = tempoTextResv;
                    } else if (tipoResolver == 3) { /*Se o tempo estiver em dias*/
                        tempoTextResv = tempoResv * 60 * 24;
                        tempoResv = tempoTextResv;
                    } else if (tipoResolver == 4) { 
                        tempoTextResv = tempoResv * 60 * 24;
                        tempoResv = tempoTextResv;
                        
                    }else if (tipoResolver == 5) { /*Se o tempo estiver em meses*/
                        tempoTextResv = tempoResv * 60 * 24 * 30;
                        tempoResv = tempoTextResv;
                    }
                    
                    if(tempoResp > tempoResv){
                        ScreenService.showMessage('Tempo de Resposta maior que o tempo de Resolução');
                        widget.currentRow['RESPONDER' + prioridadeNomeResp] = "";
                    }
                    
                }
        }        
    };

    this.setAviso = function(args) {
        var widget = templateManager.container.getActiveWidget();
        var prioridade = args.owner.field.name.replace('_OPTION','');
        var nome = prioridade.split("RESPONDER");
        var prioridadeNomeResp;
        var prioridadeNomeRelv;
        var tempoResposta;
        var tempoResolucao;

        if (nome.length === 2) {
            prioridadeNomeResp = nome[1];
            prioridadeNomeRelv = nome[1];
        } else {
            nome = prioridade.split("RESOLVER");
            if (nome.length === 2) {
                prioridadeNomeRelv = nome[1];
                prioridadeNomeResp = nome[1];
            } else {
                nome = prioridade.split("NRHORATRAB");
                prioridadeNomeRelv = nome[1];
                prioridadeNomeResp = nome[1];
            }
        }


        if (!Util.isEmptyOrBlank(widget.currentRow['RESPONDER' + prioridadeNomeResp]) && !Util.isEmptyOrBlank(widget.currentRow['RESOLVER' + prioridadeNomeRelv]) && widget.currentRow['NRHORATRAB' + prioridadeNomeRelv] != null) {

            var NRHORATRAB = widget.currentRow['NRHORATRAB' + prioridadeNomeRelv];
            restEngine.post("product#/crud/crm_horatrab", {
                'requestType': 'FilterData',
                filter: [{
                    operator: "=",
                    name: "NRHORATRAB",
                    value: NRHORATRAB
                }]
            }).
            then(function(response) {
                var slaqdhora = response.dataset.crm_horatrab;
                var quadroHorario = slaqdhora[0].NMHORARIO; /*Pega nome do quatro de horario utilizado*/
                var QNTHRTRABSEGUNDA = parseInt(slaqdhora[0].QNTHRTRABSEGUNDA.replace(':', ''));
                var QNTHRTRABTERCA = parseInt(slaqdhora[0].QNTHRTRABTERCA.replace(':', ''));
                var QNTHRTRABQUARTA = parseInt(slaqdhora[0].QNTHRTRABQUARTA.replace(':', ''));
                var QNTHRTRABQUINTA = parseInt(slaqdhora[0].QNTHRTRABQUINTA.replace(':', ''));
                var QNTHRTRABSEXTA = parseInt(slaqdhora[0].QNTHRTRABSEXTA.replace(':', ''));
                var QNTHRTRABSABADO = parseInt(slaqdhora[0].QNTHRTRABSABADO.replace(':', ''));
                var QNTHRTRABDOMINGO = parseInt(slaqdhora[0].QNTHRTRABDOMINGO.replace(':', ''));
                var IDABERTO_SEGUNDA = slaqdhora[0].IDABERTO_SEGUNDA;
                var IDABERTO_TERCA = slaqdhora[0].IDABERTO_TERCA;
                var IDABERTO_QUARTA = slaqdhora[0].IDABERTO_QUARTA;
                var IDABERTO_QUINTA = slaqdhora[0].IDABERTO_QUINTA;
                var IDABERTO_SEXTA = slaqdhora[0].IDABERTO_SEXTA;
                var IDABERTO_SABADO = slaqdhora[0].IDABERTO_SABADO;
                var IDABERTO_DOMINGO = slaqdhora[0].IDABERTO_DOMINGO;
                var idAberto = [IDABERTO_SEGUNDA, IDABERTO_TERCA, IDABERTO_QUARTA, IDABERTO_QUINTA, IDABERTO_SEXTA, IDABERTO_SABADO, IDABERTO_DOMINGO];
                var diasAbertos = idAberto.filter(function(dia) {
                    return dia == "S";
                });
                var qntHRStrab = [QNTHRTRABSEGUNDA, QNTHRTRABTERCA, QNTHRTRABQUARTA, QNTHRTRABQUINTA, QNTHRTRABSEXTA, QNTHRTRABSABADO, QNTHRTRABDOMINGO];
   
                /*calcula tempoo real de resposta*/
                if (widget.currentRow['RESPONDER' + prioridadeNomeResp + '_OPTION'] == 1) {
                    tempoResposta = self.calculaMinuto(widget, 'RESPONDER', prioridadeNomeResp, qntHRStrab);

                } else if (widget.currentRow['RESPONDER' + prioridadeNomeResp + '_OPTION'] == 2) {
                    tempoResposta = self.calculaHora(widget, 'RESPONDER', prioridadeNomeResp, qntHRStrab);

                } else if (widget.currentRow['RESPONDER' + prioridadeNomeResp + '_OPTION'] == 3) {

                    tempoResposta = self.calculaDiaUtil(widget, 'RESPONDER', prioridadeNomeResp, diasAbertos);


                } else if (widget.currentRow['RESPONDER' + prioridadeNomeResp + '_OPTION'] == 4) {
                    tempoResposta = self.calculaDiaCorrido(widget, 'RESPONDER', prioridadeNomeResp);

                } else if (widget.currentRow['RESPONDER' + prioridadeNomeResp + '_OPTION'] == 5) {

                    tempoResposta = self.calculaMesUtil(widget, 'RESPONDER', prioridadeNomeResp, diasAbertos);
                }

                /*calcula tempo real de resolver*/
                if (widget.currentRow['RESOLVER' + prioridadeNomeResp + '_OPTION'] == 1) {
                    tempoResolucao = self.calculaMinuto(widget, 'RESOLVER', prioridadeNomeResp, qntHRStrab);

                } else if (widget.currentRow['RESOLVER' + prioridadeNomeResp + '_OPTION'] == 2) {
                    tempoResolucao = self.calculaHora(widget, 'RESOLVER', prioridadeNomeResp, qntHRStrab);

                } else if (widget.currentRow['RESOLVER' + prioridadeNomeResp + '_OPTION'] == 3) {
                    tempoResolucao = self.calculaDiaUtil(widget, 'RESOLVER', prioridadeNomeResp, diasAbertos);

                } else if (widget.currentRow['RESOLVER' + prioridadeNomeResp + '_OPTION'] == 4) {
                    tempoResolucao = self.calculaDiaCorrido(widget, 'RESOLVER', prioridadeNomeResp);

                } else if (widget.currentRow['RESOLVER' + prioridadeNomeResp + '_OPTION'] == 5) {
                    tempoResolucao = self.calculaMesUtil(widget, 'RESOLVER', prioridadeNomeResp, diasAbertos);

                }

                /*Ativa o SPAN*/
                widget.getField('AVISO' + prioridadeNomeResp).isVisible = true;

                /*Seta texto no span*/
                widget.currentRow['AVISO' + prioridadeNomeResp] = " Tempo real de resposta é: " + tempoResposta + " | Tempo real de Resolução é: " + tempoResolucao + " (Tempo calculado de acordo com a parametrização do " + quadroHorario + ")";
            }.bind(this));



        }
        if (Util.isEmptyOrBlank(widget.currentRow['RESPONDER' + prioridadeNomeResp]) || Util.isEmptyOrBlank(widget.currentRow['RESOLVER' + prioridadeNomeRelv]) || widget.currentRow['NRHORATRAB' + prioridadeNomeRelv] == null) {
            widget.getField('AVISO' + prioridadeNomeResp).isVisible = false;
        }

    };

    this.filtraDataSource = function(widget) {
        var wid = templateManager.container.getWidget('WDGT_VINCULO_SLA_CLIENTE').dataSource.data;

        var rows = [];
        rows = wid.map(function(row) {
            return row['NRPARCNEGOCIO'];
        });
        if (rows && rows.length > 0) {
            widget.dataSourceFilter = [{
                    "name": "NRORG",
                    "operator": "IN",
                    "value": "@[getLocalVar('CRM_NRORGTRAB'), getLocalVar('CRM_NRORGPADRAO')]@"
                },
                {
                    "name": "NRPARCNEGOCIO",
                    "operator": "NOT_IN",
                    "value": rows
                }

            ];
        }
        widget.clearSearchList();
        widget.clearSearchCriteria();
        widget.reload();
    };

    this.filtroVinculo = function(widget) {
        widget.dataSourceFilter = [
            {
                "name": "NRORG",
                "operator": "IN",
                "value": "@[getLocalVar('CRM_NRORGTRAB'), getLocalVar('CRM_NRORGPADRAO')]@"
            },
            {
                "name": "NRSEQSLA",
                "operator": "=",
                "value": widget.parent.parent.currentRow.NRSEQSLA
            }
        ];
        if(widget.lastFilter !== widget.parent.parent.currentRow.NRSEQSLA){
            widget.reload();
            widget.lastFilter = widget.parent.parent.currentRow.NRSEQSLA;
        }
        

    };
    
    this.ocultaAviso = function() {
       
        var nomePrioridades = self.nomePrioridades();
        nomePrioridades.forEach(function(nomePrioridade){
            
            var wid = templateManager.container.getWidget('WDGT_CADASTRO_SLA');
            setTimeout(function() {
            if(wid.mode == "edit"){
                wid.getField('AVISO'+nomePrioridade).isVisible = false;
            }else{
                wid.getField('AVISO'+nomePrioridade).isVisible = true;
            }
            }, 4);
        });
    };
    
    this.formataFiel = function() {
         setTimeout(function() {
            var nomePrioridades = self.nomePrioridades();
            nomePrioridades.forEach(function(nomePrioridade){
                var wid = templateManager.container.getWidget('WDGT_CADASTRO_SLA');
                if(wid.mode == "edit"){
                    wid.getField('RESPONDER'+nomePrioridade).class = "textSelect";
                     wid.getField('RESOLVER'+nomePrioridade).class = "textSelect";
                }else if(wid.mode == "view"){
                    wid.getField('RESPONDER'+nomePrioridade).class = 3;
                    wid.getField('RESOLVER'+nomePrioridade).class = 3;
                }
                
            });
             
         }, 4); 
        
    };
    
    this.selecionarProdutoCliente = function(widget) {
        if(widget.getCheckedRows().length == 0){
            ScreenService.showMessage('Selecione um produto');
        }else{
            var dataset = {};
            var trataCheckedRows = widget.getCheckedRows();
            dataset.rows = trataCheckedRows.map(function(trataCheckedRow){
                var NRTPARVPROD = trataCheckedRow.NRTPARVPROD;
                var NRARVOREPROD = parseInt(trataCheckedRow.PARENT.replace(NRTPARVPROD, ''));
                
                if(NRTPARVPROD == NRARVOREPROD){
                    trataCheckedRow.NRTPARVPROD = NRTPARVPROD;
                    trataCheckedRow.NRARVOREPROD = NRTPARVPROD;
                }else{
                    trataCheckedRow.NRTPARVPROD = NRTPARVPROD;
                    trataCheckedRow.NRARVOREPROD = NRARVOREPROD;
                }
                
                return trataCheckedRow;
            });
            dataset.nrslaparcnegocio = widget.parent.parent.currentRow.NRSLAPARCNEGOCIO;
            
            
                 General.callRestEngine("product#/crm_sla_vincula/parcnegocioSlaProduto", "DataSet", [dataset]).then(function(response) {
                ScreenService.closeSwipe().then(function() {

                    widget.reload();
                    widget.parent.parent.reload();
                 
                });

            }.bind(this));
            
            
            
        }
    };
    
    this.filtroProdutoParc = function(widget) {
        var NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var NRSEQSLA = widget.parent.parent.currentRow.NRSEQSLA;
        widget.dataSourceFilter = [
                                            {
                                                "name": "NRORG",
                                                "operator": "=",
                                                "value": "@[getLocalVar('CRM_NRORGTRAB')]@"
                                            },
                                            {
                                                "name": "NRPARCNEGOCIO",
                                                "operator": "=",
                                                "value": NRPARCNEGOCIO
                                            },
                                            {
                                                "name": "NRSEQSLA",
                                                "operator": "=",
                                                "value": NRSEQSLA
                                            }
                                            ];
       
        widget.reload();
    };
    
    this.filtroProduto = function(widget) {
         var wid = templateManager.container.getWidget('WDGT_CLIENTES_PRODUTO').dataSource.data;

        var rows = [];
        rows = wid.map(function(row) {
            return row['CDPRODUTO'];
        });
         if (rows && rows.length > 0) {
             widget.dataSourceFilter = [
                                            {
                                                "name": "NRORG",
                                                "operator": "=",
                                                "value": "@getLocalVar('CRM_NRORGTRAB')@"
                                            },
                                            {
                                                "name": "NRTPARVPROD",
                                                "operator": "=",
                                                "value": ""
                                            },
                                            {
                                                "name": "ID",
                                                "operator": "NOT_IN",
                                                "value": rows
                                            }
                                            ];
             widget.reload();
         }
        
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register("crm_cadastro_slaController", crm_cadastro_slaController);
});

// FILE: ./assets/js/controllers/CRM_Cliente_Controller.js
function CRM_Cliente_Controller(AbaInterlocutorController, ABAEnderecoParceiroController, ABALogotipoParceiroController, PartnerInfosModalController, ScreenService, Utilities, templateManager, General, restEngine, CRM_Utilities, ABEvolucaoController, Messages, evolutionTabController, ZhFilterPreferences, CRM_ParceiroNegocio_Service, ZHPromise) {
    var self = this;
    /**
     * Executa as funções necessárias no evento
     * "WidgetOnEnterOnce" da widget de prospect.
     * 
     * @param {object} widget widget de prospect
     * ("gridProspect").
    */
    this.widgetOnEnterOnce = function(widget, fieldsToApply) {
        
        var filterRow = {};
        var wdgt = templateManager.container.getWidget('gridCliente');
        
        if((typeof templateManager !== 'undefined') && templateManager.LOGGEDOPERATOR){
            filterRow.IDOPERATIVO = 'A';
            filterRow.CDOPERRESPONSAVEL = [templateManager.LOGGEDOPERATOR.CDOPERADOR];
            
            if(widget.name === 'gridCliente' )
                CRM_Utilities.openFilterOnEnter(widget, filterRow, fieldsToApply);
            else{
                widget.dataSource.data = wdgt.dataSource.data;
                widget.appliedFilter = wdgt.appliedFilter;
            }
        }
        
        AbaInterlocutorController.setInterlocutorWidgetOnActiveWidget(widget, 3);
        ABAEnderecoParceiroController.setAddressWidgetOnActiveWidget(widget, 2);
        PartnerInfosModalController.setModalWidgetOnActiveWidget(widget, 'NRPARCNEGOCIO');
        ABALogotipoParceiroController.setLogoWidgetOnActiveWidget(widget, 8);
        
        //this.setResaleRules(widget); 
        //this.checkParamToAddProspect(widget);
        
    };
    
    this.changeValueFilterCliente = function(widget) {
        var grid = widget;
        var filterCliente = templateManager.container.getWidget("gridCliente");
        var getFieldParcResp = filterCliente.getField('CDOPERRESPONSAVEL');
    
        if (grid.currentRow.IDOPERATIVO == "I") {
            getFieldParcResp.dataSourceFilter[1].value = "I";
            grid.getField('CDOPERRESPONSAVEL').clearValue();
            getFieldParcResp.reload();
        } else {
            getFieldParcResp.dataSourceFilter[1].value = "A";
            getFieldParcResp.reload();
        }
    };

    this.saveClienteAndSetAudit = function(){
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow.NRINSJURCLIE = widget.currentRow.NRINSJURCLIE.toString().replace(/[^0-9]/g,'');
        widget.currentRow.CDOPERADOR = templateManager.LOGGEDOPERATOR.CDOPERADOR;
        widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        this.setAuditInfo(widget);
        
        if(widget.isValid()) {
            CRM_Utilities.saveWidget(widget, false).then(function(response) {
                if(widget.currentRow.__is_new) {
                    widget.currentRow.NRPARCNEGOCIO = response.dataset.DADOS.NRPARCNEGOCIO;
                }
                
                this.updateEnderecoCliente(widget).then(function() {
                    widget.reload();
                }).catch(function(error) {
                    CRM_Utilities.showErrorMessage(error);
                    widget.reload();
                });
                
                widget.currentRow.NRCONCORRPROSPECT = response.dataset.CONCORRENTE ? response.dataset.CONCORRENTE.NRCONCORRPROSPECT : widget.currentRow.NRCONCORRPROSPECT;
                
                widget.view();
            }.bind(this));   
        }
	};
	
	this.setAuditInfo = function(widget){
        var currentRow = widget.currentRow;
        
        if(widget.currentRow.__is_new) {
            currentRow.DTINCLUSAO = self.momentNow();
            currentRow.CDOPERINCLUSAO = templateManager.LOGGEDOPERATOR.CDOPERADOR;
            currentRow.CDOPERULTATU = templateManager.LOGGEDOPERATOR.CDOPERADOR;
            currentRow.NMOPERULTATU = templateManager.LOGGEDOPERATOR.NMOPERADOR; 
            currentRow.NRORGULTATU = currentRow.NRORG;
        }else{
            currentRow.DTULTATU = self.momentNow();
            currentRow.CDOPERULTATU = templateManager.LOGGEDOPERATOR.CDOPERADOR;
            currentRow.NMOPERULTATU = templateManager.LOGGEDOPERATOR.NMOPERADOR; 
            currentRow.NRORGULTATU = currentRow.NRORG;
        }
    };
    
    this.momentNow = function(){
        return moment(new Date()).format('DD/MM/YYYY HH:mm:ss');
    };
    
    this.updateEnderecoCliente = function(widget) {
	    
	    // Promise que será resolvida quando o endereço for salvo
	    var deferred = ZHPromise.defer();
	    
	    var parametroRestEngine = {
                    'requestType':'Row',
                    'row': {'NRPARCNEGOCIO': widget.currentRow.NRPARCNEGOCIO, 'NRORG': widget.currentRow.NRORG}
                };
        
        restEngine.post('/crm_enderecoparc/findEndereco', parametroRestEngine,
            function(response) {
                var row = {
        	      NRPARCNEGOCIO: widget.currentRow.NRPARCNEGOCIO,
        	      CDTIPOENDERECO: 'PRINCIPAL',
        	      NRORG: widget.currentRow.NRORG,
        	      IDATIVO: 'S',
        	      CDPAIS: widget.currentRow.CDPAIS,
        	      SGESTADO: widget.currentRow.SGESTADO,
        	      CDMUNICIPIO: widget.currentRow.CDMUNICIPIO,
        	      CDBAIRRO: widget.currentRow.CDBAIRRO,
        	      CDLOGRADOURO: widget.currentRow.CDLOGRADOURO,
        	      NMBAIRROENDERECO: widget.currentRow.NMBAIRROENDERECO,
        	      DSCOMPLEENDERECO: widget.currentRow.DSCOMPLEENDERECO,
        	      NRCEPENDERECO: widget.currentRow.NRCEPENDERECO,
        	      DSENDERECO: widget.currentRow.DSENDERECO,
        	      NRIMOVELENDERECO: widget.currentRow.NRIMOVELENDERECO
        	    };
	    
	            if(response.dataset.columnsToReturn[0]) {
	                row.__is_new = false;
	                row.tipoEnderecoWasEdited = false;
	                row.NRENDERECOPARC = response.dataset.columnsToReturn[0].NRENDERECOPARC;
	            } else row.__is_new = true;
	            
        	    CRM_ParceiroNegocio_Service.salvarEndereco(row).then(function(successData) {
                    if (widget.isNewRow()) {
                        widget.currentRow.NRENDERECOPARC = successData.dataset.columnsToReturn.NRENDERECOPARC;
                        widget.currentRow.__is_new = false;
                    }
                    deferred.resolve();
                }, function(error) {
                    var errorMessage = 'Timeout';
                    if (error.data) {
                        errorMessage = error.data.error;
                    }
                    ScreenService.showMessage(errorMessage);
                }).catch(CRM_Utilities.showErrorMessage);
            }, undefined, 
            function(error) {
                console.log(error);
            }, null, 3000000
        );
    
        
        return deferred;
	};
    
    this.actionEvolutionNewRow = function(widName){
            
        this.closeActionsPopup().then(function(){
            var widget = templateManager.container.getWidget(widName);
            
            this.activateWidget(widget).then(function(){
                
                setTimeout(function(){
                    this.evolucaoNewRow();
                }.bind(this),100);
                
            }.bind(this));
            
        }.bind(this));
    };
    
    this.activateWidget = function(widget){
        var deferred = ZHPromise.defer();
        widget.activate();
        deferred.resolve();
        return deferred;
    };
    
    /**
     * Inicia o mvc para realizar um insert de tarefas
     * na widget de Evolução
    */
    this.evolucaoNewRow = function() {
            
        var widget = templateManager.container.getWidget("evolucao");
        
        
        General.widgetNewRow(widget);
        
        var currentRow = widget.currentRow;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        currentRow.DTHREVOLCONT = (currentRow.DTHREVOLCONT)? currentRow.DTHREVOLCONT : moment(new Date()).format('DD/MM/YYYY HH:mm');
        currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
        currentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        
        ABEvolucaoController.setEvolDateChangePermission(widget);
        this.setOperatorNextTask(currentRow, loggedOperatorInfos);
        
        currentRow.DTINCLUSAO = self.momentNow();
        currentRow.NRSEQCONTATO = widget.getParent().currentRow.NRPARCNEGOCIO;

        currentRow.NRORG = loggedOperatorInfos.NRORG;
    };
    
    /**
     * Seta o operador para preparar a proxima tarefa
     * da widget de evolução
     * 
     * @param {object} currentRow pega a currentRow
     * da evolução
     * 
     * @param {object} loggedOperatorInfos objecto com
     * as informações do operador logado.
    */
    this.setOperatorNextTask = function(currentRow, loggedOperatorInfos){
        
        currentRow.NMOPERADORREAL = loggedOperatorInfos.NMOPERADOR;
        currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
        
    };
    
    this.closeActionsPopup = function() {
        var deferred = ZHPromise.defer();
        ScreenService.closePopup();
        deferred.resolve();
        return deferred;
    };
    
    this.evolucaoRowOnEnter = function(widget) {
        var prospectController = CRM_Utilities.getController('ger45000_Prospect_Controller');
        
        prospectController.setEditEvolButtonAction(widget, this.editEvolButtonDefaultCode, 'EDIT');
    };
    
    this.editEvolButtonDefaultCode = 
    'ger45000_Prospect_Controller.cleanTaskGroupIfInvisible(args.owner.widget, "AGENDAR_TAREFA");' +
    'crm00040_Lead_Controller.editEvolution(args.owner.widget);';
         
    this.editClientActionOnClick = function(widget) {
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var parceiroController = CRM_Utilities.getController('CRM_ParceiroNegocio_Controller');
        
        parceiroController.checkIfCanEditOrEvolParc(nrParcNegocio).then(function(canEdit) {
            if(canEdit) {
                General.widgetEdit(widget);
                widget.getField('NRINSJURCLIE').readOnly = false;
                widget.getField('NMRAZSOCCLIE').readOnly = false;
                parceiroController.setInscEstadualSelect(widget);
            } else {
                this.showMessageCantEditParc();
            }
        }.bind(this));
    };
    
    this.addEvolActionOnClick = function(widget) {
        var nrParcNegocio = widget.getParent().currentRow.NRPARCNEGOCIO;
        var prospectController = CRM_Utilities.getController('ger45000_Prospect_Controller');
        var parceiroController = CRM_Utilities.getController('CRM_ParceiroNegocio_Controller');
        
        parceiroController.checkIfCanEditOrEvolParc(nrParcNegocio).then(function(canEdit) {
            if (canEdit) {
                this.actionEvolutionNewRow('evolucao');
                prospectController.setNextTaskVisibility(widget, 'AGENDAR_TAREFA');
            } else {
                this.showMessageCantEditParc();
            }
        }.bind(this));
    };
    
    this.evolveActionOnClick = function(widget) {
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var parceiroController = CRM_Utilities.getController('CRM_ParceiroNegocio_Controller');
        
        parceiroController.checkIfCanEditOrEvolParc(nrParcNegocio).then(function(canEdit) {
            if (canEdit) {
                this.actionEvolutionNewRow('evolucao');
            } else {
                this.showMessageCantEditParc();
            }
        }.bind(this));
    };
    
    this.showMessageCantEditParc = function() {
        var message = 'Ação bloqueada!<br> Somente o operador responsável pelo cliente e seus assistentes podem editá-lo/evoluí-lo.';
        ScreenService.showMessage(message);
    };
    
    this.clientNewRow = function(widget) {
        General.widgetNewRow(widget);
        
        widget.currentRow.NRORG = templateManager.LOGGEDOPERATOR.NRORG;    
        widget.currentRow.CDOPERRESPONSAVEL = templateManager.LOGGEDOPERATOR.CDOPERADOR;
        widget.currentRow.NMOPERRESPONSAVEL = templateManager.LOGGEDOPERATOR.NMOPERADOR;
        widget.currentRow.IDATIVO = 'S';
        widget.currentRow.IDPRIPUBPROS = '';
        widget.currentRow.IDPRIPUBPROS = '';
        widget.currentRow.CDMODODIVULG = '';
        widget.currentRow.CDATIVCLI = '';
        widget.currentRow.CDQUALIF = '';
        widget.currentRow.CDEXPEDIENTE = '';
        widget.currentRow.CDSEGMER = '';
        widget.currentRow.IDSITUPROS = '';
        widget.currentRow.DTNASCPROS = '';
        widget.currentRow.HRINIFUNCPROSP = '';
        widget.currentRow.HRFINFUNCPROSP = '';
        widget.currentRow.IDLIGEXTPROS = '';
        widget.currentRow.NRUNOPPROS = '';
        widget.currentRow.DSCONCORREPROSP = '';
        widget.currentRow.DTENCECONTRATU = '';
        widget.currentRow.DTREVPRECOPROSP = '';
        widget.currentRow.NRSEQTPATIVCLI = '';
        widget.getField('NRINSJURCLIE').readOnly = false;
        widget.getField('NMRAZSOCCLIE').readOnly = false;
        widget.currentRow.IDINSCRESTAD = "ISENTO";
        widget.getField('NRINSESTCLIE').value('ISENTO');
        widget.getField('NRINSESTCLIE').readOnly = true;
    };
    
    this.shootEventsAfterMoveRow = function() {
        var widget = templateManager.container.getWidget('gridCliente');
        var prospController = CRM_Utilities.getController('ger45000_Prospect_Controller');
        var parcNegController = CRM_Utilities.getController('CRM_ParceiroNegocio_Controller');
        
        parcNegController.setInscEstadualSelect(widget);
        prospController.getProspectNrSeqContato(widget);
    }; 

    this.prepararInterlocutor = function (widget) {
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var currentRow = widget.currentRow;
        currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
        currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

        var parceiroController = CRM_Utilities.getController('CRM_ParceiroNegocio_Controller');
    
        parceiroController.checkIfCanEditOrEvolParc(nrParcNegocio).then(
          function (canEdit) {
            if (canEdit) {
              General.callRestEngine("product#/verifyGroupRel", "DataSet", [
                currentRow,
              ]).then(
                function (response) {
                  if (response.dataset && response.dataset.error) {
                    ScreenService.showMessage(response.dataset.error, "ERROR");
                  }
                  if (response.dataset && response.dataset.GROUPREL[0] == false) {
                    var parent = templateManager.container.getWidget(
                      widget.parentName
                    );
    
                    CRM_Utilities.setColumnToReturnInCurrentRow(
                      widget.currentRow,
                      "NRSEQINTERLOCUTOR"
                    );
                    this.removeInterlocutorPhoneMask(widget);
    
                    if(widget.currentRow.NRCPFINTERLOC){
                        widget.currentRow.NRCPFINTERLOC = widget.currentRow.NRCPFINTERLOC.replace(
                          /[^0-9]/g,
                          ""
                        );
                    } else {
                        widget.currentRow.NRCPFINTERLOC = null;
                    };
                    
                    this.salvarInterlocutor(widget.currentRow).then(function (
                      response,
                      widget
                    ) {
                      var currentRow = templateManager.container.getWidget(
                        "popupNovoInterlocutor"
                      );
                      if (currentRow.filtro === true) {
                        var widgetfilter = templateManager.container.getWidget(
                          "popupNovoInterlocutor"
                        ).__filterPopup;
                        var widgetprospect = templateManager.container.getWidget(
                          "gridCliente"
                        );
                        var widgetConvertfilter = templateManager.container.getWidget(
                          "evolucao"
                        );
                        widgetConvertfilter.currentRow.NMINTERLOCUTOR =
                          widget.currentRow.NMINTERLOCUTOR;
    
                        widgetfilter.template = "widget/form.html";
                        widgetfilter.activate();
                        widgetprospect.widgets[0].fields[7].defaultValue =
                          widget.currentRow.NMINTERLOCUTOR;
                        ScreenService.closePopup(true);
                        ScreenService.showMessage(
                          "Interlocutor criado com sucesso!"
                        );
                      } else {
                        var widgetcurrent = templateManager.container.getWidget(
                          "popupNovoInterlocutor"
                        );
    
                        parent.currentRow.NRSEQINTERLOCUTOR =
                          response.dataset.columnsToReturn[0].NRSEQINTERLOCUTOR;
                        parent.currentRow.NMINTERLOCUTOR =
                          widgetcurrent.currentRow.NMINTERLOCUTOR;
                        parent.currentRow.EMAILINTERLOC =
                          widgetcurrent.currentRow.EMAILINTERLOC;
    
                        ScreenService.closePopup(true);
    
                        ScreenService.showMessage(
                          "Interlocutor criado com sucesso!"
                        ).then(function () {
                          parent.activate();
                          parent.reload();
                        });
                      }
                    });
                  } else {
                    ScreenService.showMessage(
                      "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                      response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                      " - " +
                      response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                      "!"
                    );
                  }
                }.bind(this)
              );
            } else {
              this.showMessageCantEditParc();
            }
          }.bind(this)
        );
    };

    this.removeInterlocutorPhoneMask = function (widget) {
        var currentRow = widget.currentRow;
        var phoneFields = ["NRTELEFONE1"];

        phoneFields.forEach(function (phone) {
            if (currentRow[phone]) {
            currentRow[phone] = currentRow[phone].replace(/[^0-9]/g, "");
            }
        });
    };

    this.salvarInterlocutor = function (currentRow) {
        var paramsRestEngine = {
          requestType: "Row",
          row: currentRow,
        };
        return restEngine.post("/crm_interlocutor/save", paramsRestEngine);
    };

    this.selectInterlocutor = function (widget, nameParent){
        var parent = templateManager.container.getWidget(nameParent);

        parent.currentRow.NRSEQINTERLOCUTOR = widget.currentRow.NRSEQINTERLOCUTOR;
        parent.currentRow.NMINTERLOCUTOR = widget.currentRow.NMINTERLOCUTOR;
        parent.currentRow.EMAILINTERLOC = widget.currentRow.EMAILINTERLOC;
    
        ScreenService.closePopup(true);
    }; 

    
}

Configuration(function (ContextRegister) {
    ContextRegister.register("CRM_Cliente_Controller", CRM_Cliente_Controller);
});



// FILE: ./assets/js/controllers/crm_grupodeoperadorControler.js
function crm_grupodeoperadorControler(templateManager, ScreenService, Utilities, restEngine, General, CRM_Utilities, Messages)
{
    this.setOperGrupo = function(widget){
        widget.dataSourceFilter =   [
                                        {
                                            name : "NRFILAATENDIMENTO",
                                            operator : "=",
                                            value : widget.parent.parent.currentRow.NRFILAATENDIMENTO
                                        }
                                    ]; 
        widget.reload();                            
    };
    
    this.saveOperGrupo = function(widget){
       
       var rowGrupo = new Object();
       rowGrupo.NRFILAATENDIMENTO       = widget.parent.parent.currentRow.NRFILAATENDIMENTO;
       rowGrupo.NRORG                   = widget.parent.parent.currentRow.NRORG;
       
        var dataset = {};
        dataset.grupo = rowGrupo;
        dataset.operador =  widget.currentRow.NMOPERADOR; 
        
        General.callRestEngine("product#/grupo_operador/saveOperador", "DataSet", [dataset]).then(function(response) {
                    ScreenService.closeSwipe().then(function() {
                        widget.reload();
                    });

                }.bind(this));
    };
    
    this.grupoDelete = function(widget){
      ScreenService.confirmMessage('Deseja realmente excluir o Grupo de Operador?', 'QUESTION',
        function(success){
            var paramsRestEngine = {
                requestType:'Row',
                row:widget.currentRow
            };
            
            restEngine.post('product#/grupo_operador/excluirGrupoOperador', paramsRestEngine).
                then(function(response){
                    
                        ScreenService.showMessage('Grupo de Operador excluido');
                        ScreenService.closeSwipe().then(function(){
                            ScreenService.closePopup(true);
                            widget.reload();
                        });
                        
                }).catch(function(error){
                    ScreenService.showMessage(error.data.error);    
                });        
        }, 
          function(cancel){
            
        });
        
        
    };
}
Configuration(function(ContextRegister){    ContextRegister.register('crm_grupodeoperadorControler', crm_grupodeoperadorControler);
});

// FILE: ./assets/js/controllers/crm_Horario_Atendimento_Controller.js
function crm_Horario_Atendimento_Controller(ScreenService, templateManager, restEngine, localStorageEngine, General, ZhUtil, CRM_Utilities, Utilities) {
    var self = this;

    this.formatDate = function() {

        var widget = templateManager.container.getWidget('WDGT_HORARIO_ATENDIMENTO');

        var rows = widget.dataSource.data;
        rows.forEach(function(row) {

            if (row.IDABERTO_SEGUNDA === "S") {
                var widget = templateManager.container.getWidget('WDGT_HORARIO_ATENDIMENTO');
                if (row.IDINTERVALO_SEGUNDA === "S") {
                    var horariosegini2 = row.HRINI2SEGUNDA;
                    var horariosegend2 = row.HRFIN2SEGUNDA;
                    var horarioSEGUNDA2 = (horariosegini2 + " às " + horariosegend2);
                    row.SEGUNDA2 = horarioSEGUNDA2;
                    // widget.getField('SEGUNDA2').isVisible = true;
                }
                if (row.HRFIN1SEGUNDA != "" && row.HRFIN1SEGUNDA != null) {
                    var horariosegini = row.HRINI1SEGUNDA;
                    var horariosegend = row.HRFIN1SEGUNDA;
                    var horario2segend = row.HRFIN2SEGUNDA;
                    var horario2SEGUNDA = (horariosegini + " às " + horario2segend);
                    var horarioSEGUNDA = (horariosegini + " às " + horariosegend);
                    row.SEGUNDA = horarioSEGUNDA;
                    row.SEGUNDAGRID = horario2SEGUNDA;
                }
            } else {
                horarioSEGUNDA = "-";
                horario2SEGUNDA = "FECHADO";
                row.SEGUNDA = horarioSEGUNDA;
                row.SEGUNDAGRID = horario2SEGUNDA;
                row.IDINTERVALO_SEGUNDA = 'N';
            }

            if (row.IDABERTO_TERCA === "S") {

                if (row.IDINTERVALO_TERCA === "S") {
                    var horariotercini2 = row.HRINI2TERCA;
                    var horariotercend2 = row.HRFIN2TERCA;
                    var horarioTERCA2 = (horariotercini2 + " às " + horariotercend2);
                    row.TERCA2 = horarioTERCA2;
                    // widget.getField('TERCA2').isVisible = true;
                }
                if (row.HRINI1TERCA != "" && row.HRINI1TERCA != null) {
                    var horarioterini = row.HRINI1TERCA;
                    var horarioterend = row.HRFIN1TERCA;
                    var horario2terend = row.HRFIN2TERCA;
                    var horarioTERCA = (horarioterini + " às " + horarioterend);
                    var horario2TERCA = (horarioterini + " às " + horario2terend);
                    row.TERCA = horarioTERCA;
                    row.TERCAGRID = horario2TERCA;
                }
            } else {
                horarioTERCA = '-';
                horario2TERCA = 'FECHADO';
                row.TERCA = horarioTERCA;
                row.TERCAGRID = horario2TERCA;
                row.IDINTERVALO_TERCA = 'N';
            }

            if (row.IDABERTO_QUARTA === "S") {
  
                if (row.IDINTERVALO_QUARTA === "S") {
                    var horarioquarini2 = row.HRINI2QUARTA;
                    var horarioquarend2 = row.HRFIN2QUARTA;
                    var horarioQUARTA2 = (horarioquarini2 + " às " + horarioquarend2);
                    row.QUARTA2 = horarioQUARTA2;
                }
                if (row.HRINI1QUARTA != "" && row.HRINI1QUARTA != null) {
                    var horarioquarini = row.HRINI1QUARTA;
                    var horarioquarend = row.HRFIN1QUARTA;
                    var horario2quarend = row.HRFIN2QUARTA;
                    var horarioQUARTA = (horarioquarini + " às " + horarioquarend);
                    var horario2QUARTA = (horarioquarini + " às " + horario2quarend);
                    row.QUARTA = horarioQUARTA;
                    row.QUARTAGRID = horario2QUARTA;
                }
            } else {
                horarioQUARTA = "-";
                horario2QUARTA = "FECHADO";
                row.QUARTA = horarioQUARTA;
                row.QUARTAGRID = horario2QUARTA;
                row.IDINTERVALO_QUARTA = 'N';
            }

            if (row.IDABERTO_QUINTA === "S") {

                if (row.IDINTERVALO_QUINTA === "S") {
                    var horarioquinini2 = row.HRINI2QUINTA;
                    var horarioquinend2 = row.HRFIN2QUINTA;
                    var horarioQUINTA2 = (horarioquinini2 + " às " + horarioquinend2);
                    row.QUINTA2 = horarioQUINTA2;
                }
                if (row.HRINI1QUINTA != "" && row.HRINI1QUINTA != null) {
                    var horarioquinini = row.HRINI1QUINTA;
                    var horarioquinend = row.HRFIN1QUINTA;
                    var horario2quinend = row.HRFIN2QUINTA;
                    var horarioQUINTA = (horarioquinini + " às " + horarioquinend);
                    var horario2QUINTA = (horarioquinini + " às " + horario2quinend);
                    row.QUINTA = horarioQUINTA;
                    row.QUINTAGRID = horario2QUINTA;
                }
            } else {
                horarioQUINTA = "-";
                horario2QUINTA = "FECHADO";
                row.QUINTA = horarioQUINTA;
                row.QUINTAGRID = horario2QUINTA;
                row.IDINTERVALO_QUINTA = 'N';

            }

            if (row.IDABERTO_SEXTA === "S") {

                if (row.IDINTERVALO_SEXTA === "S") {
                    var horariosexini2 = row.HRINI2SEXTA;
                    var horariosexend2 = row.HRFIN2SEXTA;
                    var horarioSEXTA2 = (horariosexini2 + " às " + horariosexend2);
                    row.SEXTA2 = horarioSEXTA2;
                }

                if (row.HRINI1SEXTA != "" && row.HRINI1SEXTA != null) {
                    var horariosexini = row.HRINI1SEXTA;
                    var horariosexend = row.HRFIN1SEXTA;
                    var horario2sexend = row.HRFIN2SEXTA;
                    var horarioSEXTA = (horariosexini + " às " + horariosexend);
                    var horario2SEXTA = (horariosexini + " às " + horario2sexend);
                    row.SEXTA = horarioSEXTA;
                    row.SEXTAGRID = horario2SEXTA;
                }
            } else {
                horarioSEXTA = "-";
                horario2SEXTA = "FECHADO";
                row.SEXTA = horarioSEXTA;
                row.SEXTAGRID = horario2SEXTA;
                row.IDINTERVALO_SEXTA = 'N';

            }

            if (row.IDABERTO_SABADO === "S") {


                if (row.IDINTERVALO_SABADO === "S") {
                    var horariosabini2 = row.HRINI2SABADO;
                    var horariosabend2 = row.HRFIN2SABADO;
                    var horarioSABADO2 = (horariosabini2 + " às " + horariosabend2);
                    row.SABADO2 = horarioSABADO2;
                }

                if (row.HRINI1SABADO != "" && row.HRINI1SABADO != null) {
                    var horariosabini = row.HRINI1SABADO;
                    var horariosabend = row.HRFIN1SABADO;
                    var horario2sabend = row.HRFIN2SABADO;
                    var horarioSABADO = (horariosabini + " às " + horariosabend);
                    var horario2SABADO = (horariosabini + " às " + horario2sabend);
                    row.SABADO = horarioSABADO;
                    row.SABADOGRID = horario2SABADO;
                }
            } else {
                horarioSABADO = "-";
                row.SABADO = horarioSABADO;
                horario2SABADO = "FECHADO";
                row.SABADOGRID = horario2SABADO;
                row.IDINTERVALO_SABADO = 'N';

            }

            if (row.IDABERTO_DOMINGO === "S") {
   

                if (row.IDINTERVALO_DOMINGO === "S") {
                    var horariodomini2 = row.HRINI2DOMINGO;
                    var horariodomend2 = row.HRFIN2DOMINGO;
                    var horarioDOMINGO2 = (horariodomini2 + " às " + horariodomend2);
                    row.DOMINGO2 = horarioDOMINGO2;
                }

                if (row.HRINI1DOMINGO != "" && row.HRINI1DOMINGO != null) {
                    var horariodomini = row.HRINI1DOMINGO;
                    var horariodomend = row.HRFIN1DOMINGO;
                    var horario2domend = row.HRFIN2DOMINGO;
                    var horarioDOMINGO = (horariodomini + " às " + horariodomend);
                    var horario2DOMINGO = (horariodomini + " às " + horario2domend);
                    row.DOMINGO = horarioDOMINGO;
                    row.DOMINGOGRID = horario2DOMINGO;
                }
            } else {
                horarioDOMINGO = "-";
                horario2DOMINGO = "FECHADO";
                row.DOMINGO = horarioDOMINGO;
                row.DOMINGOGRID = horario2DOMINGO;
                row.IDINTERVALO_DOMINGO = 'N';

            }
        });
        self.ativaIntervalo();
    };

    this.ativaDia = function() {

        var widget = templateManager.container.getWidget('WDGT_HORARIO_ATENDIMENTO');
        var min = "1900-01-01 00:00";

        if (widget.currentRow.IDABERTO_SEGUNDA == "N") {
            widget.currentRow.SEGUNDA = {
                start: "",
                end: ""
            };
            $("[name='SEGUNDA']").val('');
            widget.getField('SEGUNDA').readOnly = true;
            widget.getField("SEGUNDA").validations = {
                required: false
            };
            widget.currentRow.IDINTERVALO_SEGUNDA = "N";
            widget.getField('IDINTERVALO_SEGUNDA').readOnly = true;
            widget.getField('IDINTERVALO_SEGUNDA').reload();
            widget.getField("SEGUNDA")['datetime-minDate'] = min;
            widget.getField("SEGUNDA2")['datetime-minDate'] = min;

        } else {
            widget.getField("SEGUNDA").validations = {
                required: true
            };
            widget.getField('SEGUNDA').readOnly = false;
            widget.getField('IDINTERVALO_SEGUNDA').readOnly = false;
            widget.getField('IDINTERVALO_SEGUNDA').reload();
        }
        if (widget.currentRow.IDABERTO_TERCA == "N") {
            widget.currentRow.TERCA = {
                start: "",
                end: ""
            };
            $("[name='TERCA']").val('');
            widget.getField('TERCA').readOnly = true;
            widget.getField('TERCA').validations = {
                required: false
            };
            widget.currentRow.IDINTERVALO_TERCA = "N";
            widget.getField('IDINTERVALO_TERCA').readOnly = true;
            widget.getField('IDINTERVALO_TERCA').reload();
            widget.getField("TERCA")['datetime-minDate'] = min;
            widget.getField("TERCA2")['datetime-minDate'] = min;

        } else {
            widget.getField("TERCA").validations = {
                required: true
            };
            widget.getField('TERCA').readOnly = false;
            widget.getField('IDINTERVALO_TERCA').readOnly = false;
            widget.getField('IDINTERVALO_TERCA').reload();
        }
        if (widget.currentRow.IDABERTO_QUARTA == "N") {
            widget.currentRow.QUARTA = {
                start: "",
                end: ""
            };
            $("[name='QUARTA']").val('');
            widget.getField('QUARTA').readOnly = true;
            widget.getField('QUARTA').validations = {
                required: false
            };
            widget.currentRow.IDINTERVALO_QUARTA = "N";
            widget.getField('IDINTERVALO_QUARTA').readOnly = true;
            widget.getField('IDINTERVALO_QUARTA').reload();
            widget.getField("QUARTA")['datetime-minDate'] = min;
            widget.getField("QUARTA2")['datetime-minDate'] = min;

        } else {
            widget.getField("QUARTA").validations = {
                required: true
            };
            widget.getField('QUARTA').readOnly = false;
            widget.getField('IDINTERVALO_QUARTA').readOnly = false;
            widget.getField('IDINTERVALO_QUARTA').reload();
        }
        if (widget.currentRow.IDABERTO_QUINTA == "N") {
            widget.currentRow.QUINTA = {
                start: "",
                end: ""
            };
            $("[name='QUINTA']").val('');
            widget.getField('QUINTA').readOnly = true;
            widget.getField('QUINTA').validations = {
                required: false
            };
            widget.currentRow.IDINTERVALO_QUINTA = "N";
            widget.getField('IDINTERVALO_QUINTA').readOnly = true;
            widget.getField('IDINTERVALO_QUINTA').reload();
            widget.getField("QUINTA")['datetime-minDate'] = min;
            widget.getField("QUINTA2")['datetime-minDate'] = min;

        } else {
            widget.getField("QUINTA").validations = {
                required: true
            };
            widget.getField('QUINTA').readOnly = false;
            widget.getField('IDINTERVALO_QUINTA').readOnly = false;
            widget.getField('IDINTERVALO_QUINTA').reload();
        }
        if (widget.currentRow.IDABERTO_SEXTA == "N") {
            widget.currentRow.SEXTA = {
                start: "",
                end: ""
            };
            $("[name='SEXTA']").val('');
            widget.getField('SEXTA').readOnly = true;
            widget.getField('SEXTA').validations = {
                required: false
            };
            widget.currentRow.IDINTERVALO_SEXTA = "N";
            widget.getField('IDINTERVALO_SEXTA').readOnly = true;
            widget.getField('IDINTERVALO_SEXTA').reload();
            widget.getField("SEXTA")['datetime-minDate'] = min;
            widget.getField("SEXTA2")['datetime-minDate'] = min;

        } else {
            widget.getField("SEXTA").validations = {
                required: true
            };
            widget.getField('SEXTA').readOnly = false;
            widget.getField('IDINTERVALO_SEXTA').readOnly = false;
            widget.getField('IDINTERVALO_SEXTA').reload();
        }
        if (widget.currentRow.IDABERTO_SABADO == "N") {
            widget.currentRow.SABADO = {
                start: "",
                end: ""
            };
            $("[name='SABADO']").val('');
            widget.getField('SABADO').readOnly = true;
            widget.getField('SABADO').validations = {
                required: false
            };
            widget.currentRow.IDINTERVALO_SABADO = "N";
            widget.getField('IDINTERVALO_SABADO').readOnly = true;
            widget.getField('IDINTERVALO_SABADO').reload();
            widget.getField("SABADO")['datetime-minDate'] = min;
            widget.getField("SABADO2")['datetime-minDate'] = min;

        } else {
            widget.getField("SABADO").validations = {
                required: true
            };
            widget.getField('SABADO').readOnly = false;
            widget.getField('IDINTERVALO_SABADO').readOnly = false;
            widget.getField('IDINTERVALO_SABADO').reload();
        }
        if (widget.currentRow.IDABERTO_DOMINGO == "N") {
            widget.currentRow.DOMINGO = {
                start: "",
                end: ""
            };
            $("[name='DOMINGO']").val('');
            widget.getField('DOMINGO').readOnly = true;
            widget.getField("DOMINGO").validations = {
                required: false
            };
            widget.currentRow.IDINTERVALO_DOMINGO = "N";
            widget.getField('IDINTERVALO_DOMINGO').readOnly = true;
            widget.getField('IDINTERVALO_DOMINGO').reload();
            widget.getField("DOMINGO")['datetime-minDate'] = min;
            widget.getField("DOMINGO2")['datetime-minDate'] = min;

        } else {
            widget.getField("DOMINGO").validations = {
                required: true
            };
            widget.getField('DOMINGO').readOnly = false;
            widget.getField('IDINTERVALO_DOMINGO').readOnly = false;
            widget.getField('IDINTERVALO_DOMINGO').reload();
        }
        self.ativaIntervalo();
    };

    this.ativaIntervalo = function() {

        var widget = templateManager.container.getWidget('WDGT_HORARIO_ATENDIMENTO');

        if (widget.currentRow.IDINTERVALO_SEGUNDA == "S") {
            widget.getField('SEGUNDA').class = 4;
            widget.getField('SEGUNDA2').isVisible = true;
            widget.getField('SEGUNDA2').validations = {
                required: true
            };
            widget.getField('SEGUNDA').label = "Primeiro Período";
            widget.getField('SEGUNDA2').label = "Segundo Período";
        } else {
            widget.currentRow.SEGUNDA2 = {
                start: "",
                end: ""
            };
            $("[name='SEGUNDA2']").val('');
            widget.getField('SEGUNDA').class = 8;
            widget.getField('SEGUNDA2').isVisible = false;
            widget.getField('SEGUNDA2').validations = {
                required: false
            };
            widget.getField('SEGUNDA').label = "Segunda-Feira";
        }

        if (widget.currentRow.IDINTERVALO_TERCA == "S") {
            widget.getField('TERCA').class = 4;
            widget.getField('TERCA2').isVisible = true;
            widget.getField('TERCA2').validations = {
                required: true
            };
            widget.getField('TERCA').label = "Primeiro Período";
            widget.getField('TERCA2').label = "Segundo Período";
        } else {
            widget.currentRow.TERCA2 = {
                start: "",
                end: ""
            };
            $("[name='TERCA2']").val('');
            widget.getField('TERCA').class = 8;
            widget.getField('TERCA2').isVisible = false;
            widget.getField('TERCA2').validations = {
                required: false
            };
            widget.getField('TERCA').label = "Terça-Feira";
        }

        if (widget.currentRow.IDINTERVALO_QUARTA == "S") {
            widget.getField('QUARTA').class = 4;
            widget.getField('QUARTA2').isVisible = true;
            widget.getField('QUARTA2').validations = {
                required: true
            };
            widget.getField('QUARTA').label = "Primeiro Período";
            widget.getField('QUARTA2').label = "Segundo Período";
        } else {
            widget.currentRow.QUARTA2 = {
                start: "",
                end: ""
            };
            $("[name='QUARTA2']").val('');
            widget.getField('QUARTA').class = 8;
            widget.getField('QUARTA2').isVisible = false;
            widget.getField('QUARTA2').validations = {
                required: false
            };
            widget.getField('QUARTA').label = "Quarta-Feira";
        }

        if (widget.currentRow.IDINTERVALO_QUINTA == "S") {
            widget.getField('QUINTA').class = 4;
            widget.getField('QUINTA2').isVisible = true;
            widget.getField('QUINTA2').validations = {
                required: true
            };
            widget.getField('QUINTA').label = "Primeiro Período";
            widget.getField('QUINTA2').label = "Segundo Período";
        } else {
            widget.currentRow.QUINTA2 = {
                start: "",
                end: ""
            };
            $("[name='QUINTA2']").val('');
            widget.getField('QUINTA').class = 8;
            widget.getField('QUINTA2').isVisible = false;
            widget.getField('QUINTA2').validations = {
                required: false
            };
            widget.getField('QUINTA').label = "Quinta-Feira";
        }

        if (widget.currentRow.IDINTERVALO_SEXTA == "S") {
            widget.getField('SEXTA').class = 4;
            widget.getField('SEXTA2').isVisible = true;
            widget.getField('SEXTA2').validations = {
                required: true
            };
            widget.getField('SEXTA').label = "Primeiro Período";
            widget.getField('SEXTA2').label = "Segundo Período";
        } else {
            widget.currentRow.SEXTA2 = {
                start: "",
                end: ""
            };
            $("[name='SEXTA2']").val('');
            widget.getField('SEXTA').class = 8;
            widget.getField('SEXTA2').isVisible = false;
            widget.getField('SEXTA2').validations = {
                required: false
            };
            widget.getField('SEXTA').label = "Sexta-Feira";
        }

        if (widget.currentRow.IDINTERVALO_SABADO == "S") {
            widget.getField('SABADO').class = 4;
            widget.getField('SABADO2').isVisible = true;
            widget.getField('SABADO2').validations = {
                required: true
            };
            widget.getField('SABADO').label = "Primeiro Período";
            widget.getField('SABADO2').label = "Segundo Período";
        } else {
            widget.currentRow.SABADO2 = {
                start: "",
                end: ""
            };
            $("[name='SABADO2']").val('');
            widget.getField('SABADO').class = 8;
            widget.getField('SABADO2').isVisible = false;
            widget.getField('SABADO2').validations = {
                required: false
            };
            widget.getField('SABADO').label = "Sabado";
        }

        if (widget.currentRow.IDINTERVALO_DOMINGO == "S") {
            widget.getField('DOMINGO').class = 4;
            widget.getField('DOMINGO2').isVisible = true;
            widget.getField('DOMINGO2').validations = {
                required: true
            };
            widget.getField('DOMINGO').label = "Primeiro Período";
            widget.getField('DOMINGO2').label = "Segundo Período";
        } else {
            widget.currentRow.DOMINGO2 = {
                start: "",
                end: ""
            };
            $("[name='DOMINGO2']").val('');
            widget.getField('DOMINGO').class = 8;
            widget.getField('DOMINGO2').isVisible = false;
            widget.getField('DOMINGO2').validations = {
                required: false
            };
            widget.getField('DOMINGO').label = "Domingo";

        }

    };

    this.verifcaCampos = function(widget) {
        if (widget.isValid()) {

            if (templateManager.container.getActiveWidget() == templateManager.container.getWidget('WDGT_HORARIO_ATENDIMENTO')) {

                var SEGUNDA;
                var TERCA;
                var QUARTA;
                var QUINTA;
                var SEXTA;
                var SABADO;
                var DOMINGO;


                if (widget.currentRow.IDINTERVALO_SEGUNDA == "S") {
                    if (widget.currentRow.SEGUNDA["start"] != "" && widget.currentRow.SEGUNDA["end"] != "" && widget.currentRow.SEGUNDA2["start"] != "" && widget.currentRow.SEGUNDA2["end"] != "") {
                        if (widget.currentRow.SEGUNDA["start"] <= widget.currentRow.SEGUNDA["end"] && widget.currentRow.SEGUNDA["end"] < widget.currentRow.SEGUNDA2["start"] && widget.currentRow.SEGUNDA2["start"] <= widget.currentRow.SEGUNDA2["end"]) {
                            SEGUNDA = true;
                        } else {
                            ScreenService.showMessage("Hora final menor que hora inicial");
                            SEGUNDA = false;
                        }

                    } else {
                        ScreenService.showMessage("Verifique os campos");
                        SEGUNDA = false;
                    }

                } else {
                    if (widget.currentRow.IDABERTO_SEGUNDA == "S") {
                        if (widget.currentRow.SEGUNDA["start"] != "" && widget.currentRow.SEGUNDA["end"] != "" && widget.currentRow.SEGUNDA != "" || widget.currentRow.IDABERTO_SEGUNDA == "N") {
                            if (widget.currentRow.SEGUNDA["start"] <= widget.currentRow.SEGUNDA["end"] && widget.currentRow.SEGUNDA != "" || widget.currentRow.IDABERTO_SEGUNDA == "N") {
                                SEGUNDA = true;

                            } else {
                                ScreenService.showMessage("Hora final menor que hora inicial");
                                SEGUNDA = false;
                            }
                        } else {
                            ScreenService.showMessage("Verifique os campos");
                            SEGUNDA = false;
                        }

                    } else {
                        SEGUNDA = true;
                    }
                }

                if (widget.currentRow.IDABERTO_TERCA == "S") {
                    if (widget.currentRow.TERCA["start"] != "" && widget.currentRow.TERCA["end"] != "" && widget.currentRow.TERCA != "" || widget.currentRow.IDABERTO_TERCA == "N") {
                        if (widget.currentRow.TERCA["start"] <= widget.currentRow.TERCA["end"] && widget.currentRow.TERCA != "" || widget.currentRow.IDABERTO_TERCA == "N") {
                            TERCA = true;

                        } else {
                            ScreenService.showMessage("Hora final menor que hora inicial");
                            TERCA = false;
                        }
                    } else {
                        ScreenService.showMessage("Verifique os campos");
                        TERCA = false;
                    }
                } else {
                    TERCA = true;
                }

                if (widget.currentRow.IDABERTO_QUARTA == "S") {
                    if (widget.currentRow.QUARTA["start"] != "" && widget.currentRow.QUARTA["end"] != "" && widget.currentRow.QUARTA != "" || widget.currentRow.IDABERTO_QUARTA == "N") {
                        if (widget.currentRow.QUARTA["start"] <= widget.currentRow.QUARTA["end"] && widget.currentRow.QUARTA != "" || widget.currentRow.IDABERTO_QUARTA == "N") {
                            QUARTA = true;

                        } else {
                            ScreenService.showMessage("Hora final menor que hora inicial");


                            QUARTA = false;
                        }
                    } else {
                        ScreenService.showMessage("Verifique os campos");
                        QUARTA = false;
                    }
                } else {
                    QUARTA = true;
                }

                if (widget.currentRow.IDABERTO_QUINTA == "S") {
                    if (widget.currentRow.QUINTA["start"] != "" && widget.currentRow.QUINTA["end"] != "" && widget.currentRow.QUINTA != "" || widget.currentRow.IDABERTO_QUINTA == "N") {
                        if (widget.currentRow.QUINTA["start"] <= widget.currentRow.QUINTA["end"] && widget.currentRow.QUINTA != "" || widget.currentRow.IDABERTO_QUINTA == "N") {
                            QUINTA = true;

                        } else {
                            ScreenService.showMessage("Hora final menor que hora inicial");

                            widget.reload();
                            QUINTA = false;
                        }
                    } else {
                        ScreenService.showMessage("Verifique os campos");
                        QUINTA = false;
                    }
                } else {
                    QUINTA = true;
                }

                if (widget.currentRow.IDABERTO_SEXTA == "S") {
                    if (widget.currentRow.SEXTA["start"] != "" && widget.currentRow.SEXTA["end"] != "" && widget.currentRow.SEXTA != "" || widget.currentRow.IDABERTO_SEXTA == "N") {
                        if (widget.currentRow.SEXTA["start"] <= widget.currentRow.SEXTA["end"] && widget.currentRow.SEXTA != "" || widget.currentRow.IDABERTO_SEXTA == "N") {
                            SEXTA = true;

                        } else {
                            ScreenService.showMessage("Hora final menor que hora inicial");
                            SEXTA = false;
                        }
                    } else {
                        ScreenService.showMessage("Verifique os campos");
                        SEXTA = false;
                    }
                } else {
                    SEXTA = true;
                }

                if (widget.currentRow.IDABERTO_SABADO == "S") {
                    if (widget.currentRow.SABADO["start"] != "" && widget.currentRow.SABADO["end"] != "" && widget.currentRow.SABADO != "" || widget.currentRow.IDABERTO_SABADO == "N") {
                        if (widget.currentRow.SABADO["start"] <= widget.currentRow.SABADO["end"] && widget.currentRow.SABADO != "" || widget.currentRow.IDABERTO_SABADO == "N") {
                            SABADO = true;

                        } else {
                            ScreenService.showMessage("Hora final menor que hora inicial");
                            SABADO = false;
                        }
                    } else {
                        ScreenService.showMessage("Verifique os campos");
                        SABADO = false;
                    }
                } else {
                    SABADO = true;
                }

                if (widget.currentRow.IDABERTO_DOMINGO == "S") {
                    if (widget.currentRow.DOMINGO["start"] != "" && widget.currentRow.DOMINGO["end"] != "" && widget.currentRow.DOMINGO != "" || widget.currentRow.IDABERTO_DOMINGO == "N") {
                        if (widget.currentRow.DOMINGO["start"] <= widget.currentRow.DOMINGO["end"] && widget.currentRow.DOMINGO != "" || widget.currentRow.IDABERTO_DOMINGO == "N") {
                            DOMINGO = true;
                        } else {
                            ScreenService.showMessage("Hora final menor que hora inicial");
                            DOMINGO = false;
                        }
                    } else {
                        ScreenService.showMessage("Verifique os campos");
                        DOMINGO = false;
                    }
                } else {
                    DOMINGO = true;
                }


                var verifica = SEGUNDA && TERCA && QUARTA && QUINTA && SEXTA && SABADO && DOMINGO;
                return verifica;


            } else {

                if (widget.currentRow.IDINTERVALO === "N") {

                    if (widget.currentRow.HORARIO["start"] <= widget.currentRow.HORARIO["end"]) {
                        return true;
                    } else {
                        ScreenService.showMessage("Hora final menor que hora inicial");
                    }
                } else {
                    if (widget.currentRow.HORARIO["start"] <= widget.currentRow.HORARIO["end"] && widget.currentRow.HORARIO["end"] < widget.currentRow.HORARIO2["start"] && widget.currentRow.HORARIO2["start"] <= widget.currentRow.HORARIO2["end"]) {
                        return true;
                    } else {
                        ScreenService.showMessage("Hora final menor que hora inicial");
                    }
                }

            }

        }
    };

    this.salvaHorario = function(widget) {

        if (self.verifcaCampos(widget) == true) {
            
            if (widget.currentRow.IDABERTO_SEGUNDA == "S") {
                if (widget.currentRow.IDINTERVALO_SEGUNDA == "S") {
                    
                    widget.currentRow.HRINI2SEGUNDA = widget.currentRow.SEGUNDA2["start"];
                    widget.currentRow.HRFIN2SEGUNDA = widget.currentRow.SEGUNDA2["end"];
                    
                    
                    /*calcula horas de funcionamento*/
                    var iseg1 = widget.currentRow.SEGUNDA["start"];
                    var fseg1 = widget.currentRow.SEGUNDA["end"];
                    var iseg2 = widget.currentRow.HRINI2SEGUNDA;
                    var fseg2 = widget.currentRow.HRFIN2SEGUNDA;
                    iseg1 = iseg1.split(':');
                    fseg1 = fseg1.split(':');
                    iseg2 = iseg2.split(':');
                    fseg2 = fseg2.split(':');
                    iseg1 = iseg1[0]+iseg1[1];
                    fseg1 = fseg1[0]+fseg1[1];
                    iseg2 = iseg2[0]+iseg2[1];
                    fseg2 = fseg2[0]+fseg2[1];
                    Number(iseg1);
                    Number(fseg1);
                    Number(iseg2);
                    Number(fseg2);
                    var qnthrseg1 = fseg1-iseg1;
                    var qnthrseg2 = fseg2-iseg2;
                    var qnthrseg = qnthrseg1+ qnthrseg2;
                    /*formata total de horas colocando ':' */
                    qnthrseg = qnthrseg.toString();
                    /*verifica se total tem 3 caracteres (100 -> 10:0) se tiver, coloca um 0 no começo (0100 -> 01:00)*/
                    for (var i = qnthrseg.length; i < 4; i++) {
                         qnthrseg = '0'+qnthrseg;
                    }
                    var separainiseg = qnthrseg.slice(0,2);
                    var separafinseg = qnthrseg.slice(2);
                    qnthrseg = separainiseg+':'+separafinseg;
                    widget.currentRow.QNTHRTRABSEGUNDA = qnthrseg;
                    
                } else {
                    widget.currentRow.HRINI2SEGUNDA = "";
                    widget.currentRow.HRFIN2SEGUNDA = widget.currentRow.SEGUNDA["end"];
                    
                    /*calcula horas de funcionamento*/
                    var iseg = widget.currentRow.SEGUNDA["start"];
                    var fseg = widget.currentRow.SEGUNDA["end"];
                    iseg = iseg.split(':');
                    fseg = fseg.split(':');
                    iseg = iseg[0]+iseg[1];
                    fseg = fseg[0]+fseg[1];
                    Number(iseg);
                    Number(fseg);
                    qnthrseg = fseg-iseg;
                    /*formata total de horas colocando ':' */
                    qnthrseg = qnthrseg.toString();
                    
                    /*verifica se total tem 3 caracteres (100 -> 10:0) se tiver, coloca um 0 no começo (0100 -> 01:00)*/
                   for (var i = qnthrseg.length; i < 4; i++) {
                         qnthrseg = '0'+qnthrseg;
                    }
                    separainiseg = qnthrseg.slice(0,2);
                    separafinseg = qnthrseg.slice(2);
                    qnthrseg = separainiseg+':'+separafinseg;
                    widget.currentRow.QNTHRTRABSEGUNDA = qnthrseg;
                    widget.currentRow.QNTHRTRABSEGUNDA = qnthrseg;
                }
                widget.currentRow.HRINI1SEGUNDA = widget.currentRow.SEGUNDA["start"];
                widget.currentRow.HRFIN1SEGUNDA = widget.currentRow.SEGUNDA["end"];
                
                

            } else {
                widget.currentRow.HRINI1SEGUNDA = "";
                widget.currentRow.HRFIN1SEGUNDA = "";
                widget.currentRow.HRINI2SEGUNDA = "";
                widget.currentRow.HRFIN2SEGUNDA = "";
                widget.currentRow.QNTHRTRABSEGUNDA = "0";
            }

            if (widget.currentRow.IDABERTO_TERCA == "S") {
                if (widget.currentRow.IDINTERVALO_TERCA == "S") {
                    widget.currentRow.HRINI2TERCA = widget.currentRow.TERCA2["start"];
                    widget.currentRow.HRFIN2TERCA = widget.currentRow.TERCA2["end"];
                    
                      /*calcula horas de funcionamento*/
                    var iterc1 = widget.currentRow.TERCA["start"];
                    var fterc1 = widget.currentRow.TERCA["end"];
                    var iterc2 = widget.currentRow.HRINI2TERCA;
                    var fterc2 = widget.currentRow.HRFIN2TERCA;
                    iterc1 = iterc1.split(':');
                    fterc1 = fterc1.split(':');
                    iterc2 = iterc2.split(':');
                    fterc2 = fterc2.split(':');
                    iterc1 = iterc1[0]+iterc1[1];
                    fterc1 = fterc1[0]+fterc1[1];
                    iterc2 = iterc2[0]+iterc2[1];
                    fterc2 = fterc2[0]+fterc2[1];
                    Number(iterc1);
                    Number(fterc1);
                    Number(iterc2);
                    Number(fterc2);
                    var qnthrterc1 = fterc1-iterc1;
                    var qnthrterc2 = fterc2-iterc2;
                    var qnthrterc = qnthrterc1+ qnthrterc2;
                    /*formata total de horas colocando ':' */
                    qnthrterc = qnthrterc.toString();
                    /*verifica se total tem 3 caracteres (100 -> 10:0) se tiver, coloca um 0 no começo (0100 -> 01:00)*/
                    for (var i = qnthrterc.length; i < 4; i++) {
                         qnthrterc = '0'+qnthrterc;
                    }
                    var separainiterc = qnthrterc.slice(0,2);
                    var separafinterc = qnthrterc.slice(2);
                    qnthrterc = separainiterc+':'+separafinterc;
                    widget.currentRow.QNTHRTRABTERCA = qnthrterc;
                    
                } else {
                    widget.currentRow.HRINI2TERCA = "";
                    widget.currentRow.HRFIN2TERCA = widget.currentRow.TERCA["end"];
                      
                    /*calcula horas de funcionamento*/
                    var iterc = widget.currentRow.TERCA["start"];
                    var fterc = widget.currentRow.TERCA["end"];
                    iterc = iterc.split(':');
                    fterc = fterc.split(':');
                    iterc = iterc[0]+iterc[1];
                    fterc = fterc[0]+fterc[1];
                    Number(iterc);
                    Number(fterc);
                    qnthrterc = fterc-iterc;
                    /*formata total de horas colocando ':' */
                    qnthrterc = qnthrterc.toString();
                    
                    /*verifica se total tem 3 caracteres (100 -> 10:0) se tiver, coloca um 0 no começo (0100 -> 01:00)*/
                   for (var i = qnthrterc.length; i < 4; i++) {
                         qnthrterc = '0'+qnthrterc;
                    }
                    separainiterc = qnthrterc.slice(0,2);
                    separafinterc = qnthrterc.slice(2);
                    qnthrterc = separainiterc+':'+separafinterc;
                    widget.currentRow.QNTHRTRABTERCA = qnthrterc;
                }
                widget.currentRow.HRINI1TERCA = widget.currentRow.TERCA["start"];
                widget.currentRow.HRFIN1TERCA = widget.currentRow.TERCA["end"];

            } else {
                widget.currentRow.HRINI1TERCA = "";
                widget.currentRow.HRFIN1TERCA = "";
                widget.currentRow.HRINI2TERCA = "";
                widget.currentRow.HRFIN2TERCA = "";
                widget.currentRow.QNTHRTRABTERCA = "0";
            }

            if (widget.currentRow.IDABERTO_QUARTA == "S") {
                if (widget.currentRow.IDINTERVALO_QUARTA == "S") {
                    widget.currentRow.HRINI2QUARTA = widget.currentRow.QUARTA2["start"];
                    widget.currentRow.HRFIN2QUARTA = widget.currentRow.QUARTA2["end"];
                    
                      
                    /*calcula horas de funcionamento*/
                    var iquart1 = widget.currentRow.QUARTA["start"];
                    var fquart1 = widget.currentRow.QUARTA["end"];
                    var iquart2 = widget.currentRow.HRINI2QUARTA;
                    var fquart2 = widget.currentRow.HRFIN2QUARTA;
                    iquart1 = iquart1.split(':');
                    fquart1 = fquart1.split(':');
                    iquart2 = iquart2.split(':');
                    fquart2 = fquart2.split(':');
                    iquart1 = iquart1[0]+iquart1[1];
                    fquart1 = fquart1[0]+fquart1[1];
                    iquart2 = iquart2[0]+iquart2[1];
                    fquart2 = fquart2[0]+fquart2[1];
                    Number(iquart1);
                    Number(fquart1);
                    Number(iquart2);
                    Number(fquart2);
                    var qnthrquart1 = fquart1-iquart1;
                    var qnthrquart2 = fquart2-iquart2;
                    var qnthrquart = qnthrquart1+ qnthrquart2;
                    /*formata total de horas colocando ':' */
                    qnthrquart = qnthrquart.toString();
                    /*verifica se total tem 3 caracteres (100 -> 10:0) se tiver, coloca um 0 no começo (0100 -> 01:00)*/
                    for (var i = qnthrquart.length; i < 4; i++) {
                         qnthrquart = '0'+qnthrquart;
                    }
                    var separainiquart = qnthrquart.slice(0,2);
                    var separafinquart = qnthrquart.slice(2);
                    qnthrquart = separainiquart+':'+separafinquart;
                    widget.currentRow.QNTHRTRABQUARTA = qnthrquart;
                    
                } else {
                    widget.currentRow.HRINI2QUARTA = "";
                    widget.currentRow.HRFIN2QUARTA = widget.currentRow.QUARTA["end"];
                      
                    /*calcula horas de funcionamento*/
                    var iquart = widget.currentRow.QUARTA["start"];
                    var fquart = widget.currentRow.QUARTA["end"];
                    iquart = iquart.split(':');
                    fquart = fquart.split(':');
                    iquart = iquart[0]+iquart[1];
                    fquart = fquart[0]+fquart[1];
                    Number(iquart);
                    Number(fquart);
                    qnthrquart = fquart-iquart;
                    /*formata total de horas colocando ':' */
                    qnthrquart = qnthrquart.toString();
                    
                    /*verifica se total tem 3 caracteres (100 -> 10:0) se tiver, coloca um 0 no começo (0100 -> 01:00)*/
                   for (var i = qnthrquart.length; i < 4; i++) {
                         qnthrquart = '0'+qnthrquart;
                    }
                    separainiquart = qnthrquart.slice(0,2);
                    separafinquart = qnthrquart.slice(2);
                    qnthrquart = separainiquart+':'+separafinquart;
                    widget.currentRow.QNTHRTRABQUARTA = qnthrquart;
         
                    
                }
                widget.currentRow.HRINI1QUARTA = widget.currentRow.QUARTA["start"];
                widget.currentRow.HRFIN1QUARTA = widget.currentRow.QUARTA["end"];
            } else {
                widget.currentRow.HRINI1QUARTA = "";
                widget.currentRow.HRFIN1QUARTA = "";
                widget.currentRow.HRINI2QUARTA = "";
                widget.currentRow.HRFIN2QUARTA = "";
                 widget.currentRow.QNTHRTRABQUARTA = "0";
            }

            if (widget.currentRow.IDABERTO_QUINTA == "S") {
                if (widget.currentRow.IDINTERVALO_QUINTA == "S") {
                    widget.currentRow.HRINI2QUINTA = widget.currentRow.QUINTA2["start"];
                    widget.currentRow.HRFIN2QUINTA = widget.currentRow.QUINTA2["end"];
                      
                    /*calcula horas de funcionamento*/
                    var iquint1 = widget.currentRow.QUINTA["start"];
                    var fquint1 = widget.currentRow.QUINTA["end"];
                    var iquint2 = widget.currentRow.HRINI2QUINTA;
                    var fquint2 = widget.currentRow.HRFIN2QUINTA;
                    iquint1 = iquint1.split(':');
                    fquint1 = fquint1.split(':');
                    iquint2 = iquint2.split(':');
                    fquint2 = fquint2.split(':');
                    iquint1 = iquint1[0]+iquint1[1];
                    fquint1 = fquint1[0]+fquint1[1];
                    iquint2 = iquint2[0]+iquint2[1];
                    fquint2 = fquint2[0]+fquint2[1];
                    Number(iquint1);
                    Number(fquint1);
                    Number(iquint2);
                    Number(fquint2);
                    var qnthrquint1 = fquint1-iquint1;
                    var qnthrquint2 = fquint2-iquint2;
                    var qnthrquint = qnthrquint1+ qnthrquint2;
                    /*formata total de horas colocando ':' */
                    qnthrquint = qnthrquint.toString();
                    /*verifica se total tem 3 caracteres (100 -> 10:0) se tiver, coloca um 0 no começo (0100 -> 01:00)*/
                    for (var i = qnthrquint.length; i < 4; i++) {
                         qnthrquint = '0'+qnthrquint;
                    }
                    var separainiquint = qnthrquint.slice(0,2);
                    var separafinquint = qnthrquint.slice(2);
                    qnthrquint = separainiquint+':'+separafinquint;
                    widget.currentRow.QNTHRTRABQUINTA = qnthrquint;
                    
                    
                } else {
                    widget.currentRow.HRINI2QUINTA = "";
                    widget.currentRow.HRFIN2QUINTA = widget.currentRow.QUINTA["end"];
                    
                       /*calcula horas de funcionamento*/
                    var iquint = widget.currentRow.QUINTA["start"];
                    var fquint = widget.currentRow.QUINTA["end"];
                    iquint = iquint.split(':');
                    fquint = fquint.split(':');
                    iquint = iquint[0]+iquint[1];
                    fquint = fquint[0]+fquint[1];
                    Number(iquint);
                    Number(fquint);
                    qnthrquint = fquint-iquint;
                    /*formata total de horas colocando ':' */
                    qnthrquint = qnthrquint.toString();
                    
                    /*verifica se total tem 3 caracteres (100 -> 10:0) se tiver, coloca um 0 no começo (0100 -> 01:00)*/
                   for (var i = qnthrquint.length; i < 4; i++) {
                         qnthrquint = '0'+qnthrquint;
                    }
                    separainiquint = qnthrquint.slice(0,2);
                    separafinquint = qnthrquint.slice(2);
                    qnthrquint = separainiquint+':'+separafinquint;
                    widget.currentRow.QNTHRTRABQUINTA = qnthrquint;
                    
                }
                widget.currentRow.HRINI1QUINTA = widget.currentRow.QUINTA["start"];
                widget.currentRow.HRFIN1QUINTA = widget.currentRow.QUINTA["end"];
            } else {
                widget.currentRow.HRINI1QUINTA = "";
                widget.currentRow.HRFIN1QUINTA = "";
                widget.currentRow.HRINI2QUINTA = "";
                widget.currentRow.HRFIN2QUINTA = "";
                 widget.currentRow.QNTHRTRABQUINTA= "0";
            }

            if (widget.currentRow.IDABERTO_SEXTA == "S") {
                if (widget.currentRow.IDINTERVALO_SEXTA == "S") {
                    widget.currentRow.HRINI2SEXTA = widget.currentRow.SEXTA2["start"];
                    widget.currentRow.HRFIN2SEXTA = widget.currentRow.SEXTA2["end"];
                    
                       /*calcula horas de funcionamento*/
                    var isex1 = widget.currentRow.SEXTA["start"];
                    var fsex1 = widget.currentRow.SEXTA["end"];
                    var isex2 = widget.currentRow.HRINI2SEXTA;
                    var fsex2 = widget.currentRow.HRFIN2SEXTA;
                    isex1 = isex1.split(':');
                    fsex1 = fsex1.split(':');
                    isex2 = isex2.split(':');
                    fsex2 = fsex2.split(':');
                    isex1 = isex1[0]+isex1[1];
                    fsex1 = fsex1[0]+fsex1[1];
                    isex2 = isex2[0]+isex2[1];
                    fsex2 = fsex2[0]+fsex2[1];
                    Number(isex1);
                    Number(fsex1);
                    Number(isex2);
                    Number(fsex2);
                    var qnthrsex1 = fsex1-isex1;
                    var qnthrsex2 = fsex2-isex2;
                    var qnthrsex = qnthrsex1+ qnthrsex2;
                    /*formata total de horas colocando ':' */
                    qnthrsex = qnthrsex.toString();
                    /*verifica se total tem 3 caracteres (100 -> 10:0) se tiver, coloca um 0 no começo (0100 -> 01:00)*/
                    for (var i = qnthrsex.length; i < 4; i++) {
                         qnthrsex = '0'+qnthrsex;
                    }
                    var separainisex = qnthrsex.slice(0,2);
                    var separafinsex = qnthrsex.slice(2);
                    qnthrsex = separainisex+':'+separafinsex;
                    widget.currentRow.QNTHRTRABSEXTA = qnthrsex;
                    
                } else {
                    widget.currentRow.HRINI2SEXTA = "";
                    widget.currentRow.HRFIN2SEXTA = widget.currentRow.SEXTA["end"];
                    
                        
                       /*calcula horas de funcionamento*/
                    var isex = widget.currentRow.SEXTA["start"];
                    var fsex = widget.currentRow.SEXTA["end"];
                    isex = isex.split(':');
                    fsex = fsex.split(':');
                    isex = isex[0]+isex[1];
                    fsex = fsex[0]+fsex[1];
                    Number(isex);
                    Number(fsex);
                    qnthrsex = fsex-isex;
                    /*formata total de horas colocando ':' */
                    qnthrsex = qnthrsex.toString();
                    
                    /*verifica se total tem 3 caracteres (100 -> 10:0) se tiver, coloca um 0 no começo (0100 -> 01:00)*/
                   for (var i = qnthrsex.length; i < 4; i++) {
                         qnthrsex = '0'+qnthrsex;
                    }
                    separainisex = qnthrsex.slice(0,2);
                    separafinsex = qnthrsex.slice(2);
                    qnthrsex = separainisex+':'+separafinsex;
                    widget.currentRow.QNTHRTRABSEXTA = qnthrsex;
                    
                }
                widget.currentRow.HRINI1SEXTA = widget.currentRow.SEXTA["start"];
                widget.currentRow.HRFIN1SEXTA = widget.currentRow.SEXTA["end"];
            } else {
                widget.currentRow.HRINI1SEXTA = "";
                widget.currentRow.HRFIN1SEXTA = "";
                widget.currentRow.HRINI2SEXTA = "";
                widget.currentRow.HRFIN2SEXTA = "";
                 widget.currentRow.QNTHRTRABSEXTA = "0";
            }

            if (widget.currentRow.IDABERTO_SABADO == "S") {
                if (widget.currentRow.IDINTERVALO_SABADO == "S") {
                    widget.currentRow.HRINI2SABADO = widget.currentRow.SABADO2["start"];
                    widget.currentRow.HRFIN2SABADO = widget.currentRow.SABADO2["end"];
                    
                    
                       /*calcula horas de funcionamento*/
                    var isab1 = widget.currentRow.SABADO["start"];
                    var fsab1 = widget.currentRow.SABADO["end"];
                    var isab2 = widget.currentRow.HRINI2SABADO;
                    var fsab2 = widget.currentRow.HRFIN2SABADO;
                    isab1 = isab1.split(':');
                    fsab1 = fsab1.split(':');
                    isab2 = isab2.split(':');
                    fsab2 = fsab2.split(':');
                    isab1 = isab1[0]+isab1[1];
                    fsab1 = fsab1[0]+fsab1[1];
                    isab2 = isab2[0]+isab2[1];
                    fsab2 = fsab2[0]+fsab2[1];
                    Number(isab1);
                    Number(fsab1);
                    Number(isab2);
                    Number(fsab2);
                    var qnthrsab1 = fsab1-isab1;
                    var qnthrsab2 = fsab2-isab2;
                    var qnthrsab = qnthrsab1+ qnthrsab2;
                    /*formata total de horas colocando ':' */
                    qnthrsab = qnthrsab.toString();
                    /*verifica se total tem 3 caracteres (100 -> 10:0) se tiver, coloca um 0 no começo (0100 -> 01:00)*/
                    for (var i = qnthrsab.length; i < 4; i++) {
                         qnthrsab = '0'+qnthrsab;
                    }
                    var separainisab = qnthrsab.slice(0,2);
                    var separafinsab = qnthrsab.slice(2);
                    qnthrsab = separainisab+':'+separafinsab;
                    widget.currentRow.QNTHRTRABSABADO = qnthrsab;
                    
                } else {
                    widget.currentRow.HRINI2SABADO = "";
                    widget.currentRow.HRFIN2SABADO = widget.currentRow.SABADO["end"];
                    
                    /*calcula horas de funcionamento*/
                    var isab = widget.currentRow.SABADO["start"];
                    var fsab = widget.currentRow.SABADO["end"];
                    isab = isab.split(':');
                    fsab = fsab.split(':');
                    isab = isab[0]+isab[1];
                    fsab = fsab[0]+fsab[1];
                    Number(isab);
                    Number(fsab);
                    qnthrsab = fsab-isab;
                    /*formata total de horas colocando ':' */
                    qnthrsab = qnthrsab.toString();
                    
                    /*verifica se total tem 3 caracteres (100 -> 10:0) se tiver, coloca um 0 no começo (0100 -> 01:00)*/
                   for (var i = qnthrsab.length; i < 4; i++) {
                         qnthrsab = '0'+qnthrsab;
                    }
                    separainisab = qnthrsab.slice(0,2);
                    separafinsab = qnthrsab.slice(2);
                    qnthrsab = separainisab+':'+separafinsab;
                    widget.currentRow.QNTHRTRABSABADO = qnthrsab;
                }
                widget.currentRow.HRINI1SABADO = widget.currentRow.SABADO["start"];
                widget.currentRow.HRFIN1SABADO = widget.currentRow.SABADO["end"];
            } else {
                widget.currentRow.HRINI1SABADO = "";
                widget.currentRow.HRFIN1SABADO = "";
                widget.currentRow.HRINI2SABADO = "";
                widget.currentRow.HRFIN2SABADO = "";
                 widget.currentRow.QNTHRTRABSABADO = "0";

            }

            if (widget.currentRow.IDABERTO_DOMINGO == "S") {
                if (widget.currentRow.IDINTERVALO_DOMINGO == "S") {
                    widget.currentRow.HRINI2DOMINGO = widget.currentRow.DOMINGO2["start"];
                    widget.currentRow.HRFIN2DOMINGO = widget.currentRow.DOMINGO2["end"];
                    
                    
                       /*calcula horas de funcionamento*/
                    var idom1 = widget.currentRow.DOMINGO["start"];
                    var fdom1 = widget.currentRow.DOMINGO["end"];
                    var idom2 = widget.currentRow.HRINI2DOMINGO;
                    var fdom2 = widget.currentRow.HRFIN2DOMINGO;
                    idom1 = idom1.split(':');
                    fdom1 = fdom1.split(':');
                    idom2 = idom2.split(':');
                    fdom2 = fdom2.split(':');
                    idom1 = idom1[0]+idom1[1];
                    fdom1 = fdom1[0]+fdom1[1];
                    idom2 = idom2[0]+idom2[1];
                    fdom2 = fdom2[0]+fdom2[1];
                    Number(idom1);
                    Number(fdom1);
                    Number(idom2);
                    Number(fdom2);
                    var qnthrdom1 = fdom1-idom1;
                    var qnthrdom2 = fdom2-idom2;
                    var qnthrdom = qnthrdom1+ qnthrdom2;
                    /*formata total de horas colocando ':' */
                    qnthrdom = qnthrdom.toString();
                    /*verifica se total tem 3 caracteres (100 -> 10:0) se tiver, coloca um 0 no começo (0100 -> 01:00)*/
                    for (var i = qnthrdom.length; i < 4; i++) {
                         qnthrdom = '0'+qnthrdom;
                    }
                    var separainidom = qnthrdom.slice(0,2);
                    var separafindom = qnthrdom.slice(2);
                    qnthrdom = separainidom+':'+separafindom;
                    widget.currentRow.QNTHRTRABDOMINGO = qnthrdom;
                    
                } else {
                    widget.currentRow.HRINI2DOMINGO = "";
                    widget.currentRow.HRFIN2DOMINGO = widget.currentRow.DOMINGO["end"];
                    
                    /*calcula horas de funcionamento*/
                    var idom = widget.currentRow.DOMINGO["start"];
                    var fdom = widget.currentRow.DOMINGO["end"];
                    idom = idom.split(':');
                    fdom = fdom.split(':');
                    idom = idom[0]+idom[1];
                    fdom = fdom[0]+fdom[1];
                    Number(idom);
                    Number(fdom);
                    qnthrdom = fdom-idom;
                    /*formata total de horas colocando ':' */
                    qnthrdom = qnthrdom.toString();
                    
                    /*verifica se total tem 3 caracteres (100 -> 10:0) se tiver, coloca um 0 no começo (0100 -> 01:00)*/
                   for (var i = qnthrdom.length; i < 4; i++) {
                         qnthrdom = '0'+qnthrdom;
                    }
                    separainidom = qnthrdom.slice(0,2);
                    separafindom = qnthrdom.slice(2);
                    qnthrdom = separainidom+':'+separafindom;
                    widget.currentRow.QNTHRTRABDOMINGO = qnthrdom;
                }
                widget.currentRow.HRINI1DOMINGO = widget.currentRow.DOMINGO["start"];
                widget.currentRow.HRFIN1DOMINGO = widget.currentRow.DOMINGO["end"];
            } else {
                widget.currentRow.HRINI1DOMINGO = "";
                widget.currentRow.HRFIN1DOMINGO = "";
                widget.currentRow.HRINI2DOMINGO = "";
                widget.currentRow.HRFIN2DOMINGO = "";
                widget.currentRow.QNTHRTRABDOMINGO = "0";
            }

            return General.saveCrud(widget).then(function(response) {
                widget.reload();
                self.formatDate(widget);
            });
        }
        // self.formatDate(widget);
        widget.reload();

    };

    this.editaHora = function() {

        var widget = templateManager.container.getWidget('WDGT_HORARIO_ATENDIMENTO');


        if (widget.currentRow.IDABERTO_SEGUNDA === "S") {
            if (widget.currentRow.IDINTERVALO_SEGUNDA === "S") {
                var startSEG2 = widget.currentRow.HRINI2SEGUNDA;
                var endSEG2 = widget.currentRow.HRFIN2SEGUNDA;
                widget.currentRow.SEGUNDA2 = {
                    start: startSEG2,
                    end: endSEG2
                };
            }
            var startSEG = widget.currentRow.HRINI1SEGUNDA;
            var endSEG = widget.currentRow.HRFIN1SEGUNDA;
            widget.currentRow.SEGUNDA = {
                start: startSEG,
                end: endSEG
            };
        }

        if (widget.currentRow.IDABERTO_TERCA === "S") {
            if (widget.currentRow.IDINTERVALO_TERCA === "S") {
                var startTER2 = widget.currentRow.HRINI2TERCA;
                var endTER2 = widget.currentRow.HRFIN2TERCA;
                widget.currentRow.TERCA2 = {
                    start: startTER2,
                    end: endTER2
                };
            }
            var startTER = widget.currentRow.HRINI1TERCA;
            var endTER = widget.currentRow.HRFIN1TERCA;
            widget.currentRow.TERCA = {
                start: startTER,
                end: endTER
            };
        }

        if (widget.currentRow.IDABERTO_QUARTA === "S") {
            if (widget.currentRow.IDINTERVALO_QUARTA === "S") {
                var startQUAR2 = widget.currentRow.HRINI2QUARTA;
                var endQUAR2 = widget.currentRow.HRFIN2QUARTA;
                widget.currentRow.QUARTA2 = {
                    start: startQUAR2,
                    end: endQUAR2
                };
            }
            var startQUAR = widget.currentRow.HRINI1QUARTA;
            var endQUAR = widget.currentRow.HRFIN1QUARTA;
            widget.currentRow.QUARTA = {
                start: startQUAR,
                end: endQUAR
            };
        }

        if (widget.currentRow.IDABERTO_QUINTA === "S") {
            if (widget.currentRow.IDINTERVALO_QUINTA === "S") {
                var startQUIN2 = widget.currentRow.HRINI2QUINTA;
                var endQUIN2 = widget.currentRow.HRFIN2QUINTA;
                widget.currentRow.QUINTA2 = {
                    start: startQUIN2,
                    end: endQUIN2
                };
            }
            var startQUIN = widget.currentRow.HRINI1QUINTA;
            var endQUIN = widget.currentRow.HRFIN1QUINTA;
            widget.currentRow.QUINTA = {
                start: startQUIN,
                end: endQUIN
            };
        }

        if (widget.currentRow.IDABERTO_SEXTA === "S") {
            if (widget.currentRow.IDINTERVALO_SEXTA === "S") {
                var startSEX2 = widget.currentRow.HRINI2SEXTA;
                var endSEX2 = widget.currentRow.HRFIN2SEXTA;
                widget.currentRow.SEXTA2 = {
                    start: startSEX2,
                    end: endSEX2
                };
            }
            var startSEX = widget.currentRow.HRINI1SEXTA;
            var endSEX = widget.currentRow.HRFIN1SEXTA;
            widget.currentRow.SEXTA = {
                start: startSEX,
                end: endSEX
            };
        }

        if (widget.currentRow.IDABERTO_SABADO === "S") {
            if (widget.currentRow.IDINTERVALO_SABADO === "S") {
                var startSAB2 = widget.currentRow.HRINI2SABADO;
                var endSAB2 = widget.currentRow.HRFIN2SABADO;
                widget.currentRow.SABADO = {
                    start: startSAB2,
                    end: endSAB2
                };
            }
            var startSAB = widget.currentRow.HRINI1SABADO;
            var endSAB = widget.currentRow.HRFIN1SABADO;
            widget.currentRow.SABADO = {
                start: startSAB,
                end: endSAB
            };
        }

        if (widget.currentRow.IDABERTO_DOMINGO === "S") {
            if (widget.currentRow.IDINTERVALO_DOMINGO === "S") {
                var startDOM2 = widget.currentRow.HRINI2DOMINGO;
                var endDOM2 = widget.currentRow.HRFIN2DOMINGO;
                widget.currentRow.DOMINGO2 = {
                    start: startDOM2,
                    end: endDOM2
                };
            }
            var startDOM = widget.currentRow.HRINI1DOMINGO;
            var endDOM = widget.currentRow.HRFIN1DOMINGO;
            widget.currentRow.DOMINGO = {
                start: startDOM,
                end: endDOM
            };
        }


        self.ativaIntervalo();
        widget.reload();

    };

    this.fecharPopUp = function() {
        var widget = templateManager.container.getWidget('inlineEditHora');
        ScreenService.closePopup(widget);

    };
    
    this.openTimeField = function(args) {
        var popUpHorario = templateManager.container.getWidget('inlineEditHora');

        /*Verifica se o PopUp esta aberto, caso esteja, fecha o popup atual e abre um novo, caso não, so abre o novo*/
        if(popUpHorario.isActive() == false){
            popUpHorario.getField('HORARIO').label = args.owner.field.label;
            popUpHorario.getField('HORARIO2').label = args.owner.field.label;
            popUpHorario.currentRow.fieldOrigemName = args.owner.field.name.replace('GRID', ''); /*Manda nome do campo de origem*/
            ScreenService.openPopup(popUpHorario);
        }else{
            self.fecharPopUp();
            popUpHorario.getField('HORARIO').label = args.owner.field.label;
            popUpHorario.getField('HORARIO2').label = args.owner.field.label;
            ScreenService.openPopup(popUpHorario);
        }
        //self.setValue(args);

    };

    this.setHoraInline = function(args) {

        var widget = templateManager.container.getWidget('inlineEditHora');

        if (self.verifcaCampos(widget) == true) {
            var widgetInline = templateManager.container.getWidget('WDGT_HORARIO_ATENDIMENTO');
            var dia = widget.currentRow.fieldOrigemName;
         

            if (widget.currentRow.IDINTERVALO === "N") {
                var horarioini = widget.currentRow.HORARIO["start"];
                var horarioend = widget.currentRow.HORARIO["end"];
                var horario = (horarioini + " às " + horarioend);
            } else {
                horarioini = widget.currentRow.HORARIO["start"];
                horarioend = widget.currentRow.HORARIO2["end"];
                horario = (horarioini + " às " + horarioend);
            }



            widgetInline.currentRow[dia] = horario;
            widgetInline.currentRow[dia+'GRID'] = horario;
            self.fecharPopUp();
            widgetInline.currentRow.changed = true;
            widgetInline.inlineEdit();
            widgetInline.mode = "inline_edit";
            widgetInline._rowsUpdate = "true";
            widgetInline.activate();

        }
    };

    this.setValue = function() {

        var wid = templateManager.container.getWidget('WDGT_HORARIO_ATENDIMENTO');
        var widget = templateManager.container.getWidget('inlineEditHora');


        setTimeout(function() {
            var nomeDiaComposto = widget.getField("HORARIO").label;
            var dia = widget.currentRow.fieldOrigemName;
            
            widget.label = "Horário de Funcionamento - "+nomeDiaComposto;
         

            var idIntervalo = wid.currentRow['IDINTERVALO_' + dia];

            if (idIntervalo == "N") {
                widget.getField("HORARIO2").isVisible = false;
                widget.getField("HORARIO").class = 12;
                widget.getField("HORARIO2").reload();
                widget.getField("HORARIO").reload();
            } else {
                widget.getField("HORARIO2").isVisible = true;
                widget.getField("HORARIO").class = 6;
                widget.getField("HORARIO").label = "Primeiro Período";
                widget.getField("HORARIO2").label = "Segundo Período";
                widget.getField("HORARIO2").reload();
                widget.getField("HORARIO").reload();
            }
            widget.currentRow.IDINTERVALO = idIntervalo;
            var dia1ini = wid.currentRow['HRINI1' + dia];
            var dia1fin = wid.currentRow['HRFIN1' + dia];
            var dia2ini = wid.currentRow['HRINI2' + dia];
            var dia2fin = wid.currentRow['HRFIN2' + dia];
        
            var horario = wid.currentRow[dia];

            if (horario == "FECHADO" || horario == "-") {
                widget.currentRow.HORARIO = {
                    start: "",
                    end: ""
                };
                widget.currentRow.HORARIO2 = {
                    start: "",
                    end: ""
                };
                $("[name='HORARIO']").val('');
                $("[name='HORARIO2']").val('');
            } else {

                widget.currentRow.HORARIO = {
                    start: dia1ini,
                    end: dia1fin
                };

                widget.currentRow.HORARIO2 = {
                    start: dia2ini,
                    end: dia2fin
                };

            }
     
            
            
            widget.reload();
        }, 4);

    };

    this.prepareRowToSaveInLineEdit = function(widget) {

        var dataWidget = widget.dataSource.data;

        var editedRows = dataWidget.filter(function(row) {
            return row.changed_NMHORARIO || row.changed_SEGUNDAGRID || row.changed_TERCAGRID || row.changed_QUARTAGRID || row.changed_QUINTAGRID || row.changed_SEXTAGRID || row.changed_SABADOGRID || row.changed_DOMINGOGRID;
        });
        
        var rowsToSave = editedRows;

        return rowsToSave;

    };

    this.saveHorarioInLine = function(widget) {

        var rows = self.prepareRowToSaveInLineEdit(widget);

        General.callRestEngine("product#/horario_atendimento/save", "DataSet", rows).then(function(response) {

            widget.list();
            widget.reload();

        }.bind(this));
    };

    this.setMaxMin = function(args) {
        var widget = templateManager.container.getWidget('WDGT_HORARIO_ATENDIMENTO');
        var widgetPopUp = templateManager.container.getWidget('inlineEditHora');

        if (templateManager.container.getActiveWidget().name == "inlineEditHora") {
            
            var min = "1900-01-01 " + widgetPopUp.currentRow[args.owner.name]["start"];
            widgetPopUp.getField(args.owner.name)['datetime-minDate'] = min;

            var horadia = widgetPopUp.currentRow.HORARIO["end"].split(":");

              if (widgetPopUp.currentRow[args.owner.name]["start"] > widgetPopUp.currentRow[args.owner.name]["end"]) { /*limpa segundo campo caso ele seha maior que o primeiro*/
                widgetPopUp.currentRow[args.owner.name]["end"] = "";
                $($("[name=" + args.owner.name + "]")[1]).val('');
            }

            /*INICIO - Acrescenta 1 minuto ao inicio do horario depois do intervalo*/
            if (horadia[1] == 59) {
                if (horadia[0] == 24) {
                    horadia[0] = "00";
                    horadia[1] = "00";
                    horadia = [horadia[0], horadia[1]];
                } else {
                    horadia[0] = Number(horadia[0]) + 1;
                    horadia[1] = "00";
                    horadia = [horadia[0], horadia[1]];
                }
            } else {
                horadia[1] = Number(horadia[1]) + 1;
                horadia = [horadia[0], horadia[1]];

            }

            var horaMaisIntervalo = horadia[0] + ":" + horadia[1];
            var min2 = "1900-01-01 " + horaMaisIntervalo;
            widgetPopUp.getField('HORARIO2')['datetime-minDate'] = min2;
            /*FIM -Acrescenta 1 minuto ao inicio do horario depois do intervalo*/

            /*INICIO -limpa segundo campo caso ele seha maior que o primeiro*/
            if (widgetPopUp.currentRow[args.owner.name]["start"] > widgetPopUp.currentRow[args.owner.name]["end"]) {
                widgetPopUp.currentRow[args.owner.name]["end"] = "";
                $($("[name=" + args.owner.name + "]")[1]).val('');
            }
            /*FIM - limpa segundo campo caso ele seha maior que o primeiro*/
        } else {
            var dia = args.owner.name;
            if(dia == undefined){
                dia = args.owner.field.name
            }
            dia = dia.replace('2', '');
            if (widget.currentRow[dia]["start"] > widget.currentRow[dia]["end"]) { /*limpa segundo campo caso ele seha maior que o primeiro*/
                widget.currentRow[dia]["end"] = "";
                $($("[name=" + args.owner.name + "]")[1]).val('');
            }
            
           if (widget.currentRow[dia]["end"] > widget.currentRow[dia+'2']["start"]) { /*limpa primeiro campo pos intervalo caso o final seja maior*/
                widget.currentRow[dia+'2']["start"] = "";
                $($("[name=" + dia+'2' + "]")[0]).val('');
            }
       
       
            min = "1900-01-01 " + widget.currentRow[dia]["start"];
            widget.getField(dia)['datetime-minDate'] = min;

            /*Acrescenta 1 minuto ao inicio do horario depois do intervalo*/
            // if (widget.currentRow[dia + '2']["start"] == null || widget.currentRow[dia + '2']["start"] == "") {
                horadia = widget.currentRow[dia]["end"].split(":");
                if (horadia[1] == 59) {
                    if (horadia[0] == 24) {
                        horadia[0] = "00";
                        horadia[1] = "00";
                        horadia = [horadia[0], horadia[1]];
                    } else {
                        horadia[0] = Number(horadia[0]) + 1;
                        horadia[1] = "00";
                        horadia = [horadia[0], horadia[1]];
                    }
                } else {
                    horadia[1] = Number(horadia[1]) + 1;
                    horadia = [horadia[0], horadia[1]];
                }
                horaMaisIntervalo = horadia[0] + ":" + horadia[1];
                min2 = "1900-01-01 " + horaMaisIntervalo;
                widget.getField(dia + '2')['datetime-minDate'] = min2;
                widget.getField(dia+'2').reload();
        }
        // }
        
    };
    
    this.resetMaxMin = function(args) {
        var widget = templateManager.container.getWidget('WDGT_HORARIO_ATENDIMENTO');
        var widgetPopUp = templateManager.container.getWidget('inlineEditHora');
        
        if (templateManager.container.getActiveWidget().name == "inlineEditHora") {
            if(widgetPopUp.currentRow[args.owner.field.name]["start"] == ""){
                 var min = "1900-01-01 00:00";
                 widgetPopUp.getField(args.owner.field.name)['datetime-minDate'] = min;
                  self.setMaxMin(args);

            }
        }else{
          
            var dia = args.owner.field.name;
            
            if(widget.currentRow[dia]["start"] == ""){
                 min = "1900-01-01 00:00";
                 widget.getField(dia)['datetime-minDate'] = min;
                self.setMaxMin(args);
            }
            
        }
        
    };
    
    this.exibeIntervalo = function(widget){
        setTimeout(function(){
            if(widget.mode == "view"){
                
                if(widget.currentRow.IDINTERVALO_DOMINGO == "S"){
                    widget.getField('DOMINGO').class = 4;
                    widget.getField('DOMINGO2').isVisible = true;
                    widget.getField('DOMINGO2').validations = {
                        required: true
                    };
                    widget.getField('DOMINGO').label = "Primeiro Período";
                    widget.getField('DOMINGO2').label = "Segundo Período";
                } else {
                    widget.currentRow.DOMINGO2 = {
                        start: "",
                        end: ""
                    };
                    $("[name='DOMINGO2']").val('');
                    widget.getField('DOMINGO').class = 8;
                    widget.getField('DOMINGO2').isVisible = false;
                    widget.getField('DOMINGO2').validations = {
                        required: false
                    };
                    widget.getField('DOMINGO').label = "Domingo";
                }
                if(widget.currentRow.IDINTERVALO_QUARTA == "S"){
                    widget.getField('QUARTA').class = 4;
                    widget.getField('QUARTA2').isVisible = true;
                    widget.getField('QUARTA2').validations = {
                        required: true
                    };
                    widget.getField('QUARTA').label = "Primeiro Período";
                    widget.getField('QUARTA2').label = "Segundo Período";
                } else {
                    widget.currentRow.QUARTA2 = {
                        start: "",
                        end: ""
                    };
                    $("[name='QUARTA2']").val('');
                    widget.getField('QUARTA').class = 8;
                    widget.getField('QUARTA2').isVisible = false;
                    widget.getField('QUARTA2').validations = {
                        required: false
                    };
                    widget.getField('QUARTA').label = "Quarta-Feira";
                }
                if(widget.currentRow.IDINTERVALO_QUINTA == "S"){
                    widget.getField('QUINTA').class = 4;
                    widget.getField('QUINTA2').isVisible = true;
                    widget.getField('QUINTA2').validations = {
                        required: true
                    };
                    widget.getField('QUINTA').label = "Primeiro Período";
                    widget.getField('QUINTA2').label = "Segundo Período";
                } else {
                    widget.currentRow.QUINTA2 = {
                        start: "",
                        end: ""
                    };
                    $("[name='QUINTA2']").val('');
                    widget.getField('QUINTA').class = 8;
                    widget.getField('QUINTA2').isVisible = false;
                    widget.getField('QUINTA2').validations = {
                        required: false
                    };
                    widget.getField('QUINTA').label = "Quinta-Feira";
                }
                if(widget.currentRow.IDINTERVALO_SABADO == "S"){
                    widget.getField('SABADO').class = 4;
                    widget.getField('SABADO2').isVisible = true;
                    widget.getField('SABADO2').validations = {
                        required: true
                    };
                    widget.getField('SABADO').label = "Primeiro Período";
                    widget.getField('SABADO2').label = "Segundo Período";
                } else {
                    widget.currentRow.SABADO2 = {
                        start: "",
                        end: ""
                    };
                    $("[name='SABADO2']").val('');
                    widget.getField('SABADO').class = 8;
                    widget.getField('SABADO2').isVisible = false;
                    widget.getField('SABADO2').validations = {
                        required: false
                    };
                    widget.getField('SABADO').label = "Sabado";
                }
                if(widget.currentRow.IDINTERVALO_SEGUNDA == "S"){
                    widget.getField('SEGUNDA').class = 4;
                    widget.getField('SEGUNDA2').isVisible = true;
                    widget.getField('SEGUNDA2').validations = {
                        required: true
                    };
                    widget.getField('SEGUNDA').label = "Primeiro Período";
                    widget.getField('SEGUNDA2').label = "Segundo Período";
                } else {
                    widget.currentRow.SEGUNDA2 = {
                        start: "",
                        end: ""
                    };
                    $("[name='SEGUNDA2']").val('');
                    widget.getField('SEGUNDA').class = 8;
                    widget.getField('SEGUNDA2').isVisible = false;
                    widget.getField('SEGUNDA2').validations = {
                        required: false
                    };
                    widget.getField('SEGUNDA').label = "Segunda-Feira";
                }
                if(widget.currentRow.IDINTERVALO_SEXTA == "S"){
                    widget.getField('SEXTA').class = 4;
                    widget.getField('SEXTA2').isVisible = true;
                    widget.getField('SEXTA2').validations = {
                        required: true
                    };
                    widget.getField('SEXTA').label = "Primeiro Período";
                    widget.getField('SEXTA2').label = "Segundo Período";
                } else {
                    widget.currentRow.SEXTA2 = {
                        start: "",
                        end: ""
                    };
                    $("[name='SEXTA2']").val('');
                    widget.getField('SEXTA').class = 8;
                    widget.getField('SEXTA2').isVisible = false;
                    widget.getField('SEXTA2').validations = {
                        required: false
                    };
                    widget.getField('SEXTA').label = "Sexta-Feira";
                }
                if(widget.currentRow.IDINTERVALO_TERCA == "S"){
                    widget.getField('TERCA').class = 4;
                    widget.getField('TERCA2').isVisible = true;
                    widget.getField('TERCA2').validations = {
                        required: true
                    };
                    widget.getField('TERCA').label = "Primeiro Período";
                    widget.getField('TERCA2').label = "Segundo Período";
                } else {
                    widget.currentRow.TERCA2 = {
                        start: "",
                        end: ""
                    };
                    $("[name='TERCA2']").val('');
                    widget.getField('TERCA').class = 8;
                    widget.getField('TERCA2').isVisible = false;
                    widget.getField('TERCA2').validations = {
                        required: false
                    };
                    widget.getField('TERCA').label = "Terça-Feira";
                }
                

                
            }
        }, 4);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm_Horario_Atendimento_Controller', crm_Horario_Atendimento_Controller);
});

// FILE: ./assets/js/controllers/CRM_Interlocutor_Controller.js
var CRM_Interlocutor_Controller = function(ScreenService, Utilities, General, Endereco, templateManager, CRM_Utilities, restEngine) {
    
    this.interlocutorOnEnterOnce = function(widget) {
        var filterRow = {};
        var fieldsToApply = ['IDATIVO'];
        
        CRM_Utilities.openFilterOnEnter(widget, filterRow, fieldsToApply);
    };
    
    this.filtraParcNegocio = function(widget) {
        var tipo = widget.getField('CDTIPOPARCPRINCIPAL');
        var parcnegocio = widget.getField('NRPARCNEGOCIO') ? widget.getField('NRPARCNEGOCIO') : widget.getField('NMPRINCIPALPARC');
        parcnegocio.value(null);
        if(tipo.value()) {
            parcnegocio.dataSourceFilter[0].value = tipo.value();
        } else {
            parcnegocio.dataSourceFilter[0].value = "@['CANDIDATO', 'PROSPECT', 'CLIENTE']@";
        }
        parcnegocio.reload();
    };
    
    this.backInterloc = function(args) {
        args.owner.widget.getAction('buscaCEP').isVisible = false;
        ScreenService.closeSwipe();
        args.owner.widget.list()
    };
    
    this.editInterloc = function(parentWidget) {
        parentWidget.getAction('buscaCEP').isVisible = true;
        General.edit(parentWidget);
    };
    
    this.cancelEditInterloc = function(args) {
        args.owner.widget.getAction('buscaCEP').isVisible = false;
        General.backOrCancel(args);
    };
    
    this.salvarInterloc = function(widget) {
        var currentRow = widget.currentRow;
        if(currentRow.NRCPFINTERLOC && currentRow.NRCPFINTERLOC != null) //Se o CPF estiver preenchido
        currentRow.NRCPFINTERLOC = currentRow.NRCPFINTERLOC.replace(/\D/g,''); //Tira os caracteres não-numéricos do CPF
        
        var paramsRestEngine = {
            "requestType": "Row",
            "row": widget.currentRow
        };
        restEngine.post('/crm_interlocutor/save', paramsRestEngine).then(function() {
            //ScreenService.closeSwipe();
            widget.getAction('buscaCEP').isVisible = true;
            widget.view();
            widget.reload();
        });
    };
    
    this.searchCountry = function() {
        var widget = templateManager.container.getActiveWidget();
        var pais = widget.getField('NMPAIS');
        var estado = widget.getField('NMESTADO');
        var municipio = widget.getField('NMMUNICIPIO');
        var bairro = widget.getField('NMBAIRRO');
        var paramsToSearch = [
            widget.currentRow.CDPAIS,
            widget.currentRow.SGESTADO,
            widget.currentRow.CDMUNICIPIO,
            widget.currentRow.CDBAIRRO
        ];
    
        if (Util.isEmptyOrBlank(widget.currentRow.CDPAIS) === false) {
            restEngine.post('/searchCountry', {'requestType': 'FilterData', 'paramsToSearch': paramsToSearch}).then(function(response) {
                if (response.dataset && response.dataset.dados) {
                    widget.currentRow.NMPAIS = response.dataset.dados[0].NMPAIS;
                    if (Util.isEmptyOrBlank(widget.currentRow.SGESTADO) === false) {
                        widget.currentRow.NMESTADO = response.dataset.dados[0].NMESTADO;
                        if (Util.isEmptyOrBlank(widget.currentRow.CDMUNICIPIO) === false) {
                            widget.currentRow.NMMUNICIPIO = response.dataset.dados[0].NMMUNICIPIO;
                            if (Util.isEmptyOrBlank(widget.currentRow.CDBAIRRO) === false) {
                                widget.currentRow.NMBAIRRO = response.dataset.dados[0].NMBAIRRO;
                            }
                        }
                    }
                }
            });
        }
    };
    
};

Configuration(function (ContextRegister) {
    ContextRegister.register('CRM_Interlocutor_Controller', CRM_Interlocutor_Controller);
});

// FILE: ./assets/js/controllers/crm_modorecebinfoController.js
function crm_modorecebinfoController(General) {

    this.saveModoRecebInfo = function(widget){
        
       var currentRow = widget.currentRow;
        
        if(currentRow.__is_new === true){
            
          
        
        }
        
        General.widgetSave(widget).then(function(response){
            widget.reload();
        });
           
    };
   
  
    
}

Configuration(function (ContextRegister) {
    ContextRegister.register("crm_modorecebinfoController", crm_modorecebinfoController);
});



// FILE: ./assets/js/controllers/CRM_Operador_Controller.js
function CRM_Operador_Controller(ScreenService, CRM_Operador_Repository, templateManager, restEngine, localStorageEngine, General)
{
    var self = this;
    self.operadorNewRow = function(widget)
    {
        self.masterDetailNewRow();
        this.setFilialField(widget, true);
        
        CRM_Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            widget.currentRow.NRORG = operator[0].NRORG;
            widget.currentRow.CDPAIS = "0055";
            widget.currentRow.NMPAIS = "Brasil";
            widget.currentRow.NRORGTRAB = operator[0].NRORG;
            self.blockCdoperadorField(widget, true);

            widget.currentRow.CDCLIENTE = null;
            widget.currentRow.CDEMPRESA = null;
            widget.currentRow.DTULTATUOPER = null;
            widget.currentRow.IDOPERACESSO = null;
            widget.currentRow.NRESTRUTTRAB = null;
            widget.currentRow.IDOPERMASTER = 'N';
            widget.currentRow.NRINSCRICAOPARC = null;
            widget.currentRow.NRORGSELECIONADA = null;
            widget.currentRow.CDFILIALSELECIONADA = null;
            widget.currentRow.NRPERFILSELECIONADO = null;

            restEngine.post('/crm_operadorTelaPrincipal/getOrganizacao', {'requestType':'Row', 'row': widget.currentRow},
                undefined, undefined, undefined).then(function(response)
                {
                    widget.currentRow.NMORGANIZACAO = response.dataset.DADOS.NMORGANIZACAO;
                });
            
        }.bind(this));
    };

    this.setFilialField = function(widget, visible){
        /*var loggedOperator = templateManager.LOGGEDOPERATOR;
        var filiaisField   = widget.getField('CDFILIAL');
        
        if(visible === true && loggedOperator.IDOPERMASTER === "S" && widget.currentRow.__is_new === true){
            filiaisField.showOnForm = true;
            if(widget.currentRow.IDOPERMASTER === "N")
                filiaisField.validations = {required:true};
            else
                filiaisField.validations = {};
        }else {
            filiaisField.showOnForm = false;
            filiaisField.validations = {};
        }*/
    };
    
    this.aplicaStylesGridSelect = function(fieldSelect){
        fieldSelect.selectWidget.styles = [
            {
                condition: "row.IDATIVO==='N'",
                cssClass: "coc-inactive"
            }
        ];
        fieldSelect.selectWidget.reload();
    };

    this.changeCase = function(field) {
        var valor = field.value();
        field.setValue(valor.toLowerCase());
        
        /*if (field.name == 'DSEMAILOPER') {
            field.widget.currentRow.DSEMAILOPER = field.widget.currentRow.DSEMAILOPER.toLowerCase();
            field.reload();
        }

        if (field.name == 'NMACESSO') {
            field.widget.currentRow.NMACESSO = field.widget.currentRow.NMACESSO.toUpperCase();
            field.reload();
        }*/
    };

    this.fillOperador = function(field){
        var widget = field.widget;
        var cdOper = widget.currentRow.CDOPERADOR;
        
        cdOper = '000000000000' + cdOper;
        cdOper = cdOper.substr(cdOper.length-12);
        widget.currentRow.CDOPERADOR = cdOper;
        field.reload();
    };

    self.blockCdoperadorField = function(widget, state)
    {
        widget.getField('CDOPERADOR').readOnly = state;
    };

    self.perfilNewRow = function(widget)
    {
        self.masterDetailNewRow();

        widget.getField('NMPERFILACESSO').showOnForm = false;
        var field = widget.getField('NMPERFILACESSO_MULT');
        field.showOnForm = true;
        field.dataSourceFilter[0].value = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        field.reload();

        widget.currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCNEGOCIO;
    };

    self.filialNewRow = function(widget)
    {
        self.masterDetailNewRow();

        widget.getField('NMFILIAL').showOnForm = false;
        var field = widget.getField('NMFILIAL_MULT');
        field.showOnForm = true;
        field.dataSourceFilter[0].value = widget.parent.parent.currentRow.CDOPERADOR;
        field.reload();

        CRM_Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            widget.currentRow.CDOPERADOR = widget.parent.parent.currentRow.CDOPERADOR;
            widget.currentRow.NRORGFILIAL = operator[0].NRORG;
            widget.currentRow.IDEXIBAVISO = null;
            widget.currentRow.DTULTATUFOPE = null;
        });
    };

    self.widgetEdit = function(widget, field)
    {
        widget.getField(field).showOnForm = true;
        widget.getField(field+'_MULT').showOnForm = false;
        widget.getField(field+'_MULT').validations = {};

        self.masterDetailEdit();
    };


    self.widgetCancel = function(widget, field)
    {
        widget.getField(field).showOnForm = true;
        widget.getField(field+'_MULT').showOnForm = false;
        widget.getField(field+'_MULT').validations = {"required": {}};

        self.masterDetailCancelForm();
    };

    self.defaultEditAuditRow = function(widget, operator)
    {
        var nrorg = operator[0].NRORG;
        var cdoperador = operator[0].CDOPERADOR;
        var dtinclusao = moment(new Date()).format('DD/MM/YYYY HH:mm');

        if(widget.currentRow.__is_new)
        {
            widget.currentRow.NRORG = nrorg;
            widget.currentRow.NRORGINCLUSAO = nrorg;
            widget.currentRow.CDOPERINCLUSAO = cdoperador;
            widget.currentRow.DTINCLUSAO = dtinclusao;
        }
        else
        {
            widget.currentRow.NRORGULTATU = nrorg;
            widget.currentRow.CDOPERULTATU = cdoperador;
            widget.currentRow.DTULTATU = dtinclusao;
        }
    };

    self.checkRequirements = function(widget)
    {
        if(!widget.isValid())
        {
            ScreenService.showMessage('Preencha todos os campos marcados com asterisco!');
            return false;
        }

        return true;
    };

    self.validaInscricao = function(widget)
    {
        if(isNaN(widget.currentRow.NRINSCRICAOPARC))
        {
            ScreenService.showMessage("Número de Inscrição Juridica deve ser um número válido.");
            return false;
        }

        return true;
    };

    self.checaInscricao = function(widget)
    {
        var nrinscricaoparc = widget.currentRow.NRINSCRICAOPARC;
        var checagem = true;

        if((nrinscricaoparc !== null) && (nrinscricaoparc !== undefined))
        {
            checagem = self.validaInscricao(widget);
            if(checagem)
            {
                if(nrinscricaoparc.length == 11)
                {
                    widget.currentRow.CDTIPOINSCRICAO = "CPF";
                }else if(nrinscricaoparc.length == 14)
                {
                    widget.currentRow.CDTIPOINSCRICAO = "CNPJ";
                }
                else
                {
                    widget.currentRow.CDTIPOINSCRICAO = "LIVRE";
                }
            }
        }
        else
        {
            widget.currentRow.CDTIPOINSCRICAO = "LIVRE";
        }

        return checagem;
    };

    self.saveOperador = function(widget)
    {
        if(widget.isValid() && self.checaInscricao(widget))
        {
            CRM_Operador_Repository.retornaOperadorLogado().then(function(operator)
            {
                var senha = widget.currentRow.CDSENHAOPERWEB;
                var confirmarSenha = widget.currentRow.CONFIRMAR_SENHA;
            
                if (senha === confirmarSenha) {    
                    
                    self.defaultEditAuditRow(widget, operator);
                    widget.currentRow.IDOPERATIVO = (widget.currentRow.IDATIVO == 'S') ? 'A' : 'I';
    
                    if(widget.currentRow.__is_new === false)
                    {
                        widget.currentRow.OLDNRINSCRICAOPARC = widget.backupRow.NRINSCRICAOPARC;
                        widget.currentRow.OLDCDCLIENTE = widget.backupRow.CDCLIENTE;
                        widget.currentRow.OLDCDSENHAOPERWEB = widget.backupRow.CDSENHAOPERWEB;
                        widget.currentRow.OLDNMOPERADOR = widget.backupRow.NMOPERADOR;
                    }
    
                    var cdOper = widget.currentRow.CDOPERADOR;
    
                    if(!widget.currentRow.NRINSCRICAOPARC) {
                        widget.currentRow.NRINSCRICAOPARC = cdOper;
                    } else {
                        widget.currentRow.NRINSCRICAOPARC = widget.currentRow.NRINSCRICAOPARC;
                    }
                    this.retornaFiliaisOperadorLogado().then(function(response){
                        if(templateManager.LOGGEDOPERATOR.IDOPERMASTER === "N"){
                           widget.currentRow.FILIAIS = response.map(function(filial){
                                return filial.CDFILIAL;   
                           }); 
                           widget.currentRow.IDOPERMASTERLOGADO = "N";
                        }
                        widget.saveRow().then(function(response)
                        {
                            widget.currentRow.changed = false;
                            widget.currentRow.__is_new = false;
                            
                            if(response.dataset) {
                                if(response.dataset.DADOS)
                                {
                                    if(response.dataset.DADOS.NRPARCNEGOCIO)
                                    {
                                        widget.currentRow.NRPARCNEGOCIO = response.dataset.DADOS.NRPARCNEGOCIO;
                                        widget.currentRow.CDOPERADOR = response.dataset.DADOS.CDOPERADOR;
                                    }
                                    //widget.currentRow.CDSENHOPER = response.dataset.DADOS.CDSENHOPER;
                                    if(response.dataset.DADOS.CDSENHAOPERWEB)
                                    {
                                        widget.currentRow.CDSENHAOPERWEB = response.dataset.DADOS.CDSENHAOPERWEB;
                                        widget.currentRow.CONFIRMAR_SENHA = response.dataset.DADOS.CDSENHAOPERWEB;
                                    }
                                }
                            }
                            self.blockCdoperadorField(widget, true);
        
                            self.changeWidgetVisibility(widget.widgets, true);
                            widget.list();
                            ScreenService.closeSwipe();
                            widget.reload();
                            this.setVisibilityFilialTab(widget);
                        }.bind(this)).catch(function(error){
                            if(error.data && error.data.error){
                                //tratando restrição unique de email
                                if(error.data.error.indexOf('USR_ORG_SAAS.UN_OPERADOR')  !== -1)
                                    ScreenService.showMessage("Operação bloqueada! <br><br> Já existe um operador com este email.");
                                else
                                    ScreenService.showMessage(error.data.error);
                            }
                        });
                    }.bind(this));
                }else {
                    ScreenService.showMessage("As senhas não correspondem.");
                }
            }.bind(this));
        }
    };

    self.savePerfil = function(widget)
    { 
        if(self.checkRequirements(widget))
        {
            CRM_Operador_Repository.retornaOperadorLogado().then(function(operator)
            {
                self.defaultEditAuditRow(widget, operator);

                if(widget.getField("NMPERFILACESSO_MULT").selectWidget) {
                
                    var rows = widget.getField("NMPERFILACESSO_MULT").selectWidget.getCheckedRows();
                    
                    rows.forEach(function(row) {
                        row.NRPARCNEGOCIO = widget.currentRow.NRPARCNEGOCIO;
                        row.NRPERFACESSOPAI = row.NRPERFILACESSO;
                        row.IDATIVO = widget.currentRow.IDATIVO;
                        row.DTVALPERFILPARC = "";
                        row.__new_code_pk = "PERFACESSPARC";
                        row.__table_pk = "NRPERFACESSPARC";
                        row.__cast_number = true;
                        row.__new_code_length = 20;    
                        row.__is_new = true;                
                        row.changed = true;
                        row.__using_unit = false;
                    });

                    General.callRestEngine("/crm_perfacessparcCompleto/save", "DataSet", rows).then(function(success) {
                        ScreenService.closeSwipe();
                        widget.activate();
                        widget.reload();
                    }, function(error) {
                        ScreenService.closeSwipe();
                        widget.activate();
                        widget.reload();
                    });
                } else {
                    widget.saveRow().then(function(){
                        ScreenService.closeSwipe();
                        widget.activate();
                        widget.reload();
                    }, function(error) {
                        var msg = (error.data && error.data.error) ? 
                        msg = error.data.error : 'Registro já existente!';
                        ScreenService.showMessage(msg);
                    });
                }
            });
        }
    };

    self.saveFilial = function(widget)
    {
        if(self.checkRequirements(widget))
        {
            CRM_Operador_Repository.retornaOperadorLogado().then(function(operator)
            {
                self.defaultEditAuditRow(widget, operator);

                if(widget.getField("NMFILIAL_MULT").selectWidget) {
                
                    var rows = widget.getField("NMFILIAL_MULT").selectWidget.getCheckedRows();

                    rows.forEach(function(row) {
                        row.IDATIVO = widget.currentRow.IDATIVO;
                        row.__new_code_pk = "FILIAL";
                        row.__table_pk = "CDFILIAL";
                        row.__cast_number = true;
                        row.__new_code_length = 12;    
                        row.__is_new = true;                
                        row.changed = true;
                        row.__using_unit = false;
                    });
                    widget.saveRow().then(function(){
                        ScreenService.closeSwipe();
                        widget.activate();
                        widget.reload();
                    }, function(error) {
                        var msg = (error.data && error.data.error) ? 
                        msg = error.data.error : 'Registro já existente!';
                        ScreenService.showMessage(msg);
                    });
                } else {
                    widget.saveRow().then(function(){
                        ScreenService.closeSwipe();
                        widget.activate();
                        widget.reload();
                    }, function(error) {
                        var msg = (error.data && error.data.error) ? 
                        msg = error.data.error : 'Registro já existente!';
                        ScreenService.showMessage(msg);
                    });
                }
            });
        }
    };

    self.iniciarDataSourceChild = function(widget)
    {
        var widPerf = widget.widgets[0];
        var widFili = widget.widgets[1];

        self.initTabGeneric(widPerf, "NRPARCNEGOCIO");
        self.initTabGeneric(widFili, "CDOPERADOR");
    };

    self.initTabGeneric = function(widget, field)
    {
        if(typeof widget === "string"){
            widget = templateManager.container.getWidget(widget);
        }
        if(widget.parent.parent.currentRow[field])
        {
            widget.dataSourceFilter[0].value = widget.parent.parent.currentRow[field];
            widget.reload();
        }
    };

    self.changeWidgetVisibility = function(widgets, isVisible) {
        widgets.forEach(function(widget){
            if(widget.name !== "wdgSenha"){
                widget.isVisible = isVisible;
                widget.enabled = true;
                widget.reload();
            }
        });
    };

    self.formChangeTemplate = function() {
        var widget = templateManager.container.getActiveWidget();

        if((widget.template != "widget/form.html")&&(widget.template != "widget/form-view.html")) return false;

        if(!widget.templateToForm) widget.templateToForm = "widget/form.html";
        if(!widget.templateToView) widget.templateToForm = "widget/form-view.html";

        if(widget.template == widget.templateToForm) widget.template = widget.templateToView;
        else if(widget.template == widget.templateToView) widget.template = widget.templateToForm;

        templateManager.updateTemplate();

        return true;
    };

    self.goBackToDashboard = function() {
        ScreenService.openWindow('dashboard');
    };

    self.masterDetailCancelForm = function() {
        var widget = templateManager.container.getActiveWidget();

        self.changeWidgetVisibility(widget.widgets, true);

        if(widget.currentRow.__is_new) {
            var indexOfCurrentRow = widget.dataSource.data.indexOf(widget.currentRow);
            if(indexOfCurrentRow !== -1) {
                widget.dataSource.data.pop();
            }
            if(!self.formChangeTemplate()) widget.list();
            else widget.list();

            ScreenService.closeSwipe();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            self.formChangeTemplate();
            widget.view();
        }
    };

    self.masterDetailClosePopup = function() {
        var popup = templateManager.container.getActiveWidget();

        ScreenService.closePopup();
        popup.deactivate();
        popup.parentWidget.currentWidget = popup.parentWidget;
        popup.parentWidget.activate();
    };

    self.masterDetailDelete = function() {
        var widget = templateManager.container.getActiveWidget();
        ScreenService.confirmMessage("Deseja deletar o registro?", "CONFIRMATION", function() {
            widget.remove();
            self.masterDetailGoBackToList();
        }.bind(this));
    };

    self.masterDetailDeleteOper = function(row) {

        var widget = templateManager.container.getActiveWidget();
        
        ScreenService.confirmMessage("Deseja deletar o registro?", "CONFIRMATION", function() {
            General.callRestEngine("/operadorTelaPrincipal/remove", "Row", row).then(function(success) {
                ScreenService.closeSwipe();
                widget.activate();
                widget.reload();
            }, function(error) {
                var msg = (error.data && error.data.error) ?
                msg = error.data.error : 'Registro já existente!';
                ScreenService.showMessage(msg);
            });
        }.bind(this));
    };
    
    self.masterDetailEdit = function() {
        var widget = templateManager.container.getActiveWidget();

        self.changeWidgetVisibility(widget.widgets, false);
        self.formChangeTemplate();

        widget.backupRow = Util.clone(widget.currentRow);
        widget.edit();
    };

    self.masterDetailGoBackToList = function() {
        var widget = templateManager.container.getActiveWidget();

        ScreenService.closeSwipe();
        widget.list();
    };

    self.masterDetailGoBackToParent = function() {
        var widget = templateManager.container.getActiveWidget();

        ScreenService.closeSwipe().then(function(){
            widget.parent.parent.list();
            widget.parent.parent.activate();
        });
    };

    self.masterDetailNewRow = function() {
        var widget = templateManager.container.getActiveWidget();

        self.changeWidgetVisibility(widget.widgets, false);

        widget.newRow();
    };

    /*self.masterDetailOpenPopup = function(name) {
        var widget = templateManager.container.getActiveWidget();

        var popup = widget.container.getWidget(name);
        popup.parentWidget = widget;
        ScreenService.openPopup(popup);
        ZhGridFilter.startFiltering();
    };*/

    self.masterDetailSave = function() {
        var widget = templateManager.container.getActiveWidget();

        self.changeWidgetVisibility(widget.widgets, true);
        self.formChangeTemplate();

        if(widget.isValid()) {
            widget.currentRow.changed = true;

            if(widget.currentRow.__is_new) {
                widget.currentRow.NRORGINCLUSAO = (widget.currentRow.NRORGINCLUSAO)? widget.currentRow.NRORGINCLUSAO : getLocalVar('CRM_NRORG');
                widget.currentRow.CDOPERINCLUSAO = (widget.currentRow.CDOPERINCLUSAO)? widget.currentRow.CDOPERINCLUSAO : getLocalVar('CDOPERADOR');
            } else {
                widget.currentRow.NRORGULTATU = (widget.currentRow.NRORGULTATU)? widget.currentRow.NRORGULTATU : getLocalVar('CRM_NRORG');
                widget.currentRow.CDOPERULTATU = (widget.currentRow.CDOPERULTATU)? widget.currentRow.CDOPERULTATU : getLocalVar('CDOPERADOR');
            }

            return widget.saveRow().then(function(response){
                widget.currentRow.changed = false;
                widget.currentRow.__is_new = false;
                ScreenService.showMessage("Registro salvo com sucesso");
                ScreenService.closeSwipe();
                widget.list();
                widget.reload();
            }).catch(function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };

    self.unMask = function(columnName) {
        var widget = templateManager.container.getActiveWidget();

        if(widget.currentRow[columnName] && typeof widget.currentRow[columnName] === 'string' && widget.currentRow[columnName].indexOf('R$') != -1)
            widget.currentRow[columnName] = $.currency.unmaskString(widget.currentRow[columnName], {"thousands": "."});
        if(widget.currentRow[columnName] && typeof widget.currentRow[columnName] === 'string' && widget.currentRow[columnName].indexOf('%') != -1)
            widget.currentRow[columnName] = parseFloat(widget.currentRow[columnName].replace(',', '.'));
    };

    self.wizardChangeFooter = function() {
        var widget = templateManager.container.getActiveWidget();

        widget.container.footer = (widget.container.footer == "component/footer.html")?
            "component/footer-wizard.html" : "component/footer.html";
    };

    self.wizardGoBack = function(){
        wizardEngine.previous();
    };

    self.wizardGoNext = function(){
        wizardEngine.next();
    };

    self.getValorEmReais = function(value)
    {
        var pad = "00";
        var valorFatura = value.split('.');

        if(valorFatura[1] === undefined)
        {
            valorFatura[1] = "";
        }
        valorFatura[1] = String(valorFatura[1]) + pad.substring(0, pad.length - String(valorFatura[1]).length);

        if(valorFatura[0] === '')
        {
            valorFatura[0] = "0";
        }
        var aux = "";
        for(var i = valorFatura[0].length - 1; i >= 0; i--)
        {
            if(((valorFatura[0].length -1 - i)%3 === 0) && (valorFatura[0].length -1 !== i))
            {
                aux += ".";
            }
            aux += valorFatura[0][i];
        }

        aux = aux.split("").reverse().join("");
        var valorEmReais = "R$ "+aux+","+valorFatura[1];
        return valorEmReais;
    };

    /*self.validateFilterPopup = function(args)
    {
        var filterPopup = templateManager.currentWidget;
        unidade = filterPopup.currentRow.CDFILIAL;
        if(!filterPopup.isValid())
            args.e.preventDefault();
    };*/
    
    this.wdgSenhaSetCurrentRow = function(widget) {
        widget.currentRow = widget.parent.dataSource.data[0];
    };
    
    this.wdgSenhaEditar = function(widget) {
        General.widgetEdit(widget);
        widget.currentRow.CDSENHAOPERWEB = "";
        widget.currentRow.CONFIRMAR_SENHA = "";
    };
    
    this.wdgSenhaSalvar = function(widget) {
        if (widget.isValid()) {
            var senha = widget.currentRow.CDSENHAOPERWEB;
            var confirmarSenha = widget.currentRow.CONFIRMAR_SENHA;
            
            if (senha === confirmarSenha) {
                restEngine.post('/crm_operadorTelaPrincipal/saveSenha', {'requestType':'Row', 'row': widget.currentRow})
                .then(function(response){
                    if(response.dataset) {
                        if(response.dataset.DADOS)
                        {
                            if(response.dataset.DADOS.CDSENHAOPERWEB)
                            {
                                widget.currentRow.CDSENHAOPERWEB = response.dataset.DADOS.CDSENHAOPERWEB;
                                widget.currentRow.CONFIRMAR_SENHA = response.dataset.DADOS.CDSENHAOPERWEB;
                            }
                        }
                        widget.parent.enabled = true;
                        widget.parent.parent.reload();
                        self.changeWidgetVisibility(widget.parent.parent.widgets, true);
                        self.wdgSenhaSetCurrentRow(widget);
                        widget.template = "widget/form-view.html";
                        widget.view();
                        
                        
                    }
                });
            }
            else {
                ScreenService.showMessage("As senhas não correspondem.");
            }
        }
    };
    
    this.setOrganOper = function(args){
        var widget = args;
        if (widget.isValid()) {
            widget.currentRow.NRORG = getLocalVar('CRM_NRORG') ? getLocalVar('CRM_NRORG') : " ";
            widget.currentRow.CDOPERADOR = widget.parent.parent.currentRow.CDOPERADOR;
            widget.currentRow.CDOPERINCLUSAO = getLocalVar('CRM_CDOPERADOR');
            return General.saveCrud(widget).then(function(response){
                widget.reload();
            });
           
        }
    };
    
    this.setVisibilityFilialTab = function(widget){
        var visible;
        if(templateManager.LOGGEDOPERATOR.IDOPERMASTER === "S"){
            visible = true;
        }else{
            visible = false;
        }
        if(widget.currentRow.__is_new !== true){
            widget.widgets.forEach(function(tab){
                if(tab.name === "FILIOPER"){
                    tab.isVisible = visible;
                }    
            });
        }
        this.setReadOnlyOperMasterField(widget, !visible);
    };
    
    this.setReadOnlyOperMasterField = function(widget, readOnly){
        widget.fields.forEach(function(field){
            if(field.name === "IDOPERMASTER"){
                field.readOnly = readOnly;
            }    
        });    
    };
    
    /**
     * Seta os filtros padrões
     * 
     * @param {object} widget widget de OPERADOR
    */
    this.defaultFilters = function(widget){
        var filter = widget.__filterPopup;
        var NMFILIAL, P_CDFILIAL, filiaisFilter, filialField = widget.getField('P_CDFILIAL');
        var idopermaster = templateManager.LOGGEDOPERATOR.IDOPERMASTER;
        
        if(idopermaster === "N"){
            this.retornaFiliaisOperadorLogado().then(function(response){
                P_CDFILIAL = response.map(function(filial){
                    return filial.CDFILIAL;   
                });
                NMFILIAL = response.map(function(filial){
                    return filial.NMFILIAL;   
                });
                filter.currentRow.P_CDFILIAL = P_CDFILIAL;
                filter.currentRow.NMFILIAL = NMFILIAL;
                
                filter.getField('P_CDFILIAL').reload();
                
                filiaisFilter = {
                   "name":"CDFILIAL",
                   "operator":"IN",
                   "value": angular.copy(P_CDFILIAL)
                };
                filialField.dataSourceFilter.push(filiaisFilter);
                
            });
        }else{
            this.retornaFiliaisOrg().then(function(response){
                P_CDFILIAL = response.map(function(filial){
                    return filial.CDFILIAL;   
                });
                NMFILIAL = response.map(function(filial){
                    return filial.NMFILIAL;   
                });
                filter.currentRow.P_CDFILIAL = P_CDFILIAL;
                filter.currentRow.NMFILIAL = NMFILIAL;
                
                filter.getField('P_CDFILIAL').reload();
            });    
        }
        
    };
    
    this.retornaFiliaisOrg = function() {
        var filter = [
            {
                "name": "NRORG",
                "operator": "=",
                "value": templateManager.LOGGEDOPERATOR.NRORG
            }
        ];
        return localStorageEngine.download("product#/crud/filial", filter);
    };
    
    this.retornaFiliaisOperadorLogado = function() {
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": templateManager.LOGGEDOPERATOR.CDOPERADOR
            },
            {
                "name": "NRORG",
                "operator": "=",
                "value": templateManager.LOGGEDOPERATOR.NRORG
            }
        ];
        return localStorageEngine.download("product#/crm_filioperCompleto", filter);
    };
    
    this.callDefaultFilters = function(widget){
        var field = widget.getField('P_CDFILIAL');
        
        if(Util.isEmptyOrBlank(field.value())){
            this.defaultFilters(templateManager.container.getWidget('OPERADOR'));    
        }
    };
    
    /*Replica mudanças no IDATIVO para o IDOPERATIVO*/
    this.changeIdoperativo  =function(widget){
        widget.currentRow.IDOPERATIVO = (widget.currentRow.IDATIVO === 'S') ? 'A' : (widget.currentRow.IDATIVO === 'N') ? 'I' : '';
    };
    
    this.prepareAtivoFilter = function(widget){
        widget.dataSourceFilter.forEach(function(filter, index, filters){
            if(filter.name === "IDATIVO"){
                filters.push({
                    "name":"IDOPERATIVO",
                    "operator": "=",
                    "static":true,
                    "value": (filter.value === 'S') ? 'A' : 'I'
                });
            }
        });
    }
    /*Fim*/
}

Configuration(function(ContextRegister)
{
    ContextRegister.register('CRM_Operador_Controller', CRM_Operador_Controller);
});

// FILE: ./assets/js/controllers/CRM_ParceiroNegocio_Controller.js
var CRM_ParceiroNegocio_Controller = function (ScreenService, Utilities, General, CRM_ParceiroNegocio_Service, Endereco, templateManager, CRM_Utilities, AbaInterlocutorController, restEngine, ChamadoController, ABALogotipoParceiroController, localStorageEngine) {

    CRM_Utilities.addController(this, 'CRM_ParceiroNegocio_Controller');

    this.alteraEstadoReadonly = function (widget) {
        var paisField = widget.getField("NMPAIS");
        var estadoField = widget.getField("NMESTADO");
        var currentRow = widget.currentRow;
        if (!paisField.value()) {
            estadoField.readOnly = true;
            currentRow.SGESTADO = null;
            currentRow.NMESTADO = null;
        }
        else {
            estadoField.readOnly = false;
        }
        this.alteraMunicipioReadonly(widget);
    };

    this.changeValueFilterParceiroNegocio = function (widget) {

        var grid = widget;
        var filterParceiroNegocio = templateManager.container.getWidget("parceiroNegocio");
        var getFieldParcResp = filterParceiroNegocio.getField('CDOPERRESPONSAVEL');

        if (grid.currentRow.IDOPERATIVO == "I") {
            getFieldParcResp.dataSourceFilter[1].value = "I";
            grid.getField('CDOPERRESPONSAVEL').clearValue();
            getFieldParcResp.reload();
        } else {
            getFieldParcResp.dataSourceFilter[1].value = "A";
            getFieldParcResp.reload();
        }
    }

    this.alteraMunicipioReadonly = function (widget) {
        var estadoField = widget.getField("NMESTADO");
        var municipioField = widget.getField("NMMUNICIPIO");
        var currentRow = widget.currentRow;
        if (!estadoField.value()) {
            municipioField.readOnly = true;
            currentRow.NMMUNICIPIO = null;
            currentRow.CDMUNICIPIO = null;
            currentRow.NMMUNICIPIO = null;
        }
        else {
            municipioField.readOnly = false;
        }
        this.alteraBairroReadonly(widget);
    };

    this.alteraBairroReadonly = function (widget) {
        var municipioField = widget.getField("NMMUNICIPIO");
        var bairroField = widget.getField("NMBAIRRO");
        var currentRow = widget.currentRow;
        if (!municipioField.value()) {
            bairroField.readOnly = true;
            currentRow.NMBAIRRO = null;
            currentRow.CDBAIRRO = null;
            currentRow.NMBAIRRO = null;
        }
        else {
            bairroField.readOnly = false;
        }
    };

    this.cancelarNovoParceiro = function () {
        var enderecoPrincipalWidget = templateManager.container.getWidget("enderecoPrincipal");
        enderecoPrincipalWidget.isVisible = false;
        enderecoPrincipalWidget.showAsTab = false;

        var enderecoWidget = templateManager.container.getWidget("parceiroNegocioEndereco");
        enderecoWidget.isVisible = true;
        enderecoWidget.showAsTab = true;

        var parentWidget = templateManager.container.getWidget("parceiroNegocio");
        parentWidget.list();
        parentWidget.dataSource.data.pop();
        parentWidget.currentRow = {};
        toggleWidgetsEnabled(parentWidget.widgets, true);
        ScreenService.goBack();
    };

    this.checkDataExists = function (field, sourceName, sourceParent) {
        field.reload().then(function () {
            if (!(field.dataSource.data && field.dataSource.data.length > 0)) {
                ScreenService.showMessage(ScreenService.i18n("Não há " + sourceName + " cadastrado para o " + sourceParent + " informado."));
            }
        });
    };

    this.cancelEditParceiro = function (args) {
        var parentWidget = args.owner.widget;
        if (parentWidget.isNewRow()) {
            this.cancelarNovoParceiro();
        } else {
            General.backOrCancel(args);
            toggleWidgetsEnabled(parentWidget.widgets, true);
        }
    };

    this.checkTransportadoraIsSelected = function (widget, editingWidget) {
        var tiposParceiro = widget.currentRow.TIPODEPARCEIRO;
        if (Array.isArray(tiposParceiro) && tiposParceiro.indexOf("TRANSPORTADORA") !== -1) {
            if (tiposParceiro.indexOf("FORNECEDOR") === -1 && editingWidget) {
                widget.currentRow.TIPODEPARCEIRO.push("FORNECEDOR");
            }
            changeTransportFieldsVisibility(widget, true);
        }
        else {
            changeTransportFieldsVisibility(widget, false);
        }
    };

    var changeTransportFieldsVisibility = function (widget, isVisible) {
        var fieldGroups = widget.fieldGroups.filter(function (fieldGroup) {
            return fieldGroup.name == "transportadora";
        });
        if (fieldGroups[0]) {
            fieldGroups[0].isVisible = isVisible;
        }
        if (!isVisible) {
            var currentRow = widget.currentRow;
            widget.getField("NRINSESTTRANFORMAT").validations = {};
            widget.getField("NRCEPENDERECO").validations = {};
            widget.getField("NMPAIS").validations = {};
            widget.getField("NMESTADO").validations = {};
            if (!Util.isEmptyOrBlank(widget.getField("NMMUNICIP"))) {
                widget.getField("NMMUNICIP").validations = {};
            } else if (!Util.isEmptyOrBlank(widget.getField("NMMUNICIPIO"))) {
                widget.getField("NMMUNICIPIO").validations = {};
            }
            widget.getField("NMBAIRRO").validations = {};
            widget.getField("DSENDERECO").validations = {};
            currentRow.NRINSESTTRAN = null;
            currentRow.NRCEPENDERECO = null;
            currentRow.NMPAIS = null;
            currentRow.NMESTADO = null;
            if (!Util.isEmptyOrBlank(widget.getField("NMMUNICIP"))) {
                currentRow.NMMUNICIP = null;
            } else if (!Util.isEmptyOrBlank(widget.getField("NMMUNICIPIO"))) {
                currentRow.NMMUNICIPIO = null;
            }
            currentRow.NMBAIRRO = null;
            currentRow.DSENDERECO = null;
        }
        else {
            widget.getField("NRINSESTTRANFORMAT").validations = { required: true };
            widget.getField("NRCEPENDERECO").validations = { required: true };
            widget.getField("NMPAIS").validations = { required: true };
            widget.getField("NMESTADO").validations = { required: true };
            if (!Util.isEmptyOrBlank(widget.getField("NMMUNICIP"))) {
                widget.getField("NMMUNICIP").validations = { required: true };
            } else if (!Util.isEmptyOrBlank(widget.getField("NMMUNICIPIO"))) {
                widget.getField("NMMUNICIPIO").validations = { required: true };
            }
            widget.getField("NMBAIRRO").validations = { required: true };
            widget.getField("DSENDERECO").validations = { required: true };
        }
    };

    this.editEnderecoParceiro = function (widget) {
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;

        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                if (canEdit) {
                    General.edit(widget);
                    this.alteraEstadoReadonly(widget);
                    widget.getField("CDTIPOENDERECO").readOnly = (widget.currentRow.CDTIPOENDERECO == "PRINCIPAL");
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this)).catch(function (error) {
                console.error('Error in editEnderecoParceiro:', error);
            });
        } else {
            General.edit(widget);
            this.alteraEstadoReadonly(widget);
            widget.getField("CDTIPOENDERECO").readOnly = (widget.currentRow.CDTIPOENDERECO == "PRINCIPAL");
        }
    };

    this.editParceiro = function (parentWidget) {
        var nrParcNegocio = parentWidget.currentRow.NRPARCNEGOCIO;
        var tipoParc = parentWidget.currentRow.CDTIPOPARCPRINCIPAL;
        var tiposDeParceiro = parentWidget.currentRow.TIPODEPARCEIRO;

        if (tiposDeParceiro !== null && !Array.isArray(tiposDeParceiro)) {
            parentWidget.currentRow.TIPODEPARCEIRO = tiposDeParceiro.split(",");
        }

        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                if (canEdit) {
                    General.edit(parentWidget);
                    toggleWidgetsEnabled(parentWidget.widgets, false);
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this)).catch(function (error) {
                console.error('Error in editParceiro:', error);
            });
        } else {
            General.edit(parentWidget);
            toggleWidgetsEnabled(parentWidget.widgets, false);
        }
    };

    this.enderecoAfterMoveRow = function (widget) {
        widget.actions.filter(function (action) {
            return action.name == "delete";
        })[0].isVisible = (widget.currentRow.CDTIPOENDERECO != "PRINCIPAL");
    };

    this.novoComunicacao = function (widget) {
        var parentRow = widget.parent.parent.currentRow;
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;

        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                if (canEdit) {
                    widget.edit();
                    widget.newRow();
                    widget.currentRow.NRPARCNEGOCIO = parentRow.NRPARCNEGOCIO;
                    // widget.currentRow.NRENDERECOPARC = '5';
                    widget.currentRow.CDCOMPLECOMUPARC = '5';
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this)).catch(function (error) {
                console.error('Error in novoComunicacao:', error);
            });
        } else {
            widget.edit();
            widget.newRow();
            widget.currentRow.NRPARCNEGOCIO = parentRow.NRPARCNEGOCIO;
            // widget.currentRow.NRENDERECOPARC = '5';
            widget.currentRow.CDCOMPLECOMUPARC = '5';
        }
    };

    this.novoEndeParc = function (widget) {
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;

        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                if (canEdit) {
                    var parentRow = widget.parent.parent.currentRow;
                    widget.edit();
                    widget.newRow();
                    widget.currentRow.NRPARCNEGOCIO = parentRow.NRPARCNEGOCIO;
                    widget.getField("CDTIPOENDERECO").readOnly = false;
                    this.alteraEstadoReadonly(widget);
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this)).catch(function (error) {
                console.error('Error in novoEndeParc:', error);
            });
        } else {
            var parentRow = widget.parent.parent.currentRow;
            widget.edit();
            widget.newRow();
            widget.currentRow.NRPARCNEGOCIO = parentRow.NRPARCNEGOCIO;
            widget.getField("CDTIPOENDERECO").readOnly = false;
            this.alteraEstadoReadonly(widget);
        }
    };

    this.novoParceiro = function (widget) {
        widget.newRow();
        toggleWidgetsEnabled(widget.widgets, false);

        var enderecoWidget = templateManager.container.getWidget("parceiroNegocioEndereco");
        enderecoWidget.isVisible = false;
        enderecoWidget.showAsTab = false;

        var enderecoPrincipalWidget = templateManager.container.getWidget("enderecoPrincipal");
        enderecoPrincipalWidget.newRow();
        enderecoPrincipalWidget.enabled = true;
        enderecoPrincipalWidget.isVisible = true;
        enderecoPrincipalWidget.showAsTab = true;
        enderecoPrincipalWidget.currentRow.NMTIPOENDERECO = "Principal";
        enderecoPrincipalWidget.currentRow.CDTIPOENDERECO = "PRINCIPAL";

        this.alteraEstadoReadonly(enderecoWidget);
        this.alteraEstadoReadonly(enderecoPrincipalWidget);

        widget.currentRow.IDPESSOAFISICA = 'N';
        widget.currentRow.IDPARCFUNDIDO = 'N';
        widget.currentRow.IDINSTITUICAO = 'N';
    };

    this.nrinscricaoOnChange = function (field) {
        var currentRow = field.widget.currentRow;
        if (field.value()) {
            var validations = General.inscricaoFormat(field.value(), true);
            var tipoInscricaoParceiro = CRM_ParceiroNegocio_Service.getTipoInscricao(validations.tipo.cod);
            if (tipoInscricaoParceiro === undefined) {
                ScreenService.showMessage(ScreenService.i18n("Ocorreu um erro ao validar a inscrição."));
            }
            else {
                currentRow.NRINSCRICAOPARCFORMAT = validations.value;
                currentRow.CDTIPOINSCRICAO = tipoInscricaoParceiro;
                currentRow.NRINSCRICAOPARC = validations.parameter;
                if (tipoInscricaoParceiro == "CPF") {
                    currentRow.IDPESSOAFISICA = 'S';
                    currentRow.IDINSTITUICAO = 'N';
                }
                else {
                    currentRow.IDPESSOAFISICA = 'N';
                    currentRow.IDINSTITUICAO = 'S';
                    if (tipoInscricaoParceiro != "CNPJ") {
                        currentRow.NRINSCRICAOPARC = validations.value;
                    }
                }
            }
        }
        else {
            currentRow.CDTIPOINSCRICAO = null;
            currentRow.NRINSCRICAOPARC = null;
        }
    };

    this.nrinscricaoEstadualOnChange = function (field) {
        var currentRow = field.widget.currentRow;
        if (field.value()) {
            var validations = General.inscricaoFormat(field.value(), true);
            var tipoInscricaoParceiro = CRM_ParceiroNegocio_Service.getTipoInscricao(validations.tipo.cod);
            if (tipoInscricaoParceiro === undefined) {
                ScreenService.showMessage(ScreenService.i18n("Ocorreu um erro ao validar a inscrição estadual."));
            }
            else {
                currentRow.NRINSESTTRANFORMAT = validations.value;
                currentRow.NRINSESTTRAN = tipoInscricaoParceiro == "LIVRE" ? validations.value : validations.parameter;
            }
        }
        else {
            currentRow.NRINSESTTRAN = null;
        }
    };

    this.parceiroAfterMoveRow = function (widget) {

        ChamadoController.setTagsOnCurrentRow(widget, 'PARCNEGOCIO');

        /*
        var tiposDeParceiro = widget.currentRow.TIPODEPARCEIRO;
        if(tiposDeParceiro && !Array.isArray(tiposDeParceiro)) {
            widget.currentRow.TIPODEPARCEIRO = tiposDeParceiro.split(",");
            widget.currentRow.TIPODEPARCEIRO = tiposDeParceiro.split(", ");
        }*/


        if (!widget.isNewRow()) {
            var nrInscricao = widget.currentRow.NRINSCRICAOPARC;
            var nrInscricaoTrans = widget.currentRow.NRINSESTTRAN;
            var validations = General.inscricaoFormat(nrInscricao, true);
            widget.currentRow.NRINSCRICAOPARCFORMAT = validations.value;
            if (nrInscricaoTrans) {
                validations = General.inscricaoFormat(nrInscricaoTrans, true);
                widget.currentRow.NRINSESTTRANFORMAT = validations.value;
            }
        }

        this.checkTransportadoraIsSelected(widget);
        this.setInscEstadualSelect(widget);

        var help;
        var tipoParceiro = widget.getField('TIPODEPARCEIRO');
        if (widget.currentRow.CDTIPOPARCPRINCIPAL == 'CLIENTE') {
            tipoParceiro.help = "Caso este campo não possua 'Lead', 'Prospect' e 'Cliente', utilize o botão 'atualizar parceria'.";
        } else if (widget.currentRow.CDTIPOPARCPRINCIPAL == 'PROSPECT') {
            tipoParceiro.help = "Caso este campo não possua 'Lead' e 'Prospect', utilize o botão 'atualizar parceria'.";
        } else if (widget.currentRow.CDTIPOPARCPRINCIPAL == 'CANDIDATO') {
            tipoParceiro.help = "";
        }
    };

    this.salvarComunicacao = function (args) {
        var currentRow = args.row;
        var widget = args.owner.widget;
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.currentRow.CDTIPOPARCPRINCIPAL;

        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                if (canEdit) {
                    var paramsNewCode = widget.paramsNewCode;

                    var keysParamsNewCode = Object.keys(paramsNewCode);
                    keysParamsNewCode.forEach(function (value) {
                        currentRow[value] = paramsNewCode[value];
                    });

                    if (widget.isValid()) {
                        widget.currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCNEGOCIO;
                        CRM_ParceiroNegocio_Service.salvarComunicacao(currentRow).then(function (successData) {
                            if (widget.isNewRow()) {
                                widget.currentRow.NRCOMUNICAPARC = successData.dataset.columnsToReturn.NRCOMUNICAPARC;
                                widget.currentRow.NRORG = successData.dataset.columnsToReturn.NRORG;
                                widget.currentRow.__is_new = false;
                            }
                            widget.view();
                        }, function (error) {
                            var errorMessage = 'Timeout';
                            if (error.data) {
                                errorMessage = error.data.error;
                            }
                            ScreenService.showMessage(errorMessage);
                        });
                    }
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this)).catch(function (error) {
                console.error('Error in salvarComunicacao:', error);
            });
        } else {
            var paramsNewCode = widget.paramsNewCode;

            var keysParamsNewCode = Object.keys(paramsNewCode);
            keysParamsNewCode.forEach(function (value) {
                currentRow[value] = paramsNewCode[value];
            });

            if (widget.isValid()) {
                widget.currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCNEGOCIO;
                CRM_ParceiroNegocio_Service.salvarComunicacao(currentRow).then(function (successData) {
                    if (widget.isNewRow()) {
                        widget.currentRow.NRCOMUNICAPARC = successData.dataset.columnsToReturn.NRCOMUNICAPARC;
                        widget.currentRow.NRORG = successData.dataset.columnsToReturn.NRORG;
                        widget.currentRow.__is_new = false;
                    }
                    widget.view();
                }, function (error) {
                    var errorMessage = 'Timeout';
                    if (error.data) {
                        errorMessage = error.data.error;
                    }
                    ScreenService.showMessage(errorMessage);
                });
            }
        }
    };

    this.salvarEndereco = function (args) {
        var currentRow = args.row;
        var widget = args.owner.widget;
        var paramsNewCode = widget.paramsNewCode;
        var keysParamsNewCode = Object.keys(paramsNewCode);

        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.currentRow.CDTIPOPARCPRINCIPAL;

        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                if (canEdit) {
                    keysParamsNewCode.forEach(function (value) {
                        currentRow[value] = paramsNewCode[value];
                    });

                    if (!widget.isNewRow()) {
                        currentRow.tipoEnderecoWasEdited = (widget.backupRow.CDTIPOENDERECO != currentRow.CDTIPOENDERECO);
                        currentRow.CDTIPOENDERECOANTIGO = widget.backupRow.CDTIPOENDERECO;
                    }

                    if (widget.isValid()) {
                        widget.currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCNEGOCIO;
                        widget.currentRow.TIPODEPARCEIRO = widget.parent.parent.currentRow.TIPODEPARCEIRO;
                        CRM_ParceiroNegocio_Service.salvarEndereco(currentRow).then(function (successData) {
                            if (widget.isNewRow()) {
                                widget.currentRow.NRENDERECOPARC = successData.dataset.columnsToReturn.NRENDERECOPARC;
                                widget.currentRow.__is_new = false;
                            }
                            widget.view();
                        }, function (error) {
                            var errorMessage = 'Timeout';
                            if (error.data) {
                                errorMessage = error.data.error;
                            }
                            ScreenService.showMessage(errorMessage);
                        });
                    }
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this)).catch(function (error) {
                console.error('Error in salvarEndereco:', error);
            });
        } else {
            keysParamsNewCode.forEach(function (value) {
                currentRow[value] = paramsNewCode[value];
            });

            if (!widget.isNewRow()) {
                currentRow.tipoEnderecoWasEdited = (widget.backupRow.CDTIPOENDERECO != currentRow.CDTIPOENDERECO);
                currentRow.CDTIPOENDERECOANTIGO = widget.backupRow.CDTIPOENDERECO;
            }

            if (widget.isValid()) {
                widget.currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCNEGOCIO;
                widget.currentRow.TIPODEPARCEIRO = widget.parent.parent.currentRow.TIPODEPARCEIRO;
                CRM_ParceiroNegocio_Service.salvarEndereco(currentRow).then(function (successData) {
                    if (widget.isNewRow()) {
                        widget.currentRow.NRENDERECOPARC = successData.dataset.columnsToReturn.NRENDERECOPARC;
                        widget.currentRow.__is_new = false;
                    }
                    widget.view();
                }, function (error) {
                    var errorMessage = 'Timeout';
                    if (error.data) {
                        errorMessage = error.data.error;
                    }
                    ScreenService.showMessage(errorMessage);
                });
            }
        }
    };

    this.salvarNovoParceiro = function () {
        var parceiroWidget = templateManager.container.getWidget("parceiroNegocio");

        var nrParcNegocio = parceiroWidget.currentRow.NRPARCNEGOCIO;
        var tipoParc = parceiroWidget.currentRow.CDTIPOPARCPRINCIPAL;

        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                if (canEdit) {
                    if (validateNewParceiro(parceiroWidget)) {
                        this.salvarParceiro(parceiroWidget);
                    }
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this)).catch(function (error) {
                console.error('Error in salvarNovoParceiro:', error);
            });
        } else {
            if (validateNewParceiro(parceiroWidget)) {
                this.salvarParceiro(parceiroWidget);
            }
        }
    };

    this.salvarParceiro = function (widget, alreadyValidated) {
        var currentRow = widget.currentRow;
        var paramsNewCode = widget.paramsNewCode;
        var keysParamsNewCode = Object.keys(paramsNewCode);

        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.currentRow.CDTIPOPARCPRINCIPAL;
        var self = this;

        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            self.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                if (canEdit) {
                    keysParamsNewCode.forEach(function (value) {
                        currentRow[value] = paramsNewCode[value];
                    });

                    if (!widget.isNewRow()) {
                        currentRow.inscricaoWasEdited = (widget.backupRow.NRINSCRICAOPARC != currentRow.NRINSCRICAOPARC);
                    }

                    if (alreadyValidated || (validateNewParceiro(widget)) && widget.isValid()) {
                        self.nrinscricaoOnChange(widget.getField('NRINSCRICAOPARC'));
                        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                        CRM_ParceiroNegocio_Service.setTipoPrincipal(currentRow);
                        CRM_ParceiroNegocio_Service.salvarParceiro(currentRow).then(function (successData) {
                            toggleWidgetsEnabled(widget.widgets, true);
                            if (widget.isNewRow()) {
                                widget.currentWidget = widget;

                                var enderecoPrincipalWidget = templateManager.container.getWidget("enderecoPrincipal");
                                enderecoPrincipalWidget.isVisible = false;
                                enderecoPrincipalWidget.showAsTab = false;

                                var enderecoWidget = templateManager.container.getWidget("parceiroNegocioEndereco");
                                enderecoWidget.isVisible = true;
                                enderecoWidget.showAsTab = true;
                                widget.currentRow.NRPARCNEGOCIO = successData.dataset.columnsToReturn.NRPARCNEGOCIO;
                                widget.currentRow.__is_new = false;

                                widget.activate();
                            }

                            widget.reload();
                            widget.view();
                            //BEGIN RD Station
                            if (widget.currentRow.CDTIPOPARCPRINCIPAL === 'CLIENTE') {
                                var contactWidgets = templateManager.container.getWidget('WDGT_INTERLOCUTOR');
                                contactWidgets.dataSourceFilter.forEach(function (filter) {
                                    if (filter.name === 'NRPARCNEGOCIO')
                                        filter.value = widget.currentRow.NRPARCNEGOCIO;
                                });
                                contactWidgets.reload().then(function () {
                                    if (!Util.isEmptyOrBlank(contactWidgets.dataSource.data)) {
                                        contactWidgets.dataSource.data.forEach(function (contact) {
                                            restEngine.post('/IntegracaoRDStation/feedBackConversion', {
                                                'requestType': 'Row',
                                                'row': {
                                                    EVENT_NAME: 'Cadastro convertido em cliente no CRM',
                                                    EMAIL: contact['EMAILINTERLOC']
                                                }
                                            }).
                                                then(function () {
                                                    restEngine.post('/IntegracaoRDStation/changeFunnel', {
                                                        'requestType': 'Row',
                                                        'row': {
                                                            FUNNEL: 'Client',
                                                            EMAIL: contact['EMAILINTERLOC']
                                                        }
                                                    });
                                                });
                                        });
                                    }
                                });
                            }
                            //END RD Station

                        }.bind(self), function (error) {
                            var errorMessage = 'Timeout';
                            if (error.data) {
                                errorMessage = error.data.error;
                            }
                            ScreenService.showMessage(errorMessage);
                        });
                    }
                } else {
                    self.showMessageCantEditParc();
                }
            });
        } else {
            keysParamsNewCode.forEach(function (value) {
                currentRow[value] = paramsNewCode[value];
            });

            if (!widget.isNewRow()) {
                currentRow.inscricaoWasEdited = (widget.backupRow.NRINSCRICAOPARC != currentRow.NRINSCRICAOPARC);
            }

            if (alreadyValidated || (validateNewParceiro(widget)) && widget.isValid()) {
                self.nrinscricaoOnChange(widget.getField('NRINSCRICAOPARC'));
                currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                CRM_ParceiroNegocio_Service.setTipoPrincipal(currentRow);
                CRM_ParceiroNegocio_Service.salvarParceiro(currentRow).then(function (successData) {
                    toggleWidgetsEnabled(widget.widgets, true);
                    if (widget.isNewRow()) {
                        widget.currentWidget = widget;

                        var enderecoPrincipalWidget = templateManager.container.getWidget("enderecoPrincipal");
                        enderecoPrincipalWidget.isVisible = false;
                        enderecoPrincipalWidget.showAsTab = false;

                        var enderecoWidget = templateManager.container.getWidget("parceiroNegocioEndereco");
                        enderecoWidget.isVisible = true;
                        enderecoWidget.showAsTab = true;
                        widget.currentRow.NRPARCNEGOCIO = successData.dataset.columnsToReturn.NRPARCNEGOCIO;
                        widget.currentRow.__is_new = false;

                        widget.activate();
                    }

                    widget.reload();
                    widget.view();
                    //BEGIN RD Station
                    if (widget.currentRow.CDTIPOPARCPRINCIPAL === 'CLIENTE') {
                        var contactWidgets = templateManager.container.getWidget('WDGT_INTERLOCUTOR');
                        contactWidgets.dataSourceFilter.forEach(function (filter) {
                            if (filter.name === 'NRPARCNEGOCIO')
                                filter.value = widget.currentRow.NRPARCNEGOCIO;
                        });
                        contactWidgets.reload().then(function () {
                            if (!Util.isEmptyOrBlank(contactWidgets.dataSource.data)) {
                                contactWidgets.dataSource.data.forEach(function (contact) {
                                    restEngine.post('/IntegracaoRDStation/feedBackConversion', {
                                        'requestType': 'Row',
                                        'row': {
                                            EVENT_NAME: 'Cadastro convertido em cliente no CRM',
                                            EMAIL: contact['EMAILINTERLOC']
                                        }
                                    }).
                                        then(function () {
                                            restEngine.post('/IntegracaoRDStation/changeFunnel', {
                                                'requestType': 'Row',
                                                'row': {
                                                    FUNNEL: 'Client',
                                                    EMAIL: contact['EMAILINTERLOC']
                                                }
                                            });
                                        });
                                });
                            }
                        });
                    }
                    //END RD Station

                }.bind(self), function (error) {
                    var errorMessage = 'Timeout';
                    if (error.data) {
                        errorMessage = error.data.error;
                    }
                    ScreenService.showMessage(errorMessage);
                });
            }
        }

    };

    this.setTipoPrincipal = function (field) {
        var currentRow = field.widget.currentRow;
        CRM_ParceiroNegocio_Service.setTipoPrincipal(currentRow);
    };

    var toggleWidgetsEnabled = function (widgets, enabled) {
        widgets.forEach(function (widget) {
            widget.enabled = enabled;
        });
    };

    this.validarCepEnd = function (widget) {
        var CEP = widget.currentRow.NRCEPENDERECO || widget.currentRow.NRCEPENDERECO;
        var currentRow = widget.currentRow;
        const nrCepEndereco = widget.currentRow.NRCEPENDERECO;
        const cepSemMascara = nrCepEndereco.replace(/\D/g, '');
        if (CEP && cepSemMascara.length === 8) {
            ScreenService.confirmMessage("Deseja buscar o endereço pelo CEP informado?", "question", function () {
                CRM_Utilities.buscarCep(CEP).then(function (response) {

                    var addressFound = response.dataset.ENDERECO;

                    if (addressFound) {

                        currentRow.NMPAIS = addressFound.NMPAIS ? addressFound.NMPAIS : '';
                        currentRow.CDPAIS = addressFound.CDPAIS ? addressFound.CDPAIS : '';
                        currentRow.NMESTADO = addressFound.NMESTADO ? addressFound.NMESTADO : '';
                        currentRow.SGESTADO = addressFound.SGESTADO ? addressFound.SGESTADO : '';
                        currentRow.NMMUNICIPIO = addressFound.NMMUNICIPIO ? addressFound.NMMUNICIPIO : '';
                        currentRow.CDMUNICIPIO = addressFound.CDMUNICIPIO ? addressFound.CDMUNICIPIO : '';
                        currentRow.NMBAIRRO = addressFound.NMBAIRRO ? addressFound.NMBAIRRO : '';
                        currentRow.CDBAIRRO = addressFound.CDBAIRRO ? addressFound.CDBAIRRO : '';
                        currentRow.DSENDERECO = addressFound.DSENDERECO ? addressFound.DSENDERECO : '';

                        this.alteraEstadoReadonly(widget);

                        /*TODO Encontrar um jeito melhor de fazer o autocomplete atualizar os fields para os dados da currentRow*/

                        angular.element('#footer').click();

                    } else {
                        currentRow.CEP = '';
                    }

                    if (response.dataset.ERRO) {
                        ScreenService.showMessage(response.dataset.ERRO.MESSAGE, "warning");
                    }

                    if (response.messages) {
                        ScreenService.showMessage(response.messages[0].message);
                    }

                }.bind(this)).catch(function (error) {
                    ScreenService.showMessage(error.error);
                });
            }.bind(this), null);
        }
    };

    var validateNewParceiro = function (parceiroWidget) {
        if (parceiroWidget.isNewRow()) {
            var enderecoWidget = templateManager.container.getWidget("enderecoPrincipal");
            if (parceiroWidget.isValid() && enderecoWidget.isValid() && enderecoWidget.currentRow.CDPAIS) {
                parceiroWidget.currentRow.ENDERECO = Util.clone(enderecoWidget.currentRow);
                parceiroWidget.currentRow.ENDERECO.TIPODEPARCEIRO = parceiroWidget.currentRow.TIPODEPARCEIRO;
                return true;
            }
            else {
                if (!parceiroWidget.isValid() && (!enderecoWidget.isValid() || !enderecoWidget.currentRow.CDPAIS)) {
                    if (enderecoWidget.isValid() && !enderecoWidget.currentRow.CDPAIS) {
                        enderecoWidget.activate();

                        enderecoWidget.isValid();

                        parceiroWidget.currentWidget = parceiroWidget;
                        parceiroWidget.activate();
                    } else {
                        enderecoWidget.isValid();
                    }
                    ScreenService.showMessage("Preencha todos os campos obrigatórios das duas telas!");
                } else {
                    if ((!enderecoWidget.isValid() || !enderecoWidget.currentRow.CDPAIS) && !enderecoWidget.isActive()) {
                        enderecoWidget.activate();
                        enderecoWidget.isValid();
                    } else if (!parceiroWidget.isValid() && !parceiroWidget.isActive()) {
                        parceiroWidget.currentWidget = parceiroWidget;
                        parceiroWidget.activate();
                    }
                    ScreenService.showMessage("Preencha os campos obrigatórios!");
                }
                return false;
            }
        }
        else {
            return true;
        }
    };

    this.novoContato = function (widget) {
        var parentRow = widget.parent.parent.currentRow;
        var currentRow = widget.currentRow;

        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.currentRow.CDTIPOPARCPRINCIPAL;

        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                if (canEdit) {
                    currentRow.NRPARCNEGOCIO = nrParcNegocio;
                    currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                    currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');

                    General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function (response) {
                        if (response.dataset && response.dataset.error) {
                            ScreenService.showMessage(response.dataset.error, 'ERROR');
                        }
                        if (response.dataset && response.dataset.GROUPREL[0] == false) {
                            widget.edit();
                            widget.newRow();
                            widget.currentRow.NRPARCNEGOCIO = parentRow.NRPARCNEGOCIO;
                            widget.currentRow.NOMEPARC = parentRow.NMPRINCIPALPARC;
                            widget.currentRow.EMAIL = "";
                            widget.currentRow.TELEFONE = null;
                            widget.currentRow.NRCOMUNICAPARC = "";
                            widget.currentRow.NRRELACIONAPARC = "";
                            widget.currentRow.NRPARCNEGRELAC = "";
                            widget.currentRow.NREMAIL = "";
                            widget.currentRow.NRTELEFONE = "";
                        } else {
                            ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
                        }
                    }.bind(this));
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            currentRow.NRPARCNEGOCIO = nrParcNegocio;
            currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
            currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');

            General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function (response) {
                if (response.dataset && response.dataset.error) {
                    ScreenService.showMessage(response.dataset.error, 'ERROR');
                }
                if (response.dataset && response.dataset.GROUPREL[0] == false) {
                    widget.edit();
                    widget.newRow();
                    widget.currentRow.NRPARCNEGOCIO = parentRow.NRPARCNEGOCIO;
                    widget.currentRow.NOMEPARC = parentRow.NMPRINCIPALPARC;
                    widget.currentRow.EMAIL = "";
                    widget.currentRow.TELEFONE = null;
                    widget.currentRow.NRCOMUNICAPARC = "";
                    widget.currentRow.NRRELACIONAPARC = "";
                    widget.currentRow.NRPARCNEGRELAC = "";
                    widget.currentRow.NREMAIL = "";
                    widget.currentRow.NRTELEFONE = "";
                } else {
                    ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
                }
            }.bind(this));
        }
    };

    this.salvarContato = function (args) {
        var currentRow = args.row;
        var widget = args.owner.widget;

        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.currentRow.CDTIPOPARCPRINCIPAL;

        currentRow.NRPARCNEGOCIO = nrParcNegocio;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');

        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                if (canEdit) {
                    General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function (response) {
                        if (response.dataset && response.dataset.error) {
                            ScreenService.showMessage(response.dataset.error, 'ERROR');
                        }
                        if (response.dataset && response.dataset.GROUPREL[0] == false) {
                            var paramsNewCode = widget.paramsNewCode;
                            if (!Util.isEmptyOrBlank(widget.currentRow['TELEFONE']))
                                widget.currentRow['TELEFONE'] = widget.currentRow['TELEFONE'].replace(/[^0-9]/g, '');
                            var email = currentRow.EMAIL;
                            var telefone = currentRow.TELEFONE;
                            widget.currentRow.PARENTTYPE = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;
                            if (Util.isEmptyOrBlank(widget.currentRow.NOMEPARC)) {
                                widget.currentRow.NOMEPARC = widget.parent.parent.currentRow.NMCANDIDATO;
                            }

                            var keysParamsNewCode = Object.keys(paramsNewCode);
                            keysParamsNewCode.forEach(function (value) {
                                currentRow[value] = paramsNewCode[value];
                            });

                            if (widget.isValid()) {
                                if (Util.isEmptyOrBlank(email) && Util.isEmptyOrBlank(telefone)) {
                                    ScreenService.showMessage('Preencha pelo menos uma forma de comunicação (Email ou Telefone)');
                                } else {
                                    CRM_ParceiroNegocio_Service.salvarContato(currentRow).then(function (successData) {
                                        widget.reload().then(function () {
                                            widget.view();
                                            var dataset = widget.dataSource.data;
                                            widget.currentRow.EMAIL = email;
                                            widget.currentRow.TELEFONE = telefone;
                                            widget.getField("TIPODEPARCEIRO").readOnly = false;
                                            widget.getField("NMTIPORELACIONA").readOnly = false;
                                            if (widget.currentRow.__is_new) ScreenService.closeSwipe();
                                            if (successData.dataset.columnsToReturn) {
                                                widget.currentRow.NRPARCNEGRELAC = parseInt(successData.dataset.columnsToReturn.NRPARCNEGOCIO);
                                                widget.currentRow.NRRELACIONAPARC = parseInt(successData.dataset.columnsToReturn.NRRELACIONAPARC);
                                                this.setCurrentRow(dataset, currentRow);
                                            }
                                        }.bind(this));
                                    }.bind(this));
                                }
                            }
                        } else {
                            ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
                        }
                    }.bind(this));
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function (response) {
                if (response.dataset && response.dataset.error) {
                    ScreenService.showMessage(response.dataset.error, 'ERROR');
                }
                if (response.dataset && response.dataset.GROUPREL[0] == false) {
                    var paramsNewCode = widget.paramsNewCode;
                    if (!Util.isEmptyOrBlank(widget.currentRow['TELEFONE']))
                        widget.currentRow['TELEFONE'] = widget.currentRow['TELEFONE'].replace(/[^0-9]/g, '');
                    var email = currentRow.EMAIL;
                    var telefone = currentRow.TELEFONE;
                    widget.currentRow.PARENTTYPE = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;
                    if (Util.isEmptyOrBlank(widget.currentRow.NOMEPARC)) {
                        widget.currentRow.NOMEPARC = widget.parent.parent.currentRow.NMCANDIDATO;
                    }

                    var keysParamsNewCode = Object.keys(paramsNewCode);
                    keysParamsNewCode.forEach(function (value) {
                        currentRow[value] = paramsNewCode[value];
                    });

                    if (widget.isValid()) {
                        if (Util.isEmptyOrBlank(email) && Util.isEmptyOrBlank(telefone)) {
                            ScreenService.showMessage('Preencha pelo menos uma forma de comunicação (Email ou Telefone)');
                        } else {
                            CRM_ParceiroNegocio_Service.salvarContato(currentRow).then(function (successData) {
                                widget.reload().then(function () {
                                    widget.view();
                                    var dataset = widget.dataSource.data;
                                    widget.currentRow.EMAIL = email;
                                    widget.currentRow.TELEFONE = telefone;
                                    widget.getField("TIPODEPARCEIRO").readOnly = false;
                                    widget.getField("NMTIPORELACIONA").readOnly = false;
                                    if (widget.currentRow.__is_new) ScreenService.closeSwipe();
                                    if (successData.dataset.columnsToReturn) {
                                        widget.currentRow.NRPARCNEGRELAC = parseInt(successData.dataset.columnsToReturn.NRPARCNEGOCIO);
                                        widget.currentRow.NRRELACIONAPARC = parseInt(successData.dataset.columnsToReturn.NRRELACIONAPARC);
                                        this.setCurrentRow(dataset, currentRow);
                                    }
                                }.bind(this));
                            }.bind(this));
                        }
                    }
                } else {
                    ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
                }
            }.bind(this));
        }
    };

    this.edit = function (widget) {
        var currentRow = widget.currentRow;

        widget.getField("TIPODEPARCEIRO").readOnly = true;
        widget.getField("NMTIPORELACIONA").readOnly = true;

        currentRow.NRPARCNEGOCIO = nrParcNegocio;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');

        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function (response) {
            if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
                General.edit(widget);
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    };

    this.deleteCrud = function (widget) {
        widget.currentRow.PARENTTYPE = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;
        var currentRow = widget.currentRow;

        currentRow.NRPARCNEGOCIO = nrParcNegocio;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');

        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                if (canEdit) {
                    General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function (response) {
                        if (response.dataset && response.dataset.error) {
                            ScreenService.showMessage(response.dataset.error, 'ERROR');
                        }
                        if (response.dataset && response.dataset.GROUPREL[0] == false) {
                            General.deleteCrud(widget);
                        } else {
                            ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
                        }
                    }.bind(this));
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function (response) {
                if (response.dataset && response.dataset.error) {
                    ScreenService.showMessage(response.dataset.error, 'ERROR');
                }
                if (response.dataset && response.dataset.GROUPREL[0] == false) {
                    General.deleteCrud(widget);
                } else {
                    ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
                }
            }.bind(this));
        }
    };

    this.backOrCancel = function (args) {
        args.owner.widget.getField("NMTIPORELACIONA").readOnly = false;
        General.backOrCancel(args);
    };

    this.setCurrentRow = function (dataset, currentRow) {
        dataset.forEach(function (row) {
            var keys = Object.keys(row);
            keys.forEach(function (value) {
                if (value === 'NRPARCNEGRELAC') {
                    if (row[value] === currentRow.NRPARCNEGRELAC) {
                        currentRow.NREMAIL = row.NREMAIL;
                        currentRow.NRTELEFONE = row.NRTELEFONE;
                    }
                }
            });
        });
    };

    /**
     * Defini a visibilidade do campo de descrição 
     * na widget de contatos pelo tipo de parceiro
     * selecionado.
     * 
     * @param {object} field field de descrição.
    */
    this.setDescriptionFieldVisibilityByPartnerType = function (field) {

        var widget = field.widget;
        var currentRow = widget.currentRow;
        var fieldValue = currentRow[field.name];

        var descriptionField = widget.getField('DSCARACINPROS');

        if (fieldValue === "INTERLOCUTOR" && widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL === "PROSPECT") {
            descriptionField.isVisible = true;
        } else {
            descriptionField.isVisible = false;
        }

    };

    /**
     * Esconde o campo de descrição da widget de contatos
     * ('parceiroNegocioComunicacao').
     * 
     * @param {object} widget widget de contatos do parceiro
     * em caso.
    */
    this.hideDescriptionField = function (widget) {

        var descriptionField = widget.getField('DSCARACINPROS');
        descriptionField.isVisible = false;

    };

    /**
     * Define as regras da tela de parceiro de negócio 
     * de acordo com a revenda do operador logado.
     * 
     * @param {object} widget widget principal da tela de parceiro
     * de negócio ('parceiroNegocio').
    */
    this.setResaleRules = function (widget) {

        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        if (loggedOperatorInfos.IDTPOPERADOR === 'R' && Boolean(loggedOperatorInfos.NRREVENDA)) {

            var restrictObjectsByResale = [];

            restrictObjectsByResale.push(widget);
            restrictObjectsByResale.push(widget.getField('NMOPERRESPONSAVEL'));

            CRM_Utilities.setResaleRulesInRestrictObjectsByLoggedOperatorResale(restrictObjectsByResale);

        }

    };

    this.changeAgenciaReadOnly = function (widget) {
        var fieldAgencia = widget.getField('NMAGENCIA');
        var fieldBanco = widget.getField('NMBANCO');

        fieldAgencia.clearValue();
        if (Util.isEmptyOrBlank(fieldBanco.value())) {
            fieldAgencia.readOnly = true;
        } else {
            fieldAgencia.readOnly = false;
        }
        this.changeContaReadOnly(widget);
    };

    this.changeContaReadOnly = function (widget) {
        var fieldAgencia = widget.getField('NMAGENCIA');
        var fieldConta = widget.getField('DSCONTCORR');

        fieldConta.clearValue();
        if (Util.isEmptyOrBlank(fieldAgencia.value())) {
            fieldConta.readOnly = true;
        } else {
            fieldConta.readOnly = false;
        }
    };

    /**
     * Cria a widget de interlocutor na tela de parceiro
     * de negócio se o produto em execução for o CRM.
     * 
     * @param {object} widget widget de parceiro de negócio.
    */
    this.setInterlocutorWidgetOnParcNegocioWidget = function (widget) {

        if (Boolean(templateManager.CRM_PARAMETRIZACAO)) {
            AbaInterlocutorController.setInterlocutorWidgetOnActiveWidget(widget, 5);
        }

    };

    this.onEnterFormDadosAdicionais = function (widget) {
        //Evita bug de ID no reload
        widget.mode = (widget.mode === "view" ? "list" : widget.mode);
        widget.reload().then(function () {
            var data = widget.dataSource.data;
            if (Util.isEmptyOrBlank(data)) {
                widget.currentRow = {};
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow = data[0];
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRPARCNEGOCIO = templateManager.container.getWidget('parceiroNegocio').currentRow.NRPARCNEGOCIO;
            widget.currentRow.NRORG = templateManager.container.getWidget('parceiroNegocio').currentRow.NRORG;
        });
    };

    this.saveDadosAdicionais = function (widget) {
        var widgPrinc = widget.parent.parent;
        var nrParcNegocio = widgPrinc.currentRow.NRPARCNEGOCIO;
        var tipoParc = widgPrinc.currentRow.CDTIPOPARCPRINCIPAL;

        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                if (canEdit) {
                    if (widget.isValid()) {
                        General.saveCrud(widget);
                        widgPrinc.widgets.forEach(function (wid) {
                            wid.enabled = true;
                        });
                    }
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            General.saveCrud(widget);
            widgPrinc.widgets.forEach(function (wid) {
                wid.enabled = true;
            });
        }
    };

    this.widgetOnEnterOnce = function (widget) {
        var filterRow = {};
        var fieldsToApply = ['IDATIVO'];
        filterRow.IDOPERATIVO = 'A';
        filterRow.CDOPERRESPONSAVEL = [templateManager.LOGGEDOPERATOR.CDOPERADOR];

        CRM_Utilities.openFilterOnEnter(widget, filterRow, fieldsToApply);

        this.setResaleRules(widget);
        this.setInterlocutorWidgetOnParcNegocioWidget(widget);
        ABALogotipoParceiroController.setLogoWidgetOnActiveWidget(widget, 5);
    };

    this.verificaIsencao = function (widget) {
        var containerName = templateManager.container.name;
        var inscField;

        if (Util.isEmptyOrBlank(widget)) {
            widget = templateManager.container.getActiveWidget();
        }

        if (containerName === 'ger45000_prospect') {
            inscField = widget.getField('NRINSESTPROS');
        } else if (containerName === 'crm_cliente') {
            inscField = widget.getField('NRINSESTCLIE');
        } else {
            inscField = widget.getField('NRINSCESTADUAL');
        }

        if (widget.currentRow.IDINSCRESTAD === "ISENTO") {
            inscField.value("ISENTO");
            inscField.readOnly = true;
            if (containerName == 'crm_parceiro_negocio' && widget.getField('CDTIPOPARCPRINCIPAL').value() == 'CANDIDATO') {
                inscField.validations = {};
            }
        } else if (containerName == 'crm_parceiro_negocio' && widget.getField('CDTIPOPARCPRINCIPAL').value() == 'CANDIDATO' && Util.isEmptyOrBlank(widget.currentRow.IDINSCRESTAD)) {
            inscField.validations = {};
            inscField.value("");
            inscField.readOnly = false;
        } else {
            if (containerName == 'crm_parceiro_negocio' && widget.getField('CDTIPOPARCPRINCIPAL').value() == 'CANDIDATO') {
                inscField.validations = { required: true };
            }
            inscField.value("");
            inscField.readOnly = false;
        }

    };

    this.setInscEstadualSelect = function (widget) {
        var containerName = templateManager.container.name;
        var selectInsc = widget.getField('IDINSCRESTAD');
        var inscField;

        if (Util.isEmptyOrBlank(widget)) {
            widget = templateManager.container.getActiveWidget();
        }

        if (containerName === 'ger45000_prospect') {
            inscField = widget.getField('NRINSESTPROS');
        } else if (containerName === 'crm_cliente') {
            inscField = widget.getField('NRINSESTCLIE');
        } else {
            inscField = widget.getField('NRINSCESTADUAL');
            if (containerName == 'crm_parceiro_negocio') {
                if (widget.getField('CDTIPOPARCPRINCIPAL').value() == 'CANDIDATO') {
                    selectInsc.hideEmptyValue = false;
                    inscField.validations = {};
                    selectInsc.validations = {};
                } else {
                    selectInsc.hideEmptyValue = true;
                    inscField.validations = { required: true };
                    selectInsc.validations = { required: true };
                }
            }
        }

        if (inscField.value() === 'ISENTO') {
            widget.currentRow.IDINSCRESTAD = 'ISENTO';
            inscField.readOnly = true;
        } else if (!Util.isEmptyOrBlank(inscField.value())) {
            widget.currentRow.IDINSCRESTAD = 'NAOISENTO';
            inscField.readOnly = false;
        } else {
            inscField.readOnly = false;
            inscField.value("");
        }



    };

    this.mergeParceiro = function (widget) {
        var mainWid = widget.parent.parent;
        var currentRow = widget.currentRow;
        var sourcePartners = currentRow.NOME;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        currentRow.NRORG = mainWid.currentRow.NRORG;
        currentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
        currentRow.NRPARCNEGOCIO = mainWid.currentRow.NRPARCNEGOCIO;

        if (currentRow.NRPARCNEGOCIO) {
            var parcSeparatedByUnderline = "_";

            sourcePartners.forEach(function (value) {
                parcSeparatedByUnderline = parcSeparatedByUnderline + value + "_";
            });
            currentRow.PARCTOSTRING = parcSeparatedByUnderline;

            var parametroRestEngine = {
                'requestType': 'Row',
                'row': currentRow
            };

            restEngine.post('/mergeParceiro', parametroRestEngine,
                undefined, undefined, undefined).then(function (response) {
                    mainWid.reload();
                    ScreenService.showMessage("Processo realizado com sucesso!");
                    currentRow.NOME = "";
                    ScreenService.closeSwipe();
                    this.reloadParnersScreens(widget);
                }.bind(this));
        } else {
            ScreenService.showMessage("Houve um problema ao tentar fundir os parceiros. Recarregue a página e tente novamente.");
            currentRow.NOME = "";
        }
    };

    this.reloadParnersScreens = function (widget) {
        // Telas afetadas pela fusão dos parceiros
        var screensToReload = [
            'crm00040_000_leads',
            'ger45000_prospect',
            'crm00002_001_oportunidade_de_negocio',
        ];

        // Limpa a cache das telas, forçando seu recarregamento
        screensToReload.forEach(function (screenName) {
            delete templateManager.containers[screenName];
        });
    };

    this.openSwipeFundirAndSetName = function () {

        var widget = templateManager.container.getWidget('FUNDIRPARC');

        ScreenService.openSwipe(widget);
        ScreenService.closePopup();

        widget.activate();
        widget.newRow();

        widget.currentRow.NMPARCEIRO = widget.parent.parent.currentRow.NMPRINCIPALPARC;

    };

    this.closeWidgetFundirParc = function () {
        var widget = templateManager.container.getActiveWidget();

        ScreenService.closeSwipe().then(function () {
            this.cleanWidgetFields(widget);
            widget.parent.parent.view();
            widget.parent.parent.activate();
        }.bind(this));
    };

    this.cleanWidgetFields = function (widget) {
        widget.fields.forEach(function (field) {
            field.value("");
        });
    };

    this.checkParcHasMerge = function (nrparcneg, nrorg) {
        var params = {
            requestType: "Row",
            row: {
                NRPARCNEGOCIO: nrparcneg,
                NRORG: nrorg
            }
        };

        // Confere se o parceiro é o destino de alguma fusão
        return restEngine.post('/checkParcHasMerge', params,
            undefined, undefined, undefined).then(function (response) {
                var hasMerge = response.dataset.DADOS.HASMERGE;

                return hasMerge;
            }.bind(this));
    };

    this.checkIfCanEditOrEvolParc = function (nrParcNegocio) {
        var restRow = {
            NRPARCNEGOCIO: nrParcNegocio,
            CRM_NRORGTRAB: getLocalVar('CRM_NRORGTRABALHO')
        };

        var params = {
            requestType: 'Row',
            row: restRow
        };

        return restEngine.post('/checkIfCanEditOrEvolParc', params)
            .then(function (response) {
                if (response.dataset && response.dataset.DADOS && response.dataset.DADOS.CAN_EDIT !== undefined) {
                    return response.dataset.DADOS.CAN_EDIT;
                } else {
                    throw new Error('Resposta inválida do servidor');
                }
            })
            .catch(function (error) {
                console.error('Erro durante a chamada assíncrona:', error);
                return false;
            });
    }

    this.setTipoDeParceiroField = function (widget) {
        var rows = widget.dataSource.data;
        rows.forEach(function (rows) {
            var tiposDeParceiro = rows.TIPODEPARCEIRO;
        });
    };

    this.updatePartnership = function () {
        var widget = templateManager.container.getActiveWidget();
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;

        var tipoParceiro = widget.getField('TIPODEPARCEIRO');
        var tipoPrincParceiro = widget.getField('CDTIPOPARCPRINCIPAL');
        var valorCampo = tipoParceiro.value();
        var cont = 0;
        var extras = [];

        if (valorCampo !== null) {
            valorCampo = tipoParceiro.value().split(",");
        }

        if (tipoPrincParceiro == 'PROSPECT' || tipoPrincParceiro == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                if (canEdit) {
                    if (tipoPrincParceiro.value() == 'CLIENTE') {
                        valorCampo.map(function (tipoDoParceiro) {
                            if (tipoDoParceiro == 'CLIENTE' || tipoDoParceiro == 'PROSPECT' || tipoDoParceiro == 'CANDIDATO') {
                                cont++;
                            } else {
                                extras.push(tipoDoParceiro);
                            }
                        });
                        if (cont !== 3) {
                            var newValues = ['CANDIDATO', 'PROSPECT', 'CLIENTE'].concat(extras);
                            tipoParceiro.value(newValues);
                            widget.backupRow = widget.currentRow;
                            this.salvarParceiro(widget, true);
                        } else {
                            ScreenService.showMessage("Este parceiro já possui suas parcerias atualizadas!");
                            return;
                        }
                    } else if (tipoPrincParceiro.value() == 'PROSPECT') {
                        valorCampo.map(function (tipoDoParceiro) {
                            if (tipoDoParceiro == 'CLIENTE' || tipoDoParceiro == 'PROSPECT' || tipoDoParceiro == 'CANDIDATO') {
                                cont++;
                            } else {
                                extras.push(tipoDoParceiro);
                            }
                        });
                        if (cont !== 2) {
                            var newValues = ['CANDIDATO', 'PROSPECT'].concat(extras);
                            tipoParceiro.value(newValues);
                            widget.backupRow = widget.currentRow;
                            this.salvarParceiro(widget, true);
                        } else {
                            ScreenService.showMessage("Este parceiro já possui suas parcerias atualizadas!");
                            return;
                        }
                    } else if (tipoPrincParceiro.value() == 'CANDIDATO') {
                        valorCampo.map(function (tipoDoParceiro) {
                            if (tipoDoParceiro == 'CLIENTE' || tipoDoParceiro == 'PROSPECT' || tipoDoParceiro == 'CANDIDATO') {
                                cont++;
                            } else {
                                extras.push(tipoDoParceiro);
                            }
                        });
                        if (cont !== 1) {
                            var newValues = ['CANDIDATO'].concat(extras);
                            tipoParceiro.value(newValues);
                            widget.backupRow = widget.currentRow;
                            this.salvarParceiro(widget, true);
                        } else {
                            ScreenService.showMessage("Este parceiro já possui suas parcerias atualizadas!");
                            return;
                        }
                    }
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this));
        } else {
            if (tipoPrincParceiro.value() == 'CLIENTE') {
                valorCampo.map(function (tipoDoParceiro) {
                    if (tipoDoParceiro == 'CLIENTE' || tipoDoParceiro == 'PROSPECT' || tipoDoParceiro == 'CANDIDATO') {
                        cont++;
                    } else {
                        extras.push(tipoDoParceiro);
                    }
                });
                if (cont !== 3) {
                    var newValues = ['CANDIDATO', 'PROSPECT', 'CLIENTE'].concat(extras);
                    tipoParceiro.value(newValues);
                    widget.backupRow = widget.currentRow;
                    this.salvarParceiro(widget, true);
                } else {
                    ScreenService.showMessage("Este parceiro já possui suas parcerias atualizadas!");
                    return;
                }
            } else if (tipoPrincParceiro.value() == 'PROSPECT') {
                valorCampo.map(function (tipoDoParceiro) {
                    if (tipoDoParceiro == 'CLIENTE' || tipoDoParceiro == 'PROSPECT' || tipoDoParceiro == 'CANDIDATO') {
                        cont++;
                    } else {
                        extras.push(tipoDoParceiro);
                    }
                });
                if (cont !== 2) {
                    var newValues = ['CANDIDATO', 'PROSPECT'].concat(extras);
                    tipoParceiro.value(newValues);
                    widget.backupRow = widget.currentRow;
                    this.salvarParceiro(widget, true);
                } else {
                    ScreenService.showMessage("Este parceiro já possui suas parcerias atualizadas!");
                    return;
                }
            } else if (tipoPrincParceiro.value() == 'CANDIDATO') {
                valorCampo.map(function (tipoDoParceiro) {
                    if (tipoDoParceiro == 'CLIENTE' || tipoDoParceiro == 'PROSPECT' || tipoDoParceiro == 'CANDIDATO') {
                        cont++;
                    } else {
                        extras.push(tipoDoParceiro);
                    }
                });
                if (cont !== 1) {
                    var newValues = ['CANDIDATO'].concat(extras);
                    tipoParceiro.value(newValues);
                    widget.backupRow = widget.currentRow;
                    this.salvarParceiro(widget, true);
                } else {
                    ScreenService.showMessage("Este parceiro já possui suas parcerias atualizadas!");
                    return;
                }
            }
        }
    };

    this.setStatusFilter = function () {
        var widget = templateManager.container.getActiveWidget();
        var parentRow = widget.getParent().currentRow;

        for (var i = 0; i < widget.dataSourceFilter.length; i++) {
            if (widget.dataSourceFilter[i].name == 'P_NRPARCNEGOCIO') {
                widget.dataSourceFilter[i].value = parentRow.NRPARCNEGOCIO;
                break;
            }
        }

        widget.reload();
    };

    this.goBackToGrid = function () {
        var mainWidget = templateManager.container.getWidget('parceiroNegocio');

        ScreenService.closeSwipe();
        mainWidget.activate();
    };

    this.showMessageCantEditParc = function () {
        var message = "Ação bloqueada!<br>" +
            "Somente o operador responsável pelo prospect e seus assistentes podem " +
            "editá-lo/evoluí-lo.";

        ScreenService.showMessage(message);
    };

    this.dadosAdicionaisEdit = function (widget) {
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;

        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                if (canEdit) {
                    General.widgetEdit(widget);
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this));
        } else {
            General.widgetEdit(widget);
        }
    };

    this.deleteParc = function (widget) {
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.currentRow.CDTIPOPARCPRINCIPAL;

        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                if (canEdit) {
                    General.deleteCrud(widget);
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this));
        } else {
            General.deleteCrud(widget);
        }
    };

    this.editComunication = function (widget) {
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;

        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                if (canEdit) {
                    General.edit(widget);
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this));
        } else {
            General.edit(widget);
        }
    };

    this.deleteComunication = function (widget) {
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;

        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                if (canEdit) {
                    General.deleteCrud(widget);
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this));
        } else {
            General.deleteCrud(widget);
        }
    };

    this.addNewAccount = function (widget) {
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;

        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                if (canEdit) {
                    General.widgetNewRow(widget);
                    this.changeAgenciaReadOnly(widget);
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this));

        } else {
            General.widgetNewRow(widget);
            this.changeAgenciaReadOnly(widget);
        }
    };

    this.editAccount = function (widget) {
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;

        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                if (canEdit) {
                    General.widgetEdit(widget);
                    this.changeAgenciaReadOnly(widget);
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this));

        } else {
            General.widgetEdit(widget);
            this.changeAgenciaReadOnly(widget);
        }
    };

    this.saveAccount = function (widget) {
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;

        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                if (canEdit) {
                    General.widgetEdit(widget);
                    this.changeAgenciaReadOnly(widget);
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this));
        } else {
            General.widgetEdit(widget);
            this.changeAgenciaReadOnly(widget);
        }
    };

    this.deleteAccount = function (widget) {
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;

        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                if (canEdit) {
                    General.deleteCrud(widget);
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this));
        } else {
            General.deleteCrud(widget);
        }
    };

    this.cancelAccount = function (widget) {
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.currentRow.CDTIPOPARCPRINCIPAL;

        if (tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE') {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
                if (canEdit) {
                    General.widgetCancelForm(widget);
                } else {
                    this.showMessageCantEditParc();
                }
            }.bind(this));
        } else {
            General.widgetCancelForm(widget);
        }
    };

    this.openTransferirResponsaveis = function () {
        var widget = templateManager.container.getWidget('transferenciaDeOperadores');
        ScreenService.openPopup(widget);
        widget.newRow();
    };

    this.fecharTransferencia = function () {
        ScreenService.closePopup();
        templateManager.container.getWidget('parceiroNegocio').activate();
    };

    this.transferirResponsaveis = function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            var mainWid = templateManager.container.getWidget('parceiroNegocio');
            var rows = mainWid.getCheckedRows();

            rows.forEach(function (row) {
                row.NRORG = getLocalVar('CRM_NRORGTRAB');
                row.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                row.CDOPERADORDEST = widget.currentRow.CDOPERADORDEST;
            });

            var parametroRestEngine = {
                'requestType': 'Row',
                'row': rows
            };

            restEngine.post('/transferirParceiros', parametroRestEngine).then(function (response) {
                mainWid.reload();
                ScreenService.closePopup();
                ScreenService.showMessage("Transferência realizada com sucesso!");
                mainWid.activate();
            }.bind(this));
        }
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('CRM_ParceiroNegocio_Controller', CRM_ParceiroNegocio_Controller);
});

// FILE: ./assets/js/controllers/crm_sla_recadoNotificalcao.js
function crm_sla_recadoNotificalcao(CRM_Utilities, General, templateManager, ScreenService, restEngine, localStorageEngine, metaDataFactory) {


    this.porCento = function(field) {
        var fieldName = field.name;
        var desconto = field.widget.currentRow[fieldName];

        if ((desconto >= 0) && (desconto <= 100)) {
            field.widget.currentRow[fieldName] = desconto + '%';
        } else {
            field.widget.currentRow[fieldName] = "";
            ScreenService.notificationMessage("O valor de desconto percentual deve estar entre 0 e 100", "alert");
        }
    };

    this.habilitaFields = function() {
        var widget = templateManager.container.getActiveWidget();

        var fieldsName = [];
        if (widget.name == "WDGT_LEMBRETE_SLA") {
            fieldsName = ["NMREGRA", "NMREGRASOLU"];
            fieldsName.forEach(function(fieldName) {
                if (fieldName == "NMREGRA") {
                    if (!Util.isEmptyOrBlank(widget.currentRow[fieldName])) {
                        widget.getField('NRPERCENT').readOnly = false;
                        widget.getField('IDNOTIFICA').readOnly = false;
                        widget.getField('OPERADORESP').readOnly = false;

                        widget.getField('NRPERCENT').validations = {
                            "required": true
                        };
                        widget.getField('IDNOTIFICA').validations = {
                            "required": true
                        };
                    } else {
                        widget.getField('NRPERCENT').readOnly = true;
                        widget.getField('IDNOTIFICA').readOnly = true;
                        widget.getField('OPERADORESP').readOnly = true;

                        widget.getField('NRPERCENT').validations = "";
                        widget.getField('IDNOTIFICA').validations = "";
                    }
                } else if (fieldName == "NMREGRASOLU") {
                    if (!Util.isEmptyOrBlank(widget.currentRow[fieldName])) {
                        widget.getField('NRPERCENTSOLU').readOnly = false;
                        widget.getField('IDNOTIFICASOLU').readOnly = false;
                        widget.getField('OPERADOSOLU').readOnly = false;

                        widget.getField('NRPERCENTSOLU').validations = {
                            "required": true
                        };
                        widget.getField('IDNOTIFICASOLU').validations = {
                            "required": true
                        };
                    } else {
                        widget.getField('NRPERCENTSOLU').readOnly = true;
                        widget.getField('IDNOTIFICASOLU').readOnly = true;
                        widget.getField('OPERADOSOLU').readOnly = true;

                        widget.getField('NRPERCENTSOLU').validations = "";
                        widget.getField('IDNOTIFICASOLU').validations = "";
                    }
                }
            });
        } else {
            fieldsName = ["NMNOTIFICARESP", "NMNOTIFICARESO"];
            fieldsName.forEach(function(fieldName) {
                if (fieldName == "NMNOTIFICARESP") {
                    if (!Util.isEmptyOrBlank(widget.currentRow[fieldName])) {
                        widget.getField('IDNOTIFICAIMEDIATORESP').readOnly = false;
                        widget.getField('NRMINNOTIFICARESP').readOnly = false;
                        widget.getField('IDNOTIFICARESP').readOnly = false;
                        widget.getField('OPERADORESP').readOnly = false;

                        widget.getField('IDNOTIFICAIMEDIATORESP').validations = {
                            "required": true
                        };
                        widget.getField('NRMINNOTIFICARESP').validations = {
                            "required": true
                        };
                        widget.getField('IDNOTIFICARESP').validations = {
                            "required": true
                        };

                    } else {
                        widget.getField('IDNOTIFICAIMEDIATORESP').readOnly = true;
                        widget.getField('NRMINNOTIFICARESP').readOnly = true;
                        widget.getField('IDNOTIFICARESP').readOnly = true;
                        widget.getField('OPERADORESP').readOnly = true;

                        widget.getField('IDNOTIFICAIMEDIATORESP').validations = "";
                        widget.getField('NRMINNOTIFICARESP').validations = "";
                        widget.getField('IDNOTIFICARESP').validations = "";
                    }
                } else if (fieldName == "NMNOTIFICARESO") {
                    if (!Util.isEmptyOrBlank(widget.currentRow[fieldName])) {
                        widget.getField('IDNOTIFICAIMEDIATORESO').readOnly = false;
                        widget.getField('NRMINNOTIFICARESO').readOnly = false;
                        widget.getField('IDNOTIFICARESO').readOnly = false;
                        widget.getField('OPERADORESO').readOnly = false;

                        widget.getField('IDNOTIFICAIMEDIATORESO').validations = {
                            "required": true
                        };
                        widget.getField('NRMINNOTIFICARESO').validations = {
                            "required": true
                        };
                        widget.getField('IDNOTIFICARESO').validations = {
                            "required": true
                        };

                    } else {
                        widget.getField('IDNOTIFICAIMEDIATORESO').readOnly = true;
                        widget.getField('NRMINNOTIFICARESO').readOnly = true;
                        widget.getField('IDNOTIFICARESO').readOnly = true;
                        widget.getField('OPERADORESO').readOnly = true;

                        widget.getField('IDNOTIFICAIMEDIATORESO').validations = "";
                        widget.getField('NRMINNOTIFICARESO').validations = "";
                        widget.getField('IDNOTIFICARESO').validations = "";
                    }
                }
            });
        }

        if (widget.currentRow.__is_new == true) {
            widget.fieldGroups.forEach(function(fieldGroup) {
                fieldGroup.isVisible = true;
            });
        }

    };

    this.salvaRegraLembrete = function(widget) {
        if (widget.currentRow.__is_new == true) {
            if (!Util.isEmptyOrBlank(widget.currentRow.NMREGRA) || !Util.isEmptyOrBlank(widget.currentRow.NMREGRASOLU)) {

                var dataset = {};
                dataset.SLA = widget.parent.parent.currentRow.NRSEQSLA;
                dataset.RESP = [];
                dataset.SOLU = [];

                if (!Util.isEmptyOrBlank(widget.currentRow.NMREGRA)) {
                    var fieldsRESP = new Object();
                    fieldsRESP.NMREGRA = widget.currentRow.NMREGRA;
                    fieldsRESP.NRPERCENT = widget.currentRow.NRPERCENT.replace('%', '');
                    fieldsRESP.IDNOTIFICA = widget.currentRow.IDNOTIFICA;
                    fieldsRESP.OPERADORESP = widget.currentRow.OPERADORESP;
                    fieldsRESP.NRORG = widget.parent.parent.currentRow.NRORG;

                    dataset.RESP = fieldsRESP;
                }
                if (!Util.isEmptyOrBlank(widget.currentRow.NMREGRASOLU)) {

                    var fieldsSOLU = new Object();
                    fieldsSOLU.NMREGRASOLU = widget.currentRow.NMREGRASOLU;
                    fieldsSOLU.NRPERCENTSOLU = widget.currentRow.NRPERCENTSOLU.replace('%', '');
                    fieldsSOLU.IDNOTIFICASOLU = widget.currentRow.IDNOTIFICASOLU;
                    fieldsSOLU.OPERADOSOLU = widget.currentRow.OPERADOSOLU;
                    fieldsSOLU.NRORG = widget.parent.parent.currentRow.NRORG;

                    dataset.SOLU = fieldsSOLU;
                }

                General.callRestEngine("product#/crm_sla_lembreteNotificacao/sla_salvar_lembrete", "DataSet", [dataset]).then(function(response) {
                    ScreenService.closeSwipe().then(function() {
                    });

                }.bind(this));
                    widget.reload();

            } else {
                ScreenService.showMessage('Crie uma regra de Tempo de Resposta ou uma regra de Tempo de Solução');
            }
        } else {
            var paramsRestEngine = {};
            if (widget.currentRow.TIPOREGRA == "RESPOSTA") {
                widget.currentRow.NRPERCENT = parseInt(widget.currentRow.NRPERCENT.replace('%', ''));
                paramsRestEngine = {
                    requestType: 'Row',
                    row: widget.currentRow
                };
                restEngine.post('product#/crm_sla_lembreteNotificacao/sla_update_resposta', paramsRestEngine);
                widget.list(true);
                ScreenService.goBack().
                 then(function(){
                    var widget = templateManager.container.getActiveWidget();
                    widget.reload();
                    
                });

            } else if (widget.currentRow.TIPOREGRA == "RESOLUCAO") {
                widget.currentRow.NRPERCENTSOLU = parseInt(widget.currentRow.NRPERCENTSOLU.replace('%', ''));
                paramsRestEngine = {
                    requestType: 'Row',
                    row: widget.currentRow
                };
                restEngine.post('product#/crm_sla_lembreteNotificacao/sla_update_resolucao', paramsRestEngine);
                widget.list(true);
                ScreenService.goBack().
                then(function(){
                    var widget = templateManager.container.getActiveWidget();
                    widget.reload();
                    
                });
            }

            widget.reload();
        }
    };

    this.salvaRegraNotificacao = function(widget) {
        if (widget.currentRow.__is_new == true) {
            if (!Util.isEmptyOrBlank(widget.currentRow.NMNOTIFICARESP) || !Util.isEmptyOrBlank(widget.currentRow.NMNOTIFICARESO)) {

                var dataset = {};
                dataset.RESP = [];
                dataset.SOLU = [];

                if (!Util.isEmptyOrBlank(widget.currentRow.NMNOTIFICARESP)) {
                    var fieldsRESP = new Object();
                    fieldsRESP.NMNOTIFICARESP = widget.currentRow.NMNOTIFICARESP;
                    fieldsRESP.IDNOTIFICAIMEDIATORESP = widget.currentRow.IDNOTIFICAIMEDIATORESP;
                    fieldsRESP.NRMINNOTIFICARESP = parseInt(widget.currentRow.NRMINNOTIFICARESP);
                    fieldsRESP.IDNOTIFICARESP = widget.currentRow.IDNOTIFICARESP;
                    fieldsRESP.OPERADORESP = widget.currentRow.OPERADORESP;
                    fieldsRESP.NRORG = widget.parent.parent.currentRow.NRORG;
                    fieldsRESP.NRSEQSLA = widget.parent.parent.currentRow.NRSEQSLA;

                    dataset.RESP = fieldsRESP;
                }
                if (!Util.isEmptyOrBlank(widget.currentRow.NMNOTIFICARESO)) {
                    var fieldsSOLU = new Object();
                    fieldsSOLU.NMNOTIFICARESO = widget.currentRow.NMNOTIFICARESO;
                    fieldsSOLU.IDNOTIFICAIMEDIATORESO = widget.currentRow.IDNOTIFICAIMEDIATORESO;
                    fieldsSOLU.NRMINNOTIFICARESO = parseInt(widget.currentRow.NRMINNOTIFICARESO);
                    fieldsSOLU.IDNOTIFICARESO = widget.currentRow.IDNOTIFICARESO;
                    fieldsSOLU.OPERADORESO = widget.currentRow.OPERADORESO;
                    fieldsSOLU.NRORG = widget.parent.parent.currentRow.NRORG;
                    fieldsSOLU.NRSEQSLA = widget.parent.parent.currentRow.NRSEQSLA;

                    dataset.SOLU = fieldsSOLU;
                }

                General.callRestEngine("product#/crm_sla_lembreteNotificacao/sla_salvar_notificacao", "DataSet", [dataset]).then(function(response) {
                    ScreenService.closeSwipe().then(function() {
                        widget.reload();
                    });

                }.bind(this));

            } else {
                ScreenService.showMessage('Crie uma regra de Tempo de Resposta ou uma regra de Tempo de Solução');
            }

        }else{
            var paramsRestEngine = {};
            if (widget.currentRow.TIPOREGRA == "RESPOSTA") {
                paramsRestEngine = {
                    requestType: 'Row',
                    row: widget.currentRow
                };
                restEngine.post('product#/crm_sla_lembreteNotificacao/sla_update_respostaNoti', paramsRestEngine);
                widget.list(true);
                ScreenService.goBack(). 
                then(function(){
                    var widget = templateManager.container.getActiveWidget();
                    widget.reload();
                    
                });

            } else if (widget.currentRow.TIPOREGRA == "RESOLUCAO") {
                paramsRestEngine = {
                    requestType: 'Row',
                    row: widget.currentRow
                };
                restEngine.post('product#/crm_sla_lembreteNotificacao/sla_update_resolucaoNoti', paramsRestEngine);
                widget.list(true);
                ScreenService.goBack().
                then(function(){
                    var widget = templateManager.container.getActiveWidget();
                    widget.reload();
                    
                });
            }
        }
    };

    this.ocultaTipo = function(widget) {

        setTimeout(function() {

            if (widget.mode != "edit") {
                if (widget.name == "WDGT_LEMBRETE_SLA") {
                    if (widget.currentRow.TIPOREGRA == "RESPOSTA") {

                        widget.fieldGroups.forEach(function(fieldGroup) {
                            if (fieldGroup.name == "RESPOSTA") {
                                fieldGroup.isVisible = true;
                            } else {
                                fieldGroup.isVisible = false;
                            }
                        });

                        widget.getField('NRPERCENT').readOnly = false;
                        widget.getField('IDNOTIFICA').readOnly = false;
                        widget.getField('OPERADORESP').readOnly = false;

                    } else if (widget.currentRow.TIPOREGRA == "RESOLUCAO") {
                        widget.fieldGroups.forEach(function(fieldGroup) {
                            if (fieldGroup.name == "RESOLUCAO") {
                                fieldGroup.isVisible = true;
                            } else {
                                fieldGroup.isVisible = false;
                            }
                        });

                        widget.getField('NRPERCENTSOLU').readOnly = false;
                        widget.getField('IDNOTIFICASOLU').readOnly = false;
                        widget.getField('OPERADOSOLU').readOnly = false;


                        var solucao = new Object();

                        solucao.NMREGRASOLU = widget.currentRow.NMREGRA;
                        solucao.IDNOTIFICASOLU = widget.currentRow.IDNOTIFICA;
                        solucao.NRORG = widget.currentRow.NRORG;
                        solucao.NRPARCNEGOCIO = widget.currentRow.NRPARCNEGOCIO;
                        solucao.NRPERCENTSOLU = widget.currentRow.NRPERCENT;
                        solucao.NRREGRATEMPOSOLU = widget.currentRow.NRREGRATEMPO;
                        solucao.NRSEQSLA = widget.currentRow.NRSEQSLA;
                        solucao.TIPOREGRA = widget.currentRow.TIPOREGRA;
                        solucao.__isSelected = widget.currentRow.__isSelected;
                        solucao.__is_new = widget.currentRow.__is_new;

                        widget.currentRow = solucao;
                    }
                } else {
                    if (widget.currentRow.TIPOREGRA == "RESPOSTA") {
                        widget.fieldGroups.forEach(function(fieldGroup) {
                            if (fieldGroup.name == "RESPOSTA") {
                                fieldGroup.isVisible = true;
                            } else {
                                fieldGroup.isVisible = false;
                            }
                        });
                        widget.getField('IDNOTIFICAIMEDIATORESP').readOnly = false;
                        widget.getField('NRMINNOTIFICARESP').readOnly = false;
                        widget.getField('IDNOTIFICARESP').readOnly = false;
                        widget.getField('OPERADORESP').readOnly = false;

                        widget.getField('IDNOTIFICAIMEDIATORESP').validations = {
                            "required": true
                        };
                        widget.getField('NRMINNOTIFICARESP').validations = {
                            "required": true
                        };
                        widget.getField('IDNOTIFICARESP').validations = {
                            "required": true
                        };
                        var resposta = new Object();
                        resposta.IDNOTIFICAIMEDIATORESP     = widget.currentRow.IDNOTIFICAIMEDIATORESP;
                        resposta.IDNOTIFICARESP             = widget.currentRow.IDNOTIFICA;
                        resposta.NMNOTIFICARESP             = widget.currentRow.NMNOTIFICARESP;
                        resposta.NRMINNOTIFICARESP          = widget.currentRow.NRMINNOTIFICARESP;
                        resposta.NRNOTIFICATEMPORESP        = widget.currentRow.NRNOTIFICATEMPO;
                        resposta.NRORG                      = widget.currentRow.NRORG;
                        resposta.NRSEQSLA                   = widget.currentRow.NRSEQSLA;
                        resposta.TIPOREGRA                  = widget.currentRow.TIPOREGRA;
                        resposta.TIPORETRAVIEW              = widget.currentRow.TIPORETRAVIEW;
                        resposta.__index                    = widget.currentRow.__index;
                        resposta.__isSelected               = widget.currentRow.__isSelected;
                        resposta.__is_new                   = widget.currentRow.__is_new;

                        widget.currentRow = resposta;

                    } else if (widget.currentRow.TIPOREGRA == "RESOLUCAO") {
                        widget.fieldGroups.forEach(function(fieldGroup) {
                            if (fieldGroup.name == "RESOLUCAO") {
                                fieldGroup.isVisible = true;
                            } else {
                                fieldGroup.isVisible = false;
                            }
                        });

                        widget.getField('IDNOTIFICAIMEDIATORESO').readOnly = false;
                        widget.getField('NRMINNOTIFICARESO').readOnly = false;
                        widget.getField('IDNOTIFICARESO').readOnly = false;
                        widget.getField('OPERADORESO').readOnly = false;

                        widget.getField('IDNOTIFICAIMEDIATORESO').validations = {
                            "required": true
                        };
                        widget.getField('NRMINNOTIFICARESO').validations = {
                            "required": true
                        };
                        widget.getField('IDNOTIFICARESO').validations = {
                            "required": true
                        };

                        var resolucao = new Object();
                        resolucao.IDNOTIFICAIMEDIATORESO    = widget.currentRow.IDNOTIFICAIMEDIATORESP;
                        resolucao.IDNOTIFICARESO            = widget.currentRow.IDNOTIFICA;
                        resolucao.NMNOTIFICARESO            = widget.currentRow.NMNOTIFICARESP;
                        resolucao.NRMINNOTIFICARESO         = widget.currentRow.NRMINNOTIFICARESP;
                        resolucao.NRNOTIFICATEMPORESO       = widget.currentRow.NRNOTIFICATEMPO;
                        resolucao.NRORG                     = widget.currentRow.NRORG;
                        resolucao.NRSEQSLA                  = widget.currentRow.NRSEQSLA;
                        resolucao.TIPOREGRA                 = widget.currentRow.TIPOREGRA;
                        resolucao.TIPORETRAVIEW             = widget.currentRow.TIPORETRAVIEW;
                        resolucao.__index                   = widget.currentRow.__index;
                        resolucao.__isSelected              = widget.currentRow.__isSelected;
                        resolucao.__is_new                  = widget.currentRow.__is_new;

                        widget.currentRow = resolucao;
                    }
                }
            }
        }, 4);
    };

    this.filtroLembrete = function(widget) {
        widget.dataSourceFilter = [{
                "name": "NRORG",
                "operator": "IN",
                "value": "@[getLocalVar('CRM_NRORGTRAB'), getLocalVar('CRM_NRORGPADRAO')]@"
            },
            {
                "name": "NRSEQSLA",
                "operator": "=",
                "value": widget.parent.parent.currentRow.NRSEQSLA
            }
        ];

        widget.reload();
    };

    this.setParcNegocio = function(widget) {
        if (widget.name == "WDGT_LEMBRETE_SLA") {
            if (widget.currentRow.TIPOREGRA == "RESPOSTA") {
                restEngine.post("product#/crud/crm_analistaresposta", {
                    'requestType': 'FilterData',
                    filter: [{
                            operator: "=",
                            name: "NRSEQSLA",
                            value: widget.currentRow.NRSEQSLA
                        },
                        {
                            operator: "=",
                            name: "NRREGRATEMPORESP",
                            value: widget.currentRow.NRREGRATEMPO
                        },
                        {
                            operator: "=",
                            name: "NRORG",
                            value: widget.currentRow.NRORG
                        }
                    ]
                }).
                then(function(response) {

                    var parcnegociosRespostas = response.dataset.crm_analistaresposta;
                    var parceiros = parcnegociosRespostas.map(function(parcnegocioResposta) {
                        return parcnegocioResposta.NRPARCNEGOCIO;
                    }.bind(this));

                    widget.currentRow.OPERADORESP = parceiros;
                    // widget.getField('OPERADORESP').reload();
                }.bind(this));

            } else if (widget.currentRow.TIPOREGRA == "RESOLUCAO") {

                restEngine.post("product#/crud/crm_analistaresolucao", {
                    'requestType': 'FilterData',
                    filter: [{
                            operator: "=",
                            name: "NRSEQSLA",
                            value: widget.currentRow.NRSEQSLA
                        },
                        {
                            operator: "=",
                            name: "NRREGRATEMPORESO",
                            value: widget.currentRow.NRREGRATEMPO
                        },
                        {
                            operator: "=",
                            name: "NRORG",
                            value: widget.currentRow.NRORG
                        }
                    ]
                }).
                then(function(response) {

                    var parcnegociosRespostas = response.dataset.crm_analistaresolucao;
                    var parceiros = parcnegociosRespostas.map(function(parcnegocioResposta) {
                        return parcnegocioResposta.NRPARCNEGOCIO;
                    }.bind(this));

                    widget.currentRow.OPERADOSOLU = parceiros;
                    // widget.getField('OPERADOSOLU').reload();
                }.bind(this));
            }
        } else {
            if (widget.currentRow.TIPOREGRA == "RESPOSTA") {
                restEngine.post("product#/crud/crm_analistanotresposta", {
                    'requestType': 'FilterData',
                    filter: [{
                            operator: "=",
                            name: "NRSEQSLA",
                            value: widget.currentRow.NRSEQSLA
                        },
                        {
                            operator: "=",
                            name: "NRNOTIFICATEMPORESP",
                            value: widget.currentRow.NRNOTIFICATEMPO
                        },
                        {
                            operator: "=",
                            name: "NRORG",
                            value: widget.currentRow.NRORG
                        }
                    ]
                }).
                then(function(response) {

                    var parcnegociosRespostas = response.dataset.crm_analistanotresposta;
                    var nmparceiros = parcnegociosRespostas.map(function(parcnegocioResposta) {
                        return parcnegocioResposta.NMPRINCIPALPARC;
                    }.bind(this));
                    var parceiros = parcnegociosRespostas.map(function(parcnegocioResposta) {
                        return parcnegocioResposta.NRPARCNEGOCIO;
                    }.bind(this));

                    widget.currentRow.OPERADORESP = parceiros;
                    // widget.reload();
                    // widget.getField('OPERADORESP').reload();
                }.bind(this));

            } else if (widget.currentRow.TIPOREGRA == "RESOLUCAO") {

                restEngine.post("product#/crud/crm_analistanotresolucao", {
                    'requestType': 'FilterData',
                    filter: [{
                            operator: "=",
                            name: "NRSEQSLA",
                            value: widget.currentRow.NRSEQSLA
                        },
                        {
                            operator: "=",
                            name: "NRNOTIFICATEMPORESO",
                            value: widget.currentRow.NRNOTIFICATEMPO
                        },
                        {
                            operator: "=",
                            name: "NRORG",
                            value: widget.currentRow.NRORG
                        }
                    ]
                }).
                then(function(response) {

                    var parcnegociosSolucoes = response.dataset.crm_analistanotresolucao;
                    
                    var nmparceiros = parcnegociosSolucoes.map(function(parcnegociosSolucao) {
                        return parcnegociosSolucao.NMPRINCIPALPARC;
                    }.bind(this));
                    
                    var parceiros = parcnegociosSolucoes.map(function(parcnegociosSolucao) {
                        return parcnegociosSolucao.NRPARCNEGOCIO;
                    }.bind(this));

                    widget.currentRow.OPERADORESO = parceiros;
                    // widget.reload();
                    // widget.getField('OPERADORESO').reload();
                }.bind(this));
            } 
        }

    };

    this.excluiLembrete = function(widget) {
        ScreenService.confirmMessage('Deseja realmente excluir o lembrete?', 'QUESTION',
            function(success) {
                var paramsRestEngine = {
                    requestType: 'Row',
                    row: widget.currentRow
                };

                restEngine.post('product#/crm_sla_lembreteNotificacao/sla_exclui_lembrete', paramsRestEngine).
                then(function(response) {
                    ScreenService.showMessage('Lembrete excluido');
                    ScreenService.closeSwipe().then(function() {
                        ScreenService.closePopup(true);
                        widget.reload();
                    });

                }).catch(function(error) {
                    ScreenService.showMessage(error.data.error);
                });
            },
            function(cancel) {

            });
    };
    
    this.excluiNotificacao = function(widget){
        ScreenService.confirmMessage('Deseja realmente excluir a Notificação?', 'QUESTION',
            function(success) {
                var paramsRestEngine = {
                    requestType: 'Row',
                    row: widget.currentRow
                };

                restEngine.post('product#/crm_sla_lembreteNotificacao/sla_exclui_notificacao', paramsRestEngine).
                then(function(response) {
                    ScreenService.showMessage('Notificação excluida');
                    ScreenService.closeSwipe().then(function() {
                        ScreenService.closePopup(true);
                        widget.reload();
                    });

                }).catch(function(error) {
                    ScreenService.showMessage(error.data.error);
                });
            },
            function(cancel) {

            });
        
    };

    this.setDSRESPSOLU = function(widget) {
        if (widget.name == "WDGT_LEMBRETE_SLA") {
            widget.currentRow.DSRESPSOLU = "Defina uma regra de lembrete para quando o tempo de RESPOSTA ou SOLUÇÃO de um Ticket estiver próximo do limite estabelecido. Um e-mail será enviado caso o tempo atinja o percentual definido e o ticket não tenha tido nenhuma resposta e nem tenha sido solucionado pelo analista.";
        } else {
            widget.currentRow.DSRESPSOLU = "Defina uma regra de notificação para quando o tempo de RESPOSTA ou SOLUÇÃO de um Ticket atingir o limite estabelecido. Um e-mail será enviado caso o tempo atinja o tempo definido e o ticket não tenha tido nenhuma resposta e nem tenha sido solucionado pelo analista. Caso Notificar Imediatamente esteja configurado como Sim, um email será enviado imediamente quando o tempo da SLA chegar no limite e outro email será enviado após o tempo configurado em Notifica Após.";
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register("crm_sla_recadoNotificalcao", crm_sla_recadoNotificalcao);
});

// FILE: ./assets/js/controllers/crm00001000_Parametrizacao_Crm_Controller.js
function crm00001000_Parametrizacao_Crm_Controller(General, CRM_Utilities, templateManager, ScreenService, restEngine, Messages, IntegracaoRDStationController) {
    
    /**
     * Procedimento para manter uma parametrização.
     * 
     * @param {object} widget widget referente a tela
     * 'parametrização CRM
    */
    this.saveParameterization = function(widget){
        if(!this.checkIfThereIsRecord(widget)){
            this.saveNewParameterization(widget);
        }else{
            this.editParameterization(widget);
        }
    };
    
    /**
     * Procedimento para salvar uma nova parametrização.
     * 
     * @param {object} widget widget referente a tela
     * 'parametrização CRM'.
     * 
     * Alterado 22/01/18 - Manda pro backend se será
     * necessário criptografar a senha do IMAP
    */
    this.saveNewParameterization = function(widget){
        
        var currentRow = widget.currentRow;
        if(widget.isValid()) {
            if(Util.isEmptyOrBlank(currentRow.NRTPARVPROD)) {
                currentRow.NRTPARVPROD = null;
            }
            
            this.defineCurrentRowAsNewRecord(widget);
            this.setNrDiasLancEvolInTemplateManager(currentRow.NRDIASLANCEVOL);
            this.controlMultipleTree(widget, 'save');
            CRM_Utilities.setColumnToReturnInCurrentRow(currentRow, "NRSEQPARAMETRIZACAO");
            
            widget.currentRow.TXHOSTIMAP = (typeof widget.currentRow.TXHOSTIMAP === "string" && widget.currentRow.TXHOSTIMAP !== '') ? widget.currentRow.TXHOSTIMAP.split(':')[0] + ':' + widget.currentRow.HOSTPORT : ''; 
            
            var redirectRDStation = false;
            if(widget.name == 'WDGT_PARAM_INTEGRATION_RDSTATION'){
                this.prepareTags(widget);
                IntegracaoRDStationController.showCustomFieldAction();
                redirectRDStation = true;
            }
                
            General.widgetSave(widget).then(function(response){
                currentRow.NRSEQPARAMETRIZACAO = response.dataset.columnsToReturn.NRSEQPARAMETRIZACAO;
                var widgetGeral = templateManager.container.getWidget('WDGT_PARAM_CRM');
                widgetGeral.reload().then(function(){
                    templateManager.CRM_PARAMETRIZACAO = widget.dataSource.data[0];
                    widget.currentRow.OLDPASSIMAP = widget.dataSource.data[0].TXPASSIMAP;    
                    widget.currentRow.TXHOSTIMAP = (typeof widget.currentRow.TXHOSTIMAP === "string" && widget.widgetGeral.TXHOSTIMAP !== '') ? widget.widgetGeral.TXHOSTIMAP.split(':')[0] : '';
                    General.changeWidgetAcessibility(templateManager.container.getWidget('WDGT_TABBED_PARAM_CRM').widgets, true);
                    if(redirectRDStation)
                        IntegracaoRDStationController.authRDStation(widget);
                }.bind(this));
            }.bind(this));
        }
    };
    
    /**
     * Procedimento para editar a parametrização
     * existente.
     * 
     * @param {object} widget widget referente a tela
     * 'parametrização CRM'.
     * 
     * Alterado 22/01/18 - Manda pro backend se será
     * necessário criptografar a senha do IMAP
    */
    this.editParameterization = function(widget){
        if(widget.isValid()){
            if(Util.isEmptyOrBlank(widget.currentRow.NRTPARVPROD)) {
                widget.currentRow.NRTPARVPROD = null;
            }
            
            this.setNrDiasLancEvolInTemplateManager(widget.currentRow.NRDIASLANCEVOL);
            this.controlMultipleTree(widget, 'save');
            
            widget.currentRow.TXHOSTIMAP = (typeof widget.currentRow.TXHOSTIMAP === "string" && widget.currentRow.TXHOSTIMAP !== '') ? widget.currentRow.TXHOSTIMAP.split(':')[0] + ':' + widget.currentRow.HOSTPORT : '';  
            
            var redirectRDStation = false;
            if(widget.name == 'WDGT_PARAM_INTEGRATION_RDSTATION'){
                this.prepareTags(widget);
                IntegracaoRDStationController.showCustomFieldAction();
                redirectRDStation = true;
            }
                
            General.widgetSave(widget).then(function(){
                var widgetGeral = templateManager.container.getWidget('WDGT_PARAM_CRM');
                widgetGeral.reload().then(function(){
                    templateManager.CRM_PARAMETRIZACAO = widget.dataSource.data[0];
                    widget.currentRow.OLDPASSIMAP = widgetGeral.dataSource.data[0].TXPASSIMAP;    
                    widget.currentRow.TXHOSTIMAP = (typeof widgetGeral.currentRow.TXHOSTIMAP === "string" && widgetGeral.currentRow.TXHOSTIMAP !== '') ? widgetGeral.currentRow.TXHOSTIMAP.split(':')[0] : '';
                    General.changeWidgetAcessibility(templateManager.container.getWidget('WDGT_TABBED_PARAM_CRM').widgets, true);
                    if(redirectRDStation)
                        IntegracaoRDStationController.authRDStation(widget);
                }.bind(this));
            }.bind(this));
        }
    };
    
    /**
     * Procedimento para verificar se existe
     * algum registro na tabela referente ao
     * dataSource da tela de parametrização.
     * 
     * @param {object} widget widget referente a tela
     * 'parametrização CRM
     * 
     * @return {boolean} retorna um valor lógico
     * mostrando se exite algum registro.
    */
    this.checkIfThereIsRecord = function(widget){
        var records = widget.dataSource.data;
        
        return records.length > 0;
    };
    
    /**
     * Procedimento para definir a linha atual
     * como novo registro, definindo a variável
     * __is_new como 'true'.
     * 
     * @param {object} widget widget referente
     * a currentRow em caso.
    */
    this.defineCurrentRowAsNewRecord = function(widget){
        widget.currentRow.__is_new = true;
    };
    
    /**
     * Procedimento para setar as informações da 
     * parametrização existente na current row da
     * widget de parametrização em modo de visualização.
     * 
     * @param {object} widget widget referente a tela
     * 'parametrização CRM
    */
    this.setParameterizationInCurrentRow = function(widget){
        if(this.checkIfThereIsRecord(widget)){
            widget.currentRow = widget.dataSource.data[0];
            if(!Util.isEmptyOrBlank(widget.currentRow.TXPASSIMAP)){
                widget.currentRow.HOST = widget.currentRow.TXHOSTIMAP;
                widget.currentRow.OLDPASSIMAP = widget.currentRow.TXPASSIMAP;
                widget.currentRow.HOSTPORT =   widget.currentRow.HOST.split(':')[1]; 
                widget.currentRow.TXHOSTIMAP = widget.currentRow.HOST.split(':')[0]; 
            }
            
            if(widget.name == 'WDGT_PARAM_CRM') {
                widget.getField('NRTPARVPROD').reload();
            }
        }else{
            /**
             * Inicializa row com todos os campos vazios
             * para evitar erros no backend na hora de 
             * salvar.
             * 
            */
            
            widget.currentRow.NRDIASLANCEVOL = "";
            widget.currentRow.NRLIMITEPROSPOPER = "";
            widget.currentRow.NRMAXDIASPROSPBLOQ = "";
            widget.currentRow.NRPERFILACESSOWEBMAIL = "";
            widget.currentRow.NRLIMITELEADREVENDA = "";
            widget.currentRow.IDBLOQNOMESEMELHA = "";
            widget.currentRow.IDCNPJRAIZ = "";
            widget.currentRow.IDPERMITESINCGOOGLE = "";
            widget.currentRow.IDVALIDARESPOPORTUNI = "N";
            widget.currentRow.NRSEQPERFATIV = "";
            widget.currentRow.NRTPARVPROD = "";
            widget.currentRow.TXHOSTIMAP = "";
            widget.currentRow.HOSTPORT = "";
            widget.currentRow.TXUSERIMAP = "";
            widget.currentRow.TXPASSIMAP = "";
            widget.currentRow.NRPERFILACESSO = "";
            widget.currentRow.IDINTEGRACAOSM = "N";
            
            widget.currentRow.NMCONTARD = "";
            widget.currentRow.IDCONTARD = "";
            widget.currentRow.IDCLIENTRD = "";
            widget.currentRow.IDCLIENTSECRETRD = "";
            widget.currentRow.NMEVENTOSCONVERSAO = "";
            widget.currentRow.IDGERATAREFARD = "N";
            widget.currentRow.CDOPERRESPONSAVELRD = "";
            widget.currentRow.DSDOMINIOSRD = "";
            widget.currentRow.DSCARGOSRD = "";
            widget.currentRow.DSSCORERD = "";
            widget.currentRow.DSTOKENPUBLICORD = "";
            widget.currentRow.DSTOKENPRIVADORD = "";
            widget.currentRow.IDADDPROSPECT = "N";
            widget.currentRow.IDATIVO = "S";

        }  
        
        //var widgetIMAP = templateManager.container.getWidget('WDGT_PARAM_INTEGRATION_IMAP');
        var widgetRD = templateManager.container.getWidget('WDGT_PARAM_INTEGRATION_RDSTATION');
        var widgetMautic = templateManager.container.getWidget('WDGT_PARAM_INTEGRATION_MAUTIC');
        
        //widgetIMAP.currentRow = widget.currentRow;
        widgetRD.currentRow = widget.currentRow;
        widgetMautic.currentRow = widget.currentRow;
        
        //widgetIMAP.dataSource.data = widget.dataSource.data;
        widgetRD.dataSource.data = widget.dataSource.data;
        widgetMautic.dataSource.data = widget.dataSource.data;
        
        this.changeReadOnlyPerfilAtiv(widget);
    };
    
    /**
     * Procedimento para setar o campo 'NRDIASLANCEVOL'
     * no templateManager;
     * 
     * @param {number} nrDiasLanceEvol campo 'NRDIASLANCEVOL'.
     * 
    */
    this.setNrDiasLancEvolInTemplateManager = function(nrDiasLanceEvol){
        templateManager.NRDIASLANCEVOL = nrDiasLanceEvol;
    };
    
    /**
     * Procedimento para mudar o readOnly do Campo
     * 'Notificar por perfil de atividade' baseado no
     * que foi selecionado no campo 'Notificar responsável'.
     * 
     * @param {object} widget
     * 
    */
    this.changeReadOnlyPerfilAtiv = function(widget){
        var fieldNotifyOperator   = widget.getField('IDVALIDARESPOPORTUNI');
        var fieldNotifyPerfilAtiv = widget.getField('DESCPEFATIV');
        var hostField = widget.getField('DSHOSTSMTP');
        
        if(fieldNotifyOperator.value() === "N") {
            if(!Util.isEmptyOrBlank(hostField.value())) {
                fieldNotifyPerfilAtiv.readOnly = false;
            } else {
                fieldNotifyPerfilAtiv.readOnly = true;
            }
        } else {
            fieldNotifyPerfilAtiv.readOnly = true;
            fieldNotifyPerfilAtiv.clearValue();
            widget.currentRow.NRSEQPERFATIV = '';
        }
        
        if(!Util.isEmptyOrBlank(hostField.value())) {
            fieldNotifyOperator.readOnly = false;
        } else {
            fieldNotifyOperator.value("N");
            fieldNotifyOperator.readOnly = true;
        }
    };
    
    this.controlMultipleTree = function(widget, mode){
        if(!Util.isEmptyOrBlank(widget.currentRow.NRTPARVPROD)){
            if(mode === 'save')
                widget.currentRow.NRTPARVPROD = widget.currentRow.NRTPARVPROD.join(',');     
            else if(mode === 'edit')
                widget.currentRow.NRTPARVPROD = widget.currentRow.NRTPARVPROD.split(',');
        }
    };
    
    this.changeReadOnlyImap = function(widget){
        var currentRow = widget.currentRow;
        
        if(!Util.isEmptyOrBlank(currentRow.TXHOSTIMAP)){
            widget.getField('TXUSERIMAP').readOnly = false;
            widget.getField('TXUSERIMAP').validations = {required:true};
            widget.getField('TXPASSIMAP').readOnly = false;
            widget.getField('TXPASSIMAP').validations = {required:true};
            widget.getField('HOSTPORT').readOnly = false;
            widget.getField('HOSTPORT').validations = {required:true};
            $('#HOSTPORT').focus();
            widget.getField('NMPERFILACESSO').readOnly = false;
            widget.getField('NMPERFILACESSO').validations = {required:true};
        }else{
            widget.getField('TXUSERIMAP').readOnly = true;
            widget.currentRow.TXUSERIMAP = '';
            widget.getField('TXUSERIMAP').validations = {};
            widget.getField('TXPASSIMAP').readOnly = true;
            widget.currentRow.TXPASSIMAP = '';
            widget.getField('TXPASSIMAP').validations = {};
            widget.getField('HOSTPORT').readOnly = true;
            widget.currentRow.HOSTPORT = '';
            widget.getField('HOSTPORT').validations = {};
            widget.currentRow.NMPERFILACESSO = '';
            widget.currentRow.NRPERFILACESSOWEBMAIL = '';
            widget.getField('NMPERFILACESSO').readOnly = true;
            widget.getField('NMPERFILACESSO').validations = {};
        }
        
    };
    
    this.setHostInCurrentRow = function(widget){
        if(!Util.isEmptyOrBlank(widget.currentRow.HOST)){
            widget.currentRow.TXHOSTIMAP =   widget.currentRow.HOST.split(':')[0]; 
            widget.currentRow.OLDPASSIMAP = widget.currentRow.TXPASSIMAP;
        }else{
            widget.currentRow.HOST = widget.currentRow.TXHOSTIMAP;
            widget.currentRow.TXHOSTIMAP =   widget.currentRow.TXHOSTIMAP.split(':')[0]; 
        } 
    };
    
    this.prepareTags = function(widget){
        widget.fields.forEach(function(field){
            if(field.template.indexOf('field-tag') !== -1){
                widget.currentRow[field.name] = Array.isArray(widget.currentRow[field.name]) ? widget.currentRow[field.name].join(',') : '';
            }
        });
    };
    
    this.editMautic = function(widget) {
        var mainWid = templateManager.container.getWidget('WDGT_TABBED_PARAM_CRM');
        
        General.widgetEdit(widget);
        General.changeWidgetAcessibility(mainWid.widgets, true);
    };
    
    this.saveMautic = function(widget) {
        if (!widget.isValid()) {
            return;
        }
    
        var restParams = {
            requestType: 'Row',
            row: widget.currentRow
        };
    
        CRM_Utilities.post('/saveParamMautic', restParams).then(function () {
            General.widgetCancelForm(widget);
            this.reloadAndCopyDataSource().then(function () {
                ScreenService.showMessage('Integração salva com sucesso!');
            });
        }.bind(this));
    };
    
    this.cancelMautic = function(widget) {
        General.widgetCancelForm(widget);
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm00001000_Parametrizacao_Crm_Controller', crm00001000_Parametrizacao_Crm_Controller);
});

// FILE: ./assets/js/controllers/crm00001002_Motivo_Contato_Perfil_Atividade_Controller.js
function crm00001002_Motivo_Contato_Perfil_Atividade_Controller(General, CRM_Utilities, ScreenService) {
    
    /**
     * Função para salvar um motivo de contato
     * ao perfil de atividade em caso.
     * 
     * @param {object} widget widget ativa onde está
     * sendo realizado o cadastro do motivo.
    */
    this.saveNewActivityProfileContactReason = function(widget){
        
        var currentRow = widget.currentRow;
        
        var activityProfileContactReasons= currentRow.MOTIVOS;
        var rows = [];
        
        activityProfileContactReasons.forEach(function(reason, reasonIndex){
            
            rows.push(this.setActivityProfileReasonValuesInCurrentRow(widget, reasonIndex));
                
        }.bind(this)); 
        
        General.callRestEngine("product#/crm_perfimoticont_moticont/save", "DataSet", rows).then(function(response){
                
                ScreenService.closeSwipe().then(function(){
                    
                    widget.reload();
                    
                });
                
        }.bind(this));
    };
    
    /**
     * Função para pegar as informações do 
     * array de motivos na currentRow, e
     * tratá-las em uma cópia da currentRow para
     * realizar o save.
     * 
     * @param {object} widget widget ativa onde está
     * sendo realizado o cadastro do motivo do contato.
     * 
     * @param {int} reasonIndex index do motivo
     * no array de motivos presente na currentRow.
    */
    this.setActivityProfileReasonValuesInCurrentRow = function(widget, reasonIndex){
        
        var currentRow = angular.copy(widget.currentRow);
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.__is_new = true;
        currentRow.NRSEQPERFATIV = widget.getParent().currentRow.NRSEQPERFATIV;
        currentRow.CDMOTICONT= currentRow.MOTIVOS[reasonIndex];
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        
        return currentRow;
        
    };
    
    /**
     * Função para inserir um filtro na field
     * de motivos de contato e logo em seguida,
     * atualiza a field.
     * 
     * @param {object} widget widget ativa no
     * modo edit, onde está sendo mostrado o campo
     * de motivos.
    */
    this.insertContactReasonFilter = function(widget){
        
        var reasonField = widget.getField("MOTIVOS");
        var reasonFieldFilter = reasonField.dataSourceFilter;
        
        var nrseqperfativIndex = CRM_Utilities.getFilterPosition(reasonFieldFilter, "P_NRSEQPERFATIV");
        
        reasonFieldFilter[nrseqperfativIndex].value = widget.getParent().currentRow.NRSEQPERFATIV;
        
        reasonField.reload();
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm00001002_Motivo_Contato_Perfil_Atividade_Controller', crm00001002_Motivo_Contato_Perfil_Atividade_Controller);
});

// FILE: ./assets/js/controllers/crm00001002_Motivo_Evolucao_Perfil_Atividade_Controller.js
function crm00001002_Motivo_Evolucao_Perfil_Atividade_Controller(General, CRM_Utilities, ScreenService) {
    
    /**
     * Função para salvar um motivo de evolução
     * ao perfil de atividade em caso.
     * 
     * @param {object} widget widget ativa onde está
     * sendo realizado o cadastro do motivo da evolução.
    */
    this.saveNewActivityProfileEvolutionReason = function(widget){
        
        var currentRow = widget.currentRow;
        
        var activityProfileEvolutionReason= currentRow.MOTIVOS;
        var rows = [];
        
        activityProfileEvolutionReason.forEach(function(reason, reasonIndex){
            
            rows.push(this.setActivityProfileReasonValuesInCurrentRow(widget, reasonIndex));
                
        }.bind(this)); 
        
        General.callRestEngine("product#/crm_perfimotievo_motievolcont/save", "DataSet", rows).then(function(response){
                
                ScreenService.closeSwipe().then(function(){
                    
                    widget.reload();
                    
                });
                
        }.bind(this)).catch(function() {
            ScreenService.showMessage('Ocorreu um erro e não foi possível realizar o procedimento.<br>Contate um administrador.');
        });
    };
    
    /**
     * Função para pegar as informações do 
     * array de motivos na currentRow, e
     * tratá-las em uma cópia da currentRow para
     * realizar o save.
     * 
     * @param {object} widget widget ativa onde está
     * sendo realizado o cadastro do motivo do evolução.
     * 
     * @param {int} reasonIndex index do motivo
     * no array de motivos presente na currentRow.
    */
    this.setActivityProfileReasonValuesInCurrentRow = function(widget, reasonIndex){
        
        var currentRow = angular.copy(widget.currentRow);
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.__is_new = true;
        currentRow.NRSEQPERFATIV = widget.parent.parent.currentRow.NRSEQPERFATIV;
        currentRow.CDMOTIEVOCON= currentRow.MOTIVOS[reasonIndex];
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        
        return currentRow;
        
    };
    
    /**
     * Função para inserir um filtro na field
     * de motivos de evolução e logo em seguida,
     * atualiza a field.
     * 
     * @param {object} widget widget ativa no
     * modo edit, onde está sendo mostrado o campo
     * de motivos.
    */
    this.insertEvolutionReasonFilter = function(widget){
        
        var reasonField = widget.getField("MOTIVOS");
        var reasonFieldFilter = reasonField.dataSourceFilter;
        
        var nrseqperfativIndex = CRM_Utilities.getFilterPosition(reasonFieldFilter, "P_NRSEQPERFATIV");
        
        reasonFieldFilter[nrseqperfativIndex].value = widget.parent.parent.currentRow.NRSEQPERFATIV;
        
        reasonField.reload();
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm00001002_Motivo_Evolucao_Perfil_Atividade_Controller', crm00001002_Motivo_Evolucao_Perfil_Atividade_Controller);
});

// FILE: ./assets/js/controllers/crm00001002_Natureza_Perfil_Atividade.js
function crm00001002_Natureza_Perfil_Atividade(General, CRM_Utilities, ScreenService) {
    
    /**
     * Função para salvar uma natureza
     * ao perfil de atividade em caso.
     * 
     * @param {object} widget widget ativa onde está
     * sendo realizado o cadastro da natureza.
    */
    this.saveNewActivityProfileNatureza = function(widget){
        
        var currentRow = widget.currentRow;
        
        var activityProfileNatureza = currentRow.NATUREZAS;
        var rows = [];
        
        activityProfileNatureza.forEach(function(natu, natuIndex){
            
            rows.push(this.setActivityProfileNaturezaValuesInCurrentRow(widget, natuIndex));
                
        }.bind(this)); 
        
        General.callRestEngine("product#/crm_perfinatucont_natucont/save", "DataSet", rows).then(function(response){
                
                ScreenService.closeSwipe().then(function(){
                    
                    widget.reload();
                    
                });
                
        }.bind(this));
    };
    
    /**
     * Função para pegar as informações do 
     * array de natureza na currentRow, e
     * tratá-las em uma cópia da currentRow para
     * realizar o save.
     * 
     * @param {object} widget widget ativa onde está
     * sendo realizado o cadastro da natureza.
     * 
     * @param {int} resultIndex index da natureza
     * no array de naturezas presente na currentRow.
    */
    this.setActivityProfileNaturezaValuesInCurrentRow = function(widget, natuIndex){
        
        var currentRow = angular.copy(widget.currentRow);
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.__is_new = true;
        currentRow.NRSEQPERFATIV = widget.parent.parent.currentRow.NRSEQPERFATIV;
        currentRow.CDNATUCONT = currentRow.NATUREZAS[natuIndex];
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        
        return currentRow;
        
    };
    
    /**
     * Função para inserir um filtro na field
     * de naturezas e logo em seguida,
     * atualiza a field.
     * 
     * @param {object} widget widget ativa no
     * modo edit, onde está sendo mostrado o campo
     * de natureza.
    */
    this.insertNatucontFilter = function(widget){
        
        var natuField = widget.getField("NATUREZAS");
        var natuFieldFilter = natuField.dataSourceFilter;
        
        var nrseqperfativIndex = CRM_Utilities.getFilterPosition(natuFieldFilter, "P_NRSEQPERFATIV");
        
        natuFieldFilter[nrseqperfativIndex].value = widget.parent.parent.currentRow.NRSEQPERFATIV;
        
        natuField.reload();
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm00001002_Natureza_Perfil_Atividade', crm00001002_Natureza_Perfil_Atividade);
});

// FILE: ./assets/js/controllers/crm00001002_Operador_Perfil_Atividade_Controller.js
function crm00001002_Operador_Perfil_Atividade_Controller(General, CRM_Utilities, ScreenService) {
    
    /**
     * Função para salvar um operador ao perfil
     * de atividade em caso.
     * 
     * @param {object} widget widget ativa onde está
     * sendo realizado o cadastro do operador.
    */
    this.saveNewActivityProfileOperator = function(widget){
        
        var currentRow = widget.currentRow;
        
        var activityProfileOperators = currentRow.OPERADORES;
        var rows = [];
        
        activityProfileOperators.forEach(function(operator, operatorIndex){
            
            rows.push(this.setActivityProfileOperatorValuesInCurrentRow(widget, operatorIndex));
                
        }.bind(this)); 
        
        General.callRestEngine("product#/crm_perfioper_operador/save", "DataSet", rows).then(function(response){
                
                ScreenService.closeSwipe().then(function(){
                    
                    widget.reload();
                    widget.getField("OPERADORES").reload();
                    
                });
                
        }.bind(this));
    };
    
    /**
     * Função para pegar as informações do 
     * array de operadores na currentRow, e
     * tratá-las em uma cópia da currentRow para
     * realizar o save.
     * 
     * @param {object} widget widget ativa onde está
     * sendo realizado o cadastro do operador.
     * 
     * @param {int} operatorIndex index do operador
     * no array de operadores presente na currentRow.
    */
    this.setActivityProfileOperatorValuesInCurrentRow = function(widget, operatorIndex){
        
        var currentRow = angular.copy(widget.currentRow);
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.__is_new = true;
        currentRow.NRSEQPERFATIV = widget.parent.parent.currentRow.NRSEQPERFATIV;
        currentRow.CDOPERADOR = currentRow.OPERADORES[operatorIndex];
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        
        return currentRow;
        
    };
    
    /**
     * Define as regras do campo de operador na aba de operadores
     * na widget perfil de atividade de acordo 
     * com a revenda do operador logado.
     * 
     * @param {object} widget widget de operadores
     * ('WDGT_OPER_PERFIL_ATIVIDADE').
    */
    this.setResaleRules = function(widget) {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        if(loggedOperatorInfos.IDTPOPERADOR === 'R' && Boolean(loggedOperatorInfos.NRREVENDA)){
            
            var restrictObjects = [];
            
            restrictObjects.push(widget.getField("OPERADORES"));
            
            CRM_Utilities.setResaleRulesInRestrictObjectsByLoggedOperatorResale(restrictObjects);
            
        }
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm00001002_Operador_Perfil_Atividade_Controller', crm00001002_Operador_Perfil_Atividade_Controller);
});

// FILE: ./assets/js/controllers/crm00001002_Perfil_de_Atividade_Controller.js
function crm00001002_Perfil_de_Atividade_Controller(General, CRM_Utilities, ScreenService, restEngine) {
    
    /**
     * Função para designar o procedimento correto
     * a ser realizado (Salvar ou editar um registro).
     * 
     * @param {object} widget widget ativa, no modo
     * de edição.
    */
    this.saveActivityProfile = function(widget){
        
        var currentRow   = widget.currentRow;
        if(widget.isValid()){
            restEngine.post('/savePerfilAtiv',{'requestType': 'Row','row': currentRow}).
            then(function(response){
                ScreenService.closeSwipe().then(function(){
                    widget.reload();
                });
                General.changeWidgetAcessibility(widget.widgets, true);
                
            }).catch(function(error){
                ScreenService.showMessage(error);
            });
        }    
    };

    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm00001002_Perfil_de_Atividade_Controller', crm00001002_Perfil_de_Atividade_Controller);
});

// FILE: ./assets/js/controllers/crm00001002_Resultado_Evolucao_Perfil_Atividade.js
function crm00001002_Resultado_Evolucao_Perfil_Atividade(General, CRM_Utilities, ScreenService) {
    
    /**
     * Função para salvar um resultado de evolução
     * ao perfil de atividade em caso.
     * 
     * @param {object} widget widget ativa onde está
     * sendo realizado o cadastro do resultado da evolução.
    */
    this.saveNewActivityProfileEvolutionResult = function(widget){
        
        var currentRow = widget.currentRow;
        
        var activityProfileEvolutionResult= currentRow.RESULTADOS;
        var rows = [];
        
        activityProfileEvolutionResult.forEach(function(result, resultIndex){
            
            rows.push(this.setActivityProfileResultValuesInCurrentRow(widget, resultIndex));
                
        }.bind(this)); 
        
        General.callRestEngine("product#/crm_perfiresult_crm_resultevo/save", "DataSet", rows).then(function(response){
                
                ScreenService.closeSwipe().then(function(){
                    
                    widget.reload();
                    
                });
                
        }.bind(this));
    };
    
    /**
     * Função para pegar as informações do 
     * array de resultados na currentRow, e
     * tratá-las em uma cópia da currentRow para
     * realizar o save.
     * 
     * @param {object} widget widget ativa onde está
     * sendo realizado o cadastro do resultado da evolução.
     * 
     * @param {int} resultIndex index do resultado
     * no array de resultados presente na currentRow.
    */
    this.setActivityProfileResultValuesInCurrentRow = function(widget, resultIndex){
        
        var currentRow = angular.copy(widget.currentRow);
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.__is_new = true;
        currentRow.NRSEQPERFATIV = widget.getParent().currentRow.NRSEQPERFATIV;
        currentRow.NRSEQRESULEVOL = currentRow.RESULTADOS[resultIndex];
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        
        return currentRow;
        
    };
    
    /**
     * Função para inserir um filtro na field
     * de resultados de evolução e logo em seguida,
     * atualiza a field.
     * 
     * @param {object} widget widget ativa no
     * modo edit, onde está sendo mostrado o campo
     * de resultados.
    */
    this.insertEvolutionResultFilter = function(widget){
        
        var resultField = widget.getField("RESULTADOS");
        var resultFieldFilter = resultField.dataSourceFilter;
        
        var nrseqperfativIndex = CRM_Utilities.getFilterPosition(resultFieldFilter, "P_NRSEQPERFATIV");
        
        resultFieldFilter[nrseqperfativIndex].value = widget.getParent().currentRow.NRSEQPERFATIV;
        
        resultField.reload();
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm00001002_Resultado_Evolucao_Perfil_Atividade', crm00001002_Resultado_Evolucao_Perfil_Atividade);
});

// FILE: ./assets/js/controllers/crm00001002_Sistema_Perfil_Atividade_Controller.js
function crm00001002_Sistema_Perfil_Atividade_Controller(General, CRM_Utilities, ScreenService) {
    
    /**
     * Função para salvar um sistema ao perfil
     * de atividade em caso.
     * 
     * @param {object} widget widget ativa onde está
     * sendo realizado o cadastro do sistema.
    */
    this.saveNewActivityProfileSystem = function(widget){
        
        var currentRow = widget.currentRow;
        
        var activityProfileSystems = currentRow.SISTEMAS;
        var rows = [];
        
        activityProfileSystems.forEach(function(system, systemIndex){
            
            rows.push(this.setActivityProfileSystemValuesInCurrentRow(widget, systemIndex));
                
        }.bind(this)); 
        
        General.callRestEngine("product#/crm_perfisistema_sistema/save", "DataSet", rows).then(function(response){
                
                ScreenService.closeSwipe().then(function(){
                    
                    widget.reload();
                    
                });
                
        }.bind(this));
    };
    
    /**
     * Função para pegar as informações do 
     * array de sistemas na currentRow, e
     * tratá-las em uma cópia da currentRow para 
     * realizar o save.
     * 
     * @param {object} widget widget ativa onde está
     * sendo realizado o cadastro do sistema.
     * 
     * @param {int} systemIndex index do sistema
     * no array de sistemas presente na currentRow.
    */
    this.setActivityProfileSystemValuesInCurrentRow = function(widget, systemIndex){
        
        var currentRow = angular.copy(widget.currentRow);
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.__is_new = true;
        currentRow.NRSEQPERFATIV = widget.parent.parent.currentRow.NRSEQPERFATIV;
        currentRow.CDSISTEMA = currentRow.SISTEMAS[systemIndex];
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        
        return currentRow;
        
    };
    
    /**
     * Função para inserir um filtro na field
     * de sistemas e logo em seguida, atualiza
     * a field.
     * 
     * @param {object} widget widget ativa no
     * modo edit, onde está sendo mostrado o campo
     * de sistemas.
    */
    this.insertSystemsFilter = function(widget){
        
        var systemField = widget.getField("SISTEMAS");
        var systemFieldFilter = systemField.dataSourceFilter;
        
        var nrseqperfativIndex = CRM_Utilities.getFilterPosition(systemFieldFilter, "P_NRSEQPERFATIV");
        
        systemFieldFilter[nrseqperfativIndex].value = widget.parent.parent.currentRow.NRSEQPERFATIV;
        
        systemField.reload();
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm00001002_Sistema_Perfil_Atividade_Controller', crm00001002_Sistema_Perfil_Atividade_Controller);
});

// FILE: ./assets/js/controllers/crm00002001_OportunidadeNegocio_Controller.js
function crm00002001_OportunidadeNegocio_Controller(
  ScreenService,
  templateManager,
  Utilities,
  ZHPromise,
  restEngine,
  Operador_Repository,
  CRM_Utilities,
  General,
  Messages,
  ABEvolucaoController,
  evolutionTabController,
  localStorageEngine,
  PartnerInfosModalController,
  ZhFilterPreferences
) {
  var self = this;
  var widgetAtiva;
  var paramCRM;

  this.shootsOpportunityEventsAfterMoveRow = function (widget) {
    this.checkOport(widget); //Define a visibilidade da action 'Editar'
    this.goBackActions();
    this.initItemsWidget();
    this.initTaskSchedule();
    this.checkLoggedOperatorPermissionToChangeOpport(widget);
    this.checkParamSM(widget);
  };

  self.iniciaFiltrosWidoportunidadegrid = function (widget) {
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
    
    Utilities.insertFilterWithoutReload(
      widget,
      "P_NRORG",
      "=",
      loggedOperatorInfos.NRORG,
      0
    );
    Utilities.insertFilterWithoutReload(
      widget,
      "P_NRPARCNEGOCIO",
      "=",
      loggedOperatorInfos.NRPARCNEGOCIO,
      1
    );
    Utilities.insertFilterWithoutReload(
      widget, 
      "NRPARCRESP", 
      "IN",
      [loggedOperatorInfos.NRPARCNEGOCIO],
      1
    );
    
    var field = widget.getField( "NRPARCRESP");
    field.value([loggedOperatorInfos.NRPARCNEGOCIO]);
    field.setValue([loggedOperatorInfos.NRPARCNEGOCIO]);
    field.reload();

    //Utilities.insertFilterWithoutReload(widget, "NRPARCRESP", "IN", [loggedOperatorInfos.NRPARCNEGOCIO], 1);

    //this.setResponsibleOperatorFilterDefaultValueInFilterPopup(widget);
  };

  self.iniciaFiltrosWidevoloport = function (widget) {
    Operador_Repository.retornaOperadorLogado().then(
      function (operator) {
        if (operator[0] === undefined || operator[0] === null) {
          ScreenService.showMessage("Erro ao realizar a operação.");
          return;
        }

        var field;

        field = widget.getField("NMPARCINTERLOCUTOR");
        Utilities.insertFilter(
          field,
          "NRPARCNEGOCIO",
          "=",
          operator[0].NRPARCNEGOCIO,
          0
        );
      },
      function (error) {
        ScreenService.showMessage("Erro ao realizar a operação.");
      }
    );
  };

  self.iniciaFiltrosWidoportfilter = function (widget) {    
    Operador_Repository.retornaOperadorLogado().then(
      function (operator) {
        if (operator[0] === undefined || operator[0] === null) {
          ScreenService.showMessage("Erro ao realizar a operação.");
          return;
        }

        field = widget.getField("NMPARCRESP");
        Utilities.insertFilterWithoutReload(
          field,
          "P_NRORG",
          "=",
          operator[0].NRORG,
          0
        );
        Utilities.insertFilter(
          field,
          "P_NRPARCNEGOCIO",
          "=",
          operator[0].NRPARCNEGOCIO,
          1
        );
      },
      function (error) {
        ScreenService.showMessage("Erro ao realizar a operação.");
      }
    );
  };

  self.iniciaFiltrosWidevolucao = function (widget) {
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    var field = widget.getField("NMMOTIEVOCON");
    Utilities.insertFilterWithoutReload(
      field,
      "P_NRORG",
      "=",
      loggedOperatorInfos.NRORG,
      0
    );
    Utilities.insertFilter(
      field,
      "P_CDOPERADOR",
      "=",
      loggedOperatorInfos.CDOPERADOR,
      1
    );

    field = widget.getField("NMSEQRESULEVOL");
    Utilities.insertFilterWithoutReload(
      field,
      "P_NRORG",
      "=",
      loggedOperatorInfos.NRORG,
      0
    );
    Utilities.insertFilter(
      field,
      "P_CDOPERADOR",
      "=",
      loggedOperatorInfos.CDOPERADOR,
      1
    );

    field = widget.getField("DESCRESULEVOL");
    Utilities.insertFilterWithoutReload(
      field,
      "P_NRORG",
      "=",
      loggedOperatorInfos.NRORG,
      0
    );
    Utilities.insertFilter(
      field,
      "P_CDOPERADOR",
      "=",
      loggedOperatorInfos.CDOPERADOR,
      1
    );
  };

  self.iniciaFiltrosWidfinishoport = function (widget) {
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    var field = widget.getField("DESCRESULEVOL");
    Utilities.insertFilterWithoutReload(
      field,
      "P_NRORG",
      "=",
      loggedOperatorInfos.NRORG,
      0
    );
    Utilities.insertFilter(
      field,
      "P_CDOPERADOR",
      "=",
      loggedOperatorInfos.CDOPERADOR,
      1
    );
  };

  self.calcOportValue = function () {
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    var items = templateManager.container.getWidget("itensgrid");
    items.reload();

    var oport =
      items.name == "itensgrid"
        ? items.parent.parent
        : templateManager.containers["wizard/oportunidade/wzoportstageoport"]
          .widgets[0];

    oport.currentRow.VRPREVOPORT = 0;

    items.dataSource.data.forEach(function (item) {
      oport.currentRow.VRPREVOPORT += parseInt(item.VRTOTITEMOPORT);
    });

    if (oport.isValid() && oport.currentRow.IDTPOPORT) {
      oport.currentRow.changed = true;

      oport.currentRow.NRORGULTATU = loggedOperatorInfos.NRORG;
      oport.currentRow.CDOPERULTATU = loggedOperatorInfos.CDOPERADOR;

      return oport.saveRow().then(function (response) {
        oport.currentRow.changed = false;

        if (response.dataset.DADOS && response.dataset.DADOS.DTULTATU)
          oport.currentRow.DTULTATU = response.dataset.DADOS.DTULTATU;
        ScreenService.showMessage(Messages.VAL_PREV_CAL_SUCESSO);
      });
    }
  };

  self.calcTotalItemValue = function () {
    var widget = templateManager.container.getWidget("itensgrid");

    Utilities.unMask("VRUNITITEMOPORT");
    Utilities.unMask("VRDESCITEMOPORT");

    widget.currentRow.QTITEMOPORT = widget.currentRow.QTITEMOPORT
      ? widget.currentRow.QTITEMOPORT
      : 1;
    widget.currentRow.VRUNITITEMOPORT = widget.currentRow.VRUNITITEMOPORT
      ? widget.currentRow.VRUNITITEMOPORT < 0
        ? widget.currentRow.VRUNITITEMOPORT * -1
        : widget.currentRow.VRUNITITEMOPORT
      : 1;
    widget.currentRow.QTMEDITEMOPORT = widget.currentRow.QTMEDITEMOPORT
      ? widget.currentRow.QTMEDITEMOPORT
      : 1;
    widget.currentRow.VRDESCITEMOPORT = widget.currentRow.VRDESCITEMOPORT
      ? widget.currentRow.VRDESCITEMOPORT
      : 0;

    var qtd = widget.currentRow.QTITEMOPORT;
    var valor_unitario = widget.currentRow.VRUNITITEMOPORT;
    var qtd_medida = widget.currentRow.QTMEDITEMOPORT;
    var tipo_desconto = widget.currentRow.IDTPDESCITEMOPORT;
    var desconto = widget.currentRow.VRDESCITEMOPORT;

    desconto =
      typeof desconto === "string"
        ? parseFloat(desconto.replace(",", "."))
        : desconto;

    switch (tipo_desconto) {
      case "S":
        widget.getField("VRDESCITEMOPORT").readOnly = true;
        widget.currentRow.VRDESCITEMOPORT = 0;
        widget.currentRow.VRTOTITEMOPORT = qtd * valor_unitario * qtd_medida;
        break;
      case "V":
        widget.getField("VRDESCITEMOPORT").readOnly = false;

        if (desconto < 0) {
          widget.currentRow.VRTOTITEMOPORT = "";
          ScreenService.notificationMessage(
            "O valor de desconto deve ser positivo",
            "alert"
          );
        } else if (desconto > qtd * valor_unitario * qtd_medida) {
          widget.currentRow.VRTOTITEMOPORT = "";
          ScreenService.notificationMessage(
            "O valor de desconto não pode ser maior que o valor total",
            "alert"
          );
        } else
          widget.currentRow.VRTOTITEMOPORT =
            qtd * valor_unitario * qtd_medida - desconto;

        widget.currentRow.VRDESCITEMOPORT = $.currency.string(desconto, {
          showSymbol: true,
          symbol: "R$",
          precision: 2,
          decimal: ",",
          thousands: ".",
        });

        break;
      case "P":
        widget.getField("VRDESCITEMOPORT").readOnly = false;

        if (desconto >= 0 && desconto <= 100)
          widget.currentRow.VRTOTITEMOPORT =
            qtd * valor_unitario * qtd_medida * (1 - desconto / 100);
        else {
          widget.currentRow.VRTOTITEMOPORT = "";
          ScreenService.notificationMessage(
            "O valor de desconto percentual deve estar entre 0 e 100",
            "alert"
          );
        }

        widget.currentRow.VRDESCITEMOPORT = desconto + "%";
    }
  };

  self.checkOport = function (widget) {
    if (
      widget.currentRow.SITUACAO == "A" ||
      widget.currentRow.SITUACAO == "Em aberto"
    ) {
      widget.getAction("EDIT").isVisible = true;
    } else {
      widget.getAction("EDIT").isVisible = false;
    }
  };

  self.checkRequirements = function (args, widgetName) {
    var widget = templateManager.container.getWidget(widgetName);

    if (
      (widget.name == "itens" || widget.name == "itensgrid") &&
      !widget.isValid() &&
      widget.currentRow.VRTOTITEMOPORT === 0 &&
      widget.currentRow.NRSERVICOPRODUTO &&
      widget.currentRow.CDTPMEDIDASERV &&
      widget.currentRow.IDTPDESCITEMOPORT
    ) {
      return true;
    } else if (
      !widget.isValid() ||
      ((widget.name == "oportunidade" || widget.name == "oportunidadegrid") &&
        !widget.currentRow.IDTPOPORT)
    ) {
      if (args) {
        args.e.preventDefault();
        ScreenService.showMessage(
          "Preencha todos os campos marcados com asterisco!"
        );
      }
      return false;
    }
    return true;
  };

  this.openModal = function () {
    ScreenService.openPopup(
      templateManager.container.getWidget("WDGT_OCCURRENCE")
    ).then(function () { }.bind(this));
  };

  self.checkRequirementsEvolutionGrid = function (args, widgetName) {
    var widget = templateManager.container.getWidget(widgetName);
    PartnerInfosModalController.setModalWidgetOnActiveWidget(
      widget,
      widget.parent.parent.currentRow.NRPARCNEGOCIO
    );
    if (
      widget.name == "evolucao" &&
      widget.isValid() &&
      widget.currentRow.NMMOTIEVOCON !== "" &&
      widget.currentRow.NMTIPOCONT !== "" &&
      widget.currentRow.NMSEQRESULEVOL !== "" &&
      widget.currentRow.TXEVOLCONT !== ""
    ) {
      if (widget.currentRow.NMSEQFASENEGO === "Solicitar Encerramento") {
        this.openModal();
      } else if (widget.parent.parent.currentRow.DSCORTERMOMETRO === '#ff030b' && (widget.currentRow.DSCORTERMOMETRO === '#19beff' || widget.currentRow.DSCORTERMOMETRO === '#ff8636')) {
        this.openModal();
      } else {
        var gridEvolucao = templateManager.container.getWidget("evolucao");
        gridEvolucao.currentRow.DSHIERARQUIAOPERPAI = "";
        gridEvolucao.currentRow.IDTPOCORRENCIA = "";
        gridEvolucao.currentRow.DSJUSTIFICATIVA = "";
        this.confirmClosingOpportunityBeforeSaveEvolution(gridEvolucao);
      }
    } else if (!widget.isValid() || widget.name == "evolucao") {
      if (args) {
        args.e.preventDefault();
        ScreenService.showMessage(
          "Preencha todos os campos marcados com asterisco!"
        );

      }
      return false;
    }

    return true;
  };

  this.saveOcorrence = function (args) {
    var widget = args.owner.widget;
    var gridEvolucao = templateManager.container.getWidget("evolucao");
    var fieldHierarquia = widget.getField("DSHIERARQUIAOPERPAI");
    var fieldTipoOcorrencia = widget.getField("IDTPOCORRENCIA");
    var fieldDescicaoOcorrencia = widget.getField("DSJUSTIFICATIVA");
    if (
      widget.name == "WDGT_OCCURRENCE" &&
      widget.isValid() &&
      widget.currentRow.DSHIERARQUIAOPER !== "" &&
      widget.currentRow.IDTPOCORRENCIA !== "" &&
      widget.currentRow.DSJUSTIFICATIVA !== ""
    ) {
      gridEvolucao.currentRow.DSHIERARQUIAOPERPAI = widget.currentRow.DSHIERARQUIAOPERPAI;
      gridEvolucao.currentRow.IDTPOCORRENCIA = widget.currentRow.IDTPOCORRENCIA;
      gridEvolucao.currentRow.DSJUSTIFICATIVA = widget.currentRow.DSJUSTIFICATIVA;
      gridEvolucao.currentRow.CDOPERADORGEST = widget.currentRow.CDOPERADORGEST;
      gridEvolucao.currentRow.NRHIERARQUIARESP = widget.currentRow.NRHIERARQUIAPAI;

      this.confirmClosingOpportunityBeforeSaveEvolution(gridEvolucao);

      ScreenService.closePopup(true);
      fieldHierarquia.value("");
      fieldTipoOcorrencia.value("");
      fieldDescicaoOcorrencia.value("");

    } else {

      ScreenService.showMessage(
        "Preencha todos os campos marcados com asterisco!"
      );
      return false;
    }
    widget.reload();
  };

  this.changeStatusJustifyField = function () {
    var gridEvolucao = templateManager.container.getWidget("evolucao");
    var fieldGroups = gridEvolucao.fieldGroups;

    var indexGroupJustify = CRM_Utilities.getFieldGroupPosition(fieldGroups, "FG_JUSTIFICATIVA");

    var groupFixedJustify = fieldGroups[indexGroupJustify];

    if (gridEvolucao.currentRow.DSJUSTIFICATIVA == "" || gridEvolucao.currentRow.DSJUSTIFICATIVA == null) {
      groupFixedJustify.isVisible = false;
    } else {
      groupFixedJustify.isVisible = true;
    }
  };

  self.cleanWizard = function () {
    if (templateManager.containers["wizard/oportunidade/wzoportstageoport"])
      templateManager.containers[
        "wizard/oportunidade/wzoportstageoport"
      ].widgets[0].currentRow = {};
    if (templateManager.containers["wizard/oportunidade/wzoportstageitens"])
      templateManager.containers[
        "wizard/oportunidade/wzoportstageitens"
      ].widgets[0].currentRow = {};
    if (templateManager.containers["wizard/oportunidade/wzoportstageposvenda"])
      templateManager.containers[
        "wizard/oportunidade/wzoportstageposvenda"
      ].widgets[0].currentRow = {};
  };

  function closeOccurrence(widget) {
    var oportWidgetFromOccurrence = widget.currentRow;
    oportWidgetFromOccurrence.CDOPERULTATU = CRM_Utilities.getLoggedOperatorInfos().CDOPERADOR;
    oportWidgetFromOccurrence.NRSEQFASENEGO = '7';
    oportWidgetFromOccurrence.IDATIVO = 'N';
    oportWidgetFromOccurrence.DTREALFECHA = moment(new Date()).format("DD/MM/YYYY HH:mm");

    var params = {
      requestType: "Row",
      row: oportWidgetFromOccurrence,
    };

    return restEngine.post("/closeOportByOccurrence", params)
      .then(function (response) {
        return response;
      })
      .catch(function (error) {
        ScreenService.showMessage(error.data.error, "error");
        console.log(error);
      });
  }

  self.closeOport = function (widget) {
    widget.currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    var params = {
      requestType: "Row",
      row: widget.currentRow,
    };

    return restEngine
      .post("/fecharOportunidade", params)
      .then(function () {
        widget.parent.parent.currentRow.DTREALFECHA =
          widget.currentRow.DTREALFECHA;
        widget.parent.parent.currentRow.NMRAZSOCCONC =
          widget.currentRow.NMRAZSOCCONC;
        widget.parent.parent.currentRow.SITUACAO = "F";

        //BEGIN RD Station
        var filter = [
          {
            name: "NRPARCNEGOCIO",
            operator: "=",
            value: widget.parent.parent.currentRow.NRPARCOPORT,
          },
          {
            name: "P_NRORGPADRAO",
            operator: "=",
            value: getLocalVar("CRM_NRORGPADRAO"),
          },
        ];
        localStorageEngine
          .download("product#/crud/crm_interlocutor", filter)
          .then(function (contacts) {
            if (!Util.isEmptyOrBlank(contacts)) {
              contacts.forEach(function (contact) {
                var row = {
                  email: contact["EMAILINTERLOC"],
                };
                if (widget.currentRow.IDGANHAPERDE === "GANHA") {
                  row["status"] = "won";
                  row["value"] = widget.currentRow.VROPORT;
                } else if (widget.currentRow.IDGANHAPERDE === "PERDE") {
                  row["status"] = "lost";
                  row["lost_reason"] = widget.currentRow.DESCRESULEVOL;
                }
                restEngine
                  .post("/IntegracaoRDStation/feedBackConversion", {
                    requestType: "Row",
                    row: {
                      EVENT_NAME: "Venda gerada pelo CRM",
                      EMAIL: contact["EMAILINTERLOC"],
                    },
                  })
                  .then(function () {
                    restEngine.post("/IntegracaoRDStation/markSale", {
                      requestType: "Row",
                      row: row,
                    });
                  });
              });
            }
          });
        //END RD Station
      })
      .catch(function (error) {
        ScreenService.showMessage(error.data.error, "error");
        console.log(error);
      });
  };

  self.evolve = function () {
    var widget = templateManager.container.getWidget("oportunidadegrid");

    self.start(
      widget.currentRow.NRPARCOPORT,
      widget.currentRow.NRCONTATO,
      widget.currentRow.NRSEQCONTATO,
      widget.currentRow.IDTPEVOLCONT
    );
  };

  self.start = function (parceiro, nrcontato, nrseqcontato, idtpevolcont) {
    setLocalVar("PARCEIRO", parceiro);

    var promises = [openWindow("evolucao_de_caso")];

    ZHPromise.all(promises).then(function () {
      var widget = templateManager.container.getActiveWidget();

      widget.currentRow.NRCONTATO = nrcontato;
      widget.currentRow.NRSEQCONTATO = nrseqcontato;

      widget.currentRow.IDTPEVOLCONT = idtpevolcont;
      widget.currentRow.NRPARCNEGOCIO = parceiro;

      widget.currentRow.__is_new = true;
    });
  };

  self.filterOport = function () {
    var widget = templateManager.container.getWidget("oportfilter");

    var NRSEQCLASSOPORT = widget.currentRow.NRSEQCLASSOPORT
      ? widget.currentRow.NRSEQCLASSOPORT
      : null;
    var NRSEQFASENEGO = widget.currentRow.NRSEQFASENEGO
      ? widget.currentRow.NRSEQFASENEGO
      : null;
    var NRPARCOPORT = widget.currentRow.NRPARCOPORT
      ? widget.currentRow.NRPARCOPORT
      : null;
    var NRPARCRESP = widget.currentRow.NRPARCRESP
      ? widget.currentRow.NRPARCRESP
      : null;
    var IDPARTPEPELINE = widget.currentRow.IDPARTPEPELINE
      ? widget.currentRow.IDPARTPEPELINE
      : null;

    var filter = [];
    var i = 0;

    filter[i] = widget.parent.parent.dataSourceFilter[0];
    i++;
    filter[i] = widget.parent.parent.dataSourceFilter[1];
    i++;

    if (NRSEQCLASSOPORT) {
      filter[i] = {
        name: "NRSEQCLASSOPORT",
        operator: "=",
        value: NRSEQCLASSOPORT,
      };
      i++;
    }
    if (NRSEQFASENEGO) {
      filter[i] = {
        name: "NRSEQFASENEGO",
        operator: "=",
        value: NRSEQFASENEGO,
      };
      i++;
    }
    if (NRPARCOPORT) {
      filter[i] = {
        name: "NRPARCOPORT",
        operator: "=",
        value: NRPARCOPORT,
      };
      i++;
    }
    if (NRPARCRESP) {
      filter[i] = {
        name: "NRPARCRESP",
        operator: "=",
        value: NRPARCRESP,
      };
      i++;
    }
    if (IDPARTPEPELINE) {
      filter[i] = {
        name: "IDPARTPEPELINE",
        operator: "=",
        value: IDPARTPEPELINE,
      };
      i++;
    }

    widget.parent.parent.dataSourceFilter = filter;
    Utilities.masterDetailClosePopup();
    widget.parent.parent.reload();
  };

  self.finishEvolution = function () {
    var popup = templateManager.container.getWidget("evoloport");

    Operador_Repository.retornaOperadorLogado().then(
      function (operator) {
        if (popup.isValid()) {
          if (operator[0] === undefined || operator[0] === null) {
            ScreenService.showMessage("Erro ao realizar a operação.");
            return;
          }

          popup.currentRow.NRORGULTATU = operator[0].NRORG;
          popup.currentRow.CDOPERULTATU = operator[0].CDOPERADOR;

          return popup.saveRow().then(function (response) {
            popup.currentRow.changed = false;
            popup.currentRow.__is_new = false;

            if (response.dataset.DADOS && response.dataset.DADOS.DTULTATU)
              popup.currentRow.DTULTATU = response.dataset.DADOS.DTULTATU;

            Utilities.masterDetailClosePopup();

            var widget = templateManager.container.getActiveWidget();

            widget.reload();
          });
        }
      },
      function (error) {
        ScreenService.showMessage("Erro ao realizar a operação.");
      }
    );
  };

  self.initAftersale = function () {
    var widget = templateManager.container.getWidget("posvenda");

    Operador_Repository.retornaOperadorLogado().then(
      function (operator) {
        if (operator[0] === undefined || operator[0] === null) {
          ScreenService.showMessage("Erro ao realizar a operação.");
          return;
        }

        widget.currentRow.NRORG = operator[0].NRORG;
        widget.currentRow.NMPARCRESP = operator[0].NMOPERADOR;
        widget.currentRow.NRPARCRESP = operator[0].CDOPERADOR;
        widget.currentRow.CDOPERREAL = operator[0].CDOPERADOR;

        widget.currentRow.NMPRINCIPALPARC = "";
        widget.currentRow.DSEMAILTAREFA = "";
        widget.currentRow.DSTELEFONETAREFA = "";

        widget.currentRow.__is_new = true;
        widget.currentRow.DTPLANFILACONTA = widget.currentRow.DTPLANFILACONTA
          ? widget.currentRow.DTPLANFILACONTA
          : moment(new Date()).format("DD/MM/YYYY HH:mm");

        widget.currentRow.NRPARCNEGOCIO =
          templateManager.containers[
            "wizard/oportunidade/wzoportstageoport"
          ].widgets[0].currentRow.NRPARCOPORT;
        widget.currentRow.NRCONTATO =
          templateManager.containers[
            "wizard/oportunidade/wzoportstageoport"
          ].widgets[0].currentRow.NRCONTATO;
        widget.currentRow.NRSEQCONTATO =
          templateManager.containers[
            "wizard/oportunidade/wzoportstageoport"
          ].widgets[0].currentRow.NRSEQCONTATO;

        widget.getField("NMPRINCIPALPARC").dataSourceFilter[0].value =
          templateManager.containers[
            "wizard/oportunidade/wzoportstageoport"
          ].widgets[0].currentRow.NRPARCOPORT;
        widget.getField("NMPRINCIPALPARC").reload();
      },
      function (error) {
        ScreenService.showMessage("Erro ao realizar a operação.");
      }
    );
  };

  self.initItemsWidget = function () {
    var widget = templateManager.container.getWidget("itensgrid");

    if (widget.parent.parent.currentRow.NRSEQOPORT) {
      widget.dataSourceFilter.find(function (x) {
        return x.name == "NRSEQOPORT";
      }).value = widget.parent.parent.currentRow.NRSEQOPORT;
    } else {
      widget.dataSourceFilter.find(function (x) {
        return x.name == "NRSEQOPORT";
      }).value = null;
    }
    widget.dataSourceFilter.find(function (x) {
      return x.name == "CRM_NRORGTRAB";
    }).value = getLocalVar("CRM_NRORGTRABALHO");

    self.reloadTab(widget, "NRSEQOPORT");
  };

  self.initItemsWizard = function () {
    var widget =
      templateManager.containers["wizard/oportunidade/wzoportstageitens"]
        .widgets[0];

    Operador_Repository.retornaOperadorLogado().then(
      function (operator) {
        if (operator[0] === undefined || operator[0] === null) {
          ScreenService.showMessage("Erro ao realizar a operação.");
          return;
        }

        widget.dataSourceFilter[1].value =
          templateManager.containers[
            "wizard/oportunidade/wzoportstageoport"
          ].widgets[0].currentRow.NRSEQOPORT;
        widget.reload();

        widget.currentRow.NRORG = operator[0].NRORG;
        widget.currentRow.NRSEQOPORT =
          templateManager.containers[
            "wizard/oportunidade/wzoportstageoport"
          ].widgets[0].currentRow.NRSEQOPORT;
      },
      function (error) {
        ScreenService.showMessage("Erro ao realizar a operação.");
      }
    );
  };

  self.initOportWidget = function () {
    if (
      templateManager.historyItems.length >= 2 &&
      templateManager.historyItems[templateManager.historyItems.length - 2] ==
      "evolucao_de_caso"
    ) {
      templateManager.historyItems[templateManager.historyItems.length - 2] =
        templateManager.historyItems[templateManager.historyItems.length - 1];

      self.openEvolutionPopup();
    }
  };

  self.initOportWizard = function () {
    var widget = templateManager.container.getWidget("oportunidade");
    Operador_Repository.retornaOperadorLogado().then(
      function (operator) {
        if (operator[0] === undefined || operator[0] === null) {
          ScreenService.showMessage("Erro ao realizar a operação.");
          return;
        }

        widget.currentRow.NRORG = operator[0].NRORG;
        widget.currentRow.CDFILIAL = "";
        widget.currentRow.NMPARCRESP = operator[0].NMOPERADOR;
        widget.currentRow.CDOPERCONT = operator[0].CDOPERADOR;
        widget.currentRow.NRPARCRESP = operator[0].NRPARCNEGOCIO;
        if (
          widget.currentRow.__is_new !== false &&
          widget.currentRow.__is_new !== true
        ) {
          widget.currentRow.__is_new = true;
        }
      },
      function (error) {
        ScreenService.showMessage("Erro ao realizar a operação.");
      }
    );
  };

  self.initTaskSchedule = function () {
    var widget = templateManager.container.getWidget("posvendagrid");

    //if(widget.parent.parent.currentRow.NRCONTATO) widget.dataSourceFilter[0].value = widget.parent.parent.currentRow.NRCONTATO;
    if (widget.parent.parent.currentRow.NRSEQCONTATO)
      widget.dataSourceFilter[0].value =
        widget.parent.parent.currentRow.NRSEQCONTATO;

    this.reloadTab(widget, "NRSEQCONTATO");
  };

  self.initTab = function (widget) {
    if (widget.parent.parent.currentRow.NRSEQOPORT) {
      var nrSeqoPortFilter = findFilterByName(widget.dataSourceFilter, "NRSEQOPORT");
      if (nrSeqoPortFilter) {
        nrSeqoPortFilter.value = widget.parent.parent.currentRow.NRSEQOPORT;
      } else {
        logError("Filtro 'NRSEQOPORT' não encontrado em dataSourceFilter.");
      }
    }

    var nrOrgTrabFilter = findFilterByName(widget.dataSourceFilter, "CRM_NRORGTRAB");
    if (nrOrgTrabFilter) {
      nrOrgTrabFilter.value = getLocalVar("CRM_NRORGTRABALHO");
    } else {
      logError("Filtro 'CRM_NRORGTRAB' não encontrado em dataSourceFilter.");
    }

    return self.reloadTab(widget, "NRSEQOPORT");
  };

  function findFilterByName(dataSourceFilter, filterName) {
    if (dataSourceFilter && dataSourceFilter.length > 0) {
      for (var i = 0; i < dataSourceFilter.length; i++) {
        if (dataSourceFilter[i].name === filterName) {
          return dataSourceFilter[i];
        }
      }
    }
    return null;
  };

  function logError(message) {
    console.error(message);
  };

  this.reloadTab = function (widget, filter) {
    var promise = ZHPromise.defer();
    if (
      widget.currentFilter &&
      widget.currentFilter !== widget.parent.parent.currentRow[filter]
    ) {
      widget.reload().then(function () {
        promise.resolve(widget.dataSource.data);
      });
    } else if (!widget.currentFilter) {
      widget.reload().then(function () {
        promise.resolve(widget.dataSource.data);
      });
    }
    this.setCurrentFilter(widget, filter);
    widget.reload();
    return promise.promise;
  };

  this.setCurrentFilter = function (widget, filter) {
    widget.currentFilter = widget.parent.parent.currentRow[filter];
  };

  /**
   * Questiona o usuário se ele deseja calcular o valor
   * (previsto) da oportunidade depois da exclusão do item.
   *
   * @param {object} widget widget de oportunidade ('oportunidadegrid').
   */
  this.calcOportValueAfeterItemDelete = function (widget) {
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              ScreenService.confirmMessage(
                Messages.CALC_VAL_PREV_OPORT_DELETE,
                "CONFIRMATION",
                function (success) {
                  this.itemsDelete(widget);
                  widget.CALCULATEOPPORTVALUE = true;
                }.bind(this),
                function () {
                  if (Boolean(widget.CALCULATEOPPORTVALUE)) {
                    delete widget.CALCULATEOPPORTVALUE;
                  }
                  this.itemsDelete(widget);
                }.bind(this)
              );
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    }.bind(this));
  };

  self.itemsDelete = function (widget) {
    General.deleteCrud(widget).then(function () {
      if (Boolean(widget.CALCULATEOPPORTVALUE)) {
        delete widget.CALCULATEOPPORTVALUE;
        self.calcOportValue();
      }
    });
  };

  self.itemsSave = function (widget) {
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              if (response.dataset) {
                Utilities.unMask("VRDESCITEMOPORT");

                widget.currentRow.CDPRODUTO = widget.currentRow.CDPRODUTO || "";
                widget.currentRow.CDSERVORCA = widget.currentRow.CDSERVORCA || "";
                if (widget.currentRow.__is_new) {
                  widget.currentRow.NRSEQOPORT = widget.parent.parent.currentRow.NRSEQOPORT;
                }

                return General.widgetSave(widget).then(function (response) {
                  if (Boolean(response.dataset.columnsToReturn[0])) {
                    widget.currentRow.NRSEQITENSOPORTUNI = response.dataset.columnsToReturn[0].NRSEQITENSOPORTUNI;
                  }
                  ScreenService.confirmMessage(
                    "Deseja calcular o valor da oportunidade à partir dos itens?",
                    "CONFIRMATION",
                    self.calcOportValue
                  );
                });
              }
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    }.bind(this));
  };

  self.itemsEdit = function (widget) {
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    if (widget.isValid()) {
      this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                General.widgetEdit(widget);
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                  response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                  " - " +
                  response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                  "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }.bind(this));
    }
  };

  /**
   * Habilita o ambiente de inserção de um item
   * para a oportunidade selecionada.
   *
   * @param {object} widget widget de items
   * ('itensgrid');
   */
  this.addOpportunityItem = function (widget) {
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              General.widgetNewRow(widget);

              this.setOpportItemsDefaultValues(widget);
              this.setWidgetItemsPermissions(widget);
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    }.bind(this));
  };

  /**
   * Define a permissão dos campos da widget de
   * itens.
   *
   * @param {object} widget widget de itens da oportunidade
   * ('itensgrid').
   */
  this.setWidgetItemsPermissions = function (widget) {
    var discountField = widget.getField("VRDESCITEMOPORT");
    discountField.readOnly = true;
  };

  /**
   * Define os valores iniciais do item
   * da oportunidade.
   *
   * @param {object} widget widget de items
   * ('itensgrid');
   */
  this.setOpportItemsDefaultValues = function (widget) {
    var currentRow = widget.currentRow;

    currentRow.CDTPMEDIDASERV = "";
  };

  self.itemsWizardCancelForm = function () {
    Utilities.wizardChangeFooter();
    Utilities.masterDetailCancelForm();
  };

  self.itemsWizardEdit = function () {
    Utilities.wizardChangeFooter();
    Utilities.masterDetailEdit();
  };

  self.itemsWizardNewRow = function () {
    self.calcTotalItemValue();
    Utilities.wizardChangeFooter();
  };

  self.openEvolutionPopup = function () {
    var widget = templateManager.container.getWidget("evoloport");

    ScreenService.openSwipe(widget);
    Utilities.masterDetailClosePopup();

    /* var widget = templateManager.container.getWidget('oportunidadegrid');

       Utilities.masterDetailOpenPopup('evoloport');

       var popup = templateManager.container.getActiveWidget();
       popup.currentRow = widget.currentRow;*/
  };

  self.oportNewRow = function (widget) {
    /*Evitando Bug depois de aplicar layout(Insere um field bugado no array d fields da widget)
          modificado no dia 05/10/17 por Arthur Herbert*/
    widget.fields.forEach(function (field, index, fields) {
      if (!field.value) {
        fields.splice(index, 1);
      }
    });
    /*Fim*/

    General.widgetNewRow(widget);

    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    widget.currentRow.CDFILIAL = "";
    widget.currentRow.NRSEQFASENEGO = "";
    widget.currentRow.NRORG = loggedOperatorInfos.NRORG;
    widget.currentRow.NMPARCRESP = loggedOperatorInfos.NMOPERADOR;
    widget.currentRow.CDOPERCONT = loggedOperatorInfos.CDOPERADOR;
    widget.currentRow.NRPARCRESP = loggedOperatorInfos.NRPARCNEGOCIO;
    widget.currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;

    this.setClosingDataGroupLockByNegotiationPhase(widget);
    this.setOpportunityValueObligatorinessByNegotiationPhase(widget);
    this.habilitaFechamento(widget);
  };

  self.removeOportFilters = function () {
    var popup = templateManager.container.getWidget("oportfilter");

    popup.currentRow = {};
    popup.reload();
  };

  self.saveOport = function (widgetName) {
    var widget = templateManager.container.getWidget(widgetName);
    var nrParcNegocio = widget.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              if (widget.isValid() && widget.currentRow.IDTPOPORT) {
                widgetAtiva = widget;
                widget.currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
                widget.currentRow.changed = true;

                Utilities.unMask("VROPORT");
                Utilities.unMask("VRPREVOPORT");
                this.goBackActions(widget);

                return General.widgetSave(widget)
                  .then(
                    function (response) {
                      if (response.dataset.DADOS && response.dataset.DADOS.NRSEQOPORT) {
                        widget.currentRow.NRSEQOPORT = response.dataset.DADOS.NRSEQOPORT;
                        widget.currentRow.NRCONTATO = response.dataset.DADOS.NRCONTATO;
                        widget.currentRow.NRSEQCONTATO = response.dataset.DADOS.NRSEQCONTATO;
                        widget.currentRow.DTINCLUSAO = response.dataset.DADOS.DTINCLUSAO;

                        widget.reload();
                        
                        var enviarEmail = function () {
                          if (response.dataset.DADOS.ENVIAEMAIL != false) {
                            ScreenService.confirmMessage(
                              "Deseja enviar um e-mail para o operador responsável da Oportunidade?",
                              "QUESTION",
                              function (yes) {
                                widget.currentRow.OPERADOREMAIL = response.dataset.DADOS.ENVIAEMAIL;      
                                var params = {
                                  requestType: "Row",
                                  row: widget.currentRow,
                                };

                                restEngine
                                  .post("/enviaEmailOportunidade", params)
                                  .then(
                                    function () {
                                      ScreenService.notificationMessage(
                                        "E-mail enviado com sucesso!! Número da Oportunidade: " +
                                        parseInt(response.dataset.DADOS.NRSEQOPORT),
                                        "success"
                                      );
                                    }
                                  )
                                  .catch(
                                    function (error) {
                                      if (error.data.error) {
                                        ScreenService.notificationMessage(
                                          "O e-mail não pode ser enviado pois as configurações de SMTP estão desconfiguradas ou erradas!",
                                          "error"
                                        );
                                      } else {
                                        ScreenService.notificationMessage(
                                          error.data.error,
                                          "error"
                                        );
                                      }
                                    }
                                  );
                              }.bind(this)
                            ).then(
                              function () {
                                this.continueIntegration(widget);
                              }.bind(this)
                            );
                          } else {
                            ScreenService.showMessage(
                              "Número da Oportunidade: " + parseInt(response.dataset.DADOS.NRSEQOPORT)
                            );
                            this.continueIntegration(widget);
                          }
                        }.bind(this);
                        
                        if (response.dataset.DADOS.IDATIVOPARCEIRO == 'N') {
                          ScreenService.confirmMessage(
                            "Parceiro inativo. Deseja reativar?",
                            "QUESTION",
                            function (yes) {
                              restEngine
                                .post("/reativaParceiro", {
                                  "PARCEIRO":nrParcNegocio 
                                })
                                .then(
                                  function () {
                                    ScreenService.notificationMessage(
                                      "Parceiro reativado com sucesso!",
                                      "success"
                                    );
                                  }
                                )
                                .catch(
                                  function (error) {
                                    if (error.data.error) {
                                      ScreenService.notificationMessage(
                                        "Parceiro não pode ser reativado. Consulte o administrador para mais informações!",
                                        "error"
                                      );
                                    } else {
                                      ScreenService.notificationMessage(
                                        error.data.error,
                                        "error"
                                      );
                                    }
                                  }
                                );
                                enviarEmail();
                            }.bind(this),
                            function (no) {
                              enviarEmail();
                            }.bind(this)
                          );
                        } else {
                          debugger;
                          enviarEmail();
                        }

                      } else if (response.dataset.DADOS && response.dataset.DADOS.DTULTATU) {
                        widget.currentRow.DTULTATU = response.dataset.DADOS.DTULTATU;
                      }
                    }.bind(this)
                  )
                  .catch(
                    function (error) {
                      ScreenService.showMessage(
                        Messages.CATCH_EXCEPTION_ERROR(error)
                      );
                    }
                  );
              }
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    }.bind(this));
  };

  self.saveTask = function (widgetName) {
    var widget = templateManager.container.getWidget(widgetName);
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              Operador_Repository.retornaOperadorLogado().then(
                function (operator) {
                  if (operator[0] === undefined || operator[0] === null) {
                    ScreenService.showMessage("Erro ao realizar a operação.");
                    return;
                  } else if (widget.isValid()) {
                    widget.currentRow.changed = true;
                    if (widget.currentRow.__is_new) {
                      widget.currentRow.NRORGINCLUSAO = operator[0].NRORG;
                      widget.currentRow.CDOPERINCLUSAO = operator[0].CDOPERADOR;
                      widget.currentRow.NRORGULTATU = null;
                      widget.currentRow.CDOPERULTATU = null;
                    } else {
                      widget.currentRow.NRORGULTATU = operator[0].NRORG;
                      widget.currentRow.CDOPERULTATU = operator[0].CDOPERADOR;
                    }

                    widget.currentRow.CDFILIAL = "";
                    widget.currentRow.NRSEQCLASSIFICATAREFA = widget.currentRow.NRSEQCLASSIFICATAREFA
                      ? widget.currentRow.NRSEQCLASSIFICATAREFA
                      : null;
                    widget.currentRow.TIPO = "OPORTUNIDADE";
                    widget.currentRow.NMPARCNEGOCIO = widget.getParent().currentRow.NMOPORT;
                    widget.currentRow.DESCRICAO =
                      "Referente a oportunidade " +
                      widget.currentRow.NMPARCNEGOCIO;
                    widget.currentRow.NMOPERREAL = widget.currentRow.NMOPERADOR;
                    widget.currentRow.OPERADORDOLOGADO = widget.getParent().currentRow.NMOPERINCLUSAO;
                    widget.currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
                    return widget.saveRow().then(function (response) {
                      widget.currentRow.changed = false;
                      widget.currentRow.__is_new = false;

                      if (Boolean(response.dataset.columnsToReturn.length)) {
                        widget.currentRow.NRSEQFILACONTA = response.dataset.DADOS[0].NRSEQFILACONTA;
                      }

                      if (widget.name == "posvenda") {
                        self.cleanWizard();
                        ScreenService.openWindow("oportunidade_de_negocio");
                      } else {
                        ScreenService.closeSwipe();
                        widget.reload();
                        widget.list();
                      }
                    });
                  }
                },
                function (error) {
                  ScreenService.showMessage("Erro ao realizar a operação.");
                }
              );
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    }.bind(this));
  };

  self.editTask = function (widget) {
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [
          currentRow,
        ]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              General.widgetEdit(widget);
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    }.bind(this));
  };

  self.deleteTask = function (widget) {
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [
          currentRow,
        ]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              General.deleteCrud(widget);
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    }.bind(this));
  };

  /**
   * Confirma o fechamento da oportunidade
   * antes de salvar a evolução em caso.
   *
   * @param {object} widget widget de evolução
   * ("evolucao").
   */
  this.confirmClosingOpportunityBeforeSaveEvolution = function (widget) {
    var currentRow = widget.currentRow;
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCOPORT;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [
          currentRow,
        ]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              if (widget.isValid()) {
                if (Boolean(currentRow.NRSEQRESULEVOLOPORT)) {
                  ScreenService.confirmMessage(
                    Messages.PERGUNTA_FECHAR_OPORTUNIDADE,
                    "CONFIRMATION",
                    function (success) {
                      widgetAtiva = widget;
                      this.saveEvolucao(widget);
                    }.bind(this)
                  );
                } else {
                  widgetAtiva = widget;
                  this.saveEvolucao(widget);
                }
              }
            } else {
              if (Boolean(currentRow.NRSEQRESULEVOLOPORT)) {
                ScreenService.confirmMessage(
                  Messages.PERGUNTA_FECHAR_OPORTUNIDADE,
                  "CONFIRMATION",
                  function (success) {
                    widgetAtiva = widget;
                    this.saveEvolucao(widget);
                  }.bind(this)
                );
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                  response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                  " - " +
                  response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                  "!"
                );
              }
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    }.bind(this));
  };

  /**
   * Organiza os campos para salvar a evolução
   * e verifica tarefa já aberta.
   *
   * @param {object} widget widget de evolução
   */
  self.saveEvolucao = function (widget) {
    var self = this; // Preserve the context

    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");

    if (Util.isEmptyOrBlank(currentRow.NRPARCNEGOCIO)) {
      currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCOPORT;
    }

    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    if (widget.getField("NMSEQRESULEVOL") && widget.name !== "WDGT_EVOLUCAO") {
      widget.getField("NMSEQRESULEVOL").readOnly = true;
    }

    if (widget.getField("DTPLANFILACONTA") && widget.name !== "WDGT_EVOLUCAO") {
      widget.getField("DTPLANFILACONTA").validations = {};
    }

    this.verificaTarefasAbertas(currentRow).then(
      function (response) {
        if (response.dataset.DADOS.TAREFAS) {
          var tarefas = response.dataset.DADOS.TAREFAS;
          var operadores = "";
          tarefas.forEach(function (tarefa) {
            operadores += "<br>" + tarefa;
          });

          ScreenService.confirmMessage(
            'Este parceiro possui tarefas "Em Aberto" para o(s) seguinte(s) operador(es) <br>' +
            operadores +
            "<br><br> Deseja continuar? ",
            "CONFIRMATION",
            function (success) {
              self.saveEvolutionAndInsertTask(
                widget,
                currentRow,
                loggedOperatorInfos
              ).then(function () {
                self.closeEvolSwipeAndReloadMainWid(widget);
              });
            }
          );
        } else {
          self.saveEvolutionAndInsertTask(
            widget,
            currentRow,
            loggedOperatorInfos
          ).then(function () {
            self.closeEvolSwipeAndReloadMainWid(widget);
          });
        }
      }.bind(self)
    );
  };

  this.closeEvolSwipeAndReloadMainWid = function (widget) {
    var mainWid = widget.parent.parent;

    ScreenService.closeSwipe().then(function () {
      ScreenService.closeSwipe();
      mainWid.activate();
      mainWid.reload();
    });
  };

  /**
   * Salva evolução e gera Tarefa
   *
   * @param {object} widget widget de evolução
   */
  this.saveEvolutionAndInsertTask = function (widget, currentRow, loggedOperatorInfos) {
    return this.insertEvolutionNewTask(widget).then(function (response) {
      if (response) {
        currentRow.NRSEQFILACONTA = response.dataset.DADOS.NRSEQFILACONTA;
      } else if (!currentRow.NRSEQFILACONTA) {
        currentRow.NRSEQFILACONTA = "";
      }
  
      currentRow.changed = true;
      if (currentRow.__is_new) {
        currentRow.NRORGINCLUSAO = loggedOperatorInfos.NRORG;
        currentRow.CDOPERINCLUSAO = loggedOperatorInfos.CDOPERADOR;
        currentRow.NRORGULTATU = null;
        currentRow.CDOPERULTATU = null;
      } else {
        currentRow.NRORGULTATU = loggedOperatorInfos.NRORG;
        currentRow.CDOPERULTATU = loggedOperatorInfos.CDOPERADOR;
      }
  
      currentRow.IDGERAFATURA = "NAO";
      currentRow.IDTPEVOLCONT = "P";
      currentRow.IDANEXOEVOLCONT = "N";
      currentRow.CDFILIAL = "";
  
      if (!currentRow.NRRELACIONAPARC) {
        currentRow.NRRELACIONAPARC = null;
      }
  
      var mainWid = templateManager.container.getWidget("oportunidadegrid");
      var estaFechada = false;
      if (
        Util.isEmptyOrBlank(mainWid) &&
        (widget.parent.parent.name == "CALENDARIO" ||
          widget.parent.parent.name == "LIST_COMPROMISSO")
      ) {
        return restEngine.post("product#/evolcont_crm_oportuni/buscarOportunidade", {
          requestType: "Row",
          row: widget.currentRow
        }).then(function (resp) {
          estaFechada = resp.dataset.DADOS.OPORTUNIDADE.SITUACAO === "F";
  
          // Reabre a evolução se ela estiver fechada e continua a salvar a evolução
          if (estaFechada) {
            return this.reabrirOportunidade(widget).then(
              function () {
                // Para garantir que não encerrará a oportunidade novamente.
                currentRow.NRSEQRESULEVOLOPORT = null;
              },
              function (err) {
                ScreenService.showMessage(err.error);
              }
            );
          } else {
            var finalizouOport = Boolean(currentRow.NRSEQRESULEVOLOPORT);
  
            // Se o operador escolheu finalizar a oportunidade
            if (finalizouOport) {
              var resposta = null;
              if (resp && resp.dataset.DADOS) {
                resposta = resp.dataset.DADOS.OPORTUNIDADE;
              }
              this.prepareToCloseOport(mainWid, widget, currentRow, resposta);
              return this.closeOport(widget).then(function () {
                if (!Util.isEmptyOrBlank(mainWid)) {
                  mainWid.currentRow.DTREALFECHA = currentRow.DTREALFECHA;
                  mainWid.currentRow.SITUACAO = "F";
                } else {
                  templateManager.container.getWidget("WDGT_NEW_COMMITMENT").currentRow.DTREALFECHA =
                    currentRow.DTREALFECHA;
                }
  
                // Guarda flag de oportunidade concluída para evitar sobreposição da mensagem de conclusão
                // e da mensagem de verificação de compromisso
                widget.OPORTCONCLUIDA = true;
              });
            }
          }
        }.bind(this));
      }
  
      return Promise.resolve();
    }.bind(this)).then(function () {
      return this.saveEvolutionAndReload(widget, currentRow, loggedOperatorInfos);
    }.bind(this));
  };

  this.prepareToCloseOport = function (mainWid, widget, currentRow, dados) {
    dados = dados || null;

    if (!Util.isEmptyOrBlank(mainWid)) {
      currentRow.NRSEQOPORT = mainWid.currentRow.NRSEQOPORT;
      currentRow.NRCONCORRENTE = currentRow.NRCONCORRENTE ? currentRow.NRCONCORRENTE : "";
      currentRow.DTREALFECHA = moment().format("DD/MM/YYYY HH:mm");
    } else if (!Util.isEmptyOrBlank(dados)) {
      currentRow.NRSEQOPORT = dados.NRSEQOPORT;
      currentRow.NRCONCORRENTE = currentRow.NRCONCORRENTE ? currentRow.NRCONCORRENTE : "";
      currentRow.DTREALFECHA = moment().format("DD/MM/YYYY HH:mm");
    }
  };

  this.saveEvolutionAndReload = function (widget, currentRow, loggedOperatorInfos) {
    var mainWid = widget.parent.parent;
  
    this.finishSavingEvolution(widget, currentRow, loggedOperatorInfos).then(function () {
      this.checkLoggedOperatorPermissionToChangeOpport(mainWid);
      mainWid.reload();
      widget.reload();
    }.bind(this));
  };

  this.finishSavingEvolution = function (widget, currentRow, loggedOperatorInfos) {
    var mainWid = widget.parent.parent;
    var is_new = widget.currentRow.__is_new;

    return General.widgetSave(widget).then(function (response) {
      if (response.dataset.DADOS) {
        widget.currentRow.NRSEQEVOLCONT =
          response.dataset.DADOS[0].NRSEQEVOLCONT;
      }

      return this.checkMail(widget).then(function () {
        this.cleanNextTaskFieldValues(widget);

        var fazerUpdate = false;
        var params = {
          requestType: "Row",
          row: {
            NRSEQOPORT: mainWid.currentRow.NRSEQOPORT,
          },
        };

        Utilities.unMask("VROPORT");
        Utilities.unMask("VRPREVOPORT");

        var nrtermoportuni = currentRow.NRTERMOPORTUNI;
        var nrseqfasenego = currentRow.NRSEQFASENEGO;
        var nrparcresp = currentRow.NRPARCRESP;
        var vroport = currentRow.VROPORT;
        var vrprevoport = currentRow.VRPREVOPORT;

        if (nrtermoportuni) {
          params.row.NRTERMOPORTUNI = nrtermoportuni;
          fazerUpdate = true;
        }
        if (nrseqfasenego) {
          params.row.NRSEQFASENEGO = nrseqfasenego;
          fazerUpdate = true;
        }
        if (nrparcresp) {
          params.row.NRPARCRESP = nrparcresp;
          fazerUpdate = true;
        }
        if (vroport) {
          params.row.VROPORT = vroport;
          fazerUpdate = true;
        }
        if (vrprevoport) {
          params.row.VRPREVOPORT = vrprevoport;
          fazerUpdate = true;
        }

        if (fazerUpdate) {
          var currRow = mainWid.currentRow;

          try {
            //atualiza oportunidade
            return restEngine.post(
              "product#/evolcont_crm_oportuni/atualizarOportunidade",
              params
            ).then(function () {
              if (nrseqfasenego) {
                currRow.NRSEQFASENEGO = nrseqfasenego;
                currRow.NMSEQFASENEGO = widget.currentRow.NMSEQFASENEGO;
              }

              if (nrparcresp) {
                currRow.NRPARCRESP = nrparcresp;
                currRow.NMPARCRESP = widget.currentRow.NMPARCRESP;
              }

              if (vroport) {
                currRow.VROPORT = vroport;
              }

              mainWid.reload();
            }).catch(function (error) {
              console.log(error);
              ScreenService.showMessage(error.data.error);
            });
          } catch (error) {
            console.log(error);
            ScreenService.showMessage(error.data.error);
          }
        }

        this.setTaskEndDate(widget);
        var widgetCompromisso = templateManager.container.getWidget(
          "compromissoOportunidade"
        );
        var widgetOportunidade = templateManager.container.getWidget(
          "oportunidadegrid"
        );
        //pula se for tab dinamica
        if (widget.name !== "WDGT_EVOLUCAO") {
          if (is_new == true) {
            if (widget.OPORTCONCLUIDA) {
              ScreenService.showMessage(Messages.OPORTUNIDADE_CONCLUIDA);
              this.verificaNovoCompromisso(widgetCompromisso, widgetOportunidade);
              delete widget.OPORTCONCLUIDA;
            } else {
              this.verificaNovoCompromisso(widgetCompromisso, widgetOportunidade);
            }
          }
        }
        if (widget.afterSave) {
          widget.afterSave.forEach(function (method) {
            eval(method);
          });
        }
      }.bind(this));
    }.bind(this)).catch(function (error) {
      if (error.indexOf("REQUIRE_INTERLOCUTOR") !== -1) {
        ScreenService.showMessage('Operação bloqueada! <br><br> Favor informar o interlocutor.');
        if (widget.OPORTCONCLUIDA === true) this.goBackActions(widget);
      } else {
        ScreenService.showMessage(error);
      }
    }.bind(this));
  };

  this.checkMail = function (widget) {
    var promise = ZHPromise.defer();
    if (
      !Util.isEmptyOrBlank(widget.currentRow.NRSEQINTERLOCUTOR) &&
      widget.currentRow.IDENVIAEMAIL === "S"
    ) {
      ScreenService.confirmMessage(
        "Deseja enviar um email para " + widget.currentRow.NMINTERLOCUTOR + "?",
        "QUESTION",
        function (yes) {
          evolutionTabController.openWidgetSendMail(widget).then(function () {
            promise.resolve();
          });
        },
        function (no) {
          promise.resolve();
        }
      );
    } else {
      promise.resolve();
    }
    return promise.promise;
  };

  /**
   * Verifica se já existem tarefas relacionadas
   * aquele parceiro
   *
   * @param {object} widget widget de evolução
   */
  this.verificaTarefasAbertas = function (currentRow) {
    var paramsRestEngine = {
      requestType: "Row",
      row: currentRow,
    };
    return restEngine.post("/verificaTarefas", paramsRestEngine);
  };

  self.insertEvolutionNewTask = function (widget) {
    var currentRow = widget.currentRow;
    currentRow.CDOPERINCLUSAO = templateManager.LOGGEDOPERATOR.CDOPERADOR;
    currentRow.NRSEQFILACONTA = null;
    currentRow.NRSEQCAMPANHA = null;
    currentRow.NRSEQINTERLOCUTOR = Util.isEmptyOrBlank(
      currentRow.NRSEQINTERLOCUTOR
    )
      ? null
      : currentRow.NRSEQINTERLOCUTOR;
    currentRow.DSEMAILTAREFA = null;
    currentRow.DSTELEFONETAREFA = null;
    currentRow.NRSEQCLASSIFICATAREFA = null;

    var deferred = ZHPromise.defer();

    if (currentRow.DTPLANFILACONTA && !currentRow.NEXTTASKBLOCKED) {
      if (Util.isEmptyOrBlank(currentRow.NRPARCNEGOCIO)) {
        currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCOPORT;
      }

      var params = {
        requestType: "Row",
        row: currentRow,
      };

      //insere tarefa
      return restEngine
        .post("/insertNextTaskCliente", params)
        .then()
        .catch(function (error) {
          ScreenService.showMessage(error.data.error);
        });
    } else {
      deferred.resolve();
    }
    return deferred;
  };

  self.evolucaoNewRow = function (encerramentoVisivel) {
    var widget = templateManager.container.getWidget("evolucao");
    var groupEncerramento = widget.fieldGroups.find(function (group) {
      return group.name === "FG_DADOS_FECHAMENTO";
    });

    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    var self = this; // Preserve the context

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              General.widgetNewRow(widget);

              widget.getField("NMSEQRESULEVOL").readOnly = false;
              widget.getField("NMSEQFASENEGO").readOnly = false;
              widget.getField("DTPLANFILACONTA").validations = {
                required: true,
              };
              widget.getField("NMSEQFASENEGO").validations = {
                required: true,
              };

              var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
              var currentRow = widget.currentRow;

              if (
                (widget.parent.parent.currentRow.SITUACAO === "P" ||
                  widget.parent.parent.currentRow.SITUACAO == "F") &&
                loggedOperatorInfos.CDOPERADOR ==
                widget.parent.parent.currentRow.CDOPERADORGEST
              ) {
                var gridEvolution = templateManager.container.getWidget(
                  "evolucao"
                );
                var newCurrentRow = Object.values(gridEvolution.dataSource.data);
                console.log(newCurrentRow);

                currentRow.DTHREVOLCONT = currentRow.DTHREVOLCONT
                  ? currentRow.DTHREVOLCONT
                  : moment(new Date()).format("DD/MM/YYYY HH:mm");
                currentRow.DTREALFECHA = CRM_Utilities.getDataHoraAtual();
                currentRow.NMOPERADOR =
                  widget.parent.parent.currentRow.NMPARCRESP;
                NMOPERADORREAL;
                currentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
                currentRow.CDOPERREAL =
                  widget.parent.parent.currentRow.CDOPERADOR;
                currentRow.NMOPERADORREAL =
                  widget.parent.parent.currentRow.NMPARCRESP;
                currentRow.NRCONTATO =
                  widget.parent.parent.currentRow.NRCONTATO;
                currentRow.NRSEQCONTATO =
                  widget.parent.parent.currentRow.NRSEQCONTATO;
                currentRow.NRORG = loggedOperatorInfos.NRORG;
                currentRow.NRSEQFASENEGO = newCurrentRow[1].NRSEQFASENEGO;
                currentRow.NMSEQFASENEGO = newCurrentRow[1].NMSEQFASENEGO;
                currentRow.NRSEQINTERLOCUTOR =
                  newCurrentRow[1].NRSEQINTERLOCUTOR;
                currentRow.NMINTERLOCUTOR =
                  newCurrentRow[1].NMINTERLOCUTOR;
                currentRow.NMTIPOCONT = newCurrentRow[1].NMTIPOCONT;
                currentRow.CDTIPOCONT = newCurrentRow[1].CDTIPOCONT;
                currentRow.CDMOTIEVOCON =
                  newCurrentRow[1].CDMOTIEVOCON;
                currentRow.NMMOTIEVOCON =
                  newCurrentRow[1].NMMOTIEVOCON;
                currentRow.DESCRESULEVOL =
                  newCurrentRow[1].DESCRESULEVOL;
                currentRow.NMSEQRESULEVOL =
                  newCurrentRow[1].NMSEQRESULEVOL;
                currentRow.NRSEQRESULEVOL =
                  newCurrentRow[1].NRSEQRESULEVOL;
                currentRow.NRTERMOPORTUNI =
                  widget.parent.parent.currentRow.NRTERMOPORTUNI;
                currentRow.NMTERMOPORTUNI =
                  widget.parent.parent.currentRow.NMTERMOPORTUNI;
              } else {
                currentRow.DTHREVOLCONT = currentRow.DTHREVOLCONT
                  ? currentRow.DTHREVOLCONT
                  : moment(new Date()).format("DD/MM/YYYY HH:mm");
                currentRow.DTREALFECHA = CRM_Utilities.getDataHoraAtual();
                currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
                currentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
                currentRow.CDOPERREAL =
                  widget.parent.parent.currentRow.CDOPERADOR;
                currentRow.NMOPERADORREAL =
                  widget.parent.parent.currentRow.NMPARCRESP;
                currentRow.NRCONTATO =
                  widget.parent.parent.currentRow.NRCONTATO;
                currentRow.NRSEQCONTATO =
                  widget.parent.parent.currentRow.NRSEQCONTATO;
                currentRow.NRORG = loggedOperatorInfos.NRORG;
                currentRow.NRSEQFASENEGO =
                  widget.parent.parent.currentRow.NRSEQFASENEGO;
                currentRow.NMSEQFASENEGO =
                  widget.parent.parent.currentRow.NMSEQFASENEGO;
                currentRow.NRTERMOPORTUNI =
                  widget.parent.parent.currentRow.NRTERMOPORTUNI;
                currentRow.NMTERMOPORTUNI =
                  widget.parent.parent.currentRow.NMTERMOPORTUNI;
              }

              ABEvolucaoController.setEvolDateChangePermission(widget);
              self.unlockNextTask(widget); // Use 'self' to reference 'this'
              self.setNewTaskPermission(widget, true);
              self.setClosingDataGroupLockByNegotiationPhase(widget);
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }
        );
      } else {
        self.showMessageCantEditParc();
      }
    });
  };

  /**
   * Confirma se o usuário deseja criar um novo
   * compromisso relacionado aquela oportunidade.
   *
   */
  this.verificaNovoCompromisso = function (
    widgetCompromisso,
    widgetOportunidade
  ) {
    ScreenService.confirmMessage(
      "Deseja criar um novo compromisso para esta oportunidade? ",
      "CONFIRMATION",
      function (success) {
        this.abrirWidgetCompromisso(widgetCompromisso, widgetOportunidade);
      }.bind(this)
    );
  };

  this.abrirWidgetCompromisso = function (
    widgetCompromisso,
    widgetOportunidade
  ) {
    ScreenService.openSwipe(widgetCompromisso).then(function () {
      widgetCompromisso.newRow();
      widgetCompromisso.edit();
      widgetCompromisso.activate();

      widgetCompromisso.actions.forEach(function (comprimissoAction) {
        comprimissoAction.isVisible = true;
      });

      var compromissoRow = widgetCompromisso.currentRow;

      compromissoRow.NMPRINCIPALPARC =
        widgetOportunidade.currentRow.NMPRINCIPALPARC;
      compromissoRow.NRPARCNEGOCIO = widgetOportunidade.currentRow.NRPARCOPORT;
      compromissoRow.DSPLANOCUPA =
        "Número da Oportunidade: " +
        parseInt(widgetOportunidade.currentRow.NRSEQOPORT);
      widgetCompromisso.descriptionOrder =
        "Compromisso relacionado à Oportunidade: " +
        parseInt(widgetOportunidade.currentRow.NRSEQOPORT);
      compromissoRow.TIPO = "OPORTUNIDADE";
      compromissoRow.NRSEQCONTATO = widgetOportunidade.currentRow.NRSEQCONTATO;
      compromissoRow.NMOPORT = widgetOportunidade.currentRow.NMOPORT;
      compromissoRow.FIELDOPORTUNI = widgetOportunidade.currentRow.NMOPORT;
      compromissoRow.CDOPERADOR = widgetOportunidade.currentRow.CDOPERADOR;
      compromissoRow.NMOPERADORESPONS =
        widgetOportunidade.currentRow.NMPARCRESP;
      compromissoRow.NMOPERADOR = widgetOportunidade.currentRow.NMPARCRESP;
      compromissoRow.CDOPERADORESPONS =
        widgetOportunidade.currentRow.CDOPERADOR;

      widgetCompromisso.redraw();
    });
  };

  this.cancelarCompromisso = function (widget) {
    var widgetOportunidade = templateManager.container.getWidget(
      "oportunidadegrid"
    );
    ScreenService.closeSwipe().then(function () {
      widgetOportunidade.activate();
    });
  };

  /**
   * Salva o novo compromisso
   */
  this.salvarCompromisso = function (widget) {
    var compromissoController = CRM_Utilities.getController(
      "crm30000000_Compromisso_Controller"
    );

    var parentWidget = widget.getParent();

    if (widget.isValid()) {
      this.setCommitmentDateInCurrentRow(widget);
      var currentRow = widget.currentRow;
      var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
      var widgetOportunidade = templateManager.container.getWidget(
        "oportunidadegrid"
      );

      currentRow.NRORG = loggedOperatorInfos.NRORG;
      currentRow.DTINIPLANOCUPA = currentRow.DTINI;
      currentRow.DTFINPLANOCUPA = currentRow.DTFIM;
      currentRow.NRRELACIONAPARC = "";
      currentRow.CDFILIAL = "";
      currentRow.NRCONTATO = currentRow.NRCONTATO
        ? currentRow.NRCONTATO
        : currentRow.NRSEQCONTATO;
      currentRow.CDINTEPLANOCUPA = "";

      currentRow.DEFINEEVENTOGOOGLE = currentRow.__is_new ? true : false;

      CRM_Utilities.setColumnToReturnInCurrentRow(
        widget.currentRow,
        "NRSEQPLANOCUPA"
      );

      var saveParams = {
        requestType: "DataSet",
        dataset: [currentRow],
      };

      restEngine
        .post(widget.dataSource.name + "/save", saveParams)
        .then(function (response) {
          ScreenService.closeSwipe().then(function () {
            templateManager.container.getWidget("oportunidadegrid").activate();
          });

          currentRow.NRSEQPLANOCUPA =
            response.dataset.columnsToReturn.NRSEQPLANOCUPA;

          ScreenService.confirmMessage(
            Messages.SINC_GOOGLE_CALENDAR,
            "question",
            function (success) {
              if (currentRow.DEFINEEVENTOGOOGLE) {
                compromissoController.addEventToLoggedUserGoogleCalendarWithoutQuest(
                  currentRow
                );
              } else {
                compromissoController.editGoogleEvent(currentRow);
              }
            },
            function (error) {
              ScreenService.showMessage("Compromisso criado com sucesso!");
            }
          );
        });
    }
  };

  self.wizardFirstStep = function () {
    var promises = [self.saveOport("oportunidade_de_negocio_wizard")];

    ZHPromise.all(promises).then(function () {
      var widget =
        templateManager.containers["wizard/oportunidade/wzoportstageoport"]
          .widgets[0];

      if (widget.isValid() && widget.currentRow.IDTPOPORT)
        self.initItemsWizard();
    });
  };

  this.abrirWidgetTarefa = function () {
    var self = this; // Preserve the context

    var widget = templateManager.container.getActiveWidget();
    var nrParcNegocio = widget.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              self.fecharPopupDeActions().then(
                function () {
                  var widget = templateManager.container.getWidget("posvendagrid");
                  widget.activate();
                  setTimeout(function () {
                    self.taskScheduleNewRow(widget);
                  }, 100);
                }.bind(self)
              );
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(self)
        );
      } else {
        self.showMessageCantEditParc();
      }
    });
  };

  this.abrirWidgetEvolucao = function (encerramentoVisivel) {
    var widget = templateManager.container.getWidget("evolucao");
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCOPORT;
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
    var self = this; // Save a reference to 'this' for use inside the inner functions

    if (
      (widget.parent.parent.currentRow.SITUACAO == "P" ||
        widget.parent.parent.currentRow.SITUACAO == "F") &&
      loggedOperatorInfos.NRHIERARQUIAOPER != widget.parent.parent.currentRow.NRHIERARQUIARESP
    ) {
      ScreenService.showMessage(
        "Essa Oportunidade encontra-se Pendente, gentileza procurar o gestor responsável!"
      );
    } else {
      this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
        if (canEdit) {
          self.fecharPopupDeActions().then(
            function () {
              widget.activate();
              setTimeout(function () {
                self.evolucaoNewRow(encerramentoVisivel);
              }, 100);
            }.bind(self) // Use .bind(self) to set the correct value of 'this'
          ).catch(function (error) {
            console.error("Error closing popup:", error);
          });
        } else {
          self.showMessageCantEditParc();
        }
      }.bind(self)); // Use .bind(self) to set the correct value of 'this'
    }
  };

  this.fecharPopupDeActions = function () {
    var deferred = ZHPromise.defer();
    ScreenService.closePopup();
    deferred.resolve();
    return deferred;
  };

  this.setResultFieldFilter = function (field) {
    var fieldFilter = field.dataSourceFilter;
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    var nrorgFilterIndex = CRM_Utilities.getFilterPosition(
      fieldFilter,
      "P_NRORG"
    );
    var operatorCodeFilterIndex = CRM_Utilities.getFilterPosition(
      fieldFilter,
      "P_CDOPERADOR"
    );

    fieldFilter[nrorgFilterIndex].value = loggedOperatorInfos.NRORG;
    fieldFilter[operatorCodeFilterIndex].value = loggedOperatorInfos.CDOPERADOR;
  };

  /**
   * Função para possibilitar o cadastro de
   * uma evolução referente a tarefa em caso,
   * indicando a conclusão da tarefa.
   *
   * @param {object} widget widget ativa, no modo
   * view, referente a tarefa em caso.
   */
  this.completeTask = function (widget) {
    var self = this; // Preserve the context
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCOPORT;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        var currentRow = widget.currentRow;

        if (!currentRow.DTREALFILACONTA) {
          var evolutionWidget = templateManager.container.getWidget("evolucao");

          evolutionWidget.COMPLETETASK = true;
          evolutionWidget.NRORG = currentRow.NRORG;
          evolutionWidget.NRSEQFILACONTA = currentRow.NRSEQFILACONTA;
          ScreenService.closeSwipe().then(
            function () {
              self.activateWidget(evolutionWidget).then(
                function () {
                  setTimeout(
                    function () {
                      self.evolucaoNewRow();
                    },
                    500
                  );
                }
              );
            }
          );
        } else {
          ScreenService.showMessage(Messages.TAREFA_JA_CONCLUIDA);
        }
      } else {
        self.showMessageCantEditParc();
      }
    });
  };

  /**
   * Função para ativar uma widget
   *
   * @param {object} widget widget que será
   * ativada.
   *
   * @return {object} deferred 'promise' indicando
   * a conclusão da tarefa da função.
   */
  this.activateWidget = function (widget) {
    var deferred = ZHPromise.defer();

    widget.activate();
    deferred.resolve();

    return deferred;
  };

  /**
   * Função para pegar as informações da tarefa
   * na widget de evolução e setar a data de
   * conclusão da tarefa no registro da própria
   * tarefa.
   *
   * @param {object} widget widget ativa que contém
   * as informações da tarefa que será concluida.
   */
  this.setTaskEndDate = function (widget) {
    var currentRow = widget.currentRow;

    if (widget.COMPLETETASK) {
      var paramsRestEngine = {
        requestType: "Row",
        row: currentRow,
      };

      currentRow.NRSEQFILACONTA = widget.NRSEQFILACONTA;
      currentRow.NRORG = widget.NRORG;

      return restEngine.post(
        "/setTaskEndDate/oportunidadeDeNegocio",
        paramsRestEngine,
        function (success) {
          ScreenService.showMessage(Messages.TAREFA_CONCLUIDA);
          this.deleteTaskInfosInEvolutionWidget(widget);
          this.activateTaskWidget();
        }.bind(this),
        undefined,
        function (error) { },
        undefined,
        undefined
      );
    }
  };

  /**
   * Função para ativar a widget de agenda
   * de tarefas.
   */
  this.activateTaskWidget = function () {
    var taskWidget = templateManager.container.getWidget("posvendagrid");

    taskWidget.activate();
  };

  /**
   * Função para deletar as informações da
   * tarefa a ser concluída da widget de evolução.
   *
   * @param {object} widget widget de evolução.
   */
  this.deleteTaskInfosInEvolutionWidget = function (widget) {
    delete widget.COMPLETETASK;
    delete widget.NRSEQFILACONTA;
    delete widget.NRORG;
  };

  /**
   * Função para definir os valores iniciais
   * de uma tarefa.
   *
   * @param {object} widget widget ativa, que terá
   * sua currentRow modificada com os valores da nova
   * tarefa.
   */
  self.taskScheduleNewRow = function (widget) {
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;
  
    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [
          currentRow,
        ]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              General.widgetNewRow(widget);
  
              currentRow = widget.currentRow;
              var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
  
              currentRow.DTPLANFILACONTA = widget.currentRow.DTPLANFILACONTA
                ? widget.currentRow.DTPLANFILACONTA
                : moment(new Date()).format("DD/MM/YYYY HH:mm");
              currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
              currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
              currentRow.NRPARCNEGOCIO =
                widget.parent.parent.currentRow.NRPARCOPORT;
              currentRow.NRCONTATO = widget.parent.parent.currentRow.NRCONTATO;
              currentRow.NRSEQCONTATO =
                widget.parent.parent.currentRow.NRSEQCONTATO;
              currentRow.NMPRINCIPALPARC = "";
              currentRow.DSEMAILTAREFA = "";
              currentRow.DSTELEFONETAREFA = "";
              currentRow.NRORG = loggedOperatorInfos.NRORG;
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    });
  };

  /**
   * Função para checar a permissão para gerar
   * uma nova tarefa a partir de uma nova evolução.
   *
   * @param {object} widget widget ativa, no modo
   * edit, onde está sendo cadastrado a evolução.
   */
  this.checkNewTaskPermissionByEvolutionResult = function (widget) {
    var currentRow = widget.currentRow;
    var dataProximaTarefa = widget.getField("DTPLANFILACONTA");
    var operadorField = widget.getField("NMOPERADORREAL");
    var assuntoTarefaField = widget.getField("DSFILACONTATO");
    var prioridadeField = widget.getField("NRPRIORFILACONT");

    if (
      !Boolean(currentRow.DESCRESULEVOL) &&
      currentRow.IDGERPROXATIV &&
      currentRow.IDGERPROXATIV === "S" &&
      !currentRow.NEXTTASKBLOCKED
    ) {
      this.setNewTaskPermission(widget, true);
      dataProximaTarefa.validations = {
        required: true,
      };
      operadorField.validations = {
        required: true,
      };
      assuntoTarefaField.validations = {
        required: true,
      };
      prioridadeField.validations = {
        required: true,
      };
    } else {
      this.setNewTaskPermission(widget, false);
      dataProximaTarefa.validations = {};
      operadorField.validations = {};
      assuntoTarefaField.validations = {};
      prioridadeField.validations = {};
    }
  };

  /**
   * Função para setar a permissão de criar uma nova
   * tarefa a partir do resultado da evolução.
   *
   * @param {object} widget widget ativa, no modo edit,
   * onde está sendo cadastrado a evolução.
   *
   * @param {boolean} isAllowed permissão booleana do
   * cadastro da tarefa.
   */
  this.setNewTaskPermission = function (widget, isAllowed) {
    if (isAllowed) {
      this.setTaskFieldLock(widget, false);

      widget.currentRow.DTPLANFILACONTA = "";
    } else {
      this.setTaskFieldLock(widget, true);
    }
  };

  /**
   * Função para definir o bloqueio dos campos
   * de agenda de tarefa na widget de evolução.
   *
   * @param {object} widget widget de evolução,
   * onde estão os campos para criar um nova
   * tarefa.
   *
   * @param {boolean} isLocked estado dos campos.
   */
  this.setTaskFieldLock = function (widget, isLocked) {
    var nextTaskDate = widget.getField("DTPLANFILACONTA");
    var taskOperator = widget.getField("NMOPERADORREAL");
    var taskDescription = widget.getField("DSFILACONTATO");
    var taskClassification = widget.getField("DSCLASSIFICATAREFA");
    var taskPriority = widget.getField("NRPRIORFILACONT");

    nextTaskDate.readOnly = isLocked;
    taskOperator.readOnly = isLocked;
    taskDescription.readOnly = isLocked;
    taskClassification.readOnly = isLocked;
    taskPriority.readOnly = isLocked;
  };

  /**
   * Função para resetar as informações
   * de criação de uma nova tarefa(a partir de uma
   * evolução).
   *
   * @param {object} widget widget de evolução, que terá
   * as informações resetadas.
   */
  this.resetNewTaskInfos = function (widget) {
    var currentRow = widget.currentRow;
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    currentRow.DTPLANFILACONTA = moment().format("DD/MM/YYYY");
    currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
    currentRow.NMOPERADORREAL = loggedOperatorInfos.NMOPERADOR;
    currentRow.NRPRIORFILACONT = 2;
  };

  /**
   * Função para abrir a widget de seleção
   * de arquivos.
   */
  this.openAnnexSwipe = function () {
    var fileUploadWidget = templateManager.container.getWidget(
      "WDGT_SELECAO_ARQUIVOS"
    );

    fileUploadWidget.isVisible = true;
    ScreenService.openSwipe(fileUploadWidget);
  };

  /**
   * Função para salvar os anexos selecionados
   * ao caso em questão.
   *
   * @param {object} widget widget onde é
   * feito a seleção dos anexos.
   */
  this.uploadEvolutionFiles = function (widget) {
    var attachedStatus = templateManager.container.getWidget("evolucao");
    var files = widget.currentRow.DSCAMINHO;

    var rows = [];

    files.forEach(
      function (file, fileIndex) {
        rows.push(this.setValuesForFileUpload(widget, fileIndex));
      }.bind(this)
    );

    General.callRestEngine(
      "product#/crm_anexocontato/save",
      "DataSet",
      rows
    ).then(
      function () {
        this.closeAnnexSwipe(widget);
        widget.parent.parent.reload();
        attachedStatus.reload();
      }.bind(this)
    );
  };

  /**
   * Função para retornar uma row configurada
   * com as informações do anexo referente
   * ao ID, recebido como parâmetro, no array
   * de anexos na currentRow.
   *
   * @param {object} widget widget onde foi selecionado
   * os anexos.Array
   *
   * @param {int} fileIndex index do anexo no array de
   * anexos presente na currentRow.
   *
   * @return {object} currentRow row configurada com as informações
   * do anexo referente ao ID recebido.
   */
  this.setValuesForFileUpload = function (widget, fileIndex) {
    var currentRow = angular.copy(widget.currentRow);
    var evolutionWidget = widget.parent.parent;
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    currentRow.NRSEQCONTATO = evolutionWidget.getParent().currentRow.NRSEQCONTATO;
    currentRow.NMARQUIVO = this.getFileNameWithoutExtension(
      currentRow.DSCAMINHO[fileIndex].name
    );
    currentRow.DSTIPO = this.getFileExtension(
      currentRow.DSCAMINHO[fileIndex].name
    );
    currentRow.VRTAMANHO = currentRow.DSCAMINHO[fileIndex].size;
    currentRow.IDATIVO = "S";
    currentRow.NRORG = loggedOperatorInfos.NRORG;
    currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
    currentRow.IDORIGEM = "EVOLUCAO";
    currentRow.NRORIGEM = evolutionWidget.getParent().currentRow.NRSEQEVOLCONT;

    return currentRow;
  };

  /**
   * Função para retornar a extenção de um arquivo
   * extraida do seu nome.
   *
   * @param {string} fileName nome completo do arquivo.
   */
  this.getFileExtension = function (fileName) {
    return fileName.replace(/^(.*)\.(.*)$/, "$2");
  };

  /**
   * Função para retornar o nome do arquivo sem
   * sua extenção.
   *
   * @param {string} fileName nome completo do arquivo.
   */
  this.getFileNameWithoutExtension = function (fileName) {
    return fileName.replace(/^(.*)\.(.*)$/, "$1");
  };

  /**
   * Função para fechar o swipe de upload de imagens.
   *
   * @param {object} widget widget de upload de imagens.
   */
  this.closeAnnexSwipe = function (widget) {
    ScreenService.closeSwipe().then(function () {
      widget.isVisible = false;
      widget.parent.parent.list();
      widget.parent.parent.activate();
    });
  };

  /**
   * Função para fazer o download de uma arquivo
   * salvo no servidor.
   *
   * @param {object} widget widget que contém
   * as informações do arquivo a ser baixado
   * em sua currentRow.
   */
  this.downloadFile = function (widget) {
    window.open(window.fileServerBaseUrl + widget.currentRow.DSCAMINHO);
  };

  /**
   * Função para deletar uma tarefa,
   *
   * @param {object} widget widget ativa, no modo
   * de visualização, mostrando a tarefa a ser deletada.
   */
  this.deleteTask = function (widget) {
    General.deleteCrud(widget)
      .then(function () { })
      .catch(
        function () {
          ScreenService.confirmMessage(
            ScreenService.i18n(Messages.EXCLUSAO_TAREFA_VINC_EVOLUCAO),
            "question",

            function (success) {
              this.deactivateTask(widget).then(function () {
                ScreenService.showMessage(Messages.TAREFA_INATIVADA);

                ScreenService.closeSwipe().then(function () {
                  widget.reload();
                });
              });
            }.bind(this),
            function (error) { }
          );
        }.bind(this)
      );
  };

  /**
   * Função para desativar a tarefa em caso.
   *
   * @param {object} widget widget ativa, no modo
   * de visualização, com as informações da tarefa
   * a ser desativada.
   */
  this.deactivateTask = function (widget) {
    var currentRow = widget.currentRow;

    var paramsRestEngine = {
      requestType: "Row",
      row: currentRow,
    };

    return restEngine.post(
      "/deactivateLeadTask",
      paramsRestEngine,
      function (success) { },
      undefined,
      function (error) { },
      undefined,
      undefined
    );
  };

  this.concludeOportTask = function (widget) {

    var paramsRestEngine = {
      requestType: "Row",
      row: widget,
    };

    return restEngine.post("/concludeOportTask", paramsRestEngine);

  };

  this.setEvolution = function (widget) {
    var currentRow = widget;
  
    var params = {
      requestType: "Row",
      row: currentRow,
    };
  
    return restEngine.post("/setEvolution", params).then(function (response) {
      return response;
    }).catch(function (error) {
      ScreenService.showMessage(error.data.error, "error");
      console.log(error);
    });
  };

  /**
   * Função para editar uma evolução.
   *
   * @param {object} widget widget ativa, no
   * modo de visualização, com as informações
   * da evolução a ser editada.
   */
  this.editEvolution = function (widget) {
    var self = this; // Preserve the context
    var currentRow = widget.parent.parent.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = currentRow.NRPARCOPORT;

    this.checkIfCanEditOrEvolParc(currentRow.NRPARCNEGOCIO).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [
          currentRow,
        ]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              General.widgetEdit(widget);

              widget.getField("NMSEQRESULEVOL").readOnly = true;
              widget.getField("NMSEQFASENEGO").readOnly = true;
              widget.getField("DTPLANFILACONTA").validations = {};
              widget.getField("NMSEQFASENEGO").validations = {};

              ABEvolucaoController.setEvolDateChangePermission(widget);
              self.checkPermissionToCreateNewTaskInEvolutionEdition(widget); // Use the preserved context
              self.setClosingDataGroupLockByNegotiationPhase(widget);
              self.setOpportunityValueObligatorinessByNegotiationPhase(widget);
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(self)
        );
      } else {
        self.showMessageCantEditParc();
      }
    });
  };

  /**
   * Função para verificar a permissão para inserir
   * uma nova tarefa na edição da evolução em caso.
   *
   * @param {object} widget widget ativa, no modo de
   * edição, com as informações da evolução em edição.
   */
  this.checkPermissionToCreateNewTaskInEvolutionEdition = function (widget) {
    var currentRow = widget.currentRow;

    if (currentRow.DTPLANFILACONTA) {
      this.setTaskFieldLock(widget, true);

      currentRow.NEXTTASKBLOCKED = true;
    } else {
      this.unlockNextTask(widget);
      this.checkNewTaskPermissionByEvolutionResult(widget);
      this.resetNewTaskInfos(widget);
    }
  };

  /**
   * Função para liberar o cadastro de uma
   * nova tarefa a partir de um evolução,
   * excluindo o parâmetro de bloqueio.
   *
   * @param {object} widget widget de evolução.
   */
  this.unlockNextTask = function (widget) {
    if (widget.currentRow.NEXTTASKBLOCKED) {
      delete widget.currentRow.NEXTTASKBLOCKED;
    }
  };

  /**
   * Função para limpar os valores dos campos
   * para gerar uma nova tarefa através de uma
   * evolução.onmessage.
   *
   * @param {object} widget widget de evolução.
   */
  this.cleanNextTaskFieldValues = function (widget) {
    var currentRow = widget.currentRow;

    if (!currentRow.DTPLANFILACONTA) {
      currentRow.DTPLANFILACONTA = "";
      currentRow.DSFILACONTATO = "";
      currentRow.NMOPERADORREAL = "";
      currentRow.CDOPERREAL = "";
      currentRow.NRPRIORFILACONT = "";
    }
  };

  /**
   * Funão para editar uma oportunidade de negocio
   * e bloquear a edição do campo 'Fase de negocioação'.
   *
   * @param {object} widget widget de oportunidade, no modo
   * de edição.
   */
  this.editOppotunity = function (widget) {
    var self = this; // Preserve the context

    var nrParcNegocio = widget.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              if (widget.isValid()) {
                General.widgetEdit(widget);
                self.blockFieldsNotAllowedForOpportunityEditing(widget);
                self.setOpportunityValueObligatorinessByNegotiationPhase(widget);
                self.habilitaFechamento(widget);
              }
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(self)
        );
      } else {
        self.showMessageCantEditParc();
      }
    });
  };

  /**
   * Função para bloquear os campos que não podem ser editados
   * no ambiente de edição de uma oportundade.
   *
   * @param {object} widget widget de oportunidade que contém
   * os campos a serem bloqueados.
   */
  this.blockFieldsNotAllowedForOpportunityEditing = function (widget) {
    var fieldFase = widget.getField("NMSEQFASENEGO");
    if (!Util.isEmptyOrBlank(fieldFase.value())) fieldFase.readOnly = true;

    var fieldResp = widget.getField("NMPARCRESP");
    if (!Util.isEmptyOrBlank(fieldResp.value())) fieldResp.readOnly = true;

    var fieldParcNeg = widget.getField("NMPRINCIPALPARC");
    if (!Util.isEmptyOrBlank(fieldParcNeg.value()))
      fieldParcNeg.readOnly = true;
  };

  /**
   * Função para desbloquear os campos que não podem ser editados
   * no ambiente de edição de uma oportundade.
   *
   * @param {object} widget widget de oportunidade que contém
   * os campos a serem desbloqueados.
   */
  this.unlockFieldsNotAllowedForOpportunityEditing = function (widget) {
    widget.getField("NMSEQFASENEGO").readOnly = false;
    widget.getField("NMPARCRESP").readOnly = false;
    widget.getField("NMPRINCIPALPARC").readOnly = false;
  };

  this.setClosingDataGroupLockByNegotiationPhase = function (widget) {
    var resultField = widget.getField("DESCRESULEVOL");
    var competitorWinnerField = widget.getField("NMRAZSOCCONC");
    var dataFechamentoField = widget.getField("DTREALFECHA");
    var valueField = widget.getField("VROPORT");

    var currentRow = widget.currentRow;

    if (currentRow.IDPERMITEFECHA && currentRow.IDPERMITEFECHA === "S") {
      dataFechamentoField.value(CRM_Utilities.getDataHoraAtual());
      this.setRequiredValidationField(resultField, true);
      this.setRequiredValidationField(valueField, true);
    } else {
      this.setRequiredValidationField(resultField, false);
      this.setRequiredValidationField(valueField, false);
    }
  };

  this.blockField = function (field) {
    field.clearValue();
    field.readOnly = true;
  };

  this.unlockField = function (field) {
    field.readOnly = false;
  };

  this.setRequiredValidationField = function (field, required) {
    if (!field.validations) {
      field.validations = {};
    }

    if (required) {
      field.validations.required = true;
    } else {
      field.validations = {};
    }
  };

  /**
   * Verifica a permissão do operador logado para
   * trabalhar a oportunidade selecionada.
   *
   * @param {object} widget widget de oportunidade
   * ('oportunidadegrid');
   */
  this.checkLoggedOperatorPermissionToChangeOpport = function (widget) {
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    if (
      !Boolean(loggedOperatorInfos.IDOPERMASTERHIERARQCRM) ||
      loggedOperatorInfos.IDOPERMASTERHIERARQCRM === "N" ||
      !this.isChildOpport(widget)
    ) {
      if (Boolean(widget.currentRow.DTREALFECHA)) {
        this.hideCompletedOpportunitiesActions(widget);
      } else {
        this.checkOpportResponsibleOperator(widget);
      }
    }

    if (widget.name !== "CALENDARIO") {
      this.checkMostrarActionReabrir(widget);
    } else {
      var calendarWidget = templateManager.container.getWidget(
        "WDGT_NEW_COMMITMENT"
      );
      if (calendarWidget.currentRow.IDSTATPLANOCUPA == "P") {
        calendarWidget.getAction("UPDATE_STATUSPLAN_ACCEPT").isVisible = true;
        calendarWidget.getAction("UPDATE_STATUS_RECUSE").isVisible = true;
      } else if (calendarWidget.currentRow.IDSTATPLANOCUPA == "A") {
        calendarWidget.getAction("UPDATE_STATUSPLAN_ACCEPT").isVisible = false;
        calendarWidget.getAction("UPDATE_STATUS_RECUSE").isVisible = true;
      } else if (calendarWidget.currentRow.IDSTATPLANOCUPA == "R") {
        calendarWidget.getAction("UPDATE_STATUSPLAN_ACCEPT").isVisible = true;
        calendarWidget.getAction("UPDATE_STATUS_RECUSE").isVisible = false;
      }

      var actionEvolucao = calendarWidget.getAction("EVOLUIR");
      if (Util.isEmptyOrBlank(calendarWidget.currentRow.TIPO)) {
        actionEvolucao.isVisible = false;
      } else if (!Util.isEmptyOrBlank(calendarWidget.currentRow.NRSEQOPORT)) {
        actionEvolucao.label = "Evoluir Oportunidade";
        actionEvolucao.isVisible = true;
      } else {
        actionEvolucao.label = "Evoluir Parceiro";
        actionEvolucao.isVisible = true;
      }

      calendarWidget.getAction("BACK_FORMCOMMITMENT").isVisible = true;
      calendarWidget.getAction("SAVE_COMMITMENT").isVisible = true;
      calendarWidget.getAction("EDIT_COMMITMENT").isVisible = true;
      calendarWidget.getAction("DELETE_COMMITMENT").isVisible = true;

      widget.getAction("ADD_COMMITMENT").isVisible = true;
      var compromissoController = CRM_Utilities.getController(
        "crm30000000_Compromisso_Controller"
      );
      compromissoController.widgetAfterLoadDataSource(widget);
    }
  };

  /**
   * Procura o responsável da oportunidade na hierarquia
   * do operador logado.
   *
   * Serve para impedir que operadores master na hierarquia
   * consigam manipular oportunidades de qualquer um, e não
   * somente de quem está abaixo dele
   *
   * @param {object} widget widget de oportunidade
   * ('oportunidadegrid');
   */
  this.isChildOpport = function (widget) {
    var childs = templateManager.LOGGEDOPERATOR.NRPARCOPERSHIERARQINF;
    var resp = widget.currentRow.NRPARCRESP;

    if (childs.indexOf(resp) !== -1) return true;

    return false;
  };

  /**
   * Esconde as ações em uma oportunidade fechada.
   *
   * @param {object} widget widget de oportunidade
   * ('oportunidadegrid').
   */
  this.hideCompletedOpportunitiesActions = function (widget) {
    var activeWidget = templateManager.container.getActiveWidget();
    var containerActions = templateManager.container.actions;

    if (activeWidget.name !== "WDGT_EVOLUCAO") {
      containerActions.forEach(function (action) {
        if (
          action.label !== "Voltar" &&
          action.name !== "ACTION_MODAL_INFOS_PARCEIRO" &&
          action.name !== "BACK_EDIT" &&
          action.name !== "SAVE"
        ) {
          action.isVisible = false;
        }
      });
    }
  };

  /**
   * Verifica se o operador logado é um dos responsáveis
   * pela oportunidade selecionada.
   *
   * @param {object} widget widget de oportunidade
   * ('oportunidadegrid').
   */
  this.checkOpportResponsibleOperator = function (widget) {
    var containerActions = templateManager.container.actions;
    var operadorInclusao = widget.currentRow.CDOPERINCLUSAO;
    var operadorResponsavel = widget.currentRow.CDOPERADOR;
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
    var operadorLogado = loggedOperatorInfos.CDOPERADOR;
    var isOperadorMaster = loggedOperatorInfos.IDOPERMASTER == "S";

    // As actions de Adicionar, Editar e Evoluir são visíveis se o operador
    //logado *for o mesmo que incluiu* a oportunidade ou se ele for *master*
    var setActionsVisible =
      operadorLogado == operadorInclusao ||
      operadorLogado == operadorResponsavel ||
      isOperadorMaster;

    containerActions.forEach(function (action) {
      if (
        action.label === "Adicionar" ||
        action.label === "Editar" ||
        action.label == "Evoluir / Alterar Fase" ||
        action.label == "Criar Tarefa"
      ) {
        action.isVisible = setActionsVisible;
      }
    });
  };

  this.goBackActions = function (widget) {
    var containerActions = templateManager.container.actions;
    var attachedScreen = templateManager.container.getWidget(
      "WDGT_ANEXOS_EVOLUCAO"
    );
    if (attachedScreen) {
      var attachedStatus = templateManager.container.getWidget("evolucao");
      attachedStatus.reload();
    }
    containerActions.forEach(function (action) {
      if (!action.chartAction) action.isVisible = true;
    });
  };

  this.returnContainerDefaultAction = function (widget) {
    var containerActions = templateManager.container.actions;

    if (widget.currentRow.DTREALFECHA && widget.mode === "list") {
      containerActions.forEach(function (action) {
        if (!action.chartAction) action.isVisible = true;
      });
    }
  };

  this.setCurrentFilterValueInFilterPopUp = function (
    filterWidget,
    field,
    value
  ) {
    var filterCurrentRow = filterWidget.currentRow;

    filterCurrentRow[field] = value;
  };

  this.setItemFieldVisibilityBySelectedItem = function (widget) {
    this.setRequiredProdServ(widget);
  };

  this.setRequiredProdServ = function (widget) {
    var fieldProd = widget.getField("NMPRODUTO");
    var fieldServ = widget.getField("NMSERVORCA");
    if (
      Util.isEmptyOrBlank(
        fieldProd.value() || Util.isEmptyOrBlank(widget.currentRow.NRTPARVPROD)
      ) &&
      Util.isEmptyOrBlank(fieldServ.value())
    ) {
      this.setRequiredValidationField(fieldServ, true);
      this.setRequiredValidationField(fieldProd, true);
    } else if (Util.isEmptyOrBlank(fieldServ.value())) {
      this.setRequiredValidationField(fieldServ, false);
      this.setRequiredValidationField(fieldProd, true);
    } else {
      this.setRequiredValidationField(fieldServ, true);
      this.setRequiredValidationField(fieldProd, false);
    }
  };

  this.setFieldVisibilityOnForm = function (field, isVisible) {
    field.showOnForm = isVisible;
  };

  this.setFieldVisibilityOnView = function (field, isVisible) {
    field.showOnView = isVisible;
  };

  /**
   * Função para definir a obrigatoriedade do campo
   * 'valor da oportunidade' de acordo com a fase de
   * negociação em caso.
   *
   * @param {object} widget widget de oportunidade.
   */
  this.setOpportunityValueObligatorinessByNegotiationPhase = function (widget) {
    var currentRow = widget.currentRow;
    var valueOportField = widget.getField("VRPREVOPORT");
    var resultadoField = widget.getField("DESCRESULEVOL");
    var fechamentoField = widget.getField("DTREALFECHA");
    var concorrenteField = widget.getField("NMRAZSOCCONC");
    if (!concorrenteField) {
      concorrenteField = widget.getField("NMPARCCONC");
    }

    if (currentRow.IDEXIGEVROPORT === "S") {
      this.setRequiredValidationField(valueOportField, true);
    } else {
      this.setRequiredValidationField(valueOportField, false);
    }

    if (currentRow.IDPERMITEFECHA === "S") {
      this.setRequiredValidationField(resultadoField, true);
      this.setRequiredValidationField(fechamentoField, true);
    } else {
      this.setRequiredValidationField(resultadoField, false);
      this.setRequiredValidationField(fechamentoField, false);
    }
  };

  /**
   * Função para setar o filtro de intervalo de dias
   * desde a ultima evolução
   */
  this.setQuantityOfDaysLastEvolutionFilter = function (args) {
    var widgetGrid = args.owner;
    var currentRow = args.e.preference.FILTER_ROW;
    /*Variável para fazer o controle do dataSourceFilter*/
    var filters = [];
    widgetGrid.dataSourceFilter.forEach(function (filter, index) {
      if (
        !(
          filter.name === "DIAS_DESDE_EVOLUCAO" ||
          filter.name === "ULTEVOLDE" ||
          filter.name === "ULTEVOLATE"
        )
      ) {
        filters.push(filter);
      }
    });
    /*Monta filtro*/
    var filter = this.getOperatorForFilterBeginEnd(
      currentRow.ULTEVOLDE,
      currentRow.ULTEVOLATE,
      "DIAS_DESDE_EVOLUCAO"
    );
    widgetGrid.dataSourceFilter = filters;
    if (filter !== false) widgetGrid.dataSourceFilter.push(filter);
  };

  /**
   * Função para setar o filtro de intervalo de
   * quantidade de evoluções por oportunidade
   */
  this.setQuantityOfEvolutionsFilter = function (args) {
    var widgetGrid = args.owner;
    var currentRow = args.e.preference.FILTER_ROW;
    /*Variável para fazer o controle do dataSourceFilter*/
    var filters = [];
    widgetGrid.dataSourceFilter.forEach(function (filter, index) {
      if (
        !(
          filter.name === "QUANTIDADE_EVOLUCOES" ||
          filter.name === "QTEVOLDE" ||
          filter.name === "QTEVOLATE"
        )
      ) {
        filters.push(filter);
      }
    });
    /*Monta filtro*/
    var filter = this.getOperatorForFilterBeginEnd(
      currentRow.QTEVOLDE,
      currentRow.QTEVOLATE,
      "QUANTIDADE_EVOLUCOES"
    );
    widgetGrid.dataSourceFilter = filters;
    if (filter !== false) widgetGrid.dataSourceFilter.push(filter);
  };

  /**
   * Função para validar os campos de filtros de
   * intervalo
   *
   * @param {String} valor do campo 'De' dos fields
   * com filtro de intervalo
   *
   * @param {String} valor do campo 'Ate' dos fields
   * com filtro de intervalo
   */
  // this.validateQTEvolutions = function(args, fieldDe, fieldAte) {
  //     var quantDe = fieldDe.value();
  //     var quantAte = fieldAte.value();
  //     var fieldDeName = fieldDe.name;
  //     var fieldAteName = fieldAte.name;
  //     var widgetGrid = templateManager.container.getWidget('oportunidadegrid').__filterPopup;
  //     if ((quantDe !== "" && quantAte !== "") && parseInt(quantDe) > parseInt(quantAte)) {
  //         ScreenService.showMessage("Quantidade inicial deve ser menor que a final. (Preencha só um dos campos para setar maior/menor que)");
  //         widgetGrid.currentRow[fieldDeName] = "";
  //         widgetGrid.currentRow[fieldAteName] = "";
  //     }

  // };

  /**
   * Função para montar o filtro baseado no field
   * e em seus valores 'De' e 'Até'. O filtro pode
   * ser criado como BETWEEN, >= ou <=
   *
   * param{String} valor do field 'De'
   * param{String} valor do field 'Ate'
   *
   * return{Boolean} Boolean se os valores não forem
   * válidos ou se forem vazios
   * return{Object} Object contendo o filtro montado
   * (name/operator/value) se os valores forem válidos
   */
  this.getOperatorForFilterBeginEnd = function (minValue, maxValue, fieldName) {
    if (minValue !== "" || maxValue !== "") {
      var quantDe = minValue;
      var quantAte = maxValue;
      var filter = {};

      if (quantAte > quantDe && quantDe !== "") {
        filter.name = fieldName;
        filter.operator = "BETWEEN";
        filter.value = [quantDe, quantAte];
        return filter;
      } else if (quantAte > quantDe && quantDe === "") {
        filter.name = fieldName;
        filter.operator = "<=";
        filter.value = quantAte;
        return filter;
      } else if (quantDe > quantAte && quantAte === "") {
        filter.name = fieldName;
        filter.operator = ">=";
        filter.value = quantDe;
        return filter;
      }
      return false;
    }
    return false;
  };

  /**
   * Define o valor default do filtro do campo de operador
   * responsável.
   *
   * @param {object} widget widget principal da tela de oportunidade
   * ("oportunidadegrid").
   */
  this.setResponsibleOperatorFilterDefaultValueInFilterPopup = function (
    widget
  ) {
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
    var filterPopupCurrentRow = widget.__filterPopup.currentRow;

    filterPopupCurrentRow.NRPARCRESP = [loggedOperatorInfos.NRPARCNEGOCIO];
    filterPopupCurrentRow.NMPARCRESP = [loggedOperatorInfos.NMOPERADOR];
  };

  /**
   * Define as regras da tela de oportunidade
   * de acordo com a revenda do operador logado.
   *
   * @param {object} widget widget principal da tela
   * de oportunidade de negócio ('oportunidadegrid').
   */
  this.setResaleRules = function (widget) {
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    if (
      loggedOperatorInfos.IDTPOPERADOR === "R" &&
      Boolean(loggedOperatorInfos.NRREVENDA)
    ) {
      var restrictObjectsByResale = [];

      restrictObjectsByResale.push(widget);
      restrictObjectsByResale.push(widget.getField("NMPARCRESP"));

      restrictObjectsByResale.push(widget.getField("NMPRINCIPALPARC"));

      var evolutionWidget = templateManager.container.getWidget("evolucao");
      restrictObjectsByResale.push(evolutionWidget.getField("NMPARCRESP"));
      restrictObjectsByResale.push(evolutionWidget.getField("NMOPERADORREAL"));

      var tasksWidget = templateManager.container.getWidget("evolucao");
      restrictObjectsByResale.push(tasksWidget.getField("NMOPERADOR"));

      CRM_Utilities.setResaleRulesInRestrictObjectsByLoggedOperatorResale(
        restrictObjectsByResale
      );
    }
  };

  //Limpa o filtro no inicio(necessário pra funcionalidade do filtro padrão de operador)
  this.cleanFilter = function (args) {
    var filterRow = args.e.preference.FILTER_ROW;
    filterRow.NRPARCRESP = "";
  };

  //Filtra pelo operador logado quando não há outros filtros
  this.changeOperatorFilter = function (args) {
    var widget = args.owner;
    var filtros = widget.dataSourceFilter;

    if (filtros.length !== 3) {
      filtros.forEach(function (filter) {
        if (filter.name === "NRPARCRESP") {
          if (filter.default) {
            filter.operator = "IS_NOT_NULL";
            delete filter.value;
          }
        }
      });
    } else {
      filtros.forEach(function (filter) {
        if (filter.name === "NRPARCRESP") {
          if (filter.default) {
            filter.operator = "IN";
            filter.value = [templateManager.LOGGEDOPERATOR.NRPARCNEGOCIO];
          }
        }
      });
    }
  };

  this.termometroOnChange = function (widget) {
    var NRTERMOPORTUNI = widget.currentRow.NRTERMOPORTUNI;
    var fieldColor = widget.getField("DSCORTERMOMETRO");

    //Tira a cor do field color se não houver termômetro selecionado
    if (Util.isEmptyOrBlank(NRTERMOPORTUNI)) {
      fieldColor.clearValue();
      $(".inner-color").removeAttr("style");
      $(".color-field-view .zh-select-multiple").addClass("zh-field-value");
    }
  };

  /**
   * metodo chamado para cada td do GRID, percorre o HTML e colore
   * o field de termômetro.
   *
   * @param {object} row row do grid a ser percorrida.
   *        {array} elemento jquery representando cada td da row.
   */
  this.setColorOfRowBasedOnTermometro = function (row, element) {
    var color = row.DSCORTERMOMETRO;
    var fieldsHTML = $(element[0]);
    if (fieldsHTML.attr("data-zh-field-name") === "NMTERMOPORTUNI") {
      //style padrão de fields zeedhi
      var style = "width: 96px; margin-left: 0px; opacity: 1;";
      fieldsHTML.attr(
        "style",
        "color:" + color + "; font-weight:bold; " + style
      );
    }
  };

  this.preventLazyUser = function (widget) {
    var fieldFechamento = widget.getField("DTREALFECHA");
    if (!Util.isEmptyOrBlank(fieldFechamento.value())) {
      widget.currentRow.SITUACAO = "F";
    } else {
      widget.currentRow.SITUACAO = "A";
      widget.currentRow.DESCRESULEVOL = "";
      widget.currentRow.NMRAZSOCCONC = "";
    }
  };

  this.fixDateFilter = function (widget) {
    widget.dataSourceFilter.forEach(function (filter) {
      if (
        filter.name === "DINCLUSAO" ||
        filter.name === "DTREALFECHA" ||
        filter.name === "ULTIMA_EVOLUCAO"
      ) {
        if (Array.isArray(filter.value)) filter.value[1] += " 23:59";
      }
    });
  };

  this.habilitaFechamento = function (widget) {
    if (widget.currentRow.SITUACAO == "F") {
      widget.getField("DTREALFECHA").readOnly = false;
      widget.getField("DESCRESULEVOL").readOnly = false;
      widget.getField("NMRAZSOCCONC").readOnly = false;
    } else {
      widget.getField("DTREALFECHA").readOnly = true;
      widget.getField("DESCRESULEVOL").readOnly = true;
      widget.getField("NMRAZSOCCONC").readOnly = true;
    }
  };

  this.criarNovoConcorrente = function (widget) {
    var popupNovoConcorrente = templateManager.container.getWidget(
      "popupNovoConcorrente"
    );
    popupNovoConcorrente.newRow();

    popupNovoConcorrente.template = "widget/form.html";
    popupNovoConcorrente.activate();
    ScreenService.openPopup(popupNovoConcorrente);
  };

  this.prepararNovoConcorrente = function (widget) {
    CRM_Utilities.setColumnToReturnInCurrentRow(
      widget.currentRow,
      "NRCONCORRENTE"
    );
    widget.currentRow.DTULTATUBAIR = CRM_Utilities.getCurrentDate();

    widget.currentRow.NRORG = templateManager.LOGGEDOPERATOR.NRORG;
    widget.currentRow.FIELDONADD = true;
    this.salvarConcorrente(widget.currentRow).then(function (response) {
      var widgetConvert = templateManager.container.getWidget("evolucao");
      widgetConvert.currentRow.NRCONCORRENTE =
        response.dataset.columnsToReturn[0].NRCONCORRENTE;
      widgetConvert.currentRow.NMRAZSOCCONC = widget.currentRow.NMRAZSOCCONC;
      ScreenService.closePopup();
      ScreenService.closePopup();
      ScreenService.showMessage("Concorrente salvo com sucesso!");
    });
  };

  this.salvarConcorrente = function (currentRow) {
    var paramsRestEngine = {
      requestType: "Row",
      row: currentRow,
    };

    return restEngine.post("/crm_concorrente/save", paramsRestEngine);
  };

  this.checkParamSM = function (widget) {
    var idIntegracaoSM = CRM_Utilities.getCrmParametrization();

    if (idIntegracaoSM) idIntegracaoSM = idIntegracaoSM["IDINTEGRACAOSM"];

    var integracaoAction = widget.getAction("GERA_PROPOSTA");
    if (idIntegracaoSM === "S") {
      integracaoAction.isVisible = true;
    } else {
      integracaoAction.isVisible = false;
    }
  };

  this.abrirPopupProposta = function () {
    this.checkItems().then(function () {
      var wdgtProposta = templateManager.container.getWidget(
        "popupGeraProposta"
      );
      wdgtProposta.newRow();

      wdgtProposta.template = "widget/form.html";
      wdgtProposta.activate();
      ScreenService.openPopup(wdgtProposta);
    });
  };

  this.checkItems = function () {
    var promise = ZHPromise.defer();
    var wdgtOportunidade = templateManager.container.getWidget(
      "oportunidadegrid"
    );
    var wdgtItens = templateManager.container.getWidget("itensgrid");
    wdgtItens.dataSourceFilter = [
      {
        name: "NRSEQOPORT",
        operator: "=",
        value: wdgtOportunidade.currentRow.NRSEQOPORT,
      },
      {
        name: "NRORG",
        operator: "=",
        value: templateManager.LOGGEDOPERATOR.NRORG,
      },
    ];
    wdgtItens.reload().then(function () {
      var itens = wdgtItens.dataSource.data;
      itens = itens.map(function (item) {
        return {
          servico: item.CDSERVORCA,
          produto: item.CDPRODUTO,
          quantidade: item.QTITEMOPORT,
          medida: item.CDTPMEDIDASERV,
          quantidade_medida: item.QTITEMOPORT,
          valor_unitario: item.VRUNITITEMOPORT,
          tipo_ajuste:
            item.IDTPDESCITEMOPORT === "S" ? "N" : item.IDTPDESCITEMOPORT,
          ajuste: item.VRDESCITEMOPORT,
          valor_total: item.VRTOTITEMOPORT,
        };
      });
      wdgtItens.ITENSPROPOSTA = itens;
      if (!Util.isEmptyOrBlank(itens)) {
        promise.resolve();
      } else {
        ScreenService.confirmMessage(
          "Esta oportunidade não possui itens, deseja continuar com a criação da proposta?",
          "CONFIRMATION",
          function () {
            promise.resolve();
          },
          function () {
            promise.reject();
          }
        );
      }
    });

    return promise.promise;
  };

  this.prepararProposta = function (widget) {
    var wdgtOportunidade = templateManager.container.getWidget(
      "oportunidadegrid"
    );
    var wdgtItens = templateManager.container.getWidget("itensgrid");
    var wdgtEvolucao = templateManager.container.getWidget("evolucao");
    var interlocutor = null;
    this.initTab(wdgtEvolucao).then(function () {
      wdgtEvolucao.dataSource.data.forEach(function (evol) {
        if (
          !Util.isEmptyOrBlank(evol.NRSEQINTERLOCUTOR) &&
          interlocutor === null
        )
          interlocutor = evol.NRSEQINTERLOCUTOR;
      });
      var rowProposta = {
        requisitante: {
          operador: templateManager.LOGGEDOPERATOR.CDOPERADOR,
          nrorg: templateManager.LOGGEDOPERATOR.NRORG,
        },
        proposta: {
          modelo: widget.currentRow.NRORCAMENTOMODELO,
          escopos: widget.currentRow.NRTIPOORCAMENTO,
          parceiro_negocio: wdgtOportunidade.currentRow.NRPARCOPORT,
          operador_responsavel: wdgtOportunidade.currentRow.CDOPERADOR,
          interlocutor: interlocutor,
          nrseqcontato: wdgtOportunidade.currentRow.NRSEQCONTATO,
          nrseqoport: wdgtOportunidade.currentRow.NRSEQOPORT,
          itens: wdgtItens.ITENSPROPOSTA,
        },
      };
      var params = {
        requestType: "DataSet",
        dataset: [rowProposta],
      };

      restEngine
        .post("product#/IntegracaoSm/geraProposta", params)
        .then(function (response) {
          if (response.dataset.INTEGRACAO) {
            ScreenService.showMessage("Proposta Criada");
          } else {
            ScreenService.showMessage("Erro ao Criar Proposta");
          }
          ScreenService.closePopup();
        });
    });
  };

  this.mainWidgetOnEnter = function (widget, fieldsToApply) {
    
    this.setResaleRules(widget);
    //PartnerInfosModalController.setModalWidgetOnActiveWidget(widget, 'NRPARCOPORT');
    
    var filterRow = {};
    filterRow.NRPARCNEGOCIO = [templateManager.LOGGEDOPERATOR.NRPARCNEGOCIO];
    filterRow.NRPARCRESP = [templateManager.LOGGEDOPERATOR.NRPARCNEGOCIO];
    filterRow.NMPARCRESP = [templateManager.LOGGEDOPERATOR.NMOPERADOR];
    filterRow.IDOPERATIVO = 'A';

    fieldsToApply.push("NRPARCRESP");
    fieldsToApply.push("NMPARCRESP");
    fieldsToApply.push("NMOPORT");
    fieldsToApply.push("IDOPERATIVO");
    
    if (widget.fromDashboard !== true) {
      CRM_Utilities.openFilterOnEnter(widget, filterRow, fieldsToApply);
    } else {
      widget.fromDashboard = false;
      ZhFilterPreferences.setOriginalFilter(widget.id, filterRow);
    }
  };

  this.checkMostrarActionReabrir = function (widget) {
    var row = widget.currentRow;
    var actionReabrir = widget.getAction("REABRIR_OPORTUNI");

    //Se a oportunidade estiver fechada e o operador
    // for master, a action será visível.
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
    var isOperadorMaster =
      loggedOperatorInfos.IDOPERMASTER === "S" ||
      loggedOperatorInfos.NRPARCNEGOCIO == widget.currentRow.NRPARCRESP;
    var isFechada = row.SITUACAO === "F";

    if (!Util.isEmptyOrBlank(actionReabrir)) {
      actionReabrir.isVisible = isFechada && isOperadorMaster;
    }
  };

  this.evolucaoReabertura = function (widget) {
    this.abrirWidgetEvolucao(false);
  };

  this.reabrirOportunidade = function (widget) {
    var mainWid = widget.parent.parent;

    var params = {
      requestType: "Row",
      row: {
        nrorg: getLocalVar("CRM_NRORG"),
        nrseqoport: mainWid.currentRow.NRSEQOPORT,
        crm_nrorgtrab: getLocalVar("CRM_NRORGTRABALHO"),
      },
    };

    //Promise
    return restEngine
      .post("/crm_oportuni_oportunidadenegocio/reopen", params)
      .then(function () {
        var row = mainWid.currentRow;

        row.SITUACAO = "A";
        row.DTREALFECHA = null;
        row.NMRAZSOCCONC = null;
        widget.OPORTCONCLUIDA = false;
      });
  };

  this.visibilidadeTransferirResponsavel = function () {
    restEngine
      .post("product#/crud/crm_parametrizacao", {
        requestType: "FilterData",
        filter: [
          {
            operator: "=",
            name: "IDATIVO",
            value: "S",
          },
          {
            operator: "=",
            name: "NRORG",
            value: templateManager.LOGGEDOPERATOR.NRORG,
          },
        ],
      })
      .then(function (response) {
        paramCRM = response.dataset.crm_parametrizacao[0];
        var widget = templateManager.container.getWidget("oportunidadegrid");

        if (
          paramCRM["IDEVOLTRANSOPORT"] == "N" ||
          widget.getField("SITUACAO").value() == "F"
        ) {
          widget.getAction("transferir_responsavel_tarefa").isVisible = false;
        } else if (paramCRM["IDEVOLTRANSOPORT"] == "S") {
          widget.getAction("transferir_responsavel_tarefa").isVisible = true;
        }
      });
  };

  this.abrirPopupTransferirOportunidade = function (widget) {
    var nrParcNegocio = widget.currentRow.NRPARCOPORT;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [
          currentRow,
        ]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              var popTransfOportuni = templateManager.container.getWidget(
                "TRANSFERIROPORTUNIDADE"
              );
              popTransfOportuni.getField("NMOPERREAL").clearValue();
              ScreenService.openPopup(popTransfOportuni);
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    });
  };

  this.fecharPopupTransferirOportunidade = function (widget) {
    widget.isVisible = false;
    ScreenService.closePopup();
  };

  this.transferirOportunidade = function (widget) {
    var row = templateManager.container.getWidget("oportunidadegrid")
      .currentRow;
    restEngine.post(
      "/transferirOportunidade",
      {
        requestType: "Row",
        row: {
          ROW: row,
          OPERADOR: widget.currentRow.NRPARCNEGOCIO,
          NOVORESPONSAVEL: widget.currentRow.NMOPERREAL,
        },
      },
      function (response) {
        var wid = templateManager.container.getWidget("oportunidadegrid");
        ScreenService.showMessage("Oportunidade transferida com sucesso.");
        ScreenService.closePopup(true);
        ScreenService.closeSwipe();
        // wid.dataSource.filter();
        wid.reload();
        // widget.getParent().reload();
      },
      undefined,
      function (response) {
        ScreenService.showMessage(response);
      }
    );
  };

  this.criarNovoInterlocutor = function (widget) {
    var popupNovoInterlocutor = templateManager.container.getWidget(
      "popupNovoInterlocutor"
    );
    popupNovoInterlocutor.newRow();
    var filterPopup = popupNovoInterlocutor.currentRow;
    if (widget.name === "convertLeadInProspect") {
      filterPopup = templateManager.container.getWidget(
        "convertLeadInProspect"
      );
      popupNovoInterlocutor.currentRow.filtro = false;
      popupNovoInterlocutor.parentName = widget.name;
    } else if (widget.name === "filterPopup") {
      filterPopup = templateManager.container.getWidget("oportunidadegrid")
        .__filterPopup;
      popupNovoInterlocutor.currentRow.filtro = true;
    } else if (widget.name === "oportunidadegrid") {
      filterPopup = templateManager.container.getWidget("oportunidadegrid");
      popupNovoInterlocutor.currentRow.filtro = false;
      popupNovoInterlocutor.parentName = widget.name;
    } else if (widget.name === "posvendagrid") {
      filterPopup = templateManager.container.getWidget("posvendagrid");
      popupNovoInterlocutor.currentRow.filtro = false;
      popupNovoInterlocutor.parentName = widget.name;
    } else if (widget.name === "evolucao") {
      filterPopup = templateManager.container.getWidget("evolucao");
      popupNovoInterlocutor.currentRow.filtro = false;
      popupNovoInterlocutor.parentName = widget.name;
    }

    ScreenService.openPopup(popupNovoInterlocutor).then(function () {
      popupNovoInterlocutor.currentRow.NMINTERLOCUTOR =
        filterPopup.NMINTERLOCUTOR;
      popupNovoInterlocutor.currentRow.DTNASCIMENTO = filterPopup.DTNASCIMENTO;
      popupNovoInterlocutor.currentRow.IDRECEBEPRESENTE =
        filterPopup.IDRECEBEPRESENTE;
      popupNovoInterlocutor.currentRow.NMCARGOINTERLOC =
        filterPopup.NMCARGOINTERLOC;
      popupNovoInterlocutor.currentRow.EMAILINTERLOC =
        filterPopup.EMAILINTERLOC;
      popupNovoInterlocutor.currentRow.NRTELEFONE1 = filterPopup.NRTELEFONE1;
      popupNovoInterlocutor.currentRow.NRORG = getLocalVar("CRM_NRORG");
      popupNovoInterlocutor.reload();
    });
  };

  this.setInterlocutorWidgetDefaultValues = function (widget) {
    var wid = templateManager.container.getWidget("oportunidadegrid");

    wid.currentRow.NRPARCNEGOCIO;

    widget.currentRow.NRPARCNEGOCIO = wid.currentRow.NRPARCOPORT;
  };

  this.removeInterlocutorPhoneMask = function (widget) {
    var currentRow = widget.currentRow;
    var phoneFields = ["NRTELEFONE1"];

    phoneFields.forEach(function (phone) {
      if (currentRow[phone]) {
        currentRow[phone] = currentRow[phone].replace(/[^0-9]/g, "");
      }
    });
  };

  this.salvarInterlocutor = function (currentRow) {
    var paramsRestEngine = {
      requestType: "Row",
      row: currentRow,
    };
    return restEngine.post("/crm_interlocutor/save", paramsRestEngine);
  };

  this.prepararInterlocutor = function (widget) {
    var parent = templateManager.container.getWidget(widget.parentName);

    CRM_Utilities.setColumnToReturnInCurrentRow(
      widget.currentRow,
      "NRSEQINTERLOCUTOR"
    );
    this.removeInterlocutorPhoneMask(widget);
    widget.currentRow.NRCPFINTERLOC = widget.currentRow.NRCPFINTERLOC.replace(
      /[^0-9]/g,
      ""
    );
    this.salvarInterlocutor(widget.currentRow).then(function (
      response,
      widget
    ) {
      var currentRow = templateManager.container.getWidget(
        "popupNovoInterlocutor"
      );
      if (currentRow.filtro === true) {
        var widgetfilter = templateManager.container.getWidget(
          "popupNovoInterlocutor"
        ).__filterPopup;
        var widgetprospect = templateManager.container.getWidget(
          "oportunidadegrid"
        );
        var widgetConvertfilter = templateManager.container.getWidget(
          "evolucao"
        );
        widgetConvertfilter.currentRow.NMINTERLOCUTOR =
          widget.currentRow.NMINTERLOCUTOR;

        widgetfilter.template = "widget/form.html";
        widgetfilter.activate();
        widgetprospect.widgets[0].fields[7].defaultValue =
          widget.currentRow.NMINTERLOCUTOR;
        ScreenService.closePopup(true);
        ScreenService.showMessage("Interlocutor criado com sucesso!");
      } else {
        var widgetcurrent = templateManager.container.getWidget(
          "popupNovoInterlocutor"
        );
        var wid = templateManager.container.getWidget("oportunidadegrid");

        parent.currentRow.NRSEQINTERLOCUTOR =
          response.dataset.columnsToReturn[0].NRSEQINTERLOCUTOR;
        parent.currentRow.NMINTERLOCUTOR =
          widgetcurrent.currentRow.NMINTERLOCUTOR;
        parent.currentRow.EMAILINTERLOC =
          widgetcurrent.currentRow.EMAILINTERLOC;

        ScreenService.closePopup(true);

        ScreenService.showMessage("Interlocutor criado com sucesso!").then(
          function () {
            parent.activate();
            parent.reload();
          }
        );
      }
    });
  };

  this.evolucaoRowOnEnter = function (widget) {
    var prospectController = CRM_Utilities.getController(
      "ger45000_Prospect_Controller"
    );

    prospectController.setEditEvolButtonAction(
      widget,
      this.editEvolButtonDefaultCode,
      "EDITAR_EVOLUCAO"
    );
  };

  this.setCanEvolve = function () {
    var widget = templateManager.container.getWidget("oportunidadegrid");
    var evolWidget = templateManager.container.getActiveWidget();
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
  
    if (
      (widget.currentRow.SITUACAO == "P" || widget.currentRow.SITUACAO == "F") &&
      loggedOperatorInfos.CDOPERADOR != widget.currentRow.CDOPERADORGEST
    ) {
      evolWidget.actions.find(function (x) {
        return x.label == "Adicionar";
      }).isVisible = false;
      evolWidget.actions.find(function (x) {
        return x.label == "Editar";
      }).isVisible = false;
    } else if (
      (widget.currentRow.SITUACAO === "P" || widget.currentRow.SITUACAO == "F") &&
      loggedOperatorInfos.CDOPERADOR == widget.currentRow.CDOPERADORGEST
    ) {
      evolWidget.actions.find(function (x) {
        return x.label == "Adicionar";
      }).isVisible = false;
      evolWidget.actions.find(function (x) {
        return x.label == "Editar";
      }).isVisible = false;
    } else {
      evolWidget.actions.find(function (x) {
        return x.label == "Adicionar";
      }).isVisible = true;
      evolWidget.actions.find(function (x) {
        return x.label == "Editar";
      }).isVisible = true;
    }
  };

  this.changeValueFilterOportunity = function (widget) {

    var grid = widget;
    var filterAgenda = templateManager.container.getWidget("oportunidadegrid");
    var getFieldParcResp = filterAgenda.getField('NRPARCRESP');
    if (grid.currentRow.IDOPERATIVO == "I") {
      getFieldParcResp.dataSourceFilter[1].value = "I";
      grid.getField('NRPARCRESP').clearValue();
      getFieldParcResp.reload();
    } else {
      getFieldParcResp.dataSourceFilter[1].value = "A";
      getFieldParcResp.reload();
    }
  };

  this.setCanEdit = function () {
    var widget = templateManager.container.getWidget("oportunidadegrid");
    var taskWidget = templateManager.container.getWidget("posvendagrid");
    var itensWidget = templateManager.container.getWidget("itensgrid");
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
  
    if ((widget.currentRow.SITUACAO == "P" || widget.currentRow.SITUACAO == "F") && loggedOperatorInfos.CDOPERADOR != widget.currentRow.CDOPERADORGEST) {
      taskWidget.actions.find(function (x) { return x.label == "Adicionar"; }).isVisible = false;
      itensWidget.actions.find(function (x) { return x.label == "Adicionar"; }).isVisible = false;
      widget.actions.find(function (x) { return x.label == "Editar"; }).isVisible = false;
      widget.actions.find(function (x) { return x.label == "Aprovar"; }).isVisible = false;
      widget.actions.find(function (x) { return x.label == "Reprovar"; }).isVisible = false;
      widget.actions[7].isVisible = false;
      widget.actions[8].isVisible = false;
      widget.actions[9].isVisible = false;
    } else if ((widget.currentRow.SITUACAO === "P" || widget.currentRow.SITUACAO == "F") && loggedOperatorInfos.CDOPERADOR == widget.currentRow.CDOPERADORGEST) {
      widget.action.find(function (x) { return x.label == "Criar Tarefa"; }).isVisible = false;
      widget.actions.find(function (x) { return x.label == "Aprovar"; }).isVisible = true;
      widget.actions.find(function (x) { return x.label == "Reprovar"; }).isVisible = true;
      taskWidget.actions.find(function (x) { return x.label == "Adicionar"; }).isVisible = false;
    } else {
      widget.actions.find(function (x) { return x.label == "Editar"; }).isVisible = true;
      widget.actions.find(function (x) { return x.label == "Aprovar"; }).isVisible = false;
      widget.actions.find(function (x) { return x.label == "Reprovar"; }).isVisible = false;
    }
  };

  this.editEvolButtonDefaultCode = 'crm00002001_OportunidadeNegocio_Controller.editEvolution(args.owner.widget);';

  this.checkValidDate = function () {
    var widget = templateManager.container.getActiveWidget();
    var dataAbertura = widget.getField("DTHREVOLCONT");
    var data = dataAbertura.value().substring(0, 10);
    var dataAtual = new moment().format("DD/MM/YYYY");
    var variacao = moment(dataAtual, "DD/MM/YYYY").diff(
      moment(data, "DD/MM/YYYY"),
      "day"
    );
    if (variacao > paramCRM.NRDIASLANCEVOL) {
      ScreenService.showMessage(
        "Operação bloqueada!<br>Há um limite de " +
        paramCRM.NRDIASLANCEVOL +
        " dias para o lançamento retroativo de evoluções!"
      );
      widget.currentRow.DTHREVOLCONT = null;
    }
  };

  self.verifyNewEvolution = function () {
    var gridEvolucao = templateManager.container.getWidget("evolucao");
    var fieldGroups = gridEvolucao.fieldGroups;
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
    var fieldValueOpportunity = gridEvolucao.getField("VRPREVOPORT");
    var fieldResponsibleOperator = gridEvolucao.getField("NMPARCRESP");
    var fieldClosingDate = gridEvolucao.getField("DTREALFECHA");
  
    var indexGroupClosingData = CRM_Utilities.getFieldGroupPosition(fieldGroups, "FG_DADOS_FECHAMENTO");
    var indexGroupOpportunityData = CRM_Utilities.getFieldGroupPosition(fieldGroups, "FG_DADOS_OPORTUNIDADE");
  
    var groupFixedClosingData = fieldGroups[indexGroupClosingData];
    var groupFixedOpportunityData = fieldGroups[indexGroupOpportunityData];
  
    if (canEditClosingData(loggedOperatorInfos, gridEvolucao)) {
      configureClosingDataEditMode(fieldValueOpportunity, fieldResponsibleOperator, fieldClosingDate, groupFixedClosingData, groupFixedOpportunityData);
    } else {
      configureOpportunityDataMode(fieldValueOpportunity, fieldResponsibleOperator, fieldClosingDate, groupFixedClosingData);
    }
  };

  function canEditClosingData(loggedOperatorInfos, gridEvolucao) {
    return loggedOperatorInfos.IDOPERMASTERHIERARQCRM === "S" || loggedOperatorInfos.CDOPERADOR === gridEvolucao.parent.parent.currentRow.CDOPERADOR;
  }
  
  function configureClosingDataEditMode(fieldValueOpportunity, fieldResponsibleOperator, fieldClosingDate, groupFixedClosingData, groupFixedOpportunityData) {
    fieldClosingDate.class = "4";
    fieldValueOpportunity.isVisible = true;
    fieldResponsibleOperator.isVisible = true;
    groupFixedClosingData.isVisible = true;
    groupFixedOpportunityData.isVisible = true;
    fieldClosingDate.fieldGroup = "FG_DADOS_FECHAMENTO";
  }
  
  function configureOpportunityDataMode(fieldValueOpportunity, fieldResponsibleOperator, fieldClosingDate, groupFixedClosingData) {
    fieldClosingDate.class = "12";
    fieldValueOpportunity.isVisible = false;
    groupFixedClosingData.isVisible = false;
    fieldResponsibleOperator.isVisible = false;
    fieldClosingDate.fieldGroup = "FG_DADOS_OPORTUNIDADE";
  }

  this.setCommitmentDateInCurrentRow = function (widget) {
    var currentRow = widget.currentRow;

    currentRow.DTINIPLANOCUPA = currentRow.DTINI.replace(/\sàs\s/, " ");
    currentRow.DTFINPLANOCUPA = currentRow.DTFIM.replace(/\sàs\s/, " ");
  };

  this.changeOutData = function () {
    var widget = templateManager.container.getActiveWidget();
    var field = widget.getField("NMPARCRESP");
    var keys = field.value();
    var rows = field.selectWidget.getCheckedRows();

    if (Array.isArray(keys) && !Util.isEmptyOrBlank(rows)) {
      field.widget.currentRow.NMPARCRESP = [];
      field.widget.currentRow.CDOPERADOR = [];
      rows.forEach(function (row) {
        keys.forEach(function (key) {
          if (row.NRPARCRESP == key) {
            field.widget.currentRow.NMPARCRESP.push(row.NMPARCRESP);
            field.widget.currentRow.DSEVENTO.push(row.CDOPERADOR);
          }
        });
      });
    }
  };

  this.returnToMainGrid = function () {
    var mainWid = templateManager.container.getWidget("oportunidadegrid");

    ScreenService.closeSwipe();
    mainWid.list();
    mainWid.activate();
  };

  this.returnToEvolutionGrid = function () {
    var evoWid = templateManager.container.getWidget("evolucao");

    ScreenService.closeSwipe();
    evoWid.list();
    evoWid.activate();

    var mainWid = templateManager.container.getWidget("oportunidadegrid");
    mainWid.view();
  };

  this.continueIntegration = function (widget) {
    var widgetCompromisso = templateManager.container.getWidget(
      "compromissoOportunidade"
    );
    var widgetOportunidade = templateManager.container.getWidget(
      "oportunidadegrid"
    );
    //BEGIN RD Station
    var filter = [
      {
        name: "NRPARCNEGOCIO",
        operator: "=",
        value: widget.currentRow.NRPARCOPORT,
      },
      {
        name: "P_NRORGPADRAO",
        operator: "=",
        value: getLocalVar("CRM_NRORGPADRAO"),
      },
    ];
    localStorageEngine
      .download("product#/crud/crm_interlocutor", filter)
      .then(function (contacts) {
        if (!Util.isEmptyOrBlank(contacts)) {
          contacts.forEach(function (contact) {
            var row = {
              EMAIL: contact["EMAILINTERLOC"],
            };
            restEngine
              .post("/IntegracaoRDStation/feedBackConversion", {
                requestType: "Row",
                row: {
                  EVENT_NAME: "Oportunidade gerada pelo CRM",
                  EMAIL: contact["EMAILINTERLOC"],
                },
              })
              .then(function () {
                restEngine.post("/IntegracaoRDStation/markOpport", {
                  requestType: "Row",
                  row: row,
                });
              });
          });
        }
      });
    //END RD Station
    //pula se for tab dinamica
    if (widget.name !== "WDGT_EVOLUCAO")
      this.verificaNovoCompromisso(widgetCompromisso, widgetOportunidade);
  };

  this.checkIfCanEditOrEvolParc = function (nrParcNegocio) {
    var restRow = {
      NRPARCNEGOCIO: nrParcNegocio,
      CRM_NRORGTRAB: getLocalVar("CRM_NRORGTRABALHO"),
    };

    var params = {
      requestType: "Row",
      row: restRow,
    };

    return restEngine
      .post("/checkIfCanEditOrEvolParc", params)
      .then(function (response) {
        return response.dataset.DADOS.CAN_EDIT;
      })
      .catch(function () {
        return false;
      });
  };

  this.showMessageCantEditParc = function () {
    var message = "Ação bloqueada!<br>" +
      "Somente o operador responsável pelo prospect e seus assistentes podem " +
      "editá-lo/evoluí-lo.";

    ScreenService.showMessage(message);
  };
}

Configuration(function (ContextRegister) {
  ContextRegister.register(
    "crm00002001_OportunidadeNegocio_Controller",
    crm00002001_OportunidadeNegocio_Controller
  );
});


// FILE: ./assets/js/controllers/crm00004000_IndicadorLead_Controller.js
function crm00004000_IndicadorLead_Controller(ScreenService,ZHPromise,templateManager,localStorageEngine) {

    this.exibeValoresLeadOperMensal = function(){
        var widget = templateManager.container.getActiveWidget();

        ScreenService.confirmMessage("Período selecionado: "+widget.currentRow.DTLABEL+"<br>Quantidade de leads convertidos: "+
                                      widget.currentRow.QTDECAND+"<br><br>Visualizar a quantidade de conversões por operador no período selecionado?",'information',function(){
        var operWidget = templateManager.container.getWidget('operador_dados');

            operWidget.dataSourceFilter = [{"name":"DTINCLUSAO", "operator":"=", "value":widget.currentRow.DTLABEL}];
            ScreenService.openWidgetAsGadget(operWidget,"swipe");
            operWidget.reload();
        },function(){

        });
    };

    this.exibeValoresOperPeriodo = function(){
        var widget = templateManager.container.getActiveWidget();
        ScreenService.showMessage("Nome do Operador: "+widget.currentRow.NMOPERADOR+"<br>Quantidade de leads convertidos: "+
                                  widget.currentRow.QTDECAND,'sucess','information');
    };

    this.filterManager = function(widget) {
        var parent = widget.parentWidget;
        FilterService.parentFilter(parent, widget).then(function(){
            ScreenService.closePopup();
            parent.activate();
        });
    };

    this.closePopUpFilter = function(widget){
        var parent = widget.parentWidget;
        ScreenService.closePopup();
        parent.activate();
    };

    this.getPopUpGeralFilter = function(){
        return templateManager.container.getWidget(templateManager.container.getActiveWidget().widgets[0].name);
    };

    this.openPopUpGeralFilter = function(){
        var currentWidget = templateManager.container.getActiveWidget();
        this.getPopUpGeralFilter().parentWidget = currentWidget;
        ScreenService.openPopup(this.getPopUpGeralFilter());
    };

}

Configuration(function (ContextRegister) {
    ContextRegister.register("crm00004000_IndicadorLead_Controller", crm00004000_IndicadorLead_Controller);
});


// FILE: ./assets/js/controllers/crm00004001_IndicadorOperador_Controller.js
function crm00004001_IndicadorOperador_Controller(ScreenService,ZHPromise,templateManager,localStorageEngine) {

    this.exibeQtdeAvalMensal = function(){
        var widget = templateManager.container.getActiveWidget();
        ScreenService.showMessage("Operador: "+widget.currentRow.NMPRINCIPALPARC + "<br><br> Quantidade: <br><br>"+
                                  "Ruim: " + widget.currentRow.QTDERUIM + "<br>Regular: " + widget.currentRow.QTDEREGULAR+
                                  "<br>Bom: " + widget.currentRow.QTDEBOM+ "<br>Ótimo: " + widget.currentRow.QTDEOTIMO,'sucess','information');
    };

    this.exibeValoresOperPeriodo = function(){
        var widget = templateManager.container.getActiveWidget();
        ScreenService.showMessage("Nome do Operador: "+widget.currentRow.NMOPERADOR+"<br>Quantidade de leads convertidos: "+widget.currentRow.QTDECAND,'sucess','information');
    };

    this.filterManager = function(widget) {
        var parent = widget.parentWidget;
        FilterService.parentFilter(parent, widget).then(function(){
            ScreenService.closePopup();
            parent.activate();
        });
    };

    this.closePopUpFilter = function(widget){
        var parent = widget.parentWidget;
        ScreenService.closePopup();
        parent.activate();
    };

    this.getPopUpGeralFilter = function(){
        return templateManager.container.getWidget(templateManager.container.getActiveWidget().widgets[0].name);
    };

    this.openPopUpGeralFilter = function(){
        var currentWidget = templateManager.container.getActiveWidget();
        this.getPopUpGeralFilter().parentWidget = currentWidget;
        ScreenService.openPopup(this.getPopUpGeralFilter());
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register("crm00004001_IndicadorOperador_Controller", crm00004001_IndicadorOperador_Controller);
});


// FILE: ./assets/js/controllers/crm00016000_Mapa_de_Prospeccao_Controller.js
function crm00016000_Mapa_de_Prospeccao_Controller(CRM_Utilities, ScreenService, templateManager, General) {
    
    this.changeValueFilterMapaProspeccao = function(widget){
    
        var grid = widget;
        var filterMapaProspeccao = templateManager.container.getWidget("WDGT_PARCEIRO_NEGOCIO");
        var getFieldParcResp = filterMapaProspeccao.getField('CDOPERRESPONSAVEL');
    
        if(grid.currentRow.IDOPERATIVO == "I"){
          getFieldParcResp.dataSourceFilter[1].value = "I";
          grid.getField('CDOPERRESPONSAVEL').clearValue();
          getFieldParcResp.reload();
        } else {
          getFieldParcResp.dataSourceFilter[1].value = "A";
          getFieldParcResp.reload();
        }
      }
    

    this.widgetOnEnterOnce = function(widget, fieldsToApply) {
        
        var partInfoController = CRM_Utilities.getController('PartnerInfosModalController');
        
        var filterRow = {};
        var wdgt = templateManager.container.getWidget('WDGT_PARCEIRO_NEGOCIO');
        
        if((typeof templateManager !== 'undefined') && templateManager.LOGGEDOPERATOR) {
            
            if(widget.name === 'WDGT_PARCEIRO_NEGOCIO' )
                CRM_Utilities.openFilterOnEnter(widget, filterRow, fieldsToApply);
            else{
                widget.dataSource.data = wdgt.dataSource.data;
                widget.appliedFilter = wdgt.appliedFilter;
            }
        }
        
        this.setResaleRules(widget, false);
        CRM_Utilities.cascadeReadOnly(widget, ['SGESTADO', 'CDMUNICIPIO']);
        CRM_Utilities.setObjectFilterWhenResaleLoggedOperator(widget);
        partInfoController.setModalWidgetOnActiveWidget(widget, 'NRPARCNEGOCIO')
    };
    
    this.setResaleRules = function(widget, reload) {
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
    
        if (reload === undefined) {
            reload = true;
        }
    
        if (loggedOperatorInfos.IDTPOPERADOR === 'R' && Boolean(loggedOperatorInfos.NRREVENDA)) {
            var restrictObjects = [];
    
            restrictObjects.push(widget.getField("NMOPERREAL"));
            restrictObjects.push(widget.getField("CDOPERREAL"));
            restrictObjects.push(widget.getField("NMPARCNEGOCIO"));
            restrictObjects.push(widget.getField("NRPARCNEGOCIO"));
    
            var taskTransferWidget = templateManager.container.getWidget("TRANSFERIR");
            restrictObjects.push(taskTransferWidget.getField("NMOPERREAL"));
    
            var evolutionWidget = templateManager.container.getWidget("evolucao");
            restrictObjects.push(evolutionWidget.getField("NMOPERADORREAL"));
    
            CRM_Utilities.setResaleRulesInRestrictObjectsByLoggedOperatorResale(restrictObjects);
        }
    
        if (reload) {
            widget.reload();
        }
    };
    
    /**
     * Função para setar os valores dos filtros da widget
     * de 'Interlorutores', depois que o usuário selecionar
     * um parceiro.
     * 
     * @param {object} widget widget de 'Parceiros'.
    */
    this.setInterlocutorWidgetFilter = function(widget) {
        
        var interlocutorWidgetIndex = CRM_Utilities.getWidgetPosition(widget.widgets, "WDGT_INTERLUCUTOR_PARCEIRO");
        var interlocutorWidget = widget.widgets[interlocutorWidgetIndex];
        
        var widgetFilter = interlocutorWidget.dataSourceFilter;
        var partnerWidgetCurrentRow = interlocutorWidget.getParent().currentRow;
        
        /*Erro de nomeclaturo no dataSource, o minemônico 'P_PARCREVEBDA' referencia ao NRPARCNEGOCIO
        do parceiro em caso*/
        var parcnegocioFilterIndex = CRM_Utilities.getFilterPosition(widgetFilter, "P_PARCREVENDA");
        var nrorgFilterIndex = CRM_Utilities.getFilterPosition(widgetFilter, "P_NRORG");
        
        widgetFilter[parcnegocioFilterIndex].value = partnerWidgetCurrentRow.NRPARCNEGOCIO;
        widgetFilter[nrorgFilterIndex].value = partnerWidgetCurrentRow.NRORG;
        
        interlocutorWidget.reload();
        
    };
    
    /**
     * Função para setar os valores dos filtros da widget
     * de 'Evoluções', depois que o usuário selecionar
     * um parceiro.
     * 
     * @param {object} widget widget de 'Parceiros'.
    */
    this.setEvolutionWidgetFilter = function(widget) {
        
        var evolutionWidget = widget;
        
        var widgetFilter = evolutionWidget.dataSourceFilter;
        var partnerWidgetCurrentRow = evolutionWidget.parent.parent.currentRow;
        
        var nrseqcontatoFilterIndex = CRM_Utilities.getFilterPosition(widgetFilter, "P_NRPARCNEGOCIO");
        
        widgetFilter[nrseqcontatoFilterIndex].value = partnerWidgetCurrentRow.NRPARCNEGOCIO;
        
        evolutionWidget.reload();
        
    };
    
    /**
     * Função para disparar os eventos relacionados 
     * a widget de parceiros logo após um parceiro
     * ser selecionado.
     * 
     * @param {object} widget widget de parceiros.
    */
    this.partnerWidgetAfterMoveRow = function(widget) {
        
        //this.setInterlocutorWidgetFilter(widget);
        
        this.setEvolutionWidgetFilter(widget);
        
    };
    
    /**
     * Função para mudar o label da action para leads e prospects.
     * 
     * @param {object} widget widget de parceiros.
    */
    this.setActionOpenWindowLabel = function(widget) {
        
        var currentRow = widget.currentRow;
        var isLeadOrProspect = widget.currentRow.NMTIPOPARCEIRO.toLowerCase();
        
        widget.actions.forEach(function(action) {
            if(action.name === "OPEN_LEAD_OR_PROSPECT")
                action.label = 'Trabalhar '+CRM_Utilities.capitalizeFirstLetter(isLeadOrProspect);
        });
        
    };
    
    /**
     * Função para abrir a tela de lead/prospect do parceiro
     * selecionado.
     * 
     * @param {object} widget widget de parceiros.
    */
    this.openWindowLeadOrProspect = function(widget) {
           
        var isLeadOrProspect = widget.currentRow.TIPO;
        var windowToOpen     = '';
        var widgetToFilter   = '';
        widget.currentRow.NMTIPO = widget.currentRow.NMTIPOPARCEIRO;
        
        if(isLeadOrProspect === "CANDIDATO") {
            windowToOpen   = 'crm00040_000_leads';
            widgetToFilter = 'gridLead';
        }else if(isLeadOrProspect === "PROSPECT") {
            windowToOpen   = 'ger45000_prospect';
            widgetToFilter = 'gridProspect';
        }else {
            windowToOpen   = 'crm_parceiro_negocio';
            widgetToFilter = 'parceiroNegocio';    
            widget.currentRow.NMTIPO = 'Parceiro';
        }
       
        ScreenService.confirmMessage('Deseja ir para a tela de '+widget.currentRow.NMTIPO+'?', 'CONFIRMATION',
        function(success) {
            ScreenService.openWindow('product#'+windowToOpen).then(function() {
                    var tipoOperador = templateManager.LOGGEDOPERATOR.IDTPOPERADOR || 'E';
                    widgetToFilter = templateManager.container.getWidget(widgetToFilter);
                    
                    var filter = [
                        {
                            name : "NRPARCNEGOCIO",
                            operator : "=",
                            static : true,
                            value : widget.currentRow.NRPARCNEGOCIO 
                        },
                        {
                            name: "NRORG",
                            operator: "=",
                            static: true,
                            value: getLocalVar('CRM_NRORG')
                        },
                        {
                            name: "IDTPOPERADOR",
                            operator: "=",
                            static: true,
                            value: tipoOperador
                        },
                        {
                            name: "P_CRM_NRORGTRAB",
                            operator: "=",
                            static: true,
                            value: getLocalVar('CRM_NRORGTRABALHO')
                        }
                    ]; 
                    
                    if(windowToOpen == 'ger45000_prospect') {
                        filter.push(
                            {
                                name: "NRPARCRESPROSP",
                                operator: "=",
                                static: true,
                                value: widget.currentRow.NRPARCRESPONSAVEL
                            }
                        );
                    }
                    if(windowToOpen == 'crm00040_000_leads') {
                        filter.push(
                            {
                                name: "NRPARCPROPRI",
                                operator: "=",
                                static: true,
                                value: widget.currentRow.NRPARCRESPONSAVEL
                            }
                        );
                    }
                    
                    widgetToFilter.dataSourceFilter = filter;
                    widgetToFilter.fromMap = true;
                    widgetToFilter.reload().
                      then(function() {
                        ScreenService.closePopup(true);
                    });
              });
        });
    };
    
    
    /**
     * Função para abrir a tela de tarefas do parceiro
     * selecionado.
     * 
     * @param {object} widget widget de parceiros.
    */
    this.openWindowTask = function(widget) {
        ScreenService.confirmMessage('Deseja ir para a agenda de tarefas?', 'CONFIRMATION',
        function(success) {
            ScreenService.openWindow('product#crm31000_000_agenda_de_tarefas').
              then(function() {
                    var widgetToFilter = templateManager.container.getWidget('Agenda');
                    var filter = [
                        {
                            name : "NRPARCNEGOCIO",
                            operator : "IN",
                            value : [widget.parent.parent.currentRow.NRPARCNEGOCIO]
                        },
                        {
                            name: "NRORG",
                            operator: "=",
                            value: "@getLocalVar('CRM_NRORGTRAB')@"
                        },
                        {
                            name: "CRM_NRORGTRAB",
                            operator: "=",
                            value: "@getLocalVar('CRM_NRORGTRABALHO')@"
                        }
                    ]; 
                    
                    widgetToFilter.dataSourceFilter = filter;
                    widgetToFilter.customFilter = true;
                    widgetToFilter.reload().
                      then(function() {
                        ScreenService.closePopup(true);
                    });
              });
        });
    };
    
     /**
     * Função para abrir a oportunidade do parceiro
     * selecionado.
     * 
     * @param {object} widget widget de parceiros.
    */
    this.openWindowOport = function(widget) {
        ScreenService.confirmMessage('Deseja ir para a tela de oportunidades?', 'CONFIRMATION',
        function(success) {
            ScreenService.openWindow('product#crm00002_001_oportunidade_de_negocio').
              then(function() {
                    var widgetToFilter = templateManager.container.getWidget('oportunidadegrid');
                    var filter = [{
                        name : "NRSEQOPORT",
                        operator : "IN",
                        value : [widget.currentRow.NRSEQOPORT]
                    }]; 
                    
                    widgetToFilter.dataSourceFilter = filter;
                    widgetToFilter.reload().
                      then(function() {
                        ScreenService.closePopup(true);
                    });
              });
        });
    };
    
      /**
     * Função para abrir os compromissos do parceiro
     * selecionado.
     * 
     * @param {object} widget widget de parceiros.
    */
    this.openWindowCommit = function(widget) {
        ScreenService.confirmMessage('Deseja ir para a tela de compromissos?', 'CONFIRMATION',
        function(success) {
            ScreenService.openWindow('product#crm30000_000_compromissos').
              then(function() {
                    var widgetToFilter = templateManager.container.getWidget('CALENDARIO');
                    var filter = [{
                        name : "NRPARCNEGOCIO",
                        operator : "IN",
                        value : [widget.parent.parent.currentRow.NRPARCNEGOCIO]
                    }]; 
                    
                    widgetToFilter.dataSourceFilter = filter;
                    widgetToFilter.reload().
                      then(function() {
                        ScreenService.closePopup(true);
                        widgetToFilter.reload();
                    });
              });
        });
    };
    
    this.unMaskPhone = function(widget) {
        widget.dataSourceFilter.forEach(function(filter) {
            if(filter.name === "TELEFONE") {
                filter.value = filter.value.replace(/[^0-9]/g, '');
                filter.value = '%' + filter.value + '%'; 
                
            }
        });
    };
    
    this.reloadTab = function(widget) {
        if(widget.currentFilter && widget.currentFilter !== General.getFieldValue('NRPARCNEGOCIO', 'WDGT_PARCEIRO_NEGOCIO'))
            widget.reload();
        else if(!widget.currentFilter)
            widget.reload();
        
        this.setCurrentFilter(widget);    
    };
    
    this.setCurrentFilter = function(widget) {
        widget.currentFilter = General.getFieldValue('NRPARCNEGOCIO', 'WDGT_PARCEIRO_NEGOCIO');    
    };
    
    this.alteraMunicipioFilter = function(widget) {
        var estado    = widget.getField('SGESTADO');
        var municipio = widget.getField('CDMUNICIPIO');
        
        var estadoFilter = CRM_Utilities.getComponentDataSourceFilter(municipio, 'SGESTADO');
        
        if(Util.isEmptyOrBlank(estado.value())) {
            estadoFilter.value = '';
        }else{
            estadoFilter.value = estado.value();
        }
    };
    
    this.alteraEstadoFilter = function(widget){
        var estado    = widget.getField('SGESTADO');
        var municipio = widget.getField('CDMUNICIPIO');
        var pais = widget.getField('CDPAIS');
        
        var estadoFilter = CRM_Utilities.getComponentDataSourceFilter(estado, 'CDPAIS');
        var municipioFilter = CRM_Utilities.getComponentDataSourceFilter(municipio, 'CDPAIS');
        
        if(Util.isEmptyOrBlank(pais.value())){
            municipioFilter.value = '';
            estadoFilter.value = '';
        }else{
            municipioFilter.value = pais.value();
            estadoFilter.value = pais.value();
        }
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register("crm00016000_Mapa_de_Prospeccao_Controller", crm00016000_Mapa_de_Prospeccao_Controller);
});


// FILE: ./assets/js/controllers/crm00023000_Relatorio_Controller.js
function crm00023000_Relatorio_Controller(ScreenService, Operador_Repository, templateManager, Utilities, wizardEngine, ZHPromise) {

    var self = this;

    /*self.changeHourFilter = function() {
        var widget = templateManager.container.getActiveWidget();
        var stripe = templateManager.container.getWidget('STRIPE');

        if(!stripe.currentRow.HORAS) stripe.currentRow.HORAS = 6;
        else widget.dataSourceFilter[1].value = stripe.currentRow.HORAS;

        widget.reload();
    };*/

    self.iniciaFiltrosWidparcnegocio_caso = function(widget)
    {
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }
            Utilities.insertFilter(widget, "P_NRORG", "=", operator[0].NRORG, 0);
            Utilities.insertFilter(widget, "P_CDOPERADOR", "=", operator[0].CDOPERADOR, 1);
        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
    };

    self.iniciaFiltrosWidsistema_caso = function(widget)
    {
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }
            Utilities.insertFilter(widget, "P_NRORG", "=", operator[0].NRORG, 0);
            Utilities.insertFilter(widget, "P_CDOPERADOR", "=", operator[0].CDOPERADOR, 1);
        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
    };

    self.iniciaFiltrosWidsemretorno = function(widget)
    {
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }
            Utilities.insertFilter(widget, "P_CDOPERADOR", "=", operator[0].CDOPERADOR, 1);
            Utilities.insertFilter(widget.getField("CDSISTEMA"), "CDOPERADOR", "=", operator[0].CDOPERADOR, 0);
        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
    };

    self.iniciaFiltrosWidsegretPadrao = function(widget)
    {
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }
            Utilities.insertFilter(widget, "P_CDOPERADOR", "=", operator[0].CDOPERADOR, 2);
            Utilities.insertFilter(widget.getField("CDSISTEMA"), "CDOPERADOR", "=", operator[0].CDOPERADOR, 0);
        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
    };

    self.iniciaFiltrosWidcasossemconc = function(widget)
    {
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }
            Utilities.insertFilter(widget, "P_NRORG", "=", operator[0].NRORG, 1);
            Utilities.insertFilter(widget, "P_CDOPERADOR", "=", operator[0].CDOPERADOR, 2);
            Utilities.insertFilter(widget.getField("CDSISTEMA"), "CDOPERADOR", "=", operator[0].CDOPERADOR, 0);
        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
    };

    self.filtrarRelatorio = function() {
        var popup = templateManager.container.getActiveWidget();

        var HORAS = (popup.currentRow.HORAS)? popup.currentRow.HORAS : 6;
        var CDOPERADOR = (popup.currentRow.CDOPERADOR)? popup.currentRow.CDOPERADOR : null;
        var CDMOTICONT = (popup.currentRow.CDMOTICONT)? popup.currentRow.CDMOTICONT : null;
        var CDSISTEMA = (popup.currentRow.CDSISTEMA)? popup.currentRow.CDSISTEMA : null;

        var filtro = []; var i = 0;

        filtro[i] = popup.parent.dataSourceFilter[i]; i++;
        filtro[i] = popup.parent.dataSourceFilter[i];
        filtro[i].value = HORAS; i++;
        filtro[i] = popup.parent.dataSourceFilter[i]; i++;
        filtro[i] = popup.parent.dataSourceFilter[i]; i++;

        if(CDOPERADOR) {
            filtro[i] = {
                "name": "CDOPERADOR",
                "operator": "IN",
                "value": CDOPERADOR
            };
            i++;
        }
        if(CDMOTICONT) {
            filtro[i] = {
                "name": "CDMOTICONT",
                "operator": "IN",
                "value": CDMOTICONT
            };
            i++;
        }
        if(CDSISTEMA) {
            filtro[i] = {
                "name": "CDSISTEMA",
                "operator": "IN",
                "value": CDSISTEMA
            };
            i++;
        }

        popup.parent.dataSourceFilter = filtro;
        Utilities.masterDetailClosePopup();
        popup.parent.reload();
    };

    self.openFilter = function() {
        var widget = templateManager.container.getActiveWidget();
    	var filtro = templateManager.container.getWidget('relatoriofilter');

    	if(!filtro.currentRow.HORAS) filtro.currentRow.HORAS = widget.dataSourceFilter[1].value;

    	Utilities.masterDetailOpenPopup(filtro.name);
    };

    self.removeFilters = function() {
        var popup = templateManager.container.getActiveWidget();

        popup.currentRow = {};
        popup.reload();
    };

    self.setColor = function() {
        var widget = templateManager.container.getActiveWidget();

        widget.currentRow.NRCORDESTAQUECASO = widget.currentRow.NRCORDESTAQUECASO.toHexString();
    };

    self.warnCount = function() {
        var widget = templateManager.container.getActiveWidget();

        var mensagem = ((widget.currentRow.PARCEIRO)? widget.currentRow.PARCEIRO : widget.currentRow.SISTEMA)+" tem "+
                        widget.currentRow.CASOS+((widget.currentRow.CASOS > 1)? " casos abertos" : " caso aberto");

        ScreenService.showMessage(mensagem, "INFORMATION", "information");
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm00023000_Relatorio_Controller', crm00023000_Relatorio_Controller);
});

// FILE: ./assets/js/controllers/crm00030000_Notificacoes_Controller.js
function crm00030000_Notificacoes_Controller(ScreenService, Operador_Repository, restEngine, templateManager, Utilities)
{
    var self = this;

    self.iniciaFiltroswdg_notificacoes = function(widget)
    {
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }
            var cdoperador = operator[0].CDOPERADOR ? operator[0].CDOPERADOR : -1;
            Utilities.insertFilter(widget, "CDOPERNOTIFICADO", "=", cdoperador, 0);
        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
    };

	this.confirmaAlteracaoNotificacao = function(widget, idconfirma)
	{
		restEngine.post('crm#/trocaValorNotificacao',
        {'requestType':'Row', 'row': {'notificacoes': widget.currentRow, 'idconfirma': idconfirma}},
        	function()
            {
                ScreenService.notificationMessage("Alteração da notificação confirmada com sucesso.", "success");
            }, undefined,
            function(error)
            {
                ScreenService.notificationMessage("Falha ao confirmar alteração da Notificação.", "error");
                console.log(error);
            }
        ).then(function()
        {
            var row = [widget.currentRow];

        	self.deletaNotificacao(row);
            ScreenService.closeSwipe();
        });
	};

	this.deletaNotificacao = function(row)
	{
		restEngine.post('crm#/deletaRelacaoNotificacao',
        {'requestType':'Row', 'row': row},
        	function()
            {
                ScreenService.notificationMessage("Notificação deletada com sucesso.", "success");
            }, undefined,
            function(error)
            {
                ScreenService.notificationMessage("Falha ao deletar Notificação.", "error");
                console.log(error);
            }
        ).then(function()
        {
            templateManager.container.getWidget('wdg_notificacoes').reload();
        });
	};

	this.controlaActionsNotificacao = function(widget)
	{
		var row = widget.currentRow;
		if(((row.DSEVENTONOTIFICACAO == 'SITUACAO') || (row.DSEVENTONOTIFICACAO == 'FASENEGOCIO')) && (row.IDACEITARECUSA === null))
		{
			widget.getAction('aceitar').isVisible = true;
			widget.getAction('recusar').isVisible = true;
		}
        else
        {
            widget.getAction('aceitar').isVisible = false;
            widget.getAction('recusar').isVisible = false;
        }
	};
}


Configuration(function(ContextRegister)
{
    ContextRegister.register('crm00030000_Notificacoes_Controller', crm00030000_Notificacoes_Controller);
});

// FILE: ./assets/js/controllers/crm00032000_FaseNegociacao_Controller.js
function crm00032000_FaseNegociacao_Controller(Utilities, ScreenService, templateManager, wizardEngine, Operador_Repository) {

    var self = this;

    this.iniciaFiltrosWidparamFaseNego = function(widget)
    {
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }
            Utilities.insertFilter(widget, "P_NRORG", "=", operator[0].NRORG, 0);
            Utilities.insertFilter(widget.getField("NRFIELDCRM"), "P_NRORG", "=", operator[0].NRORG, 0);
        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
    };

    this.setFilter = function() {
        var widgetFilha, widgetPai;
        var widget = templateManager.container.getActiveWidget();

        if(widget.name == 'paramFaseNego') {
            widgetFilha = widget;
            widgetPai = widget.parent;
        } else {
            widgetFilha = widget.widgets[0];
            widgetPai = widget;
        }

        widgetFilha.dataSourceFilter[1].value = widgetPai.currentRow.NRSEQFASENEGO;
    };

    this.save = function() {
        var widget = templateManager.container.getActiveWidget();
        
        if(Util.isEmptyOrBlank(widget.currentRow.NRORG)) {
            widget.currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
        }
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }

            self.removeItensRedundantes(widget);
            if(widget.isValid()) {
                widget.currentRow.changed = true;
                if(operator[0] === undefined || operator[0] === null)
                {
                    ScreenService.showMessage("Erro ao realizar a operação.");
                    return;
                }
                else if(widget.currentRow.__is_new)
                {
                    widget.currentRow.NRORGINCLUSAO = (widget.currentRow.NRORGINCLUSAO)? widget.currentRow.NRORGINCLUSAO : operator[0].NRORG;
                    widget.currentRow.CDOPERINCLUSAO = (widget.currentRow.CDOPERINCLUSAO)? widget.currentRow.CDOPERINCLUSAO : operator[0].CDOPERADOR;
                } else {
                    widget.currentRow.NRORGULTATU = (widget.currentRow.NRORGULTATU)? widget.currentRow.NRORGULTATU : operator[0].NRORG;
                    widget.currentRow.CDOPERULTATU = (widget.currentRow.CDOPERULTATU)? widget.currentRow.CDOPERULTATU : operator[0].CDOPERADOR;
                }

                widget.currentRow.NRSEQFASENEGO = widget.dataSourceFilter[1].value;
                return widget.saveRow().then(function(response){
                    widget.currentRow.changed = false;
                    widget.currentRow.__is_new = false;

                    ScreenService.closeSwipe();
                    widget.list();
                    widget.reload();
                });
            }
        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
    };

    this.removeItensRedundantes = function (widget){
        /*var indice = null;
        var ItensIncluidos = widget.dataSource.data;
        var novosItens = widget.currentRow.NRFIELDCRM;
        for(var i = 0; i < ItensIncluidos.length; i++){
            indice = novosItens.indexOf(ItensIncluidos[i].NRSEQCAMPOOBRIGA);
            if (indice >= 0){
                novosItens.splice(indice, 1);
            }
        }*/
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm00032000_FaseNegociacao_Controller', crm00032000_FaseNegociacao_Controller);
});

// FILE: ./assets/js/controllers/crm00038000_IndicadorDesempenho_Controller.js
function crm00038000_IndicadorDesempenho_Controller(ScreenService,ZHPromise,templateManager,localStorageEngine) {

    this.exibeQtdeAvalMensal = function(){
        var widget = templateManager.container.getWidget('indicadores_desempenho');
        ScreenService.confirmMessage("Operador selecionado: "+widget.currentRow.AVALIADO+"<br>Quantidade de avaliações: "+widget.currentRow.QTDEOPER+"<br><br>Visualizar o resultado das avaliações?",'information',function(){
                var operWidget = templateManager.container.getWidget('desempenhoOperador');
            operWidget.dataSourceFilter = [{"name":"NRPARCAVALIADO", "operator":"=", "value":widget.currentRow.NRAVALIADO}];
            ScreenService.openWidgetAsGadget(operWidget,"swipe");
            operWidget.reload();
        },function(){

        });
    };

    this.exibeValoresOperPeriodo = function(){
        var widget = templateManager.container.getActiveWidget();
        ScreenService.showMessage("Nome do Operador: "+widget.currentRow.NMOPERADOR+"<br>Quantidade de leads convertidos: "+widget.currentRow.QTDECAND,'sucess','information');
    };

    this.filterManager = function(widget) {
        var parent = widget.parentWidget;
        FilterService.parentFilter(parent, widget).then(function(){
            ScreenService.closePopup();
            parent.activate();
        });
    };

    this.closePopUpFilter = function(widget){
        var parent = widget.parentWidget;
        ScreenService.closePopup();
        parent.activate();
    };

    this.getPopUpGeralFilter = function(){
        return templateManager.container.getWidget(templateManager.container.getActiveWidget().widgets[0].name);
    };

    this.openPopUpGeralFilter = function(){
        var currentWidget = templateManager.container.getActiveWidget();
        this.getPopUpGeralFilter().parentWidget = currentWidget;
        ScreenService.openPopup(this.getPopUpGeralFilter());
    };

}

Configuration(function (ContextRegister) {
    ContextRegister.register("crm00038000_IndicadorDesempenho_Controller", crm00038000_IndicadorDesempenho_Controller);
});


// FILE: ./assets/js/controllers/crm00040_Lead_Controller.js
function crm00040_Lead_Controller(ScreenService, ValidationEngine, templateManager, Utilities, wizardEngine, ZHPromise, restEngine, Operador_Repository, Crm_00040_Lead_Service, General, CRM_Utilities, Endereco, Messages, ABEvolucaoController, evolutionTabController, CRM_ParceiroNegocio_Controller) {
    
    var self = this;
    /*
    *   Seta valores Iniciais do novo Lead.
    */
    this.newLead = function(widget) {
        
        General.widgetNewRow(widget);
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        var currentRow = widget.currentRow;

        currentRow.CDPAIS = "";
        currentRow.CDSEGMER = "";
        currentRow.CDBAIRRO = "";
        currentRow.CDFILIAL = "";
        currentRow.SGESTADO = "";
        currentRow.IDATIVO = "S";
        currentRow.IDTPIJURCAN = "I";
        currentRow.CDMUNICIPIO = "";
        currentRow.CDMODODIVULG = "";
        currentRow.TIPOINSC = "CODIGO";
        currentRow.IDPARCFUNDIDO = "N";
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        currentRow.NRORGINCLUSAO = loggedOperatorInfos.NRORG;
        currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
        currentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
        currentRow.NRPARCPROPRI = loggedOperatorInfos.NRPARCNEGOCIO;
        currentRow.NMPARCPROPRI = loggedOperatorInfos.NMOPERADOR;
        currentRow.NRSEQPERFILRESPONSAVEL = loggedOperatorInfos.NRSEQPERFATIV[0];
        currentRow.DESCPEFATIV = loggedOperatorInfos.DESCPEFATIV[0];
        currentRow.IDTPOPERADOR = loggedOperatorInfos.IDTPOPERADOR;
        currentRow.ISCPF = currentRow.IDTPIJURCAN === "F" ? "S" : "N";
        currentRow.DSTELEFONECAN = null;
        currentRow.NRSEQPERFILRESPONSAVEL = null;
        currentRow.DTINCLUSAO = "";
        widget.getField('NRINSJURCAN').readOnly = false;
        widget.getField('NMCANDIDATO').readOnly = false;

    };
    
    this.changeValueFilterLead = function (field) {

        var grid = field;
        var getFieldParcResp = grid.getField('NRPARCPROPRI');

        if (grid.currentRow.IDOPERATIVO == "A") {
            getFieldParcResp.dataSourceFilter[1].value = "A";
            getFieldParcResp.reload();
        } else {
            getFieldParcResp.dataSourceFilter[1].value = "I";
            grid.getField('NRPARCPROPRI').clearValue();
            getFieldParcResp.reload();
        }
    }

    self.saveTask = function(widgetName) {
        var widget = templateManager.container.getWidget(widgetName);
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        var currentRow = widget.currentRow;
    
        currentRow.NRPARCNEGOCIO = widget.getParent().currentRow.NRPARCNEGOCIO;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
    
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response) {
            if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
                if (widget.isValid()) {
                    widget.currentRow.changed = true;
                    if (!Util.isEmptyOrBlank) {
                        widget.currentRow['DSTELEFONETAREFA'] = widget.currentRow['DSTELEFONETAREFA'].replace(/[^0-9]/g, '');
                    }
                    if (widget.currentRow.__is_new) {
                        widget.currentRow.NRORGINCLUSAO = loggedOperatorInfos.NRORG;
                        widget.currentRow.CDOPERINCLUSAO = loggedOperatorInfos.CDOPERADOR;
                        widget.currentRow.NRORGULTATU = null;
                        widget.currentRow.CDOPERULTATU = null;
                    } else {
                        widget.currentRow.NRORGULTATU = loggedOperatorInfos.NRORG;
                        widget.currentRow.CDOPERULTATU = loggedOperatorInfos.CDOPERADOR;
                    }
    
                    widget.currentRow.CDFILIAL = "";
                    widget.currentRow.NRPARCNEGOCIO = widget.getParent().currentRow.NRPARCNEGOCIO;
                    widget.currentRow.NRSEQCLASSIFICATAREFA = (widget.currentRow.NRSEQCLASSIFICATAREFA) ? widget.currentRow.NRSEQCLASSIFICATAREFA : null;
                    widget.currentRow.TIPO = "PARCEIRO";
                    widget.currentRow.NMPARCNEGOCIO = widget.getParent().currentRow.NMCANDIDATO;
                    widget.currentRow.DESCRICAO = "Referente ao Lead " + widget.currentRow.NMPARCNEGOCIO;
                    widget.currentRow.NMOPERREAL = widget.currentRow.NMOPERADOR;
                    widget.currentRow.OPERADORDOLOGADO = widget.currentRow.NMPARCRESP;
    
                    return General.widgetSave(widget).then(function(response) {
                        widget.currentRow.changed = false;
                        widget.currentRow.__is_new = false;
    
                        ScreenService.closeSwipe();
    
                        if (widget.currentRow.CDOPERINCLUSAO != widget.currentRow.CDOPERREAL && !Util.isEmptyOrBlank(widget.currentRow.DSEMAILOPER)) {
                            ScreenService.confirmMessage('Deseja enviar um e-mail para o operador responsável da tarefa?', 'QUESTION', function(yes) {
                                var params = {
                                    "requestType": "Row",
                                    "row": widget.currentRow
                                };
    
                                restEngine.post('/enviaEmailTarefa', params).then(function() {
                                    ScreenService.showMessage('E-mail enviado com sucesso!');
                                }).catch(function(error) {
                                    if (error.data.error) {
                                        ScreenService.showMessage('O e-mail não pode ser enviado pois as configurações de SMTP estão desconfiguradas ou erradas!', 'ERROR');
                                    } else {
                                        ScreenService.showMessage(error.data.error);
                                    }
                                });
                            });
                        }
                        widget.reload();
                        widget.list();
                    });
                }
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        });
    };

    /**
     * Prepara e valida LEAD para ser salvo
    */
    this.prepareLead = function(widget) {
        if(!Util.isEmptyOrBlank(widget.currentRow.NRTELEFONE1) || !Util.isEmptyOrBlank(widget.currentRow.EMAILINTERLOC)) {
            widget.getField('NMINTERLOCUTOR').validations = {"required": true};
        }else{
            widget.getField('NMINTERLOCUTOR').validations = {};
        }

        if (Util.isEmptyOrBlank(widget.currentRow.IDSTATUSCAN)){
            ScreenService.confirmMessage("Operação Bloqueada Pois o Lead Não Possui Status <br><br> Deseja Atualiza-lo? ", 'CONFIRMATION',
                    function(success) {
                        this.updateStatusCan(widget, '2');
                    }.bind(this));
        }
        
        if(widget.isValid()) {
            widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
            var currentRow = widget.currentRow;
            const telefone = widget.currentRow['DSTELEFONECAN'];
            const cep = widget.currentRow['NRCEPENDERECO'];
            const inscricao = widget.currentRow['NRINSJURCAN'];
            if(currentRow.CDBAIRRO === undefined) currentRow.CDBAIRRO = null;
            if (!Util.isEmptyOrBlank(telefone)) {
                widget.currentRow['DSTELEFONECAN'] = telefone.replace(/\D/g, '');
            }
            if (!Util.isEmptyOrBlank(cep)) {
                widget.currentRow['NRCEPENDERECO'] = cep.replace(/\D/g, '');
            }
            if (!Util.isEmptyOrBlank(inscricao)) {
                widget.currentRow['NRINSJURCAN'] = inscricao.replace(/\D/g, '');
            }
            if (widget.currentRow.NMMODODIVULG !== 'Revenda') {
                widget.currentRow.NRREVENDA = null;                
            }

            this.prepareCurrentRowForSave(currentRow);
            widget.CRM_PARAMETRIZACAO = CRM_Utilities.getCrmParametrization();
            
            if(currentRow.__is_new) {
                
                var limiteRevenda = false;
                
                this.verificaParametrizacaoRevenda(currentRow).then(function(verificaRevenda) {
                    
                    limiteRevenda = verificaRevenda.dataset.DADOS.EXCEDEULIMITE;
                    
                    if(!limiteRevenda) {
                        
                        this.validacaoLeadExistente(widget, currentRow);
                        
                    }else{
                        
                        var quantidadeLeads = verificaRevenda.dataset.DADOS.QUANTIDADE;
                        var limiteLeads = verificaRevenda.dataset.DADOS.LIMITE;
                        ScreenService.showMessage('Operação bloqueada! <br><br> Máximo de Leads excedido. <br> Você possui: '+quantidadeLeads+' Leads<br> O limite de Leads por revenda é: '+limiteLeads);
                    
                    }
                }.bind(this));
            }else{
                this.saveValidLead(widget, currentRow);    
            }
        }
    };
    
    this.validacaoLeadExistente = function (widget, currentRow) {
        this.verificaLeadExistente(currentRow).then(function (verificaLead) {
            if (verificaLead.dataset.DADOS.LEADS === true) {
                if (widget.CRM_PARAMETRIZACAO.IDBLOQNOMESEMELHA === 'S') {
                    ScreenService.showMessage("Operação bloqueada! <br><br> A 'Razão Social' informada já está vinculada a outro lead. Consulte o mapa de prospecção.");
                } else {
                    ScreenService.confirmMessage("Operação bloqueada! <br><br> A 'Razão Social' informada já está vinculada a outro lead. Consulte o mapa de prospecção. <br><br> Deseja continuar? ", 'CONFIRMATION',
                        function (success) {
                            this.saveValidLead(widget, currentRow);
                        }.bind(this));
                }
    
            } else if (Array.isArray(verificaLead.dataset.DADOS.LEADS) && !Util.isEmptyOrBlank(verificaLead.dataset.DADOS.LEADS) && verificaLead.dataset.DADOS.PARCEXISTS) {
                var leads = verificaLead.dataset.DADOS.LEADS;
                var mensagemInscricaoVinculada = this.criarMensagemInscricaoJaVinculada(leads);
                ScreenService.showMessage(mensagemInscricaoVinculada);
                widget.fields.find(function (x) { return x.label == 'Inscrição'; }).clearValue();
                widget.fields.find(function (x) { return x.label == 'Tipo de Inscrição'; }).value('I');
                widget.currentRow.INSCRICAO = "";
                widget.currentRow.NOME = "";
                widget.currentRow.CNPJRAIZ = "";
            } else {
                this.saveValidLead(widget, currentRow);
            }
        }.bind(this));
    };
    
    /**
     * Faz verificações na currentRow e a retorna
    */
    this.prepareCurrentRowForSave = function(currentRow) {
        
        if(currentRow.IDTPIJURCAN === "J") {
            if(!currentRow.CNPJRAIZ) {
                currentRow.CNPJRAIZ = currentRow.NRINSJURCAN.toString().split('/')[0].replace(/[^0-9]/g,'');
            }
            currentRow.INSCRICAO = currentRow.NRINSJURCAN.toString();
        }else{
            currentRow.INSCRICAO = currentRow.NRINSJURCAN ? currentRow.NRINSJURCAN.toString().replace(/[^0-9]/g,'') : '';
        }
        currentRow.NOME = currentRow.NMCANDIDATO.toString().replace(' ', "%").toUpperCase();
        
        currentRow.NMFANTCAN   = currentRow.NMFANTCAN ? currentRow.NMFANTCAN : currentRow.NMCANDIDATO;
        currentRow.NRINSJURCAN = currentRow.NRINSJURCAN ? currentRow.NRINSJURCAN.toString(): '';
        
        //Propriedade para fazer validação de lead
        currentRow.LEAD     = true;
        currentRow.PROSPECT = false;
    };
    
    /**
     * Salva Lead validado
    */
    this.saveValidLead = function (widget, currentRow) {
        widget.currentRow.CDOPERINCLUSAO = templateManager.LOGGEDOPERATOR.CDOPERADOR;
        widget.currentRow.IDSTATUS = widget.currentRow.IDSTATUSCAN;
        widget.currentRow.IDVALIDACNPJ = templateManager.CRM_PARAMETRIZACAO.IDCNPJRAIZ;
        widget.currentRow.IDBLOQNOMESEMELHA = templateManager.CRM_PARAMETRIZACAO.IDBLOQNOMESEMELHA;
    
        if (widget.currentRow.__is_new) {
            widget.currentRow.DTINCLUSAO = moment().format('DD/MM/YYYY HH:mm:ss');
        } else {
            widget.currentRow.DTULTATU = moment().format('DD/MM/YYYY HH:mm:ss');
        }
        return CRM_Utilities.saveWidget(widget, false).then(function (response) {
            if (response.dataset) {
                // Atribui à current row os campos gerados no backend
                currentRow.NRCANDIDATO = response.dataset.DADOS.NRCANDIDATO;
                currentRow.NRPARCNEGOCIO = response.dataset.DADOS.NRPARCNEGOCIO;
                currentRow.NRSEQCONTATO = response.dataset.DADOS.NRSEQCONTATO;
                currentRow.NRCONTATO = response.dataset.DADOS.NRCONTATO;
                // Recarrega a widget
                widget.reload().then(function () {
                    widget.currentRow.__is_new = false;
                    widget.view();
                    widget.reload();
                });
            }
        });
    };
    
    /**
     * Defini o filtro da tela de lead pelo
     * lead ativo.
     * 
     * @param {object} widget widget principal da tela
     * de lead.
    */
    this.setLeadWidgetFilterByActiveLead = function(widget) {
        
        var currentRow = widget.currentRow;
        //Resetando filtros
        var filters = angular.copy(widget.dataSourceFilter); 
        widget.dataSourceFilter.forEach(function(filter, index) {
            if(filter.name !== "P_NRPARCNEGOCIO" && filter.name !== "P_NRORG" && filter.name !== "IDTPOPERADOR") {
                filters.splice(index);
            }
        });
        widget.dataSourceFilter = filters;
        //filtros resetados
        
        var filter = {};
            
        filter.name     = "NRCANDIDATO";
        filter.operator = "=";
        filter.value    = currentRow.NRCANDIDATO;
        
        widget.dataSourceFilter.push(filter);
        widget.reload();
        widget.dataSourceFilter.pop();    
        
    };
    
    /**
     * Verifica se já existem parceiros vinculados
     * aquele CNPJ ou nome
    */
    this.verificaLeadExistente = function(currentRow) {
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        return restEngine.post('/validaLead', paramsRestEngine);
    };
    
    /**
     * Verifica se aquele operador responsável já excedeu 
     * o máximo de leads (de acordo com a parametrização);
    */
    this.verificaParametrizacaoRevenda = function(currentRow) {
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        return restEngine.post('/validaOperadorRevenda', paramsRestEngine);
    };
    
    this.deleteLead = function (widget) {
        var currentRow = widget.currentRow;
        if (currentRow.NRPARCPROPRI === CRM_Utilities.getLoggedOperatorInfos().NRPARCNEGOCIO) {

            currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
            ScreenService.confirmMessage(ScreenService.i18n(Messages.DESATIVAR_LEAD(widget.currentRow.NMCANDIDATO)), 'question', function (success) {

                var paramsRestEngine = {
                    "requestType": "Row",
                    "row": currentRow
                };

                return restEngine.post('/deactivateParc', paramsRestEngine).then(function () {
                    currentRow.IDATIVO = 'N';
                    ScreenService.showMessage('Lead inativado com sucesso!');
                    widget.reload();
                }.bind(this)).catch(function (error) {
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
                });

            });
        } else {
            ScreenService.showMessage('Operação Bloqueada! <br/> Somente o Parceiro Responsável <br/> Pode Inativar o Lead!');
        }
    };

    this.activateLead = function (widget) {
        var currentRow = widget.currentRow;
        if (currentRow.NRPARCPROPRI === CRM_Utilities.getLoggedOperatorInfos().NRPARCNEGOCIO) {

            currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
            ScreenService.confirmMessage(ScreenService.i18n(Messages.ATIVAR_LEAD(widget.currentRow.NMCANDIDATO)), 'question', function (success) {

                var paramsRestEngine = {
                    "requestType": "Row",
                    "row": currentRow
                };

                return restEngine.post('/activateParc', paramsRestEngine).then(function () {
                    currentRow.IDATIVO = 'S';
                    ScreenService.showMessage('Lead Ativado com Sucesso!');
                    widget.reload();
                }.bind(this)).catch(function (error) {
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
                });

            });
        } else {
            ScreenService.showMessage('Operação Bloqueada! <br/> Somente o Parceiro Responsável <br/> Pode Inativar o Lead!');
        }
    };
    
    /**
     * Bloqueia as ações quando um lead inativo
     * é selecionado.
     * 
     * @param {object} widget widget principal da
     * tela de lead.
    */
    this.checkInactiveLead = function(widget) {
        
        var currentRow = widget.currentRow;
        
        if(Boolean(currentRow.IDATIVO)) {
              
            if(currentRow.IDATIVO === 'N') {
                CRM_Utilities.hideFunctionalActions();
                this.defineActivateLeadActionVisibility(widget, true);
            }else{
                CRM_Utilities.returnContainerDefaultActions();
                this.defineActivateLeadActionVisibility(widget, false);
            }
        
        }
        
    };
    
    /**
     * Exibe o botão para ativar o lead selecionado
     * se ele estivar desativado.
     * 
     * @param {object} widget widget principal da
     * tela de lead.
    */
    this.defineActivateLeadActionVisibility = function(widget, isVisible) {
        
        var actionIndexInActions = CRM_Utilities.getObjectPositionInArrayByName(widget.actions, "ATIVAR_LEAD");
        widget.actions[actionIndexInActions].isVisible = isVisible;
        
    };
    
    /**
     * Ativa o lead, desativado, selecionado.
     * 
     * @param {object} widget widget principal 
     * da tela de lead (gridLead).
    */
    this.activateLead = function(widget) {
        
        ScreenService.confirmMessage(ScreenService.i18n(Messages.ATIVAR_LEAD(widget.currentRow.NMCANDIDATO)), 'question', function (success) {
            
            var currentRow = widget.currentRow;
            currentRow.IDATIVO = 'S';
            currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
            
            var paramsRestEngine = {
                "requestType": "Row",
                "row": currentRow
            };
            
            return restEngine.post('/setLeadIdAtivo', paramsRestEngine).then(function() {
                
                this.checkInactiveLead(widget);
                this.setLeadWidgetFilterByActiveLead(widget);
                
            }.bind(this)).catch(function(error) {
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
            });
            	
		}.bind(this));
        
    };
    
    this.editLead = function(widget) {
        var currentRow = widget.currentRow;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                General.widgetEdit(widget);
                
                if(widget.currentRow.NMMODORECEBINFO == undefined) {
                    widget.currentRow.NRMODORECEBINFO = "";
                }
                    
                widget.currentRow.PARCORIGINAL = widget.currentRow.NRPARCNEGOCIO;
                widget.getField('NRINSJURCAN').readOnly = false;
                widget.getField('NMCANDIDATO').readOnly = false;
                /*Controle de Readonly fields de Endereço*/
                widget.getField('NMPAIS').readOnly = false;
                widget.getField('NMESTADO').readOnly = false;
                widget.getField('NMMUNICIPIO').readOnly = false;
                if(typeof widget.getField('NMBAIRROCAN') !== "undefined") {
                    widget.getField('NMBAIRROCAN').readOnly = false;
                }
                if(typeof widget.getField('NMBAIRRO') !== "undefined") {
                    widget.getField('NMBAIRRO').readOnly = false;
                }
                
                this.getLocalFound(currentRow);
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    };
    
    this.cleanWidgetFields = function(widget) {
        widget.fields.forEach(function(field) {
            field.value("");    
        });   
    };
    
    /**
     * Função que usa o CRM_Utilities para 
     * validar a inscrição e atualizar 
     * a currentRow.
    */
    this.validaInscricao = function(widget, lead, prospect, fromProspect) {
        
        widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        widget.currentRow.IDVALIDACNPJ = templateManager.CRM_PARAMETRIZACAO.IDCNPJRAIZ;
        widget.currentRow.IDBLOQNOMESEMELHA = templateManager.CRM_PARAMETRIZACAO.IDBLOQNOMESEMELHA;
        
        var inscricao     = widget.getField("NRINSJURCAN");
        var tipoInscricao = widget.getField("IDTPIJURCAN");
        
        if(fromProspect) {
            inscricao = widget.getField("NRINSJURPROS");
            tipoInscricao = widget.getField("IDTPIJURPROS");
            widget.currentRow.IDTPIJURCAN = widget.currentRow.IDTPIJURPROS;
        } else if(widget.name === 'gridCliente') {
            inscricao = widget.getField("NRINSJURCLIE");
            tipoInscricao = widget.getField("IDTPIJURCLIE");
        }
        
        if (CRM_Utilities.isWidgetFilter(widget)) {
            if(fromProspect) {
                widget.currentRow.NRINSJURPROS = inscricao.value().replace(/[^0-9]/g,'');
            } else if(inscricao.name == "NRINSJURCLIE") {
                widget.currentRow.NRINSJURCLIE = inscricao.value().replace(/[^0-9]/g,'');
            } else {
                widget.currentRow.NRINSJURCAN  = inscricao.value().replace(/[^0-9]/g,'')
            }
            return;
        } else if (Util.isEmptyOrBlank(inscricao.value())) {
            tipoInscricao.value('');
            return;
        }
        
        //Variavel para validacao de cpnj raiz
        var valueInscricao = inscricao.value();
        
        CRM_Utilities.validaInscricao(widget, inscricao.name, tipoInscricao.name);
        
        if(templateManager.CRM_PARAMETRIZACAO.IDCNPJRAIZ === 'S' && valueInscricao.length === 14) {
           if(templateManager.container.name == 'crm00040_000_leads') {
                widget.currentRow.CNPJRAIZ = widget.currentRow.NRINSJURCAN.toString().split('/')[0].replace(/[^0-9]/g,'');
                widget.currentRow.INSCRICAO = widget.currentRow.CNPJRAIZ;
                widget.currentRow.NOME      = widget.currentRow.NMCANDIDATO.toString().replace(' ', "%").toUpperCase();
            } else if(templateManager.container.name == 'ger45000_prospect') {
                widget.currentRow.CNPJRAIZ = widget.currentRow.NRINSJURPROS.toString().split('/')[0].replace(/[^0-9]/g,'');
                widget.currentRow.INSCRICAO = widget.currentRow.CNPJRAIZ;
                widget.currentRow.NOME      = widget.currentRow.NMRAZSOCPROS.toString().replace(' ', "%").toUpperCase();
            } else if(templateManager.container.name == 'crm_cliente') {
                widget.currentRow.CNPJRAIZ = widget.currentRow.NMRAZSOCCLIE.toString().split('/')[0].replace(/[^0-9]/g,'');
                widget.currentRow.INSCRICAO = widget.currentRow.CNPJRAIZ;
                widget.currentRow.NOME      = widget.currentRow.NMFANTCLIE.toString().replace(' ', "%").toUpperCase();
            }
            this.verificaLeadExistente(widget.currentRow).then(function(verificaLead) {
                if(Array.isArray(verificaLead.dataset.DADOS.LEADS) && verificaLead.dataset.DADOS.LEADS.LEADS && verificaLead.dataset.DADOS.PARCEXISTS) { 
                    var leads = verificaLead.dataset.DADOS.LEADS;
                
                    var mensagemCNPJ = this.criarMensagemInscricaoJaVinculada(leads);
                    mensagemCNPJ = "Operação bloqueada! Este CNPJ Raiz já está vinculado" + mensagemCNPJ.substr(81);
                    
                    ScreenService.showMessage(mensagemCNPJ);
                    widget.fields.find(function (x) {x.label == 'Inscrição'}).clearValue();
                    widget.fields.find(function (x) {x.label == 'Tipo de Inscrição'}).value('I');
                    widget.currentRow.INSCRICAO = "";
                    widget.currentRow.NOME = "";
                    widget.currentRow.CNPJRAIZ = "";
                }else if(!Util.isEmptyOrBlank(valueInscricao)) {
                    this.completeValidation(widget, inscricao, tipoInscricao, lead, prospect, fromProspect);
                }
            }.bind(this));
        }else if(!Util.isEmptyOrBlank(valueInscricao)) {
            this.completeValidation(widget, inscricao, tipoInscricao, lead, prospect, fromProspect);    
        }
        if(!fromProspect && widget.name !== 'gridCliente') {
            this.changeLabelDTNASCIFUNDPARC(widget);
        }
    };
    
    this.completeValidation = function(widget, inscricao, tipoInscricao, lead, prospect, fromProspect) {
        if(fromProspect) {
            widget.currentRow.INSCRICAO = widget.currentRow.NRINSJURPROS.toString().replace(/[^0-9]/g,'');
            widget.currentRow.NOME      = widget.currentRow.NMRAZSOCPROS.toString().replace(' ', "%").toUpperCase();
            widget.currentRow.IDTPIJURCAN = widget.currentRow.IDTPIJURPROS;
        }else if(widget.name === 'gridCliente') {
            widget.currentRow.INSCRICAO = widget.currentRow.NRINSJURCLIE.toString().replace(/[^0-9]/g,'');
            widget.currentRow.NOME      = widget.currentRow.NMRAZSOCCLIE.toString().replace(' ', "%").toUpperCase();
            widget.currentRow.IDTPIJURCAN = widget.currentRow.IDTPIJURCLIE;
        } else {
            widget.currentRow.INSCRICAO = widget.currentRow.NRINSJURCAN.toString();
            widget.currentRow.NOME      = widget.currentRow.NMCANDIDATO.toString().replace(' ', "%").toUpperCase();
        }
        widget.currentRow.LEAD      = lead || false;
        widget.currentRow.PROSPECT  = prospect || false;
        this.verificaLeadExistente(widget.currentRow).then(function(response) {
            if(Array.isArray(response.dataset.DADOS.LEADS) && !Util.isEmptyOrBlank(response.dataset.DADOS.LEADS) && response.dataset.DADOS.PARCEXISTS) {
                var leads = response.dataset.DADOS.LEADS;
                
                var mensagemInscricaoVinculada = this.criarMensagemInscricaoJaVinculada(leads);
                ScreenService.showMessage(mensagemInscricaoVinculada);
                widget.fields.find(function (x) {x.label == 'Inscrição'}).clearValue();
                widget.fields.find(function (x) {x.label == 'Tipo de Inscrição'}).value('I');
                widget.currentRow.INSCRICAO = "";
                widget.currentRow.NOME = "";
                widget.currentRow.CNPJRAIZ = "";
            } else if(!Util.isEmptyOrBlank(response.dataset.DADOS.LEADS) && response.dataset.DADOS.PARCEXISTS) {
                self.buildReturnedParcRow(widget, response.dataset.DADOS.LEADS);
            } else {
                this.autofillData(widget, fromProspect); 
            }
        }.bind(this));
        
    };
    
    /**
     * A label do campo de data de nascimento/fundação
     *  muda de acordo com o tipo de inscrição
    */
    this.changeLabelDTNASCIFUNDPARC = function(widget) {
        var readOnly = true;
        
        if(widget.currentRow.IDTPIJURCAN === "J") {
            widget.getField('DTNASCIFUNDPARC').label = 'Data de Fundação';
            readOnly = false;
        }else if(widget.currentRow.IDTPIJURCAN === "F") {
            widget.getField('DTNASCIFUNDPARC').label = 'Data de Nascimento';
            readOnly = false;
        }else{
            widget.getField('DTNASCIFUNDPARC').label = 'Nascimento/Fundação';
            readOnly = true;
            widget.currentRow.DTNASCIFUNDPARC = null;
        }
        
        widget.getField('DTNASCIFUNDPARC').readOnly = readOnly;
    };
    
    this.validaCNPJRaiz = function(CNPJ) {
        
        var cnpj = CNPJ.substr(8,4);
        
        if(cnpj === "0001")
            return true;
        else
            return false;
        
    };
    
    this.startWidgetFilterGridlead = function(widget)
    {
        var widgetFilter = widget.dataSourceFilter;
        var nrparcnegocioFilterIndex = CRM_Utilities.getFilterPosition(widgetFilter, "P_NRPARCNEGOCIO");
        var nrorgFilterIndex = CRM_Utilities.getFilterPosition(widgetFilter, "P_NRORG");
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        if(nrorgFilterIndex) {
            if(loggedOperatorInfos) widgetFilter[nrparcnegocioFilterIndex].value = loggedOperatorInfos.NRPARCNEGOCIO;
            widgetFilter[nrorgFilterIndex].value = getLocalVar("CRM_NRORG");
            var restrictObjects = [];
            
            restrictObjects.push(widget);
            restrictObjects.push(widget.getField("NMPARCPROPRI"));
            
            CRM_Utilities.setResaleRulesInRestrictObjectsByLoggedOperatorResale(restrictObjects);
        }
        
    
        //seta parametrizacoes na widget
        widget.CRM_PARAMETRIZACAO = CRM_Utilities.getCrmParametrization();
    };
    
    this.setTasksWidgetOperatorField = function() {
        
        var tasksWidget = templateManager.container.getWidget('posvendagrid');
        var operatorField = tasksWidget.getField('NMOPERADOR');
        
        CRM_Utilities.setObjectFilterWhenResaleLoggedOperator(operatorField);
        
    };
    
    /**
     * Função para definir o filtro dos campos
     * de motivo de contato e resultado, na widget
     * de evolução.
     * 
     * @param {object} widget widget de evolução.
    */
    this.setEvolutionResultFilterAndContactReasonFilter = function(widget) {
        
        var ContactReasonField = widget.getField("NMMOTIEVOCON");
        var ResultField = widget.getField("DESCRESULEVOL");
        this.setOperatorCodeFilterValueAndOrganizationNumberFilterValue(ContactReasonField);
        this.setOperatorCodeFilterValueAndOrganizationNumberFilterValue(ResultField);
        widget.getField('NRPARCNEGOCIO').defaultValue = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        
    };
    
    /**
     * Função para setar valor dos filtros de
     * número de organização e código de operador
     * da field recebida como parâmetro, e logo
     * em seguida, recarrega a field.
     * 
     * @param {object} field field que receberá
     * o valor dos filtros
    */
    this.setOperatorCodeFilterValueAndOrganizationNumberFilterValue = function(field) {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        var fieldFilter = field.dataSourceFilter;
        var nrorgFilterIndex = CRM_Utilities.getFilterPosition(fieldFilter, "P_NRORG");
        var cdoperadorFilterIndex = CRM_Utilities.getFilterPosition(fieldFilter, "P_CDOPERADOR");
        
        fieldFilter[nrorgFilterIndex].value = loggedOperatorInfos.NRORG;
        fieldFilter[cdoperadorFilterIndex].value = loggedOperatorInfos.CDOPERADOR;
        
        field.reload();
            
    };
    
    this.typechecking = function(widget) {
      var currentRow = widget.currentRow;
      if(typeof currentRow.NRINSJURCAN !== "undefined" && currentRow.NRINSJURCAN.toString() !== "")
      {
        var nrinsjuca = widget.currentRow.NRINSJURCAN.toString().replace(/[^0-9]/g,'');
        var FieldIDTPIJURCAN = widget.getField('IDTPIJURCAN');

        switch (nrinsjuca.length) {
            case 5:
                FieldIDTPIJURCAN.value("O");
                currentRow.TIPOINSC = "CODIGO";
              break;

            case 11:
                FieldIDTPIJURCAN.value("F");
                currentRow.TIPOINSC = "CPF";
              break;

            case 14:
                FieldIDTPIJURCAN.value("J");
                currentRow.TIPOINSC = "CNPJ";
              break;

            case 20:
                FieldIDTPIJURCAN.value("I");
                currentRow.TIPOINSC = "LIVRE";
              break;

            default:
                FieldIDTPIJURCAN.value("O");
                currentRow.TIPOINSC = "CODIGO";
              break;

        }
      }else{
          currentRow.IDTPIJURCAN = "";
      }
    };

    this.convertsToSubscriptionType = function(currentRow) {
      if(typeof currentRow.NRINSJURCAN !== "undefined" && currentRow.NRINSJURCAN.toString() !== "")
      {
        var nrinsjucan = currentRow.NRINSJURCAN.toString().replace(/[^0-9]/g,'');

        switch (nrinsjucan.length) {
            case 11:
                nrinsjucan = nrinsjucan.replace(/^(\d{3})(\d{3})(\d{3})(\d{2})/, "$1.$2.$3-$4");
              break;

            case 14:
                nrinsjucan = nrinsjucan.replace(/^(\d{2})(\d{3})(\d{3})(\d{4})(\d{2})/, "$1.$2.$3/$4-$5");
              break;
        }

        currentRow.NRINSJURCAN = nrinsjucan;
      }
    };

    this.checkInvalidInscription = function(widget) {
      var currentRow = widget.currentRow;
      var fieldInscription = widget.getField('NRINSJURCAN');

      if(fieldInscription && this.isValidInscription(currentRow.NRINSJURCAN)) {
          fieldInscription.value("");
          ScreenService.showMessage("Inscrição Inválida.");
      }
    };


    this.isValidInscription = function(inscription) {

        if(inscription[0] === "0") {
            inscription = this.validateRegistrationWithZerosLeft(inscription);
        }

        var inscriptionInNumber = parseInt(inscription).toString();
        if(inscriptionInNumber.length === inscription.length || inscriptionInNumber === "0") {
            return false;
        }
        return true;
    };

    this.validateRegistrationWithZerosLeft = function(value) {
        var index = 0;

       while(value[index] === "0") {
            value = value + "1";
            index++;
        }

        return parseInt(value).toString();
    };

    this.validationEmail = function(field) {
		var receivedTestEmail = ValidationEngine.mail(field.value(),"E-mail Válido");
		if(receivedTestEmail.valid === false) {
		    field.value("");
		    ScreenService.showMessage("E-mail inválido");
		}
	};

    this.validationPhone = function(field) {
	    var numberSizeReceived = field.value().replace(/[^0-9]/g,'').length;
	    if(numberSizeReceived !== 10 && numberSizeReceived !== 11 && numberSizeReceived !== 12) {
	        field.value("");
		    ScreenService.showMessage("Telefone Inválido");
	    }
	};
    
    this.localFilter = function(widget,field) {
        var localname = field.name;
        var currentRow = widget.currentRow;
        var filters = [];
        var filterCode;

        switch(localname) {
            case "NMESTADO":
                filterCode = "CDPAIS";
                filters.push(this.createEqualFilter(filterCode,currentRow.CDPAIS));
            break;
            
            case "NMMUNICIPIO":
                filterCode = "SGESTADO";
                filters.push(this.createEqualFilter(filterCode,currentRow.SGESTADO));
                filterCode = "CDPAIS";
                filters.push(this.createEqualFilter(filterCode,currentRow.CDPAIS));
            break;
            
            case "NMBAIRRO":
                filterCode = "CDMUNICIPIO";
                filters.push(this.createEqualFilter(filterCode,currentRow.CDMUNICIPIO));
                filterCode = "SGESTADO";
                filters.push(this.createEqualFilter(filterCode,currentRow.SGESTADO));
                filterCode = "CDPAIS";
                filters.push(this.createEqualFilter(filterCode,currentRow.CDPAIS));
            break;
            
            default:
                if(localname === "NMBAIRROCAN") {
                    filterCode = "CDMUNICIPIO";
                    filters.push(this.createEqualFilter(filterCode,currentRow.CDMUNICIPIO));
                    filterCode = "SGESTADO";
                    filters.push(this.createEqualFilter(filterCode,currentRow.SGESTADO));
                    filterCode = "CDPAIS";
                    filters.push(this.createEqualFilter(filterCode,currentRow.CDPAIS));
                }
            break;
        }
        
        filters.forEach(function(filter) {
            var filterCode = filter.name;    
            var localNameIndexFilter = CRM_Utilities.getFilterPosition(field.dataSourceFilter, filterCode);
            
            if(field.dataSourceFilter[localNameIndexFilter]) {
                field.dataSourceFilter = CRM_Utilities.deleteFilterObject(field.dataSourceFilter, localNameIndexFilter);
            }
            field.dataSourceFilter.push(filter);
        });
        
        
    };

    var selectedcountry;
    this.exchangeCountry = function(currentRow) {
      var currentCountrys = currentRow.NMPAIS.toString();

      if(typeof selectedcountry === "undefined") {
          selectedcountry = currentCountrys;
      }else if(selectedcountry !== currentCountrys) {
          currentRow.NMESTADO = "";
          currentRow.SGESTADO = "";
          currentRow.NMMUNICIPIO = "";
          currentRow.CDMUNICIPIO = "";
          currentRow.NMBAIRRO = "";
          currentRow.NMBAIRROCAN = "";
          currentRow.CDBAIRRO = "";
          selectedcountry = currentCountrys;
      }
    };

    var selectedstate;
    this.exchangeState = function(currentRow) {
      var currentState = currentRow.NMESTADO.toString();

      if(typeof selectedstate === "undefined") {
          selectedstate = currentState;
      }else if(selectedstate !== currentState) {
          currentRow.NMMUNICIPIO = "";
          currentRow.CDMUNICIPIO = "";
          currentRow.NMBAIRRO = "";
          currentRow.NMBAIRROCAN = "";
          currentRow.CDBAIRRO = "";
          selectedstate = currentState;
      }
    };

    var selectedmunicipality;
    this.exchangeMunicipality = function(currentRow) {
      var currentMunicipality = currentRow.NMMUNICIPIO.toString();

      if(typeof selectedmunicipality === "undefined") {
          selectedmunicipality = currentMunicipality;
      }else if(selectedmunicipality !== currentMunicipality) {
          currentRow.NMBAIRROCAN = "";
          currentRow.NMBAIRRO = "";
          currentRow.CDBAIRRO = "";
          selectedmunicipality = currentMunicipality;
      }
    };

    this.momentNow = function() {
        return moment(new Date()).format('DD/MM/YYYY HH:mm:ss');
    };

    this.createEqualFilter = function(name,value) {
        var filter = {
            "name": name,
            "operator": "=",
            "value": value
        };
            
        return filter;
    };

    this.setQualifyLead = function (widget, newValue) {
        var currentRow = widget.currentRow;
        var atualizarAcoes = this.atualizarAcoes;
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');

        if (currentRow.NRPARCPROPRI === CRM_Utilities.getLoggedOperatorInfos().NRPARCNEGOCIO) {
            General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function (response) {
                if (response.dataset && response.dataset.error) {
                    ScreenService.showMessage(response.dataset.error, 'ERROR');
                }
                if (response.dataset && response.dataset.GROUPREL[0] == false) {
                    if ((currentRow.IDSTATUSCAN !== "3" && newValue === "3") || (currentRow.IDSTATUSCAN !== "4" && newValue === "4")) {
                        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

                        currentRow.IDSTATUSCAN = newValue;
                        currentRow.CDOPERULTATU = loggedOperatorInfos.CDOPERADOR;
                        currentRow.DTULTATU = self.momentNow();

                        restEngine.post('/setQualification', { 'requestType': 'Row', 'row': currentRow },
                            undefined, undefined, undefined).then(function (response) {
                                //BEGIN RD Station
                                var contactWidgets = templateManager.container.getWidget('WDGT_INTERLOCUTOR');
                                contactWidgets.dataSourceFilter.forEach(function (filter) {
                                    if (filter.name === 'NRPARCNEGOCIO')
                                        filter.value = widget.currentRow.NRPARCNEGOCIO;
                                });
                                contactWidgets.reload().then(function () {
                                    if (!Util.isEmptyOrBlank(contactWidgets.dataSource.data)) {
                                        contactWidgets.dataSource.data.forEach(function (contact) {
                                            restEngine.post('/IntegracaoRDStation/changeFunnel', { 'requestType': 'Row', 'row': { FUNNEL: (currentRow.IDSTATUSCAN === "3") ? 'Qualified Lead' : 'Lead', EMAIL: contact['EMAILINTERLOC'], OPPORTUNITY: false } },
                                                undefined, undefined, undefined);
                                        });
                                    }
                                });
                                //END RD Station
                                this.showLeadQualificationMessage(newValue);
                                widget.reload().then(function () {
                                    atualizarAcoes(widget);
                                });
                            }.bind(this));
                    } else {
                        this.showQualificationErrorMessage(currentRow.IDSTATUSCAN);
                    }
                } else {
                    ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
                }
            }.bind(this));
        } else {
            ScreenService.showMessage('Operação Bloqueada! <br> Somente o Parceiro Responsável <br> Pode Qualificar/Desqualificar o Lead');
        }
    };
    
    this.updateStatusCan = function (widget, newValue){
        var currentRow = widget.currentRow;
        var atualizarAcoes = this.atualizarAcoes;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                if(Util.isEmptyOrBlank(currentRow.IDSTATUSCAN)) {
                    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
                    
                    currentRow.IDSTATUSCAN = newValue;
                    currentRow.CDOPERULTATU = loggedOperatorInfos.CDOPERADOR;
                    currentRow.DTULTATU = self.momentNow();
                    
                    restEngine.post('/setNewStatus', {'requestType':'Row', 'row': currentRow},
                    undefined, undefined, undefined).then(function(response) {
                        this.showLeadQualificationMessage(newValue);
                        widget.reload().then(function() {
                        atualizarAcoes(widget);
                        });
                    }.bind(this));
                }else{
                    this.showQualificationErrorMessage(currentRow.IDSTATUSCAN);
                }
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    }


    this.showLeadQualificationMessage = function(leadQualification) {
    
        if(leadQualification === "3") {
            ScreenService.showMessage('Lead qualificado com sucesso.');
        }else if (leadQualification === "4"){
            ScreenService.showMessage('Lead desqualificado com sucesso.');
        } else {
            ScreenService.showMessage('Status do Lead Atualizado Com Sucesso.');
        }
        
    };
    
    this.showQualificationErrorMessage = function(leadQualification) {
        
        if(leadQualification === "3") {
            ScreenService.showMessage(Messages.LEAD_JA_QUALIFICADO);
        }else{
            ScreenService.showMessage(Messages.LEAD_JA_DESQUALIFICADO);
        }
        
    };
    
    this.initTab = function(widget) {
        if(widget.parent.parent.currentRow.NRCANDIDATO) {
            widget.dataSourceFilter.find(function (x) {x.name = 'NRCANDIDATO'}).value = widget.parent.parent.currentRow.NRCANDIDATO;
        }

        widget.reload();
    };

    this.initTabEvol = function(widget) {
        setLocalVar('PARCEIRO', widget.parent.parent.currentRow.NRPARCNEGOCIO);
        
        widget.reload();
    };

    this.evolucaoNewRow = function() {
        var widget = templateManager.container.getWidget('evolucao');
        var currentRow = widget.currentRow;
        var gridWidget = templateManager.container.getWidget("gridLead");
        var gridCurrentRow = gridWidget.currentRow;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        gridCurrentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        gridCurrentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [gridCurrentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                widget.getField("DESCRESULEVOL").readOnly = false;
                widget.getField("NMINTERLOCUTOR").defaultValue = "";
                General.widgetNewRow(widget);
                currentRow = widget.currentRow;
                
                currentRow.DTHREVOLCONT = (currentRow.DTHREVOLCONT)? currentRow.DTHREVOLCONT : moment(new Date()).format('DD/MM/YYYY HH:mm');
                currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
                currentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
                currentRow.NRORG = loggedOperatorInfos.NRORG;
                
                ABEvolucaoController.setEvolDateChangePermission(widget);
                
                currentRow.NRCONTATO = (!Util.isEmptyOrBlank(widget.parent.parent.currentRow.NRCONTATO)) ? widget.parent.parent.currentRow.NRCONTATO : widget.parent.parent.currentRow.NRSEQCONTATO;  
                currentRow.NRSEQCONTATO = widget.parent.parent.currentRow.NRSEQCONTATO;
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    };
    

    this.cancelEvolForm = function(widget) {
        this.cleanConversionIndicator(widget);
        widget.getField("DESCRESULEVOL").readOnly = true;
        General.widgetCancelForm(widget);
    };
    
    this.setOperatorNextTask = function(currentRow, loggedOperatorInfos) {
        currentRow.NMOPERADORREAL = loggedOperatorInfos.NMOPERADOR;
        currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
    };
    
    this.insertRowNextTask = function(widget) {
        
        var currentRow = widget.currentRow;
        var deferred = ZHPromise.defer();
        
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        
        if(currentRow.DTPLANFILACONTA && !currentRow.NEXTTASKBLOCKED) {
        
            return Crm_00040_Lead_Service.callForInsertClient(widget.currentRow);
            
        }else{
            
            deferred.resolve();
            
        }
        
        return deferred;
        
    };
    
    
    /**
     * Procedimento para verificar se uma evolução
     * está sendo salva por uma rotina de conversão
     * ou por uma rotina comum de insert.
     * 
     * @param {object} widget widget de evolução.
    */
    this.checkEvolutionConversion = function(widget) {
        //prepara widget para a verificação
        if(!widget.currentRow.NRPARCNEGOCIO) {
            widget.currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        }
        
        var currentRow = widget.currentRow;
        
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                if(widget.isValid()) {
                    this.verificaTarefasAbertas(widget.currentRow).then(function() {
                        if(Boolean(widget.REALIZARCONVERCAO)) {
                            templateManager.evolutionWidget = widget;
                            this.verifyHasRelationship(widget);
                        }else{
                            this.saveEvolucao(widget);
                        }   
                    }.bind(this)).catch(function() {
                        General.widgetCancelForm(widget);
                    }.bind(this));
                }
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    };
    
    /**
     * Procedimento para remover a widget de evolução
     * salva no template Manager.
    */
    this.cleanEvolutionWidgetInTemplateManager = function() {
        
        if(Boolean(templateManager.evolutionWidget)) {
            delete templateManager.evolutionWidget;
        }
        
    };
    
    /**
     * Organiza os campos para salvar a evolução
     * e verifica tarefa já aberta.
     * 
     * @param {object} widget widget de evolução
    */
    this.saveEvolucao = function(widget) {
        
        var currentRow = widget.currentRow;
        var zhPromise = ZHPromise.defer();
        
        if(widget.isValid()) {
        
            currentRow.IDGERAFATURA = 'NAO';
            currentRow.IDTPEVOLCONT = 'P';
            currentRow.IDANEXOEVOLCONT = currentRow.IDANEXOEVOLCONT === 'S' ? currentRow.IDANEXOEVOLCONT : 'N';
            currentRow.CDFILIAL = "";
            currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
    
            if(!currentRow.NRRELACIONAPARC) {
                currentRow.NRRELACIONAPARC = null;
            }
            
            var widgetevol = templateManager.container.getWidget('evolucao');
            this.getParentField(widget);
            this.saveEvolutionAndInsertTask(widget, currentRow).then(function() {
                zhPromise.resolve();
            });
            
        }
        return zhPromise.promise;
    };
    
    
    /**
     * Salva evolução e gera Tarefa
     * 
     * @param {object} widget widget de evolução
    */
    this.saveEvolutionAndInsertTask = function(widget, currentRow) {
        var zhPromise = ZHPromise.defer();
        this.insertRowNextTask(widget).then(function(response) {
            
            if(response) {
                
                currentRow.NRSEQFILACONTA = response.dataset.DADOS.NRSEQFILACONTA;
                
            }else if(!currentRow.NRSEQFILACONTA) {
                
                currentRow.NRSEQFILACONTA = "";
                
            }
            
            General.widgetSave(widget).then(function(response) {
    
                if(response.dataset.DADOS[0] && response.dataset.DADOS[0].NRSEQEVOLCONT) {
                    currentRow.NRSEQEVOLCONT = response.dataset.DADOS[0].NRSEQEVOLCONT;
                }
                if(!Util.isEmptyOrBlank(widget.currentRow.NRSEQINTERLOCUTOR) && widget.currentRow.IDENVIAEMAIL === 'S') {
                    ScreenService.confirmMessage('Deseja enviar um email para '+widget.currentRow.NMINTERLOCUTOR+'?', 'QUESTION',
                    function(yes) {
                        evolutionTabController.openWidgetSendMail(widget, 'gridLead').then(function() {
                            templateManager.promise = zhPromise;
                        });
                    }, function(no) {
                        zhPromise.resolve();
                    });
                }else{
                    zhPromise.resolve();
                }
                widget.reload();
                
                this.setTaskEndDate(widget);    
                
            }.bind(this)).catch(function(error) {
                if(error.indexOf('REQUIRE_INTERLOCUTOR')  !== -1)
                    ScreenService.showMessage("Operação bloqueada! <br><br> Favor informar o interlocutor.");
                else
                    ScreenService.showMessage(error);
            });
        }.bind(this));
        return zhPromise.promise; 
    };
    
    /**
     * Verifica se já existem tarefas relacionadas
     * aquele parceiro
     * 
     * @param {object} widget widget de evolução
    */
    this.verificaTarefasAbertas = function(currentRow) {
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        
        var zhPromise = ZHPromise.defer();
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        
        restEngine.post('/verificaTarefas', paramsRestEngine).
            then(function(response) {
                if(response.dataset.DADOS.TAREFAS) {
                    var tarefas = response.dataset.DADOS.TAREFAS;
                    var operadores = '';
                    tarefas.forEach(function(tarefa) {
                        operadores +='<br>'+tarefa;
                    });
                    ScreenService.confirmMessage('Este parceiro possui tarefas "Em Aberto" para o(s) seguinte(s) operador(es) <br>'+operadores+'<br><br> Deseja continuar? ', 'CONFIRMATION',
                    function(success) {
                        zhPromise.resolve();
                    }.bind(this),
                    function(fail) {
                        zhPromise.reject();
                    });
                }else{
                    zhPromise.resolve();
                }
            }.bind(this));
        return zhPromise.promise;
    };
    
    
    this.getParentField = function(widget) {
        
        widget.currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        if(widget.currentRow.__is_new) {
            widget.currentRow.NRCONTATO = widget.parent.parent.currentRow.NRCONTATO;
            widget.currentRow.NRSEQCONTATO = widget.parent.parent.currentRow.NRSEQCONTATO;
        }
        
    };

    this.openWidgetFundir = function() {
      var widget = templateManager.container.getWidget('FUNDIRLEAD');

      ScreenService.closePopup();

      widget.currentRow.NRCANDIDATOLEAD = widget.parent.parent.currentRow.NMCANDIDATO;
    };

    this.closeWidgetFundir = function() {
        var widgetLeads = templateManager.container.getWidget('crm00040_000_leads');
        var widgetMerge = templateManager.container.getWidget('FUNDIR');

        widgetLeads.list();
        widgetMerge.currentRow.NOME = "";

    };

    this.mergeCandidate = function(widget) {
        var currentRow = widget.currentRow;
        var sourcePartners = currentRow.NOME;

        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.NRORG = widget.parent.parent.currentRow.NRORG;
        currentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
        currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCNEGOCIO;

        if(currentRow.NRPARCNEGOCIO) {

            var parcSeparatedByUnderline = "_";

            sourcePartners.forEach(function(value) {
            parcSeparatedByUnderline = parcSeparatedByUnderline + value + "_";
            });
            currentRow.PARCTOSTRING = parcSeparatedByUnderline;

            restEngine.post('/mergeCandidate', {'requestType':'Row', 'row': currentRow},
             function(success) {
                 
                ScreenService.showMessage(Messages.PARCEIROS_FUNDIDOS_SUCESSO);
                currentRow.NOME = "";
                ScreenService.closeSwipe();
                widget.parent.parent.view();
                widget.parent.parent.activate();
                
             },undefined, undefined);
        }else{

            ScreenService.showMessage("O Lead selecionado não possui parceiro de negócio.");
            currentRow.NOME = "";
        }
    };
    
    
    /*
    * Prepara campos para conversão do lead
    * e valida se já existe prospect com aquela inscrição
    */
    this.ConvertLeadInProspect = function(widget) {
        var loggedOperatorInfos   = CRM_Utilities.getLoggedOperatorInfos();
        var currentRow = widget.currentRow;
        widget.CRM_PARAMETRIZACAO = CRM_Utilities.getCrmParametrization();

        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                if(widget.isValid()) {
                    widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                    var currentRow = widget.currentRow;
                    currentRow['DSTELEFONECAN'] = currentRow['DSTELEFONECAN'].replace(/[^0-9]/g, '');
                    
                    if(widget.currentRow.NMMODORECEBINFO == undefined || widget.currentRow.NMMODORECEBINFO == "") {
                        widget.currentRow.NRMODORECEBINFO = "";
                    }
                    
                    currentRow.INSCRICAO = currentRow.NRINSJURCAN.toString().replace(/[^0-9]/g,'');
                    currentRow.NOME = currentRow.NMCANDIDATO.toString().replace(' ', "%").toUpperCase();
                    
                    //Propriedade para fazer validação de lead
                    currentRow.LEAD     = false;
                    currentRow.PROSPECT = true;
                    
                    currentRow.CDOPERINCLUSAO = loggedOperatorInfos.CDOPERADOR;
                    currentRow.NRORG = loggedOperatorInfos.NRORG;
                    currentRow.CURRENTDATE = self.momentNow();
                    currentRow.NRFUNCCAN = widget.parent.parent.currentRow.NRFUNCCAN;
                    currentRow.CDMODODIVULG = widget.parent.parent.currentRow.CDMODODIVULG;
                    currentRow.NRCONTATO = (!Util.isEmptyOrBlank(widget.parent.parent.currentRow.NRCONTATO)) ? widget.parent.parent.currentRow.NRCONTATO : widget.parent.parent.currentRow.NRSEQCONTATO;
                    currentRow.NRCANDIDATO = widget.parent.parent.currentRow.NRCANDIDATO;
                    currentRow.NRINSJURCAN = currentRow.NRINSJURCAN.toString().replace(/[^0-9]/g,'') ;
                    currentRow.NMFANTCAN = currentRow.NMFANTCAN ? currentRow.NMFANTCAN : currentRow.NMCANDIDATO;
                    currentRow.NRPARCRESPROSP  = loggedOperatorInfos.NRPARCNEGOCIO;
                    currentRow.CDOPERRESPONSAVEL = loggedOperatorInfos.CDOPERADOR;
                    currentRow.DTINITRESERVAPROSP = CRM_Utilities.getDataHoraAtual();
                    
                    this.getNewResponsibleOperatorForTheLead(widget);
                    this.requireInterlocutorFields(widget);
                    
                    if(currentRow.__is_new) {
                        this.verificaLeadExistente(currentRow).then(function(response) {
                                if(response.dataset.DADOS.LEADS === true){
                                    //Verifica parametrização bloqueia nome semelhante
                                    if(widget.CRM_PARAMETRIZACAO.IDBLOQNOMESEMELHA === 'S') {
                                        ScreenService.showMessage("Operação bloqueada! <br><br> A 'Razão Social' informada, já está vinculada a outro prospect.");
                                    }else{
                                        ScreenService.confirmMessage("A 'Razão Social' informada, já está vinculada a outro prospect. <br><br> Deseja continuar? ", 'CONFIRMATION',
                                            function(success) {
                                                this.convertValidLead(widget, currentRow, loggedOperatorInfos);
                                            }.bind(this));
                                    }
                                }else if(Array.isArray(response.dataset.DADOS.LEADS) && !Util.isEmptyOrBlank(response.dataset.DADOS.LEADS) && response.dataset.DADOS.PARCEXISTS) {
                                    var leads = response.dataset.DADOS.LEADS;
                                    var mensagemInscricaoVinculada = this.criarMensagemInscricaoJaVinculada(leads);
                                    ScreenService.showMessage(mensagemInscricaoVinculada);
                                    
                                    widget.fields.find(function (x) {x.label == 'Inscrição'}).clearValue();
                                    widget.fields.find(function (x) {x.label == 'Tipo de Inscrição'}).value('I');  
                                    widget.currentRow.INSCRICAO = "";
                                    widget.currentRow.NOME = "";
                                    widget.currentRow.CNPJRAIZ = "";
                                }else {
                                    this.convertValidLead(widget, currentRow, loggedOperatorInfos);
                                }
                            }
                        .bind(this));
                    }else{
                        this.convertValidLead(widget, currentRow, loggedOperatorInfos);    
                    }
                }
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
        
    };
    
    this.criarMensagemInscricaoJaVinculada = function(parceiros) {
        var mensagem = "Operação bloqueada! <br><br> Esta Inscrição já está vinculada ao(s) seguinte(s):";
    
        var tiposDeParceiroEValores = this.agruparParceirosPorTipo(parceiros);
    
        tiposDeParceiroEValores.forEach(function(grupoDeParceiros) {
            mensagem += "<br><br>--> " + grupoDeParceiros.tipo + ":";
    
            grupoDeParceiros.parceiros.forEach(function(parceiro) {
                mensagem += "<br>- " + parceiro;
            });
        });
    
        return mensagem;
    };
    
    this.agruparParceirosPorTipo = function (parceiros) {
        var parceirosAgrupadosPorTipo = CRM_Utilities.groupBy(parceiros, ['TIPOPARC']);
    
        // Adaptar para iterar sobre as propriedades
        var tiposDeParceiroEValores = [];
        var self = this; // Armazenar referência ao contexto externo
    
        Object.keys(parceirosAgrupadosPorTipo).forEach(function (tipo) {
            var grupo = parceirosAgrupadosPorTipo[tipo];
    
            // Verificar se grupo é um array antes de prosseguir
            if (Array.isArray(grupo)) {
                var grupoDeParceiros = {
                    tipo: self.cdTipoParcToString(tipo),
                    parceiros: grupo.map(function (parceiro) {
                        return parceiro.NMPRINCIPALPARC;
                    })
                };
    
                tiposDeParceiroEValores.push(grupoDeParceiros);
            }
        });
    
        return tiposDeParceiroEValores;
    };
    
    this.cdTipoParcToString = function(cdTipoParc) {
        var tipoDoParceiro;
        var crmu = CRM_Utilities;
        
        switch(cdTipoParc) {
            case 'CLIENTE':
                tipoDoParceiro = 'Cliente(s)';
                break;
                
            case 'PROSPECT':
                tipoDoParceiro = 'Prospect(s)';
                break;
                
            case 'CANDIDATO':
                tipoDoParceiro = 'Lead(s)';
                break;
                
            default:
                tipoDoParceiro = cdTipoParc;
                break;
        }
        
        return tipoDoParceiro;
    }
    
    /**
     * Verifica se o operador que está convertendo o lead em
     * caso, está sendo trabalhado por um operador diferente
     * do responsável.
     * 
     * @param {object} widget widget de conversão ("convertLeadInProspect").
    */
    this.getNewResponsibleOperatorForTheLead = function(widget){
        
        var leadWidgetCurrentRow = widget.parent.parent.currentRow;
        var conversionWidgetCurrentRow = widget.currentRow;
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        if(leadWidgetCurrentRow.NRPARCPROPRI !== loggedOperatorInfos.NRPARCNEGOCIO){
            conversionWidgetCurrentRow.NEWNRPARCPROPRI = loggedOperatorInfos.NRPARCNEGOCIO;
        }
        
    };
    
    this.atualizarAcoes = function(widget) {
        var status = widget.currentRow.IDSTATUSCAN;
        
        if(status == '3') { //QUALIFICADO
            widget.getAction('QUALIFY').isVisible = false;
            widget.getAction('DISQUALIFY').isVisible = true;
        } else if(status == '4') { //DESQUALIFICADO
            widget.getAction('QUALIFY').isVisible = true;
            widget.getAction('DISQUALIFY').isVisible = false;
        } else { //ABERTO
            widget.getAction('QUALIFY').isVisible = true;
            widget.getAction('DISQUALIFY').isVisible = true;
        }
    };
    
    /*
    *   Converte lead já preparado e verificado
    */
    this.convertValidLead = function(widget, currentRow, loggedOperatorInfos) {
        ScreenService.closePopup();
    
        currentRow.CEP = currentRow.NRCEPENDERECO;
        currentRow.NUMERO = currentRow.NRIMOVELENDERECO;
        currentRow.ENDERECO = currentRow.DSENDERECO;
        currentRow.COMPLEMENTO = currentRow.DSCOMPLEENDERECO;
    
        var parametroRestEngine = {
            'requestType': 'Row',
            'row': currentRow
        };
    
        var griWidget = templateManager.container.getWidget('gridLead');
        var evolWidget = templateManager.container.getWidget('evolucao');
        var nrparcnegocio = currentRow.NRPARCNEGOCIO;
        var parcResp = widget.parent.parent.currentRow.NRPARCPROPRI;
    
        restEngine.post('/insertProspect', parametroRestEngine,
            function(success) {
                if (success.dataset && success.dataset.error) {
                    ScreenService.closeSwipe(0);
                    widget.parent.parent.activate();
                    ScreenService.showMessage(success.dataset.error[0], "ERROR");
                } else {
                    //BEGIN RD Station
                    var contactWidgets = templateManager.container.getWidget('WDGT_INTERLOCUTOR');
                    contactWidgets.dataSourceFilter.forEach(function(filter) {
                        if (filter.name === 'NRPARCNEGOCIO')
                            filter.value = widget.currentRow.NRPARCNEGOCIO;
                    });
                    contactWidgets.reload().then(function() {
                        if (!Util.isEmptyOrBlank(contactWidgets.dataSource.data)) {
                            contactWidgets.dataSource.data.forEach(function(contact) {
                                restEngine.post('/IntegracaoRDStation/feedBackConversion', {
                                    'requestType': 'Row',
                                    'row': {
                                        EVENT_NAME: 'Cadastro convertido em prospect no CRM',
                                        EMAIL: contact['EMAILINTERLOC']
                                    }
                                }).then(function() {
                                    restEngine.post('/IntegracaoRDStation/changeFunnel', {
                                        'requestType': 'Row',
                                        'row': {
                                            FUNNEL: (currentRow.IDSTATUSCAN === "3") ? 'Qualified Lead' : 'Lead',
                                            EMAIL: contact['EMAILINTERLOC']
                                        }
                                    });
                                });
    
                            });
                        }
                    });
    
                    if (!Util.isEmptyOrBlank(griWidget.PARCUPDATE)) {
                        var rows = [];
    
                        griWidget.PARCUPDATE.forEach(function(parcnegocio, index) {
                            var row = {
                                NRPARCNEGOCIO: null,
                                NRORG: getLocalVar('CRM_NRORGTRAB'),
                                CRM_NRORGTRAB: getLocalVar('CRM_NRORGTRABALHO'),
                                DTINCLUSAO: moment().format('DD/MM/YYYY HH:mm:ss'),
                                CDOPERADOR: getLocalVar('CRM_CDOPERADOR'),
                                CDOPEREVOL: evolWidget.currentRow.CDOPEREVOL
                            };
    
                            row.NRPARCNEGOCIO = parcnegocio.NRPARCNEGOCIO;
                            rows.push(row);
                        });
    
                        restEngine.post('/setRelationshipPartnerStatus', {
                            'requestType': 'Row',
                            'row': rows
                        }).then(function(relation) {
                            if (relation.dataset && relation.dataset.error) {
                                ScreenService.showMessage(relation.dataset.error[0], "ERROR");
                            }
                        });
                    }
    
                    //END RD Station
                    ScreenService.successNotification('Lead convertido com sucesso!');
                    this.saveEvolucao(templateManager.evolutionWidget).then(function() {
                        ScreenService.closeSwipe(0).then(function() {
    
                            widget.parent.parent.activate();
                            CRM_Utilities.reloadGridInViewMode(widget.getParent());
                        }.bind(this));
                    }.bind(this));
                    if (templateManager.evolutionWidget.currentRow.IDENVIAEMAIL !== 'S' || Util.isEmptyOrBlank(templateManager.evolutionWidget.currentRow.NRSEQINTERLOCUTOR)) {
                        this.callRedirectForProspect(widget, parcResp, nrparcnegocio);
                    }
                }
            }.bind(this), undefined,
            function(error) {
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
            }
        );
    };
    /**
     * Procedimento para obrigar o usuário a
     * realizar uma evolução antes de converter
     * um lead em prospect.
     * 
     * @param {object} widget principal da tela de
     * lead.
    */
    this.openEvolutionSwipe = function(widget){
        var currentRow = widget.currentRow;
        var evolutionWidget = templateManager.container.getWidget('evolucao');

        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                if(widget.currentRow.IDSTATUSCAN === "3"){
                    this.verificaParametrizacaoProspect(widget.currentRow).then(function(response){
                            var excedeuLimite = response.dataset.DADOS.EXCEDEULIMITE;
                            if(!excedeuLimite) {
                                widget.openTab('evolucao');
                                ScreenService.closePopup();
                                
                                evolutionWidget.REALIZARCONVERCAO = true;
                                
                                setTimeout(function() {    
                                    this.evolucaoNewRow();
                                }.bind(this), 500);
                            }else{
                                var quantidadeProspects = response.dataset.DADOS.QUANTIDADE;
                                var limiteProspects = response.dataset.DADOS.LIMITE;
                                ScreenService.showMessage('Operação bloqueada! <br><br> Número máximo de prospects excedido. <br> Você possui: '+quantidadeProspects+' Prospects.<br> O limite de prospects por operador é: '+limiteProspects);
                            }
                        }.bind(this)
                    );
                }else{
                    ScreenService.showMessage("Lead não qualificado.");
                }
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    };
    
     /**
     * Verifica se o número de prospects daquele operador
     * excede o limite predefino na parametrização
     * 
     * @param {object} widget widget de evolução
    */
    this.verificaParametrizacaoProspect = function(currentRow) {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.NRPARCNEGOCIOOPER = loggedOperatorInfos.NRPARCNEGOCIO;
        
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        return restEngine.post('/verificaParametrizacaoProspect', paramsRestEngine);
    };
    
    /**
     * Procedimento para limpar o indicador
     * de conversão.
     * 
     * @param {object} widget widget de evolução.
    */
    this.cleanConversionIndicator = function(widget) {
        
        if(Boolean(widget.REALIZARCONVERCAO)) {
            delete widget.REALIZARCONVERCAO;
        }
        
    };
    
    /**
     * Procedimento para direcionar o sistema
     * para o ambiente de conversão após a realização de uma evolução.
     * 
     * @param {object} widget widget de evolução.
    */
    this.convertLeadAfterEvolution = function(widget) {
        
        if(widget.REALIZARCONVERCAO) {
            this.cleanConversionIndicator(widget);
            this.openSwipeConvertLeadInProspect(widget.parent.parent);
        }  
        
    };
    
    /**
     * Procedimento para abrir a tela de prospect
     * no sistema.
     * 
     * @param {object} widget widget de conversão.
    */
    this.openProspectWindowWithFilterByConvertedLead = function(widget) {
        
        ScreenService.openWindow('product#ger45000_prospect').then(function() {
            
            var prospectWidget = templateManager.container.getWidget('gridProspect');
            this.setProspectWidgetFilterByConvertedLead(widget, prospectWidget);
            prospectWidget.reload().then(function() {
                ScreenService.closePopup(true);
            });
            
        }.bind(this));
        
    };
    
    /**
     * Procedimento para setar a widget de prospect
     * pelo lead que está sendo convertido em caso.
     * 
     * @param {object} conversionWidget widget de conversão.
     * 
     * @param {object} prospectWidget widget principal da tela
     * de prospect.
    */
    this.setProspectWidgetFilterByConvertedLead = function(conversionWidget, prospectWidget) {
        
        var conversionWidgetCurrentRow = conversionWidget.currentRow;
        var tipoOperador = templateManager.LOGGEDOPERATOR.IDTPOPERADOR || 'E';
        var mainWid = conversionWidget.parent.parent;
        
        var filter = [
            {
                name: "NRPARCNEGOCIO",
                operator: "=",
                static: true,
                value: mainWid.currentRow.NRPARCNEGOCIO
            },
            {
                name: "NRORG",
                operator: "=",
                static: true,
                value: getLocalVar('CRM_NRORG')
            },
            {
                name: "IDTPOPERADOR",
                operator: "=",
                static: true,
                value: tipoOperador
            }
        ];
        
        prospectWidget.dataSourceFilter = filter;
    };
    
    this.openSwipeConvertLeadInProspect = function(widget) {
        var convertWidget = templateManager.container.getWidget('convertLeadInProspect');
        
        ScreenService.closeSwipe().then(function() {
            widget.view();
            ScreenService.openSwipe(convertWidget).then(function() {
                convertWidget.activate();
                convertWidget.newRow();
                convertWidget.redraw();
                var currentRow = convertWidget.currentRow;
            
                currentRow.NMCANDIDATO = convertWidget.parent.parent.currentRow.NMCANDIDATO;
                currentRow.NMFANTCAN = convertWidget.parent.parent.currentRow.NMFANTCAN;
                
                currentRow.DATAFUNDACAO = "";
                
                currentRow.DSENDERECO = convertWidget.parent.parent.currentRow.DSENDERECO;
                currentRow.NRIMOVELENDERECO = parseInt(convertWidget.parent.parent.currentRow.NRIMOVELENDERECO);
                currentRow.NRCEPENDERECO = convertWidget.parent.parent.currentRow.NRCEPENDERECO;
                currentRow.DSCOMPLEENDERECO = convertWidget.parent.parent.currentRow.DSCOMPLEENDERECO;
                currentRow.LATITUDE = "";
                currentRow.LONGITUDE = "";
                currentRow.CDCARGOINTERLOC = "";
                currentRow.DSCARGINPROS = "";
                currentRow.DTNASCIFUNDPARC = convertWidget.parent.parent.currentRow.DTNASCIFUNDPARC;
                currentRow.NRORG = templateManager.LOGGEDOPERATOR.NRORG;
                currentRow.NRPARCNEGOCIO = widget.currentRow.NRPARCNEGOCIO;
                currentRow.IDATIVO = 'S';
                currentRow.CDOPERULTATU = widget.currentRow.CDOPERULTATU;
                currentRow.PARCORIGINAL = widget.currentRow.NRPARCNEGOCIO;
                currentRow.__is_new = false;
                
                this.getLocalFound(convertWidget.parent.parent.currentRow);
                this.getLeadInforForConversionToProspect(widget);
                this.requireInterlocutorFields(convertWidget);
                this.validaInscricao(convertWidget, false, true, false);
                    
            }.bind(this));
        }.bind(this));
    };
    
    /**
     * Verifica se o prospect é pessoa jurídica ou física, ou se já possui interlocutor
     * obriga o usuário a inserir um interlocutor em caso de pesoa jurídica sem interlocutor
     * 
     * @param {object} widget widget de conversão de lead.
    */
    this.requireInterlocutorFields = function(widget) {
        
        var interlocutorField = widget.getField('NMINTERLOCUTOR');
        var interlocutorPhoneField = widget.getField('DSTELEFONEINTERLOCUTOR');
        var inscription = widget.currentRow.NRINSJURCAN.replace(/[^0-9]/g, '');
        var interlocutorEmailField = widget.getField('DSEMAILINTERLOCUTOR');
        
        if((inscription.length === 11) || widget.currentRow.IDTPIJURCAN === 'F' || this.getInterlocutorLead(widget)) {
            delete interlocutorField.validations.required; 
            delete interlocutorPhoneField.validations.required; 
            delete interlocutorEmailField.validations.required;
        }else{
            interlocutorField.validations["required"] = true; 
            interlocutorPhoneField.validations["required"] = true;
            interlocutorEmailField.validations["required"] = true;
        }
        
    };
    
    this.getInterlocutorLead = function(widget) {
        var widgetInterlocutor = templateManager.container.getWidget('WDGT_INTERLOCUTOR');
        var interlocutores = widgetInterlocutor.dataSource.data;
        
        if(Util.isEmptyOrBlank(interlocutores)) {
            widgetInterlocutor.reload().then(function() {
                interlocutores = widgetInterlocutor.dataSource.data;
                if(Util.isEmptyOrBlank(interlocutores))
                    return false;
                else
                    return true;
            });
        }else{
            return true;
        }
    }
    
    this.openSwipeFundirParceiro = function() {

        var widget = templateManager.container.getWidget('FUNDIR');
        
        widget.activate();
        widget.newRow();
        
        ScreenService.openSwipe(widget);
        
    };
    
    this.autofillData = function(widget, fromProspect) {

        var currentRow = widget.currentRow;
        if(fromProspect) {
            currentRow.NUMBERINSC = currentRow.NRINSJURPROS ? currentRow.NRINSJURPROS.replace(/[^0-9]/g,'') : "";    
        }else if(widget.name === 'gridCliente') {
            currentRow.NUMBERINSC = currentRow.NRINSJURCLIE ? currentRow.NRINSJURCLIE.replace(/[^0-9]/g,'') : "";
        } else {
            if(currentRow.NRINSJURCAN.match(/^[A-Za-z]([0-9]){8}$/gm)){
                currentRow.NUMBERINSC = currentRow.NRINSJURCAN;
            }else{
                currentRow.NUMBERINSC = currentRow.NRINSJURCAN ? currentRow.NRINSJURCAN.replace(/[^0-9]/g,'') : "";
            }
        }
        
        if(currentRow.NUMBERINSC.length === 14) {
        
            ScreenService.confirmMessage("Deseja buscar as informações pelo CNPJ?", "question", function() {
        
                var parametroRestEngine = {
                    'requestType':'Row',
                    'row': {'NUMBERINSC': currentRow.NUMBERINSC}
                };
                
                restEngine.post('/consultaRF', parametroRestEngine,
                    function(success) {
                        var dadosReceitaFederal = success.dataset.CONSULTA;
                        if(Boolean(dadosReceitaFederal.Mensagem) && dadosReceitaFederal.Mensagem === 'Saldo Insuficiente ou Contrato com Pendencias') {
                            ScreenService.showMessage(dadosReceitaFederal.Mensagem);
                        }
                        else if(dadosReceitaFederal.SituacaoRFB !== "ATIVA") {
                            ScreenService.showMessage("Lead Inativo na receita.");
                        }else{
                            self.fillWithCurrentRowReturnedValues(widget, dadosReceitaFederal);
                            ScreenService.showMessage("Consulta realizada com sucesso.");
                        }
                    }, undefined, 
                    function(error) {
                        console.log(error);
                    }, null, 3000000
                );
                ScreenService.closePopup();
            });
        }
        
    };
    
    this.fillWithCurrentRowReturnedValues = function(widget, returnedValues) {
        
        
        var currentRow = widget.currentRow;
        
        if (widget.getField('NMCANDIDATO')) {
            currentRow.NMCANDIDATO = returnedValues.RazaoSocial;
            currentRow.NMFANTCAN = returnedValues.NomeFantasia;
        } else if(widget.name === 'gridCliente') {
            currentRow.NMRAZSOCCLIE = returnedValues.RazaoSocial;
            currentRow.NMFANTCLIE = returnedValues.NomeFantasia;
        } else {
            currentRow.NMRAZSOCPROS = returnedValues.RazaoSocial;
            currentRow.NMFANTPROS = returnedValues.NomeFantasia;
        }
        
        currentRow.NMPAIS = "Brasil";
        currentRow.CDPAIS = "0055";
        
        currentRow.NRIMOVELENDERECO = parseInt(returnedValues.Enderecos.Numero);
        currentRow.DSCOMPLEENDERECO = returnedValues.Enderecos.Complemento;
        currentRow.DSENDERECO = returnedValues.Enderecos.Logradouro;
        currentRow.NRCEPENDERECO = returnedValues.Enderecos.CEP;

        currentRow.DSTELEFONECAN = (currentRow.DSTELEFONECAN === "") ? returnedValues.Telefone : currentRow.DSTELEFONECAN;
        if((currentRow.DSEMAILCAN === "") && typeof returnedValues.Email !== "undefined") {
            currentRow.DSEMAILCAN = returnedValues.Email;
        }
        currentRow.DATAFUNDACAO = returnedValues.DataFundacao;
        currentRow.LATITUDE = returnedValues.Enderecos.GeoLocalizacao.Latitude;
        currentRow.LONGITUDE = returnedValues.Enderecos.GeoLocalizacao.Longitude;
        
        this.localizationFill(currentRow, returnedValues);
        this.getLocalFound(currentRow);        
        
        widget.getField('NMESTADO').readOnly    = false;
        widget.getField('NMMUNICIPIO').readOnly = false;
        
        if(widget.getField('NMBAIRRO')) {
            widget.getField('NMBAIRRO').readOnly = false;
        } else {
            widget.getField('NMBAIRROCAN').readOnly = false;
        }
    };
    
    this.localizationFill = function(currentRow ,values) {
        
        var parametroRestEngine = {
            'requestType':'Row',
            'row': {'RESULTCONSUL': values}
        };

        restEngine.post('/ConfirmationLocation', parametroRestEngine,
            function(success) {
                var localization = success.dataset.LOCALIZACAO;
                currentRow.NMESTADO = localization[0].NMESTADO;
                currentRow.SGESTADO = localization[0].SGESTADO;
                currentRow.NMMUNICIPIO = localization[1].NMMUNICIPIO;
                currentRow.CDMUNICIPIO = localization[1].CDMUNICIPIO;
                currentRow.NMBAIRRO = (!Util.isUndefined(localization[2].NMBAIRRO)) ? localization[2].NMBAIRRO : values.Enderecos.BAIRRO;
                currentRow.NMBAIRROCAN = (!Util.isUndefined(localization[2].NMBAIRRO)) ? localization[2].NMBAIRRO : values.Enderecos.BAIRRO;
                currentRow.CDBAIRRO = (!Util.isUndefined(localization[2].CDBAIRRO)) ? localization[2].CDBAIRRO : null;
                
            }, undefined, 
            function(error) {
                ScreenService.showMessage("Operação não concluida, Tente Novamente");
            }
        ); 
        
    };
    
    this.CancelForm = function() {
        var widget = templateManager.container.getActiveWidget();
        
        this.cleanEvolutionWidgetInTemplateManager();
        
        ScreenService.closeSwipe().then(function() {
            self.cleanWidgetFields(widget);
            widget.parent.parent.view();
            widget.parent.parent.activate();
        });
    };
    
    this.inserNewTask = function(widget) {
        var currentRow = widget.currentRow;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.NRPARCNEGOCIO = loggedOperatorInfos.NRPARCNEGOCIO;
        currentRow.NMPARCRESP = loggedOperatorInfos.NMOPERADOR;
        currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
    };
    
    this.convertValidLead = function(widget, currentRow, loggedOperatorInfos) {
        ScreenService.closePopup();
    
        currentRow.CEP = currentRow.NRCEPENDERECO;
        currentRow.NUMERO = currentRow.NRIMOVELENDERECO;
        currentRow.ENDERECO = currentRow.DSENDERECO;
        currentRow.COMPLEMENTO = currentRow.DSCOMPLEENDERECO;
    
        var parametroRestEngine = {
            'requestType': 'Row',
            'row': currentRow
        };
    
        var griWidget = templateManager.container.getWidget('gridLead');
        var evolWidget = templateManager.container.getWidget('evolucao');
        var nrparcnegocio = currentRow.NRPARCNEGOCIO;
        var parcResp = widget.parent.parent.currentRow.NRPARCPROPRI;
    
        restEngine.post('/insertProspect', parametroRestEngine,
            function(success) {
                if (success.dataset && success.dataset.error) {
                    ScreenService.closeSwipe(0);
                    widget.parent.parent.activate();
                    ScreenService.showMessage(success.dataset.error[0], "ERROR");
                } else {
                    //BEGIN RD Station
                    var contactWidgets = templateManager.container.getWidget('WDGT_INTERLOCUTOR');
                    contactWidgets.dataSourceFilter.forEach(function(filter) {
                        if (filter.name === 'NRPARCNEGOCIO')
                            filter.value = widget.currentRow.NRPARCNEGOCIO;
                    });
                    contactWidgets.reload().then(function() {
                        if (!Util.isEmptyOrBlank(contactWidgets.dataSource.data)) {
                            contactWidgets.dataSource.data.forEach(function(contact) {
                                restEngine.post('/IntegracaoRDStation/feedBackConversion', {
                                    'requestType': 'Row',
                                    'row': {
                                        EVENT_NAME: 'Cadastro convertido em prospect no CRM',
                                        EMAIL: contact['EMAILINTERLOC']
                                    }
                                }).then(function() {
                                    restEngine.post('/IntegracaoRDStation/changeFunnel', {
                                        'requestType': 'Row',
                                        'row': {
                                            FUNNEL: (currentRow.IDSTATUSCAN === "3") ? 'Qualified Lead' : 'Lead',
                                            EMAIL: contact['EMAILINTERLOC']
                                        }
                                    });
                                });
    
                            });
                        }
                    });
    
                    if (!Util.isEmptyOrBlank(griWidget.PARCUPDATE)) {
                        var rows = [];
    
                        griWidget.PARCUPDATE.forEach(function(parcnegocio, index) {
                            var row = {
                                NRPARCNEGOCIO: null,
                                NRORG: getLocalVar('CRM_NRORGTRAB'),
                                CRM_NRORGTRAB: getLocalVar('CRM_NRORGTRABALHO'),
                                DTINCLUSAO: moment().format('DD/MM/YYYY HH:mm:ss'),
                                CDOPERADOR: getLocalVar('CRM_CDOPERADOR'),
                                CDOPEREVOL: evolWidget.currentRow.CDOPEREVOL
                            };
    
                            row.NRPARCNEGOCIO = parcnegocio.NRPARCNEGOCIO;
                            rows.push(row);
                        });
    
                        restEngine.post('/setRelationshipPartnerStatus', {
                            'requestType': 'Row',
                            'row': rows
                        }).then(function(relation) {
                            if (relation.dataset && relation.dataset.error) {
                                ScreenService.showMessage(relation.dataset.error[0], "ERROR");
                            }
                        });
                    }
    
                    //END RD Station
                    ScreenService.successNotification('Lead convertido com sucesso!');
                    this.saveEvolucao(templateManager.evolutionWidget).then(function() {
                        ScreenService.closeSwipe(0).then(function() {
    
                            widget.parent.parent.activate();
                            CRM_Utilities.reloadGridInViewMode(widget.getParent());
                        }.bind(this));
                    }.bind(this));
                    if (templateManager.evolutionWidget.currentRow.IDENVIAEMAIL !== 'S' || Util.isEmptyOrBlank(templateManager.evolutionWidget.currentRow.NRSEQINTERLOCUTOR)) {
                        this.callRedirectForProspect(widget, parcResp, nrparcnegocio);
                    }
                }
            }.bind(this), undefined,
            function(error) {
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
            }
        );
    };
    
    self.editTask = function() {
        var widget = templateManager.container.getActiveWidget();
        var currentRow = widget.currentRow;
        
        currentRow.NRPARCNEGOCIO = widget.getParent().currentRow.NRPARCNEGOCIO;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                General.widgetEdit(widget);
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    };

    function formatCEP(cepSemMascara, formato) {
        const regex = new RegExp(formato.regex, 'g');
        return cepSemMascara.replace(regex, formato.formato);
    }

    this.validateMask = function(field) {
        var nrCepEndereco = field.currentRow.NRCEPENDERECO;
    
        if (!Util.isEmptyOrBlank(nrCepEndereco)) {
            var cepSemMascara = nrCepEndereco.replace(/\D/g, '');
            var formatos = [
                { length: 4, regex: /^(\d{2})(\d{2})$/, formato: '$1$2' },
                { length: 5, regex: /^(\d{2})(\d{3})$/, formato: '$1$2' },
                { length: 6, regex: /^(\d{3})(\d{3})$/, formato: '$1-$2' },
                { length: 7, regex: /^(\d{3})(\d{4})$/, formato: '$1-$2' },
                { length: 8, regex: /^(\d{2})(\d{3})(\d{3})$/, formato: '$1.$2-$3' }
            ];
    
            var formatoEncontrado = null;
    
            for (var i = 0; i < formatos.length; i++) {
                var formato = formatos[i];
                if (nrCepEndereco.length === formato.length) {
                    formatoEncontrado = formato;
                    break;
                }
            }
    
            if (formatoEncontrado) {
                field.currentRow.NRCEPENDERECO = formatCEP(cepSemMascara, formatoEncontrado);
                field.reload();
            }
        }
    };

    function detectCountryCode(phoneWithoutMask) {
        const countryCodes = [
            { key: '1', value: 'US' },   // United States --Tem Validação
            { key: '1', value: 'CA' },   // Canada --Tem Validação
            { key: '1', value: 'DO' },   // Dominican Republic --Tem Validação
            { key: '1', value: 'JM' },   // Jamaica --Tem Validação
            { key: '1', value: 'PR' },   // Puerto Rico --Tem Validação
            { key: '51', value: 'PE' },  // Peru
            { key: '504', value: 'HN' }, // Honduras
            { key: '597', value: 'SR' }, // Suriname
            { key: '592', value: 'GY' }, // Guyana
            { key: '501', value: 'BZ' }, // Belize
            { key: '34', value: 'ES' },  // Spain --Tem Validação
            { key: '351', value: 'PT' }, // Portugal
            { key: '39', value: 'IT' },  // Italy --Tem Validação
            { key: '595', value: 'PY' }, // Paraguay
            { key: '58', value: 'VE' },  // Venezuela
            { key: '54', value: 'AR' },  // Argentina --Tem Validação
            { key: '55', value: 'BR' },  // Brazil --Tem Validação
            { key: '56', value: 'CL' },  // Chile
            { key: '33', value: 'FR' },  // France --Tem Validação
            { key: '46', value: 'SE' },  // Sweden
            { key: '44', value: 'UK' },  // United Kingdom --Tem Validação
            { key: '57', value: 'CO' },  // Colombia --Tem Validação
            { key: '52', value: 'MX' },  // Mexico --Tem Validação
            { key: '591', value: 'BO' }, // Bolivia
            { key: '598', value: 'UY' }, // Uruguay
            { key: '218', value: 'LY' }, // Libya
            { key: '244', value: 'AO' }, // Angola 
            { key: '213', value: 'DZ' }, // Algeria
            { key: '507', value: 'PA' }, // Panama
            { key: '234', value: 'NG' }, // Nigeria --Tem Validação
            { key: '27', value: 'ZA' },  // South Africa --Tem Validação
            { key: '971', value: 'AE' }, // United Arab Emirates --Tem Validação
            { key: '297', value: 'AW' }, // Aruba
            { key: '506', value: 'CR' }, // Costa Rica
            { key: '62', value: 'ID' },  // Indonesia
            { key: '966', value: 'SA' }, // Saudi Arabia --Tem Validação
            { key: '61', value: 'AU' },  // Australia --Tem Validação
            { key: '356', value: 'MT' }, // Malta
            { key: '248', value: 'SC' }, // Seychelles
            { key: '353', value: 'IE' }, // Ireland
            { key: '91', value: 'IN' },  // India --Tem Validação
            { key: '679', value: 'FJ' }, // Fiji
            { key: '254', value: 'KE' }, // Kenya --Tem Validação
            { key: '66', value: 'TH' },  // Thailand
            { key: '84', value: 'VN' },  // Vietnam
            { key: '86', value: 'CN' },  // China --Tem Validação
            { key: '49', value: 'DE' },  // Germany --Tem Validação
            { key: '43', value: 'AT' },  // Austria
            { key: '20', value: 'EG' },  // Egypt --Tem Validação
            { key: '81', value: 'JP' },  // Japan --Tem Validação
            { key: '41', value: 'CH' },  // Switzerland
            { key: '94', value: 'LK' },  // Sri Lanka
            { key: '65', value: 'SG' },  // Singapore --Tem Validação
            { key: '31', value: 'NL' },  // Netherlands
            { key: '40', value: 'RO' },  // Romania
            { key: '852', value: 'HK' }, // Hong Kong --Tem Validação
            { key: '593', value: 'EC' }, // Ecuador
            { key: '961', value: 'LB' }, // Lebanon
            { key: '503', value: 'SV' }, // El Salvador 
            { key: '502', value: 'GT' }, // Guatemala
            { key: '972', value: 'IL' }, // Israel --Tem Validação
            { key: '82', value: 'KR' },  // Coreia do Sul --Tem Validação
            { key: '886', value: 'TW' }, // Taiwan --Tem Validação
        ];
    
        var countryCodeInfo = null;

        for (var i = 0; i < countryCodes.length; i++) {
            var entry = countryCodes[i];
            if (phoneWithoutMask.startsWith(entry.key)) {
                countryCodeInfo = entry;
                break;
            }
        }
    
        return countryCodeInfo;

    }

    function formatPhoneNumber(phoneWithoutMask, countryCode, country) {
        var format = {};

        if (phoneWithoutMask && phoneWithoutMask.length) {
            switch (true) {
                case country === '0055' && countryCode === 'BR':
                    switch (Util.isEmptyOrBlank(phoneWithoutMask)) {
                        case phoneWithoutMask.length === 10:
                            format = { regex: /^(\d{2})(\d{4})(\d{4})$/, format: '($1) $2-$3' };
                            break;
                        case phoneWithoutMask.length === 11:
                            format = { regex: /^(\d{2})(\d{5})(\d{4})$/, format: '($1) $2-$3' };
                            break;
                        case phoneWithoutMask.length === 12:
                            format = { regex: /^(\d{2})(\d{2})(\d{4})(\d{4})$/, format: '+$1 ($2) $3-$4' };
                            break;
                        case phoneWithoutMask.length === 13:
                            format = { regex: /^(\d{2})(\d{2})(\d{5})(\d{4})$/, format: '+$1 ($2) $3-$4' };
                            break;
                        default:
                            return phoneWithoutMask;
                    }
                    break;
                case phoneWithoutMask.length === 11 && (countryCode.value === 'US' || countryCode.value === 'CA' || countryCode.value === 'DO' || countryCode.value === 'JM' || countryCode.value === 'PR'):
                    format = { regex: /^(\d{1})(\d{3})(\d{3})(\d{4})$/, format: '+$1 ($2) $3-$4' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'UK':
                    format = { regex: /^(\d{2})(\d{2})(\d{4})(\d{4})$/, format: '+($1) $2 $3-$4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'AU':
                    format = { regex: /^(\d{2})(\d{4})(\d{4})$/, format: '+$1 $2 $3' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'IN':
                    format = { regex: /^(\d{2})(\d{2})(\d{4})(\d{4})$/, format: '+$1 $2 $3 $4' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'CN':
                    format = { regex: /^(\d{3})(\d{3})(\d{4})(\d{2})$/, format: '+$1 $2 $3 $4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'JP':
                    format = { regex: /^(\d{2})(\d{3})(\d{4})$/, format: '+$1 $2 $3' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'DE':
                    format = { regex: /^(\d{2})(\d{2})(\d{4})(\d{4})$/, format: '+$1 $2 $3 $4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'FR':
                    format = { regex: /^(\d{2})(\d{1})(\d{2})(\d{2})(\d{2})$/, format: '+$1 $2 $3 $4 $5' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'MX':
                    format = { regex: /^(\d{2})(\d{2})(\d{4})(\d{4})$/, format: '+$1 $2 $3 $4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'RU':
                    format = { regex: /^(\d{1})(\d{3})(\d{3})(\d{2})(\d{2})$/, format: '+$1 ($2) $3-$4-$5' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'IT':
                    format = { regex: /^(\d{2})(\d{2})(\d{4})(\d{4})$/, format: '+$1 $2 $3 $4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'ES':
                    format = { regex: /^(\d{2})(\d{3})(\d{2})(\d{2})(\d{2})$/, format: '+$1 $2 $3 $4 $5' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'IL':
                    format = { regex: /^(\d{3})(\d{2})(\d{3})(\d{4})$/, format: '+$1 ($2) $3-$4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'AE':
                    format = { regex: /^(\d{3})(\d{2})(\d{3})(\d{4})$/, format: '+$1 ($2) $3 $4' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'SA':
                    format = { regex: /^(\d{3})(\d{2})(\d{3})(\d{4})$/, format: '+$1 ($2) $3 $4' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'KR':
                    format = { regex: /^(\d{2})(\d{2})(\d{4})(\d{4})$/, format: '+$1 ($2) $3-$4' };
                    break;
                case phoneWithoutMask.length === 10 && countryCode.value === 'SG':
                    format = { regex: /^(\d{2})(\d{4})(\d{4})$/, format: '+$1 $2-$3' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'HK':
                    format = { regex: /^(\d{3})(\d{4})(\d{4})$/, format: '+$1 $2 $3' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'TW':
                    format = { regex: /^(\d{3})(\d{4})(\d{4})$/, format: '+$1 $2 $3' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'AR':
                    format = { regex: /^(\d{2})(\d{3})(\d{3})(\d{4})$/, format: '+$1 ($2) $3-$4' };
                    break;
                case phoneWithoutMask.length === 10 && countryCode.value === 'CO':
                    format = { regex: /^(\d{1})(\d{3})(\d{4})$/, format: '+$1 $2 $3' };
                    break;
                case phoneWithoutMask.length === 10 && countryCode.value === 'NZ':
                    format = { regex: /^(\d{1})(\d{3})(\d{4})$/, format: '+$1 $2 $3' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'ZA':
                    format = { regex: /^(\d{2})(\d{3})(\d{4})$/, format: '+$1 $2 $3 $4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'NG':
                    format = { regex: /^(\d{3})(\d{1})(\d{4})(\d{4})$/, format: '+$1 $2 $3 $4' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'EG':
                    format = { regex: /^(\d{2})(\d{2})(\d{4})(\d{4})$/, format: '+$1 $2 $3 $4' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'KE':
                    format = { regex: /^(\d{3})(\d{2})(\d{4})(\d{4})$/, format: '+$1 $2 $3 $4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'PE':
                    format = { regex: /^(\d{2})(\d{3})(\d{3})(\d{3})$/, format: '+$1 $2 $3-$4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'HN':
                    format = { regex: /^(\d{3})(\d{4})(\d{4})$/, format: '+$1 $2-$3' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'GY' || countryCode.value === 'BZ':
                    format = { regex: /^(\d{3})(\d{3})(\d{4})$/, format: '+$1 $2-$3' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'PT' || countryCode.value === 'PY' || countryCode.value === 'AO':
                    format = { regex: /^(\d{3})(\d{3})(\d{3})(\d{3})$/, format: '+$1 ($2) $3 $4' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'VE':
                    format = { regex: /^(\d{2})(\d{3})(\d{3})(\d{4})$/, format: '+$1 ($2) $3 $4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'CL':
                    format = { regex: /^(\d{2})(\d{1})(\d{4})(\d{4})$/, format: '+$1 ($2) $3 $4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'SE':
                    format = { regex: /^(\d{2})(\d{2})(\d{3})(\d{2})(\d{2})$/, format: '+$1 ($2) $3 $4 $5' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'BO' || countryCode.value === 'GT':
                    format = { regex: /^(\d{3})(\d{4})(\d{4})$/, format: '+$1 $2 $3' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'UY':
                    format = { regex: /^(\d{3})(\d{2})(\d{3})(\d{3})$/, format: '+$1 ($2) $3 $4' };
                    break;
                case phoneWithoutMask.length === 9 && countryCode.value === 'SR':
                    format = { regex: /^(\d{3})(\d{3})(\d{3})$/, format: '+$1 $2-$3' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'LY':
                    format = { regex: /^(\d{3})(\d{2})(\d{3})(\d{4})$/, format: '+$1 ($2) $3 $4' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'DZ':
                    format = { regex: /^(\d{3})(\d{4})(\d{3})(\d{2})$/, format: '+$1 ($2) $3 $4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'PA' || countryCode.value === 'CR' || countryCode.value === 'MT' || countryCode.value === 'SV':
                    format = { regex: /^(\d{3})(\d{4})(\d{4})$/, format: '+$1 $2-$3' };
                    break;
                case phoneWithoutMask.length === 13 && countryCode.value === 'ID':
                    format = { regex: /^(\d{2})(\d{3})(\d{4})(\d{4})$/, format: '+$1 $2-$3-$4' };
                    break;
                case phoneWithoutMask.length === 10 && countryCode.value === 'SC':
                    format = { regex: /^(\d{3})(\d{1})(\d{3})(\d{3})$/, format: '+$1 $2 $3 $4' };
                    break;
                case phoneWithoutMask.length === 10 && countryCode.value === 'FJ':
                    format = { regex: /^(\d{3})(\d{3})(\d{4})$/, format: '+$1 $2-$3' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'IE':
                    format = { regex: /^(\d{3})(\d{2})(\d{3})(\d{4})$/, format: '+$1 $2 $3 $4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'TH':
                    format = { regex: /^(\d{2})(\d{2})(\d{3})(\d{4})$/, format: '+$1 $2-$3-$4' };
                    break;
                case phoneWithoutMask.length === 10 && countryCode.value === 'AW':
                    format = { regex: /^(\d{3})(\d{3})(\d{4})$/, format: '+$1 $2-$3' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'VN' || countryCode.value === 'LK':
                    format = { regex: /^(\d{2})(\d{2})(\d{3})(\d{4})$/, format: '+$1 ($2) $3-$4' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'AT':
                    format = { regex: /^(\d{2})(\d{3})(\d{7})$/, format: '+$1 ($2) $3' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'CH':
                    format = { regex: /^(\d{2})(\d{2})(\d{3})(\d{2})(\d{2})$/, format: '+$1 ($2) $3-$4-$5' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'NL':
                    format = { regex: /^(\d{2})(\d{1})(\d{8})$/, format: '+$1 ($2) $3' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'RO':
                    format = { regex: /^(\d{2})(\d{3})(\d{3})(\d{3})$/, format: '+$1 $2-$3-$4' };
                    break;
                case phoneWithoutMask.length === 11 && countryCode.value === 'RO':
                    format = { regex: /^(\d{3})(\d{2})(\d{3})(\d{3})$/, format: '+$1 $2-$3-$4' };
                    break;
                case phoneWithoutMask.length === 12 && countryCode.value === 'EC' || countryCode.value === 'LB':
                    format = { regex: /^(\d{3})(\d{2})(\d{3})(\d{3})$/, format: '+$1 $2-$3-$4' };
                    break;
                default:
            }

            const formattedNumber = phoneWithoutMask.replace(format.regex, format.format);
            return formattedNumber;
        } else {
            return formattedNumber = "";
        }
    }

    function validateMaskPhone(field) {
        var country;
        var numberPhones = [];
    
        switch (true) {
            case field.name === "gridLead":
                country = Util.isEmptyOrBlank(field.currentRow.CDPAIS) ? '0055' : field.currentRow.CDPAIS;
                numberPhones.push(field.currentRow.DSTELEFONECAN);
                break;
            case field.name === "WDGT_INTERLOCUTOR":
                country = field.currentRow.CDPAIS === null ? '0055' : field.currentRow.CDPAIS;
                numberPhones.push(field.currentRow.NRTELEFONE1);
                numberPhones.push(field.currentRow.NRTELEFONE2);
                numberPhones.push(field.currentRow.NRTELEFONE3);
                numberPhones.push(field.currentRow.NRTELEFONE4);
                break;
        }
    
        for (var i = 0; i < numberPhones.length; i++) {
            var numberPhone = numberPhones[i];
            if (Util.isEmptyOrBlank(numberPhone)) {
                continue;
            }
    
            var phoneWithoutMask = numberPhone ? numberPhone.replace(/\D/g, '') : '';
            var countryCode = country === '0055' ? 'BR' : detectCountryCode(phoneWithoutMask);
            var formattedNumber = formatPhoneNumber(phoneWithoutMask, countryCode, country);
    
            if (formattedNumber) {
                switch (field.name) {
                    case "gridLead":
                        field.currentRow.DSTELEFONECAN = formattedNumber;
                        break;
                    case "WDGT_INTERLOCUTOR":
                        for (var j = 1; j <= 4; j++) {
                            var fieldName = "NRTELEFONE" + j;
                            field.currentRow[fieldName] = formatPhoneNumber(
                                field.currentRow[fieldName],
                                countryCode,
                                country
                            );
                        }
                        break;
                }
                field.reload();
            }
        }
    }
    
    var MESSAGES = {
        INVALID_PHONE: "O número de Telefone informado não Corresponde ao País Selecionado."
    };

    // this.validatePhoneType = function (field){

    //     const currentPhone = field.value();
    //     const currentCountry = field.widget.currentRow.CDPAIS === null ? '0055' : field.widget.currentRow.CDPAIS;
    //     const countryWithoutZeros = parseInt(currentCountry, 10).toString();
    //     const currentPhoneWhitoutMask = currentPhone.replace(/\D/g, '');
        
    //     if (!Util.isEmptyOrBlank(currentCountry) && !Util.isEmptyOrBlank(currentPhoneWhitoutMask) && currentCountry !== '0055') {
    //         const {key: codeCountry} = detectCountryCode(currentPhoneWhitoutMask);
    //         if (countryWithoutZeros !== codeCountry){
    //             ScreenService.showMessage(MESSAGES.INVALID_PHONE)
    //         }
    //     }
    // }

    /**
     * Função para buscar e setar 
     * na currentRow do endereço em cadastro,
     * o endereço retornado da pesquisa pelo CEP.
     * 
     * @param {object(widget)} widget que receberá
     * em sua currentRow, o endereço retornado.
    */
    this.searchAddress = function(widget) {
        
        var currentRow = widget.currentRow;
        const nrCepEndereco = widget.currentRow.NRCEPENDERECO;
        const cepSemMascara = nrCepEndereco.replace(/\D/g, '');
        
        if((currentRow.CEP || currentRow.NRCEPENDERECO) && cepSemMascara.length === 8) {
        
            ScreenService.confirmMessage("Deseja buscar o endereço pelo CEP informado?", "question", function() {
                
                var CEP = currentRow.CEP || currentRow.NRCEPENDERECO;
                
                Endereco.buscarCep(CEP).then(function(response) {
                    
                    var addressFound = response.dataset.ENDERECO;
                    
                    if(addressFound) {
                            
                            currentRow.NMPAIS = "Brasil";
                            currentRow.CDPAIS = "0055";
                            currentRow.NMESTADO = addressFound.NMESTADO;
                            currentRow.SGESTADO = addressFound.SGESTADO;
                            currentRow.NMMUNICIPIO = addressFound.NMMUNICIPIO;
                            currentRow.CDMUNICIPIO = addressFound.CDMUNICIPIO;
                            currentRow.NMBAIRRO = addressFound.NMBAIRRO;
                            currentRow.NMBAIRROCAN = addressFound.NMBAIRRO;
                            currentRow.CDBAIRRO = addressFound.CDBAIRRO;
                            
                            /*Controle de Readonly fields de Endereço*/
                            widget.getField('NMPAIS').readOnly = false;
                            widget.getField('NMESTADO').readOnly = false;
                            widget.getField('NMMUNICIPIO').readOnly = false;
                            if(typeof widget.getField('NMBAIRROCAN') !== "undefined") 
                                widget.getField('NMBAIRROCAN').readOnly = false;
                            if(typeof widget.getField('NMBAIRRO') !== "undefined") 
                                widget.getField('NMBAIRRO').readOnly = false;
                            
                            this.setAddressDescriptionFoundInCurrentRow(currentRow, addressFound);
                            this.getLocalFound(currentRow);
                            
                            /*TODO Encontrar um jeito melhor de fazer o autocomplete atualizar os fields para os dados da currentRow*/
                            angular.element('#footer').click();
                        
                    }else{
                        currentRow.CEP = '';
                        currentRow.NRCEPENDERECO = '';
                    }
                    
                    if(response.dataset.ERRO) {
                        ScreenService.showMessage(response.dataset.ERRO.MESSAGE, "warning");
                    }
                    
                }.bind(this)).catch(function(error) {
                    ScreenService.showMessage(error.error);
                });
                
            }.bind(this), null);
        
        }
    };
    
    this.setAddressDescriptionFoundInCurrentRow = function(currentRow, addressResult) {
        
        currentRow.DSENDERECO = (addressResult.DSENDERECO)? addressResult.DSENDERECO : '';
        currentRow.ENDERECO = (addressResult.DSENDERECO)? addressResult.DSENDERECO : '';
        
    };

    this.getLocalFound = function(currentRow) {
        
        selectedcountry = currentRow.NMPAIS;
        selectedstate = currentRow.NMESTADO;
        selectedmunicipality = currentRow.NMMUNICIPIO;
        
    };
    
    this.getLeadInforForConversionToProspect = function() {
        
        var widget = templateManager.container.getWidget("convertLeadInProspect");
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        var parentWidgetCurrentRow = widget.parent.parent.currentRow;
        var widgetCurrentRow = widget.currentRow;
        
        widgetCurrentRow.NRINSJURCAN = (parentWidgetCurrentRow.NRINSJURCAN) ? parentWidgetCurrentRow.NRINSJURCAN : "";
        widgetCurrentRow.IDTPIJURCAN = (parentWidgetCurrentRow.IDTPIJURCAN) ? parentWidgetCurrentRow.IDTPIJURCAN : "";
        widgetCurrentRow.DSSEGMER = (parentWidgetCurrentRow.DSSEGMER) ? parentWidgetCurrentRow.DSSEGMER : "";
        widgetCurrentRow.CDSEGMER= (parentWidgetCurrentRow.CDSEGMER) ? parentWidgetCurrentRow.CDSEGMER : "";
        widgetCurrentRow.NMPAIS = (parentWidgetCurrentRow.NMPAIS) ? parentWidgetCurrentRow.NMPAIS : "";
        widgetCurrentRow.CDPAIS = (parentWidgetCurrentRow.CDPAIS) ? parentWidgetCurrentRow.CDPAIS : "";
        widgetCurrentRow.NMESTADO = (parentWidgetCurrentRow.NMESTADO) ? parentWidgetCurrentRow.NMESTADO : "";
        widgetCurrentRow.SGESTADO = (parentWidgetCurrentRow.SGESTADO) ? parentWidgetCurrentRow.SGESTADO : "";
        widgetCurrentRow.NMMUNICIPIO = (parentWidgetCurrentRow.NMMUNICIPIO) ? parentWidgetCurrentRow.NMMUNICIPIO : "";
        widgetCurrentRow.CDMUNICIPIO = (parentWidgetCurrentRow.CDMUNICIPIO) ? parentWidgetCurrentRow.CDMUNICIPIO : "";
        widgetCurrentRow.NMBAIRRO = (parentWidgetCurrentRow.NMBAIRROCAN) ? parentWidgetCurrentRow.NMBAIRROCAN : "";
        widgetCurrentRow.CDBAIRRO = (parentWidgetCurrentRow.CDBAIRRO) ? parentWidgetCurrentRow.CDBAIRRO : "";
        widgetCurrentRow.DSTELEFONECAN = (parentWidgetCurrentRow.DSTELEFONECAN) ? parentWidgetCurrentRow.DSTELEFONECAN : "";
        widgetCurrentRow.DSEMAILCAN = (parentWidgetCurrentRow.DSEMAILCAN) ? parentWidgetCurrentRow.DSEMAILCAN : "";
        widgetCurrentRow.DSEMAILINTERLOCUTOR = "";
        widgetCurrentRow.DSTELEFONEINTERLOCUTOR = "";
        
        if(Boolean(loggedOperatorInfos.NRREVENDA) && loggedOperatorInfos.IDTPOPERADOR === 'R') {
            widgetCurrentRow.NRREVENDA = loggedOperatorInfos.NRREVENDA;
        }
        
        var fieldsEndereco = [widget.getField("NMPAIS"), widget.getField("NMESTADO"), widget.getField("NMMUNICIPIO"), widget.getField("NMBAIRRO")]; 
        this.cascadeReadOnly(widget, fieldsEndereco);
            
    };
    
    /**
     * Função para possibilitar o cadastro de
     * uma evolução referente a tarefa em caso,
     * indicando a conclusão da tarefa.
     * 
     * @param {object} widget widget ativa, no modo
     * view, referente a tarefa em caso.
    */
    this.completeTask = function(widget) {
        var currentRow = widget.currentRow;
        var evolutionWidget = templateManager.container.getWidget("evolucao");
        
        currentRow.NRPARCNEGOCIO = widget.getParent().currentRow.NRPARCNEGOCIO;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                evolutionWidget.COMPLETETASK = true;
                evolutionWidget.NRSEQFILACONTA = widget.currentRow.NRSEQFILACONTA;
                
                ScreenService.closeSwipe().then(function() {
                    this.activateWidget(evolutionWidget).then(function() {
                        setTimeout(function() {    
                            this.evolucaoNewRow();
                        }.bind(this), 500);
                    }.bind(this));
                }.bind(this));
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    };
    
    /**
     * Função para ativar uma widget
     * 
     * @param {object} widget widget que será
     * ativada.
     * 
     * @return {object} deferred 'promise' indicando
     * a conclusão da tarefa da função.
    */
    this.activateWidget = function(widget) {
        
        var deferred = ZHPromise.defer();
        
        widget.activate();
        deferred.resolve();
        
        return deferred;
    };
    
    /**
     * Função para pegar as informações da tarefa
     * na widget de evolução e setar a data de
     * conclusão da tarefa no registro da própria
     * tarefa.
     * 
     * @param {object} widget widget ativa que contém
     * as informações da tarefa que será concluida.
    */
    this.setTaskEndDate = function(widget) {

        if(widget.COMPLETETASK) {
            
            Crm_00040_Lead_Service.callForSetTaskEndDate(widget).then(function() {
                
                ScreenService.showMessage(Messages.TAREFA_CONCLUIDA);
                this.deleteTaskInfosInEvolutionWidget(widget);
                this.activateTaskWidget();
                    
            }.bind(this));
        }
            
    };
    
    /**
     * Função para ativar a widget de agenda
     * de tarefas.
    */
    this.activateTaskWidget = function() {
        
        var taskWidget = templateManager.container.getWidget("posvendagrid");
        
        taskWidget.activate();    
    };
    
    /**
     * Função para deletar as informações da
     * tarefa a ser concluída da widget de evolução.
     * 
     * @param {object} widget widget de evolução.
    */
    this.deleteTaskInfosInEvolutionWidget = function(widget) {
        
        delete widget.COMPLETETASK;
        delete widget.NRSEQFILACONTA;
        
    };
    
    /**
     * Função para definir os valores iniciais
     * de uma tarefa.
     * 
     * @param {object} widget widget ativa, que terá
     * sua currentRow modificada com os valores da nova
     * tarefa.
    */
    self.taskScheduleNewRow = function(widget) {
        var currentRow = widget.currentRow;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.NRPARCNEGOCIO = widget.getParent().currentRow.NRPARCNEGOCIO;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                General.widgetNewRow(widget);
                
                currentRow.DTPLANFILACONTA = (widget.currentRow.DTPLANFILACONTA)? widget.currentRow.DTPLANFILACONTA : moment(new Date()).format('DD/MM/YYYY HH:mm');
        
                currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
                currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
                currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCOPORT;
        
                currentRow.NRCONTATO = widget.parent.parent.currentRow.NRCONTATO;
                currentRow.NRSEQCONTATO = widget.parent.parent.currentRow.NRSEQCONTATO;
                
                currentRow.DTREALFILACONTA = null;
                
                // currentRow.NRSEQCLASSIFICATAREFA = 2;
                currentRow.NMPRINCIPALPARC = '';
                currentRow.DSEMAILTAREFA = '';
                currentRow.DSTELEFONETAREFA = null;
        
                currentRow.NRORG = loggedOperatorInfos.NRORG;
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
        

    };
    
    /**
     * Função para checar a permissão para gerar
     * uma nova tarefa a partir de uma nova evolução.
     * 
     * @param {object} widget widget ativa, no modo
     * edit, onde está sendo cadastrado a evolução.
    */
    this.checkNewTaskPermissionByEvolutionResult = function(widget) {
        
        var currentRow        = widget.currentRow;
        var dataProximaTarefa = widget.getField("DTPLANFILACONTA");
        var dataMinima  = moment().subtract(dataProximaTarefa.maxDiasRetro,'d').format('DD/MM/YYYY');
        if(currentRow.IDGERPROXATIV && currentRow.IDGERPROXATIV === "S" && !currentRow.NEXTTASKBLOCKED) {
            this.setTaskFieldLock(widget, false);
            dataProximaTarefa.validations = {"required": true, "dateGreaterThan": {"minimumDate": dataMinima, "dateFormat" : "DD/MM/YYYY HH:mm"}};
        }else{
            this.setTaskFieldLock(widget, true);
        }
    };
    
    /**
     * Função para setar a permissão de criar uma nova
     * tarefa a partir do resultado da evolução.
     * 
     * @param {object} widget widget ativa, no modo edit,
     * onde está sendo cadastrado a evolução.
     * 
     * @param {boolean} isAllowed permissão booleana do
     * cadastro da tarefa.
    */
    this.setNewTaskPermission = function(widget, isAllowed) {
        
        if(isAllowed) {
            
            this.setTaskFieldLock(widget, false);
            
            widget.currentRow.DTPLANFILACONTA = "";
            
        }else{
            
            this.setTaskFieldLock(widget, true);
            
        }
            
    };
    
    /**
     * Função para definir o bloqueio dos campos
     * de agenda de tarefa na widget de evolução.
     * 
     * @param {object} widget widget de evolução,
     * onde estão os campos para criar um nova
     * tarefa.
     * 
     * @param {boolean} isLocked estado dos campos.
    */
    this.setTaskFieldLock = function(widget, isLocked) {
        
        var taskFields = ["DTPLANFILACONTA", "NMOPERADORREAL", "DSFILACONTATO",
                "DSCLASSIFICATAREFA", "NRPRIORFILACONT"];
        
        taskFields.forEach(function(fieldName) {
            var field = widget.getField(fieldName);
            
            // Se o campo for bloqueado, ele será read-only, não obrigatório e
            //terá seu valor apagado.
            field.readOnly = isLocked;
            if(fieldName != "DSCLASSIFICATAREFA") {
                field.validations = {required: !isLocked};
            }
            widget.currentRow[fieldName] = isLocked ? "" :
                widget.currentRow[fieldName];
        });
    };
        
    /**
     * Função para resetar as informações
     * de criação de uma nova tarefa(a partir de uma
     * evolução). 
     * 
     * @param {object} widget widget de evolução, que terá
     * as informações resetadas.
    */
    this.resetNewTaskInfos = function(widget) {
        
        var currentRow = widget.currentRow;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.DTPLANFILACONTA = "";
        currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
        currentRow.NMOPERADORREAL = loggedOperatorInfos.NMOPERADOR;
        currentRow.DSFILACONTATO = "Retornar contato";
        currentRow.NRPRIORFILACONT = 2;
    };
    
    /**
     * Função para abrir a widget de seleção
     * de arquivos.
    */
    this.openAnnexSwipe = function() {
        var fileUploadWidget = templateManager.container.getWidget('WDGT_SELECAO_ARQUIVOS');
        var currentRow = templateManager.container.getWidget('gridLead').currentRow;
        
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                fileUploadWidget.isVisible = true;
                ScreenService.openSwipe(fileUploadWidget);
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    };
    
    this.deleteAnnex = function() {
        var widget = templateManager.container.getActiveWidget();
        var currentRow = templateManager.container.getWidget('gridLead').currentRow;
        
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                General.deleteCrud(widget);
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    };
    
    /**
     * Função para salvar os anexos selecionados
     * ao caso em questão.
     * 
     * @param {object} widget widget onde é
     * feito a seleção dos anexos.
    */
    this.uploadEvolutionFiles = function(widget) {
        
        var files = widget.currentRow.DSCAMINHO;
        var rows = [];
        
        files.forEach(function(file, fileIndex) {
            
            rows.push(this.setValuesForFileUpload(widget, fileIndex));
            
        }.bind(this));
        
        General.callRestEngine("product#/crm_anexocontato/save", "DataSet", rows).then(function() {
            
                this.closeAnnexSwipe(widget);
                widget.parent.parent.reload();
                
        }.bind(this)).catch(function(err) {
            var errorMessage = Messages.CATCH_EXCEPTION_ERROR(err.data.error);
            ScreenService.showMessage(errorMessage);
        });
    };
    
    /**
     * Função para retornar uma row configurada
     * com as informações do anexo referente
     * ao ID, recebido como parâmetro, no array
     * de anexos na currentRow.
     * 
     * @param {object} widget widget onde foi selecionado
     * os anexos.Array
     * 
     * @param {int} fileIndex index do anexo no array de 
     * anexos presente na currentRow.
     * 
     * @return {object} currentRow row configurada com as informações
     * do anexo referente ao ID recebido.
    */
    this.setValuesForFileUpload = function(widget, fileIndex) {
        
        var currentRow = angular.copy(widget.currentRow);
        // WDGT_SELECAO_ARQUIVOS -> WDGT_ANEXOS_EVOLUCAO -> evolucao
        var evolutionWidget = widget.getParent().getParent();
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.NRSEQCONTATO = evolutionWidget.currentRow.NRSEQCONTATO;
        currentRow.NMARQUIVO = this.getFileNameWithoutExtension(currentRow.DSCAMINHO[fileIndex].name);
        currentRow.DSTIPO = this.getFileExtension(currentRow.DSCAMINHO[fileIndex].name);
        currentRow.VRTAMANHO = currentRow.DSCAMINHO[fileIndex].size;
        currentRow.IDATIVO = "S";
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
        currentRow.IDORIGEM = "EVOLUCAO";
        currentRow.NRORIGEM = evolutionWidget.currentRow.NRSEQEVOLCONT;
        
        return currentRow;
        
    };
    
    /**
     * Função para retornar a extenção de um arquivo
     * extraida do seu nome.
     * 
     * @param {string} fileName nome completo do arquivo.
    */
    this.getFileExtension = function(fileName) {
        
        return fileName.replace(/^(.*)\.(.*)$/, "$2");
        
    };
    
    /**
     * Função para retornar o nome do arquivo sem
     * sua extenção.
     * 
     * @param {string} fileName nome completo do arquivo.
    */
    this.getFileNameWithoutExtension = function(fileName) {
        
        return fileName.replace(/^(.*)\.(.*)$/, "$1");
            
    };
    
    /**
     * Função para fechar o swipe de upload de imagens.
     * 
     * @param {object} widget widget de upload de imagens.
    */
    this.closeAnnexSwipe = function(widget) {
        ScreenService.closeSwipe().then(function() {
            
            widget.isVisible = false;
            widget.parent.parent.list();
            widget.parent.parent.activate();
           
        });
    };
    
    /**
     * Função para fazer o download de uma arquivo
     * salvo no servidor.
     * 
     * @param {object} widget widget que contém
     * as informações do arquivo a ser baixado 
     * em sua currentRow.
    */    
    this.downloadFile = function(widget) {
        
        window.open(window.fileServerBaseUrl + widget.currentRow.DSCAMINHO);
            
    };
    
    /**
     * Função para deletar uma tarefa,
     * 
     * @param {object} widget widget ativa, no modo
     * de visualização, mostrando a tarefa a ser deletada.
    */
    this.deleteTask = function(widget) {
        var currentRow = widget.currentRow;
        
        currentRow.NRPARCNEGOCIO = widget.getParent().currentRow.NRPARCNEGOCIO;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                General.deleteCrud(widget).then(function() {
                }).catch(function() {
                    ScreenService.confirmMessage(ScreenService.i18n(Messages.EXCLUSAO_TAREFA_VINC_EVOLUCAO), 'question', function (success) {
                        this.deactivateTask(widget).then(function() {
                            ScreenService.showMessage(Messages.TAREFA_INATIVADA);
                            ScreenService.closeSwipe().then(function() {
                                widget.reload();
                            });
                        });
                    }.bind(this));
                }.bind(this));
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    };
    
    /**
     * Função para desativar a tarefa em caso.
     * 
     * @param {object} widget widget ativa, no modo
     * de visualização, com as informações da tarefa
     * a ser desativada.
    */
    this.deactivateTask = function(widget) {
        
        return Crm_00040_Lead_Service.callForDeactivateTask(widget);
            
    };
    
    /**
     * Função para editar uma evolução.
     * 
     * @param {object} widget widget ativa, no
     * modo de visualização, com as informações
     * da evolução a ser editada.
    */
    this.editEvolution = function(widget) {
        var currentRow = widget.currentRow;
        
        currentRow.NRPARCNEGOCIO = widget.getParent().currentRow.NRPARCNEGOCIO;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                General.widgetEdit(widget);
                var dataProximaTarefa = widget.getField("DTPLANFILACONTA");
                dataProximaTarefa.validations = {};
                ABEvolucaoController.setEvolDateChangePermission(widget);
                this.checkPermissionToCreateNewTaskInEvolutionEdition(widget);
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
            
    };
    
    /**
     * Função para verificar a permissão para inserir
     * uma nova tarefa na edição da evolução em caso.
     * 
     * @param {object} widget widget ativa, no modo de
     * edição, com as informações da evolução em edição.
    */
    this.checkPermissionToCreateNewTaskInEvolutionEdition = function(widget) {
        var currentRow = widget.currentRow;
        
        if(currentRow.DTPLANFILACONTA || currentRow.DESCRESULEVOL) {
            this.setTaskFieldLock(widget, true);
            currentRow.NEXTTASKBLOCKED = true;
        }else{
            this.unlockNextTask(widget);
            this.checkNewTaskPermissionByEvolutionResult(widget);
            this.resetNewTaskInfos(widget);
        }
    };
    
    /**
     * Função para liberar o cadastro de uma
     * nova tarefa a partir de um evolução,
     * excluindo o parâmetro de bloqueio.
     * 
     * @param {object} widget widget de evolução.
    */
    this.unlockNextTask = function(widget) {
        if(widget.currentRow.NEXTTASKBLOCKED) {
            delete widget.currentRow.NEXTTASKBLOCKED;
        }
    };
    
    /**
     * Função para limpar os valores dos campos
     * para gerar uma nova tarefa através de uma
     * evolução.
     * 
     * @param {object} widget widget de evolução.
    */
    this.cleanNextTaskFieldValues = function(widget) {
        
        var currentRow = widget.currentRow;
        
        if(!currentRow.DTPLANFILACONTA) {
            
            currentRow.DTPLANFILACONTA = "";
            currentRow.DSFILACONTATO = "";
            currentRow.NMOPERADORREAL = "";
            currentRow.DSCLASSIFICATAREFA = "";
            currentRow.NRPRIORFILACONT = "";
        }
        
    };
    
    this.setAddressFieldFilterValue = function(field) {
        
        var fieldFilter = field.dataSourceFilter;
        var nrorgFilterIndex = CRM_Utilities.getFilterPosition(fieldFilter, "NRORG");
        
        fieldFilter[nrorgFilterIndex].value = [this.getOperatorJobOrganizationNumber(), getLocalVar('CRM_NRORGPADRAO')];
        
    };
    
    this.getOperatorJobOrganizationNumber = function() {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        return loggedOperatorInfos.NRORGTRAB;
            
    };
    
    this.alteraEstadoReadonly = function(widget) {
        var paisField = widget.getField("NMPAIS");
        var estadoField = widget.getField("NMESTADO");
        var currentRow = widget.currentRow;
        if (!paisField.value()) {
            estadoField.readOnly = true;
            currentRow.SGESTADO = null;
            currentRow.NMESTADO = null;
        }
        else {
            estadoField.readOnly = false;
            currentRow.SGESTADO = null;
            currentRow.NMESTADO = null;
        }
        this.alteraMunicipioReadonly(widget);
    };

    this.alteraMunicipioReadonly = function(widget) {
        var estadoField = widget.getField("NMESTADO");
        var municipioField = widget.getField("NMMUNICIPIO");
        var currentRow = widget.currentRow;
        if (!estadoField.value()) {
            municipioField.readOnly = true;
            currentRow.NMMUNICIPIO = null;
            currentRow.CDMUNICIPIO = null;
            currentRow.NMMUNICIPIO = null;
        }
        else {
            municipioField.readOnly = false;
            currentRow.NMMUNICIPIO = null;
            currentRow.CDMUNICIPIO = null;
            currentRow.NMMUNICIPIO = null;
        }
        this.alteraBairroReadonly(widget);
    };

    this.alteraBairroReadonly = function(widget) {
        var municipioField = widget.getField("NMMUNICIPIO");
        var bairroField = widget.getField('NMBAIRRO');
        var currentRow = widget.currentRow;
        if (!municipioField.value()) {
            bairroField.readOnly = true;
            currentRow.NMBAIRROTRAN = null;
            currentRow.CDBAIRRO = null;
            currentRow.NMBAIRRO = null;
            currentRow.NMBAIRROCAN = null;
        }
        else {
            bairroField.readOnly = false;
            currentRow.NMBAIRROTRAN = null;
            currentRow.CDBAIRRO = null;
            currentRow.NMBAIRRO = null;
            currentRow.NMBAIRROCAN = null;
        }
    };
    
    this.criarNovoEstado = function(widget) {
        var popUpNovoEstado = templateManager.container.getWidget('popUpNovoEstado');
        popUpNovoEstado.newRow();
        var filterPopup;
        if(widget.name === "convertLeadInProspect") {
            filterPopup = templateManager.container.getWidget("convertLeadInProspect");
            popUpNovoEstado.currentRow.filtro = false;
        } else if(widget.name === "filterPopup") {
            filterPopup = templateManager.container.getWidget("gridLead").__filterPopup;
            popUpNovoEstado.currentRow.filtro = true;
        } else if(widget.name === "gridLead") {
            filterPopup = templateManager.container.getWidget("gridLead");
            popUpNovoEstado.currentRow.filtro = false;
        } else if(widget.name === "gridProspect") {
            filterPopup = templateManager.container.getWidget("gridProspect");
            popUpNovoEstado.currentRow.filtro = false;
        } else if(widget.name === "gridCliente") {
            filterPopup = templateManager.container.getWidget("gridCliente");
            popUpNovoEstado.currentRow.filtro = false;
        } else if(widget.name === "parceiroNegocio") {
            filterPopup = templateManager.container.getWidget("parceiroNegocio");
            popUpNovoEstado.currentRow.filtro = false;
        }
        
        ScreenService.openPopup(popUpNovoEstado).then(function() {
            if (filterPopup && filterPopup.currentRow && filterPopup.currentRow.CDPAIS !== null) {
                popUpNovoEstado.currentRow.CDPAIS = filterPopup.currentRow.CDPAIS;
            } else if (widget && widget.currentRow && widget.currentRow.CDPAIS !== null && filterPopup === undefined) {
                popUpNovoEstado.currentRow.CDPAIS = widget.currentRow.CDPAIS;
            }
            popUpNovoEstado.currentRow.NRORG  = getLocalVar('CRM_NRORG');
            popUpNovoEstado.reload();
        });
    };

    this.prepararNovoEstado = function (widget) {

        CRM_Utilities.setColumnToReturnInCurrentRow(widget.currentRow, "SGESTADO");

        this.salvarNovoEstado(widget.currentRow).then(function (response) {
            var closeAndReload = function (widget, filter) {
                ScreenService.closePopup();
                ScreenService.closePopup();
                ScreenService.showMessage('Estado Criado Com Sucesso!').then(function () {
                    if (filter) {
                        filter.reload();
                    } else {
                        widget.reload();
                    }
                });
            };

            if (widget.currentRow.filtro === true) {
                var filter = templateManager.container.getWidget("gridLead").__filterPopup;
                filter.currentRow.SGESTADO = response.dataset.estado[0].SGESTADO;
                filter.currentRow.NMESTADO = widget.currentRow.NMESTADO;
                closeAndReload(null, filter);
            } else if (widget.id === "17223197581811413729286") {
                var widgetConvert = templateManager.container.getWidget("gridProspect");
                widgetConvert.currentRow.SGESTADO = response.dataset.estado[0].SGESTADO;
                widgetConvert.currentRow.NMESTADO = widget.currentRow.NMESTADO;
                closeAndReload(widgetConvert);
            } else if (widget.id === "2946427491885752492902") {
                var widgetConvert = templateManager.container.getWidget("gridCliente");
                widgetConvert.currentRow.SGESTADO = response.dataset.estado[0].SGESTADO;
                widgetConvert.currentRow.NMESTADO = widget.currentRow.NMESTADO;
                closeAndReload(widgetConvert);
            } else if (widget.id === "14418982342932124704610") {
                var widgetConvert = templateManager.container.getWidget("parceiroNegocio");
                widgetConvert.currentRow.SGESTADO = response.dataset.estado[0].SGESTADO;
                widgetConvert.currentRow.NMESTADO = widget.currentRow.NMESTADO;
                closeAndReload(widgetConvert);
            } else {
                var widgetConvert = templateManager.container.getWidget("convertLeadInProspect");
                var widgetGrid = templateManager.container.getWidget("gridLead");
                widgetConvert.currentRow.SGESTADO = response.dataset.estado[0].SGESTADO;
                widgetConvert.currentRow.NMESTADO = widget.currentRow.NMESTADO;
                widgetGrid.currentRow.SGESTADO = response.dataset.estado[0].SGESTADO;
                widgetGrid.currentRow.NMESTADO = widget.currentRow.NMESTADO;

                closeAndReload(widgetConvert);
            }
        });
    };
    
    this.salvarNovoEstado = function(currentRow) {
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        return restEngine.post('/saveEstado', paramsRestEngine);
    };

    this.criarNovoMunicipio = function(widget) {
        var popUpNovoMunicipio = templateManager.container.getWidget('popupNovoMunicipio');
        popUpNovoMunicipio.newRow();
        var filterPopup;
        if(widget.name === "convertLeadInProspect") {
            filterPopup = templateManager.container.getWidget("convertLeadInProspect");
            popUpNovoMunicipio.currentRow.filtro = false;
        }else if(widget.name === "filterPopup") {
            filterPopup = templateManager.container.getWidget("gridLead").__filterPopup;
            popUpNovoMunicipio.currentRow.filtro = true;
        }else if(widget.name === "gridLead") {
            filterPopup = templateManager.container.getWidget("gridLead");
            popUpNovoMunicipio.currentRow.filtro = false;
        }else if(widget.name === "gridProspect") {
            filterPopup = templateManager.container.getWidget("gridProspect");
            popUpNovoMunicipio.currentRow.filtro = false;
        }else if(widget.name === "gridCliente") {
            filterPopup = templateManager.container.getWidget("gridCliente");
            popUpNovoMunicipio.currentRow.filtro = false;
        }else if(widget.name === "parceiroNegocio") {
            filterPopup = templateManager.container.getWidget("parceiroNegocio");
            popUpNovoMunicipio.currentRow.filtro = false;
        }
        
        ScreenService.openPopup(popUpNovoMunicipio).then(function() {
            if (filterPopup && filterPopup.currentRow && filterPopup.currentRow.CDPAIS !== null) {
                popUpNovoMunicipio.currentRow.CDPAIS = filterPopup.currentRow.CDPAIS;
            } else if (widget && widget.currentRow && widget.currentRow.CDPAIS !== null && filterPopup === undefined) {
                popUpNovoMunicipio.currentRow.CDPAIS = widget.currentRow.CDPAIS;
            }
            if (filterPopup && filterPopup.currentRow && filterPopup.currentRow.SGESTADO !== null) {
                popUpNovoMunicipio.currentRow.SGESTADO = filterPopup.currentRow.SGESTADO;
            } else if (widget && widget.currentRow && widget.currentRow.SGESTADO !== null && filterPopup === undefined) {
                popUpNovoMunicipio.currentRow.SGESTADO = widget.currentRow.SGESTADO;
            }
            popUpNovoMunicipio.currentRow.NRORG       = getLocalVar('CRM_NRORG');
            popUpNovoMunicipio.reload();
        });
    };
       
    this.prepararNovoMunicipio = function(widget) {
        
        CRM_Utilities.setColumnToReturnInCurrentRow(widget.currentRow, "CDMUNICIPIO");
        
        this.salvarMunicipio(widget.currentRow).then(function (response) {

            var closeAndReload = function (widget, filter) {
                ScreenService.closePopup();
                ScreenService.closePopup();
                ScreenService.showMessage('Município Criado Com Sucesso!!').then(function () {
                    if (filter) {
                        filter.reload();
                    } else {
                        widget.reload();
                    }
                });
            };

            if (widget.currentRow.filtro === true) {
                var filter = templateManager.container.getWidget("gridLead").__filterPopup;
                filter.currentRow.CDMUNICIPIO = response.dataset.columnsToReturn[0].CDMUNICIPIO;
                filter.currentRow.NMMUNICIPIO = widget.currentRow.NMMUNICIPIO;
                closeAndReload(null, filter);

            } else if (widget.id === "17223197581675540933293") {
                var widgetConvert = templateManager.container.getWidget("gridProspect");
                widgetConvert.currentRow.CDMUNICIPIO = response.dataset.columnsToReturn[0].CDMUNICIPIO;
                widgetConvert.currentRow.NMMUNICIPIO = widget.currentRow.NMMUNICIPIO;
                closeAndReload(widgetConvert);
                
            } else if (widget.id === "294642749332775850987") {
                var widgetConvert = templateManager.container.getWidget("gridCliente");
                widgetConvert.currentRow.CDMUNICIPIO = response.dataset.columnsToReturn[0].CDMUNICIPIO;
                widgetConvert.currentRow.NMMUNICIPIO = widget.currentRow.NMMUNICIPIO;
                closeAndReload(widgetConvert);

            } else if (widget.id === "1441898234649502068617") {
                var widgetConvert = templateManager.container.getWidget("parceiroNegocio");
                widgetConvert.currentRow.CDMUNICIPIO = response.dataset.columnsToReturn[0].CDMUNICIPIO;
                widgetConvert.currentRow.NMMUNICIPIO = widget.currentRow.NMMUNICIPIO;
                closeAndReload(widgetConvert);
                
            } else {
                var widgetGrid = templateManager.container.getWidget("gridLead");
                var widgetConvert = templateManager.container.getWidget("convertLeadInProspect");
                widgetConvert.currentRow.CDBAIRRO = response.dataset.columnsToReturn[0].CDMUNICIPIO;
                widgetConvert.currentRow.NMMUNICIPIO = widget.currentRow.NMMUNICIPIO;
                widgetGrid.currentRow.CDBAIRRO = response.dataset.columnsToReturn[0].CDMUNICIPIO;
                widgetGrid.currentRow.NMMUNICIPIO = widget.currentRow.NMMUNICIPIO;
                closeAndReload(widgetConvert);
            }
        });
    };
    

    this.salvarMunicipio = function(currentRow) {
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        return restEngine.post('/municipio/save', paramsRestEngine);
    };

    this.criarNovoBairro = function(widget) {
        var popUpNovoBairro = templateManager.container.getWidget('popupNovoBairro');
        popUpNovoBairro.newRow();
        var filterPopup;
        if(widget.name === "convertLeadInProspect") {
            filterPopup = templateManager.container.getWidget("convertLeadInProspect");
            popUpNovoBairro.currentRow.filtro = false;
        }else if(widget.name === "filterPopup") {
            filterPopup = templateManager.container.getWidget("gridLead").__filterPopup;
            popUpNovoBairro.currentRow.filtro = true;
        }else if(widget.name === "gridLead") {
            filterPopup = templateManager.container.getWidget("gridLead");
            popUpNovoBairro.currentRow.filtro = false;
        }else if(widget.name === "gridProspect") {
            filterPopup = templateManager.container.getWidget("gridProspect");
            popUpNovoBairro.currentRow.filtro = false;
        }else if(widget.name === "gridCliente") {
            filterPopup = templateManager.container.getWidget("gridCliente");
            popUpNovoBairro.currentRow.filtro = false;
        }else if(widget.name === "parceiroNegocio") {
            filterPopup = templateManager.container.getWidget("parceiroNegocio");
            popUpNovoBairro.currentRow.filtro = false;
        }
        
        ScreenService.openPopup(popUpNovoBairro).then(function() {
            if (filterPopup && filterPopup.currentRow && filterPopup.currentRow.CDPAIS !== null) {
                popUpNovoBairro.currentRow.CDPAIS = filterPopup.currentRow.CDPAIS;
            } else if (widget && widget.currentRow && widget.currentRow.CDPAIS !== null && filterPopup === undefined) {
                popUpNovoBairro.currentRow.CDPAIS = widget.currentRow.CDPAIS;
            }
            if (filterPopup && filterPopup.currentRow && filterPopup.currentRow.SGESTADO !== null) {
                popUpNovoBairro.currentRow.SGESTADO = filterPopup.currentRow.SGESTADO;
            } else if (widget && widget.currentRow && widget.currentRow.SGESTADO !== null && filterPopup === undefined) {
                popUpNovoBairro.currentRow.SGESTADO = widget.currentRow.SGESTADO;
            }
            if (filterPopup && filterPopup.currentRow && filterPopup.currentRow.CDMUNICIPIO !== null) {
                popUpNovoBairro.currentRow.CDMUNICIPIO = filterPopup.currentRow.CDMUNICIPIO;
            } else if (widget && widget.currentRow && widget.currentRow.CDMUNICIPIO !== null && filterPopup === undefined) {
                popUpNovoBairro.currentRow.CDMUNICIPIO = widget.currentRow.CDMUNICIPIO;
            }
            popUpNovoBairro.currentRow.NRORG = getLocalVar('CRM_NRORG');
            popUpNovoBairro.reload();
        });
    };
    
    
    this.prepararNovoBairro = function(widget) {
        
        CRM_Utilities.setColumnToReturnInCurrentRow(widget.currentRow, "CDBAIRRO");
        widget.currentRow.DTULTATUBAIR = CRM_Utilities.getCurrentDate();
        
        if(!Util.isEmptyOrBlank(widget.currentRow.CDMUNICIPIO)) {
                this.salvarBairro(widget.currentRow).then(function(response) {
                if(widget.currentRow.filtro === true) {
                    var filter = templateManager.container.getWidget("gridLead").__filterPopup;
                    filter.currentRow.CDBAIRRO    = response.dataset.columnsToReturn[0].CDBAIRRO;  
                    filter.currentRow.NMBAIRRO    = widget.currentRow.NMBAIRRO;
                    filter.currentRow.NMBAIRROCAN = widget.currentRow.NMBAIRRO;
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                    ScreenService.showMessage('Bairro criado com sucesso!').then(function() {
                    filter.reload(); 
                    });
                }else if(widget.id === "17223197581926249916678") {
                    var widgetGridProspect = templateManager.container.getWidget("gridProspect");
                    widgetGridProspect.currentRow.CDBAIRRO    = response.dataset.columnsToReturn[0].CDBAIRRO;  
                    widgetGridProspect.currentRow.NMBAIRRO    = widget.currentRow.NMBAIRRO;
                    widgetGridProspect.currentRow.NMBAIRROCAN = widget.currentRow.NMBAIRRO;
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                    ScreenService.showMessage('Bairro criado com sucesso!').then(function() {
                        widgetGridProspect.reload();
                    });    
                }else if(widget.id === "294642749498830618988") {
                    var widgetGridProspect = templateManager.container.getWidget("gridCliente");
                    widgetGridProspect.currentRow.CDBAIRRO    = response.dataset.columnsToReturn[0].CDBAIRRO;  
                    widgetGridProspect.currentRow.NMBAIRRO    = widget.currentRow.NMBAIRRO;
                    widgetGridProspect.currentRow.NMBAIRROCAN = widget.currentRow.NMBAIRRO;
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                    ScreenService.showMessage('Bairro criado com sucesso!').then(function() {
                        widgetGridProspect.reload();
                    });    
                }else if(widget.id === "14418982342382710746623") {
                    var widgetGridProspect = templateManager.container.getWidget("parceiroNegocio");
                    widgetGridProspect.currentRow.CDBAIRRO    = response.dataset.columnsToReturn[0].CDBAIRRO;  
                    widgetGridProspect.currentRow.NMBAIRRO    = widget.currentRow.NMBAIRRO;
                    widgetGridProspect.currentRow.NMBAIRROCAN = widget.currentRow.NMBAIRRO;
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                    ScreenService.showMessage('Bairro criado com sucesso!').then(function() {
                        widgetGridProspect.reload();
                    });    
                }else{
                    var widgetConvert = templateManager.container.getWidget("convertLeadInProspect");
                    widgetConvert.currentRow.CDBAIRRO    = response.dataset.columnsToReturn[0].CDBAIRRO;  
                    widgetConvert.currentRow.NMBAIRRO    = widget.currentRow.NMBAIRRO;
                    widgetConvert.currentRow.NMBAIRROCAN = widget.currentRow.NMBAIRRO;
                    var widgetGrid = templateManager.container.getWidget("gridLead");
                    widgetGrid.currentRow.CDBAIRRO    = response.dataset.columnsToReturn[0].CDBAIRRO;  
                    widgetGrid.currentRow.NMBAIRRO    = widget.currentRow.NMBAIRRO;
                    widgetGrid.currentRow.NMBAIRROCAN = widget.currentRow.NMBAIRRO;
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                    ScreenService.showMessage('Bairro criado com sucesso!').then(function() {
                        widgetConvert.reload();
                    });
                }
            });
        } else {
            ScreenService.showMessage('Gentileza Informar o Municipio!');
        }
    };
    
    this.salvarBairro = function(currentRow) {
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        return restEngine.post('/bairro/save', paramsRestEngine);
    }; 
    
    this.criarNovoInterlocutor = function(widget) {
        var popupNovoInterlocutor = templateManager.container.getWidget('popupNovoInterlocutor');
        popupNovoInterlocutor.newRow();
        var filterPopup = popupNovoInterlocutor.currentRow;
        if(widget.name === "convertLeadInProspect") {
            filterPopup = templateManager.container.getWidget("convertLeadInProspect");
            popupNovoInterlocutor.currentRow.filtro = false;
            popupNovoInterlocutor.parentName = widget.name;
        }else if(widget.name === "filterPopup") {
            filterPopup = templateManager.container.getWidget("gridLead").__filterPopup;
            popupNovoInterlocutor.currentRow.filtro = true;
        }else if(widget.name === "gridLead") {
            filterPopup = templateManager.container.getWidget("gridLead");
            popupNovoInterlocutor.currentRow.filtro = false;
            popupNovoInterlocutor.parentName = widget.name;
         }else if(widget.name === "posvendagrid") {
            filterPopup = templateManager.container.getWidget("posvendagrid");
            popupNovoInterlocutor.currentRow.filtro = false;
            popupNovoInterlocutor.parentName = widget.name;
        }else if(widget.name === "evolucao") {
            filterPopup = templateManager.container.getWidget("evolucao");
            popupNovoInterlocutor.currentRow.filtro = false;
            popupNovoInterlocutor.parentName = widget.name;
        }
        
        ScreenService.openPopup(popupNovoInterlocutor).then(function() {
            popupNovoInterlocutor.currentRow.NMINTERLOCUTOR      = filterPopup.NMINTERLOCUTOR;
            popupNovoInterlocutor.currentRow.DTNASCIMENTO    = filterPopup.DTNASCIMENTO;
            popupNovoInterlocutor.currentRow.IDRECEBEPRESENTE = filterPopup.IDRECEBEPRESENTE;
            popupNovoInterlocutor.currentRow.NMCARGOINTERLOC = filterPopup.NMCARGOINTERLOC;
            popupNovoInterlocutor.currentRow.EMAILINTERLOC = filterPopup.EMAILINTERLOC;
            popupNovoInterlocutor.currentRow.NRTELEFONE1 = filterPopup.NRTELEFONE1;
            popupNovoInterlocutor.currentRow.NRORG       = getLocalVar('CRM_NRORG');
        });
    }; 
    
    
    this.setInterlocutorWidgetDefaultValues = function(widget) {
        var wid = templateManager.container.getWidget('gridLead');
        
        wid.currentRow.NRPARCNEGOCIO;
        
        widget.currentRow.NRPARCNEGOCIO = wid.currentRow.NRPARCNEGOCIO;
        
    };
    
    this.prepararInterlocutor = function(widget) {
        
        var parent = templateManager.container.getWidget(widget.parentName);
        
        CRM_Utilities.setColumnToReturnInCurrentRow(widget.currentRow, "NRSEQINTERLOCUTOR");
        this.removeInterlocutorPhoneMask(widget);
        widget.currentRow.NRCPFINTERLOC = widget.currentRow.NRCPFINTERLOC.replace(/[^0-9]/g, '');
        this.salvarInterlocutor(widget.currentRow).then(function(response, widget) {
            var currentRow = templateManager.container.getWidget('popupNovoInterlocutor');
              if(currentRow.filtro === true) {
                var widgetfilter = templateManager.container.getWidget('popupNovoInterlocutor').__filterPopup;
                var widgetlead = templateManager.container.getWidget('gridLead');
                var widgetConvertfilter = templateManager.container.getWidget('evolucao');
                widgetConvertfilter.currentRow.NMINTERLOCUTOR = widget.currentRow.NMINTERLOCUTOR; 
                
                widgetfilter.template = "widget/form.html";
                widgetfilter.activate();
                widgetlead.widgets[0].fields[7].defaultValue = widget.currentRow.NMINTERLOCUTOR;
                ScreenService.closePopup(true);
                ScreenService.showMessage('Interlocutor criado com sucesso!');
              }else{
                var widgetcurrent = templateManager.container.getWidget('popupNovoInterlocutor');
                var wid = templateManager.container.getWidget('gridLead');

                parent.currentRow.NRSEQINTERLOCUTOR = response.dataset.columnsToReturn[0].NRSEQINTERLOCUTOR;  
                parent.currentRow.NMINTERLOCUTOR = widgetcurrent.currentRow.NMINTERLOCUTOR; 
                parent.currentRow.EMAILINTERLOC = widgetcurrent.currentRow.EMAILINTERLOC; 
                
                ScreenService.closePopup(true);
                
                ScreenService.showMessage('Interlocutor criado com sucesso!').then(function() {
                    parent.activate();
                    parent.reload();
                });
              }
        });
    };
    
    this.salvarInterlocutor = function(currentRow) {
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        return restEngine.post('/crm_interlocutor/save', paramsRestEngine);
    };

     this.removeInterlocutorPhoneMask = function(widget) {
        
        var currentRow = widget.currentRow;
        var phoneFields = ["NRTELEFONE1"];
        
        phoneFields.forEach(function(phone) {
            
            if(currentRow[phone]) {
                currentRow[phone] = currentRow[phone].replace(/[^0-9]/g, '');    
            }
            
        });
        
    };
    this.cancelarNovoRegistro = function() {
        ScreenService.closePopup();
    };
    
    this.changeOperatorFilter = function(widget) {
        var filtros = widget.dataSourceFilter;
        var allOperators = true;
        var defaultOperator = true;
        
        if(filtros.length !== 5 && filtros.length !== 4) {
            filtros.forEach(function(filtro, index) {
                //Se filtrou operador
                if(filtro.name === "NRPARCPROPRI") {
                    defaultOperator = false;
                    
                    if(filtro.value !== templateManager.LOGGEDOPERATOR.NRPARCNEGOCIO) {
                        allOperators = false;
                    }
                }
            });
            
            if(allOperators) {
                filtros.forEach(function(filtro, index) {
                    //Se filtrou operador
                    if(filtro.name === "NRPARCPROPRI" ) {
                        filtros.splice(index, 1);
                    }
                });    
            }
            
            /*if(defaultOperator) {
                var filter = {
                    name: "NRPARCPROPRI",
                    operator: "IN",
                    static: true,
                    value: [templateManager.LOGGEDOPERATOR.NRPARCNEGOCIO]
                };
                filtros.push(filter);
            }*/
        }    
        
    };
    
    
    /**
     * Função para estender a data final do filtro between de data de inclusao.
     * Sem isso a data final era passada com 00:00, não filtrando os leads 
     * daquele dia;
     * 
     * @param {object} widget widget de lead.
    */
    this.fixDataInclusaoFilter = function(widget) {
        widget.dataSourceFilter.forEach(function(filter, index, dataSourceFilter) {
            if(filter.name === "INCLUSAO")
                dataSourceFilter[index].value[1] += ' 23:59';
        });    
    };
    
    /**
     * Função para propagar readonly num array de fields
    */
    this.cascadeReadOnly = function(widget, fieldsNames) {

        var fields = [];
        
        fieldsNames.forEach(function(name) {
            var field = widget.getField(name);
            if(field) {
                fields.push(field);
            }
        });
        
        if(fields.length > 1) {
            fields.forEach(function(field, index) {
                if(index > 0) {
                    if (!field.value()) {
                        field.readOnly = true;
                    } else {
                        field.readOnly = false;
                    }
                }
            });
        }
    };
    
    this.styleNewLead = function(element) {
        var tr = $(element[0]);  
        if(tr.hasClass('tr')) {
            tr.wrap('<a class="newLeadTooltip" title="Lead recém criado"></a>');
        }
    };
    
    this.styleLead = function(element) {
        while($(element[0]).parent().is('a')) {
            $(element[0]).unwrap('a');  
        }
    };
    
    this.choosePerfOrOper = function(widget, perfOrOper) {
        var fieldOper = widget.getField('NRPARCPROPRI');
        var fieldPerf = widget.getField('NRSEQPERFILRESPONSAVEL');
        if(perfOrOper === 'OPER') {
            if(Util.isEmptyOrBlank(fieldOper.value())) {
                fieldPerf.readOnly = false;
            }else{
                fieldPerf.readOnly = true;
                fieldPerf.clearValue();
                fieldOper.readOnly = false;
            }
        }else if(perfOrOper === 'PERF') {
            if(Util.isEmptyOrBlank(fieldPerf.value())) {
                fieldOper.readOnly = false;
            }else{
                fieldPerf.readOnly = false;
                fieldOper.readOnly = true;
                fieldOper.clearValue();
            }
        }
    };
    
    this.exibeInterlocutor = function(widget) {
        setTimeout(function() {   
             widget;
             if(widget.mode === "edit" && widget.currentRow.__is_new) {
                widget.fieldGroups.forEach(function(group) {
                    if(group.name == "INTER") {
                    	group.isVisible = true;
                    }
                    widget.getField('NRTELEFONE1').validations = { "phone": {"message": "Telefone Inválido"}};
                    widget.getField('EMAILINTERLOC').validations = { "mail": true};
                });
             }else{
                 widget.fieldGroups.forEach(function(group) {
                    if(group.name == "INTER") {
                    	group.isVisible = false;
                    }
                    widget.getField('NRTELEFONE1').validations = {};
                    widget.getField('EMAILINTERLOC').validations = {};
                });
             }
            
        },4);
    };
    
    this.widgetOnEnter = function (widget, fieldsToApply) {
        CRM_Utilities.cascadeReadOnly(widget, ['NMPAIS', 'NMESTADO', 'NMMUNICIPIO', 'NMBAIRROCAN']);

        if (typeof templateManager !== 'undefined' && CRM_Utilities.getLoggedOperatorInfos()) {
            var filterRow = {
                IDOPERATIVO: 'A',
                NRPARCPROPRI: [CRM_Utilities.getLoggedOperatorInfos().NRPARCNEGOCIO]
            };

            if (widget.name === 'gridLead') {
                CRM_Utilities.openFilterOnEnter(widget, filterRow, fieldsToApply);
            } else {
                widget.dataSource.data = templateManager.container.getWidget('gridLead').dataSource.data;
                widget.appliedFilter = templateManager.container.getWidget('gridLead').appliedFilter;
            }
        }
        this.setTasksWidgetOperatorField();
        this.startWidgetFilterGridlead(widget);
    };
    
    function setDiasRetroativosTarefaEvol(widget) {
        var diasMaxRetro = 0;
        var dataProxTarefaField = widget.getField('DTPLANFILACONTA');
        
        var postParams = {
            requestType: 'FilterData',
            filter: [
                {
                    name:  'NRORG',
                    operator: '=',
                    value: getLocalVar('CRM_NRORG')
                },
                {
                    name:  'IDATIVO',
                    operator: '=',
                    value: 'S'
                }
            ]
        };
        
        try {
            diasMaxRetro = restEngine.post('/crm_parametrizacao', postParams)
                .dataset.crm_parametrizacao[0].NRDIASLANCEVOL || 0;
        } catch (err) {
            diasMaxRetro = 0;
        }
        
        dataProxTarefaField.maxDiasRetro = diasMaxRetro;
    };
    
    this.tratarCamposDeData = function(widget) {
        var rows = widget.dataSource.data;
        
        rows.forEach(function(row) {
            row.DTINCLUSAO = this.removerSegundosDeData(row.DTINCLUSAO);
            row.DTULTATU = this.removerSegundosDeData(row.DTULTATU);
            row.INCLUSAO = this.removerSegundosDeData(row.INCLUSAO);
        }.bind(this));
    };
    
    this.removerSegundosDeData = function(datetime) {
         return moment(datetime, 'DD/MM/YYYY HH:mm').
            format('DD/MM/YYYY');
    };
    
    this.removeTabCustomFilter = function(widget) {
        CRM_Utilities.removeCustomFiltersFromWidget(widget);
        widget.reload();
    };
    
    this.openPopupFundirLead = function() {
        var gridWidget = templateManager.container.getActiveWidget();
        var currentRow = gridWidget.currentRow;
        var widget = templateManager.container.getWidget('FUNDIRLEAD');
        var fieldOrigem = widget.getField('NRPARCORIGEM');
        
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                ScreenService.closePopup();
                ScreenService.openPopup(widget);
                  
                widget.activate();
                widget.newRow();
            
                widget.currentRow.NRPARCDESTINO = widget.getParent().currentRow.NRPARCNEGOCIO;
                widget.currentRow.NMDESTINO = widget.getParent().currentRow.NMCANDIDATO;
                
                var sameParcFilter = CRM_Utilities.getComponentDataSourceFilter(fieldOrigem, 'NRPARCORIGEM');
                
                sameParcFilter.value = widget.currentRow.NRPARCDESTINO;
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    };
    
    this.openPopupUnmergeLead = function(mainWid) {
        var gridWidget = templateManager.container.getActiveWidget();
        var currentRow = gridWidget.currentRow;
        var widgetUnmerge = templateManager.container.getWidget('DESFUNDIRLEAD');

        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                ScreenService.closePopup();
                ScreenService.openPopup(widgetUnmerge);
                
                widgetUnmerge.activate();
                widgetUnmerge.newRow();
                
                widgetUnmerge.currentRow.NMCANDPROSPECT = mainWid.currentRow.NMCANDIDATO;
                widgetUnmerge.currentRow.NRPARCATUAL = mainWid.currentRow.NRPARCNEGOCIO;
                
                var filterParcDestino = widgetUnmerge.getField('PARCSDESFUNDIR').dataSourceFilter.find(function(filter) {
                    return filter.name == "P_NRPARCDEST";
                });
                
                filterParcDestino.value = mainWid.currentRow.NRPARCNEGOCIO;
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
        
        
    };
    
    this.setUnmergeActionVisibility = function(widget) {
        var unmergeAction = widget.getAction('UNMERGEPARC');
        unmergeAction.isVisible = false;
        
        var nrparcneg = widget.currentRow.NRPARCNEGOCIO;
        var nrorg = widget.currentRow.NRORG;
        
        CRM_ParceiroNegocio_Controller.checkParcHasMerge(nrparcneg, nrorg).then(function(hasMerge) {
            // Action de desfundir será visível se o prospect tiver algum
            //parceiro fundido a ele.
            unmergeAction.isVisible = hasMerge;
            
            widget.redraw();
        }.bind(this));
    };
    
    this.evolucaoRowOnEnter = function(widget) {
        var prospectController = CRM_Utilities.getController('ger45000_Prospect_Controller');
        
        prospectController.setEditEvolButtonAction(widget, this.editEvolButtonDefaultCode, 'EDITAR_EVOLUCAO');
    };
    
    this.editEvolButtonDefaultCode =
        "ger45000_Prospect_Controller.cleanTaskGroupIfInvisible(args.owner.widget, 'AGENDAR_TAREFA');" +
        "crm00040_Lead_Controller.editEvolution(args.owner.widget);";
        
    this.editLeadActionOnClick = function (widget) {
        var currentRow = widget.currentRow;
        if (currentRow.NRPARCPROPRI === CRM_Utilities.getLoggedOperatorInfos().NRPARCNEGOCIO) {
            this.editLead(widget);
            CRM_Utilities.cascadeReadOnly(widget, ['NMPAIS', 'NMESTADO', 'NMMUNICIPIO', 'NMBAIRROCAN']);
        } else {
            ScreenService.showMessage('Operação Bloqueada! Somente o Parceiro Responsável Pode Editar as Informações do Lead');
        }
    };
    
    this.addEvolActionOnCLick = function(widget) {
        var prospectController = CRM_Utilities.getController('ger45000_Prospect_Controller');
        
        this.evolucaoNewRow();
        prospectController.setNextTaskVisibility(widget, 'AGENDAR_TAREFA');
    };
    
    this.showCantEditMessage = function() {
        var message = "Ação bloqueada!<br>" +
                      "Somente o operador responsável pelo lead e seus assistentes podem " +
                      "editá-lo/evoluí-lo.";
                      
        ScreenService.showMessage(message);
    };

    this.idativeBasedStatusChange = function (widget) {

        if (widget.currentRow.IDATIVO == 'S') {
            widget.getAction('ACTIVATE').isVisible = false
            widget.getAction('DELETE').isVisible = true
        } else {
            widget.getAction('ACTIVATE').isVisible = true
            widget.getAction('DELETE').isVisible = false
        }
    }

    this.leadGridAfterMoveRow = function (widget) {
        var prospectController = CRM_Utilities.getController('ger45000_Prospect_Controller');
        var rdController = CRM_Utilities.getController('IntegracaoRDStationController');

        this.idativeBasedStatusChange(widget);
        this.changeLabelDTNASCIFUNDPARC(widget);
        rdController.insertSendActionRD(widget, 'Lead');
        this.exibeInterlocutor(widget);
        this.atualizarAcoes(widget);
        prospectController.setUnmergeActionVisibility(widget);
        this.showsResale(widget);
    };
    
    this.callRedirectForProspect = function(widget, parcResp, nrparcnegocio) {
        ScreenService.confirmMessage("Deseja ser redirecionado para a tela de prospect?", "CORFIRMATION", 
        function(success) {
            templateManager.container.getWidget('gridLead').mode = 'list';
            templateManager.container.getWidget('gridLead').reload();
            ScreenService.openWindow('ger45000_prospect').then(function() {
                var prospWidgt = templateManager.container.getWidget('gridProspect');
                prospWidgt.dataSourceFilter = [
                    {
                        name: "NRPARCRESPROSP",
                        operator: "=",
                        value: parcResp
                    },
                    {
                        name: "IDATIVO",
                        operator: "=",
                        value: 'S'
                    },
                    {
                        name: "IDTPOPERADOR",
                        operator: "=",
                        value: templateManager.LOGGEDOPERATOR.IDTPOPERADOR
                    },
                    {
                        name: "NRORG",
                        operator: "=",
                        value: templateManager.LOGGEDOPERATOR.NRORGTRAB
                    },
                    {
                        name: "P_CRM_NRORGTRAB",
                        operator: "=",
                        value: getLocalVar('CRM_NRORGTRABALHO')
                    },
                    {
                        name: "NRPARCNEGOCIO",
                        operator: "=",
                        value: nrparcnegocio
                    }
                ];
                prospWidgt.fromLead = true;
                prospWidgt.reload().then(function() {
                    ScreenService.closePopup(true);
                });
            });
        }, function(error) {
            templateManager.container.getWidget('gridLead').activate();
        });
    };
    
    this.buildReturnedParcRow = function(widget, row) {
        var razSoc; var nomFant; var insc; var tpinsc;
        if(row.NMRAZSOCCLIE) {
            razSoc = row.NMRAZSOCCLIE;
            nomFant = row.NMFANTCLIE;
            insc = row.NRINSJURCLIE;
            tpinsc = row.IDTPIJURCLIE;
        } else if(row.NMRAZSOCPROS) {
            razSoc = row.NMRAZSOCPROS;
            nomFant = row.NMFANTPROS;
            insc = row.NRINSJURPROS;
            tpinsc = row.IDTPIJURPROS;
        } else {
            razSoc = row.NMCANDIDATO;
            nomFant = row.NMFANTCAN;
            insc = row.NRINSJURCAN;
            tpinsc = row.IDTPIJURCAN;
        }
        
        if(templateManager.container.name == 'crm00040_000_leads') {
            widget.currentRow.NMCANDIDATO = razSoc;
            widget.currentRow.NMFANTCAN = nomFant;
            widget.currentRow.DSTELEFONECAN = row.DSTELEFONECAN ? row.DSTELEFONECAN : null;
            widget.currentRow.NRINSJURCAN = insc;
            widget.currentRow.IDTPIJURCAN = tpinsc;
            widget.currentRow.DESCTITULOCAN = row.DESCTITULOCAN ? row.DESCTITULOCAN : widget.currentRow.DESCTITULOCAN;
            widget.currentRow.DSEMAILCAN = row.DSEMAILCAN ? row.DSEMAILCAN : widget.currentRow.DSEMAILCAN;
            widget.currentRow.IDSTATUSCAN = row.IDSTATUSCAN ? row.IDSTATUSCAN : 2;
            widget.currentRow.NRFUNCCAN = row.NRFUNCCAN ? row.NRFUNCCAN : widget.currentRow.NRFUNCCAN;
            widget.currentRow.NRSEQPERFILRESPONSAVEL = row.NRSEQPERFILRESPONSAVEL ? row.NRSEQPERFILRESPONSAVEL : widget.currentRow.NRSEQPERFILRESPONSAVEL;
            widget.currentRow.NMBAIRROCAN = row.NMBAIRRO ? row.NMBAIRRO : widget.currentRow.NMBAIRROCAN;
        } else if(templateManager.container.name == 'ger45000_prospect') {
            widget.currentRow.NMRAZSOCPROS = razSoc;
            widget.currentRow.NMFANTPROS = nomFant;
            widget.currentRow.NRINSJURPROS = insc;
            widget.currentRow.IDTPIJURPROS = tpinsc;
            widget.currentRow.NRFUNCPROS = row.NRFUNCPROS ? row.NRFUNCPROS : widget.currentRow.NRFUNCPROS;
            widget.currentRow.IDQUALIFICADO = row.IDQUALIFICADO ? row.IDQUALIFICADO : widget.currentRow.IDQUALIFICADO;
            widget.currentRow.NMBAIRRO = row.NMBAIRRO ? row.NMBAIRRO : widget.currentRow.NMBAIRRO;
        } else if(templateManager.container.name == 'crm_cliente') {
            widget.currentRow.NMRAZSOCCLIE = razSoc;
            widget.currentRow.NMFANTCLIE = nomFant;
            widget.currentRow.NRINSJURCLIE = insc;
            widget.currentRow.IDTPIJURCLIE = tpinsc;
            widget.currentRow.NMBAIRRO = row.NMBAIRRO ? row.NMBAIRRO : widget.currentRow.NMBAIRRO;
        }
        
        widget.currentRow.NRPARCNEGOCIO = row.NRPARCNEGOCIO ? row.NRPARCNEGOCIO : null;
        widget.currentRow.NMPAIS = row.NMPAIS ? row.NMPAIS : widget.currentRow.NMPAIS;
        widget.currentRow.NMESTADO = row.NMESTADO ? row.NMESTADO : widget.currentRow.NMESTADO;
        widget.currentRow.NMMUNICIPIO = row.NMMUNICIPIO ? row.NMMUNICIPIO : widget.currentRow.NMMUNICIPIO;
        widget.currentRow.CDPAIS = row.CDPAIS ? row.CDPAIS : widget.currentRow.CDPAIS;
        widget.currentRow.SGESTADO = row.SGESTADO ? row.SGESTADO : widget.currentRow.SGESTADO;
        widget.currentRow.CDMUNICIPIO = row.CDMUNICIPIO ? row.CDMUNICIPIO : widget.currentRow.CDMUNICIPIO;
        widget.currentRow.CDBAIRRO = row.CDBAIRRO ? row.CDBAIRRO : widget.currentRow.CDBAIRRO;
        widget.currentRow.CDFILIAL = row.CDFILIAL ? row.CDFILIAL : widget.currentRow.CDFILIAL;
        widget.currentRow.CDMODODIVULG = row.CDMODODIVULG ? row.CDMODODIVULG : null;
        widget.currentRow.CDSEGMER = row.CDSEGMER ? row.CDSEGMER : null;
        widget.currentRow.DSCOMPLEENDERECO = row.DSCOMPLEENDERECO ? row.DSCOMPLEENDERECO : null;
        widget.currentRow.DSENDERECO = row.DSENDERECO ? row.DSENDERECO : widget.currentRow.DSENDERECO;
        widget.currentRow.DSOBSERVACAOLEAD = row.DSOBSERVACAOLEAD ? row.DSOBSERVACAOLEAD : null;
        widget.currentRow.CDSEGMER = row.CDSEGMER ? row.CDSEGMER : widget.currentRow.CDSEGMER;
        widget.currentRow.DSSEGMER = row.DSSEGMER ? row.DSSEGMER : widget.currentRow.DSSEGMER;
        widget.currentRow.DTINCLUSAO = row.DTINCLUSAO ? row.DTINCLUSAO : null;
        widget.currentRow.DTNASCIFUNDPARC = row.DTNASCIFUNDPARC ? row.DTNASCIFUNDPARC : null;
        widget.currentRow.DTULTATU = row.DTULTATU ? row.DTULTATU : null;
        widget.currentRow.IDPARCFUNDIDO = row.IDPARCFUNDIDO ? row.IDPARCFUNDIDO : 'N';
        widget.currentRow.NRCANDIDATO = row.NRCANDIDATO ? row.NRCANDIDATO : null;
        widget.currentRow.NRCEPENDERECO = row.NRCEPENDERECO ? row.NRCEPENDERECO : widget.currentRow.NRCEPENDERECO;
        widget.currentRow.NRIMOVELENDERECO = row.NRIMOVELENDERECO ? row.NRIMOVELENDERECO : null;
        widget.currentRow.NRMODORECEBINFO = row.NRMODORECEBINFO ? row.NRMODORECEBINFO : null;
        widget.currentRow.NRORG = row.NRORG ? row.NRORG : null;
        widget.currentRow.NRORGINCLUSAO = row.NRORGINCLUSAO ? row.NRORGINCLUSAO : null;
        widget.currentRow.NRCONTATO = row.NRCONTATO ? row.NRCONTATO : null;
        widget.currentRow.NRSEQCONTATO = row.NRSEQCONTATO ? row.NRSEQCONTATO : null;
        widget.currentRow.CDOPERINCLUSAO = row.CDOPERINCLUSAO ? row.CDOPERINCLUSAO : null;
        if(templateManager.container.name == 'crm00040_000_leads') {
            if(Util.isEmptyOrBlank(widget.currentRow.NRCANDIDATO)) {
                widget.currentRow.__is_new = true;
            }
            if(!Util.isEmptyOrBlank(row.NRPARCNEGOCIO)) {
                if(!Util.isEmptyOrBlank(widget.currentRow.NRINSJURCAN)) {
                    widget.getField('NRINSJURCAN').readOnly = true;
                } else {
                    widget.getField('NRINSJURCAN').readOnly = false;
                }
                widget.getField('NMCANDIDATO').readOnly = true;
            }
        } else if(templateManager.container.name == 'ger45000_prospect') {
            if(!Util.isEmptyOrBlank(row.NRPARCNEGOCIO)) {
                if(!Util.isEmptyOrBlank(widget.currentRow.NRINSJURPROS)) {
                    widget.getField('NRINSJURPROS').readOnly = true;
                } else {
                    widget.getField('NRINSJURPROS').readOnly = false;
                }
                widget.getField('NMRAZSOCPROS').readOnly = true;
            }
        } else if(templateManager.container.name == 'crm_cliente') {
            if(!Util.isEmptyOrBlank(row.NRPARCNEGOCIO)) {
                if(!Util.isEmptyOrBlank(widget.currentRow.NRINSJURCLIE)) {
                    widget.getField('NRINSJURCLIE').readOnly = true;
                } else {
                    widget.getField('NRINSJURCLIE').readOnly = false;
                }
                widget.getField('NMRAZSOCCLIE').readOnly = true;
            }
        }
    }; 
    
    this.searchParcForName = function() {
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow.NRORG = getLocalVar('CRM_NRORG');
        widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        
        var CRM_Par = CRM_Utilities.getCrmParametrization();
        
        var razSoc;
        var insc;
        
        if (templateManager.container.name == 'crm00040_000_leads') {
            razSoc = widget.fields.find(function(x) { return x.name == "NMCANDIDATO"; });
            insc = widget.fields.find(function(x) { return x.name == "NRINSJURCAN"; });
            widget.currentRow.NOME = widget.currentRow.NMCANDIDATO.toString().replace(' ', "%").toUpperCase();
        } else if (templateManager.container.name == 'ger45000_prospect') {
            razSoc = widget.fields.find(function(x) { return x.name == "NMRAZSOCPROS"; });
            insc = widget.fields.find(function(x) { return x.name == "NRINSJURPROS"; });
            widget.currentRow.NOME = widget.currentRow.NMRAZSOCPROS.toString().replace(' ', "%").toUpperCase();
        } else if (templateManager.container.name == 'crm_cliente') {
            razSoc = widget.fields.find(function(x) { return x.name == "NMRAZSOCCLIE"; });
            insc = widget.fields.find(function(x) { return x.name == "NRINSJURCLIE"; });
            widget.currentRow.NOME = widget.currentRow.NMFANTCLIE.toString().replace(' ', "%").toUpperCase();
        }
        
        if (!Util.isEmptyOrBlank(razSoc.value()) && Util.isEmptyOrBlank(insc.value())) {
            this.verificaLeadExistente(widget.currentRow).then(function(response) {
                if (response.dataset.DADOS.LEADS === true) {
                    // Verifica parametrização bloqueia nome semelhante
                    if (CRM_Par.IDBLOQNOMESEMELHA === 'S') {
                        ScreenService.showMessage("Operação bloqueada! <br><br> A 'Razão Social' informada já está vinculada a outro lead. Consulte o mapa de prospecção.");
                        razSoc.value('');
                    } else {
                        ScreenService.confirmMessage("A 'Razão Social' informada, já está vinculada a outro prospect. <br><br> Deseja continuar? ", 'CONFIRMATION',
                            function(success) {}.bind(this),
                            function(fail) {
                                razSoc.value('');
                            }
                        );
                    }
                } else if (!Util.isEmptyOrBlank(response.dataset.DADOS.LEADS) && response.dataset.DADOS.PARCEXISTS) {
                    self.buildReturnedParcRow(widget, response.dataset.DADOS.LEADS);
                } else if (Array.isArray(response.dataset.DADOS.LEADS) && !Util.isEmptyOrBlank(response.dataset.DADOS.LEADS) && response.dataset.DADOS.PARCEXISTS) {
                    var leads = response.dataset.DADOS.LEADS;
                    var mensagemInscricaoVinculada = this.criarMensagemInscricaoJaVinculada(leads);
                    ScreenService.showMessage(mensagemInscricaoVinculada);
                    
                    widget.fields.find(function(x) { return x.label == 'Inscrição'; }).clearValue();
                    widget.fields.find(function(x) { return x.label == 'Tipo de Inscrição'; }).value('I');
                    widget.currentRow.INSCRICAO = "";
                    widget.currentRow.NOME = "";
                    widget.currentRow.CNPJRAIZ = "";
                }
            }.bind(this));
        }
    };
    
    this.verifyFilter = function() {
        var widget = templateManager.container.getWidget('gridLead');
    
        if (!widget) {
            console.error('Widget not found.');
            return;
        }
    
        var modified = false;
    
        if (widget.dataSourceFilter) {
            widget.dataSourceFilter.forEach(function(filtro, index) {
                if(filtro.name == 'NRPARCNEGOCIO' && !widget.fromMap) {
                    widget.dataSourceFilter.splice(index, 1);
                    modified = true;
                }
                if(filtro.name == 'NRPARCNEGOCIO' && widget.fromMap) {
                    widget.dataSourceFilter.splice(index, 1);
                    widget.fromMap = false;
                }
            });
        }
    
        if(modified && !widget.fromMap) {
            widget.reload();
        }
    };
    
    this.verifyHasRelationship = function() {
        var widget = templateManager.container.getWidget('gridLead');
        var evolWidget = templateManager.container.getWidget('evolucao');
        var currentRow = widget.currentRow;
    
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                General.callRestEngine("product#/verifyParcGroupRel", "DataSet", [currentRow]).then(function(response) {
                    if(response.dataset && response.dataset.error) {
                        ScreenService.showMessage(response.dataset.error, 'ERROR');
                    }
                    if(response.dataset && !Util.isEmptyOrBlank(response.dataset.RELATIONSHIP)) {
                        ScreenService.confirmMessage(response.dataset.RELATIONSHIP.PAI.NRINSCRICAOPARC + ' – ' + response.dataset.RELATIONSHIP.PAI.NMPRINCIPALPARC + ' possui parceiros relacionados. ' +
                            'Deseja criar uma evolução para os parceiros relacionados alterando o status destes parceiros para a organização ' + templateManager.LOGGEDOPERATOR.CRM_NRORGTRAB + ' - ' + templateManager.LOGGEDOPERATOR.NMORGTRAB, 'CONFIRMATION', function () {
                                widget.PARCUPDATE = response.dataset.RELATIONSHIP.FILHOS;
                                this.convertLeadAfterEvolution(evolWidget);
                            }.bind(this));
                    } else {
                        this.convertLeadAfterEvolution(evolWidget);
                    }
                }.bind(this));
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    };


    /*
    Codigos para adição e ediçao de interlocutor na evolução
    */
   
    this.prepararInterlocutor = function (widget) {
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var currentRow = widget.currentRow;
        currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
        currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

        var parceiroController = CRM_Utilities.getController('CRM_ParceiroNegocio_Controller');
    
        parceiroController.checkIfCanEditOrEvolParc(nrParcNegocio).then(
          function (canEdit) {
            if (canEdit) {
              General.callRestEngine("product#/verifyGroupRel", "DataSet", [
                currentRow,
              ]).then(
                function (response) {
                  if (response.dataset && response.dataset.error) {
                    ScreenService.showMessage(response.dataset.error, "ERROR");
                  }
                  if (response.dataset && response.dataset.GROUPREL[0] == false) {
                    var parent = templateManager.container.getWidget(
                      widget.parentName
                    );
    
                    CRM_Utilities.setColumnToReturnInCurrentRow(
                      widget.currentRow,
                      "NRSEQINTERLOCUTOR"
                    );
                    this.removeInterlocutorPhoneMask(widget);
    
                    if(widget.currentRow.NRCPFINTERLOC){
                        widget.currentRow.NRCPFINTERLOC = widget.currentRow.NRCPFINTERLOC.replace(
                          /[^0-9]/g,
                          ""
                        );
                    } else {
                        widget.currentRow.NRCPFINTERLOC = null;
                    };
                    
                    this.salvarInterlocutor(widget.currentRow).then(function (
                      response,
                      widget
                    ) {
                      var currentRow = templateManager.container.getWidget(
                        "popupNovoInterlocutor"
                      );
                      if (currentRow.filtro === true) {
                        var widgetfilter = templateManager.container.getWidget(
                          "popupNovoInterlocutor"
                        ).__filterPopup;
                        var widgetprospect = templateManager.container.getWidget(
                          "gridLead"
                        );
                        var widgetConvertfilter = templateManager.container.getWidget(
                          "evolucao"
                        );
                        widgetConvertfilter.currentRow.NMINTERLOCUTOR =
                          widget.currentRow.NMINTERLOCUTOR;
    
                        widgetfilter.template = "widget/form.html";
                        widgetfilter.activate();
                        widgetprospect.widgets[0].fields[7].defaultValue =
                          widget.currentRow.NMINTERLOCUTOR;
                        ScreenService.closePopup(true);
                        ScreenService.showMessage(
                          "Interlocutor criado com sucesso!"
                        );
                      } else {
                        var widgetcurrent = templateManager.container.getWidget(
                          "popupNovoInterlocutor"
                        );
    
                        parent.currentRow.NRSEQINTERLOCUTOR =
                          response.dataset.columnsToReturn[0].NRSEQINTERLOCUTOR;
                        parent.currentRow.NMINTERLOCUTOR =
                          widgetcurrent.currentRow.NMINTERLOCUTOR;
                        parent.currentRow.EMAILINTERLOC =
                          widgetcurrent.currentRow.EMAILINTERLOC;
    
                        ScreenService.closePopup(true);
    
                        ScreenService.showMessage(
                          "Interlocutor criado com sucesso!"
                        ).then(function () {
                          parent.activate();
                          parent.reload();
                        });
                      }
                    });
                  } else {
                    ScreenService.showMessage(
                      "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                      response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                      " - " +
                      response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                      "!"
                    );
                  }
                }.bind(this)
              );
            } else {
              this.showMessageCantEditParc();
            }
          }.bind(this)
        );
    };

    this.removeInterlocutorPhoneMask = function (widget) {
        var currentRow = widget.currentRow;
        var phoneFields = ["NRTELEFONE1"];

        phoneFields.forEach(function (phone) {
            if (currentRow[phone]) {
            currentRow[phone] = currentRow[phone].replace(/[^0-9]/g, "");
            }
        });
    };

    this.salvarInterlocutor = function (currentRow) {
        var paramsRestEngine = {
          requestType: "Row",
          row: currentRow,
        };
        return restEngine.post("/crm_interlocutor/save", paramsRestEngine);
    };

    this.selectInterlocutor = function (widget){
        var parent = templateManager.container.getWidget("evolucao");

        parent.currentRow.NRSEQINTERLOCUTOR = widget.currentRow.NRSEQINTERLOCUTOR;
        parent.currentRow.NMINTERLOCUTOR = widget.currentRow.NMINTERLOCUTOR;
        parent.currentRow.EMAILINTERLOC = widget.currentRow.EMAILINTERLOC;
    
        ScreenService.closePopup(true);
    };

    this.showsResale = function (widget) {
        var source = widget.getField("NMMODODIVULG").value();
        var fieldResale = [widget.getField("LEADNRREVENDA"), widget.getField("NMRAZSOCREVENDA")]
        
        if (source == "Revenda") {
            fieldResale.forEach(function(field) {
                field.isVisible  = true;
                field.reload();                
            });
        } else {
            fieldResale.forEach(function(field) {
                field.isVisible  = false;
                field.clearValue();
                field.reload();
            });            
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm00040_Lead_Controller', crm00040_Lead_Controller);
});

// FILE: ./assets/js/controllers/crm00040001_Tipo_Revenda_Controller.js
function crm00040001_Tipo_Revenda_Controller(General, CRM_Utilities, templateManager) {
    
    /**
     * Acrescenta os parâmetros na widget para 
     * gerar um novo código e salva o novo tipo de 
     * revenda
     * 
     * @param {object} widget widget com as informações
     * para realizar o 'save'
    */
    this.saveTypeOfResale = function(widget){
        
        var currentRow = widget.currentRow;
        
        if(currentRow.__is_new === true){
            
            var paramsNewCode = {
                    __is_new_code: true,
                    __new_code_pk: "NRTIPOREVENDA",
                    __table_pk: "NRTIPOREVENDA",
                    __cast_number: true
                };
                
            widget.paramsNewCode = paramsNewCode;
        
        }
        
        General.widgetSave(widget).then(function(){
            widget.reload();
        });
        
    };
    
     /**
     * Save:
     * Atribui widget ativa os parâmetros
     * para gerar um novo código.
     * 
     * Seta o tipo de revenda na currentRow. 
     * 
     * Remove a máscara do valor da comissão e salva a 
     * nova comissão.
     * 
     * Edit: 
     * Salva a edição da comissão.
     * 
     * @param {object} widget widget com as informações
     * para o 'save'
    */
    this.editValuesWidgetAndSaveCommission = function(widget){
        
        var currentRow = widget.currentRow;
        
        if(currentRow.__is_new === true){
            
            var paramsNewCode = {
                    __is_new_code: true,
                    __new_code_pk: "NRCOMISSAOTPREVENDA",
                    __table_pk: "NRCOMISSAOTPREVENDA",
                    __cast_number: true
                };
                
            widget.paramsNewCode = paramsNewCode;
            currentRow.NRTIPOREVENDA = widget.parent.parent.currentRow.NRTIPOREVENDA;
            currentRow.VRCOMISSAO = currentRow.VRCOMISSAO.replace(/[^0-9]/g, "");
        
        }
        
        General.widgetSave(widget).then(function(){
            widget.reload();
        });
        
    };
    
    /**
     * Função que busca o index do objeto dentro do 
     * dataSourceFilter da widget passada como parâmetro
     * e seta o número da revenda relacionada.
    */
    this.setFilterCommissionWidget = function(){
        
        var widget = templateManager.container.getWidget('COMISSAO');
        
        var indexFilterObject = CRM_Utilities.getFilterPosition(widget.dataSourceFilter, "NRTIPOREVENDA");
        
        widget.dataSourceFilter[indexFilterObject].value = widget.parent.parent.currentRow.NRTIPOREVENDA;
        
    };
    
    /**
     * Função para setar os valores iniciais
     * da widget que recebeu o evento newRow .
     * 
     * @param {object} widget widget onde será setada
     * os valores na currentRow.
    */
    this.setCurrentRowWidget = function(widget){
        
        var currentRow = widget.currentRow;
            
        currentRow.CDPRECBASESERV = "";
        currentRow.CDMODPGTO = "";
        
    };
    
    /**
     * Função para pegar os serviços já cadastrados
     * presente no dataSouce,caso não tenha, retorna
     * um array com o item '-1'.
     * 
     * @param {object} widget widget de comissões para
     * localizar os serviços usados.
     * 
     * @return {array} usedServicesArray array com os
     * serviços usasdos.
    */
    this.getUsedServiceArray = function(widget){
        
        var usedServicesArray = [-1];
        var dataSourceValues = widget.dataSource.data;
        
        dataSourceValues.map(function(values){
            if(values.CDSERVORCA){
                usedServicesArray.push(values.CDSERVORCA);
            }
        });
        
        return usedServicesArray;
        
    };
    
    /**
     * Função para setar o array de serviços ja 
     * cadastrados no valor do filtro da field
     * de serviço.
     * 
     * @param {object} widget widget de comissão.
    */
    this.setServiceFieldFilter = function(widget){
        
        var fieldNMSERVOCA = widget.getField('NMSERVORCA');
        
        var serviceFilter = fieldNMSERVOCA.dataSourceFilter;
        var usedServicesArray = this.getUsedServiceArray(widget);
        
        var indexCDSERVORCAinFilter = CRM_Utilities.getFilterPosition(serviceFilter, "CDSERVORCA");
        serviceFilter[indexCDSERVORCAinFilter].value = usedServicesArray;
        
        fieldNMSERVOCA.reload();
        
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm00040001_Tipo_Revenda_Controller', crm00040001_Tipo_Revenda_Controller);
});

// FILE: ./assets/js/controllers/crm00041000_Modalidade_Pagamento_Controller.js
function crm00041000_Modalidade_Pagamento_Controller(CRM_Utilities, General, templateManager, ScreenService){
    
    /**
     * Função para habilitar a visualização 
     * do 'field group' referente ao módulo
     * selecionado.
     * 
     * @param {object} widget widget onde se
     * localiza os FieldGroups.
     * 
    */
    this.activeGroupByTheSelectedModel = function(widget){
            
        var fieldGroups = widget.fieldGroups;
        
        var currentRowNewModalityOfPayment = widget.currentRow;
        
        var indexGroupFixedPaymentDay = CRM_Utilities.getFieldGroupPosition(fieldGroups, "PAGAMENTO_FIXO_DIA");
        var groupFixedPaymentDay = fieldGroups[indexGroupFixedPaymentDay];
        
        var indexGroupFormOfPayment = CRM_Utilities.getFieldGroupPosition(fieldGroups, "FORMA_PAGAMENTO");
        var groupFormOfPayment = fieldGroups[indexGroupFormOfPayment];
        
        if(currentRowNewModalityOfPayment.IDTPFORPGTOMOD === "F"){
            
            groupFixedPaymentDay.isVisible = true;
            
            groupFormOfPayment.isVisible = false;
            this.clearValuesFieldGorup(widget, groupFormOfPayment.name);
            
        }else if(currentRowNewModalityOfPayment.IDTPFORPGTOMOD === "V"){
            
            groupFormOfPayment.isVisible = true;
            
            groupFixedPaymentDay.isVisible = false;
            this.clearValuesFieldGorup(widget, groupFixedPaymentDay.name);
            
        }else{
            
            groupFormOfPayment.isVisible = false;
            groupFixedPaymentDay.isVisible = false;
            
            this.clearValuesFieldGorup(widget, groupFormOfPayment.name);
            this.clearValuesFieldGorup(widget, groupFixedPaymentDay.name);
            
        }
        
    };
    
    /**
     * Função para ocultar os fieldGroups
     * ligados ao tipo de modalidade quando
     * não estiver em um abiente de edição
     * (para não esconder informações no modo 'view').
     * 
     * @param {object} widget widget onde se
     * localiza os fieldGroups.
    */
    this.hideFieldGroupsOfModality = function(widget){
        
        var fieldGroups = widget.fieldGroups;
        
        var indexGroupFixedPaymentDay = CRM_Utilities.getFieldGroupPosition(fieldGroups, "PAGAMENTO_FIXO_DIA");
        var groupFixedPaymentDay = fieldGroups[indexGroupFixedPaymentDay];
        
        var indexGroupFormOfPayment = CRM_Utilities.getFieldGroupPosition(fieldGroups, "FORMA_PAGAMENTO");
        var groupFormOfPayment = fieldGroups[indexGroupFormOfPayment];
        
        if(widget.currentRow.__is_new === true){
            
            groupFixedPaymentDay.isVisible = false;
            groupFormOfPayment.isVisible = false;
        }    
    }; 
    
    /**
     * Limpa os fields de um determinado FieldGroup.
     * 
     * @param {object} widget widget onde se localiza
     * o fieldGroup.
     * 
     * @param {String} fieldGroupName nome do FieldGroup
     * que terá os campos limpados.
    */
    this.clearValuesFieldGorup = function(widget, fieldGroupName){
        
        widget.fields.forEach(function(field){
            
            if(field.fieldGroup === fieldGroupName){
                CRM_Utilities.clearFieldValue(field);
            }
                
        });
    };
    
    /**
     * Função para validar valores da currentRow 
     * e salvar uma nova modalidade de pagamento,
     * mostra o field group correto no modo 'edit',
     * e bloqueia a widget 'PRAZO_PAGAMENTO' caso 
     * necessário e seta a modalidade para 'A vista'
     * caso o campo esteja vazio(BANCO MAL FEITO).
     * 
     * @param {obejct} widget widget na qual será 
     * pego os valores para inserir uma nova modalidade
     * de pagamento.
    */
    this.checkValuesAndSaveModalityPayment = function(widget){
            
        this.checkIfModeIsInSight(widget);
        
        General.widgetSave(widget).then(function(){
            
            this.hideFieldGroupsOfModality(widget);
            this.activeWidgetPaymentDeadline(widget);
            
            if(!widget.currentRow.IDTPFORPGTOMOD){
                widget.currentRow.IDTPFORPGTOMOD = "A";
            }
            
            widget.reload();
            
        }.bind(this));
    };
    
    /**
     * Função para setar 'vazio' para o campo
     * 'Tipo de modalidade' caso a modalidade selecionada
     * for 'À vista'.
     * 
     * @param {object} widget widget onde se
     * localiza a field 'Tipo de modalidade'.
    */
    this.checkIfModeIsInSight = function(widget){
        
        var currentRow = widget.currentRow;
        
        if(currentRow.IDTPFORPGTOMOD === "A"){
            currentRow.IDTPFORPGTOMOD = "";
        }
          
    };
    
    /**
     * Função para ativar a widget 'PRAZO_PAGAMENTO'
     * quando o tipo da modalidade for 'Forma de pagamento'.
     * 
    */
    this.activeWidgetPaymentDeadline = function(){
        
        var widget = templateManager.container.getWidget('PRAZO_PAGAMENTO');
        
        var widModalityPayment = widget.parent.parent;
        
        if(widModalityPayment.currentRow.IDTPFORPGTOMOD === "V"){
            
            widget.enabled = true;
            
        }else{
            
            widget.enabled = false;
            
        }
            
    };
    
    /**
     * Função para setar os valores necessários para
     * o cadastro de um novo prazo de pagamento.
     * 
     * @param {objetc(widget)} widget widget ativa, usada
     * para o cadastro.
    */
    this.setValuesForNewPaymentDeadLine = function(widget){
    
        this.setOperatorNrorgInCurrentRow(widget);
        
        this.setModalityOfPaymentInDeadLine(widget);
        
    };
    
    /**
     * Função para setar o nrorg do operador logado
     * na currentRow da tela de cadastro de prazo de
     * pagamento.
     * 
     * @param {object(widget)} widget widget que receberá
     * o nrorg em sua currentRow.
    */
    this.setOperatorNrorgInCurrentRow = function(paymentDeadlineWidget){
        
        var currentRow = paymentDeadlineWidget.currentRow;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.NRORG = loggedOperatorInfos.NRORG;
    };
    
    /**
     * Função para setar o código da modalidade responsável
     * pelo prazo a ser criado.
     * 
     * @param {object} widget widget 'PRAZO_PAGAMENTO'
     * 
    */
    this.setModalityOfPaymentInDeadLine = function(widget){
        
        var modPaymentCurrentRow = widget.parent.parent.currentRow;
        var deadlinePaymentCurrentRow = widget.currentRow;
        
        deadlinePaymentCurrentRow.CDMODPGTO = modPaymentCurrentRow.CDMODPGTO;
        deadlinePaymentCurrentRow.DSMODPGTO = modPaymentCurrentRow.DSMODPGTO;
        
    };
    
    /**
     * Função para inserir um filtro na widget
     * 'PRAZO_PAGAMENTO'.
     * 
     * @param {object} widModalityPayment widget princital
     * (MODALIDADE_PAGAMENTO)
    */
    this.insertDeadLineFilterValue = function(widModalityPayment){
        
        var widDeadLinePayment = templateManager.container.getWidget('PRAZO_PAGAMENTO');
        
        var CDMODPGTOfilterObjectIndex = CRM_Utilities.getFilterPosition(widDeadLinePayment.dataSourceFilter, 'CDMODPGTO');    
        
        widDeadLinePayment.dataSourceFilter[CDMODPGTOfilterObjectIndex].value = widModalityPayment.currentRow.CDMODPGTO;
    };
    
}

Configuration(function(ContextRegister){
   ContextRegister.register("crm00041000_Modalidade_Pagamento_Controller", crm00041000_Modalidade_Pagamento_Controller); 
});




// FILE: ./assets/js/controllers/crm00042000_concorrente_controller.js
function crm00042000_concorrente_controller(General, ScreenService, Endereco) {
    
    
    /**
     * Seta as váriaveis de paramsNewCode 
     * para um novo código ser gerado.
     * 
     * @param {object} widget widget de concorrente
     * para setar os parametros de novo código
    */
    this.enableNewCodeNumber = function(widget){
        var paramsNewCode = widget.paramsNewCode;
        
        paramsNewCode.__is_new_code = true;
        paramsNewCode.__new_code_pk = "NRCONCORRENTE";
        paramsNewCode.__table_pk = "NRCONCORRENTE";
        paramsNewCode.__cast_number = true;
    };
    
    
    /**
     * Seta as váriaveis de paramsNewCode 
     * para um novo código não ser gerado.
     * 
     * @param {object} widget widget de concorrente
     * para setar os parametros de novo código
     */
    this.desableNewCodeNumber = function(widget){
        var paramsNewCode = widget.paramsNewCode;
        
        paramsNewCode.__is_new_code = false;
        paramsNewCode.__new_code_pk = "";
        paramsNewCode.__table_pk = "";
        paramsNewCode.__cast_number = true;
    };
    
    /**
     * Remove tudo que não for numerico
     * da inscrição.
     * 
     * @param {varchar} inscription código de inscrição
     * digitado pelo usuário.
     */
    this.removeInscriptionMask = function(inscription){
        return inscription.replace(/[^0-9]/g, "");
    };
    
    
    /**
     * Salva o registro de concorrente
     * 
     * @param {object} widget widget de concorrente
     * para setar campos da mesma
     */
    this.saveConcorrente = function(widget){
        
        this.removeInscriptionMask(widget.currentRow.NRINSCRICAOCONC);
        
        if(!widget.currentRow.NMFANTCONN){
            widget.currentRow.NMFANTCONN = widget.currentRow.NMRAZSOCCONC;
        }
        
        if(widget.currentRow.__is_new){
            this.enableNewCodeNumber(widget);
        }
        
        widget.currentRow.__columns_to_return = ["NRCONCORRENTE"];
        
        General.widgetSave(widget).then(function(response){
            if (response.dataset.columnsToReturn)
                widget.currentRow.NRCONCORRENTE = response.dataset.columnsToReturn.NRCONCORRENTE;
                widget.reload();
            this.desableNewCodeNumber(widget);
        }.bind(this));
    };
    
    /**
     * Seta os campos para que não sejam nulos 
     * e possam ser salvos sem serem preenchidos 
     * pelo usuário
     * 
     * @param {object} currentRow setar os campos
     * da currentRow com "" para evitar erro quando
     * as variáveis são nulas.
     */
    this.setDefaultValues = function(currentRow){
        currentRow.CDPAIS = "";
        currentRow.CDMUNICIPIO = "";
        currentRow.SGESTADO = "";
        currentRow.CDBAIRRO = "";
    };
    
      /**
     * Valida a inscrição informada pelo usuário
     * e seta na currentRow da widget o código do
     * tipo da inscrição através do método 
     * 'setInscriptionTypeInCurrentRow', e a máscara
     * da inscrição, caso a inscrição seja inválida,
     * ele limpa os campos e manda uma mensagem.
     * 
     * @param {object} widget widget onde está sendo
     * realizado o cadastro da revenda.
    */
    this.validateInscription = function(widget){
        
        var currentRow = widget.currentRow;
        
        var resultValidate = General.inscricaoFormat(currentRow.NRINSCRICAOCONC);
        
        if(resultValidate.valid){
            
            this.setInscriptionTypeInCurrentRow(widget, resultValidate);
            
            currentRow.NRINSCRICAOCONC = resultValidate.value;
            
        }else{
            
            this.showErrorMessageForInscription(currentRow.NRINSCRICAOCONC.length);
            
            currentRow.NRINSCRICAOCONC = "";
            currentRow.CDTIPOINSCRICAO = "";
        }
        
    };
    
    /**
     * Caso o usuário digite
     * uma inscrição inválida
     * mostra os erros correspondentes.
     * 
     * @param {varchar} inscription mostrar a mensagem
     * de erro dependendo do tipo do mesmo quando a 
     * inscrição é inválida.
     */
    this.showErrorMessageForInscription = function(inscription){
        switch(inscription){
            
            case 11:
                ScreenService.showMessage("Número de CPF inválido.");
                break;
            case 14:
                ScreenService.showMessage("Número de CNPJ inválido.");
                break;
            default:
                ScreenService.showMessage("Número de incrição inválido.");
        }
        
    };
    
    /**
     * Seta na currentRow da widget, o nome
     * e o código da inscrição informada.
     * 
     * @param {object} widget onde está sendo 
     * realizada o cadastro da revena.
     * @param {object} resultValidade reultado 
     * da validação da inscrição.
    */
    this.setInscriptionTypeInCurrentRow = function(widget, resultValidate){
        
        var inscriptionCod = resultValidate.tipo.cod;
        var currentRow = widget.currentRow;
        
        if (inscriptionCod){
            
            switch(inscriptionCod){
                
                case "F":
                    currentRow.CDTIPOINSCRICAO = "CPF";
                break;
                
                case "J":
                    currentRow.CDTIPOINSCRICAO = "CNPJ";
                break;
                
                case "O":
                    currentRow.CDTIPOINSCRICAO = "CODIGO";
                break;
                
                case "I":
                    currentRow.CDTIPOINSCRICAO = "LIVRE";
                break;
            }
            
        }
    };
    
    /**
     * Monta o filtro para os campos Estado, Pais e Municipio atraveś de um switch
     * 
     * @param {object} widget widget de concorrente
     * para pegar a currentRow
     * @param {object} field campo utilizado para pegar 
     * o nome e dataSourceFilter do campo.
    */
    this.filterAddress = function(widget, field){
        var currentRow = widget.currentRow;
        var filter = [];
        
        switch (field.name) {
            case 'SGESTADO':
                if (currentRow.CDPAIS){
                   filter = this.createFilterAddress("CDPAIS",currentRow.CDPAIS); 
                }else{
                     filter = this.createFilterAddress("CDPAIS","");  
                }
                break;
            case 'CDMUNICIPIO':
                if (currentRow.SGESTADO){
                    filter = this.createFilterAddress("SGESTADO",currentRow.SGESTADO);
                }else{
                     filter = this.createFilterAddress("SGESTADO","");  
                }
                break;
            case 'NMBAIRRO':
                if (currentRow.CDMUNICIPIO){
                    filter = this.createFilterAddress("CDMUNICIPIO",currentRow.CDMUNICIPIO);
                }else{
                     filter = this.createFilterAddress("CDMUNICIPIO","");  
                }
                break;
        }
        var nrorgfilter = {};
        nrorgfilter.name = "NRORG";
        nrorgfilter.operator = "IN";
        nrorgfilter.value = [getLocalVar('CRM_NRORGTRAB'),getLocalVar('CRM_NRORGPADRAO') ];
        
        filter.push(nrorgfilter);
        field.dataSourceFilter = filter;
        field.reload();
    };
    
    
    /**
     * Monta o filtro para os campos Estado, Pais e Municipio 
     * pegando os parametros do método filterAddress
     * 
     * @param {string} name nome do campo 
     * de estado país ou municípo
     * @param {varchar} value valor utilizado para setar
     * o valor do filtro.
    */
    this.createFilterAddress = function(name, value){
        var filter = [
            {
                "name": name,
                "operator": "=",
                "value": value
            }
        ];
        return filter;
    };
    
    var oldState;
    
    /**
     * Limpa os campos de municipio e bairro quando o 
     * campo Estado é alterado.
     * 
     * @param {object} currentRow pega a currentRow
     * para setar os campos com vazio.
    */
    
    this.onChangeState = function(currentRow){
      var currentState = currentRow.NMESTADO.toString();

      if(typeof oldState === "undefined"){
          oldState = currentState;
          
      }else if(oldState !== currentState){
          currentRow.NMMUNICIPIO = "";
          currentRow.CDMUNICIPIO = "";
          currentRow.NMBAIRRO = "";
          currentRow.CDBAIRRO = "";
          oldState = currentState;
      }
     };
     
    var oldCountry;
    /**
     * Limpa os campos de estado, municipio e bairro quando o 
     * campo País é alterado.
     * 
     * @param {object} currentRow pega a currentRow
     * para setar os campos com vazio.
    */
    this.onChangeCountry = function(currentRow){
      var currentCountry = currentRow.NMPAIS.toString();

      if(typeof oldCountry === "undefined"){
          oldCountry = currentCountry;
          
      }else if(oldCountry !== currentCountry){
          currentRow.SGESTADO = "";
          currentRow.NMMUNICIPIO = "";
          currentRow.CDMUNICIPIO = "";
          currentRow.NMBAIRRO = "";
          currentRow.CDBAIRRO = "";
          oldCountry = currentCountry;
        }
    };
    
    var oldCity;
    /**
     * Limpa os campos de bairro quando o 
     * campo Município é alterado.
     * 
     * @param {object} currentRow pega a currentRow
     * para setar os campos com vazio.
    */
    this.onChangeCity = function(currentRow){
      var currentCity = currentRow.NMMUNICIPIO.toString();

      if(typeof oldCity === "undefined"){
          oldCity = currentCity;
          
      }else if(oldCity !== currentCity){
          currentRow.NMBAIRRO = "";
          currentRow.CDBAIRRO = "";
          oldCity = currentCity;
        }
    };
    
    /**
     * Busca os campos de País, Estado, Município e Bairro
     * a partir do CEP informado pelo usuário.
     * 
     * @param {object} currentRow pega a currentRow
     * para setar os campos com os valores buscados
     * @param {object} CEP valor digitado pelo usuário 
     * do CEP a ser buscado
    */
    this.searchAddress = function(currentRow, CEP){
        
        ScreenService.confirmMessage("Deseja buscar o endereço pelo CEP informado?", "question", function(){
            Endereco.buscarCep(CEP).then(function(response) {
                var endereco = response.dataset.ENDERECO;
                if(endereco) {
                    currentRow.CEP = CEP;
                    currentRow.CDPAIS = (endereco.CDPAIS)? endereco.CDPAIS : '';
                    currentRow.NMPAIS = (endereco.NMPAIS)? endereco.NMPAIS : '';
                    currentRow.SGESTADO = (endereco.SGESTADO)? endereco.SGESTADO : '';
                    currentRow.NMESTADO = (endereco.NMESTADO)? endereco.NMESTADO : '';
                    currentRow.CDMUNICIPIO = (endereco.CDMUNICIPIO)? endereco.CDMUNICIPIO : '';
                    currentRow.NMMUNICIPIO = (endereco.NMMUNICIPIO)? endereco.NMMUNICIPIO : '';
                    currentRow.CDBAIRRO = (endereco.CDBAIRRO)? endereco.CDBAIRRO : '';
                    currentRow.NMBAIRRO = (endereco.NMBAIRRO)? endereco.NMBAIRRO : '';
                    currentRow.DSENDERECOCONC = (endereco.DSENDERECO)? endereco.DSENDERECO : '';
                    
                    /*TODO Encontrar um jeito melhor de fazer o autocomplete atualizar os fields para os dados da currentRow*/
                    angular.element('#footer').click();
                    
                } else {
                    currentRow.CEP = '';
                }
                if(response.dataset.ERRO) ScreenService.showMessage(response.dataset.ERRO.MESSAGE, "warning");
            }).catch(function(error){
                ScreenService.showMessage('Erro ao realizar a busca.');
            });
        }, null);
        
        ScreenService.closePopup();
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm00042000_concorrente_controller', crm00042000_concorrente_controller);
});

// FILE: ./assets/js/controllers/crm00050000_Associacoes_Revenda_Controller.js
function crm00050000_Associacoes_Revenda_Controller(General, CRM_Utilities, templateManager, restEngine, ScreenService, Messages, metaDataFactory) {

    /**
     * Função para salvar um operador
     * na revenda em caso.
     * 
     * @param {object(widget)} widget ativa onde
     * está será cadastrado um operador para a 
     * revenda.
    */
    this.saveResaleOperator = function(widget){
        
        var currentRow = widget.currentRow;
        
        this.setColumnToReturnInCurrentRow(currentRow, "NROPERREVENDA");
        
        General.widgetSave(widget).then(function(response){
            
            var resaleOperatorCode = response.dataset.columnsToReturn.NROPERREVENDA;
            
            this.setResaleOperatorCode(currentRow, resaleOperatorCode);
                
        }.bind(this));
            
    };
    
    /**
     * Função para setar a coluna a ser retornada
     * na resposta do 'save'.
     * 
     * @param {object} currentRow currentRow que receberá
     * a propriedade com o nome da coluna a ser retornada.
     * 
     * @param {string} columnName nome da coluna a ser
     * retornada.
    */
    this.setColumnToReturnInCurrentRow = function(currentRow, columnName){
    
        currentRow.__columns_to_return = [columnName];

    };
    
    /**
     * Função para atribuir a coluna retornada da requisição
     * 'SAVE' na currentRow do operador retornado.
     * 
     * @param {object} currentRow currentRow que irá 
     * receber o número do operador.
     * 
     * @param {String} resaleOperatorCode
     * código do operador que será inserido
     * na currentRow.
    */
    this.setResaleOperatorCode = function(currentRow, resaleOperatorCode){
        
        currentRow.NROPERREVENDA = resaleOperatorCode;
        
    };
    
    /**
     * Função para setar o valor do filtro
     * de NRORG da field 'NMOPERADOR'.
     * 
     * @param {object(widget)} widget widget
     * ativa onde está localizado a field 'NMOPERADOR'.
    */
    
    this.setNRREVENDA = function(widget){
        
        var pegaNRREVENDA = templateManager.container.getWidget('WDGT_REVENDA');
        var valorNRRVEVENDA = pegaNRREVENDA.currentRow.NRREVENDA;
      
        
        var montadasourcefilter = {name: "NRREVENDA",
                                   operator: "=",
                                   value: valorNRRVEVENDA};
        
        
        widget.dataSourceFilter[1] = montadasourcefilter;
        
  
        widget.reload();
    };
    
    this.setFilterOperatorField = function(widget){
        
        var parentWidget = widget.parent.parent;
        var client       = parentWidget.currentRow.CDCLIENTE;
        var insertFilter = true;
        
        var operatorField = widget.getField("NMOPERADOR");
        var operatorFilter = operatorField.dataSourceFilter;
        
        var nrorgFilterIndex = CRM_Utilities.getFilterPosition(operatorFilter, "P_NRORG");
        var nrRevendaFilterIndex = CRM_Utilities.getFilterPosition(operatorFilter, "P_NRREVENDA");
        
        if(!Util.isEmptyOrBlank(client)){
            operatorFilter.forEach(function(filter){
               if(filter.name === "CDCLIENTE"){
                   filter.value = client;
                   insertFilter = false;
                }
            });
            if(insertFilter){
                var clientFilter = {name:'CDCLIENTE', operator:'=', value:client};
                operatorFilter.push(clientFilter);
            }
        }else{
            operatorFilter.forEach(function(filter, index, operatorFilter){
               if(filter.name === "CDCLIENTE"){
                   operatorFilter.splice(index, 1);
                }
            });   
        }
        
        operatorFilter[nrorgFilterIndex].value = templateManager.LOGGEDOPERATOR.NRORG;
        operatorFilter[nrRevendaFilterIndex].value = parentWidget.currentRow.NRREVENDA;
        
        operatorField.reload();
            
    };
    
    /**
     * Função para salvar um prospect na revenda
     * em caso.
     * 
     * @param {object(widget)} widget widget ativa
     * onde está sendo salvo um novo prospect.
    */
    this.saveResaleProspect = function(widget){
        
        var currentRow = widget.currentRow;
        
        this.setColumnToReturnInCurrentRow(currentRow, "NRPROSPREVENDA");
        
        General.widgetSave(widget).then(function(response){
            
            var resaleProspectCode = response.dataset.columnsToReturn.NRPROSPREVENDA;
            
            this.setResaleProspectCode(currentRow ,resaleProspectCode);
            
        }.bind(this));
        
    };
    
    /**
     * Função para setar ,na currentRow, o 
     * código gerado para o novo prospect .
     * 
     * @param {object} currentRow currentRow que
     * receberá o código do prospect.
     * 
     * @param {String} resaleProspectCode code gerado
     * para o novo prospect cadastrado.
    */
    this.setResaleProspectCode = function(currentRow, resaleProspectCode){
        
        currentRow.NRPROSPREVENDA = resaleProspectCode;
        
    };
    
    /**
     * Função para setar os valores aos filtros
     * na field de prospect para vincular ao 
     * parâmeterbag.
     * 
     * @param {object(widget)} widget widget ativa
     * onde está sendo feito o cadastro do prospect
     * e onde se localiza a field de prospect.
    */
    this.setFilterProspectField = function(widget){
        
        var parentWidget = widget.parent.parent;
        
        var prospectField = widget.getField('NMRAZSOCPROS');
        var prospectFieldFilter = prospectField.dataSourceFilter;
        
        var nrorgFilterIndex = CRM_Utilities.getFilterPosition(prospectFieldFilter, "P_NRORG");
        var nrRevendaFilterIndex = CRM_Utilities.getFilterPosition(prospectFieldFilter, "P_NRREVENDA");
        
        prospectFieldFilter[nrorgFilterIndex].value = templateManager.LOGGEDOPERATOR.NRORG;
        prospectFieldFilter[nrRevendaFilterIndex].value = parentWidget.currentRow.NRREVENDA;
        
        prospectField.reload();
        
    };
    
    /**
     * Função para salvar um cliente na 
     * revenda em caso.
     * 
     * @param {object(widget)} widget widget ativa
     * onde está sendo feito o cadastro do novo cliente.
    */
    this.saveResaleClient = function(widget){
        
        var currentRow = widget.currentRow;
        
        this.setColumnToReturnInCurrentRow(currentRow, "NRCLIEREVENDA");
        
        General.widgetSave(widget).then(function(response){
            
            var resaleClientCode = response.dataset.columnsToReturn.NRCLIEREVENDA;
            
            this.setResaleClientCode(currentRow ,resaleClientCode);
            
        }.bind(this));
        
    };
    
    /**
     * Função para setar , na currentRow, o 
     * código gerado para o novo cliente.
     * 
     * @param {object} currentRow currentRow que
     * receberá o código do cliente.
    */
    this.setResaleClientCode = function(currentRow, resaleClientCode){
        
        currentRow.NRCLIEREVENDA = resaleClientCode;
        
    };
    
    /**
     * Função para setar o valor dos filtros
     * na field de cliente.
     * 
     * @param {object(widget)} widget widget ativa
     * onde está sendo feito o cadastro do cliente
     * e onde se localiza a field de clientes.
    */
    this.setFilterClientField = function(widget){
        
        var parentWidget = widget.parent.parent;
        
        var clientField = widget.getField('NMRAZSOCCLIE');
        var clientFieldFilter = clientField.dataSourceFilter;
        
        var nrorgFilterIndex = CRM_Utilities.getFilterPosition(clientFieldFilter, "P_NRORG");
        var nrRevendaFilterIndex = CRM_Utilities.getFilterPosition(clientFieldFilter, "P_NRREVENDA");
        
        clientFieldFilter[nrorgFilterIndex].value = templateManager.LOGGEDOPERATOR.NRORG;
        clientFieldFilter[nrRevendaFilterIndex].value = parentWidget.currentRow.NRREVENDA;
        
        clientField.reload();
        
    };
    
    /**
     * Função para definir o filtro da widget
     * de oportundiade (filha da widget de prospect da revenda).
     * 
     * @param {object} widget de oportunidade.
    */
    this.setOpportunityFilterBySelectedProspect = function(widget){
        
        var parentWidget = widget.parent.parent;
        
        var opportunityWidgetFilter = widget.dataSourceFilter;
        var nrparcoportFilterIndex = CRM_Utilities.getFilterPosition(opportunityWidgetFilter, "NRPARCOPORT");
        
        opportunityWidgetFilter[nrparcoportFilterIndex].value = parentWidget.currentRow.NRPARCNEGOCIO;
        
        widget.reload();
        
    };
    
    this.updateProspect = function(widget){
      
        var currentRow = widget.currentRow;
        
        if(currentRow.NRPARCNEGOCIO){
            
            var paramsRestEngine = {
                "requestType": "Row",
                "row": currentRow
            };
                
            return restEngine.post('/crm_prosprevenda_prospect/updateProspect', paramsRestEngine,
                function(success){
                    
                   ScreenService.showMessage('Atualizado com sucesso');
                   ScreenService.closeSwipe();
                   General.changeWidgetAcessibility(widget.widgets, true);
                    
                }.bind(this),undefined,
                function(error){
                    
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
                    
                },undefined,undefined
            );
        
        }
          widget.reload();
        
    };
    
    /*cria as abas dos prospects da revenda*/
    
    this.setRevendaProspectWidgetOnActiveWidget = function(widget, position){
        widget.widgets = CRM_Utilities.setElementOnArrayDefinedPosition(this.factoryRevendaProspectElvolucaoWidget(widget), widget.widgets, position);
        widget.widgets = CRM_Utilities.setElementOnArrayDefinedPosition(this.factoryRevendaProspecTarefatWidget(widget), widget.widgets, position);
        widget.activate();
    };
    
    this.factoryRevendaProspectElvolucaoWidget = function(activeWidget){
        
        var revendaProspectEvolucao = {
            "id": "",
            "name": "WDGT_EVOLUCOES",
            "label": "Evoluções",
            "container": activeWidget.container,
            "parent": activeWidget,
            "template": "widget/master_detail/grid.html",
            "isVisible": true,
            "dataSource": {
                "name": "product#/evolcont_parcnegocio",
                "rest": true
            },
            "dataSourceFilter": [
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": "@getLocalVar('CRM_NRORGTRAB')@"
                },
                {
                    "name": "P_NRPARCNEGOCIO",
                    "operator": "=",
                    "value": "@General.getFieldValue('NRPARCNEGOCIO', 'WDGT_PROSPECT')@"
                }
            ],
            "events": [
                {
                    "name":"WidgetOnEnter",
                    "code":"args.owner.reload()"
                }
            ],
            "actions": [
                {
                    "id": "",
                    "name": "BACK_EDIT",
                    "label": "Cancelar",
                    "isVisible": true,
                    "showAsAction": "back_edit",
                    "events": [
                        {
                            "id": "",
                            "name": "ActionEvent",
                            "code": "General.widgetCancelForm(args.owner.widget); ger45000_Prospect_Controller.deleteTaskInfosInEvolutionWidget(args.owner.widget);"
                        }
                    ]
                },
                {
                    "id": "",
                    "name": "BACK_VIEW",
                    "label": "Voltar",
                    "isVisible": true,
                    "showAsAction": "back_view",
                    "events": [
                        {
                            "id": "",
                            "name": "ActionEvent",
                            "code": "General.widgetGoBackToList(args.owner.widget);"
                        }
                    ]
                },
                {
                    "id": "",
                    "name": "BACK_LIST",
                    "label": "Voltar",
                    "isVisible": true,
                    "showAsAction": "back_list",
                    "events": [
                        {
                            "id": "",
                            "name": "ActionEvent",
                            "code": "General.widgetGoBackToParent(args.owner.widget);"
                        }
                    ]
                }
            ],
            "fieldGroups": [
                {
                    "id": "",
                    "name": "AGENDAR_TAREFA",
                    "label": "Próxima Tarefa",
                    "collapsible": true,
                    "opened": true
                }
            ],
            "fields": [
                {
                    "id": "",
                    "name": "NRSEQEVOLCONT",
                    "label": "Código",
                    "class": "6",
                    "isVisible": false,
                    "readOnly": false,
                    "showOnList": false,
                    "template": "field/text-edit.html",
                    "descriptionOrder": 1
                },
                {
                    "id": "",
                    "name": "NRPARCNEGOCIO",
                    "label": "",
                    "template": "field/text-edit.html",
                    "showOnForm": false,
                    "showOnList": false,
                    "isVisible": false,
                    "readOnly": false,
                    "class": 6,
                    "events": []
                },
                {
                    "id": "",
                    "name": "DTHREVOLCONT",
                    "label": "Data da Evolução",
                    "template": "field/calendar.html",
                    "isVisible": true,
                    "showOnView": true,
                    "showOnForm": true,
                    "showOnList": true,
                    "readOnly": true,
                    "dateFormat": "DD/MM/YYYY HH:mm",
                    "class": 6,
                    "events": []
                },
                {
                    "id": "",
                    "name": "IDSENEVOCONT",
                    "label": "Sentido",
                    "template": "field/select-native.html",
                    "showOnForm": true,
                    "showOnView": true,
                    "showOnList": true,
                    "class": 6,
                    "valueField": "IDSENEVOLCONT",
                    "descriptionField": "NMSENEVOLCONT",
                    "defaultValue": "S",
                    "isVisible": true,
                    "events": [],
                    "validations": {
                        "required": true
                    },
                    "filterProperties": {
                        "validations": {}
                    },
                    "hideEmptyValue": true,
                    "dataSource": {
                        "data": [
                            {
                                "NMSENEVOLCONT": "Entrada",
                                "IDSENEVOLCONT": "E"
                            },
                            {
                                "NMSENEVOLCONT": "Saída",
                                "IDSENEVOLCONT": "S"
                            }
                        ]
                    }
                },
                {
                    "id": "",
                    "name": "NMOPERADOR",
                    "label": "Operador Responsável",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "isVisible": true,
                    "showOnForm": true,
                    "showOnList": true,
                    "readOnly": true,
                    "class": 12,
                    "itemsPerPage": 30,
                    "valueField": "CDOPEREVOL",
                    "descriptionField": "NMOPERADOR",
                    "dataSource": {
                        "name": "product#/operador",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "fields": [
                        {
                            "id": "",
                            "name": "NMOPERADOR",
                            "label": "Nome",
                            "isVisible": true,
                            "showOnList": true,
                            "template": "field/text-edit.html"
                        }
                    ],
                    "dataSourceFilter": [],
                    "outData": {
                        "CDOPERADOR": "CDOPEREVOL",
                        "NMOPERADOR": "NMOPERADOR"
                    }
                },
                {
                    "id": "",
                    "name": "NMTIPOCONT",
                    "label": "Tipo de Contato",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "isVisible": true,
                    "showOnForm": true,
                    "showOnList": true,
                    "class": 6,
                    "valueField": "CDTIPOCONT",
                    "descriptionOrder": 1,
                    "descriptionField": "NMTIPOCONT",
                    "dataSource": {
                        "name": "product#/tipocont",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "dataSourceFilter": [],
                    "outData": {
                        "NMTIPOCONT": "NMTIPOCONT",
                        "CDTIPOCONT": "CDTIPOCONT"
                    },
                    "fields": [
                        {
                            "id": "",
                            "name": "NMTIPOCONT",
                            "label": "Tipo de contato",
                            "isVisible": true,
                            "showOnList": true,
                            "template": "field/text-edit.html"
                        }
                    ],
                    "validations": {
                        "required": {}
                    }
                },
                {
                    "id": "",
                    "name": "NMMOTIEVOCON",
                    "label": "Motivo de Evolução",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "isVisible": true,
                    "showOnForm": true,
                    "showOnList": true,
                    "descriptionOrder": 2,
                    "class": 6,
                    "valueField": "CDMOTIEVOCON",
                    "descriptionField": "NMMOTIEVOCON",
                    "dataSource": {
                        "name": "product#/motievolcont_crm_perfiresult_crm_perfioper",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "dataSourceFilter": [
                        {
                            "name": "P_NRORG",
                            "operator": "=",
                            "value": ""
                        },
                        {
                            "name": "P_CDOPERADOR",
                            "operator": "=",
                            "value": ""
                        }
                    ],
                    "outData": {
                        "NMMOTIEVOCON": "NMMOTIEVOCON",
                        "CDMOTIEVOCON": "CDMOTIEVOCON"
                    },
                    "fields": [],
                    "events": [
                        {
                            "id": "",
                            "name": "FieldOnClick",
                            "code": "ger45000_Prospect_Controller.setContactReasonFilter(args.owner.field);"
                        }
                    ],
                    "validations": {
                        "required": {}
                    }
                },
                {
                    "id": "",
                    "name": "NMINTERLOCUTOR",
                    "label": "Interlocutor",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "isVisible": true,
                    "showOnForm": true,
                    "class": "6",
                    "valueField": "NRSEQINTERLOCUTOR",
                    "descriptionField": "NMINTERLOCUTOR",
                    "dataSource": {
                        "name": "product#/crud/crm_interlocutor",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "dataSourceFilter": [
                        {
                            "name": "NRPARCNEGOCIO",
                            "operator": "=",
                            "value": "@templateManager.container.getWidget('gridProspect').currentRow.NRPARCNEGOCIO@"
                        }
                    ],
                    "outData": {
                        "NMINTERLOCUTOR": "NMINTERLOCUTOR",
                        "NRSEQINTERLOCUTOR": "NRSEQINTERLOCUTOR"
                    },
                    "fields": [
                        {
                            "id": "",
                            "name": "NMINTERLOCUTOR",
                            "label": "Nome",
                            "isVisible": true,
                            "showOnList": true,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id": "",
                            "name": "NMCARGOINTERLOC",
                            "label": "Cargo",
                            "isVisible": true,
                            "showOnList": true,
                            "template": "field/text-edit.html"
                        }
                    ],
                    "events": [
                        {
                            "id": "",
                            "name": "FieldOnClick",
                            "code": "args.owner.field.reload();"
                        }
                    ]
                },
                {
                    "id": "",
                    "name": "NMRESULTEVOL",
                    "label": "Resultado",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "isVisible": true,
                    "showOnForm": true,
                    "showOnList": true,
                    "class": 6,
                    "readOnly": true,
                    "valueField": "NRSEQRESULEVOL",
                    "descriptionField": "DESCRESULEVOL",
                    "dataSource": {
                        "name": "product#/crm_resultevol_crm_perfiresult_crm_perfioper",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "dataSourceFilter": [
                        {
                            "name": "P_NRORG",
                            "operator": "=",
                            "value": ""
                        },
                        {
                            "name": "P_CDOPERADOR",
                            "operator": "=",
                            "value": ""
                        },
                        {
                            "name": "IDRESULTEVOLUCAO",
                            "operator": "=",
                            "value": "SIM"
                        }
                    ],
                    "outData": {
                        "DESCRESULEVOL": "NMRESULTEVOL",
                        "NRSEQRESULEVOL": "NRSEQRESULEVOL",
                        "IDGERPROXATIV": "IDGERPROXATIV"
                    },
                    "validations": {
                        "required": {}
                    },
                    "fields": [
                        {
                            "id": "",
                            "name": "DESCRESULEVOL",
                            "label": "Resultado",
                            "isVisible": true,
                            "showOnList": true,
                            "template": "field/text-edit.html"
                        }
                    ],
                    "events": [
                        {
                            "id": "",
                            "name": "FieldOnClick",
                            "code": "ger45000_Prospect_Controller.setResultFilter(args.owner.field);"
                        },
                        {
                            "id": "",
                            "name": "FieldOnChange",
                            "code": "ger45000_Prospect_Controller.checkNewTaskPermissionByEvolutionResult(args.owner.field.widget);"
                        }
                    ]
                },
                {
                    "id": "",
                    "name": "TXEVOLCONT",
                    "label": "Descrição",
                    "template": "field/textarea.html",
                    "isVisible": true,
                    "showOnForm": true,
                    "class": 12,
                    "textRows": 5,
                    "validations": {
                        "required": {}
                    }
                },
                {
                    "id": "",
                    "name": "DTPLANFILACONTA",
                    "label": "Data da Próxima Tarefa",
                    "template": "field/datetime.html",
                    "datetime-dateFormat": "dd/mm/yy",
                    "datetime-timeFormat": "HH:ii",
                    "isVisible": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "readOnly": true,
                    "class": 6,
                    "fieldGroup": "AGENDAR_TAREFA",
                    "events": []
                },
                {
                    "id": "",
                    "name": "NMOPERADORREAL",
                    "label": "Operador",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "isVisible": true,
                    "showOnList": false,
                    "showOnForm": true,
                    "showOnView": true,
                    "readOnly": true,
                    "fieldGroup": "AGENDAR_TAREFA",
                    "class": 6,
                    "valueField": "CDOPERADOR",
                    "descriptionField": "NMOPERADOR",
                    "dataSource": {
                        "name": "product#/crud/operador_crm_operrevenda",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "dataSourceFilter": [
                        {
                            "name": "IDTPOPERADOR",
                            "operator": "=",
                            "value": "@Util.isEmptyOrBlank(templateManager.LOGGEDOPERATOR.IDTPOPERADOR) ? 'E' : templateManager.LOGGEDOPERATOR.IDTPOPERADOR@"
                        }
                    ],
                    "fields": [
                        {
                            "id": "",
                            "name": "NMOPERADOR",
                            "label": "Nome",
                            "isVisible": true,
                            "showOnList": true,
                            "template": "field/text-edit.html"
                        }
                    ],
                    "outData": {
                        "CDOPERADOR": "CDOPERREAL",
                        "NMOPERADOR": "NMOPERADORREAL"
                    },
                    "filterProperties": {
                        "showOnList": false,
                        "showOnForm": false,
                        "showOnView": false
                    }
                },
                {
                    "id": "",
                    "name": "DSFILACONTATO",
                    "label": "Assunto da Tarefa",
                    "template": "field/text-edit.html",
                    "isVisible": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "readOnly": true,
                    "fieldGroup": "AGENDAR_TAREFA",
                    "defaultValue": "Retornar contato",
                    "class": 12,
                    "events": []
                }
            ],
            "widgets": []
        };
        
        revendaProspectEvolucao = metaDataFactory.widgetFactory(revendaProspectEvolucao);
        CRM_Utilities.factoryWidgetActions(revendaProspectEvolucao);
        
        return revendaProspectEvolucao;
        
    };
    
    this.factoryRevendaProspecTarefatWidget = function(activeWidget){
        
        var revendaProspectTarefa = {
            "id": "",
            "name": "WDGT_TAREFASS",
            "label": "Agenda de Tarefas",
            "container": activeWidget.container,
            "parent": activeWidget,
            "template": "widget/master_detail/grid.html",
            "isVisible": true,
            "dataSource": {
                "name": "product#/filacontato_agendatarefas",
                "rest": true
            },
            "dataSourceFilter": [
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": "@getLocalVar('CRM_NRORGTRAB')@"
                },
                {
                    "name": "NRPARCNEGOCIO",
                    "operator": "=",
                    "value": "@templateManager.container.getWidget('WDGT_PROSPECT').currentRow.NRPARCNEGOCIO@"
                }
            ],
            "events": [
                {
                    "name":"WidgetOnEnter",
                    "code":"args.owner.reload()"
                }
            ],
            "actions": [
                {
                    "id": "",
                    "name": "BACK_EDIT",
                    "label": "Cancelar",
                    "isVisible": true,
                    "showAsAction": "back_edit",
                    "events": [
                        {
                            "id": "",
                            "name": "ActionEvent",
                            "code": "General.widgetCancelForm(args.owner.widget);"
                        }
                    ]
                },
                {
                    "id": "",
                    "name": "BACK_LIST",
                    "label": "Voltar",
                    "isVisible": true,
                    "showAsAction": "back_list",
                    "events": [
                        {
                            "id": "",
                            "name": "ActionEvent",
                            "code": "General.widgetGoBackToParent(args.owner.widget);"
                        }
                    ]
                },
                {
                    "id": "",
                    "name": "BACK_VIEW",
                    "label": "Voltar",
                    "isVisible": true,
                    "showAsAction": "back_view",
                    "events": [
                        {
                            "id": "",
                            "name": "ActionEvent",
                            "code": "General.widgetGoBackToList(args.owner.widget);"
                        }
                    ]
                }
            ],
            "fields": [
                {
                    "id": "",
                    "name": "NRPARCNEGOCIO",
                    "label": "",
                    "template": "field/text-edit.html",
                    "isVisible": false,
                    "showOnForm": false,
                    "showOnList": false,
                    "class": "12"
                },
                {
                    "id": "",
                    "name": "DSFILACONTATO",
                    "label": "Assunto",
                    "template": "field/text-edit.html",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnView": true,
                    "showOnForm": true,
                    "maxlength": 2000,
                    "class": "12",
                    "validations": {
                        "required": {}
                    },
                    "events": [],
                    "descriptionOrder": 1
                },
                {
                    "id": "",
                    "name": "DSCLASSIFICATAREFA",
                    "label": "Classificação",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "isVisible": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "class": "6",
                    "itemsPerPage": 30,
                    "validations": {},
                    "valueField": "",
                    "descriptionField": "DSCLASSIFICATAREFA",
                    "dataSource": {
                        "name": "product#/crm_classificatarefa",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "fields": [
                        {
                            "id": "",
                            "name": "DSCLASSIFICATAREFA",
                            "label": "Classificação",
                            "isVisible": true,
                            "showOnList": true,
                            "template": "field/text-edit.html"
                        }
                    ],
                    "dataSourceFilter": [],
                    "outData": {
                        "NRSEQCLASSIFICATAREFA": "NRSEQCLASSIFICATAREFA",
                        "DSCLASSIFICATAREFA": "DSCLASSIFICATAREFA"
                    },
                    "events": []
                },
                {
                    "id": "",
                    "name": "DTPLANFILACONTA",
                    "label": "Data/Hora de Contato",
                    "template": "field/datetime.html",
                    "datetime-dateFormat": "dd/mm/yy",
                    "datetime-timeFormat": "HH:ii",
                    "datetime-preset": "datetime",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnView": true,
                    "showOnForm": true,
                    "class": "6",
                    "validations": {
                        "required": {}
                    },
                    "events": []
                },
                {
                    "id": "",
                    "name": "NMOPERADOR",
                    "label": "Operador Responsável",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnView": true,
                    "showOnForm": true,
                    "class": "12",
                    "itemsPerPage": 30,
                    "valueField": "CDOPERADOR",
                    "descriptionField": "NMOPERADOR",
                    "validations": {
                        "required": {}
                    },
                    "dataSource": {
                        "name": "product#/crud/operador_crm_operrevenda",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "dataSourceFilter": [
                        {
                            "name": "IDTPOPERADOR",
                            "operator": "=",
                            "value": "@Util.isEmptyOrBlank(templateManager.LOGGEDOPERATOR.IDTPOPERADOR) ? 'E' : templateManager.LOGGEDOPERATOR.IDTPOPERADOR@"
                        }
                    ],
                    "fields": [
                        {
                            "id": "",
                            "name": "NMOPERADOR",
                            "label": "Nome",
                            "isVisible": true,
                            "showOnList": true
                        }
                    ],
                    "outData": {
                        "NMOPERADOR": "NMOPERADOR",
                        "CDOPERADOR": "CDOPERREAL"
                    },
                    "events": []
                },
                {
                    "id": "",
                    "name": "DTREALFILACONTA",
                    "label": "Data de Conclusão",
                    "template": "field/calendar.html",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnView": true,
                    "showOnForm": true,
                    "readOnly": true,
                    "dateFormat": "DD/MM/YYYY",
                    "class": "6",
                    "events": []
                },
                {
                    "id": "",
                    "name": "NRPRIORFILACONT",
                    "label": "Prioridade",
                    "template": "field/select-native.html",
                    "hideEmptyValue": true,
                    "isVisible": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "class": "6",
                    "descriptionField": "NMPRIORFILACONT",
                    "valueField": "NRPRIORFILACONT",
                    "defaultValue": 2,
                    "validations": {
                        "required": {}
                    },
                    "dataSource": {
                        "data": [
                            {
                                "NRPRIORFILACONT": 2,
                                "NMPRIORFILACONT": "Normal"
                            },
                            {
                                "NRPRIORFILACONT": 1,
                                "NMPRIORFILACONT": "Prioridade"
                            }
                        ]
                    },
                    "events": []
                },
                {
                    "id": "",
                    "name": "NMINTERLOCUTOR",
                    "label": "Interlocutor",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "isVisible": true,
                    "showOnForm": true,
                    "class": "12",
                    "valueField": "NRSEQINTERLOCUTOR",
                    "descriptionField": "NMINTERLOCUTOR",
                    "dataSource": {
                        "name": "product#/crud/crm_interlocutor",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "dataSourceFilter": [
                        {
                            "name": "NRPARCNEGOCIO",
                            "operator": "=",
                            "value": "@templateManager.container.getWidget('gridProspect').currentRow.NRPARCNEGOCIO@"
                        }
                    ],
                    "outData": {
                        "NMINTERLOCUTOR": "NMINTERLOCUTOR",
                        "NRSEQINTERLOCUTOR": "NRSEQINTERLOCUTOR",
                        "NRTELEFONE1": "DSTELEFONETAREFA",
                        "EMAILINTERLOC": "DSEMAILTAREFA"
                    },
                    "fields": [
                        {
                            "id": "",
                            "name": "NMINTERLOCUTOR",
                            "label": "Nome",
                            "isVisible": true,
                            "showOnList": true,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id": "",
                            "name": "NMCARGOINTERLOC",
                            "label": "Cargo",
                            "isVisible": true,
                            "showOnList": true,
                            "template": "field/text-edit.html"
                        }
                    ],
                    "events": [
                        {
                            "id": "",
                            "name": "FieldOnClick",
                            "code": "args.owner.field.reload();"
                        }
                    ]
                },
                {
                    "id": "",
                    "name": "DSTELEFONETAREFA",
                    "label": "Telefone",
                    "template": "field/phone.html",
                    "isVisible": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "class": "6",
                    "maxlength": 15,
                    "events": []
                },
                {
                    "id": "",
                    "name": "DSEMAILTAREFA",
                    "label": "E-mail",
                    "template": "field/text-edit.html",
                    "isVisible": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "class": "6",
                    "validations": {
                        "mail": true
                    },
                    "events": []
                },
                {
                    "id": "",
                    "name": "DSDETEFILACONTA",
                    "label": "Descrição",
                    "template": "field/textarea.html",
                    "isVisible": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "maxlength": 4000,
                    "class": "12",
                    "events": []
                }
            ],
            "widgets": []
        };
        
        revendaProspectTarefa = metaDataFactory.widgetFactory(revendaProspectTarefa);
        CRM_Utilities.factoryWidgetActions(revendaProspectTarefa);
        
        return revendaProspectTarefa;
        
    };
    
    
    this.openWindowProspect = function(widget){
           

        var windowToOpen     = 'ger45000_prospect';
        var widgetToFilter   = 'gridProspect';
     
       
        ScreenService.confirmMessage('Deseja ir para a tela de Prospect?', 'CONFIRMATION',
        function(success){
            ScreenService.openWindow('product#'+windowToOpen).
              then(function(){
                    widgetToFilter = templateManager.container.getWidget(widgetToFilter);
                    var filter = [{
                        name : "NRPARCNEGOCIO",
                        operator : "=",
                        static : true,
                        value : widget.currentRow.NRPARCNEGOCIO
                    }]; 
                    
                    widgetToFilter.dataSourceFilter = filter;
                    widgetToFilter.reload().
                      then(function(){
                        ScreenService.closePopup(true);
                        widgetToFilter.reload();
                    });
              });
        });
    };
    
    
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm00050000_Associacoes_Revenda_Controller', crm00050000_Associacoes_Revenda_Controller);
});

// FILE: ./assets/js/controllers/crm00050000_Comunicacao_Revenda_Controller.js
function crm00050000_Comunicacao_Revenda_Controller(CRM_Utilities, crm00050000_Comunicacao_Revenda_Service, General){
    
    /**
     * Função para definir o tipo de 'save' que
     * será realizado (INSERT, UPDATE).
     * 
     * @param {object(widget)} widget widget
     * ativa onde será realizado o 'save'.
     * 
    */
    this.saveCommunition = function(widget){
    
        if(widget.currentRow.__is_new){
            
            this.saveNewCommunition(widget);
            
        }else{
            
            General.widgetSave(widget);
            
        }
        
    };
    
    /**
     * Função para inserir um novo registro na tablea
     * 'COMUNICAPARC' e salvar uma nova comunicação
     * associada a revenda em caso.
     * 
     * @param {object(widget)} widget widget
     * ativa onde está sendo realizado o cadastro
     * de uma nova comunicação.
     * 
    */
    this.saveNewCommunition = function(widget){
        
        var currentRow = widget.currentRow;
        
        this.insertNewPartnerCommunication(currentRow).then(function(response){
            
            var partnerCommunicationNumber = response.dataset.DADOS.NRCOMUNICAPARC;
            
            this.setPartnerCommunicationCode(currentRow, partnerCommunicationNumber);
            
            this.setColumnToReturnInCurrentRow(currentRow, "NRCOMUNICAREVENDA");
            
            General.widgetSave(widget).then(function(response){
            
                var communicationCode = response.dataset.columnsToReturn.NRCOMUNICAREVENDA;
                
                this.setCommunicationCodeAtCurrentRow(currentRow, communicationCode);
                
            }.bind(this));
            
        }.bind(this));
        
    };
    
    /**
     * Função para setar o número gerado para a comunicação
     * em sua currentRow.
     * 
     * @param {object} currentRow currentRow associada a
     * comunicação salva.
     * 
     * @param {int} communicationCode código gerado para
     * a comunicação.
    */
    this.setCommunicationCodeAtCurrentRow = function(currentRow, communicationCode){
        
        currentRow.NRCOMUNICAREVENDA = communicationCode;
        
    };
    
    /**
     * Função para setar a coluna a ser retornada
     * na resposta do 'save'.
     * 
     * @param {object} currentRow currentRow que receberá
     * a propriedade com o nome da coluna a ser retornada.
     * 
     * @param {string} columnName nome da coluna a ser
     * retornada.
    */
    this.setColumnToReturnInCurrentRow = function(currentRow, columnName){
    
        currentRow.__columns_to_return = [columnName];
        
    };
    
    /**
     * Função para setar o número de comunicação
     * do parceiro de negócio na currentRow recebida
     * como parâmetro.
     * 
     * @param {object} currentRow currentRow que irá 
     * receber o número de comunicação do parceiro.
     * 
     * @param {String} partnerCommunicationNumber
     * número de comunicação do parceiro que será
     * inserido na currentRow.
    */
    this.setPartnerCommunicationCode = function(currentRow, partnerCommunicationNumber){
        
        currentRow.NRCOMUNICAPARC = partnerCommunicationNumber;
        
    };
    
    /**
     * Função para definir os valores necessários
     * para um novo registro de comunicação na 
     * currentRow.
     * 
     * @param {object(widget)} widget widget ativa
     * no modo edição, onde está sendo realizado
     * um novo cadastro.
    */
    
    this.setValuesForNewCommunicationInCurrentRow = function(widget){
        
        this.setResaleNumberInCurrentRow(widget);
        
        this.setPartnerNumberInCurrentRow(widget);
        
        this.setLoggedOperatorInfos(widget);
        
    };
    
    /**
     * Função para receber o número da revenda 
     * em caso na currentRow do novo cadastro
     * de comunicação.
     * 
     * @param {object(widget)} widget widget ativa que
     * terá sua currentRow modificada.
    */
    this.setResaleNumberInCurrentRow = function(widget){
    
        widget.currentRow.NRREVENDA = widget.parent.parent.currentRow.NRREVENDA;
        
    };
    
    /**
     * Função para receber o número do parceiro 
     * da revenda em caso na currentRow do novo cadastro
     * de comunicação.
     * 
     * @param {object(widget)} widget widget ativa que
     * terá sua currentRow modificada.
    */
    this.setPartnerNumberInCurrentRow = function(widget){
        
        widget.currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        
    };
    
    /**
     * Função para setar as informações necessários
     * do operador logado na currentRow da widget
     * ativa.
     * 
     * @param {object(widget)} widget widget ativa
     * no ambiente de edição, que terá sua currentRow
     * modificada.
    */
    this.setLoggedOperatorInfos = function(widget){
        
        var currentRow = widget.currentRow;
        var parentWidget = widget.parent.parent;
        
        currentRow.NRORG = parentWidget.OPERATORLOGGED.NRORG;
        currentRow.CDOPERADOR = parentWidget.OPERATORLOGGED.CDOPERADOR;
            
    };
    
    /**
     * Função para inserir uma comunicação
     * ligado ao parceiro em caso na tabela
     * 'COMUNICAPARC'.
     * 
     * @param {obejct} currentRow currentRow 
     * onde se localiza as informações para o
     * novo registro.
    */
    this.insertNewPartnerCommunication = function(currentRow){
        
        return crm00050000_Comunicacao_Revenda_Service.callForInsertNewPartnerCommunication(currentRow);
        
    };
    
    /**
     * Função que executará todas as funções 
     * requisitadas no evento 'WidgetOnEnterOnce',
     * da widget de formas de comunicação.
     * 
     * @param {object} widget widget de formas de
     * comunicação.
    */
    this.resaleComunicationWidgetOnEnterOnce = function(widget){
        
        CRM_Utilities.setDefaultOrgFilterAndOperatorOrgFilter(widget.getField('NMFORMACOMU'));
        
        CRM_Utilities.setDefaultOrgNumberFilterValue(widget);
            
    };
    
}

Configuration(function(ContextRegister){
   ContextRegister.register("crm00050000_Comunicacao_Revenda_Controller", crm00050000_Comunicacao_Revenda_Controller); 
});


// FILE: ./assets/js/controllers/crm00050000_Interlocutor_Revenda_Controller.js
function crm00050000_Interlocutor_Revenda_Controller(General, ScreenService, CRM_Utilities, crm00050000_Interlocutor_Revenda_Service, templateManager, ZHPromise) {
    
    /**
     * Valida a inscrição informada pelo usuário
     * e seta na currentRow da widget o código do
     * tipo da inscrição através do método 
     * 'setInscriptionTypeInCurrentRow', caso a 
     * inscrição seja inválida, ele limpa os campos
     * e emite uma mensagem.
     * 
     * @param {object} widget widget onde está sendo
     * realizado o cadastro do interlocutor.
    */
    this.validateInterlocutorInscription = function(widget){
        
        var currentRow = widget.currentRow;
        
        var resultValidate = General.inscricaoFormat(currentRow.NRINSCRICAOPARC);
        
        if(resultValidate.valid && resultValidate.value){
            
            this.setInscriptionTypeInCurrentRow(widget, resultValidate.tipo.cod);
            
            currentRow.NRINSCRICAOPARC = resultValidate.value;
            
        }else{
            
            this.showErrorMessageForInscription(currentRow.NRINSCRICAOPARC.length);
            
            currentRow.NRINSCRICAOPARC = "";
            currentRow.CDTIPOINSCRICAO = "";
        }
        
    };
    
    /**
     * Função para exibir a mensagem de erro referente
     * ao número de inscrição informado.
     * 
     * @param {int} inscription número de inscrição informado.
    */
    this.showErrorMessageForInscription = function(inscription){
    
        if(inscription){
    
            switch(inscription){
                
                case 11:
                    ScreenService.showMessage("Número de CPF inválido.");
                    break;
                case 14:
                    ScreenService.showMessage("Número de CNPJ inválido.");
                    break;
                default:
                    ScreenService.showMessage("Número de incrição inválido.");
            }
        
        }
        
    };
    
    /**
     * Seta na currentRow da widget, o código 
     * da inscrição informada.
     * 
     * @param {object} widget onde está sendo 
     * realizada o cadastro do interlocutor.
     * 
     * @param {int} inscriptionCod código da 
     * inscrição informada.
    */
    this.setInscriptionTypeInCurrentRow = function(widget, inscriptionCod){
        
        var currentRow = widget.currentRow;
        
        if (inscriptionCod){
            
            switch(inscriptionCod){
                
                case "F":
                    currentRow.CDTIPOINSCRICAO = "CPF";
                break;
                
                case "J":
                    currentRow.CDTIPOINSCRICAO = "CNPJ";
                break;
                
                case "O":
                    currentRow.CDTIPOINSCRICAO = "CODIGO";
                break;
                
                case "I":
                    currentRow.CDTIPOINSCRICAO = "LIVRE";
                break;
            }
            
        }
    };
    
    /**
     * Função para definir o procedimento para salver
     * as informações recebidas pelo formulário de registro
     * de interlocutor, podendo ser um atualização ou o
     * cadastro de um novo registro.
     * 
     * @param {object(widget)} widget widget ativa onde está
     * sendo realizado o cadastro ou a atualização de um
     * interlocutor.
    */
    this.saveResaleInterlocutor = function(widget){
        
        var currentRow = widget.currentRow;
        
        if(currentRow.__is_new){
            
            this.saveNewResaleInterlocutor(widget);
            
        }else{
            
            this.saveInterlocutorEdition(widget);
            
        }
            
    };
    
    /**
     * Função para salver um novo interlocutor
     * ligado a revenda em caso.
     * 
     * @param {object(widget)} widget widget ativa
     * onde está sendo realizado o cadastro do novo
     * interlocutor.
    */
    this.saveNewResaleInterlocutor = function(widget){
        
        var currentRow = widget.currentRow;
        var promise = ZHPromise.defer();
        
        this.setValuesToSaveInCurrentRow(widget);
        
        General.widgetSave(widget).then(function(response){
           
            var nrParcNegocio = response.dataset.columnsToReturn.NRPARCNEGOCIO;
           
            this.setPartnerNumberInCurrentRow(currentRow, nrParcNegocio);
            
            this.insertPartnerCommunication(widget);
            
            this.insertPartnerRelation(widget);
            
            this.insertPartnerParceria(widget);
            promise.resolve();
            
        }.bind(this));
        
        return promise.promise;
    };
    
    /**
     * Função para setar o número do parceiro 
     * cadastrado na currentRow da widget ativa.
     * 
     * @param {object(widget)} widget widget ativa
     * onde está sendo realizado o cadastro do interlocutor.
     * 
     * @param {int} nrParcNegocio número do parceiro cadastrado.
    */
    this.setPartnerNumberInCurrentRow = function(currentRow, nrParcNegocio){
        
        currentRow.NRPARCNEGOCIO = nrParcNegocio;
            
    };
    
    /**
     * Função para definir os valores necessários, na 
     * currentRow, para realizado o cadastro de um novo
     * interlocutor.
     * 
     * @param {object(widget)} widget widget ativa
     * onde está sendo realizado o cadastro de um novo
     * interlocutor.
    */
    this.setValuesToSaveInCurrentRow = function(widget){
        
        var currentRow = widget.currentRow;
        
        CRM_Utilities.setColumnToReturnInCurrentRow(currentRow, "NRPARCNEGOCIO");
        
        this.setInterlocutorSecundaryName(currentRow);
        
        this.setPersonType(currentRow);
        
        this.setPartnerPrincipalType(currentRow);
        
        this.setFusedPartnerId(currentRow);
        
        this.setPartnerDefaultState(currentRow);
            
    };
    
    /**
     * Função para igualar o nome secundário do 
     * interlocutor ao nome principal digitado pelo
     * usuário.
     * 
     * @param {object} currentRow currentRow do 
     * registro do novo interlocutor.
    */
    this.setInterlocutorSecundaryName = function(currentRow){
        
        var widgetPrincipal = templateManager.container.getWidget('WDGT_REVENDA');
        
        if(currentRow.NMPRINCIPALPARC){
        
            currentRow.NMSECUNDARIPARC = 'Referente a Revenda '+widgetPrincipal.currentRow.NMRAZSOCREVENDA;
            
        }
        
    };
    
    /**
     * Função para definir se a inscrição informada
     * é uma inscrição de pessoa física ou jurídica.
     * 
     * @param {object} currentRow currentRow do 
     * registro do novo interlocutor.
    */
    this.setPersonType = function(currentRow){

        var inscription = currentRow.NRINSCRICAOPARC;
        var inscriptionWithoutSymbols = inscription.replace(/[^0-9]/g, "");
        
        if(inscriptionWithoutSymbols.length === 11){
            
            currentRow.IDPESSOAFISICA = "S"; 
            currentRow.IDINSTITUICAO = "N";
            
        }else if(inscriptionWithoutSymbols .length === 14){
            
            currentRow.IDPESSOAFISICA = "N"; 
            currentRow.IDINSTITUICAO = "S";
            
        }else{
            
            currentRow.IDPESSOAFISICA = "N"; 
            currentRow.IDINSTITUICAO = "N";
            
        }
        
        
    };
    
    /**
     * Função para setar o tipo do parceiro
     * que será cadastrado.
     * 
     * @param {object} currentRow currentRow do 
     * registro do novo interlocutor.
    */
    this.setPartnerPrincipalType = function(currentRow){
        
        currentRow.CDTIPOPARCPRINCIPAL = "INTERLOCUTOR";
        
    };
    
    /**
     * Função para definir que o parceiro não
     * está sendo mesclado com nenhum outro
     * parceiro.
     * 
     * @param {object} currentRow currentRow do 
     * registro do novo interlocutor.
    */
    this.setFusedPartnerId = function(currentRow){
        
        currentRow.IDPARCFUNDIDO = "N";
        
    };
    
    /**
     * Função para setar o valor inicial do estado
     * do novo parceiro.
     * 
     * @param {object} currentRow currentRow do 
     * registro do novo interlocutor.
    */
    this.setPartnerDefaultState = function(currentRow){
        currentRow.IDATIVO = "S";
    };
    
    /**
     * Função para chamar funções que serão executadas
     * no evento 'New Row' da widget de interlocutor.
     * 
     * @param {object(widget)} widget widget de interlocutor.
    */
    this.interlocutorWidgetNewRow = function(widget){
      
        this.setLoggedOperatorInfosInCurrentRow(widget);
        
    };
    
    
    /**
     * Função para setar as informações do operador
     * logado na currentRow da widget recebida como 
     * parâmetro.
     * 
     * @param {object(widget)} widget widget ativa
     * onde está sendo realizado o cadastro de um novo
     * interlocutor.
    */
    this.setLoggedOperatorInfosInCurrentRow = function(widget){
      
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        var currentRow = widget.currentRow;
      
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
      
        
    };
    
    /**
     * Função para inserir os meios de comunicação
     * do interlocutor cadastrado.
     * 
     * @param {object(widget)} widget widget ativa onde
     * está sendo feito o cadastro do interlocutor.
    */
    this.insertPartnerCommunication = function(widget){
        
        var currentRow;
        
        if(widget.currentRow){
            currentRow = widget.currentRow;
        }else{
            currentRow = widget;
        }
        
        if(currentRow.NRTELEFONEINTERLOC){
            
            this.insertPartnerPhone(widget).then(function(){
                
                if(currentRow.DSEMAILINTERLOC){
            
                    this.insertPartnerEmail(widget);
                    
                }
                    
            }.bind(this));
            
        }else if(currentRow.DSEMAILINTERLOC){
            
            this.insertPartnerEmail(widget);
            
        }
        
    };
    
    /**
     * Função para insetir o número de telefone
     * do interlocutor em cadastro.
     * 
     * @param {object(widget)} widget widget ativa
     * onde está sendo feito o cadastro do interlocutor.
    */
    this.insertPartnerPhone = function(widget){
        
        var currentRow;
        
        if(widget.currentRow){
            currentRow = widget.currentRow;
        }else{
            currentRow = widget;
        }
        var interlocutorPhone = this.removePhoneMask(currentRow.NRTELEFONEINTERLOC);
        
        this.setPartnerCommunicationInCurrentRow(currentRow, interlocutorPhone);
        this.setPartnerCommunicationTypeInCurrentRow(currentRow, "01");
        
        return crm00050000_Interlocutor_Revenda_Service.callForInsertPartnerCommunication(widget);
        
    };
    
    /**
     * Função para remover a máscara do 
     * número de telefone recebido como
     * parâmetro.
     * 
     * @param {string} phone número de telefone
     * com a máscara.
    */
    this.removePhoneMask = function(phone){
        
        return phone.replace(/[^0-9]/g, "");
        
    };
    
    /**
     * Função para insetir o E-Mail 
     * do interlocutor em cadastro.
     * 
     * @param {object(widget)} widget widget ativa
     * onde está sendo feito o cadastro do interlocutor.
    */
    this.insertPartnerEmail = function(widget){
        
        var currentRow;
        
        if(widget.currentRow){
            currentRow = widget.currentRow;
        }else{
            currentRow = widget;
        }
        
        this.setPartnerCommunicationInCurrentRow(currentRow, currentRow.DSEMAILINTERLOC);
        this.setPartnerCommunicationTypeInCurrentRow(currentRow, "05");
        
        crm00050000_Interlocutor_Revenda_Service.callForInsertPartnerCommunication(widget);
        
    };
    
    /**
     * Função para definir a comunicação do
     * interlocutor na currentRow do cadastro.
     * 
     * @param {object} currentRow currentRow do cadastro
     * do interlocutor.
     * 
     * @param {string} communication comunicação do 
     * interlocutor.
    */
    this.setPartnerCommunicationInCurrentRow = function(currentRow, communication){
        
        currentRow.CDCOMUNICAPARC = communication;
        
    };
    
    /**
     * Função para definir a forma de comunicação do
     * interlocutor na currentRow do cadastro.
     * 
     * @param {object} currentRow currentRow do cadastro
     * do interlocutor.
     * 
     * @param {string} codigo da formaa da communication 
     * comunicação do interlocutor.
    */
    this.setPartnerCommunicationTypeInCurrentRow = function(currentRow, cdCommunication){
        
        currentRow.CDFORMACOMU = cdCommunication;
        
    };
    
    /**
     * Função para inserir um relacionamento
     * de parceiros.
     * 
     * @param {object(widget)} widget widget ativa
     * onde está sendo feito o cadastro do interlocutor.
    */
    this.insertPartnerRelation = function(widget){
        
        this.getResalePartnerNumber(widget);
        
        crm00050000_Interlocutor_Revenda_Service.callForInsertPartnerRelation(widget);
        
    };
    
    /**
     * Função para inserir um relacionamento
     * de parceiros.
     * 
     * @param {object(widget)} widget widget ativa
     * onde está sendo feito o cadastro do interlocutor.
    */
    this.insertPartnerParceria = function(widget){
        
        this.getResalePartnerNumber(widget);
        
        crm00050000_Interlocutor_Revenda_Service.callForInsertPartnerParceria(widget);
        
    };
    
    /**
     * Função para setar na currentRow de cadastro
     * do novo interlocutor o número da revenda em
     * cado.
     * 
     * @param {object(widget)} widget widget ativa
     * onde está sendo feito o cadastro do interlocutor.
    */
    this.getResalePartnerNumber = function(widget){
    
        var currentRow = widget.currentRow;
        
        currentRow.NRPARCNEGOCIOREV = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        
    };
    
    /**
     * Função para setar o filtro da widget
     * de 'INTERLOCUTOR';
     * 
     * @param {object(widget)} widget widget ativa
     * ligada a revenda em caso.
    */
    this.setInterlocutorWidgetFilter = function(widget){
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        var interlocutorWidget = templateManager.container.getWidget('WDGT_INTERLUCUTOR');
        var interlocutorWidgetFilter = interlocutorWidget.dataSourceFilter;
        
        var nrorgFilterIndex = CRM_Utilities.getFilterPosition(interlocutorWidgetFilter, "P_NRORG");
        var nrParcRevendaFilterIndex = CRM_Utilities.getFilterPosition(interlocutorWidgetFilter, "P_PARCREVENDA");
        
        interlocutorWidgetFilter[nrorgFilterIndex].value = loggedOperatorInfos.NRORG;
        interlocutorWidgetFilter[nrParcRevendaFilterIndex].value = widget.currentRow.NRPARCNEGOCIO;
            
    };
    
    /**
     * Função para salvar as edições feitas
     * no interlocutor selecionado.
     * 
     * @param {object(widget)} widget widget ativa 
     * onde está sendo feita a edição do interlocutor.
    */
    this.saveInterlocutorEdition = function(widget){
        
        this.updateRelationState(widget);
        
        this.deletePartnerCommunication(widget).then(function(){
            
            this.insertPartnerCommunication(widget);
            
            General.widgetSave(widget);
                
        }.bind(this));
            
    };
    
    /**
     * Função para deletar uma comunicação, no ambiente
     * de edição, ligada ao interlocutor em casoç.
     * 
     * @param {object(widget)} widget widget ativa
     * onde está sendo realizado a edição de um 
     * interlocutor.
    */
    this.deletePartnerCommunication = function(widget){
        
        return crm00050000_Interlocutor_Revenda_Service.callForDeletePartnerCommunication(widget);

    };
    
    /**
     * Função para salvar o estado do relacionamento
     * entre o interlocutor em edição e a revenda 
     * em caso.
     * 
     * @param {object(widget)} widget widget ativa
     * onde está sendo realizado a edição de um 
     * interlocutor.
    */
    this.updateRelationState = function(widget){
        
        this.getResalePartnerNumber(widget);
        
        crm00050000_Interlocutor_Revenda_Service.callForUpdateRelationState(widget);
        
    };
    
    /**
     * Função para deletar um interlocutor.
     * 
     * @param {object(widget)} widget widget ativa
     * , no modo 'view', mostrando o interlocutor
     * selecionado.
    */
    this.deleteResaleInterlocutor = function(widget){
        
        this.inactivatePartner(widget);
        
        this.deleteResaleRelation(widget).then(function(){
            
            ScreenService.closeSwipe().then(function(){
               
                widget.list();
                widget.reload();
                
            });
            
        });
        
    };
    
    this.inactivatePartner = function(widget){
        
        crm00050000_Interlocutor_Revenda_Service.callForInactivatePartner(widget);
        
    };
    
    this.deleteResaleRelation = function(widget){
        
        this.getResalePartnerNumber(widget);
        
        return crm00050000_Interlocutor_Revenda_Service.callForDeleteResaleRelation(widget);
        
    };
    
}

Configuration(function (ContextRegister) {
    ContextRegister.register("crm00050000_Interlocutor_Revenda_Controller", crm00050000_Interlocutor_Revenda_Controller);
});


// FILE: ./assets/js/controllers/crm00050000_Revenda_Controller.js
function crm00050000_Revenda_Controller(General, ScreenService, CRM_Utilities, templateManager, crm00050000_Revenda_Service, crm00050000_Interlocutor_Revenda_Repository, crm00050000_Interlocutor_Revenda_Controller, restEngine,  AbaInterlocutorController, ABAEnderecoParceiroController, ZhFilterPreferences) {
    
    
    /**
     * Método para selecionar a função save 
     * de acordo com a rotina (insert, update);
     * 
     * @param {object(widget)} widget widget onde
     * estão os objetos para o save.
    */
    this.save = function(widget){
        var currentRow = widget.currentRow;
        if(widget.isValid()) {
            if(currentRow.__is_new){
                var widgetEndereco = templateManager.container.getWidget('WDGT_ENDERECOS');
                if(!currentRow.CDCLIENTE) {
                    if(widgetEndereco.isValid()) {
                        this.setValuesAndSaveNewResale(widget);  
                        this.ocultaInterlocutor();
                    }else{
                        this.openTabEndereço(widget);
                    }
                }else{
                    this.getEnderecoCliente(currentRow).then(function(response) {
                        if(response.dataset.DADOS.POSSUIENDERECO) {
                            this.setValuesAndSaveNewResale(widget);
                            this.ocultaInterlocutor();
                        }else{
                            this.openTabEndereço(widget);    
                        }
                    }.bind(this));
                }
            }else{
                
                this.setValuesAndEditResale(widget);
                this.ocultaInterlocutor();
                
            }
        }
    }; 
    
    this.deleteRevenda = function(widget){
      ScreenService.confirmMessage('Deseja realmente excluir a Revenda?', 'QUESTION',
        function(success){
            var paramsRestEngine = {
                requestType:'Row',
                row:widget.currentRow
            };
            
            restEngine.post('product#/crm_revenda/deleteRevenda', paramsRestEngine).
                then(function(response){
                    
                        ScreenService.showMessage('Revenda excluida');
                        ScreenService.closeSwipe().then(function(){
                            ScreenService.closePopup(true);
                            widget.reload();
                        });
                        
                }).catch(function(error){
                    ScreenService.showMessage(error.data.error);    
                });        
        }, 
          function(cancel){
            
        });
        

        
    };
    
     /**
     * Verifica se já existem clientes vinculados
     * aquela inscrição ou nome
    */
    this.getEnderecoCliente = function(currentRow){
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        return restEngine.post('/getEndeClie', paramsRestEngine);
    };
    
    
    /**
     * Método para abrir a tab de endereço se a revenda
     * selecionada não for gerada automaticamente pelo cliente.
     * 
     * @param {object(widget)} widget principal da revenda
    */
    this.openTabEndereço = function(widget){
        
        var enderecoWidget = templateManager.container.getWidget('WDGT_ENDERECOS');
        
        if(enderecoWidget.template !== 'widget/form.html'){
            enderecoWidget.template = 'widget/form.html';
        }
        
        CRM_Utilities.overwriteAction(enderecoWidget, "SALVAR_ENDERECO", "crm00050000_Revenda_Controller.prepareResaleAdress(args.owner.widget);");
        
        enderecoWidget.actions.forEach(function(action){
            if(action.name !== "SALVAR_ENDERECO"){
                action.isVisible = false;
            }else{
                action.isVisible = true;
            }
        });
        
        enderecoWidget.enabled = true;
        enderecoWidget.reload();
        enderecoWidget.newRow();
        
        widget.openTab(enderecoWidget.name);
        
    };
    
    /**
     * Método para preparar os dados de endereço 
     * da revenda
     * 
     * @param {object(widget)} widget de endereco
    */
    this.prepareResaleAdress = function(widget){
        var widgetPrincipal;
        
        if(widget.isValid()){
            if(!Util.isUndefined(widget.parent.parent)) {
                widgetPrincipal = widget.parent.parent;
            } else {
                widgetPrincipal = widget.parent;
            }
            
            widgetPrincipal.currentRow.ENDERECO = widget.currentRow;
            
            widget.currentRow = widget.getDefaultValues().currentRow;
            this.setValuesAndSaveNewResale(widgetPrincipal);
            
        }
    };
    
    /**
     * Função preparada para receber um
     * novo cadastro de revenda,inserindo
     * um novo parceiro de negócio e editando
     * os valores necessários.
     * 
     * @param {object(widget)} widget widget
     * ativa, contendo os objetos para o save.
    */
    this.setValuesAndSaveNewResale = function(widget){
        
        var currentRow = widget.currentRow;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        if(widget.isValid()){
            currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
            currentRow.NRINSCRIREVENDA = this.removeInscriptionMask(currentRow.NRINSCRIREVENDA);
            currentRow.CDTIPOINSCRICAO = this.convertClientInscTypeToDefaultInscType(currentRow.CDTIPOINSCRICAO);
            
            this.checkIfEmptyFantasyName(currentRow);
            
            if(currentRow.CDCLIENTE){
                currentRow.__newClient = false;
            }else{
                currentRow.__newClient = true;
                currentRow.CDCLIENTE = '';
            }
            
            crm00050000_Revenda_Service.callInsertParcNegocioRoute(currentRow).then(function(){
                
                var rowIntelroc = angular.copy(widget.currentRow);
                
                rowIntelroc.NRRELACIONAPARC = '';
                rowIntelroc.NRPARCNEGOCIOREV = currentRow.NRPARCNEGOCIO;
                rowIntelroc.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
                
                this.saveInterlocResale(widget.currentRow).then(function(interlocutor){
                    
                    this.setColumnToBeReturned(currentRow, "NRREVENDA");
                    General.widgetSave(widget).then(function(response){
                        
                        var resaleCode = response.dataset.columnsToReturn.NRREVENDA;
                        this.setResaleCodeAtCurrentRowResale(currentRow, resaleCode);
                        this.replicaRevenda(currentRow);
                        this.goBackWidgetEndereco();
                        
                        var widgetEndereco = templateManager.container.getWidget('WDGT_ENDERECOS');
                        CRM_Utilities.setActionDefaultCode(widgetEndereco, "SALVAR_ENDERECO");
                        
                    }.bind(this));
                }.bind(this));
            }.bind(this));
        }
        
    };
    
    this.saveInterlocResale = function(currentRow){
        
        var resaleWidget = templateManager.container.getWidget('WDGT_REVENDA');
        var interlocutorWidgetIndex = CRM_Utilities.getObjectPositionInArrayByName(resaleWidget.widgets, "WDGT_INTERLOCUTOR");
        var widget = resaleWidget.widgets[interlocutorWidgetIndex];
        var parentWidget;
        
        if(!Util.isUndefined(widget.parent.parent)) {
            parentWidget = widget.parent.parent;
        } else {
            parentWidget = widget.parent;
        }
        
        var loggedOperatorInfos = parentWidget.OPERATORLOGGED;
        var rowIntelroc = {};
        
        rowIntelroc.INTERLOCUTOR = parentWidget.currentRow.INTERLOCUTOR;
        rowIntelroc.NRPARCNEGOCIOREV = parentWidget.currentRow.NRPARCNEGOCIO;
        rowIntelroc.NRTELEFONEINTERLOC = parentWidget.currentRow.NRTELEFONEINTERLOC;
        rowIntelroc.DSEMAILINTERLOC = parentWidget.currentRow.DSEMAILINTERLOC;
        rowIntelroc.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
        rowIntelroc.NRORG = loggedOperatorInfos.NRORG;
        rowIntelroc.IDATIVO = 'S';
        widget.currentRow = rowIntelroc;
        
        return crm00050000_Revenda_Service.callInsertNewResaleInterlocutor(widget.currentRow);
        
    };
    
     /**
     * Função para pegar os dados de comunicação 
     * da revenda e montar um object, para salvar
     * na comunicaparc
     * 
     * @param {object(field)} field contendo
     * name e value dos modos de comunicação.
    */
    this.buildComunicaparc = function(field){
        var currentRow = field.widget.currentRow;
        if(!Util.isEmptyOrBlank(field.value())){
            if(!currentRow.__is_new){
                currentRow.OLDCOMUNICAPARC = angular.copy(currentRow.COMUNICAPARC);
            }
            var objCom = {name:field.name, value:field.value()};
            if(currentRow.COMUNICAPARC){
               currentRow.COMUNICAPARC.forEach(function(comunicacao){
                    if(comunicacao.name === objCom.name){
                        comunicacao.value = objCom.value;
                    }else if(currentRow.COMUNICAPARC.length<2){
                        currentRow.COMUNICAPARC.push(objCom);    
                    }
               });
            }else{
                currentRow.COMUNICAPARC = [objCom];
            }
        }
    };
    
    this.buildComunicaparcAfterMoveRow = function(widget){
        var fieldEmail = widget.getField('DSEMAILREVENDA');
        var fieldTelefone = widget.getField('NRTELREVENDA');
        
        this.buildComunicaparc(fieldEmail);
        this.buildComunicaparc(fieldTelefone);
    };
    
    this.replicaRevenda = function(currentRow){
        return crm00050000_Revenda_Service.callReplicaRevenda(currentRow);    
    };
    
    this.widgetCancelForm = function(widget){
        General.widgetCancelForm(widget);
        this.goBackWidgetEndereco();
    };
    
    this.goBackWidgetEndereco = function(){
        
        var widgetEndereco = templateManager.container.getWidget('WDGT_ENDERECOS');
        
        widgetEndereco.template = 'widget/master_detail/grid.html';
        
        widgetEndereco.currentRow = widgetEndereco.getDefaultValues().currentRow;
        
        widgetEndereco.list();
        widgetEndereco.reload();
        
        widgetEndereco.actions.forEach(function(action){
            action.isVisible = true;
        });
        
    };
    
    /**
     * Função preparada para salvar
     * as alterações de uma revenda,
     * editando os valores necessários e 
     * setando a inscrição formatada para o 
     * modo view depois que o save for realizado.
     * 
     * @param {object(widget)} widget widget
     * ativa, contendo os objetos para o save.
    */
    this.setValuesAndEditResale = function(widget){
        
        var currentRow = widget.currentRow;
        
        currentRow.NRINSCRIREVENDA = this.removeInscriptionMask(currentRow.NRINSCRIREVENDA);
        
        this.checkIfEmptyFantasyName(currentRow);
            
            General.widgetSave(widget).then(function(){
                
                this.formatsResaleInscription(widget);
                
            }.bind(this));
        
    };
    
    /**
     * Função para setar na currentRow recebia
     * a coluna que será retonarda depois que
     * o save for realizado
     * 
     * @param {object} currentRow currentRow que irá
     * receber o parâmetro da coluna a ser retornada.
     * 
     * @param {String} columnName Nome da coluna a ser 
     * retornada.
    */
    this.setColumnToBeReturned = function(currentRow, columnName){
    
        currentRow.__columns_to_return = [columnName];
        
    };
    
    /**
     * Função para setar o código da revenda em
     * sua pŕopria currentRow, para ser exibida 
     * no mode view sem precisar dar um reload na widget.
     * 
     * @param {object} resaleCurrentRow currentRow 
     * da revenda salva.
     * 
     * @param {int} resaleCode Código gerado para a 
     * nova revenda.
    */
    this.setResaleCodeAtCurrentRowResale = function(resaleCurrentRow, resaleCode){
    
        resaleCurrentRow.NRREVENDA = resaleCode;
    
    };
    
    /**
    * Função para remover todos os caracteres não
    * numércios do número de inscrição recebida.
    * 
    * @param {int} inscription Inscrição que será
    * edita.
    * 
    * @return {int} inscription Inscrição editada.
    */
    this.removeInscriptionMask = function(inscription){
    
        return inscription.replace(/[^0-9]/g, ""); 
        
    };
    
    /**
     * Função para setar o nome fantasia de uma revenda
     * caso ela não fosse informada.
     * 
     * @param {object} currentRow currentRow da revenda
     * em processo de cadastro.
    */
    this.checkIfEmptyFantasyName = function(currentRow){
    
        if(!currentRow.NMFANTREVENDA){
            
            currentRow.NMFANTREVENDA = currentRow.NMRAZSOCREVENDA;
            
        }
        
    };
    
    /**
     * Função para preparar o ambiente de cadastro
     * de uma nova revenda, setando:
     * 
     * O operador logado na currentRow,
     * 
     * @param {object(widget)} widget widget onde será
     * cadastrada a nova revenda.
    */
    this.prepareSwipeForResaleRegister = function(widget){
      
        this.setOperatorLogged(widget);
        
    };
    
    
    /**
     * Valida a inscrição informada pelo usuário
     * e seta na currentRow da widget o código do
     * tipo da inscrição através do método 
     * 'setInscriptionTypeInCurrentRow', e a máscara
     * da inscrição, caso a inscrição seja inválida,
     * ele limpa os campos e manda uma mensagem.
     * 
     * @param {object} widget widget onde está sendo
     * realizado o cadastro da revenda.
    */
    this.validateResaleInscription = function(widget){
        
        var currentRow = widget.currentRow;
        
        var resultValidate = General.inscricaoFormat(currentRow.NRINSCRIREVENDA);
        
        if(resultValidate.valid && resultValidate.value){
            
            this.setInscriptionTypeInCurrentRow(widget, resultValidate.tipo.cod);
            
            this.setFormatedInscriptionInCurrentRow(widget, resultValidate.value);
            
            if(!widget.currentRow.CDCLIENTE){
                this.verificaClienteExistente(widget.currentRow).then(function(response){
                    var cliente = response.dataset.DADOS.CLIENTES[0] ? response.dataset.DADOS.CLIENTES[0] : '';
                    if(!Util.isEmptyOrBlank(cliente)){
                        ScreenService.confirmMessage('Este número de inscrição já está vinculado ao Cliente: <br>'+cliente.NMRAZSOCCLIE+'<br> Gostaria de importar os dados deste Cliente para a Revenda? ', 'CONFIRMATION',
                        function(success){
                            widget.currentRow.CDCLIENTE       = cliente.CDCLIENTE;
                            widget.currentRow.NMRAZSOCCLIE    = cliente.NMRAZSOCCLIE;
                            widget.currentRow.NMFANTREVENDA   = cliente.NMRAZSOCCLIE;    
                            widget.currentRow.NMRAZSOCREVENDA = cliente.NMRAZSOCCLIE;
                        }); 
                    }
                });
            }
        }else{
            
            this.showErrorMessageForInscription(currentRow.NRINSCRIREVENDA.length);
            
            currentRow.NRINSCRIREVENDA = "";
            currentRow.CDTIPOINSCRICAO = "";
        }
        
    };
    
    /**
     * Verifica se já existem clientes vinculados
     * aquela inscrição ou nome
    */
    this.verificaClienteExistente = function(currentRow){
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        return restEngine.post('/validaCliente', paramsRestEngine);
    };
    
    /**
     * Função para setar a inscrição formatada
     * na currentRow (quando a widget ativa não for um filtro).
     * 
     * @param {object(widget)} widget widget ativa
     * onde está sendo realizada o cadastro da revenda.
     * 
     * @para {int} formatedInscription inscrição formatada.
    */
    this.setFormatedInscriptionInCurrentRow = function(widget, formatedInscription){
        
        var currentRow = widget.currentRow;
        
        if(widget.name !== "filterPopup"){
            currentRow.NRINSCRIREVENDA = formatedInscription;
        }
        
    };
    
    /**
     * Função para exibir a mensagem de erro referente
     * ao número de inscrição informado.
     * 
     * @param {int} inscription número de inscrição informado.
    */
    this.showErrorMessageForInscription = function(inscription){
    
        if(inscription){
    
            switch(inscription){
                
                case 11:
                    ScreenService.showMessage("Número de CPF inválido.");
                    break;
                case 14:
                    ScreenService.showMessage("Número de CNPJ inválido.");
                    break;
                default:
                    ScreenService.showMessage("Número de incrição inválido.");
            }
        
        }
        
    };
    
    /**
     * Seta na currentRow da widget, o código
     * da inscrição informada.
     * 
     * @param {object} widget onde está sendo 
     * realizada o cadastro da revena.
     * 
     * @param {int} inscriptionCod código da 
     * inscrição informada.
    */
    this.setInscriptionTypeInCurrentRow = function(widget, inscriptionCod){
        
        var currentRow = widget.currentRow;
        
        if (inscriptionCod){
            
            switch(inscriptionCod){
                
                case "F":
                    currentRow.CDTIPOINSCRICAO = "CPF";
                break;
                
                case "J":
                    currentRow.CDTIPOINSCRICAO = "CNPJ";
                break;
                
                case "O":
                    currentRow.CDTIPOINSCRICAO = "CODIGO";
                break;
                
                case "I":
                    currentRow.CDTIPOINSCRICAO = "LIVRE";
                break;
            }
            
        }
    };
    
    /**
     * Função para formatar a inscrição quando o modo
     * view for chamado.
     * 
     * @param {object(widget)} widget widget ativa
     * entrando no mode view.
    */
    this.formatsResaleInscription = function(widget){
            
            var currentRow = widget.currentRow;
            var inscription = currentRow.NRINSCRIREVENDA;
            
            if(inscription){
            
                switch (inscription.length) {
                    case 11:
                        
                        inscription = inscription.replace(/(\d{3})(\d{3})(\d{3})(\d{2})/, "$1.$2.$3-$4");
                    break;
                    
                    case 14:
                        
                        inscription = inscription.replace(/^(\d{2})(\d{3})(\d{3})(\d{4})(\d{2})/, "$1.$2.$3/$4-$5");
                    break;
                }
        
                currentRow.NRINSCRIREVENDA = inscription;
            }
    };
    
    /**
     * Função para setar o operador logado na
     * field 'NMOPERADOR' da widget.
     * 
     * @param {object(widget)} widget widget 
     * 'REVENDA' no ambiente de cadastro.
    */
    
    this.setOperatorLogged = function(widget){
        
        var currentRow = widget.currentRow;
        
        currentRow.NMOPERADOR = widget.OPERATORLOGGED.NMOPERADOR;
        currentRow.CDOPERREVENDA = widget.OPERATORLOGGED.CDOPERADOR;
        currentRow.NRORG = widget.OPERATORLOGGED.NRORG;
        
    };
    
    /**
     * todo - função para criar a variável (escrita errada)
     * usada nos controllers da rotina de revenda, com as
     * informações do operador logado.
     * 
     * Trocar o nome das variáveis para o nome correto (LOGGEDOPERATOR)
     * 
     * @param {object} widget de revenda.
    */
    this.setLoggedOperatorInfosInResaleWidget = function(widget){
        
        widget.OPERATORLOGGED = templateManager.LOGGEDOPERATOR;
        
    };
    
    /**
     *  Funções para manipular is visible e readOnly
     *  no crud    
     **/
    this.setReadOnlyClient = function(widget, readOnly){
        var clientField = widget.getField('NMRAZSOCCLIE');
        clientField.readOnly = readOnly;
        clientField.reload();
        
        var inscriptionField = widget.getField('NRINSCRIREVENDA');
        inscriptionField.readOnly = readOnly;
        inscriptionField.reload();
        
        var razSocField = widget.getField('NMRAZSOCREVENDA');
        razSocField.readOnly = readOnly;
        razSocField.reload();
    };
    
    this.widgetEdit = function(widget){
        widget.fields.forEach(function (field){
           if(field.fieldGroup === 'INTERLOCUTOR'){
               field.isVisible = false;
           } 
        }); 
        this.setReadOnlyClient(widget, true);
        General.widgetEdit(widget);
    };
    
    this.ocultaInterlocutor = function(){
        var widget = templateManager.container.getWidget('WDGT_REVENDA');
            widget.fieldGroups.forEach(function (row){
            if(row.name == 'INTERLOCUTOR'){
              row.isVisible = false;  
                }
           });
      widget.reload();
        
    };
    
    this.widgetNewRow = function(widget){     
        var wid = templateManager.container.getWidget('WDGT_REVENDA');
        
        
        wid.fieldGroups.forEach(function (row){
            if(row.name == 'INTERLOCUTOR'){
              row.isVisible = true;  
            }
           });
      
        wid.reload();
        
        widget.fields.forEach(function (field){
           if(field.fieldGroup === 'INTERLOCUTOR'){
               field.isVisible = true;
           } 
        }); 
        this.setReadOnlyClient(widget, false);
        General.widgetNewRow(widget);    
    };
    /**
     * Fim funções de manipulação isVisible/Readonly 
     * no crud
     */
     
    this.setCurrentRowByClient = function(widget){
        var currentRow = widget.currentRow;
        currentRow.NMRAZSOCREVENDA = currentRow.NMRAZSOCCLIE;
    };
    
    /**
     * Converte o tipo de inscrição salvo na tabela ('CLIENTE')
     * para os tipos padrões, registrados na tabela ('TIPOINSCRICAO').
     * 
     * @param {string} inscCode código da inscrição do cliente.
     * 
     * @return {string} formato padrão de inscrição referente.
    */
    this.convertClientInscTypeToDefaultInscType = function(inscCode){
        
        switch(inscCode){
            
            case 'J':
                return "CNPJ";
            case 'F':
                return "CPF";
            case 'O':
                return "CODIGO";
            case 'I':
                return "LIVRE";
        }
        
        return inscCode;
        
    };
    
     /**
     * Executa as funções necessárias no evento
     * "WidgetOnEnterOnce" da widget de revenda.
     * 
     * @param {object} widget widget de revenda
     * ("WDGT_REVENDA").
    */
    this.widgetOnEnterOnce = function(widget, fieldsToApply){
        
        var filterRow = {};
        CRM_Utilities.openFilterOnEnter(widget, filterRow, fieldsToApply);
        
        
        ABAEnderecoParceiroController.setAddressWidgetOnActiveWidget(widget, 1);
        AbaInterlocutorController.setInterlocutorWidgetOnActiveWidget(widget, 3); 
        
        this.setLoggedOperatorInfosInResaleWidget(widget);
        
    };
    
}

Configuration(function (ContextRegister) {
    ContextRegister.register("crm00050000_Revenda_Controller", crm00050000_Revenda_Controller);
});


// FILE: ./assets/js/controllers/crm00050002_Reserva_de_Prospect_Controller.js
function crm00050002_Reserva_de_Prospect_Controller(crm00050002_Reserva_de_Prospect_Service, ScreenService, restEngine, CRM_Utilities) {
    
   /**
     * Função para formatar a inscrição e setar
     * o tipo de inscrição, quando o modo
     * view for chamado.
     * 
     * @param {object(widget)} widget widget ativa
     * entrando no mode view.
    */
    this.formatProspectInscriptionInView = function(widget){
            
            var currentRow = widget.currentRow;
            var inscription = this.removeInscriptionMask(currentRow.NRINSJURPROS);
            var inscriptionType;
            
            switch (inscription.length) {
                case 5:
                    
                    inscriptionType = "Código";
                break;
                
                case 11:
                    
                    inscription = inscription.replace(/(\d{3})(\d{3})(\d{3})(\d{2})/, "$1.$2.$3-$4");
                    inscriptionType = "CPF";
                break;
                
                case 14:
                    
                    inscription = inscription.replace(/^(\d{2})(\d{3})(\d{3})(\d{4})(\d{2})/, "$1.$2.$3/$4-$5");
                    inscriptionType = "CNPJ";
                break;
                
                default:
                
                    inscriptionType = "Livre";
                break;
            }
        
        currentRow.NRINSJURPROS = inscription;
        currentRow.CDTIPOINSC = inscriptionType;
        
    };
    
    /**
     * Função para remover a máscara de uma 
     * inscrição.
     * 
     * @param {string} inscription isncrição com máscara.
     * 
     * @return {string} inscriptionWithoutMask inscrição
     * sem máscara.
    */
    this.removeInscriptionMask = function(inscription){
        
        var inscriptionWithoutMask = inscription.replace(/[^0-9]/g, "");
        
        return inscriptionWithoutMask;
        
    };
    
    /**
     * Função para reservar um prospect a revenda
     * ligada ao operador em caso.
     * 
     * @param {object(widget)} widget widget ativa
     * no ambiente de reserva de prospect.
    */
    this.reserveProspectToOperator = function(widget){
        
        var currentRow = widget.currentRow;
            
        if(currentRow.ESTADORESERVA === "B"){
            ScreenService.showMessage('Prospect já vinculado a uma revenda.');
        }else{
            this.insertResaleProspect(widget);
        }
        
    };
    
    /**
     * Função para relacionar o prospect
     * selecionado a revenda do operador
     * logado.
     * 
     * @param {object(widget)} widget widget ativa
     * no ambiente de reserva de prospect.
    */
    this.insertResaleProspect = function(widget){
      
        var currentRow = widget.currentRow;
        
        this.setOperatorResaleNumberInCurrentRow(widget).then(function(){
                
            ScreenService.confirmMessage("Deseja vincular o prospect <br/>" + "'" + currentRow.NMRAZSOCPROS + "'" + "<br/> à Revenda <br/>" + "'" + currentRow.NMRAZSOCREVENDA + "'?", "question", function(){
             
                crm00050002_Reserva_de_Prospect_Service.callForInsertResaleProspect(currentRow).then(function(){
                    
                    currentRow.ESTADORESERVA = "B";
                    ScreenService.showMessage('Prospect vinculado com sucesso.');
                    
                }.bind(this));
                
            }.bind(this));    
          
        }.bind(this));
        
    };
    
    /**
     * Função para setar o número da revenda ligado
     * ao operador logado, na currentRow.
     * 
     * @param {object(widget)} widget widget ativa
     * no ambiente de reserva de prospect.
     * 
     * @return {object} promise promise retornado
     * pela requisição.
    */
    this.setOperatorResaleNumberInCurrentRow = function(widget){
        
        var currentRow = widget.currentRow;
        
        return this.getOperatorResaleNumber(widget).then(function(response){
            
            currentRow.NRREVENDA = response.dataset.DADOS[0].NRREVENDA;
            currentRow.NMRAZSOCREVENDA = response.dataset.DADOS[0].NMRAZSOCREVENDA;
            
        });
        
    };
    
    /**
     * Função para buscar o número da revenda
     * ligado ao operador logado.
     * 
     * @param {object(widget)} widget widget ativa
     * no ambiente de reserva de prospect.
     * 
     * @return {object} promise promise retornado
     * pela requisição.
    */
    this.getOperatorResaleNumber = function(widget){
        
        var currentRow = widget.currentRow;
        
        this.setOperatorLoggedCodeInCurrentRow(widget);
        
        return crm00050002_Reserva_de_Prospect_Service.callForSelectOperatorResaleNumber(currentRow);
        
    };
    
    /**
     * Função para setar o código do operadot logado
     * na currentRow do ambiente de reserva.
     * 
     * @param {object(widget)} widget widget ativa
     * no ambiente de reserva de prospect.
    */
    this.setOperatorLoggedCodeInCurrentRow = function(widget){
    
        var currentRow = widget.currentRow;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
        
    };
    
    /**
     * Função para enviar email.
     * 
     * @param {object(widget)} widget widget ativa onde
     * está localizado as informações do envio do E-Mail.
    */
    this.sendEmailToResaleResponsibleOperator = function(widget){
        
        var currentRow = widget.currentRow;
        
        crm00050002_Reserva_de_Prospect_Service.callForSendEmail(currentRow);
        
    };

}

Configuration(function (ContextRegister) {
    ContextRegister.register("crm00050002_Reserva_de_Prospect_Controller", crm00050002_Reserva_de_Prospect_Controller);
});


// FILE: ./assets/js/controllers/crm00060000_Campanhas_de_Maling.js
function crm00060000_Campanhas_de_Maling(CRM_Utilities, templateManager) {
    
    /**
     * Define o filtro da widget principal da tela de
     * campanha de mailing pelo operador logado.
     * 
     * @param {object} widget widget principal 'WDGT_CAMPANHA_MAILING'
    */
    this.setCampaignWidgetDefaultFilterByLoggedOperator = function(widget){
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        var cdoperadorFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(widget.dataSourceFilter, "CDOPERADOR");
        
        //widget.dataSourceFilter[cdoperadorFilterIndex].value = loggedOperatorInfos.CDOPERADOR;
        
        //this.setValueFilterInFilterPopUpCurrentDataSet('NMOPERADOR', loggedOperatorInfos.NMOPERADOR);
        //this.setValueFilterInFilterPopUpCurrentDataSet('CDOPERADOR', loggedOperatorInfos.CDOPERADOR);
        
    };
    
    /**
     * Seta valores no dataset do popup do filtro.
     * 
     * @param {string} fieldName nome do campo referência.
     * 
     * @param {string|Object} value valor a ser setado.
    */
    this.setValueFilterInFilterPopUpCurrentDataSet = function(fieldName, value){
        
        var campaignWidget = templateManager.container.getWidget('WDGT_CAMPANHA_MAILING');
        var filterPopup = campaignWidget.__filterPopup;
        
        filterPopup.currentRow[fieldName] = value;
        
    };
    
    /**
     * Define as regras da tela de campanhas de mailing
     * de acordo com a revenda do operador logado.
     * 
     * @param {object} widget widget principal da tela de
     * campanha de mailing ('WDGT_CAMPANHA_MAILING').
    */
    this.setResaleRules = function(widget) {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        if(loggedOperatorInfos.IDTPOPERADOR === 'R' && Boolean(loggedOperatorInfos.NRREVENDA)){
            
            var restrictObjects = [];
            
            restrictObjects.push(widget);
            restrictObjects.push(widget.getField("NMOPERADOR"));
            
            CRM_Utilities.setResaleRulesInRestrictObjectsByLoggedOperatorResale(restrictObjects);
            
        }
    };
    
}

Configuration(function (ContextRegister) {
    ContextRegister.register("crm00060000_Campanhas_de_Maling", crm00060000_Campanhas_de_Maling);
});


// FILE: ./assets/js/controllers/crm00070000_Hierarquia_Operador_Controller.js
function crm00070000_Hierarquia_Operador_Controller(CRM_Utilities, templateManager, ScreenService, General, ZHPromise) {
    
    /**
     * Defini o filtro do grid de operadores da hirarquia
     * selecionada.
     * 
     * @param {object} widget widget com a lista dos operadores
     * relacionado a hierarquia selecionada('WDGT_LISTA_OPERADORES_HIERARQUIA').
    */
    this.setHierarchyOperatorsWidgetFiler = function(widget){
        
        var treeGridWidget = widget.parent.parent;
        var treeGridWidgetCurrentRow = treeGridWidget.currentRow;
        
        var parentHierarchyNumberIndex = CRM_Utilities.getObjectPositionInArrayByName(widget.dataSourceFilter, "NRHIERARQUIAPAI");
        
        widget.dataSourceFilter[parentHierarchyNumberIndex].value = treeGridWidgetCurrentRow.NRHIERARQUIAOPER;
    };
    
    /**
     * Salva uma nova hierarquia.
     * 
     * @param {object} widget widget principal da tela
     * de hierarquia ("WDGT_ARVORE_HIERARQUIA").
    */
    this.saveHierarchy = function(widget){
        
        var currentRow = widget.currentRow;
        CRM_Utilities.setColumnToReturnInCurrentRow(currentRow, "NRHIERARQUIAOPER");
        
        if(widget.isValid()){
            
            if(!Boolean(currentRow.NRHIERARQUIAOPERRESP)) {
                
                General.widgetSave(widget).then(function(response){
                    
                    currentRow.NRHIERARQUIAOPERRESP = response.dataset.columnsToReturn[0].NRHIERARQUIAOPER;
                    this.saveHierarchyOperators(widget).then(function() {
                        widget.reload();
                    });
                    
                }.bind(this));
                    
            } else {
                
                this.saveHierarchyOperators(widget).then(function(){
                    ScreenService.closeSwipe().then(function() {
                        widget.reload();
                    });   
                });
                
            }
            
            if(Boolean(widget.ISTRANSFER)){
                
                this.returnOperRespFieldDefaultFilter(widget.getField('DSHIERARQUIAOPER'));
                this.deleteTransferParamOnWidget(widget);
                
            }
            
        }
        
    };
    
    /**
     * Salva os operadores de uma hierarquia.
     * 
     * @param {type} widget widget principal da tela
     * de hierarquia ("WDGT_ARVORE_HIERARQUIA").
    */
    this.saveHierarchyOperators = function(widget){
        
        var currentRow = widget.currentRow;
        
        if(Boolean(currentRow.CDOPERADORESHIERAR) && currentRow.CDOPERADORESHIERAR.length > 0){
            
            var hierarchyOperators = this.prepareHierarchyOperatorDatasToSave(currentRow);
            return General.callRestEngine("product#/crud/crm_hierarquiaoper/save", "DataSet", hierarchyOperators);
            
        } else {
            
            var zhPromise = ZHPromise.defer();
            zhPromise.resolve();
            
            return zhPromise.promise;
        }
        
    };
    
    /**
     * Prepara os registros dos operadores para serem
     * salvos na hierarquia em caso.
     * 
     * @param {object} currentRow currentRow da hierarquia
     * que está sendo criada;
    */
    this.prepareHierarchyOperatorDatasToSave = function(currentRow){
        
        var operators = [];
        var object;
        
        currentRow.CDOPERADORESHIERAR.forEach(function(operator,i){
            
            object = {};
            
            CRM_Utilities.setColumnToReturnParamsOnRow(object, "CRM_HIERARQUIAOPER", "NRHIERARQUIAOPER", "NRHIERARQUIAOPER");
            
            object.__is_new = "__is_new";
            object.CDOPERADOR = currentRow.CDOPERADORESHIERAR[i];
            object.DSHIERARQUIAOPER = currentRow.NMOPERADORHIERAR[i].toUpperCase();    
            object.NRHIERARQUIAPAI = currentRow.NRHIERARQUIAOPERRESP;
            object.IDOPERMASTER = 'N';
            
            operators.push(object);
            
        });
        
        return operators;
        
    };
    
    /**
     * Tira a possibilidade do operador selecionado como
     * responsável ser selecionado como operador relacionado.
     * 
     * @param {object} field field de operadores relacionados.
    */
    this.setRelatedOperatorsFilter = function(field){
        
        var widget = field.widget;
        var currentRow = widget.currentRow;
        
        var fieldFilter = field.dataSourceFilter;
        var cdoperadorFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(fieldFilter, "CDOPERADOR");
        
        fieldFilter[cdoperadorFilterIndex].value = currentRow.CDOPERADOR;
        
    };
    
    /**
     * Executa as funções da widget no evento
     * "WidgetAfterMoveRow".
     * 
     * @param {type} widget widget principal da tela
     * de hierarquia ("WDGT_ARVORE_HIERARQUIA").
    */
    this.widgetAfterMoveRow = function(widget){
        
        this.setActionToDeleteVisibilityBySelectedHierarchy(widget);
        this.setSuperiorHierarchyFilter(widget);
        
    };
    
    /**
     * Define a visibilidade da ação de excluir hierarquias.
     * 
     * @param {type} widget widget principal da tela
     * de hierarquia ("WDGT_ARVORE_HIERARQUIA").
    */
    this.setActionToDeleteVisibilityBySelectedHierarchy = function(widget){
        
        var currentRow = widget.currentRow;
        
        var actionToDeleteIndex = CRM_Utilities.getObjectPositionInArrayByName(widget.actions, "DELETAR_HIERARQUIA");
        
        if(currentRow._childCount !== 0) {
            widget.actions[actionToDeleteIndex].isVisible = false;
        } else {
            widget.actions[actionToDeleteIndex].isVisible = true;
        }
        
    };
    
    /**
     * Habilita a edição de uma hierarquia.
     * 
     * @param {type} widget widget principal da tela
     * de hierarquia ("WDGT_ARVORE_HIERARQUIA").
    */
    this.editHierarchy = function(widget){
        
        var currentRow = widget.currentRow;
        
        if(currentRow._childCount !== 0){
            this.transferHierarchy(widget);
        } else {
            General.widgetEdit(widget);
            this.returnOperRespFieldDefaultFilter(widget.getField('DSHIERARQUIAOPER'));
            this.deleteTransferParamOnWidget(widget);
        }
        
    };
    
    /**
     * Habilita a transferência de uma hierarquia.
     * 
     * @param {type} widget widget principal da tela
     * de hierarquia ("WDGT_ARVORE_HIERARQUIA").
    */
    this.transferHierarchy = function(widget){
        
        General.widgetEdit(widget);
        
        this.setTransferParamsOnWidget(widget);
        this.setFilterRespOperByOperWithoutHierarchy(widget.getField('DSHIERARQUIAOPER'));
        
    };
    
    /**
     * Seta o filtro do campo de operador responsável
     * para buscar apenas operadores sem hierarquia.
     * 
     * @param {object} field campo de operador responsável.
    */
    this.setFilterRespOperByOperWithoutHierarchy = function(field){
        
        var fieldFilter = field.dataSourceFilter;
        
        var filter = {
            name: "NRHIERARQUIAOPER",
            operator: "IS_NULL"
        };
        
        var nrhierarquiaoperFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(fieldFilter, "NRHIERARQUIAOPER");
        
        if(!Boolean(nrhierarquiaoperFilterIndex)){
            
            fieldFilter.push(filter);
            field.reload();    
            
        }
        
    };
    
    /**
     * Retorna o filtro do campo "Operador responsável"
     * para o padrão.
     * 
     * @param {object} field campo de operador responsável.
    */
    this.returnOperRespFieldDefaultFilter = function(field) {
        
        var fieldFilter = field.dataSourceFilter;
        var nrhierarquiaoperFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(fieldFilter, "NRHIERARQUIAOPER");
        
        if(nrhierarquiaoperFilterIndex === 0 || nrhierarquiaoperFilterIndex){
            
            field.dataSourceFilter = CRM_Utilities.deleteFilterObject(fieldFilter, nrhierarquiaoperFilterIndex);
            field.reload();
            
        }
        
    };
    
    /**
     * Define um parâmetro na widget indicando uma
     * trânferencia de hierarquia.
     * 
      * @param {type} widget widget principal da tela
     * de hierarquia ("WDGT_ARVORE_HIERARQUIA").
    */
    this.setTransferParamsOnWidget = function(widget){
        
        widget.ISTRANSFER = true;    
        
    };
    
    /**
     * Exclui o parâmetro na widget indicando uma
     * trânferencia de hierarquia.
     * 
     * @param {type} widget widget principal da tela
     * de hierarquia ("WDGT_ARVORE_HIERARQUIA").
    */
    this.deleteTransferParamOnWidget = function(widget){
        
        if(Boolean(widget.ISTRANSFER)){
            delete widget.ISTRANSFER;    
        }
        
    };
    
    /**
     * Deleta uma hierarquia e atualiza a widget
     * em seguida.
     * 
     * @param {type} widget widget principal da tela
     * de hierarquia ("WDGT_ARVORE_HIERARQUIA").
    */
    this.deleteHierarchy = function(widget){
        
        General.deleteCrud(widget).then(function(){
           widget.reload(); 
        });
        
    };
    
    /**
     * Define o filtro do campo "Hierarquia Superior" para
     * retornar apenas hierarquias superiores ou no mesmo nível
     * da hierarquia selecionada.
     * 
     * @param {type} widget widget principal da tela
     * de hierarquia ("WDGT_ARVORE_HIERARQUIA").
    */
    this.setSuperiorHierarchyFilter = function(widget){
        
        var currentRow = widget.currentRow;
        
        var SuperiorHierarchyField = widget.getField('DSHIERARQUIAOPERPAI');
        var fieldFilter = SuperiorHierarchyField.dataSourceFilter;
        
        var nrhierarquiaoperFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(fieldFilter, "P_HIERARQUIATUAL");
        
        fieldFilter[nrhierarquiaoperFilterIndex].value = currentRow.NRHIERARQUIAOPER;
        
        SuperiorHierarchyField.reload();
        
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm00070000_Hierarquia_Operador_Controller', crm00070000_Hierarquia_Operador_Controller);
});

// FILE: ./assets/js/controllers/crm20000_Caso_Controller.js
function crm20000_Caso_Controller(ScreenService, templateManager, Utilities, restEngine, fileRepository, localStorageEngine, Operador_Repository, General, CRM_Utilities, ZHPromise, Messages, ZhFilterPreferences) {
	var self = this;
    
    this.widgetOnEnterOnce = function(widget) {
            
            var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
            
            var field = widget.getField('CDOPERCONT');
            Utilities.insertFilterWithoutReload(field, "NRORG", "=", loggedOperatorInfos.NRORG, 0);
            field.reload();
            
            field.filterProperties.defaultValue = [loggedOperatorInfos.CDOPERADOR];
            field.defaultValue = loggedOperatorInfos.CDOPERADOR;
            
            Utilities.insertFilterWithoutReload(widget, "P_NRORG", "=", loggedOperatorInfos.NRORG, 0);
            Utilities.insertFilterWithoutReload(widget, "CDOPERCONT", "=", loggedOperatorInfos.CDOPERADOR, 1);
            
            Utilities.insertFilter(widget.getField('NMSISTEMA'), "CDOPERADOR", "=", loggedOperatorInfos.CDOPERADOR, 0);
            Utilities.insertFilter(widget.getField('NMSISTEMA'), "NRORG", "=", loggedOperatorInfos.NRORG, 1);
            Utilities.insertFilter(widget.getField('CDSISTEMA'), "CDOPERADOR", "=", loggedOperatorInfos.CDOPERADOR, 0);
            Utilities.insertFilter(widget.getField('CDMOTICONT'), "CDOPERADOR", "=", loggedOperatorInfos.CDOPERADOR, 1);
            //widget.reload();
            ZhFilterPreferences.openFilterWidget(widget);
    };
    
    self.iniciaFiltrosWidevolucao = function(widget)
    {
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }

            var field = widget.getField('NMMOTIEVOCON');
            Utilities.insertFilterWithoutReload(field, "P_NRORG", "=", operator[0].NRORG, 0);
            Utilities.insertFilter(field, "P_CDOPERADOR", "=", operator[0].CDOPERADOR, 1);
            
            field = widget.getField('NMSEQRESULEVOL');
            Utilities.insertFilterWithoutReload(field, "P_NRORG", "=", operator[0].NRORG, 0);
            Utilities.insertFilter(field, "P_CDOPERADOR", "=", operator[0].CDOPERADOR, 1);
        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
    };

    self.iniciaFiltrosWidCONCLUSAO = function(widget)
    {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        Utilities.insertFilterWithoutReload(widget, "NRORG", "=", 1, 0);
        Utilities.insertFilterWithoutReload(widget, "NRSEQCONTATO", "=", widget.parent.parent.currentRow.NRSEQCONTATO, 1);
        
        var field = widget.getField('NMSEQRESULEVOL');
        Utilities.insertFilterWithoutReload(field, "P_NRORG", "=", loggedOperatorInfos.NRORG, 0);
        Utilities.insertFilter(field, "P_CDOPERADOR", "=", loggedOperatorInfos.CDOPERADOR, 1);
    };

    self.iniciaFiltrosWidposvenda = function(widget)
    {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        var field = widget.getField('NMOPERADOR');
        Utilities.insertFilterWithoutReload(field, "P_NRORG", "=", loggedOperatorInfos.NRORG, 0);
        Utilities.insertFilter(field, "P_NRPARCNEGOCIO", "=", loggedOperatorInfos.NRPARCNEGOCIO, 1);
        
        field = widget.getField('NMPRINCIPALPARC');
        Utilities.insertFilter(field, "NRPARCNEGOCIO", "=", loggedOperatorInfos.NRPARCNEGOCIO, 0);
    };
    
    self.initFilterMotivo = function(fieldNMMOTIVO)
	{
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
    		if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }

            var objectFilter = 
                {
                    "name": "CDOPERADOR",
                    "operator": "=",
                    "value": operator[0].CDOPERADOR
                };
                
            fieldNMMOTIVO.dataSourceFilter.push(objectFilter);
            fieldNMMOTIVO.reload();

        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
	};
    
	self.casoNewRow = function(widget)
	{
        
        General.widgetNewRow(widget);
        
        var currentRow = widget.currentRow;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        widget.getField('EMAIL').readOnly = true;
        widget.getField('TELEFONE').readOnly = true;
        widget.getField('NMCLASSIFICACAOCASO').readOnly = true;
        widget.getField('NMOPERCONT').readOnly = true;
        
        currentRow.CDFILIAL = "";
        currentRow.NMOPERCONT = loggedOperatorInfos.NMOPERADOR;
        currentRow.CDOPERCONT = loggedOperatorInfos.CDOPERADOR;
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        currentRow.NRSEQSITUACAO = 1;
        currentRow.NRPARCINTERLOCUTOR = null;
        currentRow.NRCLASSIFICACAOCASO = null;
        currentRow.IDGERAFATURA = 'NAO';
        currentRow.IDTPCONTATO = 'C';
        currentRow.IDSTATUSCONT = 'A';
        currentRow.NMGERAFATURA = 'Considera';
        currentRow.DTHRCONTATO = moment(new Date()).format('DD/MM/YYYY HH:mm');
        
        restEngine.post('crm#/getSituacao', {'requestType':'Row', 'row': widget.currentRow},
        undefined, undefined, undefined).then(function(response)
        {
            currentRow.NMSEQSITUACAO = response.dataset.DADOS.NMSITUACAO;
        });
	};

    self.casoEdit = function(widget)
    {
        widget.getField('NMCLASSIFICACAOCASO').readOnly = false;
        widget.getField('NMOPERCONT').readOnly = false;

        General.widgetEdit(widget);
    };


    self.casoCancel = function(widget)
    {
        widget.getField('NMCLASSIFICACAOCASO').readOnly = true;
        widget.getField('NMOPERCONT').readOnly = true;

        General.widgetCancelForm(widget);
    };
    
	self.conclusaoNewRow = function(widget)
	{

		General.widgetNewRow(widget);
		self.defaultEditAuditRow(widget);
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        widget.currentRow.NMOPERCONCLUSAO = loggedOperatorInfos.NMOPERADOR;
        widget.currentRow.CDOPERCONCLUSAO = loggedOperatorInfos.CDOPERADOR;
        widget.currentRow.NRSEQCONTATO    = widget.parent.parent.currentRow.NRSEQCONTATO;
	};

    self.evolucaoNewRow = function(widget)
    {
        
        General.widgetNewRow(widget);
        
        var currentRow = widget.currentRow;
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        currentRow.DTHREVOLCONT = (currentRow.DTHREVOLCONT)? widget.currentRow.DTHREVOLCONT : moment(new Date()).format('DD/MM/YYYY HH:mm');
        currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
        currentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        currentRow.NRCONTATO = widget.parent.parent.currentRow.NRSEQCONTATO;
        currentRow.NRSEQCONTATO = widget.parent.parent.currentRow.NRSEQCONTATO;
        currentRow.NRRELACIONAPARC = "";
        currentRow.IDSENEVOCONT = 'S';
        currentRow.IDTPEVOLCONT = 'P';
        currentRow.IDANEXOEVOLCONT = 'N';
        currentRow.CDFILIAL = "";
        currentRow.IDGERAFATURA = 'NAO';

        
        this.unlockNextTask(widget);
        this.setNewTaskPermission(widget, false);
        this.setOperatorNextTask(currentRow, loggedOperatorInfos);
        
        setLocalVar('PARCEIRO', widget.parent.parent.currentRow.NRPARCNEGOCIO);
        widget.getField('NMPARCINTERLOCUTOR').reload();
    };
    
     this.setOperatorNextTask = function(currentRow, loggedOperatorInfos){
        currentRow.NMOPERADORREAL = loggedOperatorInfos.NMOPERADOR;
        currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
    };
    
    self.taskScheduleNewRow = function(widget)
    {

        General.widgetNewRow(widget);
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        widget.currentRow.DTPLANFILACONTA = (widget.currentRow.DTPLANFILACONTA) ? widget.currentRow.DTPLANFILACONTA : moment(new Date()).format('DD/MM/YYYY HH:mm');
        widget.currentRow.IDATIVO = 'S';
        widget.currentRow.NRCONTATO = widget.parent.parent.currentRow.NRCONTATO;

        widget.currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
        widget.currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
        widget.currentRow.NRSEQCONTATO = widget.parent.parent.currentRow.NRSEQCONTATO;
        widget.currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        // widget.currentRow.NRPRIORFILACONT = 2;

        widget.currentRow.NRSEQCLASSIFICATAREFA = "";
        widget.currentRow.DTREALFILACONTA = "";
        widget.currentRow.NMPRINCIPALPARC = '';
        widget.currentRow.DSEMAILTAREFA = '';
        widget.currentRow.DSTELEFONETAREFA = '';

        if(widget.parent.parent.currentRow.NRPARCNEGOCIO)
        {
            widget.getField('NMPRINCIPALPARC').dataSourceFilter[0].value = widget.parent.parent.currentRow.NRPARCNEGOCIO;
            widget.getField('NMPRINCIPALPARC').reload();
        }
    };

	self.defaultEditAuditRow = function(widget)
	{
		Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }

            if(widget.currentRow.__is_new)
    		{
    			widget.currentRow.NRORG = operator[0].NRORG;
    	        widget.currentRow.NRORGINCLUSAO = operator[0].NRORG;
                widget.currentRow.CDOPERINCLUSAO = operator[0].CDOPERADOR;
                widget.currentRow.DTINCLUSAO = moment(new Date()).format('DD/MM/YYYY HH:mm');
    		}
    		else
    		{
    			widget.currentRow.NRORGULTATU = operator[0].NRORG;
    			widget.currentRow.CDOPERULTATU = operator[0].CDOPERADOR;
                widget.currentRow.DTULTATU = moment(new Date()).format('DD/MM/YYYY HH:mm');
    		}
        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
	};

	self.checkRequirements = function(widget)
	{
		if(!widget.isValid())
		{
			ScreenService.showMessage('Preencha todos os campos marcados com asterisco!');
			return false;
		}

		return true;
	};

	self.podeEditarRowdoCaso = function(row, widget)
	{
		if(row.NRSEQSITUACAO == 3)
		{
			widget.getAction('EDIT').isVisible = false;
		}
		else
		{
			widget.getAction('EDIT').isVisible = true;
		}
	};

    self.saveConclusaoAndAtuMotivo = function(widget)
    {
        if(self.checkRequirements(widget))
        {   
            var parametroRestEngine = {
                "requestType": "Row",
                "row": widget.currentRow
            };
            
            restEngine.post('/updateMotivo', parametroRestEngine,
                function(success) {
                    
                    self.defaultEditAuditRow(widget);
            
                    return General.widgetSave(widget).then(function(response)
                    {
        
                        if(response.dataset.DADOS && response.dataset.DADOS.NRSEQCONCLUSAO)
                        {
                            widget.currentRow.NRSEQCONCLUSAO = response.dataset.DADOS.NRSEQCONCLUSAO;
                            widget.currentRow.DTINCLUSAO = response.dataset.DADOS.DTINCLUSAO;
                        }
                        else if(response.dataset.DADOS && response.dataset.DADOS.DTULTATU)
                        {
                            widget.currentRow.DTULTATU = response.dataset.DADOS.DTULTATU;
                        }
                    });
                    
                }, undefined, 
                function(error) {
                    ScreenService.showMessage("Operação não concluida, Tente Novamente");
                    return;
                }
            ); 
        }
    };

    self.saveEvolucao = function(widget){
        
        var currentRow = widget.currentRow;
        
        if(widget.isValid()){
        
            this.setValuesToInsertNextTask(widget);
            
            this.insertEvolutionNextTask(widget).then(function(responseInsertNextTask){
                
                this.cleanNextTaskFieldValues(widget);
                
                currentRow.NRSEQFILACONTA = (responseInsertNextTask) ? responseInsertNextTask.dataset.DADOS.NRSEQFILACONTA : "";
                
                return widget.saveRow().then(function(response)
                {
                    widget.currentRow.changed = false;
                    widget.currentRow.__is_new = false;
    
                    if(response.dataset.DADOS && response.dataset.DADOS.NRSEQEVOLCONT)
                    {
                        widget.currentRow.NRSEQEVOLCONT = response.dataset.DADOS.NRSEQEVOLCONT;
                        widget.currentRow.DTINCLUSAO = response.dataset.DADOS.DTINCLUSAO;
                    }
                    else if(response.dataset.DADOS && response.dataset.DADOS.DTULTATU)
                    {
                        widget.currentRow.DTULTATU = response.dataset.DADOS.DTULTATU;
                    }
    
                    General.changeWidgetAcessibility(widget.widgets, true);
                    widget.view();
                    
                    if(widget.COMPLETETASK){
                        
                        this.setTaskEndDate(widget);
                            
                    }else{
                        
                        ScreenService.confirmMessage
                        ("Deseja realizar a apropriação da evolução?","question",
                            function()
                            {
                                
                                var childWidget = widget.widgets[0];
                                
                                childWidget.activate();
                                setTimeout(function () {
                                    self.apropriaNewRow(childWidget);
                                }, 300);
                            
                            },
                            function()
                            {
                        });
                        
                    }
                    
                }.bind(this)).catch(function(err) {
                    ScreenService.showMessage(err.data.error);
                });
                 
            }.bind(this)).catch(function(error){
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
                
            });
        
        }
    };
    
    this.setValuesToInsertNextTask = function(widget){
        
        var currentRow = widget.currentRow;
        
        currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        currentRow.NRSEQCONTATO = widget.parent.parent.currentRow.NRSEQCONTATO;
        currentRow.NRCONTATO = widget.parent.parent.currentRow.NRCONTATO;
        
    };
    
	self.saveCaso = function(widget)
	{
        widget.getField('NMOPERCONT').readOnly = true;

        if(widget.currentRow.__is_new){
            delete widget.currentRow.NRSEQCONTATO;
        }
        
		return General.widgetSave(widget).then(function(response)
		{

            if(response.dataset.DADOS && response.dataset.DADOS.NRSEQCONTATO)
            {
                widget.currentRow.NRSEQCONTATO = response.dataset.DADOS.NRSEQCONTATO;
                widget.currentRow.NRCONTATO = response.dataset.DADOS.NRCONTATO;
                widget.currentRow.DTINCLUSAO = response.dataset.DADOS.DTINCLUSAO;
            }
            else if(response.dataset.DADOS && response.dataset.DADOS.DTULTATU)
            {
            	widget.currentRow.DTULTATU = response.dataset.DADOS.DTULTATU;
            }
            
		});
	};

    self.saveTask = function(widget)
    {

        self.defaultEditAuditRow(widget);

        widget.currentRow.CDFILIAL = "";
        widget.currentRow.NRSEQCLASSIFICATAREFA = (widget.currentRow.NRSEQCLASSIFICATAREFA)? widget.currentRow.NRSEQCLASSIFICATAREFA : null;

        return General.widgetSave(widget).then(function(response)
        {

            if(response.dataset && response.dataset.DADOS[0].NRSEQFILACONTA)
            {
                widget.currentRow.NRSEQFILACONTA = response.dataset.DADOS[0].NRSEQFILACONTA;
            }
        });
        
    };

	self.initTabGeneric = function(widget, field)
    {
        if(widget.parent.parent.currentRow[field])
        {
            widget.dataSourceFilter[0].value = widget.parent.parent.currentRow.NRORG;
            widget.dataSourceFilter[1].value = widget.parent.parent.currentRow[field];
        }

        widget.reload();
    };

	self.ActivateField = function (widget, field, decisiveField)
    {
        field = widget.getField(field);
        decisiveField = widget.currentRow[decisiveField];
        if((decisiveField !== null) && (decisiveField !== '') && (decisiveField !== undefined))
        {
            field.clearValue();
            field.readOnly = false;
            field.reload();
        }
    };
    
    self.initFilterNMoticont = function(widget){
        var currentRow = widget.currentRow;
        
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }
            
            if(!currentRow.NMSISTEMA){
                Utilities.insertFilter(widget.getField('NMMOTICONT'), "CDOPERADOR", "=", "", 1);  
            }else{
                Utilities.insertFilter(widget.getField('NMMOTICONT'), "CDOPERADOR", "=", operator[0].CDOPERADOR, 1); 
            } 
            widget.getField('NMMOTICONT').reload();
            
            }, function(error)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
            });
    };
    
    self.ActivateFieldMotivo = function (widget, field, decisiveField)
    {   
        
        var currentRow = widget.currentRow;
        
        self.initFilterNMoticont(widget);
        setLocalVar('CDSISTEMA',currentRow.CDSISTEMA);
        self.ActivateField(widget, field, decisiveField); 
                
    };
    
    self.uploadFile = function (widget)
    {
        
        var currentRow = widget.currentRow;
        
        var files = currentRow.DSCAMINHO;
        
        
        if(files && files.length !== 0){
            var rows = [];
            
            files.forEach((function(file, index) {
                rows.push(this.setValuesForCaseFileUpload(widget, index)); 
            }).bind(this));
            
            General.callRestEngine("product#/crm_anexocontato/save", "DataSet", rows).then(function() {
                this.closeAnexoSwipe(widget);
                widget.parent.parent.reload();
            }.bind(this));
            
        }else{
            
            ScreenService.showMessage("Selecione um arquivo para anexar ao caso.");
            
        }
            
    };
    
    this.setValuesForCaseFileUpload = function(widget, index){
        
        var currentRow = angular.copy(widget.currentRow);
        var caseWidget = widget.parent.parent;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.__is_new = true;
        currentRow.NRSEQCONTATO = caseWidget.currentRow.NRSEQCONTATO;
        currentRow.NMARQUIVO = this.getFileNameWhithoutExtension(currentRow.DSCAMINHO[index].name);
        currentRow.DSTIPO = this.getFileExtension(currentRow.DSCAMINHO[index].name);
        currentRow.VRTAMANHO = currentRow.DSCAMINHO[index].size;
        currentRow.IDATIVO = "S";
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
        currentRow.IDORIGEM = "CONTATO";
        currentRow.NRORIGEM = caseWidget.currentRow.NRSEQCONTATO;
        
        return currentRow;        
    };
    
    this.getFileExtension = function(fileName){
        
        return fileName.replace(/^(.*)\.(.*)$/, "$2");
        
            
    };
    
    this.getFileNameWhithoutExtension = function(fileName){
        
        return fileName.replace(/^(.*)\.(.*)$/, "$1");
            
    };
    
    self.createWidgetDataSource = function(widget)
    {
        var pathDir = getLocalVar('PATHDIR');
        if(pathDir === null || pathDir === undefined)
        {
            restEngine.post('crm#/crm_anexos/returnPathDir',
            {
                "requestType": "Row",
                "row": {}
            }, function(data)
            {
                setLocalVar('PATHDIR', data.dataset.pathDir[0]);
            }, undefined, function(error)
            {
                console.log(error);
            });
        }

        widget.currentRow.NRSEQCONTATO = widget.parent.parent.currentRow.NRSEQCONTATO;
        widget.currentRow.NRORG = widget.parent.parent.currentRow.NRORG;

        restEngine.post('crm#/crm_anexos/createFileDataSet',
        {
            "requestType": "Row",
            "row": widget.currentRow
        }, function(success)
        {
            localStorageEngine.remove('/crm_anexos', '').then(function()
            {
                localStorageEngine.save('/crm_anexos', success.dataset.crm_anexos).then(function()
                {
                    var widget = templateManager.container.getWidget('listAnexos');
                    widget.reload();
                });
            });
        },undefined, function(error)
        {
            console.log(error);
        });
    };

    self.downloadFile = function(widget)
    {
        window.open(window.fileServerBaseUrl + widget.currentRow.DSCAMINHO);
    };

    self.closeAnexoSwipe = function(widget)
    {
        ScreenService.closeSwipe().then(function(){
            
            widget.isVisible = false;
            widget.parent.parent.list();
            widget.parent.parent.activate();
           
        });
    };

    self.openAnexoSwipe = function(widget)
    {
        widget.isVisible = true;
        ScreenService.openSwipe(widget);
    };

    self.apropriaNewRow = function(widget)
    {
        General.widgetNewRow(widget);
        self.defaultEditAuditRow(widget);
        self.controlarCampos(widget);

        widget.currentRow.IDTIPOAPONTAMENTO = "H";
        widget.currentRow.NRSEQEVOLCONT = widget.parent.parent.currentRow.NRSEQEVOLCONT;
    };

    self.controlarCampos = function(widget)
    {
        widget.getField('NRHORASAPONTAMENTO').readOnly = widget.currentRow.IDTIPOAPONTAMENTO === "D";
        widget.getField('DTINIAPONTAMENTO').readOnly = (widget.currentRow.IDTIPOAPONTAMENTO !== "D");
        widget.getField('DTFINAPONTAMENTO').readOnly = (widget.currentRow.IDTIPOAPONTAMENTO !== "D");

        if(widget.currentRow.__is_new)
        {
            widget.currentRow.NRHORASAPONTAMENTO = "000:00";
            widget.currentRow.DTINIAPONTAMENTO = null;
            widget.currentRow.DTFINAPONTAMENTO = null;
        }
    };

    self.saveApropriacao = function(widget)
    {
        if(self.validarApropriacao(widget))
        {
            self.defaultEditAuditRow(widget);

            if(widget.currentRow.IDTIPOAPONTAMENTO == "D")
            {
                var dataini = moment(widget.currentRow.DTINIAPONTAMENTO, "DD/MM/YYYY HH:mm");
                var datafin = moment(widget.currentRow.DTFINAPONTAMENTO, "DD/MM/YYYY HH:mm");
                var minutes = datafin.diff(dataini)/60000;
                var hours = minutes/60;
                minutes = minutes%60;
                widget.currentRow.NRHORASAPONTAMENTO = self.pad(parseInt(hours), 3) + ":" + self.pad(parseInt(minutes), 2);
            }

            widget.currentRow.NRHORASAPONTAMENTO = widget.currentRow.NRHORASAPONTAMENTO.replace(":", "");

            return widget.saveRow().then(function(response)
            {
                widget.currentRow.changed = false;
                widget.currentRow.__is_new = false;

                if(response.dataset.DADOS && response.dataset.DADOS.NRSEQAPONTAMENTO)
                {
                    widget.currentRow.NRSEQAPONTAMENTO = response.dataset.DADOS.NRSEQAPONTAMENTO;
                    widget.currentRow.NRSEQRELACAPONT = response.dataset.DADOS.NRSEQRELACAPONT;
                    widget.currentRow.DTINCLUSAO = response.dataset.DADOS.DTINCLUSAO;
                }
                else if(response.dataset.DADOS && response.dataset.DADOS.DTULTATU)
                {
                    widget.currentRow.DTULTATU = response.dataset.DADOS.DTULTATU;
                }

                Utilities.changeWidgetVisibility(widget.widgets, true);
                widget.view();
                widget.reload();
            }).catch(function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };

    self.validarApropriacao = function(widget)
    {
        if(self.checkRequirements(widget))
        {
            if(widget.currentRow.IDTIPOAPONTAMENTO === "D")
            {
                var dataini = moment(widget.currentRow.DTINIAPONTAMENTO, "DD/MM/YYYY HH:mm");
                var datafin = moment(widget.currentRow.DTFINAPONTAMENTO, "DD/MM/YYYY HH:mm");
                var diffMinutos = datafin.diff(dataini);

                if(diffMinutos <= 0)
                {
                    ScreenService.showMessage('Data inicial deve ser menor/igual à data final.');
                    return false;
                }
                else if((widget.currentRow.DTINIAPONTAMENTO === null || widget.currentRow.DTFINAPONTAMENTO === null))
                {
                    ScreenService.showMessage('Ambas as datas devem ser informadas.');
                    return false;
                }
            }

            return true;
        }

        return false;
    };

    self.pad = function (n, width, z)
    {
        z = z || '0';
        n = n + '';
        return n.length >= width ? n : new Array(width - n.length + 1).join(z) + n;
    };

    self.controlHorasApont = function(widget)
    {
        var tempo = widget.currentRow.NRHORASAPONTAMENTO.split(":");
        var hora = parseInt(tempo[0]);
        var minutes = parseInt(tempo[1]);

        if(minutes >= 60)
        {
            minutes -= 60;
            hora ++;
            widget.currentRow.NRHORASAPONTAMENTO = self.pad(hora, 3)+":"+self.pad(minutes, 2);
        }
    };
    
    this.setSituationFieldFilter = function(field){
        
        var fieldFilter = field.dataSourceFilter;
        var nrorgFilterIndex = CRM_Utilities.getFilterPosition(fieldFilter, "P_NRORG");
        var nrorgPadraoFilterIndex = CRM_Utilities.getFilterPosition(fieldFilter, "P_NRORGPADRAO");
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        fieldFilter[nrorgFilterIndex].value = loggedOperatorInfos.NRORG;
        fieldFilter[nrorgPadraoFilterIndex].value = getLocalVar("CRM_NRORGPADRAO");
        
        CRM_Utilities.setDefaultOrgFilterAndOperatorOrgFilter(field);
        
        field.reload();
            
    };
    
    /**
     * Função para checar a permissão para gerar
     * uma nova tarefa a partir de uma nova evolução.
     * 
     * @param {object} widget widget ativa, no modo
     * edit, onde está sendo cadastrado a evolução.
    */
    this.checkNewTaskPermissionByEvolutionResult = function(widget){
        
        var currentRow = widget.currentRow;
        
        
        if(currentRow.IDGERPROXATIV && currentRow.IDGERPROXATIV === "S" && !currentRow.NEXTTASKBLOCKED){
            
            this.setNewTaskPermission(widget, true);
            
        }else{
            
            this.setNewTaskPermission(widget, false);
            
        }
            
    };
        
    /**
     * Função para resetar as informações
     * de criação de uma nova tarefa(a partir de uma
     * evolução).
     * 
     * @param {object} widget widget de evolução, que terá
     * as informações resetadas.
    */
    this.resetNewTaskInfos = function(widget){
        
        var currentRow = widget.currentRow;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.DTPLANFILACONTA = "";
        currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
        currentRow.NMOPERADORREAL = loggedOperatorInfos.NMOPERADOR;
        currentRow.DSFILACONTATO = "Retornar contato";
            
    };
    
    /**
     * Função para inserir um tarefa vinculada
     * a uma evolução.
     * 
     * @param {object} widget widget de evolução
     * com as informações da tarefa a ser inserida
     * em sua currentRow.
    */
    this.insertEvolutionNextTask = function(widget){
        
        var currentRow = widget.currentRow;
        var deferred = ZHPromise.defer();
        
        if(currentRow.DTPLANFILACONTA && !currentRow.NEXTTASKBLOCKED){
            
            var paramsRestEngine = {
                "requestType": "Row",
                "row": currentRow
            };
            
            return restEngine.post('/insertEvolutionNextTask/caso', paramsRestEngine,
                function(success){
                    
                },undefined,
                function(error){
                    
                },undefined,undefined
            );
            
        }else{
            
            deferred.resolve();
            
        }
        
        return deferred;
        
    };
    
    /**
     * Função para limpar os valores dos campos
     * para gerar uma nova tarefa através de uma
     * evolução.
     * 
     * @param {object} widget widget de evolução.
    */
    this.cleanNextTaskFieldValues = function(widget){
        
        var currentRow = widget.currentRow;
        
        if(!currentRow.DTPLANFILACONTA){
            
            currentRow.DTPLANFILACONTA = "";
            currentRow.DSFILACONTATO = "";
            currentRow.NMOPERADORREAL = "";
            
        }
        
    };
    
    /**
     * Função para editar uma evolução.
     * 
     * @param {object} widget widget ativa, no
     * modo de visualização, com as informações
     * da evolução a ser editada.
    */
    this.editEvolution = function(widget){
        
        General.widgetEdit(widget);
        
        this.checkPermissionToCreateNewTaskInEvolutionEdition(widget);
            
    };
    
    /**
     * Função para verificar a permissão para inserir
     * uma nova tarefa na edição da evolução em caso.
     * 
     * @param {object} widget widget ativa, no modo de
     * edição, com as informações da evolução em edição.
    */
    this.checkPermissionToCreateNewTaskInEvolutionEdition = function(widget){
        
        var currentRow = widget.currentRow;
        
        
        if(currentRow.DTPLANFILACONTA){
            
            this.setTaskFieldLock(widget, true);
            
            currentRow.NEXTTASKBLOCKED = true;
            
        }else{
            
            this.unlockNextTask(widget);
            this.checkNewTaskPermissionByEvolutionResult(widget);
            this.resetNewTaskInfos(widget);
        }
        
    };
    
    /**
     * Função para setar a permissão de criar uma nova
     * tarefa a partir do resultado da evolução.
     * 
     * @param {object} widget widget ativa, no modo edit,
     * onde está sendo cadastrado a evolução.
     * 
     * @param {boolean} isAllowed permissão booleana do
     * cadastro da tarefa.
    */
    this.setNewTaskPermission = function(widget, isAllowed){
        
        if(isAllowed){
            
            this.setTaskFieldLock(widget, false);
            
            widget.currentRow.DTPLANFILACONTA = "";
            
        }else{
            
            this.setTaskFieldLock(widget, true);
            
        }
            
    };
    
    /**
     * Função para definir o bloqueio dos campos
     * de agenda de tarefa na widget de evolução.
     * 
     * @param {object} widget widget de evolução,
     * onde estão os campos para criar um nova
     * tarefa.
     * 
     * @param {boolean} isLocked estado dos campos.
    */
    this.setTaskFieldLock = function(widget, isLocked){
        
        var nextTaskDate = widget.getField("DTPLANFILACONTA");
        var taskOperator = widget.getField("NMOPERADORREAL");
        var taskDescription = widget.getField("DSFILACONTATO");
        
        nextTaskDate.readOnly = isLocked;
        taskOperator.readOnly = isLocked;
        taskDescription.readOnly = isLocked;
            
    };
    
    /**
     * Função para liberar o cadastro de uma
     * nova tarefa a partir de um evolução,
     * excluindo o parâmetro de bloqueio.
     * 
     * @param {object} widget widget de evolução.
    */
    this.unlockNextTask = function(widget){
        
        if(widget.currentRow.NEXTTASKBLOCKED){
        
            delete widget.currentRow.NEXTTASKBLOCKED;
            
        }
        
    }; 
    
    /**
     * Função para deletar uma tarefa,
     * 
     * @param {object} widget widget ativa, no modo
     * de visualização, mostrando a tarefa a ser deletada.
    */
    this.deleteTask = function(widget){
        
        General.deleteCrud(widget).then(function(){
                    
        }).catch(function(){
            
            ScreenService.confirmMessage(ScreenService.i18n(Messages.EXCLUSAO_TAREFA_VINC_EVOLUCAO), 'question',
            
                function (success) {
        		    
                    this.deactivateCaseTask(widget).then(function(){
    		        
                        ScreenService.showMessage(Messages.TAREFA_INATIVADA);
                            		        
        		        ScreenService.closeSwipe().then(function(){
        		            
        		            widget.reload();
        		              
        		        });
    		              
    		        }).catch(function(error){
    		            
    		            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));  
    		            
    		        });
        		    
        		}.bind(this));
                
        }.bind(this));
          
    };
    
    /**
     * Função para desativar uma tarefa.
     * 
     * @param {object} widget widget de agenda de
     * tarefas, no modo de vizualisaçãom, com as
     * informações da tarefa a ser excluida.
    */
    this.deactivateCaseTask = function(widget){
        
        var currentRow = widget.currentRow;
        
            var paramsRestEngine = {
                "requestType": "Row",
                "row": currentRow
            };
            
            return restEngine.post('/deactivateCaseTask', paramsRestEngine,
                function(success){
                    
                },undefined,
                function(error){
                    
                },undefined,undefined
            );
            
    };
    
    /**
     * Função para possibilitar o cadastro de
     * uma evolução referente a tarefa em caso,
     * indicando a conclusão da tarefa.
     * 
     * @param {object} widget widget ativa, no modo
     * view, referente a tarefa em caso.
    */
    this.completeTask = function(widget){
        
        var evolutionWidget = templateManager.container.getWidget("evolucao");
        
        evolutionWidget.COMPLETETASK = true;
        evolutionWidget.NRSEQFILACONTA = widget.currentRow.NRSEQFILACONTA;
        
        ScreenService.closeSwipe().then(function(){
            
            this.activateWidget(evolutionWidget).then(function(){
                
                setTimeout(function(){    
                    this.evolucaoNewRow(evolutionWidget);
                }.bind(this), 500);
                
            }.bind(this));
            
        }.bind(this));
            
    };
    
    /**
     * Função para ativar uma widget
     * 
     * @param {object} widget widget que será
     * ativada.
     * 
     * @return {object} deferred 'promise' indicando
     * a conclusão da tarefa da função.
    */
    this.activateWidget = function(widget){
        
        var deferred = ZHPromise.defer();
        
        widget.activate();
        deferred.resolve();
        
        return deferred;
    };
    
    /**
     * Função para pegar as informações da tarefa
     * na widget de evolução e setar a data de
     * conclusão da tarefa no registro da própria
     * tarefa.
     * 
     * @param {object} widget widget ativa que contém
     * as informações da tarefa que será concluida.
    */
    this.setTaskEndDate = function(widget){
        
        var currentRow = widget.currentRow;
        
        if(widget.COMPLETETASK){
            
            currentRow.NRSEQFILACONTA = widget.NRSEQFILACONTA;
            
            var paramsRestEngine = {
                "requestType": "Row",
                "row": currentRow
            };
            
            return restEngine.post('/setTaskEndDate/caso', paramsRestEngine,
                function(success){
                    
                    ScreenService.showMessage("Tarefa Concluída com sucesso.");
                    this.deleteTaskInfosInEvolutionWidget(widget);
                     
                }.bind(this),undefined,
                function(error){
                    
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
                    
                },undefined,undefined
            );
        }

    };
    
    /**
     * Função para deletar as informações da
     * tarefa a ser concluída da widget de evolução.
     * 
     * @param {object} widget widget de evolução.
    */
    this.deleteTaskInfosInEvolutionWidget = function(widget){
        
        delete widget.COMPLETETASK;
        delete widget.NRSEQFILACONTA;
        
    };
    
    /**
     * Função para abrir a widget de seleção
     * de arquivos.
    */
    this.openAnnexSwipe = function(){
        
        var fileUploadWidget = templateManager.container.getWidget('WDGT_SELECAO_ARQUIVOS');
        
        fileUploadWidget.isVisible = true;
        ScreenService.openSwipe(fileUploadWidget);
            
    };
    
    /**
     * Função para salvar os anexos selecionados
     * ao caso em questão.
     * 
     * @param {object} widget widget onde é
     * feito a seleção dos anexos.
    */
    this.uploadEvolutionFiles = function(widget){
        
        var files = widget.currentRow.DSCAMINHO;
        
        var rows = [];
        
        files.forEach(function(file, fileIndex){
            
            rows.push(this.setValuesForEvolutionFileUpload(widget, fileIndex));
            
        }.bind(this));
        
        General.callRestEngine("product#/crm_anexocontato/save", "DataSet", rows).then(function() {
            
                this.closeAnnexSwipe(widget);
                widget.parent.parent.reload();
                
        }.bind(this));
    };
    
    /**
     * Função para retornar uma row configurada
     * com as informações do anexo referente
     * ao ID, recebido como parâmetro, no array
     * de anexos na currentRow.
     * 
     * @param {object} widget widget onde foi selecionado
     * os anexos.Array
     * 
     * @param {int} fileIndex index do anexo no array de 
     * anexos presente na currentRow.
     * 
     * @return {object} currentRow row configurada com as informações
     * do anexo referente ao ID recebido.
    */
    this.setValuesForEvolutionFileUpload = function(widget, fileIndex){
        
        var currentRow = angular.copy(widget.currentRow);
        var evolutionWidget = widget.parent.parent;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.NRSEQCONTATO = evolutionWidget.currentRow.NRSEQCONTATO;
        currentRow.NMARQUIVO = this.getFileNameWithoutExtension(currentRow.DSCAMINHO[fileIndex].name);
        currentRow.DSTIPO = this.getFileExtension(currentRow.DSCAMINHO[fileIndex].name);
        currentRow.VRTAMANHO = currentRow.DSCAMINHO[fileIndex].size;
        currentRow.IDATIVO = "S";
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
        currentRow.IDORIGEM = "EVOLUCAO";
        currentRow.NRORIGEM = evolutionWidget.currentRow.NRSEQEVOLCONT;
        
        return currentRow;
        
    };
    
    /**
     * Função para retornar a extenção de um arquivo
     * extraida do seu nome.
     * 
     * @param {string} fileName nome completo do arquivo.
    */
    this.getFileExtension = function(fileName){
        
        return fileName.replace(/^(.*)\.(.*)$/, "$2");
        
    };
    
    /**
     * Função para retornar o nome do arquivo sem
     * sua extenção.
     * 
     * @param {string} fileName nome completo do arquivo.
    */
    this.getFileNameWithoutExtension = function(fileName){
        
        return fileName.replace(/^(.*)\.(.*)$/, "$1");
            
    };
    
    /**
     * Função para fechar o swipe de upload de imagens.
     * 
     * @param {object} widget widget de upload de imagens.
    */
    this.closeAnnexSwipe = function(widget){
        ScreenService.closeSwipe().then(function(){
            
            widget.isVisible = false;
            widget.parent.parent.list();
            widget.parent.parent.activate();
           
        });
    };
    
    /**
     * Função para fazer o download de uma arquivo
     * salvo no servidor.
     * 
     * @param {object} widget widget que contém
     * as informações do arquivo a ser baixado 
     * em sua currentRow.
    */    
    this.downloadFile = function(widget){
        
        window.open(window.fileServerBaseUrl + widget.currentRow.DSCAMINHO);
            
    };
    
    this.validateCaseCustomCode = function(widget){
            
        var currentRow = widget.currentRow;
        
        if(currentRow.CDCASO){
            
            var paramsRestEngine = {
                "requestType": "Row",
                "row": currentRow
            };
                
            return restEngine.post('/validadeCaseCustomCode', paramsRestEngine,
                function(success){
                    
                    if(success.dataset.DADOS.length > 0){
                        
                        currentRow.CDCASO = "";
                        ScreenService.showMessage(Messages.CODIGO_PERSONALIZADO_EXISTENTE);
                            
                    }
                    
                }.bind(this),undefined,
                function(error){
                    
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
                    
                },undefined,undefined
            );
        
        }
            
    };
}

Configuration(function(ContextRegister)
{
    ContextRegister.register('crm20000_Caso_Controller', crm20000_Caso_Controller);
});

// FILE: ./assets/js/controllers/crm30000_001_Tipo_Compromisso_Controller.js
function crm30000_001_Tipo_Compromisso_Controller(General, templateManager)
{   
    
    /**
     * Função para definir se irá salver um
     * novo registro ou uma alteração de um 
     * registro existente.
     * 
     * @param {object(widget)} widget widget
     * ativa no modo edit.
     * 
    */
    this.saveCommitmentType = function(widget){
            
        var currentRow = widget.currentRow;
        
        if(currentRow.__is_new){
            
            this.saveNewCommitmentType(widget);
            
        }else{
            
            this.saveCommitmentTypeModification(widget);
            
        }
            
    };
    
    /**
     * Função para salvar um novo tipo de
     * compromisso.
     * 
     * @param {object(widget)} widget widget ativa
     * onde está sendo realizado o cadastro de um 
     * novo tipo de compromisso.
    */
    this.saveNewCommitmentType = function(widget){
        
        var currentRow = widget.currentRow;
        
        this.editIconPathOutput(currentRow);
        this.setColumnToReturnInCurrentRow(currentRow, "NRTIPOCOMPROMISSO");
        
        General.widgetSave(widget).then(function(response){
            
            var iconUrl = response.dataset.VALUES.DSCAMINHOICONE;
            
            currentRow.NRTIPOCOMPROMISSO = response.dataset.VALUES.NRTIPOCOMPROMISSO;
            currentRow.DSCAMINHOICONE = (iconUrl) ? iconUrl : "";
            
        });
                
    };
    
    /**
     * Função para setar a coluna a ser retornada
     * na resposta do 'save'.
     * 
     * @param {object} currentRow currentRow que receberá
     * a propriedade com o nome da coluna a ser retornada.
     * 
     * @param {string} columnName nome da coluna a ser
     * retornada.
    */
    this.setColumnToReturnInCurrentRow = function(currentRow, columnName){
    
        currentRow.__columns_to_return = [columnName];

    };
    
    /**
     * Função para salvar as alterações realizadas
     * em um registro.
     * 
     * @param {object(widget)} widget widget ativa,
     * no modo edit, onde foi feita as alterações
     * do registro.
    */
    this.saveCommitmentTypeModification = function(widget){
        
        var currentRow = widget.currentRow;
        
        this.editIconPathOutput(currentRow);
        
        General.widgetSave(widget).then(function(response){
            
            var iconUrl = response.dataset.VALUES.DSCAMINHOICONE;
            
            currentRow.DSCAMINHOICONE = (iconUrl) ? iconUrl : "";
            
            this.deleteImageUrlBackup(currentRow);
            widget.reload();
            
        }.bind(this));
        
    };
    
    /**
     * Função para deletar o backup do caminho
     * criado no inicio da rotina de edição.
     * 
     * @param {object} currentRow currentRow onde
     * foi salvo o backup da do caminho, que será
     * deletado.
    */
    this.deleteImageUrlBackup = function(currentRow){
        
        if(currentRow.IMAGEURLBACKUP){
            delete currentRow.IMAGEURLBACKUP;
        }
            
    };
    
    /**
     * Função para setar uma string vazia
     * quando o valor do caminhio do icone
     * estiver com um array vazio.
     * 
     * @param {object} currentRow currentRow da widget
     * ativa onde está sendo realizada a modificação
     * do campo 'ícone'.
    */
    this.editIconPathOutput = function(currentRow){
        
        if(currentRow.DSCAMINHOICONE === null || (typeof currentRow.DSCAMINHOICONE === "object" && currentRow.DSCAMINHOICONE.length === 0)){
            currentRow.DSCAMINHOICONE = "";
        }
            
    };
    
    /**
     * Função para setar a URL do icone do
     * tipo de compromisso em caso na currentRow da
     * widget de vizualização de icones, quando
     * for um tipo que for salvo e logo em seguida
     * for requisitado a vizualização do icone, a função
     * já irá atribuir o caminho retornado dentro do objeto
     * convertido na currentRow.
     * 
     * @param {object(widget)} widget widget ativa
     * onde será vizualizado o icone do tipo de compromisso
     * em caso.
    */
    this.setCommitmentTypeIconUrlInCurrentRow = function(widget){
        
        var commitmentTypeIconUrl = widget.parent.parent.currentRow.DSCAMINHOICONE;
        var currentRow = widget.currentRow;
        
        currentRow.DSCAMINHOICONE = (commitmentTypeIconUrl) ? commitmentTypeIconUrl : ""; 
        
    };
    
    /**
     * Função para editar as informações
     * de um tipo de compromisso.
     * 
     * @param {object(widget)} widget widget ativa
     * no modo view, onde se inicializará o processo
     * de edição.
    */
    this.editTypeCommitment = function(widget){
    
        var currentRow = widget.currentRow;
        
        this.createImageUrlBackup(currentRow);
        
        General.widgetEdit(widget);
    };
    
    /**
     * Função para criar um backup da url do icone
     * na currentRow.
     * 
     * @param {object} currentRow currentRow onde será
     * salvo o backup da url do icone.
     * 
    */
    this.createImageUrlBackup = function(currentRow){
        

        currentRow.IMAGEURLBACKUP = (currentRow.DSCAMINHOICONE) ? currentRow.DSCAMINHOICONE : "";
        
    };
    
    /**
     * Função para ativar a widget de visualização
     * do icone do tipo do compromisso em caso.
    */
    this.toVisualizeCommitmentTypeIcon = function(){
        
        var visualizationIconWidget = templateManager.container.getWidget("WDGT_COMMITMENT_TYPE_ICON");
        
        visualizationIconWidget.activate();
            
    };
    
    /**
     * Função para deletar o icone do tipo
     * do compromisso em caso.
     * 
     * @param {object(widget)} widget widget ativa
     * contendo o icone do tipo do compromisso em caso.
    */
    this.deleteCommitmentTypeIcon = function(widget){
        
        widget.currentRow = widget.parent.parent.currentRow;
        
        var currentRow = widget.currentRow;
        
        this.createImageUrlBackup(currentRow);
        
        currentRow.__is_new = false;
        currentRow.DSCAMINHOICONE = "";
        
        this.getParentWidgetDataDatasource(widget);
        
        widget.saveRow().catch(function(err) {
            ScreenService.showMessage(err.data.error);
        });
            
    };
    
    /**
     * Função para receber o objecto data, vindo do objecto
     * dataSource, do pai da widget recebida como parâmetro
     * e setar na própria widget recebida.
     * 
     * @param {object(widget)} widget widget ativa
     * contendo o icone do tipo do compromisso em caso.
    */
    this.getParentWidgetDataDatasource = function(widget){
        
        widget.dataSource.data = widget.parent.dataSource.data;
        
    };
   
}
Configuration(function(ContextRegister)
{
    ContextRegister.register('crm30000_001_Tipo_Compromisso_Controller', crm30000_001_Tipo_Compromisso_Controller);
});

// FILE: ./assets/js/controllers/crm30000000_Compromisso_Controller.js
function crm30000000_Compromisso_Controller(ScreenService, templateManager, CRM_Utilities, General, restEngine, ZHPromise, Messages, API_GoogleCalendar, evolutionTabController, metaDataFactory) {
    
    var self = this;
    
    var backUpactions;
    var actionReturnCalendar;
    var filterChanged = false;
    var syncronized = false;
    
    CRM_Utilities.addController(this, 'crm30000000_Compromisso_Controller');
    
    /**
     * Função para designar o procedimento
     * a ser feito (INSERT/UPDATE).
     * 
     * @param {object} widget widget ativa
     * onde está sendo realizado o cadastro.
    */
    this.saveCommitment = function(widget) {
        var currentRow = widget.currentRow;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
    
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
    
        if (currentRow.__is_new) {
            General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response) {
                if (response.dataset && response.dataset.error) {
                    ScreenService.showMessage(response.dataset.error, 'ERROR');
                }
                if (response.dataset && response.dataset.GROUPREL[0] == false) {
                    if (widget.isValid) {
                        this.defineGoogleCalendarStatus(widget);
                        this.saveNewCommitment(widget).then(function() {
                            if (widget.parent.parent.name == 'LIST_COMPROMISSO') {
                                widget.parent.parent.reload();
                            } else {
                                widget.reload();
                            }
                        });
                    }
                } else {
                    ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
                }
            }.bind(this));
        } else {
            if (widget.isValid) {
                this.defineGoogleCalendarStatus(widget);
                this.saveNewCommitment(widget).then(function() {
                    if (widget.parent.parent.name == 'LIST_COMPROMISSO') {
                        widget.parent.parent.reload();
                    } else {
                        widget.reload();
                    }
                });
            }
        }
    };
    
    this.setSelectedFirstDayOnStripe = function() {
        var wid = templateManager.container.getWidget('CALENDARIO');
        var stripe = templateManager.container.getWidget('stripe');
        var stripeDateField = CRM_Utilities.getObjectPositionInArrayByName(stripe.fields, "SELECTEDAY");
        stripe.fields[stripeDateField].label = "Dia Selecionado:";
        
        wid.getEventsWidget().dataSource.data = [];
    };
    
    /**
     * Define se a api do Google trabalhará com um
     * evento já existente ou criará um novo.
     * 
     * @param {object} widget widget base para inserir
     * um compromisso.
    */
    this.defineGoogleCalendarStatus = function(widget) {
        
        var currentRow = widget.currentRow;
        currentRow.DEFINEEVENTOGOOGLE = currentRow.__is_new ? true : false;
    };
    
    /**
     * Função para salvar(marcar) um novo
     * compromisso.
     * 
     * @param {object} widget widget ativar
     * onde está sendo realizado o cadastro
     * do compromisso.
    */
    this.saveNewCommitment = function(widget) {
        
        if(!widget.isValid()) {
            return;
        }
        
        var currentRow = widget.currentRow;
        var calendarWidget = templateManager.container.getWidget('CALENDARIO');
        
        this.setCommitmentDateInCurrentRow(widget);
        this.configureCommitmentIconUrl(widget);
        this.changeParticipantsWidgetActivation(true);
        this.changeDateFieldsTemplateToTextView(widget);
        this.returnDefaultActionsContainer();
        this.changeActionLabel(widget);
        
        return General.widgetSave(widget).then(function(response) {
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
                ScreenService.alertNotification('Nenhum participante adicionado foi notificado por falta dos dados na parametrização.', 5000);
            }
            calendarWidget.reloadSchedulerWidget();
            
            widget.view();
            
            if(currentRow.DEFINEEVENTOGOOGLE && Boolean(templateManager.SYNCGOOGLECALENDAR)) {
                this.addEventToLoggedUserGoogleCalendar(currentRow);
            }else if(Boolean(templateManager.SYNCGOOGLECALENDAR)) {
                this.editGoogleEvent(currentRow);
            }
            
            currentRow.NRSEQPLANOCUPA = response.dataset.columnsToReturn.NRSEQPLANOCUPA;
            
        }.bind(this));
            
    };
    
    /**
     * Função para remover a máscara do dia
     * e do horário do compromisso.
     * 
     * @param {object} widget widget ativa
     * onde foi registrado a data e o horário
     * do compromisso.
    */
    this.setCommitmentDateInCurrentRow = function(widget) {
        var currentRow = widget.currentRow;
        
        currentRow.DTINIPLANOCUPA = currentRow.DTINI.replace(/\sàs\s/, " ");
        currentRow.DTFINPLANOCUPA = currentRow.DTFIM.replace(/\sàs\s/, " ");

    };
    
    this.changeWidgetTemplateToFormView = function(widget) {
        
        widget.template = "widget/form-view.html";
            
    };
    
    this.changeDateFieldsTemplateToTextView = function() {
        
        var widget = templateManager.container.getWidget("WDGT_NEW_COMMITMENT");
        
        var startDateField = widget.getField("DTINI");
        var endDateField = widget.getField("DTFIM");
        
        startDateField.template = "field/text-edit.html";
        endDateField.template = "field/text-edit.html";
        
        startDateField.reload();
        endDateField.reload();
        
    };
    
    this.changeDateFieldsTemplateToDateTime = function() {
        
        var widget = templateManager.container.getWidget("WDGT_NEW_COMMITMENT");
        
        var startDateField = widget.getField("DTINI");
        var endDateField = widget.getField("DTFIM");
        
        startDateField.template = "field/datetime.html";
        endDateField.template = "field/datetime.html";
        
        startDateField.reload();
        endDateField.reload();
        
    };
    
    this.configureCommitmentIconUrl = function(widget) {
        
        var currentRow = widget.currentRow;
        
        if(currentRow.DSCAMINHOICONE) {
            currentRow.DSCAMINHOICONE = window.fileServerBaseUrl + currentRow.DSCAMINHOICONE;       
        }
            
    };
    
    this.setEndCommitment = function(widget) {
        var currentRow = widget.currentRow;
        var commitmentInitDate = currentRow.DTINI;
        
        if(commitmentInitDate && !currentRow.DTFIM) {
            var DTINI30minutesLater = moment(commitmentInitDate, 'DD/MM/YYYY HH:mm').add(30, 'minutes').format('DD/MM/YYYY HH:mm');
            
            currentRow.DTFIM = DTINI30minutesLater.replace(/\s/, " às ");
        }
        
        templateManager.updateTemplate();
    };
    
    this.setEndCommitmentFormated = function(widget) {
        var currentRow = widget.currentRow;
        var commitmentInitDate = currentRow.DTINI;
        
        if(commitmentInitDate && !currentRow.DTFIM) {
            var DTINI30minutesLater = moment(commitmentInitDate, 'DD/MM/YYYY HH:mm').add(30, 'minutes').format('DD/MM/YYYY HH:mm');
            currentRow.DTFIM = DTINI30minutesLater;
            widget.getField('DTFIM').reload();
        }
        
        templateManager.updateTemplate();
    };
    
    this.dateValidation = function(verifiedField) {
        var widget = templateManager.container.getActiveWidget();
        
        var currentRow = widget.currentRow;
        
        var objectInitialDate = moment(currentRow.DTINI, 'DD/MM/YYYY HH:mm');
        var objectFinalDate = moment(currentRow.DTFIM, 'DD/MM/YYYY HH:mm');
        
        if(objectFinalDate.diff(objectInitialDate) < 0 && currentRow.DTINI && verifiedField.name === 'DTFIM') {
            currentRow.DTFIM = "";
            ScreenService.showMessage('Selecione uma data final válida.');
        }
        else if(objectInitialDate.diff(objectFinalDate) > 0 && currentRow.DTFIM && verifiedField.name === 'DTINI') {
            currentRow.DTINI = "";
            ScreenService.showMessage('Selecione uma data inicial válida.');
        }
    };
    
    this.insertFilterNMMOTIEVOCON = function(widget) {
        
            var fieldMotiEvoCon = widget.getField('NMMOTIEVOCON');
            var filterMotiEvoCon = fieldMotiEvoCon.dataSourceFilter;
            var infosOperatorLogged = CRM_Utilities.getLoggedOperatorInfos();
            
            fieldMotiEvoCon.dataSourceFilter[self.getFilterPosition(filterMotiEvoCon, 'P_CDOPERADOR')].value = infosOperatorLogged.CDOPERADOR;
            fieldMotiEvoCon.dataSourceFilter[self.getFilterPosition(filterMotiEvoCon, 'P_NRORG')].value = infosOperatorLogged.NRORG;
            
            fieldMotiEvoCon.reload();
    };
    
    this.getFilterPosition = function(dataSourceFilter,name) {
        var indexFilterObject;
        
        dataSourceFilter.forEach(function(value,i) {
            if(value.name === name) {
                indexFilterObject = i;
                return;
            }    
        });
        return indexFilterObject;
    };
    
    this.newCommitmentAndFormatsWidget = function(widget) {
        
        var widgetNewCommitment = templateManager.container.getWidget("WDGT_NEW_COMMITMENT");
        var commitmentTabs = templateManager.container.getWidget("container_tabbed");
        
        widgetNewCommitment.parent.parent = widget;
        this.changeDateFieldsTemplateToDateTime();
        
        ScreenService.openSwipe(commitmentTabs).then(function() {
            
            this.changeParticipantsWidgetActivation(false);
            
            widgetNewCommitment.newRow();
            widgetNewCommitment.edit();
            widgetNewCommitment.template = 'widget/form.html';
            widgetNewCommitment.activate();
            
            this.setCommitmentDefaultValues(widgetNewCommitment);
            
        }.bind(this), function(error) {
            ScreenService.closeSwipe();
            ScreenService.showMessage(error);
        });
    };
    
    this.changeParticipantsWidgetActivation = function(isEnabled) {
        
        var participantsWidget = templateManager.container.getWidget("WDGT_COMMITMENT_PARTICIPANTS");
        
        participantsWidget.enabled = isEnabled;
        
    };
    
    /**
     * Função para setar os valores iniciais
     * de um cadastro de compromisso.
     * 
     * @param {object} widget widget ativa que
     * terá os valores recebidos em sua currentRow.
     * 
    */
    this.setCommitmentDefaultValues = function(widget) {
        
        var currentRow = widget.currentRow;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.__is_new = true;
        currentRow.CDFILIAL = "";
        currentRow.NRCONTATO = "";
        currentRow.DSCORCARD = "";
        currentRow.DSPLANOCUPA = "";
        currentRow.CDMOTIEVOCON = "";
        currentRow.NRSEQCONTATO = "";
        currentRow.NRPARCNEGOCIO = "";
        currentRow.DSCAMINHOICONE = "";
        currentRow.HRINIPLANOCUPA = "";
        currentRow.HRFINPLANOCUPA = "";
        currentRow.NRRELACIONAPARC = "";
        currentRow.CDINTEPLANOCUPA = "";
        currentRow.NRTIPOCOMPROMISSO = "";
        currentRow.NRCLASSIFICACOMPR = "";
        currentRow.TIPO = "";
        currentRow.NRSEQOPORT = "";
        widget.currentRow.IDSTATPLANOCUPA = "P";
        
        currentRow.NMOPERADORESPONS = loggedOperatorInfos.NMOPERADOR;
        currentRow.CDOPERADORESPONS = loggedOperatorInfos.CDOPERADOR;
        currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
        currentRow.NRPARCNEGOCIO = loggedOperatorInfos.NRPARCNEGOCIO;
        currentRow.NRORG = loggedOperatorInfos.NRORG;
            
    };
    
    this.setDefaultCommitmentState = function(widget) {
        
        widget.currentRow.IDSTATPLANOCUPA = "P";
            
    };
    
    this.setCDOPERADORInCurrentRow = function() {
        var widget = templateManager.container.getActiveWidget();
        
        widget.currentRow.CDOPERADOR = widget.currentRow.CDOPERADORESPONS;
    };
    
    this.closeSwipeNewCommitment = function(widget) {
        this.changeDateFieldsTemplateToTextView();
        
        if (widget.currentRow.__is_new) {
            var indexOfCurrentRow = widget.dataSource.data.indexOf(widget.currentRow);
			if (indexOfCurrentRow !== -1) {
				widget.dataSource.data.pop();
			}
			
			ScreenService.closeSwipe();
        }else{
            for (var i in widget.backupRow) {
				widget.currentRow[i] = widget.backupRow[i];
			}
			
			widget.view();
        }
    };
    
    this.deleteCommitmentAndParts = function(widget) {
        var currentRow = widget.currentRow;
        
        if(!Boolean(currentRow.NOEDITABLE)) {
            
            ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question',
            function (success) {
                var calendarWidget = templateManager.container.getWidget('CALENDARIO');
                var parentWidget = widget.parent.parent; //Não trocar por getParent()
                var parametroRestEngine = {
                    'requestType':'Row',
                    'row': widget.currentRow
                };
                
                restEngine.post('/deleteCommitmentParts', parametroRestEngine,
                    
                    function(success) {
                        
                    },undefined,
                    function(error) {
                        
                    }
                );
                
                restEngine.post('/deleteCommitment', parametroRestEngine,
                    
                    function(success) {
                        
                        if(templateManager.SYNCGOOGLECALENDAR) {
                            API_GoogleCalendar.deleteGoogleEvent(currentRow.NRSEQPLANOCUPA);    
                        }
                        this.showActionReturnCalendar();
                        
                        ScreenService.closeSwipe().then(function() {
                            
                            ScreenService.closeSwipe();
                            parentWidget.reload();
                            calendarWidget.reloadSchedulerWidget();
                            if(parentWidget.name == "LIST_COMPROMISSO") {
                                parentWidget.activate();
                            }else {
                                calendarWidget.activate();
                            }
                            
                        });
                        
                    }.bind(this),undefined,
                    function(error) {
                        
                    }
                );
            }.bind(this),
            function(error) {
                
            });
            
        }else{
            ScreenService.showMessage(Messages.IMPOSSIVEL_MANUSEAR_EVENTO(currentRow.BECAUSENOEDITABLE));
        }
    };
    
    this.formatDateField = function(field) {
        var valueField = field.value();
        
        if(valueField !== "") {
            
            field.value(valueField.replace(/\s/, " às "));
        }
    };
     
    this.setVisibleFieldReferenceCode = function() {
        var widget = templateManager.container.getActiveWidget();
        var currentRow = widget.currentRow;
        var fieldCaso = widget.getField('FIELDCASO');
        var fieldOport = widget.getField('FIELDOPORTUNI');
        
        if(currentRow.TIPO === "OPORTUNIDADE") {
            fieldCaso.isVisible = false;
            fieldCaso.showOnForm = false;
            fieldCaso.value("");
            fieldOport.isVisible = true;
            fieldOport.showOnForm = true;
            fieldCaso.validations = {};
            fieldOport.validations = {required:true};
            fieldOport.label = "Oportunidade de Negócio";
            fieldOport.readOnly = false;
            fieldCaso.validations = {};
        }else if (currentRow.TIPO === "PARCEIRO") {
            fieldOport.isVisible = false;
            fieldOport.showOnForm = false;
            fieldOport.value("");
            fieldCaso.isVisible = true;
            fieldCaso.showOnForm = true;
            fieldOport.validations = {};
            fieldCaso.validations = {required:true};
            fieldCaso.label = "Parceiro de Negócio";
            fieldCaso.readOnly = false;
            fieldOport.validations = {};
        }else{
            fieldCaso.validations = {};
            fieldOport.validations = {};
            fieldOport.label = "";
            fieldCaso.label = "";
            fieldOport.readOnly = true;
            fieldCaso.readOnly = true;
        }
        templateManager.updateTemplate();
    };
    
    this.setFilterParcNegocioAndCleanField = function(widget) {
        var currentRow = widget.currentRow;
        var filterCaso;
        var filterOport;
        var fieldCaso = widget.getField('FIELDCASO');
        var fieldOport = widget.getField('FIELDOPORTUNI');
        var fieldTipo = widget.getField('TIPO');
        
        if (!Util.isUndefinedOrNull(currentRow.NMPRINCIPALPARC) && currentRow.NMPRINCIPALPARC !== '') {
            filterCaso = [ 
                {
                    "name": "NRPARCNEGOCIO",
                    "operator": "=",
                    "value": widget.currentRow.NRPARCNEGOCIO
                },
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": widget.currentRow.NRORG
                }
            ];
            filterOport = [ 
                {
                    "name": "NRPARCOPORT",
                    "operator": "=",
                    "value": widget.currentRow.NRPARCNEGOCIO
                },
                { 
                    "name": "P_NRORG", 
                    "operator": "=", 
                    "value": widget.currentRow.NRORG
                    
                },
                {
                    "name": "IDTPOPERADOR", 
                    "operator": "=", 
                    "value": "E"
                },
                {
                    "name": "SITUACAO", 
                    "operator": "=",
                    "value": "A"
                },
                {
                    "name": "CRM_NRORGTRAB",
                    "operator": "=",
                    "value": getLocalVar('CRM_NRORGTRABALHO')
                }
            ];
            
            fieldCaso.readOnly = true;
            fieldOport.readOnly = true;
            fieldTipo.readOnly = false;
            
        }else{
            filterCaso = [];
            filterOport = [];
            fieldTipo.value("");
            fieldCaso.readOnly = true;
            fieldOport.readOnly = true;
            fieldTipo.readOnly = true;
        }
        
        fieldCaso.dataSourceFilter = filterCaso;
        fieldCaso.value("");
        fieldCaso.validations = {};
        fieldCaso.reload();
        fieldOport.dataSourceFilter = filterOport;
        fieldOport.value("");
        widget.currentRow.TIPO = "";
        fieldOport.validations = {};
        fieldOport.reload();
        
        templateManager.updateTemplate();
    };
    
    this.openSwipeFromCalendar = function(calendarWidget) {
        var widgetNewCommitment = templateManager.container.getWidget('WDGT_NEW_COMMITMENT');
        
        widgetNewCommitment.parent.parent = calendarWidget;
        this.openAndEditSwipeCardView(calendarWidget);
    };
    
    this.openSwipeFromList = function(listWidget) {
        var widgetNewCommitment = templateManager.container.getWidget('WDGT_NEW_COMMITMENT');
        
        widgetNewCommitment.parent.parent = listWidget;
        this.openAndEditSwipeCardView(listWidget);
    };
    
    this.openAndEditSwipeCardView = function(widget) {
        var currentRow = widget.currentRow;
        
        var widgetCardView = templateManager.container.getWidget('container_tabbed');
        var widgetCalendar = templateManager.container.getWidget('CALENDARIO');
        var widgetNewCommitment = templateManager.container.getWidget('WDGT_NEW_COMMITMENT');
        var widgetParticipantes = templateManager.container.getWidget('WDGT_COMMITMENT_PARTICIPANTS');
        
        widget.getParent().widgetToBack = widget.name;
        var cardCurrentRow = angular.copy(currentRow);
        
        this.getActionReturnCalendar();
        this.returnDefaultActionsContainer();
        
        ScreenService.openSwipe(widgetCardView).then(function() {

            widgetCardView.currentWidget = widgetNewCommitment;
            widgetNewCommitment.view();
            widgetNewCommitment.template = 'widget/form-view.html';
            widgetNewCommitment.activate();

            widgetNewCommitment.currentRow = cardCurrentRow;
            
            var cardViewCurrentRow =  widgetNewCommitment.currentRow;
            
            cardViewCurrentRow.DTINI = cardViewCurrentRow.DTINIPLANOCUPA.replace(/\s/, " às ").substring(0,19);
            cardViewCurrentRow.DTFIM = cardViewCurrentRow.DTFINPLANOCUPA.replace(/\s/, " às ").substring(0,19);
            cardViewCurrentRow.NMOPERADORESPONS = cardViewCurrentRow.NMOPERADOR;
            
            cardViewCurrentRow.CARDVISUALIZATIONMODE = true;
            
            if(cardViewCurrentRow.TIPO === "OPORTUNIDADE") {
                widgetNewCommitment.getField('FIELDOPORTUNI').isVisible = true;
                widgetNewCommitment.getField('FIELDOPORTUNI').label = "Oportunidade";
                widgetNewCommitment.getField('FIELDCASO').isVisible = false;
                widgetNewCommitment.getField('FIELDCASO').label = "";
                cardViewCurrentRow.FIELDOPORTUNI = cardViewCurrentRow.DSREF;
            }
            else if(cardViewCurrentRow.TIPO === "PARCEIRO" || cardViewCurrentRow.TIPO === "CASO") {
                widgetNewCommitment.getField('FIELDCASO').isVisible = true;
                widgetNewCommitment.getField('FIELDCASO').label = "Parceiro";
                widgetNewCommitment.getField('FIELDOPORTUNI').isVisible = false;
                widgetNewCommitment.getField('FIELDOPORTUNI').isVisible = "";
                cardViewCurrentRow.FIELDCASO = cardViewCurrentRow.DSREF;    
            }
            
            this.changeActionLabel(widgetNewCommitment);
            
        }.bind(this));
        
        widgetCardView.reload();
        
    };
    
    this.closeSwipeCardView = function(widget) {
        if(widget.currentRow.CARDVISUALIZATIONMODE || widget.name === "WDGT_COMMITMENT_PARTICIPANTS") {
            this.showActionReturnCalendar();
        }else{
            this.returnDefaultActionsContainer();
        }
        
        ScreenService.closeSwipe();
        
        if(widget.parent.parent.name == "LIST_COMPROMISSO") {
            var list = templateManager.container.getWidget('LIST_COMPROMISSO');
            list.activate();
        }else {
            var calendario = templateManager.container.getWidget('CALENDARIO');
            calendario.activate();
        }
    };
    
    this.updateStatusPlanocupa = function(newStatus) {
        var widget = templateManager.container.getWidget("WDGT_NEW_COMMITMENT");
        var widgetCalendar = templateManager.container.getWidget("CALENDARIO");
        var currentRow = widget.currentRow;
        
        var backupIDSTATPLANOCUPA = currentRow.IDSTATPLANOCUPA;
        currentRow.IDSTATPLANOCUPA = newStatus;
        
        var parametroRestEngine = {
            'requestType':'Row',
            'row': currentRow
        };
        
        if(!Boolean(widget.currentRow.NOEDITABLE)) {
            restEngine.post('/updateStatusPlanocupa', parametroRestEngine,
                    
                        function(success) {
                            ScreenService.showMessage("Status atualizado com sucesso.");
                            ScreenService.closePopup();
                            widgetCalendar.reloadSchedulerWidget();
                        },undefined,
                        function(error) {
                            ScreenService.showMessage("Erro ao atualizar o status do compromisso.");
                            currentRow.IDSTATPLANOCUPA = backupIDSTATPLANOCUPA;
                            ScreenService.closePopup();
                        }
                    );
            widget.reload();
        }else{
            ScreenService.showMessage(Messages.IMPOSSIVEL_MANUSEAR_EVENTO(widget.currentRow.BECAUSENOEDITABLE));
        }
        
    };

    this.prepareEditCommitmentEdit = function(newCommitCurrentRow, cardViewCurrentRow) {
        
        newCommitCurrentRow.__is_new = false;
        newCommitCurrentRow.DTINI = cardViewCurrentRow.DTINI;
        newCommitCurrentRow.DTFIM = cardViewCurrentRow.DTFIM;
        newCommitCurrentRow.CDOPERADORESPONS = cardViewCurrentRow.CDOPERADOR;
        newCommitCurrentRow.NMOPERADORESPONS = cardViewCurrentRow.NMOPERADOR;
        
        if(cardViewCurrentRow.TIPO === "OPORTUNIDADE") {
            newCommitCurrentRow.FIELDOPORTUNI = cardViewCurrentRow.DSREF;
        }
        else if(cardViewCurrentRow.TIPO === "PARCEIRO" || cardViewCurrentRow.TIPO === "CASO") {
            newCommitCurrentRow.FIELDCASO = cardViewCurrentRow.DSREF;    
        }
        
        newCommitCurrentRow.CDOPERADORPART = cardViewCurrentRow.CDOPERADORPART;
        
        
    };
    
    this.editCommitment = function(widget) {
        
        var currentRow = widget.currentRow;
        
        if(Boolean(currentRow.NOEDITABLE)) {
            ScreenService.showMessage(Messages.IMPOSSIVEL_MANUSEAR_EVENTO(currentRow.BECAUSENOEDITABLE));
        }else {
            
            this.changeDateFieldsTemplateToDateTime();
            this.changeParticipantsWidgetActivation(false);
            General.widgetEdit(widget);
            widget.template = 'widget/form.html';
            widget.activate();
        }
        
    };
    
    this.setFilterPartipantes = function(args) {
        var widgetParticipantes = templateManager.container.getWidget("WDGT_COMMITMENT_PARTICIPANTS");
        var widgetCompromisso   = templateManager.container.getWidget("WDGT_NEW_COMMITMENT");
        widgetParticipantes.currentRow.NRPARCNEGOCIOCOMP = widgetCompromisso.NRPARCNEGOCIO;
        widgetParticipantes.dataSourceFilter.forEach(function(filter) {
            if(filter.name === "NRSEQPLANOCUPA") {
                filter.value = widgetCompromisso.currentRow.NRSEQPLANOCUPA;
            } 
        });
    };
    
    this.getContainerDefaultActions = function() {
        backUpactions = templateManager.container.actions;
    };
    
    this.getActionReturnCalendar = function() {
        
        actionReturnCalendar = templateManager.container.actions;
        
    };
    
    this.showActionReturnCalendar = function() {
        templateManager.container.actions = actionReturnCalendar;    
    };
    
    this.returnDefaultActionsContainer = function() {
        templateManager.container.actions = backUpactions;    
    };
    
	this.setDefaultFilter = function(widget) {
        
        this.changeFilterOperator(widget);
        
	};
	
	this.getDateSixMonthAgo = function() {
	    var currentDate = CRM_Utilities.getCurrentDate();
        var dateSixMonthAgo = CRM_Utilities.subtractDateByMonth(currentDate,6);
        return moment(dateSixMonthAgo, 'DD/MM/YYYY').format('01/MM/YYYY');
	};
	
	this.changeFilterOperator = function(widget) {
	    
	    var cdoperador = widget.__filterPopup.currentRow.CDOPERADOR;
	    var change = false;
	    
	    if(!Util.isEmptyOrBlank(cdoperador) && (typeof cdoperador === "object")) {
	        change = true;
	    }
	    
	    var filters = [];
	    widget.dataSourceFilter.forEach(function(filter) {
	        if(filter.name !== "CDOPERADOR" && change === true) {
	            filters.push(filter);
	        }
	    });
	    
	    if(change) {
            widget.dataSourceFilter = filters;	    
	    }else{
	        
	        var operatorFilter = templateManager.LOGGEDOPERATOR.CDOPERADOR;
	        
	        if(Util.isEmptyOrBlank(cdoperador)) {
	            widget.dataSourceFilter.push({name:"CDOPERADOR", operator: "IN", value: operatorFilter});
	        }
	        
	    }
    };
    
    this.setListaFilter = function(widget) {
        this.fixHourFilter(widget);
        var listaWidget = templateManager.container.getWidget('LIST_COMPROMISSO');
        listaWidget.dataSourceFilter = widget.dataSourceFilter;
        filterChanged = true;
    }
    
    this.fixHourFilter = function(widget) {
        widget.dataSourceFilter.forEach(function(filter) {
            if(filter.name === "DTINIPLANOCUPA" && filter.operator === "BETWEEN")
                filter.value[1] += ' 23:59';
        });  
    };
    
    /**
     * Procedimento para setar o dia selecionado
     * no stripe(widget).
    */
    this.setSelectedDayOnStripe = function() {
        var stripe = templateManager.container.getWidget('stripe');
        var stripeDateField = CRM_Utilities.getObjectPositionInArrayByName(stripe.fields, "SELECTEDAY");
        var calendarWidget = templateManager.container.getWidget('CALENDARIO');
        
        stripe.fields[stripeDateField].label = "Dia Selecionado: " + calendarWidget.getCalendarWidget().currentRow;
    
    };
    
    /**
     * Procedimento para verificar se existe
     * compromissos com mais de um dia.
    */
    this.checkCommitmentsWithInterval = function() {
            var calendar = templateManager.container.getWidget('CALENDARIO');
            var calendarData = calendar.dataSource.data;
            
            calendarData.map(function(row) {
                
                if(row.DATAINI !== row.DATAFIN) {
                    var copyCommitment = angular.copy(row);
                    this.fillCommitmentIntervalDays(calendar,copyCommitment);
                }
                    
            }.bind(this));
        
    };
    
    /**
     * Procedimento para preencher os dias
     * do intervalo de um compromisso.
     * 
     * @param {object} calendar  widget principal da
     * tela de compromisso com os compromisso retornados.
     * 
     * @param {object} commitment compromisso á ser preenchido.
    */
    this.fillCommitmentIntervalDays = function(calendar, commitment) {
        var commitmentInitDate = commitment.DATAINI;
        var commitmentEndDate = commitment.DATAFIN;
        var intervalInitDate = CRM_Utilities.addDaysToDate(commitmentInitDate, 1, 'DD/MM/YYYY');
        var commitmentEndDateMoreOne = CRM_Utilities.addDaysToDate(commitmentEndDate, 1, 'DD/MM/YYYY');
        var daysCont = intervalInitDate;
        
        while(daysCont != commitmentEndDateMoreOne) {
            calendar.dataSource.data.push(this.createCommitmentIntervalDay(commitment, daysCont));
            daysCont = CRM_Utilities.addDaysToDate(daysCont, 1, 'DD/MM/YYYY');
        }
    
    };
    
    /**
     * Procedimento para retornar uma row de compromisso
     * de acordo com o intervaldo que está sendo criado.
     * 
     * @param {object} commitment compromisso referência.
     * 
     * @param {number} currentIntervalDay Dia referente
     * ao intervalo que está sendo criado.
    */
    this.createCommitmentIntervalDay = function(commitment, currentIntervalDay) {
        var newCommitmentIntervalDay = angular.copy(commitment);
        var commitmentescription = commitment.DSPLANOCUPA ? commitment.DSPLANOCUPA : "";
        
        newCommitmentIntervalDay.DEFAULTDATAINI = commitment.DATAINI;
        newCommitmentIntervalDay.DATAINI = currentIntervalDay;
        newCommitmentIntervalDay.DATAFIN = currentIntervalDay;
        /*newCommitmentIntervalDay.DTINIPLANOCUPA = currentIntervalDay + ' ' + commitment.HORAINI;
        newCommitmentIntervalDay.DTFINPLANOCUPA = currentIntervalDay + ' ' + commitment.HORAFIN;*/
        newCommitmentIntervalDay.DSPLANOCUPA = '[REFERENTE AO COMPROMISSO DO DIA: ' + commitment.DATAINI + '] ' + commitmentescription;
        newCommitmentIntervalDay.REFERENCIA = '[REFERENTE AO COMPROMISSO DO DIA: ' + commitment.DATAINI + ']';
        newCommitmentIntervalDay.NOEDITABLE = true;
        newCommitmentIntervalDay.BECAUSENOEDITABLE = "Realize a operação no dia raiz(" + commitment.DATAINI + ')';
        
        return newCommitmentIntervalDay;
    };
    
    /**
     * Executa todos os eventos necessários no eventof
     * "WidgetOnEnterOnce" da widget "CALENDARIO".
     * 
     * @param {object} widget widget "CALENDARIO".
    */
    this.calendarioOnEnterOnce = function(widget, fieldsToApply) {
        
        this.getContainerDefaultActions();
        this.defineIfUserCanSyncGoogle(widget);
        this.setResaleRules(widget);
        evolutionTabController.setEvolutionTabOnActiveWidget(templateManager.container.getWidget('tabbed_evol'));
        
        var filterRow = {};
        filterRow.CDOPERADOR = templateManager.LOGGEDOPERATOR.CDOPERADOR;
        filterRow.NMPARCRESP = templateManager.LOGGEDOPERATOR.NMOPERADOR;
        CRM_Utilities.openFilterOnEnter(widget, filterRow, fieldsToApply);
    };
    
    
    this.setOperadorFilter = function() {
        var widgetFiltro = templateManager.container.getActiveWidget();
        
        widgetFiltro.currentRow.NMPARCRESP = templateManager.LOGGEDOPERATOR.NMPARCRESP;
        widgetFiltro.currentRow.CDOPERADOR = templateManager.LOGGEDOPERATOR.CDOPERADOR;
    };
    
    
    /**
     * Executa todos os eventos necessários no evento
     * "WidgetAfterLoadDataSource" da widget "CALENDARIO".
     * 
     * @param {object} widget widget "CALENDARIO".
    */
    this.widgetAfterLoadDataSource = function(widget) {
        
        this.authenticateUserAndContinueGoogleSysnc(widget).then(function() {
            
            ScreenService.hideLoader();
            this.setCommitmentPermissions(widget);
            this.checkCommitmentsWithInterval(widget);
            if(!syncronized) {
                this.activateGoogleSyncAction();
            } else {
                this.activateGoogleDesyncAction();
            }
            
        }.bind(this))
        .catch(function(error) {
            
            ScreenService.hideLoader();
            this.deleteGoogleCalendarParamInTemplateManager();
            this.deleteSavedGoogleEventsInTemplateManager();
            this.activateGoogleSyncAction();
            ScreenService.showMessage(error); 
            
        }.bind(this));
        
    };
    
    /**
     * Fundi os compromissos recebidos como parâmetro
     * com os já presente na widget.
     * 
     * @param {object} widget widget com os eventos
     * principais.
     * 
     * @param {object} commitments compromissos a serem
     * fundidos.
    */
    this.mergeRelatedCommitmentsAsParticipantWithWidgetData = function(widget, commitments) {
        
        return widget.dataSource.data.concat(commitments);
        
    };
    
    /**
     * Configura as permissões dos compromissos exibidos
     * no calendário.
     * 
     * As permissões são controladas de acordo com o filtro
     * selecionado pelo usuário, os compromissos retornados
     * são configurados de acordo com os operadores filtrados.
     * 
     * Quando um compromisso é exibido no calendário e o operador
     * responsável pelo compromisso não é um operador presente no filtro,
     * realizado pelo usuário, o compromisso é definido como
     * "[RELACIONADO COMO PARTICIPANTE]".
     * 
     * @param {object} widget widget principal da tela de
     * compromissos('CALENDARIO').
    */
    this.setCommitmentPermissions = function(widget) {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        var commitments = widget.dataSource.data;
        var filtredOperators = this.getCalendarWidgetOperatorFilter(widget);
        
        commitments.forEach(function(commitment) {
            
            if(Boolean(commitment.CDOPERADOR)) {
                
                if(!this.checkIfOperadorCanToEditCommitment(widget, commitment)) {
                    
                    commitment.NOEDITABLE = true;
                    commitment.BECAUSENOEDITABLE = Messages.NOEDIT_PARTICIPANTE_COMPROMISSO;
                    commitment.REFERENCIA = '[RELACIONADO COMO PARTICIPANTE]';    
                    
                }else if(filtredOperators.indexOf(commitment.CDOPERADOR) === -1 && commitment.CDOPERADOR === loggedOperatorInfos.CDOPERADOR) {
                    
                    commitment.REFERENCIA = '[RELACIONADO COMO PARTICIPANTE]'; 
                    
                }else if(commitment.CDOPERADOR !== loggedOperatorInfos.CDOPERADOR && commitment.CDOPERINCLUSAO !== loggedOperatorInfos.CDOPERADOR && Boolean(loggedOperatorInfos.IDOPERMASTER !== 'S') && loggedOperatorInfos.CDOPERSHIERARQINF.indexOf(commitment.CDOPERADOR) === -1) {
                    
                    commitment.NOEDITABLE = true;
                    commitment.BECAUSENOEDITABLE = Messages.EDICAO_APENAS_RESPONSAVEL;
                    
                }    
                
            }
            
        }.bind(this));
        
        return commitments;
        
    };
    
    /**
     * Retorna um valor lógico indicando se o usuário poderá ou não
     * modificar o compromisso em caso.
     * Se o operador do compromisso não estiver presente no filtro
     * e o operador logado não for o operador responsável pelo compromisso
     * indica que o compromisso é exibido como 'participante' e o operador
     * logado não poderá editá-lo.
     * 
     * Porém, se o operador logado for o criador do compromisso ou um operador
     * master, na hierarquia de operadores, ele será editavel.
     * 
     * @param {object} widget widget de compromisso.
     * 
     * @param {object} commitment compromisso em caso.
     * 
     * @return {boolean} valor lógico indicando se o usuário poderá ou não
     * modificar o compromisso em caso.
     * 
    */
    this.checkIfOperadorCanToEditCommitment = function(widget, commitment) {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        var filtredOperators = this.getCalendarWidgetOperatorFilter(widget);
        
        if(
            (filtredOperators.indexOf(commitment.CDOPERADOR) !== -1 && 
            commitment.CDOPERADOR !== loggedOperatorInfos.CDOPERADOR) ||
            commitment.CDOPERINCLUSAO === loggedOperatorInfos.CDOPERADOR ||
            Boolean(loggedOperatorInfos.IDOPERMASTER === 'S') ||
            loggedOperatorInfos.CDOPERSHIERARQINF.indexOf(commitment.CDOPERADOR) !== -1
        )
        {
            return true;
        }
        
        return false;
        
    };
    
    /**
     * Retorna os operadores que estão como filtro
     * na widget de compromissos('CALENDARIO'), caso o
     * filtro esteja vazio, a função retorna o operador
     * logado..
     * 
     * @param {object} widget widget principal da tela de
     * compromissos('CALENDARIO').
     * 
     * @return  {object} array com os operadores filtrados.
    */
    this.getCalendarWidgetOperatorFilter = function(widget) {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        var widgetFilter = widget.dataSourceFilter;
        var operatorFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(widgetFilter, "CDOPERADOR");
        
        if(!operatorFilterIndex) {
            var operatorFilter = {
                name: "CDOPERADOR",
                operator: "IN",
                value: [loggedOperatorInfos.CDOPERADOR]
            };
            widgetFilter.push(operatorFilter);
            operatorFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(widgetFilter, "CDOPERADOR");
        }
        
        var filter = widgetFilter[operatorFilterIndex].value ? widgetFilter[operatorFilterIndex].value : loggedOperatorInfos.CDOPERADOR;
        var modifiedFilter = this.changeStringAsLoggedOperatorFilter(filter);
        
        return modifiedFilter;
        
    };
    
    /**
     * Altera o filtro de operator caso ele esteja como
     * a string de referência ('@templateManager.LOGGEDOPERATOR.CDOPERADOR@').
     * 
     * @param {object | String} filter filtro a ser verificado.
     * 
     * @return {object | String} filtro configurado.
    */
    this.changeStringAsLoggedOperatorFilter = function(filter) {
        
        if(filter === "@templateManager.LOGGEDOPERATOR.CDOPERADOR@") {
            filter = templateManager.LOGGEDOPERATOR.CDOPERADOR;
        }
        
        return filter;
        
    };
    
    /**
     * Ativa a ação para o usuário sincronizar
     * um calendário google ao sistema.
    */
    this.activateGoogleSyncAction = function() {
        
        this.setGoogleSyncActionVisibility(true);
        this.setGoogleDesyncActionVisibility(false);
        
    };
    
    /**
     * Ativa a ação para o usuário dessincronizar
     * um calendário google ao sistema.
    */
    this.activateGoogleDesyncAction = function() {
        
        this.setGoogleSyncActionVisibility(false);
        this.setGoogleDesyncActionVisibility(true);
        
    };
    
    /**
     * Pergunta ao usuário se ele deseja desativar a 
     * sincronização com o calendário do Google.
     * 
     * @param {object} widget widget principal "CALENDARIO".
    */
    this.desyncTasksWithGoogleCalendarQuestion = function(widget) {
        
        ScreenService.confirmMessage(Messages.DESINC_GOOGLE_CALENDAR, 'question', function(success) {
            
            this.desyncTasksWithGoogleCalendar(widget);
            syncronized = false;
            widget.reload().then(function() {
                ScreenService.showMessage(Messages.GOOGLE_DESINC_SUCESSO);
            });    
            
        }.bind(this));
        
    };
    
    /**
     * Desativa a sincronização com o calendário do Google.
     * 
     * @param {object} widget widget principal "CALENDARIO".
    */
    this.desyncTasksWithGoogleCalendar = function(widget) {
        
        this.deleteGoogleCalendarParamInTemplateManager();
        this.deleteSavedGoogleEventsInTemplateManager();
        this.activateGoogleSyncAction();
        API_GoogleCalendar.signOutGoogle();
        
    };
    
    /**
     * Questiona o usuário se ele deseja sincronizar
     * suas atividades com o calendário vinculado
     * a conta(Gmail) autenticada.
     * 
     * @param {object} widget widget principal "CALENDARIO".
    */
    this.syncTasksWithGoogleCalendar = function(widget) {
    
        ScreenService.confirmMessage(Messages.SINC_GOOGLE_CALENDAR, 'question',
            function (success) {
                
                this.defineParamInTemplateManagerConfirmingGoogleCalendar();
                widget.reload();
                
            }.bind(this),
            function (error) {
            }
        );
        
    };
    
    /**
     * Realiza o processo de autenticação pelo google
     * e continua o processo de sincronização decorrente.
     * 
     * @param {object} widget widget principal "CALENDARIO".
    */
    this.authenticateUserAndContinueGoogleSysnc = function(widget) {
        
        var zhPromise = ZHPromise.defer();
        
        if(Boolean(templateManager.SYNCGOOGLECALENDAR)) {
            
            ScreenService.showLoader();
            return API_GoogleCalendar.signInGoogle()
                .then(function() {
                    
                    this.activateGoogleDesyncAction();
                    syncronized = true;
                    return this.mergeGoogleCalendareEventsToZeedhiCalendarEvents(widget);
                    
                }.bind(this));
        }else{
            
            zhPromise.resolve();
            
        }
        return zhPromise.promise;    
        
    };
    
    /**
     * Mescla os eventos do calendário google
     * do usuário autenticado com os eventos criados
     * pelo calendário zeedhi.
     * 
     * @param {object} zeedhiCalendarWidget widgtet principal
     * com o  calendário zeedhi.
    */
    this.mergeGoogleCalendareEventsToZeedhiCalendarEvents = function(zeedhiCalendarWidget) {
        
        var zhPromise = ZHPromise.defer();
        
        if(Boolean(templateManager.SYNCGOOGLECALENDAR)) {
            var zeedhiCalendarEvents = zeedhiCalendarWidget.dataSource.data;
            
            if(!Boolean(templateManager.GOOGLEEVENTS)) {
                
                return this.createArrayWithLoggedUserGoogleEventsInZeedhiCalendarWidget(zeedhiCalendarWidget).then(function() {
                    zeedhiCalendarWidget.dataSource.data = zeedhiCalendarEvents.concat(templateManager.GOOGLEEVENTS);
                    ScreenService.showMessage(Messages.GOOGLE_SINC_SUCESSO);
                });
                
            }else{
                zeedhiCalendarWidget.dataSource.data = zeedhiCalendarEvents.concat(templateManager.GOOGLEEVENTS);
            }
        }
        
        zhPromise.resolve();
        return zhPromise.promise;
        
    };
    
    /**
     * Deleta os eventos do google salvo no templateManager;
    */
    this.deleteSavedGoogleEventsInTemplateManager = function() {
        
        if(templateManager.GOOGLEEVENTS) {
            delete templateManager.GOOGLEEVENTS;
        }
        
    };
    
    /**
     * Cria um array com os eventos relacionados a agenda
     * do google do usuário autenticado(pelo google) dentro
     * do template manager, excluindo eventos cadastrados pelo
     * CRM e foram incluídos no google calendar(Eventos de seis
     * meses atrás em diante, em consideração a data atual).
    */
    this.createArrayWithLoggedUserGoogleEventsInZeedhiCalendarWidget = function() {
        
        var zhPromise = ZHPromise.defer();
        
        var dateSixMonthAgo = this.getDateSixMonthAgo();
        var googleFormateddateSixMonthAgo = API_GoogleCalendar.createGoogleEventDateTimeFormat(dateSixMonthAgo, '00:00:00');
        
        API_GoogleCalendar.getLoggedGoogleUserEvents(null, googleFormateddateSixMonthAgo).then(function(response) {
            
            templateManager.GOOGLEEVENTS = [];
            response.map(function(event) {
                
                if((!Boolean(event.summary) || event.summary.search("[CRM]") <= 0) && event.status !== 'cancelled') {
                    
                    var initDate = Boolean(event.start.dateTime) ? event.start.dateTime : event.start.date;
                    var endDate = Boolean(event.end.dateTime) ? event.end.dateTime : event.end.date;
                    
                    event.iniDateTime = this.getGoogleEventFormattedDateTime(initDate);
                    event.endDateTime = this.getGoogleEventFormattedDateTime(endDate);
                    
                    templateManager.GOOGLEEVENTS.push(this.createZeedhiCalendarDefaultEvent(event));
                }
                
                return;
                
            }.bind(this));
            
            zhPromise.resolve();
            
        }.bind(this)).catch(function(error) {
            zhPromise.reject(error);
        });
        
        return zhPromise.promise;
        
    };
    
    /**
     * Retorna uma string no formato datetime
     * padrão de acordo com o datetime usado
     * pelo evento do google.
     * 
     * @param {string} googleDateTime datetime usado
     * nos eventos do google.
    */
    this.getGoogleEventFormattedDateTime = function(googleDateTime) {
        
        var date;
        var time;
        
        if(googleDateTime.length <= 10) {
            
            date = moment(googleDateTime, 'YYYY-MM-DD').format('DD/MM/YYYY');
            time = '00:00';
            
        }else{
            
            date = moment(googleDateTime.substr(0,10), 'YYYY-MM-DD').format('DD/MM/YYYY');
            time = googleDateTime.substr(11,5);
            
        }
        
        return date + ' ' + time;
        
    };
    
    /**
     * Retornar um objecto padrão para o ser inserido
     * ao data source de uma calendário zeehdi(scheduler).
     * 
     * @param {object} event evento referência para criar o 
     * objeto.
     * 
     * @param {object} objeto pardrão para ser inserido
     * no data source do calendário zeedhi.
    */
    this.createZeedhiCalendarDefaultEvent = function(event) {
        
        var isEventDuringTheWholeDay = this.checkEventsDuringTheWholeDay(event);
        
        if(isEventDuringTheWholeDay) {
            event = this.defineEventDuringTheWholeDay(event);
        }
        
        var iniDate = CRM_Utilities.getDateInDateTime(event.iniDateTime);
        var endDate = CRM_Utilities.getDateInDateTime(event.endDateTime);
        var iniTime = CRM_Utilities.getTimeInDateTime(event.iniDateTime);
        var endTime = CRM_Utilities.getTimeInDateTime(event.endDateTime);
        
        var eventTitle = event.summary ? event.summary.toUpperCase() : '(SEM TÍTULO)';
        var eventDuration = iniTime + ' - ' + endTime;
        var eventDescription = event.description ? event.description : "";
        var reference = "[COMPROMISSO REFERENTE A AGENDA DO EMAIL: " + event.creator.email.toUpperCase() + ']';
        
        if(isEventDuringTheWholeDay) {
            endDate = iniDate;
            eventDuration = 'Duranto Todo o Dia';
        }
        
        var googleEvent = {
            DATAINI: iniDate,
            DATAFIN: endDate,
            HRINICONCATFIN: eventDuration,
            HORAINI: iniTime,
            HORAFIN: endTime,
            DTINI: iniDate + ' às ' + iniTime,
            DTFIM: endDate + ' às ' + endTime,
            DTINIPLANOCUPA: event.iniDateTime,
            DTFINPLANOCUPA: event.endDateTime,
            TITULOEVENTOGOOGLE: eventTitle,
            STATUSPLANOCUPA: "Aceito",
            IDATIVO: 'S',
            DSCAMINHOICONE: "https://crm.teknisa.com/assets/images/icons/list.png",
            DSCORCARD: "#6fe88b",
            REFERENCIA:  reference,
            DSPLANOCUPA: reference + ' ' + eventDescription,
            NOEDITABLE: true,
            BECAUSENOEDITABLE: Messages.IMPOSSIVEL_MANUSEAR_EVENTO_GOOGLE,
            GOOGLEEVENT: true,
            __isSelected: false,
            __is_new: false
        };
        return googleEvent;
        
    };
    
    /**
     * Verifica se a variável de início do
     * evento é denominada 'date'.
     * Quando uma variável possui esta denominação,
     * significa que o compromisso dura o dia inteiro.
     * 
     * @param {event} event objecto com as informações do
     * evento.
    */
    this.checkEventsDuringTheWholeDay = function(event) {
        
        if(Boolean(event.start.date)) {
            return true;
        } else {
            return false;
        }
        
    };
    
    /**
     * Seta as configuraçãoes de um evento para ser
     * representado como um evento de um dia interio.
     * 
     * @param {object} event objeto com as informações
     * do evento em cas.
     * 
     * @return {object} evento configurado.
    */
    this.defineEventDuringTheWholeDay = function(event) {
        
        event.endDateTime = event.iniDateTime;
        
        return event;
        
    };
    
    /**
     * Defini a utilização do calendário do
     * google.
    */
    this.defineParamInTemplateManagerConfirmingGoogleCalendar = function() {
        templateManager.SYNCGOOGLECALENDAR = true;
    };
    
    /**
     * Delete o parâmetro no template manager que
     * indica o uso do calendário do google.
    */
    this.deleteGoogleCalendarParamInTemplateManager = function() {
        
        if(Boolean(templateManager.SYNCGOOGLECALENDAR)) {
            delete templateManager.SYNCGOOGLECALENDAR;
        }
        
    };
    
    /**
     * Adiciona um evento a agenda do usuário logado
     * (pela autenticação do Google).
     * 
     * @param {object} event compromisso que será
     * utilizado como referência para a inserção do
     * compromisso na agenda do google.
    */
    this.addEventToLoggedUserGoogleCalendar = function(event) {
        
        ScreenService.confirmMessage(Messages.QUESTAO_INSERIR_COMPROMISSO_GOOGLE, 'question',
        function(success) {
            
            var googleEventObject = this.createGoogleEventObject(event);
            
            API_GoogleCalendar.addGoogleEvent(googleEventObject)
            .then(function(response) {
                ScreenService.showMessage(Messages.COMPROMISSO_INSERIDO_GOOGLE);
            }.bind(this))
            .catch(function() {
                ScreenService.showMessage(Messages.COMPROMISSO_NAO_INSERIDO_GOOGLE);
            });
            
        }.bind(this));
    };
    
    /**
     * Adiciona um evento a agenda do usuário logado
     * (pela autenticação do Google).
     * 
     * @param {object} event compromisso que será
     * utilizado como referência para a inserção do
     * compromisso na agenda do google.
    */
    this.addEventToLoggedUserGoogleCalendarWithoutQuest = function(event) {
            
            var googleEventObject = this.createGoogleEventObject(event);
            
            API_GoogleCalendar.addGoogleEvent(googleEventObject)
            .then(function(response) {
                ScreenService.showMessage(Messages.COMPROMISSO_INSERIDO_GOOGLE);
            }.bind(this))
            .catch(function() {
                ScreenService.showMessage(Messages.COMPROMISSO_NAO_INSERIDO_GOOGLE);
            });
        
    };
    
    /**
     * Cria um objeto padrão Google para ser inserido
     * no Google calendar.
     * 
     * @param {object} event objeto com as informações
     * para criar o objeto padrão Google.
    */
    this.createGoogleEventObject = function(event) {
        
        var googleEventObject = {
            ID: event.NRSEQPLANOCUPA,
            TITLE: '[CRM] - ' + event.NMPRINCIPALPARC,
            INITDATE: CRM_Utilities.getDateInDateTime(event.DTINIPLANOCUPA),
            INITTIME: CRM_Utilities.getTimeInDateTime(event.DTINIPLANOCUPA),
            ENDDATE: CRM_Utilities.getDateInDateTime(event.DTFINPLANOCUPA),
            ENDTIME: CRM_Utilities.getTimeInDateTime(event.DTFINPLANOCUPA),
            DESCRIPTION: event.DSPLANOCUPA
        };
        
        return googleEventObject;
        
    };
    
    /**
     * Função para editar um evendo no google.
     * 
     * @param {object} event object com as informações 
     * base para realizar a edição. 
    */
    this.editGoogleEvent = function(event) {
        
        var googleEventObject = this.createGoogleEventObject(event);
        
        API_GoogleCalendar.editGoogleEvent(googleEventObject).then(function() {
            ScreenService.showMessage(Messages.GOOGLE_EVENTO_EDITADO_SUCESSO);
        });
        
    };
    
    /**
     * Define se o usuário terá a possibilidade
     * de sincronizar o Google Calendar a sua agenda
     * de acordo com a parametrização do CRM.
     * 
     * @param {object} widget widget principal "CALENDARIO".
    */
    this.defineIfUserCanSyncGoogle = function(widget) {
        
        var crmParametrization = CRM_Utilities.getCrmParametrization();
            
        if(crmParametrization.IDPERMITESINCGOOGLE === 'S') {
            this.setGoogleSyncActionVisibility(true);
        }
        
    };
    
    /**
     * Define se a ação "Sincronizar Google" será visível ao
     * usuário.
     * 
     * @param {boolean} isVisible valor lógico para definir
     * visibilidade.
    */
    this.setGoogleSyncActionVisibility = function(isVisible) {
        var actions = templateManager.container.actions;
        var syncActionIndex = CRM_Utilities.getObjectPositionInArrayByName(actions, 'SINC_GOOGLE');
        
        templateManager.container.actions[syncActionIndex].isVisible = isVisible;
    };
    
    /**
     * Define se a ação "Dessincronizar Google" será visível ao
     * usuário.
     * 
     * @param {boolean} isVisible valor lógico para definir
     * visibilidade.
    */
    this.setGoogleDesyncActionVisibility = function(isVisible) {
        var actions = templateManager.container.actions;
        var desyncActionIndex = CRM_Utilities.getObjectPositionInArrayByName(actions, 'DESSINC_GOOGLE');
        
        templateManager.container.actions[desyncActionIndex].isVisible = isVisible;
    };
    
    /**
     * Define as regras da tela de compromisso de acordo 
     * com a revenda do operador logado.
     * 
     * @param {object} widget widget principal da tela de compromisso
     * ('CALENDARIO').
    */
    this.setResaleRules = function(widget) {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        if(loggedOperatorInfos.IDTPOPERADOR === 'R' && Boolean(loggedOperatorInfos.NRREVENDA)) {
            
            var restrictObjects = [];
            
            restrictObjects.push(widget);
            restrictObjects.push(widget.getField("NMOPERADOR"));
            
            var newCommitmentWidget = templateManager.container.getWidget('WDGT_NEW_COMMITMENT');
            restrictObjects.push(newCommitmentWidget.getField("NMOPERADORESPONS"));
            restrictObjects.push(newCommitmentWidget.getField("NMPRINCIPALPARC"));
            
            var commitmentParticipantsWidget = templateManager.container.getWidget('WDGT_COMMITMENT_PARTICIPANTS');
            restrictObjects.push(commitmentParticipantsWidget.getField("CDOPERADORPART"));
            
            CRM_Utilities.setResaleRulesInRestrictObjectsByLoggedOperatorResale(restrictObjects);
            
        }
    };
    
    this.changeOperatorFilter = function(args) {
        
        var widget = args.owner;
        var cdoperador = widget.__filterPopup.currentRow.CDOPERADOR;
        var filtros = widget.dataSourceFilter;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        var allOperators = true;
        
        //2 = Quantidade padrão de filtros, ou seja, se algo foi filtrado
        if(filtros.length !== 3) {
            filtros.forEach(function(filtro) {
                //Se filtrou operador
                if(filtro.name === "CDOPERADOR") {
                    allOperators = false;
                }
            });
        }else{
            //Se nada foi filtrado operador logado é o padrão
            var defaultOperator = {};
            defaultOperator.name = "CDOPERADOR";
            defaultOperator.operator = "IN";
            defaultOperator.value = [loggedOperatorInfos.CDOPERADOR];
            defaultOperator.static = true;
            filtros.push(defaultOperator);
            allOperators = false;
        }
        //Se algo foi filtrado e operador não foi setado, todos é o padrão
        if(allOperators) {
            allOperators = {};
            allOperators.name = "CDOPERADOR";
            allOperators.operator = "IS_NOT_NULL";
            allOperators.static = true;
            filtros.push(allOperators);    
        }
        
    };
    
    /**
     * Define o filtro dos campos de parceiro de negócio
     * do container.
     * 
     * @param {widget} widget widget principal da tela 
     * de compromissos.
    */
    this.setNegotiationPartnerFieldFilter = function(widget) {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        var newCommitmentWidget = templateManager.container.getWidget('WDGT_NEW_COMMITMENT');
        
        var fields = [];
        fields.push(widget.getField('NMPRINCIPALPARC'));
        fields.push(newCommitmentWidget.getField('NMPRINCIPALPARC'));
        
        var fieldFilter;
        var nrorgFilterIndex;
        var nrparcnegocioFilterIndex;
        
        fields.forEach(function(field) {
            
            fieldFilter = field.dataSourceFilter;
            nrorgFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(fieldFilter, "P_NRORG");
            nrparcnegocioFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(fieldFilter, "P_NRPARCNEGOCIO");
            
            fieldFilter[nrorgFilterIndex].value = loggedOperatorInfos.NRORG;
            fieldFilter[nrparcnegocioFilterIndex].value = loggedOperatorInfos.NRPARCNEGOCIO;    
            
        });
        
    };
    
    /**
     * Abri o swipe para adicionar um novo participante
     * ao compromisso.
     * 
     * @param {object} widget widge de participantes
     * ("WDGT_COMMITMENT_PARTICIPANTS").
    */
    this.addCommitmentParticipant = function(widget) {
        
        var eventCurrentRow = templateManager.container.getWidget('WDGT_NEW_COMMITMENT').currentRow;
        
        if(!Boolean(eventCurrentRow.NOEDITABLE)) {
            General.widgetNewRow(widget);
        } else {
            ScreenService.showMessage(Messages.IMPOSSIVEL_MANUSEAR_EVENTO(eventCurrentRow.BECAUSENOEDITABLE));
        }
        
    };
    
    /**
     * Delete um participante de um compromisso.
     * 
     * @param {object} widget widge de participantes
     * ("WDGT_COMMITMENT_PARTICIPANTS").
    */
    this.deleteCommitmentParticipant = function(widget) {
        
        var eventCurrentRow = templateManager.container.getWidget('WDGT_NEW_COMMITMENT').currentRow;
        
        if(!Boolean(eventCurrentRow.NOEDITABLE)) {
            General.deleteCrud(widget);
        } else {
            ScreenService.showMessage(Messages.IMPOSSIVEL_MANUSEAR_EVENTO(eventCurrentRow.BECAUSENOEDITABLE));
        }
        
    };
    
    /**
     * Abre a tab de evolução como swipe de form
    */
    this.openTabEvolucao = function(widget) {
        var widgetEvolucao = templateManager.container.getWidget('WDGT_EVOLUCAO');        
        var widgetCompromisso = templateManager.container.getWidget('WDGT_NEW_COMMITMENT');
        if(Util.isEmptyOrBlank(widgetCompromisso.currentRow.DTREALFECHA)) {
            this.setCurrentRow(widgetEvolucao);
            ScreenService.openSwipe(widgetEvolucao.parent).then(function() {
                widgetEvolucao.template = "widget/form.html";
                widgetEvolucao.mode = "edit";
                widgetEvolucao.edit();
                widgetEvolucao.formTemplate = "widget/form.html";
                //Garantindo que os métodos do general irão funcionar
                widgetEvolucao.backupRow = angular.copy(widgetEvolucao.currentRow);
                ScreenService.closePopup(true);
                widgetEvolucao.activate();
                evolutionTabController.overwriteAction('BACK_EDIT', "crm30000000_Compromisso_Controller.cancelEvol(args.owner.widget)");
                var methods = [
                    "ScreenService.closeSwipe(true)",
                    "templateManager.container.getWidget('WDGT_NEW_COMMITMENT').activate()"
                ];
                evolutionTabController.setMethodsAfterSave(methods);
                if(widgetCompromisso.currentRow.TIPO === 'OPORTUNIDADE') {
                    this.createOportFields();
                    evolutionTabController.overwriteAction('SAVE', "crm00002001_OportunidadeNegocio_Controller.confirmClosingOpportunityBeforeSaveEvolution(args.owner.widget)");
                    widgetEvolucao.dataSource.name = "product#/evolcont_crm_oportuni";
                    evolutionTabController.showFieldGroup(true);
                }else{
                    evolutionTabController.hideFieldGroup(true);
                    evolutionTabController.defaultAction('SAVE');
                    widgetEvolucao.dataSource.name = "/evolcont_contato";
                }
            }.bind(this));
        }else{
            ScreenService.showMessage(Messages.IMPOSSIVEL_MANUSEAR_EVENTO(Messages.OPORTUNIDADE_FECHADA));    
        }
    };
    
    /**
     * Metodo para sobreescrever a action de cancel da tab
     * dinânica, adaptando para form.
    */
    this.cancelEvol = function(widget) {
        var widgetCompromisso = templateManager.container.getWidget('WDGT_NEW_COMMITMENT');
        General.widgetCancelForm(widget);
        ScreenService.closeSwipe();
        widgetCompromisso.activate();
    };
    
    /**
     * Seta os valores default da tab de evolução
    */
    this.setCurrentRow = function(widget) {
        //Limpa a currentRow
        Object.keys(widget.currentRow).forEach(function(key) {
           widget.currentRow[key] = ''; 
        });
        
        var widgetCompromisso = templateManager.container.getWidget('WDGT_NEW_COMMITMENT');
        if(Util.isEmptyOrBlank(widgetCompromisso.currentRow.NRSEQCONTATO)) {
            var params = {
                'requestType':'Row',
                'row': {"NRPARCNEGOCIO": widgetCompromisso.currentRow.NRPARCNEGOCIO, "NRORG": widgetCompromisso.currentRow.NRORG}
            };
            restEngine.post('/selectProspectNrContato', params,
                function(success) {
                    widget.currentRow.NRSEQCONTATO = success.dataset.DADOS.NRSEQCONTATO;
                    widget.currentRow.NRCONTATO = success.dataset.DADOS.NRSEQCONTATO;
                });
        }else{
            widget.currentRow.NRSEQCONTATO = widgetCompromisso.currentRow.NRSEQCONTATO;
            widget.currentRow.NRCONTATO = widgetCompromisso.currentRow.NRSEQCONTATO;
        }
        widget.currentRow.DTHREVOLCONT = CRM_Utilities.getDataHoraAtual();
        widget.currentRow.IDSENEVOCONT = 'S';
        widget.currentRow.CDOPEREVOL = templateManager.LOGGEDOPERATOR.CDOPERADOR;
        widget.currentRow.NMOPERADOR = templateManager.LOGGEDOPERATOR.NMOPERADOR;
        widget.currentRow.DSFILACONTATO = 'Retornar contato';
        widget.currentRow.NMOPERADORREAL = templateManager.LOGGEDOPERATOR.NMOPERADOR;
        widget.currentRow.CDOPERREAL = templateManager.LOGGEDOPERATOR.CDOPERADOR;
        widget.currentRow.NRPARCNEGOCIO = widgetCompromisso.currentRow.NRPARCNEGOCIO;
        widget.currentRow.NRORG = widgetCompromisso.currentRow.NRORG;
        widget.NRSEQOPORT = widgetCompromisso.currentRow.NRSEQOPORT;
        widget.currentRow.NRSEQOPORT = widgetCompromisso.currentRow.NRSEQOPORT;
        widget.parent.parent.currentRow.NRSEQOPORT = widgetCompromisso.currentRow.NRSEQOPORT;
        widget.parent.parent.currentRow.NRPARCNEGOCIO = widgetCompromisso.currentRow.NRPARCNEGOCIO;
        widget.currentRow.__is_new = true;
    };
    
    
    /**
     * Muda a Action de acordo com o tipo do compromisso
    */
    this.changeActionLabel = function(widget) {
        var actionEvolucao = widget.getAction('EVOLUIR');
        var currentRow = widget.currentRow;
        
        if(Util.isEmptyOrBlank(currentRow.TIPO)) {
            actionEvolucao.isVisible = false;
        }else if(!Util.isEmptyOrBlank(currentRow.NRSEQOPORT)) {
            actionEvolucao.label = 'Evoluir Oportunidade';
            actionEvolucao.isVisible = true;
        } else {
            actionEvolucao.label = 'Evoluir Parceiro';
            actionEvolucao.isVisible = true;
        }
        
    };
    /**
     * Cria o json dos fields de oportunidade e builda na tab de evolução
    */
    this.createOportFields = function() {
        //dados oport
        var fieldsDadosOportunidade = [
            {
                "name": "NMSEQFASENEGO",
                "label": "Fase de Negociação",
                "fieldGroup": "FG_DADOS_OPORTUNIDADE",
                "template": "field/select.html",
                "isVisible": true,
                "showOnList": false,
                "showOnView": true,
                "showOnForm": true,
                "class": "6",
                "dataSource": {
                    "name": "product#/crm_fasenegoci_operador",
                    "rest": true,
                    "lazyLoad": true
                },
                "itemsPerPage": 50,
                "valueField": "NRSEQFASENEGO",
                "descriptionField": "NMSEQFASENEGO",
                "outData": {
                    "NRSEQFASENEGO": "NRSEQFASENEGO",
                    "NMSEQFASENEGO": "NMSEQFASENEGO",
                    "IDPERMITEFECHA": "IDPERMITEFECHA",
                    "IDEXIGEVROPORT": "IDEXIGEVROPORT"
                },
                "validations": {
                    "required": true
                },
                "showSelectAs": "grid",
                "fields": [
                    {
                        
                        "name": "NMSEQFASENEGO",
                        "label": "Fase de Negociação",
                        "showOnList": true,
                        "isVisible": true,
                        "template": "field/text-edit.html"
                    }
                ],
                "events": [
                    {
                        
                        "name": "FieldOnChange",
                        "code": "crm00002001_OportunidadeNegocio_Controller.setClosingDataGroupLockByNegotiationPhase(args.owner.field.widget); crm00002001_OportunidadeNegocio_Controller.setOpportunityValueObligatorinessByNegotiationPhase(args.owner.field.widget);"
                    }
                ]
            },
            {
                
                "name": "VRPREVOPORT",
                "label": "Valor Previsto da Oportunidade",
                "template": "field/text-edit.html",
                "class": "6",
                "isVisible": true,
                "showOnList": false,
                "showOnView": true,
                "showOnForm": true,
                "fieldGroup": "FG_DADOS_OPORTUNIDADE",
                "validation": {},
                "mask": {
                    "type": "currency",
                    "params": {
                        "decimal": ",",
                        "thousands": "."
                    }
                },
                "defaultValue": "@General.getFieldValue('VRPREVOPORT', 'oportunidadegrid')@",
                "events": [],
                "filterProperties": {
                    "isVisible": false,
                    "showOnForm": false,
                    "showOnList": false
                }
            },
            {
                
                "name": "NMPARCRESP",
                "label": "Novo Operador Responsável",
                "fieldGroup": "FG_DADOS_OPORTUNIDADE",
                "template": "field/select.html",
                "isVisible": true,
                "showOnList": false,
                "showOnView": true,
                "showOnForm": true,
                "class": "12",
                "dataSource": {
                    "name": "product#/crud/operador_crm_operrevenda",
                    "rest": true,
                    "lazyLoad": true
                },
                "itemsPerPage": 50,
                "dataSourceFilter": [
                    {
                        "name": "IDTPOPERADOR",
                        "operator": "=",
                        "value": "E"
                    }
                ],
                "showSelectAs": "grid",
                "fields": [
                    {
                        
                        "name": "NMOPERADOR",
                        "label": "Nome",
                        "showOnList": true
                    }
                ],
                "valueField": "NRPARCRESP",
                "descriptionField": "NMPARCRESP",
                "outData": {
                    "NRPARCNEGOCIO": "NRPARCRESP",
                    "NMOPERADOR": "NMPARCRESP",
                    "CDOPERADOR": "CDOPERADOR"
                },
                "validations": {},
                "filterProperties": {}
            }
        ];
        evolutionTabController.buildDynamicFieldGroup(fieldsDadosOportunidade, "FG_DADOS_OPORTUNIDADE", "Dados da Oportunidade");
        
        //fechamentoOport
        var fieldsFechaOportunidade = [
            {
                "name": "DTREALFECHA",
                "label": "Data de Fechamento",
                "template": "field/datetime.html",
                "isVisible": true,
                "showOnView": true,
                "showOnForm": true,
                "readOnly": true,
                "fieldGroup": "FG_DADOS_FECHAMENTO",
                "class": "4",
                "validations": {},
                "events": []
            },
            {
                "name": "DESCRESULEVOL",
                "label": "Resultado",
                "template": "field/select.html",
                "showSelectAs": "grid",
                "isVisible": true,
                "showOnForm": true,
                "class": "4",
                "fieldGroup": "FG_DADOS_FECHAMENTO",
                "valueField": "NRSEQRESULEVOL",
                "descriptionField": "DESCRESULEVOL",
                "validations": {},
                "dataSource": {
                    "name": "product#/crm_resultevol_crm_perfiresult_crm_perfioper",
                    "rest": true,
                    "lazyLoad": true
                },
                "itemsPerPage": 50,
                "dataSourceFilter": [
                    {
                        "name": "P_NRORG",
                        "operator": "=",
                        "value": ""
                    },
                    {
                        "name": "P_CDOPERADOR",
                        "operator": "=",
                        "value": ""
                    },
                    {
                        "name": "IDRESULTOPORTUNI",
                        "operator": "=",
                        "value": "SIM"
                    }
                ],
                "fields": [
                    {
                        "name": "DESCRESULEVOL",
                        "label": "Resultado",
                        "showOnList": true,
                        "isVisible": true,
                        "template": "field/text-edit.html"
                    }
                ],
                "outData": {
                    "NRSEQRESULEVOL": "NRSEQRESULEVOLOPORT",
                    "DESCRESULEVOL": "DESCRESULEVOL"
                },
                "events": [
                    {
                        "name":"FieldAfterSelectOpen",
                        "code":"crm00002001_OportunidadeNegocio_Controller.setResultFieldFilter(args.owner.field);args.owner.field.reload()"
                    }
                ]
            },
            {
                "name": "VROPORT",
                "label": "Valor da Oportunidade",
                "template": "field/text-edit.html",
                "class": "4",
                "isVisible": true,
                "showOnList": false,
                "showOnView": true,
                "showOnForm": true,
                "fieldGroup": "FG_DADOS_FECHAMENTO",
                "validation": {},
                "mask": {
                    "type": "currency",
                    "params": {
                        "decimal": ",",
                        "thousands": "."
                    }
                },
                "events": [],
                "filterProperties": {
                    "isVisible": false,
                    "showOnForm": false,
                    "showOnList": false
                }
            },
            {
                "name": "NMRAZSOCCONC",
                "label": "Concorrente Vencedor da Negociação",
                "template": "field/select.html",
                "isVisible": true,
                "showOnView": true,
                "showOnForm": true,
                "class": "12",
                "fieldGroup": "FG_DADOS_FECHAMENTO",
                "dataSource": {
                    "name": "product#/crm_concorrente",
                    "rest": true,
                    "lazyLoad": true
                },
                "itemsPerPage": 50,
                "dataSourceFilter": [],
                "showSelectAs": "grid",
                "fields": [
                    {
                        "name": "NMRAZSOCCONC",
                        "label": "Razão Social",
                        "showOnList": true
                    },
                    {
                        "name": "NMFANTCONN",
                        "label": "Nome Fantasia",
                        "showOnList": true
                    }
                ],
                "valueField": "NRCONCORRENTE",
                "descriptionField": "NMRAZSOCCONC",
                "outData": {
                    "NRCONCORRENTE": "NRCONCORRENTE",
                    "NMRAZSOCCONC": "NMRAZSOCCONC"
                }
            }
        ];
        evolutionTabController.buildDynamicFieldGroup(fieldsFechaOportunidade, "FG_DADOS_FECHAMENTO", "Dados do Fechamento");
    };
    
    this.findCalendarWidgetThroughList = function(listWidget) {
        var calendarWidget = listWidget.getParent().widgets.find(function(x) {
            return x.name == 'CALENDARIO';
        });
        return calendarWidget;
    };
    
    this.listOnEnter = function(widget) {
        widget.reload();  
    };
    
    this.askToNotifyInterloc = function() {
        var zhPromise = ZHPromise.defer();
        var message = 'Deseja selecionar um interlocutor para ser notificado?';
        
        ScreenService.confirmMessage(message, 'question', zhPromise.resolve);
        
        return zhPromise;
    };
    
    this.openSwipeNotifyInterloc = function(newCommitWidget) {
        var notifyWidget = templateManager.container.getWidget('WDGT_NOTIFY_INTERLOC');
    
        return ScreenService.openSwipe(notifyWidget).then(function() {
            notifyWidget.activate();
            notifyWidget.edit();
        });
    };
    
    this.closeInterlocNotify = function() {
        var widget = templateManager.container.getActiveWidget();
        ScreenService.closeSwipe();
        widget.parent.widgets[0].widgets[0].activate()
    };
    
    this.notifyInterloc = function() {
        var widget = templateManager.container.getActiveWidget();
        var widgetPai = templateManager.container.getWidget('WDGT_NEW_COMMITMENT');
        
        if(widget.isValid()) {
            var currentRow = widget.currentRow;
            
            var commitmentInterlocs = currentRow.NRSEQINTERLOCUTOR;
            var rows = [];
            
            commitmentInterlocs.forEach(function(operator, interlocIndex) {
                
                rows.push(this.setCommitmentInterlocValues(widget, interlocIndex));
                    
            }.bind(this));
        
            General.callRestEngine("product#/notifyInterloc", 'DataSet', rows).then(function(data) {
                if(!Util.isUndefined(data.messages) && data.messages[0].type === "success") {
                    ScreenService.showMessage(data.messages[0].message);
                    ScreenService.closeSwipe();
                    widgetPai.activate();
                } else{
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }.bind(this));
            
        }
    };
    
    /**
     * Cria uma cópia da currentRow da widget
     * recebida, define os valores do participante
     * na cópia e a retorna.
     * 
     * @param {object} widget - widget ativa onde está
     * sendo realizado o cadastro do participante.
     * 
     * @param {int} interloctIndex - index do participante
     * nos arrays relacionados ao participantes selecionados
     * na field.
     * 
     * @return {obeject} currentRow cópia da currentRow 
     * da widget recebida como parâmetro, com os valores
     * do participante em caso.
    */
    this.setCommitmentInterlocValues = function(widget, interlocIndex) {
        
        var currentRow = angular.copy(widget.currentRow);
        var commitmentWidgetCurrentRow = this.getCommitmentWidgetCurrentRow();
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.NRPARCNEGOCIO = currentRow.NRPARCNEGOCIO[interlocIndex];  
        currentRow.NRSEQPLANOCUPA = commitmentWidgetCurrentRow.NRSEQPLANOCUPA;
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        currentRow.CDOPERADOR = currentRow.CDOPERADOR[interlocIndex];
        currentRow.NMINTERLOCUTOR = currentRow.NMINTERLOCUTOR[interlocIndex];
        currentRow.DATACOMPROMISSO = commitmentWidgetCurrentRow.DTINIPLANOCUPA;
        currentRow.DATAFINAL = commitmentWidgetCurrentRow.DTFINPLANOCUPA;
        currentRow.REFERENCIA = commitmentWidgetCurrentRow.DSREF ? commitmentWidgetCurrentRow.DSREF : "";
        currentRow.MOTIVO = commitmentWidgetCurrentRow.NMMOTIEVOCON;
        currentRow.PARCEIRO = commitmentWidgetCurrentRow.NMPRINCIPALPARC;
        currentRow.OPERADOR = loggedOperatorInfos.NMOPERADOR;
        currentRow.EMAILINTERLOC = currentRow.EMAILINTERLOC[interlocIndex];
        currentRow.NRSEQINTERLOCUTOR = currentRow.NRSEQINTERLOCUTOR[interlocIndex];
        currentRow.TIPO = commitmentWidgetCurrentRow.TIPO;
        
        
        return currentRow;
    };
    
    /**
     * Função para receber a currentRow no compromisso
     * em caso.
     * 
     * @return {object} currentRow currentRow da widget
     * do compromisso em caso.
    */
    this.getCommitmentWidgetCurrentRow = function() {
        
        var commitmentWidget = templateManager.container.getWidget("WDGT_NEW_COMMITMENT");
        
        return commitmentWidget.currentRow;
        
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm30000000_Compromisso_Controller', crm30000000_Compromisso_Controller);
});

// FILE: ./assets/js/controllers/crm30000000_Participantes_Compromisso_Controller.js
function crm30000000_Participantes_Compromisso_Controller(CRM_Utilities, templateManager, General, ScreenService, restEngine, Messages)
{
    
    /**
     * Filtra os resultados da widget de participantes
     * de acordo com o número de identificação do compromisso
     * marcado, e em seguida da um reload na widget.
    */
    this.insertParticipantsWidgetFilter = function(){
        
        var participantsWidget = templateManager.container.getWidget("WDGT_COMMITMENT_PARTICIPANTS");
        
        var widgetFilter = participantsWidget.dataSourceFilter;
        var calendarWidget = participantsWidget.parent.parent;
        var eventWidgetCurrentRow = calendarWidget.getEventsWidget().currentRow;
        
        var nrseqplanocupaIndex = CRM_Utilities.getFilterPosition(widgetFilter, "NRSEQPLANOCUPA");
        
        widgetFilter[nrseqplanocupaIndex].value = eventWidgetCurrentRow.NRSEQPLANOCUPA;
        
        participantsWidget.reload();
        
    };
    
    /**
     * Esconde o nome do operador responsável pelo
     * compromisso, para que ela não possa ser selecionado
     * como participante.
     * 
     * @param {object} field field de operador que receberá
     * o filtro.
    */
    this.hideResponsibleOperatorByFilter = function(field){
        
        var fieldFilter = field.dataSourceFilter;
        var commitmentWidgetCurrentRow = this.getCommitmentWidgetCurrentRow();
        
        var cdoperatorIndex = CRM_Utilities.getFilterPosition(fieldFilter, "CDOPERADOR");
        
        fieldFilter[cdoperatorIndex].value = commitmentWidgetCurrentRow.CDOPERADOR;
        
        field.reload();
        
    };
    
    /**
     * Filtra os resultados da fiels de participantes
     * para não trazer os participantes já cadastrados
     * no compromisso em caso.
     * 
     * @param {object} field field de participantes
     * que recebera o filtro.
    */
    this.setParticipantsFilter = function(field){
        
        var fieldFilter = field.dataSourceFilter;
        var commitmentWidgetCurrentRow = this.getCommitmentWidgetCurrentRow();
        
        var nrseqplanocupaIndex = CRM_Utilities.getFilterPosition(fieldFilter, "P_NRSEQPLANOCUPA");
        var nrparcnegocioFilterInddex = CRM_Utilities.getFilterPosition(fieldFilter, "P_NRPARCNEGOCIO");
        
        fieldFilter[nrseqplanocupaIndex].value = commitmentWidgetCurrentRow.NRSEQPLANOCUPA;
        fieldFilter[nrparcnegocioFilterInddex].value = commitmentWidgetCurrentRow.NRPARCNEGOCIO;
        
        field.reload();
        
    };

    /**
     * Salva participantes ao compromisso em caso.
     * 
     * @param {object} widget widget ativa onde está
     * sendo realizado o cadastro do participante do
     * compromisso.
    */
    this.saveCommitmentParticipants = function(widget){
        
        var currentRow = widget.currentRow;
        
        var commitmentParticipants = currentRow.CDOPERADORPART;
        var rows = [];
        
        commitmentParticipants.forEach(function(operator, participantIndex){
            
            rows.push(this.setCommitmentParticipantsValues(widget, participantIndex));
                
        }.bind(this)); 
        
        General.callRestEngine("product#/partplanocupa_operador/save", "DataSet", rows).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
                ScreenService.alertNotification('Nenhum participante adicionado foi notificado por falta dos dados na parametrização.', 5000);
            }
            ScreenService.closeSwipe();
            widget.reload();
            widget.list();
            
        });

    };
    
    /**
     * Cria uma cópia da currentRow da widget
     * recebida, define os valores do participante
     * na cópia e à retorna.
     * 
     * @param {object} widget widget ativa onde está
     * sendo realizado o cadastro do participante.
     * 
     * @param {int} participantIndex index do participante
     * nos arrays relacionados ao participantes selecionados
     * na field.
     * 
     * @return {obeject} currentRow cópia da currentRow 
     * da widget recebida como parâmetro, com os valores
     * do participante em caso.
    */
    this.setCommitmentParticipantsValues = function(widget, participantIndex){
        
        var currentRow = angular.copy(widget.currentRow);
        var commitmentWidgetCurrentRow = this.getCommitmentWidgetCurrentRow();
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        if(currentRow.TIPO[participantIndex] === 'INTERLOCUTOR'){
            currentRow.NRPARCNEGOCIO = currentRow.CDOPERADORPART[participantIndex];  
            currentRow.CDOPERADOR = currentRow.CDOPERADORPART[participantIndex];  
        }else{
            currentRow.NRPARCNEGOCIO = currentRow.NRPARCNEGOCIO[participantIndex];  
            currentRow.CDOPERADOR = currentRow.CDOPERADORPART[participantIndex];
        }   
        
        currentRow.NRSEQPLANOCUPA = commitmentWidgetCurrentRow.NRSEQPLANOCUPA;
        currentRow.NRORG = currentRow.NRORGOPERADORPART[participantIndex];
        currentRow.DATACOMPROMISSO = commitmentWidgetCurrentRow.DTINIPLANOCUPA;
        currentRow.DATAFINAL = commitmentWidgetCurrentRow.DTFINPLANOCUPA;
        currentRow.REFERENCIA = commitmentWidgetCurrentRow.DSREF ? commitmentWidgetCurrentRow.DSREF : "";
        currentRow.MOTIVO = commitmentWidgetCurrentRow.NMMOTIEVOCON;
        currentRow.PARCEIRO = commitmentWidgetCurrentRow.NMPRINCIPALPARC;
        currentRow.OPERADOR = loggedOperatorInfos.NMOPERADOR;
        currentRow.PARTICIPANTE = currentRow.NMOPERADORPART[participantIndex];
        currentRow.DESCRICAO = commitmentWidgetCurrentRow.DSPLANOCUPA;
        currentRow.TIPOCOMPROMISSO = commitmentWidgetCurrentRow.TIPO;
        currentRow.CDINTEPLANOCUPA = "";
        
        return currentRow;
    };
    
    /**
     * Função para receber a currentRow no compromisso
     * em caso.
     * 
     * @return {object} currentRow currentRow da widget
     * do compromisso em caso.
    */
    this.getCommitmentWidgetCurrentRow = function(){
        
        var commitmentWidget = templateManager.container.getWidget("WDGT_NEW_COMMITMENT");
        
        return commitmentWidget.currentRow;
        
    };
    
    this.openPopupMensagem = function(args){
        
        var eventCurrentRow = templateManager.container.getWidget('WDGT_NEW_COMMITMENT').currentRow;

        if(!Boolean(eventCurrentRow.NOEDITABLE)){
            
            var widget = templateManager.container.getWidget('mensagens');
            widget.isVisible = true;
            ScreenService.openPopup(widget);
            
        } else {
            ScreenService.showMessage(Messages.IMPOSSIVEL_MANUSEAR_EVENTO(eventCurrentRow.BECAUSENOEDITABLE));
        }
    };
    
    this.notificarParticipantes = function(args){
        var popUp  = args.owner.widget;
        var widget = templateManager.container.getWidget("WDGT_COMMITMENT_PARTICIPANTS");
        
        if (popUp.isValid()) {
            widget.currentRow.__report_name = 'notificacao_compromisso';
            widget.currentRow.NRORGTRAB      = getLocalVar("CRM_NRORGTRAB");
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("CRM_CDOPERADOR");
            widget.currentRow.NRSEQPLANOCUPA = widget.dataSourceFilter[0].value;
            
            var row = this.pegaParticipantesSalvos(widget);
            var saveData = Object.assign({}, row, {"MENSAGEM": popUp.currentRow});
             restEngine.post('/notificarCompromisso',{'requestType': 'Row','row': saveData})
             .then(function(data) {
                 if(data.dataset && data.dataset.error) {
                    ScreenService.showMessage(data.dataset.error, 'ERROR');
                    ScreenService.alertNotification('Nenhum participante foi notificado por falta dos dados na parametrização.', 5000);
                    ScreenService.closePopup(popUp);
                    widget.reload();
                } else {
                    var message = data.messages[(data.messages.length - 1)];
                    if(!Util.isEmptyOrBlank(data.messages)){
                        if (message.type === "M") {
                            ScreenService.showMessage('Participantes Notificados');
                            ScreenService.successNotification(message.message, 100000);
                            ScreenService.closePopup(popUp);
                            widget.reload();
                        } else {
                            ScreenService.showMessage('Nenhum participante cadastrado');    
                            ScreenService.closePopup(popUp);
                        }
                    } else {
                        ScreenService.showMessage('Falha ao notificar Participantes');
                    } 
                }
                }).catch(function(e) {
                    ScreenService.closePopup(popUp);
                    ScreenService.showMessage(e);
            });
        }
    };
    
    this.setTemplateInicial = function(args){
        var widget           = templateManager.container.getWidget("mensagens");
        var widgetCommitment = templateManager.container.getWidget("WDGT_NEW_COMMITMENT");
        var dataCompromisso  = widgetCommitment.currentRow.DTINIPLANOCUPA;
        widget.currentRow.DSMENSAGEM      = '<table border="0" width="100%" cellpadding="0" cellspacing="0" bgcolor="eeeeee" style="background-color: #eeeeee;"> <tbody> <tr> <td> <table border="0" align="center" width="590" cellpadding="0" cellspacing="0" bgcolor="0274BA" class="container590" style="background-color: #0274ba; text-align: center;"> <tbody> <tr> <td> <table border="0" align="center" width="540" cellpadding="0" cellspacing="0" class="container580"> <tbody> <tr> <td align="center" valign="middle"> <table border="0" align="middle" cellpadding="0" cellspacing="0" style="border-collapse:collapse; mso-table-lspace:0pt; mso-table-rspace:0pt;" class=""> <tbody> <tr> <td align="center" valign="middle"> <p style="color: #ffffff; font-size: 25px; padding:20px; font-family: " Questrial ", Helvetica, sans-serif; line-height: 25px; padding-top:45px;">ALERTA DE COMPROMISSO</p> <p style="color: #ffffff; font-size: 16px; font-family: "Questrial", Helvetica, sans-serif; line-height: 15px; padding-top:15px;"> [DATA] </p> <p style="color: #ffffff; font-size: 16px; font-family: "Questrial", Helvetica, sans-serif; line-height: 15px; padding-top:15px;">&nbsp;</p> <p style="color: #ffffff; font-size: 16px; font-family: " Questrial ", Helvetica, sans-serif; line-height: 15px; padding-top:15px;"> <br> </p> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> <table border="0" width="100%" cellpadding="0" cellspacing="0" bgcolor="eeeeee"> <tbody> <tr> <td align="center"> <table border="0" align="center" width="590" cellpadding="0" cellspacing="0" bgcolor="ffffff" class="container590 bg_color"> <tbody> <tr> <td> <table border="0" align="center" width="540" cellpadding="0" cellspacing="0" class="container580"> <tbody> <tr> <td align="left" style="color: #39434b; font-size: 20px; font-family: " Montserrat ", Helvetica, sans-serif; font-weight: 400; padding-bottom:15px; padding-top:20px; line-height: 35px;" class="title_color"> <div style="padding:20px; line-height: 22px"> Prezado(a) [PARTICIPANTE]</div> </td> </tr> <tr> <td align="left" class="title_color" style="color: #848999; font-size: 14px; font-family: " Questrial ", sans-serif; mso-line-height-rule: exactly; line-height: 24px; padding-bottom:15px;"> <div style="line-height: 24px;"> <p>Você está recebendo este email para alertá-lo sobre seu Compromisso no dia [DATA].</p> <br> </div> </td> </tr> <tr> <td height="10" style="font-size: 10px; line-height: 10px;">&nbsp;</td> </tr> </tbody> </table> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> ';
        widget.currentRow.DATACOMPROMISSO = dataCompromisso.replace(' ', ' as ');
        widget.reload();
    };
    
    //foi criada essa função pois na current row não vão todos os participantes
    this.pegaParticipantesSalvos = function(widget) {
        var row = [];
        
        if(Util.isEmptyOrBlank(widget.dataSource.data)) {
            row.NRSEQPLANOCUPA = templateManager.container.getWidget('WDGT_NEW_COMMITMENT').currentRow.NRSEQPLANOCUPA;
        }else {
            widget.dataSource.data.forEach(function(registro) {
                row.CDOPERADOR = []; row.CDOPERADORPART = []; row.DSEMAILOPER = []; row.NMOPERADOR = []; row.NRORG = [];
                row.NRPARCNEGOCIO = []; row.NRSEQPLANOCUPA = []; row.TIPO = [];
                
                row.CDOPERADOR.push(registro.CDOPERADOR);
                row.CDOPERADORPART.push(registro.CDOPERADORPART);
                row.DSEMAILOPER.push(registro.DSEMAILOPER);
                row.NMOPERADOR.push(registro.NMOPERADOR);
                row.NRORG.push(registro.NRORG);
                row.NRPARCNEGOCIO.push(registro.NRPARCNEGOCIO);
                row.NRSEQPLANOCUPA.push(registro.NRSEQPLANOCUPA);
                row.TIPO.push(registro.TIPO);
            });
        }
        
        return row;
    };
    
    this.interlocOnChange = function() {
        var widget = templateManager.container.getActiveWidget();
        var field = widget.getField('CDOPERADOR');
        var keys = field.value();
        var rows = field.selectWidget.getCheckedRows();
        field.widget.currentRow.NMOPERADORPART = [];
        field.widget.currentRow.NRORGOPERADORPART = [];
        field.widget.currentRow.NRPARCNEGOCIO = [];
        field.widget.currentRow.DSEMAILOPER = [];
        field.widget.currentRow.TIPO = [];
        
        rows.forEach(function(row) {
    		keys.forEach(function(key) {
    			if (row.CDOPERADOR == key) {
                    field.widget.currentRow.NMOPERADORPART.push(row.NMOPERADOR);
                    field.widget.currentRow.NRORGOPERADORPART.push(row.NRORG);
                    field.widget.currentRow.NRPARCNEGOCIO.push(row.NRPARCNEGOCIO);
                    field.widget.currentRow.DSEMAILOPER.push(row.DSEMAILOPER);
                    field.widget.currentRow.TIPO.push(row.TIPO);
    			}
    		});
    	});
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm30000000_Participantes_Compromisso_Controller', crm30000000_Participantes_Compromisso_Controller);
});

// FILE: ./assets/js/controllers/crm33000000_Assistente_De_AgendamentoController.js
function crm33000000_Assistente_De_AgendamentoController(CRM_Utilities, ScreenService, templateManager, Messages, General, ZhFilterPreferences) {


    /**
     * Função para cancelar o gerenciamento do assistente;
     * 
     * @param {object} widget widget de gerenciamento
     * do assistente.
    */
    this.cancelScheduling = function (widget) {

        var parentWidget = widget.parent.parent;

        ScreenService.closeSwipe();
        parentWidget.activate();

    };
    /**
     * Função para verificar se o país
     * foi alterado no formulário, se ele foi alterado,
     * a função limpa todos os campos inferiores na 
     * hierarquia de localidade.
     * 
     * @param {object} currentRow currentRow onde está os
     * dados do formulário em caso.
    */
    var selectedCountry;
    this.checkIfTheCountryIsChanged = function (currentRow) {

        var currentCountrys = currentRow.CDPAIS;

        if (typeof selectedCountry === "undefined") {
            selectedCountry = currentCountrys;
        } else if (selectedCountry !== currentCountrys) {

            currentRow.NMESTADO = "";
            currentRow.SGESTADO = "";
            currentRow.NMMUNICIPIO = "";
            currentRow.CDMUNICIPIO = "";
            currentRow.NMBAIRRO = "";
            currentRow.NMBAIRROCAN = "";
            currentRow.CDBAIRRO = "";

            selectedCountry = currentCountrys;
        }
    };

    /**
     * Função para verificar se o estado
     * foi alterado no formulário, se ele foi alterado,
     * a função limpa todos os campos inferiores na 
     * hierarquia de localidade.
     * 
     * @param {object} currentRow currentRow onde está os
     * dados do formulário em caso.
    */
    var selectedState;
    this.checkIfTheStateIsChanged = function (currentRow) {
        var currentState = currentRow.SGESTADO;

        if (typeof selectedState === "undefined") {
            selectedState = currentState;
        } else if (selectedState !== currentState) {

            currentRow.NMMUNICIPIO = "";
            currentRow.CDMUNICIPIO = "";
            currentRow.NMBAIRRO = "";
            currentRow.NMBAIRROCAN = "";
            currentRow.CDBAIRRO = "";

            selectedState = currentState;
        }
    };

    /**
     * Função para verificar se o município
     * foi alterado no formulário, se ele foi alterado,
     * a função limpa todos os campos inferiores na 
     * hierarquia de localidade.
     * 
     * @param {object} currentRow currentRow onde está os
     * dados do formulário em caso.
    */
    var selectedmunicipality;
    this.checkIfTheCityIsChanged = function (currentRow) {
        var currentMunicipality = currentRow.CDMUNICIPIO;

        if (typeof selectedmunicipality === "undefined") {
            selectedmunicipality = currentMunicipality;
        } else if (selectedmunicipality !== currentMunicipality) {

            currentRow.NMBAIRROCAN = "";
            currentRow.NMBAIRRO = "";
            currentRow.CDBAIRRO = "";

            selectedmunicipality = currentMunicipality;
        }
    };

    /**
     * Função para definir o filtro dos campos
     * de localidade.
     * 
     * @param {object} field campo (de localidade)
     * em caso.
    */
    this.setAddressFieldFilter = function (field) {

        CRM_Utilities.setDefaultOrgFilterAndOperatorOrgFilter(field);

        CRM_Utilities.setPlaceFilterByPlaceOrigin(field.widget, field);

        field.reload();

    };

    /**
     * Função para abrir o formulário de gerenciamento
     * do assistente(se existir registros filtrados).
     * 
     * @param {objetct} widget widget principal contendo
     * os parceiros que irão ser referenciados nas tarefas.
    */
    this.openFormToGenerateTasks = function (widget) {

        var tabbedWidget = templateManager.container.getWidget('WDGT_TABBED_GERENCIAMENTO_ASSISTENTE');
        var taskGenerationForm = templateManager.container.getWidget('WDGT_GERENCIAMENTO_ASSISTENETE');

        if (widget.dataSource.data.length > 0) {

            this.setWidgetsEnabledProperty(tabbedWidget.widgets, false);

            ScreenService.openSwipe(tabbedWidget);
            ScreenService.closePopup();

            taskGenerationForm.enabled = true;
            taskGenerationForm.activate();
            taskGenerationForm.newRow();

            this.setGenerateFormDefaultValues(taskGenerationForm);

        } else {

            ScreenService.confirmMessage(ScreenService.i18n(Messages.NAO_HA_PARCEIROS_FILTRADOR), 'question',

                function (success) {

                    ScreenService.closePopup();
                    ZhFilterPreferences.openFilterWidget(widget);

                }.bind(this), null
            );

        }

    };

    /**
     * Função para setar os valores iniciais
     * do formulário de gerenciamento do assistente.
     * 
     * @param {object} widget widget do formulário 
     * de gerenciamento do assistente.
    */
    this.setGenerateFormDefaultValues = function (widget) {

        var currentRow = widget.currentRow;

        currentRow.NRPRIORIDADETAREFA = 2;

    };

    /**
     * Função para setar o filtro dos campos de
     * intervalo da widget principal.
     * 
     * @param {object} widget widget onde se localiza
     * os campos de intervalo.
    **/
    this.setWidgetIntervalFilters = function (widget, args) {

        this.setEmployeesNumberFilter(widget, args);

        this.setBillingValueFilter(widget, args);

        delete args.e.preference.FILTER_ROW.NRFUNC_ATE;
        delete args.e.preference.FILTER_ROW.NRFUNC_DE;
        delete args.e.preference.FILTER_ROW.VRFATUPROS_ATE;
        delete args.e.preference.FILTER_ROW.VRFATUPROS_DE;
    };

    /**
    * Função para setar o operador de filtragem do campo
    * 
    * @param {object} widget widget onde se localiza
    * os campos.
   */
    this.changeOperatorFilter = function (widget) {
        var widgetFilter = widget.dataSourceFilter;
        var diasultevolFilterIndex = CRM_Utilities.getFilterPosition(widgetFilter, "DIASULTEVOL");
        var diasultativconcFilterIndex = CRM_Utilities.getFilterPosition(widgetFilter, "DIASULTATIVCONC");

        if (!Util.isUndefined(diasultevolFilterIndex))
            widgetFilter[diasultevolFilterIndex].operator = '>=';
        if (!Util.isUndefined(diasultativconcFilterIndex))
            widgetFilter[diasultativconcFilterIndex].operator = '>=';
    };

    /**
     * Função para setar o filtro do campo
     * de número de funcionários.
     * 
     * @param {object} widget widget onde se localiza
     * o campo de número de funcionários.
    */
    this.setEmployeesNumberFilter = function (widget, args) {

        var widgetFilter = widget.dataSourceFilter;
        var filterPopupValues = args.e.preference.FILTER_ROW;

        var employeesNumberFilterIndex = CRM_Utilities.getFilterPosition(widgetFilter, "NRFUNCIONARIOS");

        if (filterPopupValues.NRFUNC_DE > 0 || filterPopupValues.NRFUNC_ATE > 0) {

            var intervalFilter = this.createNumericalIntervalFilter("NRFUNCIONARIOS", filterPopupValues.NRFUNC_DE, filterPopupValues.NRFUNC_ATE);

            if (employeesNumberFilterIndex >= 0) {
                widgetFilter[employeesNumberFilterIndex] = intervalFilter;
            } else {
                widgetFilter.push(intervalFilter);
            }

        } else if (employeesNumberFilterIndex >= 0) {
            widget.dataSourceFilter = CRM_Utilities.deleteFilterObject(widgetFilter, employeesNumberFilterIndex);

        }

    };

    /**
     * Função para setar o filtro do campo
     * de faturamento do parceiro.
     * 
     * @param {object} widget widget onde se localiza
     * o campo de faturamento.
    */
    this.setBillingValueFilter = function (widget, args) {

        var filterPopupValues = this.getFilterValues(args);
        var widgetFilter = widget.dataSourceFilter;

        var intervalInitialValue = CRM_Utilities.removeValueCurrencyMask(filterPopupValues.VRFATUPROS_DE);
        var intervalFinalValue = CRM_Utilities.removeValueCurrencyMask(filterPopupValues.VRFATUPROS_ATE);

        var billingValueFilterIndex = CRM_Utilities.getFilterPosition(widgetFilter, "VRFATURAMENTO");

        if (intervalInitialValue > 0 || intervalFinalValue > 0) {

            var intervalFilter = this.createNumericalIntervalFilter("VRFATURAMENTO", filterPopupValues.VRFATUPROS_DE, filterPopupValues.VRFATUPROS_ATE);

            if (billingValueFilterIndex >= 0) {
                widgetFilter[billingValueFilterIndex] = intervalFilter;
            } else {
                widgetFilter.push(intervalFilter);
            }

        } else if (billingValueFilterIndex >= 0) {
            widget.dataSourceFilter = CRM_Utilities.deleteFilterObject(widgetFilter, billingValueFilterIndex);
        }

    };

    /**
     * Função para criar um filtro de intervalor
     * de acordo com o valor inicial e final.
     * 
     * @param {string} fieldReference campo referência
     * para o filtro.
     * 
     * @param {number} initialValue número inicial do 
     * intervalo.
     * 
     * @param {number} finalValue número final do
     * intervalo.
     * 
     * @return {object} filter objeto para ser referenciado
     * no array de objetos(filtros) do campo referência.
    */
    this.createNumericalIntervalFilter = function (fieldReference, initialValue, finalValue) {

        var filter;

        if ((initialValue === 0 || initialValue) && (finalValue === 0 || finalValue)) {
            filter = { name: fieldReference, operator: 'BETWEEN', value: [initialValue, finalValue] };
        } else if (initialValue === 0 || initialValue) {
            filter = { name: fieldReference, operator: '>=', value: initialValue };
        } else if (finalValue === 0 || finalValue) {
            filter = { name: fieldReference, operator: '<=', value: finalValue };
        }

        return filter;

    };


    /**
     * Função para verificar se os números de um
     * intervalo crescente são válidos (primeiro menor, segundo maior).
     * 
     * @param {object} initialField campo referente ao inicio
     * do intervalo.
     * 
     * @param {object} finalField campo referente ao
     * fim do intervalo.
    */
    this.validateNumericalIntervalBetweenTwoFields = function (initialField, finalField) {

        var currentRow = initialField.widget.currentRow;

        if ((currentRow[initialField.name] && currentRow[initialField.name] >= 0) && (currentRow[finalField.name] && currentRow[finalField.name] >= 0)) {

            if (currentRow[initialField.name] > currentRow[finalField.name]) {

                currentRow[finalField.name] = undefined;
                ScreenService.showMessage(Messages.INTERVALO_INVALIDO);

            }

        }

    };

    /**
     * Função para verificar se os valores de um
     * intervalo monetário crescente são válidos 
     * (primeiro menor, segundo maior).
     * 
     * @param {object} initialField campo referente ao inicio
     * do intervalo.
     * 
     * @param {object} finalField campo referente ao
     * fim do intervalo.
    */
    this.validateCurrencyIntervalBetweenTwoFields = function (initialField, finalField) {

        var currentRow = initialField.widget.currentRow;

        var initialValue = CRM_Utilities.removeValueCurrencyMask(currentRow[initialField.name]);
        var finalValue = CRM_Utilities.removeValueCurrencyMask(currentRow[finalField.name]);

        if ((currentRow[initialField.name] && initialValue > 0) && (currentRow[finalField.name] && finalValue > 0)) {

            if (initialValue > finalValue) {

                currentRow[finalField.name] = undefined;
                ScreenService.showMessage(Messages.INTERVALO_INVALIDO);

            }

        }

    };

    /**
     * Função para remover os objetos de um filtro
     * referente aos nomes recebidos por parâmetro.
     * 
     * @param {object} fieldFilter array com os objetos
     * referente ao filtro do field em caso.
     * 
     * @param {object} filtersName array com os nomes dos
     * objetos a serem removidos;
    */
    this.removeFiledsFilter = function (widget, filtersName) {

        var widgetFilter = widget.dataSourceFilter;
        var referenceFilterIndex;

        filtersName.map(function (filterName) {

            referenceFilterIndex = CRM_Utilities.getFilterPosition(widgetFilter, filterName);

            if (referenceFilterIndex >= 0) {
                widgetFilter = CRM_Utilities.deleteFilterObject(widgetFilter, referenceFilterIndex);
            }

        });

        widget.dataSourceFilter = widgetFilter;

    };

    /**
     * Função para retornar os valores do filtro
     * da widget recebida com parâmetro.
     * 
     * @param {object} 'referenceWidget' widget referência;.
     * 
     * @return {object} valores do filtro da widget em caso.
    */
    this.getFilterValues = function (args) {

        return args.e.preference.FILTER_ROW;

    };

    /**
     * Define as regras da tela de prospect de acordo 
     * com a revenda do operador logado.
     * 
     * @param {object} widget widget principal da tela de prospect
     * ('WDGT_ASSISTENTE_AGENDAMENTO').
    */
    this.setResaleRules = function (widget) {

        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        if (loggedOperatorInfos.IDTPOPERADOR === 'R' && Boolean(loggedOperatorInfos.NRREVENDA)) {

            var restrictObjects = [];

            restrictObjects.push(widget);

            var managementWidget = templateManager.container.getWidget("WDGT_GERENCIAMENTO_ASSISTENETE");
            restrictObjects.push(managementWidget.getField("CDOPERADOR"));

            CRM_Utilities.setResaleRulesInRestrictObjectsByLoggedOperatorResale(restrictObjects);

        }
    };

    /**
     * Abri a widget tabbed de gerenciamento do
     * assistente, na aba de tarefas por aniversários.
    */
    this.openTasksByBirthdaySwipe = function () {

        var tabbedWidget = templateManager.container.getWidget('WDGT_TABBED_GERENCIAMENTO_ASSISTENTE');
        var tasksByBirthdayWidget = templateManager.container.getWidget('WDGT_ASSISTENTE_ANIVERSARIOS');

        ScreenService.openSwipe(tabbedWidget).then(function () {

            this.setWidgetsEnabledProperty(tabbedWidget.widgets, false);

            ScreenService.closePopup();

            tasksByBirthdayWidget.newRow();
            tasksByBirthdayWidget.activate();
            tasksByBirthdayWidget.enabled = true;

            this.setTasksByBirthdayDefaultValues(tasksByBirthdayWidget.currentRow);

        }.bind(this));

    };

    /**
     * Seta os valores básicos necessários para gerar tarefas
     * em massa, pelo aniversário do operador responsável.
     * 
     * @param {object} currentRow currentRow que receberá
     * os valores iniciais.
    */
    this.setTasksByBirthdayDefaultValues = function (currentRow) {

        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
        currentRow.NRORG = loggedOperatorInfos.NRORG;

    };

    /**
     * Define a propriedade 'enabled' das widgets recebidas como
     * parâmetro.
     * 
     * @param {object} widgets array com as widgets a serem 
     * configuradas.
     * 
     * @param {boolean} isEnabled valor lógico indicando se as
     * widgets ficarão habilitado ou não.
    */
    this.setWidgetsEnabledProperty = function (widgets, isEnabled) {

        widgets.forEach(function (widget) {
            widget.enabled = isEnabled;
        });

    };

    /**
     * Realiza uma requição no banco chamando a procedure
     * 'GERA_TAREFA_ANIVER_ANO_ATUAL', responsável por
     * gerar tarefas para os responsável dos parceiros
     * na data de fundação ou aniversário do parceiro.
     * 
     * Ex.: Parceiro: Coca-Cola.
     *      Data Fundação: 12/01/1892.
     *      Responsável: Carlos Eduardo.
     * 
     * Após chamar a procedure, é criada uma tarefa
     * na data de criação da empresa, no ano selecionado.
     * 
     * Data Tarefa: 12/01/2017(ano selecionado).
     * Parceiro; Coca-Cola.
     * Descrição: Desejar feliz aniversário para o
     * parceiro.
     * Responsável pela tarefa: Carlos Eduardo.
     * 
     * @param {object} widget widget de agendamento
     * de tarefas através do aniversário.
    */
    this.generateTasksByBirthday = function (widget) {
        if (widget.isValid()) {
            var assistantMainWidget = templateManager.container.getWidget('WDGT_ASSISTENTE_AGENDAMENTO');
            ScreenService.confirmMessage(ScreenService.i18n(Messages.PERGUNTA_GERAR_TAREFAS_ANIVERSARIO), 'question',
                function (success) {
                    widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                    var currentRow = widget.currentRow;
                    General.callRestEngine("/generateTasksByBirthday", "Row", currentRow).then(function (response) {
                        if (response.dataset && response.dataset.error) {
                            ScreenService.showMessage(response.dataset.error, 'ERROR');
                        }
                        if (response.dataset && (response.dataset.PPR || response.dataset.PFR)) {
                            var dataset = response.dataset;

                            ScreenService.notificationMessage("Ocorreram erros na adição dos registros, verifique o popup de mensagens!", "alert");
                            openPopupMensagens(dataset.msg);
                        }

                        ScreenService.showMessage(Messages.TAREFAS_GERADAS_SUCESSO);
                        this.cancelScheduling(widget);
                        assistantMainWidget.activate();

                    }.bind(this))
                        .catch(function (error) {
                            Messages.CATCH_EXCEPTION_ERROR(error.data.error);
                        });
                }.bind(this), null);
        }
    };

    /**
     * Verifica se o ano selecionado pelo usuário é menos que o ano atual.
     * 
     * @param {object} widget widget de agendamento de tarefas através
     * do aniversário.
    */
    this.checkIfSelectedYearIsSmallerThanCurrentYear = function (widget) {

        var currentRow = widget.currentRow;

        if (moment(currentRow.ANO_TAREFAS, 'YYYY').format('YYYY') < moment().format('YYYY')) {

            ScreenService.showMessage(Messages.ANO_MAIOR_ANO_ATUAL);
            currentRow.ANO_TAREFAS = "";

        }

    };

    /**
     * Abri a widget tabbed de gerenciamento do
     * assistente, na aba de tarefas por intervalo.
    */
    this.openTasksByIntervalSwipe = function () {

        var tabbedWidget = templateManager.container.getWidget('WDGT_TABBED_GERENCIAMENTO_ASSISTENTE');
        var tasksByInterval = templateManager.container.getWidget('WDGT_ASSISTENTE_TAREFAS_INTERVALO');

        ScreenService.openSwipe(tabbedWidget).then(function () {

            this.setWidgetsEnabledProperty(tabbedWidget.widgets, false);

            ScreenService.closePopup();

            tasksByInterval.newRow();
            tasksByInterval.activate();
            tasksByInterval.enabled = true;

            this.setTasksByIntervalDefaultValues(tasksByInterval.currentRow);

        }.bind(this));

    };

    /**
     * Seta os valores básicos necessários para gerar tarefas
     * em massa, pelo intervalo selecionado pelo usuário.
     * 
     * @param {object} currentRow currentRow que receberá
     * os valores iniciais.
    */
    this.setTasksByIntervalDefaultValues = function (currentRow) {

        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
        currentRow.NRORG = loggedOperatorInfos.NRORG;

    };

    /**
     * Realiza uma chamada para a procedure 'GERA_TAREFAS_PARC_RELAC_OPER'
     * reponsável por gerar tarefas para os responsáveis
     * de seus respectivos parceiros em um intervalo
     * de tempo.
     * 
     * @param {object} widget widget de agendamento
     * de tarefas por intervalo.
    */
    this.generateTasksByInterval = function (widget) {
        var assistantMainWidget = templateManager.container.getWidget('WDGT_ASSISTENTE_AGENDAMENTO');
        if (widget.isValid()) {

            ScreenService.confirmMessage(ScreenService.i18n(Messages.PERGUNTA_GERAR_TAREFAS_INTERVALO), 'question',
                function (success) {
                    widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                    var currentRow = widget.currentRow;
                    General.callRestEngine("/generateTasksByInterval", "Row", currentRow).then(function (response) {
                        if (response.dataset && response.dataset.error) {
                            ScreenService.showMessage(response.dataset.error, 'ERROR');
                        }
                        if (response.dataset && (response.dataset.PPR || response.dataset.PFR)) {
                            var dataset = response.dataset;

                            ScreenService.notificationMessage("Ocorreram erros na adição dos registros, verifique o popup de mensagens!", "alert");
                            openPopupMensagens(dataset.msg);
                        }

                        ScreenService.showMessage(Messages.TAREFAS_GERADAS_SUCESSO);
                        this.cancelScheduling(widget);
                        assistantMainWidget.activate();

                    }.bind(this))
                        .catch(function (error) {
                            Messages.CATCH_EXCEPTION_ERROR(error.data.error);
                        });
                }.bind(this), null);
        }
    };

    var openPopupMensagens = function (msg) {
        var widgetMensagens = templateManager.container.getWidget('messagesAgrupamento');
        widgetMensagens.dataSource.data = msg;
        ScreenService.openPopup(widgetMensagens);
    };

    this.assistAgendaOnEnterOnce = function (widget) {
        var parceiroController = CRM_Utilities.getController('CRM_ParceiroNegocio_Controller');
        var filterRow = {};
        var fieldsToApply = ['IDATIVO'];

        CRM_Utilities.openFilterOnEnter(widget, filterRow, fieldsToApply);
        this.setResaleRules(widget);
        parceiroController.alteraEstadoReadonly(widget);
    };

    this.popupMensagensVoltar = function () {
        var widget = templateManager.container.getWidget('WDGT_ASSISTENTE_AGENDAMENTO');

        ScreenService.closePopup();
        widget.activate();
        widget.list();

    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('crm33000000_Assistente_De_AgendamentoController', crm33000000_Assistente_De_AgendamentoController);
});

// FILE: ./assets/js/controllers/crm33000000_Gerenciamento_De_AgendamentoController.js
function crm33000000_Gerenciamento_De_AgendamentoController(ScreenService, CRM_Utilities, General, Messages, restEngine, templateManager) {

    /**
     * Função para cancelar o gerenciamento do assistente;
     * 
     * @param {object} widget widget de gerenciamento
     * do assistente.
    */
    this.cancelScheduling = function (widget) {

        var parentWidget = templateManager.container.getWidget('WDGT_ASSISTENTE_AGENDAMENTO');

        ScreenService.closeSwipe();
        parentWidget.activate();

    };

    /**
     * Função para confirmar se o usuário
     * realmente quer gerar as tarefas para
     * os parceiros filtrados na widget principal.
     * 
     * @param {object} widget widget responsável
     * pelo gerenciamento do assistente(WDGT_GERENCIAMENTO_ASSISTENETE).
    */
    this.confirmGenerator = function (widget) {
        var mainWidget = templateManager.container.getWidget('WDGT_ASSISTENTE_AGENDAMENTO');
        var numberOfPartners = this.getNumberOfPartnersToGenerateTasks(mainWidget);

        if (widget.isValid()) {
            ScreenService.confirmMessage(Messages.CONFIRMACAO_GERADOR_DE_TAREFAS(numberOfPartners), 'question', function (success) {
                this.generateTasks(widget);
            }.bind(this));
        }
    };

    /**
     * Retornar o número de parceiros configurado
     * no assistente.
     * 
     * @param {object} widget widget principal do
     * assistente.
    */
    this.getNumberOfPartnersToGenerateTasks = function (widget) {

        if (widget.hasCheckedRows()) {

            var selectedPartners = widget.getCheckedRows();
            return selectedPartners.length;

        } else {
            return widget.dataSource.data.length;
        }

    };

    /**
     * Função para gerar as tarefas para os
     * parceiros filtrados na widget principal.
     * 
     * @param {object} widget widget responsável
     * pelo gerenciamento do assistente(WDGT_GERENCIAMENTO_ASSISTENETE).
    */
    this.generateTasks = function (widget) {

        widget.currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        var assistantMainWidget = templateManager.container.getWidget('WDGT_ASSISTENTE_AGENDAMENTO');

        this.createTasksCampaign(widget).then(function (response) {

            var operatorsDataSet = this.configureRowsForTheTaskGenerator(assistantMainWidget, widget);

            General.callRestEngine("product#/crm_candidato_prospect_infosparc/generateTasks", "DataSet", operatorsDataSet).then(
                function (response) {
                    if (response.dataset && response.dataset.error) {
                        ScreenService.showMessage(response.dataset.error, 'ERROR');
                    }
                    if (response.dataset && (response.dataset.msg || response.dataset.msg)) {
                        var dataset = response.dataset;

                        ScreenService.notificationMessage("Ocorreram erros na adição dos registros, verifique o popup de mensagens!", "alert");
                        openPopupMensagens(dataset.msg);
                    } else {
                        ScreenService.showMessage(Messages.TAREFAS_GERADAS_SUCESSO);
                    }

                    ScreenService.closeSwipe();
                    assistantMainWidget.activate();

                }.bind(this),
                function (error) {
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
                }
            );

        }.bind(this));

    };

    /**
     * Salva a campanha referente as tarefas que
     * serão geradas.
     * 
     * @param {object} widget widget do gerenciamento
     * do assistente.
    */
    this.createTasksCampaign = function (widget) {

        var currentRow = widget.currentRow;

        var params = {
            "requestType": "Row",
            "row": currentRow
        };

        return restEngine.request("product#/crm_campanhatarefa/save", params).then(
            function (response) {
                widget.currentRow.NRSEQCAMPANHA = response.dataset.DATA.NRSEQCAMPANHA;
            }.bind(this),
            function (error) {

            }
        );

    };

    /**
     * Função para configurar os dados das tarefas
     * que serão inseridas.
     * 
     * @param {object} assistantMainWidget widget principal
     * onde foram filtrados os parceiros(WDGT_ASSISTENTE_AGENDAMENTO).
     * 
     * @param {object} widget widget responsável
     * pelo gerenciamento do assistente(WDGT_GERENCIAMENTO_ASSISTENETE).
     * 
     * @return {object} operatorsDataSet dataset com os objetos(tarefas)
     * configurados.
    */
    this.configureRowsForTheTaskGenerator = function (assistantMainWidget, widget) {

        this.setOperatorsTaskInitialDate(widget);

        var operatorsDataSet = this.prepareRowsToSave(assistantMainWidget, widget);

        return operatorsDataSet;

    };

    /**
     * Função para criar um array referente ao array
     * de operadores(já existente na currentRow), responsável
     * por controlar a data das tarefas referente a cada operado.
     * 
     * @param {object} widget widget responsável
     * pelo gerenciamento do assistente(WDGT_GERENCIAMENTO_ASSISTENETE).
    */
    this.setOperatorsTaskInitialDate = function (widget) {

        var currentRow = widget.currentRow;

        var operators = currentRow.CDOPERADOR;
        var initialDate = currentRow.DATAINICIALTAREFAS;

        currentRow.DATARERERENCIAOPER = [];

        operators.forEach(function (operator, i) {

            currentRow.DATARERERENCIAOPER.push(initialDate);

        });

    };

    /**
     * Função para configurar os dados de cada tarefa
     * a ser inserida.
     *
     * @param {object} assistantMainWidget widget principal
     * onde foram filtrados os parceiros(WDGT_ASSISTENTE_AGENDAMENTO).
     * 
     * @param {object} widget widget responsável
     * pelo gerenciamento do assistente(WDGT_GERENCIAMENTO_ASSISTENETE).
    */
    this.prepareRowsToSave = function (assistantMainWidget, widget) {

        var currentRow = widget.currentRow;

        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

        var operators = currentRow.CDOPERADOR;
        var partners = this.getPartnersToGenerateTasks(assistantMainWidget);

        var numberOfTasksByOperator = currentRow.NRTAREFASPORDIA;

        var taskCount = 0;
        var referenceOperator = 0;

        var row;
        var operatorTaskDate;

        return partners.map(function (partner) {

            row = {};

            if (taskCount === numberOfTasksByOperator) {

                currentRow.DATARERERENCIAOPER[referenceOperator] = this.addWorkingDaysToDate(operatorTaskDate, 1);

                referenceOperator = (++referenceOperator) % operators.length;
                taskCount = 0;

            }

            operatorTaskDate = currentRow.DATARERERENCIAOPER[referenceOperator];

            row.__is_new = true;
            row.DSFILACONTATO = (currentRow.NMCAMPANHA) ? '[' + currentRow.NMCAMPANHA + '] ' + currentRow.DESCTAREFA : currentRow.DESCTAREFA;
            row.DTPLANFILACONTA = operatorTaskDate;
            row.IDORIGFILACONTA = 'M';
            row.NRPARCNEGOCIO = partner.NRPARCNEGOCIO;
            row.NRPRIORFILACONT = currentRow.NRPRIORIDADETAREFA;
            row.CDOPERREAL = operators[referenceOperator];
            row.NRORG = loggedOperatorInfos.NRORG;
            row.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
            row.NRSEQCONTATO = partner.NRSEQCONTATO;
            row.NRSEQCAMPANHA = currentRow.NRSEQCAMPANHA;

            taskCount++;

            return row;

        }.bind(this));
    };

    /**
     * Retorna os parceiros requerido pelo
     * assistente.
     * 
     * @param {object} widget widget principal
     * do assistente.
    */
    this.getPartnersToGenerateTasks = function (widget) {

        if (widget.hasCheckedRows()) {
            return widget.getCheckedRows();
        } else {
            return widget.dataSource.data;
        }

    };

    /**
     * Função para somar um número de dias úteis
     * a uma determinada data.
     * 
     * @param {string} date data que será alterada.
     * 
     * @param {number} numberOfWorkingDays número 
     * de dias úteis que serão acrescentados a data 
     * recebida com parâmetro.
    */
    this.addWorkingDaysToDate = function (date, numberOfWorkingDays) {

        var newDate = this.addDaysToADate(date, numberOfWorkingDays);

        switch (this.getDayOfTheWeekRelativeTheDate(newDate)) {

            case "Sat":
                newDate = this.addDaysToADate(newDate, 2);
                break;

            case "Sun":
                newDate = this.addDaysToADate(newDate, 1);
                break;
        }

        return newDate;

    };

    /**
     * Função para retornar o dia da semana(simplificado)
     * referente a data recebida como parâmetro.
     * 
     * @param {string} date date referência.
     * 
     * @return {string} nome simplificado do dia da semana
     * referente a date recebida como parâmetro
    */
    this.getDayOfTheWeekRelativeTheDate = function (date) {

        var dateMomentObject = moment(date, 'DD/MM/YYYY HH:mm');

        return dateMomentObject.toString().substr(0, 3);

    };

    /**
     * Função para somar um número de dias a uma
     * determinada data.
     * 
     * @param {string} date data que será alterada.
     * 
     * @param {number} numberOfDays número de dias
     * que serão acrescentados a data recebida com
     * parâmetro.
    */
    this.addDaysToADate = function (date, numberOfDays) {

        var newDate = moment(date, 'DD/MM/YYYY HH:mm').add(numberOfDays, 'days').format('DD/MM/YYYY HH:mm');

        return newDate;

    };

    var openPopupMensagens = function (msg) {
        var widgetMensagens = templateManager.container.getWidget('messagesAgrupamento');
        widgetMensagens.dataSource.data = msg;
        ScreenService.openPopup(widgetMensagens);
    };

}

Configuration(function (ContextRegister) {
    ContextRegister.register('crm33000000_Gerenciamento_De_AgendamentoController', crm33000000_Gerenciamento_De_AgendamentoController);
});

// FILE: ./assets/js/controllers/CRMAssistentesController.js
function CRMAssistentesController(ScreenService, templateManager, CRM_Utilities) {
    
    this.openPopupNewRow = function() {
        var widgetNewRow = templateManager.container.getWidget('popupNewRow');
        
        ScreenService.openPopup(widgetNewRow);
        widgetNewRow.newRow();
        widgetNewRow.activate();
    };
    
    this.openPopupNewRowFromView = function(widget) {
        var popup = templateManager.container.getWidget('popupNewRow');
        var mainRow = templateManager.container.getWidget('assistencia').currentRow;
        var operPrincipalField = popup.getField('NMOPERPRINCIPAL');
        
        popup.parent = widget;
        this.openPopupNewRow();
        
        popup.currentRow.NROPERPRINCIPAL = mainRow.NRPARCNEGOCIO;
        popup.currentRow.NMOPERPRINCIPAL = mainRow.NMOPERADOR;
        operPrincipalField.readOnly = true;
        
        this.updateNewAssitFilter(popup);
    };
    
    this.openPopupNewRowFromList = function() {
        var popup = templateManager.container.getWidget('popupNewRow');
        var mainRow = templateManager.container.getWidget('assistencia');
        var operPrincipalField = popup.getField('NMOPERPRINCIPAL');
        
        popup.parent = mainRow;
        this.openPopupNewRow();
        
        operPrincipalField.readOnly = false;
    };
    
    this.updateNewAssitFilter = function(widget) {
        var assistField = widget.getField('NROPERASSIST');
        
        var assistOperFilter = null;
        for (var i = 0; i < assistField.dataSourceFilter.length; i++) {
            if (assistField.dataSourceFilter[i].name === 'NROPERPRINCIPAL') {
                assistOperFilter = assistField.dataSourceFilter[i];
                break;
            }
        }
        
        assistField.readOnly = Util.isEmptyOrBlank(widget.currentRow.NROPERPRINCIPAL);
        
        assistOperFilter.value = widget.currentRow.NROPERPRINCIPAL;
    };
    
    this.saveNewAssist = function(widget) {
        if (!widget.isValid()) {
            return;
        }
    
        var row = widget.currentRow;
    
        var params = {
            requestType: 'Row',
            row: row
        };
    
        CRM_Utilities.post('/saveNewAssist', params).then(function(response) {
            this.showMessageAfterSaveAndReload(widget, response).then(function() {
                this.openSwipeIfIsNew(widget);
            }.bind(this));
        }.bind(this));
    };
    
    this.openSwipeIfIsNew = function(popup) {
        if (popup.getParent().name !== 'assistencia') {
            return;
        }
    
        var mainWid = templateManager.container.getWidget('assistencia');
        var nrOperPrincipal = popup.currentRow.NROPERPRINCIPAL;
    
        mainWid.currentRow = mainWid.dataSource.data.find(function(row) {
            return row.NRPARCNEGOCIO == nrOperPrincipal;
        });
    
        this.openAssistList(mainWid);
    };
    
    this.reloadParentAndMainWidget = function(popup) {
        var mainWid = templateManager.container.getWidget('assistencia');
        var parentWid = popup.getParent();
        var reloadPromise;
        
        if(mainWid.name == parentWid.name) {
            reloadPromise = mainWid.reload();
        } else {
            reloadPromise = this.reloadListAndView();
        }
        
        return reloadPromise;
    };
    
    this.openAssistList = function(widget) {
        var tabWidget = templateManager.container.getWidget('tabAssist');
        var listWidget = templateManager.container.getWidget('assistentes');
        
        var listFilter = CRM_Utilities.getDataSourceFilter(listWidget, 'NROPERPRINCIPAL');
        listFilter.value = widget.currentRow.NRPARCNEGOCIO;
        
        ScreenService.openSwipe(tabWidget);
        listWidget.activate();
        
        listWidget.unSelectAll();
        
        listWidget.reload();
    };
    
    this.reloadListAndView = function() {
        var listWid = templateManager.container.getWidget('assistencia');
        var viewWid = templateManager.container.getWidget('assistentes');
        
        var promise1 = listWid.reload();
        var promise2 = viewWid.reload();
        
        return Promise.all([promise1, promise2]);
    };
    
    this.cancelPopup = function(popupWidget) {
        var parentWid = popupWidget.getParent();
        
        ScreenService.closePopup(popupWidget);
        parentWid.activate();
    };
    
    this.askToRemoveAssist = function(widget) {
        var msg = 'Deseja realmente remover esse assistente?';
    
        ScreenService.confirmMessage(msg, 'question', function() {
            this.removeAssist(widget);
        }.bind(this));
    };
    
    this.removeAssist = function(widget) {
        var checkedAssists = widget.dataSource.checkedRows;
        
        var row = {
            ASSISTENCIAS: checkedAssists
        };
        
        var params = {
            requestType: 'Row',
            row: row
        };
        
        CRM_Utilities.post('/removeAssist', params).then(function(response) {
            widget.unSelectAll();
            this.showMessageAfterRemoveAndReload(response).then(function() {
                if(widget.dataSource.data.length == 0) {
                    ScreenService.closeSwipe();
                }
            }.bind(this));
        }.bind(this));
    };
    
    this.showMessageAfterRemoveAndReload = function(response) {
        var removed = response.dataset.DADOS.REMOVED;
        var notRemoved = response.dataset.DADOS.NOT_REMOVED;
        
        var message = '';
        
        if(notRemoved.length > 0) {
            message = notRemoved.length > 1 ?
                'Os seguintes assistentes não puderam ser removidos:<br>' :
                'O seguinte assistente não pôde ser removido:<br>';
            
            message += notRemoved.reduce(function(concat, assist) {
                return concat + '<br>-> ' + assist.NMOPERADOR;
            }, '');
            
            message += '<br><br>Entre em contato com um administrador do sistema.';
        } else {
            message = (removed.length > 1 ?
                'Assistentes removidos ' : 'Assistente removido ') +
                'com sucesso!';
        }
        
        var promiseReload = this.reloadListAndView();
        ScreenService.showMessage(message);
        
        return promiseReload;
    };
    
    this.showMessageAfterSaveAndReload = function(widget, response) {
        var added = response.dataset.DADOS.ADDED;
        var notAdded = response.dataset.DADOS.NOT_ADDED;
        var assistField = widget.getField('NROPERASSIST');
        
        var message = '';
        
        if(notAdded.length > 0) {
            message = notAdded.length > 1 ?
                'Os seguintes assistentes não puderam ser adicionados:<br>' :
                'O seguinte assistente não pôde ser adicionado:<br>';
            
            message += notAdded.reduce(function(concat, assist) {
                return concat + '<br>-> ' + assist.NMOPERADOR;
            }, '');
            
            message += '<br><br>Entre em contato com um administrador do sistema.';
            
            assistField.reload();
        } else {
            message = (added.length > 1 ?
                'Assistentes adicionados ' : 'Assistente adicionado ') +
                'com sucesso!';
                
            ScreenService.closePopup();
            widget.getParent().activate();
        }
        
        var promiseReload = this.reloadParentAndMainWidget(widget);
        ScreenService.showMessage(message);
        
        return promiseReload;
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register("CRMAssistentesController", CRMAssistentesController);
});

// FILE: ./assets/js/controllers/crmLoginController.js
function crmLoginController(ScreenService, Operador_Repository, eventAggregator, restEngine, localStorageEngine, Messages, templateManager, API_GoogleCalendar, General, CRM_Utilities, CRM_Operador_Repository) {
    
    /**
     * Evento para iniciar o sistema principal(CRM);
    */
    eventAggregator.subscribe('authSuccess', function(session) {
        
        this.setLoggedOperatorInfosIntemplateManager(session).then(function(){
            this.setAlterarParametros(session);
            this.getInferiorHierarchiesByLoggedOperator(templateManager.LOGGEDOPERATOR).then(function(){
               this.initializeSystem(session); 
            }.bind(this));
            
        }.bind(this));
        
    }.bind(this));
    
    /**
     * Função para iniciar o sistema com 
     * todas as configurações necessárias.
     * 
     * @param {object} session informações da sessão em caso.
    */
    this.initializeSystem = function(session){
        
        API_GoogleCalendar.loadAuth2AndApiClientLibrary();
        
        this.openCrmDashboard().then(function(){
            this.setCrmParametrizationInTemplateManager().then(function(){
                //this.changeAclOperatorWindowToCrmOperatorWindow();
                this.setSystemValidation();
            }.bind(this));    
        }.bind(this));
        
    };
    
    /**
     * Inicializa validações customizadas do sistema.
    */
    this.setSystemValidation = function(){
        
        CRM_Utilities.registerPhoneValidation();
        CRM_Utilities.registerMinCurrencyValidation();
        
    };
    
    /**
     * Função para chamar a tela de dashboard
     * do CRM.
    */
    this.openCrmDashboard = function(){
        return ScreenService.openWindow('product#dashboard');
    };
    
    //TODO
    this.changeAclOperatorWindowToCrmOperatorWindow = function(){
        templateManager.project.getMenu('acl').menus[0].windowName = 'product#crm_operador';
    };
    
    /**
     * Função para setar as informações do operador
     * logado na sessão do PHP.
     * 
     * @param {object} user objeto com as informações
     * do operador logado.
     * 
     * @param {object} resultado da requisição ao
     * back-end.
    */
    this.setLoggedOperatorInfosInPhpSession = function(){
        
        var loggedOperatorInfos = {
            "CDOPERADOR": localStorageEngine.getLocalVar('CRM_CDOPERADOR'),
            "NRORG"     : localStorageEngine.getLocalVar('CRM_NRORG'),
            "NRORGTRAB" : localStorageEngine.getLocalVar('CRM_NRORGTRAB'),
            "CDFILIAL"  : 9999
        };
        
        return restEngine.post("product#/setLoggedOperatorInfosInPhpSession", {
            "requestType": "Row",
            "row": loggedOperatorInfos
        });    
        
    };
    
    /**
     * Função para buscar as informações do operador logado,
     * através de uma requisição no banco, e retorná-las para
     * dentro do templateManager.
     * 
     * @param {object} session sessão da autenticação do usuário
     * logado.
    */
    this.setLoggedOperatorInfosIntemplateManager = function(session){
        var cdoperador = 'OPERADOR_LOGADO';
        if(!Util.isEmptyOrBlank(session) && !Util.isEmptyOrBlank(session.user)) {
            cdoperador = session.user.cdoperador;
        }
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": cdoperador
            }
        ];
        
        return Operador_Repository.retornaOperadorLogado(session.user).then(function(operator){
            if(!operator[0]){
                operator = localStorageEngine.download("product#/crud/operador_geral", filter);
                if(!operator[0]) {
                    operator = localStorageEngine.download("product#/crud/operador_geral", filter);
                    if(!operator[0]) {
                        ScreenService.showMessage(Messages.ERRO_REQUSICAO_INFOS_OPERADOR_LOGADO);
                        return;
                    }
                }
            }
        
            templateManager.LOGGEDOPERATOR = operator[0];
            Operador_Repository.retornaPerfilOperadorLogado().then(function(perfil){
                templateManager.LOGGEDOPERATOR.NRSEQPERFATIV = null;
                if(Array.isArray(perfil)){
                    templateManager.LOGGEDOPERATOR.NRSEQPERFATIV = [];
                    templateManager.LOGGEDOPERATOR.DESCPEFATIV = [];
                    perfil.forEach(function(perf){
                        if(templateManager.LOGGEDOPERATOR.NRSEQPERFATIV.indexOf(perf.NRSEQPERFATIV) === -1){
                            templateManager.LOGGEDOPERATOR.NRSEQPERFATIV.push(perf.NRSEQPERFATIV);
                            templateManager.LOGGEDOPERATOR.DESCPEFATIV.push(perf.DESCPEFATIV);
                        }
                    });
                }
            });

            }.bind(this), 
            function(error){
                ScreenService.showMessage(Messages.ERRO_REQUSICAO_INFOS_OPERADOR_LOGADO);
            }
        );  
            
    };
    
    /**
     * Busca as parametrizações do sistema
     * de acordo com o número da organização
     * do operador logado e seta no templateManager.
    */
    this.setCrmParametrizationInTemplateManager = function(){
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        return General.callRestEngine("product#/getCrmParametrization", "DataSet", [{NRORG: loggedOperatorInfos.NRORG}]).then(function(response){
            
            if(!response.dataset.DADOS.PARAMETRIZACAO){
                
                ScreenService.showMessage(Messages.ERRO_REQUSICAO_PARAMETRIZACOES);
                return;
            }
        
            templateManager.CRM_PARAMETRIZACAO = response.dataset.DADOS.PARAMETRIZACAO[0];
        }.bind(this), 
            function(error){
                ScreenService.showMessage(Messages.ERRO_REQUSICAO_PARAMETRIZACOES);
            }
        ); 
      
    };
    
    /**
     * Busca as hierarquias inferiores ao operador
     * logado.
     * 
     * @param {object} LOGGEDOPERATOR objecto com as informações do
     * operador logado.
    */
    this.getInferiorHierarchiesByLoggedOperator = function(LOGGEDOPERATOR) {
        
        var filter = [
            {
                "name": "P_HIERARQUIATUAL",
                "operator": "=",
                "value": LOGGEDOPERATOR.NRHIERARQUIAOPER
            }
        ];
        
        return localStorageEngine.download("product#/crud/crm_hierarquiaoper_hierarquiasinferior", filter).then(function(response){
            this.setLoggedOperatorInferiorHierarchiesInLoggedOperator(response);
        }.bind(this));
        
    };
    
    /**
     * Cria dois arrays, no objeto com as informações do 
     * operador logado, um mostrando os códigos do operadores
     * com hierarquia inferior ao operador logado e outro com o
     * número do parceiro dos operadores.
     * 
     * @param {object} hierarchies operadores com hierarquia
     * abaixo do operador logado.
    */
    this.setLoggedOperatorInferiorHierarchiesInLoggedOperator = function(hierarchies){
        
        var loggedOperator = templateManager.LOGGEDOPERATOR;
        
        loggedOperator.CDOPERSHIERARQINF = [loggedOperator.CDOPERADOR];
        loggedOperator.NRPARCOPERSHIERARQINF = [loggedOperator.NRPARCNEGOCIO];
        
        hierarchies.forEach(function(hierarchy){
            
            loggedOperator.CDOPERSHIERARQINF.push(hierarchy.CDOPERADOR);
            loggedOperator.NRPARCOPERSHIERARQINF.push(hierarchy.NRPARCNEGOCIO);
            
        });
    };
    
    this.setAlterarParametros = function(session) {
        var filtro = [
            {
                "name": "P_NRORG",
                "operator": "=",
                "value": session.user.nrorg
            },
            {
                "name": "P_CDOPERADOR",
                "operator": "=",
                "value": session.user.cdoperador
            }
        ];
    
        General.callRestEngine("product#/getRelatedOrganizations", "FilterData", filtro).then(function(response) {
            if(response.dataset && response.dataset.getRelatedOrganizations && response.dataset.getRelatedOrganizations.length > 1) {
                templateManager.project.userDataActions = [
                    {
                        "label": "Alterar Parâmetros",
                        "icon": "refresh",
                        "events": [
                            {
                                "name": "ActionEvent",
                                "code": "ScreenService.openWindow('product#par3002_paramconfig');ScreenService.toggleSideMenu();"
                            }
                        ]
                    }
                ];
            } else {
                templateManager.project.userDataActions = [];
            }
        });
    
        General.callRestEngine("product#/getNrOrgTrabalhoAtual", "FilterData", filtro).then(function(response) {
            if(!Util.isEmptyOrBlank(response.dataset.getOperador)) {
                var userInfo = response.dataset.getOperador[0].NMORGTRAB + ' - ' + response.dataset.getOperador[0].CRM_NRORGTRAB;
                ScreenService.setHeaderInfo(userInfo);
                ScreenService.buildUserData(templateManager.LOGGEDOPERATOR.NMOPERADOR, [userInfo], function() {}, './assets/images/user.jpg');
                templateManager.LOGGEDOPERATOR.CRM_NRORGTRAB = response.dataset.getOperador[0].CRM_NRORGTRAB;
                templateManager.LOGGEDOPERATOR.NMORGTRAB = response.dataset.getOperador[0].NMORGTRAB;
            }
        });
    };
    
    eventAggregator.subscribe('setParamsProduct', function(session) {
        var user = session.user;

        CRM_Operador_Repository.getNrOrgTrabalhoAtual(user).then(function(data) {
            if(!Util.isEmptyOrBlank(data.dataset.getOperador)) {
                setLocalVar('CRM_NRORGTRABALHO', data.dataset.getOperador[0].CRM_NRORGTRAB);
                setLocalVar('NMORGTRAB', data.dataset.getOperador[0].NMORGTRAB);
            }
        });
        
    });

    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('crmLoginController', crmLoginController);
}); 

// FILE: ./assets/js/controllers/CrmNext_Controller.js
function CrmNext_Controller(LibUtilities) {

    this.redirectOnContainerAfterinit = function (widget, rotaDaTela) {
        var token = window.localStorage.getItem('LOGIN_TOKEN');
        var hash = window.localStorage.getItem('LOGIN_HASH') || '0';
        var user = window.localStorage.getItem('NEXTSESSION_ENCRYPTED');
        var languange = window.localStorage.getItem('LOGIN_LANGUAGE');
        var productId = window.projectId;

        var url = window.urlCrmNext + rotaDaTela + "?header=0&menu=0" +
            "&token=" + token +
            "&hash=" + hash +
            "&user=" + user +
            "&languange=" + languange +
            "&productId=" + productId +
            "&isZhAngular=1";


        clearTimeout(LibUtilities.expiredSessionMethod);

        widget.sourceUrl = url;
    };
}
//redirecionarSMNEXT_Controllerr

window.Configuration(function (ContextRegister) {
    ContextRegister.register('CrmNext_Controller', CrmNext_Controller);
});

// FILE: ./assets/js/controllers/Dashboard_Controller.js
function Dashboard_Controller(
  ScreenService,
  templateManager,
  localStorageEngine,
  ZhUtil,
  restEngine,
  $window,
  CRM_Utilities,
  ZHPromise,
  ZhFilterPreferences
) {
  this.startDashboard = function (args) {
    if (templateManager.LOGGEDOPERATOR) {
      this.reloadWidgets(args);
      this.setVisibleDashboardTabs();
    }
  };

  this.reloadWidgets = function (args) {
    var container = args.owner;
    var widgets = container.widgets;
    widgets.forEach(function (widget) {
      widget.reload();
    });
  };

  this.setVisibleDashboardTabs = function () {
    var tabbed = templateManager.container.getWidget("tabbed");
    var tabForcaVendas = templateManager.container.getWidget("tabForcaVendas");
    var tabSAC = templateManager.container.getWidget("tabSAC");
    var IDEXIBEPAINELATEND = templateManager.LOGGEDOPERATOR.IDEXIBEPAINELATEND;
    var IDEXIBEPAINELVENDAS =
      templateManager.LOGGEDOPERATOR.IDEXIBEPAINELVENDAS;
    var whoIsVisible = "";

    if (IDEXIBEPAINELVENDAS !== "N") {
      tabForcaVendas.isVisible = true;
      whoIsVisible = "vendas";
    }
    //Comentado para manter a aba "Atendimento ao Cliente" invisível devido a mudanças no sistema.
    /*if (IDEXIBEPAINELATEND !== 'N') {
            tabSAC.isVisible = true;
            if (Util.isEmptyOrBlank(whoIsVisible))
                whoIsVisible = 'sac';
            else
                whoIsVisible = 'both';
        }*/

    this.getActiveTabs(whoIsVisible).then(function (response) {
      setTimeout(
        function () {
          response.activeWidget.activate();
        }.bind(this),
        500
      );
    });
  };

  this.getActiveTabs = function (whoIsVisible) {
    var tabbed = templateManager.container.getWidget("tabbed");
    var tabForcaVendas = templateManager.container.getWidget("tabForcaVendas");
    var tabSAC = templateManager.container.getWidget("tabSAC");
    var zhPromise = ZHPromise.defer();

    switch (whoIsVisible) {
      case "sac":
        tabbed.currentWidget = tabSAC;
        tabSAC.active = true;
        tabForcaVendas.active = false;
        break;

      case "vendas":
        tabbed.currentWidget = tabForcaVendas;
        tabForcaVendas.active = true;
        tabSAC.active = false;
        break;

      case "both":
        tabbed.currentWidget = tabForcaVendas;
        tabForcaVendas.active = true;
        tabSAC.active = false;
        break;

      default:
        tabbed.isVisible = false;
        zhPromise.resolve({
          activeWidget: tabbed,
        });
    }

    zhPromise.resolve({
      activeWidget: tabbed.currentWidget,
    });

    return zhPromise.promise;
  };

  this.setDimensions = function (container) {
    var widgets = container.widgets;
    if (window.innerWidth < 929) {
      widgets.forEach(function (widget) {
        widget.dimensions.width = 4.5;
        widget.width = 4.5;
      });
    }
  };

  this.openOpportunityWidgetWithoutFilterPopup = function () {
    ScreenService.openWindow(
      "product#crm00002_001_oportunidade_de_negocio"
    ).then(function () {
      var oportWid = templateManager.container.getWidget("oportunidadegrid");

      oportWid.fromDashboard = true;

      var filtroAberto = [
        {
          name: "P_NRORG",
          operator: "=",
          value: templateManager.LOGGEDOPERATOR.NRORG,
        },
        {
          name: "CRM_NRORGTRAB",
          operator: "=",
          value: getLocalVar("CRM_NRORGTRABALHO"),
        },
        {
          name: "SITUACAO",
          operator: "=",
          value: "A",
        },
        {
          name: "NRPARCRESP",
          operator: "IN",
          value: [templateManager.LOGGEDOPERATOR.NRPARCNEGOCIO],
        },
        {
          name: "IDTPOPERADOR",
          operator: "=",
          value: Util.isEmptyOrBlank(
            templateManager.LOGGEDOPERATOR.IDTPOPERADOR
          )
            ? "E"
            : templateManager.LOGGEDOPERATOR.IDTPOPERADOR,
        },
      ];

      oportWid.dataSourceFilter = filtroAberto;
      oportWid.reload().then(function () {
        ScreenService.closePopup(true);
      });
    });
  };

  this.openOpportunityWidgetWithPendencesFilterPopup = function () {
    ScreenService.openWindow("product#crm00002_001_oportunidade_de_negocio").then(function () {
        var oportWid = templateManager.container.getWidget("oportunidadegrid");

        oportWid.fromDashboard = true;

        var filtroAberto = [
            {
                name: "P_NRORG",
                operator: "=",
                value: templateManager.LOGGEDOPERATOR.NRORG,
            },
            {
                name: "CRM_NRORGTRAB",
                operator: "=",
                value: getLocalVar("CRM_NRORGTRABALHO"),
            },
            {
                name: "SITUACAO",
                operator: "=",
                value: "P",
            },
            {
                name: "CDOPERADORGEST",
                operator: "IN",
                value: [templateManager.LOGGEDOPERATOR.CDOPERADOR],
            },
            {
                name: "IDTPOPERADOR",
                operator: "=",
                value: Util.isEmptyOrBlank(templateManager.LOGGEDOPERATOR.IDTPOPERADOR)
                    ? "E"
                    : templateManager.LOGGEDOPERATOR.IDTPOPERADOR,
            }
        ];

        oportWid.dataSourceFilter = filtroAberto;
        oportWid.reload().then(function () {
            ScreenService.closePopup(true);
        });
    });
};

  this.getOccurrencesInfo = function () {
    var restRow = {
      CDOPERADOR: getLocalVar("CRM_CDOPERADOR"),
      CRM_NRORGTRAB: getLocalVar("CRM_NRORGTRABALHO"),
      NRORG: getLocalVar("CRM_NRORG"),
    };

    var params = {
      requestType: "Row",
      row: restRow,
    };

    return restEngine.post("/getOccurrences", params).then(function (response) {
      this.populetedOccurrenceCard(response);
      return response;
    }.bind(this)).catch(function () {
      return false;
    });
  };

  this.populetedOccurrenceCard = function (response) {
    var cardOccurrence = templateManager.container.getWidget("ocorrencias");
    cardOccurrence.isVisible = true;
    response.dataset.DADOS.forEach(function (key) {
      var newCurrentRow = [];
      newCurrentRow.push(key);
      cardOccurrence.dataSource.data = newCurrentRow;
    });
  };

  this.loadDataSources = function (widget) {
    if (widget.isVisible) {
      if (!Util.isEmptyOrBlank(widget.widgets)) {
        widget.widgets.forEach(
          function (inWidget) {
            this.loadDataSources(inWidget);
          }.bind(this)
        );
      }
      widget.reload();
    }
  };

  this.openChamadoWidgetWithoutFilterPopup = function () {
    ScreenService.openWindow("product#crm_20000_chamado").then(function () {
      var chamadoWidgt = templateManager.container.getWidget("WDGT_CHAMADO");
      chamadoWidgt.dataSourceFilter = [
        {
          name: "STATUS",
          operator: "=",
          static: true,
          value: "Aberto",
        },
        {
          name: "CDOPERCONT",
          operator: "IN",
          static: true,
          value: [templateManager.LOGGEDOPERATOR.CDOPERADOR],
        },
      ];
      chamadoWidgt.reload().then(function () {
        ScreenService.closePopup(true);
      });
    });
  };

  this.changeColorBarFunil = function (name) {
    $(document).ready(function () {
      var element = angular.element(name);
      element.find("g.bars").each(function (index, element) {
        //Declarando outra variavel de index para evitar perder o index do 'each'
        var indexColor = index;

        var colors = [
          "#7ad2e8",
          "#57b0cc",
          "#3f95af",
          "#3288a3",
          "#1b6077",
          "#0c3c4f",
          "#052b3a",
          "#011f2d",
          "#001119",
          "#00090f",
        ];

        //Se houver mais barras do que cores no array colors, continua pegando a última
        if (typeof colors[indexColor] === "undefined")
          indexColor = colors.length - 1;

        $(this).find("rect").attr("fill", colors[indexColor]);
        $(this).find("text").attr("fill", colors[indexColor]);
      });
    });
  };

  this.changeColorTerm = function (name, widget) {
    $(document).ready(function () {
      var element = angular.element(name);
      var data = widget.dataSource.data;
      element.find("g.slices .slice").each(function (index, element) {
        $(this).attr("fill", data[index]["CORTERMOMETRO"]);
        $(this).attr("fill", data[index]["CORTERMOMETRO"]);
      });
      element.find("g.slices .label-value").each(function (index, element) {
        $(this).attr("fill", data[index]["CORTERMOMETRO"]);
        $(this).attr("fill", data[index]["CORTERMOMETRO"]);
      });
      element.find(".legend-label path").each(function (index, element) {
        $(this).attr("fill", data[index]["CORTERMOMETRO"]);
        $(this).attr("fill", data[index]["CORTERMOMETRO"]);
      });
    });
  };

  this.openChartTermByOper = function (widget) {
    var mes = widget.currentRow.ORDEM;
    var operadores = templateManager.LOGGEDOPERATOR.CDOPERSHIERARQINF;

    ScreenService.openWindow("product#crm_indicadorTermometro").then(
      function () {
        this.getColors().then(function (termometro) {
          var nameTermometro = termometro.map(function (t) {
            return t["NMTERMOPORTUNI"];
          });

          var widgetChart = templateManager.container.getWidget(
            "WDGT_INDICADOR_TERMOMETRO"
          );

          if (!Util.isEmptyOrBlank(widgetChart.chartSeries[0].serieFields)) {
            widgetChart.chartSeries[0].serieFields = [];
            widgetChart.chartSeries[0].serieLabels = [];
            widgetChart.chartSeries[0].serieColors = [];
          }
          termometro.forEach(function (t) {
            widgetChart.chartSeries[0].serieFields.push(
              "'" + t["NMTERMOPORTUNI"] + "'"
            );
            widgetChart.chartSeries[0].serieLabels.push(t["NMTERMOPORTUNI"]);
            widgetChart.chartSeries[0].serieColors.push(t["DSCORHEXADECIMAL"]);
          });
          widgetChart.chartSeries[0].serieFields.push("'SEMTERM'");
          widgetChart.chartSeries[0].serieLabels.push("Sem Termômetro");
          widgetChart.chartSeries[0].serieColors.push("#ddd");

          widgetChart.dataSourceFilter = [
            {
              name: "P_NRORG",
              operator: "=",
              static: true,
              value: templateManager.LOGGEDOPERATOR.NRORG,
            },
            {
              name: "P_NRPARCOPERSHIERARQINF",
              operator: "IN",
              static: true,
              value: templateManager.LOGGEDOPERATOR.NRPARCOPERSHIERARQINF,
            },
            {
              name: "P_COLORS",
              operator: "=",
              static: true,
              value: nameTermometro,
            },
            {
              name: "P_CRM_NRORGTRAB",
              operator: "=",
              static: true,
              value: getLocalVar("CRM_NRORGTRABALHO"),
            },
          ];
          var stripe = templateManager.container.getWidget(
            "WDGT_INDICADOR_STRIPE"
          );
          stripe.fields[0].label = "Termômetro de Oportunidades";
          stripe.activate();
          widget.activate();
          widgetChart.reload();
          widgetChart.updateChart();
        });
      }.bind(this)
    );
  };

  this.getColors = function () {
    var filter = [
      {
        name: "NRORG",
        operator: "=",
        value: templateManager.LOGGEDOPERATOR.NRORG,
      },
    ];
    return localStorageEngine.download(
      "product#/crud/crm_termoportuni",
      filter
    );
  };

  this.openChartMetaByOper = function (widget, chart) {
    var mes = widget.currentRow.ORDEM;
    var operadores = templateManager.LOGGEDOPERATOR.CDOPERSHIERARQINF;

    ScreenService.openWindow("product#crm_indicadorMeta").then(
      function () {
        var widgetChart = this.chooseWidgetChart(chart);

        widgetChart.dataSourceFilter = [
          {
            name: "P_NRORG",
            operator: "=",
            static: true,
            value: templateManager.LOGGEDOPERATOR.NRORG,
          },
          {
            name: "P_CDOPERSHIERARQINF",
            operator: "IN",
            static: true,
            value: operadores,
          },
          {
            name: "ORDEM",
            operator: "=",
            static: true,
            value: mes.slice(0, 2),
          },
        ];
        widgetChart.currentRow["MES"] = mes;
        widgetChart.currentRow["ORDEM"] = widget.currentRow.ORDEM;
        var stripe = templateManager.container.getWidget(
          "WDGT_INDICADOR_STRIPE"
        );
        stripe.fields[0].label = widgetChart.label;
        //Replace pra pegar o ano no LocaleString
        stripe.fields[1].label = new Date(
          mes.replace("/", "/01/")
        ).toLocaleString("pt-BR", { month: "long", year: "numeric" });
        stripe.fields[1].label = CRM_Utilities.capitalizeFirstLetter(
          stripe.fields[1].label
        );
        stripe.chart = chart;
        widget.activate();
        widgetChart.reload();
      }.bind(this)
    );
  };

  this.chooseWidgetChart = function (chart) {
    var widget;
    switch (chart) {
      case "valor_oportunidades":
        widget = templateManager.container.getWidget("WDGT_INDICADOR_VALOR");
        widget.isVisible = true;
        templateManager.container.getWidget(
          "WDGT_INDICADOR_CONVERSAO"
        ).isVisible = false;
        break;

      case "conversao_leads":
        widget = templateManager.container.getWidget(
          "WDGT_INDICADOR_CONVERSAO"
        );
        widget.isVisible = true;
        templateManager.container.getWidget(
          "WDGT_INDICADOR_VALOR"
        ).isVisible = false;
        break;

      case "leads_cadastrados_convertidos":
        widget = templateManager.container.getWidget("WDGT_TAB_INDICADORLEAD");
        widget.isVisible = true;
        break;
    }
    return widget;
  };

  this.openChartLeadsByOper = function (widget) {
    var mes = widget.currentRow.ORDEM;

    ScreenService.openWindow("product#crm_indicadorLeads").then(
      function () {
        var widgetChart = templateManager.container.getWidget(
          "WDGT_TAB_INDICADORLEAD"
        );
        widgetChart.ORDEM = mes;
      }.bind(this)
    );
  };

  this.getOperatorPropertyIfSetted = function (propertyName) {
    var operatorInfos = templateManager.LOGGEDOPERATOR;

    if (operatorInfos) {
      return operatorInfos[propertyName];
    } else {
      return "";
    }
  };

  this.openTarefasWindow = function () {
    ScreenService.openWindow("product#crm31000_000_agenda_de_tarefas"
    ).then(function () {
        var taskWidget = templateManager.container.getWidget("Agenda");
        taskWidget.fromDashboard = true;
        var filtroAberto = [
          {
            name: "NRORG",
            operator: "=",
            value: templateManager.LOGGEDOPERATOR.NRORG,
          },
          {
            name: "CRM_NRORGTRAB",
            operator: "=",
            value: getLocalVar("CRM_NRORGTRABALHO"),
          },
          {
            name: "P_CDOPERLOGADO",
            operator: "=",
            value: getLocalVar("CRM_CDOPERADOR"),
          },
          {
            name: "STATUS_PRINCIPAL",
            operator: "IN",
            value: ["ATRASADA", "HOJE"],
          },
          {
            name: "CDOPERREAL",
            operator: "IN",
            value: [templateManager.LOGGEDOPERATOR.CDOPERADOR],
          },
        ];
        taskWidget.dataSourceFilter = filtroAberto;
        console.log(taskWidget);
        taskWidget.reload().then(function () {
          setTimeout(function () {
            ScreenService.closeSwipe(true);
          }, 200);
        });
      }
    );
  };
}

Configuration(function (ContextRegister) {
  ContextRegister.register("Dashboard_Controller", Dashboard_Controller);
});


// FILE: ./assets/js/controllers/EvolucaoController.js
function EvolucaoController(ScreenService, templateManager, Utilities, wizardEngine, ZHPromise, Operador_Repository, General, CRM_Utilities, restEngine, ChamadoController, evolutionTabController, ZHPromise) {

    /**
     * Função para mudar o readonly e o validations
     * dos campos de próxima tarefa baseado no resultado
     * da evolução.
    */
    this.checkNewTask = function(widget) {
        var currentRow = widget.currentRow;
        var fieldsNextTask = widget.fields.map(function(field) {
            if(field.fieldGroup && field.fieldGroup == "FG_AGENDAR_TAREFA")
                return field;
        }).filter(function(x) {
            return typeof x !== 'undefined';
        });
        if(currentRow.NEWTASK && currentRow.NEWTASK == "S") {
            fieldsNextTask.forEach(function(field) {
                field.readOnly = false;
                field.validations = {"required":true};
            });
        }else{
            fieldsNextTask.forEach(function(field) {
                field.readOnly = true;
                field.validations = {};
                field.applyDefaultValue();
            });    
        }
    };
    
    /**
     * Função para abrir a widget de seleção
     * de arquivos.
    */
    this.openAttachSwipe = function() {
        
        var fileUploadWidget = templateManager.container.getWidget('WDGT_SELECAO_ARQUIVOS');
        
        fileUploadWidget.isVisible = true;
        ScreenService.openSwipe(fileUploadWidget);
            
    };
    
    /**
     * Função para salvar os anexos selecionados
     * ao caso em questão.
     * 
     * @param {object} widget widget onde é
     * feito a seleção dos anexos.
    */
    this.uploadEvolutionFiles = function(widget, fromChamado) {
        
        var files = widget.currentRow.DSCAMINHO;
        
        var rows = [];
        
        files.forEach(function(file, fileIndex) {
            
            if(fromChamado)
                rows.push(this.setValuesForFileUpload(widget, fileIndex, fromChamado));
            else
                rows.push(this.setValuesForFileUpload(widget, fileIndex));
            
        }.bind(this));
        
        General.callRestEngine("product#/crm_anexocontato/save", "DataSet", rows).then(function() {
                
                this.closeAttachSwipe(widget);
                if(fromChamado) {
                    //Volta is new pra false
                    widget.currentRow.__is_new = false;
                    templateManager.container.getWidget('WDGT_ANEXOS_CHAMADO').reload();
                }else{
                    widget.parent.parent.reload();
                }
        }.bind(this)).catch(function() {
            widget.currentRow.__is_new = false;
        });
    };
    
    /**
     * Função para retornar uma row configurada
     * com as informações do anexo referente
     * ao ID, recebido como parâmetro, no array
     * de anexos na currentRow.
     * 
     * @param {object} widget widget onde foi selecionado
     * os anexos.Array
     * 
     * @param {int} fileIndex index do anexo no array de 
     * anexos presente na currentRow.
     * 
     * @return {object} currentRow row configurada com as informações
     * do anexo referente ao ID recebido.
    */
    this.setValuesForFileUpload = function(widget, fileIndex, fromChamado) {
        
        var currentRow = angular.copy(widget.currentRow);
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        if(!fromChamado)
            var evolutionWidget = widget.parent.parent;
        else
            var chamadoWidget   = templateManager.container.getWidget(fromChamado);
        
        if(evolutionWidget) {
            currentRow.NRSEQCONTATO = evolutionWidget.currentRow.NRSEQCONTATO;
            currentRow.IDORIGEM = "EVOLUCAO";
            currentRow.NRORIGEM = evolutionWidget.currentRow.NRSEQEVOLCONT;
        }else if(chamadoWidget) {
            currentRow.NRSEQCONTATO = chamadoWidget.currentRow.NRSEQCONTATO;
            currentRow.IDORIGEM = "CONTATO";
            currentRow.NRORIGEM = chamadoWidget.currentRow.NRSEQCONTATO;
        }
        
        currentRow.NMARQUIVO = this.getFileNameWithoutExtension(currentRow.DSCAMINHO[fileIndex].name);
        currentRow.DSTIPO = this.getFileExtension(currentRow.DSCAMINHO[fileIndex].name);
        currentRow.VRTAMANHO = currentRow.DSCAMINHO[fileIndex].size;
        currentRow.IDATIVO = "S";
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
        
        return currentRow;
        
    };
    
    /**
     * Função para retornar a extenção de um arquivo
     * extraida do seu nome.
     * 
     * @param {string} fileName nome completo do arquivo.
    */
    this.getFileExtension = function(fileName) {
        
        return fileName.replace(/^(.*)\.(.*)$/, "$2");
        
    };
    
    /**
     * Função para retornar o nome do arquivo sem
     * sua extenção.
     * 
     * @param {string} fileName nome completo do arquivo.
    */
    this.getFileNameWithoutExtension = function(fileName) {
        
        return fileName.replace(/^(.*)\.(.*)$/, "$1");
            
    };
    
    /**
     * Função para fechar o swipe de upload de imagens.
     * 
     * @param {object} widget widget de upload de imagens.
    */
    this.closeAttachSwipe = function(widget) {
        ScreenService.closeSwipe().then(function() {
            widget.isVisible = false;
            widget.parent.parent.list();
            widget.parent.parent.activate();
        });
    };
    
    /**
     * Função para fazer o download de uma arquivo
     * salvo no servidor.
     * 
     * @param {object} widget widget que contém
     * as informações do arquivo a ser baixado 
     * em sua currentRow.
    */    
    this.downloadFile = function(widget) {
        
        window.open(window.fileServerBaseUrl + widget.currentRow.DSCAMINHO);
            
    };
    
    /**
     * Verifica se já existem tarefas relacionadas
     * aquele parceiro
     * 
     * @param {object} widget widget de evolução
    */
    this.verificaTarefasAbertas = function(currentRow) {
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        
        var zhPromise = ZHPromise.defer();
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        
        restEngine.post('/verificaTarefas', paramsRestEngine).
            then(function(response) {
                if(response.dataset.DADOS.TAREFAS) {
                    var tarefas = response.dataset.DADOS.TAREFAS;
                    var operadores = '';
                    tarefas.forEach(function(tarefa) {
                        operadores +='<br>'+tarefa;
                    });
                    ScreenService.confirmMessage('Este parceiro possui tarefas "Em Aberto" para o(s) seguinte(s) operador(es) <br>'+operadores+'<br><br> Deseja continuar? ', 'CONFIRMATION',
                    function(success) {
                        zhPromise.resolve();
                    }.bind(this),
                    function(fail) {
                        zhPromise.reject();
                    });
                }else{
                    zhPromise.resolve();
                }
            }.bind(this));
        return zhPromise.promise;
    };
    
     /**
     * Preapara widgets de evolução, verificando tarefas
     * abertas e chama o método de save
     * 
     * @param {object} widget widget de evolução
    */
    this.checkEvolution = function(widget) {
        //prepara widget para a verificação
        if(!widget.currentRow.NRPARCNEGOCIO)
            widget.currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        
        if(widget.isValid()) {
            this.verificaTarefasAbertas(widget.currentRow).
                then(function() {
                    if(!widget.currentRow.EVOLUCAOPRECONCLUSAO === true) {
                        this.saveEvolution(widget);
                    }else{
                        ScreenService.closeSwipe();
                        templateManager.container.WIDGETEVOLUCAO = widget;
                        ChamadoController.concluirChamado(widget.parent);
                    }
                    widget.activate();
                }.bind(this)).
                catch(function() {
                    General.widgetCancelForm(widget);
                }.bind(this));
        }    
    };
    
     /**
     * Salva widgets de evolução, gerando nova tarefa
     * baseado no resultado da evolução
     * 
     * @param {object} widget widget de evolução
    */
    this.saveEvolution = function(widget) {
        var currentRow = widget.currentRow;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        widget.fields.forEach(function(field) {
            if(!Util.isEmptyOrBlank(field.fieldGroup)) {
                if(field.fieldGroup == 'FG_AGENDAR_TAREFA') {
            	    field.readOnly = true;
                }
            }
        });
        General.widgetSave(widget).then(function(responseEvol) {
            if (responseEvol.dataset.DADOS) {
                widget.currentRow.NRSEQEVOLCONT = responseEvol.dataset.DADOS.NRSEQEVOLCONT;
            }
            
            this.checkMail(widget).then(function() { 
                if(currentRow.NEWTASK && currentRow.NEWTASK == "S") {
                    var paramsRestEngine = {
                        "requestType": "Row",
                        "row": currentRow 
                    };
                    
                    restEngine.post('/generalInsertTask', paramsRestEngine). 
                        then(function(responseTask) {
                            ScreenService.showMessage('Nova Tarefa Criada!');    
                        }.bind(this)).
                        catch(function(fail) {
                            ScreenService.showMessage('Falha ao criar Tarefa.');
                        }.bind(this));
                        
                }
                if(widget.afterSave) {
                    widget.afterSave.forEach(function(method) {
                        eval(method);    
                    });
                }
                widget.reload();
            }.bind(this));
        }.bind(this));
    };
    
    this.checkMail = function(widget) {
        var promise = ZHPromise.defer();
        if(!Util.isEmptyOrBlank(widget.currentRow.NRSEQINTERLOCUTOR) && widget.currentRow.IDENVIAEMAIL === 'S') {
                    ScreenService.confirmMessage('Deseja enviar um email para '+widget.currentRow.NMINTERLOCUTOR+'?', 'QUESTION',
            function(yes) {
                evolutionTabController.openWidgetSendMail(widget).then(function() {
                    promise.resolve();
                });
            }, function(no) {
                promise.resolve();
            });
        }else{
            promise.resolve();
        }
        return promise.promise;
    };
    
    this.saveChamadoExterno = function(widget) {
        General.widgetSave(widget).then(function(response) {
            if(response.dataset.DADOS && response.dataset.DADOS.NRSEQCONTATO)
                widget.currentRow.NRSEQCONTATO = parseInt(response.dataset.DADOS.NRSEQCONTATO);
                widget.reload().then(function() {
                    //seta is new pra true pra fazer a inserção do anexo
                    if(widget.currentRow.DSCAMINHO) {
                        widget.currentRow.__is_new = true;
                        this.uploadEvolutionFiles(widget, 'WDGT_ABERTURA_CHAMADO');
                    }
                }.bind(this));
        }.bind(this));
    }
    
    this.setDTFilter = function(args) {
        var wid = args.owner;
        var filter = wid.dataSourceFilter;
        
        filter.forEach(function(f) {
            if(f.name === 'DTHREVOLCONT' || f.name === 'DATAINCLUSAO' || f.name === 'DTREALFILACONTA' || f.name === 'DTPREVFECHA') {
                f.value[1] = f.value[1] + ' 23:59';
            }
        });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('EvolucaoController', EvolucaoController);
});

// FILE: ./assets/js/controllers/ger01200_estadoController.js
function ger01200_estadoController(ScreenService, General, Ger01200_Estado_Service) {

	this.salvar = function (widget) {
		if (widget.isValid()) {
			Ger01200_Estado_Service.salvarEstado(widget.currentRow).then(function (Success) {
					if (widget.currentRow.__is_new) {
						widget.reload().then(function () {
							widget.list(true);
							ScreenService.closeSwipe();
						});
					} else {
						widget.view();
					}
				}.bind(this),
				function (callback) {
					if (callback.data) {
						ScreenService.showMessage(callback.data.error);
					}
				});
		}
	};

	this.toAddCountry = function (args) {
		var arr = args.owner.widget.dataSourceFilter;
		var nm_pais = args.owner.widget.appliedFilter.FILTER_ROW.NMPAIS;
		var cd_pais = args.owner.widget.appliedFilter.FILTER_ROW.CDPAIS;
		args.owner.widget.newRow();
		args.owner.widget.currentRow.NMPAIS = nm_pais;
		args.owner.widget.currentRow.CDPAIS = cd_pais.toString();
	};

	this.controlaCampoEstado = function (widget) {
		var estado = widget.getField('NMESTADO');
		widget.currentRow.NMESTADO = '';
		widget.currentRow.SGESTADO = '';
		if (widget.currentRow.CDPAIS) {
			estado.readOnly = false;
		} else {
			estado.readOnly = true;
		}
	};

	this.setFiltroEstado = function (widget) {
			var estado = widget.getField('NMESTADO');
		estado.dataSourceFilter[0].value = widget.currentRow.CDPAIS;
		estado.reload();
	};

	this.converteSiglaEstadoMaisculo = function (field) {
		field.value(field.value().toUpperCase());

	};
}

Configuration(function (ContextRegister) {
	ContextRegister.register('ger01200_estadoController', ger01200_estadoController);
});

// FILE: ./assets/js/controllers/Ger01300_Pais_Controller.js
function Ger01300_Pais_Controller(General,Ger01300_Pais_Service,ScreenService){


    this.savePais = function(widget){
        if(widget.isValid()){
          	Ger01300_Pais_Service.salvarPais(widget.currentRow).then(function(Success) {
            	if (widget.currentRow.__is_new) {
		            widget.reload().then(function() {
                   		widget.list(true);
                   		ScreenService.closeSwipe();
                    });
                }
                else {
                    widget.view();
                }
            }.bind(this),
            function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('Ger01300_Pais_Controller', Ger01300_Pais_Controller);
});


// FILE: ./assets/js/controllers/Ger01500_municipio.js
function Ger01500_municipio(ScreenService, General, Ger01500_Municipio_Service){

    this.filtraEstado = function(widget){
        widget.getField('NMESTADO').readOnly    = widget.currentRow.CDPAIS?false:true;
        widget.getField('NMMUNICIPIO').readOnly = true;
        
        widget.currentRow.SGESTADO = '';
        widget.currentRow.NMESTADO = '';
        widget.currentRow.CDMUNICIPIO ='';
        widget.currentRow.NMMUNICIPIO ='';
        
		widget.getField('NMESTADO').dataSourceFilter[0].value = widget.currentRow.CDPAIS;
    };
    
    this.filtraMunicipio = function(widget){
        widget.getField('NMMUNICIPIO').readOnly    = widget.currentRow.SGESTADO?false:true;
        
        widget.currentRow.CDMUNICIPIO ='';
        widget.currentRow.NMMUNICIPIO ='';
        
		widget.getField('NMMUNICIPIO').dataSourceFilter[0].value = widget.currentRow.CDPAIS;
		widget.getField('NMMUNICIPIO').dataSourceFilter[1].value = widget.currentRow.SGESTADO;
    };
    
    this.blockFields = function(args){
        var widget = args.owner;
        widget.getField('NMPAIS').readOnly = true;
        widget.getField('NMESTADO').readOnly = true;
    };

    this.takeLocations = function(widget){
        var popupCurrentRow = widget.appliedFilter.FILTER_ROW;
        widget.currentRow.NMPAIS = popupCurrentRow.NMPAIS;
        widget.currentRow.CDPAIS = popupCurrentRow.CDPAIS;
        widget.currentRow.NMESTADO = popupCurrentRow.NMESTADO;
        widget.currentRow.SGESTADO = popupCurrentRow.SGESTADO;
    };

    this.salvarMunicipio = function (widget){
        if(widget.currentRow.CDPAIS && widget.currentRow.SGESTADO){
            if(widget.isValid()){
                Ger01500_Municipio_Service.salvarMunicipio(widget.currentRow).then(function(Success) {
                    this.controlaStatusWidgets(widget,'municipio',true); 
                    if (widget.currentRow.__is_new) {
                        widget.reload().then(function() {
                            widget.list(true);
                            ScreenService.closeSwipe();
                        });
                    }
                    else {
                        widget.view();
                    }
                }.bind(this),
                function(callback){
                    if(callback.data){
                        ScreenService.showMessage(callback.data.error);
                    }
                });
            }   
        }else{
            ScreenService.showMessage('Campos do filtro não preenchidos.');
        }
       
    };
    
    this.addBairro = function (widget){
        var widgetMunicipio           = widget.getParent();
        var filtro =  {
            "CDPAIS"     : widgetMunicipio.currentRow.CDPAIS,
            "SGESTADO"   : widgetMunicipio.currentRow.SGESTADO,
            "CDMUNICIPIO": widgetMunicipio.currentRow.CDMUNICIPIO
        };
        widget.newRow();
        Ger01500_Municipio_Service.novoCodigoBairro(filtro).then(
            function(success) {
                var codigo                    = formatCdbairro(String (success.dataset.CDBAIRRO.CDBAIRRO[0].MAIORBAIRRO));
                widget.currentRow.CDBAIRRO    = codigo.substring(0,10);
                widget.currentRow.CDPAIS      = widgetMunicipio.currentRow.CDPAIS;
                widget.currentRow.SGESTADO    = widgetMunicipio.currentRow.SGESTADO;
                widget.currentRow.CDMUNICIPIO = widgetMunicipio.currentRow.CDMUNICIPIO;
            },
            function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            }
        );
       
    };
    
    function formatCdbairro (string){
        switch (string.length){
            case 1:
                return '000000000' + string;
            case 2:
                return '00000000' + string;
            case 3:
                return '0000000' + string;
            case 4:
                return '000000' + string;
            case 5:
                return '00000' + string;
            case 6:
                return '0000' + string;
            case 7:
                return '000' + string;
            case 8:
                return '00' + string;
            case 9:
                return '0' + string;
            case 10:
                return string;
        }
    }
    
    this.addMunicipio = function (widget){
        var filtro = widget.appliedFilter.FILTER_ROW;
        widget.newRow();
        widget.currentRow.CDPAIS   = filtro.CDPAIS;
        widget.currentRow.SGESTADO = filtro.SGESTADO;
        this.controlaStatusWidgets(widget,'municipio',false); 
    };
    
    this.controlaStatusWidgets = function(mainWidget, nomeWidgetAtual, status){
        mainWidget.widgets.forEach(function(widg) {
            if(nomeWidgetAtual !== widg.name)
                widg.enabled = status;
        });

        if(mainWidget.name !== nomeWidgetAtual)
            mainWidget.enabled = status;
    };
    
    this.salvarBairro = function (widget){
        if(widget.isValid()){
            if(widget.currentRow.QTHORAENTREGA)
                widget.currentRow.QTHORAENTREGA = widget.currentRow.QTHORAENTREGA.replace(/[^0-9]/g,'');
            General.saveCrud(widget);
            
        }
    };
    
    this.addRegiao = function (widget){
        var widgetMunicipio           = widget.getParent();
        var filtro =  {
            "CDPAIS"     : widgetMunicipio.currentRow.CDPAIS,
            "SGESTADO"   : widgetMunicipio.currentRow.SGESTADO,
            "CDMUNICIPIO": widgetMunicipio.currentRow.CDMUNICIPIO
        };
        widget.newRow();
        Ger01500_Municipio_Service.novoCodigoRegiao(filtro).then(
            function(success) {
                var codigo                     = formatCdregiaoMuni(String(success.dataset.CDREGIAOMUNI.CDREGIAOMUNI[0].MAIORREGIAO));
                widget.currentRow.CDREGIAOMUNI = codigo.substring(0,4);
                widget.currentRow.CDPAIS       = widgetMunicipio.currentRow.CDPAIS;
                widget.currentRow.SGESTADO     = widgetMunicipio.currentRow.SGESTADO;
                widget.currentRow.CDMUNICIPIO  = widgetMunicipio.currentRow.CDMUNICIPIO;
            },
            function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            }
        );
       
    };
    
    function formatCdregiaoMuni (string){
        switch (string.length){
            case 1:
                return '000' + string;
            case 2:
                return '00' + string;
            case 3:
                return '0' + string;
        }
    }
    
    this.recarrecarWidgetsFilhas = function (widget){
        if(! widget.currentRow.__is_new){
            widget.widgets.forEach(function(widg) {
                widg.reload();
            });
        }
    };
    
    this.filtraEstadoFilter = function(field){
        var fieldEstado = field.widget.container.getWidget('municipio').getField('NMESTADO');
        
        			var estado =field.widget.container.getWidget('municipio').getField('NMESTADO');
		estado.dataSourceFilter[0].value = widget.currentRow.CDPAIS;
		estado.reload();
        
        
        var country = field.widget.container.getWidget('municipio');

        field.getParent().getField('NMESTADO').readOnly    = country.currentRow.CDPAIS?false:true;
        field.getParent().getField('NMMUNICIPIO').readOnly = true;
        
        field.getParent().getField('NMESTADO').value('');
        
        country.currentRow.NMMUNICIPIO ='';
        country.currentRow.CDMUNICIPIO ='';

        country.currentRow.SGESTADO = '';
        
    };
    
    this.filtraMunicipioFilter = function(field){
        var fieldMunicipio = field.widget.container.getWidget('municipio').getField('NMMUNICIPIO');
        var country = field.widget;

        if(country.currentRow.CDPAIS && country.currentRow.SGESTADO){
            field.getParent().getField('NMMUNICIPIO').readOnly = false;

        }else{
            field.getParent().getField('NMMUNICIPIO').readOnly = true;
        }
        


    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('Ger01500_municipio', Ger01500_municipio);
});

// FILE: ./assets/js/controllers/ger01900_cadastroproduto_controller.js
var ger01900_cadastroproduto_controller = function (ScreenService, ProdutoService, General, templateManager, CRM_Utilities) {

	var parent = this;


	this.filtraArvProduto = function (widget) {
		if (widget.mode !== 'edit' && widget.mode !== 'view') {

			var cdproduto = widget.parent.parent.currentRow.CDPRODUTO;
			var filtro = [
				{
					"name": "CDPRODUTO",
					"operator": "=",
					"value": cdproduto
                }
            ];
			widget.dataSourceFilter = filtro;
			widget.reload();
			widget.activate();

		}
	};

	this.onChangeTipoArv = function (field) {
		var value = field.value();
		if (!Util.isEmptyOrBlank(value)) {
			var nrtparvprod = field.widget.currentRow.NRTPARVPROD;
			field.widget.getField('NMARVOREPROD').dataSourceFilter = [
				{
					"name": "NRTPARVPROD",
					"operator": "=",
					"value": nrtparvprod
                }
            ];
			field.widget.getField('NMARVOREPROD').reload().then(function () {
				field.widget.getField('NMARVOREPROD').readOnly = false;
				field.widget.getField("NMARVOREPROD").validations = {
					"required": true
				};
			});
		} else {
			field.widget.getField('NMARVOREPROD').readOnly = true;
			field.widget.getField('NMARVOREPROD').value('');
			field.widget.getField("NMARVOREPROD").validations = undefined;
		}
	};

	this.saveProduto = function (widget) {
		
		var currentRow = widget.currentRow;
        CRM_Utilities.setColumnToReturnInCurrentRow(currentRow, "CDPRODUTO");
		
		if(widget.isValid()){
			General.widgetSave(widget).then(function (success) {
				widget.dataSourceFilter.push({
					"name":"CDPRODUTO",
					"operator":"=",
					"value": success.dataset.columnsToReturn[0].CDPRODUTO
				});
				widget.reload().then(function () {
					widget.dataSourceFilter.pop();
				});
			}).catch(function(err) {
				ScreenService.showMessage(err.data.error);
			});
			
		}

	};

	this.saveProdutoArvoreProduto = function (widget) {
		if (widget.isValid()) {
			var row = widget.currentRow;
			ProdutoService.saveProdArvProd(row).then(function (success) {
				ScreenService.showMessage('Salvo com sucesso!');
				General.changeWidgetAcessibility(widget.widgets, true);
				widget.reload().then(function () {
					widget.view();
					ScreenService.closeSwipe();
					widget.getField('NMARVOREPROD').readOnly = true;
					widget.getField('NMARVOREPROD').value('');
					widget.getField("NMARVOREPROD").validations = undefined;
				});
			}, function (err) {
				ScreenService.showMessage(err.data.error);
			});
		}
	};

};

Configuration(function (ContextRegister, eventEngine) {
	ContextRegister.register('ger01900_cadastroproduto_controller', ger01900_cadastroproduto_controller);
});

// FILE: ./assets/js/controllers/ger01901_cadastro_tipo_arvore_produto_controller.js
var ger01901_cadastro_tipo_arvore_produto_controller = function (ScreenService, ProdutoService, General) {

	var G_NRARVPRODPAI;
	var G_NMARVPRODPAI;
	var G_NRTPARVPRODPAI;

	this.novoTipoArvore = function (widget) {
		widget.newRow();
		ScreenService.openSwipe(widget);
	};

	this.onEnterEstrutura = function (widget) {
		if (widget.mode == "list")
			widget.reload();
	};

	this.onEnterTabTipoArvore = function (widget) {
		if (widget.mode == "edit") {
			widget.container.getWidget("estrutura").isVisible = false;
		} else {
			widget.container.getWidget("estrutura").isVisible = true;
		}
	};

	this.desabilitaEHabilitaEstrutura = function (widget, option) {
		General.changeWidgetAcessibility(widget.widgets, option);
	};

	this.onEnterTabEstrutura = function (widget) {

		var nrtparvprod = widget.container.getWidget('tipoarvoreproduto').currentRow.NRTPARVPROD;

		var filter = [
			{
				"name": "NRTPARVPROD",
				"operator": "=",
				"value": nrtparvprod
            }
        ];

		widget.dataSourceFilter = filter;
		widget.getField('NMARVOREPRODPAI').dataSourceFilter = angular.copy(filter);
		
		widget.reload();

	};

	this.getArvProdPai = function (widget) {

		G_NRARVPRODPAI = widget.currentRow.NRARVOREPROD;
		G_NMARVPRODPAI = widget.currentRow.NMARVOREPROD;

	};

	this.novoItemEstrutura = function (widget) {
		var novoNrarvoreprodpai;
		var novoNmarvoreprodpai;
		if (widget.mode === "view") {
			novoNrarvoreprodpai = typeof (widget.currentRow.NRARVOREPROD) !== "undefined" ? widget.currentRow.NRARVOREPROD : null;
			novoNmarvoreprodpai = typeof (widget.currentRow.NMARVOREPROD) !== "undefined" ? widget.currentRow.NMARVOREPROD : null;
		} else {
			novoNrarvoreprodpai = null;
			novoNmarvoreprodpai = null;
		}

		ScreenService.openSwipe(widget).then(function () {
			widget.edit();
			widget.newRow();
			widget.getField('NMARVOREPRODPAI').setValue(novoNmarvoreprodpai);
			widget.currentRow.NRARVOREPRODPAI = novoNrarvoreprodpai;
			widget.currentRow.NRTPARVPRODPAI = widget.currentRow.NRTPARVPROD;
		});

	};

	this.salvarNovoItemEstrutura = function (widget) {

		widget.currentRow.NRTPARVPROD = widget.container.getWidget('tipoarvoreproduto').currentRow.NRTPARVPROD;
		widget.currentRow.NRTPARVPRODPAI = widget.container.getWidget('tipoarvoreproduto').currentRow.NRTPARVPROD;
		widget.currentRow.NRARVOREPRODPAI = !(typeof widget.currentRow.NRARVOREPRODPAI === "undefined" || widget.currentRow.NRARVOREPRODPAI === null) ? widget.currentRow.NRARVOREPRODPAI : null;
		if (!widget.currentRow.__is_new && verificaParentesco(widget)) {
			General.saveCrud(widget).then(function () {
				widget.reload();
			});
		} else if (widget.currentRow.__is_new) {
			General.saveCrud(widget).then(function () {
				widget.reload();
				widget.currentRow = {};
			});
		} else {
			ScreenService.showMessage("O grupo nao pode ser movido para um de seus grupos filhos");
		}

	};

	var verificaParentesco = function (widget) {

		var valido = true;

		if (!widget.currentRow.__is_new) {
			var rows = widget.dataSource.data;
			var nrarvoreprodpai = widget.currentRow.NRARVOREPRODPAI !== "undefined" && widget.currentRow.NRARVOREPRODPAI !== null ? widget.currentRow.NRARVOREPRODPAI.toString() : "";
			var nrarvoreprod = widget.currentRow.NRARVOREPROD.toString();
			rows.forEach(function (row) {
				if (row.NRARVOREPROD === nrarvoreprodpai) {
					if (row.NRARVOREPRODPAI === nrarvoreprod)
						valido = false;
				}
			});
		}

		return valido;

	};

	this.filtroParaNivelPai = function (widget) {

		var field = widget.getField('NMARVOREPRODPAI');
		if (typeof widget.currentRow.NRARVOREPROD !== "undefined") {
			field.dataSourceFilter.push({
				"name": "NRARVOREPROD",
				"operator": "<>",
				"value": widget.currentRow.NRARVOREPROD
			});
		}
		field.reload();
	};

};

Configuration(function (ContextRegister, eventEngine) {
	ContextRegister.register('ger01901_cadastro_tipo_arvore_produto_controller', ger01901_cadastro_tipo_arvore_produto_controller);
});

// FILE: ./assets/js/controllers/ger01902_arvore_de_produto_controller.js
var ger01902_arvore_de_produto_controller = function(ScreenService, General) {

	this.onLoadDataSource = function(widget){
		widget.dataSource.data.forEach(function(item){
			if(item.HASCHILD == "S"){
				item._hasChild = true;
			}
		});
		/*Gambs pra conseguir filtrar o tree grid*/
		widget.dataSource.data = Util.isEmptyOrBlank(widget.plainTreeData) ? widget.dataSource.data : widget.plainTreeData;
	};

};

Configuration(function(ContextRegister, eventEngine) {
    ContextRegister.register('ger01902_arvore_de_produto_controller', ger01902_arvore_de_produto_controller);
});

// FILE: ./assets/js/controllers/Ger05400_Logradouro_Controller.js
function Ger05400_Logradouro_Controller(General,Ger05400_Logradouro_Service,ScreenService){


    this.saveLogradouro = function(widget){
        if(widget.isValid()){
          	Ger05400_Logradouro_Service.salvarLogradouro(widget.currentRow).then(function(Success) {
            	if (widget.currentRow.__is_new) {
		            widget.reload().then(function() {
                   		widget.list(true);
                   		ScreenService.closeSwipe();
                    });
                }
                else {
                    widget.view();
                }
            }.bind(this),
            function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('Ger05400_Logradouro_Controller', Ger05400_Logradouro_Controller);
});


// FILE: ./assets/js/controllers/ger10120_segmento_mercado_controller.js
function ger10120_segmento_mercado_controller(General) {
    
    /**
     * Função para salvar um novo segmento
     * de mercado.
     * 
     * @param {object} widget ativa, no modo
     * de edição, onde contém os valores do novo
     * segmento de mercado.
    */
    this.saveMarketSegment = function(widget){
        
        this.setMarketSegmentDefaultValues(widget);
        
        General.widgetSave(widget).then(function(response){
            widget.reload();
        });
           
    };
   
    /**
     * Função para setar os valores padrão
     * do novo segmento de mercado.
     * 
     * @param {object} widget widget que receberá
     * os valores padrão em sua currentRow.
    */
    this.setMarketSegmentDefaultValues = function(widget){
        
        var currentRow = widget.currentRow;
        
        currentRow.DTULTATUSEGM = "";
        currentRow.CDPRECOPROP = "";
    };
    
}

Configuration(function (ContextRegister) {
    ContextRegister.register("ger10120_segmento_mercado_controller", ger10120_segmento_mercado_controller);
});



// FILE: ./assets/js/controllers/ger45000_Prospect_Controller.js
function ger45000_Prospect_Controller(
  ScreenService,
  Utilities,
  Operador_Repository,
  ValidationEngine,
  templateManager,
  General,
  restEngine,
  Endereco,
  ger00004500_Prospect_Service,
  ZHPromise,
  CRM_Utilities,
  Messages,
  ABEvolucaoController,
  crm00002001_OportunidadeNegocio_Controller,
  AbaInterlocutorController,
  ABAEnderecoParceiroController,
  PartnerInfosModalController,
  evolutionTabController,
  ABALogotipoParceiroController,
  ZhFilterPreferences,
  CRM_ParceiroNegocio_Controller,
  CRM_ParceiroNegocio_Service
) {
  CRM_Utilities.addController(this, "ger45000_Prospect_Controller");

  var self = this;
  var opportunityWidgetActions;

  this.changeValueFilter = function(widget){
    
    var grid = widget;
    var filterProspect = templateManager.container.getWidget("gridProspect");
    var getFieldParcResp = filterProspect.getField('NRPARCRESPROSP');

    if(grid.currentRow.IDOPERATIVO == "I"){
      getFieldParcResp.dataSourceFilter[1].value = "I";
      grid.getField('NRPARCRESPROSP').clearValue();
      getFieldParcResp.reload();
    } else {
      getFieldParcResp.dataSourceFilter[1].value = "A";
      getFieldParcResp.reload();
    }
  }

  this.setAuditInfo = function (widget) {
    var currentRow = widget.currentRow;

    if (widget.currentRow.__is_new) {
      currentRow.DTINCLUSAO = self.momentNow();
      currentRow.CDOPERINCLUSAO = currentRow.CODOPERLOGGED;
      currentRow.CDOPERULTATU = currentRow.CODOPERLOGGED;
      currentRow.NRORGULTATU = currentRow.NRORG;
    } else {
      currentRow.DTULTATU = self.momentNow();
      currentRow.CDOPERULTATU = currentRow.CODOPERLOGGED;
      currentRow.NMOPERULTATU = currentRow.NMOPERLOGGED;
      currentRow.NRORGULTATU = currentRow.NRORG;
    }
  };

  this.gridProspectAfterMoveRow = function (widget) {
    var IntegracaoRDStationController = CRM_Utilities.getController(
      "IntegracaoRDStationController"
    );

    this.shootsMainWidgetEventsAfterMoveRow(widget);
    IntegracaoRDStationController.insertSendActionRD(widget, "Prospect");
    CRM_ParceiroNegocio_Controller.setInscEstadualSelect(widget);

    if (!widget.currentRow.__is_new) {
      this.setUnmergeActionVisibility(widget);
    }
  };

  this.setOperatorLoggedInCurrentRow = function () {
    var user = {
      cdoperador: getLocalVar("CRM_CDOPERADOR"),
      nrorg: getLocalVar("CRM_NRORG"),
    };

    Operador_Repository.retornaOperadorLogado(user).then(function (operator) {
      if (self.operatorIsValid(operator) === false) {
        return;
      }
      var widget = templateManager.container.getActiveWidget();

      widget.currentRow.CODOPERLOGGED = operator[0].CDOPERADOR;
      widget.currentRow.NMOPERLOGGED = operator[0].NMOPERADOR;
    });
  };

  this.getFilterPosition = function (dataSourceFilter, name) {
    var indexFilterObject;

    dataSourceFilter.forEach(function (value, i) {
      if (value.name === name) {
        indexFilterObject = i;
        return;
      }
    });
    return indexFilterObject;
  };

  this.operatorIsValid = function (operator) {
    if (operator[0] === undefined || operator[0] === null) {
      ScreenService.showMessage("Erro ao realizar a operação.");
      return false;
    }
    return true;
  };

  this.momentNow = function () {
    return moment(new Date()).format("DD/MM/YYYY HH:mm:ss");
  };

  this.createEqualFilter = function (name, value) {
    var filter = [
      {
        name: name,
        operator: "=",
        value: value,
      },
    ];
    return filter;
  };

  this.validationPhone = function (field) {
    var numberSizeReceived = field.value().replace(/[^0-9]/g, "").length;
    if (
      numberSizeReceived !== 10 &&
      numberSizeReceived !== 11 &&
      numberSizeReceived !== 12
    ) {
      ScreenService.showMessage("Telefone Inválido");
      field.clearValue();
      return false;
    }
  };

  this.setAddressDefaultValue = function (currentRow) {
    currentRow.CDPAIS = "";
    currentRow.SGESTADO = "";
    currentRow.CDMUNICIPIO = "";
    currentRow.CDBAIRRO = "";
  };

  this.setWidgetsVisibility = function (widgetParent, value) {
    widgetParent.widgets.forEach(function (widget) {
      widget.isVisible = value;
    });
  };

  this.verificaEndereco = function (widget) {
    var fields = widget.fields;
    widget.currentRow.REPLICAENDERECO = false;
    widget.currentRow.CODOPERLOGGED = widget.getParent().currentRow.CODOPERLOGGED;
    fields.forEach(function (field) {
      if (field.fieldGroup == "ENDER_INTER") {
        if (!Util.isEmptyOrBlank(field.value()))
          widget.currentRow.REPLICAENDERECO = true;
        else field.setValue("");
      }
    });
  };

  this.saveProspectAndSetAudit = function () {
    var widget = templateManager.container.getActiveWidget();
    if (widget.isValid()) {
      if (Util.isEmptyOrBlank(widget.currentRow.NMFANTPROS)) {
        widget.currentRow.NMFANTPROS = widget.currentRow.NMRAZSOCPROS;
      }
      widget.currentRow.NRINSJURPROS = widget.currentRow.NRINSJURPROS.toString().replace(
        /[^0-9]/g,
        ""
      );
      widget.currentRow.CDTIPOPARCEIRO = "PROSPECT";
      widget.currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
      this.setAuditInfo(widget);

      CRM_Utilities.saveWidget(widget, false).then(
        function (response) {
          if (widget.currentRow.__is_new) {
            widget.currentRow.NRPARCNEGOCIO =
              response.dataset.DADOS.NRPARCNEGOCIO;
          }
          this.classConcorrente(widget);
          this.saveEnderecoProspect(widget)
            .then(function () {
              if (response && response.dataset && response.dataset.DADOS) {
                widget.reload().then(function () {
                  widget.view();
                });
              } else {
                widget.reload();
              }
            })
            .catch(function (error) {
              CRM_Utilities.showErrorMessage(error);
              widget.reload();
            });

          widget.currentRow.DIASFIMCONTRATO = this.calculaDiasFimContrato(
            widget.currentRow.DTFIMVIGENCIA
          );

          widget.currentRow.NRCONCORRPROSPECT = response.dataset.CONCORRENTE
            ? response.dataset.CONCORRENTE.NRCONCORRPROSPECT
            : widget.currentRow.NRCONCORRPROSPECT;
        }.bind(this)
      );
    }
  };

  this.saveEnderecoProspect = function (widget) {
    // Promise que será resolvida quando o endereço for salvo
    var deferred = ZHPromise.defer();

    var parametroRestEngine = {
      requestType: "Row",
      row: {
        NRPARCNEGOCIO: widget.currentRow.NRPARCNEGOCIO,
        NRORG: widget.currentRow.NRORG,
      },
    };

    restEngine.post(
      "/crm_enderecoparc/findEndereco",
      parametroRestEngine,
      function (response) {
        var row = {
          NRPARCNEGOCIO: widget.currentRow.NRPARCNEGOCIO,
          CDTIPOENDERECO: "PRINCIPAL",
          NRORG: widget.currentRow.NRORG,
          IDATIVO: "S",
          CDPAIS: widget.currentRow.CDPAIS,
          SGESTADO: widget.currentRow.SGESTADO,
          CDMUNICIPIO: widget.currentRow.CDMUNICIPIO,
          CDBAIRRO: widget.currentRow.CDBAIRRO,
          CDLOGRADOURO: widget.currentRow.CDLOGRADOURO,
          NMBAIRROENDERECO: widget.currentRow.NMBAIRROENDERECO,
          DSCOMPLEENDERECO: widget.currentRow.DSCOMPLEENDERECO,
          NRCEPENDERECO: widget.currentRow.NRCEPENDERECO,
          DSENDERECO: widget.currentRow.DSENDERECO,
          NRIMOVELENDERECO: widget.currentRow.NRIMOVELENDERECO,
        };

        if (response.dataset.columnsToReturn[0]) {
          row.__is_new = false;
          row.tipoEnderecoWasEdited = false;
        } else row.__is_new = true;

        CRM_ParceiroNegocio_Service.salvarEndereco(row)
          .then(
            function (successData) {
              if (widget.isNewRow()) {
                if (successData.dataset) {
                  widget.currentRow.NRENDERECOPARC =
                    successData.dataset.columnsToReturn.NRENDERECOPARC;
                }
                widget.currentRow.__is_new = false;
              }
              deferred.resolve();
            },
            function (error) {
              var errorMessage = "Timeout";
              if (error.data) {
                errorMessage = error.data.error;
              }
              ScreenService.showMessage(errorMessage);
            }
          )
          .catch(CRM_Utilities.showErrorMessage);
      },
      undefined,
      function (error) {
        CRM_Utilities.showErrorMessage(error);
      },
      null,
      3000000
    );

    return deferred;
  };

  //Função usada tanto na tela de lead quanto na de prospect!
  this.mergeProspect = function (widget) {
    var mainWid = widget.getParent();

    if (widget.isValid()) {
      var parametroRestEngine = {
        requestType: "Row",
        row: widget.currentRow,
      };

      CRM_Utilities.post(
        "/mergeParceiro",
        parametroRestEngine,
        undefined,
        undefined,
        undefined
      ).then(
        function (response) {
          CRM_Utilities.reloadGridInViewMode(mainWid).then(function () {
            this.setUnmergeActionVisibility(mainWid);
            widget.currentRow.NRPARCORIGEM = "";
            widget.currentRow.NRPARCORIGEM = "";
            this.closeWidgetFundirParc(widget);
            ScreenService.showMessage("Processo realizado com sucesso!");
          }.bind(this));
        }.bind(this)
      );
    }
  };

  this.openSwipeFundirAndSetName = function (widget) {
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      function (canEdit) {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                var widgetFundir = templateManager.container.getWidget("FUNDIRPROSP");
                var fieldOrigem = widgetFundir.getField("NRPARCORIGEM");

                ScreenService.closePopup();
                ScreenService.openPopup(widgetFundir);

                widgetFundir.activate();
                widgetFundir.newRow();

                widgetFundir.currentRow.NMDESTINO = widget.currentRow.NMRAZSOCPROS;
                widgetFundir.currentRow.NRPARCDESTINO = widget.currentRow.NRPARCNEGOCIO;
                widgetFundir.currentRow.NRORG = widget.currentRow.NRORG;
                widgetFundir.currentRow.CDOPEREVOL = templateManager.LOGGEDOPERATOR.CDOPERADOR;

                var origemFilter = CRM_Utilities.getComponentDataSourceFilter(
                  fieldOrigem,
                  "NRPARCORIGEM"
                );

                origemFilter.value = widget.currentRow.NRPARCNEGOCIO;
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                  response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                  " - " +
                  response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                  "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }.bind(this)
    );
  };

  this.closeWidgetFundirParc = function (widget) {
    ScreenService.closePopup();
    self.cleanWidgetFields(widget);
    widget.getParent().view();
    widget.getParent().activate();
  };

  this.cleanWidgetFields = function (widget) {
    widget.fields.forEach(function (field) {
      field.value("");
    });
  };

  /**
   * Inicia o mvc para realizar um insert de tarefas
   * na widget de Evolução
   *
   * @param {object} widget widget Evolução
   * para pegar a currentRow.
   *
   * @return {object} (deferred | restEngine) retorna
   * a promisse da finalização da inserção da tarefa,
   * ou a promisse da finalização da execução função.
   */
  this.insertRowNextTask = function (widget) {
    var currentRow = widget.currentRow;
    var deferred = ZHPromise.defer();

    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");

    if (currentRow.DTPLANFILACONTA && !currentRow.NEXTTASKBLOCKED) {
      return ger00004500_Prospect_Service.callForInsertProspect(
        widget.currentRow
      );
    }

    deferred.resolve();
    return deferred;
  };

  /**
   * Inicia o mvc para realizar um insert de tarefas
   * na widget de Evolução
   */
  this.evolucaoNewRow = function () {
    var widget;

    widget = templateManager.container.getActiveWidget();

    if (
      !Util.isEmptyOrBlank(templateManager.container.getWidget("evolucaoOport"))
    ) {
      widget = templateManager.container.getWidget("evolucaoOport");
    } else if (
      !Util.isEmptyOrBlank(templateManager.container.getWidget("evolucao"))
    ) {
      widget = templateManager.container.getWidget("evolucao");
    }

    General.widgetNewRow(widget);

    var currentRow = widget.currentRow;
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    currentRow.DTHREVOLCONT = currentRow.DTHREVOLCONT
      ? currentRow.DTHREVOLCONT
      : moment(new Date()).format("DD/MM/YYYY HH:mm");
    currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
    currentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
    currentRow.NRORG = loggedOperatorInfos.NRORG;

    ABEvolucaoController.setEvolDateChangePermission(widget);
    this.setOperatorNextTask(currentRow, loggedOperatorInfos);

    currentRow.DTINCLUSAO = self.momentNow();
    currentRow.NRSEQCONTATO = widget.getParent().currentRow.NRSEQCONTATO;

    currentRow.NRORG = loggedOperatorInfos.NRORG;
  };

  /**
   * Seta o operador para preparar a proxima tarefa
   * da widget de evolução
   *
   * @param {object} currentRow pega a currentRow
   * da evolução
   *
   * @param {object} loggedOperatorInfos objecto com
   * as informações do operador logado.
   */
  this.setOperatorNextTask = function (currentRow, loggedOperatorInfos) {
    currentRow.NMOPERADORREAL = loggedOperatorInfos.NMOPERADOR;
    currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
  };

  this.setContactReasonFilter = function (field) {
    var fieldFilter = field.dataSourceFilter;

    var nrorgFilterIndex = CRM_Utilities.getFilterPosition(
      fieldFilter,
      "P_NRORG"
    );
    var cdoperadorFilterIndex = CRM_Utilities.getFilterPosition(
      fieldFilter,
      "P_CDOPERADOR"
    );
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    fieldFilter[nrorgFilterIndex].value = loggedOperatorInfos.NRORG;
    fieldFilter[cdoperadorFilterIndex].value = loggedOperatorInfos.CDOPERADOR;

    field.reload();
  };

  this.setInterlocutorFilter = function (field) {
    var fieldFilter = field.dataSourceFilter;
    var parentWidgetCurrentRow = field.widget.getParent().currentRow;

    var nrnparcnegocioFilterIndex = CRM_Utilities.getFilterPosition(
      fieldFilter,
      "NRPARCNEGOCIO"
    );

    fieldFilter[nrnparcnegocioFilterIndex].value =
      parentWidgetCurrentRow.NRPARCNEGOCIO;

    field.reload();
  };

  this.setResultFilter = function (field) {
    var fieldFilter = field.dataSourceFilter;

    var nrorgFilterIndex = CRM_Utilities.getFilterPosition(
      fieldFilter,
      "P_NRORG"
    );
    var cdoperadorFilterIndex = CRM_Utilities.getFilterPosition(
      fieldFilter,
      "P_CDOPERADOR"
    );
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    fieldFilter[nrorgFilterIndex].value = loggedOperatorInfos.NRORG;
    fieldFilter[cdoperadorFilterIndex].value = loggedOperatorInfos.CDOPERADOR;

    field.reload();
  };

  /**
   * Organiza os campos para salvar a tarefa
   * e salva a evolução.
   *
   * @param {object} widget widget de evolução
   */
  this.saveTask = function (widgetName) {
    var widget = templateManager.container.getWidget(widgetName);
    var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      function (canEdit) {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                if (widget.isValid()) {
                  if (widget.currentRow.__is_new) {
                    widget.currentRow.NRORGINCLUSAO = loggedOperatorInfos.NRORG;
                    widget.currentRow.CDOPERINCLUSAO =
                      loggedOperatorInfos.CDOPERADOR;
                    widget.currentRow.NRORGULTATU = null;
                    widget.currentRow.CDOPERULTATU = null;
                  } else {
                    widget.currentRow.NRORGULTATU = loggedOperatorInfos.NRORG;
                    widget.currentRow.CDOPERULTATU =
                      loggedOperatorInfos.CDOPERADOR;
                  }

                  widget.currentRow.CDFILIAL = "";
                  widget.currentRow.NRPARCNEGOCIO = widget.getParent().currentRow.NRPARCNEGOCIO;
                  widget.currentRow.NRSEQCLASSIFICATAREFA = widget.currentRow
                    .NRSEQCLASSIFICATAREFA
                    ? widget.currentRow.NRSEQCLASSIFICATAREFA
                    : null;

                  widget.currentRow.TIPO = "PARCEIRO";

                  widget.currentRow.NMPARCNEGOCIO = widget.getParent().currentRow.NMFANTPROS;
                  widget.currentRow.DESCRICAO =
                    "Referente ao Prospect " + widget.currentRow.NMPARCNEGOCIO;
                  widget.currentRow.NMOPERREAL = widget.currentRow.NMOPERADOR;
                  widget.currentRow.OPERADORDOLOGADO =
                    widget.currentRow.NMPARCRESP;

                  this.selectProspectContato(widget).then(
                    function (response) {
                      widget.currentRow.NRSEQCONTATO =
                        response.dataset.DADOS.NRSEQCONTATO;

                      return General.widgetSave(widget).then(
                        function (response) {
                          if (Boolean(response.dataset.DADOS)) {
                            widget.currentRow.NRSEQFILACONTA =
                              response.dataset.DADOS[0].NRSEQFILACONTA;
                          }
                          if (
                            widget.currentRow.CDOPERINCLUSAO !=
                            widget.currentRow.CDOPERREAL &&
                            !Util.isEmptyOrBlank(widget.currentRow.DSEMAILOPER)
                          ) {
                            ScreenService.confirmMessage(
                              "Deseja enviar um e-mail para o operador responsável da tarefa?",
                              "QUESTION",
                              function (yes) {
                                var params = {
                                  requestType: "Row",
                                  row: widget.currentRow,
                                };

                                restEngine.post("/enviaEmailTarefa", params)
                                  .then(function () {
                                    ScreenService.showMessage("E-mail enviado com sucesso!");
                                  })
                                  .catch(function (error) {
                                    if (error.data.error) {
                                      ScreenService.showMessage(
                                        "O e-mail não pode ser enviado pois as configurações de SMTP estão desconfiguradas ou erradas!",
                                        "ERROR"
                                      );
                                    } else {
                                      ScreenService.showMessage(error.data.error);
                                    }
                                  });
                              }.bind(this)
                            );
                          }
                          widget.reload();
                        }.bind(this)
                      );
                    }.bind(this)
                  );
                }
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                  response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                  " - " +
                  response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                  "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }.bind(this)
    );
  };

  /**
   * Organiza os campos para salvar a evolução
   * e verifica tarefa já aberta.
   *
   * @param {object} widget widget de evolução
   */
  this.saveEvolucao = function (widget) {
    var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    if (Util.isEmptyOrBlank(nrParcNegocio)) {
      nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
      currentRow.NRPARCNEGOCIO = nrParcNegocio;
    }

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      function (canEdit) {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                if (widget.isValid()) {
                  var currentRow = widget.currentRow;

                  currentRow.IDGERAFATURA = "NAO";
                  currentRow.IDTPEVOLCONT = "P";
                  currentRow.IDANEXOEVOLCONT =
                    currentRow.IDANEXOEVOLCONT === "S"
                      ? currentRow.IDANEXOEVOLCONT
                      : "N";
                  currentRow.IDSENEVOCONT = Util.isEmptyOrBlank(
                    currentRow.IDSENEVOCONT
                  )
                    ? "S"
                    : currentRow.IDSENEVOCONT;
                  currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
                  widget.currentRow.CRM_NRORGTRAB = getLocalVar(
                    "CRM_NRORGTRABALHO"
                  );
                  currentRow.NRPARCNEGOCIO = widget.getParent().currentRow.NRPARCNEGOCIO;

                  currentRow.CDFILIAL = "";

                  if (!currentRow.NRRELACIONAPARC) {
                    currentRow.NRRELACIONAPARC = null;
                  }

                  this.cleanTaskGroupIfInvisible(widget, "AGENDAR_TAREFA");

                  this.selectProspectContato(widget).then(
                    function (response) {
                      if (currentRow.__is_new) {
                        this.getParentField(
                          widget,
                          response.dataset.DADOS.NRSEQCONTATO
                        );
                      }
                      this.verificaTarefasAbertas(currentRow).then(
                        function (response) {
                          if (response.dataset.DADOS.TAREFAS) {
                            var tarefas = response.dataset.DADOS.TAREFAS;
                            var operadores = "";
                            tarefas.forEach(function (tarefa) {
                              operadores += "<br>" + tarefa;
                            });
                            ScreenService.confirmMessage(
                              'Este parceiro possui tarefas "Em Aberto" para o(s) seguinte(s) operador(es) <br>' +
                              operadores +
                              "<br><br> Deseja continuar? ",
                              "CONFIRMATION",
                              function (success) {
                                this.saveEvolutionAndInsertTask(
                                  widget,
                                  currentRow
                                );
                              }.bind(this),
                              function (fail) {
                                General.widgetCancelForm(widget);
                              }
                            );
                          } else {
                            this.saveEvolutionAndInsertTask(widget, currentRow);
                          }
                        }.bind(this)
                      );
                    }.bind(this)
                  );
                }
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                  response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                  " - " +
                  response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                  "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }.bind(this)
    );
  };

  this.cleanTaskGroupIfInvisible = function (widget, taskGroupName) {
    var taskGroup = null;
    for (var i = 0; i < widget.fieldGroups.length; i++) {
        if (widget.fieldGroups[i].name === taskGroupName) {
            taskGroup = widget.fieldGroups[i];
            break;
        }
    }
    var currentRow = widget.currentRow;

    // Não limpa os campos se o grupo de próxima tarefa estiver visível
    // (resultado parametrizado para gerar tarefa)
    if (taskGroup.isVisible) return;

    var valuesToClean = [
        "DTPLANFILACONTA",
        "NMOPERADORREAL",
        "CDOPERREAL",
        "DSCLASSIFICATAREFA",
        "DSFILACONTATO",
        "NMPRIORFILACONT",
        "NRPRIORFILACONT",
        "DSEMAILOPER",
    ];

    // "Remove" da current row todos os valores inseridos por campos
    // pertencentes ao grupo de próxima tarefa
    for (var j = 0; j < valuesToClean.length; j++) {
        var valueName = valuesToClean[j];
        currentRow[valueName] = "";
    }
};

  /**
   * Salva evolução e gera Tarefa
   *
   * @param {object} widget widget de evolução
   */
  this.saveEvolutionAndInsertTask = function (widget, currentRow) {
    this.insertRowNextTask(widget).then(
      function (response) {
        if (response) {
          currentRow.NRSEQFILACONTA = response.dataset.DADOS.NRSEQFILACONTA;
        } else if (!currentRow.NRSEQFILACONTA) {
          currentRow.NRSEQFILACONTA = "";
        }

        General.widgetSave(widget)
          .then(
            function (response) {
              this.cleanNextTaskFieldValues(widget);

              //Se a evolução é de qualificação
              if (widget.SET_QUALIFICADO) {
                this.callSetIdQualificadoProspect(widget.SET_QUALIFICADO);
                delete widget.preventLoad;
                delete widget.SET_QUALIFICADO;
              }
              if (
                !Util.isEmptyOrBlank(widget.currentRow.NRSEQINTERLOCUTOR) &&
                widget.currentRow.IDENVIAEMAIL === "S"
              ) {
                ScreenService.confirmMessage(
                  "Deseja enviar um email para " +
                    widget.currentRow.NMINTERLOCUTOR +
                    "?",
                  "QUESTION",
                  function (yes) {
                    evolutionTabController.openWidgetSendMail(widget);
                  }
                );
              }
              widget.reload();
              this.setTaskEndDate(widget);
            }.bind(this)
          )
          .catch(function (error) {
            if (error.indexOf("REQUIRE_INTERLOCUTOR") !== -1)
              ScreenService.showMessage(
                "Operação bloqueada! <br><br> Favor informar o interlocutor."
              );
            else ScreenService.showMessage(error);
          });
      }.bind(this)
    );
  };

  /**
   * Verifica se já existem tarefas relacionadas
   * aquele parceiro
   *
   * @param {object} widget widget de evolução
   */
  this.verificaTarefasAbertas = function (currentRow) {
    var paramsRestEngine = {
      requestType: "Row",
      row: currentRow,
    };
    return restEngine.post("/verificaTarefas", paramsRestEngine);
  };

  /**
   * Função para pegar as informações da tarefa
   * na widget de evolução e setar a data de
   * conclusão da tarefa no registro da própria
   * tarefa.
   *
   * @param {object} widget widget ativa que contém
   * as informações da taréfa que será concluida.
   */
  this.setTaskEndDate = function (widget) {
    var currentRow = widget.currentRow;
    var nrParcNegocio = currentRow.NRPARCNEGOCIO;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      function (canEdit) {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                if (widget.COMPLETETASK) {
                  ger00004500_Prospect_Service.callForSetTaskEndDate(widget).then(
                    function () {
                      ScreenService.showMessage("Tarefa Concluída com sucesso.");
                      this.deleteTaskInfosInEvolutionWidget(widget);
                      this.activateTaskWidget();
                    }.bind(this)
                  );
                }
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                  response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                  " - " +
                  response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                  "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }.bind(this)
    );
  };

  /**
   * Função para ativar a widget de agenda
   * de tarefas.
   */
  this.activateTaskWidget = function () {
    var taskWidget = templateManager.container.getWidget("posvendagrid");

    taskWidget.activate();
  };

  /**
   * Função para deletar as informações da
   * tarefa a ser concluída da widget de evolução.
   *
   * @param {object} widget widget de evolução.
   */
  this.deleteTaskInfosInEvolutionWidget = function (widget) {
    delete widget.COMPLETETASK;
    delete widget.NRSEQFILACONTA;
  };

  /**
   * Seta o operador para preparar a proxima tarefa
   * da widget de evolução
   *
   * @param {object} currentRow pega a currentRow
   * da evolução
   */
  this.getParentField = function (widget, nrseqcontato) {
    widget.currentRow.NRPARCNEGOCIO = widget.getParent().currentRow.NRPARCNEGOCIO;
    widget.currentRow.NRSEQCONTATO = nrseqcontato;
    widget.currentRow.NRCONTATO = nrseqcontato;
  };

  /**
   * Inicia o mvc para realizar select de CONTATO
   *
   * @param {object} widget widget para passar a currentRow
   */
  this.selectProspectContato = function (widget) {
    return ger00004500_Prospect_Service.callForSelectProspect(
      widget.currentRow
    );
  };

  /**
   * Inicia a adição de uma nova tarefa na Agenda de tarefas
   *
   */
  this.taskScheduleNewRow = function (widget) {
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    var currentRow = widget.currentRow;

    currentRow.NRSEQCLASSIFICATAREFA = "";
    currentRow.DTPLANFILACONTA = currentRow.DTPLANFILACONTA
      ? currentRow.DTPLANFILACONTA
      : moment(new Date()).format("DD/MM/YYYY HH:mm");
    currentRow.NMPARCRESP = loggedOperatorInfos.NMOPERADOR;
    currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
    currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
    currentRow.NRORG = loggedOperatorInfos.NRORG;
    currentRow.NRPARCNEGOCIO = widget.getParent().currentRow.NRPARCNEGOCIO;

    this.selectProspectContato(widget).then(
      function (response) {
        this.getParentField(widget, response.dataset.DADOS.NRSEQCONTATO);

        currentRow.NMPRINCIPALPARC = "";
        currentRow.DSEMAILTAREFA = "";
        currentRow.DSTELEFONETAREFA = "";
      }.bind(this)
    );
  };

  this.actionsNewRow = function (widName) {
    var widget = templateManager.container.getActiveWidget();
    var currentRow = widget.currentRow;
    var nrParcNegocio = templateManager.container.getActiveWidget().currentRow.NRPARCNEGOCIO;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    var self = this; // Armazenar referência ao contexto externo

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (currentRow.IDATIVO === "S") {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                self.closeActionsPopup().then(
                  function () {
                    var widget = templateManager.container.getWidget(widName);
                    self.activateWidget(widget).then(
                      function () {
                        setTimeout(function () {
                          widget.newRow();
                        }, 100);
                      }
                    );
                  }
                );
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                  response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                  " - " +
                  response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                  "!"
                );
              }
            }
          );
        } else {
          self.showMessageCantEditParc();
        }
      } else {
        ScreenService.showMessage(
          "Operação Bloqueada Pois o Prospect se encontra Inativo!<br>" +
          "<br>Gentileza Procurar a Equipe de Qualidade Para Ativação do Prospect"
        );
      }
    });
  };

  this.actionEvolutionNewRow = function (widName) {
    this.closeActionsPopup().then(
      function () {
        var widget = templateManager.container.getWidget(widName);

        this.activateWidget(widget).then(
          function () {
            setTimeout(
              function () {
                this.evolucaoNewRow();
              }.bind(this),
              100
            );
          }.bind(this)
        );
      }.bind(this)
    );
  };

  this.closeActionsPopup = function () {
    var deferred = ZHPromise.defer();
    ScreenService.closePopup();
    deferred.resolve();
    return deferred;
  };

  this.activateWidget = function (widget) {
    var deferred = ZHPromise.defer();
    widget.activate();
    deferred.resolve();
    return deferred;
  };

  this.filterOnOpenEvol = function (widget) {
    this.selectProspectContato(widget).then(
      function (response) {
        var widDataSource = widget.dataSourceFilter;

        var nrseqcontatoFilter = CRM_Utilities.getFilterPosition(
          widDataSource,
          "NRSEQCONTATO"
        );

        widDataSource[nrseqcontatoFilter].value =
          response.dataset.DADOS.NRSEQCONTATO;
        //widget.reload();
      }.bind(this)
    );
  };

  this.setEvolutionWidgetFilter = function (widget) {
    var widgetFilter = widget.dataSourceFilter;
    var parentWidgetCurrentRow = widget.getParent().currentRow;

    var parcFilter = null;
    var nrorgFilter = null;

    for (var i = 0; i < widgetFilter.length; i++) {
        if (widgetFilter[i].name === "P_NRPARCNEGOCIO") {
            parcFilter = widgetFilter[i];
        } else if (widgetFilter[i].name === "P_NRORG") {
            nrorgFilter = widgetFilter[i];
        }
    }

    if (parcFilter && nrorgFilter) {
        parcFilter.value = parentWidgetCurrentRow.NRPARCNEGOCIO;
        nrorgFilter.value = parentWidgetCurrentRow.NRORG;

        if (widget.container.name == "crm33000_000_assistente_de_agendamento") {
            this.verifyFilterAssistant(widget);
        }

        if (!widget.preventLoad) {
            widget.reload();
        }
    }
};

  this.setNextTaskDefaultValues = function (widget) {
    var currentRow = widget.currentRow;
    var loggedOperatorInfos = templateManager.LOGGEDOPERATOR;

    currentRow.DTPLANFILACONTA = moment(new Date()).format(
      "DD/MM/YYYY HH:mm:ss"
    );
    currentRow.NRPRIORFILACONT = 2;
    currentRow.NMOPERADORREAL = loggedOperatorInfos.NMOPERADOR;
    currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
  };

  this.setNextTaskVisibility = function (widget, taskGroupName) {
    // Pega o grupo de campos relacionado à próxima tarefa
    var taskGroup = null;
    for (var i = 0; i < widget.fieldGroups.length; i++) {
        if (widget.fieldGroups[i].name === taskGroupName) {
            taskGroup = widget.fieldGroups[i];
            break;
        }
    }

    // Se o resultado selecionado estiver parametrizado para gerar tarefa,
    // o grupo ficará visível. Caso contrário, ficará invisível
    var geraProxTarefa = widget.currentRow.IDGERPROXATIV === "S";

    var taskFields = [];
    for (var j = 0; j < widget.fields.length; j++) {
        if (widget.fields[j].fieldGroup == taskGroupName) {
            taskFields.push(widget.fields[j]);
        }
    }

    for (var k = 0; k < taskFields.length; k++) {
        taskFields[k].isVisible = geraProxTarefa;
        taskFields[k].readOnly = !geraProxTarefa;
    }

    if (taskGroup) {
        taskGroup.isVisible = geraProxTarefa;
    }
};

  this.reloadTab = function (widget) {
    if (
      widget.currentFilter &&
      widget.currentFilter !== widget.getParent().currentRow.NRPARCNEGOCIO
    )
      widget.reload();
    else if (!widget.currentFilter) widget.reload();

    this.setCurrentFilter(widget);
  };

  this.setCurrentFilter = function (widget) {
    widget.currentFilter = widget.getParent().currentRow.NRPARCNEGOCIO;
  };

  this.setOpportunityWidgetFilter = function (widget) {
    var widgetFilter = widget.dataSourceFilter;
    var parentWidgetCurrentRow = widget.getParent().currentRow;

    var nrseqcontatoFilterIndex = CRM_Utilities.getFilterPosition(
      widgetFilter,
      "NRPARCOPORT"
    );

    widgetFilter[nrseqcontatoFilterIndex].value =
      parentWidgetCurrentRow.NRPARCNEGOCIO;

    this.reloadTab(widget);
  };

  this.getProspectNrSeqContato = function (widget) {
    this.selectProspectContato(widget).then(function (response) {
      widget.currentRow.NRSEQCONTATO = response.dataset.DADOS.NRSEQCONTATO;
    });
  };

  this.setResponsibleOperatorFilter = function (field) {
    var fieldFilter = field.dataSourceFilter;

    var nrorgFilterIndex = CRM_Utilities.getFilterPosition(
      fieldFilter,
      "P_NRORG"
    );
    var nrparcnegocioFilterIndex = CRM_Utilities.getFilterPosition(
      fieldFilter,
      "P_NRPARCNEGOCIO"
    );
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    fieldFilter[nrorgFilterIndex].value = loggedOperatorInfos.NRORG;
    fieldFilter[nrparcnegocioFilterIndex].value =
      loggedOperatorInfos.CDOPERADOR;

    field.reload();
  };

  this.setValuesForNewOpportunity = function (widget) {
    var currentRow = widget.currentRow;
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
    var parentWidgetCurrentRow = widget.getParent().currentRow;

    currentRow.CDFILIAL = "";
    currentRow.NRSEQFASENEGO = "";
    currentRow.NRORG = loggedOperatorInfos.NRORG;
    currentRow.NMPARCRESP = loggedOperatorInfos.NMOPERADOR;
    currentRow.CDOPERCONT = loggedOperatorInfos.CDOPERADOR;
    currentRow.NRPARCRESP = loggedOperatorInfos.NRPARCNEGOCIO;
    if (!Util.isEmptyOrBlank(parentWidgetCurrentRow.NMRAZSOCPROS)) {
      currentRow.NMPRINCIPALPARC = parentWidgetCurrentRow.NMRAZSOCPROS;
    } else if (!Util.isEmptyOrBlank(parentWidgetCurrentRow.NMRAZSOCCLIE)) {
      currentRow.NMPRINCIPALPARC = parentWidgetCurrentRow.NMRAZSOCCLIE;
    }
    currentRow.NRPARCOPORT = parentWidgetCurrentRow.NRPARCNEGOCIO;
    currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;

    this.setNegotiationPhaseLock(widget, false);
  };

  this.editTask = function (widget) {
    var currentRow = widget.currentRow;
    var nrParcNegocio = currentRow.NRPARCNEGOCIO;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      function (canEdit) {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                General.widgetEdit(widget);
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                  response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                  " - " +
                  response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                  "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }.bind(this)
    );
  };

  this.editOppotunity = function (widget) {
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [
          currentRow,
        ]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              this.setNegotiationPhaseLock(widget, true);

              General.widgetEdit(widget);
              this.disableSituacaoOport(widget);
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    }.bind(this));
  };

  this.saveOpportunity = function (widget) {
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [
          currentRow,
        ]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              if (widget.currentRow.__is_new) {
                this.saveNewOpportunity(widget);
              } else {
                this.saveEditionOpportunity(widget);
              }
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    }.bind(this));
  };

  this.saveNewOpportunity = function (widget) {
    var currentRow = widget.currentRow;
    var newRow = currentRow.__is_new;

    this.removeOpportunityValueMask(currentRow);
    this.setColumsToReturnInCurrentRow(currentRow, [
      "NRSEQOPORT",
      "NRSEQCONTATO",
      "NRCONTATO",
    ]);

    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    General.widgetSave(widget).then(
      function (response) {
        currentRow.NRSEQOPORT = response.dataset.DADOS.NRSEQOPORT;
        currentRow.NRSEQCONTATO = response.dataset.DADOS.NRSEQCONTATO;
        currentRow.NRCONTATO = response.dataset.DADOS.NRCONTATO;

        if (newRow) {
          CRM_Utilities.reloadGridInViewMode(widget);
        }

        ScreenService.showMessage(
          "Número da Oportunidade: " + parseInt(currentRow.NRSEQOPORT)
        ).then(function () {
          widget.list();
          var widgetCompromisso = templateManager.container.getWidget(
            "compromissoOportunidade"
          );
          var widgetOportunidade = templateManager.container.getWidget(
            "oportunidadegrid"
          );
          crm00002001_OportunidadeNegocio_Controller.verificaNovoCompromisso(
            widgetCompromisso,
            widgetOportunidade
          );
        });
      }.bind(this)
    );
  };

  this.saveEditionOpportunity = function (widget) {
    var currentRow = widget.currentRow;

    this.removeOpportunityValueMask(currentRow);

    General.widgetSave(widget);
  };

  this.removeOpportunityValueMask = function (currentRow) {
    currentRow.VROPORT = CRM_Utilities.removeValueCurrencyMask(
      currentRow.VROPORT
    );
    currentRow.VRPREVOPORT = CRM_Utilities.removeValueCurrencyMask(
      currentRow.VRPREVOPORT
    );
  };

  this.setColumsToReturnInCurrentRow = function (currentRow, arrayColumns) {
    currentRow.__columns_to_return = arrayColumns;
  };

  this.insertNrseqcontatoForNewOpportunity = function (widget) {
    var currentRow = widget.currentRow;

    ger00004500_Prospect_Service.callForInsertNrseqcontatoForNewOpportunity(
      currentRow
    );
  };

  this.convertProspectIntoClient = function (widget) {
    var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
        if (canEdit) {
            General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function (response) {
                if (response.dataset && response.dataset.error) {
                    ScreenService.showMessage(response.dataset.error, "ERROR");
                }
                if (response.dataset && response.dataset.GROUPREL[0] == false) {
                    var parcPosicionado = widget.currentRow.NRPARCNEGOCIO;
                    General.callRestEngine("product#/verifyParcGroupRel", "DataSet", [currentRow]).then(function (response) {
                        if (response.dataset && response.dataset.error) {
                            ScreenService.showMessage(response.dataset.error, "ERROR");
                        }
                        if (response.dataset && !Util.isEmptyOrBlank(response.dataset.RELATIONSHIP)) {
                            ScreenService.confirmMessage(
                                response.dataset.RELATIONSHIP.PAI.NRINSCRICAOPARC +
                                ' – ' +
                                response.dataset.RELATIONSHIP.PAI.NMPRINCIPALPARC +
                                ' possui parceiros relacionados. Deseja criar uma evolução para os parceiros relacionados alterando o status destes parceiros para a organização ' +
                                templateManager.LOGGEDOPERATOR.CRM_NRORGTRAB +
                                ' - ' +
                                templateManager.LOGGEDOPERATOR.NMORGTRAB,
                                'CONFIRMATION',
                                function () {
                                    this.callPopupPartnerRelated(response.dataset.RELATIONSHIP);
                                }.bind(this)
                            );
                        } else {
                            this.callToConvertProspect(widget, parcPosicionado);
                        }
                    }.bind(this));
                } else {
                    ScreenService.showMessage(
                        'Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' +
                        response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                        ' - ' +
                        response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                        '!'
                    );
                }
            }.bind(this));
        } else {
            this.showMessageCantEditParc();
        }
    }.bind(this));
};
  /**
   * Verifica se já existem clientes vinculados
   * com aquele CNPJ
   */
  this.validacaoCNPJCliente = function (CNPJ, NRORG) {
    var paramsRestEngine = {
      requestType: "Row",
      row: {
        CNPJ: CNPJ,
        NRORG: NRORG,
        CRM_NRORGTRAB: getLocalVar("CRM_NRORGTRABALHO"),
      },
    };
    return restEngine.post("/validaCNPJCliente", paramsRestEngine);
  };

  this.updatePartnerType = function (currentRow) {
    ger00004500_Prospect_Service.callForUpdatePartnerType(currentRow);
  };

  this.insertPartnershipOfTypeClient = function (currentRow) {
    ger00004500_Prospect_Service.callForInsertPartnershipOfTypeClient(
      currentRow
    );
  };

  this.insertClient = function (currentRow) {
    return ger00004500_Prospect_Service.callForInsertClient(currentRow);
  };

  this.insertClientAddress = function (currentRow) {
    this.selectProspectAddress(currentRow).then(function (response) {
      var address = response.dataset.DADOS.ADDRESS;

      address.forEach(function (addressObject) {
        var reserveCurrentRow = currentRow;

        reserveCurrentRow.NRENDERECOPARC = addressObject.NRENDERECOPARC;
        reserveCurrentRow.CDPAIS = addressObject.CDPAIS;
        reserveCurrentRow.SGESTADO = addressObject.SGESTADO;
        reserveCurrentRow.CDMUNICIPIO = addressObject.CDMUNICIPIO;
        reserveCurrentRow.CDBAIRRO = addressObject.CDBAIRRO;
        reserveCurrentRow.DSENDECLIE = addressObject.DSENDEPROS;
        reserveCurrentRow.IDTPENDECLIE = addressObject.IDTPENDEPROS;
        reserveCurrentRow.NMBAIRCLIE = addressObject.NMBAIRPROS;
        reserveCurrentRow.DSCOMPENDCLI = addressObject.DSCOMPENDPRO;
        reserveCurrentRow.NRCEPCLIE = addressObject.NRCEPPROS;
        reserveCurrentRow.NRTELECLIE = addressObject.NRTELEPROS;
        reserveCurrentRow.NRRAMALCLIE = addressObject.NRRAMALPROS;
        reserveCurrentRow.DSEMAILCLIE = addressObject.DSEMAILPROS;

        ger00004500_Prospect_Service.callForInsertClientAddress(
          reserveCurrentRow
        );
      });
    });
  };

  this.selectProspectAddress = function (currentRow) {
    return ger00004500_Prospect_Service.callForSelectProspectAddress(
      currentRow
    );
  };

  this.deactivateProspect = function (currentRow) {
    ger00004500_Prospect_Service.callForDeactivateProspect(currentRow);
  };

  this.setEvolutionInterlocutorFieldFilter = function (field) {
    var fieldFilter = field.dataSourceFilter;
    var prospectPartnershipNumber = field.widget.getParent().currentRow
      .NRPARCNEGOCIO;

    var nrparcnegocioFilterIndex = CRM_Utilities.getFilterPosition(
      fieldFilter,
      "NRPARCNEGOCIO"
    );

    fieldFilter[nrparcnegocioFilterIndex].value = prospectPartnershipNumber;

    field.reload();
  };

  /**
   * Função para possibilitar o cadastro de
   * uma evolução referente a tarefa em caso,
   * indicando a conclusão da tarefa.
   *
   * @param {object} widget widget ativa, no modo
   * view, referente a tarefa em caso.
   */
  this.completeTask = function (widget) {
    var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
    var currentRow = widget.currentRow;
    var evolutionWidget = templateManager.container.getWidget("evolucao");
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function (response) {
          if (response.dataset && response.dataset.error) {
            ScreenService.showMessage(response.dataset.error, "ERROR");
          }
          if (response.dataset && response.dataset.GROUPREL[0] == false) {
            evolutionWidget.COMPLETETASK = true;
            evolutionWidget.NRSEQFILACONTA = widget.currentRow.NRSEQFILACONTA;

            ScreenService.closeSwipe().then(function () {
              this.activateWidget(evolutionWidget).then(function () {
                setTimeout(function () {
                  this.evolucaoNewRow();
                }.bind(this), 500);
              }.bind(this));
            }.bind(this));
          } else {
            ScreenService.showMessage(
              'Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' +
              response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
              ' - ' +
              response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
              '!'
            );
          }
        }.bind(this));
      } else {
        this.showMessageCantEditParc();
      }
    }.bind(this));
  };

  /**
   * Função para abrir a widget de seleção
   * de arquivos.
   */
  this.openAnnexSwipe = function () {
    var fileUploadWidget = templateManager.container.getWidget(
      "WDGT_SELECAO_ARQUIVOS"
    );
    var nrParcNegocio = fileUploadWidget.getParent().getParent().getParent()
      .currentRow.NRPARCNEGOCIO;
    var currentRow = fileUploadWidget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      function (canEdit) {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                fileUploadWidget.isVisible = true;
                ScreenService.openSwipe(fileUploadWidget);
              } else {
                ScreenService.showMessage(
                  'Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' +
                  response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                  ' - ' +
                  response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                  '!'
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }.bind(this)
    );
  };

  /**
   * Função para salvar os anexos selecionados
   * ao caso em questão.
   *
   * @param {object} widget widget onde é
   * feito a seleção dos anexos.
   */
  this.uploadEvolutionFiles = function (widget) {
    var nrParcNegocio = widget.getParent().getParent().getParent().currentRow
      .NRPARCNEGOCIO;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      function (canEdit) {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                var files = widget.currentRow.DSCAMINHO;
                var rows = [];

                files.forEach(
                  function (file, fileIndex) {
                    rows.push(this.setValuesForFileUpload(widget, fileIndex));
                  }.bind(this)
                );

                General.callRestEngine(
                  "product#/crm_anexocontato/save",
                  "DataSet",
                  rows
                ).then(
                  function () {
                    this.closeAnnexSwipe(widget);
                    widget.getParent().reload();
                    widget.parent.parent.reload();
                  }.bind(this)
                );
              } else {
                ScreenService.showMessage(
                  'Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' +
                  response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                  ' - ' +
                  response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                  '!'
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }.bind(this)
    );
  };

  /**
   * Função para retornar uma row configurada
   * com as informações do anexo referente
   * ao ID, recebido como parâmetro, no array
   * de anexos na currentRow.
   *
   * @param {object} widget widget onde foi selecionado
   * os anexos.Array
   *
   * @param {int} fileIndex index do anexo no array de
   * anexos presente na currentRow.
   *
   * @return {object} currentRow row configurada com as informações
   * do anexo referente ao ID recebido.
   */
  this.setValuesForFileUpload = function (widget, fileIndex) {
    var currentRow = angular.copy(widget.currentRow);
    var evolutionWidget = widget.getParent().getParent();
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    currentRow.NRSEQCONTATO =
      evolutionWidget.parent.parent.currentRow.NRSEQCONTATO;
    currentRow.NMARQUIVO = this.getFileNameWithoutExtension(
      currentRow.DSCAMINHO[fileIndex].name
    );
    currentRow.DSTIPO = this.getFileExtension(
      currentRow.DSCAMINHO[fileIndex].name
    );
    currentRow.VRTAMANHO = currentRow.DSCAMINHO[fileIndex].size;
    currentRow.IDATIVO = "S";
    currentRow.NRORG = loggedOperatorInfos.NRORG;
    currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
    currentRow.IDORIGEM = "EVOLUCAO";
    currentRow.NRORIGEM = evolutionWidget.currentRow.NRSEQEVOLCONT;

    return currentRow;
  };

  /**
   * Função para retornar a extenção de um arquivo
   * extraida do seu nome.
   *
   * @param {string} fileName nome completo do arquivo.
   */
  this.getFileExtension = function (fileName) {
    return fileName.replace(/^(.*)\.(.*)$/, "$2");
  };

  /**
   * Função para retornar o nome do arquivo sem
   * sua extenção.
   *
   * @param {string} fileName nome completo do arquivo.
   */
  this.getFileNameWithoutExtension = function (fileName) {
    return fileName.replace(/^(.*)\.(.*)$/, "$1");
  };

  /**
   * Função para fechar o swipe de upload de imagens.
   *
   * @param {object} widget widget de upload de imagens.
   */
  this.closeAnnexSwipe = function (widget) {
    ScreenService.closeSwipe().then(function () {
      widget.isVisible = false;
      widget.getParent().list();
      widget.getParent().activate();
    });
  };

  /**
   * Função para fazer o download de uma arquivo
   * salvo no servidor.
   *
   * @param {object} widget widget que contém
   * as informações do arquivo a ser baixado
   * em sua currentRow.
   */

  this.downloadFile = function (widget) {
    window.open(window.fileServerBaseUrl + widget.currentRow.DSCAMINHO);
  };

  this.deleteAttachment = function (widget) {
    var nrParcNegocio = widget.getParent().getParent().currentRow.NRPARCNEGOCIO;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      function (canEdit) {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                General.deleteCrud(widget);
              } else {
                ScreenService.showMessage(
                  'Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' +
                  response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                  ' - ' +
                  response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                  '!'
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }.bind(this)
    );
  };

  /**
   * Função para resetar as informações
   * de criação de uma nova tarefa(a partir de uma
   * evolução).
   *
   * @param {object} widget widget de evolução, que terá
   * as informações resetadas.
   */
  this.resetNewTaskInfos = function (widget) {
    var currentRow = widget.currentRow;
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    currentRow.DTPLANFILACONTA = "";
    currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
    currentRow.NMOPERADORREAL = loggedOperatorInfos.NMOPERADOR;
    currentRow.NRPRIORFILACONT = 2;
  };

  /**
   * Função para deletar uma evolução e
   * seus anexos.
   *
   * @param {object} widget widget ativa, no
   * modo view, mostrando os dados da evolução
   * que será deletada.
   */
  this.deleteEvolution = function (widget) {
    var currentRow = widget.currentRow;

    currentRow.NRORIGEM = currentRow.NRSEQEVOLCONT;

    General.deleteCrud(widget).then(
      function () {
        this.deleteEvolutionFilesByOriginNumber(widget);
      }.bind(this)
    );
  };

  /**
   * Função para deletar os anexos de uma evolução
   * pelo número de origem do anexo.
   *
   * @param {object} widget widget ativa, no
   * modo view, mostrando os dados da evolução
   * que será deletada.
   */
  this.deleteEvolutionFilesByOriginNumber = function (widget) {
    return ger00004500_Prospect_Service.callForDeleteEvolutionFilesByOriginNumber(
      widget
    );
  };

  /**
   * Função para checar a permissão para gerar
   * uma nova tarefa a partir de uma nova evolução.
   *
   * @param {object} widget widget ativa, no modo
   * edit, onde está sendo cadastrado a evolução.
   */
  this.checkNewTaskPermissionByEvolutionResult = function (widget) {
    var currentRow = widget.currentRow;
    var dataProximaTarefa = widget.getField("DTPLANFILACONTA");

    if (
      currentRow.IDGERPROXATIV &&
      currentRow.IDGERPROXATIV === "S" &&
      !currentRow.NEXTTASKBLOCKED
    ) {
      this.setNewTaskPermission(widget, true);
      dataProximaTarefa.validations = { required: true };
    } else {
      this.setNewTaskPermission(widget, false);
      dataProximaTarefa.validations = {};
    }
  };

  /**
   * Função para setar a permissão de criar uma nova
   * tarefa a partir do resultado da evolução.
   *
   * @param {object} widget widget ativa, no modo edit,
   * onde está sendo cadastrado a evolução.
   *
   * @param {boolean} isAllowed permissão booleana do
   * cadastro da tarefa.
   */
  this.setNewTaskPermission = function (widget, isAllowed) {
    if (isAllowed) {
      this.setTaskFieldLock(widget, false);

      widget.currentRow.DTPLANFILACONTA = "";
    } else {
      this.setTaskFieldLock(widget, true);
    }
  };

  /**
   * Função para definir o bloqueio dos campos
   * de agenda de tarefa na widget de evolução.
   *
   * @param {object} widget widget de evolução,
   * onde estão os campos para criar um nova
   * tarefa.
   *
   * @param {boolean} isLocked estado dos campos.
   */
  this.setTaskFieldLock = function (widget, isLocked) {
    var nextTaskDate = widget.getField("DTPLANFILACONTA");
    var taskOperator = widget.getField("NMOPERADORREAL");
    var taskDescription = widget.getField("DSFILACONTATO");
    var taskClassification = widget.getField("DSCLASSIFICATAREFA");
    var taskPriority = widget.getField("NRPRIORFILACONT");

    this.setFieldLock(nextTaskDate, isLocked, widget);
    this.setFieldLock(taskOperator, isLocked, widget);
    this.setFieldLock(taskDescription, isLocked, widget);
    this.setFieldLock(taskClassification, isLocked, widget);
    this.setFieldLock(taskPriority, isLocked, widget);
  };

  /**
   * Função para editar uma evolução.
   *
   * @param {object} widget widget ativa, no
   * modo de visualização, com as informações
   * da evolução a ser editada.
   */
  this.editEvolution = function (widget) {
    General.widgetEdit(widget);

    widget.getField("NMRESULTEVOL").readOnly = true;
    widget.getField("DTPLANFILACONTA").validations = {};

    ABEvolucaoController.setEvolDateChangePermission(widget);
    this.checkPermissionToCreateNewTaskInEvolutionEdition(widget);
  };

  /**
   * Função para verificar a permissão para inserir
   * uma nova tarefa na edição da evolução em caso.
   *
   * @param {object} widget widget ativa, no modo de
   * edição, com as informações da evolução em edição.
   */
  this.checkPermissionToCreateNewTaskInEvolutionEdition = function (widget) {
    var currentRow = widget.currentRow;

    if (currentRow.DTPLANFILACONTA) {
      this.setTaskFieldLock(widget, true);

      currentRow.NEXTTASKBLOCKED = true;
    } else {
      this.unlockNextTask(widget);
      this.checkNewTaskPermissionByEvolutionResult(widget);
      this.resetNewTaskInfos(widget);
    }
  };

  /**
   * Função para liberar o cadastro de uma
   * nova tarefa a partir de um evolução,
   * excluindo o parâmetro de bloqueio.
   *
   * @param {object} widget widget de evolução.
   */
  this.unlockNextTask = function (widget) {
    if (widget.currentRow.NEXTTASKBLOCKED) {
      delete widget.currentRow.NEXTTASKBLOCKED;
    }
  };

  /**
   * Função para limpar os valores dos campos
   * para gerar uma nova tarefa através de uma
   * evolução.onmessage.
   *
   * @param {object} widget widget de evolução.
   */
  this.cleanNextTaskFieldValues = function (widget) {
    var currentRow = widget.currentRow;

    if (!currentRow.DTPLANFILACONTA) {
      currentRow.DTPLANFILACONTA = "";
      currentRow.DSFILACONTATO = "";
      currentRow.NMOPERADORREAL = "";
      currentRow.NRPRIORFILACONT = "";
    }
  };

  /**
   * Função para deletar uma tarefa,
   *
   * @param {object} widget widget ativa, no modo
   * de visualização, mostrando a tarefa a ser deletada.
   */
  this.deleteTask = function (widget) {
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              General.deleteCrud(widget).then(
                function () { }
              ).catch(
                function () {
                  ScreenService.confirmMessage(
                    ScreenService.i18n(Messages.EXCLUSAO_TAREFA_VINC_EVOLUCAO),
                    "question",
                    function (success) {
                      this.deactivateTask(widget).then(
                        function () {
                          ScreenService.showMessage(Messages.TAREFA_INATIVADA);
                          ScreenService.closeSwipe().then(
                            function () {
                              widget.reload();
                            }
                          );
                        }
                      ).catch(
                        function (error) {
                          ScreenService.showMessage(
                            Messages.CATCH_EXCEPTION_ERROR(error.data.error)
                          );
                        }
                      );
                    }.bind(this),
                    function (error) { }
                  );
                }.bind(this)
              );
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    });
  };

  /**
   * Função para desativar a tarefa em caso.
   *
   * @param {object} widget widget ativa, no modo
   * de visualização, com as informações da tarefa
   * a ser desativada.
   */
  this.deactivateTask = function (widget) {
    return ger00004500_Prospect_Service.callForDeactivateTask(widget);
  };

  /**
   * Função para setar o bloqueio de um campo.
   *
   * @param {object} field field a ser manipulada.
   *
   * @param {boolean} isLocked variável que apontará
   * se o campo será bloqueado ou não;
   */
  this.setFieldLock = function (field, isLocked, widget) {
    var currentRow = widget.currentRow;
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    field.readOnly = isLocked;

    if (isLocked) {
      field.clearValue();
    } else {
      if (field.name == "NMOPERADORREAL") {
        currentRow.NMOPERADORREAL = loggedOperatorInfos.NMOPERADOR;
        currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
      } else if (field.name == "DSFILACONTATO") {
        field.value("Retornar Contato");
      }
    }
  };

  /**
   * Função para setar o bloqueio do campo 'Código'
   * na widget de interlocutores.
   *
   * @param {object} widget widget de interlocutores do prospect
   * em caso.
   *
   * @param {boolean} isLocked variável que apontará
   * se os campos serão bloqueados ou não;
   */
  this.setNegotiationPhaseLock = function (widget, isLocked) {
    var interlocCodeField = widget.getField("NMSEQFASENEGO");

    interlocCodeField.readOnly = isLocked;
  };

  /*this.setIDATIVO = function(widget) {
        var filter;
        if(widget.name !== 'gridProspect') {
            filter = templateManager.container.getWidget('gridProspect').__filterPopup;
        }else{
            filter = widget.__filterPopup;
        }
        filter.currentRow.IDATIVO = 'S';
        filter.reload();
    };*/

  /**
   * Dispara os eventos necessários no evento
   * "WidgetAfterMoveRow" da widget principal
   * (gridProspect).
   *
   * @param {object} widget widget principal da tela
   * prospect.
   */
  this.shootsMainWidgetEventsAfterMoveRow = function (widget) {
    this.setOperatorLoggedInCurrentRow();
    this.getProspectNrSeqContato(widget);
    this.hideActionsToProspectsWithCreatedOpportunity(widget);
    this.hideActionsToReservedProspects(widget);
    this.setLabelActionQualificado(widget);
    this.classConcorrente(widget);
    this.readOnlyConcorrente(widget);
  };

  /**
   * Esconde as ações quando um propect possuir
   * oportunidade criada e o operador logado não for
   * o responsável pelo prospect.
   *
   * @param {object} widget widget principal da tela de
   * prospect.
   */
  this.hideActionsToProspectsWithCreatedOpportunity = function (widget) {
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
    var currentRow = widget.currentRow;

    if (
      currentRow.POSSUIOPORTUNIDADE === "S" &&
      loggedOperatorInfos.NRPARCNEGOCIO !== currentRow.NRPARCRESPROSP
    ) {
      this.hideFunctionalActions();
      currentRow.BLOCKEDPROSPECT = true;
      ScreenService.showMessage(Messages.PROSPECT_BLOQUEADO);
    } else if (
      !Boolean(currentRow.BLOCKEDPROSPECT) ||
      currentRow.BLOCKEDPROSPECT === false
    ) {
      this.returnContainerDefaultAction(widget);
      currentRow.BLOCKEDPROSPECT = false;
    }
  };

  /**
   * Esconde as actions da tela de prospect quando
   * um prospect reservado é selecionado.
   *
   * @param {object} widget widget principal da tela
   * de prospect (gridProspect).
   *
   */
  this.hideActionsToReservedProspects = function (widget) {
    var currentRow = widget.currentRow;
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    if (
      this.isReservedProspect(widget) &&
      loggedOperatorInfos.NRPARCNEGOCIO !== currentRow.NRPARCRESPROSP
    ) {
      this.hideFunctionalActions();
      currentRow.BLOCKEDPROSPECT = true;
      ScreenService.showMessage(Messages.PROSPECT_BLOQUEADO);
    } else if (
      !Boolean(currentRow.BLOCKEDPROSPECT) ||
      currentRow.BLOCKEDPROSPECT === false
    ) {
      this.returnContainerDefaultAction(widget);
      currentRow.BLOCKEDPROSPECT = false;
    }
  };

  /**
   * Verifica se um prospect está reservado
   * de acordo com a paramentrização do CRM.
   *
   * @param {object} widget widget principal da tela
   * de prospect (gridProspect).
   */

  this.isReservedProspect = function (widget) {
    var crmParametrization = CRM_Utilities.getCrmParametrization();

    var currentRow = widget.currentRow;

    var reserveTnitDate = CRM_Utilities.subtractDateByDays(
      currentRow.DTINIRESERVAPROSP,
      1
    );
    var reserveEndDate = CRM_Utilities.addDaysToDate(
      reserveTnitDate,
      crmParametrization.NRMAXDIASPROSPBLOQ + 1,
      "DD/MM/YYYY"
    );

    var currentDate = CRM_Utilities.getDataHoraAtual();
    var formatedCurrentDate = CRM_Utilities.changeDateFormat(
      currentDate,
      "DD/MM/YYYY HH:mm",
      "YYYY-MM-DD"
    );
    var formatedReserveTnitDate = CRM_Utilities.changeDateFormat(
      reserveTnitDate,
      "DD/MM/YYYY HH:mm",
      "YYYY-MM-DD"
    );
    var formatedReserveEndDate = CRM_Utilities.changeDateFormat(
      reserveEndDate,
      "DD/MM/YYYY HH:mm",
      "YYYY-MM-DD"
    );

    return moment(formatedCurrentDate).isBetween(
      formatedReserveTnitDate,
      formatedReserveEndDate
    );
  };

  /**
   * Esconde as ações funcionais da tela.
   */
  this.hideFunctionalActions = function () {
    var containerActions = templateManager.container.actions;

    containerActions.forEach(function (action) {
      if (action.label !== "Voltar") {
        action.isVisible = false;
        action.disable = true;
      }
    });
  };

  /**
   * Retorna as configurações padrão das ações
   * do container ativo.
   *
   * @param {object} widget widget principal da tela de
   * prospect com o backup das actions.
   */
  this.returnContainerDefaultAction = function (widget) {
    var containerActions = templateManager.container.actions;

    containerActions.forEach(function (action) {
      if (Boolean(action.disable)) {
        action.isVisible = true;
        delete action.disable;
      }
    });
  };

  /**
   * Define as regras da tela de prospect de acordo
   * com a revenda do operador logado.
   *
   * @param {object} widget widget principal da tela de prospect
   * ('WDGT_ASSISTENTE_AGENDAMENTO').
   */
  this.setResaleRules = function (widget) {
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    if (
      loggedOperatorInfos.IDTPOPERADOR === "R" &&
      Boolean(loggedOperatorInfos.NRREVENDA)
    ) {
      var restrictObjects = [];

      restrictObjects.push(widget);

      restrictObjects.push(widget.getField("NMPARCRESPROSP"));

      var tasksWidget = templateManager.container.getWidget("posvendagrid");
      restrictObjects.push(tasksWidget.getField("NMOPERADOR"));

      var evolutionWidget = templateManager.container.getWidget("evolucao");
      restrictObjects.push(evolutionWidget.getField("NMOPERADORREAL"));

      CRM_Utilities.setResaleRulesInRestrictObjectsByLoggedOperatorResale(
        restrictObjects
      );
    }
  };

  this.setLabelActionQualificado = function (widget) {
    var currentRow = widget.currentRow;
    var actionQualificar = widget.getAction("SET_QUALIFICADO");

    if (currentRow.IDQUALIFICADO === "S") {
      actionQualificar.label = "Desqualificar Prospect";
    } else {
      actionQualificar.label = "Qualificar Prospect";
    }
  };

  this.setIdQualificadoProspect = function (widget) {
    var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
    var currentRow = widget.currentRow;
    var actionQualificar = widget.getAction("SET_QUALIFICADO");
    var message =
      "Tem certeza que deseja " +
      actionQualificar.label.split(" ")[0].toLowerCase() +
      " o prospect: <br>" +
      currentRow.NMRAZSOCPROS +
      " ?";
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    var self = this; // Armazenar referência ao contexto externo

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              ScreenService.confirmMessage(
                message,
                "CONFIRMATION",
                function () {
                  var evolWidgt = templateManager.container.getWidget("evolucao");
                  widget.openTab("evolucao");

                  ScreenService.closePopup();

                  evolWidgt.getField("NMRESULTEVOL").readOnly = false;
                  evolWidgt.preventLoad = true;
                  evolWidgt.SET_QUALIFICADO = widget;

                  setTimeout(
                    function () {
                      self.evolucaoNewRow(); // Usar a referência externa ao contexto
                    },
                    500
                  );
                },
                function () {
                  ScreenService.closePopup();
                }
              );
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                " - " +
                response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                "!"
              );
            }
          }
        );
      } else {
        self.showMessageCantEditParc();
      }
    });
  };

  this.callSetIdQualificadoProspect = function (widget) {
    var currentRow = widget.currentRow;

    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");

    if (currentRow.IDQUALIFICADO === "S") {
      currentRow.IDQUALIFICADO = "N";
    } else {
      currentRow.IDQUALIFICADO = "S";
    }

    var parametroRestEngine = {
      requestType: "Row",
      row: currentRow,
    };

    restEngine
      .post("/setIdQualificadoProspect", parametroRestEngine)
      .then(
        function (response) {
          widget.reload();
          if (currentRow.IDQUALIFICADO === "N")
            ScreenService.showMessage("Prospect Desqualificado com Sucesso!");
          else ScreenService.showMessage("Prospect Qualificado com Sucesso!");
          this.setLabelActionQualificado(widget);
        }.bind(this)
      )
      .catch(function () {
        currentRow.IDQUALIFICADO === "N"
          ? (currentRow.IDQUALIFICADO = "S")
          : (currentRow.IDQUALIFICADO = "N");
        ScreenService.showMessage("Falha na operação!");
      });
  };

  /**
   * Executa as funções necessárias no evento
   * "WidgetOnEnterOnce" da widget de prospect.
   *
   * @param {object} widget widget de prospect
   * ("gridProspect").
   */
  this.widgetOnEnterOnce = function (widget, fieldsToApply, filterError) {
    var filterRow = {};
    var wdgt = templateManager.container.getWidget("gridProspect");

    if (typeof templateManager !== "undefined" && templateManager.LOGGEDOPERATOR) {
      filterRow.IDOPERATIVO = 'A';

      if (filterRow.IDOPERATIVO === 'A') {
        filterRow.NRPARCRESPROSP = [templateManager.LOGGEDOPERATOR.NRPARCNEGOCIO];
        wdgt.getField('NRPARCRESPROSP').reload();
      }

      if (widget.name === "gridProspect") {
        CRM_Utilities.openFilterOnEnter(widget, filterRow, fieldsToApply);
      } else {
        widget.dataSource.data = wdgt.dataSource.data;
        widget.appliedFilter = wdgt.appliedFilter;
      }
    }

    if (!filterError) {
      AbaInterlocutorController.setInterlocutorWidgetOnActiveWidget(widget, 3);
      ABAEnderecoParceiroController.setAddressWidgetOnActiveWidget(widget, 2);
      PartnerInfosModalController.setModalWidgetOnActiveWidget(widget, "NRPARCNEGOCIO");
      ABALogotipoParceiroController.setLogoWidgetOnActiveWidget(widget, 8);

      this.setResaleRules(widget);
      this.checkParamToAddProspect(widget);
    }
  };

  this.classConcorrente = function (widget) {
    var fieldDTinicio = widget.getField("DTINIVIGENCIA");
    var fieldDTfim = widget.getField("DTFIMVIGENCIA");

    if (widget.mode === "edit") {
      fieldDTfim.class = "6";
      fieldDTinicio.class = "6";
    } else {
      fieldDTfim.class = "4";
      fieldDTinicio.class = "4";
    }
  };

  this.readOnlyConcorrente = function (widget) {
    var fieldDTinicio = widget.getField("DTINIVIGENCIA");
    var fieldDTfim = widget.getField("DTFIMVIGENCIA");

    if (Util.isEmptyOrBlank(widget.currentRow.NRCONCORRENTE)) {
      fieldDTfim.readOnly = true;
      fieldDTinicio.readOnly = true;
      fieldDTinicio.value("");
      fieldDTfim.value("");
    } else {
      fieldDTfim.readOnly = false;
      fieldDTinicio.readOnly = false;
    }
  };

  this.calculaDiasFimContrato = function (fimVigencia) {
    if (typeof fimVigencia === "string" && !Util.isEmptyOrBlank(fimVigencia)) {
      //formata data
      fimVigencia =
        fimVigencia.slice(3, 5) +
        "/" +
        fimVigencia.slice(0, 2) +
        "/" +
        fimVigencia.slice(6, 10);
      fimVigencia = new Date(fimVigencia);
      var currentDate = new Date();
      //calcula a diferencia em milesimos
      var diferenca = fimVigencia - currentDate;
      //milesimos em um dia
      var dia = 1000 * 60 * 60 * 24;

      //Se fimVigencia não for numero retorna vazio, se não retorna a diferenca limitada a zero
      return Math.round(diferenca / dia) < 0 ? 0 : Math.round(diferenca / dia);
    } else {
      return null;
    }
  };

  this.alteraEstadoReadonly = function (widget) {
    var paisField = widget.getField("NMPAIS");
    var estadoField = widget.getField("NMESTADO");
    var currentRow = widget.currentRow;
    if (!paisField.value()) {
      estadoField.readOnly = true;
      currentRow.SGESTADO = null;
      currentRow.NMESTADO = null;
    } else {
      estadoField.readOnly = false;
      currentRow.SGESTADO = null;
      currentRow.NMESTADO = null;
    }
    this.alteraMunicipioReadonly(widget);
  };

  this.alteraMunicipioReadonly = function (widget) {
    var estadoField = widget.getField("NMESTADO");
    var municipioField = widget.getField("NMMUNICIPIO");
    var currentRow = widget.currentRow;
    if (!estadoField.value()) {
      municipioField.readOnly = true;
      currentRow.NMMUNICIPIO = null;
      currentRow.CDMUNICIPIO = null;
      currentRow.NMMUNICIPIO = null;
    } else {
      municipioField.readOnly = false;
      currentRow.NMMUNICIPIO = null;
      currentRow.CDMUNICIPIO = null;
      currentRow.NMMUNICIPIO = null;
    }
    this.alteraBairroReadonly(widget);
  };

  this.alteraBairroReadonly = function (widget) {
    var municipioField = widget.getField("NMMUNICIPIO");
    var bairroField = widget.getField("NMBAIRRO");
    var currentRow = widget.currentRow;
    if (!municipioField.value()) {
      bairroField.readOnly = true;
      currentRow.NMBAIRROTRAN = null;
      currentRow.CDBAIRRO = null;
      currentRow.NMBAIRRO = null;
      currentRow.NMBAIRROCAN = null;
    } else {
      bairroField.readOnly = false;
      currentRow.NMBAIRROTRAN = null;
      currentRow.CDBAIRRO = null;
      currentRow.NMBAIRRO = null;
      currentRow.NMBAIRROCAN = null;
    }
  };

  this.disableSituacaoOport = function (widget) {
    if (widget.currentRow.__is_new) {
      widget.getField("SITUACAO").readOnly = true;
    } else {
      widget.getField("SITUACAO").readOnly = false;
    }
  };

  this.styleNewProspect = function (element) {
    var tr = $(element[0]);
    if (tr.hasClass("tr")) {
      tr.wrap('<a class="newLeadTooltip" title="Prospect recém criado"></a>');
    }
  };

  this.styleProspect = function (element) {
    while ($(element[0]).parent().is("a")) {
      $(element[0]).unwrap("a");
    }
  };

  this.cancelarNovoRegistro = function () {
    ScreenService.closePopup();
  };

  this.criarNovoConcorrente = function (widget) {
    var popupNovoConcorrente = templateManager.container.getWidget(
      "popupNovoConcorrente"
    );
    popupNovoConcorrente.newRow();

    popupNovoConcorrente.template = "widget/form.html";
    popupNovoConcorrente.activate();
    ScreenService.openPopup(popupNovoConcorrente);
  };

  this.prepararNovoConcorrente = function (widget) {
    CRM_Utilities.setColumnToReturnInCurrentRow(
      widget.currentRow,
      "NRCONCORRENTE"
    );
    widget.currentRow.DTULTATUBAIR = CRM_Utilities.getCurrentDate();

    widget.currentRow.NRORG = templateManager.LOGGEDOPERATOR.NRORG;
    widget.currentRow.FIELDONADD = true;
    this.salvarConcorrente(widget.currentRow).then(function (response) {
      var widgetConvert = templateManager.container.getWidget("gridProspect");
      widgetConvert.currentRow.NRCONCORRENTE =
        response.dataset.columnsToReturn[0].NRCONCORRENTE;
      widgetConvert.currentRow.NMRAZSOCCONC = widget.currentRow.NMRAZSOCCONC;
      ScreenService.closePopup();
      ScreenService.closePopup();
      ScreenService.showMessage("Concorrente salvo com sucesso!");
    });
  };

  this.salvarConcorrente = function (currentRow) {
    var paramsRestEngine = {
      requestType: "Row",
      row: currentRow,
    };

    return restEngine.post("/crm_concorrente/save", paramsRestEngine);
  };

  this.checkParamToAddProspect = function (widget) {
    if (templateManager.CRM_PARAMETRIZACAO.IDADDPROSPECT === "S")
      widget.getAction("ADD").isVisible = true;
  };

  this.widgetNewRow = function (widget) {
    General.widgetNewRow(widget);

    widget.currentRow.NRORG = templateManager.LOGGEDOPERATOR.NRORG;
    widget.currentRow.NRPARCRESPROSP =
      templateManager.LOGGEDOPERATOR.NRPARCNEGOCIO;
    widget.currentRow.NMPARCRESPROSP =
      templateManager.LOGGEDOPERATOR.NMOPERADOR;
    widget.currentRow.IDATIVO = "S";
    widget.currentRow.IDPRIPUBPROS = "";
    widget.currentRow.IDPRIPUBPROS = "";
    widget.currentRow.CDMODODIVULG = "";
    widget.currentRow.CDATIVCLI = "";
    widget.currentRow.CDQUALIF = "";
    widget.currentRow.CDEXPEDIENTE = "";
    widget.currentRow.CDSEGMER = "";
    widget.currentRow.IDSITUPROS = "";
    widget.currentRow.DTNASCPROS = "";
    widget.currentRow.HRINIFUNCPROSP = "";
    widget.currentRow.HRFINFUNCPROSP = "";
    widget.currentRow.IDLIGEXTPROS = "";
    widget.currentRow.NRUNOPPROS = "";
    widget.currentRow.DSCONCORREPROSP = "";
    widget.currentRow.DTENCECONTRATU = "";
    widget.currentRow.DTREVPRECOPROSP = "";
    widget.currentRow.NRSEQTPATIVCLI = "";
    widget.getField("NRINSJURPROS").readOnly = false;
    widget.getField("NMRAZSOCPROS").readOnly = false;
    widget.currentRow.IDINSCRESTAD = "ISENTO";
    widget.getField("NRINSESTPROS").value("ISENTO");
    widget.getField("NRINSESTPROS").readOnly = true;
  };

  this.checarAddProspectDireto = function (widget) {
    var paramsRestEngine = {
      requestType: "FilterData",
      filter: [
        {
          name: "NRORG",
          operator: "=",
          value: getLocalVar("CRM_NRORG"),
        },
      ],
    };
    restEngine
      .post("/crm_parametrizacao", paramsRestEngine)
      .then(function (response) {
        var paramentrizao = response.dataset.crm_parametrizacao;
        if (paramentrizao) {
          var addProsDireto = paramentrizao[0].IDADDPROSPECT;
          var addAction = widget.getAction("ADD");

          addAction.isVisible = addProsDireto == "S";

          widget.redraw();
        }
      });
  };

  this.addProspect = function (widget) {
    widget.newRow();
  };

  this.addNewTask = function (widget) {
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      function (canEdit) {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] === false) {
                General.widgetNewRow(widget);
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                  response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                  " - " +
                  response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                  "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }.bind(this)
    );
  };

  this.setUnmergeActionVisibility = function (widget) {
    var unmergeAction = widget.getAction("UNMERGE_PARC");
    unmergeAction.isVisible = false;

    if (widget.currentRow.__is_new) {
      return;
    }

    var nrparcneg = widget.currentRow.NRPARCNEGOCIO;
    var nrorg = widget.currentRow.NRORG;

    CRM_ParceiroNegocio_Controller.checkParcHasMerge(nrparcneg, nrorg).then(
      function (hasMerge) {
        // Action de desfundir será visível se o prospect tiver algum
        //parceiro fundido a ele.
        unmergeAction.isVisible = hasMerge;

        widget.redraw();
      }.bind(this)
    );
  };

  this.openSwipeUnmergeProspect = function (mainWid) {
    var nrParcNegocio = mainWid.currentRow.NRPARCNEGOCIO;
    var currentRow = mainWid.currentRow;
    var widgetUnmerge = templateManager.container.getWidget("DESFUNDIRPROSP");
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      function (canEdit) {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] === false) {
                ScreenService.closePopup();
                ScreenService.openPopup(widgetUnmerge);

                widgetUnmerge.activate();
                widgetUnmerge.newRow();

                widgetUnmerge.currentRow.NMCANDPROSPECT =
                  mainWid.currentRow.NMRAZSOCPROS;
                widgetUnmerge.currentRow.NRORG = mainWid.currentRow.NRORG;
                widgetUnmerge.currentRow.NRPARCATUAL =
                  mainWid.currentRow.NRPARCNEGOCIO;
                widgetUnmerge.currentRow.CDOPEREVOL =
                  templateManager.LOGGEDOPERATOR.CDOPERADOR;

                var filterParcDestino = widgetUnmerge
                  .getField("PARCSDESFUNDIR")
                  .dataSourceFilter.find(function (filter) {
                    return filter.name == "P_NRPARCDEST";
                  });

                filterParcDestino.value = mainWid.currentRow.NRPARCNEGOCIO;
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                  response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                  " - " +
                  response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                  "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }.bind(this)
    );
  };

  //Função usada tanto na tela de lead quanto na de prospect!
  this.unmergeProspect = function (widget) {
    var mainWid = widget.getParent();

    if (widget.isValid()) {
      var parametroRestEngine = {
        requestType: "Row",
        row: widget.currentRow,
      };

      restEngine.post(
        "/unmergeParceiro",
        parametroRestEngine,
        undefined,
        undefined,
        undefined
      ).then(
        function (response) {
          CRM_Utilities.reloadGridInViewMode(mainWid).then(function () {
            this.setUnmergeActionVisibility(mainWid);
            widget.currentRow.NRPARCORIGEM = "";
            widget.currentRow.NRPARCORIGEM = "";
            this.closeWidgetFundirParc(widget);

            this.showUnmergeResultMessage(response);
          }.bind(this));
        }.bind(this)
      ).catch(
        function (err) {
          CRM_Utilities.showErrorMessage(err);
        }
      );
    }
  };

  this.showUnmergeResultMessage = function (response) {
    var message = "";

    if (!response.dataset) {
      message = "Ocorreu um erro inesperado, nenhuma alteração foi feita." +
        "<br>Favor contatar o administrador do sistema.";
    } else {
      if (response.dataset.DADOS.NAODESFUNDIDOS.length > 0) {
        message += "Os seguintes parceiros não foram desfundidos:<br>";
        response.dataset.DADOS.NAODESFUNDIDOS.forEach(function (parc) {
          message += "<br>-> " + parc.nome + "<br>";
        });

        if (response.dataset.DADOS.DESFUNDIDOS.length >= 1) {
          message += "<br>Os outros parceiros foram desfundidos com sucesso!";
        }
      } else {
        message += "Desfusão feita com sucesso!";
      }
    }

    ScreenService.showMessage(message);
  };

  this.criarNovoInterlocutor = function (widget) {
    var popupNovoInterlocutor = templateManager.container.getWidget(
      "popupNovoInterlocutor"
    );
    popupNovoInterlocutor.newRow();
    var filterPopup = popupNovoInterlocutor.currentRow;
    if (widget.name === "convertLeadInProspect") {
      filterPopup = templateManager.container.getWidget(
        "convertLeadInProspect"
      );
      popupNovoInterlocutor.currentRow.filtro = false;
      popupNovoInterlocutor.parentName = widget.name;
    } else if (widget.name === "filterPopup") {
      filterPopup = templateManager.container.getWidget("gridProspect")
        .__filterPopup;
      popupNovoInterlocutor.currentRow.filtro = true;
    } else if (widget.name === "gridProspect") {
      filterPopup = templateManager.container.getWidget("gridProspect");
      popupNovoInterlocutor.currentRow.filtro = false;
      popupNovoInterlocutor.parentName = widget.name;
    } else if (widget.name === "posvendagrid") {
      filterPopup = templateManager.container.getWidget("posvendagrid");
      popupNovoInterlocutor.currentRow.filtro = false;
      popupNovoInterlocutor.parentName = widget.name;
    } else if (widget.name === "evolucao") {
      filterPopup = templateManager.container.getWidget("evolucao");
      popupNovoInterlocutor.currentRow.filtro = false;
      popupNovoInterlocutor.parentName = widget.name;
    }

    ScreenService.openPopup(popupNovoInterlocutor).then(function () {
      if (widget.name != "Agenda") {
        //Se a tela não for a de Agenda de Tarefas
        if (
          widget.parent.parent.name !== "oportunidadegrid" &&
          widget.parent.parent.name != "gridCliente"
        ) {
          //Se a tela não for a de Oportunidade ou a de Cliente
          popupNovoInterlocutor.currentRow.NMINTERLOCUTOR =
            filterPopup.NMINTERLOCUTOR;
          popupNovoInterlocutor.currentRow.DTNASCIMENTO =
            filterPopup.DTNASCIMENTO;
          popupNovoInterlocutor.currentRow.IDRECEBEPRESENTE =
            filterPopup.IDRECEBEPRESENTE;
          popupNovoInterlocutor.currentRow.NMCARGOINTERLOC =
            filterPopup.NMCARGOINTERLOC;
          popupNovoInterlocutor.currentRow.EMAILINTERLOC =
            filterPopup.EMAILINTERLOC;
          popupNovoInterlocutor.currentRow.NRTELEFONE1 =
            filterPopup.NRTELEFONE1;
          popupNovoInterlocutor.currentRow.NRORG = getLocalVar("CRM_NRORG");
        }
        if (widget.parent.parent.name == "gridCliente") {
          //Caso seja a tela de Cliente, pegar o PARCNEGOCIO do Cliente e não o logado
          popupNovoInterlocutor.currentRow.NRPARCNEGOCIO =
            widget.parent.parent.currentRow.NRPARCNEGOCIO;
        }
      } else {
        //Caso seja a tela de Agenda, pegar o PARCNEGOCIO da Tarefa
        popupNovoInterlocutor.currentRow.NRPARCNEGOCIO =
          widget.currentRow.NRPARCNEGOCIO;
      }
      popupNovoInterlocutor.currentRow.NRORG = getLocalVar("CRM_NRORG");
    });
  };

  this.setInterlocutorWidgetDefaultValues = function (widget) {

    var nameWidget = widget.name;
    var wid = templateManager.container.getWidget(nameWidget);
    widget.currentRow.NRPARCNEGOCIO = wid.currentRow.NRPARCNEGOCIO;

  };

  this.removeInterlocutorPhoneMask = function (widget) {
    var currentRow = widget.currentRow;
    var phoneFields = ["NRTELEFONE1"];

    phoneFields.forEach(function (phone) {
      if (currentRow[phone]) {
        currentRow[phone] = currentRow[phone].replace(/[^0-9]/g, "");
      }
    });
  };

  this.salvarInterlocutor = function (currentRow) {
    var paramsRestEngine = {
      requestType: "Row",
      row: currentRow,
    };
    return restEngine.post("/crm_interlocutor/save", paramsRestEngine);
  };

  this.prepararInterlocutor = function (widget) {
    var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      function (canEdit) {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                var parent = templateManager.container.getWidget(
                  widget.parentName
                );

                CRM_Utilities.setColumnToReturnInCurrentRow(
                  widget.currentRow,
                  "NRSEQINTERLOCUTOR"
                );
                this.removeInterlocutorPhoneMask(widget);

                if(widget.currentRow.NRCPFINTERLOC){
                    widget.currentRow.NRCPFINTERLOC = widget.currentRow.NRCPFINTERLOC.replace(
                      /[^0-9]/g,
                      ""
                    );
                };
                
                this.salvarInterlocutor(widget.currentRow).then(function (
                  response,
                  widget
                ) {
                  var currentRow = templateManager.container.getWidget(
                    "popupNovoInterlocutor"
                  );
                  if (currentRow.filtro === true) {
                    var widgetfilter = templateManager.container.getWidget(
                      "popupNovoInterlocutor"
                    ).__filterPopup;
                    var widgetprospect = templateManager.container.getWidget(
                      "gridProspect"
                    );
                    var widgetConvertfilter = templateManager.container.getWidget(
                      "evolucao"
                    );
                    widgetConvertfilter.currentRow.NMINTERLOCUTOR =
                      widget.currentRow.NMINTERLOCUTOR;

                    widgetfilter.template = "widget/form.html";
                    widgetfilter.activate();
                    widgetprospect.widgets[0].fields[7].defaultValue =
                      widget.currentRow.NMINTERLOCUTOR;
                    ScreenService.closePopup(true);
                    ScreenService.showMessage(
                      "Interlocutor criado com sucesso!"
                    );
                  } else {
                    var widgetcurrent = templateManager.container.getWidget(
                      "popupNovoInterlocutor"
                    );

                    parent.currentRow.NRSEQINTERLOCUTOR =
                      response.dataset.columnsToReturn[0].NRSEQINTERLOCUTOR;
                    parent.currentRow.NMINTERLOCUTOR =
                      widgetcurrent.currentRow.NMINTERLOCUTOR;
                    parent.currentRow.EMAILINTERLOC =
                      widgetcurrent.currentRow.EMAILINTERLOC;

                    ScreenService.closePopup(true);

                    ScreenService.showMessage(
                      "Interlocutor criado com sucesso!"
                    ).then(function () {
                      parent.activate();
                      parent.reload();
                    });
                  }
                });
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                  response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                  " - " +
                  response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                  "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }.bind(this)
    );
  };

  this.tabEvolucaoOnEnter = function (widget) {
    this.setEvolutionWidgetFilter(widget);
  };

  this.evolucaoRowOnEnter = function (widget) {
    this.setEditEvolButtonAction(
      widget,
      this.editEvolButtonDefaultCode,
      "EDIT"
    );
  };

  this.editEvolButtonDefaultCode = 'ger45000_Prospect_Controller.editEvolution(args.owner.widget);\n' +
    'ger45000_Prospect_Controller.setNextTaskVisibility(args.owner.widget, "AGENDAR_TAREFA");';

    this.setEditEvolButtonAction = function (widget, codeCanEdit, actionName) {
      if (widget.currentRow.__is_new) {
          return;
      }
  
      var codeCannotEdit = "ger45000_Prospect_Controller.showMessageCantEditEvol();";
  
      var editButton = widget.getAction(actionName);
  
      return new Promise(function (resolve, reject) {
          this.checkIfCanEditEvol(widget)
              .then(function (canEdit) {
                  editButton.events[0].code = canEdit ? codeCanEdit : codeCannotEdit;
                  resolve();
              })
              .catch(function (err) {
                  editButton.events[0].code = codeCanEdit;
                  reject(err);
              });
      }.bind(this));
  };

  this.checkIfCanEditEvol = function (widget) {
    var params = {
      requestType: "Row",
      row: widget.currentRow,
    };

    return restEngine
      .post("/checkCanEditEvol", params)
      .then(function (response) {
        return response.dataset.DATA.CAN_EDIT;
      });
  };

  this.showMessageCantEditEvol = function () {
    var message = "Edição Bloqueada!<br>Não é possível editar as evoluções de outros operadores.";

    ScreenService.showMessage(message);
  };

  this.editProspectActionOnClick = function (widget) {
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;

    var self = this;

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      function (canEdit) {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                General.widgetEdit(widget);
                widget.getField("NRINSJURPROS").readOnly = false;
                widget.getField("NMRAZSOCPROS").readOnly = false;
                self.classConcorrente(widget);
                CRM_ParceiroNegocio_Controller.setInscEstadualSelect(widget);
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                  response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                  " - " +
                  response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                  "!"
                );
              }
            }.bind(self)
          );
        } else {
          self.showMessageCantEditParc();
        }
      }
    );
  };

  this.evolveProspectActionOnClick = function (widget) {
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    var self = this; // Armazenar referência ao contexto externo

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      function (canEdit) {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                self.actionEvolutionNewRow("evolucao");
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                  response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                  " - " +
                  response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                  "!"
                );
              }
            }
          );
        } else {
          self.showMessageCantEditParc();
        }
      }
    );
  };

  this.addEvolutionActionOnClick = function (widget) {
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    var nrParcNegocio = widget.getParent().currentRow.NRPARCNEGOCIO;
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    var self = this;

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      function (canEdit) {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                widget.getField("NMRESULTEVOL").readOnly = false;
                self.evolucaoNewRow();
                self.setNextTaskVisibility(widget, "AGENDAR_TAREFA");
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                  response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                  " - " +
                  response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                  "!"
                );
              }
            }.bind(self)
          );
        } else {
          self.showMessageCantEditParc();
        }
      }
    );
  };

  this.showMessageCantEditParc = function () {
    var message = "Ação bloqueada!<br> Somente o operador responsável pelo prospect e seus assistentes podem editá-lo/evoluí-lo.";
    ScreenService.showMessage(message);
  };

  this.verifyFilter = function () {
    var widget = templateManager.container.getWidget("gridProspect");
    var modified = false;
    widget.dataSourceFilter.forEach(function (filtro, index) {
      if (
        filtro.name == "NRPARCNEGOCIO" &&
        !widget.fromLead &&
        !widget.fromMap
      ) {
        widget.dataSourceFilter.splice(index, 1);
        modified = true;
      }
      if (
        filtro.name == "NRPARCNEGOCIO" &&
        (widget.fromLead || widget.fromMap)
      ) {
        widget.dataSourceFilter.splice(index, 1);
        widget.fromLead = false;
        widget.fromMap = false;
      }
    });

    if (modified && !widget.fromMap) {
      widget.reload();
    }
  };

  this.checkValidDate = function () {
    var widget = templateManager.container.getActiveWidget();
    var dataAbertura = widget.getField("DTHREVOLCONT");
    var data = dataAbertura.value().substring(0, 10);
    var dataAtual = new moment().format("DD/MM/YYYY");
    var variacao = moment(dataAtual, "DD/MM/YYYY").diff(
      moment(data, "DD/MM/YYYY"),
      "day"
    );
    var paramCRM;
    restEngine
      .post("product#/crud/crm_parametrizacao", {
        requestType: "FilterData",
        filter: [
          {
            operator: "=",
            name: "IDATIVO",
            value: "S",
          },
          {
            operator: "=",
            name: "NRORG",
            value: templateManager.LOGGEDOPERATOR.NRORG,
          },
        ],
      })
      .then(function (response) {
        paramCRM = response.dataset.crm_parametrizacao[0];

        if (variacao > paramCRM.NRDIASLANCEVOL) {
          ScreenService.showMessage(
            "Operação bloqueada!<br>Há um limite de " +
              paramCRM.NRDIASLANCEVOL +
              " dias para o lançamento retroativo de evoluções!"
          );
          widget.currentRow.DTHREVOLCONT = null;
        }
      });
  };

  this.verifyFilter = function () {
    var widget = templateManager.container.getWidget("gridProspect");
    var modified = false;
    widget.dataSourceFilter.forEach(function (filtro, index) {
      if (
        filtro.name == "NRPARCNEGOCIO" &&
        !widget.fromLead &&
        !widget.fromMap
      ) {
        widget.dataSourceFilter.splice(index, 1);
        modified = true;
      } else if (widget.fromLead || widget.fromMap) {
        widget.dataSourceFilter.splice(index, 1);
        widget.fromMap = false;
        widget.fromLead = false;
      }
    });

    if (modified) {
      widget.reload();
    }
  };

  this.returnToMainWidget = function () {
    ScreenService.closeSwipe();
    templateManager.container.getWidget("gridProspect").activate();
  };

  this.validaFiltro = function (args) {
    var row = args.e.preference.FILTER_ROW;
    if (
      !row.NRINSJURPROS &&
      !row.NMRAZSOCPROS &&
      !row.NMFANTPROS &&
      (!row.NRPARCRESPROSP || row.NRPARCRESPROSP.length <= 0)
    ) {
      ScreenService.showMessage(
        "Preencha pelo menos um dos campos: 'Razão Social', 'Nome Fantasia', 'Inscrição' ou 'Operador Responsável'."
      ).then(function () {
        self.widgetOnEnterOnce(args.owner, ["IDATIVO"], true);
      });
    }
  };

  this.deleteFromMap = function () {
    var widget = templateManager.container.getWidget("gridProspect");
    if (widget.fromMap) {
      delete widget.fromMap;
    }
  };

  this.removeParcOnRow = function (widget, nrparcnegocio) {
    widget.dataSource.data.forEach(function (row, index) {
      if (row.NRPARCNEGOCIO == nrparcnegocio) {
        widget.dataSource.data.splice(index, 1);
      }
    });
  };

  this.checkIfCanEditOrEvolParc = function (nrParcNegocio) {
    var restRow = {
      NRPARCNEGOCIO: nrParcNegocio,
      CRM_NRORGTRAB: getLocalVar("CRM_NRORGTRABALHO"),
    };

    var params = {
      requestType: "Row",
      row: restRow,
    };

    return restEngine
      .post("/checkIfCanEditOrEvolParc", params)
      .then(function (response) {
        return response.dataset.DADOS.CAN_EDIT;
      })
      .catch(function () {
        return false;
      });
  };

  this.addNewOpportunity = function (widget) {
    var currentRow = widget.currentRow;
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then(function (canEdit) {
      if (widget.parent.parent.currentRow.IDATIVO === "S") {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                General.widgetNewRow(widget);
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                  response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                  " - " +
                  response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                  "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      } else {
        ScreenService.showMessage(
          "Operação Bloqueada Pois o Prospect se encontra Inativo!<br>" +
          "<br>Gentileza Procurar a Equipe de Qualidade Para Ativação do Prospect"
        );
      }
    });
  };

  this.verifyFilterAssistant = function (widget) {
    // Parent widget filter
    var datFilter = widget.getParent().dataSourceFilter;
    var widgetFilter = widget.dataSourceFilter;

    var datFilterDia = datFilter.find(function (x) {
      return x.name == "DTHREVOLCONT";
    });
    var datFilterSent = datFilter.find(function (x) {
      return x.name == "IDSENEVOCONT";
    });
    var datFilterOper = datFilter.find(function (x) {
      return x.name == "NRPARCRESPONSAVEL";
    });
    var datFilterTipo = datFilter.find(function (x) {
      return x.name == "CDTIPOCONT";
    });
    var datFilterMoti = datFilter.find(function (x) {
      return x.name == "CDMOTIEVOCON";
    });
    var datFilterResu = datFilter.find(function (x) {
      return x.name == "NRSEQRESULEVOL";
    });
    var datFilterDesc = datFilter.find(function (x) {
      return x.name == "TXEVOLCONT";
    });

    // Widget filter
    var filterDia = widgetFilter.find(function (x) {
      return x.name == "DTHREVOLCONT";
    });
    var filterSent = widgetFilter.find(function (x) {
      return x.name == "IDSENEVOCONT";
    });
    var filterOper = widgetFilter.find(function (x) {
      return x.name == "NRPARCRESPONSAVEL";
    });
    var filterTipo = widgetFilter.find(function (x) {
      return x.name == "CDTIPOCONT";
    });
    var filterMoti = widgetFilter.find(function (x) {
      return x.name == "CDMOTIEVOCON";
    });
    var filterResu = widgetFilter.find(function (x) {
      return x.name == "NRSEQRESULEVOL";
    });
    var filterDesc = widgetFilter.find(function (x) {
      return x.name == "TXEVOLCONT";
    });

    // Changing widget filter
    if (!Util.isEmptyOrBlank(filterDia) && !Util.isEmptyOrBlank(datFilterDia)) {
      widgetFilter.push(datFilterDia);
    } else if (!Util.isEmptyOrBlank(filterDia)) {
      filterDia.value = !Util.isEmptyOrBlank(datFilterDia.value) ?
        datFilterDia.value : null;
    }
    if (!Util.isEmptyOrBlank(filterSent) && !Util.isEmptyOrBlank(datFilterSent)) {
      widgetFilter.push(datFilterSent);
    } else if (!Util.isEmptyOrBlank(filterSent)) {
      filterSent.value = !Util.isEmptyOrBlank(datFilterSent.value) ?
        datFilterSent.value : null;
    }
    if (!Util.isEmptyOrBlank(filterOper) && !Util.isEmptyOrBlank(datFilterOper)) {
      widgetFilter.push(datFilterOper);
    } else if (!Util.isEmptyOrBlank(filterOper)) {
      filterOper.value = !Util.isEmptyOrBlank(datFilterOper.value) ?
        datFilterOper.value : null;
    }
    if (!Util.isEmptyOrBlank(filterTipo) && !Util.isEmptyOrBlank(datFilterTipo)) {
      widgetFilter.push(datFilterTipo);
    } else if (!Util.isEmptyOrBlank(filterTipo)) {
      filterTipo.value = !Util.isEmptyOrBlank(datFilterTipo.value) ?
        datFilterTipo.value : null;
    }
    if (!Util.isEmptyOrBlank(filterMoti) && !Util.isEmptyOrBlank(datFilterMoti)) {
      widgetFilter.push(datFilterMoti);
    } else if (!Util.isEmptyOrBlank(filterMoti)) {
      filterMoti.value = !Util.isEmptyOrBlank(datFilterMoti.value) ?
        datFilterMoti.value : null;
    }
    if (!Util.isEmptyOrBlank(filterResu) && !Util.isEmptyOrBlank(datFilterResu)) {
      widgetFilter.push(datFilterResu);
    } else if (!Util.isEmptyOrBlank(filterResu)) {
      filterResu.value = !Util.isEmptyOrBlank(datFilterResu.value) ?
        datFilterResu.value : null;
    }
    if (!Util.isEmptyOrBlank(filterDesc) && !Util.isEmptyOrBlank(datFilterDesc)) {
      widgetFilter.push(datFilterDesc);
    } else if (!Util.isEmptyOrBlank(filterDesc)) {
      filterDesc.value = !Util.isEmptyOrBlank(datFilterDesc.value) ?
        datFilterDesc.value : null;
    }
  };

  this.returnToGrid = function () {
    var widget = templateManager.container.getActiveWidget();
    var parentWdg = widget.getParent();

    ScreenService.closeSwipe();

    parentWdg.activate();
    parentWdg.list();
  };

  this.callToConvertProspect = function (widget, parcPosicionado) {
    ScreenService.confirmMessage(
      "Deseja converter o parceiro para cliente?",
      "CONFIRMATION",
      function () {
        widget.currentRow.CDOPERADOR =
          templateManager.LOGGEDOPERATOR.CDOPERADOR;
        var currentRow = widget.currentRow;

        currentRow.CDOPERADOR = currentRow.CODOPERLOGGED;

        currentRow.NRINSESTCLIE = currentRow.NRINSESTPROS;

        this.validacaoCNPJCliente(
          widget.currentRow.NRINSJURPROS,
          widget.currentRow.NRORG
        ).then(
          function (response) {
            if (
              response.dataset &&
              response.dataset.cnpjcliente.valid === true
            ) {
              this.insertClient(currentRow).then(
                function (dataSet) {
                  if (dataSet.dataset && dataSet.dataset.CLIENTE) {
                    ScreenService.showMessage(
                      'O parceiro "' + dataSet.dataset.CLIENTE[0].NMRAZSOCCLIE + '" já foi convertido em Cliente anteriormente por outra organização do grupo. O Status deste parceiro foi atualizado com sucesso para Cliente!'
                    );
                    self.removeParcOnRow(widget, parcPosicionado);
                  } else {
                    ScreenService.showMessage(
                      "Prospect convertido com sucesso."
                    );
                    self.removeParcOnRow(widget, parcPosicionado);
                  }
                  widget.reload();
                  // BEGIN RD Station
                  var contactWidgets = templateManager.container.getWidget(
                    "WDGT_INTERLOCUTOR"
                  );
                  contactWidgets.dataSourceFilter.forEach(function (filter) {
                    if (filter.name === "NRPARCNEGOCIO")
                      filter.value = widget.currentRow.NRPARCNEGOCIO;
                  });
                  contactWidgets.reload().then(function () {
                    if (!Util.isEmptyOrBlank(contactWidgets.dataSource.data)) {
                      contactWidgets.dataSource.data.forEach(function (
                        contact
                      ) {
                        restEngine
                          .post("/IntegracaoRDStation/feedBackConversion", {
                            requestType: "Row",
                            row: {
                              EVENT_NAME:
                                "Cadastro convertido em cliente no CRM",
                              EMAIL: contact["EMAILINTERLOC"],
                            },
                          })
                          .then(function () {
                            restEngine.post(
                              "/IntegracaoRDStation/changeFunnel",
                              {
                                requestType: "Row",
                                row: {
                                  FUNNEL: "Client",
                                  EMAIL: contact["EMAILINTERLOC"],
                                },
                              }
                            );
                          });
                      });
                    }
                  });
                  // END RD Station
                  ScreenService.closePopup();
                  ScreenService.closeSwipe();
                }.bind(this)
              );
            } else if (
              response.dataset &&
              Array.isArray(response.dataset.cnpjcliente.valid)
            ) {
              var clientes = response.dataset.cnpjcliente.valid;
              var nomes = "";
              clientes.forEach(function (cliente) {
                nomes += "<br>" + cliente.NMRAZSOCCLIE;
              });
              ScreenService.showMessage(
                "Operação bloqueada! <br><br> Este CNPJ já está vinculado ao(s) seguinte(s) clientes(s): <br>" +
                nomes
              );
            }
          }.bind(this)
        );
      }.bind(this)
    );
  };

  this.callPopupPartnerRelated = function (dados) {
    var relationshipPopup = templateManager.container.getWidget("RELATIONSHIP_POPUP");
    ScreenService.closePopup();

    relationshipPopup.edit();

    dados.PAI.NRAGRPARC = null;
    dados.PAI.CRM_NRORGTRAB = 20;

    var data = [dados.PAI];
    var dataaux = dados.FILHOS;

    dataaux.forEach(function (filho) {
      filho.CRM_NRORGTRAB = 20;
      data.push(filho);
    });

    relationshipPopup.dataSource.data = data;

    ScreenService.openPopup(relationshipPopup);
  };

  this.popupRelationshipVoltar = function () {
    var widget = templateManager.container.getWidget("gridProspect");
    ScreenService.closePopup();
    widget.activate();
  };

  this.setParcsToConvert = function () {
    var gridWidget = templateManager.container.getWidget("gridProspect");
    var widget = templateManager.container.getWidget("RELATIONSHIP_POPUP");
    var evolWidgt = templateManager.container.getWidget("evolucaoParceiro");

    var parcupdate = widget.getCheckedRows();

    gridWidget.currentRow.CDOPERADOR = templateManager.LOGGEDOPERATOR.CDOPERADOR;

    var self = this; // Adicione esta linha para armazenar uma referência ao contexto externo

    parcupdate.forEach(function (parceiro, index) {
      var parcPosicionado = parceiro.NRPARCNEGOCIO;

      parceiro.CDOPERADOR = gridWidget.currentRow.CODOPERLOGGED;
      parceiro.NRINSJURPROS = parceiro.NRINSCRICAOPARC;
      parceiro.NMRAZSOCPROS = parceiro.NMPRINCIPALPARC;
      parceiro.NRORG = getLocalVar("CRM_NRORGTRAB");
      parceiro.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
      parceiro.DTINCLUSAO = moment(new Date()).format("DD/MM/YYYY HH:mm");
      parceiro.CURRENTOPER = templateManager.LOGGEDOPERATOR.CDOPERADOR;

      self.validacaoCNPJCliente(parceiro.NRINSJURPROS, parceiro.NRORG).then(
        function (response) {
          if (response.dataset && response.dataset.cnpjcliente.valid === true) {
            this.insertClient(parceiro).then(function (dataSet) {
              if (dataSet.dataset && dataSet.dataset.CLIENTE) {
                ScreenService.notificationMessage(
                  'O parceiro "' + dataSet.dataset.CLIENTE[0] + '" já foi convertido em Cliente anteriormente por outra organização do grupo. O Status deste parceiro foi atualizado com sucesso para Cliente!'
                );
                self.removeParcOnRow(gridWidget, parcPosicionado);

                General.callRestEngine(
                  "product#/agrupamentoEvolSave",
                  "Row",
                  evolWidgt.currentRow
                ).then(function (resp) {
                  if (resp.dataset && resp.dataset.error) {
                    ScreenService.showMessage(resp.dataset.error, "ERROR");
                  } else if (resp.error) {
                    ScreenService.showMessage(resp.error, "ERROR");
                  } else {
                    ScreenService.closeSwipe();
                  }
                });
              } else {
                General.callRestEngine(
                  "product#/agrupamentoEvolSave",
                  "Row",
                  evolWidgt.currentRow
                ).then(function (resp) {
                  if (resp.dataset && resp.dataset.error) {
                    ScreenService.showMessage(resp.dataset.error, "ERROR");
                  } else if (resp.error) {
                    ScreenService.showMessage(resp.error, "ERROR");
                  } else {
                    ScreenService.closeSwipe();
                  }
                });
                ScreenService.showMessage(
                  "Prospect convertido com sucesso.",
                  "success"
                );
                self.removeParcOnRow(gridWidget, parcPosicionado);
              }
            });
          } else if (
            response.dataset &&
            Array.isArray(response.dataset.cnpjcliente.valid)
          ) {
            var clientes = response.dataset.cnpjcliente.valid;
            var nomes = '';
            clientes.forEach(function (cliente) {
              nomes += '<br>' + cliente.NMRAZSOCCLIE;
            });
            ScreenService.showMessage(
              'Operação bloqueada! <br><br> Este CNPJ já está vinculado ao(s) seguinte(s) clientes(s): <br>' +
              nomes
            );
          }
        }.bind(self)
      );
    });

    gridWidget.reload();
    ScreenService.closePopup();
    ScreenService.closeSwipe();
  };
  
  this.openEvolTabWithoutInterloc = function () {
    var evolWidgt = templateManager.container.getWidget("evolucaoParceiro");
    var popupRelation = templateManager.container.getWidget("RELATIONSHIP_POPUP");
    var gridWidgt = templateManager.container.getWidget("gridProspect");

    var currentRow = evolWidgt.currentRow;
    var nrParcNegocio = gridWidgt.currentRow.NRPARCNEGOCIO;

    ScreenService.closePopup();
    ScreenService.openPopup(evolWidgt);
    evolWidgt.activate();

    evolWidgt.CONVERTPARCS = popupRelation.getCheckedRows();

    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      function (canEdit) {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                evolWidgt.getField("NMRESULTEVOL").readOnly = false;
                General.widgetNewRow(evolWidgt);

                currentRow = evolWidgt.currentRow;
                var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

                currentRow.DTHREVOLCONT = currentRow.DTHREVOLCONT
                  ? currentRow.DTHREVOLCONT
                  : moment(new Date()).format("DD/MM/YYYY HH:mm");
                currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
                currentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
                currentRow.NRORG = loggedOperatorInfos.NRORG;
                currentRow.TXEVOLCONT =
                  "Convertido por meio da evolução do parceiro " +
                  gridWidgt.currentRow.NMRAZSOCPROS;

                ABEvolucaoController.setEvolDateChangePermission(evolWidgt);
                this.setOperatorNextTask(currentRow, loggedOperatorInfos);

                currentRow.DTINCLUSAO = self.momentNow();
                currentRow.NRSEQCONTATO = gridWidgt.currentRow.NRSEQCONTATO;

                currentRow.NRORG = loggedOperatorInfos.NRORG;
                this.setNextTaskVisibility(evolWidgt, "AGENDAR_TAREFA");
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                  response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                  " - " +
                  response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                  "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }.bind(this)
    );
  };

  this.cancelRelationEvolPopup = function () {
    var widget = templateManager.container.getWidget("evolucaoParceiro");
    var gridWidget = templateManager.container.getWidget("gridProspect");

    General.widgetCancelForm(widget);
    this.deleteTaskInfosInEvolutionWidget(widget);

    ScreenService.closePopup();
    gridWidget.activate();
  };

  this.criarAcaoEditInterlocutor = function(field){
    CRM_Utilities.construirWidgetSelect(field, this.criarActionEditarInterlocutor());
  };

  /**
     * Função responsável por criar uma action de editar Interlocutor
     * @return {Object} action - a ação de editar
     */
  this.criarActionEditarInterlocutor = function(){
    return {
        "icon": "pencil",
        "showAsAction": "grid-right",
        "tooltip": "Editar",
        "isVisible": true,
        "condition": true,
        "events": [
            {
                "name": "ActionEvent",
                "code": "ger45000_Prospect_Controller.abrirPopupInterlocutorModoEdicao(args.owner.widget)"
            }
        ]
    };
  };

  this.abrirPopupInterlocutorModoEdicao = function(widget){
    if(!widget.currentRow.NRPARCNEGOCIO){
       ScreenService.showMessage(ScreenService.i18n("Operação bloqueada.<br>Selecione o parceiro de negócio ligado a proposta."));
    } else {
          ScreenService.closePopup();
          var wdgPopup = templateManager.container.getWidget("popupNovoInterlocutor");
          wdgPopup.isVisible = true;
          ScreenService.openPopup(wdgPopup).then(function(){
              wdgPopup.activate();
              wdgPopup.dataSource.data = [];
              wdgPopup.newRow();
              this.substituiRowDaPopupDoInterlocutor(wdgPopup, widget.currentRow);
              wdgPopup.getField("NMINTERLOCUTOR").readOnly = (wdgPopup.currentRow.IDNOMEVINDODAAPI != "N");
              wdgPopup.label = "Editar Interlocutor";              
              templateManager.updateTemplate();
          }.bind(this));
    }
  };

  this.substituiRowDaPopupDoInterlocutor = function(popupWdg, row) {
      popupWdg.currentRow.NRPARCNEGOCIO = row.NRPARCNEGOCIO;  
      popupWdg.currentRow.CDCARGOINTERLOC = row.CDCARGOINTERLOC;  
      popupWdg.currentRow.NMCARGOINTERLOC = row.NMCARGOINTERLOC;  
      popupWdg.currentRow.NMINTERLOCUTOR = row.NMINTERLOCUTOR;  
      popupWdg.currentRow.NRCPFINTERLOC = row.NRCPFINTERLOC;  
      popupWdg.currentRow.DSEMAIL = row.DSEMAIL;  
      popupWdg.currentRow.EMAILINTERLOC = row.EMAILINTERLOC;
      popupWdg.currentRow.NRSEQINTERLOCUTOR = row.NRSEQINTERLOCUTOR;
      popupWdg.currentRow.IDTPSIGNATARIO = (row.IDTPSIGNATARIO) ? row.IDTPSIGNATARIO :  "N";  
      popupWdg.currentRow.DTNASCIMENTO = row.DTNASCIMENTO;  
      popupWdg.currentRow.IDNOMEVINDODAAPI = (row.IDNOMEVINDODAAPI) ? row.IDNOMEVINDODAAPI :  "N";  
      popupWdg.currentRow.__is_new = false;  
  };

  this.selectInterlocutorEvolucao = function (widget){
      var parent = templateManager.container.getWidget("evolucao");

      parent.currentRow.NRSEQINTERLOCUTOR = widget.currentRow.NRSEQINTERLOCUTOR;
      parent.currentRow.NMINTERLOCUTOR = widget.currentRow.NMINTERLOCUTOR;
      parent.currentRow.EMAILINTERLOC = widget.currentRow.EMAILINTERLOC;

      ScreenService.closePopup(true);
  };

  this.selectInterlocutorAgenda= function (widget){
      var parent = templateManager.container.getWidget("posvendagrid");

      parent.currentRow.NRSEQINTERLOCUTOR = widget.currentRow.NRSEQINTERLOCUTOR;
      parent.currentRow.NMINTERLOCUTOR = widget.currentRow.NMINTERLOCUTOR;
      parent.currentRow.EMAILINTERLOC = widget.currentRow.EMAILINTERLOC;

      ScreenService.closePopup(true);
  };
};

Configuration(function (ContextRegister) {
  ContextRegister.register(
    "ger45000_Prospect_Controller",
    ger45000_Prospect_Controller
  );
});


// FILE: ./assets/js/controllers/ImportacaoProspectController.js
function ImportacaoProspectController(ScreenService, templateManager, Utilities, restEngine, Operador_Repository, metaDataFactory) {

    this.downloadPlanilhaModelo = function() {
        var filename = 'template_importacao_mailing.xls';
        window.open("files/" + filename, "_blank");
    };

    this.uploadPlanilhaModelo = function() {
        var widget = templateManager.container.getWidget('WDGT_UPLOAD_PLANILHA');
        widget.isVisible = true;
        ScreenService.openPopup(widget);
    };
    
    this.confirmUploadPlanilha = function(args) {
        var widget = args.owner.widget;
        var mainWid = widget.parent.parent;
        if (widget.isValid()) {
            var validationFile = this.verificaExtensaoArquivo(widget.currentRow);
            if (validationFile) {
                widget.currentRow.NRPARCNEGOCIO_OPER = templateManager.LOGGEDOPERATOR.NRPARCNEGOCIO;
                return restEngine.post("/saveUploadFile",{
                        requestType: "DataSet",
                        dataset: [widget.currentRow]
                    }, null, null, null, null, 900000000000000000
                ).then(function (response) {
                    if (!Util.isUndefined(response.dataset.saveUploadFile) && response.dataset.saveUploadFile[0] === true) {
                        mainWid.dataSource.data = [];
                        widget.isVisible = false;
                        ScreenService.closePopup(true);
                        ScreenService.showMessage("Arquivo '" + widget.currentRow.FILEPATH[0].name + "' carregado com sucesso.");
                    } else if (!Util.isUndefined(response.dataset.saveUploadFile) && !Util.isUndefined(response.dataset.saveUploadFile[0].error)) {
                        var inconsistencias = response.dataset.saveUploadFile[0].error;
                        //Percorre o objeto 'error' inserindo as inconsistencias no datasource da widget.
                        var newData = Object.keys(inconsistencias).map(function(key){
                            return inconsistencias[key];
                        });
                        //insere no datasource
                        mainWid.dataSource.data = newData;
                        widget.isVisible = false;
                        ScreenService.closePopup(true);
                        ScreenService.showMessage('Importação finalizada, verifique as inconsistências.');
                    } else {
                        ScreenService.showMessage("Não foi possível realizar o upload do arquivo '" + widget.currentRow.FILEPATH[0].name + "'.");
                    }
                }).catch(function(e) {
                    if (!Util.isUndefined(e.data) && e.data !== null)
                        ScreenService.showMessage(e.data.error);
                    else    
                        ScreenService.showMessage(e.message);
                        
                    mainWid.dataSource.data = [];
                    ScreenService.closePopup(true);
                });
            }
        }
    };
    
    this.widgetOnEnter = function(args) {
        var widget = args.owner;
        
        widget.currentRow.DTPLANFILACONTA = moment().format('DD/MM/YYYY HH:mm');
        widget.currentRow.DTHREVOLCONT = moment().format('DD/MM/YYYY');
    };
    
    this.onChangeGeraTarefa = function(args) {
        var widget = args.owner.field.widget;
        if (args.row.IDGERATAREFA == 'S') {
            widget.getField('DTPLANFILACONTA').validations = {"required": {}};
            widget.getField('NRPRIORFILACONT').validations = {"required": {}};
            widget.getField('DSFILACONTATO').validations = {"required": {}};
            widget.getField('DTPLANFILACONTA').readOnly = false;
            widget.getField('NRPRIORFILACONT').readOnly = false;
            widget.getField('NMOPERREAL').readOnly      = false;
            widget.getField('DSFILACONTATO').readOnly   = false;
        } else {
            widget.getField('DTPLANFILACONTA').validations = {};
            widget.getField('NRPRIORFILACONT').validations = {};
            widget.getField('DSFILACONTATO').validations = {};
            widget.getField('DTPLANFILACONTA').readOnly = true;
            widget.getField('NRPRIORFILACONT').readOnly = true;
            widget.getField('NMOPERREAL').readOnly      = true;
            widget.getField('DSFILACONTATO').readOnly   = true;
        }
        
        widget.reload();
    };
    
    this.onChangeGeraEvolucao = function(args) {
        var widget = args.owner.field.widget;
        if (args.row.IDGERAEVOLUCAO == 'S') {
            widget.getField('NMTIPOCONT').validations    = {"required": {}};
            widget.getField('NMMOTIEVOCON').validations  = {"required": {}};
            widget.getField('DESCRESULEVOL').validations = {"required": {}};
            widget.getField('TXEVOLCONT').validations    = {"required": {}};
            widget.getField('NMTIPOCONT').readOnly       = false;
            widget.getField('NMMOTIEVOCON').readOnly     = false;
            widget.getField('DESCRESULEVOL').readOnly    = false;
            widget.getField('TXEVOLCONT').readOnly       = false;
        } else {
            widget.getField('NMTIPOCONT').validations    = {};
            widget.getField('NMMOTIEVOCON').validations  = {};
            widget.getField('DESCRESULEVOL').validations = {};
            widget.getField('TXEVOLCONT').validations    = {};
            widget.getField('NMTIPOCONT').readOnly       = true;
            widget.getField('NMMOTIEVOCON').readOnly     = true;
            widget.getField('DESCRESULEVOL').readOnly    = true;
            widget.getField('TXEVOLCONT').readOnly       = true;
        }
        
        widget.reload();
    };
    
    this.onChangeTipoParceiro = function(args) {
        var widget = args.owner.field.widget;
        if (args.row.TIPODEPARCEIRO == 'CANDIDATO') {
            widget.getField('IDGERATAREFA').readOnly    = true;
            widget.getField('IDGERATAREFA').validations = {};
            widget.getField('IDGERATAREFA').hideEmptyValue = false;
            args.row.IDGERATAREFA = 'N';
            this.onChangeGeraTarefa(args);
            widget.getField('IDGERAEVOLUCAO').readOnly = true;
            widget.getField('IDGERAEVOLUCAO').validations = {};
            widget.getField('IDGERAEVOLUCAO').hideEmptyValue = false;
            args.row.IDGERAEVOLUCAO = 'N';
            this.onChangeGeraEvolucao(args);
            
        } else {
            widget.getField('IDGERATAREFA').readOnly = false;
            widget.getField('IDGERATAREFA').validations = {"required":{}};
            widget.getField('IDGERATAREFA').hideEmptyValue = true;
            widget.getField('IDGERAEVOLUCAO').readOnly = false;
            widget.getField('IDGERAEVOLUCAO').validations = {"required":{}};
            widget.getField('IDGERAEVOLUCAO').hideEmptyValue = true;
        }
        
        widget.reload();
    };
    
    this.verificaExtensaoArquivo = function(argsRow){
        var bool = true;
        if (!Util.isUndefined(argsRow.FILEPATH) && argsRow.FILEPATH.length > 0) {
            var extencoes = ['xls', 'xlsx'];            
            $.each(argsRow.FILEPATH, function (key, value) {
                var tipo = argsRow.FILEPATH[key].name.split('.');
                if (extencoes.indexOf(tipo[1]) == -1) {
                    ScreenService.showMessage('Favor selecionar arquivos no formato XLS, XLSX ou CSV');
                    bool = false;
                }
            });
        } else {
            ScreenService.showMessage('Favor selecionar um arquivo no formato XLS, XLSX ou CSV');
            bool = false;
        }

        return bool;
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ImportacaoProspectController', ImportacaoProspectController);
});

// FILE: ./assets/js/controllers/Indicador_Oportunidade_Controller.js
function Indicador_Oportunidade_Controller(templateManager, ScreenService, Utilities, Operador_Repository)
{

	this.iniciaFiltrosWidoportunidade_pizza = function(widget)
    {
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
        		if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }

        	  Utilities.insertFilter(widget, "P_NRPARCRESP", "=", "_"+operator[0].NRPARCNEGOCIO+"_", 2);
            Utilities.insertFilter(widget.getField("P_NRPARCRESP"), "P_NRORG", "=", operator[0].NRORG, 0);
            Utilities.insertFilter(widget.getField("P_NRPARCRESP"), "P_NRPARCNEGOCIO", "=", operator[0].NRPARCNEGOCIO, 1);
        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
    };

    this.iniciaFiltrosWidoportunidade_donut = function(widget)
    {
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
        		if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }
                    		Utilities.insertFilter(widget, "P_NRPARCRESP", "=", "_"+operator[0].NRPARCNEGOCIO+"_", 2);
            Utilities.insertFilter(widget.getField("P_NRPARCRESP"), "P_NRORG", "=", operator[0].NRORG, 0);
            Utilities.insertFilter(widget.getField("P_NRPARCRESP"), "P_NRPARCNEGOCIO", "=", operator[0].NRPARCNEGOCIO, 1);
        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
    };

	this.exibeValorOportPizza = function()
	{
		var widget = templateManager.container.getWidget('tabbed').widgets[0];
        var msg = widget.currentRow.IDENTIFICADOR+" : "+widget.currentRow.QUANTIDADE;
        ScreenService.showMessage(msg, 'success', 'information');
	};

	this.exibeValorOportDonut = function()
	{
		var widget = templateManager.container.getWidget('tabbed').widgets[1];
        var msg = "Negócios "+widget.currentRow.IDENTIFICADOR+" : "+widget.currentRow.QUANTIDADE+".<br/> Com valores de até: ";
        msg += Utilities.getValorEmReais(widget.currentRow.SOMA);
        ScreenService.showMessage(msg, 'success', 'information');
	};

	this.changeValuesFilter = function(widget)
	{
		widget.dataSourceFilter[2].operator = '=';
		var val = widget.dataSourceFilter[2].value;
		var i, string = '_';
		for(i = 0; i < val.length; i++)
		{
			string += val[i]+"_";
		}

		if(val.length === 0)
		{
			string += '_';
		}

		widget.dataSourceFilter[2].value = string;
	};
}

Configuration(function(ContextRegister)
{
    ContextRegister.register('Indicador_Oportunidade_Controller', Indicador_Oportunidade_Controller);
});

// FILE: ./assets/js/controllers/IndicadorLeadController.js
function IndicadorLeadController(templateManager, ScreenService, Utilities, restEngine, General, metaDataFactory, CRM_Utilities, ZHPromise, Dashboard_Controller, ZhReports, ZhFilterPreferences){
    
    this.cascadeReload = function(widget){
        widget.widgets.forEach(function(childWid){
            childWid.dataSource.data = widget.dataSource.data;
            if(childWid.template.indexOf('chart') !== -1 && widget.currentWidget.name === childWid.name){
                childWid.updateChart();
            }
            if(childWid.name === 'WDGT_GRID_LEADS'){
                this.afterLoadDataSourceReport(childWid, false);
            }
        }.bind(this));
    };
    
    this.filterAfterApplyReport = function(args){
        var widget = args.owner;
        var filterRow = args.e.preference.FILTER_ROW;
        var stripe = templateManager.container.getWidget('WDGT_INDICADOR_STRIPE');
        
        var stripeLabel;
        
        if(filterRow.INTERVALO) {
            var start = filterRow.INTERVALO.start;
            var end = filterRow.INTERVALO.end;
            
            stripeLabel = start ? start + ' a ' + end : "";
        } else {
            stripeLabel = "";
        }
        
        stripe.getField('SELECTEDMONTH').label = stripeLabel;
        widget.activate();
    };
    
    this.onEnterOnceReport = function(widget){
        this.openFilter(widget);
        
        widget.currentRow.CDOPERADOR = templateManager.LOGGEDOPERATOR.CDOPERSHIERARQINF;
        var filteredMonth = templateManager.container.getWidget("WDGT_TAB_INDICADORLEAD").currentRow.ORDEM.slice(0,2);
        var filteredYear  = templateManager.container.getWidget("WDGT_TAB_INDICADORLEAD").currentRow.ORDEM.slice(3,5);
        
        var start = '01/'+filteredMonth+'/20'+filteredYear;
        var lastday = new Date(2000+parseInt(filteredYear), parseInt(filteredMonth), 0).getDate();
        var end = lastday+'/'+filteredMonth+'/20'+filteredYear;
        widget.currentRow.INTERVALO = {
            start:start,
            end:end
        };
    };
    
    this.openFilter = function(widget) {
        var fieldsToApply = [];
        
        CRM_Utilities.openFilterOnEnter(widget, widget.currentRow, fieldsToApply);
    };
    
    this.afterLoadDataSourceReport = function(widget, cascadeReload){
        var stripe = templateManager.container.getWidget('WDGT_INDICADOR_STRIPE');
        var chart = templateManager.container.getWidget('WDGT_INDICADOR_LEADS');
        
        widget.dataSource.data.forEach(function(row){
            row.MES =  stripe.getField('SELECTEDMONTH').label;
            row.INTERVALO =  stripe.getField('SELECTEDMONTH').label;
        });  
        
        if(cascadeReload){
            chart.dataSource.data = widget.dataSource.data;
        }
        
        widget.redraw();
    };
    
    this.generateReport = function(widget, option){
        var widgetToReport = templateManager.container.getWidget('WDGT_TO_REPORT');
        var stripe = templateManager.container.getWidget('WDGT_INDICADOR_STRIPE');
        widget = widget || templateManager.container.getWidget('WDGT_GRID_LEADS');
        
        //Numbers to String
        widget.dataSource.data.forEach(function(row){
        	Object.keys(row).forEach(function(key){
            	if(typeof row[key] === "number")
        			row[key] = row[key].toString();
        	});
        });
        
        widgetToReport.dataSource.data = widget.dataSource.data;
        widgetToReport.fields = widget.fields;
        var label = widgetToReport.getField('MES').label;
        label = label.indexOf('De') ? stripe.fields[1].label : 'De '+stripe.fields[1].label;  
        
        if(option === 'XLS'){
            widgetToReport.getField('MES').label = 'Período';
            widgetToReport.getField('MES').isVisibleOnReport = true;
            widgetToReport.getField('MES').isVisible = true;
        }else{
            widgetToReport.getField('MES').label = label;
            widgetToReport.getField('MES').isVisibleOnReport = false;
            widgetToReport.getField('MES').isVisible = false;
        }
        ZhReports.openReport(widget.dataSource.data, widgetToReport, null, null, option);
        widgetToReport.getField('MES').label = 'Período';
    };
	
	this.setDefaultParameters = function(widget, mes) {
	    if(!widget.currentRow.ORDEM) {
	        widget.currentRow.ORDEM = moment().subtract(1, 'M').format('MM/YY');
	    }
	    
	    var mes = widget.currentRow.ORDEM;
        var ano = mes.slice(3,5);
        
        var operadores = templateManager.LOGGEDOPERATOR.CDOPERSHIERARQINF;
	    
	    var widgetChart = templateManager.container.getWidget('WDGT_TAB_INDICADORLEAD');
        var lastday = new Date(2000+ano, parseInt(mes.slice(0,2)), 0).getDate();
        widgetChart.dataSourceFilter = [
            {
                name: "P_NRORG",
                operator: "=",
                static: true,
                value: templateManager.LOGGEDOPERATOR.NRORG
            },
            {
                name: "P_CRM_NRORGTRAB",
                operator: "=",
                static: true,
                value: getLocalVar('CRM_NRORGTRABALHO')
            },
            {
                name: "P_CDOPERADORES",
                operator: "IN",
                static: true,
                value: operadores
            },
            {
                name: "DATAINICIAL",
                operator: "=",
                static: true,
                value: "01/"+mes+" 00:00"
            },
            {
                name: "DATAFINAL",
                operator: "=",
                static: true,
                value:lastday+'/'+mes+" 23:59"
            }
        ];
        widgetChart.currentRow['MES'] = mes;
        widgetChart.currentRow['ORDEM'] = widget.currentRow.ORDEM;
        var stripe = templateManager.container.getWidget('WDGT_INDICADOR_STRIPE');
        stripe.fields[0].label = 'Leads Cadastrados x Convertidos';
        //Replace pra pegar o ano no LocaleString
        stripe.fields[1].label = new Date(mes.replace('/', '/01/')).toLocaleString('pt-BR', {month:'long', year:'numeric'});
        stripe.fields[1].label = CRM_Utilities.capitalizeFirstLetter(stripe.fields[1].label);
        stripe.chart = 'leads_cadastrados_convertidos';
        widget.activate();
        widgetChart.reload();
	}
}
Configuration(function(ContextRegister){
    ContextRegister.register('IndicadorLeadController', IndicadorLeadController);
});

// FILE: ./assets/js/controllers/InterlocutoresPendentesController.js
function InterlocutoresPendentes(ScreenService, templateManager, Utilities, wizardEngine, ZHPromise, Operador_Repository, General, CRM_Utilities, restEngine, ChamadoController) {

    this.changeLabel = function(widget){
        var action = widget.getAction('SENT_MAIL');
        if(widget.getCheckedRows().length > 1)
            action.label = 'Reenviar Email de Ativação aos interlocutores';
        else
            action.label = 'Reenviar Email de Ativação ao interlocutor';
    };
    
    this.openPopupSetClient = function(widget){
        if(widget.currentRow.ATIVO === 'S'){
            var popUp = templateManager.container.getWidget('WDGT_SET_CLIENT');
            popUp.currentRow = {};
            popUp.isVisible =true;
            ScreenService.openPopup(popUp);
        }else{
            ScreenService.confirmMessage('O interlocutor precisa ser ativado para atribuir um cliente.  </br>Deseja reenviar o email de ativação?', 'QUESTION',
            function(success){
                this.sentMail(widget);
            }.bind(this));
        }
    };
    
    this.sentMail = function(widget){
        var mainWidget = templateManager.container.getWidget('WDGT_INTERLOCUTORES');
        var rows;
        if(mainWidget.getCheckedRows().length === 0)
            rows = [mainWidget.currentRow];
        else
            rows = mainWidget.getCheckedRows();
            
        var rowsToBackend = [];    
        
        rows.forEach(function(interloc){
            var row = {
                NRPARCNEGOCIO: interloc.NRPARCNEGOCIO,
                NMINTERLOCUTOR: interloc.NMINTERLOCUTOR,
                EMAIL:interloc.EMAILINTERLOC,
                NRSEQINTERLOCUTOR:interloc.NRSEQINTERLOCUTOR,
                NRORG: interloc.NRORG
            };
            rowsToBackend.push(row);
        });
        
        var paramsRestEngine = {
            requestType:"DataSet",
            dataset:rowsToBackend
        };
        
        restEngine.post('product#/sentConfirmationMail', paramsRestEngine).
            then(function(response){
                if(response.dataset.INTERLOCUTOR){
                    ScreenService.showMessage('Email enviado com sucesso!').then(function(){
                        mainWidget.dataSource.clearCheckedRows();
                        mainWidget.reload();
                    });
                }    
            }).catch(function(error){
                ScreenService.showMessage(error.data.error);    
            });
    };
    
    this.setClient = function(widget){
        var mainWidget = templateManager.container.getWidget('WDGT_INTERLOCUTORES');
        var interloc = mainWidget.currentRow;
        var rowsToBackend = [];
        
        var row = {
            NRPARCNEGOCIOINTERLOCUTOR: interloc.NRPARCNEGOCIO,
            NMINTERLOCUTOR: interloc.NMINTERLOCUTOR,
            CDCLIENTE: widget.currentRow.CDCLIENTE,
            NRPARCNEGOCIOCLIENTE:widget.currentRow.NRPARCNEGOCIO,
            NRSEQINTERLOCUTOR:interloc.NRSEQINTERLOCUTOR,
            NRORG:interloc.NRORG
        };
        rowsToBackend.push(row);
        
        var paramsRestEngine = {
            requestType:"DataSet",
            dataset:rowsToBackend
        };
        
        restEngine.post('product#/setClientInPendInt', paramsRestEngine).
            then(function(response){
                if(response.dataset.INTERLOCUTOR){
                    ScreenService.showMessage('Cliente Atribuido ao Interlocutor');
                    ScreenService.closePopup(true);
                    ScreenService.closeSwipe().then(function(){
                        mainWidget.reload();
                    });
                }    
            }).catch(function(error){
                ScreenService.showMessage(error.data.error);    
            });
    };
    
    this.cancelInterloc = function(widget){
        ScreenService.confirmMessage('Deseja realmente excluir o interlocutor e cancelar todos os seus tickets?', 'QUESTION',
        function(success){
            var paramsRestEngine = {
                requestType:'Row',
                row:widget.currentRow
            };
            
            restEngine.post('product#/cancelInterloc', paramsRestEngine).
                then(function(response){
                    if(response.dataset.INTERLOCUTOR){
                        ScreenService.showMessage('Interlocutor excluido e Tickets cancelados');
                        ScreenService.closeSwipe().then(function(){
                            ScreenService.closePopup(true);
                            widget.reload();
                        });
                    }    
                }).catch(function(error){
                    ScreenService.showMessage(error.data.error);    
                });        
        }, 
        function(cancel){
            
        });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('InterlocutoresPendentes', InterlocutoresPendentes);
});

// FILE: ./assets/js/controllers/LoginProductController.js
function LoginProductController(ApplicationContext, eventAggregator, Query, templateManager, RepositoryFactory, ScreenService, localStorageEngine, Dashboard_Controller, General)
{
    var self = this;
    
    
    var setParameters = function(session) {
        
        var operatorName = session.user ? session.user.nmoperador : session.nmoperador;
        var orgName = session.user ? session.user.nmorg : session.nmorg;
        
        ScreenService.buildUserData(operatorName, [orgName], function(){
            ScreenService.openWindow('product#crm_profile');
        }, window.defaultUserImageUrl);
        ScreenService.setHeaderInfo(orgName);
    };
    
    var setLocalVars = function(user) {
        
        localStorageEngine.setLocalVar('CRM_CDOPERADOR', user.cdoperador);
        localStorageEngine.setLocalVar('CRM_NRORG', user.nrorg);
        localStorageEngine.setLocalVar('CRM_NRORGTRAB', user.nrorgtrab);
        localStorageEngine.setLocalVar('CRM_CDOPERADOR', user.cdoperador);
        localStorageEngine.setLocalVar('CRM_NMOPERADOR', user.nmoperador);
        localStorageEngine.setLocalVar('CRM_DSEMAILOPER', user.dsemailoper);
        localStorageEngine.setLocalVar('CRM_NRORGPADRAO', 0);
        localStorageEngine.setLocalVar('PROJECT_ID', window.projectId);
        
    };
    
    var setUserID = function(user) {
        //ZhPreferences.setUserID(user.cdoperador);
        if(ApplicationContext.ZhPreferences) {
            ApplicationContext.ZhPreferences.setUserID(user.cdoperador);
        } else {
            ApplicationContext.zhCustomizationsService.registerUser(user.cdoperador);
        }
    };
    
    eventAggregator.subscribe('authSuccess', function(session) {
        var widget;
        
        var user = session.user;
        var cdoperador = user.cdoperador;
        var perfilDeAcesso = user.perfilDeAcesso;

                
        setLocalVars(user);
        setUserID(user);
        setParameters(user);
        setGeneralParameters(user.nrorg);
        
        
        //Zeedhi Access Control
        localStorageEngine.setLocalVar("userId", cdoperador);
        localStorageEngine.setLocalVar("accessProfiles", perfilDeAcesso);
        //localStorageEngine.setLocalVar("productIdLoginUrl", ConfigLogin.loginProductId);
        var interval = setInterval(function() {
            if(!Util.isEmptyOrBlank(templateManager.container) && !Util.isEmptyOrBlank(templateManager.LOGGEDOPERATOR)) {
                clearInterval(interval);
                widget = templateManager.container.getWidget('tabForcaVendas');
                Dashboard_Controller.setVisibleDashboardTabs();
                loadGraphics(widget);
            }
        }.bind(this), 1500);
        
    });
    
    
    function getTableByName(tableName, filter) {
        if (!filter) {
            filter = [];
        }
        return General.callRestEngine("product#/crud/" + tableName, "FilterData", filter).then(function (response) {
            var result = [];
            if (response.dataset[tableName])
                result = response.dataset[tableName];
            return result;
        });
    }
    
    function getParamgeral(filtro) {
        return getTableByName("paramgeral", filtro).then(function(response) {
            var paramgeral = null;
            if (response.length)
                paramgeral = response[0];
            return paramgeral;
        });
    }
    
    function setGeneralParameters(nrorg) {
        var filtro = [
            {
                "name": "NRORG",
                "operator": "=",
                "value": nrorg
            }
        ];
        return getParamgeral(filtro).then(function (paramgeral) {
            if (paramgeral) {
                localStorageEngine.setLocalVar('CAD_CDPICTPRAT', replaceMask(paramgeral.CDPICTPRAT, regularExpressions.LETTERS));
                localStorageEngine.setLocalVar('GER_CDPICTPROD', replaceMask(paramgeral.CDPICTPROD, regularExpressions.LETTERS));
                localStorageEngine.setLocalVar('CDPICTPROD', replaceMask(paramgeral.CDPICTPROD, regularExpressions.LETTERS));
                localStorageEngine.setLocalVar('CDPICTCCTB', replaceMask(paramgeral.CDPICTCCTB, regularExpressions.LETTERS));
                localStorageEngine.setLocalVar('GER_CDPICTPRAT', replaceMask(paramgeral.CDPICTPRAT, regularExpressions.LETTERS_AND_NUMBERS));
                localStorageEngine.setLocalVar('CDPICTPRAT', replaceMask(paramgeral.CDPICTPRAT, regularExpressions.LETTERS_AND_NUMBERS));
            } else {
                ScreenService.showMessage("Parâmetros gerais não configurados", "E");
            }
        });
    }
    
    var replaceMask = function(value, regex) {
        return (value || '').toString().replace(regex, '*');
    };
    
    var regularExpressions = {
        LETTERS: /((a|A))/g,
        LETTERS_AND_NUMBERS: /((a|A|9))/g
    };
    
     function loadGraphics(widget) {
        var widName = widget.name;
        
        if (widget.isVisible) {
            if (!Util.isEmptyOrBlank(widget.widgets)) {
                widget.widgets.forEach(function(inWidget) {
                    loadGraphics(inWidget);
                }.bind(this));
            }
            
            widget.dataSourceFilter.forEach(function(dataFilter) {
                if(dataFilter.name == 'P_NRPARCOPERADORES') {
                    dataFilter.value = Dashboard_Controller.getOperatorPropertyIfSetted('NRPARCOPERSHIERARQINF');
                } else if (dataFilter.name == 'CDOPERADOR'){
                    dataFilter.value = Dashboard_Controller.getOperatorPropertyIfSetted('CDOPERADOR');
                } else if (dataFilter.name == 'P_CDOPERSHIERARQINF'){
                    dataFilter.value = Dashboard_Controller.getOperatorPropertyIfSetted('CDOPERSHIERARQINF');
                }
            });
            
            widget.reload();
        }
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('LoginProductController', LoginProductController);
});


// FILE: ./assets/js/controllers/MapController.js
function MapController(restEngine, ScreenService, ZHPromise, templateManager) {
    
    var map;
    var markers;
    var dataForReplace = [];

    this.getSRC = function(){
        var widget = templateManager.container.getActiveWidget();
        return widget.mapUrl;
    };
    
    this.getMap = function() {
        return "https://maps.googleapis.com/maps/api/js?key=AIzaSyA5vRtFek_17V-Q6t4bhTYpSCSunxDPzzM&callback=initMap";
    };
    
    this.initMap = function (filteredData, filter) {
        var center = {
            lat: -14.235004,
            lng: -51.925280
        };
        templateManager.mapPreviousPosition = [];
    
        ScreenService.changeLoadingMessage('Carregando Mapa');
        ScreenService.showLoader();
    
        map = new google.maps.Map(document.getElementById('map'), {
            center: center,
            zoom: 4
        });
    
        if (Util.isEmptyOrBlank(filter)) {
            filter = [
                {
                    "name": "CRM_NRORGTRAB",
                    "operator": "=",
                    "value": getLocalVar('CRM_NRORGTRABALHO')
                }
            ];
        }
    
        this.buildLocations(filteredData, filter).then(function (locations) {
            var markersInMap = [];
            this.clearCurrentList();
            templateManager.container.getWidget('list').dataSource.data = locations;
            templateManager.container.getWidget('list').dataSource.reload();
            this.createParents();
            markers = locations.map(function (location, i) {
                var icon = this.buildIcon(location['CDTIPOPARCPRINCIPAL'], location['NRTERMOPORTUNI']);
                var position = new google.maps.LatLng(parseFloat(location['DSLATITUDE']), parseFloat(location['DSLONGITUDE']));
                if (this.isLocationFree(position, markersInMap)) {
                    markersInMap.push(position);
                    return new google.maps.Marker({
                        position: position,
                        map: map,
                        icon: icon,
                        information: location
                    });
                } else {
                    return 'duplicated';
                }
            }.bind(this)).filter(function (marker) { return marker !== 'duplicated' });
            templateManager.mapMarkers = markers;
            templateManager.map = map;
    
            var markerCluster = new MarkerClusterer(map, markers, {
                imagePath: 'https://developers.google.com/maps/documentation/javascript/examples/markerclusterer/m',
                gridSize: 45
            });
            google.maps.event.addListener(markerCluster, "clusterclick", function (cluster) {
                if (!templateManager.mapPreviousPosition.find(function (n) { return n.zoom === templateManager.map.getZoom() }))
                    templateManager.mapPreviousPosition.push({ "center": templateManager.map.getCenter(), "zoom": templateManager.map.getZoom() });
            });
    
            google.maps.event.addListener(map, "dblclick", function () {
                if (!templateManager.mapPreviousPosition.find(function (n) { return n.zoom === templateManager.map.getZoom() }))
                    templateManager.mapPreviousPosition.push({ "center": templateManager.map.getCenter(), "zoom": templateManager.map.getZoom() });
            });
    
            templateManager.mapClusters = markerCluster;
    
            markers.forEach(function (marker) {
                var nome = (Util.isEmptyOrBlank(marker['information']['NMPRINCIPALPARC'])) ? '' : marker['information']['NMPRINCIPALPARC'];
                var endereco = (Util.isEmptyOrBlank(marker['information']['DSENDERECO'])) ? '' : marker['information']['DSENDERECO'];
                var interlocutor = (Util.isEmptyOrBlank(marker['information']['NMINTERLOCUTOR'])) ? '' : marker['information']['NMINTERLOCUTOR'];
                var telefone = (Util.isEmptyOrBlank(marker['information']['DSTELEFONE'])) ? '' : marker['information']['DSTELEFONE'];
                if (telefone)
                    telefone = '(' + telefone.slice(0, 2) + ')' + ' ' + telefone.slice(2, 6) + '-' + telefone.slice(6, telefone.length);
    
                var contentInfoWindow =
                    '<style> @import url("https://fonts.googleapis.com/css?family=Roboto:300,900");' +
                    'h1,h2,h3,h4{font-family:"Roboto", sans-serif; color:#414141}' +
                    'h1{font-size:11px;font-weight:900; line-height:0.9}' +
                    'h2{font-size:9.5px;font-weight:300; color:#232323; line-height:1.2}' +
                    'h3{font-size:10px;font-weight:300; line-height:1.2}' +
                    'h4{font-size:9.5px;font-weight:300; line-height:1.2}' +
                    '</style>' +
                    '<div id="infoWindowMap" style="width:150px; height:auto; border-radius:10%;">' +
                    '<h1>' + nome + '</h1>' +
                    '<h2>' + endereco + '</h2>' +
                    '<h3>' + interlocutor + '</h2>' +
                    '<h4>' + telefone + '</h3>' +
                    '</div>';
    
                var infoWindow = new google.maps.InfoWindow({
                    content: contentInfoWindow
                });
    
                marker.addListener('mouseover', function () {
                    infoWindow.open(map, marker);
                });
                marker.addListener('mouseout', function () {
                    infoWindow.close(map, marker);
                });
                marker.addListener('click', function () {
                    var widget = templateManager.container.getWidget('iframe');
                    widget.currentRow.NRPARCNEGOCIO = marker['information']['NRPARCNEGOCIO'];
                    ScreenService.openPopup(templateManager.container.getWidget('INFOPARCEIRO'));
                });
            }.bind(this));
    
            if (filteredData)
                this.closeFilter();
    
            ScreenService.hideLoader();
            ScreenService.restoreDefaultLoadingMessage();
        }.bind(this));
    };
    
    this.buildLocations = function (filteredData, filter) {
        var promise = ZHPromise.defer();
        var widMapa = templateManager.container.getWidget('mapa');
    
        if (typeof filter === 'undefined' || filter === null) {
            filter = null;
        }
    
        this.getLocations(filter).then(function (dataSet) {
            var locations = dataSet.dataset.locations;
            widMapa.dataSource.data = dataSet.dataset.locations;
            promise.resolve(locations.filter(function (n) {
                return (n['DSLATITUDE'] !== null && n['DSLONGITUDE'] !== null);
            }));
        }.bind(this));
    
        return promise.promise;
    };
    
    this.getLocations = function (filter) {
        return restEngine.post('/getLocationsForMap', { 'requestType': 'FilterData', 'filter': filter }, null, null, null, null, 900000000);
    };
    
    this.buildList = function(markers) {
        var list = templateManager.container.getWidget('list');
        var data = list.dataSource.data;
        var maxID = 100;
        
        markers.forEach(function(parceiro){
            parceiro = parceiro['information'];
            var parent = parceiro['CDTIPOPARCPRINCIPAL'] === 'CLIENTE' ? "30" : parceiro['CDTIPOPARCPRINCIPAL'] === 'PROSPECT' ? "20" : "10";
            
            var itemForList = {
                "ID":(maxID+1).toString(),
                "NMPRINCIPALPARC":  parceiro['NMPRINCIPALPARC'],
                "DSENDERECO":       parceiro['DSENDERECO'],
                "NMINTERLOCUTOR":   parceiro['NMINTERLOCUTOR'],
                "DSTELEFONE":       parceiro['DSTELEFONE'],
                "PARENT":           parent,
                "DSLATITUDE":       parceiro['DSLATITUDE'],
                "DSLONGITUDE":      parceiro['DSLONGITUDE'],
                "NRPARCNEGOCIO":    parceiro['NRPARCNEGOCIO']
            };
            data.push(itemForList);    
            maxID++;
        }.bind(this));
        
        
        list.dataSource.data = data;
        list.reload();
    };
    
    this.clearCurrentList = function() {
        var list = templateManager.container.getWidget('list');
        var data = list.dataSource.data;
        data = data.splice(0, 1);
        list.dataSource.data = data;
        list.reload();
    };
    
    this.createParents = function (exists) {
        exists = exists || false;
        var widget = templateManager.container.getWidget('list');
        var data = widget.dataSource.data;
        var title = lead = prospect = cliente = null;
    
        data.forEach(function (parceiro, parcIndex) {
            if (parceiro.CDTIPOPARCPRINCIPAL == 'CLIENTE') {
                parceiro.PARENT = '30';
            } else if (parceiro.CDTIPOPARCPRINCIPAL == 'PROSPECT') {
                parceiro.PARENT = '20';
            } else if (parceiro.CDTIPOPARCPRINCIPAL == 'CANDIDATO') {
                parceiro.PARENT = '10';
            }
    
            if (parceiro.DSLATITUDE == null || parceiro.DSLONGITUDE == null) {
                dataForReplace.push(parceiro);
                delete data[parcIndex];
            }
        });
    
        if (exists == false) {
            title = {
                "ID": "1",
                "NMPRINCIPALPARC": "Parceiros Listados",
                "PARENT": null,
                "preventClick": true
            };
            lead = {
                "ID": "10",
                "NMPRINCIPALPARC": "Lead",
                "PARENT": null,
                "opened": false,
                "preventClick": true
            };
            prospect = {
                "ID": "20",
                "NMPRINCIPALPARC": "Prospect",
                "PARENT": null,
                "opened": false,
                "preventClick": true
            };
            cliente = {
                "ID": "30",
                "NMPRINCIPALPARC": "Cliente",
                "PARENT": null,
                "opened": false,
                "preventClick": true
            };
        }
        data.push(title, lead, prospect, cliente);
    };
    
    this.openFilter = function() {
        var filterMap = templateManager.container.getWidget('filterMap');
        if(Util.isEmptyOrBlank(filterMap.currentRow.IDATIVO)) {
            filterMap.currentRow.IDATIVO = 'S';
        }
        if(Util.isEmptyOrBlank(filterMap.currentRow.CDOPERADOR)) {
            filterMap.currentRow.CDOPERADOR = templateManager.LOGGEDOPERATOR.CDOPERADOR;
            filterMap.currentRow.NMOPERADOR = templateManager.LOGGEDOPERATOR.NMOPERADOR;
        }
        ScreenService.openPopup(filterMap);
    };
    
    this.closeFilter = function() {
        var filterMap = templateManager.container.getWidget('filterMap');
        filterMap.isVisible = false;
        ScreenService.closePopup(true);
        templateManager.container.getWidget('mapa').activate();
    };
    
    this.colorLuminance = function(hex, lum) {
        
    	// validate hex string
    	hex = String(hex).replace(/[^0-9a-f]/gi, '');
    	if (hex.length < 6) {
    		hex = hex[0]+hex[0]+hex[1]+hex[1]+hex[2]+hex[2];
    	}
    	lum = lum || 0;
    
    	// convert to decimal and change luminosity
    	var rgb = "#", c, i;
    	for (i = 0; i < 3; i++) {
    		c = parseInt(hex.substr(i*2,2), 16);
    		c = Math.round(Math.min(Math.max(0, c + (c * lum)), 255)).toString(16);
    		rgb += ("00"+c).substr(c.length);
    	}

    	return rgb;
    };
    
    this.buildIcon = function(tipoParc, termParc) {
        var templateForProspect = [
                '<?xml version="1.0" encoding="utf-8"?> <!-- Generator: Adobe Illustrator 16.0.0, SVG Export Plug-In . SVG Version: 6.00 Build 0) --> <!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd"> <svg version="1.1" id="Capa_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" width="512px" height="512px" viewBox="0 0 512 512" enable-background="new 0 0 512 512" xml:space="preserve"> <g> <path fill="{{fillMarker}}" stroke="{{strokeMarker}}" stroke-miterlimit="10" d="M256,0C167.641,0,96,71.625,96,160 c0,24.75,5.625,48.219,15.672,69.125C112.234,230.313,256,512,256,512l142.594-279.375C409.719,210.844,416,186.156,416,160 C416,71.625,344.375,0,256,0z M160,160 M352,160"/> </g> <g> <path fill="{{fillLetter}}" d="M242.084,222.002V286h-29.168V109.513h53.537c20.266,0,35.979,4.719,47.137,14.153 c11.158,9.437,16.738,22.729,16.738,39.876c0,17.149-5.826,31.18-17.477,42.091c-11.65,10.913-27.404,16.369-47.26,16.369H242.084z M242.084,133.635v64.491h18.953c12.555,0,22.111-2.912,28.678-8.738c6.563-5.825,9.846-14.031,9.846-24.615 c0-20.757-12.061-31.138-36.185-31.138H242.084z"/> </g> </svg>'
                ].join('\n');;
        var templateForLead     = [
                '<?xml version="1.0" encoding="utf-8"?> <!-- Generator: Adobe Illustrator 16.0.0, SVG Export Plug-In . SVG Version: 6.00 Build 0) --> <!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd"> <svg version="1.1" id="Capa_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" width="512px" height="512px" viewBox="0 0 512 512" enable-background="new 0 0 512 512" xml:space="preserve"> <g> <path fill="{{fillMarker}}" stroke="{{strokeMarker}}" stroke-miterlimit="10" d="M256,0C167.641,0,96,71.625,96,160 c0,24.75,5.625,48.219,15.672,69.125C112.234,230.313,256,512,256,512l142.594-279.375C409.719,210.844,416,186.156,416,160 C416,71.625,344.375,0,256,0z M160,160 M352,160"/> </g> <g> <path fill="{{fillLetter}}" d="M310.637,286h-97.721V109.513h29.292v151.75h68.429V286z"/> </g> </svg>'
                ].join('\n');;
        var templateForClient   = [
                '<?xml version="1.0" encoding="utf-8"?> <!-- Generator: Adobe Illustrator 16.0.0, SVG Export Plug-In . SVG Version: 6.00 Build 0) --> <!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd"> <svg version="1.1" id="Capa_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" width="512px" height="512px" viewBox="0 0 512 512" enable-background="new 0 0 512 512" xml:space="preserve"> <g> <path fill="{{fillMarker}}" stroke="{{strokeMarker}}" stroke-miterlimit="10" d="M256,0C167.641,0,96,71.625,96,160 c0,24.75,5.625,48.219,15.672,69.125C112.234,230.313,256,512,256,512l142.594-279.375C409.719,210.844,416,186.156,416,160 C416,71.625,344.375,0,256,0z M160,160 M352,160"/> </g> <g> <path fill="{{fillLetter}}" d="M310.492,267.616c-13.291,6.892-29.826,10.338-49.6,10.338c-25.599,0-46.112-8.081-61.537-24.246 c-15.426-16.163-23.138-37.372-23.138-63.629c0-28.225,8.677-51.033,26.03-68.429c17.354-17.394,39.28-26.092,65.783-26.092 c17.066,0,31.219,2.421,42.461,7.262v29.045c-11.898-7.056-25.025-10.584-39.383-10.584c-19.12,0-34.606,6.113-46.462,18.338 c-11.857,12.227-17.784,28.553-17.784,48.983c0,19.446,5.538,34.934,16.615,46.46c11.077,11.529,25.64,17.292,43.691,17.292 c16.656,0,31.096-3.938,43.322-11.815V267.616z"/> </g> <g> </g> </svg>'
                ].join('\n');;
        var color, template;
        
        if(tipoParc === 'CLIENTE'){
            color = '#48db81';
            template = templateForClient;
        }else if(tipoParc === 'CANDIDATO'){
            color = '#ffc64a';
            template = templateForLead;
        }else{
            color = '#1893db';
            template = templateForProspect;
        }
        
        if(!Util.isEmptyOrBlank(templateManager.termometroFilter)){
            templateManager.termometroFilter.forEach(function(termometro){
                if(termometro.nrtermoportuni === termParc)
                    color = termometro.cor;
            });
        }
        
        var svg = this.replaceTemplateWithColor(template, color);        
        return { url: 'data:image/svg+xml;charset=UTF-8,' + encodeURIComponent(svg), scaledSize: new google.maps.Size(35, 35), color:color }   
    };
    
    this.chooseColor = function(type) {
        templateManager.mapMarkers.forEach(function(marker, index, markers){
            if(type === 'oportunidade'){
                var icon = marker.getIcon();    
                icon.url = this.replaceTemplateWithColor(icon.url, '#42f480', icon.color);
                marker.setIcon(icon);
            }
        }.bind(this));
    };
    
    this.replaceTemplateWithColor = function(template, color, actualColor) {
        var replacer;
        if(actualColor){
            replacer = actualColor.replace('#', '');
            color = color.replace('#', '');
        }
        var svg = template.replace(Util.isEmptyOrBlank(replacer) ? '{{fillMarker}}' : replacer, color);
        svg.replace(Util.isEmptyOrBlank(replacer) ? '{{strokeMarker}}'  : replacer, this.colorLuminance(color, -0.2));
        svg.replace(Util.isEmptyOrBlank(replacer) ? '{{fillLetter}}'  : replacer, this.colorLuminance(color, -0.2));
        return svg;
    };
    
    this.centerMarker = function(args) {
        var currentMarker = args.owner.currentRow;
        if(!currentMarker.preventClick){
            var lat = currentMarker.DSLATITUDE;
            var lng = currentMarker.DSLONGITUDE;
            if(!templateManager.mapPreviousPosition.find(function(n){return n.zoom === templateManager.map.getZoom()}))
                templateManager.mapPreviousPosition.push({"center":templateManager.map.getCenter(), "zoom":templateManager.map.getZoom()});
            
            var center = new google.maps.LatLng(parseFloat(lat), parseFloat(lng));
            
            var bounds = new google.maps.LatLngBounds();
            bounds.extend(center);
            templateManager.map.panTo(center);
            templateManager.map.fitBounds(bounds);
            templateManager.map.setZoom(15);
            
            templateManager.mapMarkers.forEach(function(marker){
                google.maps.event.trigger(marker, 'mouseout');
                if(marker['information']['NRPARCNEGOCIO'] === currentMarker['NRPARCNEGOCIO'])
                    google.maps.event.trigger(marker, 'mouseover');
            });
        }
    };
    
    this.smoothZoom = function(map, max, cnt) {
        if(cnt == max){
            return
        }else if (cnt > max) {
             var z = google.maps.event.addListener(map, 'zoom_changed', function(event){
                google.maps.event.removeListener(z);
                this.smoothZoom(map, max, cnt - 1);
            }.bind(this));
            
            setTimeout(function(){map.setZoom(cnt)}, 40); 
        }
    }; 
    
    this.geocodePartners = function(widget) {
        this.getLocations().then(function(dataSet){
            var locations = dataSet.dataset.locations;
            var geocoder = new google.maps.Geocoder();
            var geocoded = [];
            var partnersWithoutLat = (locations.filter(function(n){ return n['DSLONGITUDE'] == null }));
            partnersWithoutLat.forEach(function(partner, index){
                geocoder.geocode({'address': (partner['ENDERECO']).toString()}, function(results, status) {
                    if (status === 'OK') {
                        geocoded.push({parcnegocio: partner['NRPARCNEGOCIO'], nrorg: partner['NRPARCNEGOCIO'], lat: results[0].geometry.location.lat(), lng:results[0].geometry.location.lng()});
                    }
                    if(index === partnersWithoutLat.length-1)
                        restEngine.post('/geocode', {
                                requestType: "DataSet",
                                dataset: geocoded
                        }).
                        then(function(response){
                            
                        }); 
                }.bind(this)); 
            }.bind(this));
        });
    };
    
    this.readOnlyFieldValorOport = function(widget) {
        var fieldValorOportDe = widget.getField('VROPORT');
        var fieldValorOportAte = widget.getField('VROPORTATE');
        
        var valorDe;
        var valorAte;
        
        if(fieldValorOportDe.value()) {
            valorDe = fieldValorOportDe.value().replace(/[^0-9]/g, '').slice(0, -2);
        }
        
        if(fieldValorOportAte.value()) {
            valorAte = fieldValorOportAte.value().replace(/[^0-9]/g, '').slice(0, -2);
        }
        
        if(Util.isEmptyOrBlank(fieldValorOportDe.value())){
            // fieldValorOportAte.readOnly = true;
            // fieldValorOportAte.clearValue();
            fieldValorOportAte.validations.minCurrency.limit = '';
        }else{
            // fieldValorOportAte.readOnly = false;
            // fieldValorOportAte.clearValue();
            fieldValorOportAte.validations.minCurrency.limit = valorDe;
        }
    };
    
    this.buildFilterValorOport = function() {
        var widget = templateManager.container.getActiveWidget();
        var fieldValorOportDe = widget.getField("VROPORT");
        var fieldValorOportAte = widget.getField("VROPORTATE");
        
        var valorDe, valorAte;
        
        if(Util.isEmptyOrBlank(fieldValorOportDe.value())){
            fieldValorOportDe.value("R$0,00");
        }
        
        if(Util.isEmptyOrBlank(fieldValorOportAte.value())){
            fieldValorOportAte.value("R$10000000,00");
        }
        
        if(fieldValorOportDe.value()) {
            valorDe = fieldValorOportDe.value().toString().replace(/[^0-9]/g, '').slice(0, -2);
        }
        if(fieldValorOportAte.value()) {
            valorAte = fieldValorOportAte.value().toString().replace(/[^0-9]/g, '').slice(0, -2);
        }
        var filters = [];
        
        if(!Util.isEmptyOrBlank(valorDe) && !Util.isEmptyOrBlank(valorAte)){
            var frame = templateManager.container.getWidget('iframe');
            filters.push(widget.currentRow);
            
            frame.dataSourceFilter = filters;
            var filterBetween = {
                "name":"VROPORT",
                "operator":"BETWEEN",
                "value": [valorDe, valorAte]
            };
            
            frame.dataSourceFilter[0].push(filterBetween);
            delete frame.dataSourceFilter[0].$error;
        }else{
            widget.dataSourceFilter.forEach(function(filter, index){
                if(filter.name !== "VROPORT" && filter.name !== "VROPORTATE")
                    filters.push(filter);
            });
            widget.dataSourceFilter = filters;    
        }
        
        this.unMaskPhone(widget);
        // this.checkTermometro(widget);
    };
    
    this.unMaskPhone = function(widget) {
        widget.dataSourceFilter.forEach(function(filter){
            if(filter.name === "TELEFONE"){
                filter.value = filter.value.replace(/[^0-9]/g, '');
                filter.value = '%' + filter.value + '%';
            }
        });
    };

    this.goBackZoom = function() {
        var center = {
            lat: -14.235004,
            lng: -51.925280    
        };
        
        var previousCenter = center;
        var previousZoom   = 4;
    
        this.smoothZoom(templateManager.map, previousZoom-1, templateManager.map.getZoom());
        templateManager.map.panTo(previousCenter);
        
        templateManager.mapMarkers.forEach(function(marker){
                google.maps.event.trigger(marker, 'mouseout');
        });
    };
    
    this.checkTermometro = function(widget) {
        var filters = widget.dataSourceFilter;
        filters.forEach(function(filter){
            if(filter.name === "NRTERMOPORTUNI"){
                templateManager.termometroFilter = [];
                filter.value.forEach(function(termometro, index){
                    templateManager.termometroFilter.push({"nrtermoportuni": termometro, "cor":widget.dataSourceFilter.filter(function(f){return f.name === "DSCORTERMOMETRO"})[0].value[index]});
                });                                                                 
            }    
        });
        
        
    };
    
    this.isLocationFree = function(position, markersInMap) {
        var lat = position.lat();
        var lng = position.lng();
        
        markersInMap.forEach(function(markerInMap){
            if(markerInMap.position.lat() === lat && markerInMap.position.lng() === lng)
                return false;
        });
        
        return true;
    };
    
    this.atualizaLatLong = function(dataAux, registros) {
        var widget = templateManager.container.getWidget('mapa');
       
        restEngine.post('/atualizaLatLong', {requestType: "DataSet", dataset: dataAux}).then(function(response) {
            if (!Util.isEmptyOrBlank(dataAux) && widget.geocodeError) {
                ScreenService.notificationMessage('Foram atualizados somente ' + registros + ' porque o limite de pesquisa por latitude e longitude foi excedido.', "alert");
            }
            this.aplicarFiltro();
            this.createParents(true);
            templateManager.container.getWidget('list').dataSource.reload();
        }.bind(this));
    };
    
    
    this.setLatLong = function () {
        ScreenService.confirmMessage("Todos os parceiros relacionados ao operador filtrado que não possuam latitude e longitude terão seus respectivos dados atualizados conforme o endereço principal atual, deseja continuar? (Este processo pode demorar algum tempo)", 'CONFIRMATION',
            function (success) {
                var widget = templateManager.container.getWidget('mapa');
                var data = widget.dataSource.data;
                var geocoder = new google.maps.Geocoder();
                var dataAux = [];
    
                data.forEach(function (parceiro) {
                    if (!parceiro.DSLONGITUDE && !parceiro.DSLATITUDE) {
                        dataAux.push(parceiro);
                    }
                });
    
                // Repete o processo até que não existam mais parceiros no dataSource ou até que o geocoder tenha dado erro
                var contador = 0; var registros = 0;
                ScreenService.showLoader();
                var interval = setInterval(function () {
                    if (contador + 1 >= dataAux.length && contador !== 0) {
                        clearInterval(interval);
                        ScreenService.hideLoader();
                        if (!Util.isEmptyOrBlank(dataAux)) {
                            ScreenService.confirmMessage("Foram encontrados " + dataAux.length + " parceiros, deseja continuar?", "CONFIRMATION", function (success) {
                                this.atualizaLatLong(dataAux, registros);
                            }.bind(this));
                        } else if (Util.isEmptyOrBlank(dataAux) && widget.geocodeError) {
                            ScreenService.showMessage(widget.geocodeError, "ERROR");
                        }
                    } else {
                        if (Util.isEmptyOrBlank(widget.geocodeError)) {
                            geocoder.geocode({ 'address': dataAux[contador].DSENDERECO }, function (results, status) {
                                if (dataAux[contador]) {
                                    if (status == google.maps.GeocoderStatus.OK) {
                                        var latitude = results[0].geometry.location.lat();
                                        var longitude = results[0].geometry.location.lng();
                                        dataAux[contador].DSLATITUDE = latitude;
                                        dataAux[contador].DSLONGITUDE = longitude;
                                        registros++;
                                    } else if (status == 'OVER_QUERY_LIMIT') {
                                        widget.geocodeError = 'Limite de pesquisa por latitude e longitude por tempo ou diário excedido! Espere alguns minutos e tente novamente ou tente novamente em outro dia.';
                                    }
                                }
                            });
                        }
                        contador++;
                    }
                }.bind(this), 1500);
    
            }.bind(this));
    
    };
    
    this.closeModal = function() {
        var map = templateManager.container.getWidget('mapa');
        ScreenService.closePopup(true);
        map.activate();
    };
    
    this.aplicarFiltro = function() {
        // foi feito um filtro a mão pois o filtro do zeedhi só pega para uma widget com dataSource, e neste caso, o dataSource é chamado em um função
        var widget = templateManager.container.getWidget('filterMap');
        var currentRow = widget.currentRow;
        var filtro = [];
        
        if(!Util.isEmptyOrBlank(currentRow.CDTIPOPARCPRINCIPAL)) {
            filtro.push(
                {
                    "name": "CDTIPOPARCPRINCIPAL",
                    "operator": "=",
                    "value": currentRow.CDTIPOPARCPRINCIPAL
                }
            );
        } if(!Util.isEmptyOrBlank(currentRow.CDTIPOINSCRICAO)) {
            filtro.push(
                {
                    "name": "CDTIPOINSCRICAO",
                    "operator": "=",
                    "value": currentRow.CDTIPOINSCRICAO
                }
            );
        } if(!Util.isEmptyOrBlank(currentRow.NRINSCRICAOPARC)) {
            filtro.push(
                {
                    "name": "NRINSCRICAOPARC",
                    "operator": "LIKE_I",
                    "value": currentRow.NRINSCRICAOPARC
                }
            );
        } if(!Util.isEmptyOrBlank(currentRow.NMPRINCIPALPARC)) {
            filtro.push(
                {
                    "name": "NMPRINCIPALPARC",
                    "operator": "LIKE_I",
                    "value": currentRow.NMPRINCIPALPARC
                }
            );
        } if(!Util.isEmptyOrBlank(currentRow.NMSECUNDARIPARC)) {
            filtro.push(
                {
                    "name": "NMSECUNDARIPARC",
                    "operator": "LIKE_I",
                    "value": currentRow.NMSECUNDARIPARC
                }
            );
        } if(!Util.isEmptyOrBlank(currentRow.CDPAIS)) {
            filtro.push(
                {
                    "name": "CDPAIS",
                    "operator": "=",
                    "value": currentRow.CDPAIS
                }
            );
        } if(!Util.isEmptyOrBlank(currentRow.SGESTADO)) {
            filtro.push(
                {
                    "name": "SGESTADO",
                    "operator": "=",
                    "value": currentRow.SGESTADO
                }
            );
        } if(!Util.isEmptyOrBlank(currentRow.CDMUNICIPIO)) {
            filtro.push(
                {
                    "name": "CDMUNICIPIO",
                    "operator": "=",
                    "value": currentRow.CDMUNICIPIO
                }
            );
        } if(!Util.isEmptyOrBlank(currentRow.CDBAIRRO)) {
            filtro.push(
                {
                    "name": "CDBAIRRO",
                    "operator": "=",
                    "value": currentRow.CDBAIRRO
                }
            );
        } if(!Util.isEmptyOrBlank(currentRow.IDATIVO)) {
            filtro.push(
                {
                    "name": "IDATIVO",
                    "operator": "=",
                    "value": currentRow.IDATIVO
                }
            );
        } if(!Util.isEmptyOrBlank(currentRow.CDOPERADOR)) {
            filtro.push(
                {
                    "name": "CDOPERADOR",
                    "operator": "=",
                    "value": currentRow.CDOPERADOR
                }
            );
        }
        
        filtro.push(
            {
                "name": "CRM_NRORGTRAB",
                "operator": "=",
                "value": getLocalVar('CRM_NRORGTRABALHO')
            }
        );
        
        this.initMap('default', filtro);
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('MapController', MapController);
});

// FILE: ./assets/js/controllers/MetasController.js
function MetasController(templateManager, ScreenService, Utilities, restEngine, General, metaDataFactory, CRM_Utilities, ZHPromise, Dashboard_Controller, ZhFilterPreferences, Messages){
    this.setMeta = function(args) {
        var widget = args;
        if (widget.isValid()) {
            widget.currentRow.VRMINMETA = widget.currentRow.VRMINMETA.toString().split(',')[0].replace(/[^0-9]/g, '');
            return General.widgetSave(widget).then(function(response){
                widget.reload().then(function(){
                    this.applyMaskOnMinValue(widget);
                }.bind(this));
            }.bind(this));
        }
    };
    
    this.applyMaskOnMinValue = function(widget){
        var tipoMeta;
        widget.dataSource.data.forEach(function(row){
           tipoMeta = row['CDTIPOMETA']; 
            switch (tipoMeta) {
                case 'VALOR_OPORTUNIDADES' :
                    if(row['VRMINMETA'].toString().indexOf('R$') === -1 && row['VRMINMETA'].toString().length > 0)
                        row['VRMINMETA'] = 'R$'+row['VRMINMETA']+',00';
                    break;
                case 'CONVERSAO_LEADS' :
                    row['VRMINMETA'] = row['VRMINMETA'].toString().split(',')[0].replace(/[^0-9]/g, '');
                    break;
            }
            if(widget.currentRow.NRMETAS === row['NRMETAS'])
                widget.currentRow.VRMINMETA = row['VRMINMETA'];
        });
    };
    
    /**
     * Função para salvar uma meta
     * ao perfil de atividade em caso.
     * 
     * @param {object} widget widget ativa onde está
     * sendo realizado o cadastro de meta
    */
    this.salvarMetaNoPerfil = function(widget){
        
        var currentRow = widget.currentRow;
        
        var activityProfileMeta = currentRow.METAS;
        var rows = [];
        
        activityProfileMeta.forEach(function(result, metaIndex){
            
            rows.push(this.setActivityProfileMetaValuesInCurrentRow(widget, metaIndex));
                
        }.bind(this)); 
        
        General.callRestEngine("product#/crm_perfilmetas/save", "DataSet", rows).then(function(response){
                
                rows.forEach(function(meta){
                    var nrmetas = meta['NRMETAS'];
                    var nrseqperfativ = meta['NRSEQPERFATIV'];
                    var cdtipometa = meta['CDTIPOMETA'];
                    this.buildOperadoresPerfil(nrseqperfativ, nrmetas, cdtipometa).then(function(operadores){
                        
                        General.callRestEngine("product#/crm_perfilmetas/saveOperador", "DataSet", operadores).then(function(response){
                    
                                
                        }.bind(this)).catch(function(err) {
                            var errorMessage = Messages.CATCH_EXCEPTION_ERROR(err);
                            ScreenService.showMessage(errorMessage);
                        });  
                        
                    }.bind(this));
                }.bind(this));
                ScreenService.closeSwipe().then(function(){
                    widget.reload();
                });
                
        }.bind(this));
    };
    
    /**
     * Função para pegar as informações do 
     * array de metas na currentRow, e
     * tratá-las em uma cópia da currentRow para
     * realizar o save.
     * 
     * @param {object} widget widget ativa onde está
     * sendo realizado o cadastro de metas.
     * 
     * @param {int} metaIndex index da meta
     * no array de metas presente na currentRow.
    */
    this.setActivityProfileMetaValuesInCurrentRow = function(widget, metaIndex){
        
        var currentRow = angular.copy(widget.currentRow);
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.__is_new = true;
        currentRow.NRSEQPERFATIV = widget.parent.parent.currentRow.NRSEQPERFATIV;
        currentRow.NRMETAS = currentRow.METAS[metaIndex];
        currentRow.CDTIPOMETA = currentRow.CDTIPOMETA[metaIndex];
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        
        return currentRow;
        
    };
    
    /**
     * Função para inserir um filtro na field
     * de metas da tela de perfil de atividade,
     * atualiza a field.
     * 
     * @param {object} widget widget ativa no
     * modo edit, onde está sendo mostrado o campo
     * de metas.
    */
    this.insertMetaFilter = function(widget){
        
        var metaField = widget.getField("METAS");
        var metaFieldFilter = metaField.dataSourceFilter;
        
        var nrseqperfativIndex = CRM_Utilities.getFilterPosition(metaFieldFilter, "P_NRSEQPERFATIV");
        
        metaFieldFilter[nrseqperfativIndex].value = widget.parent.parent.currentRow.NRSEQPERFATIV;
        
        metaField.reload();
    };
    
    this.setOperMetaValuesInCurrentRow = function(widget, operIndex){
        
        var currentRow = angular.copy(widget.currentRow);
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.__is_new = true;
        currentRow.NRMETAS = widget.parent.parent.currentRow.NRMETAS;
        currentRow.CDOPERADOR = currentRow.OPERADORES[operIndex];
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        currentRow.NRSEQPERFATIV = null;
        
        return currentRow;
        
    };
    
    this.saveNewOper = function(widget){
        
        var currentRow = widget.currentRow;
        
        var metaOper = currentRow.OPERADORES;
        var rows = [];
        
        metaOper.forEach(function(result, operIndex){
            
            rows.push(this.setOperMetaValuesInCurrentRow(widget, operIndex));
                
        }.bind(this)); 
        
        General.callRestEngine("product#/crm_perfilmetas/saveOperador", "DataSet", rows).then(function(response){
                
                ScreenService.closeSwipe().then(function(){
                    
                    widget.reload();
                    
                });
                
        }.bind(this)).catch(function(err) {
            var errorMessage = Messages.CATCH_EXCEPTION_ERROR(err);
            ScreenService.showMessage(errorMessage);
        });    
        
    };
    
    this.buildOperadoresPerfil = function(nrseqperfativ, nrmetas, cdtipometa){
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        var promise = ZHPromise.defer();
        
        restEngine.post("product#/crud/crm_perfioper_operadormeta", {'requestType':'FilterData', filter: [{operator: "=", name: "NRSEQPERFATIV", value: nrseqperfativ}, {operator: "=", name: "CDTIPOMETA", value: cdtipometa}]}).
        then(function(response){
                
            var operadores = response.dataset.crm_perfioper_operadormeta;   
            operadores.forEach(function(operador, index, operadores){
                var row  = {};
                
                row.__is_new = true;
                row.NRMETAS = nrmetas;
                row.CDOPERADOR = operador['CDOPERADOR'];
                row.NRORG = loggedOperatorInfos.NRORG;
                row.NRSEQPERFATIV = nrseqperfativ;
                operadores[index] = row;
            
                
            }.bind(this));
            
            promise.resolve(operadores);
                
        }.bind(this));   
        return promise.promise;
    };
    
    this.deleteOperadores = function(nrmetas, nrseqperfativ){
        restEngine.post("product#/crm_perfioper_operador/deleteOperadores", {'requestType':'FilterData', filter: [{operator: "=", name: "NRSEQPERFATIV", value: nrseqperfativ}, {operator: "=", name: "NRMETAS", value: nrmetas}]});
    };
    
    this.deleteMeta = function(widget, nrmetas, nrseqperfativ){
        General.deleteCrud(widget).then(function(){
            this.deleteOperadores(nrmetas, nrseqperfativ)
        }.bind(this));
        
    }
    
    this.changeMonth = function(widget, goTo, betweenFilter){
        var indicadorWdgt = Dashboard_Controller.chooseWidgetChart(widget.chart);
        var mesatual = indicadorWdgt.currentRow.ORDEM;
        var mesMin = moment().subtract(6, 'months').format('MM/YY');
        var mesMax = moment().format('MM/YY');
        
        if((this.compareMonths(mesatual,mesMin) && goTo === 'back') || (this.compareMonths(mesMax,mesatual) && goTo === 'next') || (betweenFilter && goTo === 'back') ){
            var mes = parseInt(mesatual.slice(0,2))+(goTo === 'back' ? -1 : +1);
            var ano = mesatual.slice(3,5);
            
            //Trata anos diferentes
            if(mes == 13){
                mes = 1;
                ano = parseInt(ano) + 1;
            }if(mes == 0){
                mes = 12;
                ano = parseInt(ano) - 1;
            }
            
            var pad = "00";
            mes = (pad+mes).slice(-pad.length);
            if(betweenFilter){
                var filters = [];
                indicadorWdgt.dataSourceFilter.forEach(function(filter, index){
                    if(filter.name !== 'DATAINICIAL' && filter.name !== 'DATAFINAL'){
                        filters.push(filter);
                    }
                });
                filters.push({
                    name:'DATAINICIAL',
                    operator:'=',
                    static:true,
                    value:'01/'+mes+'/'+ano+' 00:00'
                });
                var lastday = new Date(2000+ano, mes, 0).getDate();
                filters.push({
                    name:'DATAFINAL',
                    operator:'=',
                    static:true,
                    value:lastday+'/'+mes+'/'+ano+' 23:59'
                });
                indicadorWdgt.dataSourceFilter = filters;
            }else{
                indicadorWdgt.dataSourceFilter[2] = {
                        name: "ORDEM",
                        operator: "=",
                        static: true,
                        value: mes
                };
            }
            indicadorWdgt.currentRow['ORDEM'] = mes + '/' + ano;
            var stripe = templateManager.container.getWidget('WDGT_INDICADOR_STRIPE');
            stripe.fields[0].label = indicadorWdgt.label;
            stripe.fields[1].label = new Date(mes + '/01/' + ano).toLocaleString('pt-BR', {month:'long', year:'numeric'});
            stripe.fields[1].label = CRM_Utilities.capitalizeFirstLetter(stripe.fields[1].label);
            indicadorWdgt.reload();
        }else if(mesatual === mesMax && goTo === 'next'){
            ScreenService.alertNotification('Não é possível mostrar datas superiores ao mês atual.', 2000);
        }else if(mesatual === mesMin && goTo === 'back'){
            ScreenService.alertNotification('Só é possivel mostrar até 6 meses anteriores ao mês atual.', 2000);
        }
        
        
    };
    
    
    //Retorna true se o primeiro mês é menor que o segundo, verifica ano
    this.compareMonths = function(month1, month2){
        var year1 = month1.slice(3,5);
        var year2 = month2.slice(3,5);
        
        if(year1 > year2){
            return true;
        }else if(month1 > month2){
            return true;
        }
        
        return false;
        
    };
    
    this.openOportWindowFilteringOper = function(widget){
        ScreenService.openWindow('product#crm00002_001_oportunidade_de_negocio').then(function(){
            
            var oportWidgt = templateManager.container.getWidget('oportunidadegrid');
            var date = new Date();
            var firstDateBewteen = new Date(date.getFullYear(), (parseInt(widget.currentRow.ORDEM)-1), 1);
            var lastDateBewteen  = new Date(date.getFullYear(), (parseInt(widget.currentRow.ORDEM)), 0);
            firstDateBewteen = firstDateBewteen.toLocaleDateString('pt-BR');
            lastDateBewteen = lastDateBewteen.toLocaleDateString('pt-BR');
            
            oportWidgt.dataSourceFilter = [
                {
                    name: "NRORG",
                    operator: "=",
                    value: "@templateManager.LOGGEDOPERATOR.NRORG@"
                },
                {
                    name: "IDTPOPERADOR",
                    operator: "=",
                    value: "E"
                },
                {
                    name: "NRPARCRESP",
                    operator: "=",
                    default: true,
                    value: widget.currentRow.NRPARCNEGOCIO
                },
                {
                    name: "SITUACAO",
                    operator: "IN",
                    static: true,
                    value: "@['F']@"
                },
                {
                    name: "DINCLUSAO",
                    operator: "BETWEEN",
                    static: true,
                    value: [firstDateBewteen,lastDateBewteen]
                }
            ];
            oportWidgt.reload().then(function(){
                ScreenService.closePopup(true);
                oportWidgt.actions.forEach(function(action, index){
                    if(action.name == 'BACK_CHARTS')
                        action.isVisible = true;
                });
                oportWidgt.activate();
                oportWidgt.METAFILTER = true;
                oportWidgt.__filterPopup.currentRow.CDOPERADOR = [widget.currentRow.CDOPERADOR];
                oportWidgt.__filterPopup.currentRow.NRPARCRESP = [widget.currentRow.NRPARCNEGOCIO];
                oportWidgt.__filterPopup.currentRow.NMPARCRESP = [widget.currentRow.OPERADOR];
                oportWidgt.__filterPopup.currentRow.DINCLUSAO = {start: firstDateBewteen, period: undefined, end:lastDateBewteen};
                oportWidgt.__filterPopup.getField('NRPARCRESP').reload();
                oportWidgt.__filterPopup.getField('DINCLUSAO').reload();
            });
            
            
            
        });
    };
    
    this.openProspectWindowFilteringOper = function(widget){
        ScreenService.openWindow('product#ger45000_prospect').then(function(){
            
            var prospWidgt = templateManager.container.getWidget('gridProspect');
            var date = new Date();
            var firstDateBewteen = new Date(date.getFullYear(), (parseInt(widget.currentRow.ORDEM)-1), 1);
            var lastDateBewteen  = new Date(date.getFullYear(), (parseInt(widget.currentRow.ORDEM)), 0);
            firstDateBewteen = firstDateBewteen.toLocaleDateString('pt-BR') ;
            lastDateBewteen = lastDateBewteen.toLocaleDateString('pt-BR') + ' 23:59';
            
            prospWidgt.dataSourceFilter = [
                {
                    name: "NRORG",
                    operator: "=",
                    value: "@templateManager.LOGGEDOPERATOR.NRORG@"
                },
                {
                    name: "IDTPOPERADOR",
                    operator: "=",
                    value: "E"
                },
                {
                    name: "CDOPERINCLUSAO",
                    operator: "=",
                    static:true,
                    value: widget.currentRow.CDOPERADOR
                },
                {
                    name: "DATAINCLUSAO",
                    operator: "BETWEEN",
                    static:true,
                    value: [firstDateBewteen,lastDateBewteen]
                }
            ];
            prospWidgt.reload().then(function(){
                ScreenService.closePopup(true);
                prospWidgt.actions.forEach(function(action, index){
                    if(action.name == 'BACK_CHARTS')
                        action.isVisible = true;
                });
                prospWidgt.activate();
                prospWidgt.METAFILTER = true;
                prospWidgt.__filterPopup.currentRow.NRPARCRESPROSP = [widget.currentRow.NRPARCNEGOCIO];
                prospWidgt.__filterPopup.currentRow.NMPARCRESPROSP = [widget.currentRow.OPERADOR];
                prospWidgt.__filterPopup.currentRow.DATAINCLUSAO = {start: firstDateBewteen, period: undefined, end:lastDateBewteen};
                prospWidgt.__filterPopup.getField('NMPARCRESPROSP').reload();
                prospWidgt.__filterPopup.getField('DATAINCLUSAO').reload();
            });
            
            
            
        });
    };
    
    this.goBackCharts = function(){
        ScreenService.goBack();
        var oportWidgt = templateManager.container.getWidget('oportunidadegrid');
        oportWidgt.actions.forEach(function(action, index){
            if(action.name == 'BACK_CHARTS')
                action.isVisible = false;
        });
        oportWidgt.activate();
    };
    
    this.checkMetaFilter = function(widget){
        if(widget.METAFILTER){
            ZhFilterPreferences.openFilterWidget(widget);
            widget.METAFILTER = false;
            widget.actions.forEach(function(action, index){
            if(action.name == 'BACK_CHARTS')
                action.isVisible = false;
            });
        }
    };
    
    this.setFiltroPai = function () {
        var widget = templateManager.container.getActiveWidget();
        var filter = widget.dataSourceFilter.find(function (x) {
            return x.name === 'NRSEQPERFATIV';
        });
        if (filter) {
            filter.value = widget.parent.parent.currentRow.NRSEQPERFATIV;
        }
    };
	
}
Configuration(function(ContextRegister){
    ContextRegister.register('MetasController', MetasController);
});

// FILE: ./assets/js/controllers/MixController.js
function MixController(ScreenService, templateManager, Utilities, wizardEngine, ZHPromise, Operador_Repository, General) {
	var self = this;

	self.paramsCRMInit = function() {
		var widget = templateManager.container.getActiveWidget();
		var data = widget.dataSource.data[0];

		widget.currentRow.CASOMENSAGEM = "O ''Modelo de Caso'' define um modelo padrão de informações para a abertura de um caso. Entre as informações definidas para o caso estão o ''Código Padrão do Caso'' (responsável por especificar um código padrão para a identificação dos casos) e a ''Situação de Abertura do Caso''. Também são definidos padrões para as evoluções dos casos, como: ''Tipo de Contato Padrão'', ''Motivo de Evolução Padrão'' e ''Descrição de Evolução Padrão''.";
		widget.currentRow.NOTIFICAMENSAGEM = "Serão enviadas notificações quando:";

		widget.view();

		if(!data) {
			widget.currentRow.__is_new = true;
			return;
		} else widget.currentRow.__is_new = false;

		widget.currentRow.NRSEQRELATIONE = data.NRSEQRELATIONE;
		widget.currentRow.DSDIRANEXOCONT = data.DSDIRANEXOCONT;
		widget.currentRow.IDOBRIGAINSCJUR = data.IDOBRIGAINSCJUR;
		widget.currentRow.IDCONTROLEACESSODADOSPERFIL = data.IDCONTROLEACESSODADOSPERFIL;
		widget.currentRow.IDOBRIGACPF = data.IDOBRIGACPF;
		widget.currentRow.IDCRIAOPORTLEAD = data.IDCRIAOPORTLEAD;
		widget.currentRow.IDOBRIGACOMUNICACAOCONVERSAO = data.IDOBRIGACOMUNICACAOCONVERSAO;
		widget.currentRow.NRSEQMODELOCASO = data.NRSEQMODELOCASO;
		widget.currentRow.IDUTILIZACONTRTEMPO = data.IDUTILIZACONTRTEMPO;
		widget.currentRow.HRUTILHORATENINI = data.HRUTILHORATENINI;
		widget.currentRow.HRUTILHORATENFIN = data.HRUTILHORATENFIN;
		widget.currentRow.QTTMPRETONATEN = data.QTTMPRETONATEN;
		widget.currentRow.DSURLPESQSATISFACAO = data.DSURLPESQSATISFACAO;
		widget.currentRow.IDNOTIFICAOPORTUNI = data.IDNOTIFICAOPORTUNI;
		widget.currentRow.IDNOTIFICATAREFA = data.IDNOTIFICATAREFA;
		widget.currentRow.IDNOTIFICACOMPR = data.IDNOTIFICACOMPR;
		widget.currentRow.IDNOTIFICAPARCNEG = data.IDNOTIFICAPARCNEG;
		widget.currentRow.IDNOTIFICACASO = data.IDNOTIFICACASO;
	};

	self.setDefaultValueOperador = function(field, parametro)
	{
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
        	if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }

					field.defaultValue = operator[0][parametro];
        },function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
	};

	self.iniciaFiltrosWidtop10casossemconc = function(widget)
    {
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
        	if(operator[0] === undefined || operator[0] === null)
          {
              ScreenService.showMessage("Erro ao realizar a operação.");
              return;
          }

        	Utilities.insertFilter(widget, "P_NRORG", "=", operator[0].NRORG, 0);
        	Utilities.insertFilter(widget, "P_CDOPERADOR", "=", operator[0].CDOPERADOR, 1);
        },function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
    };
    
    self.save = function(widget){
    	General.widgetSave(widget).then(function(){
    		widget.reload();	
    	});
    };
    
    this.showWonLostField = function(widget){
    	if(widget.currentRow.IDRESULTOPORTUNI === 'SIM'){
    		widget.getField('IDGANHAPERDE').isVisible = true;
    		widget.getField('IDGANHAPERDE').validations = {required:true};
    		widget.getField('IDRESULTOPORTUNI').class = "8";
    	}else{
    		widget.getField('IDGANHAPERDE').isVisible = false;
    		widget.getField('IDGANHAPERDE').validations = {};
    		widget.getField('IDRESULTOPORTUNI').class = "12";
    	}
    }
}

Configuration(function(ContextRegister) {
    ContextRegister.register('MixController', MixController);
});

// FILE: ./assets/js/controllers/ModoDivulgacaoController.js
function ModoDivulgacaoController(templateManager, ScreenService, CRM_Utilities, Utilities, restEngine, General){
    
    this.mainWidgetOnEnter = function(widget, fieldsToApply) {
        var filterRow = {};
        CRM_Utilities.openFilterOnEnter(widget, filterRow, fieldsToApply);
    };
    
    this.setModoDivulg = function(args) {
        var widget = args;
        if (widget.isValid()) {
            widget.currentRow.NRORG = getLocalVar('CRM_NRORG') ? getLocalVar('CRM_NRORG') : " ";
            
            return General.saveCrud(widget).then(function(response){
                widget.reload();
            });
           
        }
    };
	
}
Configuration(function(ContextRegister){
    ContextRegister.register('ModoDivulgacaoController', ModoDivulgacaoController);
});

// FILE: ./assets/js/controllers/MotiEvolcontController.js
function MotiEvolcontController(ScreenService, templateManager, Utilities, wizardEngine, ZHPromise, Operador_Repository, General, CRM_Utilities, restEngine, ChamadoController, evolutionTabController, ZHPromise) {

    /**
     * Função para abrir a widget de seleção
     * de arquivos.
    */
    this.openAttachPopup = function(){
        
        var fileUploadWidget = templateManager.container.getWidget('WDGT_SELECAO_ARQUIVOS');
        ScreenService.openPopup(fileUploadWidget);
            
    };
    
    /**
     * Função para fechar o Popup de upload de imagens.
     * 
     * @param {object} widget widget de upload de imagens.
    */
    this.closeAttachPopup = function(widget){
        ScreenService.closePopup();
        widget.isVisible = false;
        widget.parent.parent.view();
        widget.parent.parent.activate();
    };
    
    /**
     * Função para fazer o download de um arquivo
     * salvo no servidor.
     * 
     * @param {object} widget widget que contém
     * as informações do arquivo a ser baixado 
     * em sua currentRow.
    */    
    this.downloadFile = function(widget){
        
        window.open(window.fileServerBaseUrl + widget.currentRow.DSCAMINHOANEXOPADRAO);
            
    };
    
    this.changeActionDefaultAttachment = function(widget){
        var currentRow = widget.currentRow;
        
        if(Util.isEmptyOrBlank(currentRow.DSCAMINHOANEXOPADRAO) && Util.isEmptyOrBlank(currentRow.ATTACHMENT)){
            widget.getAction('DOWNLOAD').isVisible = false;
            widget.getAction('REMOVE_FILE').isVisible = false;
            widget.getAction('UPLOAD').isVisible = true;
            widget.getAction('UPLOAD').label = 'Adicionar anexo padrão';
        }else{
            widget.getAction('DOWNLOAD').isVisible = true;
            widget.getAction('REMOVE_FILE').isVisible = true;
            widget.getAction('UPLOAD').isVisible = true;
            widget.getAction('UPLOAD').label = 'Modificar anexo padrão';
        }
        
        widget.activate();
    };
    
    
    /**
     * Seta o anexo na widget de motivo e salva.
    */
    this.uploadDefaultFile = function (widget) {
        widget.parent.parent.currentRow.ATTACHMENT = widget.currentRow.DSCAMINHO;
    
        General.widgetSave(widget.parent.parent).then(function () {
            ScreenService.showMessage('Anexo salvo com sucesso!');
            this.closeAttachPopup(widget);
            this.changeActionDefaultAttachment(widget.parent.parent);
            widget.parent.parent.reload();
        }.bind(this));
    };
    
    this.askToRemoveFile = function (widget) {
        var message = 'Deseja realmente remover o anexo padrão?';
    
        ScreenService.confirmMessage(message, 'question', function () {
            this.removeFile(widget);
        }.bind(this));
    };
    
    this.removeFile = function (widget) {
        var params = {
            requestType: 'Row',
            row: widget.currentRow
        };
    
        CRM_Utilities.post('/removeMotiEvolAttachment', params).then(function (response) {
            widget.reload().then(function () {
                widget.currentRow.ATTACHMENT = null;
    
                ScreenService.closePopup();
                this.changeActionDefaultAttachment(widget);
                ScreenService.showMessage('Anexo removido com sucesso!');
            }.bind(this));
        }.bind(this));
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('MotiEvolcontController', MotiEvolcontController);
});

// FILE: ./assets/js/controllers/MotivoContatoController.js
function MotivoContatoController(templateManager, ScreenService, Utilities, restEngine, General, metaDataFactory, CRM_Utilities, ZHPromise, Dashboard_Controller, ZhFilterPreferences){
    
    this.saveProduto = function(widget){
        
        var currentRow = widget.currentRow;
        
        var produtos = currentRow.PRODUTOS;
        var rows = [];
        
        produtos.forEach(function(result, index){
            
            rows.push(this.setProdutoValuesInCurrentRow(widget, index));
                
        }.bind(this)); 
        
        General.callRestEngine("product#/produto_moticont/save", "DataSet", rows).then(function(response){
            widget.reload().then(function(){
                ScreenService.closeSwipe(true);
            });
        }.bind(this));
    };
    
    this.setProdutoValuesInCurrentRow = function(widget, index){
        
        var currentRow = angular.copy(widget.currentRow);
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.__is_new = true;
        currentRow.CDMOTICONT = widget.parent.parent.currentRow.CDMOTICONT;
        currentRow.CDPRODUTO = currentRow.PRODUTOS[index];
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        
        return currentRow;
        
    };
    
    
	
}
Configuration(function(ContextRegister){    ContextRegister.register('MotivoContatoController', MotivoContatoController);
});

// FILE: ./assets/js/controllers/NatucontController.js
function NatucontController(templateManager, ScreenService, Utilities, restEngine, General){
    
    this.setNatucont = function(args) {
        var widget = args;
        if (widget.isValid()) {
            widget.currentRow.NRORG = getLocalVar('CRM_NRORG') ? getLocalVar('CRM_NRORG') : " ";
            
            return General.saveCrud(widget).then(function(response){
                widget.reload();
            });
           
        }
    };
	
}
Configuration(function(ContextRegister){
    ContextRegister.register('NatucontController', NatucontController);
});

// FILE: ./assets/js/controllers/OrgoperController.js
function OrgOperController(templateManager, ScreenService, Utilities, restEngine, General, localStorageEngine, CRM_Utilities, Messages) {
    
    var changeActualOrg = false;
    
    this.saveOrganization = function() {
        var widget = templateManager.container.getActiveWidget();
    
        if (widget.isValid()) {
            widget.currentRow.NRORG = getLocalVar('CRM_NRORG');
            var paramsRestEngine = {
                "requestType": "Row",
                "row": widget.currentRow
            };
    
            restEngine.post('/saveOrganization', paramsRestEngine).then(function(response) {
                if ((response.dataset && response.dataset.error) || Util.isEmptyOrBlank(response)) {
                    ScreenService.showMessage(response.dataset.error[0], "ERROR");
                } else if (response.dataset) {
                    ScreenService.successNotification("Organização salva com sucesso!", 10000);
                    widget.reload().then(function() {
                        widget.view();
                    });
                    widget.currentRow.__is_new = false;
                    this.widgetOnSave(response.dataset.DADOS.CRM_NRORGTRAB);
                    General.changeWidgetAcessibility(widget.widgets, true);
                }
            }.bind(this)).catch(function(e) {
                var error;
                if (e.data.error === undefined) {
                    error = e;
                } else {
                    error = e.data.error;
                }
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };
    
    this.deleteOrganization = function() {
        var widget = templateManager.container.getActiveWidget();
        
        if(widget.currentRow.CRM_NRORGTRAB === widget.currentRow.NRORG) {
            ScreenService.showMessage("Não é possível excluir a organização padrão!");
            return;
        }
        
        ScreenService.confirmMessage("Deseja mesmo excluir esta organização?", 'QUESTION',
        function(success) {
            General.callRestEngine("product#/deleteOrganization", "Row", widget.currentRow).then(function(data) {
                if (data.notifications &&data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    Utilities.masterDetailVoltarList(widget);
                    widget.reload();
                } else if(data.messages) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    widget.currentRow.IDATIVO = 'N';
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined) {
                    error = e;
                }else {
                    error = e.data.error;
                }
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        });
        
    };
    
    this.saveOperators = function() {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            var nrorgtrab = widget.getParent().currentRow.CRM_NRORGTRAB;
            var rows = [];
            widget.currentRow.CDOPERADOR.forEach(function(operador, index) {
                if (widget.currentRow.CDOPERADOR[index] == templateManager.LOGGEDOPERATOR.CDOPERADOR) {
                    changeActualOrg = true;
                }
                rows.push(this.setOperatorsInRow(widget, index));
            }.bind(this));
    
            General.callRestEngine('product#/saveRelatedOperators', "DataSet", rows).then(function(response) {
                if ((response.dataset && response.dataset.error) || Util.isEmptyOrBlank(response)) {
                    ScreenService.showMessage(response.dataset.error[0], "ERROR");
                } else if (response.dataset) {
                    ScreenService.successNotification("Operador(es) salvo(s) com sucesso!", 10000);
                    ScreenService.closeSwipe();
                    widget.list();
                    widget.reload().then(function() {
                        ScreenService.confirmMessage('Deseja alterar a organização de trabalho dos operadores adicionados para ' + nrorgtrab + '?', 'CONFIRMATION', function() {
                            var dados = [
                                response.dataset.DADOS.CDOPERADOR,
                                widget.getParent().currentRow.CRM_NRORGTRAB
                            ];
                            General.callRestEngine('product#/alterarNrOrgTrab', "Row", dados).then(function(retorno) {
                                ScreenService.successNotification("Organização de trabalho dos operadores modificada com sucesso!", 10000);
                                if (changeActualOrg) {
                                    setLocalVar("CRM_NRORGTRABALHO", nrorgtrab);
                                    var userInfo = widget.getParent().currentRow.NMORGTRAB + ' - ' + nrorgtrab;
                                    ScreenService.setHeaderInfo(userInfo);
                                    ScreenService.buildUserData(templateManager.LOGGEDOPERATOR.NMOPERADOR, [userInfo], function() {}, './assets/images/user.jpg');
                                    changeActualOrg = false;
                        
                                    Object.keys(templateManager.containers).forEach(function(container, index) {
                                        if (container !== "zeedhi_project" && container !== "product#dashboard" && container !== "product#par3001_orgoper") {
                                            templateManager.historyItems.forEach(function(item, index) {
                                                if (item == container) {
                                                    templateManager.historyItems.splice(index, 1);
                                                }
                                            });
                                            delete templateManager.containers[container];
                                        }
                                    });
                                }
                            });
                        });
                    });
                } else {
                    ScreenService.showMessage("Erro ao tentar salvar o registro!<br>Por favor, contate um administrador!", "ERROR");
                }
            }.bind(this)).catch(function(e) {
                var error;
                if (e.data.error === undefined) {
                    error = e;
                } else {
                    error = e.data.error;
                }
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };
    
    this.setOperatorsInRow = function(widget, index){
        var currentRow = angular.copy(widget.currentRow);

        currentRow.__is_new = true;
        currentRow.CDOPERADOR = currentRow.CDOPERADOR[index];
        currentRow.NMOPERADOR = currentRow.NMOPERADOR[index];
        currentRow.NRPARCNEGOCIO = currentRow.NRPARCNEGOCIO[index];
        currentRow.CRM_NRORGTRAB = widget.getParent().currentRow.CRM_NRORGTRAB;
        currentRow.NRORG = widget.getParent().currentRow.NRORG;

        return currentRow;
    };
    

    this.deleteOperators = function() {
        ScreenService.confirmMessage('Deseja realmente excluir os operadores selecionados?', 'CONFIRMATION', function(){
            var widget = templateManager.container.getActiveWidget();
            var params;
            var multipleTargets = false;
            
            if(!Util.isEmptyOrBlank(widget.getCheckedRows())) {
                params = widget.getCheckedRows();
                multipleTargets = true;
            } else {
                params = widget.currentRow;
                multipleTargets = false;
            }
            restEngine.post('product#/deleteOperators', {'requestType':'DataSet','dataset':[params]}).
                then(function(data){
                    if(data.messages){
                        if(data.messages[0].type == 'W') {
                            ScreenService.showMessage(data.messages[0].message, 'ERROR');
                        } else {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS + '! Os operadores que possuíam esta organização como a organização de trabalho ativa foram atualizados para a organização de trabalho matriz.', 10000);
                            if(multipleTargets) {
                                widget.unSelectAll();
                            } else {
                                ScreenService.closeSwipe();
                            }
                        }
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).catch(function(e) {
                    var error;
                    if(e.data.error === undefined) {
                        error = e;
                    }else {
                        error = e.data.error;
                    }
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        );
    };
    
    this.setOperatorFilter = function() {
        var widget = templateManager.container.getActiveWidget();
        widget.dataSourceFilter[1].value = widget.getParent().currentRow.CRM_NRORGTRAB;
        widget.reload();
    
        var filter = widget.getField('CDOPERADOR').dataSourceFilter;
        var orgFilter = filter.find(function (x) {
            return x.name === 'P_CRM_NRORGTRAB';
        });
        if (orgFilter) {
            orgFilter.value = widget.getParent().currentRow.CRM_NRORGTRAB;
        }
    };
    
    this.widgetOnEnterOnce = function(widget, fieldsToApply) {
        General.callRestEngine("product#/verifyMainOrg", "DataSet", []);
        
        var filterRow = {};
        filterRow.IDATIVO = 'S';
        
        CRM_Utilities.openFilterOnEnter(widget, filterRow, fieldsToApply);
    };
    
    this.goBackToMainGrid = function() {
        var mainWidget = templateManager.container.getWidget('gridOrgOper');
        
        ScreenService.closeSwipe();
        mainWidget.activate();
        mainWidget.list();
    };
    
    this.updateOrgTrabalho = function() {
        var widget = templateManager.container.getActiveWidget();
        var nrorgtrab = widget.getParent().currentRow.CRM_NRORGTRAB;
        var rows = widget.getCheckedRows();
        var cdoperador = [];
        
        for (var index = 0; index < rows.length; index++) {
            cdoperador.push(rows[index].CDOPERADOR);
        }
    
        var params = [cdoperador, nrorgtrab];
    
        ScreenService.confirmMessage("Deseja alterar a organização de trabalho dos operadores selecionados para " + nrorgtrab + "?", 'CONFIRMATION', function() {
            General.callRestEngine('product#/alterarNrOrgTrab', "Row", params).then(function() {
                ScreenService.successNotification("Organização de trabalho dos operadores modificada com sucesso!", 10000);
            });
        });
    };
	
    this.widgetOnSave = function(crm_nrorgtrab) {
        var widget = templateManager.container.getActiveWidget();
        var filter = [
            {
                "name": "CRM_NRORGTRAB",
                "operator": "=",
                "value": crm_nrorgtrab
            },
            {
                "name": "P_NRORG",
                "operator": "=",
                "value": widget.currentRow.NRORG
            }
        ];
    
        General.callRestEngine("product#/findOrganization", "FilterData", filter).then(function(response) {
            widget.currentRow.CRM_NRORGTRAB = response.dataset.orgoper[0].CRM_NRORGTRAB;
            widget.currentRow.NMORGTRAB = response.dataset.orgoper[0].NMORGTRAB;
            widget.currentRow.IDATIVO = response.dataset.orgoper[0].IDATIVO;
            widget.currentRow.DSORG = response.dataset.orgoper[0].DSORG;
            widget.currentRow.DTINCLUSAO = response.dataset.orgoper[0].DTINCLUSAO;
            widget.currentRow.NMOPERINCLUSAO = response.dataset.orgoper[0].NMOPERINCLUSAO;
            widget.currentRow.DTULTATU = response.dataset.orgoper[0].DTULTATU;
            widget.currentRow.NMOPERULTATU = response.dataset.orgoper[0].NMOPERULTATU;
        });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('OrgOperController', OrgOperController);
});

// FILE: ./assets/js/controllers/OrgTrabController.js
function OrgTrabController(templateManager, ScreenService, Utilities, restEngine, General, localStorageEngine, CRM_Utilities, Messages) {
    
    self = this;
    
    this.saveConfiguration = function(args) {
        var widget = templateManager.container.getActiveWidget();
    
        if (widget.isValid()) {
            var paramsRestEngine = {
                "requestType": "Row",
                "row": widget.currentRow
            };
    
            restEngine.post('/saveConfiguration', paramsRestEngine).then(function(response) {
                if ((response.dataset && response.dataset.error) || Util.isEmptyOrBlank(response)) {
                    ScreenService.showMessage(response.dataset.error[0], "ERROR");
                } else if (response.dataset) {
                    ScreenService.successNotification("Parâmetros salvos com sucesso!", 10000);
                    if (widget.currentRow.CRM_NRORGTRAB !== getLocalVar('CRM_NRORGTRABALHO')) {
                        setLocalVar('CRM_NRORGTRABALHO', widget.currentRow.CRM_NRORGTRAB);
                        var userInfo = widget.currentRow.NMORGTRAB + ' - ' + widget.currentRow.CRM_NRORGTRAB;
                        ScreenService.setHeaderInfo(userInfo);
                        ScreenService.buildUserData(templateManager.LOGGEDOPERATOR.NMOPERADOR, [userInfo], function() {}, './assets/images/user.jpg');
    
                        Object.keys(templateManager.containers).forEach(function(container, index) {
                            if (container !== "zeedhi_project" && container !== "product#dashboard" && container !== "product#par3002_paramconfig") {
                                templateManager.historyItems.forEach(function(item, index) {
                                    if (item == container) {
                                        templateManager.historyItems.splice(index, 1);
                                    }
                                });
                                delete templateManager.containers[container];
                            }
                        });
                    }
                    templateManager.updateTemplate();
                    widget.reload().then(function() {
                        Utilities.changeTemplateToView(args);
                    });
                }
            }.bind(this)).catch(function(e) {
                var error;
                if (e.data.error === undefined) {
                    error = e;
                } else {
                    error = e.data.error;
                }
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };
    
    this.setDataInCurrentRow = function() {
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow = widget.dataSource.data[0];
    };
    
    this.saveOperators = function() {
        var widget = templateManager.container.getActiveWidget();
        if(widget.isValid()) {
            var rows = [];
            widget.currentRow.CDOPERADOR.forEach(function(operador, index) {
                rows.push(this.setOperatorsInRow(widget, index));
            }.bind(this));
            
            General.callRestEngine('product#/saveRelatedOperators', "DataSet", rows).then(function(response) {
                 if((response.dataset && response.dataset.error) || Util.isEmptyOrBlank(response)) {
                    ScreenService.showMessage(response.dataset.error[0], "ERROR");
                } else if (response.dataset) {
                    ScreenService.successNotification("Operador(es) salvo(s) com sucesso!", 10000);
                    ScreenService.closeSwipe();
                    widget.list();
                    widget.reload();
                } else {
                    ScreenService.showMessage("Erro ao tentar salvar o registro!<br>Por favor, contate um administrador!", "ERROR");
                }
            }.bind(this)).catch(function(e) {
                var error;
                if(e.data.error === undefined) {
                    error = e;
                }else {
                    error = e.data.error;
                }
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };
    
    this.setOperatorsInRow = function(widget, index){
        var currentRow = angular.copy(widget.currentRow);

        currentRow.__is_new = true;
        currentRow.CDOPERADOR = currentRow.CDOPERADOR[index];
        currentRow.NMOPERADOR = currentRow.NMOPERADOR[index];
        currentRow.NRORGTRAB = widget.getParent().currentRow.NRORGTRAB;
        currentRow.NRORG = widget.getParent().currentRow.NRORG;

        return currentRow;
    };
    

    this.deleteOperators = function() {
        ScreenService.confirmMessage('Deseja realmente excluir os operadores selecionados?', 'CONFIRMATION', function(){
            var widget = templateManager.container.getActiveWidget();
            var params;
            var multipleTargets = false;
            
            if(!Util.isEmptyOrBlank(widget.getCheckedRows())) {
                params = widget.getCheckedRows();
                multipleTargets = true;
            } else {
                params = widget.currentRow;
                multipleTargets = false;
            }
            restEngine.post('product#/deleteOperators', {'requestType':'DataSet','dataset':[params]}).
                then(function(data){
                    if(data.messages){
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        if(multipleTargets) {
                            widget.unSelectAll();
                        } else {
                            ScreenService.closeSwipe();
                        }
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).catch(function(e) {
                    var error;
                    if(e.data.error === undefined) {
                        error = e;
                    }else {
                        error = e.data.error;
                    }
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        );
    };
    
    this.setOperatorFilter = function() {
        var widget = templateManager.container.getActiveWidget();
        widget.dataSourceFilter[1].value = widget.getParent().currentRow.NRORGTRAB;
        widget.reload();
    
        var dataSourceFilter = widget.getField('CDOPERADOR').dataSourceFilter;
        var filterItem = null;
        for (var i = 0; i < dataSourceFilter.length; i++) {
            if (dataSourceFilter[i].name === 'P_CRM_NRORGTRAB') {
                filterItem = dataSourceFilter[i];
                break;
            }
        }
        if (filterItem) {
            filterItem.value = widget.getParent().currentRow.NRORGTRAB;
        }
    };
    
    this.widgetOnEnterOnce = function(widget, fieldsToApply) {
        General.callRestEngine("product#/verifyMainOrg", "DataSet", []);
        
        var filterRow = {};
        filterRow.IDATIVO = 'S';
        
        CRM_Utilities.openFilterOnEnter(widget, filterRow, fieldsToApply);
    };
    
    this.goBackToMainGrid = function() {
        var mainWidget = templateManager.container.getWidget('gridOrgOper');
        
        ScreenService.closeSwipe();
        mainWidget.activate();
        mainWidget.list();
    };
	
}

Configuration(function(ContextRegister) {
    ContextRegister.register('OrgTrabController', OrgTrabController);
});

// FILE: ./assets/js/controllers/ParamOrgController.js
function ParamOrgController(templateManager, ScreenService, Utilities, restEngine, General, localStorageEngine, CRM_Utilities) {
    
	this.changeTemplateToEdit = function(args) {
        var widget = args.owner.widget;
        widget.template = 'widget/form.html';
        widget.edit();
    };

    this.changeTemplateToView = function(args) {
        var widget = args.owner.widget;
        widget.template = 'widget/form-view.html';
        widget.list();
    };
	
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ParamOrgController', ParamOrgController);
});	

// FILE: ./assets/js/controllers/ProfileController.js
function ProfileController(templateManager, ScreenService, Utilities, restEngine, General, localStorageEngine){
    
    this.checkUrl = function(widget){
        var parcnegocio = decodeURIComponent(window.location.hash).split('?')[1];
        var data = {};
        if(Util.isEmptyOrBlank(parcnegocio)){
            widget.reload().then(function(){
                this.initCurrentRow();
            }.bind(this));
        }else{
            parcnegocio = parcnegocio.split('=')[1];
            var filter = [
                {
                    "name": "NRPARCNEGOCIO",
                    "operator": "=",
                    "value": parcnegocio
                },
                {
                    "name": "NRORG",
                    "operator": "IS_NOT_NULL",
                }
            ];
            restEngine.post("product#/crud/parcnegocio_comunicaparc", {requestType:"FilterData", filter: filter}).then(function(parceiro){
                var parc = parceiro.dataset.parcnegocio_comunicaparc;
                if(Util.isEmptyOrBlank(parc[0])){
                    ScreenService.showMessage("Erro ao buscar as informações do parceiro. <br/>Contate um administrador.")    
                }else{
                    restEngine.post("product#/crud/operador", {requestType:"FilterData", filter: filter}).then(function(operador){
                        if(Util.isEmptyOrBlank(operador.dataset.operador[0])){
                            widget.currentRow.NMOPERADOR  = parc[0].NMPRINCIPALPARC;
                            widget.currentRow.DSEMAILOPER = parc[0].EMAIL;
                            
                            widget = templateManager.container.getWidget('WDGT_NOVO_OPERADOR');
                            widget.currentRow.NMOPERADOR  = parc[0].NMPRINCIPALPARC;
                            widget.currentRow.DSEMAILOPER = parc[0].EMAIL;
                            widget.currentRow.NRPARCNEGOCIO = parc[0].NRPARCNEGOCIO;
                            widget.currentRow.NRORG = parc[0].NRORG;
                            ScreenService.openPopup(widget);
                        }else{
                            var reload = true;
                            ScreenService.showMessage('Operador já cadastrado. <br/>Você será redirecionado ao dashboard').then(function(){
                                window.location.href = '#/product#dashboard';
                                window.location.reload();
                                reload = false;
                            });
                            setTimeout(function(){
                                if(reload){
                                    window.location.href = '#/product#dashboard';
                                    window.location.reload();
                                }
                            }, 4000);
                        }
                    });
                }
            });
        }   
    };
    
    this.initCurrentRow = function(args) {
        var widget = templateManager.container.getWidget('crm_perfil_form');
        var data   = widget.dataSource.data[0];
        
        widget.currentRow.NMOPERADOR = getLocalVar('CRM_NMOPERADOR')/*data.NMOPERADOR*/;
        widget.currentRow.DSEMAILOPER = getLocalVar('CRM_DSEMAILOPER')/*data.DSEMAILOPER*/;
    };
    
    this.openPopupRedefinirSenha = function(args){
        var widget = templateManager.container.getWidget('crm_perfil_popup');
        ScreenService.openPopup(widget);
    };
    
    this.redefinirSenha = function(widget){
        if(widget.isValid()){
            if(widget.currentRow.NOVA_SENHA === widget.currentRow.CONFIRMAR_SENHA){
                restEngine.post('/redefinirSenha', {'requestType': 'Row', 'row': [widget.currentRow]}).
                    then(function(success){
                        ScreenService.showMessage('Senha Alterada com Sucesso.');
                        widget.currentRow.SENHA_ATUAL     = "";
                        widget.currentRow.NOVA_SENHA      = "";
                        widget.currentRow.CONFIRMAR_SENHA = "";
                        widget.currentRow.NRINSCRICAOPARC = "";
                        ScreenService.closePopup();
                    }).
                    catch(function(error){
                        ScreenService.showMessage(error.data.error);
                        widget.currentRow.SENHA_ATUAL     = "";
                    });
            }else{
                ScreenService.showMessage('As senhas não coincidem');
                widget.currentRow.NOVA_SENHA      = "";
                widget.currentRow.CONFIRMAR_SENHA = "";
            }
        }
        
    };
    
    this.createOper = function(widget){
        if(widget.isValid()){
            if(widget.currentRow.NOVO_NOVA_SENHA === widget.currentRow.NOVO_CONFIRMAR_SENHA){
                widget.currentRow.NRINSCRICAOPARC = widget.currentRow.NRINSCRICAOPARC.replace(/[^0-9]/g, '');
                restEngine.post('/createOper', {'requestType': 'Row', 'row': [widget.currentRow]}).
                    then(function(success){
                        var reload = true;
                        if((success.dataset.OPER[0] && !Util.isEmptyOrBlank(success.dataset.OPER[0].CDOPERADOR)) || !Util.isEmptyOrBlank(success.dataset.OPER.CDOPERADOR)){
                            ScreenService.showMessage('Senha Criada com sucesso. <br/>Você será redirecionado ao dashboard').then(function(){
                                widget.currentRow.SENHA_ATUAL     = "";
                                widget.currentRow.NOVA_SENHA      = "";
                                widget.currentRow.CONFIRMAR_SENHA = "";
                                ScreenService.closePopup();
                                window.location.href = '#/product#dashboard';
                                window.location.reload();
                                reload = false;
                            });
                            setTimeout(function(){
                                if(reload){
                                    window.location.href = '#/product#dashboard';
                                    window.location.reload();
                                }
                            }, 4000);
                        }else{
                            ScreenService.showMessage("Erro no Cadastro. <br/>Contate um administrador.");   
                        }
                    }).
                    catch(function(error){
                        var exceptions = error.data.error.slice(error.data.error.indexOf('ORA'), error.data.error.length);
                        ScreenService.showMessage("Erro no Cadastro. <br/>Contate um administrador informando o trecho abaixo: <br/>"+exceptions);   
                    });
            }else{
                ScreenService.showMessage('As senhas não coincidem');
                widget.currentRow.NOVA_SENHA      = "";
                widget.currentRow.CONFIRMAR_SENHA = "";
            }
        }
        
    };
    this.cancelPopup = function(widget){
        widget.currentRow.SENHA_ATUAL     = "";
        widget.currentRow.NOVA_SENHA      = "";
        widget.currentRow.CONFIRMAR_SENHA = "";
        ScreenService.closePopup();
    };
	
}
Configuration(function(ContextRegister){
    ContextRegister.register('ProfileController', ProfileController);
});

// FILE: ./assets/js/controllers/RelatorioAuditoriaController.js
function RelatorioAuditoriaController(General, templateManager, CRM_Utilities) {

    this.widgetOnEnterOnce = function(widget, fieldsToApply) {
        var filterRow = {};
        CRM_Utilities.openFilterOnEnter(widget, filterRow, fieldsToApply);
    };

    this.DOMListToArray = function(list){
        var array = [];
        
        for(var i = 0; i<list.length; i++)
            array.push(list[i]);
            
        return array;
    };
    
    this.setIcon = function(row, element){
        var zeedhiField = element.owner;
        var jqueryField = $(element[0]);
        var classList = jqueryField[0].classList;
        var missing = 'N';
        var check   = 'S';
        
        classList = this.DOMListToArray(classList);
        
        if(row[zeedhiField.name] === missing && classList.indexOf('Missing') === -1){
            jqueryField.addClass('Missing');
            jqueryField.removeClass('Check');
        }else if(row[zeedhiField.name] === check){
            jqueryField.addClass('Check');
            jqueryField.removeClass('Missing');
        }
    };
    
    this.buildFilterFieldsAuditoria = function(widget){
        var valueToNotNull = "%Possui%";
        var valueToNull    = "%Não Possui%";
        var filter = widget.dataSourceFilter;    
        var auditoriaFields = widget.fields.map(function(field){
            if(field.fieldGroup && field.fieldGroup === "GERAL")
                return field.name;
        }).filter(function(name) {
            return typeof name !== 'undefined';
        });
        
        var value;
        filter.forEach(function(filter){
            if(auditoriaFields.indexOf(filter.name) > -1){
                value = filter.value;
                if(value === valueToNotNull){
                    filter.operator = "=";
                    filter.value = 'S';
                }else if(value === valueToNull){
                    filter.operator = "=";
                    filter.value = 'N';
                }
            }    
        });
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('RelatorioAuditoriaController', RelatorioAuditoriaController);
});

// FILE: ./assets/js/controllers/RelatorioConsolidadoDeLeadsController.js
/**
 * @author Reynaldo Pinto <reynaldo.pinto@teknisa.com>
 */
function RelatorioConsolidadoDeLeadsController(CRM_Utilities, templateManager) {
    
    /**
     * Define os valores padrões dos campos que não podem ter o default value
     *inserido diretamente no JSON e abre o filtro.
     */
    this.widgetOnEnterOnce = function(widget) {
        // Como o operador logado no campo de operador responsável no filtro
        widget.currentRow.NRPARCRESP = [templateManager.LOGGEDOPERATOR.NRPARCNEGOCIO];
        
        // Define o valor padrão do campo de intervalo de tempo no filtro entre
        widget.currentRow.DTINCLUSAO = {
            //um mês da data atual
            start: CRM_Utilities.subtractDateByMonth(moment(), 1),
            period: undefined,
            //e o dia de hoje
            end: CRM_Utilities.getCurrentDate()
        }
        
        // Abre o filtro e define os valores padrões dos campos definidos no JSON
        CRM_Utilities.openFilterOnEnter(widget, widget.currentRow, ['IDATIVO',
            'NMOPERRESP', 'IDSTATUSCAN', 'AGRUPADOR']);
    };
    
    /**
     * Cria as variáveis que serão utilizadas na query com base nos valores
     *definidos no filtro e os adiciona ao data source filter da widget.
     */
    this.definirParametrosDoFiltro = function(args) {
        // Pega os valores inseridos pelo usuário nos campos do filtro
        var filterRow = args.e.preference.FILTER_ROW;
        var widget = args.owner;
        
        // Como os parâmetros que serão utilizados na query são adicionados ao
        //data source filter, é preciso remover aqueles que foram definidos na
        //consulta anterior
        var dataSourceFilter = this.removerFiltrosNaoFixos(widget);
        
        var operadorFiltro = filterRow.NMOPERRESP;
        var leadFiltro = filterRow.NMCANDIDATO;
        var intervalFiltro = filterRow.DTINCLUSAO;
        var ativoFiltro = filterRow.IDATIVO;
        var statusFiltro = filterRow.IDSTATUSCAN;
        
        // Cria o parâmetro do operador.
        //Ex: se os operadores selecionados forem [203040, 473569], ele será
        //definido como 203040_473569_
        if(operadorFiltro) {
            var nrOperadores = this.arrayParaString(operadorFiltro);
            dataSourceFilter = this.criarEAdicionarParametro('P_NRPARCOPER',
                nrOperadores, dataSourceFilter);
        }
        
        // O mesmo se aplica a esse campo
        if(leadFiltro) {
            var nrLeads = this.arrayParaString(leadFiltro);
            dataSourceFilter = this.criarEAdicionarParametro('P_NRLEADS',
                nrLeads, dataSourceFilter);
        }
        
        // E esse também
        if(statusFiltro) {
            var idStatus = this.arrayParaString(statusFiltro);
            dataSourceFilter = this.criarEAdicionarParametro('P_IDSTATUS',
                idStatus, dataSourceFilter);
        }
        
        // E esse... não. Ele cria dois parâmetros: um pra pro início do período
        //a ser filtrado e outro para o fim.
        if(intervalFiltro) {
            var iniData = intervalFiltro.start;
            var fimData = intervalFiltro.end;
            
            dataSourceFilter = this.criarEAdicionarParametro('P_INIDATA',
                iniData, dataSourceFilter);
                
            dataSourceFilter = this.criarEAdicionarParametro('P_FIMDATA',
                fimData, dataSourceFilter);
        }
        
        if(ativoFiltro) {
            dataSourceFilter = this.criarEAdicionarParametro('P_IDATIVO',
                ativoFiltro, dataSourceFilter);
        }
        
        // Atualiza o data source filter da widget.
        widget.dataSourceFilter = dataSourceFilter;
    };
    
    // Transforma um array de valores em string, colocando um "_" ao final de
    //cada valor. ['Bolo', 'é', 'muito', 'bom'] => 'Bolo_é_muito_bom_'
    this.arrayParaString = function(arrayToConvert) {
        var concatString = arrayToConvert.reduce(function(concat, valueToAdd) {
            return concat + valueToAdd + '_';
        }, '');
    
        return concatString;
    };
    
    // Cria um novo filtro com base nos valores passados por parâmetro e o
    //adiciona ao data source filter da widget.
    this.criarEAdicionarParametro = function(nomeParam, valorParam,
        dataSourceFilter) {
        
        var novoParam = {
            name: nomeParam,
            // Como se trata de um parâmetro(variável) a ser utilizado na query,
            //o operator definido não faz diferença
            operator: '=',
            value: valorParam,
            fromFilter: true
        };
        
        // Adiciona o novo parâmetro ao data source filter
        dataSourceFilter.push(novoParam);
        
        return dataSourceFilter;
    };
    
    this.removerFiltrosNaoFixos = function(widget) {
        var dataFilter = widget.dataSourceFilter ? widget.dataSourceFilter.slice() : [];
        var newFilter;
    
        if (!dataFilter) return [];
    
        newFilter = dataFilter.filter(function(x) {
            return x.fixed === true;
        });
    
        return newFilter;
    };
    
    /**
     * Deixa alguns campos do filtro como read-only e remove seus valores da
     *current row com base no agrupador escolhido.
     */
    this.atualizarCamposPeloAgrupador = function(widget) {
        var currentRow = widget.currentRow;
        var agrupadoPorLead = currentRow.AGRUPADOR == 'L';
        
        // Esses campos serão read-only se o resultado for agrupado por Operador.
        //Caso contrário, eles serão editáveis
        widget.getField('NMCANDIDATO').readOnly = !agrupadoPorLead;
        widget.getField('IDATIVO'    ).readOnly = !agrupadoPorLead;
        widget.getField('IDSTATUSCAN').readOnly = !agrupadoPorLead;
        widget.getField('DTINCLUSAO' ).readOnly = !agrupadoPorLead;
        
        // Escolhe qual data source será consultado
        if(agrupadoPorLead) {
            widget.dataSource.name = 'relatorioConsolidadoDeLeads_lead';
        } else {
            widget.dataSource.name = 'relatorioConsolidadoDeLeads_oper';
            
            // Remove os valores desses campos da current row
            currentRow.NMCANDIDATO = null;
            currentRow.IDATIVO = null;
            currentRow.DTINCLUSAO = null;
            currentRow.IDSTATUSCAN = null;
        }
        
        // Recarrega o filtro para aplicar as mudanças visualmente.
        widget.reload();
    };
    
    /**
     * Define quais colunas aparecerão na grid(list) com base no agrupador
     *selecionado.
     */
    this.definirVisibilidadeDosCampos = function(args) {
        var agrupadoPorLead = args.e.preference.FILTER_ROW.AGRUPADOR == 'L';
        var widget = args.owner;
        
        // Colunas visíveis quando agrupar por lead
        widget.getField('NMCANDIDATO').isVisible     = agrupadoPorLead;
        widget.getField('IDATIVO').isVisible         = agrupadoPorLead;
        widget.getField('IDSTATUSCAN').isVisible     = agrupadoPorLead;
        widget.getField('DTINCLUSAO').isVisible      = agrupadoPorLead;
        widget.getField('NMOPERRESP').isVisible      = agrupadoPorLead;
        widget.getField('DSSEGMER').isVisible        = agrupadoPorLead;
        widget.getField('QNTEVOL').isVisible         = agrupadoPorLead;
        widget.getField('QNTTAREFA').isVisible       = agrupadoPorLead;
        widget.getField('QNTINTER').isVisible        = agrupadoPorLead;
        
        // Colunas visíveis quando agrupar por operador
        widget.getField('NMOPERADOR').isVisible      = !agrupadoPorLead;
        widget.getField('CONTRATADOS').isVisible     = !agrupadoPorLead;
        widget.getField('ABERTOS').isVisible         = !agrupadoPorLead;
        widget.getField('QUALIFICADOS').isVisible    = !agrupadoPorLead;
        widget.getField('DESQUALIFICADOS').isVisible = !agrupadoPorLead;
        
        // Redesenha o cabeçalho da grid
        widget.redraw();
    };
}

Configuration(function(ContextRegister){
    ContextRegister.register('RelatorioConsolidadoDeLeadsController', RelatorioConsolidadoDeLeadsController);
});

// FILE: ./assets/js/controllers/RelatorioConsolidadoDeTarefasController.js
function RelatorioConsolidadoDeTarefasController(General, templateManager, CRM_Utilities, ScreenService, Utilities) {
  
  this.readOnlyOperNeg = function(widget){
        var parcneg = widget.getField('NRPARCNEGOCIO');
        var operador = widget.getField('CDOPERADOR');
        var tipo = widget.getField('TIPO');
        widget.getField('TIPO').dataSource.data  = [];
        if(widget.currentRow.AGRUPOR == 'OPERADOR'){
            operador.readOnly = false;
            parcneg.readOnly = true;
            parcneg.clearValue();
            var data = [
                {
                    "TIPO": "OPORTUNIDADE",
                    "DESC": "Oportunidade"
                },
                {
                    "TIPO": "CHAMADO",
                    "DESC": "Ticket"
                },
                {
                    "TIPO": "PARCEIRO",
                    "DESC": "Parceiro"
                }
            ];
            widget.getField('TIPO').dataSource.data = data;
        } else {
            widget.getField('TIPO').dataSource.data  = [];
            parcneg.readOnly = false;
            operador.readOnly = true;
            operador.clearValue();
            var data = [
                {
                    "TIPO": "OPORTUNIDADE",
                    "DESC": "Oportunidade"
                },
                {
                    "TIPO": "CHAMADO",
                    "DESC": "Ticket"
                }
            ];
            widget.getField('TIPO').dataSource.data = data;
        }
        
        tipo.readOnly = false; 
         
        setTimeout(function() {
            $(window).resize();            
        }, 200);
    };
        
  
    this.alteraGrid = function (args) {
        var widget = args.owner;
        if(args.e.preference.FILTER_ROW.AGRUPOR == 'OPERADOR'){
            widget.getField('NMPRINCIPALPARC').isVisible = false;
            widget.getField('NMOPERADOR').isVisible = true;
            widget.getField('NMOPERADOR').showOnList = true;
        } else {
             widget.getField('NMOPERADOR').isVisible = false;
             widget.getField('NMPRINCIPALPARC').isVisible = true;
             widget.getField('NMPRINCIPALPARC').isVisible = true;
             widget.getField('NMPRINCIPALPARC').showOnList = true;
             widget.currentRow.NMOPERADOR = "";
        }
        
        // tipo.readOnly = false; 
        setTimeout(function() {
            $(window).resize();            
        }, 200);
    };
        
    this.setFilterRelacionadoA = function(widget) {
        var NRSEQCONTATOField = widget.getField('NRSEQCONTATO');
        var tipoField = widget.getField('TIPO');

        if (!Util.isEmptyOrBlank(tipoField.value())) {
            NRSEQCONTATOField.dataSourceFilter.forEach(function(filter) {
                if (filter.name === "SEPARADOR")
                    filter.value = tipoField.value();
            });
            NRSEQCONTATOField.readOnly = false;
        }
        else {
            NRSEQCONTATOField.readOnly = true;
        }
    };

    this.activateFieldDescricao = function(widget, field, decisiveField) {
        if(widget){
            var NRSEQCONTATO = widget.getField('NRSEQCONTATO');
            if (!Util.isEmptyOrBlank(NRSEQCONTATO)) {
                NRSEQCONTATO.readOnly = false;
                var value = widget.getField('TIPO').value();
                switch (value) {
                    case 'PARCEIRO':
                        NRSEQCONTATO.label = 'Parceiro'; 
                    widget.currentRow.NRSEQCONTATO = "";
                    widget.currentRow.NRSEQCONTATO ="";
                        break;
                    case 'CHAMADO':
                        NRSEQCONTATO.label = 'Ticket';
                    widget.currentRow.NRSEQCONTATO = "";
                    widget.currentRow.NRSEQCONTATO ="";
                        break;
                    case 'OPORTUNIDADE':
                        NRSEQCONTATO.label = 'Oportunidade';
                    widget.currentRow.NRSEQCONTATO = "";
                    widget.currentRow.NRSEQCONTATO ="";
                        break;
                    default:
                        NRSEQCONTATO.label = 'Código';
                    widget.currentRow.NRSEQCONTATO = "";
                    widget.currentRow.NRSEQCONTATO ="";
                        NRSEQCONTATO.readOnly = true;
                        break;
                }
                
            }
            else {
                NRSEQCONTATO.readOnly = true;
                NRSEQCONTATO.label = 'Código';
                widget.currentRow.NRSEQCONTATO = null;
                widget.currentRow.NRCONTATO = null;
                widget.currentRow.NRSEQCONTATO = "";
            }
           
        }

    };
  
        
}
Configuration(function(ContextRegister) {
    ContextRegister.register('RelatorioConsolidadoDeTarefasController', RelatorioConsolidadoDeTarefasController);
});

// FILE: ./assets/js/controllers/RelatorioCustomizavelProspectController.js
function RelatorioCustomizavelProspectController(templateManager, CRM_Utilities) {
    
   this.setEstado = function(args){
        var widgetFiltro = args.owner.owner.widget;
        
        var pais = widgetFiltro.currentRow.CDPAIS;
        var estado = widgetFiltro.getField("SGESTADO");
        if(!Util.isEmptyOrBlank(pais)){
            estado.readOnly = false;
            estado.dataSourceFilter[0].value = pais;
        }else{
            estado.readOnly = true; 
            estado.clearValue();
            estado.dataSourceFilter[0].value = "";
            args.owner.owner.widget.currentRow.SGESTADO = "";
            this.setMunicipio(args);
        }    
       
   };
   
   this.setMunicipio = function(args){
        var widgetFiltro = args.owner.owner.widget;
        
        var pais = widgetFiltro.currentRow.CDPAIS;
        var estado = widgetFiltro.currentRow.SGESTADO;
        var municipio = widgetFiltro.getField("CDMUNICIPIO");
        if(!Util.isEmptyOrBlank(estado)){
            municipio.readOnly = false;
            municipio.dataSourceFilter[0].value = pais;
            municipio.dataSourceFilter[1].value = estado;
        }else{
            municipio.readOnly = true; 
            municipio.clearValue();
            municipio.dataSourceFilter[0].value = "";
            municipio.dataSourceFilter[1].value = "";
            args.owner.owner.widget.currentRow.CDMUNICIPIO = "";
            this.setBairro(args);
        }    
       
   };
   
    this.setBairro = function(args){
        var widgetFiltro = args.owner.owner.widget;
        
        var pais = widgetFiltro.currentRow.CDPAIS;
        var estado = widgetFiltro.currentRow.SGESTADO;
        var municipio = widgetFiltro.currentRow.CDMUNICIPIO;
        var bairro = widgetFiltro.getField("CDBAIRRO");
        if(!Util.isEmptyOrBlank(municipio)){
            bairro.readOnly = false;
            bairro.dataSourceFilter[0].value = pais;
            bairro.dataSourceFilter[1].value = estado;
            bairro.dataSourceFilter[2].value = municipio;
        }else{
            bairro.readOnly = true; 
            bairro.clearValue();
            bairro.dataSourceFilter[0].value = "";
            bairro.dataSourceFilter[1].value = "";
            bairro.dataSourceFilter[2].value = "";
        }    
       
   };
   
   this.setFilterOpportunityByParc = function(args){
        var widgetFiltro = args.owner.owner.widget;
        var nrParc       = widgetFiltro.getField("NRPARCNEGOCIO").value();
        var oppor        = widgetFiltro.getField("NRSEQOPORT");
        oppor.clearValue();
        oppor.dataSourceFilter.forEach(function(filter, index, dataSourceFilter){
            if(filter.name === "NRPARCOPORT")
                dataSourceFilter.splice(index, 1);    
        });
        if(!Util.isEmptyOrBlank(nrParc)){
            var filter = {};
            filter.name     = "NRPARCOPORT";
            filter.operator = "IN";
            filter.value    = nrParc;
            oppor.dataSourceFilter.push(filter);
        }
        
   };
   
   /**
     * Define as regras da tela de relatórios de prospect 
     * de acordo com a revenda do operador logado.
     * 
     * @param {object} widget widget principal da tela de relatórios de prospect 
     * ('layoutPrincipal').
    */
    this.setResaleRules = function(widget) {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        if(loggedOperatorInfos.IDTPOPERADOR === 'R' && Boolean(loggedOperatorInfos.NRREVENDA)){
            
            var restrictObjects = [];
            
            restrictObjects.push(widget);
            restrictObjects.push(widget.getField("NMOPERADOR"));
            
            if(widget.name === 'evolucao'){
                restrictObjects.push(widget.getField("NRPARCNEGOCIO__LABEL"));
            }
            
            CRM_Utilities.setResaleRulesInRestrictObjectsByLoggedOperatorResale(restrictObjects);
            
        }
    };
    
    this.unMaskPhone = function(widget){
        widget.dataSourceFilter.forEach(function(filter){
            if(filter.name === "TELEFONES"){
                filter.value = '%'+ CRM_Utilities.removeValueMask(filter.value) + '%'; 
            }    
        });
    };
    
    this.fazerCopiaDataSource = function(widget) {
        var ds = widget.dataSource;
        ds.dataCopy = ds.data;
    };
    
    this.agruparFieldsVisiveis = function(widget) {
        var loadedData = widget.dataSource.dataCopy;
        var visibleFields = widget.fields.filter(function(field) {
            return field.isVisible == field.showOnList == true; 
        });
        
        var columnsToGroup = visibleFields.map(function(field) {
            return field.name;
        });
        
        if(!Util.isEmptyOrBlank(loadedData)) {
            var groupedRows = CRM_Utilities.groupBy(loadedData, columnsToGroup)
                .map(function(row) {
                    return row.value;
                });
        
            widget.dataSource.data = groupedRows;
        }
    };
    
    this.consertarOrdenacaoPorData = function(widget) {
        var orderingByDate = this.estaOrdenandoPorData(widget);
        
        if (!orderingByDate) {
            return;
        }
        
        var rows       = widget.dataSource.dataCopy;
        var sortedRows = rows.sort(this.comparaDatas);
        var sentido    = this.findSentidoOrdenacao(widget);
        
        if (sentido === 'DESC') {
            sortedRows.reverse();
        }
        
        widget.dataSource.data = sortedRows;
        widget.redraw();
    };
    
    this.estaOrdenandoPorData = function(widget) {
        var filtroOrderBy = widget.dataSourceFilter.find(function(filter) {
            return filter.operator === 'ORDER_BY';
        });
    
        if (Util.isEmptyOrBlank(filtroOrderBy)) {
            return false;
        }
    
        return filtroOrderBy.name[0].name === '__proxy_DTHREVOLCONT' ||
               filtroOrderBy.name[0].name === 'DTHREVOLCONT';
    };
    
    this.comparaDatas = function(row1, row2) {
        var date1 = moment(row1.DTHREVOLCONT, 'DD/MM/YYYY HH:mm:ss').valueOf();
        var date2 = moment(row2.DTHREVOLCONT, 'DD/MM/YYYY HH:mm:ss').valueOf();
        
        return date1 - date2;
    };
    
    this.findSentidoOrdenacao = function(widget) {
        var filtroOrderBy = widget.dataSourceFilter.find(function(filter) {
            return filter.operator === 'ORDER_BY';
        });
    
        return filtroOrderBy.name[0].direction;
    };
    
    this.relatorioAfteLoadDataSource = function(widget) {
        this.fazerCopiaDataSource(widget);
        this.agruparFieldsVisiveis(widget);
        this.consertarOrdenacaoPorData(widget);
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register("RelatorioCustomizavelProspectController", RelatorioCustomizavelProspectController);
});



// FILE: ./assets/js/controllers/RelatorioDiasSemEvolucaoController.js
function RelatorioDiasSemEvolucaoController(General, templateManager, CRM_Utilities) {
    
    this.defaultFilter = function(widget){
        /* 
         * Os campos CDSETOR E CDDEPTO serão visíveis no filtro apenas
         *  se o NRORG for igual a 20.
         */
        var showCodes = templateManager.LOGGEDOPERATOR.NRORG == '20';
        var filterCDSETOR = widget.getField('NMSETOR').filterProperties;
        var filterCDDEPTO = widget.getField('NMDEPTO').filterProperties;
        
        /* 
         * Os dois atributos de ambos os campos possuem o mesmo valor booleano,
         *  que está em showCodes.
         */
        filterCDSETOR.isVisible = filterCDSETOR.isVisibleOnReport
            = filterCDDEPTO.isVisible = filterCDDEPTO.isVisibleOnReport = showCodes;
    };
    
    this.readOnlySetor = function(widget){
        var depto = widget.getField('CDDEPTO');
        var setor = widget.getField('CDSETOR');
        
        if(Util.isEmptyOrBlank(depto.value())){
            setor.readOnly = true;
            setor.clearValue();
        }else{
            setor.readOnly = false;
            setor.clearValue();
        }
        
    };
    
    this.defaultValueInterval = function() {
        var newDefault = {};
        
        var year  = moment().format('YYYY');
        var month = moment().format('MM');
        var day   = moment().format('DD');
       
        var dateStart = '01/' + month.toString() + '/' + year;
        var dateEnd   = day +'/'+ month.toString() + '/' + year;
        
        newDefault.start = dateStart;
        newDefault.end = dateEnd;
        newDefault.period = undefined;
        
        return newDefault;
    };
    
    this.filtraOposta = function(nmWidget, widget){
        
        widget.getParent().widgets.forEach(function(wid){
        	if(wid.name != nmWidget){
        		wid.filtra = true;
        	}
        });
         
        widget.filtra = false;
        widget.getParent().currentFilter =  widget.dataSourceFilter;
    };
    
    this.verificaFiltro = function(nmWidget, widget){
       
       if(widget.getParent().currentFilter){
           if(widget.dataSourceFilter != widget.getParent().currentFilter){
                widget.dataSourceFilter = widget.getParent().currentFilter;
                widget.reload();
                widget.filtra = false;
           }
       }
         
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('RelatorioDiasSemEvolucaoController', RelatorioDiasSemEvolucaoController);
});
/* global moment Util Configuration */

// FILE: ./assets/js/controllers/RelatorioLeadOperadorController.js
function RelatorioLeadOperadorController(CRM_Utilities, templateManager) {
    
    this.tabLeadOnEnter = function(widget) {
        this.tabOnEnter(widget, 'P_NRORG', 'NRPARCPROPRI', 'IDTPOPERADOR',
            'IDATIVO', 'DTINCLUSAO', 'LEADACTIVE');
    };
    
    this.tabProspectOnEnter = function(widget) {
        this.tabOnEnter(widget, 'NRORG', 'NRPARCRESPROSP', 'IDTPOPERADOR',
            'IDATIVO', 'DTINCLUSAO', 'PROSACTIVE');
    };
    
    this.tabOnEnter = function(widget, nrorg, nrparcnegocio, idtpoperador,
        idativo, dtinclusao, ativoFiltro) {
            
        // Necessário para que a função gerarDataSourceTab seja compatível
        // com as duas tabs!
        var columnNames = {
            NRORG: nrorg,
            NRPARCNEGOCIO: nrparcnegocio,
            IDTPOPERADOR: idtpoperador,
            IDATIVO: idativo,
            DTINCLUSAO: dtinclusao,
            ativoFiltro: ativoFiltro
        };
        
        this.gerarDataSourceTab(widget, columnNames);
        widget.reload();
    };
  
    this.gerarDataSourceTab = function(widget, columnNames) {
        var parentWdg = widget.parent.parent;
    
        widget.dataSourceFilter = [];
    
        var valorNRORG = getLocalVar('CRM_NRORG');
    
        var valorNRPARCNEGOCIO = parentWdg.currentRow.CDRESPONSAVEL;
    
        var valorIDTPOPERADOR = Util.isEmptyOrBlank(templateManager.LOGGEDOPERATOR.IDTPOPERADOR) ?
            'E' : templateManager.LOGGEDOPERATOR.IDTPOPERADOR;
    
        var filtroIdAtivo = parentWdg.dataSourceFilter.find(function(filtro) {
            return filtro.name == columnNames.ativoFiltro;
        });
        var valorIDATIVO = filtroIdAtivo ? filtroIdAtivo.value : null;
    
        var filtroPeriodo = parentWdg.dataSourceFilter.find(function(filtro) {
            return filtro.name == 'DATEINTERVAL';
        });
        var valorPERIODO = filtroPeriodo ? filtroPeriodo.value : null;
    
        var options = [
            {
                "name": columnNames.NRORG,
                "operator": "=",
                "value": valorNRORG || null
            },
            {
                "name": columnNames.NRPARCNEGOCIO,
                "operator": "=",
                "value": valorNRPARCNEGOCIO || null
            },
            {
                "name": columnNames.IDTPOPERADOR,
                "operator": "=",
                "value": valorIDTPOPERADOR || null
            },
            {
                "name": columnNames.IDATIVO,
                "operator": "=",
                "value": valorIDATIVO || null
            },
            {
                "name": columnNames.DTINCLUSAO,
                "operator": "BETWEEN",
                "value": valorPERIODO || null
            }
        ];
    
        // Usa somente os filtros que têm valor válido (diferente de null,
        // undefined, etc
        var filters = options.filter(function(filter) {
            return filter.value ? true : false;
        });
    
        widget.dataSourceFilter.push.apply(widget.dataSourceFilter, filters);
    };
}

Configuration(function(ContextRegister){
    ContextRegister.register('RelatorioLeadOperadorController', RelatorioLeadOperadorController);
});

// FILE: ./assets/js/controllers/RelatParcNegocioController.js
function RelatParcNegocioController(ScreenService, templateManager, CRM_Utilities, General, restEngine, ZHPromise, Messages) {
    
    this.openFilter = function() {
        var filterRow = {};
        var widget = templateManager.container.getActiveWidget();
        
        if((typeof templateManager !== 'undefined') && templateManager.LOGGEDOPERATOR){
            filterRow.CDOPERRESPONSAVEL = [templateManager.LOGGEDOPERATOR.CDOPERADOR];
            filterRow.CDOPERADOR = [templateManager.LOGGEDOPERATOR.CDOPERADOR];
            filterRow.IDATIVO = 'S';
            
            CRM_Utilities.openFilterOnEnter(widget, filterRow, []);

        }
        
    }
    
    this.setLogotipoInRow = function() {
        var widgetGrid = templateManager.container.getActiveWidget();
        var tab = templateManager.container.getWidget('TAB_SWIPE');
        var widget = templateManager.container.getWidget('LOGOTIPO_PARCEIRO');
        
        widget.getField('DSDIRLOGOMARCA').value(widgetGrid.currentRow.DSDIRLOGOMARCA);
        widget.getField('DSDIRLOGOMARCA').descriptionOrder = 0;
        widget.currentRow.DSDIRLOGOMARCA = widgetGrid.currentRow.DSDIRLOGOMARCA;
        
        
        ScreenService.openSwipe(tab);
        tab.activate();
        
    }
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('RelatParcNegocioController', RelatParcNegocioController);
});

// FILE: ./assets/js/controllers/RespostasController.js

function RespostasController(ScreenService, templateManager, restEngine, ZHPromise) {
    var self = this;
this.getPopUpFilter = function(){
    return templateManager.container.getWidget('PROJECT_FILTER_MANAGER');
};

this.openPopUpFilterPart = function(){
    var currentWidget = templateManager.container.getActiveWidget();
    this.getPopUpFilter().parentWidget = currentWidget;
    ScreenService.openPopup(this.getPopUpFilter());
};

this.closePopUpFilter = function(widget){
    var parent = widget.parentWidget;
    ScreenService.closePopup();
    parent.activate();

};

this.filterManager = function(widget) {
    var parent = widget.parentWidget;
    var vlr0 = widget.fields[0].value();
    var vlr1 = widget.fields[1].value();
    var vlr2 = widget.fields[2].value();

    var ar_thr = [this.alterarValorCampo(widget.fields[1]), this.alterarValorCampo(widget.fields[2])];

    ZHPromise.all(ar_thr).then(function (){
            FilterService.parentFilter(parent, widget).then(function(){
                ScreenService.closePopup();
                parent.activate();

                widget.fields[0].setValue(vlr0);
                widget.fields[1].setValue(vlr1);
                widget.fields[2].setValue(vlr2);
            });
        }
    );
};


this.alterarValorCampo = function (field)
{
    var cur = field.value();
    if(cur === '' || cur === null)
    {
        return;
    }

    var stringin = "IN (";

    for(var i=0; i<cur.length; i++)
    {
        stringin += "'"+cur[i]+"',";
    }
    stringin = stringin.substr(0, stringin.length-1);
    stringin += ")";

    return restEngine.post('crm#/respostas/retornaParceiros',{"requestType":"Row","row":{"Entrada": stringin}},function (param)
    {
        var ar = [];
        for(var j = 0; j<param.dataset.SAIDA.length;j++)
        {
            ar[j] = param.dataset.SAIDA[j].NRPARCNEGOCIO;
        }

        field.setValue(ar);
    }, undefined, function(error){
        console.log(error);
    });
};
}

Configuration(function(ContextRegister) {
    ContextRegister.register('RespostasController', RespostasController);
});

// FILE: ./assets/js/controllers/ron30001_classificacao_compromisso_controller.js
function ron30001_classificacao_compromisso_controller(General, templateManager, Operador_Repository) {
    /**
     * Salva o registro de classificação de compromisso
     * 
     * @param {object} widget widget de classificação de compromisso
     * para setar campos da mesma
     */
    this.saveClassificacaoCompromisso = function(widget){
        
        if(widget.currentRow.__is_new){
            this.enableNewCodeNumber(widget);
        }
        
        widget.currentRow.__columns_to_return = ["NRCLASSIFICACOMPR"];
        
        this.setColorRGBtoHexadecimal(widget.currentRow);
        
        General.widgetSave(widget).then(function(response){
            if (response.dataset.columnsToReturn)
                widget.currentRow.NRCLASSIFICACOMPR = response.dataset.columnsToReturn.NRCLASSIFICACOMPR;
                
            this.desableNewCodeNumber(widget);
        });
    };
    /**
     * Seta as váriaveis de paramsNewCode 
     * para um novo código ser gerado.
     * 
     * @param {object} widget widget de classificação de compromisso
     * para setar os parametros de novo código
    */
    this.enableNewCodeNumber = function(widget){
        var paramsNewCode = widget.paramsNewCode;
        
        paramsNewCode.__is_new_code = true;
        paramsNewCode.__new_code_pk = "CRM_CLASSIFICACOMPR";
        paramsNewCode.__table_pk = "NRCLASSIFICACOMPR";
        paramsNewCode.__cast_number = true;
    };
    
    /**
     * Seta as váriaveis de paramsNewCode 
     * para um novo código não ser gerado.
     * 
     * @param {object} widget widget de concorrente
     * para setar os parametros de novo código
     */
    this.desableNewCodeNumber = function(widget){
        var paramsNewCode = widget.paramsNewCode;
        
        paramsNewCode.__is_new_code = false;
        paramsNewCode.__new_code_pk = "";
        paramsNewCode.__table_pk = "";
        paramsNewCode.__cast_number = true;
    };
    
    
    this.setColorRGBtoHexadecimal = function(currentRow){
        
        if(typeof currentRow.DSCORCLASSIFICACAO === "object"){
            var hexadecimal = currentRow.DSCORCLASSIFICACAO.toHexString();
            currentRow.DSCORCLASSIFICACAO = hexadecimal;
        }
    };
    
    
    this.setColor = function(row, element, widget){
        widget = templateManager.container.getWidget(widget);
        if(widget.mode === "edit"){
            
            element.children('p').remove();
            element.children('span').remove();
            element.children('div').remove();
            
            var class1 = "colorfield", class2 = "";
            
            class1 += " colorfield-in-grid";
            
            element.append('<div class='+class2+'> <div class='+class1+' style = background-color:'+ row.DSCORCLASSIFICACAO +';"> </div> </div>');
        }
    };
    
    /**
     * Altera o local da imagem que abre
     * no pop up para escolha da cor no campo
     * de cor após meio segundo.
    */
    this.changeImageLocal = function(){
            
        setTimeout(function(){
            document.getElementsByClassName('color-wheel')[0].src = "./assets/images/color-wheel.png";
        },500); 
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('ron30001_classificacao_compromisso_controller', ron30001_classificacao_compromisso_controller);
});

// FILE: ./assets/js/controllers/rules.js
var Application = function(localStorageEngine, templateManager, ScreenService, restEngine, ZHPromise, eventAggregator){

  var self = this;

  /*var hasRuned = false;

  eventAggregator.subscribe('onContainerOpen', function(){
    if(!hasRuned){
      ScreenService.openWindow('product#dashboard');
      hasRuned = true;
    }
  });*/

  this.login = function(widget){

    var user = widget.currentRow.CDOPERADOR;
    var password = widget.currentRow.CDSENHAOPER;

    var filters = [{
      "name": "user",
      "value": user,
      "operator": "="
    }, {
      "name": "password",
      "value": password,
      "operator": "="
    }];

    localStorageEngine.download('/login/login', filters).then(function(data){
        var userId = data.login;
        templateManager.userId = userId;
        var accessProfiles = getLocalVar('NRGROUPCTLACESS');
        localStorageEngine.setLocalVar('login', user);
        localStorageEngine.setLocalVar('PROJECT_ID', 13);
        self.getRules(accessProfiles).then( //remove the hash when query is ready
            function(response) {
                var data = response.dataset.zhu_access_control_rule_login;
                var rules = {};
                data.forEach(
                    function(rule) {
                        var profileObject = {
                            'rule': rule.RULE
                        };
                        var profileObjects = {};
                        profileObjects[userId] = profileObject;
                        rules[rule.NAME] = {
                            'itemName': rule.NAME,
                            'userGroups': profileObjects
                        };
                    }
                );
                templateManager.aclRules = rules;
                ScreenService.openWindow('dashboard');
            }
        );


        ScreenService.buildUserData(data.userData.nmoperador, [data.userData.nmEstrutLegalOper,""],function(){
            ScreenService.successNotification("Logado com sucesso!");
        });
    });
  };
    this.autenticar = function(widget){

        var user = widget.currentRow.CDOPERADOR;
        var password = widget.currentRow.CDSENHAOPER;

        var filters = [{
            "name": "user",
            "value": user,
            "operator": "="
        }, {
            "name": "password",
            "value": password,
            "operator": "="
        }];

        localStorageEngine.download('/login/login', filters).then(function(data){
            var userId = data.login;
            templateManager.userId = userId;
            var accessProfiles = getLocalVar('NRGROUPCTLACESS');
            localStorageEngine.setLocalVar('login', user);
            localStorageEngine.setLocalVar('PROJECT_ID', 13);
            self.getRules(accessProfiles).then( //remove the hash when query is ready
                function(response) {
                    var data = response.dataset.zhu_access_control_rule_login;
                    var rules = {};
                    data.forEach(
                        function(rule) {
                            var profileObject = {
                                'rule': rule.RULE
                            };
                            var profileObjects = {};
                            profileObjects[userId] = profileObject;
                            rules[rule.NAME] = {
                                'itemName': rule.NAME,
                                'userGroups': profileObjects
                            };
                        }
                    );
                    templateManager.aclRules = rules;
                }
            );


            ScreenService.buildUserData(data.userData.nmoperador, [data.userData.nmEstrutLegalOper,""],function(){
                ScreenService.successNotification("Logado com sucesso!");
            });
        });
    };

  this.loginKeyEnter = function(widget){
      if(event.keyCode === 13){
          this.login(widget);
      }
  };

  this.onEnter = function(widget) {
      Operador_Repository.retornaOperadorLogado().then(function(operator)
      {
        if(operator[0] === undefined || operator[0] === null)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
            return;
        }

        widget.getField('CDSENHAOPER').setValue('');
        widget.getField('CDOPERADOR').setValue(localStorageEngine.operator[0].DSEMAILOPER);
      }, function(error)
      {
          ScreenService.showMessage("Erro ao realizar a operação.");
      });
  };

    self.getRules = function(groupIds) {
        return restEngine.post('/zhu_acl_element_login',
            {
                "requestType": "FilterData",
                "filter": [
                    {
                        "name": "GROUP_ID",
                        "operator": "=",
                        "value": groupIds
                    }
                ]
            }
        );
    };

   /* this.prepareData = function(args) {
      if (localStorageEngine.getLocalVar("avaliacao").SITUACAO == 'CONCLUIDA') {
      alert("A avaliação já foi concluída. Por isto, não pode mais ser modificada.");
    } else {
        var dataAvaliacao = localStorageEngine.getLocalVar("avaliacao");
        dataAvaliacao.NRORG = localStorageEngine.getLocalVar('NRORG');
        dataAvaliacao.CDOPERADOR = localStorageEngine.getLocalVar('CDOPERADOR');
        dataAvaliacao.changed = true;
        dataAvaliacao.answers = args.owner.widget.dataSource.data[0].answer;
        //console.log(dataAvaliacao);
        localStorageEngine.setDataSource('/questionario', dataAvaliacao, function () {
          restEngine.post('/questionario/save',{"requestType":"Row","row":dataAvaliacao},function () {
            alert('Registro salvo com sucesso.');
          });
        });
    }
    }*/

  this.prepareDataConcluir = function(args) {
    if (localStorageEngine.getLocalVar("avaliacao").SITUACAO == 'CONCLUIDA')
    {
      alert("A avaliação já foi concluída. Por isto, não pode mais ser modificada.");
    }
    else
    {

      Operador_Repository.retornaOperadorLogado().then(function(operator)
      {
        if(operator[0] === undefined || operator[0] === null)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
            return;
        }

        dataAvaliacao = localStorageEngine.getLocalVar("avaliacao");
      	dataAvaliacao.concluir = true;
        dataAvaliacao.NRORG = localStorageEngine.operator[0].NRORG;
        dataAvaliacao.CDOPERADOR = localStorageEngine.operator[0].CDOPERADOR;
        dataAvaliacao.changed = true;
        dataAvaliacao.answers = args.owner.widget.dataSource.data[0].answer;
        localStorageEngine.setDataSource('crm#/questionario', dataAvaliacao, function () {
            restEngine.post('crm#/questionario/save',{"requestType":"Row","row":dataAvaliacao},function ()
            {
                var arrPro = [ScreenService.goBack()];
                ZHPromise.all(arrPro).then(function() {
                    var widget = templateManager.container.getWidget('avaliacao_desempenho');
                    widget.reload();
                    ScreenService.showMessage("Avaliação concluída com sucesso.");
                });
            }, undefined, function(error){
                console.log(error);
            });
        });
      }, function(error)
      {
          ScreenService.showMessage("Erro ao realizar a operação.");
      });
    }
  };

  this.verificaLocalStorage = function() {
    if (!localStorageEngine.getLocalVar("operador_avaliado")) {
      return '';
    } else {
      return localStorageEngine.getLocalVar("operador_avaliado").OPERADOR_AVALIADO;
    }
  };

  this.clearLocalStorage = function(exceptions) {
    //localStorage.clear();
      var storage = localStorage;
      var keys = [];
      exceptions = [].concat(exceptions); //prevent undefined

      //get storage keys
      $.each(localStorage, function(key, val) {
          keys.push(key);
      });

      //loop through keys
      for( i=0; i<keys.length; i++ ){
          var key = keys[i];
          var deleteItem = true;
          //check if key excluded
          for( j=0; j<exceptions.length; j++ ){
              var exception = exceptions[j];
              if( key == exception ) deleteItem = false;
          }
          //delete key
          if( deleteItem ){
              localStorage.removeItem(key);
          }
      }
      ScreenService.openWindow('login');
  };

    this.onClickRecuperarSenha = function(args) {
        var widgetPai = args.owner.field.widget;
        var widget = widgetPai.widgets[0];
        console.log(widget);
        widget.currentRow.DSEMAILOPER = widgetPai.currentRow.CDOPERADOR;
        ScreenService.openPopup(widget);
    };

    this.recuperarSenha = function(dataSet) {
        return restEngine.post("crm#/login/recuperarSenha",
            {
                requestType: "DataSet",
                dataset: [dataSet]
            }
        ).then(function(data) {
                ScreenService.showMessage(data.messages[0].message);
                ScreenService.closePopup();
            });
    };
};


Configuration(function(ContextRegister) {
    ContextRegister.register('questionarioAppControllerRules', Application);
});

// FILE: ./assets/js/controllers/TagController.js
function TagController(crm00002001_OportunidadeNegocio_Controller){
    
    this.buildFilter = function(widget){
        var filterPopUp = widget.__filterPopup;
        var currentRow = filterPopUp.currentRow;
        var buildInTicket = currentRow.QTINTICKETDE || currentRow.QTINTICKETATE;
        var buildInParcn = currentRow.QTINPARCNDE || currentRow.QTINPARCNATE;
        
        if(!Util.isEmptyOrBlank(buildInTicket)){
            var filterInTicket = crm00002001_OportunidadeNegocio_Controller.getOperatorForFilterBeginEnd(currentRow.QTINTICKETDE, currentRow.QTINTICKETATE, 'QTINTICKET');
        }
        if(!Util.isEmptyOrBlank(buildInParcn)){
            var filterInParcn = crm00002001_OportunidadeNegocio_Controller.getOperatorForFilterBeginEnd(currentRow.QTINPARCNDE, currentRow.QTINPARCNATE, 'QTINPARCN');
        }
        
        var filters = widget.dataSourceFilter.filter(function(filter){
            if(filter.name === "DSNOMETAG")
                return filter;
        });
        
        if(filterInTicket){
            filters.push(filterInTicket);
        }
        if(filterInParcn){
            filters.push(filterInParcn);
        }
        
        widget.dataSourceFilter = filters;
    };
}
Configuration(function(ContextRegister){
    ContextRegister.register('TagController', TagController);
});

// FILE: ./assets/js/controllers/TermometroOportunidadeController.js
function TermometroOportunidadeController(General, templateManager, CRM_Utilities, ScreenService, ZhFilterPreferences) {

    this.setHexColorCodeInCurrentRow = function(widget){
        var currentRow = widget.currentRow;
        currentRow.DSCORHEXADECIMAL = currentRow.DSCORHEXADECIMAL.toHexString();
    };
    
    this.setColor = function(row, element, widget){
        if(widget!=='Active')
            widget = templateManager.container.getWidget(widget);
        else
            widget = templateManager.container.getActiveWidget();
        var field = widget.getField("DSCORHEXADECIMAL");
        if(widget.mode != "edit"){
            element.children('p').remove();
            element.children('span').remove();
            element.children('div').remove();
            var class1 = "colorfield", class2 = "zh-field-value";
            if(widget.mode == "view"){
                class1 += " colorfield-in-form";
            }
            else {
                class1 += " colorfield-in-grid";
            }
            element.append('<div class='+class2+'> <div class='+class1+' style = background-color:'+ row.DSCORHEXADECIMAL +';"> </div> </div>');
        }
    };
    
    this.widgetSave = function(widget){
        CRM_Utilities.setColumnToReturnInCurrentRow(widget.currentRow, 'NRTERMOPORTUNI');
        General.widgetSave(widget).then(function(response){
            widget.currentRow.NRTERMOPORTUNI = response.dataset.columnsToReturn[0].NRTERMOPORTUNI;
            if(widget.mode === "list")
                widget.reload();
        });
    };
    
    this.openOportWindowFilteringOper = function(widget){
        ScreenService.openWindow('product#crm00002_001_oportunidade_de_negocio').then(function(){
            
            var oportWidgt = templateManager.container.getWidget('oportunidadegrid');
            
            oportWidgt.dataSourceFilter = [
                {
                    name: "NRORG",
                    operator: "=",
                    value: "@templateManager.LOGGEDOPERATOR.NRORG@"
                },
                {
                    name: "IDTPOPERADOR",
                    operator: "=",
                    value: "E"
                },
                {
                    name: "NRPARCRESP",
                    operator: "=",
                    default: true,
                    value: widget.currentRow.NRPARCNEGOCIO
                },
                {
                    name: "SITUACAO",
                    operator: "IN",
                    static: true,
                    value: "@['A']@"
                }
            ];
            oportWidgt.reload().then(function(){
                ScreenService.closePopup(true);
                oportWidgt.actions.forEach(function(action, index){
                    if(action.name == 'BACK_CHARTS')
                        action.isVisible = true;
                });
                oportWidgt.activate();
                oportWidgt.TERMFILTER = true;
                oportWidgt.__filterPopup.currentRow.CDOPERADOR = [widget.currentRow.CDOPERADOR];
                oportWidgt.__filterPopup.currentRow.NRPARCRESP = [widget.currentRow.NRPARCNEGOCIO];
                oportWidgt.__filterPopup.currentRow.NMPARCRESP = [widget.currentRow.OPERADOR];
                oportWidgt.__filterPopup.getField('NRPARCRESP').reload();
            });
            
            
            
        });
        
        this.checkTermFilter = function(widget){
            if(widget.TERMFILTER){
                ZhFilterPreferences.openFilterWidget(widget);
                widget.TERMFILTER = false;
                widget.actions.forEach(function(action, index){
                if(action.name == 'BACK_CHARTS')
                    action.isVisible = false;
                });
            }
        };
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('TermometroOportunidadeController', TermometroOportunidadeController);
});

// FILE: ./assets/js/controllers/WizardProspectController.js
/*global Util, $, Configuration*/
function WizardProspectController(ScreenService, templateManager, restEngine, metaDataFactory) {

    this.executeQuery = function(argsRow, mode) {

        if(Util.isEmptyOrBlank(argsRow.DSQUERY)){
            ScreenService.showMessage('Favor informar a query desejada.', 'ALERT');
        } else {
            restEngine.post('/executeQuery', {
                'requestType':'Row', 
                'row': {
                    query: argsRow.DSQUERY.toUpperCase(),
                    type:  (mode === 'fetch') ? 'fecth' : 'execute'
                }
            }).then(function (data) {
                try {
                    if (!Util.isUndefined(data.messages)) {
                        ScreenService.showMessage(data.messages[0].message, 'ERROR');
                    } else {
                        var container = templateManager.container;
                        var widgetResult = container.getWidget('wizardProspectGrid');

                        widgetResult.fields = [];

                        if (data.dataset.resultQuery.length > 0 && (data.dataset.resultQuery[0] !== null && data.dataset.resultQuery[0] !== true)) {
                            var resultQueryColumns = data.dataset.resultQuery[0];
                            $.each(resultQueryColumns, function (key, value) {
                                var obj = {
                                    "name": key,
                                    "label": key,
                                    "isVisible": true,
                                    "showOnList": true,
                                    "isReadOnly": true,
                                    "template": "field/text.html",
                                    "events": []
                                };

                                metaDataFactory.factoryField(obj, widgetResult, true);
                            });

                            widgetResult.dataSource.data = data.dataset.resultQuery;

                            templateManager.updateTemplate();
                            widgetResult.redraw();
                            $(window).resize();

                            ScreenService.closePopup();
                            ScreenService.successNotification("Query executada com sucesso");
                            widgetResult.activate();
                        } else {
                            if(mode === 'fetch')
                                ScreenService.showMessage('Dados não encontrados na consulta.');
                            else if(data.dataset.resultQuery[0] === true){
                                ScreenService.closePopup();
                                ScreenService.successNotification("Query executada com sucesso");
                                widgetResult.activate();
                            }else if(data.dataset.resultQuery[0] === null){
                                ScreenService.successNotification("Falha na execução da query");
                            }
                        }
                    }
                } catch (e) {
                    ScreenService.showMessage(e, 'ERROR');
                }

            }).catch(function(error){
                var message = error.data.error;
                message = message.slice(message.indexOf('ORA'), message.length);
                ScreenService.showMessage(message);        
            });
        }

    };

    this.openPopupQuery = function() {

        var container = templateManager.container;
        var widget = container.getWidget('wizardProspectPopup');

        ScreenService.openPopup(widget);
    };
    
    this.checkQuery = function(row){
        var container = templateManager.container;
        var widget = container.getWidget('wizardProspectPopup');
        
        var query = row['DSQUERY'];
        var actionQuery = widget.getAction('QUERY');
        var actionExecute = widget.getAction('EXECUTE');
        
        if(query){
            query = query.toUpperCase();
            if(query.indexOf('SELECT') !== -1 || query.indexOf('DESC') !== -1){
                actionQuery.isVisible = true;
                actionExecute.isVisible = false;
            }
            
            if(query.indexOf('INSERT') !== -1 || query.indexOf('UPDATE') !== -1 || query.indexOf('DELETE') !== -1 || query.indexOf('ALTER') !== -1 || query.indexOf('BEGIN') !== -1 || query.indexOf('CREATE') !== -1 || query.indexOf('DECLARE') !== -1){
                actionQuery.isVisible = false;
                actionExecute.isVisible = true;
            }
            widget.activate();
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('WizardProspectController', WizardProspectController);
});

// FILE: ./assets/js/controllers/ZhUtils.js
function ZhUtils() {
    this.getFilterField = function(widget, fieldName) {
        var field = widget.dataSourceFilter.find(function(f) {
            return f.name == fieldName;
        });
        
        return field;
    }
}

Configuration(function (ContextRegister) {
    ContextRegister.register("ZhUtils", ZhUtils);
});
